﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/topic",
    "dojo/Deferred",
    "cq/util/config/config"
],function(declare,lang,array,topic,Deferred,config){
    var BoBaseC = declare("",null,{
        modalName:"object",
        __shopId:null,
        getBaseUrl:function(){
            return config.getDataOrigin()+"/bizv2/" + this.modalName;
        },
        getPlatformShopId:function(){
            return config.getPlatformShopId();
        },
        nothing:function(){
            return {};
        },
        deferred:function(data){
            var def = new Deferred();
            setTimeout(function(){
                def.resolve(data);
            },100);
            return def;
        },
        getShopId:function(){
            if(!this.__shopId){
                BoBaseC.prototype.__shopId = window.g_sys_info&&g_sys_info._id||config.shopId||config.getPlatformShopId();
            }
            return this.__shopId;
        },
        _replaceNull:function(param){
            if(param){
                if(-1<Object.prototype.toString.call(param).indexOf("Array")){
                    for(var i=0;i<param.length;i++){
                        if(!param[i]){
                            if(0!==param[i]&&false!==param[i]){
                                param[i] = "__n";
                            }
                        }else if("object"===typeof(param[i])){
                            this._replaceNull(param[i]);
                        }
                    }
                }else if(typeof(param)==="object"){
                    for(var field in param){
                        if(!param[field]){
                            if(0!==param[field]&&false!==param[field]){
                                param[field] = "__n";
                            }
                        }else if("object"===typeof(param[field])){
                            this._replaceNull(param[field]);
                        }
                    }
                }
            }
        },
        exec:function(action, param, preventBusy){
            if(window.busy&&!preventBusy){
                window.busy();
            }
            return this.exec2(action, param).then(function(data){
                if(window.free){
                    window.free();
                }
                return data;
            });
        },
        exec2:function(action, param){
            param = param||{};
            var def = new Deferred();
            param = lang.clone(param);
            this._replaceNull(param);
            param.shopId = this.getShopId();
            paramSend = {};
            paramSend.__ds = JSON.stringify(param);
            require([
                "dojo/request/xhr"
            ],lang.hitch(this,function(xhr){
                xhr.post(config.getDataOrigin()+"/bizv2/" + this.modalName + "/" + action,{
                    data: paramSend,
                    handleAs:"json"
                }).then(function(data){
                    def.resolve({
                        data:data
                    });
                });
            }));
            return def;
        },
        exec3:function(model,method,param){
            param = param||{};
            var def = new Deferred();
            param = lang.clone(param);
            this._replaceNull(param);
            param.dbName = this.getShopId();
            paramSend = {};
            paramSend.__ds = JSON.stringify(param);
            var url = config.getS2Origin() + model + "/" + method;
            var first = true;
            require([
                "dojo/request/xhr"
            ],lang.hitch(this,function(xhr){
                xhr.post(url,{
                    data:paramSend,
                    handleAs:"json"
                }).then(function(data){
                    def.resolve(data);
                });
            }));
            return def;
        },
        constructor:function(params){
            params = params||{};
            var obj=Object.getPrototypeOf(this),
                fields = [{},this.fields||{},params.fields||{}];
            obj = Object.getPrototypeOf(obj);
            while(obj){
                if(obj.fields){
                    fields.splice(1,0,obj.fields);
                }
                obj = Object.getPrototypeOf(obj);
            }
            params.fields = lang.mixin.apply(null,fields);
            lang.mixin(this,params);
        },
        //field的内容
        /**
            检查机制
            所有类型的字段
                notNull
            编辑方式为数字的字段
                type:number，非数字时报错
                range:
                    [0,10]，0到10之间，包含0和10
                    (0,10)，0到10之间，不包含0和10
                    (,0)，小于0
                    (0,)，大于零
            编辑方式为电话的字段
                type:tel，内容不是电话时报错
        **/
        fields:null,
        _getFieldItem:function(field,canEdit,layoutType){
            var fieldItem = null;
            field = field&&field.field||field||"";
            if(lang.isString(field)){
                fieldItem = lang.clone(this.fields[field]);
            }
            if(!fieldItem){
                fieldItem =  {
                    type:"text",
                    field:field,
                    canEdit:false
                };
            }
            if(!fieldItem.label&&field.indexOf(".")>-1){
                var fs = field.split(".");
                while(fs.length){
                    if(this.fields[fs.join(".")]&&this.fields[fs.join(".")].label){
                        fieldItem.label = this.fields[fs.join(".")].label;
                        break;
                    }
                    fs.pop();
                }
            }
            if("button"===fieldItem.type){
                fieldItem.type = "action";
            }else if("link"===fieldItem.type){
            }else{
                fieldItem.canEdit = false===fieldItem.canEdit||false===canEdit||false===field.canEdit?false:true;
            }
            fieldItem.field = field&&field.field||field;
            if(layoutType&&fieldItem[layoutType]){
                fieldItem = lang.mixin(fieldItem,fieldItem[layoutType]);
            }
            return fieldItem;
        },
        getFormItems:function(fields,canEdit,layoutType){
            var fs = [];
            array.map(fields,function(field){
                var fieldItem = this._getFieldItem(field,canEdit,layoutType);
                if(fieldItem){
                    fs.push(fieldItem);
                }else{
                    console.error("get field item error");
                    console.error(this,fields,field);
                }
            },this);
            return fs;
        },
        
        _isNull:function(value){
            return !(value||0===value||false===value);
        },
        _isNumber:function(value){
            return value==parseFloat(value);
        },
        isEmail:function(value){
            return /^([a-zA-Z0-9_-])+@([a-zA-Z0-9_-])+(.[a-zA-Z0-9_-])+/.test(value);
        },
        isUrl:function(value){
            var strRegex = '^((https|http|ftp|rtsp|mms)?://)'
                + '?(([0-9a-z_!~*\'().&=+$%-]+: )?[0-9a-z_!~*\'().&=+$%-]+@)?' //ftp的user@ 
                + '(([0-9]{1,3}.){3}[0-9]{1,3}' // IP形式的URL- 199.194.52.184 
                + '|' // 允许IP和DOMAIN（域名） 
                + '([0-9a-z_!~*\'()-]+.)*' // 域名- www. 
                + '([0-9a-z][0-9a-z-]{0,61})?[0-9a-z].' // 二级域名 
                + '[a-z]{2,6})' // first level domain- .com or .museum 
                + '(:[0-9]{1,4})?' // 端口- :80 
                + '((/?)|' // a slash isn't required if there is no file name 
                + '(/[0-9a-z_!~*\'().;?:@&=+$,%#-]+)+/?)$'; 
            var re=new RegExp(strRegex); 

            return re.test(value);
        },
        isTel:function(value){
            return !!(/^(\(\d{3,4}\)|\d{3,4}-|\s)?\d{7,14}$/.test(value));
        },
        isCellPhone:function(value){
            return !!(/^1\d{10}$/.test(value));
        },
        // getEdtLayout 编辑页面
        // onDataReady 单行数据加载完成
        // getListLayout 列表页面
        // getListUrl 列表页面请求地址
        // onListClick 列表页面点击
        // getListParam 列表页面查询参数
        // loadById 加载指定数据
        // getItemProp 移动端生成HTML片段
        // onListDataReady 列表页数据加载完成
        // onEditFieldChange 字段变更
        // 
        getDataValidMsg:function(data,fields){
            var msg = "";
            array.some(fields,function(field){
                var fieldItem = this.fields[field],value = data[field];
                if(!fieldItem){
                    return;
                }
                if(fieldItem.notNull&&this._isNull(value)){
                    msg = fieldItem.label+"不能为空";
                    return true;
                }
                if(!this._isNull(value)){
                    if(fieldItem.type==="tel"){
                        if(!(this.isTel(value)||this.isCellPhone(value))){
                            msg = fieldItem.label+"不合法，请输入正确的电话号码";
                            return true;
                        }
                    }
                    if(fieldItem.type==="number"){
                        if(!this._isNumber(value)){
                            msg = fieldItem.label+"不合法，请填写正确的数字";
                            return true;
                        }
                        if(fieldItem.range){
                            var range = fieldItem.range.split(/[\[\(\),\]]/g);
                            if(range[1]){
                                if("["===fieldItem.range[0]){
                                    if(value-range[1]<0){
                                        msg = fieldItem.label+"不能小于"+range[1];
                                        return true;
                                    }
                                }else{
                                    if(value-range[1]<=0){
                                        msg = fieldItem.label+"必须大于"+range[1];
                                        return true;
                                    }
                                }
                            }
                            if(range[2]){
                                if("]"===fieldItem.range[fieldItem.range.length-1]){
                                    if(value-range[2]>0){
                                        msg = fieldItem.label+"不能大于"+range[2];
                                        return true;
                                    }
                                }else{
                                    if(value-range[2]>=0){
                                        msg = fieldItem.label+"必须小于"+range[2];
                                        return true;
                                    }
                                }
                            }
                        }
                        if (fieldItem.isInteger) {
                            // 是否为整数
                            if (!(value % 1 === 0)) {
                                msg = fieldItem.label+"必须是整数";
                                return true;
                            }
                        }
                    }
                    if(fieldItem.type==="email"){
                        if(!this.isEmail(value)){
                            msg = fieldItem.label+"格式错误，请填写正确的邮箱地址";
                            return true;
                        }
                    }
                    if(fieldItem.type==="url"){
                        if(!this.isUrl(value)){
                            msg = fieldItem.label+"格式错误，请填写正确的网址";
                            return true;
                        }
                    }
                    if(fieldItem.pattern){
                        if(!fieldItem.pattern.test(value)){
                            msg = fieldItem.label+"格式错误";
                            return true;
                        }
                    }
                    // 添加 objects的检查
                    if(fieldItem.type==="objects"){
                        if(fieldItem.notNull&&!data[field].length){
                            msg = fieldItem.label+"不能为空";
                            return true;
                        }
                    }
                }
            },this);
            return msg;
        },
        defTest:function(data){
            var def = new Deferred();
            setTimeout(lang.hitch(this,function(){
                def.resolve(data);
            }),100);
            return def;
        }
    });
    
    
    var BoBaseB = declare("", [BoBaseC], {
        __shopId:null,
        getShopId:function(){
            if(!this.__shopId){
                BoBaseB.prototype.__shopId = config.__shopIdB;
            }
            return this.inherited(arguments);
        }
    });
    BoBaseC.prototype.getShopId();
    topic.subscribe("whz/shop/changed",function(shop){
        // BoBaseC.prototype.__shopId = shop._id;
        BoBaseB.prototype.__shopId = shop&&shop._id;
    });
    BoBaseB.B = BoBaseB;
    BoBaseB.C = BoBaseC;
    
    return {B:BoBaseB,C:BoBaseC};
});
