﻿//订单系统公共基类
// 1、提供订单系统的基本属性
// 2、提供公用的方法
define([
    "dojo/_base/declare"
], function (declare) {
    return declare("",null,{
        modalName:"article/article",
        fields:{
            logo:{
                type:"image",
                label : "封面图",
                imgSize:{
                    width: this.imgWidth,
                    height: this.imgHeight
                }
            }, 
            _id:{
                type:'text',
                label:'ID'
            },
            code:{
                type:'text',
                label:'编码',
                placeHolder:"录入编码"
            },
            title:{
                type:'text',
                label:'标题',
                notNull: true,
                placeHolder:"录入标题"
            },
            groupId:{
                type : "ref",
                field : "groupId",
                label : "资讯类别",
                pageSize : 5,
                labelFields : "groupName",
                dataProvider : "bob/article/article/b",
                searchField: 'groupName',
                targetMethod : "getGroupUrl",
                canEdit : true
            },
            // 微信栏目
            section:{
                type:"ref",
                field:"section",
                label:"微信栏目",
                pageSize:5,
                labelFields:"title",
                dataProvider : "bob/article/section/b",
                searchField: 'title',
                targetMethod : "getNewsSectionUrl",
            },
            
            brief:{
                type:'textarea',
                label:'摘要'
            },
            content:{
                type:'richText',
                label : '内容',
                notNull: true
            },
            isUse:{
                type:'checkbox',
                label:'使用',
                noArrow:true,
                value: true
            },
            isTop:{
                type:'checkbox',
                label:'置顶',
                noArrow:true
            },
            groupName:{
                type:'text',
                label:'类别名称',
                notNull: true,
                placeHolder: "录入类别名称"
            },
            attachment:{
                type:'file',
                label:'上传附件'
            },
            share: {
				type: 'button',
				label: '分享',
				action: 'share'
			}
        },
        getNewsGroupBListBUrl:function(){
            // summary:
            //        app资讯类别列表数据载入
            // view:
            //         newsGroupListB
            // description:
            //         无
            return this.getBaseUrl()+"/loadGroup";
        },
        getNewsGroupBListBQuery:function(params){
            // summary:
            //        app资讯类别列表参数传递
            // view:
            //         newsGroupListB
            // description:
            //         无
            var query = {
                shopId: this.getShopId()
            };
            // 没有用到模糊匹配
            //if (params.search) {
            //    query.groupName = params.search;
            //}
            return query;
        },
        /**************以下为资讯列表****************/
        //资讯列表数据载入
        getNewsListBUrl:function(){
            return this.getBaseUrl()+"/load";
        },
        //资讯列表传递的参数
        getNewsListBQuery:function(params){
            var query = {
                shopId: this.getShopId()
            };
            if (params.search) {
                query.search = params.search;
                //query.title = params.search;
            }
            if(params.rowList){
                query.groupId = params.rowList._id;
            }
            return query;
        },
        //资讯列表的点击事件
        onNewsListBClick:function(data, action, widget){
            window.moveToView("newDetail", data._id);
        },
        //资讯详情的载入
        getNewsBData:function(e){
            var params = e&&e.cqViewParam&&e.cqViewParam.params||"",
                _id, fromShopId;
            _id = params;
            fromShopId = this.getShopId();
            if(params.indexOf("_")>-1){
                _id = params.split("_")[0];
                fromShopId = params.split("_")[1];
            }
            if(params){
                return this.exec("loadById",{
                    _id: _id,
                    fromShopId: fromShopId
                }).then(function(data){
                    return data&&data.data&&data.data.item||{};
                });
            }else{
                return {
                    isUse: true
                };
            }  
        }
    });
});
