﻿define([
	"dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "cq/app/config",
    "cq/util/config/config",
	"cq/util/sys/date",
    "bob/BoBase",
    "./_Mixin"
],function(declare, lang, Deferred, config ,appConfig, date, BoBase, _Mixin){
	var TimeLineBo = declare("", [BoBase.B, _Mixin], {
        fields:{
			createAt:{
				type:"date",
				formatter:function(v){return date.formatISODate(v);},
				label:"发布日期"
			},
            onSubmitNewsBButton:{
                className: "fullButton",
                type: "button",
                label: "发布资讯信息",
                action: "onNewsB"
            },
            onSubmitNewsGroupBButton:{
                className: "fullButton",
                type: "button",
                label: "创建资讯类别",
                action: "onNewsGroupB"
            }

        },
        /**************以下为资讯详情****************/
        //资讯详情的layout
        getNewsBLayout:function(){
            if (!this.newsBLayout) {
                this.newsBLayout = [{
                    type: "form",
                    fields: this.getFormItems([
                        // 置顶暂时没有地方用到 有用的时候再添加
                        "logo","code","title","groupId","section","brief","isUse",/*"isTop",*/"content","attachment","onSubmitNewsBButton","share"
                    ])
                }];
            }
            return this.newsBLayout;
        },
        //发布资讯的数据操作
        onNewsB:function(item){
            var msg = this.getDataValidMsg(item, ["title", "content"]);
            if(msg){
                alert(msg);
                return;
            }
            return this.exec("save",item).then(lang.hitch(this,function(data){
                // 保存成功则跳转到资讯列表页面
                if(data&&data.data&&data.data.ok === 1){
                    alert("保存成功");
                    history.back();
                }else{
                    alert(data&&data.data&&data.data.message||"保存失败");
                }
            }));
        },
        share: function (data, widget) {
            //         点击后分享给其他人 或者获取资讯链接
            // view:
            require([
                "cq/util/share/share",
                "bob/shop/shop"
            ], lang.hitch(this, function(share, shop){
                var shopId = this.getShopId();
                share.getShopLocation(this.getShopId()).then(function(baseUrl){
                    var options = [{
                        "weixin": {
                            title: data.title,
                            thumb: data.logo || "",
                            url:baseUrl+"#newDetail-" +  data._id+"_" + shopId
                        }
                    }, {
                        "friendCircle": {
                            title: data.title,
                            thumb: data.logo || "",
                            url:baseUrl+"#newDetail-" +  data._id+"_" + shopId
                        }
                    }, {
                        "timeLine": {
                            title: data.title,
                            thumb: data.logo || "",
                            url:baseUrl+"#newDetail-" +  data._id+"_" + shopId
                        }
                    }, {
                        "copy": {
                            url: baseUrl+"#newDetail-" +  data._id+"_" + shopId
                        }
                    }];
                    shop.getCurrentShop().then(lang.hitch(this, function(shopInfo){
                        if(shopInfo&&shopInfo.isVerified){
                            share.showShare(options);   
                        }else{
                            alert("您的店铺还未认证,不能分享,请尽快完成认证");
                        }
                    }));
                });
            }));
		},
        // 本方法中实现是错误的 不知道什么地方用到
        // 在村头 服务站首页 加载评价资讯时使用 2017-4-14 刘轩
        getItemPropForF: function(data){
            return {
                label: "<a class='row1' href='#news-"+data._id+"'>"+data.title+"</a>"
            };
        },
        onDataReady: function(widget){
            var data = widget.getData();
            widget.hideByFields(["share"]);
            if(!data._id){
                return;
            }
            widget.showByFields(["share"]);
        },
        /**************以下为资讯类别详情****************/
        getNewsGroupBLayout:function(){
            // summary:
            //        app资讯类型详情的layout
            // view:
            //         newsGroupB
            // description:
            //         无
            if (!this.newsGroupBLayout) {
                this.newsGroupBLayout = [{
                    type: "form",
                    fields: this.getFormItems([
                        "logo","code","groupName","isUse","onSubmitNewsGroupBButton"
                    ])
                }];
            }
            return this.newsGroupBLayout;
        },
        //创建资讯类型详情的数据处理
        onNewsGroupB:function(item){
            var msg = this.getDataValidMsg(item, ["groupName"]);
            if(msg){
                alert(msg);
                return;
            }
            return this.exec("saveGroupById",item).then(lang.hitch(this,function(data){
                if(data&&data.data&&data.data.ok === 1){
                    alert("保存成功");
                    history.back();
                }else{
                    alert(data&&data.data&&data.data.message||"保存失败");
                }
            }));
        },
        //资讯类型详情的载入
        getNewsGroupBData:function(e){
            if(e&&e.cqViewParam&&e.cqViewParam.params){
                return this.exec("loadGroupById",{
                    _id:e.cqViewParam.params
                }).then(lang.hitch(this,function(data){
                    if(data.data.ok === 1){
                        return data.data.item;
                    }else{
                        alert("加载数据错误");
                    }
                }));
            }else{
                var def = new Deferred();
                def.resolve({
					isUse: true
				});
				return def;
            }
        },
        getNewsListData:function(){
            return this.exec("load",{shopId:this.getShopId()});
        },
        //资讯列表的点击事件
        onNewsListBClick:function(data, action, widget){
            if(action=="share"){
                this.share(data);
            }else{
                window.moveToView("newsB", data._id);   
            }
        },
        getGroupUrl: function(){
            return this.getBaseUrl()+"/loadGroup?shopId="+this.getShopId();
        },
        onNewsGroupBListBClick:function(item){
            // summary:
            //        资讯类别列表的点击事件
            // view:
            //         newsGroupListB
            // description:
            //         无
            window.moveToView("newsGroupB", item._id);
        },
		getHelpLayout:function(){
            if (!this.helpLayout) {
                this.helpLayout = [{
                    type: "form",
                    fields: this.getFormItems([
                        "title","brief", "content"
                    ])
                }];
            }
            return this.helpLayout;
        },
		loadB2CVerifiedHelp: function(params){
            return this.exec("loadPlatformByTitle",{
                title : "一般商家认证流程",
				platformShopId : this.getPlatformShopId()
            }).then(lang.hitch(this, function(result){
				if(result.data.ok === 1){
					var item = result&&result.data&&result.data.item||{};
					return item;
				}
			}));
        },
        showDisRule: function(data, widget){
            require([
                "cq/util/edit/confirmFrame2"
            ],lang.hitch(this,function(confirmIFrame){
                this.exec("loadPlatformByTitle", {
                    title: "商品分销规则",
                    platformShopId: this.getPlatformShopId()
                }).then(function(result){
                    var item = result&&result.data&&result.data.item||{};
                    if(!item._id){
                        alert("暂无");
                        return;
                    }
                    var url = location.href.split("#")[0]+"#newDetailNoHeader-"+item._id;
                    confirmIFrame.show(url,"分销规则");
                });
            }));
        }
    });
	var timeLineBo = new TimeLineBo();
	timeLineBo.Bo = TimeLineBo;
    return timeLineBo;
});
