﻿define([
	"dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-style",
    "bob/BoBase",
    "./_Mixin",
    "cq/util/sys/date"
],function(declare, lang, array, domStyle, BoBase, _Mixin, date){
	var ArticleCBo = declare("", [BoBase.C, _Mixin], {
        fields:{
			createAt:{
				type:"dateTime"
			},
            getBrief:{
                type: "button",
                action: "getBrief"
            },
            logoNode: {
                type: "text"
            }
        },
        getQueryParams : function (paramStr) {
            var params = {};
            var arrayStr = paramStr.split("_");
            if (arrayStr && arrayStr.length > 1) {
                params._id = arrayStr[0];
                params.fromShopId = arrayStr[1];
            } else {
                params._id = arrayStr[0];
            }
            return params;
        },
        share: function (data, widget) {
            //         点击后分享给其他人
            // view:
            require(["cq/util/share/share"], lang.hitch(this, function(share){
                share.getShopLocation(this.getShopId()).then(function(baseUrl){
                    var options = [{
                        "weixin": {
                            title: data.title,
                            thumb: data.logo || "",
                            url:baseUrl+"#newDetail-" +  widget.cqRefInfo.cqViewParam.params
                        }
                    }, {
                        "friendCircle": {
                            title: data.title,
                            thumb: data.logo || "",
                            url:baseUrl+"#newDetail-" +  widget.cqRefInfo.cqViewParam.params
                        }
                    }, {
                        "copy": {
                            url: baseUrl+"#newDetail-" +  widget.cqRefInfo.cqViewParam.params
                        }
                    }];
                    share.showShare(options);
                });
            }));
		},
        getListParamByShop: function(params){
            var query = {
                isUse: true
            };
            query.shopId = params.cqViewParam.params||this.getShopId();
            return query;
        },
        getItemProp: function(item){
            item.logoNode = item.logo?"<div><img style='margin-top:0;' src='"+item.logo+"'/></div>":"";
            return item;
        },
        getItemPropA: function(item){
            item.logoNode = item.logo?"<div style='width:100px;margin-right:10px;'><img style='margin-top:0;margin-right:0;width:auto;' src='"+item.logo+"'/></div>":"";
            item.timeStr = date.getTimeMoment(item.createAt);
            return item;
        },
        // 商家首页的动态列表
        getListUrlByShop: function(){
            return this.getBaseUrl()+"/load";
        },
        onListClickByShop: function(data, widget, c){
            window.moveToView("newDetail", data._id+"_"+c.cqRefInfo.cqViewParam.params);
        },
        titleClick: function(data, widget){
            window.moveToView("newsList", widget.cqRefInfo.cqViewParam.params||this.getShopId());
        },
        //资讯详情的载入
        loadById : function(e){
            if(e.cqViewParam.params){
                var queryParams = this.getQueryParams(e.cqViewParam.params);
                return this.exec("loadById",queryParams).then(lang.hitch(this,function(data){
                    return data&&data.data&&data.data.item||{};
                })).then(lang.hitch(this,function(data){
                    var shopId = this.getShopId();
                    require([
                        "dojo/topic",
                        "cq/util/share/share"
                    ],function(topic,share){
                        share.getShopLocation(shopId).then(function(baseUrl){
                            topic.publish("/cq/util/sys/share/infoChanged",{
                                title: data.title,
                                thumb: data.logo || "",
                                url:baseUrl+"#newDetail-" + e.cqViewParam.params
                            });
                        });
                    });
                    return data;
                }));
            }
        },
		loadTrendByTitle: function(){
			var queryParams = {title : "电商商家的认证流程"};
			return this.exec("loadById",queryParams).then(lang.hitch(this,function(data){
				if(data.data.ok === 1){
					return data.data.item;
				}else{
					alert("加载数据错误");
				}
			}));
        },
        onDataReady : function(widget){
            widget.hideByFields(["getBrief"]);
            var data = widget.getData();
            if(!data._id){
                return;
            }
            if(data.title){
                var view = widget.getView();
                view.changeTitle(data.title);
            }
            if(data.brief){
                widget.showByFields(["getBrief"]);
            }
        },
        queryGroupLoaded:function(datas,list){
            if(!(datas&&datas[0])){
                return;
            }
            if(list.cqRefInfo.cqViewParam&&list.cqRefInfo.cqViewParam.params&&array.some(datas,function(data){
                if(data._id==list.cqRefInfo.cqViewParam.params){
                    data.selected = true;
                    return true;
                }
            })){
                return;
            }
            datas[0].selected = true;
        }
    });
	var articleCBo = new ArticleCBo();
	articleCBo.Bo = ArticleCBo;
    return articleCBo;
});
