define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "../../BoBase"
], function (declare, lang, topic, BoBase) {
	var AutoReplyBo = declare("", BoBase.B, {
        modalName: "article/auto_reply",
        fields: {
            rType:{
				type:"options",
                label:"触发条件",
                options:{
                    '00000': '新会员关注自动回复',
                    '99999': '找不到自动回复时的回复',
                    '其他': '其他'
                },
                notNull: true
            },
            replyType:{
				type:"options",
                label:"回复类型",
                options:{
                    'text': '文本',
                    'image': '图片',
                    'aritcle': '图文'
                },
                notNull: true
            },
            "keyword":{
                type:"text",
                label:"关键词",
                className:"middle-width",
                placeHolder:"必填",
                notNull: true
            },
            imgUrl:{
                type:"image",
                label:"回复图片",
                className:"large-high"
            },
            replyText:{
                type:"textarea",
                label:"回复内容",
                className:"middle-width"
            },
            rTypeTxt: {
                type: "text",
                label: "回复类型"
            },
            url:{
                type:"text",
                label:"链接网址",
                className:"middle-width"
            },
            saveButton:{
                type:"button",
                label:"完成",
                action:"save",
                className:"fullButton"
            },
        },
        loadData: function (data) {
            return this.exec("load", data).then(lang.hitch(this,function(result){
                return result.data.items;
            }));
        },
        getListUrl: function(){
            return this.getBaseUrl() + "/load?shopId=" + this.getShopId();
        },
        changeShow: function(data){
            var rType;
            if(data.rType){
                if('00000' == data.rType){
                    rType = '新会员关注自动回复';
                }
                if('99999' == data.rType){
                    rType = '找不到自动回复时的回复';
                }
                if('其他' == data.rType){
                    rType = '其他';
                }
            }
            return rType;
        },
        getItemProp: function(data){
            data.rTypeTxt = this.changeShow(data);
            return data;
        },
        getListParam: function(){
            var query = {
            //    shopId: this.getShopId(),
                isUse: true
            };
            return query;
        },
        onListClick: function(data,node,list){
            if('delete' == node){
                var isDelete = confirm("确认删除?");
                if(isDelete){
                    this.exec("deleteById", {
                        _id:data._id,
                        shopId:this.getShopId()
                    }).then(lang.hitch(this,function(result){
                        if(1 == result.data.ok){
                            //history.back();
                            list.cqRefresh();
                        }else
                            alert("服务器繁忙，请稍后再试")
                    }));
                }
            }else if('editor' == node){
                window.moveToView("autoReplyDetail",data._id);
            }
        },
        // 自动回复详情布局
        getEdtLayout: function(){
            return [{
                type: "form",
                fields: this.getFormItems([
                    "rType",
                    "replyType",
                    "keyword",
                    "imgUrl",
                    "replyText",
                    "url",
                    "saveButton"
                ])
            }];
        },
        // 自动回复详情数据初始化
        loadById: function(param){
            if(param&&param.cqViewParam&&param.cqViewParam.params){
                var data = {};
                data._id = param.cqViewParam.params;
                data.shopId = this.getShopId();
                return this.exec("loadById", data).then(lang.hitch(this,function(result){
                    return result.data.item;
                }));
            }
        },
        // 保存
        save: function(data){
            var msg = this.getDataValidMsg(data, ["rType",
                    "replyType",
                    "keyword",
                    "replyText"]);
            if(msg){
                alert(msg);
                return;
            }
            data.isUse = true;
            data.shopId = this.getShopId();
            this.exec("save", data).then(lang.hitch(this,function(result){
                if(result.data.ok === 1){
                    history.back();
                }else{
                    alert("服务器繁忙，请稍后再试！")
                }
            }));
        },
    });
	var autoReplyBo = new AutoReplyBo();
	autoReplyBo.Bo = AutoReplyBo;
	return autoReplyBo;
});