define([
	"dojo/_base/declare",
	"dojo/Deferred",
    "dojo/_base/array",
	"dojo/_base/lang",
	"bob/BoBase",
    "cq/util/config/config",
    "bob/shop/shop"
], function (declare, Deferred, array, lang, BoBase, config, shop) {
	var IndustryArticleB = declare('', [BoBase.B], {
		modalName: 'article/industry_article',
        fields : {
            title:{
                type:'text',
                label:'标题',
                notNull: true,
                placeHolder:"录入标题"
            },
            logo:{
                type:"image",
                label : "图片",
                imgSize:{
                    width: this.imgWidth,
                    height: this.imgHeight
                }
            },
            industryType : {
                type : 'options',
                label : '类型',
                options : {
                    10 : "产业模式",
                    20 : "主体培育"
                },
                canEdit : false
            },
            brief : {
                type : "textarea",
                label : "摘要"
            },
            content:{
                type:'richText',
                label : '内容',
                notNull: true
            },
            isUse:{
                type:'checkbox',
                label:'使用',
                noArrow:true,
                value: true
            },
            onSubmitButton:{
                className: "fullButton",
                type: "button",
                label: "保存",
                action: "onSave"
            },
        },
        save : function (item) {
            return this.exec("save",item).then(lang.hitch(this,function(data){
                // 保存成功则跳转到资讯列表页面
                if(data&&data.data&&data.data.ok === 1){
                    alert("保存成功");
                    history.back();
                }else{
                    alert(data&&data.data&&data.data.message||"保存失败");
                }
            }));
        },
        // 保存
        onSave : function (item) {
            var msg = this.getDataValidMsg(item, ["title", "industryType"]);
            if(msg){
                alert(msg);
                return;
            }
            return this.save(item);
        },
        onIndustryModelItem : function (data, action, widget) {
            window.moveToView("industryModelDetail", data._id);  
        },
        onIndustryCultivatItem : function (data, action, widget) {
            window.moveToView("industryCultivatDetail", data._id);  
        },
        getIndustryModelLayout : function () {
            if (!this.industryModelLayout) {
                this.industryModelLayout = [{
                    type: "form",
                    fields: this.getFormItems([
                        "logo","title", "brief", "content", "onSubmitButton"
                    ])
                }];
            }
            return this.industryModelLayout;
        },
        getIndustryCultivatLayout : function () {
            if (!this.industryCultivetLayout) {
                this.industryCultivetLayout = [{
                    type: "form",
                    fields: this.getFormItems([
                        "logo","title", "brief", "content", "onSubmitButton"
                    ])
                }];
            }
            return this.industryCultivetLayout;
        },
        loadById : function (_id) {
            return this.exec("loadById", {
                _id : _id
            });
        },
        getListUrl : function () {
            return this.getBaseUrl()+"/load";  
        },
        getModelListQuery : function (params) {
            var query = {};
            query.shopId = this.getShopId();
            query.industryType = 10;
            return query;
        },
        getCultivatListQuery : function (params) {
            var query = {};
            query.shopId = this.getShopId();
            query.industryType = 20;
            return query;
        },
        //资讯详情的载入
        getIndustryModelData : function(e){
            if(e && e.cqViewParam && e.cqViewParam.params){
                return this.loadById(e.cqViewParam.params).then(lang.hitch(this,function(data){
                    var pageData = {};
                    if (data && data.data && data.data.ok === 1) {
                        pageData = data.data.item;
                    }
                    pageData.industryType = pageData.industryType || 10;
                    return pageData;
                }));
            }else{
                var def = new Deferred();
                def.resolve({industryType : 10});
				return def;
            }  
        },
        getIndustryCultivatData : function(e){
            if(e && e.cqViewParam && e.cqViewParam.params){
                return this.loadById(e.cqViewParam.params).then(lang.hitch(this,function(data){
                    var pageData = {};
                    if (data && data.data && data.data.ok === 1) {
                        pageData = data.data.item;
                    }
                    pageData.industryType = pageData.industryType || 20;
                    return pageData;
                }));
            }else{
                var def = new Deferred();
                def.resolve({industryType : 20});
				return def;
            }  
        }
	});
	industryArticleB = new IndustryArticleB();
	industryArticleB.Bo = IndustryArticleB;
	return industryArticleB;
});