﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/util/config/config",
    '../../BoBase',
    "./_Mixin"
], function (declare,lang,config,BoBase,_Mixin) {
    var NoticeBBo = declare("", [BoBase.B, _Mixin], {
        fields:{
            createAt:{
                type:"dateTime"
            },
            deleteButton: {
                type: "button",
                action: "deleteById"
            },
            saveButton: {
				type: "button",
				label: "保存",
				action: "save",
				buttonClass: "fullButton"
			},
            showBrief: {
                type: "button"
            }
        },
        
        // 添加商家公告Layout
        getEdtLayout: function(){
            return [{
                type : "form",
                fields : this.getFormItems(["logo", "code", "title", "brief", "content", "saveButton", "deleteButton"], true)//, "isUse"
            }];
        },
        deleteById: function(data){
            if(confirm("确认删除?")){
                var deleteData = {
                    _id: data._id,
                    isUse: false
                }
                this.exec("save", deleteData).then(function(result){
                    if (result&&result.data && result.data.ok === 1) {
                        history.back();
                    } else {
                        alert(result&&result.data&&result.data.msg||"删除失败");
                    }
                });
            }
        },
        // 保存商家公告
        save: function(data, dataList){
            var msg = this.getDataValidMsg(data, ["code", "title", "brief", "content"]);
            if (msg) {
				alert(msg);
				return;
			}
            data.isUse = true;
            this.exec('save', data).then(function (result) {
				if (result&&result.data && result.data.ok === 1) {
					history.back();
				} else {
					alert(result&&result.data&&result.data.msg||"保存失败");
				}
			});
        },
        // 加载商家公告列表的url
        getListUrl: function(){
            return this.getBaseUrl() + '/load';
        },
        // 加载商家公告列表的url
        getListUrlB: function(){
            return this.getBaseUrl() + '/loadB';
        },
        loadPltNotice: function(){
            return this.exec("loadB", {
                fromShopId: this.getPlatformShopId(),
                isUse: true,
                orderBy: "-createAt"
            }).then(lang.hitch(this, function(result){
                return result&&result.data&&result.data.items||[];
            }));
        },
        onListClickForP: function(){
            window.moveToView("proclamationList");
        },
        //通过ID获取商家公告并拼接数据
        loadProclamationDetail:function(params){
            window.busy();
            var _id = params && params.cqViewParam && params.cqViewParam.params;
            if(_id) {
                return this.exec("loadById", {
                    _id: _id,
                    fromShopId: this.getPlatformShopId()
                }).then(lang.hitch(this, function (result) {
                    window.free(); 
                    return result.data.item;
                }));
            }else {
                return {};
            }
        },
        //控制页面元素的显示和隐藏
        onDataReady:function(widget){
            var data = widget.getData();
            widget.hideByFields(["deleteButton", "showBrief"]);
            if(!data._id){
                return;
            }
            widget.showByFields(["deleteButton"]);
            if(data.brief){
                widget.showByFields(["showBrief"]);
            }
        },
        // 加载商家公告列表的条件
        getListParam: function(cqRefInfo){
            var params = {
                shopId : this.getShopId(),
                fromShopId:this.getPlatformShopId()
            };
            return params;
        },
        //加载C端查看公告列表的条件
        getListParamC: function(cqRefInfo){
            var params = {
                isUse:true,
                shopId : this.getShopId(),
                fromShopId:this.getPlatformShopId()
            };
            return params;
        },
        // 商家公告列表点击事件
        onListClickB : function (item) {
            window.moveToView("proclamationB", item._id);
        },
        // 商家公告列表点击事件
        onListClick : function (item) {
            window.moveToView("proclamation", item._id);
        },
        // 加载指定商家公告
        // 参数:
        //      _id
        loadById : function (params) {
            if (!params.cqViewParam.params) {
                return {
                    isUse: true
                };
            }
			return this.exec('loadById', {
                _id: params.cqViewParam.params,
                shopId: this.getShopId()
            }).then(lang.hitch(this, function (result) {
				return result&&result.data&&result.data.item||{}
			}));
        }
    });
    
    var noticeBBo = new NoticeBBo();
    noticeBBo.Bo = NoticeBBo;
    return noticeBBo;
});