define([
    "dojo/_base/declare",
    "dojo/json",
    "dojo/Deferred",
	"dojo/_base/lang",
    "../../../BoBase",
    'cq/util/config/config',
    "cq/util/sys/date",
],function(declare, JSON, Deferred, lang, BoBase, config,date){
    var ImgGallery = declare("", BoBase.B,{
        modalName:"article/pm/gallery",
        fields: {
            imgUrl: {
                type: "image",
                label: "图片",
                sizeType: "cut",
                size: {
                    width: 640,
                    height: 300
                },
                cqWidth:160,
                notNull: true,
                clickImg:true
            },
            application : {
                type: "options",
                label: "用途",
                options : {
                    1:"欢迎页",
                    2:"图标",
                    3:"banner",
                    // 4:"黑巴拉多运动猪肉情人节Banner",
                    // 5:"黑山羊年货节",
                    // 6:"腾达袜厂情人节商城装修风格",
                    // 7:"沃蓝德教师节商城装修风格",
                    // 8:"中秋撞上教师节",
                    // 9:"元宵节"
                } 
            },
            level : {
                type: "text",
                placeHolder: "请输入级别",
                label: "级别"
            },
            label : {
                type: "text",
                placeHolder: "请输入标签",
                label: "标签"
            },
            createAt : {
                type: "text",
                label: "创建时间",
                formatter:function(action,data){
                    var v='';
                    if(data.createAt){
                        v = date.formatISODateMinutes(data.createAt);
                    }
					return v;
				}
            },
            onImgSaveDetailButton: {
                type: "button",
                label: "保存",
                className: "large-width",
                action: "imgSave"
            },
            getBigImgUrl : {
                type : "button"
            }
        },
        addImg : function(){
            window.moveToView("imgDetail");
        },
        loadGallery : function(){
            return this.getBaseUrl() + "/load?shopId=" + this.getShopId();
        },
        getImgQuery : function(params){
            var query = {};
            if(params.search){
                query.search = params.search;
            }
            if(params.state&&params.state._id){
                if(1 == params.state._id){
                    query.application=1;
                }else if(2 == params.state._id){
                    query.application=2;
                }else if(3 == params.state._id){
                    query.application=3;
                // }else if(4 == params.state._id){
                    // query.application=4;    
                // }else if(5 == params.state._id){
                    // query.application=5;    
                // }else if(6 == params.state._id){
                    // query.application=6;    
                // }else if(7 == params.state._id){
                    // query.application=7;    
                // }else if(8 == params.state._id){
                    // query.application=8;    
                // }else if(9 == params.state._id){
                    // query.application=9;    
                }else{
    
                }
            }
            return query;
        },
        getBigImgUrl : function(data){
            if(data._id){
                require(["cq/widgets/bigImg"],lang.hitch(this,function(bugImg){
                    bugImg.show(data.imgUrl);
                }));
            }
        },
        onSImgClick: function (data, action, list) {
            if(action == "getBigImgUrl"){
                this.getBigImgUrl(data);
            }else{
                window.moveToView("imgDetail", data._id);                
            }
		},
        getImgDetailLayout: function () {
            return [{
                type: "form",
                fields: this.getFormItems([
                    "application","imgUrl","level", "label","onImgSaveDetailButton"
                ], true)
            }];
        },
        imgSave: function (data) {
            window.busy();
            if(!data.application){
                alert("用途不能为空");
                return;
            }
            if(!data.imgUrl){
                alert("图片不能为空");
                return;
            }
            if(!data.level){
                alert("级别不能为空");
                return;
            }
            if(!data.label){
                alert("标签不能为空");
                return;
            }
            this.save(data).then(lang.hitch(this, function(result){
                window.free();
                if (result.data && result.data.ok === 1) {
                    alert("保存成功");
                    history.back();
                } else {
                    alert(result&&result.data&&result.data.message||"保存失败");
                }
            }));
        },
        save: function(data){
            return this.exec("save", data).then(lang.hitch(this, function(result){
                return result;
            }));
        },
        getImgDetailData: function (e) {
            window.busy();
            return this.exec("load_by_id", {
                _id: e.cqViewParam.params
            }).then(lang.hitch(this, function (result) {
                window.free();
                return result.data.item;
            }));
        },
        onDataReadyForImgEdit:function(widget){
            var item = widget.getData();
            if(item){
                widget.enableByFields(["imgUrl", "application", "level", "label"]);
            }
            var checkboxbtn =  widget.getEditorByField("application");
            widget.connect(checkboxbtn,"onFieldChanged",lang.hitch(this,function(obj,field,state){
                var uploadImgBtn =  widget.getEditorByField("imgUrl");
                if(state){
                    if(state == "1"){
                        uploadImgBtn.size = {
                            width: 640,
                            height: 250                            
                        }
                    }else if(state == "2" || state == "7"){
                        uploadImgBtn.size = {
                            width: 640,
                            height: 1700                            
                        }                       
                    }else if(state == "3" || state == "4" || state == "9"){
                        uploadImgBtn.size = {
                            width: 640,
                            height: 400                            
                        }                         
                    }else if(state == "5"){
                        uploadImgBtn.size = {
                            width: 640,
                            height: 1000                            
                        }                       
                    }else if(state == "6"){
                        uploadImgBtn.size = {
                            width: 640,
                            height: 2500                            
                        }                         
                    }else if(state == "8"){                        
                        uploadImgBtn.size = {
                            width: 640,
                            height: 2428                            
                        }                      
                    }
                }
            }))           
        }

    });
    var imgGallery = new ImgGallery();
	imgGallery.Bo = ImgGallery;
	return imgGallery;
});