﻿define([
    "dojo/_base/declare",
    "dojo/json",
    "dojo/Deferred",
	"dojo/_base/lang",
    "../../BoBase",
    'cq/util/config/config'
],function(declare, JSON, Deferred, lang, BoBase, config){
    var MatTemp = declare("", BoBase.B,{
        modalName:"article/pm/rich_text_temp",
        fields: {
            logo:{
                type : 'image',
                label : "主题图片",
                className: 'large-width',
				sizeType: 'cut',
				size: {
					width: 640,
					height: 640
				},
                notNull: true
            },
            title:{
                type : 'text',
                label : "名称"
            },
            content:{
                type:'richText',
                label : '内容',
                isAdvance:true,
                notNull: true
            },
            isUse:{
                type : 'checkbox',
                label : '使用',
                selected : true
            },
            tempType:{
                type:"text",
                label:"",
            },
            replaceTxt:{
                type:"objects",
                label:"替换项",
                labelField:"remark",
                canEdit:true,
                canDelete:true,
                canAdd:true,
                canDnd:false,
                fields:{
                    workMode:"edit",
                    className:"editEditor",
                    layout:[{
                        field:"replaceType",
                        type:"options",
                        label:"替换类型",
                        options:{
                            '1': '文字',
                            '2': '图片'
                        },
                        notNull: true
                    },{
                        field:"replaceTxt",
                        type:"text",
                        enableAll:true,
                        placeHolder:"请输入替换值",
                        label:"替换值"
                    }]
                }
            },
            onSaveTemp:{
                type: "button",
				label: "保存",
				action: "save",
				buttonClass: "fullButton"
            }
        },
        getTempLayout : function(){
            return [{
				type: "form",
				fields: this.getFormItems(["logo", "title", "content", "isUse", /*"replaceTxt",*/ "onSaveTemp"], true)
			}];
        },
        onDataReady: function(param){
            
        },
        save: function (data, dataList) {
			var msg = this.getDataValidMsg(data, ['logo', 'title']);
			if (msg) {
				alert(msg);
				return;
			}
            
            data.tempType = "mat";
            window.busy();
			this.exec('save', data).then(function (tempData) {
				if (tempData.data && tempData.data.ok === 1) {
                    window.free();
					history.back();
				} else {
                    window.free();
					alert("保存失败");
				}
			});
		},
        getTempUrl:function(){
            return this.getBaseUrl() + '/load?isUse=true';
        },
        getShopIdTempUrl : function(){
            return this.getBaseUrl() + '/load?isUse=true&shopId='+this.getPlatformShopId();
        },
        onListClick:function(params){
            window.moveToView("matTmpEdt", params._id);
        },
        getListParam: function () {
			return {
				shopId: this.getShopId(),
				orderBy: "createAt"
			};
		},
        loadById: function (params) {
			if (!params.cqViewParam.params) {
                var def = new Deferred();
                def.resolve({
                    isUse: true
                });
                return def;
			}
			var def = new Deferred();
			this.exec('load_by_id', {
				_id: params.cqViewParam.params
			}).then(lang.hitch(this, function (data) {
				data = data.data.item;
				def.resolve(data);
			}));
			return def;
		}
    });
    var matTemp = new MatTemp();
	matTemp.Bo = MatTemp;
	return matTemp;
});