﻿define([
	"dojo/_base/declare",
    "dojo/_base/lang",
    "cq/util/config/config",
    "../../BoBase",
    "./_Mixin",
    "dojo/_base/array"
],function(declare, lang, config, BoBase, _Mixin,array){
	var RecommendRouteBBo = declare("", [BoBase.B, _Mixin], {
        fields:{
            onSave:{
                type:"button",
                action:"onSave"
            },
            deleteById: {
                type: "button",
                action: "deleteById"
            }
        },
        getEdtLayout:function(){
            // summary:
            //        录入景点的layout
            // view:
            //         newsGroupB
            // description:
            //         无
            return [{
                type : "form",
                fields : this.getFormItems(["logo","recommend","routeId","deleteById","onSave"], true)
            }];
        },
        loadById:function(params){
            // summary:
            //        录入景点的
            // view:
            //         newsGroupB
            // description:
            //         无
            if (!(params&&params.cqViewParam&&params.cqViewParam.params)) {
                return;
            }
            return this.exec("loadById",{
                _id:params.cqViewParam.params
            }).then(lang.hitch(this,function(result){
                if(result&&result.data&&result.data.item){
                    return result&&result.data&&result.data.item||{};
                }
            }));
        },
        onDataReady: function(widget){
            var data = widget.getData();
            widget.hideByFields(["deleteById"]);
            if(data._id){
                widget.showByFields(["deleteById"]);
            }
        },
        deleteById: function(data){
            var item = {
                _id: data._id,
                isUse: false
            }
            window.busy();
            this.exec("save", item).then(function(result){
                window.free();
                if(result&&result.data&&result.data.ok){
                    alert("删除成功")
                    history.back();
                }else{
                    alert(result && result.data && result.data.message || "删除失败");
                }
            });
        },
        onSave:function(data){
            var msg = this.getDataValidMsg(data, ["logo","recommend","routeId"]);
			if (msg) {
				alert(msg);
				return;
			}
            window.busy();
            data.routrId = data.routeId._id;
            this.exec("save",data).then(lang.hitch(this,function(result){
                window.free();
                if(result&&result.data&&result.data.ok){
                    alert("线路推荐成功")
                    history.back();
                }else{
                    alert(result && result.data && result.data.message || "线路推荐失败");
                }
            }));
        },
        getListUrl: function(){
            return this.getBaseUrl()+"/load";
        },
        getListParam: function(e){
            return {
                shopId: this.getShopId()
            };
        },
        onListClick: function(data){
            window.moveToView("tRecommendEdit", data._id);
        },
        loadRouteData:function(data,widget,options){
            /*if (!(params&&params.cqViewParam&&params.cqViewParam.params)) {
                return;
            }*/
            //options.shopId = this.getShopId();
            return this.exec("load",options||{}).then(function(data){
                var items = data&&data.data&&data.data.items||[];
                for(var i=0;i<items.length;i++){
                    items[i].shelfTarget = items[i].routeId?"#tRoute-"+items[i].routeId:"";
                }
                return items;
            });
        }
    });
	var recommendRouteBBo = new RecommendRouteBBo();
	recommendRouteBBo.Bo = RecommendRouteBBo;
    return recommendRouteBBo;
});
