﻿define([
	"dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/Deferred",
    "bob/BoBase",
    "./_Mixin",
    "cq/util/sys/date",
    "bob/article/schoolClassStudent",
    "bob/user/consumer"
],function(declare, lang, domConstruct, Deferred, BoBase, _Mixin,date,schoolClassStudent,consumer){
	var SchoolClassCBo = declare("", [BoBase.C, _Mixin], {
        fields:{
            time:{
                type:"text",
                label:"讲堂时间",
            },
            checkSign:{
                type: 'button',
                label: '报到',
                action: 'checkSign'
            },
            checkAttend:{
                type: 'button',
                label: '报名',
                action: 'checkAttend'
            },
            /*isAttended:{
                type:"text"
            },
            isSigned:{
                type:"text"
            },*/
        },
        getListUrl: function(){
            return this.getBaseUrl() + '/load';
        },
        getListParam:function(param){
            var params = {
                shopId: this.getShopId(),
                afterStartDate: date.nowISOString()
                
            };
            if(param.state){
                if(param.state._id==0){
                    params.afterStartDate = date.nowISOString();
                }else{
                    delete params.afterStartDate;
                }
            }
            if(param.search){
                params.title = param.search;
            }
            return params;
        },
        onListClick: function(data,action,widget){
            window.moveToView("classRoomDtl", data._id);
        },
        loadById:function(params){
            // summary:
            //        录入景点的
            // view:
            //         newsGroupB
            // description:
            //         无
            if (!(params&&params.cqViewParam&&params.cqViewParam.params)) {
                return;
            }
            var classId = params.cqViewParam.params,
                def = new Deferred(),
                _this = this;
            this.exec("loadById",{
                _id:params.cqViewParam.params
            }).then(lang.hitch(this,function(data){
                data.data.item.time = date.formatISODateMinutes(data.data.item.startDate)+"~"+date.formatISODateMinutes(data.data.item.endDate);
                //def.resolve(data.data.item);
                return data.data.item;
            })).then(function(data){
                var userInfo = consumer.getCurrentUserFromSession();
                var param = {
                    userId:userInfo&&userInfo._id,
                    classId:classId
                };
                if(userInfo&&userInfo._id){
                    data.userId = userInfo._id;
                }
                //默认显示两个按钮
                //data.isAttended = false;
                //data.isSigned=false;
                //显示底部按钮控制
                schoolClassStudent.getUserState(param).then(lang.hitch(this,function(result){
                    if(result&&result.data&&result.data.item){
                        //登录
                        data.isAttended = result.data.item.isAttended;
                        data.isSigned = result.data.item.isSigned;
                    }
                    def.resolve(data);
                }));
            });
            return def;
        },
        loadStudentUrl:function(params){
            return this.getBaseUrl() + '/loadStudentsById';
        },
        loadStudentParams:function(params){
            var query = {
                _id:params&&params.cqViewParam&&params.cqViewParam.params,
                shopId:this.getShopId()
            };
            return query;
        },
        onDataReady:function(widget){
            //已经签到不显示两个底部button
            //没有报名，已经到报名时间显示报名
            //已经报名，已经到开课时间开始报到
            //没有登录显示两个底部按钮，提示登录
            //isAttended:报名
            //isSigned :签到
            widget.hideByFields(["checkSign","checkAttend"]);
            var data = widget.getData();
            if(data.isAttended){
                if(!data.isSigned){
                    //已报名没签到，时间对，可签到
                    if(date.nowISOString()<data.endDate&&date.nowISOString()>data.startDate){
                        widget.showByFields(["checkSign"]);
                    }
                }
            }else{
                if(typeof(data.isAttended)=="undefinded"){
                    widget.showByFields(["checkSign","checkAttend"]);
                }else{
                    if(date.nowISOString()<data.endSignDate&&date.nowISOString()>data.startSignDate){
                        widget.showByFields(["checkAttend"]);
                    }
                }
            }
        },
        checkSign:function(data, widget){
            window.busy();
            if(data.userId){
                this.exec("signByRoomId",{_id:data._id,userId:data.userId}).then(lang.hitch(this,function(data){
                    window.free();
                    if(data&&data.data&&data.data.ok){
                        widget.cqRefresh();
                        alert("签到成功");
                    }else{
                        alert(data.data.msg||"签到失败");
                    }
                }));
            }else{
                window.moveToView("login");
            }
            
        },
        checkAttend:function(data, widget){
            window.busy();
            if(data.userId){
                var params = {
                    _id:data._id,
                    userId:data.userId
                };
                var _this = this;
                require(["whz/util/addSchoolStudent",
                    "cq/util/edit/overlay"
                ],function(addSchoolStudent,overlay){
                    window.free();
                    addSchoolStudent.createContent().then(lang.hitch(this,function(result){
                        overlay.hide();
                        if(result&&result.sName&&result.sPhone){
                            params.sName = result.sName;
                            params.sPhone = result.sPhone;
                            window.busy();
                            _this.exec("attendByRoomId",params).then(lang.hitch(this,function(data){
                                window.free();
                                if(data&&data.data&&data.data.ok){
                                    widget.cqRefresh();
                                    alert("报名成功");
                                    //加载报名的人
                                    
                                }else{
                                    alert(data.data.msg||"报名失败");
                                }
                            }));
                        }else{
                            alert("您还有信息没有填完，请重新填写");
                        }
                    }));
                    overlay.showElement(addSchoolStudent.domNode,null);
                });
            }else{
                window.moveToView("login");
            }
        }
    });
	var schoolClassCBo = new SchoolClassCBo();
	schoolClassCBo.Bo = SchoolClassCBo;
    return schoolClassCBo;
});
