﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "bob/BoBase",
    "./_Mixin"
], function (declare, lang, BoBase, Mixin) {
	var O = declare("", [BoBase.B, Mixin], {
        //  summary：
        //      添加或修改微信栏目
        //  view：
        //      section
        save : function(data, widget){
            var upSection = widget.cqRefInfo.cqViewParam.params.split(",")[1]||"";
            if(!data._id){
                data.upSection = upSection;
                data.sOrder = this.maxSOrder;   
            }
            if(data.upSection&&data.sectionTypeForSub){
                data.sectionType = data.sectionTypeForSub;
            }
            var msg = this.getDataValidMsg(data, ["title"]);
            if(msg){
                alert(msg);
                return;
            }
            var msg = this.checkedFields(data);
            if(msg){
                alert(msg);
                return;
            }
            window.busy();
            this.toSave(data).then(lang.hitch(this, function(result){
                window.free();
                if(result&&result.data&&result.data.ok==1){
                    alert("保存成功");
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"保存失败");
                }
            }));
        },
        checkedFields: function(data){
            var msg = "";
            if (data.title.length>8) {
                msg = "标题不能超过八个字!";
            }else{
                switch (parseInt(data.sectionType)) {
                case 3:
                    if (!data.groupId) {
                        msg = "品类还没有选择!";
                    }
                    break;
                case 4:
                    var webAddress = new RegExp("http");
                    if (!data.targetPath) {
                        msg = "网址不能为空!";
                    } else if (!webAddress.test(data.targetPath)) {
                        msg = "应该输入“http://www.cqthink.com”格式的网址!";
                    }
                    break;
                case 5:
                    if (!data.arId) {
                        msg = "自动回复内容还没有选择!";
                    }
                    break;
                case 6:
                    if (!data.svcType) {
                        msg = "服务类型还没有选择!";
                    }
                    break;
                default:
                }
                //没有上级,则为一级栏目
                if(""===msg&&!data.upSection&&(data.title.length>8)){
                    msg = "一级栏目的标题数量不能超过八个字!";
                }
            }
            return msg;
        },
        //  summary：
        //      保存微信栏目单行数据
        //  view：
        //      section
        toSave: function(data){
            return this.exec("save", data).then(lang.hitch(this, function(result){
                return result;
            }));
        },
        //  summary：
        //      微信栏目详情布局
        //  view：
        //      section
        getEdtLayout : function(){
            return [{
                type:"form",
                fields:this.getFormItems([
                    "title","sectionType", "sectionTypeForSub", "groupId", "arId", "targetPath", "svcType","save"
                ],true)
            }]
        },
        onDataReady: function(widget){
            var data = widget.getData();
            // 先隐藏所有的
            var hideFields = ["groupId", "arId", "targetPath", "svcType"];
            widget.hideByFields(["sectionType", "sectionTypeForSub"]);
            widget.hideByFields(hideFields);
            //data.sectionType = data.sectionTypeForSub;
            if(!data.upSection&&data.sectionType){
                widget.showByFields(["sectionType"]);
            }else{
                widget.showByFields(["sectionTypeForSub"]);
            }
            if(data._id) {
                if(data.sectionType==1){
                    widget.hideByFields(hideFields);
                }if(data.sectionType==2){
                    widget.hideByFields(hideFields);
                }else if(data.sectionType==3){
                    widget.hideByFields(hideFields);
                    widget.showByFields(["groupId"]);
                }else if(data.sectionType==4){
                    widget.hideByFields(hideFields);
                    widget.showByFields(["targetPath"]);
                }else if(data.sectionType==5){
                    widget.hideByFields(hideFields);
                    widget.showByFields(["arId"]);
                }else if(data.sectionType==6){
                    widget.hideByFields(hideFields);
                    widget.showByFields(["svcType"]);
                }else{
                    
                }
            }
            var typeNodeForSub =  widget.getEditorByField("sectionTypeForSub");
            widget.connect(typeNodeForSub,"onFieldChanged",lang.hitch(this,function(obj,field,state){
                changeFieldState(state);
            }));
            var typeNode = widget.getEditorByField("sectionType");
            widget.connect(typeNode,"onFieldChanged",lang.hitch(this,function(obj,field,state){
                changeFieldState(state);
            }));
            var changeFieldState = function(state){
                if(state==1){
                    widget.hideByFields(hideFields);
                }else if(state==2){
                    widget.hideByFields(hideFields);
                }else if(state==3){
                    widget.hideByFields(hideFields);
                    widget.showByFields(["groupId"]);
                }else if(state==4){
                    widget.hideByFields(hideFields);
                    widget.showByFields(["targetPath"]);
                }else if(state==5){
                    widget.hideByFields(hideFields);
                    widget.showByFields(["arId"]);
                }else if(state==6){
                    widget.hideByFields(hideFields);
                    widget.showByFields(["svcType"]);
                }else{
                    
                }
            };
        },
        // 最大编号 处理排序问题
        maxSOrder: 0,
        // 加载单行数据
        loadById: function(params){
            var id = params.cqViewParam.params.split(",");
            return this.load().then(lang.hitch(this, function(items){
                for(var i=0;i<items.length;i++){
                    var sOrder = items[i].sOrder||0;
                    if(sOrder>this.maxSOrder){
                        this.maxSOrder = sOrder;
                    }
                }
                this.maxSOrder += 1;
                if(!id[0]){
                    if(id[1]){
                        return {
                            sectionTypeForSub : 2
                        };
                    }else{
                        return {
                            sectionType : 1
                        };
                    }
                }else{
                    return this.exec("loadById", {
                        _id: id[0]
                    }).then(lang.hitch(this, function(result){
                        var item = result&&result.data&&result.data.item||{}
                        item.sectionTypeForSub = item.sectionType;
                        return item;
                    }));
                }
            }));
        },
        load: function(){
            return this.exec("load", this.getListParam()||{}).then(lang.hitch(this, function(result){
                return result&&result.data&&result.data.items||[];
            }));
        },
        // 加载栏目的参数
        getListParam: function(){
            var query = {
                shopId: this.getShopId(),
                orderBy: "sOrder"
            };
            return query;
        },
        deleteById: function(data,widget){
            return this.exec("deleteById", {
                _id: data._id
            }).then(lang.hitch(this, function(result){
                return result;
            }));
        },
        refresh: function(){
            
        },
        createWxMenu: function(data){
            // 检查数据
            return this.exec("createWxMenu", {
                data:{
                    button : data
                }
            }).then(lang.hitch(this, function(result){
                return result;
            }));
        },
        getNewsSectionUrl:function(){
            return this.getBaseUrl()+"/load?shopId="+this.getShopId()+"&sectionType=2";
        }
    });
	var o = new O();
	o.Bo = O;
	return o;
});