// 创建人：周超
// 创建时间：2017-1-5
// 创建内容：资讯列表、详情
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
	"dojo/Deferred",
    "cq/util/config/config",
	"cq/util/sys/date",
    '../../BoBase',
    '../../shop/shop',
    "./_Mixin"
], function (declare,lang,Deferred,config,date,BoBase,shop,_Mixin) {
    var ServiceArticleBo = declare("", [BoBase.B, _Mixin], {
		fields:{
			createAt:{
				type:"date",
				formatter:function(v){return date.formatISODate(v);},
				label:"发布日期"
			}
		},
        //  资讯（详情）布局
        getServiceArticleLayout: function(){
            // 可选的服务项目应从认证的服务项目中选择
            var def = new Deferred();
            shop.loadMe().then(lang.hitch(this,function(shopData){
                var options = {};
                if(shopData&&shopData.services&&shopData.services.length>0){
                    for(var i=0;i<shopData.services.length;i++){
                        options[shopData.services[i].serviceType] = config.shopService[shopData.services[i].serviceType];
                    }
                }
                this.fields.serviceType.options = options;
                def.resolve([{
                    type: "form",
                    fields: this.getFormItems([
                        "logo",
                        "code",
                        "title",
                        "serviceType",
                        "brief",
                        "content",
                        "isUse",
                        "saveButton"
                    ])
                }]) ;
            }));
            return def;
        },
        //  详情加载数据
        loadById: function(parms){
            if(parms&&parms.cqViewParam&&parms.cqViewParam.params){
                return this.exec("loadById", {
                    _id: parms.cqViewParam.params//this.getShopId()
                }).then(lang.hitch(this, function(result){
                    return result.data.item;
                }));
            }else{
                return {};
            }
        },
        //  详情从平台加载数据
        loadByIdFromPlat: function(parms){
            if(parms&&parms.cqViewParam&&parms.cqViewParam.params){
                return this.exec("loadByIdFromPlat", {
                    _id: parms.cqViewParam.params,
					platformShopId:this.getPlatformShopId()
                }).then(lang.hitch(this, function(result){
                    return result.data.item;
                }));
            }else{
                return {};
            }
        },
        //  保存
        save: function(data){
            var fields = ["code","title","serviceType","brief"];
            var msg = this.getDataValidMsg(data,fields);
            if(msg){
                alert(msg);
                return;
            }
            this.exec("save", data).then(lang.hitch(this, function(result){
                if(result.data&&result.data.ok==1){
                    alert("保存成功");
                    history.back();
                }else{
                    alert("服务器繁忙，清稍后再试！");
                    return;
                }
            }))
        },
        //   列表加载数据url
        getArticleListUrl:function(){
            return this.getBaseUrl()+"/load?";
        },
        //  列表筛选条件
        getSearchListQuery:function(parms){
            var query = {};
            query.shopId = this.getShopId();
            if(parms.search){
                query.title = parms.search;
            }
            return query;
        },
        //  列表点击跳转
        onArticleClick: function(data){
            window.moveToView("serviceArticle",data._id);
        },
        add: function(){
            window.moveToView("serviceArticle");
        }
    });
    var serviceArticleBo = new ServiceArticleBo();
    serviceArticleBo.Bo = ServiceArticleBo;
    return serviceArticleBo;
});