﻿define([
    "dojo/_base/declare",
    "bob/BoBase",
    "bob/user/consumer",
    "dojo/_base/lang",
    "./_Mixin"
], function(declare, BoBase, consumer, lang, Mixin){
    var C = declare("bob.article.ss.comment.c",[BoBase.C, Mixin],{
        toAddAdditionalComment: function(data, widget){
            var msg = this.getDataValidMsg(data, ["userReply"]);
            if(msg){
                alert(msg);
                return;
            }
            data._id = widget.cqRefInfo.cqViewParam.params;
            window.busy();
            this.onAddAdditionalComment(data).then(lang.hitch(this, function(result){
                window.free();
                if(result&&result.data&&result.data.ok==1){
                    alert("追加成功");
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.msg||"追加失败");
                }
            }));
        },
        onAddAdditionalComment: function(params){
            params.userId = consumer.getCurrentUserId();
            return this.exec("appendReply",params);
        },
        getListParamByUser : function () {
            var params = {
                shopId : this.getShopId(),
                commentType : "mat",
                withMat:'1',
                userId: consumer.getCurrentUserId()
            };
            return params;
        },
        getListParamByMat: function(e){
            var params = {
                shopId : this.getShopId()
            };
            if (e.cqViewParam.params) {
                params.commentType = "mat";
                params.commentId = e.cqViewParam.params.split("_")[0];
                params.fromShopId = e.cqViewParam.params.split("_")[1]||this.getShopId();
            }
            return params;
        },
        // 获得评论的路由
        getCommentUrl: function () {
            return this.getBaseUrl() + '/load?shopId=' + this.getShopId();
        },
        // 获得评论的查询方式
        getParamList: function (cqRefInfo) {
            var params = {
                pageSize: 10,
                commentType: 'mat'
            };
            cqRefInfo = cqRefInfo.cqViewParam;
            if (cqRefInfo) {
                if (cqRefInfo.fromShopId) {
                    params.fromShopId = cqRefInfo.fromShopId;
                }
                if (cqRefInfo._id) {
                    params.commentId = cqRefInfo._id;
                }
            }
            return params;
        },
        loadNewOneByMat: function(params){
            return this.exec('loadNewOne', {
        		commentId: params._id,
        		commentType: 'mat',
                fromShopId: params.fromShopId
        	});
        },
        load: function (params) {
            return this.exec('load', {
                commentId: params._id,
                commentType: 'mat'
            });
        },
        getListUrlByFarmer : function(){
            return this.getBaseUrl() +"/loadByFarmerId"
        },
        getListParamByFarmer : function(cqRefInfo){
            var params = {};
            if(cqRefInfo.cqViewParam&&cqRefInfo.cqViewParam.params){
                params = {
                    shopId: this.getShopId(),
                    farmer: cqRefInfo.cqViewParam.params
                }
			}
            return params;
        },
        setItemPro:function(item){
            //如果客户是微信客户引用不出来的问题
            if(!item.userId){
                item.userId = {logo:'images/temp/footerbar/i4.jpg',_id:"00"};
            }
            return item;
        },
    });
    var c = new C();
    c.Bo = C;
	return c;
});