﻿
define([
    "dojo/_base/declare"
], function (declare) {
    return declare("",null,{
        modalName:"article/t/tPoint",
        //景点名称、logo、经纬度、省市区县镇、详细地址、景点介绍不允许为空
        fields:{
            pointName:{
                type:"text",
                label:"景点名称",
                notNull: true
            },
            logo:{
                type: 'image',
				label: 'LOGO',
                sizeType: "cut",
                size: {
                    width: 640,
                    height: 640
                }
            },
            "lon,lat":{
                type:"location",
                label:"地理位置",
                //用于联动区划，传入省市区ID字段名，不联动则传入空字符串
                distFields:"provinceId,cityId,countyId",
                //区域划分地址字段名(显示字段名)
                distFieldsStr:"countyName",
                //详细地址
                detailAddrField:"detailAddress",
                className: "lon-lat-high",
                notNull:true
            },
            //区划编辑,省、市、县、地址文本
            "provinceId,cityId,countyId,countyName" : {
                type : "district",
                label : "省-市-区县",
                canEdit : true,
                className:"large-width province-high",
                placeHolder:"请选择"
            },
            "countyId,townId,villageId,townName" : {
                type : "village",
                label: "乡镇",
                canEdit:true
            },
            countyName: {
                type: "text",
                label: "省-市-区县",
				className:"middle-width",
                notNull: true
            },
            townName : {
                type: "text",
                label: "乡镇",
				className:"middle-width",
                notNull: true
            },
            detailAddress:{
                type:"text",
                label:"详细地址",
                notNull: true
            },
            pointInfo:{
                type:"richText",
                label:"景点介绍",
                notNull: true
            },
            pointSpecial:{
                type:"text",
                label:"景点特色",
            },
            pointCapacity:{
                type:"number",
                label:"接待能力"
            },
            avgPriceFrom:{
                type:"number",
                label:"均价从",
                fixedTo:2
            },
            avgPriceTo:{
                type:"number",
                label:"均价到",
                fixedTo:2
            },
            navigateKeyword:{
                type:"text",
                label:"导航"
            },
            navigateInfo:{
                type:"text",
                label:"导航信息"
            },
            parkingInfo:{
                type:"text",
                label:"停车信息"
            },
            neighbourInfo:{
                type:"text",
                label:"周边信息"
            },
            contactName:{
                type:"text",
                label:"联系人"
            },
            contactTel:{
                type:"text",
                label:"联系电话"
            },
            contactQQ:{
                type:"text",
                label:"联系人QQ"
            },
            contactWeXin:{
                type:"text",
                label:"联系人微信"
            },
            honourInfo:{
                type:"text",
                label:"景区级别"
            },
            visitedCount:{
                type:"number",
                label:"到访数"
            },
            wantToVisitCount:{
                type:"number",
                label:"想去数"
            },
            avgScore:{
                type:"number",
                label:"平均得分"
            }
        },
        loadById:function(params){
            // summary:
            //        录入景点的
            // view:
            //         newsGroupB
            // description:
            //         无
            if (!(params&&params.cqViewParam&&params.cqViewParam.params)) {
                return;
            }
            return this.exec("loadById",{
                _id:params.cqViewParam.params
            });
        },
        getListParam:function(params){
            var query = {};
            if(params.search){
                query.search = params.search;
            }
            return query;
        },
        onListClick:function(item){
            window.moveToView("tPointEdit",item._id);
        },
        getListUrl:function(){
            return this.getBaseUrl() + '/load?shopId='+this.getShopId();
        }
    });
});
