﻿define([
	"dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "cq/util/config/config",
    "../../BoBase",
    "./_Mixin"
],function(declare, lang, array, config, BoBase, _Mixin){
	var TPointBo = declare("", [BoBase.B, _Mixin], {
        fields:{
            onSave: {
                type: 'button',
                label: '保存',
                action: 'onSave'
            },
            vtag:{
                type:"text",
                label:"标签"
            },
            tags:{
                type : "ref",
                label : "标签",
                dataProvider : "bob/article/travelTag/c",
                targetMethod : "getListUrl",
                labelFields : "tag",
                searchField : "tag",
                canEdit : true,
                pageSize : 10,
                multiselect : "multiselect",
                setRightTextMethod: "setRight"
            },
            lon: {
                type: "text",
                label: "经度"
            },
            lat: {
                type: "text",
                label: "纬度"
            },
            deleteById: {
                type: "button",
                action: "deleteById"
            },
            tempId: {
                type: "options",
                options: {
                    "1": "模板1"
                },
                label: "模板"//,
                //notNull: true
            }
        },
        getEdtLayout:function (){
            // summary:
            //        录入景点的layout
            // view:
            //         newsGroupB
            // description:
            //         无
            return [{
                type : "form",
                fields : this.getFormItems(["logo","pointName",
                "provinceId,cityId,countyId,countyName",
                "countyId,townId,villageId,townName",
                "lon,lat","lon", "lat","detailAddress"/*,"tempId"*/, "pointInfo", "pointSpecial",
                "pointCapacity", "avgPriceFrom","avgPriceTo",
                "navigateKeyword","navigateInfo","parkingInfo",
                "neighbourInfo","contactName","contactTel",
                "contactQQ","contactWeXin","vtag","deleteById","onSave"], true)
            }];
        },
        loadByIds:function(ids){
            return this.exec("loadByIds",{_id:id});
        },
        loadById:function(params){
            // summary:
            //        录入景点的
            // view:
            //         newsGroupB
            // description:
            //         无
            if (!(params&&params.cqViewParam&&params.cqViewParam.params)) {
                return;
            }
            return this.exec("loadById",{
                _id:params.cqViewParam.params
            }).then(lang.hitch(this,function(result){
                if(result&&result.data&&result.data.item){
                    return result&&result.data&&result.data.item||{};
                }
            })).then(function(item){
                if(item&&item.tags){
                    item.vtag = item.tags.map(function(i){
                        return i.tagName;
                    });
                }
                return item;
            });
        },
        onDataReady: function(widget){
            var data = widget.getData();
            widget.hideByFields(["deleteById"]);
            if(data._id){
                widget.showByFields(["deleteById"]);
            }
        },
        deleteById: function(data, widget){
            var item = {
                _id: data._id,
                isUse: false
            };
            window.busy();
            this.exec("deleteById", item).then(function(result){
                window.free();
                if(result&&result.data&&result.data.ok){
                    alert("删除成功");
                    history.back();
                }else{
                    alert(result && result.data && result.data.message || "删除失败");
                }
            });
        },
        //加载条件
        
        onSave:function(data){
            var msg = this.getDataValidMsg(data, ["pointName","logo",
                "provinceId,cityId,countyId,countyName",
                "countyId,townId,villageId,townName",
                "detailAddress","tags",/*"tempId", */"pointInfo", "pointSpecial","pointCapacity", "avgPriceFrom","avgPriceTo","navigateKeyword","navigateInfo","parkingInfo",
                "neighbourInfo","contactName","contactTel","contactQQ","contactWeXin"]);
			if (msg) {
				alert(msg);
				return;
			}
            window.busy();
            /*if(data.tags&&data.tags.length){
                var tags = [];
                array.forEach(data.tags, function(tag){
                    tags.push({
                        tagId: tag._id,
                        tagName:tag.tag
                    });
                });
                data.tags = tags;
            }*/
            data.tags = data.vtag?data.vtag.split(",").map(function(tag){
                return {
                    tagName:tag
                };
            }):[];
            data.provinceId = data.provinceId._id||data.provinceId;
            data.countyId = data.countyId._id||data.countyId;
            data.cityId = data.cityId._id||data.cityId;
            data.townId = data.townId._id||data.townId;
            //景点处的模板
            /*var html = "", tempId = data.tempId, tempHtml = config.pointTempId[tempId], cur = "";
            cur = tempHtml;
            for(var field in data){
                cur = cur.replace("{{"+field+"}}", data[field]||"");
            }
            html = html + cur;
            data.content = html;*/
            this.exec("save",data).then(lang.hitch(this,function(result){
                window.free();
                if(result&&result.data&&result.data.ok){
                    alert("景点保存成功");
                    history.back();
                }else{
                    alert(result && result.data && result.data.message || "景点保存失败");
                }
            }));
        },
    });
	var tPointBo = new TPointBo();
	tPointBo.Bo = TPointBo;
    return tPointBo;
});
