﻿define([
	"dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "bob/BoBase",
    "./_Mixin",
    "cq/util/image/blob"
],function(declare, lang, domStyle, BoBase, _Mixin,blob){
	var TPointCBo = declare("", [BoBase.C, _Mixin], {
        fields:{
			//用于列表显示小图
			sLogo:{
                type: 'image',
				label: 'LOGO',
				formatter:function(value,item){
					return blob.getImageUrl(item.logo,"160");
				}
			}
        },
        loadByIdFortravel:function(id){
            return this.exec("loadById",{_id:id});
        },
        getListParam:function(params){
            var query = {
            };
            if(params.search){
                query.search = params.search;
            }
            query.tags = [];
            if(params.tag1&&params.tag1._id){
                query.tags.push(params.tag1.tag);
                query.tag1 = params.tag1.tag;
            }
            if(params.tag2&&params.tag2._id){
                query.tags.push(params.tag2.tag);
                query.tag2 = params.tag2.tag;
            }
            if(params.tag3&&params.tag3._id){
                query.tags.push(params.tag3.tag);
                query.tag3 = params.tag3.tag;
            }
            return query;
        },
        getListParamByOpShop: function(params){
            var query = {
                opShopId: params.cqViewParam.params
            };
            return query;
        },
        getListParamBySevShop: function(params){
            var query = {
                sevShopId: params.cqViewParam.params
            };
            return query;
        },
        share: function(a,b,widget,c){
            window.busy();
            require(["cq/util/share/share"], lang.hitch(this, function(share){
                this.exec("loadById",{_id:widget.cqRefInfo.cqViewParam.params}).then(lang.hitch(this,function(data){
                    window.free();
                    if(data&&data.data&&data.data.item){
                        data = data.data.item;
                        var options = [{
                        "weixin": {
                                title: data.pointName,
                                thumb: data.logo || "",
                                url:share.getPageLoc(this.getShopId(),"#tPoint-" + data._id)
                            }
                        }, {
                            "friendCircle": {
                                title: data.pointName,
                                thumb: data.logo || "",
                                url:share.getPageLoc(this.getShopId(),"#tPoint-" + data._id)
                            }
                        }, {
                            "copy": {
                                url: share.getPageLoc(this.getShopId(),"#tPoint-" + data._id)
                            }
                        }];
                        share.showShare(options);
                    }
                }));
            }));
        },
        navigation:function(a,b,widget,c){
            window.busy();
            this.exec("loadById",{
                _id:widget.cqRefInfo.cqViewParam.params
            }).then(lang.hitch(this,function(data){
                if(data&&data.data&&data.data.item){
                    var point = {
                        _id:data.data.item._id,
                        title:data.data.item.pointName,
                        lon:data.data.item.lon,
                        lat:data.data.item.lat
                    };
                    require([
                        "cq/util/sys/wx",
                        "cq/util/sys/userAgent"
                    ],function(wx,userAgent){
                        window.free();
                        if(userAgent.isWeixin()&&wx.isReady){
                            wx.openLocation(point.lon,point.lat,point.title);
                        }else if(!userAgent.isIos()&&!userAgent.isAndroid()){
                            window.moveToView('travelMap',encodeURIComponent(JSON.stringify({
                                tp:"point",
                                points:[point]
                            }))); 
                        }else{
                            var aHref = "androidamap://navi?sourceApplication=appname&poiname=fangheng&lat="+point.lat+"&lon="+point.lon+"&dev=1&style=1"
                            window.location.href = aHref;
                        }
                    });
                }else{
                    window.free();
                }
            }));
        },
        navShare:function(a,b,widget,evt){
            if(widget.cqRefInfo.cqViewParam.params){
                var params = JSON.parse(decodeURIComponent(widget.cqRefInfo.cqViewParam.params));
                var title = "";
                if(params.tp==="nav"||params.tp==="point"){
                    title = params.points[0].title;
                }else if(params.tp==="route"){
                    title= params.routeName;
                }
                window.busy();
                require(["cq/util/share/share"], lang.hitch(this, function(share){
                    window.free();
                        
                        var options = [{
                        "weixin": {
                                title: title,
                                thumb: "",
                                url:share.getPageLoc(this.getShopId(),"#travelMap-" + widget.cqRefInfo.cqViewParam.params)
                            }
                        }, {
                            "friendCircle": {
                                title: title,
                                thumb: "",
                                url:share.getPageLoc(this.getShopId(),"#travelMap-" + widget.cqRefInfo.cqViewParam.params)
                            }
                        }, {
                            "copy": {
                                url: share.getPageLoc(this.getShopId(),"#travelMap-" + widget.cqRefInfo.cqViewParam.params)
                            }
                        }];
                        share.showShare(options);
                }));
            }
        },
        loadByIds:function(ids){
            return this.exec("load",{
                ids:ids,
                pageSize:100
            });
        }
    });
	var tPointCBo = new TPointCBo();
	tPointCBo.Bo = TPointCBo;
    return tPointCBo;
});
