﻿
define([
    "dojo/_base/declare",
    "dojo/_base/lang"
], function (declare,lang) {
    return declare("",null,{
        modalName:"article/t/tRoute",
        fields:{
            routeName:{
                type:"text",
                label:"线路名称",
                notNull: true
            },
            days:{
                type:"number",
                label:"所需天数"
            },
            routeBrief:{
                type:"richText",
                label:"线路简介",
                notNull: true
            },
            tags:{
                type : "ref",
                label : "标签",
                dataProvider : "bob/article/travelTag/c",
                targetMethod : "getListUrl",
                labelFields : "tag",
                searchField : "tag",
                canEdit : true,
                pageSize : 10,
                multiselect : "multiselect",
                setRightTextMethod: "setRight"
            },
            //区划编辑,省、市、县、地址文本
            "provinceId,cityId,countyId,countyName" : {
                type : "district",
                label : "省-市-区县",
                canEdit : true,
                enableAll:true,
                className:"large-width province-high",
                placeHolder:"请选择"
            },
            "countyId,townId,villageId,townName" : {
                type : "village",
                label: "乡镇",
                enableAll:true,
                canEdit:true
            },
            countyName: {
                type: "text",
                label: "省-市-区县",
				className:"middle-width",
                notNull: true
            },
            townName : {
                type: "text",
                label: "乡镇",
				className:"middle-width",
                notNull: true
            },
            points: {
                type: 'objects',
                label: '景点',
                canEdit:true,
                canDelete:true,
                canAdd:true,
                canDnd:false,
                fields: {
                    workMode:"edit",
                    className:"editEditor",
                    layout: [{
                        field : "pointId",
                        label:"景点选择",
                        type: 'ref',
                        dataProvider: 'bob/article/tPoint/b',
                        targetMethod: 'getListUrl',
                        className: 'middle-width',
                        searchField: 'search',
                        labelFields: 'pointName',
                        labelAttr:"pointName",
                        notNull: true,
                        query: {
                            withPointInfo: true
                        }
                    }, {
                        field : "recommand",
                        type : "text",
                        notNull : true,
                        label : "商家建议"
                    }]
                }
            },
            logo:{
                type: 'image',
				label: 'LOGO',
                sizeType: "cut",
                size: {
                    width: 750,
                    height: 288
                }
            },
        },
        loadById:function(params){
            // summary:
            //        录入景点的
            // view:
            //         newsGroupB
            // description:
            //         无
            if (!(params&&params.cqViewParam&&params.cqViewParam.params)) {
                return;
            }
            return this.exec("loadById",{
                _id:params.cqViewParam.params
            });
        },
        //加载条件
        getListParam:function(params){
            var query = {};
            if(params.search){
                query.search = params.search;
            }
            return query;
        },
        onListClick:function(item){
            window.moveToView("tRouteEdit",item._id);
        },
        getListUrl:function(){
            return this.getBaseUrl() + '/load?shopId='+this.getShopId();
        }
    });
});
