﻿define([
	"dojo/_base/declare",
    "dojo/_base/lang",
    "cq/util/config/config",
    "../../BoBase",
    "./_Mixin",
    "dojo/_base/array"
],function(declare, lang, config, BoBase, _Mixin,array){
	var TRouteBo = declare("", [BoBase.B, _Mixin], {
        fields:{
            content: {
                type: "richText",
                label: "内容"
            },
            tempId: {
                type: "options",
                options: {
                    "1": "模板1"
                },
                label: "模板",
                notNull: true
            },
            vtag:{
                type:"text",
                label:"标签"
            },
            onSave:{
                type:"button",
                action:"onSave"
            },
            deleteById: {
                type: "button",
                action: "deleteById"
            }
        },
        getEdtLayout:function(){
            // summary:
            //        录入景点的layout
            // view:
            //         newsGroupB
            // description:
            //         无
            return [{
                type : "form",
                fields : this.getFormItems(["logo","routeName","days","routeBrief",
                "provinceId,cityId,countyId,countyName",
                "countyId,townId,villageId,townName",
                "points", "tempId", "content","vtag","deleteById","onSave"], true)
            }];
        },
        loadById:function(params){
            // summary:
            //        录入景点的
            // view:
            //         newsGroupB
            // description:
            //         无
            if (!(params&&params.cqViewParam&&params.cqViewParam.params)) {
                return;
            }
            return this.exec("loadById",{
                _id:params.cqViewParam.params
            }).then(lang.hitch(this,function(result){
                if(result&&result.data&&result.data.item){
                    return result&&result.data&&result.data.item||{};
                }
            })).then(function(item){
                if(item&&item.tags){
                    item.vtag = item.tags.map(function(i){
                        return i.tagName;
                    }).join(",");
                }
                return item;
            });
        },
        onDataReady: function(widget){
            var data = widget.getData();
            widget.hideByFields(["deleteById"]);
            if(data._id){
                widget.showByFields(["deleteById"]);
            }
        },
        deleteById: function(data, widget){
            var item = {
                _id: data._id,
                isUse: false
            };
            window.busy();
            this.exec("deleteById", item).then(function(result){
                window.free();
                if(result&&result.data&&result.data.ok){
                    alert("删除成功");
                    history.back();
                }else{
                    alert(result && result.data && result.data.message || "删除失败");
                }
            });
        },
        onSave:function(data){
            var msg = this.getDataValidMsg(data, ["routeName","logo","days","routeBrief", 
                //"provinceId,cityId,countyId,countyName","countyId,townId,villageId,townName",
                "points", "tempId"]);
			if (msg) {
				alert(msg);
				return;
			}
            data.tags = data.vtag?data.vtag.split(",").map(function(i){
                return {
                    tagName:i
                };
            }):[];
            data.provinceId = data.provinceId&&data.provinceId._id||data.provinceId;
            data.countyId = data.countyId&&data.countyId._id||data.countyId;
            data.cityId = data.cityId&&data.cityId._id||data.cityId;
            data.townId = data.townId&&data.townId._id||data.townId;
            // 重新生成html片段
            if(data.points){
                var html = "", tempId = data.tempId, tempHtml = config.routeTempId[tempId], cur = "";
                array.forEach(data.points, function(point){
                    var fields = point.pointId;
                    cur = tempHtml;
                    for(var field in fields){
                        cur = cur.replace("{{"+field+"}}", fields[field]||"");
                    }
                    html = html + cur;
                });
                data.content = html;
            }
            window.busy();
            if(data.points&&data.points.length){
                var points = [];
                array.forEach(data.points, function(m){
                    points.push({
                        pointId: m.pointId,
                        recommand:m.recommand
                    });
                });
                data.points = points;
            }
            this.exec("save",data).then(lang.hitch(this,function(result){
                window.free();
                if(result&&result.data&&result.data.ok){
                    alert("路线保存成功");
                    history.back();
                }else{
                    alert(result && result.data && result.data.message || "路线保存失败");
                }
            }));
        },
    });
	var tRouteBo = new TRouteBo();
	tRouteBo.Bo = TRouteBo;
    return tRouteBo;
});
