﻿define([
	"dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojo/Deferred",
    "bob/BoBase",
    "./_Mixin"
],function(declare, lang, domStyle, Deferred, BoBase, _Mixin){
	var TRouteCBo = declare("", [BoBase.C, _Mixin], {
        fields:{
            wantGo:{
                label:"想去",
                type: "button",
                action: "wantGo",
            },
            beenGo: {
                label:"去过",
                type: "button",
                action: "beenGo",
            },
            navigation: {
                label:"导航",
                type: "button",
                action: "navigation",
            },
            tp:{
                label:"状态",
                type: "Number"
            },
            alertComment:{
                label:"修改",
                type: "button",
                action: "navigation",
            },
            tp1:{
                label:"状态",
                type: "Number"
            },
            tp2:{
                label:"状态",
                type: "Number"
            },
            tpDate:{
                label:"时间",
                type:"date"
            }
        },
        getListUrl: function(){
            return this.getBaseUrl() + '/load';
        },
        // 加载线路的参数
        getListParam: function(e){
            var params = {
                shopId: this.getShopId()
            };
            var did = e.cqViewParam.params, hash = did.split("_");
            if(hash.length){            
                if(hash.length==1){
                    params.fromShopId = hash[0];
                }
                if(hash.length==2){
                    if(hash[0]=="opShop"){
                        params.opShopId = hash[1];
                    }else if(hash[0]=="sevShop"){
                        params.sevShopId = hash[1];
                    }else{
                        params.fromShopId = hash[0];
                        params.search = hash[1]; 
                    }
                }
            }
            return params;
        },
        getItemProp: function(item){
            item.pointQty = item.points.length;
            return item;
        },
        onListClick: function(data,action,widget){
            window.moveToView("tRoute", data._id);
        },
        getListParamByMain: function(params){
            var query = {
                shopId: this.getShopId()
            };
            query.tags = [];
            if(params.tag1&&params.tag1._id){
                query.tags.push(params.tag1.tag);
                query.tag1 = params.tag1.tag;
            }
            if(params.tag2&&params.tag2._id){
                query.tags.push(params.tag2.tag);
                query.tag2 = params.tag2.tag;
            }
            if(params.tag3&&params.tag3._id){
                query.tags.push(params.tag3.tag);
                query.tag3 = params.tag3.tag;
            }
            return query;
        },
        // 加载区县路线列表
        getListParamByOpShop: function(params){
            var query = {
                opShopId: params.cqViewParam.params,
                shopId: this.getShopId()
            };
            return query;
        },
        // 加载乡镇路线列表
        getListParamBySevShop: function(e){
            return {
                sevShopId: e.cqViewParam.params,
                shopId: this.getShopId()
            };
        },
        loadByIdFortravel:function(id){
            return this.exec("loadById",{_id:id});
        },
        loadById:function(params){
            // summary:
            //        录入景点的
            // view:
            //         newsGroupB
            // description:
            //         无
            if (!(params&&params.cqViewParam&&params.cqViewParam.params)) {
                return;
            }
            var shopId = this.getShopId(),def = new Deferred();
            this.exec("loadById",{
                _id:params.cqViewParam.params
            }).then(lang.hitch(this,function(data){
                def.resolve(data.data.item);
            }));
            return def;
        },
        titleClickToOpShop: function(data, widget){
            window.moveToView("tRouteList", "opShop_"+widget.cqRefInfo.cqViewParam.params);
        },
        titleClickToSevShop: function(data, widget){
            window.moveToView("tRouteList", "sevShop_"+widget.cqRefInfo.cqViewParam.params);
        },
        share: function(a,b,widget,c){
            require(["cq/util/share/share"], lang.hitch(this, function(share){
                this.exec("loadById",{_id:widget.cqRefInfo.cqViewParam.params}).then(lang.hitch(this,function(data){
                    if(data&&data.data&&data.data.item){
                        data = data.data.item;
                        var options = [{
                        "weixin": {
                                title: data.routName,
                                thumb: data.logo || "",
                                url:share.getPageLoc(this.getShopId(),"#tRoute-" + data._id)
                            }
                        }, {
                            "friendCircle": {
                                title: data.routName,
                                thumb: data.logo || "",
                                url:share.getPageLoc(this.getShopId(),"#tRoute-" + data._id)
                            }
                        }, {
                            "copy": {
                                url: share.getPageLoc(this.getShopId(),"#tRoute-" + data._id)
                            }
                        }];
                        share.showShare(options);
                    }
                }));
            }));
        },
        navRoute:function(e){
            var id = e.cqRefInfo.cqViewParam.params;//arguments[2]
            this.exec("loadById",{_id:id}).then(lang.hitch(this,function(data){
                if(data&&data.data&&data.data.ok==1&&data.data.item){
                    data = data.data.item;
                    var pp = [];
                    for(var i=0;i<data.points.length;i++){
                        pp.push({
                            _id:data.points[i].pointId._id,
                            title:data.points[i].pointId.pointName,
                            lon:data.points[i].pointId.lon,
                            lat:data.points[i].pointId.lat,
                        });
                    }
                    var param = encodeURIComponent(JSON.stringify({
                        tp:"route",
                        points:pp,
                        routeName:data.routeName
                    }));
                    window.moveToView("travelMap",param);
                }
            }));
        }
    });
	var tRouteCBo = new TRouteCBo();
	tRouteCBo.Bo = TRouteCBo;
    return tRouteCBo;
});
