﻿//订单系统公共基类
// 1、提供订单系统的基本属性
// 2、提供公用的方法
define([
    "dojo/_base/declare"
], function (declare) {
    return declare("",null,{
        modalName: "article/user_image",
        fields:{
            title:{
                type:"text",
                label:"标题",
                canEdit:true,
                notNull: true
            },
            logoPath:{
                type:"image",
                label:"LOGO",
                sizeType:"upload",
                size:{
                    width:256,
                    height:256
                },
                notNull:true
            },
            prodImgPath:{
                type:"image",
                label:"商品图片",
                sizeType:"upload",
                size:{
                    width:170,
                    height:110
                },
                notNull:true
            },
            prodDesc:{
                type:"textarea",
                label:"商品文案",
                canEdit:true,
                notNull:true
            },
            validDate:{
                type:"text",
                label:"有效期",
                canEdit:false
            },
            qrCodeUrl:{
                type:"text",
                label:"二维码网址",
                canEdit:true
            },
            bgImgPath:{
                /*type:"image",
                label:"背景图片",
                sizeType:"upload",
                size:{
                    width:488,
                    height:568
                },
                notNull:true*/
                type:"imageRef",
                label:"背景图片",
                dataProvider:"bob/article/userImage/material/c",
                targetMethod:"getBgImages",
                //targetMethod:"getListUrl",
                tagDataProvider:"bob/article/travelTag/c",
                tagTargetMethod:["getMaterialList3","getMaterialList4","getMaterialList5"],
                showTags:true,
                showType:"waterfall",
                pageSize:20,
                addMaterial:true
            },
            qrCodePath:{
                type:"image",
                label:"二维码",
                sizeType:"upload",
                size:{
                    width:130,
                    height:130
                },
                notNull:true
            },
            save:{
                type:"button",
                label:"保存",
                action:"save"
            },
            preview:{
                type:"button",
                label:"预览",
                action:"preview"
            },
            recharge:{
                type:"button",
                label:"充值",
                action:"recharge"
            },
            useBgImg:{
                type:"checkbox",
                label:"使用指定背景图片"
            }
        }
    });
});
