﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "bob/BoBase",
    "bob/user/consumer",
    "./_Mixin",
    "cq/util/config/config"
], function (declare, lang, BoBase, consumer, Mixin, config) {
	var O = declare("", [BoBase.B, Mixin], {
        fields:{
            title:{
                type:"text",
                label:"标题",
                canEdit:false,
                notNull: true
            },
            logoPath:{
                type:"image",
                label:"LOGO",
                sizeType:"upload",
                size:{
                    width:256,
                    height:256
                },
                canEdit:false,
                notNull:true
            },
            prodImgPath:{
                type:"image",
                label:"商品图片",
                sizeType:"upload",
                size:{
                    width:170,
                    height:110
                },
                canEdit:false,
                notNull:true
            },
            prodDesc:{
                type:"textarea",
                label:"商品文案",
                canEdit:false,
                notNull:true
            },
            validDate:{
                type:"text",
                label:"有效期",
                canEdit:false
            },
            bgImgPath:{
                type:"image",
                label:"背景图片",
                sizeType:"upload",
                size:{
                    width:488,
                    height:568
                },
                canEdit:false,
                notNull:true
            },
            qrCodePath:{
                type:"image",
                label:"二维码",
                sizeType:"upload",
                size:{
                    width:130,
                    height:130
                },
                canEdit:false,
                notNull:true
            }
        },
        getEdtLayout : function(){
            return [{
                type:"form",
                fields:this.getFormItems([
                    "logoPath","title","prodImgPath","prodDesc","bgImgPath","qrCodePath","validDate"
                ],true)
            }]
        },
        onDataReady: function(widget){
        },
        loadByUserId: function(){
            var did = window.location.href.split("-")[1];
            return this.exec("loadByUserId", {userId:did,shopId:this.getShopId()}).then(lang.hitch(this, function(result){
                var data = result&&result.data&&result.data.item||{};
                if(data.validDate){
                    var validDate = new Date(data.validDate);
                    data.validDate = validDate.getFullYear() + "-" + (validDate.getMonth() + 1) + "-" + validDate.getDate();
                }
                return data;
            }));
        },
        refresh: function(){
            
        },
        getListUrl:function(){
            return config.dataOrigin + "/bizv2/" + this.modalName + "/load"
        },
        getListParam:function(cqRefInfo){
            var param = {
                shopId: this.getShopId()
            };
            return param;
        },
        getItemProp:function(item){
            item.logo = item.userId.logo;
            item.nickName = item.userId.nickName;
            if(item.validDate){
                var validDate = new Date(item.validDate);
                item.validDate = "会员到期时间:" + validDate.getFullYear() + "-" + (validDate.getMonth() + 1) + "-" + validDate.getDate();
            }else{
                item.validDate = "会员未充值";
            }
            return item;
        },
        onListClick:function(data){
            window.moveToView("userImage", data.userId._id);
        }
    });
	var o = new O();
	o.Bo = O;
	return o;
});