﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "bob/BoBase",
    "bob/user/consumer",
    "dojo/DeferredList",
    "./_Mixin",
    "cq/util/image/blob",
    "cq/util/config/config",
    "dojo/topic",
    "cq/util/image/canvas",
    "bob/article/travelTag/c",
    "cq/util/image/qrCode"
], function (declare, lang, BoBase, consumer, DeferredList, Mixin, blob, config, topic, canvas, travelTag, qrCode) {
	var O = declare("", [BoBase.C, Mixin], {
        cache:{
            dailyinfo:{},
            material:{},
            logoMaterial:{},
            corpus:{},
            userImage:null,
            layouts:[],
            materials:[]
        },
        checkedFields: function(data){
            var msg = "";
            if (!data.title) {
                msg = "标题未填写!";
                return msg;
            }
            if(!data.logoPath){
                msg = "logo未上传";
                return msg;
            }
            if(!data.prodImgPath){
                msg = "商品图片未上传";
                return msg;
            }
            if(!data.prodDesc){
                msg = "商品文案未填写";
                return msg;
            }
            /*if(!data.bgImgPath){
                msg = "背景图片未上传";
                return msg;
            }
            if(!data.qrCodePath){
                msg = "二维码未上传";
                return msg;
            }*/
        },
        getTags:function(){
            var _this = this;
            if(_this.cache.dailyinfo.gongli){
                return Promise.resolve().then(function(){
                    return _this.cache.dailyinfo.tags||[];
                });
            }else{
                return _this.exec("getDailyInfo", {shopId:_this.getShopId()}, true).then(function(data){
                    _this.cache.dailyinfo = data&&data.data&&data.data.item||{};
                    return _this.cache.dailyinfo.tags||[];
                });
            }
        },
        getLayoutNum:function(){
            var _this = this;
            if(_this.cache.layouts.length == 0){
                return this.getLayout().then(function(){
                    return _this.cache.layouts.length;
                });
            }else{
                return Promise.resolve().then(function(){
                    return _this.cache.layouts.length;
                });
            }
        },
        getLayout:function(params){
            var _this = this;
            return Promise.resolve().then(function(){
                var param = {
                    shopId:_this.getShopId(),
                    userId:consumer.getCurrentUserId()
                };
                // 先从cache中取，如果取不到再加载
                // 加载模板
                if(_this.cache.layouts.length == 0){
                    // 第一次加载
                    /*return _this.exec("loadImageLayouts", param, true).then(function(data){
                        if(data.data.ok&&data&&data.data&&data.data.items&&data.data.items.length){
                            _this.cache.layouts = data&&data.data&&data.data.items;
                            return _this.cache.layouts[0];
                        }
                    });*/
                    // 加载模板、material、userImage
                    return _this.exec("home", param, true).then(function(data){
                        if(data&&data.data&&data.data.item){
                            _this.cache.layouts = data.data.item.layouts;
                            _this.cache.userImage = data.data.item.userImage;
                            _this.cache.dailyinfo = data.data.item.dailyinfo;
                            var materials = data.data.item.materials;
                            for(var index = 0;index < materials.length;index++){
                                _this.cache.materials.push({
                                    materialId:materials[index].bgImage.id,
                                    corpusId:materials[index].corpus.id,
                                    logoMaterialId:materials[index].logoMaterialImage.id
                                });
                                _this.cache.material[materials[index].bgImage.id] = materials[index].bgImage;
                                _this.cache.corpus[materials[index].corpus.id] = materials[index].corpus;
                                _this.cache.logoMaterial[materials[index].logoMaterialImage.id] = materials[index].logoMaterialImage;
                                _this.cache.dailyinfo = materials[index].dailyinfo;
                            }
                        }
                        return _this.cache.layouts[0];
                    });
                }else{
                    var x = 0;
                    if(params.x < 0){
                        x = params.x%_this.cache.layouts.length;
                        x = x<0?(x + _this.cache.layouts.length):x;
                    }else{
                        x = params.x%_this.cache.layouts.length;
                    }
                    return _this.cache.layouts[x];
                }
            });
        },
        loadMoreMaterial:function(fromIndex){
            var _this = this;
            var param = {
                shopId:_this.getShopId(),
                fromIndex:fromIndex||0,
                tagId:_this.cache.tagId||""
            };
            return _this.exec("loadMaterial", param, true).then(function(data){
                if(data.data.ok&&data&&data.data&&data.data.items){
                    var items = data.data.items;
                    for(var index = 0;index < items.length;index++){
                        _this.cache.materials.push({
                            materialId:items[index].bgImage.id,
                            corpusId:items[index].corpus.id,
                            logoMaterialId:items[index].logoMaterialImage.id
                        });
                        _this.cache.material[items[index].bgImage.id] = items[index].bgImage;
                        _this.cache.corpus[items[index].corpus.id] = items[index].corpus;
                        _this.cache.logoMaterial[items[index].logoMaterialImage.id] = items[index].logoMaterialImage;
                        _this.cache.dailyinfo = items[index].dailyinfo;
                    }
                    return;
                }
            });
        },
        getMaterial:function(params,tagId){
            var _this = this;
            if(tagId){
                this.cache.tagId = tagId;
            }
            return Promise.resolve().then(function(){
                var param = {
                    shopId:_this.getShopId()
                };
                // 加载背景、语料、右上角图片,日期
                if(_this.cache.materials[params.y]){
                    // 如果剩余个数不足二，则再次加载10条数据
                    if(_this.cache.materials.length - params.y <= 2){
                        _this.loadMoreMaterial(_this.cache.materials.length);
                    }
                    return {
                        bgImage:_this.cache.material[_this.cache.materials[params.y].materialId],
                        corpus:_this.cache.corpus[_this.cache.materials[params.y].corpusId],
                        logoMaterialImage:_this.cache.corpus[_this.cache.materials[params.y].logoMaterialId],
                        dailyinfo:_this.cache.dailyinfo
                    };
                }else{
                    return _this.loadMoreMaterial().then(function(){
                        return {
                            bgImage:_this.cache.material[_this.cache.materials[params.y].materialId],
                            corpus:_this.cache.corpus[_this.cache.materials[params.y].corpusId],
                            logoMaterialImage:_this.cache.corpus[_this.cache.materials[params.y].logoMaterialId],
                            dailyinfo:_this.cache.dailyinfo
                        };
                    });
                }
            });
        },
        getImageUrl:function(params,tagId,refresh){
            //return {
            //    src:this.cache.images[Math.floor(Math.random()*this.cache.images.length)]
            //};
            
            if(refresh){
                this.cache.materials = [];
            }
            var _this = this;
            var data,data1 = {};
            var date = new Date();
            return _this.getLayout(params).then(function(layout){
                data1.layout = layout;
                return _this.getMaterial(params,tagId);
            }).then(function(material){
                data1.bgImage = material.bgImage;
                data1.corpus = material.corpus;
                data1.logoMaterialImage = material.logoMaterialImage;
                //data1.dailyinfo = material.dailyinfo;
                data1.dailyinfo = _this.cache.dailyinfo;
            }).then(function(){
                //if(_this.cache.userImage){
                    data1.userImage = _this.cache.userImage;
                //}else{
                //    return _this.loadByUserId(true).then(function(userImage){
                //        _this.cache.userImage = userImage;
                //        data1.userImage = userImage;
                //    });
                //}
            }).then(function(){
                return _this.generateParams(data1);
            }).then(function(imageParams){
                return _this.createImageUrl(imageParams);
            }).then(function(base64){
                return {
                    src:base64
                };
            });
        },
        generateParams:function(data){
            var options = {
                width:data.layout.width,
                height:data.layout.height,
                bgColor:data.layout.bgColor
            };
            var elements = data.layout.elements;
            var elements1 = [];
            var posJi = 0;
            var posJiContent = 0;
            var posAuthor = 0;
            var posCorpus = 0;
            var date = new Date();
            for(var index = 0;index < elements.length;index++){
                if(elements[index].type == "bgImage"){
                    elements1[elements1.length]= {
                        type:"image",
                        isBgImg:true
                    };
                    if(data.userImage.useBgImg&&data.userImage.bgImgPath){
                        elements1[elements1.length-1].src = data.userImage.bgImgPath;
                    }else if(data.bgImage.bgSrc){
                        elements1[elements1.length-1].src = data.bgImage.bgSrc;
                    }
                }else if(elements[index].type == "logoImage"){
                    elements1[elements1.length]= {
                        type:"image",
                        src:data.userImage.logoPath||(config.dataOrigin + "/static/images/m-logo/blanklogo.png")
                    };
                }else if(elements[index].type == "prodImage"){
                    elements1[elements1.length]= {
                        type:"image",
                        src:data.userImage.prodImgPath||(config.dataOrigin+"/static/images/m-logo/blankprod.jpg")
                    };
                }else if(elements[index].type == "qrcodeImage"){
                    elements1[elements1.length]= {
                        type:"image",   
                        src:(data.userImage.validDate&&(new Date(data.userImage.validDate) > new Date())&&data.userImage.qrCodePath)?data.userImage.qrCodePath:(config.dataOrigin + "/static/images/qrcodeImages/userImageQrcode.png")
                        //src:(data.userImage.validDate&&(new Date(data.userImage.validDate) > new Date())&&data.userImage.qrCodePath)?data.userImage.qrCodePath:("http://192.168.58.100/static/images/qrcodeImages/userImageQrcode.png")
                    };
                }else if(elements[index].type == "title"){
                    elements1[elements1.length]= {
                        type:"text",
                        content:data.userImage.title||"标题",
                        x:elements[index].left,
                        y:elements[index].top
                    };
                }else if(elements[index].type == "prodDesc"){
                    elements1[elements1.length]= {
                        type:"text",
                        content:data.userImage.prodDesc||"产品介绍",
                        x:elements[index].left,
                        y:elements[index].top
                    };
                }else if(elements[index].type == "day"){
                    elements1[elements1.length]= {
                        type:"text",
                        content:"" + date.getDate(),
                        x:(date.getDate() >= 10)?(elements[index].left - 30):elements[index].left,
                        y:elements[index].top
                    };
                }else if(elements[index].type == "nongli"){
                    elements1[elements1.length]= {
                        type:"text",
                        content:data.dailyinfo.nongli.split("").reverse().join(""),
                        x:elements[index].left,
                        y:elements[index].top
                    };
                }else if(elements[index].type == "yi"){
                    elements1[elements1.length]= {
                        type:"text",
                        content:"宜",
                        x:elements[index].left,
                        y:elements[index].top
                    };
                }else if(elements[index].type == "yicontent"){
                    elements1[elements1.length]= {
                        type:"text",
                        content:data.dailyinfo.yi,
                        x:elements[index].left,
                        y:elements[index].top
                    };
                    posJi = elements1[elements1.length-1].x - 10 - Math.ceil(elements1[elements1.length-1].content.length/9)*15;
                }else if(elements[index].type == "ji"){
                    elements1[elements1.length]= {
                        type:"text",
                        content:"忌",
                        x:posJi,
                        y:elements[index].top
                    };
                    posJiContent = posJi - 25;
                }else if(elements[index].type == "jicontent"){
                    elements1[elements1.length]= {
                        type:"text",
                        content:data.dailyinfo.ji,
                        x:posJiContent,
                        y:elements[index].top
                    };
                }else if(elements[index].type == "corpussaying"){
                    elements1[elements1.length]= {
                        type:"text",
                        content:data.corpus.text,
                        x:elements[index].left,
                        y:elements[index].top
                    };
                    posAuthor = elements1[elements1.length-1].y + Math.ceil((data.corpus.text.length + 2)/22)*(elements[index].lineHeight||20);
                }else if(elements[index].type == "author"){
                    elements1[elements1.length]= {
                        type:"text",
                        content:elements[index].top?data.corpus.author:(data.corpus.author.split("").reverse().join("")),
                        x:elements[index].left,
                        y:elements[index].top?elements[index].top:posAuthor
                    };
                }else if(elements[index].type == "line" || elements[index].type == "border"){
                    elements1[elements1.length] = elements[index];
                    continue;
                }else if(elements[index].type == "reverseCorpus"){// 语料，从右至左，左边离边框x
                    /*elements1[elements1.length] = {
                        type:"text",
                        content:data.corpus.text,
                        x:elements[index].left,
                        y:elements[index].top,
                        reverse:true
                    };*/
                    
                    // 在canvas中做拆分
                    
                    // 拆分诗词成单句
                    var corpus = data.corpus.text;
                    var arr1 = corpus.split(/[:：；;.。！!?？]/g);
                    var arr2 = corpus.match(/[:：；;.。！!?？]/g);
                    var lineHeight = elements[index].lineHeight||((arr1.length*20>(data.layout.width - elements[index].left*2))?Math.floor((data.layout.width - elements[index].left*2)/arr1.length):20);
                    if(arr1.length == 1){
                        elements1[elements1.length] = {
                            type:"text",
                            content:arr1[0],
                            x:elements[index].left,
                            y:elements[index].top,
                            direction:"V",
                            orientation:"l-r",
                            fontFamily:elements[index].fontFamily,
                            fontWeight:elements[index].fontWeight,
                            fontSize:elements[index].fontSize,
                            fontColor:elements[index].fontColor,
                            fontStyle:elements[index].fontStyle,
                            fontVariant:elements[index].fontVariant,
                            maxWidth:elements[index].maxWidth,
                            maxHeight:elements[index].maxHeight,
                            lineMaxHeight:elements[index].lineMaxHeight,
                            lineMaxWidth:elements[index].lineMaxWidth,
                            lineHeight:lineHeight,
                            indentation:elements[index].indentation,
                            letterspacing:elements[index].letterspacing,
                            firstIndent:elements[index].firstIndent
                        }
                    }else{
                        for(var i = arr1.length - 2;i >= 0;i--){
                            elements1[elements1.length] = {
                                type:"text",
                                content:arr1[i] + arr2[i],
                                x:elements[index].left + lineHeight*(arr1.length - 2 - i),
                                y:elements[index].top,
                                direction:"V",
                                orientation:"l-r",
                                fontFamily:elements[index].fontFamily,
                                fontWeight:elements[index].fontWeight,
                                fontSize:elements[index].fontSize,
                                fontColor:elements[index].fontColor,
                                fontStyle:elements[index].fontStyle,
                                fontVariant:elements[index].fontVariant,
                                maxWidth:elements[index].maxWidth,
                                maxHeight:elements[index].maxHeight,
                                lineMaxHeight:elements[index].lineMaxHeight,
                                lineMaxWidth:elements[index].lineMaxWidth,
                                lineHeight:lineHeight,
                                indentation:elements[index].indentation,
                                letterspacing:elements[index].letterspacing,
                                firstIndent:elements[index].firstIndent
                            }
                        }
                    }
                    continue;
                }else{
                    continue;
                }
                if(elements1[elements1.length-1].type == "image"){
                    elements1[elements1.length-1].width = elements[index].width;
                    elements1[elements1.length-1].height = elements[index].height;
                    elements1[elements1.length-1].left = elements[index].left;
                    elements1[elements1.length-1].top = elements[index].top;
                    elements1[elements1.length-1].radius = elements[index].radius;
                    elements1[elements1.length-1].opacity = elements[index].opacity;
                }else if(elements1[elements1.length-1].type == "text"){
                    elements1[elements1.length-1].fontFamily = elements[index].fontFamily;
                    elements1[elements1.length-1].fontWeight = elements[index].fontWeight;
                    elements1[elements1.length-1].fontSize = elements[index].fontSize;
                    elements1[elements1.length-1].fontColor = elements[index].fontColor;
                    elements1[elements1.length-1].fontStyle = elements[index].fontStyle;
                    elements1[elements1.length-1].fontVariant = elements[index].fontVariant;
                    elements1[elements1.length-1].maxWidth = elements[index].maxWidth;
                    elements1[elements1.length-1].maxHeight = elements[index].maxHeight;
                    elements1[elements1.length-1].lineMaxWidth = elements[index].lineMaxWidth;
                    elements1[elements1.length-1].lineMaxHeight = elements[index].lineMaxHeight;
                    elements1[elements1.length-1].lineHeight = elements[index].lineHeight;
                    elements1[elements1.length-1].direction = elements[index].direction;
                    elements1[elements1.length-1].orientation = elements[index].orientation;
                    elements1[elements1.length-1].indentation = elements[index].indentation;
                    elements1[elements1.length-1].letterspacing = elements[index].letterspacing;
                    elements1[elements1.length-1].firstIndent = elements[index].firstIndent;
                }
            }
            
            return {
                options:options,
                elements:elements1
            };
        },
        createImageUrl:function(imageParams){
            return canvas.merge(imageParams.options, imageParams.elements);
        },
        getEdtLayout : function(){
            var _this = this;
            topic.subscribe("userImage/material/addMaterial", function(dt){
                _this.addMaterialData = dt;
            });
            return [{
                type:"form",
                fields:this.getFormItems([
                    "logoPath","title","prodImgPath","prodDesc","qrCodeUrl","qrCodePath","validDate","bgImgPath","useBgImg",/*"save",*/"preview","recharge"
                ],true)
            }]
        },
        onDataReady: function(widget){
            var data = widget.getData();
            // 先隐藏所有的
            var hideFields = ["preview","qrCodePath","bgImgPath"/*,"qrCodeUrl"*/];
            widget.hideByFields(hideFields);
            widget.disableByFields(["validDate"]);
            if(this.hasUserImageData){
                widget.showByFields(["preview"]);
            }
            if(data.validDate&&(new Date(data.validDate) > new Date())){
                widget.showByFields(["qrCodePath","qrCodeUrl"]);
            }
            if(data.useBgImg){
                widget.showByFields(["bgImgPath"]);
            }
        },
        loadByUserId: function(preventBusy){
            return this.exec("loadByUserId", {userId:consumer.getCurrentUserId()}, preventBusy).then(lang.hitch(this, function(result){
                var data = result&&result.data&&result.data.item||{};
                if(data.validDate){
                    var validDate = new Date(data.validDate);
                    data.validDate = validDate.getFullYear() + "-" + (validDate.getMonth() + 1) + "-" + validDate.getDate();
                }
                if(result&&result.data&&result.data.item){
                    this.hasUserImageData = true;
                }else{
                    this.hasUserImageData = false;
                }
                if(this.addMaterialData){
                    data.bgImgPath = this.addMaterialData.bgSrc;
                    this.addMaterialData = null;
                }
                return data;
            }));
        },
        refresh: function(){
            
        },
        recharge:function(){
            window.moveToView("daysList");
        },
        preview:function(data, widget, event){
            var _this = this;
            this.exec("save", data).then(function(result){
                if(result&&result.data&&result.data.ok == 1){
                    _this.exec("preview", {
                        userId:consumer.getCurrentUserId()
                    }).then(function(result) {
                        if(result&&result.data&&result.data.ok == 1){
                            require(["cq/widgets/bigImg"],lang.hitch(_this,function(bigImg){
                                bigImg.show(result.data.item.uri);
                            }));
                        }else{
                            alert(result&&result.data&&result.data.msg||"生成图片出错");
                        }
                    });
                }
            });
        },
        save:function(data, widget, event){
            var _this = this;
            if(this.checkedFields(data)){
                alert(this.checkedFields(data));
                return;
            }
            data.userId = consumer.getCurrentUserId();
            delete data.validDate;
            this.exec("save", data).then(function(result){
                if(result&&result.data&&result.data.ok == 1){
                    _this.hasUserImageData = true;
                    alert("保存成功");
                    var validDate = result&&result.data&&result.data.item&&result.data.item.validDate;
                    if(!validDate||(new Date(validDate) < new Date())){
                        widget.showByFields(["preview"]);
                    }
                    _this.cache.userImage = result.data.item||{};
                    if(validDate){
                        validDate = new Date(validDate);
                        result.data.item.validDate = validDate.getFullYear() + "-" + (validDate.getMonth() + 1) + "-" + validDate.getDate();
                    }
                    widget.setData(result.data.item||{});
                }else{
                    alert(result&&result.data&&result.data.msg||"保存失败");
                }
            });
        },
        fieldChangeMethod:function(widget, field, value){
            var _this = this;
            if(field == "useBgImg"){
                if(value == true){
                    widget.showByFields(["bgImgPath"]);
                }else{
                    widget.hideByFields(["bgImgPath"]);
                }
            }
            // 如果是二维码网址触发，则生成二维码并保存
            if(field == "qrCodeUrl" && value){
                var base64 = qrCode.generatePNG(value);
                var file = blob.dataUrltoBlob(base64);
                blob.uploadReady(file, {width:165,height:165}, 1, "upload").then(function(data){
                    if(data&&data.items&&data.items.length){
                        widget.fieldToElements["qrCodePath"][0].setValue(data.items[0].uri);
                        var uiData = widget.getData();
                        uiData.qrCodePath = data.items[0].uri;
                        uiData.userId = consumer.getCurrentUserId();
                        delete uiData.validDate;
                        uiData.qrCodePath = data.items[0].uri;
                        _this.exec("save", uiData);
                    }
                });
            }else{
                if(_this.timer){
                    clearTimeout(_this.timer);
                    _this.timer = null;
                }
                _this.timer = setTimeout(function(){
                    var data = widget.getData();
                    data.userId = consumer.getCurrentUserId();
                    delete data.validDate;
                    _this.exec("save", data);
                }, 300);
            }
        }
    });
	var o = new O();
	o.Bo = O;
	return o;
});