﻿define([
    "dojo/_base/lang",
    "dojo/_base/declare",
    'bob/BoBase',
    "./_Mixin",
    "dojo/_base/xhr",
    "dojo/Deferred"
], function (lang,declare,BoBase,_Mixin,xhr,Deferred) {
    var O = declare("", [BoBase.B, _Mixin], {
        planePath:'path://M1705.06,1318.313v-89.254l-319.9-221.799l0.073-208.063c0.521-84.662-26.629-121.796-63.961-121.491c-37.332-0.305-64.482,36.829-63.961,121.491l0.073,208.063l-319.9,221.799v89.254l330.343-157.288l12.238,241.308l-134.449,92.931l0.531,42.034l175.125-42.917l175.125,42.917l0.531-42.034l-134.449-92.931l12.238-241.308L1705.06,1318.313z',
        fields: {
            onSaveButton: {
				type: "button",
				label: "保存",
				action: "save",
				buttonClass: "fullButton"
			},
            barChart:{
                type:"chart",
                chartType:"bar"
            },
            mId:{
                type:"ref",
                label:"商品",
                labelFields:"mName",
                dataProvider:"bob/echartsTest/b",
                targetMethod:"getMatUrl",
                keyField:"_id"
            },
            month:{
                type:'date',
                label:'月份'
            }
        },
        getMatUrl:function(){
            return "http://appwork.nepbaby.com/datacenter/showData?params={%22modelName%22:%22Mat%22}";
        },
        getTestSeries:function(){
            var def = new Deferred();
            return def.resolve([
            // 经销商散点图
            {
                id:"series1",
                type: 'effectScatter',
                coordinateSystem:'bmap',
                zlevel: 3,
                rippleEffect: {
                    brushType: 'stroke'
                },
                symbolSize: function (val) {
                    return (val[4] / 50)>25?25:((val[4]/50)<10?10:(val[4]/50));
                },
                label:{
                    normal:{
                        show:false,
                        color:'black',
                        position:'right',
                        formatter:function(params){
                            return params.data.clientName||params.data.terminalName;
                        }
                    }
                },
                itemStyle:{
                    color:function(params){
                        if(params.data.value[3]/params.data.value[4]>0.8){
                            return "green";
                        }else if(params.data.value[3]/params.data.value[4]>0.2){
                            return "blue";
                        }else{
                            return "red";
                        }
                    }
                }
            },
            // 厂家到经销商的飞行线
            // 或者经销商到终端飞行线
            {
                id:"series2",
                type:"lines",
                zlevel:1,
                coordinateSystem:"bmap",
                effect:{
                    show: true,
                    period: 5,
                    trailLength: 0.7,
                    color: '#ffa022',
                    symbolSize: 5
                },
                lineStyle: {
                    normal: {
                        color: "#a6c84c",
                        width: 0,
                        curveness: 0.2
                    }
                }
            },{
                type: 'lines',
                id:'series3',
                zlevel:2,
                coordinateSystem:'bmap',
                symbol: ['none', 'arrow'],
                symbolSize: 10,
                effect: {
                    show: true,
                    period: 5,
                    trailLength: 0,
                    symbol: this.planePath,
                    symbolSize:15
                },
                lineStyle: {
                    normal: {
                        color: "#ffa022",
                        width: 3,
                        opacity: 0.6,
                        curveness: 0.2
                    }
                }
            },
            // 经销商气球
            {
                type:"scatter",
                id:"series4",
                coordinateSystem:"bmap",
                symbol:"pin",
                symbolSize:25,
                zlevel:4
            },
            // 或者终端散点图
            {
                id:"series5",
                type: 'effectScatter',
                coordinateSystem:'bmap',
                zlevel: 3,
                rippleEffect: {
                    brushType: 'stroke'
                },
                symbolSize: function (val) {
                    return (val[4] / 20)>25?25:((val[4]/20)<10?10:(val[4]/20));
                },
                label:{
                    normal:{
                        show:false,
                        color:'black',
                        position:'right',
                        formatter:function(params){
                            return params.data.terminalName;
                        }
                    }
                }
            }
            ]);
        },
        clickTest:function(params, echart, widget){
            if(params.seriesId == "series4"){
                window.moveToView("test");
            }
        },
        getTestData:function(cqRefInfo, widget, dataOptions){
            var def = new Deferred();
            
            var data = {
                series1:[],
                series2:[],
                series3:[],
                series4:[]
            };
            
            if(cqRefInfo&&cqRefInfo["cqViewParam"]&&cqRefInfo["cqViewParam"].params){
                // 终端数据
                var param = cqRefInfo["cqViewParam"].params;
                var clientId = parseInt(param.split("_")[0]);
                var mId = parseInt(param.split("_")[1]);
                var year = parseInt(param.split("_")[4]);
                var month = parseInt(param.split("_")[5]);
                
                var obj = {
                    mId:mId,
                    clientId:clientId,
                    year:year,
                    month:month
                };
                
                xhr("GET", {
                    url:"http://appwork.nepbaby.com/datacenter/clientSaleMat?params=" + JSON.stringify(obj),
                    handleAs:'json',
                    load:function(zdData){
                        
                        data.series4.push({
                            value:[param.split("_")[2],param.split("_")[3]],
                            tooltip:{
                                formatter:""
                            }
                        });
                        
                        for(var index = 0;index < zdData.items.length;index++){
                            zdData.items[index].gps&&data.series1.push({
                                terminalName:zdData.items[index].terminalName,
                                itemStyle:{
                                    color:zdData.items[index].saleQty>0?"green":"red"
                                },
                                symbolSize:zdData.items[index].saleQty/10,
                                value:zdData.items[index].gps.split(",").concat(zdData.items[index].saleQty)
                            });
                            if(zdData.items[index].flowQty > 0){
                                data.series2.push({
                                    coords:[[param.split("_")[2],param.split("_")[3]], zdData.items[index].gps.split(",")]
                                });
                            }
                        }
                        data.series3 = data.series2;
                        def.resolve(data);
                    },
                    error:function(err){
                        def.resolve(data);
                    }
                });
            }else if(cqRefInfo&&cqRefInfo["1"]&&!cqRefInfo["cqViewParam"].params
            &&cqRefInfo["1"].month&&cqRefInfo["1"].mId&&cqRefInfo["1"].mId._id){
                // 经销商数据
                var date = new Date(cqRefInfo["1"].month);
                var year = date.getFullYear();
                var month = date.getMonth() + 1;
                var obj = {
                    year:year,
                    month:month,
                    mId:cqRefInfo["1"].mId._id
                };
                xhr("GET", {
                    url:"http://appwork.nepbaby.com/datacenter/clientRepertory?params=" + JSON.stringify(obj),
                    handleAs:"json",
                    load:function(crData){
                        
                        for(var index = 0;index < crData.items.length;index++){
                            data.series1.push({
                                mId:cqRefInfo["1"].mId._id,
                                clientId:crData.items[index].clientId,
                                clientName:crData.items[index].clientName,
                                year:year,
                                month:month,
                                value:[crData.items[index].gps.split(",")[0],crData.items[index].gps.split(",")[1],crData.items[index].inQty,crData.items[index].outQty,crData.items[index].endQty]
                            });
                            if(crData.items[index].inQty > 0){
                                data.series2.push({
                                    coords:[[113.5107,23.2196],crData.items[index].gps.split(",")]
                                });
                            }
                        }
                        data.series3 = data.series2;
                        
                        def.resolve(data);
                    },
                    error:function(err){
                        def.resolve(data);
                    }
                });
                
            }else{
                if(cqRefInfo&&cqRefInfo["1"]&&!cqRefInfo["1"].month){
                    alert("日期必须选择");
                }
                if(cqRefInfo&&cqRefInfo["1"]&&!cqRefInfo["1"].mId){
                    alert("商品必须选择");
                }
                return def.resolve({});
            }
            return def;
        },
        testFormatter:function(params){
            if(params.seriesId == "series1"){
                return params.data.clientName + "<br/>" + "进:" + params.data.value[2] + ",销:" 
                + params.data.value[3] + ",存:" + params.data.value[4] 
                + "<br/>" 
                + "<input type='button' value='终端' onclick='window.moveToView(\"test\", \""
                + params.data.clientId + "_" + params.data.mId + "_"
                + params.data.value[0] + "_" + params.data.value[1] + "_"
                + params.data.year + "_" + params.data.month + "\");'>";
            }else if(params.seriesId == "series5"){
                return params.data.terminalName;
            }else{
                return "";
            }
        },
        initTestLayout:function(){
            var data = {};
            var date = new Date();
            date.setMonth(date.getMonth() - 1);
            date.setDate(1);
            data.month = date.toISOString();
            return data;
        },
        getTestLayout:function(){
            return [{
                type:"form",
                fields:this.getFormItems([
                    "mId","month"
                ])
            }];
        },
        getEdtLayout: function(){
            return [{
                type:"form",
                fields:this.getFormItems([
                    "barChart"
                ])
            }];
        },
        getData3:function(){
            var def = new Deferred();
            return def.resolve([{
                name:"张三",
                total:1000000,
                sale:800000
            },{
                name:"李四",
                total:1500000,
                sale:1520000
            },{
                name:"王五",
                total:1700000,
                sale:1700001
            },{
                name:"赵六",
                total:2000000,
                sale:4000000
            },{
                name:"赵",
                total:1234567,
                sale:7654321
            },{
                name:"钱",
                total:2345678,
                sale:8765432,
            },{
                name:"孙",
                total:3456789,
                sale:9876543
            },{
                name:"李",
                total:4567890,
                sale:987654
            },{
                name:"周",
                total:5678901,
                sale:1098765
            },{
                name:"吴",
                total:6789012,
                sale:2109876
            },{
                name:"郑",
                total:7890123,
                sale:3210987
            },{
                name:"王",
                total:8901234,
                sale:4321098
            }]);
        },
        getData2:function(){
            var def = new Deferred();
            return def.resolve({
                // 经销商进销存数据
                lx:[{
                    fromShop:{lon:113.5107,lat:23.2196,name:"广东",provinceName:"广东"},
                    toShop:{lon:112.3352,lat:37.9413,name:"山西",provinceName:"山西"},
                    buy:12345,
                    sale:10000,
                    save:3000,
                    createAt:new Date("2018-9-13 10:00:05")
                },{
                    fromShop:{lon:113.5107,lat:23.2196,name:"广东",provinceName:"广东"},
                    toShop:{lon:117.29,lat:32.0581,name:"安徽",provinceName:"安徽"},
                    buy:200,
                    sale:220,
                    save:0,
                    createAt:new Date("2018-9-13 15:30:00")
                },{
                    fromShop:{lon:113.5107,lat:23.2196,name:"广东",provinceName:"广东"},
                    toShop:{lon:87.9236,lat:43.5883,name:"新疆",provinceName:"新疆"},
                    buy:500,
                    sale:450,
                    save:50,
                    createAt:new Date("2018-9-14 15:30:00")
                }],
                // 终端数据
                zd:[{
                    fromShop:{lon:87.9236,lat:43.5883,name:"新疆",provinceName:"新疆"},
                    toShop:{lon:86.5236,lat:42.0883,name:"A超市",provinceName:"新疆"},
                    buy:50,
                    sale:35
                },{
                    fromShop:{lon:87.9236,lat:43.5883,name:"新疆",provinceName:"新疆"},
                    toShop:{lon:85.0236,lat:43.0883,name:"B超市",provinceName:"新疆"},
                    buy:30,
                    sale:30
                },{
                    fromShop:{lon:87.9236,lat:43.5883,name:"新疆",provinceName:"新疆"},
                    toShop:{lon:88.5236,lat:43.0883,name:"C超市",provinceName:"新疆"},
                    buy:100,
                    sale:50
                },{
                    fromShop:{lon:87.9236,lat:43.5883,name:"新疆",provinceName:"新疆"},
                    toShop:{lon:89.5236,lat:42.0883,name:"D超市",provinceName:"新疆"},
                    buy:150,
                    sale:130
                },{
                    fromShop:{lon:87.9236,lat:43.5883,name:"新疆",provinceName:"新疆"},
                    toShop:{lon:85.5236,lat:44.0883,name:"E超市",provinceName:"新疆"},
                    buy:20,
                    sale:5
                },{
                    fromShop:{lon:117.29,lat:32.0581,name:"安徽",provinceName:"安徽"},
                    toShop:{lon:116.29,lat:31.0581,name:"A超市",provinceName:"安徽"},
                    buy:50,
                    sale:49
                },{
                    fromShop:{lon:117.29,lat:32.0581,name:"安徽",provinceName:"安徽"},
                    toShop:{lon:118.29,lat:33.0581,name:"B超市",provinceName:"安徽"},
                    buy:30,
                    sale:8
                },{
                    fromShop:{lon:117.29,lat:32.0581,name:"安徽",provinceName:"安徽"},
                    toShop:{lon:117.00,lat:32.5581,name:"C超市",provinceName:"安徽"},
                    buy:20,
                    sale:20
                },{
                    fromShop:{lon:117.29,lat:32.0581,name:"安徽",provinceName:"安徽"},
                    toShop:{lon:116.59,lat:32.0581,name:"D超市",provinceName:"安徽"},
                    buy:100,
                    sale:0
                },{
                    fromShop:{lon:117.29,lat:32.0581,name:"安徽",provinceName:"安徽"},
                    toShop:{lon:116.79,lat:31.5581,name:"E超市",provinceName:"安徽"},
                    buy:20,
                    sale:20
                }]
            });
        },
        getZDData:function(province){
            var data = {};
            var buyData = [{
                    fromName:'广东',
                    toName:'新疆',
                    value:500,
                    coords:[[113.5107,23.2196],[87.9236,43.5883]]
                },{
                    fromName:'广东',
                    toName:'安徽',
                    value:200,
                    coords:[[113.5107,23.2196],[117.29,32.0581]]
                },{
                    fromName:'广东',
                    toName:'山西',
                    value:12345,
                    coords:[[113.5107,23.2196],[112.3352,37.9413]]
                }];
            data.series1 = buyData;
            data.series2 = buyData;
            data.series7 = [{
                    fromName:"新疆",
                    toName:"A超市",
                    value:50,
                    coords:[[87.9236,43.5883],[86.5236,42.0883]]
                },{
                    fromName:"新疆",
                    toName:"B超市",
                    value:30,
                    coords:[[87.9236,43.5883],[85.0236,43.0883]]
                },{
                    fromName:"新疆",
                    toName:"C超市",
                    value:100,
                    coords:[[87.9236,43.5883],[88.5236,43.0883]]
                },{
                    fromName:"新疆",
                    toName:"D超市",
                    value:150,
                    coords:[[87.9236,43.5883],[89.5236,42.0883]]
                },{
                    fromName:"新疆",
                    toName:"E超市",
                    value:20,
                    coords:[[87.9236,43.5883],[85.5236,44.0883]]
                }];
                data.series8 = [{
                    name:"A超市",
                    value:[86.5236,42.0883,50,35]
                },{
                    name:"B超市",
                    value:[85.0236,43.0883,30,30]
                },{
                    name:"C超市",
                    value:[88.5236,43.0883,100,50]
                },{
                    name:"D超市",
                    value:[89.5236,42.0883,150,130]
                },{
                    name:"E超市",
                    value:[85.5236,44.0883,20,5]
                }];
            var def = new Deferred();
            if(province == '新疆'){
                return def.resolve(data);
            }else{
                return def.resolve();
            }
        },
        clickEchart:function(params,echart,widget){
            console.log("=====================");
            console.log("地图被点击了");
            console.log(params);
            var s1 = widget.mapType=="json"?"series1":"series2";
            var s2 = widget.mapType=="json"?"series2":"series3";
            var data = {};
            var buyData = [{
                    fromName:'广东',
                    toName:'新疆',
                    value:500,
                    coords:[[113.5107,23.2196],[87.9236,43.5883]]
                },{
                    fromName:'广东',
                    toName:'安徽',
                    value:200,
                    coords:[[113.5107,23.2196],[117.29,32.0581]]
                },{
                    fromName:'广东',
                    toName:'山西',
                    value:12345,
                    coords:[[113.5107,23.2196],[112.3352,37.9413]]
                }];
            data[s1] = buyData;
            data[s2] = buyData;
            if((widget.mapType == "json"&&params.seriesId == "series3")||
                (widget.mapType == "bmap" && params.seriesId == "series4")){
                if(params.data.name == "新疆"){
                    // 最好是将所有系列的数据都传入，否则可能造成某些系列不显示
                    // 这里只传入了点击的经销商到商家的数据以及飞行线路的数据
                    // 如果需要隐藏某个序列，将它的data数组设置为0长度数组
                    data.series7 = [{
                        fromName:"新疆",
                        toName:"A超市",
                        value:50,
                        coords:[[87.9236,43.5883],[86.5236,42.0883]]
                    },{
                        fromName:"新疆",
                        toName:"B超市",
                        value:30,
                        coords:[[87.9236,43.5883],[85.0236,43.0883]]
                    },{
                        fromName:"新疆",
                        toName:"C超市",
                        value:100,
                        coords:[[87.9236,43.5883],[88.5236,43.0883]]
                    },{
                        fromName:"新疆",
                        toName:"D超市",
                        value:150,
                        coords:[[87.9236,43.5883],[89.5236,42.0883]]
                    },{
                        fromName:"新疆",
                        toName:"E超市",
                        value:20,
                        coords:[[87.9236,43.5883],[85.5236,44.0883]]
                    }];
                    data.series8 = [{
                        name:"A超市",
                        value:[86.5236,42.0883,50,35]
                    },{
                        name:"B超市",
                        value:[85.0236,43.0883,30,30]
                    },{
                        name:"C超市",
                        value:[88.5236,43.0883,100,50]
                    },{
                        name:"D超市",
                        value:[89.5236,42.0883,150,130]
                    },{
                        name:"E超市",
                        value:[85.5236,44.0883,20,5]
                    }];
                }else if(params.data.name == "安徽" || params.data.name == "山西"){
                    data.series7 = [];
                    data.series8 = [];
                    console.log("no data");
                }
                widget.setSeriesData(data);
            }
            console.log("=====================");
        },
        getData4:function(params,widget,options){
            var def = new Deferred();
            var buyData = [{
                    fromName:'广东',
                    toName:'新疆',
                    value:500,
                    coords:[[113.5107,23.2196],[87.9236,43.5883]]
                },{
                    fromName:'广东',
                    toName:'安徽',
                    value:200,
                    coords:[[113.5107,23.2196],[117.29,32.0581]]
                },{
                    fromName:'广东',
                    toName:'山西',
                    value:12345,
                    coords:[[113.5107,23.2196],[112.3352,37.9413]]
                }];
            return def.resolve({
                // series1 series2是飞机路线,以及飞机尾焰
                series1:buyData,
                series2:buyData,
                // series3是经销商散点图
                series3:[{
                    name:"新疆",
                    value:[87.9236,43.5883,500]
                },{
                    name:'安徽',
                    value:[117.29,32.0581,200]
                },{
                    name:'山西',
                    value:[112.3352,37.9413,12345]
                }],
                // series4是生产商散点图
                series4:[{
                    name:'广东',
                    value:[113.5107,23.2196,13045]
                }],
                // series5是省区通过颜色区分销售情况
                series5:[{
                    name:'新疆',
                    value:450
                },{
                    name:'安徽',
                    value:220
                },{
                    name:'山西',
                    value:10000
                }],
                // series6是气球标记存的数据
                series6:[[
                    87.9236,43.5883,50
                ],[
                    117.29,32.0581,0
                ],[
                    112.3352,37.9413,3000
                ]],
                // series7是经销商到终端的线
                series7:[],
                // series8终端销售点
                series8:[],
                // series9热力图
                series9:[
                    [121.15,31.89,-5],
                    [109.781327,39.608266,5],
                    [120.38,37.35,20],
                    [122.207216,29.985295,18],
                    [123.97,47.33,-15],
                    [120.13,33.38,35],
                    [118.87,42.28,-5],
                    [104.06,30.67,50],
                    [104.56,29.77,40],
                    [104.778442,29.33903,30],
                    [104.73,31.48,20]
                ]
            });
        },
        getSeries1:function(){
            var def = new Deferred();
            return def.resolve([{
                type:'heatmap',
                id:'series1',
                coordinateSystem:'bmap',
                data:[]
            },{
                type:"lines",
                id:'series2',
                zlevel:1,
                // 使用百度地图时一定要加coordinateSystem
                coordinateSystem:'bmap',
                effect:{
                    show: true,
                    period: 5,
                    trailLength: 0.7,
                    color: '#ffa022',
                    symbolSize: 5
                },
                lineStyle: {
                    normal: {
                        color: "#a6c84c",
                        width: 0,
                        curveness: 0.2
                    }
                },
                data: []
            },{
                type: 'lines',
                id:'series3',
                zlevel:2,
                coordinateSystem:'bmap',
                symbol: ['none', 'arrow'],
                symbolSize: 10,
                effect: {
                    show: true,
                    period: 5,
                    trailLength: 0,
                    // 飞机图片，可以替换成其它图片
                    // 可以使用正常的jpg或者png图片，但是图片必须保证正面朝上
                    // image://http://...
                    // image:///static/sites/....
                    symbol: this.planePath,
                    symbolSize:15
                },
                lineStyle: {
                    normal: {
                        color: "#ffa022",
                        width: 3,
                        opacity: 0.6,
                        curveness: 0.2
                    }
                },
                data: []
            },{
                type: 'effectScatter',
                id:'series4',
                coordinateSystem:'bmap',
                zlevel: 3,
                rippleEffect: {
                    brushType: 'stroke'
                },
                label: {
                    normal: {
                        show: true,
                        position: 'right',
                        formatter: '{b}'
                    }
                },
                symbolSize: function (val) {
                    console.log(val.join(",,") + "---------");
                    return (val[2] / 8)>15?15:((val[2]/8)<5?5:(val[2]/8));
                },
                itemStyle: {
                    normal: {
                        color: "#46bee9"
                    }
                },
                data: []
            },{
                type:'effectScatter',
                id:'series5',
                coordinateSystem:'bmap',
                zlevel:2,
                rippleEffect:{
                    brushType:'stroke'
                },
                label:{
                    normal:{
                        show:true,
                        position:'right',
                        formatter:'{b}'
                    }
                },
                symbolSize: 15,
                itemStyle:{
                    normal:{
                        color:'red'
                    }
                },
                data:[]
            },{
                type:'scatter',
                id:'series6',
                coordinateSystem:'bmap',
                symbol:'pin',
                symbolSize:function(val){
                    return (val[2] / 8)>100?100:((val[2]/8)<50?50:(val[2]/8));
                },
                label:{
                    normal:{
                        show:true,
                        color:'#fff',
                        formatter:function(params){
                            return params.value[2];
                        }
                    }
                },
                data:[]
            },{
                type:"lines",
                id:'series7',
                coordinateSystem:'bmap',
                zlevel:2,
                lineStyle: {
                    normal: {
                        color: "#016308",
                        width: 1,
                        curveness: 0.2
                    }
                },
                data: []
            },{
                type:"effectScatter",
                id:'series8',
                coordinateSystem:'bmap',
                zlevel:2,
                rippleEffect:{
                    brushType:'stroke'
                },
                label:{
                    normal:{
                        show:true,
                        position:'right',
                        formatter:'{b}'
                    }
                },
                symbolSize: 10,
                itemStyle:{
                    normal:{
                        color:'#016308'
                    }
                },
                data:[]
            }]);
        },
        getData5:function(){
            var buyData = [{
                    fromName:'广东',
                    toName:'新疆',
                    value:500,
                    coords:[[113.5107,23.2196],[87.9236,43.5883]]
                },{
                    fromName:'广东',
                    toName:'安徽',
                    value:200,
                    coords:[[113.5107,23.2196],[117.29,32.0581]]
                },{
                    fromName:'广东',
                    toName:'山西',
                    value:12345,
                    coords:[[113.5107,23.2196],[112.3352,37.9413]]
                }];
            var def = new Deferred();
            return def.resolve({
                series1:[
                    [121.15,31.89,-5],
                    [109.781327,39.608266,5],
                    [120.38,37.35,20],
                    [122.207216,29.985295,18],
                    [123.97,47.33,-15],
                    [120.13,33.38,35],
                    [118.87,42.28,-5],
                    [104.06,30.67,50],
                    [104.56,29.77,40],
                    [104.778442,29.33903,30],
                    [104.73,31.48,20]
                ],
                series2:buyData,
                series3:buyData,
                series4:[{
                    name:"新疆",
                    value:[87.9236,43.5883,500]
                },{
                    name:'安徽',
                    value:[117.29,32.0581,200]
                },{
                    name:'山西',
                    value:[112.3352,37.9413,12345]
                }],
                // series4是生产商散点图
                series5:[{
                    name:'广东',
                    value:[113.5107,23.2196,13045]
                }],
                // series6是气球标记存的数据
                series6:[[
                    87.9236,43.5883,50
                ],[
                    117.29,32.0581,0
                ],[
                    112.3352,37.9413,3000
                ]],
                // series7是经销商到终端的线
                series7:[],
                // series8终端销售点
                series8:[]
            });
        },
        getSeries:function(){
            var def = new Deferred();
            return def.resolve([{
                type:"lines",
                id:'series1',
                // 也可以使用z来表示系列的前后关系
                // z的优先级低于zlevel
                // z不会创建新的canvas
                // 每个zlevel都会创建一个新的canvas
                // 相同zlevel系列会画在一个canvas上
                // 尽量少用zlevel，多了会有性能问题
                zlevel:1,
                effect:{
                    show: true,
                    period: 5,
                    trailLength: 0.7,
                    color: '#ffa022',
                    symbolSize: 5
                },
                lineStyle: {
                    normal: {
                        color: "#a6c84c",
                        width: 0,
                        curveness: 0.2
                    }
                },
                data: []
            },{
                type: 'lines',
                id:'series2',
                zlevel: 2,
                symbol: ['none', 'arrow'],
                symbolSize: 10,
                effect: {
                    show: true,
                    period: 5,
                    trailLength: 0,
                    // 飞机图片，可以替换成其它图片
                    symbol: this.planePath,
                    symbolSize:15
                },
                lineStyle: {
                    normal: {
                        color: "#ffa022",
                        width: 3,
                        opacity: 0.6,
                        curveness: 0.2
                    }
                },
                data: []
            },{
                type: 'effectScatter',
                id:'series3',
                //coordinateSystem:'bmap',
                coordinateSystem: 'geo',
                zlevel: 3,
                rippleEffect: {
                    brushType: 'stroke'
                },
                label: {
                    normal: {
                        show: true,
                        position: 'right',
                        formatter: '{b}'
                    }
                },
                symbolSize: function (val) {
                    console.log(val.join(",,") + "---------");
                    return (val[2] / 8)>15?15:((val[2]/8)<5?5:(val[2]/8));
                },
                itemStyle: {
                    normal: {
                        color: "#46bee9"
                    }
                },
                data: []
            },{
                type:'effectScatter',
                id:'series4',
                //coordinateSystem:'bmap',
                coordinateSystem: 'geo',
                zlevel:2,
                rippleEffect:{
                    brushType:'stroke'
                },
                label:{
                    normal:{
                        show:true,
                        position:'right',
                        formatter:'{b}'
                    }
                },
                symbolSize: 15,
                itemStyle:{
                    normal:{
                        color:'red'
                    }
                },
                data:[]
            },{
                type:"map",
                id:'series5',
                map:'china',
                roam:true,
                geoIndex:0,
                data:[]
            },{
                type:'scatter',
                id:'series6',
                //coordinateSystem:'bmap',
                coordinateSystem: 'geo',
                symbol:'pin',
                symbolSize:function(val){
                    return (val[2] / 8)>100?100:((val[2]/8)<50?50:(val[2]/8));
                },
                label:{
                    normal:{
                        show:true,
                        color:'#fff',
                        formatter:function(params){
                            return params.value[2];
                        }
                    }
                },
                data:[]
            },{
                type:"lines",
                id:'series7',
                zlevel:2,
                lineStyle: {
                    normal: {
                        color: "#016308",
                        width: 1,
                        curveness: 0.2
                    }
                },
                data: []
            },{
                type:"effectScatter",
                id:'series8',
                //coordinateSystem:'bmap',
                coordinateSystem: 'geo',
                zlevel:2,
                rippleEffect:{
                    brushType:'stroke'
                },
                label:{
                    normal:{
                        show:true,
                        position:'right',
                        formatter:'{b}'
                    }
                },
                symbolSize: 10,
                itemStyle:{
                    normal:{
                        color:'#016308'
                    }
                },
                data:[]
            },{
                type:'heatmap',
                id:'series9',
                //coordinateSystem:'bmap',
                coordinateSystem: 'geo',
                data:[]
            }]);
        },
        formatter:function(params){
            // 如果系列类型为散点
            if(params.seriesType == "effectScatter"){
                // 参数中的seriesId为定义series时的id值
                if(params.seriesId == "series3"){
                    return "经销商:" + params.data.name + "购入" + params.data.value[2];
                }else if(params.seriesId == "series8"){
                    return "商家:" + params.data.name + "购入" + params.data.value[2] + " 售出" + params.data.value[3];
                }else if(params.seriesId == "series4"){
                    return "生产商:总共售出" + params.data.value[2];
                }
            }else if(params.seriesType == "lines"){
                return params.data.fromName + "-" + params.data.toName + "<br/>" + params.data.value;
            }
        },
        getLineCategory:function(){
            var def = new Deferred();
            return def.resolve([{
                axis:'x',
                axisIndex:0,
                data:['重庆','四川','北京','伤害','广州']
            },{
                axis:'x',
                axisIndex:1,
                data:['重庆','四川','北京','伤害','广州']
            },{
                axis:'y',
                axisIndex:2,
                data:['重庆','四川','北京','伤害','广州']
            }]);
        },
        getLineData:function(){
            var def = new Deferred();
            return def.resolve({
                series1:[100,200,300,250,800],
                series2:[300,500,150,800,500],
                series3:[10,20,30,40,50],
                series4:[5,4,3,2,1],
                series5:[{
                    name:'重庆',
                    value:1234
                },{
                    name:'四川',
                    value:2345
                },{
                    name:'北街口',
                    value:4321
                }]
            });
        },
        getLineSeries:function(){
            var def = new Deferred();
            return def.resolve([{
                name:'series1',
                type:'line',
                id:'series1',
                xAxisIndex:0,
                yAxisIndex:0,
                data:[]
            },{
                name:'series2',
                type:'line',
                id:'series2',
                xAxisIndex:0,
                yAxisIndex:0,
                data:[]
            },{
                name:'series3',
                type:'line',
                id:'series3',
                xAxisIndex:1,
                yAxisIndex:1,
                data:[]
            },{
                name:'series4',
                type:'bar',
                id:'series4',
                xAxisIndex:2,
                yAxisIndex:2,
                data:[]
            }]);
        },
        lineFormatter:function(params){
            if(params[0].seriesId == "series1"){
                return 'series1:' + params[0].name + ":" + params[0].value 
                     + "<br>series2:" + params[1].name + ";" + params[1].value;
            }else if(params[0].seriesId == 'series3'){
                return '测试一';
            }else{
                return '测试二';
            }
        },
        getPieData:function(){
            var def = new Deferred();
            return def.resolve({
                series1:[{
                    name:'重庆',
                    value:12345
                },{
                    name:'四川',
                    value:23456
                },{
                    name:'北京',
                    value:34567
                }
            ]});
        },
        getPieSeries:function(){
            var def = new Deferred();
            return def.resolve([{
                type:'pie',
                id:'series1',
                data:[],
                center:['75%','75%'],
                radius: '20%'// number/string/[number/string,number/string]圆环使用数组，数组中第一项为内半径，第二项为外半径
            }]);
        },
        pieFormatter:function(params){
            return 'pie:' + params.name + "---" + params.value;
        },
        getPieLegend:function(params, widget, options){
            var def = new Deferred();
            return def.resolve([
                '重庆','四川','北京'
            ]);
        },
        getBarData:function(){
            var def = new Deferred();
            return def.resolve({
                series1:[{
                    name:'重庆',
                    value:12345
                },{
                    name:'四川',
                    value:54321
                },{
                    name:'云南',
                    value:13579
                }],
                series2:[{
                    name:'重庆',
                    value:10000
                },{
                    name:'四川',
                    value:20000
                },{
                    name:'云南',
                    value:30000
                }],
                series3:[{
                    name:'重庆',
                    value:30000
                },{
                    name:'四川',
                    value:40000
                },{
                    name:'云南',
                    value:50000
                }]
            });
        },
        barAxisData:function(){
            var def = new Deferred();
            return def.resolve([{
                axis:'x',
                axisIndex:0,
                data:['重庆','四川','云南']
            }]);
        },
        getBarSeries:function(){
            var def = new Deferred();
            return def.resolve([{
                name:'series1',
                id:'series1',
                type:'bar',
                data:[]
            },{
                name:'堆叠柱状图1',
                id:'series2',
                type:'bar',
                data:[],
                // stack相同的会堆叠在一起
                stack:'stack1'
            },{
                name:'堆叠柱状图2',
                id:'series3',
                type:'bar',
                data:[],
                stack:'stack1'
            }]);
        },
        barFormatter:function(params){
            return params.seriesName + "<br/>" + params.data.name + ":" + params.data.value;
        },
        getGraphSeries:function(){
            var def = new Deferred();
            return def.resolve([{
                id:'series1',
                type:'graph',
                layout:'force',// none(不使用布局,以节点的x y做坐标)/circular(环形布局)/force(力引导布局)
                left:'10%',
                width:'80%',
                top:'20%',
                height:'60%',
                focusNodeAdjacency:true,// 是否在鼠标移上去时，只显示鼠标指向的节点
                roam:true,
                data:[],
                label:{
                    normal:{
                        position:'top',
                        show:true,
                        textStyle:{
                            color:'red',
                            fontSize:12
                        }
                    }
                },
                force:{// 力引导布局相关配置
                    initLayout:'none',// 初始化布局，还可以使用circular
                    repulsion:50,//斥力因子,可以是数组，表示斥力的范围，值越大，斥力越大
                    gravity:0.1,//引力因子
                    edgeLength:[50,100],// 边的两个节点间的距离，可以使用数组，引力值越小则长度越长
                    layoutAnimation:true// 力引导布局会在多次迭代后稳定，所以当节点过多时，最好开启
                },
                links:[], // 节点之间的关系数据
                symbolSize:function(value, params){// value为data的数据项
                    // console.log(value);
                    return lang.isArray(value)?(value[0]/3000):(value/3000);
                }
            }]);
        },
        getGraphData:function(){
            var def = new Deferred();
            return def.resolve({
                series1:[{
                    name:'重庆',
                    value:[12345,23456]// 可以是数字或者数组
                },{
                    name:'四川',
                    value:54321
                },{
                    name:'云南',
                    value:30000
                }]
            });
        },
        graphFormatter:function(params){
            return "本年度GDP" + params.name + ":" + (lang.isArray(params.value)?params.value.reduce(function(a,b){return a+b;}):params.value) + "亿";
        },
        getRadarData:function(){
            var def = new Deferred();
            return def.resolve({
                series1:[[300,500,600,1300,2000]],
                series2:[[400,800,550,1480,1900]]
            });
        },
        getRadarSeries:function(){
            var def = new Deferred();
            return def.resolve([{
                id:'series1',
                name:'四川省',
                type:'radar',
                symbol:'circle',
                symbolSize:8,
                areaStyle:{
                    normal:{
                        color:'rgba(245, 166, 35, 0.4)'
                    }
                },
                itemStyle:{
                    color:'rgba(245, 166, 35, 1)',
                    borderColor:'rgba(245, 166, 35, 0.3)',
                    borderWidth:5,
                },
                lineStyle: {
                    "normal": {
                        "type": "dashed",
                        "color": "rgba(245, 166, 35, 1)",
                        "width": 2
                    }
                },
                data:[]
            },{
                id:'series2',
                name:'重庆市',
                type:'radar',
                symbol:'circle',
                symbolSize:8,
                areaStyle:{
                    normal:{
                        color:'rgba(19, 173, 255, 0.5)'
                    }
                },
                "itemStyle": {
                    "normal": {
                        color:'rgba(19, 173, 255, 1)',
                        "borderColor": "rgba(19, 173, 255, 0.4)",
                        "borderWidth": 5
                    }
                },
                "lineStyle": {
                    "normal": {
                        "color": "rgba(19, 173, 255, 1)",
                        "width": 2,
                        "type": "dashed"
                    }
                },
                data:[]
            }]);
        },
        radarFormatter:function(params){
            return "2018年" + params.seriesName + "预算明细:<br/>"
                + '教育' + params.value[0] + '亿<br/>'
                + '医疗' + params.value[1] + '亿<br/>'
                + '食品' + params.value[2] + '亿<br/>'
                + '娱乐' + params.value[3] + '亿<br/>'
                + '房地产' + params.value[4] + '亿<br/>';
        },
        getTreeData:function(){
            var def = new Deferred();
            return def.resolve({
                series1:[{
                    name:'2018年',
                    label:{// 节点特殊配置
                    },
                    itemStyle:{
                    },
                    children:[{
                        name:'一月',
                        value:12345,
                        children:[{
                            name:'一号',
                            value:123,
                            children:[{
                                name:'子时',
                                value:12
                            },{
                                name:'午时',
                                value:23
                            },{
                                name:'寅时',
                                value:88
                            },{
                                name:'丑时'
                            },{
                                name:'卯时'
                            }]
                        }]
                    },{
                        name:'二月',
                        children:[{
                            name:'初二'
                        },{
                            name:'初三'
                        }]
                    }]
                }]
            });
        },
        getTreeSeries:function(){
            var def = new Deferred();
            return def.resolve([{
                id:'series1',
                name:'series1',
                type:'tree',
                layout:'orthogonal',//orthogonal(正交布局-水平或者垂直)radial(径向布局-以根节点为圆心)
                orient:'LR',// 正交布局时起作用，LR,RL,TB,BT
                symbol:'emptyCircle',// 'circle', 'rect', 'roundRect', 'triangle', 'diamond', 'pin', 'arrow', 'none'还可以是图片,指定方式和之前的图片配置方式相同
                symbolSize:10,
                symbolRotate:0,//标记选择角度
                symbolKeepAspect:true,// 如果标记是以path://形式指定，是否保持长宽比
                symbolOffset:[0,0],// 偏移量
                roam:true,
                expandAndCollapse:true,// 点击节点，子节点的折叠展开
                initialTreeDepth:2,//默认展开的层数
                data:[],
                label:{
                    normal:{
                        position:'top',
                        rotate:0,
                        verticalAlign:'middle',
                        align:'right',
                        fontSize:10
                    }
                },
                leaves:{// 叶子节点特殊配置
                    
                }
            }]);
        },
        treeFormatter:function(params){
            // console.log(params);
            var value = this.getTotalValue(params);
            return params.data.name + ":" + value;
        },
        getTotalValue:function(params){
            if(lang.isArray(params)){
                var total = 0;
                for(var index = 0;index < params.length;index++){
                    total += this.getTotalValue(params[index]);
                }
                return total;
            }else if(params.data){
                if(params.data.value){
                    return params.data.value;
                }else if(params.data.value == 0){
                    return 0;
                }else if(params.data.children){
                    return this.getTotalValue(params.data.children);
                }else{
                    return 0;
                }
            }else{
                if(params.value){
                    return params.value;
                }else if(params.value == 0){
                    return 0;
                }else if(params.children){
                    return this.getTotalValue(params.children);
                }else{
                    return 0;
                }
            }
        },
        getTreeMapData:function(){
            var def = new Deferred();
            return def.resolve({
                series1:[{
                    name:'rect1',
                    value:12345,
                    children:[{
                        name:'rect11',
                        value:10000,
                        children:[{
                            name:'rect111',
                            value:5000
                        },{
                            name:'rect112',
                            value:4000
                        },{
                            name:'rect113',
                            value:1000
                        }]
                    },{
                        name:'rect12',
                        value:2000
                    },{
                        name:'rect13',
                        value:300
                    },{
                        name:'rect14',
                        value:40
                    },{
                        name:'rect15',
                        value:5
                    }]
                },{
                    name:'rect2',
                    value:23456,
                    children:[{
                        name:'rect21',
                        value:20000
                    },{
                        name:'rect22',
                        value:3000
                    },{
                        name:'rect23',
                        value:456
                    }]
                }]
            });
        },
        getTreeMapSeries:function(){
            var def = new Deferred();
            return def.resolve([{
                name:'series1',
                id:'series1',
                type:'treemap',
                label:{
                    show:true,
                    formatter:"{b}:{c}"
                },
                itemStyle:{
                    normal:{
                        borderColor:'#fff'
                    }
                },
                levels:[{},{},{}],// 每个层级的特殊配置，从第一层到最后一层，可以有多个，没有设置的按series中的统一设置
                data:[]
            }]);
        },
        treeMapFormatter:function(params){
            return params.data.name + "::" + params.data.value;
        },
        getSunburstData:function(){
            var def = new Deferred();
            return def.resolve({
                series1:[{
                    name:'四川',
                    itemStyle:{
                        color: '#da0d68'
                    },
                    children:[{
                        name:'成都',
                        itemStyle: {
                            color: '#975e6d'
                        },
                        value:2
                    },{
                        name:'绵阳',
                        value:2,
                        itemStyle:{
                            color:'#e0719c'
                        }
                    },{
                        name:'德阳',
                        itemStyle:{
                            color:'#f99e1c'
                        },
                        children:[{
                            name:'dy1',
                            value:1,
                            itemStyle:{
                                color:'#ef5a78'
                            }
                        },{
                            name:'dy2',
                            value:1,
                            itemStyle:{
                                color:'#f7f1bd'
                            }
                        }]
                    }]
                },{
                    name:'重庆',
                    itemStyle:{
                        color:'#da1d23'
                    },
                    children:[{
                        name:'九龙坡',
                        itemStyle:{
                            color:'#dd4c51'
                        },
                        children:[{
                            name:'石桥铺',
                            itemStyle:{
                                color:'#3e0317'
                            },
                            value:2
                        },{
                            name:'陈家坪',
                            itemStyle:{
                                color:'#e62969'
                            },
                            value:1
                        },{
                            name:'杨家坪',
                            itemStyle:{
                                color:'#6569b0'
                            },
                            value:1
                        }]
                    },{
                        name:'渝中区',
                        itemStyle:{
                            color:'#ef2d36'
                        },
                        children:[{
                            name:'yz1',
                            value:1
                        },{
                            name:'yz2',
                            value:1
                        },{
                            name:'yz3',
                            value:2
                        }]
                    }]
                },{
                    name:'云南',
                    children:[{
                        name:'yn1',
                        value:5
                    },{
                        name:'yn2',
                        children:[{
                            name:'yn21',
                            value:1
                        },{
                            name:'yn22',
                            value:2
                        }]
                    }]
                }]
            });
        },
        getSunburstSeries:function(){
            var def = new Deferred();
            return def.resolve([{
                name:'series1',
                id:'series1',
                type:'sunburst',
                highlightPolicy:'descendant',// 当鼠标移动到item上时的高亮策略descendant(item及其子元素高亮，其它元素呈灰色),ancestor(item及其父节点高亮),self,none(不会使其它节点呈灰色)
                radius:[0, '80%'],
                sort:null,// 排序方式，desc asc null(不排序)3种
                levels:[{},// 第一个对象留给数据下钻的空白配置
                {// 从第二个开始，对应数据的每一层
                    r0:'15%',
                    r:'30%',
                    itemStyle:{
                        borderWidth:2
                    },
                    label:{
                        rotate:'radial',//数字(角度)或者字符串(radial,tangential)
                        align:'center'
                    }
                },{
                    r0:'30%',
                    r:'55%',
                    itemStyle:{
                        borderWidth:2
                    },
                    label:{
                        rotate:'tangential'
                    }
                },{
                    r0:'55%',
                    r:'58%',
                    label:{
                        position:'outside',
                        padding:3,
                        silent:false,
                        rotate:'radial'
                    }
                }],// 指定每一级的特殊配置
                nodeClick:false// 默认旭日图启用数据下钻，如果不想启用，可以设置false
            }]);
        },
        sunburstFormatter:function(params){
            // console.log(params);
            return params.name + "==" + params.value;
        },
        getHeatmapData:function(){
            var def = new Deferred();
            return def.resolve({
                series1:[[0,0,1],[0,1,2],[0,2,3],[0,3,4],[0,4,5],
                        [0,5,6],[0,6,7],[1,0,10],[1,1,9],[1,2,8],
                        [1,3,7],[1,4,6],[1,5,5],[1,6,4]]
            });
        },
        getHeatmapSeries:function(){
            var def = new Deferred();
            return def.resolve([{
                name:'series1',
                id:'series1',
                type:'heatmap',
                label:{
                    normal:{
                        show:true
                    }
                }
            }]);
        },
        getHeatmapAxisData:function(){
            var def = new Deferred();
            return def.resolve([{
                axis:'x',
                axisIndex:0,
                data:['00','01','02','03','04','05','06','07',
                '08','09','10','11','12','13','14','15',
                '16','17','18','19','20','21','22','23']
            },{
                axis:'y',
                axisIndex:0,
                data:['星期日','星期六','星期五','星期四','星期三','星期二','星期一']
            }]);
        },
        heatmapFormatter:function(params){
            // console.log(params);
            var date = ['星期日','星期六','星期五','星期四','星期三','星期二','星期一'];
            var time = ['00','01','02','03','04','05','06','07',
                '08','09','10','11','12','13','14','15',
                '16','17','18','19','20','21','22','23'];
            return date[params.value[1]] + "  " + time[params.value[0]] + "  " + params.value[2];
        },
        getParallelData:function(){
            var def = new Deferred();
            return def.resolve({
                scs:[
                    [1,2,4,6,8,'优'],
                    [2,3,10,13,5,'优'],
                    [3,8,3,15,8,'优'],
                    [4,9,4,5,8,'良'],
                    [5,9,5,2,7,'良'],
                    [6,7,2,5,9,'轻度污染'],
                    [7,13,2,7,15,'轻度污染'],
                    [8,15,15,8,6,'中度污染'],
                    [9,5,8,3,8,'重度污染'],
                    [10,1,3,5,7,'严重污染'],
                    [11,7,3,5,1,'轻度污染'],
                    [12,10,15,3,8,'良'],
                ],
                cqs:[
                    [1,10,15,3,8,'优'],
                    [2,3,10,13,5,'优'],
                    [3,8,3,15,8,'优'],
                    [4,9,4,5,8,'良'],
                    [5,9,5,2,7,'良'],
                    [6,7,2,5,9,'轻度污染'],
                    [7,13,2,7,15,'轻度污染'],
                    [8,15,15,8,6,'中度污染'],
                    [9,5,8,3,8,'重度污染'],
                    [10,1,3,5,7,'严重污染'],
                    [11,7,3,5,1,'轻度污染'],
                    [12,10,15,3,8,'良'],
                ],
                yns:[
                    [1,8,4,1,6,'优'],
                    [2,3,10,13,5,'优'],
                    [3,8,3,15,8,'优'],
                    [4,9,4,5,8,'良'],
                    [5,9,5,2,7,'良'],
                    [6,7,2,5,9,'轻度污染'],
                    [7,13,2,7,15,'轻度污染'],
                    [8,15,15,8,6,'中度污染'],
                    [9,5,8,3,8,'重度污染'],
                    [10,1,3,5,7,'严重污染'],
                    [11,7,3,5,1,'轻度污染'],
                    [12,10,15,3,8,'良'],
                ]
            });
        },
        getParallelSeries:function(){
            var def = new Deferred();
            return def.resolve([{
                name:'四川省',
                id:'scs',
                type:'parallel'
            },{
                name:'重庆市',
                id:'cqs',
                type:'parallel'
            },{
                name:'云南省',
                id:'yns',
                type:'parallel'
            }]);
        },
        getParallelLegend:function(){
            var def = new Deferred();
            return def.resolve(['四川省','重庆市','云南省']);
        },
        getParallelAxisData:function(){
            var def = new Deferred();
            return def.resolve([{
                dim:5,
                data:['优', '良', '轻度污染', '中度污染', '重度污染', '严重污染']
            }]);
        },
        getFunnelData:function(){
            var def = new Deferred();
            return def.resolve({
                series1:[{
                    value:15,
                    name:'科园四路'
                },{
                    value:10,
                    name:'科员六路'
                },{
                    value:50,
                    name:'九龙坡'
                },{
                    value:100,
                    name:'重庆'
                }]
            });
        },
        getFunnelSeries:function(){
            var def = new Deferred();
            return def.resolve([{
                name:'漏斗图示例',
                id:'series1',
                type:'funnel',
                width:'80%',
                left:'10%',
                height:'30%',
                top:'35%',
                min:10,
                max:100,
                minSize:'2%',// 最小值对应的图形宽度,默认是0%,可以是数字
                maxSize:'80%',// 最大值对应的图形宽度,默认100%
                sort:'descending',//'ascending'，'descending'，'none'或者function// sort:function(a,b){return a-b;}
                gap:2,// 每一个梯形间的距离
                legendHoverLink:true,//鼠标移动到图例上时，是否联动高亮，默认true可以不设置
                funnelAlign:'center',// left,right,center,默认center
                label:{
                    normal:{
                        show:true,
                        position:'inside'
                    },
                    emphasis:{
                        textStyle:{
                            fontSize:16
                        }
                    }
                },
                labelLine:{// 视觉引导线，当label的位置为left或者right的时候，会显示
                    normal:{
                        length:15,
                        lineStyle:{
                            width:1,
                            type:'dashed'
                        }
                    }
                }
            }]);
        },
        funnelFormatter:function(params){
            // console.log(params);
            return params.name + "<br/>" + params.value;
        }
    });
    var o = new O();
    o.Bo = O;
    return o;
});