﻿//客户端消息列表以及平台消息界面的数据获取，参数设置，
//字段匹配，为配置是相应的客户端的dataProvider
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "./_Mixin",
    '../../BoBase',
    'cq/util/sys/query',
    "cq/util/sys/date"
], function (declare,lang,_Mixin,BoBase,query,date) {
    var MsgCBo = declare('', [BoBase.B, _Mixin], {
        fields: {
            save: {
                type: "button",
                label: "保存",
                action: "save",
                buttonClass: "fullButton"
            },
            onDelete: {
                type: "button",
                label: "删除",
                action: "onDelete",
                buttonClass: "fullButton"
            },
            sendTime: {
                type : 'dateTime',
                label : '选择推送时间',
                notNull : true
            },
            msgContent: {
                type: "textarea",
                label: "推送内容",
                notNull: true
            },
            url:{
                type : 'text',
                label : '链接地址',
                notNull : true,
                placeHolder: "填写链接地址"
            },
            title : {
                type:"text",
                label:"消息主题",
                placeHolder: "填写消息主题",
                notNull: true
            },
            partnerType:{
                type : 'options',
                label : '接收用户',
                options : {
                    1:'周期订单周一配送',
                    2:'周期订单周二配送',
                    3:'周期订单周三配送',
                    4:'周期订单周四配送',
                    5:'周期订单周五配送',
                    6:'周期订单周六配送',
                    7:'周期订单周天配送',
                    9:"指定用户",
                    10:"下单客户",
                    11:"周期订单即将过期用户"
                    //8:'所有人'
                },
                selected: '1',
                canEdit : 1,
                notNull: true
            },
            userId: {
                type: "ref",
                label: "接收用户",
                dataProvider: 'bob/user/customer',
                targetMethod: 'getUserListUrl',
                className: 'middle-width',
                searchField: 'search',
                labelFields: 'nickName,pName'
            },
            pushType:{
                type : 'options',
                label : '推送类型',
                options : {
                    1:'app',
                    2:'微信模板'
                },
                selected: 2,
                canEdit : 1,
                notNull: true
            }
        },
        fieldChangeMethod: function(widget, field, fieldVl){
            var data = widget.getData();
            if(field=="userId"){
                data.partnerType = 9;
                widget.setData(data);
            }
        },
        getEdtLayout : function(){
            return [{
                type : "form",
                fields : this.getFormItems(["sendTime","msgContent","url","title","userId","partnerType","pushType","save","onDelete"], true)
            }];
        },
        save : function(data){
            var msg = this.checkedFiled(data);
            if(msg){
                alert(msg);
                return;
            }
            window.busy();
            data.isInformAll = true;
            data.shopId = this.getShopId();
            this.exec("save", data).then(lang.hitch(this, function(result){
                window.free();
                if(result&&result.data&&result.data.ok==1){
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"保存失败");
                }
            }));
        },
        onDelete:function(data){
            if(!confirm("确定要删除？")){
                return;
            }
            window.busy();
            this.exec("deleteInform",{
                _id:data._id
            }).then(function(result){
                window.free();
                if(result&&result.data&&result.data.ok==1){
                    return history.back();
                }
                alert(result&&result.data&&result.data.message||"删除失败");
            });
        },
        checkedFiled : function(data){
            var msg = this.getDataValidMsg(data, ["sendTime","msgContent","url","title","partnerType","pushType"]);
            if(msg){
                return msg;
            }
            if(data.sendTime<date.nowISOString()){
                return "推送日期不能小于当前日期";
            }
        },
        loadById : function(params){
            if(!params.cqViewParam.params){
                return;
            }
            return this.exec('loadById', {
                _id:params.cqViewParam.params,
                shopId: this.getShopId()
            }).then(lang.hitch(this, function(result){
                var item = result&&result.data&&result.data.item||{};
                if(!item.partnerType){
                    item.partnerType = 8;
                }
                return item;
            }));
        },
        getListUrl:function(){
            return this.getBaseUrl() + '/load';
        },
        onListClick:function(data){
            window.moveToView("massNotificationEdt",data._id);
        },
        onDataReady:function(widget){
            var data = widget.getData();
            var canEdit = !data._id||data.sendTime>date.nowISOString();
            widget[canEdit?"enableByFields":"disableByFields"]();
            widget[canEdit?"showByFields":"hideByFields"](["save"]);
            widget[canEdit&&data._id?"showByFields":"hideByFields"](["onDelete"]);
        },
        getListParam:function(cqRefInfo){
            var params = {
                shopId: this.getShopId(),
                orderBy: '-createAt',
                isInformAll: true
            };
            var value = query.getQueryValue(cqRefInfo.search);
            if (value) {
                params.search = value;
            }
            return params;
        }
    });
    var msgCBo = new MsgCBo();
    msgCBo.Bo = MsgCBo;
    return msgCBo;
});