﻿//客户端消息列表以及平台消息界面的数据获取，参数设置，
//字段匹配，为配置是相应的客户端的dataProvider
define([
    "dojo/_base/declare",
    "./_Mixin",
    '../../BoBase',
    "dojo/_base/lang",
    "bob/user/consumer",
    "cq/util/sys/userAgent"
], function (declare,_Mixin,BoBase, lang,consumer, userAgent) {
    var O = declare('', [BoBase.C, _Mixin], {
        save: function(data){
            var alarmType = "", toSave = true;
            consumer.hasLogin().then(lang.hitch(this, function(s){
                // 若已登录
                if(s){
                    var currentUserInfo = consumer.getCurrentUserFromSession();
                    // 判断当前用户所在环境
                    // 在APP上
                    if(userAgent.isApp()){
                        // 直接发送消息
                        alarmType = "sms";
                    }
                    // 在微信上
                    else if(userAgent.isWeixin()){
                        // 检查是否已经关注微信公众号
                        // 已关注微信
                        if(currentUserInfo.subscribed){
                            alarmType = "sms";
                        }
                        // 未关注微信但绑定了手机号
                        else if(this.isCellPhone(currentUserInfo.userName)){
                            alarmType = "sms";
                        }else{
                            // 提示关注公众号或绑定手机号码 方便通知到他
                            // 弹出confirm
                            toSave = false;
                            if(confirm("您还未绑定手机,为了方便通知您,马上去绑定手机号?")){
                                window.moveToView("bindPhone");
                            }
                        }
                    }else{
                        // 在其他网页或设备上
                        // 检查是否绑定手机号
                        if(!this.isCellPhone(currentUserInfo.userName)){
                            toSave = false;
                            if(confirm("您还未绑定手机,为了方便通知您,马上去绑定手机号?")){
                                window.moveToView("bindPhone");
                            }
                        }else{
                            alarmType = "sms";
                        }
                    }
                }else{
                    if(confirm("您还未登录,马上去登录?")){
                        toSave = false;
                        window.moveToView("login");
                    }
                }
                if(toSave){
                    data.alarmType = alarmType;
                    this.exec("addInform", data).then(lang.hitch(this, function(result){
                        if(result&&result.data&&result.data.ok==1){
                            alert("添加提醒成功，我们会在活动开始前10分钟通知你，请注意关注微信、APP或短信通知");
                        }else{
                            alert(result&&result.data&&result.data.message||"添加提醒失败");
                        }
                    }));
                }
            }));
        }
    });
    var o = new O();
    o.Bo = O;
    return o;
});
