﻿//订单系统公共基类
// 1、提供订单系统的基本属性
// 2、提供公用的方法
define([
    "dojo/_base/declare",
    "dojo/_base/connect",
    "dojo/_base/lang",
    "cq/util/sys/date",
    "bob/user/consumer",
    "../socket"
], function (declare,connect,lang,date,consumer,socket) {
    return declare("",null,{
        modalName:"im/msg",
        //字段名
        fields: {
            msgContent: {
				type: 'text',
				label: '消息内容'
			},
            lastMod: {
                type: "date",
                label: "发送时间",
                formatter:function(action,data){
                    return date.formatISODateMinutes(data.lastMod);
                }
            },
            //列表提醒消息中聊天信息的头像
            logo:{
                type:'text',
                label:'头像',
                canEdit:false
            },
            //未读消息的数量
            msgCount:{
                type:'text',
                label:'未读消息',
                canEdit:false
            },
            //最后一条未读消息的具体内容
            lastMsg:{
                type:'text',
                label:'最新消息',
                canEdit:false
            },
            //最后一条未读消息的事件
            lastMsgTime:{
                type:'text',
                label:'时间',
                canEdit:false
            },
            //发送消息者的昵称
            nickName:{
                type:'text',
                label:'昵称',
                canEdit:false
            },
            //msgList里面每条数据显示的内容
            msgContent:{
                type:'text',
                label:'消息',
                canEdit:false
            },
            //包含点击跳转页面的信息
            moveTo:{
                type:'text',
                label:'跳转页面',
                canEdit:false
            },
            //消息的创建时间
            createAt:{
                type:'dateTime',
                label:'创建时间',
                canEdit:false
            }
        },
        
        //未读消息数量相关接口
        //只需要加载各种类型上次点击之后受到的消息的数量即可
        getMsgNum:function(cqRefInfo,widget,options){
            var msgTypes = options&&options.msgTypes||[];
            var typeInfo = {},len = msgTypes.length;
            while(len--){
                typeInfo[msgTypes[len]] = localStorage.getItem(this.getShopId()+"-msg"+msgTypes[len])||"";
            }
            return this.exec("getMsgNum",{
                typeInfo:typeInfo
            }).then(function(data1){
                return data1;
            });
        },
        //清空消息数量，再次读取时读取现在之后的消息
        clearMsgNum:function(type){
            localStorage.setItem(this.getShopId()+"-msg"+type,(new Date).toISOString());
        },
        
        //列表相关，分类消息列表相关接口
        getListUrlForType: function () {
			return this.getBaseUrl() + '/loadByType?topicType='+4;
		},
        //获取列表查询的参数
        getListParam: function(){
            return {
                shopId: this.getShopId()
            };
        },
        //列表点击事件
        onListClick:function(e){
            if(e&&e.moveTo){
                window.moveToView(e.moveTo,e.param||'');
            }
        },
        
        
        //客服相关消息
        //客服回话相关接口
        getSvcMsgUrl:function(){
            return this.getBaseUrl()+"/loadSpecifiedChatMsg?shopId="+this.getShopId();
        },
        //保存消息并广播, 必须传入shopId、receiverId、senderId
        save:function(params){
            return this.exec3("im/msg","onNewMessage", params);
        },
        getCurrentShopId:function(){
            return this.getShopId();
        },
        //发送消息
        //当前房间，当前登录用户的userId
        currentRoom:"",
        join:function(){
            if(this.currentRoom){
                socket.leave(this.currentRoom);
            }
            this.currentRoom = consumer.getCurrentUserId();
            socket.join(this.currentRoom);
        },
        //对象创建之后的初始化
        init:function(){
            if(this._inited){
                return;
            }
            this._inited = true;
            //加载指定的会话消息    张金鹏，2016/07/20
            this.join();
			//用connect对象的subscribe方法去判断是否登陆，登录则加载指定的会话消息    张金鹏，2016/07/20
            connect.subscribe("/cq/biz/user/user/hasLogin",lang.hitch(this,function(success){
                if(success){
                    this.join();
                }
            }));
            //侦听新消息    张金鹏，2016/07/20
            connect.connect(socket,"onMsg",this,function(msg){
                if(msg.src==="SVCMsg"){
                    msg = msg.msg;
                    this.onShowMsg(msg);
                    this.onPenddingMsg(msg);
                    this.onPenddingNum(msg);
                }
            });
        },
        //新消息，会话详情的处理
        onShowMsg:function(msg){
            
        },
        //新消息，会话列表的处理
        onPenddingMsg:function(msg){
            
        },
        //新消息，未读会话数量的处理
        onPenddingNum:function(msg){
            
        },
        // 获取自动回复接口
        getDefaultReply:function(targetShopId, svcUser){
            return this.exec("defaultReplyAs", {
                targetShopId:targetShopId,
                svcUser:svcUser
            });
        }
    });
});
