﻿// 未读详细的公共处理
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "bob/user/consumer",
    "cq/util/sys/date",
    "cq/util/config/config"
],function(declare,lang,Deferred,consumer,date, config){
    return declare("",null,{
        modalName:"im/msg_p",
        //列表对话
        //可处理的字段
        fields:{
            //列表提醒消息中聊天信息的头像
            logo:{
                type:'text',
                label:'头像',
                canEdit:false
            },
            //未读消息的数量
            msgCount:{
                type:'text',
                label:'未读消息',
                canEdit:false
            },
            //最后一条未读消息的具体内容
            lastMsg:{
                type:'text',
                label:'最新消息',
                canEdit:false
            },
            //最后一条未读消息的事件
            lastMsgTime:{
                type:'text',
                label:'时间',
                canEdit:false
            },
            //发送消息者的昵称
            nickName:{
                type:'text',
                label:'昵称',
                canEdit:false
            },
            //msgList里面每条数据显示的内容
            msgContent:{
                type:'text',
                label:'消息',
                canEdit:false
            },
            //包含点击跳转页面的信息
            moveTo:{
                type:'text',
                label:'跳转页面',
                canEdit:false
            },
            //消息的创建时间
            createAt:{
                type:'text',
                label:'创建时间',
                canEdit:false
            },
            msgNumNode: {
                type: "text",
                formatter:function(action,data){
                    return data&&data.msgCount&&data.msgCount>0?("<div class='msg-num-node'>"+data.msgCount+"</div>"):"";
                }
            }
        },
        _getToUserDef:function(userId){
            if(!this._toUserDef){
                this._toUserDef = this.exec("loadToUser", {
                    shopId: this.getShopId(),
                    userId: userId,
                    orderBy: "-lastMsgTime"
                }).then(lang.hitch(this,function(data){
                    this._toUserDef = null;
                    return data;
                }));
            }
            return this._toUserDef;
        },
        //获取未读消息数量
        getMsgCount:function(){
            return consumer.hasLogin().then(lang.hitch(this, function (isLogin) {
                if(isLogin){
                    return this._getToUserDef(consumer.getCurrentUserId()).then(lang.hitch(this, function (item) {
                        var items = {
                            intotal: 0
                        };
                        if(item.data.items.length){
                            for(var i=0;i<item.data.items.length;i++){
                                items.intotal += item.data.items[i].msgCount||0;
                            }
                            return items;
                        }
                    }));
                }else{
                    return {};
                }
            }));
        },
        //对话列表
        //获取对话列表
        getPendingData:function(){
            return this.getBaseUrl() + '/loadToUser';
        },
        //加载对话清单的参数
        getImListParam:function(){
            return {
                shopId: this.getShopId(),
                userId: consumer.getCurrentUserId(),
                orderBy: "-lastMsgTime"
            };
        },
        //对话列表中默认头像，昵称，消息时间的处理
        getItemProp:function(data){
            data.logo = data&&data.senderId&&data.senderId.logo||config.defultUserLogo;
            data.nickName = data&&data.senderId&&data.senderId.nickName||data&&data.senderId&&data.senderId.pName||data&&data.senderId&&data.senderId.userName;
            //处理时间
            data.lastMsgTime = date.getTimeMoment(data.lastMsgTime);
            return data;
        },
        //对话界面viewId，子类必须重载
        svcDetailView:"",
        //列表点击事件
        onListClick:function(data){
            window.moveToView(this.svcDetailView,data.senderId._id+','+(data.targetShopId||this.getShopId()));
        },
        //公共方法，和指定商家的指定人对话
        msgTo:function(targetUserId,targetShopId){
            return this.exec("msgTo",{
                receiverId:targetUserId,
                targetUserId: consumer.getCurrentUserId(),
                targetShopId:targetShopId
            }).then(lang.hitch(this,function(){
                window.moveToView(this.svcDetailView,targetUserId+","+targetShopId);
            }));
        },
        clearPenddingMsg:function(userId,targetShopId){
            return this.exec("clearPenddingMsg",{
                receiverId:consumer.getCurrentUserId(),
                targetShopId:targetShopId,
                senderId:userId
            });
        }
    });
});