﻿define([
    "dojo/_base/declare"
], function (declare) {
    return declare("",null,{
        modalName:"log/parsedLog",
        //字段名
        fields: {
            createAt:{
                type: "dateTime",
                label: "时间",
                className:"middle-width"
            },
			currUrl:{
				type:"text",
				label:"网址",
                className:"middle-width",
                formatter: function (value, data) {
					var v = "<a target='_blank' href='"+value+"'>"+value+"</a>";
					return v;
				}
			},
			oldView:{
				type:"text",
				label:"原页面",
                className:"min-width"
			},
			os:{
				type:"text",
				label:"操作系统",
                className:"min-width"
			},
			stayTime:{
				type:"text",
				label:"停留时间",
                className:"min-width"
			},
            browserType:{
                type:"text",
                label:"浏览器",
                className:"min-width"
            },
            clientType:{
                type:"text",
                label:"使用工具",
                className:"middle-width"
            },
            userIp:{
                text:"text",
                label:"访问IP地址",
                className:"middle-width"
            },
            netType:{
                type:"text",
                label:"网络",
                className:"min-width"
            },
            logTime:{
                type:"dateTime",
                label:"logTime",
                className:"middle-width"
            },
            host:{
                type:"text",
                label:"主机",
                className:"middle-width"
            },
            svc:{
                type:"text",
                label:"svc",
                className:"middle-width"
            },
            newView:{
                type:"options",
                label:"新页面",
                options: {
                    
                },
                className:"min-width"
            },
            param:{
                type:"text",
                label:"param",
                className:"middle-width"
            },
            // 以下继承自log
            logType: {
                type:"text",
                label:"logType",
                className:"middle-width"
            },
            logDate: {
                type:"dateTime",
                label:"logDate",
                className:"middle-width"
            },
            token:{
                type:"text",
                label:"token",
                className:"middle-width"
            },
            fromType:{
                type:"options",
                label:"数据来源",
                options:{
                    "singlemessage":"微信分享",
                    "timeline":"朋友圈分享",
                    "groupmessage":"微信群分享",
                    "weixin":"微信",
                    "browser":"浏览器",
                    "app":"app"
                },
                className:"middle-width"
            },
            total:{
                type:"text",
                label:"到访客户数",
                className:"middle-width"
            },
            app:{
                type:"text",
                label:"app访问",
                className:"middle-width"
            },
            weixin:{
                type:"text",
                label:"微信",
                className:"middle-width"
            },
            groupmessage:{
                type:"text",
                label:"微信群",
                className:"middle-width"
            },
            singlemessage:{
                type:"text",
                label:"微信分享",
                className:"middle-width"
            },
            timeline:{
                type:"text",
                label:"朋友圈",
                className:"middle-width"
            },
            browser:{
                type:"text",
                label:"浏览器访问",
                className:"middle-width"
            },
            date:{
                type:"date",
                label:"访问日期",
                className:"middle-width"
            },
            hours:{
                type:"text",
                label:"访问时间",
                className:"middle-width"
            },
            "mId.mName":{
                type:"text",
                label:"商品",
                className:"middle-width"
            },
            "targetShopId.shopName":{
                type:"text",
                label:"商家",
                className:"middle-width"
            },
            "fromUser.nickName":{
                type:"text",
                label:"来源客户",
                className:"middle-width"
            }
        }
    });
});