/****
 *   创建时间: 2016/12/20
 *   创建人:   杜飞军
 *   内容
 *       提供公共使用的方法
 */
define([
    'dojo/_base/declare',
    "dojo/_base/lang",
    "bob/shop/shop",
    'cq/util/config/config',
    "cq/util/share/share"
], function (declare, lang, shop, config, share) {
    return declare('', null, {
        modalName: 'mat/mat',
        // 链接后台的地址名
        // 可处理的字段
        fields: {
            logo: {
                type: 'image',
                label: '图标',
                cqWidth:"80"
            },
            images: {
                type: 'images',
                label: '商品图片',
                className: 'large-width',
                sizeType: 'cut',
                size: {
                    width: 640,
                    height: 640
                },
                notNull: true
            },
            code: {
                type: 'text',
                label: '商品编码'
            },
            mName: {
                type: 'text',
                label: '商品名称',
                placeHolder: '必填',
                notNull: true
            },
            sortId: {
                label: '标准分类',
                type: 'ref',
                dataProvider: 'bob/mat/stdSort',
                targetMethod: 'getMatSortUrl',
                className: 'middle-width',
                searchField: 'sortName',
                labelFields: 'sortName',
                query: {},
                notNull: true
            },
            groupId: {
                label: '品类',
                type: 'ref',
                dataProvider: 'bob/mat/group',
                targetMethod: 'getGroupUrl',
                className: 'middle-width',
                searchField: 'gName',
                labelFields: 'gName',
                query: {
                    isUse: true
                }
            },
            sizeType: {
                type: 'text',
                label: '规格',
                placeHolder: '必填',
                notNull: true
            },
            freight: {
                label: '运费',
                type: 'number',
                fixedTo:2
            },
            retailPrice: {
                label: '销售价',
                type: 'number',
                placeHolder: '给商品定个好价格',
                notNull: true,
                fixedTo:2
            },
            marketPrice: {
                label: '市场参考价',
                type: 'number',
                placeHolder: "市场参考价",
                fixedTo:2
            },
            content: {
                label: '图文描述',
                type: 'richText',
                placeHolder: '必填',
                // 允许选择模版，模版类型为"mat"
                tempType:"mat",
                notNull: true
            },
            qty: {
                label: '库存',
                placeHolder: '设置合理的库存避免超卖',
                type: 'number',
                notNull: true,
                fixedTo: 0
            },
            totalSale: {
                type: 'number',
                label: '销量',
                fixedTo: 0
            },
            // 运费模版
            freightTplId: {
                label: '运费模版',
                type: 'ref',
                dataProvider: 'bob/shop/freightTemplate',
                targetMethod: 'getFreightTemplateListUrl',
                searchField: 'title',
                labelFields: 'title',
                query: {
                    isUse: true
                }
            },
            purchaseQty: {
                label: "采购起订量",
                type: "number"
            },
            // 销售起订量
            minQty: {
                label: "销售起订量",
                type: "number",
                placeHolder: "商品最小订购量"
            },
            settlePrice: {
                type: 'number',
                label: '结算价',
                placeHolder: "设置商品分销结算价",
                fixedTo: 2
            },
            share: {
                type: 'button',
                label: '分享',
                action: 'share'
            },
            "freightTplId.minFee": {
                type: "number",
                fixedTo: 2
            },
            minFee: {
                type: "number",
                fixedTo: 2,
                placeHolder: "运费"
            },
            limitedQty: {
                type: "number",
                fixedTo: 0,
                placeHolder: "限购数量",
                label: "限购数量"
            }
        },
        getListUrl: function () {
            // summary:
            //        加载商品列表地址
            // view:
            //      matList --商品列表页面
            //      searchDisMat    --平台商品列表页面
            // description:
            //         无
            return this.getBaseUrl() + '/loadMat';
        },
        // 编辑列表跳转ID
        editViewID: 'matBB2C',
        // 查询列表点击跳转ID
        listViewID: 'matDetail',
        // 商品详情页面跳转ID
        //detailViewId: 'matDetail'

        onListClick: function (item) {
            // summary:
            //        商品列表点击
            // view:
            //         matListB --商家端商品列表页面
            // description:
            //         无
            window.moveToView(this.listViewID, item._id);
        },
        editMat: function (params) {
            // summary:
            //         点击编辑商品后的响应
            // view:
            //         matDetailBB2B -- 服务商查看自己商品内容详情页面
            //         matDetailBB2C -- 商家端商品内容详情
            // description:
            //         无
            window.moveToView(this.editViewID, params.cqRefInfo && params.cqRefInfo.cqViewParam && params.cqRefInfo.cqViewParam.params);
        },
        getListUrl: function () {
            return this.getBaseUrl() + '/loadMat';
        },
        share: function (data, widget) {
            // summary:
            //         点击后分享给其他人
            // view:
            //         matDetail
            //         matDetailBB2B -- 服务商查看自己商品内容详情页面
            //         matDetailBB2C -- 商家端商品内容详情
            // description:
            //         无
            var options = [
                {
                    timeLine: {
                        title: data.mName,// 分享标题
                        thumb: data.logo || "",// logo,
                        url: "#matDetail-" + data._id, // url
                    }
                },{
                    "weixin": {
                        title: data.mName,
                        thumb: data.logo || "",
                        url: share.getPageLoc(this.getShopId(),"#matDetail-" + data._id)
                    }
                }, {
                    "friendCircle": {
                        title: data.mName,
                        thumb: data.logo || "",
                        url:share.getPageLoc(this.getShopId(),"#matDetail-" + data._id)
                    }
                }, {
                    "copy": {
                        url: share.getPageLoc(this.getShopId(),"#matDetail-" + data._id)
                    }
                }
            ];
            // 判断当前店铺的认证状态
            shop.getCurrentShop().then(lang.hitch(this, function(shopData){
                // 如果商家认证了
                if(shopData && shopData.isVerified) {
                    share.showShare(options);
                }else {
                    alert("商家没有认证,不能分享商品,请尽快完成认证");
                }
            }));
        }
    });
});
