define([
	"dojo/_base/declare",
	"dojo/Deferred",
    "dojo/_base/array",
	"dojo/_base/lang",
	"../BoBase",
    "cq/biz/mat/cattle"
], function (declare, Deferred, array, lang, BoBase, cattle) {
	var CattleC = declare('', [BoBase.B], {
		modalName: 'mat/cattle',
		getStateCount : function () {
            return cattle.getStateCount().then(lang.hitch(this, function(data) {
                var cattleSates = {};
                if (data && data.data && data.data.ok === 1) {
                    array.forEach(data.data.items, function (item) {
                        cattleSates["cattleState" + item.pregnantState] = item.count;
                    }, this);
                }
                return cattleSates;
            }));
        },
        getCattleCount : function () {
            return cattle.getCattleCount().then(lang.hitch(this, function(data) {
                var pageData = {};
                if (data && data.data && data.data.ok === 1) {
                    pageData = data.data.item;
                }
                return pageData;
            }))
        }
	});
	var cattleC = new CattleC();
	cattleC.Bo = CattleC;
	return cattleC;
});