//在村头2.0，检查的页面
//B2C商家页面:列表、详情、编辑
//平台管其他商家商品的页面:列表、购物车、详情、编辑
//消费者端：商品列表、详情、编辑、农户主页、商家首页
//不需要的接口全部注释掉，后台biz下的接口同理

/****
 *   创建时间: 2016/12/20
 *   创建人:   杜飞军
 *   内容
 *       提供商家端使用的方法
 */
define([
    'dojo/_base/declare',
    'dojo/_base/lang',
    'dojo/_base/array',
    './_MatMixin',
    '../BoBase',
    "dojo/Deferred",
    "bob/user/timeLine",
    "bob/user/consumer",
    "bob/shop/shop",
    'bob/mk/limitDiscount/b',
    "bob/mk/deliveryCard/b",
    'cq/util/sys/query',
    'cq/util/config/config',
    "cq/util/share/share",
    "cq/util/sys/date",
    "bob/mk/reward/b"
], function (declare, lang, array, _MatMixin, BoBase, Deferred, timeLine, consumer, shop, limitDiscount, deliveryCard, query, config, share,date, reward) {
    var MatBBo = declare("", [BoBase.B, _MatMixin], {
        // 商家端需要的按钮
        fields: {
            groomMatConfirm: {
                type: 'button',
                label: '推荐商品',
                action: 'onRecommend'
            },
            groomMatCancel: {
                type: 'button',
                label: '取消推荐',
                action: 'offRecommend'
            },
            frameConfirm: {
                type: 'button',
                label: '商品上架',
                action: 'onShelves'
            },
            frameCancel: {
                type: 'button',
                label: '商品下架',
                action: 'offShelves'
            },
            isCycle: {
                type: "checkbox",
                label: "周期配送",
            },
            farmer: {
                label: '农户',
                type: 'ref',
                dataProvider: 'bob/user/farmer/b',
                targetMethod: 'getListUrlForFarmer',
                className: 'middle-width',
                searchField: 'search',
                labelFields: 'pName,phone',
                query: {
                    isFarmer: true
                }
            },
            saveAndOnShelves: {
                type: 'button',
                label: '保存',
                action: 'saveAndOnShelves',
                className: 'fullButton'
            },
            saveAndOffShelves: {
                type: 'button',
                label: '保存并放入仓库',
                action: 'saveAndOffShelves'
            },
            matlistActions: {
                type: 'text',
                label: '',
                formatter: function (action, data) {
                    var v = '<div class=\'button\' cq-action=\'detail\'>详情</div>' +
                        '<div class=\'button\' cq-action=\'edit\'>编辑</div>';
                    return v;
                },
                className: 'middle-width'
            },
            specs: {
                type: 'objects',
                label: '商品规格',
                labelField: 'name',
                rightTextField: 'price',
                canEdit:true,
                canDelete:true,
                canAdd:true,
                canDnd:false,
                fields: {
                    workMode:"edit",
                    className:"editEditor",
                    layout: [{
                        field: 'name',
                        type: 'text',
                        label: '规格',
                        placeHolder: "请输入商品规格"
                    }, {
                        field: 'price',
                        type: 'number',
                        label: '销售价',
                        placeHolder: "给商品定个好价格"
                    },{
                        field: "settlePrice",
                        type: "number",
                        label: "结算价",
                        placeHolder: "设置商品分销结算价"
                    }, {
                        field: 'qty',
                        type: 'number',
                        label: '库存',
                        placeHolder: "设置合理库存避免超卖"
                    },{
                        field: 'deliveryTimes',
                        type: 'number',
                        label: '配送次数',
                        placeHolder: "单位商品的实际配送数量"
                    },{
                        field: 'optId',
                        label: '商品属性',
                        type: 'ref',
                        dataProvider: 'bob/mat/opt/b',
                        targetMethod: 'getListUrlForMyself',
                        searchField: 'search',
                        labelFields: 'title',
                        query: {
                            isUse: true
                        }
                    },{
                        field: "weight",
                        type: "number",
                        label: "单位重量(g)",
                        placeHolder: "单位重量"
                    }]
                }
            },
            weight: {
                type: "number",
                label: "单位重量",
                placeHolder: "单位重量(g)"
            },
            optId: {
                label: '商品属性',
                type: 'ref',
                dataProvider: 'bob/mat/opt/b',
                targetMethod: 'getListUrlForMyself',
                searchField: 'search',
                labelFields: 'title',
                query: {
                    isUse: true
                }
            },
            deliveryTimes: {
                type: 'text',
                label: '配送次数',
                placeHolder: "单位商品的实际配送数量"
            },
            share: {
                type: 'button',
                label: '分享',
                action: 'share'
            },
            modifySupplier: {
                type: 'button',
                label: '修改供货商',
                action: 'modifySupplier'
            },
            addMat: {
                type: 'button',
                label: '保存',
                action: 'addMat'
            },
            onSave: {
                type: 'button',
                label: '保存',
                action: 'onSave'
            },
            onDelete:{
                type:'button',
                label:'删除商品',
                action:'onDelete'
            },
            shopName: {
                type: "text"
            },
            "fromShopId.shopName": {
                type: "text"
            },
            retailPriceTxt: {
                type: "text"
            },
            buyLimit: {
                type: 'button',
                label: '加入抢购',
                action: 'buyLimit'
            },
            addSeasonMat: {
                type: 'button',
                label: '加入时令区',
                action: 'addSeasonMat'
            },
            prices: {
                type: 'objects',
                label: '',
                labelField: 'name',
                rightTextField: 'price',
                canEdit:true,
                canDelete:true,
                canAdd:true,
                canDnd:false,
                fields: {
                    workMode:"edit",
                    className:"editEditor",
                    layout: [{
                        field: 'clientLevel',
                        label: '等级',
                        type: 'ref',
                        dataProvider: 'bob/user/clientLevel',
                        targetMethod: 'getListUrl',
                        searchField: 'search',
                        labelFields: 'levelName'
                    }, {
                        field: 'price',
                        type: 'number',
                        label: '折扣',
                        placeHolder: "请输入0~1的小数",
                        fixedTo:2
                    }]
                }
            },
            group: {
                type: "groupEdit",
                label: "分级定价",
                rightText: "点击设置",
                group: "group3"
            }
        },
        share: function (data, widget) {
            // summary:
            //         点击后分享给其他人
            // view:
            //         matDetail
            //         matDetailBB2B -- 服务商查看自己商品内容详情页面
            //         matDetailBB2C -- 商家端商品内容详情
            // description:
            //         无
            share.getShopLocation(this.getShopId()).then(function(baseUrl){
                var options = [{
                    timeLine: {
                        title: data.mName, // 分享标题
                        thumb: data.logo || "", // logo,
                        url: "#matDetail-" + data._id, // url
                    }
                }, {
                    "weixin": {
                        title: data.mName,
                        thumb: data.logo || "",
                        url: baseUrl+"#matDetail-" + data._id
                    }
                }, {
                    "friendCircle": {
                        title: data.mName,
                        thumb: data.logo || "",
                        url: baseUrl+"#matDetail-" + data._id
                    }
                }, {
                    "copy": {
                        url: baseUrl+"#matDetail-" + data._id
                    }
                }];
                // 判断当前店铺的认证状态
                shop.getCurrentShop().then(lang.hitch(this, function (shopData) {
                    // 如果商家认证了
                    if (shopData && shopData.isVerified) {
                        share.showShare(options);
                    } else {
                        alert("商家没有认证,不能分享商品,请尽快完成认证");
                    }
                }));
            });
        },
        //mat的根据mid加载数据，限时抢购引用处需要
        loadByMid:function(mid, fromShopId){
            var params = {
                _id: mid
            };
            if(fromShopId){
                params.fromShopId = fromShopId;
            }
            return this.exec("loadById",params);
        },
        // 根据mid数组加载数据
        loadByMids:function(ids){
            var params = {
                ids: ids
            }; 
            return this.exec('loadByIds',params);
        },
        buyLimit:function(data, widget){
            // summary:
            //         点击查看限时抢购的改商品
            // view:
            //         matDetail
            //         matDetailBB2B -- 服务商查看自己商品内容详情页面
            //         matDetailBB2C -- 商家端商品内容详情
            // description:
            //         跳转到限时抢购的编辑页面（limitDiscountEdt），参数格式：mid_XXX
            window.moveToView("limitDiscountEdt","mid_"+data._id);
            
        },
        addSeasonMat:function(data,widget){
            // summary:
            //         将该商品加入时令生鲜商品
            // view:
            //         matDetail
            //         matDetailBB2B -- 服务商查看自己商品内容详情页面
            //         matDetailBB2C -- 商家端商品内容详情
            // description:
            //         跳转到时令生鲜的编辑页面（seasonMatEdt），参数格式：mid_XXX
            // 检查商家是否已经认证 未认证的 不允许提交申请
            shop.loadMe().then(function(shopData){
                if(shopData&&shopData.isVerified){
                    window.moveToView("seasonMatEdt","mid_"+data._id);
                }else{
                    alert("店铺未认证，不能申请加入时令区");
                }
            });
        },
        fieldChangeMethod: function (widget, field, fieldVl) {
            var data = widget.getData();
            if (field == "specs") {
                // 如果有规格 则隐藏配送次数
                if (fieldVl.length) {
                    widget.hideByFields(['sizeType', 'qty', 'retailPrice', "deliveryTimes", "optId", "weight"]);
                } else {
                    widget.showByFields(['sizeType', 'qty', 'retailPrice', "weight"]);
                    if(data.isCycle){
                        widget.showByFields(["deliveryTimes", "optId"]);
					}
                }
                /*if(fieldVl.length==1&&!fieldVl[0]._id){
                    data.specs[0].name = data.sizeType;
                    data.specs[0].qty = data.qty;
                    data.specs[0].price = data.retailPrice;
                    data.specs[0].settlePrice = data.settlePrice;
                    data.specs[0].weight = data.weight;
                    data.specs[0].optId = data.optId;
                    data.specs[0].deliveryTimes = data.deliveryTimes;
                    widget.setData(data);
                }*/
            }
            if (field == 'isCycle') {
                if (data.specs.length) {
                    widget.hideByFields(['sizeType', 'qty', 'retailPrice', "deliveryTimes", "optId", "weight"]);
                } else {
                    widget.showByFields(['sizeType', 'qty', 'retailPrice', "weight"]);
                    if(fieldVl){
                        widget.showByFields(["deliveryTimes", "optId"]);
                    }
                }
            }
        },
        // 网站端编辑商品的Layout
        getEdtLayoutForWeb: function () {
            return [{
                type: 'form',
                fields: this.getFormItems(['mName', 'sizeType', 'retailPrice', 'qty', 'totalSale', 'matlistActions'], true)
            }];
        },
        getListUrlForCurrentShop: function () {
            return this.getBaseUrl() + '/loadMat?shopId=' + this.getShopId() + "&fromShopId=" + this.getShopId() + "&isUse=true&qty=1";
        },
        getListDataForCurrentShop: function () {
            return this.exec("loadMat", {
                shopId: this.getShopId(),
                fromShopId: this.getShopId(),
                isUse: true,
                qty: 1
            });
        },
        getEdtLayoutForApp: function () {
            // summary:
            //        App端编辑商品的Layout
            // view:
            //         mat  --商品录入修改页面
            // description:
            //         无
            return [{
                type: 'form',
                fields: this.getFormItems([
                    'images',
                    'code',
                    'mName',
                    'groupId',
                    'sortId',
                    'sizeType',
                    'retailPrice',
                    "settlePrice",
                    'group',
                    'qty',
                    'weight',
                    'specs',
                    'isCycle',
                    'deliveryTimes',
                    'optId',
                    'marketPrice',
                    'minQty',
                    'limitedQty',
                    'farmer',
                    'freightTplId',
                    'freight',
                    'content',
                    'saveAndOnShelves',
                    "saveAndOffShelves",
                    "onSave"
                ], true)
            }, {
                type: "group",
                groupId: "group3",
                groupClass: "mblEdgeToEdgeList no-margin-top",
                fields : this.getFormItems([
                    "prices"
                ])
            }];
        },
        getMatDetailLayout: function () {
            // summary:
            //        商品详情的Layout
            // view:
            //         matDetailB   --商家端商品内容详情
            // description:
            //         无
            return [{
                type: 'content',
                content: config.mat.simpleLayout
            }, {
                type: 'form',
                formClass: "hide",
                fields: this.getFormItems(['groomMatConfirm', 'groomMatCancel', 'frameConfirm', 'frameCancel', 'share','buyLimit','addSeasonMat','onDelete'])
            }];
        },
        getMatDetailSDLayout: function () {
            return [{
                type: 'content',
                content: config.mat.detailLayout
            }, {
                type: 'form',
                fields: this.getFormItems(['modifySupplier', 'share'])
            }];
        },
        // 修改供货商
        modifySupplier: function (data, widget) {
            console.log(data);
        },
        // 点击后分享商品的信息
        onClickShare: function (item) {
            var data = {};
            data.title = item.mName;
            data.logo = item.logo;
            data.images = item.images;
            data.herf = 'matDetail' + item._id;
            data.fromShopId = this.getShopId();
            data.userId = consumer.getCurrentUserId();
            data.tp = 2;
            timeLine.onSave(data);
        },
        // 设置商品详情跳转Id
        listViewID: 'matDetailBB2C',
        getListParamForP: function (cqRefInfo) {
            // summary:
            //        加载商品列表的查询条件
            // view:
            //         matListB --商家端商品列表页面
            // description:
            //         无
            var params = {
                shopId: this.getShopId(),
                orderBy: 'createAt',
                isUse: true,
                qty: 1,
                preventSelf: false
            };
            // 如果传递了商家id则追加
            if (cqRefInfo.cqViewParam && cqRefInfo.cqViewParam.params) {
                params.fromShopId = cqRefInfo.cqViewParam.params;
            }
            // 商品库存查询
            if (cqRefInfo.verifyState && cqRefInfo.verifyState.qty !== undefined) {
                params.qty = cqRefInfo.verifyState.qty;
            }
            // 商品上架查询
            if (cqRefInfo.verifyState && cqRefInfo.verifyState.isUse !== undefined) {
                params.isUse = cqRefInfo.verifyState.isUse;
                // 如果查询下架商品 移除库存条件
                if (!params.isUse) {
                    delete params.qty;
                }
            }

            // 推荐商品的查询
            if (cqRefInfo.verifyState && cqRefInfo.verifyState.isRecommend !== undefined) {
                params.isRecommend = cqRefInfo.verifyState.isRecommend;
                // 查询推荐商品时 移除库存和上架条件
                delete params.isUse;
                delete params.qty;
            }
            //新增按sortId查询
            value = query.getQueryValue(cqRefInfo.sortId);
            if (value) {
                params.sortId = value;
            }
            // 关键字查询条件
            var value = query.getQueryValue(cqRefInfo.search);
            if (value) {
                params.search = value;
            }
            return params;
        },
        getItemProp: function (item) {
            item.totalSale = item.totalSale || 0;
            item.qty = item.qty || 0;
            item.shopName = item.fromShopId && item.fromShopId.shopName || "";
            return item;
        },
        getListParam: function (cqRefInfo) {
            // summary:
            //        加载商品列表的查询条件
            // view:
            //         matListB --商家端商品列表页面
            // description:
            //         无
            var params = {
                shopId: this.getShopId(),
                orderBy: '-createAt',
                fromShopId: this.getShopId(),
                isUse: true,
                qty: 1
            };
            if(cqRefInfo.verifyState&&cqRefInfo.verifyState._id=="2"){
                // "已售罄"
                params.orderBy = "-lastMod";
            }/*else if(cqRefInfo.verifyState._id=="1"){
                // 已推荐
                
            }else  if(cqRefInfo.verifyState._id=="3"){
                // 已下架
            }*/
            // 如果传递了商家id则追加
            if (cqRefInfo.cqViewParam && cqRefInfo.cqViewParam.params) {
                params.fromShopId = cqRefInfo.cqViewParam.params;
            }
            // 商品库存查询
            if (cqRefInfo.verifyState && cqRefInfo.verifyState.qty !== undefined) {
                params.qty = cqRefInfo.verifyState.qty;
            }
            // 商品上架查询
            if (cqRefInfo.verifyState && cqRefInfo.verifyState.isUse !== undefined) {
                params.isUse = cqRefInfo.verifyState.isUse;
                // 如果查询下架商品 移除库存条件
                if (!params.isUse) {
                    delete params.qty;
                }
            }

            // 推荐商品的查询
            if (cqRefInfo.verifyState && cqRefInfo.verifyState.isRecommend !== undefined) {
                params.isRecommend = cqRefInfo.verifyState.isRecommend;
                // 查询推荐商品时 移除库存和上架条件
                delete params.isUse;
                delete params.qty;
            }
            //新增按sortId查询
            value = query.getQueryValue(cqRefInfo.sortId);
            if (value) {
                params.sortId = value;
            }
            // 关键字查询条件
            var value = query.getQueryValue(cqRefInfo.search);
            if (value) {
                params.search = value;
            }
            return params;
        },
        // 干劲：这里有对需求错误
        //        TODO:
        //            分销商找商品也是从供应商详情的商品列表中去找，从平台找商品来分销的做法不合理
        //            参考matDetailB2B2C

        getListPlatfromParam: function (cqRefInfo) {
            // summary:
            //        加载平台商品的条件查询
            // view:
            //      searchDisMat --平台商品列表页面
            //      matListD    --分销商品的商品列表
            // description:
            //         无
            var params = {
                shopId: this.getShopId(),
                orderBy: 'createAt',
                fromShopId: this.getPlatformShopId(),
                isUse: true,
                preventSelf: true,
                qty: 1
            };
            // 关键字查询条件
            var value = query.getQueryValue(cqRefInfo.search);
            if (value) {
                params.search = value;
            }
            // 如果传递了商家id则追加
            if (cqRefInfo.cqViewParam && cqRefInfo.cqViewParam.params) {
                params.fromShopId = cqRefInfo.cqViewParam.params;
            }
            // 商品上架查询
            if (cqRefInfo.verifyState && cqRefInfo.verifyState.isUse !== undefined) {
                params.isUse = cqRefInfo.verifyState.isUse;
            }
            // 商品库存查询
            if (cqRefInfo.verifyState && cqRefInfo.verifyState.qty !== undefined) {
                params.qty = cqRefInfo.verifyState.qty;
            }
            // 推荐商品的查询
            if (cqRefInfo.verifyState && cqRefInfo.verifyState.isRecommend !== undefined) {
                params.isRecommend = cqRefInfo.verifyState.isRecommend;
            }
            //新增按sortId查询
            value = query.getQueryValue(cqRefInfo.sortId);
            if (value) {
                params.sortId = value;
            }
            return params;
        },
        onListClickForD: function (item) {
            // summary:
            //        商家获得的商品点击处理
            // view:
            //         matListD --分销商品的商品列表
            // description:
            //         无
            window.moveToView('matDetailD', item._id);
        },
        onListClickForP: function (item) {
            // summary:
            //        商家获得的商品点击处理
            // view:
            //         matListP --平台管商品
            // description:
            //         无
            window.moveToView('matDetailP', item._id);
        },
        checkFields: function (data) {
            if (!data.images.length) {
                alert("请上传图片");
                return false;
            }
            // 销售价和库存不再是必检查的项目了
            var msg = this.getDataValidMsg(data, ['images', 'mName', "sortId", 'content']);//, 'retailPrice', 'qty'
            if (msg) {
                alert(msg);
                return false;
            }
            if (data.images.length) {
                data.logo = data.images[0];
            }
            // 检查价格的合法性
            if(!data.retailPrice&&!data.specs.length){
                alert("请填写零售价");
                return false;
            }
            if (!data.sizeType && !data.specs.length) {
                alert("规格或者商品规格选择一个录入");
                return false;
            }
            // 后台程序会处理模板和运费的优先级
            //if (data.freight && data.freightTplId) {
            //    alert("运费和运费模板选填一个");
            //    return false;
            //}
            // 多规格数据检测
            if (data.specs.length) {
                var specs = true;
                for(var i=0;i<data.specs.length;i++){
                    if(!data.specs[i].price||
                        !data.specs[i].name||
                        (Number(data.specs[i].qty)<0)||
                        (data.isCycle&&Number(data.specs[i].deliveryTimes)<=0)||
                        Number(data.specs[i].price)<0||
                        (data.specs[i].settlePrice&&(Number(data.specs[i].settlePrice)<0||Number(data.specs[i].settlePrice)>Number(data.specs[i].price)))
                    ){
                        alert("第"+(i+1)+"个规格信息填写不合法");
                        specs = false;
                        break;
                    }
                }
                if(!specs){
                    return;
                }
            }else{
                if(Number(data.retailPrice)<0){
                    alert("零售价填写不合法");
                    return;
                }
                if(data.settlePrice&&(Number(data.settlePrice)<0||Number(data.settlePrice)>Number(data.retailPrice))){
                    alert("结算价填写不合法");
                    return;
                }
                // 若果库存填的0 则设置为不上架
                if (!data.qty || data.qty == 0) {
                    alert("库存为0不能上架");
                    return false;
                }
                if(data.isCycle&&Number(data.deliveryTimes)<=0){
                    alert("周期商品配送次数填写不合法");
                }
            }
            //等级定价检查
            if(data.prices.length){
                var pricesHash = {};
                for(var i=0;i<data.prices.length;i++){
                    if(!data.prices[i].clientLevel||!data.prices[i].price){
                        alert("第"+(i+1)+"行等级为空，请设置");
                        return;
                    }
                    if(!pricesHash[data.prices[i].clientLevel._id]){
                        pricesHash[data.prices[i].clientLevel._id] = 1;
                    }else{
                        alert(data.prices[i].clientLevel.levelName+"设置重复");
                        return;
                    }
                    if(data.prices[i].price>1||data.prices[i].price<0){
                        alert("分级定价折扣区间只能为0~1");
                        return;
                    }
                }
            }
            if(data.minQty&&data.limitedQty){
                if(data.minQty>data.limitedQty){
                    alert("最小起订量不能大于限购数量");
                    return;
                }
            }
            return true;
        },
        save: function (data) {
            if (data.specs&&data.specs.length) {
                var qty = Number(data.specs[0].qty),
                    price = data.specs[0].price,
                    settlePrice = data.specs[0].settlePrice;
                for(var i=1;i<data.specs.length;i++){
                    qty += Number(data.specs[i].qty);
                    price = Math.min(price,data.specs[i].price);
                    settlePrice = Math.min(settlePrice, data.specs[i].settlePrice);
                }
                data.qty = qty;
                data.retailPrice = price;
                data.settlePrice = settlePrice;
            }
			if(!data.shopLevel||data.shopLevel<3){
				data.isCycle = false;
			}
            //处理分等级定价
            if(data.prices.length){
                var currentPrice = null;
                for(var i=0;i<data.prices.length;i++){
                    currentPrice = data.prices[i];
                    currentPrice.price = currentPrice.price*10;
                }
            }
            data.settlePrice = data.settlePrice&&data.settlePrice||data.retailPrice;
            data.diffPrice = data.retailPrice - data.settlePrice;
            return this.exec("save", data).then(lang.hitch(this, function (result) {
                return result;
            }));
        },
        saveAndOnShelves: function (data, widget) {
            if (!this.checkFields(data)) {
                return;
            }
            window.busy();
            // 设置是否销售为false这个是用于b2b的
            data.isPurchase = false;
            data.isUse = true;
            // 判断当前店铺的认证状态
            shop.getCurrentShop().then(lang.hitch(this, function (item) {
                if (item && item.isVerified) {
                    this.save(data).then(lang.hitch(this, function (result) {
                        if (result && result.data && result.data.ok == 1) {
                            window.free();
                            alert("上架成功");
                            history.back();
                        } else {
                            window.free();
                            alert(result && result.data && result.data.message || "上架失败");
                        }
                    }));
                } else {
                    window.free();
                    alert("商家未认证，不允许上架商品。请尽快完成认证");
                }
            }));
        },
        saveAndOffShelves: function (data, widget) {
            if (!this.checkFields(data)) {
                return;
            }
            window.busy();
            // 设置是否销售为false这个是用于b2b的
            data.isPurchase = false;
            data.isUse = false;
            this.save(data).then(lang.hitch(this, function (result) {
                if (result && result.data && result.data.ok == 1) {
                    window.free();
                    alert("保存成功");
                    history.back();
                } else {
                    window.free();
                    alert(result && result.data && result.data.message || "上架失败");
                }
            }));
        },
        onShelves: function (data, widget) {
            // summary:
            //        商家分销的上架操作
            // view:
            //         matDetailD   --分销商品的详细内容
            // description:
            //         无
            if (data.qty === 0 || !data.qty) {
                alert("没有库存不能上架");
                return;
            }
            window.busy();
            shop.loadById(this.getShopId()).then(lang.hitch(this, function (shopData) {
                if (shopData) {
                    if (shopData.isVerified) {
                        this.exec('onShelves', {
                            _id: data._id
                        }).then(function (matData) {
                            if (matData.data && matData.data.ok === 1) {
                                //history.back();
                                // 刷新当前数据
                                window.free();
                                widget.cqRefresh();
                            } else {
                                window.free();
                                alert('上架失败');
                            }
                        });
                    } else {
                        window.free();
                        alert("商家未认证,不允许上架商品,请尽快完成认证");
                    }
                } else {
                    window.free();
                    alert("没有查找到商家");
                }
            }));

        },
        // 下架商品
        offShelves: function (data, widget) {
            // summary:
            //        商家分销的下架操作
            // view:
            //         matDetailD   --分销商品的详细内容
            // description:
            //         无
            if (data.qty === 0 || !data.qty) {
                alert("没有库存不能上架");
                return;
            }
            window.busy();
            this.exec('offShelves', {
                _id: data._id
            }).then(function (matData) {
                if (matData.data && matData.data.ok === 1) {
                    //history.back();
                    // 刷新当前数据
                    window.free();
                    widget.cqRefresh();
                } else {
                    window.free();
                    alert('下架失败');
                }
            });
        },
        onRecommend: function (data, widget) {
            // summary:
            //        推荐商品的操作
            // view:
            //         matDetailB   --商家端商品内容详情
            // description:
            //         无
            window.busy();
            this.exec('recMat', {
                isRecommend: true,
                _id: data._id
            }).then(lang.hitch(this, function (result) {
                if (result && result.data && result.data.ok === 1) {
                    // 刷新当前数据
                    window.free();
                    widget.cqRefresh();
                } else {
                    window.free();
                    alert('推荐失败');
                }
            }));
        },
        offRecommend: function (data, widget) {
            // summary:
            //        取消推荐
            // view:
            //         matDetailB   --商家端商品内容详情
            // description:
            //         无
            window.busy();
            this.exec('recMat', {
                isRecommend: false,
                _id: data._id
            }).then(lang.hitch(this, function (result) {
                if (result && result.data && result.data.ok === 1) {
                    //this.tabGroom(data.data.item, layoutWidget);
                    // 刷新当前数据
                    window.free();
                    widget.cqRefresh();
                } else {
                    window.free();
                    alert('取消推荐失败');
                }
            }));
        },
        loadById: function (params) {
            // summary:
            //        加载指定商品信息
            // view:
            //      mat --商品录入修改页面
            //      matDetailB  --商家端商品内容详情
            //      searchDisMatDetail  --平台商品的商品内容详情
            //      updateDisMatPic     --更新从平台获得分销商品的销售价页面
            // description:
            //         无
			var def = new Deferred();
            var m = params.cqViewParam.params;
			shop.loadMe().then(lang.hitch(this, function(shopItem){
				if(!params.cqViewParam.params){
					def.resolve({
						shopLevel:shopItem.shopLevel||"",
                        shopIsVerified: shopItem.isVerified||false
					});
				}else{
					// 初始化fromShopId
					this.exec('loadById', {
						_id: m,
					}).then(lang.hitch(this, function (data) {
						// 获取商家的信息
						data = data.data.item;
                        //查看该商品是否存在提货活动
                        deliveryCard.loadByMid(data._id).then(lang.hitch(this,function(deliveryData){
                            reward.loadByGiveMid(data._id).then(lang.hitch(this, function(rewardData){
                                if(rewardData&&rewardData.data&&rewardData.data.ok==1){
                                    data.isReward = true;
                                }
                                if(deliveryData&&deliveryData.data&&deliveryData.data.items.length){
                                    data.isDeliveryCard = true;
                                }
                                data.totalSale = data.totalSale || 0;
                                data.shopLevel = shopItem.shopLevel||"";
                                //修改prices的price
                                if(data.prices.length){
                                    for(var i=0;i<data.prices.length;i++){
                                        data.prices[i].price = data.prices[i].price/10;
                                        var levelId = data.prices[i].level;
                                        data.prices[i].level = {};
                                        data.prices[i].level._id = levelId;
                                        data.prices[i].level.levelName = data.prices[i].levelName;
                                    }
                                }
                                /*查看limitDiscount[]:限时抢购
                                //查看preSale[]:预售
                                是否还在活动中或者是否停用，如果为真，显示多规格，否则隐藏多规格，
                                如果原来多规格存在设置多规格为空
                                */
                                var now = date.nowISOString();
                                if(data.limitDiscount.length){
                                    //停用的未加载，只考虑时间范围,在活动中就不允许设置规格
                                    for(var i=0;i<data.limitDiscount.length;i++){
                                        if((data.limitDiscount[i].ed>=now&&data.limitDiscount[i].sd<=now)||data.limitDiscount[i].sd>now){
                                            data.isLimitDiscount = true;
                                            break;
                                        }
                                    }
                                }
                                if(data.preSale.length){
                                    for(var i=0;i<data.preSale.length;i++){
                                        if((data.preSale[i].ed>=now&&data.preSale[i].sd<=now)||data.preSale[i].sd>now){
                                            data.isPreSale = true;
                                            break;
                                        }
                                    }
                                }
                                if(data.pacBuy.length){
                                    for(var i=0;i<data.pacBuy.length;i++){
                                        if((data.pacBuy[i].ed>=now&&data.pacBuy[i].sd<=now)||data.pacBuy[i].sd>now){
                                            data.isPacBuy = true;
                                            break;
                                        }
                                    }
                                }
                                // 查询来源商家
                                if (data.fromShopId) {
                                    shop.loadById(data.fromShopId).then(lang.hitch(this, function (item) {
                                        data.shopName = item && item.shopName || "";
                                        data.shopIsVerified = item && item.isVerified || false;
                                        def.resolve(data);
                                    }));
                                } else {
                                    def.resolve(data);
                                }
                            }));
                        }));
					}));
				}
			}));
			return def.then(function(data){
				// 如果设置了多规格价钱修改
				if (data){
					if(data.specs&&data.specs.length) {
						// 对价格排序
						var specs = data.specs.concat();
						specs.sort(function(a,b){
							return a.price>b.price?1:-1;
						});
						var first = specs[0];
						// 可能只有一个规格
						var last = specs[specs.length - 1];
						if (first.price != last.price) {
							data.retailPriceTxt = window.fixedTo(first.price, 3) + '~' + window.fixedTo(last.price, 3);
						} else {
							data.retailPriceTxt = window.fixedTo(first.price, 3);
						}
					}else{
						data.retailPriceTxt = window.fixedTo(data.retailPrice, 3);
					}
                    data.isSf = !!data.isSf;
                    data.isCycle = !!data.isCycle;
				}
				return data;
			});
        },
        onDataReady: function (widget) {
            // summary:zjp
            //        编辑商品数据完成后
            // view:
            //         mat  --商品录入修改页面
            // description:
            //         无
            var data = widget.getData();
            // 如果销量大于0标准分类不能修改
            /*if (data.totalSale > 0) {
                widget.disableByFields(['sortId']);
            } else {
                widget.enableByFields(['sortId']);
            }*/
            widget.hideByFields(["isCycle"/*, "isSf"*/]);//设置isCycle为假
            if (data._id) {
                widget.showByFields(["onSave"]);
                widget.hideByFields(["saveAndOnShelves", "saveAndOffShelves"]);
                //如果设置了活动的商品不允许设置多规格
                if(data.isPreSale||data.isLimitDiscount||data.isDeliveryCard||data.isPacBuy||data.isReward){
                    widget.hideByFields(["specs"]);
                }
            } else {
                widget.hideByFields(["onSave"]);
                widget.showByFields(["saveAndOnShelves", "saveAndOffShelves"]);
            }
            widget.hideByFields(["optId", "deliveryTimes"]);
            //店铺等级大于3才允许添加周期产品
            if(data.shopLevel&&data.shopLevel>=3){
                widget.showByFields(["isCycle"]);
            }
            if (data.specs.length) {
                widget.hideByFields(['sizeType', 'qty', 'retailPrice',"weight"]);
            } else {
                widget.showByFields(['sizeType', 'qty', 'retailPrice', "weight"]);
            }
            if(data.isCycle&&!(data.specs&&data.specs.length)){
                widget.showByFields(["optId", "deliveryTimes"]);
            }
            /*
            // 选择标准分类后，商品详情允许选择模版
            var sortNode = widget.getEditorByField("sortId");
            var contentNode = widget.getEditorByField("content");
            if(!widget.sortHandle){
                widget.sortHandle = contentNode.connect(sortNode,"setValue",function(sort){
                    if(sort){
                        contentNode.tempType = "mat";       
                    }else{
                        contentNode.tempType = "";   
                    }
                    
                });
            }*/
        },
        getPlatfromListUrl: function () {
            // summary:
            //        分销商品的商品列表
            // view:
            //         matListD --分销商品的商品列表
            // description:
            //         无
            return this.getBaseUrl() + '/loadNeFromShopId';
        },

        // 直接用getListUrl
        getPlatfromListUrlForB: function () {
            // summary:
            //        商品列表的数据加载
            // view:
            //         matListB --商家端商品列表页面
            // description:
            //         无
            return this.getBaseUrl() + '/loadMat';
        },
        getListUrlForP: function () {
            return this.getBaseUrl() + '/loadMat'
        },
        onDataReadyForMat: function (widget) {
            // summary:
            //        商品详情数据加载完成后页面元素的显示
            // view:
            //      matDetailB  --商家端商品内容详情
            //      searchDisMatDetail  --平台商品的商品内容详情
            //      matDetailD  -- 分销商品的详细内容
            // description:
            //         无
            var data = widget.getData();
            widget.hideByFields(["groomMatConfirm", "groomMatCancel", "frameCancel", "frameConfirm", "marketPrice", "farmer._id", "verified","buyLimit"]);
            // 如果设置了市场价 则显示市场价
            if (data.marketPrice) {
                widget.showByFields(["marketPrice"]);
            }
            if (data.isRecommend) {
                widget.showByFields(["groomMatCancel"]);
            } else {
                widget.showByFields(["groomMatConfirm"]);
            }
            if (data.isUse) {
                widget.showByFields(["frameCancel"]);
            } else {
                widget.showByFields(["frameConfirm"]);
            }
            // 如果没有设置farmerId则隐藏查看农户
            if (data.farmer && data.farmer._id) {
                widget.showByFields(["farmer._id"]);
            }
            if (data.shopIsVerified) {
                widget.showByFields(["verified"]);
            }
            //商品使用且商品无规格显示抢购
            if(data.isUse&&data.specs.length==0){
                widget.showByFields(["buyLimit"]);
            }
        },
        onSave: function (data) {
            if (!this.checkFields(data)) {
                return;
            }
            window.busy();
            // 设置是否销售为false这个是用于b2b的
            data.isPurchase = false;
            // 如果设置了多规格检查商品是否处于抢购活动中
            if (data.specs && data.specs.length && data._id) {
                limitDiscount.loadByMatId({
                    _id: data._id
                }).then(lang.hitch(this, function (limitData) {
                    if (limitData && limitData.data && limitData.data.ok) {
                        alert('商品已设置了限时抢购,不允许再重新添加规格');
                        return;
                    }
                    this.save(data).then(lang.hitch(this, function (result) {
                        if (result && result.data && result.data.ok == 1) {
                            window.free();
                            alert("保存成功");
                            history.back();
                        } else {
                            window.free();
                            alert(result && result.data && result.data.message || "上架失败");
                        }
                    }));
                }));
            } else {
                this.save(data).then(lang.hitch(this, function (result) {
                    if (result && result.data && result.data.ok == 1) {
                        window.free();
                        alert("保存成功");
                        history.back();
                    } else {
                        window.free();
                        alert(result && result.data && result.data.message || "上架失败");
                    }
                }));
            }
        },
        onDelete:function(mat){
            var data = mat;
            if(window.confirm("确定删除该商品?")){
                data.isDelete = true;
                window.busy();
                this.exec("save", data).then(lang.hitch(this, function (result) {
                    window.free();
                    if (result && result.data && result.data.ok == 1) {
                        alert("删除成功!");
                        history.back();
                    } else {
                        alert(result && result.data && result.data.message || "删除成功");
                    }
                }));
            }
        }
    });
    var matBBo = new MatBBo();
    matBBo.Bo = MatBBo;
    return matBBo;
});