/****
 *   创建时间: 2016/1/8
 *   创建人:   干劲
 *   内容
 *       B2B商品的处理：B2B商品详情，加入和移除采购清单
 */
define([
	"dojo/_base/declare",
	"dojo/_base/array",
	"dojo/_base/lang",
	'dojo/Deferred',
	'cq/util/config/config',
	'./_MatMixin',
	'../BoBase',
	'cq/util/sys/query',
	"bob/shop/shop",
    "bob/shop/shopB2B",
    "bob/article/ss/comment/c"
], function (declare, array, lang, Deferred, config,  _MatMixin, BoBase, query, shop, shopB2B, comment) {
	var MatB2BBo = declare("", [BoBase.B, _MatMixin], {
		fields: {
			/*listRightText:{
				type:"text",
				formatter:function(value,data){
					return data.enableB2B2C?"去代销":"去采购";
				}
			},*/
			//加入采购清单按钮
			addToPurchaseList:{
				type: 'button',
				label: '加入采购清单',
				action: 'addToPurchaseList'
			},
			//停止采购按钮
			removeFromPurchaseList:{
				type: 'button',
				label: '停止采购',
				action: 'removeFromPurchaseList'
			},
            // 添加商家为供应商
            addToPurchase:{
                type: 'button',
                label: '添加供应商',
                action: 'addToPurchase'
            },
            // 把供应商移除
            removeFromPurchase:{
                type: 'button',
                label:'移除供应商',
                action:'removeFromPurchase'
            },
            // 等待供应商同意
            waitPurchase:{
                type: "button",
                label: "申请中",
                action: "waitPurchase"
            }
		},
		addToPurchaseList:function(data,widget){
            // summary:
            //        加入产品库
            // view:
            //         matDetailB2B
            // description:
            //         无
			window.busy();
			this.exec("addToPurchaseList",{mId:data._id,fromShopId:widget.cqRefInfo.cqViewParam.params.split("_")[1]}).then(lang.hitch(this,function(data){
				window.free();
				if(data&&data.data&&data.data.ok){
					widget.showByFields(['removeFromPurchaseList']);
					widget.hideByFields(['addToPurchaseList']);
					alert("操作成功");
				}
				else alert("操作失败");
			}));
		},
		removeFromPurchaseList:function(data,widget){
            // summary:
            //        停止采购
            // view:
            //         matDetailB2B
            // description:
            //         无
			window.busy();
			this.exec("removeFromPurchaseList",{mId:data._id,fromShopId:widget.cqRefInfo.cqViewParam.params.split("_")[1]}).then(lang.hitch(this,function(data){
				window.free();
				if(data&&data.data&&data.data.ok){
					widget.hideByFields(['removeFromPurchaseList']);
					widget.showByFields(['addToPurchaseList']);
					alert("操作成功");
				}
				else alert("操作失败");
			}));
		},
		// 加载指定商家商品列表的条件
		getBusDtailListParam: function (cqRefInfo) {
			var params = {
				isUse: true,
				qty: 1,
                shopId: cqRefInfo.cqViewParam.params,
                fromShopId: cqRefInfo.cqViewParam.params
			};
			// 关键字查询条件
			var value = query.getQueryValue(cqRefInfo.search);
			if (value) {
				params.search = value;
			}
            if(cqRefInfo.query){
                params.orderBy = cqRefInfo.query.orderBy;
            }
			// 按照销量/价格 排序
			return params;
		},
		// 联系客服
    
		loadById: function (param) {
            // summary:
            //        加载指定商品信息
            // view:
            //         matDetailB2B
            // description:
            //         URL参数格式：mId_shopId
			if (!param.cqViewParam.params) {
				return;
			}
			var def = new Deferred();
			var m = param.cqViewParam.params.split("_");
            if(m.length<2) return;
            
            // 先从目标商家中加载商品
			this.exec('loadById', {
				_id: m[0],
                fromShopId:m[1]
			}).then(lang.hitch(this, function (data) {
				data = data&&data.data&&data.data.item||{};
                if(data.specs&&data.specs.length){
                    var specs = data.specs.concat();
                    specs.sort(function(a,b){
                        return a.price>b.price?1:-1;
                    });
                    var first = specs[0];
                    // 可能只有一个规格
                    var last = specs[specs.length - 1];
                    if (first.price != last.price) {
                        data.retailPriceTxt = window.fixedTo(first.price, 3) + '~' + window.fixedTo(last.price, 3);
                    } else {
                        data.retailPriceTxt = window.fixedTo(first.price, 3);
                    }
                }else{
                    data.retailPriceTxt = window.fixedTo(data.retailPrice, 3);
                }
                
                // 加载最新一行评价信息
                comment.loadNewOneByMat({
                    _id: data._id,
                    fromShopId: m[1]
                }).then(lang.hitch(this, function (commentData) {
                    if (commentData && commentData.data && commentData.data.ok === 1&& commentData.data.item ) {
                        data.hasComments = true;
                        data.commentInfo = commentData.data.item;
                        if (data.commentInfo && data.commentInfo.userId) {
                            //data.commentInfo.createAt = date.formatISODateMinutes(data.commentInfo.createAt);
                            data.commentInfo.userId.logo = data.commentInfo.userId.logo || config.defultUserLogo;
                            data.commentInfo.userId.nickName = data.commentInfo.userId.nickName || "无名氏";
                        }
                    }
                    // 加载来源商家名称
                    shop.loadByIdFromPlt(m[1]).then(function(fromShopData){
                        data.shopName = fromShopData&&fromShopData.shopName||"";
                        // 判断商品对应的商家是否为当前商家的供应商
                        shopB2B.loadById(m[1]).then(function(shopData){
                            if(shopData){
                                // 是供应商
                                if(shopData.isSupplier){
                                    data.isSupplier = 1;
                                }
                                // 申请中
                                else if(shopData.supplierState==1){
                                    data.isSupplier = 3;
                                }else{
                                    data.isSupplier = 2;
                                }
                                data.shopName = shopData.shopName;
                            }else{
                                // 不是供应商
                                data.isSupplier = 2;
                            }
                            def.resolve(data);
                        });
                    });
                }));
			}));
			return def;
		},
		getListUrl: function () {
			return this.getBaseUrl() + '/loadBySort';
		},
		onDataReady: function (widget) {
            // summary:
            //        商品数据加载完成后的显示
            // view:
            //         matDetailB2B
            // description:
            //         无
            // 隐藏所有的按钮
			widget.hideByFields(["addToPurchaseList", "removeFromPurchaseList","addToPurchase","removeFromPurchase", "waitPurchase", "marketPrice", "hasCommentsArea", "url"]);
            var data = widget.getData();
            if(!data._id) return;
            // 如果设置了市场价 则显示市场价
            if (data.marketPrice) {
            	widget.showByFields(["marketPrice"]);
            }
            if(data.isSupplier==1){
                widget.showByFields(['removeFromPurchase']);
            }else if(data.isSupplier==2){
                widget.showByFields(["addToPurchase"]);
            }else if(data.isSupplier==3){
               widget.showByFields(["waitPurchase"]);
            }
            if(data.isPurchase){
                widget.showByFields(["removeFromPurchaseList"]);
            }
            // 如果有评论
            if(data.hasComments){
                widget.showByFields(["hasCommentsArea"]);
            }
            // 没有评论不显示 查看更多评论
            if (data.commentInfo) {
                widget.showByFields(["url"]);
            }
			// 从商家中查找是否为当前商家的供应商
            /*shopB2B.loadById(shop[1]).then(lang.hitch(this,function(shopData){
                if (shopData && shopData.isSupplier) {
                	// 商家为供应商
                	widget.showByFields(["removeFromPurchase"]);
                	this.exec('loadById', {
                		_id: shop[0]
                	}).then(lang.hitch(this, function (data) {
                			if (data.data && data.data.item && data.data.item.isPurchase) {

                				widget.showByFields(['removeFromPurchaseList']);
                			} else {
                				// 不是自己的供应商：
                				// 不显示加入和删除采购清单，不显示价格。
                				widget.showByFields(['addToPurchaseList']);
                			}

                		}));
                } else if (shopData && shopData.supplierState == 1) {
                	// 正在申请中
                	widget.showByFields(["waitPurchase"]);
                } else {
                	//  不是供应商
                	widget.showByFields(["addToPurchase"]);
                }
            }));
            */
			// 重算高度
			var view = widget.getView();
			if (view) {
				view.resize();
			}
		},
        // 移除供应商处理
        removeFromPurchase:function(data, widget){
            window.busy();
            var shop = widget.cqRefInfo.cqViewParam.params.split("_")[1];
            shopB2B.deleteSupplyBus(shop).then(lang.hitch(this,function(delData){
                window.free();
                if(delData && delData.data && delData.data.ok === 1){
                    widget.cqRefresh();
                }else{
                   alert(delData.msg);
                }
            }));
        },
        // 添加供应商处理
        addToPurchase: function(data, widget){
            window.busy();
            var shop = widget.cqRefInfo.cqViewParam.params.split("_")[1];
            shopB2B.addSupplyerAction(shop).then(lang.hitch(this,function(addData){
                window.free();
                if(addData && addData.data && addData.data.ok === 1){
					widget.cqRefresh();
                }else{
                    alert(addData.data.msg);
                }
            }));
        },
        //  点击商品跳转（供应商独用）
        onSupplyMatClick: function(param,xxx,list){
            if(!list || !list.cqRefInfo || !list.cqRefInfo.cqViewParam) return;
			// 如果商品是B2B2C代销模式，那么跳转到下游查看上游代销商品详情页面，否则跳转下游采购上游商品页面
            window.moveToView(param.enableB2B2C?"matDetailB2B2C":"matDetailB2B",param._id+"_"+list.cqRefInfo.cqViewParam.params);
        },
        //  供应商详情显示
        getSupplyBusProp: function(data){
            //if(){
             var a = data;   
                //retailPrice
        }, 
        getSupplyDtlLayout: function(){
            // summary:
            //        供应商的商品详情(布局)
            // view:
            //         matDetailB2B
            // description:
            //         无
            return [{
				type: 'content',
				content: config.matB2B.detailLayout
			}, {
				type: 'form',
                formClass: "hide",
				fields: this.getFormItems(["addToPurchaseList", "removeFromPurchaseList", "addToPurchase", "removeFromPurchase", "waitPurchase"])
			}];
        },
        waitPurchase:function(){
            // 一个空的方法 用于控制按钮的显示隐藏
        }
        
	});
	var matB2BBo = new MatB2BBo();
	matB2BBo.Bo = MatB2BBo;
	return matB2BBo;
});