/****
 *   创建时间: 2016/1/15
 *   创建人:   干劲
 *   内容
 *       B2B2C商品详情加入和移除代销清单
 */
define([
	"dojo/_base/declare",
	"dojo/_base/array",
	"dojo/_base/lang",
	'dojo/Deferred',
	'cq/util/config/config',
	'./_MatMixin',
	'../BoBase',
	'cq/util/sys/query',
	"bob/shop/shop",
    "bob/shop/shopB2B"
], function (declare, array, lang, Deferred, config,  _MatMixin, BoBase, query, shop, shopB2B) {
	var MatB2B2CBo = declare("", [BoBase.B, _MatMixin], {
		fields: {
			settlePrice: {
                type: "number",
                fixedTo: 2
            },
            diffPrice: {
                type: "number",
                fixedTo: 2
            },
            toDistribute: {
                type: "button",
                label: "我要分销",
                action: "toDistribute"
            },
            offShelves: {
                type: "button",
                label: "下架",
                action: "offShelves"
            },
            onShelves: {
                type: "button",
                label: "上架",
                action: "onShelves"
            },
            mdfGroup: {
                type: "button",
                label: "修改分类",
                action: "mdfGroup"
            }
		},
        getListProp: function(item){
            item.settlePrice = item.settlePrice&&item.settlePrice||item.retailPrice;
            item.diffPrice = item.retailPrice - item.settlePrice;
            return item;
        },
		b2b2cAdd:function(data,widget){
            // summary:
            //        加入产品库
            // view:
            //         matDetailB2B2C
            // description:
            //         无
			window.busy();
			this.exec("b2b2cAdd",{mId:data._id,fromShopId:widget.cqRefInfo.cqViewParam.params.split("_")[1]}).then(lang.hitch(this,function(data){
				window.free();
				if(data&&data.data&&data.data.ok){
					widget.showByFields(['b2b2cRemove']);
					widget.hideByFields(['b2b2cAdd']);
					alert("操作成功");
				}
				else alert("操作失败");
			}));
		},
		b2b2cRemove:function(data,widget){
            // summary:
            //        停止采购
            // view:
            //         matDetailB2B2C
            // description:
            //         无
			window.busy();
			this.exec("b2b2cRemove",{mId:data._id,fromShopId:widget.cqRefInfo.cqViewParam.params.split("_")[1]}).then(lang.hitch(this,function(data){
				window.free();
				if(data&&data.data&&data.data.ok){
					widget.hideByFields(['b2b2cRemove']);
					widget.showByFields(['b2b2cAdd']);
					alert("操作成功");
				}
				else alert("操作失败");
			}));
		},
		getListParamForEdit: function (cqRefInfo) {
            // summary:
            //        单独加载代销商品的条件查询
            // view:
            //      matListD    --分销商品的商品列表
            // description:
            //         无
			var params = {
				shopId: this.getShopId(),
				orderBy: 'createAt',
				isB2B2C:true,
				isUse: true,
				qty: 1,
				preventSelf: true
			};
			// 关键字查询条件
			var value = query.getQueryValue(cqRefInfo.search);
			if (value) {
				params.search = value;
			}
			// 如果传递了商家id则追加
			if (cqRefInfo.cqViewParam && cqRefInfo.cqViewParam.params) {
				params.fromShopId = cqRefInfo.cqViewParam.params;
			}
			// 商品上架查询
			if (cqRefInfo.verifyState && cqRefInfo.verifyState.isUse !== undefined) {
				params.isUse = cqRefInfo.verifyState.isUse;
			}
			// 商品库存查询
			if (cqRefInfo.verifyState && cqRefInfo.verifyState.qty !== undefined) {
				params.qty = cqRefInfo.verifyState.qty;
			}
			// 推荐商品的查询
			if (cqRefInfo.verifyState && cqRefInfo.verifyState.isRecommend !== undefined) {
				params.isRecommend = cqRefInfo.verifyState.isRecommend;
			}
			//新增按sortId查询
			value = query.getQueryValue(cqRefInfo.sortId);
			if (value) {
				params.sortId = value;
			}
			return params;
		},
		loadById: function (param) {
            // summary:
            //        加载指定商品信息
            // view:
            //         matDetailB2B2C
            // description:
            //         
			if (!param.cqViewParam.params) {
				return;
			}
            return this.exec("loadById", {
                _id: param.cqViewParam.params
            }).then(lang.hitch(this, function(result){
                return this.exec('loadById', {
                    _id: param.cqViewParam.params,
                    fromShopId: this.getPlatformShopId()
                }).then(lang.hitch(this, function (data) {
                    var item = data&&data.data&&data.data.item||{};
                    item.hasDis = !!(result&&result.data&&result.data.item);
                    if(item.hasDis){
                        item.isUse = result.data.item.isUse;
                        item.groupId = result.data.item.groupId;
                    }
                    return shop.loadByIdFromPlt(item.fromShopId).then(function(shopItem){
                        item.shopName = shopItem.shopName;
                        return item;
                    });
                }));
            }));
		},
		onDataReady: function (widget) {
            // summary:
            //        商品数据加载完成后的显示
            // view:
            //         matDetailB2B2C
            // description:
            //         无
            // 隐藏所有的按钮
            var data = widget.getData();
            widget.hideByFields(["toDistribute","onShelves","offShelves","mdfGroup","marketPrice"]);
            if(!data._id){
                return;
            }
            if(!data.hasDis){
                widget.showByFields(["toDistribute"]);
            }else{
                widget.showByFields(["mdfGroup"]);
                if(data.isUse){
                    widget.showByFields(["offShelves"]);
                }else{
                    widget.showByFields(["onShelves"]);
                }
            }
            if(data.marketPrice){
                widget.showByFields(["marketPrice"]);
            }
			// 重算高度
			var view = widget.getView();
			if (view) {
				view.resize();
			}
		},
        getSupplyDtlLayout: function(){
            // summary:
            //        供应商的商品详情(布局)
            // view:
            //         matDetailB2B2C
            // description:
            //         无
            return [{
				type: 'content',
				content: config.mat.simpleLayout
			}, {
				type: 'form',
				fields: this.getFormItems(["b2b2cAdd", "b2b2cRemove"])
			}];
        },
        // 分销详情页面跳转
        onListClickForD: function (data) {
			window.moveToView('matDetailD', data._id);
        },
		getDetailLayout: function () {
			// summary:
			//        获得平台商品的Layout
			// view:
			//         searchDisMatDetail   --平台商品的商品内容详情
			// description:
			//         无
			return [{
				type: 'content',
				content: config.matB2B.detailLayout
			},{
                type: "form",
                fields: this.getFormItems(["toDistribute","onShelves","offShelves","mdfGroup"])
            }];
		},
		getListPlatfromParam: function (cqRefInfo) {
            // summary:
            //        加载平台商品的条件查询
            // view:
            //      searchDisMat --平台商品列表页面
            //      matListD    --分销商品的商品列表
            // description:
            //         无
            var params = {
                shopId: this.getShopId(),
                orderBy: 'createAt',
                fromShopId: this.getPlatformShopId(),
                isUse: true,
                preventSelf: true,
                qty: 1
            };
            // 关键字查询条件
            var value = query.getQueryValue(cqRefInfo.search);
            if (value) {
                params.search = value;
            }
            // 如果传递了商家id则追加
            if (cqRefInfo.cqViewParam && cqRefInfo.cqViewParam.params) {
                params.fromShopId = cqRefInfo.cqViewParam.params;
            }
            // 商品上架查询
            if (cqRefInfo.verifyState && cqRefInfo.verifyState.isUse !== undefined) {
                params.isUse = cqRefInfo.verifyState.isUse;
            }
            // 商品库存查询
            if (cqRefInfo.verifyState && cqRefInfo.verifyState.qty !== undefined) {
                params.qty = cqRefInfo.verifyState.qty;
            }
            // 推荐商品的查询
            if (cqRefInfo.verifyState && cqRefInfo.verifyState.isRecommend !== undefined) {
                params.isRecommend = cqRefInfo.verifyState.isRecommend;
            }
            //新增按sortId查询
            value = query.getQueryValue(cqRefInfo.sortId);
            if (value) {
                params.sortId = value;
            }
            return params;
        },
		onListClick: function (item) {
			// summary:
			//        平台商品列表的点击处理
			// view:
			//         searchDisMat --平台商品列表页面
			// description:
			//         无
			window.moveToView('searchDisMatDetail', item._id);
		},
		getListUrl: function () {
            return this.getBaseUrl() + '/loadBySort';
        },
        getListParamBySelf: function(params){
            var p = {
                currentShopId: this.getShopId(),
                shopId: this.getShopId(),
                preventSelf: true,
                isUse: true,
                qty: 1
            };
            if(params.verifyState){
                var state = query.getQueryValue(params.verifyState);
                if(state==1){
                    p.isUse = true;
                    p.qty = 1;
                    p.orderBy = '-createAt';
                }else if(state==2){
                    p.isUse = true;
                    p.qty = 0;
                    p.orderBy = "-lastMod";
                }else if(state==3){
                    p.isUse = false;
                }else{
                    delete p.isUse;
                    delete p.qty;
                }
            }
            if(params.search){
                p.search = params.search;
            }
            return p;
        },
        getListParam: function(params){
            var p = {
                currentShopId: this.getShopId(),
                shopId: this.getPlatformShopId(),
                preventSelf: true,
                isUse: true
            };
            if(params.search){
                p.search = params.search;
            }
            if(params.orderBy){
                p.orderBy = params.orderBy.orderBy;
            }
            if(params.filter){
                p.sortId = JSON.stringify(params.filter["sortId"]);
            }
            return p;
        },
		getEdtPlatformLayout: function () {
            // summary:
            //        加入我的商品库显示列表
            // view:
            //         updateDisMatPic  --更新从平台获得分销商品的销售价页面
            // description:
            //         只更改当前商家数据的内容
            return [{
                type: 'form',
                fields: this.getFormItems([
                    'logo',
                    'mName',
                    'settlePrice',
                    'retailPrice',
                    'addMat',
                ], false)
            }];
        },
		onPlatfromDataReady: function (widget) {
			// summary:
			//        平台商品数据加载完成后
			// view:
			//         updateDisMatPic  --更新从平台获得分销商品的销售价页面
			// description:
			//         无
			widget.disableByFields(['totalSale', 'mName', 'settlePrice']);
		},
		addMat: function (data) {
			// summary:
			//        把商品添加到自己的商品中
			// view:
			//         updateDisMatPic --更新从平台获得分销商品的销售价页面
			// description:
			//         无
			// 如果销售价低于分销价 提示不能保存
			if (data.settlePrice > data.retailPrice) {
				alert("零售价不能低于分销价");
				return;
			}
			window.busy();
			this.exec('copyMat', {
				mId: data._id,
				fromShopId: data.fromShopId._id
			}).then(function (result) {
				if (result && result.data && result.data.ok === 1) {
					window.free();
					history.back();
				} else {
					alert(result&&result.data&&result.data.message||"分销失败");
				}
			});
		},
		getMatDetailDLayout: function () {
			// summary:
			//        商家分销的Layout
			// view:
			//         matDetailD   --分销商品的详细内容
			// description:
			//         无
			return [{
				type: 'content',
				content: config.mat.simpleLayout
			}, {
				type: 'form',
				fields: this.getFormItems(['frameConfirm', 'frameCancel', 'share'])
			}];
		},
		loadPlatfromById: function (params) {
            // summary:
            //        加载商家自己的商品数据
            // view:
            //         matDetailD   --分销商品的详细内容
            // description:
            //         无
            var def = new Deferred();
            var m = params.cqViewParam.params;
            // 初始化fromShopId
            // this.fromShopId = m[1];
            this.exec('loadById', {
                _id: m
            }).then(lang.hitch(this, function (data) {
                // 获取商家的信息
                data = data.data.item;
                data.totalSale = data.totalSale || 0;
                def.resolve(data);
            }));
            return def;
        },
		// 用于处理分销页面的显示处理
		onDataReadyForMatDetailD: function (widget) {
			var data = widget.getData();
			if (!data._id) return;
			widget.hideByFields(["frameConfirm", "frameCancel", "marketPrice"]);
			// 如果设置了市场价 则显示市场价
			if (data.marketPrice) {
				widget.showByFields(["marketPrice"]);
			}
			if (data.isUse) {
				widget.showByFields(["frameCancel"]);
			} else {
				widget.showByFields(["frameConfirm"]);
			}
		},
		onShelves: function (data, widget) {
            // summary:
            //      商家分销的上架操作
            //      判断供货商是否已下架，若已下架则不允许分销商再下架    
            // view:
            //         matDetailD   --分销商品的详细内容
            // description:
            //         无
            window.busy();
            shop.loadById(this.getShopId()).then(lang.hitch(this, function (shopData) {
                if (shopData) {
                    if (shopData.isVerified) {
                        this.exec('updateInfoInCurrentShop', {
                            _id: data._id,
                            isUse: true
                        }).then(function (matData) {
                            if (matData.data && matData.data.ok === 1) {
                                // 刷新当前数据
                                window.free();
                                widget.cqRefresh();
                            } else {
                                window.free();
                                alert('上架失败');
                            }
                        });
                    } else {
                        window.free();
                        alert("商家未认证,不允许上架商品,请尽快完成认证");
                    }
                } else {
                    window.free();
                    alert("没有查找到商家");
                }
            }));

        },
        // 下架商品
        offShelves: function (data, widget) {
            // summary:
            //        商家分销的下架操作
            // view:
            //         matDetailD   --分销商品的详细内容
            // description:
            //         无
            window.busy();
            this.exec('updateInfoInCurrentShop', {
                _id: data._id,
                isUse: false
            }).then(function (matData) {
                if (matData.data && matData.data.ok === 1) {
                    //history.back();
                    // 刷新当前数据
                    window.free();
                    widget.cqRefresh();
                } else {
                    window.free();
                    alert('下架失败');
                }
            });
        },
        // 分销 复制到当前商家数据库
		toDistribute: function (data,widget) {
            window.busy();
            this.exec('copyMat', {
				mId: data._id,
				fromShopId: data.fromShopId
			}).then(function (result) {
				if (result && result.data && result.data.ok === 1) {
					window.free();
                    alert("分销成功");
					history.back();
				} else {
					alert(result&&result.data&&result.data.message||"分销失败");
				}
			});
        },
        mdfGroup: function(data, widget){
            window.busy();
            require([
                "cq/util/edit/jsonRef",
                "bob/mat/group"
            ], lang.hitch(this, function(jsonRef, group){
                window.free();
                jsonRef.startEdit({_id:data.groupId},widget.getView(),{
                    target: group.getGroupUrl(),
                    searchField: "search",
                    labelField: "gName",
                    multiselect: "",
                    query: {isUse: true}
                }).then(lang.hitch(this, function(selectedGroup){
                    window.busy();
                    if(!selectedGroup&&!selectedGroup._id){
                        alert("没有选择品类");
                        window.free();
                    }
                    this.exec("updateInfoInCurrentShop", {
                        groupId: selectedGroup._id,
                        _id: data._id
                    }).then(function(result){
                        window.free();
                        if(result&&result.data&&result.data.ok==1){
                            alert("修改成功");
                        }else{
                            alert(result&&result.data&&result.data.message||"修改失败");
                        }
                    });
                }));
            }));
        }
	});
	var matB2B2CBo = new MatB2B2CBo();
	matB2B2CBo.Bo = MatB2B2CBo;
	return matB2B2CBo;
});