/****
 *   创建时间: 2016/1/13
 *   创建人:   杜飞军
 *   内容
 *       B2B商品的处理：B2B商品添加和删除 商品上架\下架
 */
define([
    'dojo/_base/declare',
    'dojo/_base/array',
    'dojo/_base/lang',
    'dojo/Deferred',
    "bob/shop/shop",
    'cq/util/config/config',
    'cq/util/sys/query',
    './_MatMixin',
    '../BoBase'
], function (declare, array, lang, Deferred, shop, config, query, _MatMixin, BoBase) {
var MatBB2B = declare("", [BoBase.B, _MatMixin], {
        fields: {
            enableB2B2C:{
                type:"checkbox",
                label:"允许代销"
            },
            isB2B2C:{
                type:"checkbox",
                label:"是否代销商品"
            },
            groomMatConfirm: {
                type: 'button',
                label: '推荐商品',
                action: 'onRecommend'
            },
            groomMatCancel: {
                type: 'button',
                label: '取消推荐',
                action: 'offRecommend'
            },
            frameConfirm: {
                type: 'button',
                label: '商品上架',
                action: 'onShelves'
            },
            frameCancel: {
                type: 'button',
                label: '商品下架',
                action: 'offShelves'
            },
            frameConfirmToPlatfrom: {
                type: 'button',
                label: '商品上架',
                action: 'onShelvesToPlatfrom'
            },
            frameCancelToPlatfrom: {
                type: 'button',
                label: '商品下架',
                action: 'offShelvesToPlatfrom'
            },
            onBusinessRegistButton: {
                type: 'button',
                label: '保存',
                action: 'save',
                buttonClass: 'registerButton',
                className: 'fullButton'
            },
            // 用于存放商家等级对应的价格
            prices: {
                type: 'object',
                label: "分级定价",
                action: 'gradePrice',
                canEdit : true,
                fields : {
                    layout: [{
                        field: "1",
                        type: "number",
                        label: "级别1"
                    }, {
                        field: "2",
                        type: "number",
                        label: "级别2"
                    }, {
                        field: "3",
                        type: "number",
                        label: "级别3"
                    }, {
                        field: "4",
                        type: "number",
                        label: "级别4"
                    }, {
                        field: "5",
                        type: "number",
                        label: "级别5"
                    }]
                }
            },
            holdMatToStore: {
                type: 'button',
				label: '保存并放入仓库',
				action: 'holdMatToStore'
            }
        },
        
        onListClick: function (item) {
			// summary:
			//        商品列表点击
			// view:
			//         matListB --商家端商品列表页面
			// description:
			//         无
			window.moveToView(this.listViewID, item._id + '_' + item.fromShopId);
		},
        loadById: function (params) {
            // summary:
            //        加载指定商品信息
            // view:
            //      mat --商品录入修改页面
            //      matDetailB  --商家端商品内容详情
            //      searchDisMatDetail  --平台商品的商品内容详情
            //      updateDisMatPic     --更新从平台获得分销商品的销售价页面
            // description:
            //         无
            if (!params.cqViewParam.params) {
                return;
            }
            var def = new Deferred();
            var m = params.cqViewParam.params.split('_');
            // 初始化fromShopId
            this.fromShopId = m[1];
            this.exec('loadById', {
                _id: m[0],
                fromShopId: m[1]
            }).then(lang.hitch(this, function (data) {
                // 获取商家的信息
                data = data.data.item;
                data.totalSale = data.totalSale||0;
                // 如果prices有数据 处理下数据方式
                if (data.prices && data.prices.length) {
                    var pricesData = {};
                    array.forEach(data.prices, function (item) {
                        pricesData[item.level] = item.price;
                    });
                    data.prices = pricesData;
                }
                def.resolve(data);
            }));
            return def;
        },
        getItemProp: function(item){
            item.totalSale = item.totalSale||0;
            return item;
        },
        onDataChange:function(widget, field, value){
            // 判断数据改变的键值是否为允许代销
            if (field === "enableB2B2C") {
                if (value) {
                    widget.showByFields(['settlePrice']);
                } else {
                    widget.hideByFields(['settlePrice']);
                }
            }
        },
        getEdtLayoutForApp: function () {
            // summary:
            //        App端编辑商品的Layout
            // view:
            //         matBB2B  --商品录入修改页面
            // description:
            //         无
            return [{
                type: 'form',
                fields: this.getFormItems([
                    'images',
                    'code',
                    'mName',
                    'groupId',
                    'sortId',
                    'sizeType',
                    'retailPrice',
                    'marketPrice',
                    "enableB2B2C",
                    'settlePrice',
                    'freightTplId',
                    'freight',
                    'qty',
                    'minQty',
                    //'totalSale',
                    'prices',
                    'content',
                    'onBusinessRegistButton'
                ], true)
            }];
        },
        onDataReady: function (widget) {
            // summary:zjp
            //        编辑商品数据完成后
            // view:
            //         mat  --商品录入修改页面
            // description:
            //         无
            var data = widget.getData();
            // widget.disableByFields(['totalSale']);
            // 如果允许代销为true就显示 否则隐藏
            if (data.enableB2B2C) {
                widget.showByFields(['settlePrice']);
            } else {
                widget.hideByFields(['settlePrice']);
            }
        },
        getSupplyDtlLayout: function () {
            // summary:
            //        供应商的商品详情(布局)
            // view:
            //         matDetailB2B
            // description:
            //         无
            return [{
                    type: 'content',
                    content: config.mat.simpleLayout
                }, {
                    type: 'form',
                    fields: this.getFormItems([])
                }
            ];
        },
        gradePrice:function(){
            console.log(1)
        },
        getPlatfromListUrlForB: function () {
            // summary:
            //        商品列表的数据加载 数据来自于
            // view:
            //         matListB --商家端商品列表页面
            // description:
            //         无
            return this.getBaseUrl() + '/loadOneFromShopId';
        },

        getListParam: function (cqRefInfo) {
            // summary:
            //        加载商品列表的查询条件
            // view:
            //         matListB --商家端商品列表页面
            // description:
            //         无
            var params = {
                shopId: this.getShopId(),
                orderBy: 'createAt',
                fromShopId: this.getShopId(),
                isUse: true,
                qty: 1
            };
            // 如果传递了商家id则追加
            if (cqRefInfo.cqViewParam && cqRefInfo.cqViewParam.params) {
                params.fromShopId = cqRefInfo.cqViewParam.params;
            }
            // 商品库存查询
            if (cqRefInfo.verifyState && cqRefInfo.verifyState.qty !== undefined) {
                params.qty = cqRefInfo.verifyState.qty;
            }
            // 推荐商品的查询
            if (cqRefInfo.verifyState && cqRefInfo.verifyState.isRecommend !== undefined) {
                params.isRecommend = cqRefInfo.verifyState.isRecommend;
            }
            // 商品上架查询
            if (cqRefInfo.verifyState && cqRefInfo.verifyState.isUse !== undefined) {
                params.isUse = cqRefInfo.verifyState.isUse;
                // 如果查询下架商品 移除库存条件
                if (!params.isUse) {
                    delete params.qty;
                }
            }
            //新增按sortId查询
            value = query.getQueryValue(cqRefInfo.sortId);
            if (value) {
                params.sortId = value;
            }
            // 关键字查询条件
            var value = query.getQueryValue(cqRefInfo.search);
            if (value) {
                params.search = value;
            }
            return params;
        },
        // 后面需要优化程序 应该和matC差不多
        // 保存商品
        save: function (data, widget) {
            // summary:
            //        App端编辑商品的保存操作
            // view:
            //         mat  --商品录入修改页面
            // description:
            //         无
             // 检测是否上传了图片 
            if (!data.images.length){
                alert("请上传图片");
                return;
            }
            var msg = this.getDataValidMsg(data, ['images', 'mName','sortId', 'sizeType', 'retailPrice', 'qty', 'content']);
            if (msg) {
                alert(msg);
                return;
            }
            if (data.images.length) {
                data.logo = data.images[0];
            }
            // 设置是否销售为false这个是用于b2b的
            data.isPurchase = false;
            // 检测是否设置了分销
            if(data.enableB2B2C){
                // 检查是否设置了分销价格
                if(!data.settlePrice){
                    alert("请输入代销价");
                    return;
                }
                // 检测分销价格是否大于销售价
                else if(Number(data.settlePrice) > Number(data.retailPrice)){
                    alert("代销价不能大于销售价");
                    return;
                }
            }
            // 把分级定价转回后台需要的数据
            var prices = [];
            array.forEach(new Array(5), function (i, index) {
                index = index + 1;
                if (data.prices[index] > 0) {
                    prices.push({
                        level: index,
                        price: data.prices[index] - 0
                    });
                }
            });
            data.prices = prices;
            // 若果库存填的0 则提示不能上架
            if (!data.qty || data.qty == 0) {
                alert("库存为0不能上架");
                return;
            }
            window.busy();
            // 获得商家的认证状态
            shop.loadById(this.getShopId()).then(lang.hitch(this, function (shopData) {
            		if (shopData) {
            			if (shopData.isVerified) {
            				// 商家已经认证
            				this.exec('save', data).then(lang.hitch(this, function (matData) {
            						if (matData.data && matData.data.ok === 1) {
            							// 检测获得的数据是否有_id
            							if (data._id) {
                                            window.free();
            								history.back();
            							} else {
            								// 没有_id进行上架处理
            								this.onShelvesSend(matData).then(function (shelfData) {
                                                window.free();
            									history.back();
            									/*if(shelfData && shelfData.data && shelfData.data.ok === 1){

            									}else{
            									//alert("上架失败");
            									history.back();
            									}*/
            								});
            							}
            						} else {
                                        window,free();
            							alert(matData && matData.data && matData.data.message || "保存失败");
            						}
            					}));
            			} else {
                            window,free();
                            alert("商家未认证,不允许上架商品,请尽快完成认证");
                        }
            		} else {
                        window,free();
            			alert("没有查找到商家");
            		}
            	}));
        },
        // 保存并放入仓库
        holdMatToStore: function (data, widget) {
            // 检测是否上传了图片 
            if (!data.images.length){
                alert("请上传图片");
                return;
            }
            var msg = this.getDataValidMsg(data, ['images', 'mName','sortId', 'sizeType', 'retailPrice', 'qty', 'content']);
            if (msg) {
                alert(msg);
                return;
            }
            if (data.images.length) {
                data.logo = data.images[0];
            }
            // 设置是否销售为false这个是用于b2b的
            data.isPurchase = false;
            // 检测是否设置了分销
            if(data.enableB2B2C){
                // 检查是否设置了分销价格
                if(!data.settlePrice){
                    alert("请输入代销价");
                    return;
                }
                // 检测分销价格是否大于销售价
                else if(Number(data.settlePrice) > Number(data.retailPrice)){
                    alert("代销价不能大于销售价");
                    return;
                }
            }
            window.busy();
            // 把分级定价转回后台需要的数据
            var prices = [];
            array.forEach(new Array(5), function (i, index) {
                index = index + 1;
                if (data.prices[index] > 0) {
                    prices.push({
                        level: index,
                        price: data.prices[index] - 0
                    });
                }
            });
            data.prices = prices;
            // 设置成不上架
            data.isUse = false;
            this.exec('save', data).then(lang.hitch(this, function (matData) {
            		if (matData.data && matData.data.ok === 1) {
            			// 检测获得的数据是否有_id
            			if (data._id) {
                            window.free();
            				history.back();
            			} else {
            				// 没有_id进行上架处理
            				this.onShelvesSend(matData).then(function (shelfData) {
                                window.free();
            					history.back();
            					/*if(shelfData && shelfData.data && shelfData.data.ok === 1){

            					}else{
            					//alert("上架失败");
            					history.back();
            					}*/
            				});
            			}
            		} else {
                        window.free();
            			alert(matData && matData.data && matData.data.message || "保存失败");
            		}
            	}));
        },
        getMatDetailBB2BLayout: function () {
            // summary:
            //        商品详情的Layout
            // view:
            //         matDetailB   --商家端商品内容详情
            // description:
            //         无
            return [{
                    type: 'content',
                    content: config.mat.simpleLayout
                }, {
                    type: 'form',
                    fields: this.getFormItems(['frameConfirmToPlatfrom', 'frameCancelToPlatfrom', 'share'])
                }
            ];
        },
        onDataReadyForMatBB2B: function (widget) {
            // summary:
            //        商品详情数据加载完成后页面元素的显示
            // view:
            //      matDetailB  --商家端商品内容详情
            //      searchDisMatDetail  --平台商品的商品内容详情
            //      matDetailD  -- 分销商品的详细内容
            // description:
            //         无
            var data = widget.getData();
            widget.hideByFields(["frameCancelToPlatfrom", "frameConfirmToPlatfrom", "marketPrice"]);
            // 如果设置了市场价 则显示市场价
            if (data.marketPrice) {
                widget.showByFields(["marketPrice"]);
            }
            // if (data.isRecommend) {
                // widget.showByFields(["groomMatCancel"]);
            // } else {
                // widget.showByFields(["groomMatConfirm"]);
            // }
            // if (data.isUse) {
                // widget.showByFields(["frameCancel"]);
            // } else {
                // widget.showByFields(["frameConfirm"]);
            // }
            if (data.isUse) {
                widget.showByFields(["frameCancelToPlatfrom"]);
            } else {
                widget.showByFields(["frameConfirmToPlatfrom"]);
            }
        },
        // 编辑列表跳转ID
        editViewID: 'matBB2B',
        // 查询列表点击跳转ID
        listViewID: 'matDetailBB2B',
        // 用于提供上架商品接口
        onShelvesSend: function (data) {
            return this.exec('onShelvesToPlatfrom', {
                mId: data._id
            });
        },
        onShelvesToPlatfrom: function (data, widget) {
            // summary:
            //        上架商品 并同步平台
            // view:
            //         matDetailB   --商家端商品内容详情
            // description:
            //         无
            if (data.qty === 0 || !data.qty) {
                alert("没有库存不能上架");
                return;
            }
            window.busy();
            shop.loadById(this.getShopId()).then(lang.hitch(this, function (shopData) {
            		if (shopData) {
            			if (shopData.isVerified) {
            				this.onShelvesSend(data).then(function (matData) {
            					if (matData.data && matData.data.ok === 1) {
            						//history.back();
            						// 刷新当前数据
                                    window.free();
            						widget.cqRefresh();
            					} else {
            						alert('上架失败');
            					}
            				});
            			} else {
                            window.free();
            				alert("商家未认证,不允许上架商品,请尽快完成认证");
            			}
            		} else {
                        window.free();
            			alert("没有查找到商家");
            		}
            	}));  
        },
        offShelvesToPlatfrom: function (data, widget) {
            // summary:
            //        下架商品 并同步平台
            // view:
            //         matDetailB   --商家端商品内容详情
            // description:
            //         无
            if (data.qty === 0 || !data.qty) {
                alert("没有库存不能上架");
                return;
            }
            window.busy();
            this.exec('offShelvesToPlatfrom', {
                mId: data._id
            }).then(function (matData) {
                if (matData.data && matData.data.ok === 1) {
                    //history.back();
                    // 刷新当前数据
                    window.free();
                    widget.cqRefresh();
                } else {
                    window.free();
                    alert('下架失败');
                }
            });
        },
        onRecommend: function (data, widget) {
            // summary:
            //        推荐商品的操作
            // view:
            //         matDetailB   --商家端商品内容详情
            // description:
            //         无
            window.busy();
            this.exec('rec_mat', {
                isRecommend: true,
                _id: data._id
            }).then(lang.hitch(this, function (result) {
                if (result && result.data && result.data.ok === 1) {
                    //this.tabGroom(data.data.item, layoutWidget);
                    // 刷新当前数据
                    window.free();
                    widget.cqRefresh();
                } else {
                    window.free();
                    alert('推荐失败');
                }
            }));
        },
        offRecommend: function (data, widget) {
            // summary:
            //        取消推荐
            // view:
            //         matDetailB   --商家端商品内容详情
            // description:
            //         无
            window.busy();
            this.exec('rec_mat', {
                isRecommend: false,
                _id: data._id
            }).then(lang.hitch(this, function (result) {
                if (result && result.data && result.data.ok === 1) {
                    //this.tabGroom(data.data.item, layoutWidget);
                    // 刷新当前数据
                    window.free();
                    widget.cqRefresh();
                } else {
                    window.free();
                    alert('取消推荐失败');
                }
            }));
        },
    });
	var matBB2B = new MatBB2B();
	matBB2B.Bo = MatBB2B;
	return matBB2B;
});
