/****
 *   创建时间: 2016/12/20
 *   创建人:   杜飞军
 *   内容
 *       提供消费者端使用的方法
 */
define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/lang",
    'dojo/Deferred',
    "dojo/DeferredList",
    "dojo/query",
    "dojo/dom-attr",
    'dojo/dom-class',
    'dojo/dom-construct',
    'dijit/registry',
    'cq/util/config/config',
    'bob/user/matStore',
    'bob/user/consumer',
    './_MatMixin',
    '../BoBase',
    'cq/util/sys/query',
    "cq/util/sys/date",
    "cq/widgets/bigImg",
    "bob/shop/shopC",
    "bob/article/ss/comment/c",
    "bob/mk/reward/c",
    "bob/mk/limitDiscount/c",
    "bob/ts/cart",
    "bob/mk/preSale/c",
    "bob/shop/store/c",
    "bob/mk/pacBuy/c",
    "bob/mk/pacBuy/team/c"
], function (declare, array, lang, Deferred, DeferredList, domQuery, domAttr, domClass, domConstruct, registry, config, matStore,consumer,
_MatMixin, BoBase, query, date, bigImg, shop, comment, reward, limitDiscount, cart, preSale, store,pacBuy, team) {
    var MatCBo = declare("", [BoBase.C, _MatMixin], {
        fields: {
            favoritesConfirm: {
                type: 'button',
                label: '收藏商品',
                action: 'collectionMat'
            },
            favoritesCancel: {
                type: 'button',
                label: '取消收藏',
                action: 'cancelCollectionMat'
            },
            buyImmediately: {
                type: 'button',
                label: '立即购买',
                action: 'buyNow'
            },
            addToOrderCar: {
                type: 'button',
                label: '加入购物车',
                action: 'addToOrderCar'
            },
            onShelfAlarm: {
                type: "button",
                label: "即将上架",
                action: "onShelfAlarm",
                className: "on-shelf-text"
            },
            matSellOut: {
                type: 'button',
                label: '已售罄',
                action: 'noOperation',
                className: "sale-out-txt"
            },
            matOffShelves: {
                type: 'button',
                label: '已下架',
                action: 'noMatOperation',
                className: "sale-out-txt"
            },
            deleted: {
                type: "button",
                label: "已删除",
                action: "deleted",
                className: "sale-out-txt"
            },
            addToOrderCar1: {
                type: 'button',
                label: '加入购物车',
                action: 'addToOrderCar1'
            },
            buyNow1: {
                type: 'button',
                label: '立即购买',
                action: 'buyNow1'
            },
            getDiscount: {
                type: 'button',
                label: "领券",
                action: "getDiscount"
            },
            shopName: {
                type: "text",
                label: "店铺"
            },
            svcClick: {
                type: "button",
                action: "onSvcClick"
            },
            share: {
                type: 'button',
                label: '分享',
                action: 'share'
            },
            "commentNum": {
                type: "text"
            },
            scoreAvg: {
                type: "text"
            },
            "commentInfo.userId.logo": {
                type: "text"
            },
            "commentInfo.userId.nickName": {
                type: "text"
            },
            "commentInfo.content": {
                type: "text"
            },
            "farmer.pName": {
                type: "text"
            },
            specsfiled:{
                type: "button",
                action: "specsfiled"
            },
            shopIsVerified: {
                type: "options",
                options: {
                    "true": "已认证",
                    "false": "未认证"
                }
            },
            hasCommentsArea: {
                type: "button",
                action: "hasComments"
            },
            hasComments: {
                type: "text"
            },
            getAutState: {
                type: "button",
                action: "getAutState"
            },
            // 促销内容
            rewardTxt: {
                type: "text"
            },
            retailPrice: {
                label: '销售价',
                type: 'text',
                placeHolder: '必填',
                notNull: true
            },
            pacPic: {
                type: "number",
                fixedTo: 2
            },
            pacRealPic: {
                type: "number",
                fixedTo: 2
            },
            // fw规格显示
            specs: {
                type: "text"
            },
            "preSaleT,preSaleEd": {
                type: "text"
            },
            currentPic: {
                type: "number",
                fixedTo: 2
            },
            finalPayment: {
                type: "text"
            },
            hasStores: {
                type: "options",
                options: {
                    "true": "线下门店",
                    "false": "暂无"
                }
            },
            hasStores1: {
                type: "options",
                options: {
                    "true": "线下门店",
                    "false": "暂无"
                }
            },
            pacBuyNow: {
                type: "button",
                action: "pacBuyNow"
            },
            pacNewTeam: {
                type: "button",
                action: "pacNewTeam"
            }
        },
        // 获得商品收藏的列表
        getCollectListUrl: function () {
            return this.getBaseUrl() + '/loadRecMat';
        },
        getDtlLayout: function () {
            // summary:
            //        商品详情的Layout
            // view:
            //         matDetail
            // description:
            //         无
            return [{
                type: 'content',
                content: config.mat.detailLayout
            }, {
                type: 'form',
                formClass: "hide",
                fields: this.getFormItems(['svcClick', 'favoritesConfirm', 'favoritesCancel', "onShelfAlarm","deleted", 'matSellOut',
                'matOffShelves', 'buyImmediately',  'addToOrderCar1', 'addToOrderCar', 'buyNow1', 'buyNow', "preSaleT,preSaleEd",
                "pacBuyNow", "pacNewTeam"])
            }];
        },
        // 网页端fw的样式获取
        getDtlLayoutForFw: function () {
            return [{
                type: 'content',
                contents: [config.mat.detailLayout]
            }];
        },
        getListParamForSf: function(cqRefInfo){
            var param = {
                shopId: this.getShopId(),
                isUse: true,
                isSf: true,
                //添加按销量倒叙排序
                orderBy: "-expectShelfDate",
                qty: 1
            };
            if(cqRefInfo&&cqRefInfo.verifyState) {
                if(cqRefInfo.verifyState._id==1){
                    param.isUse = true;
                }else{
                    param.isUse = false;
                    param.expectShelfDate = "greater";
                    param.orderBy = "expectShelfDate";
                }
            }
            var value = query.getQueryValue(cqRefInfo.search);
            if (value) {
                // 设置的查询编码转回
                param.search = window.decodeURIComponent(value);
            }
            return param;
        },
        getRecommendListParamForSf:function(cqRefInfo){
            var query = {
                orderBy:"-recommendTime",
                isRecommend:true,
                pageSize:4
            };
            /*// 关键字查询条件
            var value = query.getQueryValue(cqRefInfo.search);
            if (value) {
                // 设置的查询编码转回
                params.search = window.decodeURIComponent(value);
            }*/
            return query;
        },
        getListParamFromshopId: function(cqRefInfo){
            var data = cqRefInfo.matData;
            var query = {
                shopId: data.fromShopId,
                isUse: true,
                qty: 1,
                orderBy: "-totalSale",
                pageSize: 4
            };
            if(!data._id){
                return;
            }
            return query;
        },
        getListParam: function (cqRefInfo) {
            // summary:
            //        加载商品列表的条件
            // view:
            //         matList
            // description:
            //         无
            var params = {
                shopId: this.getShopId(),
                isUse: true,
                //qty: 1,
                // 默认按照平均评价和销量组合加载
                // 20170217 刘轩
                orderBy: "-gScore"
            };
            // 按照销量/价格 排序
            if (cqRefInfo.verifyState && cqRefInfo.verifyState.orderBy) {
                params.orderBy = cqRefInfo.verifyState.orderBy;
            }
            // 传递的路由处理
            if (cqRefInfo.cqViewParam && cqRefInfo.cqViewParam.params) {
                var cqParam = cqRefInfo.cqViewParam.params.split(',');
                var list = '';
                array.forEach(cqParam, function (item) {
                    list = item.split('_');
                    if (list[0] === 'sort') {
                        params.sortId = list[1];
                    } else if (list[0] === 'group') {
                        params.groupId = list[1];
                    } else if (list[0] === 'shop') {
                        params.fromShopId = list[1];
                    } else if (list[0] === 'search') {
                        params.search = list[1];
                    }
                });
            }
            if(cqRefInfo.filter){
                for(var i in cqRefInfo.filter){
                    params[i] = JSON.stringify(cqRefInfo.filter[i]);
                }
            }
            if(cqRefInfo.sort){
                if(cqRefInfo.sort._id!=0){
                    params.sortId = cqRefInfo.sort._id;
                }else{
                    delete params.sortId;
                }
            }
            if(cqRefInfo.group){
                if(cqRefInfo.group._id!=0){
                    params.groupId = cqRefInfo.group._id;
                }else{
                    delete params.groupId;
                }
            }
            // 关键字查询条件
            var value = query.getQueryValue(cqRefInfo.search);
            if (value) {
                // 设置的查询编码转回
                params.search = window.decodeURIComponent(value);
            }
            return params;
        },
        //消费者端加载农户所有商品列表的url
        getListUrlByFarmer:function(){
            return this.getBaseUrl() + '/loadByFarmerId';
        },
        //消费者端加载农户的所有商品列表的
        getListParamByFarmer:function(cqRefInfo){
            var params = {};
            if(cqRefInfo.cqViewParam&&cqRefInfo.cqViewParam.params){
                params = {
                    shopId: this.getShopId(),
                    farmer: cqRefInfo.cqViewParam.params
                };
            }
            return params;
        },
        // 加载指定商家商品列表的条件
        getBusDtailListParam: function (cqRefInfo) {
            var params = {
                isUse: true//,
                //qty: 1
            };
            if (cqRefInfo.cqViewParam && cqRefInfo.cqViewParam.params) {
                params.shopId = cqRefInfo.cqViewParam.params;
            }
            // 关键字查询条件
            var value = query.getQueryValue(cqRefInfo.search);
            if (value) {
                // 设置的查询编码转回
                params.search = window.decodeURIComponent(value);
            }
            // 如果设置了排序条件 
            if (cqRefInfo.query && cqRefInfo.query.orderBy) {
                params.orderBy = cqRefInfo.query.orderBy;
            }
            // 按照销量/价格 排序
            return params;
        },
        getOpBusDtailListParam: function (cqRefInfo) {
            var params = {
                isUse: true,
                //qty: 1,
                // 按照综合得分排序
                orderBy: "-gScore"
            };
            if (cqRefInfo.cqViewParam && cqRefInfo.cqViewParam.params) {
                params.fromShopId = cqRefInfo.cqViewParam.params;
            }
            // 关键字查询条件
            var value = query.getQueryValue(cqRefInfo.search);
            if (value) {
                // 设置的查询编码转回
                params.search = window.decodeURIComponent(value);
            }
            // 如果设置了排序条件 
            if (cqRefInfo.query && cqRefInfo.query.orderBy) {
                params.orderBy = cqRefInfo.query.orderBy;
            }
            // 按照销量/价格 排序
            return params;
        },
        collectionMat: function (mData, layoutWidget) {
            // summary:
            //        收藏
            // view:
            //         matDetail
            // description:
            //         无

            // 如果没有商品
            if (!mData._id) {
                alert("没有商品");
                return;
            }
            
            matStore.matStore({
                mId: mData._id,
                retailPrice:mData.realPrice
            }).then(lang.hitch(this, function (data) {
                if (data && data.data && data.data.ok === 1) {
                    layoutWidget.cqRefresh();
                } else {
                    alert('添加收藏失败');
                }
            }));
        },
        cancelCollectionMat: function (mData, layoutWidget) {
            // summary:
            //        取消收藏
            // view:
            //         matDetail
            // description:
            //         无

            // 如果没有商品
            if (!mData._id) {
                alert("没有商品");
                return;
            }
            matStore.matStoreCancel({
                mId: mData._id
            }).then(lang.hitch(this, function (data) {
                if (data && data.data && data.data.ok === 1) {
                    // 刷新当前数据
                    layoutWidget.cqRefresh();
                } else {
                    alert('取消收藏失败');
                }
            }));
        },
        addToOrderCar: function (data, widget) {
            // summary:
            //        加入购物车
            // view:
            //         matDetail
            // description:
            //         无
            require(["whz/util/matDispose"], function(matDispose){
                matDispose.getAction(data,"addTo"); 
            });
        },
        pacBuyNow: function(data, widget){
            require(["whz/util/matDispose"], function(matDispose){
                matDispose.getAction(data,"buyNow");
            });
        },
        pacNewTeam: function(data, widget){
            require(["whz/util/pacMatDispose"], function(matDispose){
                matDispose.getAction(data,"newTeam");
            });
        },
        buyNow: function (data, widget) {
            // summary:
            //        立即购买
            // view:
            //         matDetail
            // description:
            //         无
            require(["whz/util/matDispose"], function(matDispose){
                matDispose.getAction(data,"buyNow");
            });
        },
        specsfiled: function (data, widget) {
            this.buyNow(data, widget);
        },
        //联系客服操作
        onSvcClick: function (data) {
            // summary:
            //        联系客服页面跳转
            // view:
            //         matDetail
            // description:
            //         无
            window.busy();
            require(["bob/im/msgP/c"],function(msgP){
                msgP.toShopSvc(data.fromShopId);
            });
        },
        _loadOthers: function(mid, fromShopId){
            return new DeferredList([
                reward.loadByMat({
                    mid: mid,
                    fromShopId: fromShopId
                }),
                matStore.checkMatStore({
                    mId: mid
                }),
                shop.loadByIdFromPlt(fromShopId),
                comment.loadNewOneByMat({
                    _id: mid,
                    fromShopId: fromShopId
                }),
                store.loadOne({
                    fromShopId: fromShopId
                }),
                team.loadOneByMid({
                    fromShopId: fromShopId,
                    mId: mid
                })
            ]).then(function(result){
                var rewardItem = result[0][1]||{};//.data&&result[0][1].data.item
                var commentItem = result[3][1].data&&result[3][1].data.item||{};
                var pacTeamItem = result[5][1].data&&result[5][1].data.item||{};
                if(pacTeamItem._id){
                    pacTeamItem.pacTeamUrl = pacTeamItem._id+","+pacTeamItem.fromShopId;
                    if(!pacTeamItem.leader){
                        pacTeamItem.leader = {};
                    }
                    if(!pacTeamItem.leader.logo){
                        pacTeamItem.leader.logo = config.defultUserLogo;
                    }
                    if(!pacTeamItem.leader.nickName){
                        pacTeamItem.leader.nickName = "**";
                    }
                }
                if(commentItem.userId){
                    commentItem.userId.logo = commentItem.userId.logo || config.defultUserLogo;
                    commentItem.userId.nickName = commentItem.userId.nickName || "无名氏";
                }
                var obj = {
                    rewardTxt: rewardItem._id?rewardItem.title+",满"+rewardItem.amount+"元包邮":"",
                    collect: result[1][1] && result[1][1].data && result[1][1].data.ok === 1?result[1][1].data.attion:false,
                    shopName: result[2][1].shopName || "",
                    __svcId: result[2][1].svcId && result[2][1].svcId._id,
                    shopIsVerified: result[2][1].isVerified,
                    hasComments: result[3][1].data && result[3][1].data.item?true:false,
                    commentInfo: commentItem,
                    hasStores: result[4][1].data && result[4][1].data.ok === 1?true:false,
                    hasStores1: result[4][1].data && result[4][1].data.ok === 1?true:false,
                    pacTeamItem: pacTeamItem,
                    hasTeams: result[5][1].data && result[5][1].data.ok === 1?true:false
                };
                return obj;
            });
        },
        _loadById: function(mid){
            // summary:
            //        加载指定商品信息
            // view:
            //         matDetail
            // description:
            //         无
            var def = new Deferred();
            this.exec("consumerLoadMat", {
                _id: mid
            }).then(lang.hitch(this, function(data){
                var item = data&&data.data&&data.data.item||{};
                if(!item._id){
                    alert("数据加载失败");
                    return;
                }
                this._loadOthers(mid, item.fromShopId).then(lang.hitch(this, function(obj){
                    if(item.fromShopId!=this.getShopId()){
                        this.exec("consumerLoadMat", {
                            _id: mid,
                            fromShopId: item.fromShopId
                        }).then(function(data2){
                            var fromItem = data2&&data2.data&&data2.data.item||{};
                            if(!fromItem._id){
                                alert("数据加载失败");
                            }
                            fromItem.isUse = item.isUse==false?false:fromItem.isUse;
                            def.resolve({item: fromItem, obj: obj});
                        });
                    }else{
                        def.resolve({item: item, obj: obj});
                    }
                }));
            }));
            return def.then(function(data){
                var item = data.item;
                var obj = data.obj;
                for(var field in obj){
                    item[field] = obj[field];
                }
                if(item.pacTeamItem&&item.pacTeamItem._id){
                    item.limitTime = item.pacTeamItem.limitTime;
                    item.limitTitle = "剩";
                    item.pacTeamItem.remainNum = Number(item.pacTeamItem.pacId.pacNum) - Number(item.pacTeamItem.inNum);
                }
                if(item.freightTplId&&item.freightTplId._id){
                    var freightTplId = item.freightTplId;
                    // 如果有运费模板 从运费模板中获取 否则是商品中的运费
                    item.freight = freightTplId.minFee;
                }
                item.pacTeamUrl = item._id+","+item.fromShopId;
                item.preMarketPrice = item.marketPrice;
                item.url = item._id+"_"+item.fromShopId;
                return item;
            });
        },
        loadByIdWithAct: function(param){
            var mId = param&&param.cqViewParam&&param.cqViewParam.params||param||"";
            if (!mId) {
                return;
            }
            return this._loadById(mId).then(lang.hitch(this, function(item){
                // 有可能取到多行数据
                var limitDiscountItem = item.limitDiscount||[], 
                    findedLimitDis = null,
                    now = date.nowISOString(),
                    preSaleItem = item.preSale||[],
                    findedPreSale = null,
                    pacBuyItem = item.pacBuy||[],
                    findedPacBuy = null;
                // 查找限时抢购活动
                for(var i=0;i<limitDiscountItem.length;i++){
                    if(limitDiscountItem[i].ed<now){
                        continue;
                    }
                    if(!findedLimitDis||findedLimitDis.sd>limitDiscountItem[i].sd){
                        findedLimitDis = limitDiscountItem[i];
                    }
                }
                // 查找商品的预售活动
                for(var i=0;i<preSaleItem.length;i++){
                    // 找到正在进行的预售活动
                    if(preSaleItem[i].sd<=now&&preSaleItem[i].ed>=now){
                        findedPreSale = preSaleItem[i];
                        item.preSaleEd = findedPreSale.ed;
                        item.preSaleT = "距离结束还剩";
                        break;
                    }
                }
                // 查找拼团活动
                for(var i=0;i<pacBuyItem.length;i++){
                    // 查找当前正在进行的拼团活动
                    if(pacBuyItem[i].sd<=now&&pacBuyItem[i].ed>=now){
                        findedPacBuy = pacBuyItem[i];
                        item.pacBuyEd = findedPacBuy.ed;
                        item.pacBuyT = "剩";
                        item.pacBuyId = findedPacBuy.pacBuyId;
                        break;
                    }
                }
                // 如果有正在进行的预售活动 则不再处理抢购
                if(findedPreSale&&findedPreSale.preSaleId){
                    // 加载活动信息
                    return preSale.loadById(findedPreSale.preSaleId).then(lang.hitch(this, function(preSaleData){
                        // 修改商品信息
                        var pItem = preSaleData&&preSaleData.data&&preSaleData.data.item||{};
                        if(pItem._id){
                            item.isPreSale = true;
                            item.earnest = pItem.earnest;
                            item.payEarNum = pItem.payEarNum;
                            // 查找当前价格
                            if(pItem.ladders&&pItem.ladders.length>0){
                                // 有阶梯
                                for(var i=0;i<pItem.ladders.length;i++){
                                    if(item.payEarNum>=pItem.ladders[i].qtyFrom&&item.payEarNum<=(pItem.ladders[i].qtyTo||item.payEarNum+1)){
                                        item.currentPic = pItem.ladders[i].finalPayment+item.earnest;
                                        item.currentRate = window.fixedTo((pItem.ladders[i].finalPayment+item.earnest)/item.retailPrice*100,3)+"%";
                                        break;
                                    }
                                }
                                // finalPayment
                                var finalPayment = "";
                                for(var i=0;i<pItem.ladders.length;i++){
                                    if(item.payEarNum>=pItem.ladders[i].qtyFrom&&item.payEarNum<=(pItem.ladders[i].qtyTo||item.payEarNum+1)){
                                        finalPayment += "<div class='hflex selected' style='color: rgb(190, 47, 40);font-size: 16px;margin-bottom: 5px;'><div class='flex1'>累计预定"+pItem.ladders[i].qtyFrom+"份"+(pItem.ladders[i].qtyTo?("~"+pItem.ladders[i].qtyTo+"份"):"以上")+"</div><div>尾款¥"+pItem.ladders[i].finalPayment+"</div></div>";
                                    }else{
                                        finalPayment += "<div class='hflex' style='margin-bottom:5px;'><div class='flex1'>累计预定"+pItem.ladders[i].qtyFrom+"份"+(pItem.ladders[i].qtyTo?("~"+pItem.ladders[i].qtyTo+"份"):"以上")+"</div><div>尾款¥"+pItem.ladders[i].finalPayment+"</div></div>";
                                    }
                                }
                                item.finalPayment = finalPayment;
                            }else{
                                // 无阶梯
                                item.currentPic = pItem.finalPayment+item.earnest;
                                item.currentRate = window.fixedTo((pItem.finalPayment+item.earnest)/item.retailPrice*100,3)+"%";
                                item.finalPayment = "<div class='hflex' style='color: rgb(190, 47, 40);font-size: 16px;margin-bottom: 5px;'><div class='flex1'>累计预定0份以上</div><div>尾款¥"+window.fixedTo(pItem.finalPayment,3)+"</div></div>";
                            }
                        }
                        return item;
                    }));
                }
                // 查询当前商品是否有拼团
                else if(findedPacBuy&&findedPacBuy.pacBuyId){
                    return pacBuy.loadFromShopById({
                        _id: findedPacBuy.pacBuyId,
                        fromShopId: item.fromShopId
                    }).then(function(pacBuyData){
                        pacBuyData = pacBuyData&&pacBuyData.data&&pacBuyData.data.item||{};
                        item.pacPic = pacBuyData.pacPic;
                        item.pacNum = pacBuyData.pacNum;
                        item.pacRealPic = item.retailPrice;
                        return item;
                    });
                }
                // 如果有找到处于当前时间的抢购活动
                else if(findedLimitDis){
                    if(findedLimitDis.sd>now){
                        item.limitDiscountSd = findedLimitDis.sd;
                        item.limitDiscountST = "距离抢购开始还有";
                        return item;
                    }else{
                        // 加载活动数据
                        return limitDiscount.loadByMid(item._id).then(lang.hitch(this, function(data2){
                            var item2 = data2&&data2.data&&data2.data.item||{};
                            if(item2._id){
                                item.limitDiscountEd = item2.ed;
                                item.limitDiscountET = "距离抢购结束还有";
                                item.qty = item2.qty;
                                item.retailPrice = item2.limitPic;
                                item.limitedQty = item2.limitQty;
                                item.isLimitDiscount = true;
                            }
                            return item;
                        }));
                    }
                }
                else{
                    return item;
                }
            })).then(lang.hitch(this,function(item){
                item = this.getRealPrice(item);
                var shopId = this.getShopId();
                require([
                    "dojo/topic",
                    "cq/util/share/share"
                ],function(topic,share){
                    share.getShopLocation(shopId).then(function(baseUrl){
                        topic.publish("/cq/util/sys/share/infoChanged",{
                            title: item.mName,
                            thumb: item.logo || "",
                            url:baseUrl+"#matDetail-" + item._id
                        });
                    });
                });
                return item;
            }));
        },
        getRealPrice:function(item){
            // 获取最终商品的价格 包含的等级信息
            // 判断商品当前时间是否有抢购或者预售活动
            // 自己的商品才处理 分销商品不处理
            // 如果设置了多规格价钱修改
            item.realPrice = item.retailPrice;
            for(var i=0;i<item.specs.length;i++){
                item.specs[i].realPrice = item.specs[i].price;
            }
            if(!item.isPreSale&&!item.isLimitDiscount&&item.prices&&item.prices.length&&this.getShopId()==(item.fromShopId._id||item.fromShopId)){
                var currentUserLevel = consumer.getCurrentUserFromSession().clientLevel&&consumer.getCurrentUserFromSession().clientLevel._id||"",
                    currentPrice = null,
                    currentRate = 10;
                if(currentUserLevel){
                    for(var i=0;i<item.prices.length;i++){
                        currentPrice = item.prices[i];
                        if(currentUserLevel==(currentPrice.clientLevel._id||currentPrice.clientLevel)){
                            currentRate = currentPrice.price;
                            break;
                        }
                    }
                    // 修改得到的价格
                    if(item.specs&&item.specs.length){
                        // 重算规格中的价格
                        for(var i=0;i<item.specs.length;i++){
                            item.specs[i].price = item.specs[i].price/10*currentRate;
                        }
                    }else{
                        item.retailPrice = item.retailPrice*currentRate/10;
                    }
                }
            }
            if(item.specs&&item.specs.length) {
                // 对价格排序
                var specs = item.specs.concat();
                specs.sort(function(a,b){
                    return a.price>b.price?1:-1;
                });
                var first = specs[0];
                // 可能只有一个规格
                var last = specs[specs.length - 1];
                if (first.price != last.price) {
                    item.retailPrice = window.fixedTo(first.price, 3) + '~' + window.fixedTo(last.price, 3);
                } else {
                    item.retailPrice = window.fixedTo(first.price, 3);
                }
            }else{
                item.retailPrice = window.fixedTo(item.retailPrice, 3);
            }
            return item;
        },
        getItemProp: function(item){
            return this.getRealPrice(item);
        },
        loadById: function (param) {
            if (!param.cqViewParam.params) {
                return;
            }
            return this._loadById(param.cqViewParam.params);
        },
        loadByIdOpen:function(param){
            return this._loadById(param);
        },
        // fw端加载商品使用
        loadByIdForFw: function (param) {
            if (!param.cqViewParam.params) {
                return;
            }
            var def = new Deferred();
            this.exec('consumerLoadMat', {
                _id: param.cqViewParam.params
            }).then(lang.hitch(this, function (data) {
                if (data && data.data && data.data.ok === 1) {
                    data = data.data.item;
                    data.scoreAvg = window.fixedTo(data.scoreAvg, 2);
                    if(data.specs.length) {
                        // 对价格排序
                        var specs = data.specs.concat();
                        specs.sort(function (a, b) {
                            return a.price > b.price ? 1 : -1;
                        });
                        var first = specs[0];
                        // 可能只有一个规格
                        var last = specs[specs.length - 1];
                        if (first.price != last.price) {
                            data.retailPrice = window.fixedTo(first.price, 3) + '~' + window.fixedTo(last.price, 3);
                        } else {
                            data.retailPrice = first.price;
                        }
                    }
                    // 加载完成后保留数据
                    this.qty = data.qty;
                    this.retailPrice = data.retailPrice;
                    this.createStatus = true;
                    def.resolve(data);
                } else {
                    def.resolve({});
                }
            }));
            return def;
        },
        share: function (data, widget) {
            // summary:
            //         点击后分享给其他人
            // view:
            //         matDetail
            //         matDetailBB2B -- 服务商查看自己商品内容详情页面
            //         matDetailBB2C -- 商家端商品内容详情
            // description:
            //         无
            // 不常用功能 用到再require
            require(["cq/util/share/share"], lang.hitch(this, function(share){
                share.getShopLocation(this.getShopId()).then(function(baseUrl){
                    var options = [{
                        "weixin": {
                            title: data.mName,
                            thumb: data.logo || "",
                            url:baseUrl+"#matDetail-" + data._id
                        }
                    }, {
                        "friendCircle": {
                            title: data.mName,
                            thumb: data.logo || "",
                            url:baseUrl+"#matDetail-" + data._id
                        }
                    }, {
                        "copy": {
                            url: baseUrl+"#matDetail-" + data._id
                        }
                    }];
                    share.showShare(options);
                });
            }));
        },
        getMatListUrl: function () {
            // summary:
            //        加载商品列表
            // view:
            //         matList
            // description:
            //         无
            return this.getBaseUrl() + '/consumerLoadMat';
        },
        //运营商加载商品列表
        getOpMatListUrl:function(){
            // summary:
            //        加载商品列表
            // view:
            //         matList
            // description:
            //         无
            return this.getBaseUrl() + '/loadOpMat?shopId='+config.getPlatformShopId();
        },
        //服务商加载商品列表
        getScMatListUrl:function(){
            // summary:
            //        加载商品列表
            // view:
            //         matList
            // description:
            //         无
            return this.getBaseUrl() + '/loadScMat?shopId='+config.getPlatformShopId();
        },
        // 商家首页 热销商品
        getListParamByShopAndSale: function(params){
            var query = {
                isUse: true,
                orderBy: "-totalSale",
                pageSize: 4
            };
            query.shopId = params.cqViewParam.params||this.getShopId();
            return query;
        },
        // 商家首页 推荐商品
        getListParamByShopAndRecommend: function(params){
            var query = {
                isUse: true,
                isRecommend: true,
                pageSize: 4
            };
            query.shopId = params.cqViewParam.params;
            return query;
        },
        getListUrl: function () {
            // summary:
            //        加载商品列表
            // view:
            //         matList
            // description:
            //         无
            return this.getBaseUrl() + '/consumerLoadMat';
        },
        getListUrlwx:function(){
            return this.getBaseUrl()+ '/loadByCurrentSort';
        },
        getRecommendListUrl: function(){
            return this.getBaseUrl()+ "/loadRecMat?shopId="+this.getShopId();
        },
        onListClick: function(data,action,list){
            if(action==="addToOrderCar"){
                this.addToOrderCar(data,list);
            }else{
                window.moveToView("matDetail", data._id);    
            }
            
        },
        preSaleRule: function(){
            return "<div style='text-align: left;padding: 10px;line-height: 24px;font-size:14px;'>"+
                "<h1 style='text-align:center;font-size:16px;'>预售活动规则</h1>"+
                "<h2 style='margin-top:10px;'>一、    预售定金</h2>"+
                "<h3>消费者在购买预售商品时，预先支付的一定数额的预付款；</h3>"+
                "<p>1.    支付时间：定金应在活动期间支付，否则不能享受预售活动优惠；</p>"+
                "<p>2.    退款：消费者未如期支付尾款，定金不退还；</p>"+
                "<p>3.    优惠：预售定金支持使用符合条件的优惠券、村币、金元宝。</p>"+
                "<h2 style='margin-top:10px;'>二、    预售尾款</h2>"+
                "<h3>预售商品价格减去定金后消费者还需支付的对应数额的金钱；</h3>"+
                "<p>1.    支付时间：尾款在活动结束后进行，具体金额由实际预售活动规则而定；</p>"+
                "<p>2.    退款：消费者未如期支付尾款，定金不退还；</p>"+
                "<p>3.    优惠：预售尾款支持使用符合条件的优惠券、村币、金元宝。</p>"+
                "<h2 style='margin-top:10px;'>三、    规则</h2>"+
                "<p>1.    预售商品的优惠阶梯至少大于或等于1，以售出笔数为单位；</p>"+
                "<p>2.    预售商品是否包邮由商家自行设置"+
                "<h2 style='margin-top:10px;'>四、    发货</h2>"+
                "<p>1.    发货时间：预售商品发货时间以商品详情页描述为准。实际发货时间为尾款支付成功后。</p>"+
                "<p>2.    其他：没有支付尾款的不予以发货，商家不承担责任。</p>"+
            "</div>";
        },
        // 查看预售规则
        showPreSaleRule: function(data, widget){
            // 创建overlay
            require([
                "cq/util/edit/overlay",
                "dojo/dom-construct",
                "dojox/mobile/FixedSplitter",
                "dojox/mobile/ScrollablePane",
                "dojox/mobile/Pane",
                "dojo/_base/connect"
            ], lang.hitch(this, function(overlay, domConstruct, FixedSplitter, ScrollablePane, Pane, connect){
                var f = new FixedSplitter({
                    orientation: "V",
                    variablePane: "0",
                    height: "400px",
                    style: "height:400px;width:100%;"
                });
                var p1 = new Pane({
                    
                });
                var p2 = new Pane({
                    height: "30px;",
                    style: "height:30px;width:100%;"
                });
                f.domNode.appendChild(p1.domNode);
                f.domNode.appendChild(p2.domNode);
                var s = new ScrollablePane({
                    height: "360px",
                    style: "height:360px;",
                    scrollDir: "v"
                });
                p1.domNode.appendChild(s.domNode);
                s.containerNode.appendChild(domConstruct.toDom(this.preSaleRule()));
                // 添加关闭按钮
                var b = domConstruct.create("div", {
                    innerHTML: "完成",
                    style: "line-height:30px;background:#0f8680;color:white;"
                }, p2.domNode);
                connect.connect(b, "onclick", function(){
                    overlay.hide();
                });
                f.startup();
                overlay.showElement(f.domNode);
            }));
        },
        onDataReady: function (widget) {
            // summary:
            //        商品数据加载完成后的显示
            // view:
            //         matDetail
            // description:
            //         无
            widget.hideByFields(["favoritesConfirm", "favoritesCancel","deleted", 'matSellOut', 'matOffShelves', 'buyImmediately', 
            'addToOrderCar', "preMarketPrice", "marketPrice", "shopIsVerified","buyNow", "farmer._id", "hasCommentsArea", "getAutState", "getReward", "limitDiscountDeadLine",
            "limitDiscountDeadLine2", 'specs', "onShelfAlarm", "addToOrderCar1", "buyNow1", "preSaleT,preSaleEd", "normalPic", "presalePic", "showCurrentRate", "showPreSaleRule",
            "showFinalPayment","rewardTxt","hasStores","hasStores1"]);
            // 隐藏拼团相关信息
            widget.hideByFields(["pacNum","pacPic","pacRealPic","pacBuyT,pacBuyEd","pacBuyNow","pacNewTeam","pacBuyIntroduce","pacBuyProccess"
            ,"pacTeamItem.leader.logo","pacTeamItem.leader.nickName","limitTitle,limitTime","pacTeamItem.remainNum","pacTeamItem.pacTeamUrl","pacTeamUrl"]);
            var data = widget.getData();
            if(!data._id){
                return;
            }
            if(data.pacBuyEd){
                widget.showByFields(["pacNum","pacPic","pacRealPic","pacBuyT,pacBuyEd","pacBuyIntroduce","pacBuyProccess"]);
            }
            if(data.pacTeamItem._id){
                widget.showByFields(["pacTeamItem.leader.logo","pacTeamItem.leader.nickName","limitTitle,limitTime",
                "pacTeamItem.remainNum","pacTeamItem.pacTeamUrl","pacTeamUrl"]);
            }
            if(data.hasStores){
                widget.showByFields(["hasStores","hasStores1"]);
            }
            if(data.mName){
                var view = widget.getView();
                view.changeTitle(data.mName);
            }
            if(data.isPreSale){
                widget.showByFields(["presalePic", "showCurrentRate", "showPreSaleRule", "showFinalPayment","preSaleT,preSaleEd"]);
                widget.hideByFields(["normalPic"]);
            }else{
                widget.hideByFields(["presalePic", "showCurrentRate", "showPreSaleRule", "showFinalPayment","preSaleT,preSaleEd"]);
                widget.showByFields(["normalPic"]);
            }
            if(data.commentInfo&&data.commentInfo.userId&&data.commentInfo.userId.isAut){
                widget.showByFields(["getAutState"]);
            }
            // 如果店铺认证了 显示认证标志
            if(data.shopIsVerified){
                widget.showByFields(["shopIsVerified"]);
            }
            if(data.isDelete){
                widget.showByFields(["deleted", 'addToOrderCar1', 'buyNow1']);
            }else if(!data.isUse){
                widget.showByFields(["matOffShelves", 'addToOrderCar1', 'buyNow1']);
            }else if(data.qty<=0){
                widget.showByFields(["matSellOut", 'addToOrderCar1', 'buyNow1']);
            }else if(!data.pacBuyEd){
                widget.showByFields(["addToOrderCar", "buyImmediately"]);
            }else{
                widget.showByFields(["pacBuyNow","pacNewTeam"]);
            }
            // 如果设置了周期配送 不能加入到购物车
            if (data.isCycle&&!data.pacBuyEd) {
                widget.hideByFields(["addToOrderCar"]);
                widget.showByFields(["addToOrderCar1"]);
            }
            // 如果设置了市场价 则显示市场价
            if (data.marketPrice) {
                widget.showByFields(["marketPrice"]);
            }
            if (data.preMarketPrice) {
                widget.showByFields(["preMarketPrice"]);
            }
            // 依据数据控制按钮的显示
            if (data.collect) {
                widget.showByFields(["favoritesCancel"]);
            } else {
                widget.showByFields(["favoritesConfirm"]);
            }
            // 如果没有设置farmerId则隐藏查看农户
            if(data.farmer &&data.farmer._id){
                widget.showByFields(["farmer._id"]);
            }
            // 如果有评论
            if(data.hasComments){
                widget.showByFields(["hasCommentsArea"]);
            }
            // 没有评论不显示 查看更多评论
            if (!data.hasComments) {
                widget.hideByFields(["url"]);
            } else {
                widget.showByFields(["url"]);
            }
            if(data.rewardTxt){
                widget.showByFields(["rewardTxt"]);
            }
            // 多规格显示
            if (data.specs.length) {
                widget.showByFields(["specs"]);
            } else {
                widget.hideByFields(["specs"]);
            }
            
            // 如果有倒计时
            if(data.limitDiscountEd){
                widget.showByFields(["limitDiscountDeadLine"]);
            }
            if(!data.limitDiscountEd&&data.limitDiscountSd>date.nowISOString()){
                widget.showByFields(["limitDiscountDeadLine2"]);
            }
            // 重算高度
            var view = widget.getView();
            if (view) {
                view.resize();
            }
        },
        defineFields: ['purchNum'],
        createStatus: true,
        // 处理fw上的显示
        // -- matDetail
        onDataReadyForFw: function (widget) {
            var freight = domQuery('.mat-package', widget.domNode)[0];
            var specs = domQuery('.mat-specs', widget.domNode)[0];
            var data = widget.getData();
            if (!data._id) {
                return;
            }
            if (data.freight) {
                domClass.remove(freight, 'none');
            }else {
                domClass.add(freight, 'none');
            }
            // fw规格显示
            if (data.specs.length) {
                this.createStatus && this.createSpecs(data.specs, widget);
                domClass.remove(specs, 'none');
            } else {
                domClass.add(specs, 'none');
            }
            this.createStatus = false;
            array.forEach(this.defineFields, lang.hitch(this, function (item) {
                this[item] = 1;
            }));
            !this.selector && this.showDetail(data, widget, {
                target: domQuery('.mat-detail-tag', widget.domNode)
            });
            domQuery('.mat-amount-tool', widget.domNode).forEach(lang.hitch(this, function (item) {
                var field = domAttr.get(item, 'field');
                var node = domQuery('.edit-car-qty', item)[0];
                this[field] = data.minQty || this[field];
                domAttr.set(node, 'value',  this[field]);
            }));
        },
        // toNoticeMe
        toNoticeMe: function(data){
            // 限购提醒我
            require([
                "bob/im/inform/c"
            ], lang.hitch(this, function(inform){
                item = {};
                item.tempData = {
                    "first": "抢购即将开始",
                    "orderSn": data._id,
                    "orderStatus": "抢购即将开始",
                    "remark": "您关注的抢购活动即将开始了，快去看看吧"
                };
                item.billType = 2;
                item.bid = data._id;
                var sd = new Date(data.limitDiscountSd);
                sd.setMinutes(sd.getMinutes()-10);
                item.alarmTime = sd;
                item.url = window.location.href.split("#")[0]+"#matDetail-"+data._id;
                item.msgContent = "您关注的抢购活动即将开始了，快去看看吧";
                inform.save(item);
            }));
        },
        // 不进行处理
        addToOrderCar1: function () {},
        // 不进行处理
        buyNow1: function () {},
        // 空方法 用于绑定按钮 不做任何操作
        noOperation: function () {},
        // 空方法 用于绑定按钮 不做任何操作
        noMatOperation: function () {},
        // 领取优惠劵
        getDiscount: function (data, widget) {
            require([
                "bob/mk/discount/c",
                "cq/util/edit/overlay",
                "cq/widgets/item/mat/GetDiscoutList"
            ], lang.hitch(this, function (discount, overlay, GetDiscountList) {
                // 获取商家的数据
                var fromShopId = data.fromShopId;
                discount.loadByShop(fromShopId).then(lang.hitch(this, function (items) {
                    if (!items.length || items.length === 0) {
                        alert("没有可以领取的优惠劵");
                    } else {
                        // 创建overLay
                        if (!this.getDiscoutListElement) {
                            this.getDiscoutListElement = new GetDiscountList();
                        }
                        var data = {};
                        data.items = items;
                        data.fromShopId = fromShopId;
                        this.getDiscoutListElement.init(data).then(function () {
                            overlay.hide();
                        });
                        overlay.showElement(this.getDiscoutListElement.domNode);
                    }
                }));
            }));
        },
        //  点击商品跳转（供应商独用）
        onSupplyMatClick: function (param) {
            window.moveToView("matDetailS", param._id);
        },
        //  供应商详情显示
        getSupplyBusProp: function (data) {
            //if(){
            var a = data;
            //retailPrice
        },
        //  供应商的商品详情(布局)
        getSupplyDtlLayout: function () {
            return [{
                type: 'content',
                content: config.mat.simpleLayout
            }, {
                type: 'form',
                fields: this.getFormItems([])
            }];
        },
        showImage: function(data, widget, e) {
            if(e.target.nodeName != "IMG") return;
            var node = widget.getElementByField("content");
            // 获得节点中的图片
            var images = domQuery("img", node).map(function(item){
                return domAttr.get(item, "src");
            });
            // 获得点击图片的位置
            var index = images.indexOf(domAttr.get(e.target, "src"));
            // 修改显示图片的数据
            images = array.map(images, function(item){
                return {
                    src: item
                };
            });
            bigImg.show(images, index);
        },
        // fw规格显示处理
        createSpecs: function (data, widget) {
            var pack = domQuery('.mat-specs-pack', widget.domNode)[0];
            domConstruct.empty(pack);
            if (!data.length) return;
            array.forEach(data, lang.hitch(this, function (item) {
               var list = domConstruct.create('li', {
                    "class": 'mat-specs-list',
                    innerHTML: item.name,
                    click: lang.hitch(this, function(e){this.clickListForFw(e, widget);})
                }, pack);
                list.params = item;
            }));
        },
        // fw规格点击处理
        clickListForFw: function (e, widget) {
            var node = e.target;
            var data = widget.getData();
            if (data.minQty > node.params.qty) {
                this.selector = false;
                // domQuery('.edit-car-specs', widget.domNode)[0].innerHTML = '请选择 规格';
                return;
            }
            if (domClass.contains(node, 'selected')) {
                domClass.remove(node, 'selected');
                this.selector = false;
                this.params.specs.price = this.retailPrice;
                this.params.specs.qty = this.qty;
                this.setValue(this.params, widget);
            } else {
                domQuery('.mat-specs-list', widget.domNode).forEach(function (item) {
                    domClass.remove(item, 'selected');
                });
                domClass.add(node, 'selected');
                for (var e in node.params) {
                    this.params.specs[e] = node.params[e];
                }
                this.selector = true;
                this.params.specs.price = window.fixedTo(this.params.specs.price, 3);
                this.setValue(this.params, widget);
            }
        },
        // fw数量减少
        // -- matDetail
        clickReduce: function (data, widget, e) {
            var node = e.target;
            var field = domAttr.get(node.parentNode, 'field');
            this[field]--;
            this.setQty(data, node.parentNode, field);
        },
        // fw数量增加
        // -- matDetail
        clickAdd: function (data, widget, e) {
            var node = e.target;
            var field = domAttr.get(node.parentNode, 'field');
            this[field]++;
            this.setQty(data, node.parentNode, field);
        },
        // fw数量加减设置方法
        // -- matDetail
        setQty: function (data, domNode, field) {
            var limitedQty = data.limitedQty || 0;
            var maxQty, minQty, deliveryTimes;
            if (data.specs.length) {
                var buy = array.every(data.specs, lang.hitch(this, function (item) {
                    return item.qty < data.minQty;
                }));
                if (buy) return;
            }
            if (limitedQty > 0) {
                maxQty = Math.min(data.qty, limitedQty);
                minQty = data.minQty > limitedQty ? limitedQty : (data.minQty || 1);
            } else {
                maxQty = data.qty;
                minQty = data.minQty || 1;
            }
            if (field == 'purchNum') {
                if (this.purchNum <= maxQty && this.purchNum >= minQty) {
                    domAttr.set(domQuery('.edit-car-qty', domNode)[0], "value", this.purchNum);
                } else {
                    if (this.purchNum > maxQty) {
                        this.purchNum = maxQty;
                        return;
                    } else {
                        this.purchNum = minQty;
                        return;
                    }
                }
            }
            // else if (field == 'trgNum') {
            //     if (this.trgNum >= 1 && this.trgNum <= this.data.deliveryTimes) {
            //         domAttr.set(query('.edit-car-qty', node)[0], "value", this.trgNum);
            //     } else {
            //         if (this.trgNum > this.data.deliveryTimes) {
            //             this.trgNum = this.data.deliveryTimes || 1;
            //             alert("每次配送数量不能超过" + this.trgNum);
            //             return;
            //         } else {
            //             this.trgNum = 1;
            //             alert("每次配送数量不能少于" + this.trgNum);
            //             return;
            //         }
            //     }
            // }
            if (!field) {
                domQuery('.edit-car-qty', domNode).forEach(lang.hitch(this, function (item, key) {
                    domAttr.set(item, "value", this[this.defineFields[key]]);
                }));
            }
        },
        params: {
            specs: {
                qty: 0,
                price: 0,
                name: ""
            }
            // trgMode: {
            //     deliveryStatus: '',
            //     deliveryTimes: 1,
            //     userDelivery: '',
            // }
        },
        // fw设置显示库存价格
        // -- matDetail
        setValue: function (params, widget) {
            var data = widget.getData();
            var matPrice = widget.getElementByField('retailPrice');
            var qty = widget.getElementByField('qty');
            var specsInfo = domQuery('.edit-car-specs', widget.domNode)[0];
            data.retailPrice = params.specs.price;
            this.purchNum = data.minQty || 1;
            data.qty = params.specs.qty;
            widget.setData(data);
            // if (this.data.isCycle) {
            //     this.trgNum = 1;
            //     this.data.deliveryTimes = params.specs.deliveryTimes;
            //     domClass.add(qty, 'none');
            // }
            // domAttr.set(this.purchNode, "value", this.purchNum);
            this.setQty(data, widget.domNode);
            qty.innerHTML = params.specs.qty;
        },
        // fw评价详情初始化内容显示
        // -- matDetail
        initShow: function (widget, node) {
            domQuery('.mat-tags>div', widget.domNode).forEach(function (item) {
                domClass.remove(item, 'selected');
            });
           domQuery('.mat-content>span', widget.domNode).forEach(function (item) {
                domClass.add(item, 'none');
            });
            domClass.add(node, 'selected');
        },
        // fw评价内容显示
        // -- matDetail
        showJudge: function (data, widget, e) {
            var node = e.target;
            var judge = domQuery('.mat-judge', widget.domNode)[0];
            var judgeList = domQuery('.mat-judge-list', widget.domNode)[0];
            this.initShow(widget, node);
            var widgetByNode = registry.byNode(judgeList);
            if(widgetByNode){
                widgetByNode.cqRefInfo.cqViewParam = {
                    fromShopId: data.fromShopId,
                    _id: data._id
                };
                widgetByNode.cqRefresh();
            }
            domClass.remove(judge, 'none');
        },
        // fw详情内容显示
        // -- matDetail
        showDetail: function (data, widget, e) {
            var node = e.target;
            this.initShow(widget, node);
            domClass.remove(domQuery('.mat-part', widget.domNode)[0], 'none');
        },
        // fw立即购买处理
        // -- matDetail
        buyNowForFw: function (data, widget) {
            if (data.specs.length) {
                if (this.selector) {
                    this.achieve(this.params, 'buyNow', widget);
                } else {
                    alert("请选择规格");
                }
            } else {
                this.achieve(null, 'buyNow', widget);
            }
        },
        achieve: function (params, affirmAction, widget) {
            var data = widget.getData();
            if (affirmAction == "addTo") {
                var matInfo = cart.getCartInfo();
                var limitedQty = data.limitedQty || 0;
                if (limitedQty > 0) {
                    var matInfo = cart.getCartInfo();
                    if (matInfo[data._id] + this.purchNum > limitedQty) {
                        alert("购物车已经有该商品了");
                    } else {
                        cart.addMatAndQty(params ? data._id + '_' + params.specs._id : data._id, this.purchNum, params);
                        alert("添加成功");
                    }
                } else {
                    cart.addMatAndQty(params ? data._id + '_' + params.specs._id : data._id, this.purchNum, params);
                    alert("添加成功");
                }
            } else if (affirmAction == "buyNow") {
                cart.addBuyNow(params ? data._id + '_' + params.specs._id : data._id, this.purchNum, params);
                window.moveToView('orderInfo', data._id, params);
            }
        },
        // fw立即购买处理
        // -- matDetail
        addToOrderCarForFw: function (data, widget) {
            if (data.specs.length) {
                if (this.selector) {
                    this.achieve(this.params, 'addTo', widget);
                } else {
                    alert("请选择规格");
                }
            } else {
                this.achieve(null, 'addTo', widget);
            }
        },
        clickRGroupListItem:function(item,action,list){
            if(action==="addToOrderCar"){
                this.addToOrderCar(item,list);
            }else{
                window.moveToView('matDetail', item._id);
            }
        }
        
    });
    var matCBo = new MatCBo();
    matCBo.Bo = MatCBo;
    return matCBo;
});