﻿// 订单系统商家端
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    '../../BoBase',
    "./_Mixin",
    'cq/util/sys/query',
    "dojo/Deferred"
], function (declare,lang, BoBase,_Mixin, query, Deferred) {
    var O = declare("", [BoBase.B, _Mixin], {
        fields: {
            saveBtn: {
                type: 'button',
                label: '保存',
                action: "save"
            },
            deleteBtn: {
                type: 'button',
                label: '删除',
                action: "deleteById"
            }
        },
        deleteById: function(data, widget){
            if(!confirm("确认删除？")){
                return;
            }
            var item = {
                _id: data._id,
                isUse: false
            };
            this.exec("save", item).then(function(result){
                if(result&&result.data&&result.data.ok==1){
                    alert("删除成功");
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"删除失败");
                }
            });
        },
        save: function (data, widget) {
            var msg = this.getDataValidMsg(data, ['title', 'maxQty']);
            if (msg) {
                alert(msg);
                return false;
            }
            // 检查属性值是否填写完整
            var opts = data.opts;
            if(!opts.length){
                alert("请添加属性值");
                return;
            }
            var isFind = false;
            for(var i=0;i<opts.length;i++){
                if(!opts[i].name||!opts[i].qty){
                    alert("第"+(i+1)+"行属性信息不完整");
                    isFind = true;
                    break;
                }
            }
            if(isFind){
                return false;
            }
            data.isUse = true;
            this.exec('save', data).then(function (reponse) {
                if (reponse && reponse.data && reponse.data.ok === 1) {
                    alert('保存成功');
                    history.back();
                } else {
                    alert('保存失败');
                }
            });
        },
        getListUrl: function () {
            return this.getBaseUrl() + '/load';
        },
        getListUrlForMyself: function(){
            return this.getBaseUrl() + '/load?shopId='+this.getShopId();
        },
        getListParam: function (cqRefInfo) {
            var params = {
                shopId: this.getShopId(),
                isUse: true
            };
            var value = query.getQueryValue(cqRefInfo.search);
            if (value) {
                params.search = value;
            }
            return params;
        },
        getItemProp: function(item){
            item.maxQty = item.maxQty|| 0;
            return item;
        },
        onListClick: function(data){
            window.moveToView("matOptEdit", data._id);
        },
        getEdtLayout: function () {
            return [{
                type: 'form',
                fields: this.getFormItems(['title',"href","img", 'maxQty', "remark", 'opts', "deleteBtn", 'saveBtn'])
            }];
        },
        loadById: function (param) {
            if (!param.cqViewParam.params) {
                return ;
            }
            var def = new Deferred();
            this.exec('loadById', {
                '_id': param.cqViewParam.params
            }).then(function (data) {
                var item = data&&data.data&&data.data.item||{};
                def.resolve(item);
            });
            return def;
        },
        onDataReady: function(widget){
            var data = widget.getData();
            widget.hideByFields(["deleteBtn"]);
            if(!data._id){
                return;
            }
            if(data.isUse&&data._id){
                widget.showByFields(["deleteBtn"]);
            }
        }
    });
    var o = new O();
    o.Bo = O;
    return o;
});