﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    '../../BoBase',
    "./_Mixin",
    'cq/util/sys/query',
    "cq/util/config/config",
    "cq/util/sys/date",
    "dojo/Deferred"
], function (declare,lang, BoBase,_Mixin, query, config, date, Deferred) {
    var O = declare("", [BoBase.B, _Mixin], {
        fields: {
            saveBtn: {
                type: 'button',
                label: '提交',
                action: "save"
            },
            resubmitBtn: {
                type: 'button',
                label: '重新提交',
                action: "resubmit"
            },
            reject: {
                type: 'button',
                label: '驳回申请',
                action: "reject"
            },
            verify: {
                type: 'button',
                label: '审核通过',
                action: "verify"
            },
            verifyTime:{
                type : 'date',
                label : '审核通过时间',
            },
            rejectReason:{
                type:"textarea",
                label:"驳回理由",
                placeHolder: "若拒绝商家申请，请填写驳回理由"
            }
        },
        resubmit:function(data,widget){
            this.save(data,widget);
        },
        save: function (data, widget) {
            // summary:
            //        商家端申请时令生鲜上架
            // view:
            //         seasonMatEdtB
            // description:
            //         无
            var msg = this.getDataValidMsg(data, ['mId', 'sd', "ed", "applyReason"]);
            if (msg) {
                alert(msg);
                return false;
            }
            //开始时间大于当前时间，结束时间大于开始时间
            if(data.sd<date.nowISOString()){
                alert("预计上架日期必须大于当前日期");
                return;
            }
            if(data.ed<data.sd){
                alert("预计下架日期必须大于预计上架日期");
                return;
            }
            data.state = 1;
            data.rejectReason = "";
            window.busy();
            this.exec('save', data).then(function (reponse) {
                window.free();
                if (reponse && reponse.data && reponse.data.ok === 1) {
                    alert('保存成功');
                    history.back();
                } else {
                    alert(reponse.data.msg||'保存失败');
                }
            });
        },
        getListUrl: function () {
            return this.getBaseUrl() + '/load';
        },
        getListUrlForMyself: function(){
            return this.getBaseUrl() + '/load?shopId='+this.getShopId();
        },
        getListParam: function (cqRefInfo) {
            var params = {
                shopId: this.getShopId()
            };
            if(cqRefInfo.state){
                params.state = cqRefInfo.state.state;
            }else{
                params.state = 1;
            }
            return params;
        },
        onListClick: function(data){
            window.moveToView("seasonMatEdt", data._id);
        },
        onListClickB: function(data){
            window.moveToView("seasonMatEdtB",data._id);
        },
        getEdtLayout: function () {
            // summary:
            //        商家端申请时令生鲜编辑页面layout
            // view:
            //         seasonMatEdt
            // description:
            //         无
            return [{
                type: 'form',
                fields: this.getFormItems(['mId', 'sd', "ed", 'applyReason', 'rejectReason', 'verifyTime', 'saveBtn','resubmitBtn'])
            }];
        },
        getEdtLayoutB: function(){
            // summary:
            //        平台审核时令生鲜layout
            // view:
            //         seasonMatEdtB
            // description:
            //         无
            return [{
                type: 'form',
                fields: this.getFormItems(['mId', 'sd', "ed", 'applyReason', 'rejectReason', 'verify', 'reject'])
            }];
        },
        loadById: function(params){
            var def = new Deferred(),params = params.cqViewParam.params,data={};
            if(!params){
                def.resolve({});
            }else if(params.split("_")[0] == "mid"){
				// 设置商品默认值
                data.mId = {};
                data.mId._id = params.split("_")[1];
                require(["bob/mat/matB"],lang.hitch(this,function(mat){
                    mat.loadByMid(data.mId._id).then(lang.hitch(this,function(result){
                        result = result&&result.data&&result.data.item;
                        data.mId.mName = result.mName;
                        def.resolve(data);
                    }));
                }));
            }else{
                this.exec("loadById",{
                    _id:params
                }).then(lang.hitch(this,function(data){
                    if(data.data.ok === 1){
                        data = data.data.item;
                        if(typeof(data.mId)=="string"){
                            var mId = data.mId;
                            data.mId = {};
                            data.mId._id = mId;
                            data.mId.mName = data.mName;
                        }
                        def.resolve(data);
                    }else{
                        def.resolve({});
                    }
                }));
            }
            return def;
        },
        onDataReady: function(widget){
            // summary:
            //        商家端显示隐藏保存按钮
            // view:
            //         seasonMatEdt
            // description:
            //         无
            var data = widget.getData();
            widget.hideByFields(["resubmitBtn","saveBtn","verifyTime","rejectReason"]);
            var arr = ["mId","sd","ed","applyReason"];
            if(!data._id){
                widget.showByFields(["saveBtn"]);
                return;
            }
            if(data.state==1){
                widget.disableByFields();
            }
            if(data.state==2){
                widget.disableByFields();
                widget.showByFields(["verifyTime"]);
            }
            if(data.state==3){
                widget.enableByFields(arr);
                widget.disableByFields(["rejectReason"]);
                widget.showByFields(["rejectReason","resubmitBtn"]);
            }
        },
        onDataReadyB: function(widget){
            // summary:
            //        平台显示隐藏审核拒绝按钮
            // view:
            //         seasonMatEdtB  --平台审时令生鲜
            // description:
            //         无
            var data = widget.getData();
            var arr = ["mId","sd","ed","applyReason"];
            widget.disableByFields(arr);
            widget.hideByFields(["reject","verify"]);
            //已经提交申请的显示审核和拒绝按钮
            if(data.state == 1){
                widget.showByFields(["reject","verify"]);
            }
            //如果平台在商家想销售的时间内没有看到申请，不能再审核
            if(data.ed<date.nowISOString()){
                widget.hideByFields(["reject","verify"]);
            }
        },
        reject:function(data, widget){
            // summary:
            //        平台驳回商家申请
            // view:
            //         seasonMatEdtB  --平台审时令生鲜
            // description:
            //         无
            if(!data.rejectReason){
                alert("请填写驳回理由!");
                return;
            }
            window.busy();
            this.exec("reject",{_id:data._id,rejectReason:data.rejectReason}).then(lang.hitch(this,function(result){
                window.free();
                if(result&&result.data&&result.data.ok){
                    alert("已驳回该申请");
                    history.back();
                }else{
                    alert(result.data.msg||"驳回失败，请重试");
                }
            }));
            
        },
        verify:function(data, widget){
            // summary:
            //        平台同意商家申请
            // view:
            //         seasonMatEdtB  --平台审时令生鲜
            // description:
            //         无
            window.busy();
            this.exec("verify",{_id:data._id}).then(lang.hitch(this,function(result){
                window.free();
                if(result&&result.data&&result.data.ok){
                    alert("审核通过");
                    history.back();
                }else{
                    alert(result.data.msg||"审核失败，请重试");
                }
            }));
        }
    });
    var o = new O();
    o.Bo = O;
    return o;
});