﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "../BoBase",
    "dojo/Deferred",
    "cq/app/config",
    "cq/util/config/config",
    "cq/util/sys/query",
    "../shop/shop",
    "cq/util/sys/date",
],function(declare, lang, array, BoBase, Deferred, appConfig, config, query, shop, date){
    var ActivityBo = declare("",BoBase,{
        modalName : 'mk/activity',
        // 用到的字段
        fields: {
            title : {
                type : 'text',
                label : '活动名称',
                placeHolder : '必填'
            },
            logo : {
                type : "image",
                sizeType : "cut",
                //canEdit : true,
                size : {
                    width : 750,
                    height : 288
                },
                label : '活动logo'
            },
            tp : {
                type : "options",
                label : "活动类型",
                options : {
                    1 : "横幅推荐",
                    2 : "24节气"
                },
                selected : 1
            },
            isUse : {
                type : 'checkbox',
                label : '使用',
                canEdit : true
            },
            inviteDateFrom : {
                type : 'date',
                label : '邀约期起'
            },
            inviteDateTo : {
                type : 'date',
                label : '邀约期至'
            },
            preheatDateFrom : {
                type : 'date',
                label : '预热期起'
            },
            preheatDateTo : {
                type : 'date',
                label : '预热期至'
            },
            execDateFrom : {
                type : 'date',
                label : '执行期起'
            },
            execDateTo : {
                type : 'date',
                label : '执行期至'
            },
            //poster : {
                //type : "textarea",
                //label : "活动海报",
                //canEdit : true
            //},
            remark : {
                type : "richText",
                label : "活动介绍",
                canEdit : true
            },
            mats : {
                type : "ref",
                label : "参与商品",
                dataProvider : "bob/mat/mat",
                targetMethod : "getMatUrl",
                labelFields : "mName",
                searchField : "mName",
                canEdit : true,
                pageSize : 10,
                multiselect : "multiselect"
            },
            onSaveButton: {
				type: "button",
				label: "保存",
				action: "save",
				buttonClass: "fullButton"
			},
            onEditButton : {
                type : "button",
                label : "编辑",
                action : "onEdit"
            },
            onisUseButton : {
                type : "button",
                label : "停用",
                action : "onBlockUp"
            },
            toJoinShopButton : {
                type : "button",
                label : "查看报名商家",
                action : "toJoinShop"
            },
            toSignUpButton : {
                type : "button",
                label : "去报名",
                action : "toSignUp"
            },
            dropOut : {
                type : "button",
                label : "退出",
                action : "dropOut"
            },
            signUpButton : {
                type : "button",
                label : "报名",
                action : "signUp"
            }
        },
        // 添加优惠活动Layout
        getEdtLayout: function(){
            return [{
                type : "form",
                fields : this.getFormItems(["title", "logo", "tp", "isUse", "inviteDateFrom", "inviteDateTo", "preheatDateFrom", "preheatDateTo", "execDateFrom", "execDateTo", "remark", "onSaveButton"], true)
            }];
        },
        getDtlLayout : function () {
            return [{
                type : "form",
                fields : this.getFormItems(["title", "logo", "tp", "isUse", "inviteDateFrom", "inviteDateTo", "preheatDateFrom", "preheatDateTo", "execDateFrom", "execDateTo", "onEditButton", "onisUseButton", "toJoinShopButton"], true)
            }];
        },
        // 获取邀约期的活动详情的layout
        getInviteDtlLayout : function (item) {
            return [{
                type: 'content',
                content: '<div>{remark}</div>'
            }, {
                type: 'form',
                fields: this.getFormItems(['toSignUpButton'])
            }];
        },
        getSignUpLayout : function () {
            return [{
                type : "form",
                fields : this.getFormItems(["title", "mats", "signUpButton"], true)
            }]
        },
        onEdit : function (data) {
            window.moveToView("activityEdt", data._id);
        },
        onBlockUp : function (data, widget) {
            this.exec("stopUse", {_id : data._id}).then(lang.hitch(this, function (data) {
                if (data && data.data && data.data.ok === 1) {
                    widget.cqRefresh();
                } else {
                    alert("停用失败");
                }
            }));
        },
        // 退出
        dropOut : function (data, widget) {
            var params = {};
            params._id = data._id;
            params.fromShopId = data.fromShopId;
            params.joinShopId = this.getShopId();
            this.exec("exit", params).then(lang.hitch(this, function (data) {
                if (data && data.data && data.data.ok === 1) {
                    widget.cqRefresh();
                } else {
                    alert("退出失敗");
                }
            })); 
        },
        signUp : function (data) {
            var params = {};
            params._id = data._id;
            params.fromShopId = data.fromShopId;
            params.shopInfo = {};
            // 获取当前商家的信息
            shop.getCurrentShopInfo().then(lang.hitch(this, function (shopData) {
                if (shopData) {
                    params.shopInfo.joinShopId = this.getShopId();
                    params.shopInfo.shopName = shopData.shopName;
                    params.shopInfo.contactName = shopData.contactName;
                    params.shopInfo.tel = shopData.tel || "";
                    params.shopInfo.signUpTime = new Date();
                    params.shopInfo.mats = [];
                    array.forEach(data.mats, function (mat) {
                        params.shopInfo.mats.push({
                            mId : mat._id,
                            mName : mat.mName || ""
                        });
                    }, this);
                    this.exec("signUp", params).then(lang.hitch(this, function (data) {
                        if (data && data.data && data.data.ok === 1) {
                            alert("报名成功");
                            history.back();
                        } else {
                            alert("报名失败");
                        }
                    })); 
                } else {
                    alert("获取当前商家信息失败");
                }
            }));
            
        },
        toJoinShop : function (data) {
            window.moveToView("showSignUpShops", data._id);
        },
        toSignUp : function (data) {
            window.moveToView("activitySignUp", data._id);
        },
        // 保存优惠活动
        save: function(data, dataList){
            var msg = this.getDataValidMsg(data, ['title']);
			if (msg) {
				alert(msg);
				return;
			}
            this.exec('save', data).then(function (matData) {
				if (matData.data && matData.data.ok === 1) {
					history.back();
				} else {
					alert("保存失败");
				}
			});
        },
        // 加载动态的url
        getListUrl: function(){
            return this.getBaseUrl() + '/load';
        },
        getInviteListParam : function (cqRefInfo) {
            var params = {
                shopId : this.getPlatformShopId(),
                state : 1,
                isUse : true
            };
            var paramValue = query.getQueryValue(cqRefInfo.search);
            if (paramValue) {
                params.search = paramValue;
            }
            return params;
        },
        // 加载动态的条件
        getListParam: function(cqRefInfo){
            var params = {
                shopId : this.getShopId()
            };
            var paramValue = "";
            paramValue = query.getQueryValue(cqRefInfo.state);
            // 如果为0或者不存在，这不添加条件
            if (!paramValue || paramValue == 0) {
                
            } else if (paramValue == 4){
                params.isUse = false;
            } else {
                params.state = paramValue;
                params.isUse = true;
            }
            paramValue = "";
            paramValue = query.getQueryValue(cqRefInfo.search);
            if (paramValue) {
                params.search = paramValue;
            }
            return params;
        },
        onListClick : function (item) {
            window.moveToView("activityDtlB", item._id);
        },
        onInviteListClick : function (item) {
            window.moveToView ("inviteActivityDtl", item._id);
        },
        loadDataFormShopId : function (params) {
            if (!lang.isObject(params)) {
				params = {
					_id: params
				};
			} else {
				params = params.split('_');
				// 字符串处理
				if (params.length === 2) {
					params = {
						_id: params[0],
						fromShopId: params[1]
					};
				} else {
					params = {
						_id: params[0]
					};
				}
			}
            params.fromShopId = this.getPlatformShopId();
			return this.exec('loadById', params);
        },
        // 加载指定动态
        // 参数:
        //      _id
        loadById: function (params){
            if (!lang.isObject(params)) {
				params = {
					_id: params
				};
			} else {
				params = params.split('_');
				// 字符串处理
				if (params.length === 2) {
					params = {
						_id: params[0],
						fromShopId: params[1]
					};
				} else {
					params = {
						_id: params[0]
					};
				}
			}
			return this.exec('loadById', params);
        },
        loadActivityByShopId : function (params) {
            if (!params.cqViewParam.params) {
                return;
            }
            var def = new Deferred();
			var m = params.cqViewParam.params;
			this.loadDataFormShopId(m).then(lang.hitch(this, function (data) {
				// 获取商家的信息
				data = data.data.item;
				def.resolve(data);
			}));
			return def;
        },
        loadOneActivity : function (params) {
            if (!params.cqViewParam.params) {
                return;
            }
            var def = new Deferred();
			var m = params.cqViewParam.params;
			this.loadById(m).then(lang.hitch(this, function (data) {
				// 获取商家的信息
				data = data.data.item;
				def.resolve(data);
			}));
			return def;
        },
        // 删除优惠活动
        // 参数:
        //      _id
        delete: function(){},
        onInviteDataReady: function(widget){
            var pageData = widget.getData();
            var nowDate = new Date();
            if (pageData.isUse && (nowDate > pageData.inviteDateFrom) && (nowDate < pageData.inviteDateTo)) {
                widget.showByFields(["toSignUpButton"]);
            } else {
                widget.hideByFields(["toSignUpButton"]);
            }
        },
        onInviteDtlDataReady : function (widget) {
            var pageData = widget.getData();
            var shopIds = [];
            array.forEach(pageData.shops, function (shopData) {
                shopIds.push(shopData.joinShopId);
            }, this);
            
            if (shopIds.indexOf(this.getShopId()) === -1) {
                widget.showByFields(["toSignUpButton"]);
                widget.hideByFields(["dropOut"]);
            } else {
                widget.showByFields(["dropOut"]);
                widget.hideByFields(["toSignUpButton"]);
            }
        },
        // 活动详情数据加载完成后调用的方法
        onDtlDataReady : function (widget) {
            // 设置字段不可编辑
            var fields = ["title", "logo", "tp", "isUse", "inviteDateFrom", "inviteDateTo", "preheatDateFrom", "preheatDateTo", "execDateFrom", "execDateTo"];
            widget.disableByFields(fields);
            var pageData = widget.getData();
            if (new Date() > pageData.inviteDateFrom) {
                widget.hideByFields(["onEditButton"]);
            } else {
                widget.showByFields(["onEditButton"]);
            }
            if (!pageData.isUse) {
                widget.hideByFields(["onisUseButton"]);
            } else {
                widget.showByFields(["onisUseButton"]);
            }
        },
        onSignUpDataReady : function (widget) {
            widget.disableByFields(["title"]);
        },
        getTpStr : function (tp) {
            var options = {
                1 : "横幅推荐",
                2 : "24节气"
            };
            return options[tp];
        },
        onDataListReady: function(){},
        getListProp : function (item) {
            var labelStr = "";
            labelStr += "<div>活动标题：" + item.title + "</div>";
            labelStr += "<div>活动类型：" + this.getTpStr(item.tp) + "</div>";
            
            return {
                icon : item.logo,
                label: labelStr,
				data: item,
                variableHeight : true
            };
        }
    });
    var activityBo = new ActivityBo();
    activityBo.Bo = ActivityBo;
	return activityBo;
});
