﻿// 订单系统商家端
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "cq/util/config/config",
    '../../BoBase',
    "./_Mixin",
    "cq/util/sys/query",
    "bob/shop/shop",
    "cq/util/sys/date",
    "bob/layout/shelf/b"
], function (declare,lang, array,config,BoBase,_Mixin, query, shop, date, b) {
    var ActivityBBo = declare("", [BoBase.B, _Mixin], {
        fields: {
            
            mats : {
                type : "ref",
                label : "参与商品",
                dataProvider : "bob/mat/matB",
                targetMethod : "getListUrlForCurrentShop",
                labelFields : "mName",
                searchField : "mName",
                canEdit : true,
                pageSize : 10,
				query: {
					isUse: true,
					qty:1
				},
                multiselect : "multiselect"
            },
            onSaveButton: {
				type: "button",
				label: "保存",
				action: "save",
				buttonClass: "fullButton"
			},
            onEditButton : {
                type : "button",
                label : "编辑",
                action : "onEdit"
            },
            onisUseButton : {
                type : "button",
                label : "停用",
                action : "onBlockUp"
            },
            toJoinShopButton : {
                type : "button",
                label : "查看报名商家",
                action : "toJoinShop"
            },
            toSignUpButton : {
                type : "button",
                label : "去报名",
                action : "toSignUp"
            },
            dropOut : {
                type : "button",
                label : "退出",
                action : "dropOut"
            },
            signUpButton : {
                type : "button",
                label : "确认报名",
                action : "signUp"
            },
            contactName: {
                type: "text",
                label: "联系人",
                notNull: true
            },
            tel: {
                type: "text",
                label: "联系电话",
                notNull: true
            },
            signUpRemark: {
                type: "textarea",
                label: "备注",
                notNull: true
            },
            shelfDesignButton : {
                type:"button",
                label:"设计海报",
                action:"shelfDesign"
            }
        },
        // 编辑活动layout
        getEdtLayout: function(){
            return [{
                type : "form",
                fields : this.getFormItems(["logo", "title", "tp", "isUse", 
                    "inviteDateFrom", "inviteDateTo", 
                    "preheatDateFrom", "preheatDateTo", 
                    "execDateFrom", "execDateTo", 
                    "remark", "onSaveButton"], true)
            }];
        },
        // 商家端预览活动layout
        getDtlLayout : function () {
            return [{
                type : "form",
                fields : this.getFormItems(["logo", "title", "tp", "isUse", "inviteDateFrom", "inviteDateTo", "preheatDateFrom", "preheatDateTo", "execDateFrom", "execDateTo", "onEditButton", "onisUseButton", "shelfDesignButton", "toJoinShopButton"],
                false)
            }];
        },
        // 设计海报函数
        shelfDesign:function(data, widget){
            // 如果没有id，则去服务器新增一行空的货架数据
                // 更新当前活动的海报  widget.setData()
                // 跳转到海报设计页面
            // 否则直接跳转
            if(data&&data.shelfId){
                window.moveToView("shelfEdit", data.shelfId);
            }else{
                b.save({title:data.title}).then(lang.hitch(this, function(dt){
                    if(dt && dt.data && dt.data.ok === 1){
                        data.shelfId = dt.data.item._id;
                        this.exec("updateShelf", {_id: data._id, shelfId: data.shelfId}).then(lang.hitch(this, function(d){
                            if(d && d.data && d.data.ok === 1){
                                widget.cqRefresh();
                                window.moveToView("shelfEdit", data.shelfId);
                            }
                        }));
                    }else {
                        alert("新增货架失败");
                    }
                }));
            }
        },
        // 编辑活动layout
        onEdit : function (data) {
            window.moveToView("activityEdt", data._id);
        },
        // 停用活动
        onBlockUp : function (data, widget) {
            this.exec("stopUse", {_id : data._id}).then(lang.hitch(this, function (data) {
                if (data && data.data && data.data.ok === 1) {
                    widget.cqRefresh();
                } else {
                    alert("停用失败");
                }
            }));
        },
        // 退出活动
        dropOut : function (data, widget) {
            var params = {};
            params._id = data._id;
            params.fromShopId = data.fromShopId;
            params.joinShopId = this.getShopId();
            this.exec("exit", params).then(lang.hitch(this, function (data) {
                if (data && data.data && data.data.ok === 1) {
                    widget.cqRefresh();
                } else {
                    alert("退出失敗");
                }
            })); 
        },
        // 活动报名
        signUp : function (data) {
            // 字段为空检查
            var msg = this.getDataValidMsg(data, ["contactName", "tel"]);
            if(msg){
                alert(msg);
                return;
            }
            var params = {};
            params._id = data._id;
            params.fromShopId = data.fromShopId;
            params.shopInfo = {};
            // 获取当前商家的信息
            // 检查登录状态
            shop.loadMe().then(lang.hitch(this, function (shopData) {
                if (shopData) {
                    params.shopInfo.joinShopId = this.getShopId();
                    params.shopInfo.shopName = shopData.shopName;
                    params.shopInfo.contactName = data.contactName;
                    params.shopInfo.tel = data.tel;
                    params.shopInfo.signUpRemark = data.signUpRemark;
                    params.shopInfo.logo = shopData.logo||"";
                    params.shopInfo.signUpTime = new Date();
                    params.shopInfo.mats = [];
                    array.forEach(data.mats, function (mat) {
                        params.shopInfo.mats.push({
                            mId : mat._id,
                            mName : mat.mName || "",
                            logo: mat.logo||""
                        });
                    }, this);
                    this.exec("signUp", params).then(lang.hitch(this, function (data) {
                        if (data && data.data && data.data.ok === 1) {
                            alert("报名成功");
                            history.back();
                        } else {
                            alert(data&&data.data&&data.data.message||"报名失败");
                        }
                    })); 
                } else {
                    alert("获取当前商家信息失败");
                }
            }));
            
        },
        // 商家端查看报名商家
        toJoinShop : function (data) {
            window.moveToView("showSignUpShops", data._id);
        },
        // 商家报名layout
        getSignUpLayout : function () {
            return [{
                type : "form",
                fields : this.getFormItems(["title", "contactName", "tel", "signUpRemark", "signUpButton"], true)
            }]
        },
        // 点击去报名按钮
        toSignUp : function (data) {
            window.moveToView("activitySignUp", data._id+"_"+data.fromShopId);
        },
        // 保存活动
        save: function(data, dataList){
            var msg = this.getDataValidMsg(data, ['title']);
			if (msg) {
				alert(msg);
				return;
			}
            this.exec('save', data).then(function (result) {
				if (result.data && result.data.ok === 1) {
					history.back();
				} else {
					alert(result.data.msg||"保存失败");
				}
			});
        },
        // 加载活动的url
        getListUrl: function(){
            return this.getBaseUrl() + '/load';
        },
        getInviteListParam0 : function (cqRefInfo) {
            var params = {
                shopId : this.getPlatformShopId(),
                state : 1
            };
            var paramValue = query.getQueryValue(cqRefInfo.search);
            if (paramValue) {
                params.search = paramValue;
            }
            params.fromShopId = params.shopId;
            return params;
        },
        getInviteListParam1 : function (cqRefInfo) {
            var params = {
                shopId : this.getPlatformShopId(),
                state : 1
            };
            var paramValue = query.getQueryValue(cqRefInfo.search);
            if (paramValue) {
                params.search = paramValue;
            }
            params.fromShopId = window.__shop.dftOpShop;
            return params;
        },
        getInviteListParam2 : function (cqRefInfo) {
            var params = {
                shopId : this.getPlatformShopId(),
                state : 1
            };
            var paramValue = query.getQueryValue(cqRefInfo.search);
            if (paramValue) {
                params.search = paramValue;
            }
            delete params.fromShopId;
            return params;
        },
        // 加载活动的条件
        getListParam: function(cqRefInfo){
            var params = {
                shopId : this.getShopId()
            };
            var paramValue = "";
            paramValue = query.getQueryValue(cqRefInfo.state);
            // 如果为0或者不存在，这不添加条件
            if (!paramValue || paramValue == 0) {
                
            } else if (paramValue == 4){
                params.isUse = false;
            } else {
                params.state = paramValue;
                params.isUse = true;
            }
            paramValue = "";
            paramValue = query.getQueryValue(cqRefInfo.search);
            if (paramValue) {
                params.search = paramValue;
            }
            return params;
        },
        // 活动列表点击事件
        onListClick : function (item) {
            window.moveToView("activityDtlB", item._id);
        },
        // 活动列表点击事件
        onInviteListClick : function (item) {
            window.moveToView ("inviteActivityDtl", item._id+"_"+item.fromShopId._id);
        },
        // 加载指定活动信息
        // 参数:
        //      _id
        loadById: function (params){
            if(!params.cqViewParam.params){
                return;
            }
			return this.exec('loadById', {
                _id: params.cqViewParam.params.split("_")[0],
                shopId: this.getShopId(),
                fromShopId: params.cqViewParam.params.split("_")[1]||this.getShopId()
            }).then(lang.hitch(this, function(result){
                var item = result&&result.data&&result.data.item;
                //item.createAt = date.formatISODateMinutes(item.createAt);
                /*if(item.shops.length){
                    array.forEach(item.shops, function(shop){
                        shop.signUpTime = date.formatISODateMinutes(shop.signUpTime);
                    });
                }*/
                return item||{};
            }));
        },
        // 邀约期活动详情
        onDataReadyForInvite: function(widget){
            var pageData = widget.getData();
            var shopIds = [];
            array.forEach(pageData.shops, function (shopData) {
                shopIds.push(shopData.joinShopId);
            }, this);
            widget.hideByFields(["dropOut","toSignUpButton"]);
            if (shopIds.indexOf(this.getShopId()) > -1) {
                widget.showByFields(["dropOut"]);
            } else {
                widget.showByFields(["toSignUpButton"]);
            }
            var nowDate = new Date();
            if (pageData.isUse && (nowDate < pageData.inviteDateFrom) && (nowDate > pageData.inviteDateTo)) {
                widget.hideByFields(["toSignUpButton"]);
            }
        },
        // 活动详情数据加载完成后调用的方法
        // 商家端录入
        onDataReady : function (widget) {
            // 设置字段不可编辑
            // 设置不可编辑是不是直接在layout中设置?
            var fields = ["title", "logo", "tp", "isUse", "inviteDateFrom", "inviteDateTo", "preheatDateFrom", "preheatDateTo", "execDateFrom", "execDateTo"];
            widget.disableByFields(fields);
            var data = widget.getData();
            if (new Date() > data.inviteDateFrom) {
                widget.hideByFields(["onEditButton"]);
            } else {
                widget.showByFields(["onEditButton"]);
            }
            if (!data.isUse) {
                widget.hideByFields(["onisUseButton"]);
            } else {
                widget.showByFields(["onisUseButton"]);
            }
        },
        onSignUpDataReady : function (widget) {
            widget.disableByFields(["title"]);
        }
    });
    
    var activityBBo = new ActivityBBo();
    activityBBo.Bo = ActivityBBo;
    return activityBBo;
});