﻿define([
    "dojo/_base/declare",
    "cq/app/config",
    "./_Mixin",
    "dojo/_base/lang",
    '../../BoBase',
    'cq/util/sys/query'
], function (declare,appConfig,_Mixin, lang,BoBase, query) {
    var CouponCBo = declare('', [BoBase.C, _Mixin], {
        // 加载活动的url
        getListUrl: function(){
            return this.getBaseUrl() + '/load';
        },
		getVfListUrlForHistory: function(){
			return this.getBaseUrl()+ '/load?shopId='+this.getShopId()+"&tp=2&isUse=true&orderBy=-execDateTo";
		},
        // 加载预热期的活动列表参数
        getListParam: function(cqRefInfo){
            var params = {
                shopId : this.getShopId(),
                state : 2,
                isUse : true,
                orderBy: "execDateFrom"
            };
            var paramValue = query.getQueryValue(cqRefInfo.search);
            if (paramValue) {
                params.search = paramValue;
            }
            return params;
        }, 
        getExecDataStr : function (execDate) {
            // 获取时间的日期，小时
            var execDate = new Date(execDate);
            var month = execDate.getMonth() + 1;
            var day = execDate.getDate();
            var hours = execDate.getHours();
            var minutes = execDate.getMinutes();
            return (month < 10 ? ("0" + month) : month) + "月" + (day < 10 ? ("0" + day) : day) + "日" + (hours < 10 ? ("0" + hours) : hours) + ":" + (minutes < 10 ? ("0" + minutes) : minutes);
        },
        // 处理item中的数据
        getListProp : function (data,widget,options) {
            data.execDateFromStr = this.getExecDataStr(data.execDateFrom);
            return data;
        },
        onClickList : function (data, type, list) {
            if ("preHeadWarn" == type) {
                //alert("开售提醒");
                var sd = new Date(data.execDateFrom);
                sd.setMinutes(sd.getMinutes()-10);
                this.toNotice({
                    shelfId: data.shelfId,
                    _id: data._id,
                    title: data.title,
                    execDateTo: sd
                });
            }else{
                data.shelfId&&window.moveToView("shelf", data.shelfId);
            }
        },
        toNotice: function(data){
            require([
                "bob/im/inform/c"
            ], lang.hitch(this, function(inform){
                var item = {};
                item.tempData = {
                    "first": "活动即将开始",
                    "orderSn": data._id,
                    "orderStatus": "活动即将开始",
                    "remark": "您关注的活动即将开始了，快去看看吧"
                };
                item.shelfId = data.shelfId;
                item.billType = 1;
                item.bid = data._id;
                item.alarmTime = data.execDateTo;
                item.url = window.location.href;
                item.msgContent = "您关注的活动即将开始了，快去看看吧";
                inform.save(item);
            }));
        },
        getActiviy:function(data,widget,options){
            if(options&&options.currentShop){
                options.fromShopId = this.getShopId();
            }
			//干劲：任意商家都可以搞活动，消费者通过在村头APP打开商家首页，也需要显示活动信息
			if(widget.cqRefInfo&&widget.cqRefInfo.cqViewParam&&widget.cqRefInfo.cqViewParam.params) options.fromShopId = widget.cqRefInfo.cqViewParam.params;
            return this.exec("load",options||{}).then(function(data){
                var items = data&&data.data&&data.data.items||[];
                for(var i=0;i<items.length;i++){
                    items[i].shelfTarget = items[i].shelfId?"#shelf-"+items[i].shelfId:"";
                }
                return data;
            });
        },
        getActiviyById:function(data,widget,options){
            return this.exec("loadById",{
                _id:options._id?options._id:"585f654503696a5f5d6ddebd",
                shopId:options.shopId?options.shopId:this.getShopId
            }); 
        },
        loadByShelfId: function(widget){
            return this.exec("loadByShelfId", {
                shelfId: widget.cqViewParam.params
            }).then(lang.hitch(this, function(result){
                var item = result&&result.data&&result.data.item||{};
                item.st = "距离开始";
                item.et = "距离结束";
                return item;
            }));
        },
        onDataReady: function(widget){
            var data = widget.getData();
            widget.hideByFields(["deadline1", "deadline2"]);
            if(!data._id){
                return;
            }
            //execDateFrom
            if(new Date()<new Date(data.execDateFrom)){
                widget.showByFields(["deadline1"]);
            }else if(new Date >=new Date(data.execDateFrom)&&new Date<=new Date(data.execDateTo)){
                widget.showByFields(["deadline2"]);
            }
        }
    });
    var couponCBo = new CouponCBo();
    couponCBo.Bo = CouponCBo;
    return couponCBo;
});