﻿// 订单系统商家端
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/util/config/config",
    '../../BoBase',
    "./_Mixin",
    "cq/app/config",
    'cq/util/sys/query',
    "bob/user/consumer"
], function (declare,lang,config,BoBase,_Mixin, appConfig, query, consumer) {
    var PreSaleBBo = declare("", [BoBase.C, _Mixin], {
        getDtlLayout : function () {
            return [{
                type : "content",
                content : "<div>累计收入</div>"
            }, {
                type : "content",
                content : '<div>'+
                    '<span class="cq-field-input" data-cq-field="myIncome"></span>'+
                    '</div>'
            }, {
                type : "content",
                content : '<div class = "mat-item-cells">'+
                            '<div class="item-cell cq-from-button cq-action" cq-action="getMyCode" data-cq-field="myCode">'+
                                '<div>'+
                                    '<div class="matShop-icon">'+
                                        '<span>我的二维码</span>'+
                                    '</div>'+
                                '</div>'+
                                '<div></div>'+
                            '</div>'+
                            '<div class="item-cell cq-from-button cq-action" cq-action="onMyFans" data-cq-field="myCode">'+
                                '<div>'+
                                    '<div class="matShop-icon">'+
                                        '<span>我的粉丝数</span>'+
                                    '</div>'+
                                '</div>'+
                                '<div>'+
                                    '<span class="cq-field-input" data-cq-field="myFans"></span>'+
                                '</div>'+
                            '</div>'+
                            '<div class="item-cell cq-from-button cq-action" cq-action="onMyIncome" data-cq-field="myCode">'+
                                '<div>'+
                                    '<div class="matShop-icon">'+
                                        '<span>累计收入</span>'+
                                    '</div>'+
                                '</div>'+
                                '<div>'+
                                    '<span class="cq-field-input" data-cq-field="myIncome"></span>'+
                                '</div>'+
                            '</div>'+
                            '<div class="item-cell cq-from-button cq-action" cq-action="onExchangeIncome" data-cq-field="myCode">'+
                                '<div>'+
                                    '<div class="matShop-icon">'+
                                        '<span>申请兑换</span>'+
                                    '</div>'+
                                '</div>'+
                                '<div></div>'+
                            '</div>'+
                        '</div>'
            }];
        },
        getMyCode : function () {
            alert("我的二维码");  
        },
        onExchangeIncome : function () {
            window.moveToView("exchangeIncome");
        },
        onMyFans : function () {
            window.moveToView("myFansList");  
        },
        onMyIncome : function () {
            window.moveToView("myIncomeList");  
        },
        onDataReady : function (widget) {
            var pageData = widget.getData();
            // 设置字段不能编辑
            var fields = ["mId", "startTime", "endTime", "startPayTime", "endPayTime", "isUse", "earnest", "finalPayment", "postNum", "payEarNum",  "payNum", "ladders"];
            widget.disableByFields(fields);
            // 当前时间小于活动开始时间才可以编辑
            if (pageData.isUse) {
                widget.showByFields(["onEndPreSale"]);
                if (new Date() < new Date(pageData.startTime)) {
                    widget.showByFields(["onEditPreSale"]);
                } else {
                    widget.hideByFields(["onEditPreSale"]);
                }
            } else {
                widget.hideByFields(["onEditPreSale", "onEndPreSale"]);
            }
        },
        
        loadUserInformation : function (params) {
            // 获取当前登录的用户ID
            var userId = appConfig.session.userId;
            // 设置页面的默认值
            var pageData = {
                myFans : 0,
                myIncome : 0
            };
            if (!userId) {
                alert("请先登录");
                return;
            }
            return consumer.loadUserInformation(userId).then(lang.hitch(this, function (result) {
                if (result&&result.data&&result.data.ok == 1) {
                    // 刷新页面的数据
                    var itemData = result.data.item;
                    pageData.myFans = itemData.fansNum1 + itemData.fansNum2 + itemData.fansNum3;
                    pageData.myIncome = itemData.disPenddingAmt || 0.00;
                    return pageData;
                } else {
                    return pageData;
                }
                
            }));
        }
    });
    
    var preSaleBBo = new PreSaleBBo();
    preSaleBBo.Bo = PreSaleBBo;
    return preSaleBBo;
});