﻿// 订单系统商家端
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/util/config/config",
    '../../BoBase',
    "cq/util/edit/overlay",
	"cq/widgets/item/mk/UserCard",
    "cq/util/sys/date",
    "bob/mk/card",
    "bob/user/consumer"
], function (declare,lang,config,BoBase, overlay, UserCard, date, card, consumer) {
    var ClientDistributeBo = declare("", [BoBase.C], {
        modalName:"mk/clientDistribute",
        //字段名
        fields:{
            fansNum1 : {
                type : 'number',
                label : '一级粉丝数',
                fixedTo: 0
            },
            fansNum2 : {
                type : 'number',
                label : '二级粉丝数',
                fixedTo: 0
            }, 
            fansNum3 : {
                type : 'number',
                label : '三级粉丝数',
                fixedTo: 0
            },
            disPenddingAmt : {
                type : 'number',
                label : '待确认收益',
                fixedTo: 2
            },
            disRecieptAmt : {
                type : 'number',
                label : '已提现收益',
                fixedTo: 2
            },
            disRaiseableAmt : {
                type : 'text',
                label : '可提现收益',
                fixedTo: 2
            },
            type : {
                type : 'options',
                label : '兑换方式',
                options: {
                    "3": "提现到余额"
                },
                selected: 3
            }, 
            cgIncome : {
                type : 'number',
                label : '本次兑换',
                placeHolder : '小于等于可提现',
                range: "(0,)"
            },
            outAmt : {
                type : 'text',
                label : '兑换数量'
            },
            createAt : {
                type : 'dateTime',
                label : '时间'
            },
            incomeType : {
                type : 'options',
                label : '类型',
                options: {
                    "1":'新关注收益',
                    "2":'分销收益',
                    "3":'提现到余额',
                    "4":'提现到微信'
                }
            },
            onSaveButton: {
				type: "button",
				label: "提交",
				action: "save",
				buttonClass: "fullButton"
			}
        },
        // 我的兑换页面加载方式
        getExIncomeLayout : function () {
            return [{
                type : "form",
                fields : this.getFormItems(["disRaiseableAmt", "type", "cgIncome", "onSaveButton"], true)
            }];
        },
        // 我的累计收入页面加载方式
        getMyIncomeLayout : function () {
            return [{
                type : "form",
                fields : this.getFormItems(["disPenddingAmt", "disRecieptAmt", "disRaiseableAmt"], true)
            }];
        },
        // 我的粉丝页面加载方式
        getMyFansLayout : function () {
            return [{
                type : "form",
                fields : this.getFormItems(["fansNum1", "fansNum2", "fansNum3"], true)
            }];
        },
        parseReason:function(reasonId){
			var reason="";
			var reasons={
				"1":'新关注收益',
				"2":'分销收益',
				"3":'提现到积分',
				"4":'提现到微信'
			};
			reason=reasons[reasonId]||"未知";
			return reason;
		},
        // 主页面的加载方式
        getQRCodeLayout : function () {
            return [{
                type : "content",
                content : '<div class="user-content">'+
                        '<div class="user-name">累计收入</div>'+
                        '<div class="user-point">'+
                            '<span class="cq-field-input" data-cq-field="disRaiseableAmt"></span>'+
                        '</div>'+
                    '</div>'+
                    '<div class = "mat-item-cells">'+
                        '<div class="item-cell cq-from-button cq-action" cq-action="getMyCode" data-cq-field="myCode">'+
                            '<div>'+
                                '<div class="matShop-icon">'+
                                    '<span>分销二维码</span>'+
                                '</div>'+
                            '</div>'+
                            '<div><span>点击查看</span></div>'+
                        '</div>'+
                        '<a class="item-cell" href="#myFansList">'+
                            '<div>'+
                                '<div class="matShop-icon">'+
                                    '<span>我的粉丝</span>'+
                                '</div>'+
                            '</div>'+
                            '<div>'+
                                '<span class="cq-field-input" data-cq-field="myFans"></span>'+
                            '</div>'+
                        '</a>'+
                        '<a class="item-cell" href="#myIncomeList">'+
                            '<div>'+
                                '<div class="matShop-icon">'+
                                    '<span>累计收入</span>'+
                                '</div>'+
                            '</div>'+
                            '<div>'+
                                '<span class="cq-field-input" data-cq-field="disRaiseableAmt"></span>'+
                            '</div>'+
                        '</a>'+
                        '<a class="item-cell" href="#exchangeIncome">'+
                            '<div>'+
                                '<div class="matShop-icon">'+
                                    '<span>收益兑换</span>'+
                                '</div>'+
                            '</div>'+
                            '<div><span>马上兑换</span></div>'+
                        '</a>'+
                    '</div>'
            }];
        },
        getMyCode : function () {
            // 显示二维码
            window.busy();
            consumer.getUserDiscard().then(lang.hitch(this, function (result){
                if(result&&result.data&&result.data.ok === 1){
                    // 显示overlay
                    if (!this.userCardNode) {
                        this.userCardNode = new UserCard();
                    }
                    this.userCardNode.init({url : result.data.item.url}).then(lang.hitch(this, function() {
                        overlay.hide();
                    }));
                    overlay.showElement(this.userCardNode.domNode);
                    window.free();
                }else {
                    window.free();
                    alert(result&&result.data&&result.data.msg || "数据错误!");
                } 
            }));
        },
        onMyFansDataReady : function (widget) {
            widget.disableByFields(["fansNum1", "fansNum2", "fansNum3"]);
        },
        onMyIncomeDataReady : function (widget) {
            widget.disableByFields(["disPenddingAmt", "disRecieptAmt", "disRaiseableAmt"]);
        },
        onExIncomeDataReady : function (widget) {
            widget.disableByFields(["disRaiseableAmt", "type"]);
        },
        checkedFiled : function (data) {
            if (parseFloat(data.disRaiseableAmt) == 0) {
                return "可提现数量为0，无法兑换";
            }
            if (!data.cgIncome) {
                return "请输入兑换的数量";
            }
            if (parseFloat(data.cgIncome) > parseFloat(data.disRaiseableAmt)) {
                return "可兑换数量小于您输入的数量！"
            }
            return "";
        },
        save : function (data, dataList) {
            // 保存之前对数据进行处理
            var msg = this.checkedFiled(data);
            if (msg) {
                alert(msg);
                return;
            }
            consumer.exchangeDisAmount({amount : data.cgIncome}).then(lang.hitch(this, function (result) {
                if (result && result.data && result.data.ok === 1) {
                    alert("保存成功");
                } else {
                    alert(result&&result.data&&result.data.message||"保存失败")
                }
            }))
        },
        loadUserInformation : function (params) {
            return consumer.getCurrentUser().then(lang.hitch(this, function(result){
                var item = result ||{};
                item.myFans = item.fansNum1 + item.fansNum2 + item.fansNum3;
                /*item.fansNum1 = item.fansNum1 || 0;
                item.fansNum2 = item.fansNum2 || 0;
                item.fansNum3 = item.fansNum3 || 0;
                
                
                item.disPenddingAmt = item.disPenddingAmt || "0.00";
                item.disRecieptAmt = item.disRecieptAmt || "0.00";
                item.disRaiseableAmt = item.disRaiseableAmt || "0.00";*/
                return item;
            }));
        }
    });
    
    var clientDistributeBo = new ClientDistributeBo();
    clientDistributeBo.Bo = ClientDistributeBo;
    return clientDistributeBo;
});