﻿// 订单系统商家端
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    '../../BoBase',
    "./_Mixin",
    'cq/util/sys/query'
], function (declare,lang, array, BoBase,_Mixin, query) {
    var O = declare("", [BoBase.B, _Mixin], {
        fields: {
            save: {
				type: "button",
				label: "保存",
				action: "save",
				buttonClass: "fullButton"
			}
        },
        // 编辑页面Layout
        getEdtLayout: function(){
            return [{
                type : "form",
                fields : this.getFormItems(["title","sd", "ed", "gold", "rule", "save"], true)
            }];
        },
        // 保存数据
        save: function(data){
            msg = this.getDataValidMsg(data, ["title","sd", "ed", "gold", "rule"]);
            if(msg){
                alert(msg);
                return;
            }
            this.exec("save", data).then(lang.hitch(this, function(result){
                if(result&&result.data&&result.data.ok==1){
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"保存失败");
                }
            }));
        },
        onDataReady: function(widget){
            var data = widget.getData();
            widget.hideByFields(["deleteById"]);
            if(!data._id){
                return;
            }
            widget.showByFields(["deleteById"]);
        },
        // 获取数据url
        getListUrl: function(){
            return this.getBaseUrl() + '/load';
        },
        // params
        getListParam: function(cqRefInfo){
            var params = {
                shopId : this.getShopId(),
                isUse: true
            };
            var paramValue = query.getQueryValue(cqRefInfo.state);
            if (paramValue) {
                params.state = paramValue;
            }
            return params;
        },
        // 列表点击事件
        onListClick : function (item, action, widget) {
            window.moveToView("collectPraiseEdt", item._id);
        },
        loadById : function(params){
            if(!params.cqViewParam.params){
                return;
            }
			return this.exec('loadById', {
                _id: params.cqViewParam.params
            }).then(lang.hitch(this, function(result){
                var item = result&&result.data&&result.data.item;
                return item||{};
            }));
        }
    });
    var o = new O();
    o.Bo = O;
    return o;
});