﻿//订单系统公共基类
// 1、提供订单系统的基本属性
// 2、提供公用的方法
define([
    "dojo/_base/declare"
], function (declare) {
    return declare("",null,{
        modalName:"mk/discountCoupon",
        //字段名
        fields:{
            title : {
                type : 'text',
                label : '活动名称',
                placeHolder : '必填'
            },
            startDate: {
                type: "date",
                label: "开始时间"
            },
            stopDate : {
                type : 'date',
                label : '活动结束时间'
            },
            reachAmount : {
                type : 'text',
                label : '抵满金额'
            },
            amount : {
                type : 'text',
                label : '抵用金额'
            },
            userQuota : {
                type : 'text',
                label : '会员领取限额'
            },
            remark : {
                type : "textarea",
                label : "活动说明",
                canEdit : true
            },
            typeId : { //1活动奖品，2新客奖品，3注册优惠，4其他
                type : "options",
                label : "活动类型",
                options : {
                    1 : "活动奖品",
                    2 : "新客奖品",
                    3 : "注册优惠",
                    4 : "其他"
                },
                canEdit : 1
            },
            using : {
                type : 'checkbox',
                label : '是否使用'
                //canEdit : true
            },
            wholeUse : {
                type : 'checkbox',
                label : '是否全店通用'
                //canEdit : true
            },
            "fromShopId._id":{
                type:"text",
                label:"店铺id"
            }
        },
        getState: function (state) {
            var stateObj = {
                1: "未使用",
                2: "待支付",
                3: "已使用",
                4: "已作废"
            };
            return stateObj[state];
        },
        getListProp : function (data) {
            data.stateText = this.getState(data.state);
            data.shopName = data.fromShopId.shopName||"";
            data.logo = data.fromShopId.logo||"";
            var now = new Date();
            
            data.clsTxt = "coupon-item"+((data.state==1&&now<new Date(data.stopDate))?"-h":"");
            data.couponTag = "<div class='coupon-item-tag'>"+
                (now>new Date(data.stopDate)&&data.state!=3?"<img src='./images/temp/discount/overdue.png'/>":data.state==3?"<img src='./images/temp/discount/used.png'/>":"")+
            "</div>";
            data.useButton = (data.state==1&&now<new Date(data.stopDate))?
            '<a class="coupon-button" href="#couponAvailableMatList-'+data.discountId+","+data.fromShopId._id+'">立即使用</a>':"";
            return data;
        }
    });
});
