// 订单系统商家端
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/util/config/config",
    '../../BoBase',
    "./_Mixin",
    'cq/util/sys/query'
], function (declare,lang,config,BoBase,_Mixin, query) {
    var OrderBBo = declare("", [BoBase.B, _Mixin], {
        // 添加优惠活动Layout
        getEdtLayout: function(){
            return [{
                type : "form",
                fields : this.getFormItems(["title", "startDate", "stopDate", "totalNum", "reachAmount", "amount", "userQuota", "using", "wholeUse", "remark",  "typeId", "onBusinessRegistButton"], true)
            }];
        },
        // 保存优惠活动
        save: function(data, dataList){
            var msg = this.getDataValidMsg(data, ['title']);
			if (msg) {
				alert(msg);
				return;
			}
            this.exec('save', data).then(function (result) {
				if (result.data && result.data.ok === 1) {
					history.back();
				} else {
					alert("保存失败:"+result.data.msg);
				}
			});
        },
        getListUrlByUserId: function(){
            return this.getBaseUrl() + "/loadByUserId";
        },
        //
        getListCouponUrl:function(){
            return this.getBaseUrl() + '/load?shopId='+this.getShopId();
        },
        // url
        getListUrl: function(){
            return this.getBaseUrl() + '/load';
        },
        // 加载动态的条件
        getListParam: function(cqRefInfo){
            var params = {
                shopId : this.getShopId()
            };
            var paramValue = query.getQueryValue(cqRefInfo.search);
            if (paramValue) {
                params.search = paramValue;
            }
            var userId = cqRefInfo&&cqRefInfo.cqViewParam&&cqRefInfo.cqViewParam.params||"";
            if(userId){
                params.userId = userId;
            }
            paramValue = query.getQueryValue(cqRefInfo.state);
            if (paramValue) {
                params.state = paramValue;
            }
            return params;
        },
        onListClick : function (item) {
            window.moveToView("discount", item._id);
        },
        // 加载指定动态
        // 参数:
        //      _id
        loadById: function (params){
            if (!lang.isObject(params)) {
				params = {
					_id: params
				};
			} else {
				params = params.split('_');
				// 字符串处理
				if (params.length === 2) {
					params = {
						_id: params[0],
						fromShopId: params[1]
					};
				} else {
					params = {
						_id: params[0]
					};
				}
			}
			return this.exec('loadById', params);
        },
        loadOneDiscount : function (params) {
            if (!params.cqViewParam.params) {
                return;
            }
            var def = new Deferred();
			var m = params.cqViewParam.params;
			this.loadById(m).then(lang.hitch(this, function (data) {
				// 获取商家的信息
				data = data.data.item;
				def.resolve(data);
			}));
			return def;
        },
        // 删除优惠活动
        // 参数:
        //      _id
        delete: function(){},
        // 依据fromShopId获得商家的优惠券
        loadAvailableByUserSelf : function (fromShopId) {
            return this.exec("loadAvailableByUserSelf", {fromShopId : fromShopId});
        },
        // 用户自领，一次一张
        getCouponByUserSelf : function (params) {
            return this.exec("getCouponByUserSelf", params);
        }
    });
    
    var orderBBo = new OrderBBo();
    orderBBo.Bo = OrderBBo;
    return orderBBo;
});