﻿//订单系统公共基类
// 1、提供订单系统的基本属性
// 2、提供公用的方法
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "cq/util/image/blob"
], function (declare, lang, Deferred, blob) {
    return declare("",null,{
        modalName:"mk/dailyRec",
        //字段名
        fields:{
            _id: {
                type: "text"
            },
            title : {
                type : 'text',
                label : '标题',
                placeHolder : '必填',
                notNull : true
            },
            sd : {
                type : 'date',
                label : '开始推荐日期',
                notNull : true
            },
            ed : {
                type : 'date',
                label : '结束推荐日期',
                notNull : true
            },
            signUpDateFrom : {
                type : 'date',
                label : '开始报名日期',
                notNull : true
            },
            signUpDateTo : {
                type : 'date',
                label : '结束报名日期',
                notNull : true
            },
            logo : {
                type : 'image',
                label : '封面图',
                notNull : true
            },
            isUse : {
                type : 'checkbox',
                label : '使用',
                notNull : true
            },
            content: {
                type: "richText",
                label: "推荐内容",
                notNull: true
            },
            remark : {
                type: "richText",
                label: "报名介绍"
            },
            enroll : {
                type: "button",
                label: "报名",
                action: "enroll"
            },
            quit : {
                type: "button",
                label: "退出",
                action: "quit"
            },
            contactName: {
                type: "text",
                label: "联系人",
                placeHolder: "联系人",
                notNull: true
            },
            contactPhone: {
                type: "text",
                label: "联系电话",
                placeHolder: "联系电话",
                notNull: true
            },
            signUpRemark: {
                type: "textarea",
                label: "备注",
                notNull: true
            },
            signUpButton : {
                type : "button",
                label : "确认报名",
                action : "signUp"
            },
            signUpTime: {
                type: "dateTime"
            }
        },
        // 加载指定数据
        // 参数:
        //      _id
        loadById : function (params) {
            if(!params.cqViewParam.params){
                var def = new Deferred();
                def.resolve({
					isUse: true
				});
				return def;
            }
			return this.exec('loadById', {
                _id: params.cqViewParam.params
            }).then(lang.hitch(this, function (result) {
				return result&&result.data&&result.data.item||{};
			}));
        },
        getListItem: function(item){
            item.logo = blob.getImageUrl(item.logo, 480);
            return item;
        }
    });
});
