﻿// 订单系统商家端
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    '../../BoBase',
    "./_Mixin",
    'cq/util/sys/query'
], function (declare,lang, array, BoBase,_Mixin, query) {
    var O = declare("", [BoBase.B, _Mixin], {
        fields: {
            save: {
				type: "button",
				label: "保存",
				action: "save",
				buttonClass: "fullButton"
			},
            deleteById: {
                type: "button",
                label: "删除",
                action: "deleteById",
                buttonClass: "fullButton"
            },
            showRemark: {
                type: "button"
            },
            verify: {
                type: "button",
                label: "审核"
            }
        },
        // 编辑页面Layout
        getEdtLayout: function(){
            return [{
                type : "form",
                fields : this.getFormItems(["logo","title", "signUpDateFrom", "signUpDateTo", "sd", "ed", "remark", "content", "deleteById", "save"], true)
            }];
        },
        deleteById: function(data){
            if(!confirm("确认删除?")){
               return; 
            }
            if(!data._id){
                return;
            }
            this.exec("deleteById", {
                _id: data._id
            }).then(lang.hitch(this, function(result){
                if(result&&result.data&&result.data.ok==1){
                    alert("删除成功");
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"删除失败");
                }
            }));
        },
        // 保存数据
        save: function(data){
            msg = this.checkedFiled(data);
            if(msg){
                alert(msg);
                return;
            }
            this.exec("save", data).then(lang.hitch(this, function(result){
                if(result&&result.data&&result.data.ok==1){
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"保存失败");
                }
            }));
        },
        //数据合法性检查
        checkedFiled : function(data){
            var msg = this.getDataValidMsg(data, ["logo","title","sd", "ed", "content"]);//, "content"// "signUpDateFrom", "signUpDateTo", 
            if(msg){
                return msg;
            }
            /*var nowDate = new Date();
            if(data.signUpDateFrom<nowDate){
                return "开始报名时间不能小于当前时间"
            }
            if(data.signUpDateFrom>data.signUpDateTo){
                return "开始报名时间不能大于于结束报名时间"
            }
            if(data.signUpDateFrom>data.sd){
                return "开始报名时间不能大于活动开始时间"
            }
            if(data.signUpDateTo>data.ed){
                return "结束报名时间不能大于活动结束时间"
            }*/
            if(data.sd>data.ed){
                return "开始推荐日期不能大于结束推荐日期"
            }
        },
        onDataReady: function(widget){
            var data = widget.getData();
            widget.hideByFields(["deleteById"]);
            if(!data._id){
                return;
            }
            widget.showByFields(["deleteById"]);
        },
        // 获取数据url
        getListUrl: function(){
            return this.getBaseUrl() + '/load';
        },
        getListUrlForSigning: function(){
            return this.getBaseUrl() + '/loadSigning?fromShopId='+this.getPlatformShopId();
        },
        // params
        getListParam: function(cqRefInfo){
            var params = {
                shopId : this.getShopId(),
                isUse: true
            };
            var paramValue = query.getQueryValue(cqRefInfo.state);
            if (paramValue) {
                params.state = paramValue;
            }
            return params;
        },
        getListActivityParam : function(cqRefInfo){
            var params = {
                shopId : this.getPlatformShopId(),
                isUse: true
            };
            return params;
        },
        // 列表点击事件
        onListClick : function (item, action, widget) {
            if("showSignUpShops"==action){
                window.moveToView("dailyRecSignUpShops", item._id);
            }else{
                window.moveToView("dailyRecEdt", item._id);   
            }
        },
        onActivityListClick : function(data){
            window.moveToView("dailyRecDtlB", data._id);
        },
        enroll:function(data,widget){
            window.moveToView("dailyRecSignUp", data._id);
        },
        quit:function(data,widget){
            return this.exec("signOut",{
                shopId : this.getShopId(),
                fromShopId : this.getPlatformShopId(),
                _id :data._id
            }).then(function(result){
                if(result&&result.data&&result.data.ok==1){
                    alert("退出报名成功");
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"退出报名失败");
                }
            });
        },
        loadById : function(params){
            if(!params.cqViewParam.params){
                return;
            }
			return this.exec('loadById', {
                _id: params.cqViewParam.params,
                shopId: this.getShopId(),
                fromShopId: this.getPlatformShopId()
            }).then(lang.hitch(this, function(result){
                var item = result&&result.data&&result.data.item;
                return item||{};
            }));
        },
        _loadById: function(_id){
            return this.exec("loadById", {
                _id: _id
            });
        },
        getDailyRecSignUpLayout:function(){
            return [{
                type : "form",
                fields : this.getFormItems(["contactName", "contactPhone", "signUpRemark", "signUpButton"], true)
            }]
        },
        signUp : function (data) {
            // 字段为空检查
            var msg = this.getDataValidMsg(data, ["contactName", "contactPhone"]);
            if(msg){
                alert(msg);
                return;
            }
            var params = {};
            params._id = data._id;
            params.fromShopId = this.getPlatformShopId();
            params.contactName = data.contactName;
            params.contactPhone = data.contactPhone;
            params.remark = data.signUpRemark;
            this.exec("signUp", params).then(lang.hitch(this, function (data) {
                if (data && data.data && data.data.ok === 1) {
                    alert("报名成功");
                    history.back();
                } else {
                    alert(data&&data.data&&data.data.message||"报名失败");
                }
            })); 
        },
        onSignUpDataReady : function(widget){
            var pageData = widget.getData();
            var shopIds = [];
            array.forEach(pageData.shops, function (shopData) {
                shopIds.push(shopData.shopId._id);
            }, this);
            widget.hideByFields(["quit","enroll"]);
            if (shopIds.indexOf(this.getShopId()) > -1) {
                widget.showByFields(["quit"]);
            } else {
                widget.showByFields(["enroll"]);
            }
            var nowDate = new Date();
            if (pageData.isUse && (nowDate < pageData.signUpDateFrom) && (nowDate > pageData.signUpDateTo)) {
                widget.hideByFields(["enroll"]);
            }
        },
        onExport: function(a,b,widget,d){
            //查询条件
            //var query = this.getListParam(widget.getParent().cqRefInfo);
            //var url = this.getListUrl();
            require([
                "cq/util/sys/xlsx",
                "cq/util/sys/date",
                "cq/util/sys/userAgent"
            ],lang.hitch(this,function(xlsx,date,userAgent){
                if(userAgent.isBrowser){
                    this._loadById(window.location.hash.split("-")[1]).then(lang.hitch(this, function(result){
                        var shops = result&&result.data&&result.data.item&&result.data.item.shops||[];
                        //设置表头
                        var datas = [["商家","报名时间","联系人","联系电话","备注","状态"]];
                        //初始化订单数据
                        for(var i=0;i<shops.length;i++){
                            datas.push([
                                shops[i].shopId.shopName,
                                date.formatISODateMinutes(shops[i].signUpTime),
                                shops[i].contactName,
                                shops[i].contactPhone,
                                shops[i].remark,
                                shops[i].isVerified?"已审核":"未审核"
                            ]);
                        }
                        //导出成xlsx文件
                        xlsx.exportMatrix(datas,Date.now().toString());
                    }));
                }
                
            }));
        },
        shopsReload: function(widget){
            var data = widget.getData();
            widget.hideByFields(["verify", "showRemark"]);
            if(!data._id){
                return;
            }
            if(!data.isVerified){
                widget.showByFields(["verify"]);
            }
            if(data.remark){
                widget.showByFields(["showRemark"]);
            }
        },
        verify: function(data, widget){
            this.exec("verify", {
                _id: data.did,
                joinShopId: data.shopId._id
            }).then(lang.hitch(this, function(result){
                if(result&&result.data&&result.data.ok==1){
                    widget.cqRefresh();
                }else{
                    alert(result&&result.data&&result.data.message||"审核失败");
                }
            }));
        }
    });
    var o = new O();
    o.Bo = O;
    return o;
});