﻿define([
    "dojo/_base/declare"
],function(declare){
    return declare("",null,{
        modalName : "mk/delivery/deliveryCard",
        fields : {
            typeId:{
                type : 'options',
                label : '类型',
                options : {
                    1:'实物',
                    2:'积分'
                },
                selected: 1,
                notNull: true
            },
            title:{
                type:"text",
                label:"标题",
                notNull: true,
                placeHolder: "请填写标题"
            },
            mId:{
                type: "ref",
                label: "提货商品",
                dataProvider: "bob/mat/matB",
                query:{
                    isSpecs:false
                },
                targetMethod: "getListUrlForCurrentShop",
                labelFields: "mName",
                searchField: "search",
                canEdit: true,
                notNull: true,
                pageSize: 10
            },
            price:{
                type:"number",
                label:"价格",
                notNull: true,
                fixedTo:2,
                range:"[0,)",
                placeHolder: "提货卡商品需额外支付"
            },
            mQty:{
                type:"number",
                label:"商品数量",
                notNull: true,
                fixedTo: 0,
                range:"(0,)",
                placeHolder: "提货卡包含商品数量"
            },
            freight:{
                type:"number",
                label:"运费",
                fixedTo:2,
                range:"[0,)",
                placeHolder: "提货需支付运费"
            },
            point:{
                type:"number",
                label:"积分数量",
                notNull: true,
                range:"(0,)",
                placeHolder: "提货卡包含积分数量"
            },
            cashAmount:{
                type:"number",
                label:"兑换金额",
                range:"[0,)",
                placeHolder: "提现微信红包金额"
            },
            isUse:{
                type:"checkbox",
                label:"是否使用"
            },
            periodEd:{
                type:"dateTime",
                label:"失效日期",
                notNull: true
            },
            remark:{
                type:"textarea",
                label:"使用说明",
                notNull: true
            },
            qty:{
                type:"number",
                label:"发放数量",
                notNull: true,
                fixedTo:0,
                range:"(0,)",
                placeHolder: "提货卡发放数量"
            },
            //已生成提货卡，默认为fasle
            isGened:{
                type:"checkbox",
                label:"已生成提货卡"
            }
        }
	});
});
