﻿//  创建人：徐阿雪
//  创建时间：2017-7-27
//  创建内容：提货活动的编辑录入
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    'bob/BoBase',
    "./_Mixin"
], function (declare,lang,BoBase,_Mixin) {
    var DeliveryCardBBo = declare("", [BoBase.B, _Mixin], {
        fields:{
            save:{
                type: "button",
                action: "save"
            },
            saveAndCreate: {
                type: "button",
                action: "saveAndCreate"
            },
            //生成提货卡按钮
            create:{
                type: "button",
                action: "create"
            },
            showCard: {
                type: "button",
                action: "showCard"
            },
            exportCard: {
                type: "button",
                action: "exportCard"
            },
            isGened:{
                type:"text",
                lable:"是否生成提货卡"
            }
            
        },
        fieldChangeMethod:function(widget, field, fieldVl){
            if (field == 'typeId') {
                this.initFields(fieldVl, widget);
            }
        },
        initFields: function(fieldVl, widget){
            if (fieldVl == "1") {
                widget.showByFields(['mId', "price",
                //"mQty", 
                "freight"]);
                widget.hideByFields(["point","cashAmount"]);
            }else if(fieldVl == "2"){
                widget.hideByFields(['mId', "price",
                //"mQty", 
                "freight"]);
                widget.showByFields(["point","cashAmount"]);
            }
            if(this._shopId==this.getShopId()){
                if(this.disableCash){
                    widget.hideByFields(["cashAmount"]);
                }
            }else{
                require(["bob/shop/shop"],lang.hitch(this,function(shop){
                    shop.loadMe().then(lang.hitch(this,function(item){
                        this._shopId = item._id;
                        this.disableCash = !item.wxPayMchId;
                        if(this.disableCash){
                            widget.hideByFields(["cashAmount"]);
                        }
                    }));
                }));
            }
        },
        // 获取列表url地址
        getListUrl : function(){
            return this.getBaseUrl() + '/load';
        },
        // 参数
        getListParam : function(cqRefInfo){
            var param = {};
            param.shopId = this.getShopId();
            if(cqRefInfo&&cqRefInfo.search){
                param.search = cqRefInfo.search;
            }
            if(cqRefInfo.state){
                if(cqRefInfo.state._id == 1){
                    //已失效
                    param.state = 1;
                }
            }
            return param;
        },
        // 列表点击事件
        onListClick : function(item){
            window.moveToView("deliveryCardEdt",item._id);
        },
        // 详情页面布局
        getEdtLayout: function(){
            return [{
                type : "form",
                fields : this.getFormItems([
                "typeId",
                "title","mId","price",//"mQty",
                "freight","qty",
                "point",
                "cashAmount",
                "periodEd",
                "remark",
                "saveAndCreate","save","create","showCard", "exportCard"], true)
            }];
        },
        onDataReady: function(widget){
            var data = widget.getData();
            widget.hideByFields(["saveAndCreate", "save", "create", "showCard", "exportCard"]);
            widget.disableByFields();
            this.initFields(data.typeId, widget);
            if(!data._id){
                widget.enableByFields();
                widget.showByFields(["saveAndCreate", "save"]);
                return;
            }
            if(data.isGened){
                widget.disableByFields();
                widget.showByFields(["showCard", "exportCard"]);
            }else{
                widget.enableByFields();
                widget.showByFields(["save", "create"]);
            }
        },
        loadByMid:function(mid){
            //参数：mid,查询没有失效的提货活动
            return this.exec("load",{mId:mid});
        },
        loadById:function(params){
            if (!params.cqViewParam.params) {
                return {
                    isUse: true,
                    typeId: 1,
                    mQty:1,
                    isGened:false
                };
            }
            return this.exec("loadById",{
                _id:params.cqViewParam.params
            }).then(lang.hitch(this,function(result){
                return result&&result.data&&result.data.item||{};
            }));
        },
        _checkFields: function(data){
            var msg = this.getDataValidMsg(data, ['typeId','title','periodEd','remark','qty','remark']);
            if(msg){
                alert(msg);
                return false;
            }
            if(data.typeId == "1"){
                msg = this.getDataValidMsg(data, ['mId','price','mQty',"freight"]);
                if(msg){
                    alert(msg);
                    return false;
                }
            }else if(data.typeId == "2"){
                var msg = this.getDataValidMsg(data, ['point']);
                if(msg){
                    alert(msg);
                    return false;
                }
            }
            return true;
        },
        save:function(data){
            if(!this._checkFields(data)){
                return;
            }
            window.busy();
            this.onSave(data).then(lang.hitch(this,function(result){
                window.free();
                if(result&&result.data&&result.data.ok==1){
                    alert("保存成功");
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.msg||"保存失败");
                }
            }));
        },
        onSave: function(data){
            return this.exec("save", data);
        },
        saveAndCreate: function(data, widget){
            if(!this._checkFields(data)){
                return ;
            }
            var _this = this;
            window.busy();
            this.onSave(data).then(function(result){
                if(result&&result.data&&result.data.ok==1){
                    _this.onCreate(result.data.item).then(function(result2){
                        window.free();
                        if(result2&&result2.data&&result2.data.ok==1){
                            if(confirm("提货卡生成成功，马上查看？")){
                                window.moveToView("deliveryCardDListB", result.data.item._id);
                            }
                            else{
                                history.back(2);
                            }
                        }else{
                            alert(result2&&result2.data&&result2.data.message||"提货卡生成失败");
                        }
                    });
                }else{
                    window.free();
                    alert(result&&result.data&&result.data.message||"保存失败");
                }
            });
        },
        onCreate: function(data){
            return this.exec("createDeliveryCard",{
                _id:data._id
            });
        },
        create:function(data,widget){
            if(confirm("确认生成提货卡？")){
                window.busy();
                this.onCreate(data).then(function(result){
                    window.free();
                    if(result&&result.data&&result.data.ok==1){
                        if(confirm("提货卡生成成功，马上查看？")){
                            window.moveToView("deliveryCardDListB", result.data.item._id);
                        }
                    }else{
                        alert(result&&result.data&&result.data.msg||"生成失败");
                    }
                });
            }
        },
        showCard: function(data, widget){
            window.moveToView("deliveryCardDListB", data._id);
        },
        exportCard: function(data, widget){
            var _this = this;
            require([
                "bob/mk/deliveryCardD/b"
            ], function(card){
                card.onExport(card.getListUrl(), {
                    shopId: _this.getShopId(),
                    cardId: data._id
                });
            });
        }
    });
    var deliveryCardBBo = new DeliveryCardBBo();
    deliveryCardBBo.Bo = DeliveryCardBBo;
    return deliveryCardBBo;
});