﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "bob/user/consumer",
    "../../BoBase",
    "./_Mixin",
    "cq/util/sys/userAgent"
],function(declare, lang, consumer, BoBase, _Mixin, userAgent){
    var O = declare("",[BoBase.C, _Mixin],{
        fields:{
            deliver: {
                type: "button",
                label: "充值/提货",
                action: "deliver",
                buttonClass: "fullButton"
            },
            withdraw: {
                type: "button",
                label: "提现到微信红包",
                action: "withdraw",
                buttonClass: "fullButton"
            },
            deliveryPointAdd:{
                type:"button",
                action:"deliveryPointAdd"
            },
            usePoint2:{
                label:"确认",
                type:"button",
                action:"usePoint2",
                buttonClass: "fullButton"
            }
        },
        usePoint2:function(data,edit,e){
            var msg = this.getDataValidMsg(data, ["NO", "pwd"]);
            if (msg) {
                alert(msg);
                return;
            }
            if(edit.cqRefInfo.cqViewParam.params){
                data.targetShopId = edit.cqRefInfo.cqViewParam.params;
            }
            window.busy();
            this.exec("usePoint", data).then(function(result){
                window.free();
                if (result.data && result.data.ok === 1) {
                    alert("充值成功");
                    window.moveToView("other");
                } else {
                    alert(result&&result.data&&result.data.message||"充值失败");
                }
            });
        },
        //根绝提货卡进行充值积分
        deliveryPointAdd:function(data){
            var _this = this;
            var item = {};
            item.amount = parseInt(data.deliveryPoint);
            //当前登录的id
            var user = consumer.getCurrentUserFromSession();
            item.userId = user._id;
            item._id = data._id;
            window.busy();
            return this.exec("usePoint",item).then(lang.hitch(this,function(result){
                window.free();
                if (result.data && result.data.ok === 1) {
                    window.moveToView("other");
                } else {
                    alert(result&&result.data&&result.data.message||"充值失败");
                }
            }));
        },
        //获取提货卡里面包含的积分金额
        deliveryPointinitmethod:function(params){
            //var def = new Deferred();
            window.busy();
            return this.loadById(params.cqViewParam.params).then(lang.hitch(this,function(data){
                window.free();
                var item = data&&data.data&&data.data.item||{};
                item.deliveryPoint = item.cardId.point||0;
                item.remark = item.cardId.remark||"该积分是商家提货卡赠送的积分，点击确认充值后立即到账";
                return item;
            }));
        },
        clearData: function(){
            return {};
        },
        getEdtLayout: function(){
            return [{
                type : "form",
                fields : this.getFormItems(["NO", "pwd", "deliver", "withdraw"], true)
            }];
        },
        getCard2Layout: function(){
            return [{
                type : "form",
                fields : this.getFormItems(["NO", "pwd","usePoint2"], true)
            }];
        },
        onDataReady:function(widget){
            if(!(window.g_sys_info&&window.g_sys_info.wxPayMchId&&userAgent.isWeixin())){
                widget.hideByFields(["withdraw"]);
            }
        },
        deliver: function(data, widget){
            var msg = this.getDataValidMsg(data, ["NO", "pwd"]);
            if (msg) {
                alert(msg);
                return;
            }
            window.busy();
            this.exec("userCard", data).then(function(result){
                window.free();
                if(result&&result.data&&result.data.ok==1){
                    if(result.data.item.cardId.typeId == 2){
                        window.moveToView("deliveryPointCard", result.data.item._id);
                    }else{
                        window.moveToView("deliveryOrderInfo", result.data.item._id);
                    }
                }else{
                    alert(result&&result.data&&result.data.message||"提货失败");
                }
            });
        },
        loadById: function(id){
            return this.exec("loadById",{
                _id: id
            });
        },
        usePoint:function(id){
            return this.exec("usePoint",{
                _id:id
            });
        },
        withdraw:function(data,widget){
            var msg = this.getDataValidMsg(data, ["NO", "pwd"]);
            if (msg) {
                alert(msg);
                return;
            }
            window.busy();
            this.exec("checkWithdraw", data).then(lang.hitch(this,function(result){
                if(!(result&&result.data&&result.data.ok==1)){
                    alert(result&&result.data&&result.data.message||"提现失败");
                    return window.free();
                }
                var amount = parseFloat(result.data.item.cashAmount,10).toFixed(2);
                if(!confirm("本提货卡可充值积分 "+result.data.item.point+" ，可提现 "+amount+" 元，确定提现到微信零钱")){
                    return window.free();
                }
                return this.exec("withdraw",data).then(function(result){
                    window.free();
                    if(!(result&&result.data&&result.data.ok==1)){
                        alert(result&&result.data&&result.data.message||"提现失败");
                        return window.free();
                    }else{
                        alert("已发送红包，请注意查收");
                    }
                });
            }));
        }
    });
    var o = new O();
    o.Bo = O;
	return o;
});
