﻿//订单系统公共基类
// 1、提供订单系统的基本属性
// 2、提供公用的方法
define([
    "dojo/_base/declare"
], function (declare) {
    return declare("",null,{
        modalName:"mk/discount",
        //字段名
        fields:{
            title : {
                type : 'text',
                label : '优惠券名称',
                placeHolder : '必填',
                notNull : true
            },
            startDate : {
                type : 'dateTime',
                label : '生效时间',
                notNull : true
            },
            stopDate : {
                type : 'dateTime',
                label : '过期时间',
                notNull : true
            },
            totalNum : {
                type : 'number',
                label : '发放数量',
                placeHolder: "请填写发放数量",
                notNull : true
            },
            reachAmount : {
                type : 'number',
                label : '订单金额',
                placeHolder: "订单金额,不含运费",
                notNull : true
            },
            amount : {
                type : 'number',
                label : '面值',
                placeHolder: "抵用金额",
                notNull : true
            },
            userQuota : {
                type : 'number',
                label : '领取限额',
                placeHolder: "每人限领",
                notNull : true
            },
            remark : {
                type : "textarea",
                label : "优惠券说明",
                canEdit : true
            },
            typeId : { //1活动奖品，2新客奖品，3注册优惠，4其他
                type : "options",
                label : "优惠活动类型",
                options : {
                    1 : "活动奖品",
                    //2 : "新客奖品",
                    3 : "注册优惠",
                    4 : "其他"
                },
                selected : 4,
                notNull : true
            },
            using : {
                type : 'checkbox',
                label : '使用',
                selected : true
            },
            wholeUse : {
                type : 'checkbox',
                label : '全店通用'
            },
            mIds: {
                type : "ref",
                label : "可使用商品",
                dataProvider : "bob/mat/matB",
                targetMethod : "getListUrlForCurrentShop",
                labelFields : "mName",
                searchField : "mName",
                canEdit : true,
                pageSize : 10,
				//query: {
				//	isUse: true,
				//	qty:1
				//},
                multiselect : "multiselect"
            },
            distributedNum:{
                type : 'text',
                label : '已领取',
                notNull : true
            },
            usedNum :{
                type : 'text',
                label : '已使用',
                notNull : true 
            }
        }
    });
});
