﻿// 订单系统商家端
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/Deferred",
    "cq/util/config/config",
    '../../BoBase',
    "./_Mixin",
    'cq/util/sys/query',
    "cq/util/sys/date"
], function (declare,lang, array, Deferred, config,BoBase,_Mixin, query, date) {
    var DiscountBBo = declare("", [BoBase.B, _Mixin], {
        fields: {
            edit: {
                type: "button",
                action: "edit"
            },
            stop: {
                type: "button",
                action: "stop"
            },
            addCouponNum: {
                type: "button",
                action: "addCouponNum"
            },
            save: {
				type: "button",
				label: "保存",
				action: "save",
				buttonClass: "fullButton"
			},
            share: {
                type: "button",
                action: "share"
            }
        },
        // 添加优惠活动Layout
        getEdtLayout: function(){
            return [{
                type : "form",
                fields : this.getFormItems(["typeId", "title", "startDate", "stopDate", "totalNum", "reachAmount", "amount", "userQuota", "remark",  "wholeUse", "mIds", "save"], true)
            }];
        },
        getDtlLayout: function(){
            return [{
                type : "form",
                fields : this.getFormItems([
                    "typeId","title", "startDate", "stopDate", "totalNum", "reachAmount",
                    "amount", "userQuota", "distributedNum", "usedNum", "remark",  "wholeUse", "mIds",
                    "edit", "stop", "addCouponNum","share"
                ], false)
            }];
        },
        share: function(data){
            require([
                "cq/util/share/share",
                "bob/shop/shop"
            ], function(share, shop){
                var options = [{
                    "weixin": {
                        title: data.title,
                        thumb: "",
                        url:shop.getCurrentShopLocation()+"#discountDtlC-" + data._id
                    }
                }, {
                    "friendCircle": {
                        title: data.title,
                        thumb: "",
                        url:shop.getCurrentShopLocation()+"#discountDtlC-" + data._id
                    }
                }, {
                    "copy": {
                        url: shop.getCurrentShopLocation()+"#discountDtlC-" + data._id
                    }
                }];
                share.showShare(options);
            });
        },
        addCouponNum: function(data, widget){
            window.busy();
            require([
                "cq/util/edit/jsonRef",
                "bob/user/customer"
            ],lang.hitch(this, function(jsonRef, customer){
                window.free();
                jsonRef.startEdit({_id:data.userId},widget.getView(),{
                    target: customer.getUserListUrl(),
                    getDataLabel: function (data) {
                        return '<div style="min-width:160px;display:inline-block;">' + array.map(["nickName","pName","userName"], function (field) {
                            return data[field] || "";
                        }).join('</div><div style="min-width:160px;display:inline-block;">') + "</div>";
                    },
                    searchField: "search",
                    labelField: "nickName,pName,userName",
                    multiselect: "",
                    query: {isFarmer: false}
                }).then(lang.hitch(this, function(user){
                    window.busy();
                    if(!(user&&user._id)){
                        alert("请选择客户");
                        window.free();
                    }
                    this.exec("distributeCoupon", {
                        userShopId: this.getShopId(),
                        userId: user._id,
                        discount: {_id: data._id}
                    }).then(function(result){
                        window.free();
                        if(result&&result.data&&result.data.ok==1){
                            alert("赠送成功");
                            widget.cqRefresh();
                        }else{
                            alert(result&&result.data&&result.data.message||"赠送失败");
                        }
                    });
                }));
            }));
        },
        fieldChangeMethod: function(widget, field, state){
            if(field=="wholeUse"){
                if(!state){
                    widget.showByFields(["mIds"]);
                }else{
                    widget.hideByFields(["mIds"]);
                }
            }
        },
        onDataReady: function(widget){
            widget.hideByFields(["mIds"]);
            var data = widget.getData();
            widget.getEditorByField("mIds").setRight = function(){
                var t = this.getValue();
                this.set("rightText", "已选"+(t?t.length:"0")+"种");
            };
            // 单独有设置右标签的方法
            widget.getEditorByField("mIds").setRight();
            if(!data._id){
                return;
            }
            if(!data.wholeUse){
                widget.showByFields(["mIds"]);
            }
        },
        //每次重进都要进行的方法
        onDataReadyBase: function(widget){
            var data = widget.getData();
            var hidefields = ["typeId", "title","startDate","stopDate","totalNum","reachAmount","amount","userQuota","remark","typeId","using","wholeUse","distributedNum","usedNum"];
            widget.disableByFields(hidefields);
            
            widget.hideByFields(["mIds"]);
            widget.getEditorByField("mIds").setRight = function(){
                var t = this.getValue();
                this.set("rightText", "已选"+(t?t.length:"0")+"种");
            };
            // 单独有设置右标签的方法
            widget.getEditorByField("mIds").setRight();
            if(!data._id){
                return;
            }
            if(!data.wholeUse){
                widget.showByFields(["mIds"]);
            }
            if(data.mIds){
                data.mIds.forEach(function(mat){
                    mat._id = mat.mId;
                });
            }
            var nowDate = date.nowISOString();
            if(data.endDate < nowDate /* || data.distributedNum>0*/){
                widget.hideByFields(["edit"]);
            }else{
                widget.showByFields(["edit"]);
            }
            if(data.using==true){
                widget.showByFields(["stop"]);
            }else{
                widget.hideByFields(["stop"]);
            }
        },
        edit: function(data, widget){
            if(data){
                window.moveToView("discount", data._id);
            }
        },
        stop: function(e){
            if(confirm("确认失效?")){
                return this.exec("disableById", {
                    _id:e._id
                } ).then(function (result) {
                    if (result.data && result.data.ok === 1) {
                        alert("失效成功");
                        history.back();
                    } else {
                        alert(result&&result.data&&result.data.message||"失效失败");
                    }
                });
            }
        },
        checkedFiled : function (data) {
            var nowDate = date.now();
            /*if (new Date(data.startDate) < nowDate) {
                return "生效时间不能小于当前时间";
            }
            if (new Date(data.startDate) >new Date(data.stopDate)) {
                return "生效时间不能大于过期时间";
            }
            if (Number(data.reachAmount) < Number(data.amount)) {
                return "面值金额不能大于订单金额";
            }
            if (Number(data.totalNum) <= 0) {
                return "发放数量必须大于0";
            }
*/
            return "";
        },
        // 保存优惠活动
        save: function(data, dataList){
            var msg = this.getDataValidMsg(data, ["typeId", 'title', "startDate", "stopDate", "totalNum", "reachAmount", "amount", "userQuota"]);
            if (msg) {
				alert(msg);
				return;
			}
            // 验证合法性
            msg = this.checkedFiled(data);
            if (msg) {
				alert(msg);
				return;
			}
            var mIds = [];
            // 如果有选择商品  则要追加保存商品信息
            if(data.mIds&&data.mIds.length){
                array.forEach(data.mIds, function(mId){                   
                    mIds.push({
                        _id:mId.params&&mId.params._id||mId._id,
                        mId: mId.params&&mId.params._id||mId._id,
                        mName: mId.params&&mId.params.mName||mId.mName
                    });
                });
                data.mIds = mIds;
            }
            data.using = true;
            data.typeId = data.typeId||4;
            this.exec('save', data ).then(function (result) {
				if (result.data && result.data.ok === 1) {
					history.back();
				} else {
					alert(result.data.msg ? (result.data.msg) : "保存失败");
				}
			});
        },
        // 加载优惠活动的url
        getListUrl: function(){
            return this.getBaseUrl() + '/load?shopId='+this.getShopId();
        },
        getValidDiscountListUrl:function(){
            return this.getBaseUrl()+"/load?shopId="+this.getShopId()+"&state=2";
        },
        // 加载优惠活动的条件
        getListParam: function(cqRefInfo){
            var params = {};
            var paramValue = query.getQueryValue(cqRefInfo.search);
            if (paramValue) {
                params.search = paramValue;
            }
            paramValue = query.getQueryValue(cqRefInfo.state);
            if (paramValue) {
                params.state = paramValue;
            }
            return params;
        },
        // 优惠活动列表点击事件
        onListClick : function (item) {
            window.moveToView("discountDtl", item._id);
        },
        // 加载指定优惠活动
        // 参数:
        //      _id
        loadById : function (params) {
            // if (!params.cqViewParam.params) {
                // return;
            // }
            if(!params.cqViewParam.params){
                var def = new Deferred();
                def.resolve({
					wholeUse: true,
                    typeId: 4
				});
				return def;
            }
			return this.exec('loadById', {
                _id: params.cqViewParam.params,
                shopId: this.getShopId()
            }).then(lang.hitch(this, function (result) {
				return result&&result.data&&result.data.item||{};
			}));
        }
    });
    
    var discountBBo = new DiscountBBo();
    discountBBo.Bo = DiscountBBo;
    return discountBBo;
});
