﻿define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"cq/app/config",
    "cq/util/sys/date",
	"./_Mixin",
	'../../BoBase',
    "bob/user/consumer"
], function (declare, lang, appConfig, date, _Mixin, BoBase, consumer) {
	var DiscountCBo = declare('', [BoBase.C, _Mixin], {
		fields: {
            "fromShopId._id":{
                type:"text"
            },
            shopName: {
                type: "text"
            },
            logo: {
                type: "text"
            },
            shopId: {
                type: "text",
                label: "shopId"
            },
            receive: {
                type: "button",
                label: "领券",
                action: "receive"
            },
            enterShop:{
                type: "button",
                label: "进入店铺",
                action: "enterShop"
            }
        },
        getListUrl: function(){
            return this.getBaseUrl()+ "/loadByShop";
        },
        getListParam: function(){
            return {
                shopId: this.getShopId(),
                using: true
            };
        },
        onListClick: function(data, action, widget){
            if(action=="receive"){
                this.receive(data, widget);
            }else if(action=="use"){
                window.moveToView("businessDetails", data.fromShopId._id);
            }else{
                window.moveToView("discountDtlC",data._id);
            }
        },
        getItemProp: function(data){
            data.shopName = data.fromShopId&&data.fromShopId.shopName||"";
            data.logo = data.fromShopId&&data.fromShopId.logo||"";
            data.shopId = data.fromShopId&&data.fromShopId.shopId||"";
            return data;
        },
        // 查询指定商家的优惠活动
		loadByShop: function (shopId) {
			// 改成程磊提供的新接口
			// 加载商家优惠券列表
            // 修改时间 2017/01/17 杜飞军
            //      exec会自动获得shopId 所以数据来源于fromShopId
			return this.exec("loadByShop", {
				fromShopId: shopId
			}).then(lang.hitch(this, function (result) {
				return result && result.data && result.data.items || {};
			}));
		},
		// 用户领取优惠券
		receiveCoupon: function (params) {
			return this.exec("getCouponByUserSelf", params).then(lang.hitch(this, function (result) {
				return result;
			}));
		},
        loadById : function(params){
            var params = params&&params.cqViewParam&&params.cqViewParam.params||"";
            if(!params){
                return {};
            }
            params = params.split(",");
            return this.exec("loadById",{
                _id:params[0],
                fromShopId: params[2]||this.getShopId()
            }).then(lang.hitch(this,function(data){
                if(data.data.ok === 1){
                    var item = data.data.item;
                    if(item.fromShopId){
                        item.shopName = item.fromShopId.shopName || "";
                        item.logo = item.fromShopId.logo || "";
                    }
                    return item;
                }else{
                    alert("加载数据错误");
                }
            }));
        },
        receive: function(data, widget){
            this.receiveCoupon({
                fromShopId: this.getShopId(),
                _id: data._id
            }).then(lang.hitch(this, function(result){
                if(result&&result.data&&result.data.ok==1){
                    alert("领取成功");
                }else{
                    alert(result&&result.data&&result.data.message||"领取失败");
                }
            }));
        },
        enterShop : function(data){
            window.moveToView("businessDetails",data.fromShopId._id);
        },
        getAvailableMatUrl: function(){
            return this.getBaseUrl()+"/getAvailableMat"
        },
        getAvailableMatParam: function(params){
            var params = params&&params.cqViewParam&&params.cqViewParam.params||"";
            params = params.split(",");
            if(params.length<1){
                return;
            }
            var query = {
                shopId: this.getShopId()
            };
            if(params.length>1){
                query.fromShopId = params[1];
            }
            query.discountId = params[0];
            return query;
        }
	});
	var discountCBo = new DiscountCBo();
	discountCBo.Bo = DiscountCBo;
	return discountCBo;
});