﻿// 订单系统商家端
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/util/config/config",
    '../../BoBase',
    "./_Mixin",
    'cq/util/sys/query'
], function (declare,lang,config,BoBase,_Mixin, query) {
    var FlashSaleBBo = declare("", [BoBase.B, _Mixin], {
        getDtlLayout : function () {
            return [{
                type : "form",
                fields : this.getFormItems(["mId", "prc", "qty", "startTime", "endTime", "isUse", "onEditPreSale", "onEndPreSale"], true)
            }];
        },
        getItemData : function (itemData) {
            itemData.mName = itemData.mId.mName ? (itemData.mId.mName) : "";
            itemData.logo = itemData.mId.logo ? (itemData.mId.logo) : "";
            return itemData;
        },
        onEditPreSale : function (data) {
            window.moveToView("flashSaleEdt", data._id);
        },
        // 停用
        onEndPreSale : function (data, widget) {
            this.exec("disableById", {_id : data._id}).then(lang.hitch(this, function (result) {
                if (result && result.data && result.data.ok == 1) {
                    widget.cqRefresh();
                } else {
                    alert("停用失败");
                }
            }));
        },
        onDataReady : function (widget) {
            var pageData = widget.getData();
            // 设置字段不能编辑
            var fields = ["mId", "prc", "qty", "startTime", "endTime", "isUse"];
            widget.disableByFields(fields);
            // 当前时间小于活动开始时间才可以编辑
            if (pageData.isUse) {
                widget.showByFields(["onEndPreSale"]);
                if (new Date() < new Date(pageData.startTime)) {
                    widget.showByFields(["onEditPreSale"]);
                } else {
                    widget.hideByFields(["onEditPreSale"]);
                }
            } else {
                widget.hideByFields(["onEditPreSale", "onEndPreSale"]);
            }
        },
        // 添加优惠活动Layout
        getEdtLayout: function(){
            return [{
                type : "form",
                fields : this.getFormItems(["mId", "prc", "qty", "startTime", "endTime", "isUse", "onBusinessRegistButton"], true)
            }];
        },
        checkedFiled : function (data) {
            var nowDate = new Date();
            if (new Date(data.startDate) < nowDate) {
                return "活动开始时间不能小于当前时间"
            }
            if (new Date(data.startDate) > new Date(data.stopDate)) {   
                return "活动开始时间不能大于活动结束时间"
            }
            return "";
        },
        // 保存优惠活动
        save: function(data, dataList){
            var msg = this.getDataValidMsg(data, ["mId", "startTime", "endTime", "startPayTime", "endPayTime", "isUse", "earnest", "finalPayment", "postNum", "payEarNum",  "payNum"]);
            if (msg) {
				alert(msg);
				return;
			}
            // 验证合法性
            msg = this.checkedFiled(data);
            if (msg) {
				alert(msg);
				return;
			}
            data.mId = data.mId._id ? data.mId._id : null;
            this.exec('save', data).then(function (result) {
				if (result.data && result.data.ok === 1) {
					history.back();
				} else {
					alert(result.data.msg ? (result.data.msg) : "保存失败");
				}
			});
        },
        // 加载优惠活动的url
        getListUrl: function(){
            return this.getBaseUrl() + '/load';
        },
        // 加载优惠活动的条件
        getListParam: function(cqRefInfo){
            var params = {
                shopId : this.getShopId()
            };
            var paramValue = query.getQueryValue(cqRefInfo.search);
            if (paramValue) {
                params.search = paramValue;
            }
            paramValue = query.getQueryValue(cqRefInfo.state);
            if (paramValue == 1) {
                params.isUse = true;
                params.state = 1;
            } else if (paramValue == 2) {
                params.isUse = true;
                params.state = 2;
            } else if (paramValue == 3) {
                params.isUse = true;
                params.state = 3;
            } else if (paramValue == 4) {
                params.isUse = false;
            } else {
                delete params.isUse;
                delete params.state;
            }
            return params;
        },
        // 优惠活动列表点击事件
        onListClick : function (item) {
            window.moveToView("flashSaleDetail", item._id);
        },
        // 加载指定优惠活动
        // 参数:
        //      _id
        loadById : function (params) {
            if (!params.cqViewParam.params) {
                return;
            }
			return this.exec('loadById', {
                _id: params.cqViewParam.params,
                shopId: this.getShopId()
            }).then(lang.hitch(this, function (result) {
				return result&&result.data&&result.data.item||{}
			}));
        }
    });
    
    var flashSaleBBo = new FlashSaleBBo();
    flashSaleBBo.Bo = FlashSaleBBo;
    return flashSaleBBo;
});