﻿//限时抢购商家端
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    '../../BoBase',
    "./_Mixin",
    'cq/util/sys/query',
    'cq/util/sys/date'
],function(declare, lang, Deferred, BoBase, _Mixin, query, date){
    var O = declare("",[BoBase.B, _Mixin],{
        fields:{
            onsaveButton: {
                type: "button",
                label: "保存",
                action: "save",
                buttonClass: "fullButton"
            }
        },
        getListParam : function(cqRefInfo){
            var params = {
                shopId : this.getShopId(),
                state: 1
            };
            var paramValue = query.getQueryValue(cqRefInfo.state);
            if (paramValue) {
                params.state = paramValue;
            }
            paramSearch = query.getQueryValue(cqRefInfo.search);
            if (paramSearch) {
                params.search = paramSearch;
            }
            return params;
        },
        onListClick : function (item) {
            window.moveToView("limitDiscountEdt", item._id);  
        },
        loadById: function(params){
            var def = new Deferred(),params = params.cqViewParam.params,data={};
            if(!params){
                data.isUse = true;
                data.freePost = false;
                data.limitBuyd = date.nowISOString();
                def.resolve(data);
            }else if(params.split("_")[0] == "mid"){
                // 设置商品默认值
                data.mId = {};
                data.mId._id = params.split("_")[1];
                data.isUse = true;
                data.freePost = false;
                data.limitBuyd = date.nowISOString();
                require(["bob/mat/matB"],lang.hitch(this,function(mat){
                    mat.loadByMid(data.mId._id).then(lang.hitch(this,function(result){
                        result = result&&result.data&&result.data.item;
                        data.mId.mName = result.mName;
                        data.mId.specs = result.specs;
                        data.title = result.mName;
                        def.resolve(data);
                    }));
                }));
            }else{
                this.exec("loadById",{
                    _id:params
                }).then(lang.hitch(this,function(data){
                    if(data.data.ok === 1){
                        data = data.data.item;
                        if(typeof(data.mId)=="string"){
                            var mId = data.mId;
                            data.mId = {};
                            data.mId._id = mId;
                            data.mId.mName = data.mName;
                        }
                        data.limitBuyd = data.sd;
                        def.resolve(data);
                    }else{
                        def.resolve({});
                    }
                }));
            }
            return def;
        },
        // 提供依据参数加载数据的方法
        loadByMatId: function (id) {
            return this.exec("loadByMid", {
                mid: id
            });
        },
        getEdtLayout : function(){
            return [{
                type : "form",
                fields : this.getFormItems(["title", "sd", "ed","limitBuyd","mId", "limitQty", "limitPic", "qty", "isUse", "freePost", "onsaveButton"], true)
            }];
        },
        save: function(data, widget){
            var msg = this.getDataValidMsg(data, ['title',"mId", "limitQty", "limitPic", "qty", "limitBuyd"]);
            if (msg) {
                alert(msg);
                return;
            }
            window.busy();
            //修改开始时间为 抢购日期的晚上八点，结束时间为抢购日期的晚上十点
            var sd = new Date(data.limitBuyd), ed = new Date(data.limitBuyd);
            sd.setHours(20);
            sd.setMinutes(0);
            sd.setSeconds(0);
            sd.setMilliseconds(0);
            data.sd = sd.toISOString();
            // 结束时间设置为今天晚上十点
            ed.setHours(22);
            ed.setMinutes(0);
            ed.setSeconds(0);
            ed.setMilliseconds(0);
            data.ed = ed.toISOString();
            var now = new Date();
            // 当前时间<sd
            if(now>=new Date(sd)&&now <= new Date(ed)){
                alert("当前的抢购已经开始，请重新设置");
                return;
            }else if(now >new Date(ed)){
                alert("当前的抢购已经结束，请重新设置")
                return;
            }else if(now>new Date(sd)){
                alert("抢购日期不能小于今天");
                return;
            }
            if (data.mId && data.mId.specs && data.mId.specs.length) {
                alert("商品设置了规格,请重新添加无规格商品做限购");
                return;
            }
            this.exec('save', data).then(function (result) {
                window.free();
                if (result.data && result.data.ok === 1) {
                    alert("设置成功");
                    history.back();
                } else {
                    alert(result.data.msg||"保存失败");
                }
            });
            /*var _this = this;
            // 检查该时间段是否已经有预售活动
            require(["bob/mk/preSale/b"], function(preSale){
                preSale.loadConflict({
                    mId: data.mId,
                    sd: data.sd,
                    ed: data.ed
                }).then(function(result){
                    if(result&&result.data&&result.data.items.length){
                        window.free();
                        alert("该时间段已有限购活动，请重新设置");
                        return;
                    }
                });
            });
            */
        },
        onDataReady: function(widget){
            var data = widget.getData();
            widget.hideByFields(["sd","ed"]);
            widget.showByFields(["limitBuyd"]);
            var hidefields = ["title","limitBuyd","mId", "limitQty", "limitPic", "qty", "isUse", "freePost"];
            widget.enableByFields(hidefields);
            widget.showByFields(["onsaveButton"]);
            //已经开始不允许保存和编辑,
            if(data.sd){
                if(data.sd<(new Date()).toISOString()){
                    widget.disableByFields(hidefields);
                    widget.hideByFields(["onsaveButton"]);
                    //查看状态可看开始时间和结束时间
                    //widget.showByFields(["sd","ed"]);
                    widget.hideByFields(["limitBuyd"]);
                }
            }
        },
        loadConflict: function(params){
            return this.exec("loadConflict",params);
        }
    });
    var o = new O();
    o.Bo = O;
    return o;
});
