﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "../BoBase",
    "dojo/Deferred",
    "cq/app/config",
    "cq/util/config/config",
    "cq/util/sys/query"
],function(declare, lang, BoBase, Deferred, appConfig, config, query){
    var PacBuyBo = declare("",BoBase,{
        modalName : "mk/pac_buy",
        fields : {
            title : {
                type : "text",
                label : "活动标题"
            },
            mId : {
                type : 'ref',
                label : "拼团商品",
                pageSize : "20",
                dataProvider : "bob/mat/mat",
                targetMethod : "getMatUrl",
                labelFields : "mName",
                searchField : "mName"
            },
            pacPic : {
                type : "text",
                label : "拼团价格"
            },
            pacNum : {
                type : "text",
                label : "拼团人数"
            },
            startTime : {
                type : "date",
                label : "拼团开始时间",
            },
            endTime : {
                type : "date",
                label : "拼团结束时间"
            },
            ficInto : {
                type : "checkbox",
                label : "模拟成团",
                canEdit : false
            },
            freePost : {
                type : "checkbox",
                label : "包邮",
                canEdit : false
            },
            rcdInfo  : {
                type : "textarea",
                label : "推荐信息",
            },
            isUse : {
                type : "checkbox",
                label : "是否使用",
                canEdit : true
            },
            onBusinessRegistButton: {
				type: "button",
				label: "保存",
				action: "save",
				buttonClass: "fullButton"
			}
        },
        // 添加拼团Layout
        getEdtLayout: function(){
            return [{
                type : "form",
                fields : this.getFormItems(["title", "mId", "pacPic", "pacNum", "startTime", "endTime", "ficInto", "freePost", "rcdInfo", "isUse", "onBusinessRegistButton"])
            }];
        },
        // 保存
        save: function(data, dataList){
            var msg = this.getDataValidMsg(data, ['title']);
            if (msg) {
                alert(msg);
                return;
            }
            this.exec('save', data).then(function (matData) {
                if (matData.data && matData.data.ok === 1) {
                    history.back();
                } else {
                    alert("保存失败");
                }
            });
        },
        // 拼团列表Layout
        getListLayout: function(){
            if (!this.gridLayout) {
                this.gridLayout = this.getFormItems(["title", "pacNum", "pacPic"]);
            }
            return this.gridLayout;
        },
        // 加载拼团的url
        getListUrl: function(){
            return this.getBaseUrl() + '/load';
        },
        // 加载拼团的条件
        getListParam: function(cqRefInfo){
            var params = {
                shopId : this.getShopId()
            };
            var paramValue = "";
            paramValue = query.getQueryValue(cqRefInfo.state);
            if (paramValue) {
                params.state = paramValue;
            }
            return params;
        },
        onListClick : function (item) {
            window.moveToView("pacBuy", item._id);  
        },
        // 加载指定拼团
        // 参数:
        //      timeLineId
        loadById: function(params){
            if (!lang.isObject(params)) {
                params = {
                    _id : params  
                };
            } else {
                params = params.split("_");
                if (params.length === 2) {
                    params = {
                        _id : params[0],
                        fromShopId : params[1]
                    };
                } else {
                    params = {
                        _id : params[0]
                    }
                }
            }
            return this.exec('loadById', params);
        },
        loadOnePacBuy : function (params) {
            //var def = new Deferred();
            //if (!params.cqViewParam.params) {
            //    def.resolve({
            //        ficInto : false,
             //       freePost : false,
             //       isUse : true
             //   });
            //} else {
            //    this.loadById(params.cqViewParam.params).then(lang.hitch(this, function(data) {
            //        data = data.data.item;
            //        def.resolve(data);
            //    }));
            //} 
            if (!params.cqViewParam.params) {
                return;
            }
            var def = new Deferred();
			var m = params.cqViewParam.params;
			this.loadById(m).then(lang.hitch(this, function (data) {
				// 获取商家的信息
				data = data.data.item;
				def.resolve(data);
			}));
			return def;
        },
        getListProp : function (item) {
            var labelStr = "";
            labelStr += "<div>活动名称：" + item.title + "</div>";
            labelStr += "<div>商品名称：" + (item.mId ? (item.mId.mName) || "" : "") + "</div>";
            labelStr += "<div>拼团人数：" + item.pacNum || 0 + "</div>";
            labelStr += "<div>拼团价格：" + window.fixedTo(item.pacPic, 3) + "</div>";
            return {
                label : labelStr,
                data : item,
                variableHeight : true
            };  
        },
        onDataReady: function(){},
        onDataListReady: function(){}
    });
    var pacBuyBo = new PacBuyBo();
    pacBuyBo.Bo = PacBuyBo;
	return pacBuyBo;
});
