﻿define([
    "dojo/_base/declare"
],function(declare){
    return declare("",null,{
        modalName : "mk/pacBuy/pacBuy",
        fields : {
            title : {
                type : "text",
                label : "活动标题",
                placeHolder: "填写活动标题",
                notNull: true
            },
            mId : {
                type : 'ref',
                label : "拼团商品",
                pageSize : "20",
                dataProvider : "bob/mat/matB",
                targetMethod : "getListUrlForCurrentShop",
                labelFields : "mName",
                searchField : "search",
                query:{
                    isSpecs:false
                },
                notNull: true
            },
            pacPic : {
                type : "number",
                label : "拼团价格",
                placeHolder: "填写拼团价格",
                fixedTo: 2,
                notNull: true,
                range: "[0,)"
            },
            "mId.retailPrice": {
                type : "number",
                fixedTo: 2
            },
            pacNum : {
                type : "number",
                label : "拼团人数",
                placeHolder: "填写拼团人数",
                fixedTo: 0,
                notNull: true,
                range: "[2,)"
            },
            startTime : {
                type : "dateTime",
                label : "开始时间",
                notNull: true
            },
            endTime : {
                type : "dateTime",
                label : "结束时间",
                notNull: true
            },
            ficInto : {
                type : "checkbox",
                label : "模拟成团"
            },
            freePost : {
                type : "checkbox",
                label : "包邮"
            },
            rcdInfo  : {
                type : "textarea",
                label : "推荐信息",
                notNull: true
            },
            isUse : {
                type : "checkbox",
                label : "是否使用"
            }
        },
        getListUrl: function(){
            return this.getBaseUrl() + '/load';
        }
	});
});
