﻿define([
    "dojo/_base/declare",
    "bob/BoBase",
    "cq/util/sys/query",
    "./_Mixin",
    "cq/util/sys/date"
],function(declare, BoBase, query, _Mixin, date){
    var PacBuyBo = declare("",[BoBase.B, _Mixin],{
        fields: {
            save: {
                type: "button",
                label: "保存",
                action: "save",
                buttonClass: "fullButton"
            },
            disableById: {
                type: "button",
                label: "使失效",
                action: "disableById",
                buttonClass: "fullButton"
            },
            share: {
                type: "button",
                action: "share"
            },
            showTeams: {
                type: "button",
                action: "showTeams"
            },
            showPartners: {
                type: "button",
                action: "showPartners"
            },
            showOrders: {
                type: "button",
                action: "showOrders"
            }
        },
        // 添加拼团Layout
        getEdtLayout: function(){
            return [{
                type : "form",
                fields : this.getFormItems(["title", "mId", "pacPic", "pacNum", "startTime", "endTime",
                "ficInto", "freePost", "rcdInfo", "save","disableById","started","ended","disabled",
                "share","showTeams","showPartners","showOrders"])
            }];
        },
        // 加载指定拼团
        // 参数:
        //      _id
        loadById: function(params){
            var _id = params&&params.cqViewParam&&params.cqViewParam.params;
            if(!_id){
                return {
                    isUse: true,
                    freePost: true
                }
            }else{
                return this.exec("loadById", {
                    _id: _id
                }).then(function(result){
                    return result&&result.data&&result.data.item||{};
                });
            }
        },
        onDataReady: function(widget){
            var data = widget.getData();
            widget.hideByFields(["save","disableById","started","ended","disabled",
            "share","showTeams","showPartners","showOrders"]);
            widget.disableByFields();
            if(!data._id){
                widget.enableByFields();
                widget.showByFields(["save"]);
                return;
            }
            /* 徐阿雪 2018/8/6
            已开始未结束的拼团活动，可以修改结束时间和模拟成团
            注意：
            1. 未开始的活动编辑时，可以遍历前台传来的所有参数覆盖活动的属性
            2. 一开始的活动，只能修改模拟成团和结束时间字段，其他字段不能修改
            */
            widget.showByFields(["share","showTeams","showPartners","showOrders"]);
            var now = date.nowISOString();
            if(!data.isUse){
                widget.disableByFields();
                widget.showByFields(["disabled"]);
            }else if(now<data.startTime){
                //未开始的已经存在的拼团活动，不允许更改商品
                widget.enableByFields();
                widget.disableByFields(["mId"]);
                widget.showByFields(["disableById", "save"]);
            }else if(now>=data.startTime&&now<=data.endTime){
                 /*
                一开始未结束的拼团活动，可以修改结束时间和模拟成团
                注意：
                1. 未开始的活动编辑时，可以遍历前台传来的所有参数覆盖活动的属性
                2. 一开始的活动，只能修改模拟成团和结束时间字段，其他字段不能修改
                */
                widget.disableByFields();
                //允许修改最后结束时间，包邮，和模拟成团
                widget.enableByFields(["ficInto","endTime"])
                //允许保存
                widget.showByFields(["disableById", "started","save"]);
            }else{
                widget.disableByFields();
                widget.showByFields(["ended"]);
            }
        },
        // 保存
        save: function(data, dataList){
            var msg = this.getDataValidMsg(data, ['title',"mId","pacPic","pacNum","startTime","endTime","rcdInfo"]);
            if (msg) {
                alert(msg);
                return;
            }
            window.busy();
            this.exec('save', data).then(function (result) {
                window.free();
                if (result&&result.data && result.data.ok === 1) {
                    alert("保存成功");
                    history.back();
                } else {
                    alert(result&&result.data&&result.data.msg||"保存失败");
                }
            });
        },
        // 加载拼团的条件
        getListParam: function(cqRefInfo){
            var params = {
                shopId : this.getShopId(),
                state: 2
            };
            var paramValue = query.getQueryValue(cqRefInfo.state);
            if (paramValue) {
                params.state = paramValue;
            }
            if(cqRefInfo.search){
                params.search = cqRefInfo.search;
            }
            return params;
        },
        onListClick : function (item) {
            window.moveToView("pacBuyB", item._id);  
        },
        disableById: function(data, widget){
            window.busy();
            this.exec("disableById", {
                _id: data._id
            }).then(function(result){
                window.free();
                if (result&&result.data && result.data.ok === 1) {
                    alert("使失效成功");
                    history.back();
                } else {
                    alert(result&&result.data&&result.data.msg||"使失效失败");
                }
            });
        },
        showPartners: function(data, widget){
            if(!data._id){
                return;
            }
            window.moveToView("teamMemberListB", "pacId_"+data._id);
        },
        showTeams: function(data, widget){
            if(!data._id){
                return;
            }
            window.moveToView("pacTeamListB", data._id);
        },
        showOrders: function(data, widget){
            if(!data._id){
                return;
            }
            window.moveToView("teamOrderListB", "pacId_"+data._id);
        },
        share: function(data, widget){
            require([
                "cq/util/share/share",
                "bob/shop/shop"
            ], function(share, shop){
                var options = [{
                    "weixin": {
                        title: data.title,
                        thumb: data.mId.logo || "",
                        url:shop.getCurrentShopLocation()+"#matDetail-" + data.mId._id
                    }
                }, {
                    "friendCircle": {
                        title: data.title,
                        thumb: data.mId.logo || "",
                        url:shop.getCurrentShopLocation()+"#matDetail-" + data.mId._id
                    }
                }, {
                    "copy": {
                        url: shop.getCurrentShopLocation()+"#matDetail-" + data.mId._id
                    }
                }];
                share.showShare(options);
            });
        }
    });
    var pacBuyBo = new PacBuyBo();
    pacBuyBo.Bo = PacBuyBo;
    return pacBuyBo;
});
