﻿define([
    "dojo/_base/declare",
    "bob/BoBase",
    "./_Mixin",
    "bob/mk/pacBuy/team/c"
],function(declare, BoBase, _Mixin, team){
    var PacBuyBo = declare("",[BoBase.C, _Mixin],{
        getListParam: function(cqRefInfo){
            var params = {
                shopId: this.getShopId(),
                state: 2
            };
            if(cqRefInfo.cqViewParam.params){
                params.shopId = cqRefInfo.cqViewParam.params;
            }
            return params;
        },
        onListClick : function (item) {
            window.moveToView("matDetail", item.mId._id);
        },
        loadFromShopById: function(params){
            return this.exec("loadById",params);
        },
        loadById: function(params){
            var id = params&&params.cqViewParam&&params.cqViewParam.params||params||"";
            return this.exec("loadById", {
                _id: id
            }).then(function(result){
                var item = result&&result.data&&result.data.item||{};
                item.remainPacNum = item.pacNum-1;
                require([
                    "dojo/topic",
                    "cq/util/share/share",
                    "bob/shop/shop"
                ],function(topic,share,shop){
                    topic.publish("/cq/util/sys/share/infoChanged",{
                        title: item.title,
                        thumb: item.mId.logo || "",
                        url:shop.getCurrentShopLocation()+"#pacBuy-" + item._id
                    });
                });
                return item;
            });
        },
        share: function(data, widget){
            require([
                "cq/util/share/share",
                "bob/shop/shop"
            ], function(share, shop){
                var url = shop.getCurrentShopLocation()+"#matDetail-" + data.mId._id;
                var options = [{
                    "weixin": {
                        title: data.title,
                        thumb: data.mId.logo || "",
                        url:url
                    }
                }, {
                    "friendCircle": {
                        title: data.title,
                        thumb: data.mId.logo || "",
                        url:url
                    }
                }, {
                    "copy": {
                        url:url
                    }
                }];
                share.showShare(options);
            });
        },
        openGroup: function(data, widget){
            // 开团
            // 开团成功后 将团队ID 传入订单中
            team.newTeam({
                pacBuyId: data._id
            }).then(function(result){
                if(result&&result.data&&result.data.ok==1){
                    require([
                        "bob/ts/cart"
                    ], function(cart){
                        cart.addBuyNow(data.mId._id, 1, {pacTeamId: result.data.item._id});
                        window.moveToView('pacBuyOrderInfo', data.mId._id);
                    });
                }else{
                    alert(result&&result.data&&result.data.message||"开团失败");
                }
            });
        },
        buyNow: function(data, widget){
            var mat = data.mId;
            require(["whz/util/matDispose"], function(matDispose){
                matDispose.getAction(mat,"buyNow");
            });
        }
    });
    var pacBuyBo = new PacBuyBo();
    pacBuyBo.Bo = PacBuyBo;
	return pacBuyBo;
});
