﻿define([
    "dojo/_base/declare",
    "bob/BoBase",
    "cq/util/sys/query",
    "./_Mixin",
    "cq/util/sys/date",
    "whz/util/config"
],function(declare, BoBase, query, _Mixin, date, config){
    var PacBuyBo = declare("",[BoBase.B, _Mixin],{
        fields: {
            state: {
                type: "options",
                options: {
                    1:"准备参团",
                    2:"待付款",
                    3:"已付款",
                    4:"已退出"
                },
                label: "状态"
            }
        },
        getListUrl: function(){
            return this.getBaseUrl()+"/load"
        },
        getListItem: function(item){
            if(item.isLeader){
                item.tag = "<font class='pac_item_tag'>团长</font>";
                item.action = "开团";
            }else{
                item.action = "参团";
            }
            if(!item.user){
                item.user = {};
            }
            if(!item.user.logo){
                item.user.logo = config.defultUserLogo;
            }
            if(!item.user.nickName){
                item.user.nickName = item.user.pName || item.user.userName || "**";
            }
            return item;
        },
        // 加载拼团的条件
        getListParam: function(cqRefInfo){
            var params = {
                shopId : this.getShopId(),
                autoJoinIn: false,
                state: 3
            };
            var did = cqRefInfo&&cqRefInfo.cqViewParam&&cqRefInfo.cqViewParam.params||"";
            did = did.split(",");
            var pacId,teamId;
            if(did.length){
                for(var i=0;i<did.length;i++){
                    if(did[i].split("_")[0] == "pacId"){
                        pacId = did[i].split("_")[1];
                    }
                    if(did[i].split("_")[0] == "teamId"){
                        teamId = did[i].split("_")[1];
                    }
                }
            }
            if(pacId){
                params.pacId = pacId;
            }
            if(teamId){
                params.teamId = teamId;
            }
            var paramValue = query.getQueryValue(cqRefInfo.state);
            if (paramValue) {
                params.state = paramValue;
            }
            if(cqRefInfo.search){
                params.search = cqRefInfo.search;
            }
            return params;
        },
        onListClick : function (item) {
            if(!item.tsId){
                return;
            }
            window.moveToView("orderDetailB", item.tsId);
        },
        getExportLayout: function(){
            return this.getFormItems(["user.nickName","user.pName","user.userName","createAt","state", "isLeader"]);
        }
    });
    var pacBuyBo = new PacBuyBo();
    pacBuyBo.Bo = PacBuyBo;
    return pacBuyBo;
});
