﻿define([
    "dojo/_base/declare",
    "bob/BoBase",
    "cq/util/sys/query",
    "./_Mixin",
    "cq/util/sys/date",
    "whz/util/config"
],function(declare, BoBase, query, _Mixin, date, config){
    var PacBuyBo = declare("",[BoBase.B, _Mixin],{
        fields: {
            save: {
                type: "button",
                label: "保存",
                action: "save",
                buttonClass: "fullButton"
            },
            disableById: {
                type: "button",
                label: "使失效",
                action: "disableById",
                buttonClass: "fullButton"
            },
            share: {
                type: "button",
                action: "share"
            },
            state: {
                type: "options",
                options: {
                    1:"准备开团",
                    2:"开团成功",
                    3:"拼团成功",
                    4:"拼团失败"
                },
                label: "状态"
            },
            createAt: {
                type: "dateTime",
                label: "开团时间"
            },
            "leader.nickName": {
                type: "text",
                label: "团长昵称"
            },
            "leader.pName": {
                type: "text",
                label: "团长姓名"
            },
            "leader.userName": {
                type: "text",
                label: "团长登录名"
            }
        },
        // 加载指定拼团
        // 参数:
        //      _id
        loadById: function(params){
            var _id = params&&params.cqViewParam&&params.cqViewParam.params||params||"";
            if(!_id){
                return {
                    isUse: true,
                    freePost: true
                }
            }else{
                return this.exec("loadById", {
                    _id: _id
                }).then(function(result){
                    return result&&result.data&&result.data.item||{};
                });
            }
        },
        getListUrl: function(){
            return this.getBaseUrl()+"/load"
        },
        // 加载团队
        getListParam: function(cqRefInfo){
            var params = {
                shopId : this.getShopId(),
                state: 3
            };
            var pacId = cqRefInfo&&cqRefInfo.cqViewParam&&cqRefInfo.cqViewParam.params||"";
            if(pacId){
                params.pacId = pacId;
            }
            if(cqRefInfo.search){
                params.search = cqRefInfo.search;
            }
            if(cqRefInfo.state){
                params.state = cqRefInfo.state._id;
            }
            return params;
        },
        getListItem: function(item){
            if(!item.leader){
                item.leader = {};
            }
            if(!item.leader.nickName){
                item.leader.nickName = item.leader.pName || item.leader.userName || "**";
            }
            if(!item.leader.logo){
                item.leader.logo = config.defultUserLogo;
            }
            return item;
        },
        onListClick : function (data, action, widget) {
            if(action == "share"){
                this.share(data, widget);
            }else if(action == "showMembers"){
                window.moveToView("teamMemberListB", "teamId_"+data._id);
            }else if(action == "showOrders"){
                window.moveToView("teamOrderListB", "teamId_"+data._id);
            }else{
                
            }
        },
        share: function(data, widget){
            require([
                "cq/util/share/share",
                "bob/shop/shop"
            ], function(share, shop){
                var options = [{
                    "weixin": {
                        title: data.pacId.title,
                        thumb: data.pacId.mId.logo || "",
                        url:shop.getCurrentShopLocation()+"#pacTeam-" + data._id+","+data.fromShopId
                    }
                }, {
                    "friendCircle": {
                        title: data.pacId.title,
                        thumb: data.pacId.mId.logo || "",
                        url:shop.getCurrentShopLocation()+"#pacTeam-" + data._id+","+data.fromShopId
                    }
                }, {
                    "copy": {
                        url: shop.getCurrentShopLocation()+"#pacTeam-" + data._id+","+data.fromShopId
                    }
                }];
                share.showShare(options);
            });
        },
        getPacTeamListUrl: function(){
            return this.getBaseUrl() + "/loadOrder"
        },
        getPacTeamListParam: function(cqRefInfo){
            var params = {
                shopId: this.getShopId(),
                state: 1
            };
            var did = cqRefInfo&&cqRefInfo.cqViewParam&&cqRefInfo.cqViewParam.params||"";
            did = did.split(",");
            var pacId,teamId;
            if(did.length){
                for(var i=0;i<did.length;i++){
                    if(did[i].split("_")[0] == "pacId"){
                        pacId = did[i].split("_")[1];
                    }
                    if(did[i].split("_")[0] == "teamId"){
                        teamId = did[i].split("_")[1];
                    }
                }
            }
            if(pacId){
                params.pacId = pacId;
            }
            if(teamId){
                params.teamId = teamId;
            }
            if(cqRefInfo.state){
                params.state = cqRefInfo.state._id;
            }
            return params;
        },
        toOrderDetailB: function(data, widget){
            window.moveToView("orderDetailB", data._id);
        },
        getExportLayout: function(){
            return this.getFormItems(["leader.nickName","leader.pName","leader.userName","createAt","state"]);
        }
    });
    var pacBuyBo = new PacBuyBo();
    pacBuyBo.Bo = PacBuyBo;
    return pacBuyBo;
});
