﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "bob/BoBase",
    "./_Mixin",
    "cq/util/image/blob"
],function(declare, lang, BoBase, _Mixin, blob){
    var O = declare("",[BoBase.C, _Mixin],{
        fields: {
            joinIn: {
                type: "button",
                action: "joinIn"
            },
            share: {
                type: "button",
                action: "share"
            },
            "pacId.mId.retailPrice": {
                type: "number",
                fixedTo: 2
            },
            "pacId.pacPic": {
                type: "number",
                fixedTo: 2
            }
        },
        getListUrl: function(){
            return this.getBaseUrl()+"/loadMyTeam";
        },
        getListParam: function(cqRefInfo){
            var params = {
                shopId: this.getShopId()
            };
            if(cqRefInfo&&cqRefInfo.state){
                params.state = cqRefInfo.state._id;
            }
            return params;
        },
        getListItem: function(item){
            item.pacId.mId.logo = blob.getImageUrl(item.pacId.mId.logo,"80");
            return item;
        },
        onListClick: function(data, action, widget){
            if(action=="showOrder"){
                require(["bob/mk/pacBuy/member/c"], function(member){
                    member.loadByTeamId(data._id).then(function(result){
                        var item = result&&result.data&&result.data.item||{};
                        if(!item._id){
                            alert("没找到订单信息");
                            return;
                        }
                        window.moveToView("orderDetail", item.tsId);
                    });
                });
            }
        },
        newTeam: function(params){
            return this.exec("newTeam", params);
        },
        loadById: function(params){
            var did = params&&params.cqViewParam&&params.cqViewParam.params||params||"";
            did = did.split(",");
            var _id,fromShopId;
            _id = did[0];
            fromShopId = did[1]||this.getShopId();
            return this.exec("loadById", {
                _id: _id,
                fromShopId: fromShopId
            }).then(function(result){
                var item = result&&result.data&&result.data.item||{};
                item.limitTitle = "剩";
                item.remainNum = Number(item.pacId.pacNum||0)-Number(item.inNum);
                return item;
            });
        },
        loadOneByMid: function(params){
            return this.exec("loadOneByMid", params);
        },
        getLoadByMidUrl: function(){
            return this.getBaseUrl() + "/loadByMid";
        },
        getLoadByMidParam: function(cqRefInfo){
            var params = {
                shopId: this.getShopId()
            };
            var did = cqRefInfo&&cqRefInfo.cqViewParam&&cqRefInfo.cqViewParam.params||"";
            did = did.split(",");
            if(did.length){
                params.mId = did[0];
                params.fromShopId = did[1]||this.getShopId();
            }
            return params;
        },
        getLoadByMidListItem: function(item){
            item.remain = Number(item.pacId.pacNum) - Number(item.inNum);
            item.proccess = window.fixedTo(item.inNum/Number(item.pacId.pacNum)*100, 1);
            return item;
        },
        share: function(data, widget){
            require(["cq/util/share/share"], lang.hitch(this, function(share){
                share.getShopLocation(this.getShopId()).then(function(baseUrl){
                    var options = [{
                        "weixin": {
                            title: data.pacId.title,
                            thumb: data.pacId.mId.logo || "",
                            url:baseUrl+"#pacTeam-" + data._id+","+data.fromShopId
                        }
                    }, {
                        "friendCircle": {
                            title: data.pacId.title,
                            thumb: data.pacId.mId.logo || "",
                            url:baseUrl+"#pacTeam-" + data._id+","+data.fromShopId
                        }
                    }, {
                        "copy": {
                            url: baseUrl+"#pacTeam-" + data._id+","+data.fromShopId
                        }
                    }];
                    share.showShare(options);
                });
            }));
        },
        joinIn: function(data, widget){
            require([
                "whz/util/pacMatDispose",
                "bob/mat/matC",
                "bob/mk/pacBuy/c"
            ], function(matDispose, mat, pacbuy){
                mat.loadByIdWithAct(data.pacId.mId._id).then(function(matDoc){
                    if(!matDoc.pacBuyId||(matDoc.pacBuyId&&matDoc.pacBuyId!=data.pacId._id)){
                        pacbuy.loadById(data.pacId._id).then(function(pacBuyDoc){
                            matDoc.pacPic = pacBuyDoc.pacPic;
                            matDoc.pacNum = pacBuyDoc.pacNum;
                            matDispose.getAction(matDoc,"joinIn", data._id+","+data.fromShopId);
                        });
                    }else{
                        matDispose.getAction(matDoc,"joinIn", data._id+","+data.fromShopId);
                    }
                });
            });
        },
        toJoinIn: function(params){
            return this.exec("joinIn", params);
        },
        onDataReady: function(widget){
            var data = widget.getData();
            widget.hideByFields(["remainNum","limitTitle,limitTime"]);
            if(!data._id){
                return;
            }
            if(data.state==2){
                widget.showByFields(["remainNum","limitTitle,limitTime"]);
            }
        }
    });
    var o = new O();
    o.Bo = O;
	return o;
});
