﻿// 订单系统商家端
define([
    "dojo/_base/declare",
    '../../BoBase',
    "./_Mixin"
], function (declare,BoBase,_Mixin) {
    var O = declare("", [BoBase.B, _Mixin], {
        fields: {
            onSaveButton: {
				type: "button",
				label: "保存",
				action: "save",
				buttonClass: "fullButton"
			}
        },
        getEdtLayout: function(){
            return [{
                type : "form",
                fields : this.getFormItems(["point", "price", "prizeId", "prizeNum", "isUse", "onSaveButton"], true)
            }];
        },
        save: function(data){
            var msg = this.getDataValidMsg(data, ['point', "price"]);
			if (msg) {
				alert(msg);
				return;
			}
            this.exec('save', data).then(function (result) {
				if (result.data && result.data.ok === 1) {
					history.back();
				} else {
					alert(result.data.msg||"保存失败");
				}
			});
        },
        getListUrl: function(){
            return this.getBaseUrl() + '/load';
        },
        getListParam: function(cqRefInfo){
            var params = {
                shopId : this.getShopId()
            };
            return params;
        },
        onListClick : function (item) {
            window.moveToView("pointEdt", item._id);
        },
        loadById: function (params){
            if(!params.cqViewParam.params){
                return {
                    isUse: true
                };
            }
			return this.exec('loadById', {
                _id: params.cqViewParam.params
            }).then(function(result){
                var item = result&&result.data&&result.data.item;
                return item||{};
            });
        }
    });
    var o = new O();
    o.Bo = O;
    return o;
});