﻿//订单系统公共基类
// 1、提供订单系统的基本属性
// 2、提供公用的方法
define([
    "dojo/_base/declare"
], function (declare) {
    return declare("",null,{
        modalName:"mk/pre_sale",
        //字段名
        fields:{
            mId : {
                type : 'ref',
                label : "预售商品",
                pageSize : "20",
                dataProvider : "bob/mat/matB",
                query:{
                    isSpecs:false
                },
                targetMethod : "getListUrlForCurrentShop",
                labelFields : "mName",
                searchField : "mName"
            },
			"mId.mName": {
				type: "text"
			},
            startTime : {
                type : 'dateTime',
                label : '预售开始时间',
                notNull : true
            },
            endTime : {
                type : 'dateTime',
                label : '预售结束时间',
                notNull : true
            },
            startPayTime : {
                type : 'dateTime',
                label : '尾款支付开始时间',
                notNull : true
            },
            endPayTime : {
                type : 'dateTime',
                label : '尾款支付结束时间',
                notNull : true
            },
            isUse : {
                type : 'checkbox',
                label : '使用',
                selected : true
            },
            earnest : {
                type : 'number',
                label : '定金',
                notNull : true,
                placeHolder: "待支付的定金金额"
            },
            finalPayment : {
                type : 'number',
                label : '尾款',
                placeHolder: "待支付的尾款金额"
            },
            postNum : {
                type : 'number',
                label : '下单数',
                notNull : true
            },
            payEarNum : {
                type : 'number',
                label : '支付定金数',
                notNull : true
            },
            payNum : {
                type : 'number',
                label : '支付数',
                notNull : true
            },
            ladders: {
                type: 'objects',
                label: '阶梯',
                labelField: 'qtyFrom',
                rightTextField: 'qtyTo',
                canEdit:true,
                canDelete:true,
                canAdd:true,
                canDnd:false,
                fields: {
                    workMode:"edit",
                    className:"editEditor",
                    layout: [{
                        field : "qtyFrom",
                        type : "number",
                        notNull : true,
                        label : "定金数从",
                        placeHolder: "支付定金数从",
                        range: "(0,)"
                    }, {
                        field : "qtyTo",
                        type : "number",
                        notNull : true,
                        label : "定金数到",
                        placeHolder: "支付定金数到"
                    }, {
                        field : "finalPayment",
                        type : "number",
                        notNull : true,
                        label : "尾款",
                        placeHolder: "阶梯尾款",
                        range: "(0,)"
                    }]
                }
            }
        }
    });
});
