//订单系统公共基类
// 1、提供订单系统的基本属性
// 2、提供公用的方法
define([
    "dojo/_base/declare"
], function (declare) {
    return declare("",null,{
        modalName:"mk/prize/prize/b2c",
        //字段名
        fields:{
            prizeName : {
                type : 'text',
                label : '活动名称',
                placeHolder : '必填',
                notNull: true
            },
            luckType : {
                type : 'options',
                label : '中奖类型',
                options : {
                    1:'随机中奖',
                    2:'先到先得'
                },
                selected: 1,
                canEdit : 1,
                notNull: true
            },
            maxLucky : {
                type : 'number',
                label : '最大中奖数',
                placeHolder: "填写最大中奖数",
                range : "[1,)",
                isInteger : true,
                notNull: true
            },
            startTime : {
                type : 'dateTime',//date
                label : '开始时间',
                notNull: true
            },
            endTime : {
                type : 'dateTime',
                label : '结束时间',
                notNull: true
            },
            stopTime: {
                type: 'dateTime',
                label: "停用时间"
            },
            content: {
                type : 'textarea',
                label : '活动说明信息',
                notNull: true
            },
            price: {
                type : 'number',
                label : '消耗积分',
                placeHolder: "每次抽奖使用积分数",
                range:"[0,)"
            },
            involvedNum: {
                type : 'number',
                label : '参与次数',
                placeHolder: '指定用户每天抽奖次数',
                notNull: true,
                isInteger : true,
                range:"[0,)"
            },
            remark: {
                type : 'textarea',
                label:'未中奖的提示说明'
            },
            //抽奖字段是一个对象，点击新增的弹出字段
            awards: {
                type : 'objects',
                label : '奖项',
                reloadMethod : "awardsReload",
                fieldChangeMethod:"awardsLayoutChange",
                dataProvider : "bob/mk/prize/b",
                canEdit: true,
                canDelete: true,
                canAdd: true,
                canDnd: false,
                fields: {
                    workMode: "edit",
                    className:"editEditor",
                    layout: [{
                        field : "awardType",
                        type : "options",
                        options : {
                            1:'一等奖',
                            2:'二等奖',
                            3:'三等奖',
                            4:'四等奖',
                            5:'五等奖'
                        },
                        canEdit : 1,
                        label : "奖品等级"
                    }, {
                        field : "sendType",
                        type : "options",
                        options:{
                            1:'送积分',
                            2:'送优惠券',
                            3:'送赠品',
                        },
                        selected: 3,
                        label : "奖品类型"
                    }, {
                        field : "awardNum",
                        type : "number",
                        label : "奖品数量",
                        placeHolder: "填写奖品数量",
                        range : "[1,)",
                        isInteger : true,
                        notNull: true
                    }/*,{
                        field : "awardName",
                        type : "text",
                        label : "奖品名称",
                        placeHolder: "填写奖品名称"
                    }*/,{
                        field : "awardAmount",
                        type : "number",
                        label : "积分金额",
                        placeHolder: "中奖积分金额",
                        range : "[1,)",
                    },{
                        field : "awardCoupon",
                        type : "ref",
                        label : "优惠活动",
                        labelFields : "title",
                        searchField : "search",
                        pageSize : 10,
                        dataProvider : "bob/mk/discount/b",
                        targetMethod : "getListUrl",
                        query: {
                            typeId: 1,
                            state : 4
                        }
                    }, {
                        field : "awardMid",
                        type : "ref",
                        label : "赠品",
                        labelFields : "mName",
                        searchField : "mName",
                        pageSize : 10,
                        dataProvider : "bob/mat/matB",
                        query:{
                            isSpecs:false
                        },
                        targetMethod : "getListUrlForCurrentShop"
                    },{
                        field: "handledNum",
                        type: "number",
                        label: "已中"
                    }]
                }
            },
            typeId: {
                type: "options",
                label: "抽奖类型",
                options: {
                    4: "其他",
                    3: "注册新用户"
                },
                selected: 4,
                notNull: true
            },
            giftNum: {
                type: "number",
                label: "赠送次数",
                range:"[0,)"
            }
        }
    });
});