define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    '../../BoBase',
    "./_Mixin",
    "cq/util/sys/date"
], function (declare,lang,BoBase,_Mixin,date) {
    //本对象功能：
    //      新增抽奖
    //      奖项编辑,停用，查看等一系列操作
    //      
    var PrizeBBo = declare("", [BoBase.B, _Mixin], {
        fields:{
            saveButton:{
                type: "button",
                label: "保存",
                action: "save",
                buttonClass: "fullButton"
            },
            //停用
            stopButton:{
                type: "button",
                label: "停用",
                action: "stopPrize",
                buttonClass: "fullButton"
            },
            stoped: {
                type: "button",
                label: "已停用",
                action: "stoped",
                buttonClass: "fullButton"
            },
            ended: {
                type: "button",
                label: "已结束",
                action: "ended",
                buttonClass: "fullButton"
            },
            //抽奖记录
            prizeRecordButton:{
                type: "button",
                label: "抽奖记录",
                action: "recordPrize",
                buttonClass: "fullButton"
            },
            //中奖结果
            prizeResultButton:{
                type: "button",
                label: "中奖结果",
                action: "resultPrize",
                buttonClass: "fullButton"
            },
            share: {
                type: "button",
                action: "share"
            },
            toAddPrizeNum: {
                type: "button",
                action: "toAddPrizeNum"
            },
            addPrizeNum: {
                type: "button",
                action: "addPrizeNum"
            },
            userId: {
                type: "ref",
                label: "赠送客户",
                dataProvider: 'bob/user/customer',
                targetMethod: 'getUserListUrl',
                className: 'middle-width',
                searchField: 'search',
                labelFields: 'nickName,pName,userName',
                query: {
                    isFarmer: false
                },
                notNull: true//,
                //multiselect : "multiselect"
            },
            addNum: {
                type: "number",
                label: "赠送次数",
                notNull: true,
                range: "(0,)",
                placeHolder: "填写赠送次数"
            }
        },
        //根据点击显示隐藏引用对象的字段
        awardsReload:function(widget){
            var data = widget.getData();
            if(data.sendType == 3){
                widget.disableByFields(["handledNum"]);
                widget.hideByFields(["awardCoupon","awardAmount"]);
                widget.showByFields(["awardMid"]);
            }else if(data.sendType == 2){
                widget.disableByFields(["handledNum"]);
                widget.hideByFields(["awardMid","awardAmount"]);
                widget.showByFields(["awardCoupon"]);
            }else{
                widget.disableByFields(["handledNum"]);
                widget.hideByFields(["awardMid","awardCoupon"]);
                widget.showByFields(["awardAmount"]);
            }
        },
        //根据字段改变显示隐藏相应字段
        awardsLayoutChange:function(widget,field,value){
            if(field == "sendType"){
                var data = widget.getData();
                widget.disableByFields(["handledNum"]);
                // 送赠品
                if(data.sendType == 3){
                    widget.hideByFields(["awardCoupon","awardAmount"]);
                    widget.showByFields(["awardMid"]);
                }else if(data.sendType == 2){
                    widget.hideByFields(["awardMid","awardAmount"]);
                    widget.showByFields(["awardCoupon"]);
                }else{
                    widget.hideByFields(["awardMid","awardCoupon"]);
                    widget.showByFields(["awardAmount"]);
                }
            }
        },
        //新增优惠活动的编辑界面
        getEdtLayout: function(){
            return [{
                type : "form",
                fields : this.getFormItems(["typeId", "prizeName", "luckType", "maxLucky", "startTime", "endTime", "content", "giftNum", "price",
                "involvedNum", "remark", "awards", "saveButton", "stopButton", "stoped", "ended", "prizeRecordButton", "prizeResultButton", "share","toAddPrizeNum"], true)
            }];
        },
        //依据id加载抽奖
        loadById:function(params){
            if (!params.cqViewParam.params) {
                return {
                    luckType: 1,
                    typeId: 4
                };
            }
            return this.exec("loadById",{
                _id:params.cqViewParam.params
            }).then(lang.hitch(this,function(result){
                return result&&result.data&&result.data.item||{};
            }));
        },
        //加载所有的抽奖活动的url
        getListUrl:function(){
            return this.getBaseUrl() + '/load?shopId='+this.getShopId();;
        },
        //加载所有抽奖的条件
        getListParam:function(cqRefInfo){
            var params = {};
            var state = cqRefInfo.state ? cqRefInfo.state._id : 0;
            if (state) {
                if (state == 3) {
                    // 已停用
                    params.isUse = false;
                } else {
                    params.isUse = true;
                    params.state = state;
                }
            }
            return params;
        },
        //抽奖活动列表的点击事件
        onListClick:function(item){
            window.moveToView("prizeEdit",item._id);
        },
        // 商品数据加载完成后的显示
        onDataReady: function (widget) {
            widget.hideByFields(["giftNum", "price","involvedNum",
                "saveButton", "stoped", "ended", 'stopButton', 'prizeRecordButton', 'prizeResultButton', "share","toAddPrizeNum"]);
            widget.disableByFields();
            //依据活动类型，显示隐藏字段
            var data = widget.getData();
            if(data.typeId===3){
                widget.showByFields(["giftNum"]);
            }else{
                widget.showByFields(["price","involvedNum"]);
            }
            if(!data._id){
                widget.enableByFields();
                widget.showByFields(["saveButton"]);
                return;
            }
            widget.showByFields(["share","toAddPrizeNum"]);
            widget.showByFields(['prizeRecordButton', 'prizeResultButton']);
            // 判断是否已经停用
            var now = date.nowISOString();
            if(!data.isUse){
                widget.showByFields(["stoped"]);
                return ;
            }else if(now>data.endTime){
                widget.showByFields(["ended"]);
                return;
            }else{
                widget.showByFields(["stopButton"]);
            }
            if(data.startTime>now){
                widget.showByFields(["saveButton"]);
                widget.enableByFields();
                widget.hideByFields(['prizeRecordButton', 'prizeResultButton']);
            }else{
                widget.showByFields(['prizeRecordButton', 'stopButton','prizeResultButton']);
            }
        },
        onFieldChanged:function(widget,field,value){
            if(field==="typeId"){
                if(value==3){
                    widget.showByFields(["giftNum"]);
                    widget.hideByFields(["price","involvedNum"]);
                    widget.updateByField("price",0);
                    widget.updateByField("involvedNum",0);
                }else{
                    widget.hideByFields(["giftNum"]);
                    widget.showByFields(["price","involvedNum"]);
                }
            }
        },
        //保存抽奖
        save:function(data, widget){
            if(data.typeId==3){
                if(!(data.giftNum>0)){
                    return alert("赠送次数必须大于 0");
                }
                data.price = data.involvedNum = 0;
            }
            var msg = this.getDataValidMsg(data, ["typeId", "prizeName", "luckType", "maxLucky", "startTime", "endTime",
            "content", "price", "involvedNum", "remark", "awards"]);
            if (msg) {
                alert(msg);
                return;
            }
            // 检查奖项信息
            var awards = data.awards;
            if(!(awards&&awards.length)){
                alert("请添加奖项");
                return;
            }
            if(awards.length>5){
                alert("最多只能设置五个奖项");
                return;
            }
            var awardTypeHash = {};
            for(var i=0;i<awards.length;i++){
                if(!awards[i].awardType){
                    alert("第"+(i+1)+"行奖品等级未选择");
                }
                if(awardTypeHash[awards[i].awardType]){
                    alert("第"+(i+1)+"行奖品等级重复");
                    return;
                }
                if(!awards[i].awardNum){
                    alert("第"+(i+1)+"行奖品数量不能为空");
                    return;
                }
                awardTypeHash[awards[i].awardType] = 1;
                // 送积分
                if(awards[i].sendType==1&&!awards[i].awardAmount){
                    alert("第"+(i+1)+"行积分金额不能为空");
                    return;
                }
                if(awards[i].sendType==2&&!awards[i].awardCoupon){
                    alert("第"+(i+1)+"行优惠活动不能为空");
                    return;
                }
                if(awards[i].sendType==3&&!awards[i].awardMid){
                    alert("第"+(i+1)+"行赠品不能为空");
                    return;
                }
                awards[i].awardName = awards[i].sendType==1?awards[i].awardAmount+"个积分":awards[i].sendType==2?"优惠券-"+awards[i].awardCoupon.title:awards[i].awardMid.mName;
            }
            window.busy();
            this.exec('save', data).then(function (result) {
                window.free();
                if (result&&result.data && result.data.ok === 1) {
                    history.back();
                } else{
                    alert(result&&result.data&&result.data.message||"保存失败");
                }
            });
        },
        //停用抽奖
        stopPrize:function(data,widget){
            window.busy();
            this.exec("stopById",{
                _id:data._id
            }).then(lang.hitch(this,function(data){
                window.free();
                if(data&&data.data&&data.data.ok){
                    alert("停用成功");
                    widget.cqRefresh();
                }else{
                    alert(data&&data.data&&data.data.message||"停用失败");
                }
            }));
        },
        loadPrizeRecords: function(){
            return this.getBaseUrl()+"/loadPrizeRecords?shopId="+this.getShopId()
        },
        // 抽奖记录
        recordPrize:function(data,widget){
            var _this = this;
            require([
                "cq/util/sys/xlsx",
				"cq/util/sys/date",
				"cq/util/sys/userAgent"
            ], function(xlsx, date, userAgent){
                var url = _this.loadPrizeRecords();
                var params = {
                    prizeId: data._id
                };
                xlsx.loadAllData(url,params).then(lang.hitch(this,function(items){
                    //设置表头
                    var datas = [["抽奖人","抽奖时间"]];
                    var createAt = "";
                    for(var i=0;i<items.length;i++){
                        createAt = date.formatISODateMinutes(items[i].createAt);
                        datas.push([(items[i].userId.nickName||items[i].userId.pName||items[i].userId.userName),createAt]);
                    }
                    xlsx.exportMatrix(datas,Date.now().toString());
                }));
            });
        },
        getAwardType: function(awardType){
            var options = {
                1:'一等奖',
                2:'二等奖',
                3:'三等奖',
                4:'四等奖',
                5:'五等奖'
            };
            return options[awardType];
        },
        getSendType: function(sendType){
            var options = {
                1:'积分',
                2:'优惠券',
                3:'赠品',
                4:'现金红包'
            };
            return options[sendType];
        },
        getState: function(state){
            state = state==undefined?0:state;
            var options = {
                0:"未领取",
                1:"已领取",
                2:"已过期"
            };
            return options[state];
        },
        //中奖记录
        resultPrize:function(data,widget){
            var _this = this;
            require([
                "bob/mk/prizeResult/b",
                "cq/util/sys/xlsx",
				"cq/util/sys/date",
				"cq/util/sys/userAgent"
            ], function(prizeResult, xlsx, date, userAgent){
                var url = prizeResult.getListUrl();
                var params = {
                    prizeId: data._id
                };
                xlsx.loadAllData(url,params).then(function(items){
                    //设置表头
                    var datas = [["中奖人","中奖时间","中奖等级","奖品类型","奖品","领取状态", "领取时间"]];
                    var createAt = "", receiveTime = "";
                    for(var i=0;i<items.length;i++){
                        createAt = date.formatISODateMinutes(items[i].createAt);
                        receiveTime = items[i].receiveTime;
                        receiveTime = receiveTime?date.formatISODateMinutes(receiveTime):"";
                        datas.push([(items[i].userId.nickName||items[i].userId.pName||items[i].userId.userName),createAt,_this.getAwardType(items[i].awardType),
                        _this.getSendType(items[i].sendType),items[i].awardName,_this.getState(items[i].state),receiveTime]);
                    }
                    xlsx.exportMatrix(datas,Date.now().toString());
                });
            });
        },
        // 分享
        share: function(data, widget){
            require(["cq/util/share/share"], lang.hitch(this, function(share){
                share.getShopLocation(this.getShopId()).then(function(baseUrl){
                    var options = [{
                        "weixin": {
                            title: data.prizeName,
                            thumb: data.logo || "",
                            url: baseUrl+"#prizeBigWheel-" + data._id
                        }
                    }, {
                        "friendCircle": {
                            title: data.prizeName,
                            thumb: data.logo || "",
                            url: baseUrl+"#prizeBigWheel-" + data._id
                        }
                    }, {
                        "copy": {
                            url: baseUrl+"#prizeBigWheel-" + data._id
                        }
                    }];
                    share.showShare(options);
                });
            }));
        },
        getToAddPrizeNumLayout: function(){
            return [{
                type: "form",
                fields: this.getFormItems(["userId", "addNum", "addPrizeNum"])
            }];
        },
        toAddPrizeNum: function(data, widget){
            window.moveToView("toAddPrizeNum", data._id);
        },
        addPrizeNum: function(data, widget){
            var msg = this.getDataValidMsg(data, ["userId", "addNum"]);
            if(msg){
                alert(msg);
                return;
            }
            window.busy();
            this.exec("giftByUserId", {
                _id: data._id,
                userId: data.userId,
                num: data.addNum
            }).then(function(result){
                window.free();
                if(result&&result.data&&result.data.ok==1){
                    alert("赠送成功");
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"赠送失败");
                }
            });
        }
    });
    var prizeBBo = new PrizeBBo();
    prizeBBo.Bo = PrizeBBo;
    return prizeBBo;
});