//订单系统公共基类
// 1、提供订单系统的基本属性
// 2、提供公用的方法
define([
    "dojo/_base/declare"
], function (declare) {
    return declare("",null,{
        modalName:"mk/prize/prize/b2b",
        //字段名
        fields:{
            prizeName : {
                type : 'text',
                label : '活动名称',
                placeHolder : '必填',
                notNull: true
            },
            luckType : {
                type : 'options',
                label : '中奖类型',
                options : {
                    1:'随机中奖',
                    2:'先到先得'
                },
                canEdit : 1,
                notNull: true
            },
            maxLucky : {
                type : 'number',
                label : '最大中奖数',
                notNull: true
            },
            startTime : {
                type : 'dateTime',//date
                label : '开始时间',
                notNull: true
            },
            endTime : {
                type : 'dateTime',
                label : '活动结束时间',
                notNull: true
            },
            content : {
                type : 'text',
                label : '活动说明信息',
                notNull: true
            },
            price : {
                type : 'number',
                label : '消耗金额',
                notNull: true
            },
            involvedNum : {
                type : 'number',
                label : '参与次数',
                notNull: true
            },
            remark : {
                type : 'text',
                label:'未中奖的提示说明',
                notNull: true
            },
            onBusinessRegistButton:{
				type: "button",
				label: "保存",
				action: "save",
				buttonClass: "fullButton"
			},
            //编辑
            editButton:{
                type: "button",
				label: "编辑",
				action: "editPrize",
				buttonClass: "fullButton"
            },
            //停用
            stopButton:{
                type: "button",
				label: "停用",
				action: "stopPrize",
				buttonClass: "fullButton"
            },
            //抽奖记录
            prizeRecordButton:{
                type: "button",
				label: "抽奖记录",
				action: "recordPrize",
				buttonClass: "fullButton"
            },
            //中奖结果
            prizeResultButton:{
                type: "button",
				label: "中奖结果",
				action: "resultPrize",
				buttonClass: "fullButton"
            }
        }
    });
});