define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/util/config/config",
    '../../BoBase',
    "./_Mixin",
    "cq/util/sys/date"
], function (declare,lang,config,BoBase,_Mixin,date) {
    //本对象功能：b2b
    //      新增抽奖
    //      奖项编辑,停用，查看等一系列操作
    //      
    var PrizeBBo = declare("", [BoBase.B, _Mixin], {
        fields:{
            //抽奖字段是一个对象，点击新增的弹出字段
            awards : {
                type : 'objects',
                label : '新增奖项',
                reloadMethod : "awardsReload",
                fieldChangeMethod:"awardsLayoutChange",
                dataProvider : "bob/mk/prize/b",
                userDefinedValue : "awardsLabel",
                canEdit : true,
                canDelete : true,
                canAdd : true,
                canDnd : true,
                fields : {
                    layout : [{
                            field : "awardType",
                            type : "options",
                            options : {
                                1:'一等奖',
                                2:'二等奖',
                                3:'三等奖',
                                4:'四等奖',
                                5:'五等奖'
                            },
                            canEdit : 1,
                            label : "奖品等级",
                            notNull: true
                        }, {
                            field : "sendType",
                            type : "options",
                            options:{
                                1:'送积分',
                                2:'送优惠券',
                                3:'送赠品',
                            },
                            canEdit : 1,
                            label : "奖品类型",
                            notNull: true
                        }, {
                            field : "awardNum",
                            type : "number",
                            label : "奖品数量",
                            notNull: true
                        },{
                            field : "awardName",
                            type : "text",
                            label : "奖品名称",
                            //notNull: true
                        },{
                            field : "awardAmount",
                            type : "number",
                            label : "积分金额"
                            //notNull: true
                        },{
                            field : "awardCoupon",
                            type : "ref",
                            label : "优惠活动",
                            labelFields : "title",
                            searchField : "awardCoupon",
                            pageSize : 5,
                            dataProvider : "bob/mk/coupon/b",
                            targetMethod : "getListCouponUrl",
                            query : {},
                            canEdit : true
                        }
                    ]
                }
            },
        },
        //自己定制label属性值，左边是label，右边是rightText
        awardsLabel:function(widget,data){
            var label = (data.awardType==1?"一等奖":data.awardType==2?"二等奖":data.awardType==3?"三等奖":data.awardType==4?"四等奖":"五等奖")+"，"+(data.sendType==1?"积分金额："+data.awardAmount:data.sendType==2?"优惠活动："+data.awardCoupon.title:"奖品名称："+data.awardName)+"，奖品数量："+data.awardNum;
            widget.set("label",label);       
        },
        //根据点击显示隐藏引用对象的字段
        awardsReload:function(widget){
            widget.hideByFields(["awardName","awardCoupon"]);
        },
        //根据字段改变显示隐藏相应字段
        awardsLayoutChange:function(widget,field,value){
            if(field == "sendType"){
                var data = widget.getData();
                if(data.sendType == 3){
                    widget.hideByFields(["awardCoupon","awardAmount"]);
                    widget.showByFields(["awardName"]);
                }else if(data.sendType == 2){
                    widget.hideByFields(["awardName","awardAmount"]);
                    widget.showByFields(["awardCoupon"]);
                }else{
                    widget.hideByFields(["awardName","awardCoupon"]);
                    widget.showByFields(["awardAmount"]);
                }
            }
        },
        //新增优惠活动的编辑界面
        getEdtLayout: function(){
            return [{
                type : "form",
                fields : this.getFormItems(["prizeName", "luckType", "maxLucky", "startTime", "endTime", "content", "price", "involvedNum", "remark", "awards","onBusinessRegistButton"], true)
            }];
        },
        //依据id加载抽奖
        loadById:function(params){
            if (!params.cqViewParam.params) {
                return;
            }
            return this.exec("loadById",{
                _id:params.cqViewParam.params
            }).then(lang.hitch(this,function(result){
                if(result&&result.data&&result.data.item){
                    for(var i =0;i<result.data.item.awards.length;i++){
                        result.data.item.awards[i].name="奖品名称";
                        if(result.data.item.awards[i].sendType==1){
                            result.data.item.awards[i].awardName=result.data.item.awards[i].awardAmount;
                            result.data.item.awards[i].name="积分金额";
                        }else if(result.data.item.awards[i].sendType==2){
                            result.data.item.awards[i].awardName=result.data.item.awards[i].awardCoupon.title;
                            result.data.item.awards[i].name="优惠活动";
                        }
                        result.data.item.awards[i].awardType = (result.data.item.awards[i].awardType==1?"一等奖":result.data.item.awards[i].awardType==2?"二等奖":result.data.item.awards[i].awardType==3?"三等奖":result.data.item.awards[i].awardType==4?"四等奖":"五等奖")
                    }
                    result.data.item.luckType = (result.data.item.luckType===1?"随机抽奖":"先到先得")
                    result.data.item.startTime=date.formatISODateMinutes(result.data.item.startTime);
                    result.data.item.endTime=date.formatISODateMinutes(result.data.item.endTime);
                    if(result.data.item.stopTime){
                        result.data.item.stopTime = "停用时间："+date.formatISODateMinutes(result.data.item.stopTime);
                    }else{
                        result.data.item.stopTime = "";
                    }
                }
                return result&&result.data&&result.data.item||{};
            }));
            
        },
        //加载所有的抽奖活动的url
        getListUrl:function(){
            return this.getBaseUrl() + '/load';
        },
        //加载所有抽奖的条件
        getListParam:function(cqRefInfo){
            var params = {};
            if(cqRefInfo.state&&cqRefInfo.state._id){
                params.state = cqRefInfo.state._id;
            }
            params.shopId = this.getShopId();
            return params;
        },
        //抽奖活动列表的点击事件
        onListClick:function(item){
            window.moveToView("prizeDetail",item._id);
        },
        //监听编辑奖项
        awardsChange:function(widget,field,value){
            if(field == "awards"){
                //奖项不能超过5个，而且是从一到五依次增加的
                if(widget.getData().awards.length<5){
                    //判断是递增的奖项
                    var awards = widget.getData().awards;
                    for(var i=0;i<awards.length;i++){
                        if(awards[i]&&awards[i].awardType!=i+1){
                            alert("请设置"+(i+1)+"等奖");
                            var label = "请设置"+(i+1)+"等奖";
                            widget.set("label",label);  
                            return;
                        }
                    }
                }else{
                    alert("奖项不能超过5！");
                    return;
                }
            }
        },
        // 商品数据加载完成后的显示
		onDataReady: function (widget) {
			widget.hideByFields(['editButton','stopButton','prizeRecordButton','prizeResultButton']);
			var data = widget.getData();
			// 判断活动状态
            if(!data.isUse){
                widget.showByFields(['prizeRecordButton','prizeResultButton']);
                widget.hideByFields(['editButton', 'stopButton']);
            }else if(data.isUse&&data.startTime>date.nowISOString()){
                widget.showByFields(['editButton']);
                widget.hideByFields(['prizeRecordButton', 'stopButton','prizeResultButton']);
            }else if(data.isUse===true&&data.startTime<date.nowISOString()&&data.endTime>date.nowISOString()){
                widget.showByFields(['prizeRecordButton','prizeResultButton','stopButton']);
                widget.hideByFields(['editButton']);
            }
			// 重算高度
			var view = widget.getView();
			if (view) {
				view.resize();
			}
		},
        //保存抽奖
        save:function(data, dataList){
            var msg = this.getDataValidMsg(data, ["prizeName", "luckType", "maxLucky", "startTime", "endTime", "content", "price", "involvedNum", "remark", "awards"]);
			if (msg) {
				alert(msg);
				return;
			}
            this.exec('save', data).then(function (result) {
				if (result.data && result.data.ok === 1) {
					window.moveToView("prizeList");
				} else if(result.data.msg){
					alert(result.data.msg);
				}
			});
        },
        //编辑按钮
        editPrize:function(data,widget){
            window.moveToView("prizeEdit",data._id);
        },
        //停用抽奖
        stopPrize:function(data,widget){
            this.exec("stopById",{_id:data._id}).then(lang.hitch(this,function(data){
                if(data.data.ok){
                    alert("已经停用");
                    //不知道停用过后应该怎么显示呢
                    widget.showByFields(['prizeRecordButton','prizeResultButton']);
                    widget.hideByFields(['editButton','stopButton']);
                }else{
                    this.isEditing = true;
                    alert("不成功的停用，不知道为什么会有");
                }
            }));
        },
        //中奖记录
        recordPrize:function(data,widget){alert("待实现");},
        resultPrize:function(data,widget){alert("待实现");}
        //抽奖记录和中奖结果以前就没有处理，暂时没写
        
    });
    var prizeBBo = new PrizeBBo();
    prizeBBo.Bo = PrizeBBo;
    return prizeBBo;
});