﻿//抽奖系统，获取结果的基类
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    '../../BoBase',
    "./_Mixin",
    "bob/user/consumer",
    "cq/util/sys/query"
], function (declare, lang,BoBase,_Mixin, consumer, query) {
    var PrizeCBo = declare("", [BoBase.C, _Mixin], {
        fields: {
            bg_color:{
                type: "text"
            },
            received: {
                type: "button",
                action: "received"
            }
        },
        //抽奖
        prize:function(params){
            return this.exec("prize",params);
        },
        //加载所有的抽奖信息
        load:function(params){
            return this.exec("load",params);
        },
        getListUrl: function(){
            return this.getBaseUrl()+"/load";
        },
        getListParam: function(params){
            var param = {
                shopId: this.getShopId(),
                userId: consumer.getCurrentUserId(),
                state:0
            };
            var state = query.getQueryValue(params.state);
            if(state!=undefined){
                param.state = state;
            }
            return param;
        },
        getListItem: function(item){
            item.awardTypeStr = this.getAwardTypeString(item.sendType);
            item.stateStr = this.getStateString(item.state);
            if(item.state&&item.state>0){
                item.bg_color = "grey";
            }else{
                item.bg_color = "";
            }
            return item;
        },
        onListClick: function(data, action, widget){
            window.moveToView("award", data._id);
        },
        loadById: function(params){
            return this.exec("loadById", {
                _id: params.cqViewParam.params
            }).then(lang.hitch(this, function(result){
                var item = result&&result.data&&result.data.item||{}
                item.awardTypeStr = this.getAwardTypeString(item.sendType);
                return item;
            }));
        },
        //提供给领奖页面的loadById
        loadMatInfoById:function(prizeId){
            return this.exec("loadById",{_id:prizeId});
        },
        receive: function(data){
            window.moveToView("giftOrderInfo", data._id);
        },
        onDataReady: function(widget){
            var data = widget.getData();
            widget.hideByFields(["receive", "received"]);
            if(!data._id){
                return;
            }
            if(data.state>0){
                widget.showByFields(["received"]);
            }else{
                widget.showByFields(["receive"]);
            }
        }
    });
    var prizeCBo = new PrizeCBo();
    prizeCBo.Bo = PrizeCBo;
    return prizeCBo;
});