﻿define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "bob/BoBase",
    "./_Mixin",
    "cq/util/sys/date"
],function(declare, array, BoBase, _Mixin, date){
    var O = declare("",[BoBase.B, _Mixin],{
        fields: {
            save: {
                type: "button",
                action: "save"
            },
            share: {
                type: "button",
                action: "share"
            },
            qnrResult: {
                type: "button",
                action: "qnrResult"
            },
            exportMethod: {
                type: "button",
                action: "exportMethod"
            }
        },
        getListParam: function(cqRefInfo){
            return {
                shopId: this.getShopId()
            };
        },
        getEditLayout: function(){
            return [{
                type : "form",
                fields : this.getFormItems(["title", "sd", "ed", "qus", "save", "share","qnrResult","exportMethod"])
            }];
        },
        _getAnsIndex: function(index){
            return this._indexString[index%26]+"";
        },
        _indexString: "ABCDEFGHIJKLMNOPQRSTUVWXYZ",
        userDefinedValue: function(widget, data){
            var type = data.type==1?"单选":data.type==2?"多选":data.type==3?"文本":"未定义";
            var ans = data.type==3?"自定义答案":(data&&data.ans&&data.ans.length?(
                array.map(data.ans, function(ans, index){
                    return "<p class='title' style='margin-top:5px;'>"+this._getAnsIndex(index)+"、"+ans.title+"</p>";
                }, this).join(" ")
            ):"未定义")
            widget.set("label", "<div class='hflex title'>[题干] "+(data.title||"未定义")+" ["+type+"]</div>"+
                "<div class='title' style='margin-top:5px;'>[备选答案] </div>"+
                "<div class='title' style='margin-top:5px;'>"+ans+"</div>"
            );
        },
        loadById: function(params){
            var id = params&&params.cqViewParam&&params.cqViewParam.params||"";
            if(!id){
                return {
                    isUse: true
                };
            }
            return this.exec("loadById",{
                _id: id
            }).then(function(result){
                return result&&result.data&&result.data.item||{};
            });
        },
        loadByIdWithResult: function(params){
            return this.exec("loadById", params).then(function(result){
                return result&&result.data&&result.data.item||{};
            });
        },
        onDataReady: function(widget){
            var data = widget.getData();
            widget.hideByFields(["save", "share"]);
            widget.disableByFields();
            if(!data._id){
                widget.enableByFields();
                widget.showByFields(["save"]);
                return;
            }
            widget.showByFields(["share","qnrResult","exportMethod"]);
            var now = date.now().toISOString();
            if(now<data.sd){
                widget.enableByFields();
                widget.showByFields(["save"]);
            }else if(now>=data.sd&&now<=data.ed){
                widget.hideByFields(["save"]);
                widget.disableByFields();
            }else{
                
            }
        },
        validFields: function(data){
            var msg = this.getDataValidMsg(data, ["title", "sd", "ed"]);
            if(msg){
                alert(msg);
                return false;
            }
            if(!data.qus||(data.qus&&!data.qus.length)){
                alert("请填写问卷问题");
                return false;
            }
            var flag = false;
            for(var i=0;i<data.qus.length;i++){
                if(flag){
                    break;
                }
                if(!data.qus[i].type||!data.qus[i].title||(data.qus[i].type!=3&&!data.qus[i].ans.length)){
                    alert("第"+(i+1)+"个问题填写不完整");
                    flag = true;
                    break;
                }
                for(var j=0;j<data.qus[i].ans.length;j++){
                    if(!data.qus[i].ans[j].title){
                        alert("第"+(i+1)+"个问题第"+(j+1)+"个答案不能为空");
                        flag = true;
                        break;
                    }
                }
            }
            if(flag){
                return false;
            }
            return true;
        },
        save: function(data, widget){
            if(!this.validFields(data)){
                return;
            }
            this.exec("save", data).then(function(result){
                if(result&&result.data&&result.data.ok==1){
                    alert("保存成功");
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"保存失败");
                }
            });
        },
        onListClick: function(data, widget){
            window.moveToView("qnrEdit", data._id);
        },
        share: function(data, widget){
            require([
                "cq/util/share/share",
                "bob/shop/shop"
            ], function(share, shop){
                var options = [{
                    "weixin": {
                        title: data.title,
                        thumb: "",
                        url:shop.getCurrentShopLocation()+"#qnr-" + data._id
                    }
                }, {
                    "friendCircle": {
                        title: data.title,
                        thumb: "",
                        url:shop.getCurrentShopLocation()+"#qnr-" + data._id
                    }
                }, {
                    "copy": {
                        url: shop.getCurrentShopLocation()+"#qnr-" + data._id
                    }
                }];
                share.showShare(options);
            });
        },
        qnrResult: function(data, widget){
            window.moveToView("qnrResultListB", data._id);
        },
        getResultListUrl: function(){
            return this.getBaseUrl()+"/aggregateResultByUserId";
        },
        getResultListparam: function(cqRefInfo){
            var params = {
                shopId: this.getShopId()
            };
            if(cqRefInfo&&cqRefInfo.cqViewParam&&cqRefInfo.cqViewParam.params){
                params.qnrId = cqRefInfo.cqViewParam.params;
            }
            return params;
        },
        onResultListClick: function(data, action, widget){
            var qnrId = widget.cqRefInfo.cqViewParam.params;
            window.moveToView("qnrB", qnrId+","+data._id);
        },
        exportMethod: function(data, widget){
            var url = this.getBaseUrl()+"/loadResult";
            var query = {
                shopId: this.getShopId(),
                qnrId: data._id
            };
            require([
                "cq/util/sys/xlsx",
                "cq/util/sys/date"
            ], function(xlsx, date){
                xlsx.loadAllData(url, query).then(function(data){
                    var datas = [["提交人","提交时间","问题","问题类型","答案"]];
                    var answerString = "";
                    for(var i=0;i<data.length;i++){
                        answerString = data[i].quType!=3?array.map(data[i].answerId, function(answer){
                            return answer.answer;
                        }).join("、"):data[i].answer;
                        datas.push([(data[i].userId.nickName||data[i].userId.pName||data[i].userId.userName),
                        date.formatISODateMinutes(data[i].createAt),data[i].quId.title,
                        (data[i].quType==1?"单选":data[i].quType==2?"多选":data[i].quType==3?"文本":""),answerString]);
                    }
                    xlsx.exportMatrix(datas,Date.now().toString());
                });
            });
        }
    });
    var o = new O();
    o.Bo = O;
    return o;
});