﻿//  创建人：周超
//  创建时间：2017-3-8
//  创建内容：原有包邮机制如何在新系统下工作
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    'bob/BoBase',
    "./_Mixin",
    "dojo/_base/array"
], function (declare,lang,BoBase,_Mixin, array) {
    var O = declare("", [BoBase.B, _Mixin], {
        fields:{
            saveButton:{
                type: "button",
                action: "saveAction"
            },
            deleteById: {
                type: "button",
                action: "deleteById"
            },
            freePostTxt: {
                type: "options",
                options: {
                    "true": "免邮"
                }
            }
        },
        // 获取列表url地址
        getListUrl : function(){
            return this.getBaseUrl() + '/load';
        },
        // 参数
        getListParam : function(cqRefInfo){
            var param = {
                state: 1,
                isUse: true
            };
            param.shopId = this.getShopId();
            if(cqRefInfo&&cqRefInfo.state&&cqRefInfo.state.state){
                param.state = cqRefInfo.state.state;
            }
            if(cqRefInfo&&cqRefInfo.search){
                param.search = cqRefInfo.search;
            }
            return param;
        },
        getListItem: function(item){
            item.freePostTxt = item.freePost;
            if(item.allMat){
                item.mnames = "订单";
            }else if(item.mids&&item.mids.length){
                item.mnames = "购买商品";
                item.mnames += array.map(item.mids, function(mid){
                    return " ["+mid.mName+"] ";
                }).join("、");
            }
            if(item.give_mid){
                item.give_mName = "赠送 "+item.give_mid.mName;
            }
            return item;
        },
        // 列表点击事件
        onListClick : function(item){
            window.moveToView("rewardEdit",item._id);
        },
        // 详情页面布局
        getEdtLayout: function(){
            return [{
                type : "form",
                fields : this.getFormItems([
                //"type", 
                "title", "sd", "ed", "amount", "freePost", "give_mid", "allMat", "mids",
                "blackRegions","whiteRegions","deleteById",
                //"isUse",
                "saveButton"], true)
            }];
        },
        fieldChangeMethod: function(widget, field, state){
            if(field=="allMat"){
                if(!state){
                    widget.showByFields(["mids"]);
                }else{
                    widget.hideByFields(["mids"]);
                }
            }
        },
        onDataReady: function(widget){
            widget.hideByFields(["mids", "deleteById"]);
            var data = widget.getData();
            // 如果有选择的商品 则设置 ref的value
            widget.getEditorByField("mids").setRight = function(){
                var t = this.getValue();
                this.set("rightText", "已选"+(t?t.length:"0")+"种");
            }
            if(!data._id){
                return;
            }
            if(data.title){
                widget.showByFields(["deleteById"]);
            }
            // 单独有设置右标签的方法
            widget.getEditorByField("mids").setRight();
            if(!data.allMat){
                widget.showByFields(["mids"]);
            }
        },
        saveAction: function(data){
            var msg = this.getDataValidMsg(data, ["title", "sd", "ed", "amount"]);
            if(msg){
                alert(msg);
                return ;
            }
            if(!data.freePost&&!data.give_mid){
                alert("请勾选免邮或者选择赠送商品");
                return;
            }
            if(!data.allMat&&(!data.mids||(data.mids&&data.mids.length==0))){
                alert("请选择可使用商品");
                return;
            }
            if(data.mids&&data.mids.length){
                var mids = [];
                array.forEach(data.mids, function(m){
                    mids.push({
                        mId: m._id,
                        mName: m.mName
                    });
                });
                data.mids = mids;
            }
            // 重新处理mids
            // 如果不是全部商品 则mids不允许为空
            // 如果免邮为false 则不允许保存
            data.type = 1;
            this.exec("save", data).then(function (result) {
				if (result.data && result.data.ok === 1) {
					history.back();
				} else {
					alert(result.data.msg||"保存失败");
				}
			});
        },
        deleteById: function(data, widget){
            if(confirm("确认删除?")){
                window.busy();
                this.exec("deleteById", {
                    _id: data._id
                }).then(lang.hitch(this, function(result){
                    window.free();
                    if(result&&result.data&&result.data.ok==1){
                        alert("删除成功");
                        history.back();
                    }else{
                        alert(result&&result.data&&result.data.msg||"删除失败");
                    }
                }));
            }
        },
        loadById:function(params){
            if (!params.cqViewParam.params) {
                return {isUse: true,allMat: true, type: 1,freePost: true};
            }
            return this.exec("loadById",{
                _id:params.cqViewParam.params
            }).then(lang.hitch(this,function(result){
                var data = result&&result.data&&result.data.item||{};
                
                // 满减满送页面，当参与商品点击进入，不做任何操作时，点完成或者返回，mid发生变化的bug
                // 将mids的_id值设置为mId的值
                // 张松  20181120
                data&&data.mids&&data.mids.length&&data.mids.forEach(function(item){
                    item._id = item.mId;
                });
                
                return data;
            }));
        },
        loadByGiveMid: function(mId){
            return this.exec("loadByGiveMid",{
                mId: mId
            });
        }
    });
    var o = new O();
    o.Bo = O;
    return o;
});
