﻿define([
    "dojo/_base/declare"
],function(declare){
    return declare("",null,{
        modalName : "mk/vote/vote",
        fields : {
            logo: {
                type: 'image',
                label: '活动图片',
                notNull: true
            },
            images: {
                type: 'images',
                label: '照片',
                className: 'large-width',
                sizeType: 'cut',
                size: {
                    width: 640,
                    height: 640
                },
                notNull: true
            },
            title : {
                type : "text",
                label : "活动主题",
                notNull: true,
                placeHolder: "请输入活动主题"
            },
            startTime : {
                type:"dateTime",
                label:"开始时间",
                notNull: true
            },
            endTime : {
                type:"dateTime",
                label:"结束时间",
                notNull: true
            },
            limitType:{
                type: "options",
                label: "投票限制",
                options : {
                    1:"限制每人投票总数",
                    2:"限制每人每天投票数"
                },
                selected:1,
                notNull:true
            },
            numPerDay:{
                type:"number",
                label:"每人每日票数",
                fixedTo:0,
                placeHolder: "请输入每人每日票数"
            },
            numPerUser:{
                type:"number",
                label:"每人总票数",
                fixedTo:0,
                placeHolder: "请输入每人总票数"
            },
            isUse:{
                type:"checkbox",
                label:"是否停用"
            },
            remark:{
                type:"textarea",
                label:"活动介绍",
                notNull:true
            },
            resultNum:{
                type:"number",
                label:"报名人数",
                fixedTo:0
            },
            voteNum:{
                type:"number",
                label:"累计投票数"
            },
            visitNum:{
                type:"number",
                label:"访问量"
            }
        },
        signUp:function(params){
            // summary:
            //         报名
            // view:
            //         voteSignUp
            // description:
            //         无
            return this.exec("signUp",params);
        }
	});
});
