﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    'bob/BoBase',
    "./_Mixin",
    "dojo/_base/array",
    "cq/util/sys/date"
], function (declare,lang,BoBase,_Mixin, array,date) {
    var O = declare("", [BoBase.B, _Mixin], {
        fields:{
            saveButton:{
                type: "button",
                action: "save"
            },
            stopButton:{
                type: "button",
                action: "stopVote"
            },
            resultUser:{
                type: "button",
                action: "resultUser"
            },
            voteUser:{
                type: "button",
                action: "voteUser"
            },
            getVoteUrl:{
                type: "button",
                action: "getVoteUrl"
            },
            addUser: {
                type: "button",
                action: "addUser"
            }
        },
        voteUser:function(data,widget){
            // summary:
            //         商家端点击查看投票人
            // view:
            //         voteEdl
            // description:
            //         无
            window.moveToView("voteUserList",data._id);
        },
        resultUser:function(data,widget){
            // summary:
            //         商家端跳转查看报名人
            // view:
            //         voteEdl
            // description:
            //         无
            window.moveToView("resultUserList",data._id);
        },
        stopVote:function(data,widget){
            // summary:
            //         商家端停用搞活动
            // view:
            //         voteEdl
            // description:
            //         无
            window.busy();
            return this.exec("stopVote",{_id:data._id}).then(lang.hitch(this,function(result){
                window.free();
                if(result&&result.data&&result.data.ok){
                    alert("已成功停用");
                    widget.cqRefresh();
                }else{
                    alert(result.data.msg||"停用失败")
                }
            }));
        },
        getVoteUrl:function(data,widget){
            // summary:
            //         商家端复制链接
            // view:
            //         voteEdl
            // description:
            //         无
            var shopId = this.getShopId();
            require([
                "cq/util/share/share",
                "bob/shop/shop"
            ], function(share, shop){
                share.copyUrl({
                    url:shop.getCurrentShopLocation()+"#voteAct-" + data._id
                });
            });
        },
        // 获取列表url地址
        getListUrl : function(){
            return this.getBaseUrl() + '/load';
        },
        // 参数
        getListParam : function(cqRefInfo){
            var param = {};
            param.shopId = this.getShopId();
            if(cqRefInfo.search){
                param.search = cqRefInfo.search;
            }
            return param;
        },
        // 列表点击事件
        onListClick : function(item){
            window.moveToView("voteEdt",item._id);
        },
        save:function(data,widget){
            data.logo = data.images[0]||"";
            //合法性检查
            var msg = this.getDataValidMsg(data, ["logo","title","startTime","endTime","limitType","remark"]);
            if(msg){
                alert(msg);
                return ;
            }
            if(data.limitType==1&&Number(data.numPerUser)<=0){
                alert("每人总票数填写不合法");
                return;
            }
            if(data.limitType==2&&Number(data.numPerDay)<=0){
                alert("每人每日票数填写不合法");
            }
            window.busy();
            this.exec("save",data).then(lang.hitch(this,function(result){
                window.free();
                if(result&&result.data.ok){
                    alert("保存成功");
                    history.back();
                }else{
                    alert(result.data.msg||"保存失败");
                }
            }));
        },
        // 详情页面布局
        getEdtLayout: function(){
            return [{
                type : "form",
                fields : this.getFormItems([
                "images","title","startTime","endTime","limitType",
                "numPerDay","numPerUser","remark",
                "resultNum","voteNum","visitNum","stopButton","voteUser","resultUser","getVoteUrl","saveButton","stoped","ended","started","addUser"], true)
            }];
        },
        fieldChange: function(widget, field, state){
            if(field == "limitType"){
                if(state == "1"){
                    widget.showByFields(["numPerUser"]);
                    widget.hideByFields(["numPerDay"]);
                }else{
                    widget.showByFields(["numPerDay"]);
                    widget.hideByFields(["numPerUser"]);
                }
            }
        },
        onDataReady: function(widget){
            var data = widget.getData();
            // 如果没有数据 则所有字段可以编辑 且显示保存按钮
            widget.disableByFields();
            widget.disableByFields(["images"]);
            widget.hideByFields(["saveButton","stopButton","voteUser","resultUser","getVoteUrl","stoped","ended","started","addUser","resultNum","voteNum","visitNum"]);
            if(data.limitType==1){
                widget.showByFields(["numPerUser"]);
                widget.hideByFields(["numPerDay"]);
            }else{
                widget.showByFields(["numPerDay"]);
                widget.hideByFields(["numPerUser"]);
            }
            if(!data._id){
                widget.enableByFields();
                widget.enableByFields(["images"]);
                widget.showByFields(["saveButton"]);
                return;
            }
            widget.enableByFields();
            widget.enableByFields(["images"]);
            widget.showByFields(["saveButton","stopButton","voteUser","resultUser","getVoteUrl","stoped","ended","started","addUser"]);
            if(!data.isUse){
                widget.hideByFields(["saveButton","stopButton","ended","started","addUser"]);
            }else if(data.startTime<=date.nowISOString()&&data.endTime>=date.nowISOString()){
                widget.hideByFields(["saveButton","stopButton","ended","stoped"]);
            }else if(data.endTime<date.nowISOString()){
                widget.hideByFields(["saveButton","stopButton","started","stoped","addUser"]);
            }else{
                widget.hideByFields(["stoped","ended","started"]);
            }
            // 已停用
            if(!data.isUse||data.startTime<date.nowISOString()){
                widget.disableByFields();
                widget.disableByFields(["images"]);
                widget.hideByFields(["saveButton","stopButton"]);
                widget.showByFields(["resultNum","voteNum","visitNum"]);
                //widget.disableByFields(["resultNum","voteNum","visitNum"]);
            }
        },
        addUser: function(data, widget){
            window.moveToView("voteAddUser", ","+data._id);
        },
        loadById:function(params){
            if (!(params&&params.cqViewParam&&params.cqViewParam.params)) {
                return {limitType:1,isUse:true};
            }
            window.busy();
            return this.exec("loadById",{
                _id:params.cqViewParam.params
            }).then(lang.hitch(this,function(result){
                window.free();
                return result&&result.data&&result.data.item||{};
            }));
        }
    });
    var o = new O();
    o.Bo = O;
    return o;
});