﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "../../BoBase",
    "./_Mixin",
    "cq/util/sys/date"
],function(declare, lang, Deferred, BoBase, _Mixin,date){
    var O = declare("",[BoBase.C, _Mixin],{
        fields:{
            goSignUp:{
                type: "button",
                action: "goSignUp"
            },
            voteRemark:{
                type:"text",
                label:"活动介绍"
            },
            resultNum:{
                type:"number",
                label:"参与人数",
                fixedTo: 0
            },
            voteNum:{
                type:"number",
                label:"累计投票",
                fixedTo: 0
            },
            visitNum:{
                type:"number",
                label:"访问量",
                fixedTo: 0
            }
        },
        goSignUp:function(data,widget){
            // summary:
            //         消费者端点击跳转到报名页面
            // view:
            //         voteAct、voteDtl
            // description:
            //         无
            window.moveToView("voteSignUp",data._id);
        },
        loadByIdForResult:function(id){
            // summary:
            //         为result 表提供通过voteId加载活动详情
            // view:
            //         voteAct、voteDtl
            // description:
            //         bob/mk/resultUser/loadVoteById调用
            window.busy();
            return this.exec("loadById",{
                _id:id
            }).then(lang.hitch(this,function(result){
                window.free();
                if(result&&result.data&&result.data.item){
                    result.data.item.voteOver = result.data.item.endTime;
                }
                return result&&result.data&&result.data.item||{};
            }));
        },
        loadById:function(params){
            if (!(params&&params.cqViewParam&&params.cqViewParam.params)) {
                return ;
            }
            var loadMethod = "loadById"
            if(params.refresh===undefined||params.refresh === true){
                loadMethod = "loadByIdC"
            }else if(params.refresh===null){
                params.refresh = true;
                loadMethod = "loadById"
            }
            window.busy();
            return this.exec(loadMethod,{
                _id:params.cqViewParam.params
            }).then(lang.hitch(this,function(result){
                window.free();
                var item = result&&result.data&&result.data.item||{};
                if(item._id){
                    // 活动未开始
                    if(date.nowISOString()<item.startTime){
                        item.voteOverMsg = "距离投票开始还有：";
                        item.voteTime = item.startTime;
                    }else if(date.nowISOString()>=item.startTime&&date.nowISOString()<=item.endTime){
                        item.voteOverMsg = "距离投票结束还有：";
                        item.voteTime = item.endTime;
                    }else{
                        item.voteOverMsg = "投票已结束";
                    }
                }
                var shopId = this.getShopId();
                require([
                    "dojo/topic",
                    "cq/util/share/share"
                ],function(topic,share){
                    share.getShopLocation(shopId).then(function(baseUrl){
                        topic.publish("/cq/util/sys/share/infoChanged",{
                            title: item.title,
                            thumb: item.logo || "",
                            url:baseUrl+"#voteAct-" + params.cqViewParam.params
                        });
                    });
                });
                return item;
            }));
        },
        onDataReady:function(widget){
        },
        share: function (data, widget) {
            //         点击后分享给其他人
            // view:
            require(["cq/util/share/share"], lang.hitch(this, function(share){
                share.getShopLocation(this.getShopId()).then(function(baseUrl){
                    var options = [{
                        "weixin": {
                            title: data.title,
                            thumb: data.logo || "",
                            url:baseUrl+"#voteAct-" +  widget.cqRefInfo.cqViewParam.params
                        }
                    }, {
                        "friendCircle": {
                            title: data.title,
                            thumb: data.logo || "",
                            url:baseUrl+"#voteAct-" +  widget.cqRefInfo.cqViewParam.params
                        }
                    }, {
                        "copy": {
                            url: baseUrl+"#voteAct-" +  widget.cqRefInfo.cqViewParam.params
                        }
                    }];
                    share.showShare(options);
                });
            }));
		}
    });
    var o = new O();
    o.Bo = O;
	return o;
});
