﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
],function(declare,lang){
    return declare("",null,{
        modalName : "mk/vote/result",
        fields : {
            logo: {
                type: 'image',
                label: '参赛图片',
                notNull: true
            },
            images: {
                type: 'images',
                label: '照片',
                className: 'large-width',
                sizeType: 'cut',
                size: {
                    width: 640,
                    height: 640
                },
                notNull: true
            },
            "userId.nickName": {
                label: "报名人",
                type: "text"
            },
            userId:{
                label: '报名人',
                type: 'ref',
                dataProvider: 'bob/user/customer',
                targetMethod: 'getUserListUrl',
                className: 'middle-width',
                searchField: 'search',
                labelFields: 'nickName,pName,userName',
                notNull: true
            },
            nickName:{
                type:"text",
                label:"姓名",
                notNull:true,
                placeHolder: "请填写姓名"
            },
            mobile:{
                type:"tel",
                label:"联系电话",
                notNull:true,
                placeHolder: "请填写联系电话"
            },
            remark:{
                type:"textarea",
                label:"参赛宣言",
                notNull:true,
                placeHolder: "请填写参赛宣言"
            },
            num:{
                type:"number",
                label:"得票数"
            },
            createAt:{
                type:"dateTime",
                label:"报名时间"
            }
        },
        // 参数
        getListParam : function(cqRefInfo){
            var param = {};
            param.shopId = this.getShopId();
            param.voteId = cqRefInfo&&cqRefInfo.cqViewParam&&cqRefInfo.cqViewParam.params||"";
            return param;
        },
        loadById:function(params){
            if (!(params&&params.cqViewParam&&params.cqViewParam.params)) {
                return {};
            }
            window.busy();
            return this.exec("loadById",{
                _id:params.cqViewParam.params
            }).then(lang.hitch(this,function(result){
                window.free();
                return result&&result.data&&result.data.item||{};
            }));
        },
	});
});
