﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    'bob/BoBase',
    "./_Mixin",
    "bob/mk/vote/b"
], function (declare,lang,BoBase,_Mixin, vote) {
    var O = declare("", [BoBase.B, _Mixin], {
        fields:{
            exportB:{
                type: "button",
                action: "exportB"
            },
            save: {
                type: "button",
                action: "save"
            },
            deleteById: {
                type: "button",
                action: "deleteById"
            }
        },
        deleteById: function(data, widget){
            window.busy();
            return this.exec("deleteById",{
                _id: data._id
            }).then(function(result){
                window.free();
                if(result&&result.data&&result.data.ok==1){
                    alert("删除成功");
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"删除失败");
                }
            });
        },
        getEdtLayout: function(){
            return [{
                type : "form",
                fields : this.getFormItems([
                "images","userId","nickName","mobile","remark","save","deleteById"], true)
            }];
        },
        fieldChange: function(widget, field, val){
            if(field=="userId"){
                if(val){
                    var data = widget.getData();
                    data.nickName = val.nickName||val.pName||val.userName;
                    widget.setData(data);
                }
            }
        },
        loadById: function(params){
            var viewId = params.cqViewParam.params||"";
            var voteId = viewId.split(",")[1];
            var _id = viewId.split(",")[0];
            if(!_id){
                return {
                    voteId: voteId
                };
            }else{
                return this.exec("loadById", {
                    _id: _id
                }).then(function(result){
                    return result&&result.data&&result.data.item||{};
                });
            }
        },
        onDataReady: function(widget){
            var data = widget.getData();
            widget.hideByFields(["save","deleteById"]);
            if(!data._id){
                widget.showByFields(["save"]);
                return;
            }
            widget.showByFields(["save","deleteById"]);
        },
        save: function(data, widget){
            data.logo = data.images[0]||"";
            var msg = this.getDataValidMsg(data, ["logo", "userId", "nickName", "mobile", "remark"]);
            if(msg){
                alert(msg);
                return;
            }
            window.busy();
            vote.signUp(data).then(function(result){
                window.free();
                if(result&&result.data&&result.data.ok==1){
                    alert("添加成功");
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"添加失败");
                }
            });
        },
        // 获取列表url地址
        getListUrl : function(){
            return this.getBaseUrl() + '/load';
        },
        onListClick: function(data, action, widget){
            if(action==="contactWith"){
                require(["bob/im/msgP/b"], function(msg){
                    msg.msgTo(data.userId._id,data.userId.fromShopId);
                });
            }else{
                window.moveToView("voteAddUser", data._id+","+data.voteId._id);   
            }
        },
        exportB:function(data,t,widget){
            // summary:
            //         报名人列表导出
            // view:
            //         resulUserList
            // description:
            //         
            var url = this.getListUrl();
            var query = this.getListParam(widget.cqRefInfo);
            require([
				"cq/util/sys/xlsx",
				"cq/util/sys/date",
				"cq/util/sys/userAgent"
			],lang.hitch(this,function(xlsx,date,userAgent){
                if(userAgent.isBrowser()){
                    window.busy();
                    xlsx.exportData(url, query, this.getFormItems(["userId.nickName","nickName","mobile","remark","num","createAt"], true),"报名人清单"+(new Date()).toISOString());
                }
            }));
        },
    });
    var o = new O();
    o.Bo = O;
    return o;
});