﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "bob/BoBase",
    "./_Mixin",
    "bob/mk/vote/c",
    "bob/user/consumer",
    "cq/util/sys/date"
],function(declare, lang, Deferred, BoBase, _Mixin,vote,consumer,date){
    var O = declare("",[BoBase.C, _Mixin],{
        fields:{
            signUpButton:{
                type: "button",
                action: "signUp"
            },
            goSignUp:{
                type: "button",
                action: "goSignUp"
            },
            voteOne:{
                type: "button",
                action: "voteOne"
            },
            checkMore:{
                type: "button",
                action: "checkMore"
            }
        },
        getEdtLayout: function(){
            return [{
                type : "form",
                fields : this.getFormItems([
                "nickName","mobile","remark","images","signUpButton","goSignUp"], true)
            }];
        },
        signUp:function(data,widget){
            data.logo = data.images[0]||"";
            var msg = this.getDataValidMsg(data, ["nickName","mobile","remark","logo"]);
            if(msg){
                alert(msg);
                return ;
            }
            data.voteId = widget.cqRefInfo.cqViewParam.params;
            window.busy();
            vote.signUp(data).then(lang.hitch(this,function(result){
                window.free();
                if(result&&result.data.ok){
                    alert("报名成功");
                    history.back();
                }else if(result.data.msg == "不能重复报名！"){
                    if(confirm("您已经报名，点击确认直接跳转到对应报名详情")){
                        window.moveToView("voteDtl",result.data.item[0]._id);
                    }else{
                        return ;
                    }
                }else{
                    alert(result.data.msg||"报名失败");
                }
            }));
        },
        goSignUp:function(data,widget){
            // summary:
            //         跳转到报名页面
            // view:
            //         voteDtl
            // description:
            window.moveToView("voteSignUp",data.voteId);
        },
        voteOne:function(data,widget){
            //偷一票
            var params = {};
            params._id = data._id;
            window.busy();
            this._vote(params).then(function(result){
                window.free();
                if(result&&result.data&&result.data.ok){
                    alert("投票成功");
                    widget.cqRefresh();
                }else{
                    alert(result.data.msg||"投票失败")
                }
            });
        },
        checkMore:function(data,widget){
            window.moveToView("voteAct",data.voteId);
        },
        getListUrl:function(){
            //加载我所有参加的活动
            return this.getBaseUrl()+"/loadMine";
        },
        getListUrlForAct:function(){
            // summary:
            //         活动详情，根绝活动详情的id加载所有的报名人的load方法
            // view:
            //         voteAct
            // description:
            return this.getBaseUrl()+"/load";
        },
        getListParamByVoteId:function(cqRefInfo){
            // summary:
            //         活动详情，根绝活动详情的id加载所有的报名人
            // view:
            //         voteAct
            // description:
            var params = {};
            params.shopId = this.getShopId();
            params.voteId = cqRefInfo.cqViewParam.params;
            params.orderBy = "-createAt";
            if(cqRefInfo.search){
                params.search = cqRefInfo.search;
            }
            if(cqRefInfo.orderBy){
                params.orderBy = cqRefInfo.orderBy.orderBy;
            }
            return params;
        },
        _vote: function(params){
            var def = new Deferred();
            var _this = this;
            require([
                "cq/util/sys/userAgent",
                "cq/util/edit/dialog",
                "bob/shop/shopC"
            ], function(userAgent, dialog, shop){
                if(userAgent.isWeixin()){
                    consumer.getCurrentUser().then(function(user){
                        if(!user._id||!user.subscribed){
                            shop.loadMe().then(function(shopInfo){
                                if(shopInfo&&shopInfo.wxLogo){
                                    // 弹出二维码 提示需要先关注公众号
                                    dialog.show("<img style='width:160px;height:160px;' src='"+shopInfo.wxLogo+"'/>", true);
                                    def.resolve({
                                        data: {
                                            ok: 0,
                                            message: "请长按识别图片，关注公众号为TA投票",
                                            msg: "请长按识别图片，关注公众号为TA投票"
                                        }
                                    });
                                }else{
                                    _this.exec("vote", params).then(function(result){
                                        def.resolve(result);
                                    });
                                }
                            });
                        }else{
                            _this.exec("vote", params).then(function(result){
                                def.resolve(result);
                            });
                        }
                    })
                }else{
                    _this.exec("vote", params).then(function(result){
                        def.resolve(result);
                    });
                }
            });
            return def;
        },
        getListParam:function(){
            var params = {};
            params.shopId = this.getShopId();
            return params;
        },
        onClickList:function(params){
            // summary:
            //         我的报名列表跳转
            // view:
            //         mySign
            // description:
            window.moveToView("voteDtl",params._id);
        },
        onListClick: function (data,action,widget) {
            // summary:
            //         活动详情所有报名人列表的点击
            // view:
            //         voteDtl
            // description:
            if(action == "vote"){
                if(!consumer.hasLogin()){
                    window.moveToView("login")
                }
                //如果已经停用未开始已结束的点击投票弹出提示，不做出响应
                if(date.nowISOString()>data.voteId.endTime){
                    alert("投票已结束");
                }else if(date.nowISOString()<data.voteId.startTime){
                    alert("投票未开始");
                }else if(!data.voteId.isUse){
                    alert("投票已停用");
                }else{
                    var params = {
                        _id:data._id
                    }
                    this._vote(params).then(function(result){
                        if(result&&result.data&&result.data.ok){
                            alert("成功投票");
                            //列表刷新
                            //widget.cqRefresh();
                            data.num+=1;
                            widget.refreshItemByData(data);
                        }else{
                            alert(result.data.msg||"投票失败");
                        }
                    });
                }
            }else{
                window.moveToView('voteDtl', data._id);
            }
		},
        loadVoteById:function(widget){
            // summary:
            //         投票详情加载自己的和改报名所属的活动详情数据
            // view:
            //         voteDtl
            // description:
            //         
            if(!(widget&&widget.cqViewParam&&widget.cqViewParam.params)){
                return ;
            }
            var params = {
                _id:widget.cqViewParam.params
            };
            var def = new Deferred();
            window.busy();
            var shopId = this.getShopId();
            this.exec("loadById",params||{}).then(function(data){
                window.free();
                var item = data&&data.data&&data.data.item||{};
                vote.loadByIdForResult(item.voteId||"").then(lang.hitch(this,function(result){
                    if(result){
                        item.startTime = result.startTime;
                        item.endTime = result.endTime;
                        item.voteRemark = result.remark;
                        item.resultNum = result.resultNum;
                        item.voteNum = result.voteNum;
                        item.visitNum = result.visitNum;
                        item.isUse = result.isUse;
                        // 活动未开始
                        if(date.nowISOString()<item.startTime){
                            item.voteOverMsg = "距离投票开始还有：";
                            item.voteTime = item.startTime;
                        }else if(date.nowISOString()>=item.startTime&&date.nowISOString()<=item.endTime){
                            item.voteOverMsg = "距离投票结束还有：";
                            item.voteTime = item.endTime;
                        }else{
                            item.voteOverMsg = "投票已结束";
                        }
                        if(date.nowISOString()>item.endTime){
                            item.voteOverMsg = "活动已经结束";
                        }else{
                            item.voteOverMsg = "距离活动结束 : ";
                        }
                    }
                    require([
                        "dojo/topic",
                        "cq/util/share/share"
                    ],function(topic,share){
                        share.getShopLocation(shopId).then(function(baseUrl){
                            topic.publish("/cq/util/sys/share/infoChanged",{
                                title: item.title,
                                thumb: item.logo || "",
                                url:baseUrl+"#voteDtl-" + widget.cqViewParam.params
                            });
                        });
                    });
                    def.resolve(item);
                }));
            });
            return def;
        },
        onDataReady:function(widget){
        },
        share: function (data, widget) {
            //         点击后分享给其他人
            // view:
            require(["cq/util/share/share"], lang.hitch(this, function(share){
                share.getShopLocation(this.getShopId()).then(function(baseUrl){
                    var options = [{
                        "weixin": {
                            title: data.nickName,
                            thumb: data.logo || "",
                            url:baseUrl+"#voteDtl-" +  widget.cqRefInfo.cqViewParam.params
                        }
                    }, {
                        "friendCircle": {
                            title: data.nickName,
                            thumb: data.logo || "",
                            url:baseUrl+"#voteDtl-" +  widget.cqRefInfo.cqViewParam.params
                        }
                    }, {
                        "copy": {
                            url: baseUrl+"#voteDtl-" +  widget.cqRefInfo.cqViewParam.params
                        }
                    }];
                    share.showShare(options);
                });
            }));
		}
    });
    var o = new O();
    o.Bo = O;
	return o;
});
