//会员系统公共基类
// 1、提供会员系统的基本属性
define(["dojo/_base/declare"],function(declare){
    return declare("",null,{
        modalName: "shop/shop",
        fields: {
            // 支持的支付方式
            "payWeiXin":{
                type:"checkbox",
                label:"微信支付",
                className:"large-high",
                canEdit:"true"
            },
            "payAli":{
                type:"checkbox",
                label:"支付宝支付",
                className:"large-high",
                canEdit:"true"
            },
            "payDeposit":{
                type:"checkbox",
                label:"余额支付",
                className:"large-high",
                canEdit:"true"
            },
            "shopInfoButton":{
                type:"button",
                label:"完成",
                action:"save",
                className:"fullButton"
            },
            "collectButton":{
                type:"button",
                label:"收藏",
                action:"collectAction"
            },
            "cancelCollectButton":{
                type:"button",
                label:"取消收藏",
                action:"cancelCollectAction"
            },
            "orderCheckerId" : {
                type:"ref",
                field:"orderCheckerId",
                label:"新订单消息通知",
                searchField:"pName",
                labelFields:"pName",
                dataProvider:"bob/user/shopAdmin",
                targetMethod:"getStaffUrl",
                canEdit:true,
				className:"middle-width"
            },
            "svcId" : {
                type:"ref",
                field:"svcId",
                label:"新客服消息通知",
                searchField:"pName",
                //pageSize:5,
                labelFields:"pName",
                dataProvider:"bob/user/shopAdmin",
                targetMethod:"getStaffUrl",
                canEdit:true,
				className:"middle-width"
            },
            "orderTimeout":{
                type:"text",
                label:"自动关闭未付款订单",
                className:"large-high",
                placeHolder:"未填写"
            },
            "tranAddr":{
                type:"text",
                label:"发货地点",
                className:"large-width",
                placeHolder:"未填写"
            },
            "tranRegion" : {
                type : "link",
                label : "销售区域",
                rightText : "",
                canEdit : false,
                href : "section",
                notNull: true
            },
            "tranRegions":{
                type:"objects",
                label:"销售区域",
                labelField:"remark",
                canEdit:true,
                canDelete:true,
                canAdd:true,
                canDnd:true,
                fields:{
                    layout:[{
                        field:"provinceId,cityId,countyId,remark",
                        type:"district",
						enableAll:true,
                        placeHolder:"请选择地址",
                        label:"区划"
                    }]
                },
                notNull: true
            },
            "freightTemplated":{
                type:"checkbox",
                label:"启用运费模板",
                className:"large-high",
                canEdit:"true"
            },
            // 微信相关配置
            "wxLogo":{
                type:"image",
                label:"公众号二维码",
                className:"large-high"
            },
            "wxAppId":{
                type:"text",
                label:"微信APPID",
                className:"middle-width",
                placeHolder:"未填写"
            },
            "wxAppSec":{
                type:"text",
                label:"微信APPSEC",
                className:"middle-width",
                placeHolder:"未填写"
            },
            "wxUrl":{
                type:"text",
                label:"微信配置Url",
                className:"middle-width",
                placeHolder:"未配置"
            },
            "wxCqToken":{
                type:"text",
                label:"微信Token",
                className:"middle-width",
                placeHolder:"未填写"
            },
            "wxHash":{
                type:"text",
                label:"微信wxAesk",
                className:"middle-width",
                placeHolder:"未填写"
            },
            "wxMsgTemplate":{
                type:"text",
                label:"订单状态模板",
                className:"middle-width",
                placeHolder:"未填写"
            },
            "wxVerification":{
                type:"checkbox",
                label:"微信认证",
                className:"middle-width"
            },
            "wxAutoLogin":{
                type:"checkbox",
                label:"快速登录",
                className:"middle-width"
            },
            "isSectionData" : {
                type : "link",
                label : "微信栏目",
                rightText : "未设置",
                canEdit : false,
                href : "#section"
            },
            "isAutoReplyData":{
                type : "link",
                label : "自动回复",
                rightText : "未设置",
                canEdit : false,
                href : "#autoReply"
            },
            "shopWeiXinSave":{
                type:"button",
                label:"完成",
                action:"save",
                className:"fullButton"
            },
            "shopWeiXinUrl":{
                type:"button",
                label:"",
                action:"cutUrlAction",
                className:"fullButton"
            },
            "shopWeiXinToken":{
                type:"button",
                label:"",
                action:"cutTokenAction",
                className:"fullButton"
            },
            "brief": {
                type:"textarea",
                label:"店铺简介",
                className:"large-width",
                placeHolder:"请填写简介",
                notNull: true
            },
            "svcPhone":{
                type:"text",
                label:"客服电话",
                className:"middle-width",
                placeHolder:"请填写客服电话"
            },
            "svcWx":{
                type:"text",
                label:"客服微信",
                className:"middle-width",
                placeHolder:"请填写客服微信"
            },
            "svcQQ":{
                type:"text",
                label:"客服QQ",
                className:"middle-width",
                placeHolder:"请填写客服QQ"
            },
            logo:{
                type:"image",
                clickImg:true,
                label:"公司LOGO",
                className:"large-high",
                sizeType: 'cut',
				size: {
					width: 256,
					height: 256
				},
                notNull: true
            },
            companyName:{
                type:"text",
                label:"经营主体",
                className:"large-width",
                placeHolder:"请输入经营主体名称",
                notNull: true
            },
            shopName:{
                type:"text",
                label:"店铺名称",
                className:"middle-width"
            },
            "lon,lat":{
                type:"location",
                label:"地理位置",
                //用于联动区划，传入省市区ID字段名，不联动则传入空字符串
                distFields:"provinceId,cityId,countId",
                //区域划分地址字段名(显示字段名)
                distFieldsStr:"town",
                //详细地址
                detailAddrField:"address",
                className: "lon-lat-high",
                notNull:true
            },
            legalPerson:{
                type:"text",
                label:"法人姓名",
                className:"middle-width",
                placeHolder:"请输入法人姓名",
                notNull: true
            },
            legalPersonCode: {
                type: "text",
                label: "法人身份证号",
                clickImg:true,
                placeHolder:"请与身份证保持一致",
                className: "middle-width",
                notNull: true
            },
            legalImg1:{
                type:"image",
                label:"法人身份证正面",
                clickImg:true,
                className:"large-high",
                notNull: true
            },
            legalImg2:{
                type:"image",
                clickImg:true,
                label:"法人身份证反面",
                className:"large-high",
                notNull: true
            },
            businessLicense:{
                type:"image",
                clickImg:true,
                label:"营业执照",
                className:"large-high",
                notNull: true
            },
            contactName:{
                type:"text",
                label:"联系人",
                className:"middle-width",
                placeHolder:"请输入联系名称",
                notNull: true
            },
            contactPhone:{
                type:"text",
                label:"联系电话",
                className:"middle-width",
                placeHolder:"请输入电话号码",
                notNull: true
            },
            contactWx:{
                type:"text",
                label:"店主微信",
                className:"middle-width",
                placeHolder:"请输入微信号码"
            },
            contactQQ:{
                type:"text",
                label:"店主QQ",
                className:"middle-width",
                placeHolder:"请输入店主QQ"
            },
            aliPaySeller:{
                type:"text",
                label:"支付宝账号",
                className:"middle-width",
                placeHolder:"请输入支付宝账号"
            },
            bankName:{
                type:"text",
                label:"开户行",
                className:"middle-width",
                placeHolder:"请输入开户银行"
            },
            bankAccountName:{
                type:"text",
                label:"账户名",
                className:"middle-width",
                placeHolder:"请输入账户名"
            },
            bankAccountCode:{
                type:"text",
                label:"账号",
                className:"middle-width",
                placeHolder:"请输入账号"
            },
            payee:{
                type:"text",
                label:"收款人",
                className:"middle-width",
                placeHolder:"请输入收款人"
            },
            fiName:{
                type:"text",
                label:"财务联系人姓名",
                className:"middle-width",
                placeHolder:"请输入财务联系人姓名"
            },
            fiPhone:{
                type:"text",
                label:"财务联系人电话",
                className:"middle-width",
                placeHolder:"请输入财务联系人电话"
            },
            fiQQ:{
                type:"text",
                label:"财务联系人QQ",
                className:"middle-width",
                placeHolder:"请输入财务联系人QQ"
            },
            rejectedReason: {
                type: "text",
                canEdit:false,
                label: "驳回原因",
                className:"large-width"
            },
            orgCode: {
                type: "text",
                label: "组织机构代码",
                placeHolder:"请输入组织机构代码",
                className:"large-width"
            },
            
            //区划编辑,省、市、县、地址文本
            "provinceId,cityId,countId,town" : {
                type : "district",
                label : "省-市-区县",
                canEdit : true,
                className:"large-width province-high",
                placeHolder:"请选择"
            },
            town: {
                type: "text",
                label: "省-市-区县",
				className:"middle-width"
            },
            address: {
                type: "text",
                label: "详细地址",
				className:"middle-width",
                placeHolder:"未填写"
            },
            operateButton:{
                type:"text",
				label:"操作",
				formatter:function(action,data){
					var v = "<div class='button' onclick='window.moveToView(\"merchantDetail\",\""+data._id+"\");'>详情</div>";
					return v;
				}
            },
            //店铺基本信息保存
            baseSaveButton:{
                type:"button",
                label:"保存",
                action:"save",
                className:"fullButton"
            },
            backVerificationButton:{
                type:"button",
                label:"驳回认证",
                action:"backVerification",
                buttonClass:"margin10"
            },
            noVerificationButton:{
                type:"button",
                label:"取消认证",
                action:"cancelVerification",
                buttonClass:"margin10"
            },
            deleteMerchantButton:{
                type:"button",
                label:"删除商家",
                action:"deleteMerchan",
                buttonClass:"margin10"
            },
            recommendeMerchantButton:{
                type:"button",
                label:"推荐商家",
                action:"recommendeMerchant",
                buttonClass:"margin10"
            },
            noRecommendeButton:{
                type:"button",
                label:"撤销推荐",
                action:"cancelRecommende",
                buttonClass:"margin10"
            },
            verificationButton:{
                type:"button",
                label:"标记认证",
                action:"doVerification",
                buttonClass:"margin10"
            },
            shopType: {
                type: "options",
                label: "服务站类型",
                options : {
                    1:"一般商家",
                    2:"服务站",
                    3:"服务中心",
                    4:"服务商",
                    5:"运营商",
                    6:"平台商",
                    7:"政府",
                    9999:"其它"
                } 
            },
            lon: {
                type: "text",
                label: "地理位置"
            },
            lat: {
                type: "text",
                label: "地理位置"
            },
            isVerified:{
                type:"options",
                label:"是否认证",
                options:{
                    "true":"已认证",
                    "false":"待认证"
                },
            },
            isWhiteList: {
                type: 'checkbox',
                label: '是否启用白名单',
                className: ""
            },
            manageFreightButton : {
                type:"button",
                label:"管理运费模板",
                action:"manageFreight",
                buttonClass:"margin10"                
            },
            pendingAmount: {
                type: "number",
                label: "待结算金额",
                fixedTo: 2
            },
            availableAmount: {
                type: "number",
                label: "可提现金额",
                fixedTo: 2
            }
        }
    });
});