﻿define([
    "dojo/_base/declare",
    "bob/BoBase"
], function (declare, BoBase) {
    var TaskBo = declare("",BoBase.B,{
        fields:{
            "targetUserId.nickName": {
                type: "text",
                label: "客户"
            },
            "targetMid.mName": {
                type: "text",
                label: "商品"
            },
            "fromShopId.shopName": {
                type: "text",
                label: "商家"
            },
            taskType: {
                type: "options",
                options: {
                    1:"促进购买",
                    2:"改善服务",
                    3:"平台招商"
                },
                label: "任务类型"
            },
            taskSource: {
                type: "options",
                options: {
                    1:"关注",
                    2:"看了没买",
                    3:"加购物车未买",
                    4:"签收后回访",
                    5:"预计消费完后提醒复购",
                    6:"周期性产品续费",
                    7:"客户评价的回复",
                    8:"订单审核",
                    9:"订单发货",
                    10:"新的客服请求",
                    11:"会员取消关注",
                    12:"开店跟踪",
                    13:"商家很久未登录",
                    14:"客户要求退款",
                    15:"客户差评",
                    25:"引流产品转化为周期性产品"
                },
                label: "任务来源"
            },
            userId: {},
            taskStatus: {
                type: "options",
                options: {
                    1:"创建",
                    2:"执行",
                    3:"完成"
                },
                label: "任务状态"
            },
            taskResult: {
                type: "text",
                label: "任务结果"
            },
            createAt: {
                type: "dateTime"
            }
        },
        modalName: 'shop/cm/task',
        getListUrl: function(){
            return this.getBaseUrl()+"/load";
        },
        getListParam: function(cqRefInfo){
            var params = {
                shopId: this.getShopId(),
                taskStatus: 1,
                taskSource: 1
            };
            var state = cqRefInfo&&cqRefInfo.state&&cqRefInfo.state._id||"";
            if(state){
                params.taskStatus = state;
            }else{
                delete params.taskStatus;
            }
            var taskSource = cqRefInfo&&cqRefInfo.taskSource&&cqRefInfo.taskSource._id||"";
            if(taskSource){
                params.taskSource = taskSource;
            }else{
                delete params.taskSource;
            }
            return params;
        },
        getToDoListParam: function(cqRefInfo){
            var params = {
                shopId: this.getShopId(),
                taskStatus: 1
            };
            var userId = cqRefInfo&&cqRefInfo.cqViewParam&&cqRefInfo.cqViewParam.params||"";
            if(userId){
                params.targetUserId = userId;
            }
            return params;
        },
        onListClick: function(data, action, widget){
            if(action === "toCustomerView"){
                window.moveToView("customerView", data.targetUserId._id);
            }else if(action === "toFinish"){
                this.toFinish(data, widget);
            }else if(action === "toExec"){
                this.toExec(data, widget);
            }
        },
        toExec: function(data, widget){
            window.busy();
            this.exec("setStart", {_id: data._id}).then(function(result){
                window.free();
                if(result&&result.data&&result.data.ok==1){
                    alert("开始执行");
                    widget.cqRefresh();
                }else{
                    alert(result&&result.data&&result.data.message||"执行失败");
                }
            });
        },
        toFinish: function(data, widget){
            window.busy();
            this.exec("setFinish", {_id: data._id}).then(function(result){
                window.free();
                if(result&&result.data&&result.data.ok==1){
                    alert("完成");
                    widget.cqRefresh();
                }else{
                    alert(result&&result.data&&result.data.message||"设置完成失败");
                }
            });
        },
        onDataReady: function(){}
    });
    var taskBo = new TaskBo();
    taskBo.Bo = TaskBo;
    return taskBo;
});