//  运营商
//  继承自shop
//  边界
//      向平台提交认证信息
//          需要填写的信息：
//			LOGO、联系人contactName、联系电话contactPhone、
//			经营主体名称companyName、法人姓名、法人身份证号、法人身份证正反面、营业执照、组织机构代码、地理位置、所在省市区地址、运营商简介、
//			运营区域
//      查看平台的认证结果
//      管理服务商和服务站的列表
//      进行服务商和服务站的认证
//      服务商和服务站的统计
define([
	"dojo/_base/declare",
	"dojo/_base/lang",
    "cq/util/sys/common",
	"./shop",
    "whz/util/config"
], function(declare, lang, common, shop, config) {
    var ShopBo = declare("",shop.Bo,{
        modalName : "shop/operatorShop",
        fields:{
            //运营商提交认证
            opAutApplyButton:{
                type:"button",
                label:"提交认证",
                action:"opAutApply",
                className:"fullButton"
            },
            opAutReApplyButton : {
                type:"button",
                label:"重新提交",
                action:"opAutReApply",
                className:"fullButton"
            },
            opCertificationThrough:{
                type:"button",
                label:"认证通过",
                action:"verifyPass",
                className:"large-width",
                canEdit: false
            },
            "stationType" : {
                type: "options",
                label: "经营主体类型",
                options : {
                    1:"标准型",
                    2:"简易型",
                    3:"专业型"
                } 
            },
            opAudit : {
                type:"button",
                label:"审核中",
                action:"verify",
                className:"large-width",
                canEdit: false
            },
            //申请运营地区
            "opTranRegions" : {
                type:"objects",
                label:"运营地区",
                labelField:"remark",
                canEdit:true,
                canDelete:true,
                canAdd:true,
                canDnd:true,
                defaultData:{
                    cityId:null,
                    countyId:null,
                    provinceId:"57a936a0e026905d4c92f647",
                    remark:"重庆市"
                },
                fields:{
                    layout:[{
                        field:"provinceId,cityId,countyId,remark",
                        type:"district",
                        enableAll:true,
                        placeHolder:"请选择地址",
                        label:"区划"
                    }]
                },
                className: "large-width"
            },
            backVerificationButtonSta:{
                type:"button",
                label:"驳回认证",
                action:"backVerificationSta",
                buttonClass:"margin10"
            },
            noVerificationButtonSta:{
                type:"button",
                label:"取消认证",
                action:"cancelVerificationSta",
                buttonClass:"margin10"
            },           
            // deleteMerchantButtonSta:{
            //     type:"button",
            //     label:"删除商家",
            //     action:"deleteMerchanSta",
            //     buttonClass:"margin10"
            // },
            verificationButtonSta:{
                type:"button",
                label:"标记认证",
                action:"doVerificationSta",
                buttonClass:"margin10"
            },
            backVerificationButtonB2C:{
                type:"button",
                label:"驳回认证",
                action:"backVerificationB2C",
                buttonClass:"margin10"
            },
            noVerificationButtonB2C:{
                type:"button",
                label:"取消认证",
                action:"cancelVerificationB2C",
                buttonClass:"margin10"
            },           
            deleteMerchantButtonB2C:{
                type:"button",
                label:"删除商家",
                action:"deleteMerchanB2C",
                buttonClass:"margin10"
            },
            verificationButtonB2C:{
                type:"button",
                label:"标记认证",
                action:"doVerificationB2C",
                buttonClass:"margin10"
            },
            backVerificationButtonSev:{
                type:"button",
                label:"驳回认证",
                action:"backVerificationSev",
                buttonClass:"margin10"
            },
            noVerificationButtonSev:{
                type:"button",
                label:"取消认证",
                action:"cancelVerificationSev",
                buttonClass:"margin10"
            },           
            deleteMerchantButtonSev:{
                type:"button",
                label:"删除商家",
                action:"deleteMerchanSev",
                buttonClass:"margin10"
            },
            verificationButtonSev:{
                type:"button",
                label:"标记认证",
                action:"doVerificationSev",
                buttonClass:"margin10"
            },
            "services" : {
                type:"objects",
                label:"服务项目",
                labelField:"serviceType",
                dataProvider: "bob/shop/sevShop",
                userDefinedValue:"setobjsValue",
                rightTextField:"remark",
                canEdit:true,
                canDelete:true,
                canAdd:true,
                canDnd:true,
                defaultData:{
                    serviceType:null,
                    remark:""
                },
                fields:{
                    layout:[{
                        field:"serviceType",
                        type:"options",
						label:"服务项目",
						options:config.shopService
                    },{
                        field:"remark",
                        type:"text",
						label:"备注"
                    }]
                },
                className: "large-width"
            }
        },

        getEdtLayoutForAutApply: function(){
            // summary:
            //      运营商店铺提交认证成为运营商Layout
            // view:
            //      opAut——运营商提交认证            
            return [{
                type:"form",
                fields:this.getFormItems([
                    "rejectedReason",
                    "opCertificationThrough",
                    "opAudit",
                    "logo",
                    "contactName","contactPhone",
                    "companyName","legalPerson",
                    "legalPersonCode",
                    "legalImg1","legalImg2",
                    "businessLicense",
                    "orgCode",//组织机构代码
                    "lon,lat",
                    "address",
                    "provinceId,cityId,countId,town",
                    "opTranRegions",//运营区域
                    "opAutApplyButton",
                    "opAutReApplyButton"
                ],true)
            }]
        },
        opAutDataReady: function(widget){
            // summary:
            //      数据加载完成,可在此处处理按钮的显示和隐藏
            // view:
            //      opAut——运营商提交认证   
            widget.disableByFields(["rejectedReason"]);
            widget.hideByFields([
                "opAutApplyButton",
                "opAutReApplyButton",
                "rejectedReason",
                "opCertificationThrough",
                "opAudit"]);
            var data = widget.getData();
                if(!data.isVerified&&0==data.isVerifySubmit){
                    widget.showByFields(["opAutApplyButton"]);
                }
                if(!data.isVerified&&-1==data.isVerifySubmit){
                    widget.showByFields(["opAutReApplyButton"]);
                    // 显示驳回原因
                    widget.showByFields(["rejectedReason"]);
                }
                //  若店铺isVerify为false且isVerifySubmit为1,则显示认证审核中
                if(!data.isVerified&&1==data.isVerifySubmit){
                    widget.showByFields(["opAudit"]);
                }
                if(data.isVerified&&2==data.isVerifySubmit){
                    widget.showByFields(["opCertificationThrough"]);
                }
                // 若是审核中或者审核通过 要禁止所有字段的编辑
                if((!data.isVerified&&1==data.isVerifySubmit) || 
                    (data.isVerified&&2==data.isVerifySubmit)){
                    widget.disableByFields([                   
                        "logo","contactName","contactPhone",
                        "companyName","legalPerson","legalPersonCode",
                        "legalImg1","legalImg2","businessLicense",
                        "orgCode",//组织机构代码
                        "lon,lat","address","provinceId,cityId,countId,town",
                        "opTranRegions"
                    ]);
                }else{
                    widget.enableByFields([                   
                        "logo","contactName","contactPhone",
                        "companyName","legalPerson","legalPersonCode",
                        "legalImg1","legalImg2","businessLicense",
                        "orgCode",//组织机构代码
                        "lon,lat","address","provinceId,cityId,countId,town",
                        "opTranRegions"
                    ]);
                }             
        },
        opAutApply : function(data,dataList){
            // summary:
            //      运营商提交认证调用方法
            // view:
            //      opAut——运营商提交认证
            var msg = this.getDataValidMsg(data, ["logo","contactName",
                    "companyName","contactPhone","legalPerson","legalPersonCode",
                    "legalImg1","legalImg2","businessLicense",
                    "lon","lat","provinceId,cityId,countId,town",
                    "address","opTranRegions"]);
            if(msg){
                alert(msg);
                return;
            }
            if(!data.companyName){
                alert("请输入经营主体名称");
                return;
            }
            if (!data.legalPerson) {
                alert("请输入法人姓名");
                return;
            }
            //  去除字符串前后空格
            data.contactName = common.deleteBail(data.contactName);
            data.legalPerson = common.deleteBail(data.legalPerson);
            data.companyName = common.deleteBail(data.companyName);
            if (!common.isCellPhone(data.contactPhone)) {
                alert("请输入11位电话号码");
                return;
            }
            //  检查身份证号码合法性
            if(!common.legIdCard(data.legalPersonCode)){
                alert("请输入正确的身份证号码");
                return;
            }
            if(! data.lat || ! data.lon){
                alert("请设置地理位置");
                return;
            }
            if(!data.address){
                alert("详细地址不能为空");
                return;
            }
            if (data.opTranRegions.length<1) {
                alert("请选择运营区域");
                return;
            }
            if(data.opTranRegions.length>0){
                var districtdata = data.opTranRegions;
                for(var i=0;i<districtdata.length;i++){
                    if(!districtdata[i].provinceId){
                        alert("运营区域必须精确到省市区县");
                        return;
                    }
                    if(!districtdata[i].cityId){
                        alert("运营区域必须精确到省市区县");
                        return;
                    }
                    if(!districtdata[i].countyId){
                        alert("运营区域必须精确到省市区县");
                        return;
                    }
                }
            }
            window.busy();
            this.exec("verifyShopSubmit", data).then(lang.hitch(this, function(result){
                window.free();
                if(result&&result.data&&result.data.ok==1){
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"提交失败");
                }
            }));
        }, 
        opAutReApply : function(data,dataList){
            // summary:
            //      运营商重新提交认证调用方法
            // view:
            //      opAut——运营商提交认证
            this.opAutApply(data,dataList);
        },
        getOpListQuery:function(params){
            // summary:
            //      平台上运营商列表的查询条件
            // view:
            //      opAtPltList——运营商列表             
            var query = {
                isDelete:false,
                shopType:5,
                isVerifySubmit:1,
                isVerified: false
            };
            if(params.search){
                query.search = params.search;
            }
            if(params.state&&params.state._id){
                // 待认证
                if(1 == params.state._id){
                    query.isVerifySubmit=1;
                    query.isVerified=false;
                }else if(2 == params.state._id){
                    // 已认证
                    query.isVerifySubmit=2;
                    query.isVerified=true;
                }else if(3 == params.state._id){
                    // 未提交
                    query.isVerifySubmit= 0;
                    query.isVerified=false;
                }else if(4 == params.state._id){
                    // 已驳回
                    query.isVerifySubmit=-1;
                    query.isVerified=false;
                }else{
                    delete query.isVerifySubmit;
                    delete query.isVerified;
                }
            }
            return query;
        },
        onOpListClick: function(data){
            // summary:
            //      运营商列表点击事件
            // view:
            //      opAtPltList——运营商列表
            // description:
            //      点击跳转到运营商详情页面 
            window.moveToView("opMerDetail",data._id);
        },
        getListLayout: function(){
            // summary:
            //      运营商查找服务商的列表(网站端)
            // view:
            //      sevManage——服务商列表            
            if(!this.merchantListLayout){
                this.merchantListLayout = this.getFormItems([
                "shopName",
                "town",
                "address",
                "contactPhone",
                "isVerify",
                "operateButton"
                ],false);
            }
            return this.merchantListLayout;
        },
        
        getEdtLayoutForB2C : function(){
            // summary:
            //      B2C店铺详情页面layout
            // view:
            //      b2cMerDetail——b2c商家详情             
            if(!this.b2cAutLayout){
                this.b2cAutLayout = [{
                    type: "form",
                    fields: this.getFormItems([
                    "logo",
                    "contactName","contactPhone",
                    "companyName","legalPerson",
                    "legalPersonCode",
                    "legalImg1","legalImg2",
                    "businessLicense",
                    "lon,lat",
                    "address",
                    "provinceId,cityId,countId,town",
                    "backVerificationButtonB2C",
                    "noVerificationButtonB2C",
                    "verificationButtonB2C",
                    "deleteMerchantButtonB2C"
                    ])
                }];
            }
            return this.b2cAutLayout;
        },
        onDataReadyForB2C:function(widget){
            // summary:
            //      b2c商家详情按钮的显示和隐藏
            // view:
            //      b2cMerDetail——b2c商家详情 
           var data = widget.getData();
           widget.hideByFields([
            "backVerificationButtonB2C",
            "noVerificationButtonB2C",
            "verificationButtonB2C",
            "deleteMerchantButtonB2C"]);
            widget.disableByFields([
                "logo",
                "contactName","contactPhone",
                "companyName","legalPerson",
                "legalPersonCode",
                "legalImg1","legalImg2",
                "businessLicense",
                "lon,lat",
                "address",
                "provinceId,cityId,countId,town",
                ]);
            if(!data.isVerified&&data.isVerifySubmit==1){
                widget.showByFields(["backVerificationButtonB2C","verificationButtonB2C"]);
            }
            // 已认证 显示取消认证
            if(data.isVerified){
                widget.showByFields(["noVerificationButtonB2C"]);
            }
            if(this.getShopId() == data.platformShopId){
               widget.hideByFields([
                    "backVerificationButtonB2C",
                    "noVerificationButtonB2C",
                    "verificationButtonB2C"
                ]);
            }
        },
        doVerificationB2C : function(params,widget){
            // summary:
            //      通过认证点击按钮
            // view:
            //      b2cMerDetail——b2c商家详情 
            window.busy();
            var data = {
                targetShopId: params._id,
                shopId : this.getShopId()
            };
            return this.exec("verifyB2CAut", data).then(lang.hitch(this, function(result){
                window.free();
                if(result&&result.data&&result.data.ok == 1){
                    alert("认证成功！");
                    history.back();
                    //widget.cqRefresh();
                }else{
                    alert("认证失败！");
                    return ;
                };
            }));
        },
        cancelVerificationB2C : function(params,widget){
            // summary:
            //      取消认证点击按钮
            // view:
            //      b2cMerDetail——b2c商家详情
            window.busy();
            var data = {
                targetShopId: params._id,
                shopId : this.getShopId()
            };
            this.exec("cancelB2CAut", data).then(lang.hitch(this, function(result){
                window.free();
                if(result&&result.data&&result.data.ok == 1){
                    alert("取消成功！");
                    history.back();
                    //widget.cqRefresh();
                }else{
                    alert("取消失败！");
                    return ;
                };
            }));            
        },
        backVerificationB2C : function(params,widget){
            // summary:
            //      驳回认证点击按钮
            // view:
            //      b2cMerDetail——b2c商家详情            
            var reason = prompt("请输入驳回原因");
            if(!reason) return;
            window.busy();
            var data = {
                targetShopId: params._id,
                rejectedReason:reason,
                shopId : this.getShopId()
            };
            this.exec("rejectB2CAut", data).then(lang.hitch(this, function(result){
                window.free();
                if(result&&result.data&&result.data.ok == 1){
                    alert("驳回成功！");
                    history.back();
                    //widget.cqRefresh();
                }else{
                    alert("驳回失败！");
                    return ;
                };
            }));            
        },
        getEdtLayoutForSev : function(){
            // summary:
            //      服务商店铺详情页面layout
            // view:
            //      sevMerDetail——服务商家详情              
            if(!this.merchantDetailLayout){
                this.merchantDetailLayout = [{
                    type: "form",
                    fields: this.getFormItems([
                        "logo",
                        "contactName","contactPhone",
                        "companyName","legalPerson",
                        "legalPersonCode",
                        "legalImg1","legalImg2",
                        "businessLicense",
                        "orgCode",//组织机构代码
                        "lon,lat",
                        "address",
                        "provinceId,cityId,countId,town",
                        "brief",
                        "tranRegions",
                        "services",
                        "backVerificationButtonSev",
                        "noVerificationButtonSev",
                        "verificationButtonSev",
                        "deleteMerchantButtonSev"
                    ])
                }];
            }
            return this.merchantDetailLayout;
        },
        onDataReadyForSev:function(widget){
            // summary:
            //      服务商店铺详情按钮的显示和隐藏
            // view:
            //      sevMerDetail——服务商家详情            
            var data = widget.getData();
            widget.hideByFields([
                "backVerificationButtonSev",
                "noVerificationButtonSev",
                "verificationButtonSev",
                "deleteMerchantButtonSev"
            ]);
            widget.disableByFields([
                "logo",
                "contactName","contactPhone",
                "companyName","legalPerson",
                "legalPersonCode",
                "legalImg1","legalImg2",
                "businessLicense",
                "orgCode",//组织机构代码
                "lon,lat",
                "address",
                "provinceId,cityId,countId,town",
                "brief",
                "tranRegions","services"
            ]);
            if(!data.isVerified&&data.isVerifySubmit==1){
                widget.showByFields(["backVerificationButtonSev","verificationButtonSev"]);
            }
            if(data.isVerified){
                widget.showByFields(["noVerificationButtonSev"]);
            }
            if(this.getShopId() == data.platformShopId){
               widget.hideByFields([
                    "backVerificationButtonSev",
                    "noVerificationButtonSev",
                    "verificationButtonSev"
                ]);
            }
        },
        doVerificationSev : function(params,widget){
            // summary:
            //      通过认证点击按钮
            // view:
            //      sevMerDetail——服务商家详情
            window.busy();
            var data = {
                targetShopId: params._id,
                shopId : this.getShopId()
            };
            this.exec("verifySevAut", data).then(lang.hitch(this, function(result){
                window.free();
                if(result&&result.data&&result.data.ok == 1){
                    alert("认证成功！");
                    history.back();
                    //widget.cqRefresh();
                }else{
                    alert("认证失败！");
                    return ;
                };
            }));
        },
        cancelVerificationSev : function(params,widget){
            // summary:
            //      取消认证点击按钮
            // view:
            //      sevMerDetail——服务商家详情
            window.busy();
            var data = {
                targetShopId: params._id,
                shopId : this.getShopId()
            };
            this.exec("cancelSevAut", data).then(lang.hitch(this, function(result){
                window.free();
                if(result&&result.data&&result.data.ok == 1){
                    alert("取消成功！");
                    history.back();
                    //widget.cqRefresh();
                }else{
                    alert("取消失败！");
                    return ;
                };
            }));            
        },
        backVerificationSev : function(params,widget){
            // summary:
            //      驳回认证点击按钮
            // view:
            //      sevMerDetail——服务商家详情
            var reason = prompt("请输入驳回原因");
            if(!reason) return;
            window.busy();
            var data = {
                targetShopId: params._id,
                rejectedReason:reason,
                shopId : this.getShopId()
            };
            this.exec("rejectSevAut", data).then(lang.hitch(this, function(result){
                window.free();
                if(result&&result.data&&result.data.ok == 1){
                    alert("驳回成功！");
                    history.back();
                    //widget.cqRefresh();
                }else{
                    alert("驳回失败！");
                    return ;
                };
            }));            
        },      
        getEdtLayoutForSta : function(){
            // summary:
            //      服务站店铺详情页面layout
            // view:
            //      staMerDetail——服务站详情  
            if(!this.merchantDetailLayout){
                this.merchantDetailLayout = [{
                    type: "form",
                    fields: this.getFormItems([
                        "logo","contactName",
                        "contactPhone","stationType","shopType",
                        "companyName","legalPerson","legalPersonCode",
                        "legalImg1","legalImg2","businessLicense",
                        "orgCode", //组织机构代码
                        "lon,lat","address",
                        "provinceId,cityId,countId,town","brief",
                        "backVerificationButtonSta",
                        "noVerificationButtonSta",
                        "verificationButtonSta"
                        // "deleteMerchantButtonSta"
                    ])
                }];
            }
            return this.merchantDetailLayout;
        },
        onDataReadyForSta:function(widget){
            // summary:
            //      服务站详情按钮的显示和隐藏
            // view:
            //      staMerDetail——服务站详情  
            var data = widget.getData();
             widget.hideByFields([
                "backVerificationButtonSta",
                "noVerificationButtonSta",
                "verificationButtonSta"
                //"deleteMerchantButtonSta"
            ]);
            widget.disableByFields([
                "logo","contactName",
                "contactPhone","stationType","shopType",
                "companyName","legalPerson","legalPersonCode",
                "legalImg1","legalImg2","businessLicense",
                "orgCode", //组织机构代码
                "lon,lat","address",
                "provinceId,cityId,countId,town","brief"
            ]);
            if(!data.isVerified&&data.isVerifySubmit==1){
                widget.showByFields(["backVerificationButtonSta","verificationButtonSta"]);
            }
            // 已认证 显示取消认证
            if(data.isVerified){
                widget.showByFields(["noVerificationButtonSta"]);
            }
            if(this.getShopId() == data.platformShopId){
               widget.hideByFields([
                    "backVerificationButtonSta",
                    "noVerificationButtonSta",
                    "verificationButtonSta"
                ]);
            }
        },
        doVerificationSta : function(params,widget){
            // summary:
            //      通过认证点击按钮
            // view:
            //      staMerDetail——服务站详情 
            window.busy();
            var data = {
                targetShopId: params._id,
                shopId : this.getShopId()
            };
            this.exec("verifyStaAut", data).then(lang.hitch(this, function(result){
                window.free();
                if(result&&result.data&&result.data.ok == 1){
                    alert("认证成功！");
                    history.back();
                    //widget.cqRefresh();
                }else{
                    alert("认证失败！");
                    return ;
                };
            }));
        },
        cancelVerificationSta : function(params,widget){
            // summary:
            //      取消认证点击按钮
            // view:
            //      staMerDetail——服务站详情
            window,busy();
            var data = {
                targetShopId: params._id,
                shopId : this.getShopId()
            };
            this.exec("cancelStaAut", data).then(lang.hitch(this, function(result){
                window.free();
                if(result&&result.data&&result.data.ok == 1){
                    alert("取消认证成功！");
                    history.back();
                    //widget.cqRefresh();
                }else{
                    alert("取消认证失败！");
                    return ;
                }
            }));            
        },
        backVerificationSta : function(params,widget){
            // summary:
            //      驳回认证点击按钮
            // view:
            //      staMerDetail——服务站详情
            var reason = prompt("请输入驳回原因");
            if(!reason) return;
            var data = {
                targetShopId: params._id,
                rejectedReason:reason,
                shopId : this.getShopId()
            };
            window.busy();
            this.exec("rejectStaAut", data).then(lang.hitch(this, function(result){
                if(result&&result.data&&result.data.ok == 1){
                    alert("驳回成功！");
                    history.back();
                    //widget.cqRefresh();
                }else{
                    alert("驳回失败！");
                    return ;
                }
            }));            
        },
        setobjsValue:function(widget,value){
            var label = "";
            if("2001" == value.serviceType){
                label = "生产经营";
            }
            if("2002" == value.serviceType){
                label = "技术推广";
            }
            if("2003" == value.serviceType){
                label = "政策法规";
            }
            if("2004" == value.serviceType){
                label = "疫病防治";
            }
            if("2005" == value.serviceType){
                label = "质量安全";
            }
            if("2006" == value.serviceType){
                label = "农业执法";
            }
            if("3001" == value.serviceType){
                label = "水电缴纳";
            }
            if("4001" == value.serviceType){
                label = "农资供应";
            }
            widget.set("label",label);
            widget.set("rightText",value.remark);
        }
    });
	
	var shopBo = new ShopBo();
	shopBo.Bo = ShopBo;
    lang.setObject("bob.shop.opShop", shopBo);
    return shopBo;
});
