define([
	"dojo/_base/declare",
	"dojo/_base/lang",
    "bob/user/shopAdmin",
	"./shop"
], function(declare,lang,shopAdmin,shop) {
    var ShopBo = declare("",shop.Bo,{
        modalName : "shop/platformShop",
        // 可处理的字段
        fields:{
            shopType: {
                type: "options",
                label: "店铺类型",
                options : {
                    1:"一般商家",
                    2:"服务站",
                    3:"服务中心",
                    4:"服务商",
                    5:"运营商",
                    6:"平台商",
                    7:"政府",
                    9999:"其它"
                } 
            },
            isVerified: {
                type : 'checkbox',
                label : '认证',
                selected : true
            },
            bailAmount: {
                label : '保证金金额',
                type : 'text',
                field : '',
                placeHolder : "请输入保证金金额"
            }, 
            settlePeriod: {
                label : '结算周期',
                type : 'text',
                placeHolder : "请输入结算周期"
            },
            wxPayMchId: {
                label : '微信支付商家ID',
                type : 'text',
                placeHolder : "请输入微信支付商家ID"
            }, 
            wxPayCert: {
                label : '微信支付秘钥文件',
                type : 'text',
                placeHolder : "请输入微信支付秘钥文件"
            }, 
            wxPayPartnerKey: {
                label : '微信支付api密码',
                type : 'text',
                placeHolder : "请输入微信支付api密码"
            },
            aliPayAccount: {
                label : '支付宝商家名',
                type : 'text',
                placeHolder : "请输入支付宝商家名"
            }, 
            aliPayMchId: {
                label : '支付宝商家id',
                type : 'text',
                placeHolder : "请输入支付宝商家id"
            },
            aliPaySeller: {
                label : '支付宝账号',
                type : 'text',
                placeHolder : "请输入支付宝账号"
            }, 
            aliPayPartnerKey: {
                label : '支付宝支付api密码',
                type : 'text',
                placeHolder : "请输入支付宝支付api密码"
            },
            wxPayFeeRate: {
                label : '微信支付率',
                type : 'text',
                placeHolder : "请输入微信支付率"
            }, 
            aliWapFeeRate: {
                label : '支付宝手机支付费率',
                type : 'text',
                placeHolder : "请输入支付宝手机支付费率"
            }, 
            aliWebFeeRate: {
                label : '支付宝网页支付费率',
                    type : 'text',
                    placeHolder : "请输入支付宝网页支付费率"
            }, 
            aliAppFeeRate: {
                label : '支付宝APP支付费率',
                type : 'text',
                placeHolder : "请输入支付宝APP支付费率"
            }, 
            platformFeeRate: {
                label : '平台手续费费率',
                type : 'text',
                placeHolder : "请输入平台手续费费率"
            },
            bailFeedbackRate: {
                label : '担保支付平台补贴',
                type : 'text',
                placeHolder : "请输入担保支付平台补贴"
            }, 
            casheFeebackRate: {
                label : '货到付款补贴',
                type : 'text',
                placeHolder : "请输入货到付款补贴"
            }, 
            pointFeedbackRate: {
                label : '余额支付补贴',
                type : 'text',
                placeHolder : "请输入余额支付补贴"
            },
            automaticReceipt: {
                label : '是否自动签收',
                type : 'checkbox'
            },
            platformResponsible : {
                type:"ref",
                field:"platformResponsible",
                label:"平台责任人",
                searchField:"pName",
                labelFields:"pName",
                dataProvider:"bob/user/shopAdmin",
                targetMethod:"getStaffUrl",
                canEdit:true
            },
            dftOpShop: {
                type:"ref",
                label:"默认运营商",
                field:"dftOpShop",
                searchField:"search",
                labelFields:"shopName",
                dataProvider:"bob/shop/shop",
                targetMethod:"getPlaShopListUrl",
                canEdit:true,
                query: {
                    isVerified: true,
                    shopType: 5
                }
            },
            platformInfoSaveButton: {
                type: "button",
                label: "保存",
                action: "save"
            },
            isOpVerifySubmit:{
				type:"options",
                label:"运营商认证状态",
                options:{
                    "-1":"已驳回",
                    "0":"未提交",
                    "1" : "待认证",
                    "2" : "已认证"
                }
            },
            opListActions:{
				type:"text",
				label:"操作",
				formatter:function(action,data){
					var v = 
                        (data.isVerified == false?"<div class='button' cq-action='verify'>认证</div>":"");		
				},
				className:"large-width"
            },
            "opTranRegions" : {
                type:"objects",
                label:"运营地区",
                labelField:"remark",
                canEdit:true,
                canDelete:true,
                canAdd:true,
                canDnd:true,
                defaultData:{
                    cityId:null,
                    countyId:null,
                    provinceId:"57a936a0e026905d4c92f647",
                    remark:"重庆市"
                },
                fields:{
                    layout:[{
                        field:"provinceId,cityId,countyId,remark",
                        type:"district",
                        enableAll:true,
                        placeHolder:"请选择地址",
                        label:"区划"
                    }]
                },
                className: "large-width"
            },
            "delete": {
                type: "button",
                action: "delete"
            },
            onRecommend: {
                type: "button",
                action: "onRecommend"
            },
            offRecommend: {
                type: "button",
                action: "offRecommend"
            },
            edit: {
                type: "button",
                action: "edit"
            },
            //平台添加可为商铺直接添加管理员功能按钮“字段”
            //徐阿雪2018/7/17
            adminSave : {
                type: "button",
                action: "adminSave"
            },
            createAt: {
                type: "dateTime",
                label: "创建时间"
            },
            lastLoginTime: {
                type: "dateTime",
                label: "最后登录时间"
            },
            showShopAdminP: {
                type:"button",
                action: "showShopAdminP"
            },
            reverse:{
                type:"button",
                action:"reverse",
                label:"恢复"
            }
		},
        //平台添加可为商铺直接添加管理员功能按钮“字段”
        //徐阿雪2018/7/17
        adminSave:function(data,widget){
            window.moveToView("addShopAdmin",widget.cqRefInfo.cqViewParam.params);
        },
        edit: function(data, widget){
            window.moveToView("shopEdt", data._id);
        },
        showShopAdminP:function(data,widget){
            window.moveToView("shopAdminP",data._id);
        },
        // 查询我管理的商家
        getListUrl: function(){
            return this.getBaseUrl()+ "/loadShops";
        },
        getPlatListUrl: function(){
            return this.getBaseUrl()+ "/loadShops?shopId="+this.getShopId();
        },
        getListParam: function(cqRefInfo){
            var params = {
                shopId: this.getShopId(),
                isVerified: true
                //isDelete: false,
                //isVerified: true,
                //shopType: 1,
                //isRecommend: true
            };
            if(cqRefInfo&&cqRefInfo.shopType&&cqRefInfo.shopType.shopType){
                params.shopType = cqRefInfo.shopType.shopType;
            }
            if(cqRefInfo&&cqRefInfo.state&&cqRefInfo.state._id){
                var state = cqRefInfo.state._id;
                if(state ==1){
                    delete params.isVerified;
                    delete params.isRecommend;
                }else if(state==2){
                    params.isVerified = true;
                }else if(state == 4){
                    params.isDelete = true;
                }else{
                    params.isRecommend = true;
                }
            }
            //if(cqRefInfo&&cqRefInfo.verified&&cqRefInfo.verified.isVerified){
            //    params.isVerified = cqRefInfo.verified.isVerified;
            //}
            //if(cqRefInfo&&cqRefInfo.isRecommend&&cqRefInfo.isRecommend.isRecommend){
            //    params.isRecommend = cqRefInfo.isRecommend.isRecommend;
            //}
            if(cqRefInfo&&cqRefInfo.search){
                params.search = cqRefInfo.search;
            }
            this.queryInfo = params;
            return params;
        },
        onListClick: function(data){
            window.moveToView("shopDetail", data._id);
        },
        onListClick2: function(data){
            window.moveToView("shopEdt", data._id);
        },
        // 平台设置Layout
        getEdtLayoutForSet: function(){
            return [{
                type: "form",
                fields: this.getFormItems([
                "bailAmount","settlePeriod","wxPayMchId",
                "wxPayCert","wxPayPartnerKey","aliPayAccount","aliPayMchId","aliPaySeller",
                "aliPayPartnerKey","wxPayFeeRate","aliWapFeeRate","aliWebFeeRate","aliAppFeeRate",
                "platformFeeRate","bailFeedbackRate","casheFeebackRate",
                "pointFeedbackRate","automaticReceipt","platformResponsible","dftOpShop","platformInfoSaveButton"
                ])
            }];
        },
        getDtlLayoutFroShop: function(){
            // summary:
            //      运营商详情页面Layout
            // view:
            //      opMerDetail——运营商详情   
            return [{
                type: "form",
                fields: this.getFormItems([
                    "logo",
                    "shopName",
                    "createAt",
                    "lastLoginTime",
                    "shopType",
                    "isVerified",
                    "contactName","contactPhone",
                    "companyName","legalPerson",
                    "legalPersonCode",
                    "legalImg1","legalImg2",
                    "businessLicense",
                    "orgCode",//组织机构代码
                    "lon,lat",
                    "address",
                    "provinceId,cityId,countId,town",
                    "countId,townId,villageId,locationName",
                    "brief",
                    "delete",
                    "onRecommend",
                    "offRecommend",
                    "edit",
                    "adminSave",
                    "showShopAdminP",
                    "reverse"
                ])
            }];
        },
        onDataReadyForShop: function(widget){
            var data = widget.getData();
            widget.disableByFields();
            widget.hideByFields(["onRecommend", "offRecommend"]);
            // 已认证 未推荐才允许推荐
            if(data){
                if(data.isRecommend){
                    widget.showByFields(["offRecommend"]);
                }else{
                    if(data.isVerified){
                        widget.showByFields(["onRecommend"]);
                    }
                }
                if(data.isDelete){
                    widget.showByFields(["reverse"]);
                    widget.hideByFields(["delete"]);
                }else{
                    widget.showByFields(["delete"]);
                    widget.hideByFields(["reverse"]);
                }
            }
        },
        getEdtLayoutForOp : function(){
            // summary:
            //      运营商详情页面Layout
            // view:
            //      opMerDetail——运营商详情           
            if(!this.merchantDetailLayout){
                this.merchantDetailLayout = [{
                    type: "form",
                    fields: this.getFormItems([
                        "logo",
                        "contactName","contactPhone",
                        "companyName","legalPerson",
                        "legalPersonCode",
                        "legalImg1","legalImg2",
                        "businessLicense",
                        "orgCode",//组织机构代码
                        "lon,lat",
                        "address",
                        "provinceId,cityId,countId,town",
                        "brief",
                        "opTranRegions",
                        "backVerificationButton",
                        "noVerificationButton",
                        "verificationButton",
                        "deleteMerchantButton",
                        "recommendeMerchantButton",
                        "noRecommendeButton"
                    ])
                }];
            }
            return this.merchantDetailLayout;
        },
        onDataReadyForOp:function(widget){
            // summary:
            //      平台上运营商详情按钮处理
            // view:
            //      opMerDetail——运营商详情            
            var data = widget.getData();
            widget.hideByFields([
                "backVerificationButton",
                "noVerificationButton",
                "verificationButton",
                "deleteMerchantButton",
                "recommendeMerchantButton",
                "noRecommendeButton"
            ]);
            widget.disableByFields([
                "logo",
                "contactName","contactPhone",
                "companyName","legalPerson",
                "legalPersonCode",
                "legalImg1","legalImg2",
                "businessLicense",
                "orgCode",//组织机构代码
                "lon,lat",
                "address",
                "provinceId,cityId,countId,town",
                "brief",
                "opTranRegions"]);
            if(!data.isVerified&&data.isVerifySubmit==1){
                widget.showByFields(["backVerificationButton","verificationButton"]);
            }
            // 已认证 显示取消认证
            if(data.isVerified){
                widget.showByFields(["noVerificationButton"]);
            }                
        },
        doVerification : function(params){
            // summary:
            //      运营商通过认证
            // view:
            //      opMerDetail——运营商详情 
            var data = {
                targetShopId: params._id,
                shopId : this.getShopId()
            };
            this.exec("verifyOPAut", data).then(lang.hitch(this, function(result){
                if(result&&result.data&&result.data.ok==1){
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"操作失败");
                }
            }));
        },
        cancelVerification : function(params){
            // summary:
            //      取消认证运营商
            // view:
            //      opMerDetail——运营商详情
            var data = {
                targetShopId: params._id,
                shopId : this.getShopId()
            };
            window.busy();
            this.exec("cancelOPAut", data).then(lang.hitch(this, function(result){
                window.free();
                if(result&&result.data&&result.data.ok==1){
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"操作失败");
                }
            }));            
        },
        backVerification : function(params){
            // summary:
            //      驳回认证运营商
            // view:
            //      opMerDetail——运营商详情
            var data = {
                targetShopId: params._id,
                shopId : this.getShopId()
            };
            // 输入驳回原因
            var backReason = prompt("驳回原因", "");
            if(!backReason){
                alert("请输入驳回原因");
                return;
            }
            window.busy();
            data.rejectedReason = backReason;
            this.exec("rejectOPAut", data).then(lang.hitch(this, function(result){
                window.free();
                if(result&&result.data&&result.data.ok==1){
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"操作失败");
                }
            }));            
        },
        "delete": function(data, widget){
            var isDelete = confirm("确认删除店铺:"+data.shopName);
            if(!isDelete){
                return;
            }
            this.exec("deleteById", {
                targetShopId: data._id
            }).then(lang.hitch(this, function(result){
                if(result&&result.data&&result.data.ok==1){
                    alert("删除成功");
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"删除失败");
                }
            }));
        },
        reverse: function(data, widget){
            var isReverse = confirm("确认恢复店铺:"+data.shopName);
            if(!isReverse){
                return;
            }
            this.exec("reverseById", {
                targetShopId: data._id
            }).then(lang.hitch(this, function(result){
                if(result&&result.data&&result.data.ok==1){
                    alert("恢复成功");
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"恢复失败");
                }
            }));
        },
        onRecommend: function(data, widget){
            this.exec("recommend", {
                targetShopId: data._id,
                isRecommend: true
            }).then(lang.hitch(this, function(result){
                if(result&&result.data&&result.data.ok==1){
                    alert("推荐成功");
                    widget.cqRefresh();
                }else{
                    alert(result&&result.data&&result.data.message||"推荐失败");
                }
            }));
        },
        offRecommend: function(data, widget){
            this.exec("recommend", {
                targetShopId: data._id,
                isRecommend: false
            }).then(lang.hitch(this, function(result){
                if(result&&result.data&&result.data.ok==1){
                    alert("取消推荐成功");
                    widget.cqRefresh();
                }else{
                    alert(result&&result.data&&result.data.message||"取消推荐失败");
                }
            }));
        },
        shopExport:function(a,b,widget){
            var query = this.queryInfo;
			var url = this.getListUrl();
			this.doExport(query, url);
        },
        doExport:function(query, url){
            require([
				"cq/util/sys/xlsx",
				"cq/util/sys/date",
				"cq/util/sys/userAgent",
				"cq/util/config/config"
			],lang.hitch(this,function(xlsx,date,userAgent,config){
                if(userAgent.isBrowser){
                    xlsx.loadAllData(url,query).then(lang.hitch(this,function(items){
                        var datas = [["商家名称","可提现","待结算","商家地址","创建时间",
                        "是否审核","审核时间"]];
                        for(var i=0;i<items.length;i++){
                            var data = items[i];
                            if(data.isVerifySubmit == 0){
                                data.isVerifySubmit = "未提交";
                            }else if(data.isVerifySubmit == -1){
                                data.isVerifySubmit = "驳回";
                            }else if(data.isVerifySubmit == 1){
                                data.isVerifySubmit = "审核中";
                            }else if(data.isVerifySubmit == 2){
                                data.isVerifySubmit = "已审核";
                            }
                            datas.push([data.shopName,data.availableAmount,data.pendingAmount,
                            data.address,data.createAt,data.isVerifySubmit,""]);
                        }
                        //导出成xlsx文件
                        xlsx.exportMatrix(datas,Date.now().toString());
                    }));
                }
            }));
        }
    });
	var shopBo = new ShopBo();
	shopBo.Bo = ShopBo;
    lang.setObject("bob.shop.pltShop", shopBo);
    return shopBo;
});
