﻿// 店铺公共基类
//		边界定义：
//   		1、提供平台会员自主创建店铺的能力
//			2、提供免注册直接创建店铺的能力
//			3、提供基础版本的店铺管理员维护店铺资料的能力
define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojo/topic",
  "dojo/DeferredList",
  "dojo/Deferred",
	"cq/util/config/config",
    "cq/util/image/qrCode",
    "bob/article/section/b",
    "bob/article/autoReply/b",
    "bob/util/copyPlate",
	"../BoBase",
    "cq/util/sys/geo",
    "cq/util/edit/position"
], function(declare,lang,topic,DeferredList,Deferred,config,qrCode,section,autoReply,copyPlate,BoBase, geo, position) {
    var ShopBo = declare("",BoBase.B,{
        modalName : "shop/shop",
        // 可处理的字段
        fields:{
            // 支持的支付方式
            "code":{
                type:"text",
                label:"编码",
                canEdit:"true"
            },
            "payWeiXin":{
                type:"checkbox",
                label:"微信支付",
                className:"large-high",
                canEdit:"true"
            },
            "payAli":{
                type:"checkbox",
                label:"支付宝支付",
                className:"large-high",
                canEdit:"true"
            },
            "payDeposit":{
                type:"checkbox",
                label:"余额支付",
                className:"large-high",
                canEdit:"true"
            },
            "shopInfoButton":{
                type:"button",
                label:"完成",
                action:"save",
                className:"fullButton"
            },
            "collectButton":{
                type:"button",
                label:"收藏",
                action:"collectAction"
            },
            "cancelCollectButton":{
                type:"button",
                label:"取消收藏",
                action:"cancelCollectAction"
            },
            "orderCheckerId" : {
                type:"ref",
                field:"orderCheckerId",
                label:"新订单消息通知",
                searchField:"userName",
                labelFields:"nickName,userName",
                dataProvider:"bob/user/shopAdmin",
                targetMethod:"getStaffUrl",
                canEdit:true,
				className:"middle-width"
            },
            "svcId" : {
                type:"ref",
                field:"svcId",
                label:"新客服消息通知",
                searchField:"userName",
                labelFields:"nickName,userName",
                dataProvider:"bob/user/shopAdmin",
                targetMethod:"getStaffUrl",
                canEdit:true,
				className:"middle-width"
            },
            "orderTimeout":{
                type:"text",
                label:"关闭订单时间",
                className:"large-high",
                placeHolder:"未付款订单超时取消时间(分钟)"
            },
            "tranAddr":{
                type:"text",
                label:"发货地点",
                className:"large-width",
                placeHolder:"未填写"
            },
            "tranRegion" : {
                type : "link",
                label : "销售区域",
                rightText : "",
                canEdit : false,
                href : "section",
                notNull: true
            },
            "tranRegions":{
                type:"objects",
                label:"销售区域",
                labelField:"remark",
                canEdit:true,
                canDelete:true,
                canAdd:true,
                canDnd:true,
                fields:{
                    layout:[{
                        field:"provinceId,cityId,countyId,remark",
                        type:"district",
						enableAll:true,
                        placeHolder:"请选择地址",
                        label:"区划"
                    }]
                },
                notNull: true
            },
            "freightTemplated":{
                type:"checkbox",
                label:"启用运费模板",
                className:"large-high",
                canEdit:"true"
            },
            // 微信相关配置
            "wxLogo":{
                type:"image",
                label:"公众号二维码",
                className:"large-high"
            },
            "wxAppId":{
                type:"text",
                label:"微信APPID",
                className:"middle-width",
                placeHolder:"未填写"
            },
            "wxAppSec":{
                type:"text",
                label:"微信APPSEC",
                className:"middle-width",
                placeHolder:"未填写"
            },
            "wxUrl":{
                type:"text",
                label:"微信配置Url",
                className:"middle-width",
                placeHolder:"未配置"
            },
            "wxCqToken":{
                type:"text",
                label:"微信Token",
                className:"middle-width",
                placeHolder:"未填写"
            },
            "wxHash":{
                type:"text",
                label:"微信wxAesk",
                className:"middle-width",
                placeHolder:"未填写"
            },
            "wxMsgTemplate":{
                type:"text",
                label:"订单状态模板",
                className:"middle-width",
                placeHolder:"未填写"
            },
            "wxVerification":{
                type:"checkbox",
                label:"微信认证",
                className:"middle-width"
            },
            "wxAutoLogin":{
                type:"checkbox",
                label:"快速登录",
                className:"middle-width"
            },
            "isSectionData" : {
                type : "link",
                label : "微信栏目",
                rightText : "未设置",
                canEdit : false,
                href : "#section"
            },
            "isAutoReplyData":{
                type : "link",
                label : "自动回复",
                rightText : "未设置",
                canEdit : false,
                href : "#autoReply"
            },
            "gotoCShop":{
                type : "link",
                label : "三级分销",
                rightText : "去设置",
                canEdit : false,
                href : "#cShop"
            },
            "shopWeiXinSave":{
                type:"button",
                label:"完成",
                action:"save",
                className:"fullButton"
            },
            "shopWeiXinUrl":{
                type:"button",
                label:"",
                action:"cutUrlAction",
                className:"fullButton"
            },
            "shopWeiXinToken":{
                type:"button",
                label:"",
                action:"cutTokenAction",
                className:"fullButton"
            },
            "shopReturnAddrSave":{
                type:"button",
                label:"完成",
                action:"save",
                className:"fullButton"
            },
            "brief": {
                type:"textarea",
                label:"店铺简介",
                className:"large-width",
                placeHolder:"请填写简介",
                notNull: true
            },
            "svcPhone":{
                type:"text",
                label:"客服电话",
                className:"middle-width",
                placeHolder:"请填写客服电话"
            },
            "svcWx":{
                type:"text",
                label:"客服微信",
                className:"middle-width",
                placeHolder:"请填写客服微信"
            },
            "svcQQ":{
                type:"text",
                label:"客服QQ",
                className:"middle-width",
                placeHolder:"请填写客服QQ"
            },
            logo:{
                type:"image",
                label:"店铺LOGO",
                className:"large-high",
                sizeType: 'cut',
				size: {
					width: 256,
					height: 256
				},
                notNull: true,
                clickImg:true
            },
            shopBackground:{
                type:"image",
                label:"店铺招牌",
                sizeType: "cut",
                size: {
                    width:750,
                    height:288
                }
            },
            companyName:{
                type:"text",
                label:"经营主体",
                className:"large-width",
                placeHolder:"请输入经营主体名称",
                notNull: true
            },
            shopName:{
                type:"text",
                label:"店铺名称",
                className:"middle-width"
            },
            "lon,lat":{
                type:"location",
                label:"地理位置",
                //用于联动区划，传入省市区ID字段名，不联动则传入空字符串
                distFields:"provinceId,cityId,countId",
                //区域划分地址字段名(显示字段名)
                distFieldsStr:"town",
                //详细地址
                detailAddrField:"address",
                className: "lon-lat-high",
                notNull:true
            },
            legalPerson:{
                type:"text",
                label:"法人姓名",
                className:"middle-width",
                placeHolder:"请输入法人姓名",
                notNull: true
            },
            legalPersonCode: {
                type: "text",
                label: "法人身份证号",
                placeHolder:"请与身份证保持一致",
                className: "middle-width",
                notNull: true
            },
            legalImg1:{
                type:"image",
                label:"法人身份证正面",
                className:"large-high",
                notNull: true,
				clickImg:true,
                size: {
                    width: "",
                    height: ""
                }
            },
            legalImg2:{
                type:"image",
                label:"法人身份证反面",
                className:"large-high",
                notNull: true,
			    clickImg:true
            },
            businessLicense:{
                type:"image",
                label:"营业执照",
                className:"large-high",
                notNull: true,
				clickImg:true
            },
            contactName:{
                type:"text",
                label:"联系人",
                className:"middle-width",
                placeHolder:"请输入联系名称",
                notNull: true
            },
            contactPhone:{
                type:"text",
                label:"联系电话",
                className:"middle-width",
                placeHolder:"请输入电话号码",
                notNull: true
            },
            contactWx:{
                type:"text",
                label:"店主微信",
                className:"middle-width",
                placeHolder:"请输入微信号码"
            },
            contactQQ:{
                type:"text",
                label:"店主QQ",
                className:"middle-width",
                placeHolder:"请输入店主QQ"
            },
            aliPaySeller:{
                type:"text",
                label:"支付宝账号",
                className:"middle-width",
                placeHolder:"请输入支付宝账号"
            },
            bankName:{
                type:"text",
                label:"开户行",
                className:"middle-width",
                placeHolder:"请输入开户银行"
            },
            bankAccountName:{
                type:"text",
                label:"账户名",
                className:"middle-width",
                placeHolder:"请输入账户名"
            },
            bankAccountCode:{
                type:"text",
                label:"账号",
                className:"middle-width",
                placeHolder:"请输入账号"
            },
            payee:{
                type:"text",
                label:"收款人",
                className:"middle-width",
                placeHolder:"请输入收款人"
            },
            fiName:{
                type:"text",
                label:"财务联系人姓名",
                className:"middle-width",
                placeHolder:"请输入财务联系人姓名"
            },
            fiPhone:{
                type:"text",
                label:"财务联系人电话",
                className:"middle-width",
                placeHolder:"请输入财务联系人电话"
            },
            fiQQ:{
                type:"text",
                label:"财务联系人QQ",
                className:"middle-width",
                placeHolder:"请输入财务联系人QQ"
            },
            rejectedReason: {
                type: "text",
                canEdit:false,
                label: "驳回原因",
                className:"large-width"
            },
            orgCode: {
                type: "text",
                label: "组织机构代码",
                placeHolder:"请输入组织机构代码",
                className:"large-width"
            },
            
            //区划编辑,省、市、县、地址文本
            "provinceId,cityId,countId,town" : {
                type : "district",
                label : "省-市-区县",
                canEdit : true,
                className:"large-width province-high",
                placeHolder:"请选择"
            },
            "countId,townId,villageId,locationName" : {
                type : "village",
                label: "乡镇",
                canEdit:true
            },
            town: {
                type: "text",
                label: "省-市-区县",
				className:"middle-width"
            },
            locationName : {
                type: "text",
                label: "乡镇",
				className:"middle-width"
            },
            address: {
                type: "text",
                label: "详细地址",
				className:"middle-width",
                placeHolder:"未填写"
            },
            operateButton:{
                type:"text",
				label:"操作",
				formatter:function(action,data){
					var v = "<div class='button' onclick='window.moveToView(\"merchantDetail\",\""+data._id+"\");'>详情</div>";
					return v;
				}
            },
            //店铺基本信息保存
            baseSaveButton:{
                type:"button",
                label:"保存",
                action:"save",
                className:"fullButton"
            },
            backVerificationButton:{
                type:"button",
                label:"驳回认证",
                action:"backVerification",
                buttonClass:"margin10"
            },
            noVerificationButton:{
                type:"button",
                label:"取消认证",
                action:"cancelVerification",
                buttonClass:"margin10"
            },
            deleteMerchantButton:{
                type:"button",
                label:"删除商家",
                action:"deleteMerchan",
                buttonClass:"margin10"
            },
            recommendeMerchantButton:{
                type:"button",
                label:"推荐商家",
                action:"recommendeMerchant",
                buttonClass:"margin10"
            },
            noRecommendeButton:{
                type:"button",
                label:"撤销推荐",
                action:"cancelRecommende",
                buttonClass:"margin10"
            },
            verificationButton:{
                type:"button",
                label:"标记认证",
                action:"doVerification",
                buttonClass:"margin10"
            },
            shopType: {
                type: "options",
                label: "店铺类型",
                options : {
                    1:"一般商家",
                    //2:"服务站",
                    3:"服务中心",
                    //4:"服务商",
                    5:"运营商",
                    //6:"平台商",
                    //7:"政府",
                    //9999:"其它"
                } 
            },
            industryType: {
                type: "options",
                label: "产业类型",
                options : {
                    1:"村",
                    2:"企业"
                }
            },
            lon: {
                type: "text",
                label: "地理位置"
            },
            lat: {
                type: "text",
                label: "地理位置"
            },
            isVerified:{
                type:"options",
                label:"是否认证",
                options:{
                    "true":"已认证",
                    "false":"待认证"
                },
            },
            isWhiteList: {
                type: 'checkbox',
                label: '是否启用白名单',
                className: ""
            },
            manageFreightButton : {
                type:"button",
                label:"管理运费模板",
                action:"manageFreight",
                buttonClass:"margin10"                
            },
            saveToPicButton:{
                type:"button",
                label:"保存到相册",
                action:"saveToPic",
                buttonClass:"margin10"
            },
            returnAddr : {
                type:"text",
                label:"退货地址",
				placeHolder: "请填写退货地址"
            },
            returnContact : {
                type:"text",
                label:"收货人",
				placeHolder: "请填写收货人"
            },
            returnPhone : {
                type:"text",
                label:"收货电话",
				placeHolder: "请填写收货电话"
            },
            getLocationView:{
                type:"button",
                label:"位置",
                action:"getLocationView"
            },
			verifiedStatus: {
				type: "text",
				label: "认证状态"
			},
            saveFromShopId: {
                type: "button",
                action: "saveFromShopId",
                label: "完成"
            },
            "location": {
                type: "text",
                label: "微商城地址"
            },
            availableAmount: {
                type: "number",
                fixedTo: 2
            },
            pendingAmount: {
                type: "number",
                fixedTo: 2
            },
            amount: {
                type: "number",
                fixedTo: 2
            },
            transactionAmount : {
                type : "number",
                fixedTo: 2,
                label : "交易总额",
                canEdit : false
            },
            payAmount : {
                type : "number",
                label : "在线支付金额",
                fixedTo: 2,
                canEdit : false
            },
            refundAmount : {
                type : "number",
                label : "退款总额",
                fixedTo: 2,
                canEdit : false
            },
            statisticsDate : {
                type : "date",
                label : "统计月份"
            },
            receiptStatus: {
                type: "options",
                label: "收款人状态",
                options : {
                    10:"待设置",
                    20:"待验证",
                    30:"已设置"
                } 
            },
            receiptStatusStr: {
                type: "text",
                label: "收款人状态"
            },
            receiptCode : {
                type : "text",
                label : "收款码",
                placeHolder:"",
                notNull : true
            },
            verifyCode : {
                type : "text",
                label : "验证码",
                placeHolder:"输入收款验证码",
                notNull : true
            },
            receiptName : {
                type : "text",
                label : "收款人姓名",
                placeHolder:"收款人姓名",
                notNull : true
            },
            receiptWxId : {
                type : "text",
                label : "收款人微信"
            },
            getReceiptCode:{
                type:"button",
                label:"获取收款码",
                action:"getReceiptCode",
                buttonClass:"margin10"
            },
            checkReceiptCode:{
                type:"button",
                label:"完成验证",
                action:"checkReceiptCode",
                buttonClass:"margin10"
            },
            stopReceiptStaff:{
                type:"button",
                label:"暂停结算",
                action:"stopReceiptStaff",
                buttonClass:"margin10"
            }
		},
        getListParam: function(params){
            var query = {
                isVerified: true,
                shopType: 1,
                preventSelf: true,
                currentShopId: this.getShopId()
            };
            if(params.search){
                query.search = params.search;
            }
            if(params.orderBy){
                query.orderBy = params.orderBy.orderBy;
            }
            return query;
        },
        onSearchListClick: function(data, widget){
            window.moveToView("supplyBus", data._id);
        },
        downLoadPrompt: function(){},
        getHiddenAction: function(data,widget){
            widget.hideByFields(["downLoadPrompt"]);
            localStorage.setItem("downLoadPrompt",true);
        },
        //  summary：
        //      保存到相册（二维码）
        //  view:
        //      shopQrCode
        saveToPic: function(data,wiget){
            if(window.canvas2ImagePlugin){
                var myCanvas = document.createElement("canvas"),src;
                var ctx = myCanvas.getContext("2d");
                if(data.logo && data.shopName){// 图文二维码
                    myCanvas.width = 488;
                    myCanvas.height = 488;
                    ctx.fillStyle = "#fe9570";
                    ctx.fillRect(0, 0, 488, 488);
                    
                    // 获得80*80的logo
                    var c1 = document.createElement("canvas");
                    c1.height = c1.width = 80;
                    if(typeof data.logo == "string"){
                        src = data.logo;
                        data.logo = new Image();
                        data.logo.src = src;
                    }
                    ctx1 = c1.getContext("2d");
                    ctx1.drawImage(data.logo, 0, 0, 80, 80);
                    data.logo.src = c1.toDataURL();
                    
                    // 获得312*424的无边框图文二维码
                    var c2 = document.createElement("canvas");
                    c2.height = 424;
                    c2.width = 312;
                    var ctx2 = c2.getContext("2d");
                    var pattern = ctx2.createPattern(data.logo, "no-repeat");
                    ctx2.arc(40,40,40,0,Math.PI*2);
                    ctx2.fillStyle = pattern;
                    ctx2.fill();
                    ctx2.fillStyle = "rgb(255,68,1)";
                    ctx2.font = "26px SimHei Regular";
                    ctx2.fillText(data.shopName, 98, 50);
                    
                    //  店铺二维码
                    var qrCode1 = data.shopQrCodeUrl;
                    //  微信二维码
                    var qrCode2 = data.shopWeixinCodeUrl;
                    
                    qrCode = new Image();
                    if(this.paramId == 1){
                        qrCode.src = qrCode1;
                    }else{
                        qrCode.src = qrCode2;
                    }
                    ctx2.drawImage(qrCode, 0, 112, 312, 312);
                    
                    var twQRcode = new Image();
                    twQRcode.src = c2.toDataURL();
                    // 二维码加边框
                    ctx.drawImage(twQRcode, 88, 32, 312, 424);
                }
                var onSuccess = function(){
                    alert("保存成功");
                };
                var onError = function(){
                    alert("保存失败");
                };
                window.canvas2ImagePlugin.saveImageDataToLibrary(onSuccess, onError, myCanvas);
            }
        },
        //  summary：
        //      根据不同的条件显示不同的二维码图片
        //  view:
        //      shopQrCode
        onDataReadyForShopCode: function(widget){
            widget.hideByFields(["shopQrCodeUrl","shopWeixinCodeUrl"]);
            var data = widget.getData();
            if(this.paramId==2){
                widget.showByFields(["shopWeixinCodeUrl"]);
            }else{
                //  首次进入页面的时候也是店铺二维码
                widget.showByFields(["shopQrCodeUrl"]);
            }
        },
        //  summary：
        //      设置店铺二维码选中table栏状态
        //  view:
        //      shopQrCode
        getStateItemForCode: function(data,itemType,list){
            //根据参数设置Item的选中状态
            data.selected = data._id==1;
            return data;
        }, 
        //  summary：
        //      获取店铺二维码
        //  view:
        //      shopQrCode
        loadShopCode : function(params){
            if(params.state){
                if(params.state._id){
                    this.paramId = params.state._id;
                }
            }
            return this.exec("loadById", {
                fromShopId: config.getPlatformShopId(),
                _id: this.getShopId()
            }).then(lang.hitch(this, function(result){
                //  店铺二维码
                var shopQrCodeUrl = location.href.split("#")[0]+'#businessDetails-' + this.getShopId();
                //  微信二维码
                var shopWeixinCodeUrl = this.getCurrentShopLocation();
                result.data.item.shopQrCodeUrl = qrCode.generatePNG(shopQrCodeUrl);
                result.data.item.shopWeixinCodeUrl = qrCode.generatePNG(shopWeixinCodeUrl);
                return result.data.item;
            }));
        },
        //  summary：
        //      保存指定店铺店铺信息
        //  view:
        //      很多，很多
        getQrCodeLayout:function(){
            return [{
                    type: "content",
                    content: 
                    '<div style="text-align: -webkit-center;">'+
                        '<div style="width:400px;height:400px;background-color:rgba(228, 47, 47, 0.41);margin-top: 30px;">'+
                            '<div style="width:310.5px;margin-top:20px;text-align: center">'+
                                '<img class="cq-field-input" style="display: inline-block;width:50px;height:50px;" data-cq-field="logo"/>'+
                                '<div style="display: inline-block;"><span class="cq-field-input" data-cq-field="shopName"></span></div>'+
                            '</div>'+
                            //  店铺二维码
                            '<img class="cq-field-input" style="width:310.5px;height:310.5px" data-cq-field="shopQrCodeUrl"/>'+
                            //  微信二维码
                            '<img class="cq-field-input" style="width:310.5px;height:310.5px" data-cq-field="shopWeixinCodeUrl"/>'+
                        '</div>'+
                        '<div>长按或扫描二维码关注我的店铺</div>'+
                        '<div style="font-weight: bold;font-size: 20px;">发送二维码给好友吸引更多客源</div>'+
                    '</div>'
                },{
				type: 'form',
				fields: this.getFormItems(["saveToPicButton"])
			}];
        },
        getStateItemProps: function(data,itemType,list){
            //根据参数设置Item的选中状态
            data.selected = data._id==1;
            return data;
        },
        //  summary：
        //      保存指定店铺店铺信息
        //  view:
        //      很多，很多
        save: function(data){
            window.busy();
            this.toSave(data).then(lang.hitch(this, function(result){
                window.free();
                if(result.data&&result.data.ok==1){
                    alert("保存成功");
                    history.back();
                }else{
                    alert(result.message||"保存错误");
                }
            }));
        },
        // 保存指定店铺的数据
        saveFromShopId: function(data, widget){
            window.busy();
            this.exec("saveFromPlatform", data).then(function(result){
                window.free();
                if(result&&result.data&&result.data.ok==1){
                    alert("保存成功");
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"保存失败");
                }
            });
        },
        //  summary：
        //      保存数据
        //  description:
        //      暂未找到使用的页面(当前页面有调用)
        toSave: function(data){
            return this.exec("save",data).then(lang.hitch(this,function(result){
                return result;
            }));
        },
		getShopConfigLayout: function(){
			return [{
                type:"form",
                fields:this.getFormItems([
                    "pendingAmount"
                ])
            }];
		},
		// 一个店铺数据加载完成的回调函数
		// 在这里依据加载到的数据来做显示隐藏等操作
		onDataReady:function(widget){},
        //  summary：
        //      从本商家的商家数据库加载指定的数据
        //  view：
        //      平台和运营商在执行店铺认证时查看店铺详情
        //      B2B商家在管理合作伙伴时，查看合作伙伴详情
        loadById: function(params){
            var _id = typeof(params)==="string"?params:params&&params.cqViewParam&&params.cqViewParam.params||"";
            if(!_id){
                return ;
            }
            return this.exec("loadById", {
                _id: _id
            }).then(lang.hitch(this, function(result){
                return result.data.item;
            }));
        },
        //  summary：
        //      依据地址栏参数从平台加载指定的店铺
        //  view：
        //      supplyBus
        //  returns
        //      Deferred(shopData)
        loadShopFromPlt: function(params){
            return this.loadByIdFromPlt(params.cqViewParam.params);
        },
        //  summary：
        //      从平台加载数据
        //  description:
        //      暂未找到使用的页面(当前页面有调用)
        loadByIdFromPlt: function(shopId){
            return this.exec("loadById", {
                fromShopId: config.getPlatformShopId(),
                _id: shopId
            }).then(lang.hitch(this, function(result){
                return result.data.item;
            }));
        },
		goToAut: function(data, widget){
			var shopType = data.shopType;
			if(shopType==1||shopType==6){
				window.moveToView("shopAut");
			}else if(shopType==2){
				window.moveToView("sevStationAut");
			}else if(shopType==3){
				window.moveToView("townShopAut");
			}else if(shopType==4){
				window.moveToView("sevAut");
			}else if(shopType==5){
				window.moveToView("opAut");
			}
		},
        shopConfigDataReady: function(widget){
            require(["cq/util/config/config"],function(config){
                var role = config.session.userInfo.role;
                if (role && role === 1) {
                    widget.showByFields([
                        "goToReceipt"
                    ]);
                } else {
                    widget.hideByFields([
                        "goToReceipt"
                    ]);
                }
            });
        },
        goToReceipt: function(data, widget) {
            window.moveToView("setReceiptInfo");
        },
        __shop:window.g_sys_info,
        //  summary：
        //      加载当前商家信息
        //  view:
        //      shopAut
        //      sevAut
        //      opAut
        //      sevStationAut
        //      townShopAut
        //      shopBase
        //      shopWeiXin
        //      shopCustomerMsg
        //      shopPay
        //      setPlatform
        loadMe: function(){
            return this.exec("loadById", {
                _id: this.getShopId()
            }).then(function(result){
                var item = result&&result.data&&result.data.item||{};
                // 不知道为什么要修改成负数 注释 刘轩 2017-3-6
                //item.pendingAmount = -1*item.pendingAmount;
                item.logo = item.logo||"./images/temp/dftLogo.png";
				item.amount = (item.pendingAmount||0)+(item.availableAmount||0);
				if(item.isVerified){
					item.verifiedStatus = "已认证";
				}else if(item.isVerifySubmit==0){
					item.verifiedStatus = "未提交";
				}else if(item.isVerifySubmit==1){
					item.verifiedStatus = "审核中";
				}else if(item.isVerifySubmit==-1){
					item.verifiedStatus = "已驳回";
				}
                // 设置店铺收款人的状态
                if (!item.receiptStatus || item.receiptStatus == 10) {
                    item.receiptStatusStr = "待设置";
                } else if (item.receiptStatus == 20) {
                    item.receiptStatusStr = "待验证";
                } else if (item.receiptStatus == 30) {
                    item.receiptStatusStr = "已设置";
                }
				item.logo = item.logo||config.defultShopLogo;
                if(!item.lon&&!item.lat){
                    var def = new Deferred();
                    require(["bob/user/consumer"],function(consumer){
                        consumer.getUserLocation().then(function(position){
                            if(position&&position.length===2){
                                item.lon = position[0];
                                item.lat = position[1];
                            }
                            def.resolve(item);
                        });
                    });
                    return def;
                }
                return item;
            }).then(lang.hitch(this,function(item){
                this.__shop = item;
                return item;
            }));
        },
        getCurrentShopLocation:function(){
            if(this.__shop&&this.__shop.location){
                return this.__shop.location;
            }else{
                var baseUrl = config.getDataOrigin()+"/w/home/"+shopId;
                if(config.fullURL){
                    baseUrl = config.fullURL;
                }
                if(config.session&&config.session.userId){
                    if(baseUrl.indexOf("?")>-1){
                        baseUrl += "&suid="+config.session.userId;
                    }else{
                        baseUrl += "?suid="+config.session.userId;
                    }
                }
                return baseUrl+hash;
            }
        },
		// 店铺切换的回调函数
        //  summary：
        //      店铺切换的回调函数
        //  TODO：
        //      暂未找到使用的页面
		onShopChanged:function(){},
        
            /*****shopBase*****/
        // 店铺基础信息
        //  函数名：getEdtLayoutForBase
        //      参数：无
        //      返回值：Object
        //      view：shopBase
        //      功能：店铺基础信息布局
        getEdtLayoutForBase: function(){
            return [{
                type:"form",
                fields:this.getFormItems([
                    "logo","shopName","shopBackground","lon,lat",
                    "address","brief","svcPhone",
                    "svcWx","svcQQ","contactName",
                    "contactPhone","contactWx",
                    "contactQQ","aliPaySeller",
                    "bankName","bankAccountName",
                    "bankAccountCode","payee","fiName",
                    "fiPhone","fiQQ","provinceId,cityId,countId,town","countId,townId,villageId,locationName",
                    "baseSaveButton"
                ])
            }];
        },
        //  view:
        //      shopBase
        //  summary：
        //      每次进入页面都要执行的方法
        onDataReadyBase: function(widget){
            var data = widget.getData();
            var hidefields = ["logo","shopName","lon,lat","address"];
            // 已认证或已经提交申请 则不允许修改下列字段
            if(data.isVerified||data.isVerifySubmit==1){
                widget.disableByFields(hidefields);
            }else{
                widget.enableByFields(hidefields);
            }
        },
        // 店铺微信配置
        // 函数名：getShopWeiXinLayout
        //      参数：无
        //      返回值：Object
        //      view:shopWeiXin
        //      作用：店铺微信布局
        getShopWeiXinLayout : function(){
            return [{
                type: "form",
                fields: this.getFormItems([
                    "wxLogo","wxAppId","wxAppSec",
                    "wxUrl","wxCqToken","wxHash",
                    "wxMsgTemplate","wxVerification",
                    "wxAutoLogin","isSectionData",
                    "isAutoReplyData",/*"gotoCShop",*/
                    "shopWeiXinSave",
                    "shopWeiXinUrl","shopWeiXinToken"
                ])
            }];
        },
        getShopReceiptLayout : function () {
            return [{
                type: "form",
                fields: this.getFormItems([
                    "receiptCode","receiptName",//"receiptWxId",
                    "verifyCode","getReceiptCode","checkReceiptCode",
                    "stopReceiptStaff"
                ])
            }];
        },
        //退货地址设置
        getReturnAddrLayout : function(){
            return [{
                type: "form",
                fields: this.getFormItems(["returnContact","returnPhone","returnAddr","shopReturnAddrSave"])
            }];
        },
        //  函数名：onDataReadyByShopWeiXin
        //      参数：widget
        //      返回值：无
        //      view:shopWeiXin
        onDataReadyByShopWeiXin : function(widget){
            widget.disableByFields(["wxUrl"]);
            var data = widget.getData();
            //判断自动回复是否设置
            var domNodeName = widget.getEditorByField("isAutoReplyData");
            if(data.autoReplyData&&data.autoReplyData.length>0){
                domNodeName.set("rightText","已设置");
            }else{
                domNodeName.set("rightText","未设置");
            }
            //判断微信栏目是否设置
            var nodeSectionName = widget.getEditorByField("isSectionData");
            if(data.sectionData&&data.sectionData.legnth>0){
               nodeSectionName.set("rightText","已设置");
            }else{
               nodeSectionName.set("rightText","未设置");
            }
        },
        onDataReadyByShopReceipt : function(widget){
            // 邀请码不能编辑
            widget.disableByFields(["receiptCode", "receiptWxId"]);
            var data = widget.getData();
            // 隐藏字段
            widget.hideByFields(["receiptCode","receiptName","receiptWxId","verifyCode","checkReceiptCode","stopReceiptStaff","getReceiptCode"]);
            if (!data.receiptStatus || data.receiptStatus == 10) {
                widget.showByFields(["getReceiptCode"]);
            } else if (data.receiptStatus == 20) {
                widget.showByFields(["receiptCode","receiptName","verifyCode","getReceiptCode","checkReceiptCode"]);
                widget.enableByFields(["receiptName"]);
            } else if (data.receiptStatus == 30) {
                widget.showByFields(["receiptName","stopReceiptStaff"]);
                widget.disableByFields(["receiptName"]);
            }
        },
        getReceiptCode : function (data, widget) {
            window.busy();
            this.exec3("co/receiptverify", "bGetReceiptCode", {}).then(lang.hitch(this, function(result) {
                window.free();
                if (result && result.ok == 1) {
                    var receiptCode = result.result.receiptCode || "";
                    copyPlate.copyToClipboard(receiptCode,function(){
                        alert("收款码已复制到剪贴板");
                    },function () {
                        prompt("",receiptCode);
                    });
                    widget.cqRefresh();
                } else {
                    alert(result.message || "获取失败");
                }
            }))
        },
        checkReceiptCode : function (data, widget) {
            var msg = this.getDataValidMsg(data, ['receiptName', 'verifyCode']);
            if (msg) {
                alert(msg);
                return ;
            }
            window.busy();
            this.exec3("co/receiptverify", "bBindReceiptStaff", {
                receiptName : data.receiptName,
                verifyCode : data.verifyCode
            }).then(lang.hitch(this, function(result) {
                window.free();
                if (result && result.ok == 1) {
                    alert("绑定成功");
                    widget.cqRefresh();
                } else {
                    alert(result.message || "绑定失败");
                }
            }));
        },
        stopReceiptStaff : function (data, widget) {
            window.busy();
            this.exec3("co/receiptverify", "clearReceiptCode", {}).then(lang.hitch(this, function(result) {
                window.free();
                if (result && result.ok == 1) {
                    alert("停用成功");
                    widget.cqRefresh();
                } else {
                    alert(result.message || "停用失败");
                }
            }));
        },
        // onDataReadyByShopReturnAddr : function(){
            // widget.disableByFields(["wxUrl"]);
            // var data = widget.getData();
            //判断自动回复是否设置
            // var domNodeName = widget.getEditorByField("isAutoReplyData");
            // if(data.autoReplyData&&data.autoReplyData.length>0){
                // domNodeName.set("rightText","已设置")
            // }else{
                // domNodeName.set("rightText","未设置")
            // }
            //判断微信栏目是否设置
            // var nodeSectionName = widget.getEditorByField("isSectionData");
            // if(data.sectionData&&data.sectionData.legnth>0){
               // nodeSectionName.set("rightText","已设置")
            // }else{
               // nodeSectionName.set("rightText","未设置")
            // }
        // },
        
        
        // 复制微信url
        // 周超
        //  函数名：cutUrlAction
        //      参数：param
        //      返回值：无
        //      view: shopWeiXin
        cutUrlAction : function(param){
            var wxUrl = param.wxUrl;
            if(!wxUrl){
                alert("微信Url为空");
                return;
            }
            copyPlate.copyToClipboard(wxUrl,function(){
                alert("微信Url复制成功!");
            },function () {
                prompt("",wxUrl);
            });
        },
        // 复制微信Token
        // 周超
        //  函数名：cutTokenAction
        //      参数：param
        //      返回值：无
        //      view: shopWeiXin
        cutTokenAction : function(param){
            var wxToken = param.wxCqToken;
            if(!wxToken){
                alert("微信Token为空");
                return;
            }
            copyPlate.copyToClipboard(wxToken,function(){
                alert("微信Token复制成功!");
            },function () {
                prompt("",wxToken);
            });
        },

        // 店铺客服配置
        // 函数名：getShopCustomerMsgLayout
        //      参数：无
        //      返回值：Object
        //      view: shopCustomerMsg
        getShopCustomerMsgLayout:function(){
            return [{
                type: "form",
                fields: this.getFormItems([
                    "orderCheckerId",
                    "svcId",
                    "orderTimeout",
                    "tranAddr",
                    //"isWhiteList",
                    //"tranRegions",
                    //"freightTemplated",
                    "shopInfoButton"//,
                    //"manageFreightButton"
                ])
            }];
        },
        onDataReadyShopCustomerMsg : function(widget){
            //var checkboxbtn =  widget.getEditorByField("freightTemplated");
            //widget.connect(checkboxbtn,"onFieldChanged",lang.hitch(this,function(obj,field,state){
            //    if(state){
            //        widget.showByFields(["manageFreightButton"]);
            //    }else{
            //        widget.hideByFields(["manageFreightButton"]);
            //    }
            //}))
            var data = widget.getData();
            widget.hideByFields([
                "isWhiteList"//,
                //"manageFreightButton"
            ]);
            if(data.isVerified&&"4"==data.shopType){  
                widget.showByFields(["isWhiteList"]);
            }
            //if(data.freightTemplated == true){
            //    widget.showByFields(["manageFreightButton"]);
            //}
        },
        manageFreight : function(){
            window.moveToView("freightList");
        },
        // 店铺支付方式配置
        //  函数名：getBussnessShop
        //      参数：无
        //      返回值：Object
        //      view:shopPay
        getShopPayLayout: function(){
            return [{
                type: "form",
                fields: this.getFormItems([
                    "payWeiXin",
                    "payAli",
                    "payDeposit",
                    "shopInfoButton"
                ])
            }];
        },
        //  summary：
        //      
        //  TODO：
        //      暂未找到使用的页面
        loadByIds:function(shopIds){
            return this.exec("loadByIds",{
                ids:shopIds
            });
        },
        /*opAtPltList,sevManage,sevStationManage*/
        //在当前商家数据库中加载指定条件的商家数据
        //  summary：
        //      商家列表url获取
        //  view：
        //      opAtPltList
        //      b2cShopManage
        //      sevManage
        //      sevStationManage
        //      townShopManage
        getShopListUrl: function(){
            return this.getBaseUrl()+"/loadShops?shopId="+this.getShopId();
        },
        getPlaShopListUrl: function(){
            return this.getBaseUrl()+"/loadShops?shopId="+this.getShopId()+"&fromShopId="+config.getPlatformShopId();
        },
        //  summary：
        //      加载我的伙伴（供shopB2B调用）
        loadPartner: function(){
            return this.getBaseUrl()+"/loadPartner?shopId="+this.getShopId();
        },
        getStateItemProps:function(data,itemType,list){
            var refInfo = list&&list.cqRefInfo||{};
            var state = refInfo.cqViewParam&&refInfo.cqViewParam.params||"";
            data.selected = data._id==state;
            return data;
        },
        //  summary：
        //      同意成为分销商（供shopB2B调用）
        agreeCoustmer:function(parms){
            return this.exec("agree",parms); 
        },
        //  summary：
        //      不同意成为分销商（供shopB2B调用）
        disAgreeCoustmer:function(parms){
            return this.exec("disagree",parms); 
        },
		getHelpLayout:function(){
            if (!this.helpLayout) {
                this.helpLayout = [{
                    type: "form",
                    fields: this.getFormItems([
                        "title","brief", "content"
                    ])
                }];
            }
            return this.helpLayout;
        },
        getCurrentShop: function(){
            return this.loadById(this.getShopId()).then(lang.hitch(this, function(item){
                return item||{};
            }));
        },
        getShopEdit : function(){
            return [{
                type: "form",
                fields: this.getFormItems(["logo","shopName","code","shopBackground","shopType","industryType","lon,lat",
                "provinceId,cityId,countId,town","countId,townId,villageId,locationName",
                "address","contactName", "contactPhone","brief","location",
                "saveFromShopId"])
            }];
        },
        onListClick : function(data){
            window.moveToView("shopEdt",data._id);
        },
        getShopSortUrl: function(param){
            return this.getBaseUrl() + "/loadShopCompartment?shopId=" + this.getPlatformShopId();
        },
        share: function(a,b,widget,c){
            require([
                "cq/util/share/share"
            ],lang.hitch(this, function(share){
                this.loadMe().then(lang.hitch(this, function(item){
                    if(item&&item.isVerified){
                        share.getShopLocation(this.getShopId()).then(function(baseUrl){
                            var moveTo = item.shopType==1?item.location.indexOf("wx")>-1?"":"#businessDetails-"+item._id:"";
                            var options = [{
                                "weixin": {
                                    title: item.shopName,
                                    thumb: item.logo || "",
                                    url:baseUrl+moveTo
                                }
                            }, {
                                "friendCircle": {
                                    title: item.shopName,
                                    thumb: item.logo || "",
                                    url:baseUrl+moveTo
                                }
                            }, {
                                "copy": {
                                    url: baseUrl+moveTo
                                }
                            }];
                            share.showShare(options);
                        });
                    }else{
                        alert("完成认证后可以分享店铺");
                    }
                }));
            }));
        },
        //  点击位置，跳转至地图
        getLocationView:function(data,viewNode){
            if(!this.view){
                var view = viewNode.getParent();
                while(view){
                    if(!view.show){
                        view = view.getParent();
                    }else{
                        break;
                    }
                }
                this.view = view;
            }
            var lonpic,latpic;
            lonpic = data.lon;
            latpic = data.lat;
            //alert("你跳啊，条给朕看一看")
            position.startEdit({
                lon:lonpic,
                lat:latpic
            }||null,this.view||viewNode, false);
            position.setEnable(false);
        },
        getUserNum: function(){
            return this.exec("getUserNum").then(function(result){
                return result&&result.data&&result.data.item||{};
            });
        },
        getShopNum: function(){
            return this.exec("getShopNum").then(function(result){
                return result&&result.data&&result.data.item||{};
            });
        },
        getTsAmount: function(){
            return this.exec("getTsAmount").then(function(result){
                return result&&result.data&&result.data.item||{};
            });
        },
        getTransactionData : function () {
            if (!this.statisticsDate) {
                var currentDate = new Date();
                this.statisticsDate = currentDate.toISOString();
            }
            var item = {};
            return this.exec("transactionStatistics", {
                statisticsDate : this.statisticsDate
            }).then(lang.hitch(this, function(result){
                if (result && result.data && result.data.ok == 1) {
                    item = result.data.item;
                }
                item.statisticsDate = this.statisticsDate;
                return item;
            }));
        },
        getTransactionLayout : function() {
            return [{
                type : "form",
                fields : this.getFormItems(["statisticsDate", "transactionAmount", "payAmount", "refundAmount"], true)
            }];
        },
        onTransactionDataReady : function (widget) {
            widget.disableByFields(["transactionAmount", "payAmount", "refundAmount"])
        },
        fieldChangeMethod: function(widget, field, newValue){
            if (field == "statisticsDate") {
                if (newValue != this.statisticsDate) {
                    this.statisticsDate = newValue;
                    widget.cqRefresh();
                }
            }
        }
    });
    var shopBo = new ShopBo();
    shopBo.Bo = ShopBo;
    topic.subscribe("whz/shop/changed", function() {
        shopBo.onShopChanged();
    });
    return shopBo;
});
