//  创建人：周超
//  创建时间：2017-1-6
//  创建内容：供应商列表
define([
	"dojo/_base/declare",
	"dojo/_base/lang",
    "dojo/Deferred",
    "cq/util/config/config",
    "cq/biz/user/user",
    "whz/util/config",
	"./shop"
], function(declare,lang,Deferred,config,user,configService,shop) {
    var ShopB2BBo = declare("",shop.Bo,{
        //  可处理的字段
        fields:{
            //合作伙伴特有按钮字段
            //  同意按钮
            beingPartnerButton_1:{
                type:"button",
                label:"同意成为分销商",
                action:"agreeAdd",
				buttonClass:"margin10"
            },
            //  不同意按钮
            beingPartnerButton_2:{
                type:"button",
                label:"不同意成为分销商",
                action:"disAgree",
				buttonClass:"margin10"
            },
            //  删除供应商按钮
            deleteSupplyerButton:{
                type:"button",
                label:"删除供应商",
                action:"deleteSupplyer",
                buttonClass:"fullButton"
            },
            //  删除分销商按钮
            deletePartnerButton:{
                type:"button",
                label:"删除分销商",
                action:"deletePartner",
                buttonClass:"fullButton"
            },
            //  保存按钮
            completePartnerButton:{
                type:"button",
                label:"保存",
                action:"completeSave",
                buttonClass:"fullButton"
            },
            "shopName,_id":{
                type:"link",
                showLogo:true,
                label:"{shopName}",
                rightText:"去看看",
                href:"#supplyBus-{_id}"
            },
            "inviter" : {
                type:"ref",
                field:"inviter",
                label:"业务经理",
                searchField:"userName",
                labelFields:"userName",
                dataProvider:"bob/user/shopAdmin",
                targetMethod:"getStaffUrl",
                canEdit:true,
				className:"middle-width"
            },
            shopLevel:{
                type:"options",
                label: config.shopFieldLabel&&config.shopFieldLabel.shopLevel||"客户级别",
                options:config.shopLevel||{},
                canEdit:true
            },
            saleAmount: {
                type: "text"
            },
            shopMatNum: {
                type: "text"
            },
            town: {
                type: "text"
            },
            // 看认证
            "brief": {
                type:"textarea",
                label:"简介",
                className:"large-width",
                placeHolder:"请填写简介"
            },
            "tranRegions" : {
                type:"objects",
                label:"服务地域",
                labelField:"remark",
                canEdit:true,
                canDelete:true,
                canAdd:true,
                canDnd:true,
                defaultData:{
                    cityId:null,
                    countyId:null,
                    provinceId:null,
                    remark:""
                },
                fields:{
                    layout:[{
                        field:"provinceId,cityId,countyId,remark",
                        type:"district",
                        enableAll:true,
                        placeHolder:"请选择地址",
                        label:"区划"
                    }]
                },
                className: "large-width"
            },
            "services" : {
                type:"objects",
                label:"服务项目",
                labelField:"serviceType",
                dataProvider: "bob/shop/sevShop",
                userDefinedValue:"setobjsValue",
                rightTextField:"remark",
                canEdit:true,
                canDelete:true,
                canAdd:true,
                canDnd:true,
                defaultData:{
                    serviceType:null,
                    remark:""
                },
                fields:{
                    layout:[{
                        field:"serviceType",
                        type:"options",
						label:"服务项目",
						options:configService.shopService
                    },{
                        field:"remark",
                        type:"text",
						label:"备注"
                    }]
                },
                className: "large-width"
            },
            "opTranRegions" : {
                type:"objects",
                label:"运营地区",
                labelField:"remark",
                canEdit:true,
                canDelete:true,
                canAdd:true,
                canDnd:true,
                defaultData:{
                    cityId:null,
                    countyId:null,
                    provinceId:"57a936a0e026905d4c92f647",
                    remark:"重庆市"
                },
                fields:{
                    layout:[{
                        field:"provinceId,cityId,countyId,remark",
                        type:"district",
                        enableAll:true,
                        placeHolder:"请选择地址",
                        label:"区划"
                    }]
                },
                className: "large-width"
            },
            "stationType" : {
                type: "options",
                label: "经营主体类型",
                options : {
                    1:"标准型",
                    2:"简易型",
                    3:"专业型"
                } 
            }
        },
        //  删除分销商接口
        deletePartnerAction: function(id){
            var params = {};
            params.shopId = this.getShopId();
            params.customerShopId = id;
            return this.exec("deletePartner", params);
        },
        //  summary：
        //      删除分销商
        //  view：
        //      myPartnerDetail
        deletePartner: function(data,wiget){
            window.busy();
            this.deletePartnerAction(data._id).then(lang.hitch(this,function(data){
                window.free();
                if(data&&data.data&&data.data.ok == 1){
                    alert("删除成功!");
                    wiget.cqRefresh();
                }else{
                    alert("操作失败，请稍后再试！");
                    return;
                }
            }));
        },
        showDataAction: function(data){
            var backdata = data;
            if(backdata.isSupplier){
                backdata.showField = "供";
            }
            if(backdata.isCustomer){
                backdata.showField = "销";
            }
            if(backdata.customerState){
                backdata.showField = "申";
            }
            return backdata;
        },
        agreeAdd: function(data,widget){
            var parms = {};
            parms.shopId = this.getShopId();
            parms.customerShopId = data._id;
            window.busy();
            this.agreeCoustmer(parms).then(lang.hitch(this,function(result){
                window.free();
                if(result&&result.data&&result.data.ok == 1){
                    alert("操作成功！")
                    widget.cqRefresh();
                }else{
                    alert("操作失败！")
                }
            }));
        },
        disAgree:function(data,widget){
            var parms = {};
            parms.shopId = this.getShopId();
            parms.customerShopId = data._id;
            window.busy();
            this.disAgreeCoustmer(parms).then(lang.hitch(this,function(result){
                window.free();
                if(result&&result.data&&result.data.ok == 1){
                    alert("操作成功！")
                    widget.cqRefresh();
                }else{
                    alert("操作失败！")
                }
            }));
        },
        //  修改合作伙伴等级或业务经理保存接口
        modifyPartner: function(completeData){
            return this.exec("modifyPartner", completeData);
        },
        //修改合作伙伴等级或业务经理，保存
        completeSave: function(saveData){
            var completeData = {};
            completeData.targetShopId = saveData._id;
            completeData.shopLevel = saveData.shopLevel;
			completeData.inviter = saveData.inviter;
            completeData.shopId = this.getShopId();
            this.modifyPartner(completeData).then(lang.hitch(this, function(data) {
                if(data.data&&data.data.ok==1){
                    history.back();
                }else{
                    alert("保存失败");
                }
            }));
        },
        //  summary：
        //      我的伙伴query条件筛选
        //  view:
        //      myPartnerList
        getShopB2BListQuery: function(params){
            var query = {isDelete:false,isVerified:true};
            query.shopId = this.getShopId();
            if(params.search){
                query.search = params.search;
            }
            query.allPartner = 
                {'isSupplier':true,'isCustomer':true,'customerState':1};
            query.allPartner = JSON.stringify(query.allPartner);
            if(params.state&&params.state._id){
                if(1 == params.state._id){
                    query.isSupplier=true;
                    delete query.allPartner;
                }else if(2 == params.state._id){
                    query.isCustomer=true;
                    delete query.allPartner;
                }else if(3 == params.state._id){
                    query.customerState=1;
                    delete query.allPartner;
                }else{
                    delete query.isSupplier;
                    delete query.isCustomer;
                    delete query.customerState;
                }
            }
            return query;
        },
        //  summary：
        //      加载供应商列表url
        //  view:
        //      supplyList
        loadSupplyUrl: function(){
            return this.getBaseUrl()+"/loadSupplyUrl";
        },
        //  summary：
        //      添加供应商
        //  TODO：
        //      暂未找到使用的页面（但是在本页面在调用）
        addSupplyerAction: function(parm){
            var params = {};
            //params.shopId = this.getShopId();
            params.supplierShopId = parm;
            return this.exec("addSupplyer", params);
        },
        //  删除供应商接口（但是在本页面有进行调用）
        deleteSupplyBus: function(parm){
            var params = {};
            params.shopId = this.getShopId();
            params.supplierShopId = parm;
            return this.exec("deleteSupplyer", params);
        },
        //  summary：
        //      合作伙伴点击事件处理
        //  view: 
        //      myPartnerList
        onShopB2BListClick: function(data){
            window.moveToView("myPartnerDetail",data._id);
        },
        //  summary：
        //      重盐合作伙伴详情
        //  view: 
        //      myPartnerDetail
        getPartnerDetailLayout : function(){
            return [{
                type: "form",
                fields: this.getFormItems([
                    "logo",
                    "shopName,_id",
                    "shopName",
                    "lon,lat",
                    "provinceId,cityId,countId,town",
                    "address",
                    "contactName",
                    "contactPhone",
                    "companyName",
                    "legalPerson",
                    "shopLevel",
                    "inviter",
                    "businessLicense",
                    "tranRegions",
                    "beingPartnerButton_1",
                    "beingPartnerButton_2",
                    "completePartnerButton",
                    "deletePartnerButton",
                    "deleteSupplyerButton",
                ])
            }];
        },
        //  summary：
        //      合作伙伴详情
        //  view:
        //      myPartnerDetail
        initPartnerDetailData : function(data){
            var _id = data.cqViewParam.params;
            return this.exec("loadById", { shopId: this.getShopId(), _id: _id }).then(lang.hitch(this,function(shopData){
                var data = (shopData&&shopData.data&&shopData.data.item)||shopData;
                return data;
            }));
        },
        //  summary：
        //      合作伙伴每次进入页面数据重新加载
        //  view:
        //      myPartnerDetail
        onPartnerReloaded : function(widget){
            var btns = [
                "deletePartnerButton",
                "beingPartnerButton_1",
                "beingPartnerButton_2",
                "deleteSupplyerButton"
            ];
            //隐藏所有按钮
            widget.hideByFields(btns);
            //其他字段不可编辑
            var fields = [
                "logo",
                "shopName",
                "lon,lat",
                "provinceId,cityId,countId,town",
                "address",
                "contactName",
                "contactPhone",
                "companyName",
                "legalPerson",
                "shopLevel",
                "inviter",
                "businessLicense",
                "tranRegions"
            ];
            widget.disableByFields(fields);
            //根据supplierState状态显示：1、申请中 2、同意 3、拒绝 
            var label = "";
            //若是已审核的分销商则应该是2，申请中则是1，默认为3
            if(widget.__data.customerState == 1){
                //显示同意和不同意像个按钮
                widget.showByFields(["beingPartnerButton_1","beingPartnerButton_2"]);
            }
            //若果是分销商
            if(widget.__data.isCustomer){
                //显示删除按钮
                widget.showByFields(["deletePartnerButton"]);
                widget.hideByFields(["beingPartnerButton_1","beingPartnerButton_2","deleteSupplyerButton"]);
            }
            //若果是供应商
            if((widget.__data.isSupplier == true)&&(widget.__data.isDelete !== true)){
                //显示删除供应商按钮
                widget.showByFields(["deleteSupplyerButton"]);
            }
            if(!widget.__data.isCustomer){
                widget.hideByFields(["shopLevel"]);
                widget.hideByFields(["inviter"]);
                //若不为分销商，隐藏保存按钮
                widget.hideByFields(["completePartnerButton"]);
            }else{
                widget.showByFields(["shopLevel"]);
                widget.showByFields(["inviter"]);
                widget.showByFields(["completePartnerButton"]);
                widget.enableByFields(["shopLevel","inviter"]);
            }
            var role = user.getCurrentUserRole();
            /*
            if((1==role||0==role)){
                widget.enableByFields(["inviter"]);
            }else{
                widget.disableByFields(["inviter"]);
            }*/
        },
        //  根据不同情况显示的不同按钮或内容
        shopStoreDataReady: function(widget){
            var data = widget.getData();
            widget.hideByFields(["getButton","cancelButton","applyButton"]);
			//注意：data是从平台加载的，而判断是否是供应商，应该从当前商家加载。
			this.loadById(data._id).then(function(shopData){
				if(shopData&&shopData.isSupplier){
					widget.showByFields(["cancelButton"]);
				}else if(shopData && shopData.supplierState == 1){
                    widget.showByFields(["applyButton"]);
                }else{
					widget.showByFields(["getButton"]);
				}
			});
        },
        //  summary：
        //      添加供应商
        //  view: 
        //      supplyBus
        addSupplyer: function(data,wiget){
            window.busy();
            this.addSupplyerAction(data._id).then(lang.hitch(this,function(data){
                window.free();
                if(data&&data.data&&data.data.ok == 1){
                    alert("添加成功");
                    wiget.cqRefresh();
                }//else if(data&&data.data&&data.data.item.isSupplier == true){
                    //alert("添加成功");
                  //  wiget.cqRefresh();
                //}
                else{
                    alert(data&&data.data&&data.data.message||"操作失败，请稍后再试！");
                }
            }));
        },
        //  summary：
        //      删除供应商
        //  view: 
        //      supplyBus
        deleteSupplyer: function(data,wiget){
            window.busy();
            this.deleteSupplyBus(data._id).then(lang.hitch(this,function(data){
                window.free();
                if(data&&data.data&&data.data.ok == 1){
                    alert("删除成功!");
                    wiget.cqRefresh();
                }else{
                    alert(data&&data.data&&data.data.message||"操作失败，请稍后再试！");
                    return;
                }
            }));
        },
        // summary:
        //      获取商家列表
        // view:
        //      supplyList
        getSupplyShopUrl: function(){
            return this.loadSupplyUrl();
        },
        // summary:
        //      处理点击事件（B2B供应商list）
        // view:
        //      supplyList
        onClickSupplyShop: function(data){
            window.moveToView("supplyBus",data._id);
        },
        /*
        // summary:
        //      加载我的伙伴
        // view:
        //      myPartnerList
        loadPartner: function(){
            this.loadPartnerList();
        },
        */
        //筛选条件
        getSupplyShopParam:function(params){
            //  从平台获取商家列表，因此把shopId设置成平台Id,
            //  _id存入当前店铺id,传给后台为了将返回的结果中的当前店铺剔除
            var query = {shopId:config.getPlatformShopId(),isVerified:true,shopType:4,_id:this.getShopId()};
            if(params.district){
                if(params.district.province){
                    query.provinceId = params.district.province._id;
                }
                if(params.district.city){
                    query.cityId = params.district.city._id;
                }
                if(params.district.county){
                    query.countId = params.district.county._id;
                }
            }
            if(params.search){
                query.search = params.search;
            }
            return query;
        },
        // summary:
        //      查看认证布局
        // view:
        //      supplyBusDetail
        // 注： 包含了运营商、服务商、服务站、服务中心所有字段（驳回原因，认证通过等字段不会出现）
        //      根据不同条件显示不同内容
        getVerfyLayout: function(){
            return [{
                type:"form",
                fields:this.getFormItems([
                    "logo","contactName","contactPhone","stationType",
                    "companyName","orgCode","businessLicense",
                    "lon,lat","provinceId,cityId,countId,town",
                    "address","brief","tranRegions",
					"services","opTranRegions"
                ],true)
            }]
        },
        // summary:
        //      每次进入页面都要执行的方法
        // view:
        //      supplyBusDetail
        getVerfyLayoutReload: function(widget){
            widget.disableByFields([
                "logo","contactName","contactPhone","stationType",
                "companyName","orgCode","businessLicense",
                "lon,lat","provinceId,cityId,countId,town",
                "address","brief","tranRegions",
                "services","opTranRegions"
            ]);
            var data = widget.getData();
            //运营商显示
            if(data.shopType == 5){
                widget.showByFields(["opTranRegions"]);
                widget.hideByFields(["tranRegions","services","stationType"]);
            }
            //服务商显示
            else if(data.shopType == 4){
                widget.hideByFields(["opTranRegions","stationType"]);
                widget.showByFields(["tranRegions","services"]);
            }
            //服务中心
            else if(data.shopType == 3){
                widget.showByFields(["stationType"]);
                widget.hideByFields(["tranRegions","services","opTranRegions"]);
            }
            //服务站显示
            else if(data.shopType == 2){
                widget.showByFields(["stationType"]);
                widget.hideByFields(["tranRegions","services","opTranRegions"]);
            }
            //普通商家显示
            //  注：暂时包含了（9999这类型商家）
            else{
                widget.hideByFields(["stationType","tranRegions","services","opTranRegions"]);
            }
        },
        // 查看服务商信息 2017-4-21 刘轩
        showVerifiedInfo: function(data, widget){
            window.moveToView("supplyBusDetail", data._id);
        }
    });
    
    var shopB2BBo = new ShopB2BBo();
    shopB2BBo.Bo = ShopB2BBo;
    return shopB2BBo;
});