define([
	"dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    '../BoBase',
    "cq/util/config/config",
    "./shopBalanceDeposit",
	"./shop"
], function(declare,lang,Deferred,BoBase,config, shopBalanceDeposit,shop) {
    var ShopBalanceDepBo = declare("",shop.Bo,{
        modalName : "ts/pm/shopPayLog",
        fields:{
            amount:{
                type:"text",
                label:"提现金额",
                canEdit : false
            },
            isVerified:{
                type:"text",
                label:"审核状态",
                canEdit : false
            },
            createAt:{
                type:"dateTime",
                label:"提交日期",
                canEdit : false,
                qry:{
                    canEdit:true,
                    type:"date",
                    label:"日期"
                }
            },
            receiveDate:{
                type:"dateTime",
                label:"审核日期",
                canEdit : false
            }
        },
        getListUrl:function(){
            return this.getBaseUrl()+"/loadByType?shopId="+this.getShopId();
        },
        // 加载列表的条件
        getListParam: function(params){
            var query = {ioType:1,isVerified: false};
            //var queryValue = cqQuery.getQueryValue(params.state);
            //if(queryValue){
            //    query.ioType = queryValue;
            //}
            if(params&&params.state&&params.state.isVerified){
                query.isVerified = params.state.isVerified;
            }
            if(params.query){
                if(params.query.createAtf){
                    query.createAtf = params.query.createAtf;
                }
                if(params.query.createAtt){
                    query.createAtt = params.query.createAtt;
                }
            }
            return query;
        },
        getisVerified:function(state){
            var str = "";
            str = (state == 1)?"未审核":"已审核";
            return str;
        },
        getListProp:function(data){
            data.isVerified = data.isVerified?"已审核":"未审核";
            //data.receiveDate = data.receiveDate?date.formatISODateMinutes(data.receiveDate):"";
            //data.createAt = date.formatISODateMinutes(data.createAt);
            return data;
        },
        exportLayout:function(){
            return this.getFormItems(["amount","isVerified","createAt","receiveDate"]);
        },
        getQueryLayout:function(){
            return [{
                type: 'form',
                fields: this.getFormItems(['createAt'], true,"qry")
            }];
        },
        initData: function(data){
            return {
                createAt: (new Date()).toISOString()
            };
        },
    });
	var shopBalanceDepBo = new ShopBalanceDepBo();
	shopBalanceDepBo.Bo = ShopBalanceDepBo;
    return shopBalanceDepBo;
});
