//  创建人：周超
//  创建时间：2017-1-4
//  创建内容：（商家收索页面）
define([
	"dojo/_base/declare",
	"dojo/_base/lang",
    "dojo/Deferred",
    "cq/util/config/config",
    "cq/util/sys/geo",
    "cq/util/edit/position",
    "cq/util/image/qrCode",
    "../user/shopStore",
    "../user/consumer",
    "./_ShopMixin",
	"../BoBase",
	'cq/util/sys/query'
], function(declare,lang,Deferred,config,geo,position,qrCode,shopStore,consumer,_ShopMixin,BoBase, query) {
    var ShopCBo = declare("",[BoBase.C,_ShopMixin],{
        modalName : "shop/shop",
        // 可处理的字段
        fields:{
            fansNum:{
                type:"text",
                label:"粉丝数",
                className:"middle-width"
            },
            _id:{
                type:"text",
                label:"ID"
            },
            shopBackground:{
                type:"text"
            },
            distance: {
                type: "text",
                label: "距离"
            },
            showVerifiedInfo:{
                type:"button",
                label:"商家简介",
                action:"showVerifiedInfo"
            },
            
            contactSeller: {
                type:"button",
                label:"联系卖家",
                action:"contactSeller"
            },
            share: {
				type: 'button',
				label: '分享',
				action: 'share'
			},
            getShopBackground: {
                type: "button",
                action: "getShopBackground"
            },
            getBigLogo:{
                type: "button"
            },
            getBigBusinessLicense:{
                type: "button"
            },
            getDiscount: {
				type: 'button',
				label: "领券",
				action: "getDiscount"
			},
            authenticated:{
                type:'button',
                label:"已认证",
                action:"authenticated"
            }
        },
        getBigLogo : function(data){
            if(data._id){
                require(["cq/widgets/bigImg"],lang.hitch(this,function(bugImg){
                    bugImg.show(data.logo);
                }));
            }
        },
        getBigBusinessLicense : function(data){
            if(data._id){
                require(["cq/widgets/bigImg"],lang.hitch(this,function(bugImg){
                    bugImg.show(data.businessLicense);
                }));
            }
        },
        getShopBackground: function(){
            // 获取店铺背景图空函数
        },
        showVerifiedInfo: function(data, widget){
            window.moveToView("shopCDetail", data._id);
        },
        contactSeller: function(data, widget){
            require(["bob/im/msgP/c"],function(msgP){
                msgP.toShopSvc(data._id);
            });
        },
        loadShopFromPlt: function(params){
            return params.cqViewParam&&params.cqViewParam.params&&this.loadByIdFromPlt(params.cqViewParam.params)||{};
        },
        loadByIdFromPlt: function(shopId){
            return this.exec("loadById", {
                fromShopId: config.getPlatformShopId(),
                _id: shopId
            }).then(lang.hitch(this, function(result){
                //return result.data.item;
                //return shopStore.hasCollectedByShopId(shopId).then(lang.hitch(this, function(state){
                var item = result&&result.data&&result.data.item||{};
                //item.hasCollected = state;
                item.fansNum = item.fansNum||0;
                item.logo =item.logo||config.defultShopLogo;
                return item;
                //}));
            }));
        },
        //店铺认证布局
        getVerfyLayout: function(){
            return [{
                type:"form",
                fields:this.getFormItems([
                    "logo","shopName","legalPerson","businessLicense",
                    "contactName","contactPhone",
                    "address"
                ],true)
            }];
        },
        //设置编辑状态
        getVerfyLayoutReload: function(widget){
            widget.disableByFields([
                "logo","shopName","legalPerson","businessLicense",
                "contactName","contactPhone",
                "address"
            ]);
        },
        //  点击位置，跳转至地图
        getLocationView:function(data,viewNode){
            if(!this.view){
                var view = viewNode.getParent();
                while(view){
                    if(!view.show){
                        view = view.getParent();
                    }else{
                        break;
                    }
                }
                this.view = view;
            }
            var lonpic,latpic;
            lonpic = data.lon;
            latpic = data.lat;
            //alert("你跳啊，条给朕看一看")
            position.startEdit({
                lon:lonpic,
                lat:latpic
            }||null,this.view||viewNode, false);
            position.setEnable(false);
        },
        loadById: function(params){
            if(!(params&&params.cqViewParam&&params.cqViewParam.params)){
                return;
            }
            return this.exec("loadById",{
                _id: params.cqViewParam.params,
                fromShopId: params.cqViewParam.params
            }).then(lang.hitch(this, function(result){
                return shopStore.hasCollectedByShopId(params.cqViewParam.params).then(lang.hitch(this, function(state){
                    var item = result&&result.data&&result.data.item||{};
                    item.hasCollected = state;
                    item.fansNum = item.fansNum||0;
                    item.logo =item.logo||config.defultShopLogo;
                    item.shopBackground = item.shopBackground||"./images/temp/shop-banner.jpg";
                    return item;
                }));
            })).then(lang.hitch(this,function(data){
                var shopId = this.getShopId();
                require([
                    "dojo/topic",
                    "cq/util/share/share"
                ],function(topic,share){
                    topic.publish("/cq/util/sys/share/infoChanged",{
            			title: data.shopName,
            			thumb: data.logo || "",
                        url:share.getPageLoc(shopId,"#businessDetails-" + data._id)
                    });
                });
                return data;
            }));
        },
        get: function(data, widget){
            window.busy();
            shopStore.collectShop(data._id).then(lang.hitch(this, function(result){
                window.free();
                if(result&&result.data&&result.data.ok==1){
                    alert("关注成功");
                    widget.cqRefresh();
                }else{
                    alert(result&&result.data&&result.data.message||"关注失败");
                }
            }));
        },
        cancel: function(data, widget){
            window.busy();
            shopStore.cancelCollectShop(data._id).then(lang.hitch(this, function(result){
                window.free();
                if(result&&result.data&&result.data.ok==1){
                    alert("取消关注成功");
                    widget.cqRefresh();
                }else{
                    alert(result&&result.data&&result.data.message||"取消关注失败");
                }
            }));
        },
        // 领取优惠劵
		getDiscount: function (params) {
			require([
                "bob/mk/discount/c",
                "cq/util/edit/overlay",
                "cq/widgets/item/mat/GetDiscoutList"
            ], lang.hitch(this, function (discount, overlay, GetDiscountList) {
				// 获取商家的数据
				var fromShopId = params._id;
				discount.loadByShop(fromShopId).then(lang.hitch(this, function (items) {
					if (!items.length || items.length === 0) {
						alert("没有可以领取的优惠劵");
					} else {
						// 创建overLay
						if (!this.getDiscoutListElement) {
							this.getDiscoutListElement = new GetDiscountList();
						}
						var data = {};
						data.items = items;
						data.fromShopId = fromShopId;
						this.getDiscoutListElement.init(data).then(function () {
							overlay.hide();
						});
						overlay.showElement(this.getDiscoutListElement.domNode);
					}
				}));
			}));
		},
        getStateItemProps: function(data,itemType,list){
            //根据参数设置Item的选中状态
            data.selected = data._id==1;
            return data;
        },
        onDataReadyForShop: function(widget){
            widget.hideByFields(["cancel", "get","authenticated"]);
            var data = widget.getData();
            if(data.shopName){
                var view = widget.getView();
                view.changeTitle(data.shopName);
            }
            if(data.hasCollected){
                widget.showByFields(["cancel"]);
            }else{
                widget.showByFields(["get"]);
            }
            if(data.isVerified==true){
                widget.showByFields(["authenticated"]);
            }
        },
        share: function (data, widget) {
            //         点击后分享给其他人
            // view:
            require(["cq/util/share/share"], lang.hitch(this, function(share){
                var options = [{
            		"weixin": {
            			title: data.shopName,
            			thumb: data.logo || "",
            			url:share.getPageLoc(this.getShopId(),"#businessDetails-" + data._id)
            		}
            	}, {
            		"friendCircle": {
            			title: data.shopName,
            			thumb: data.logo || "",
            			url:share.getPageLoc(this.getShopId(),"#businessDetails-" + data._id)
            		}
            	}, {
            		"copy": {
            			url: share.getPageLoc(this.getShopId(),"#businessDetails-" + data._id)
            		}
            	}];
                share.showShare(options);
            }));
		},
        loadImgForCode: function(data1,data2){
            var a;
            var b = data1;
        },
        getRecommendListUrl: function(){
            return this.getBaseUrl()+"/loadShops?shopId="+this.getShopId()+"&isRecommend=true&isDetete=false&isVerified=true&orderBy=-recommendTime";
        },
        getPlaShopListUrl: function(){
            return this.getBaseUrl()+"/loadShops?shopId="+this.getShopId()+"&fromShopId="+config.getPlatformShopId();
        },
        getOpShopListUrl: function(){
            return this.getBaseUrl()+"/loadOpShop?shopId="+this.getShopId();
        },
        //记载所有运营中心的所有商家
        getOpPlaShopListUrl:function(){
            return this.getBaseUrl()+"/loadOpShops?fromShopId="+config.getPlatformShopId();
        },
        //2017/6/12 徐阿雪 运营中心加载服务中心
        getScShops:function(){
            return this.getBaseUrl()+"/getScShops?shopId="+config.getPlatformShopId();
        },
        getOpScListParamForShop:function(params){
            var query = {};
            //当前商家的id
            query.fromShopId =params.cqViewParam.params||this.getShopId();
            return query;
        },
        getSevShops: function(){
            return this.getBaseUrl()+"/loadShops?shopId="+this.getShopId()+"&isDelete=false&shopType=3";
        },
        //服务中心获取下级村
        getScTowns:function(){
            return this.getBaseUrl()+"/getScTownS?shopId="+config.getPlatformShopId();
        },
		// 加载当前URL参数中指定的店铺
        getShopUrlParam: function(parm){
            var query = {};
            //搜索框
            if(parm.cqViewParam.params){
                query.targetShopId = parm.cqViewParam.params;
            }
            return query;
        },
        //处理列表数据(主要是显示距离这个字段)
        getSearchShops: function(data){
            //  定死地址(当前店铺地址)
            var position = geo.getCoordinate();
            if(position){
                var lat1 = position.lon;
                var lng1 = position.lat;
                //  获取目标商家地址坐标
                var lat2,lng2,distance;
                lng2 = data.lon;
                lat2 = data.lat;
                distance = geo.getDistance(lat1,lng1,lat2,lng2);
                data.distance = distance;
            }else{
                data.distance = "无法获取当前店铺地址";
            }
            return data;
        },
        //点击跳转
        onListClick: function(data){
            window.moveToView("businessDetails",data._id);
        },
        onListClickForOpShop: function(data){
            if(data&&data._id){
                window.moveToView("opShopDetail",data._id);
            }
        },
		// 消费者查看店铺详情时，处理收藏和取消收藏
		onDetailClick:function(data,action,widget){
			shopStore[action](data,widget);
		},
        getOpSearchListQuery:function(params){
            var query = {shopId: params.cqViewParam.params}
            return query;
        },
        //搜索条件
        getSearchListQuery:function(params){
            var query = {
            	//isVerified: true,
            	shopType: 1,
                orderBy: "-isVerified",
                isDelete: false
            };
            if(params.filter){
                for(var i in params.filter){
                    query[i] = JSON.stringify(params.filter[i]);
                }
                query.isVerified = true;
            }
            // lon,lat 是当前店铺的坐标
            var position = geo.getCoordinate();
            if (position) {
            	query.orderBy = "-isVerified,distance";
            	query.lon = position.lon;
            	query.lat = position.lat;
            } else {
            	delete query.lon;
            	delete query.lat;
            }
            if (params.search) {
            	query.search = params.search;
            }
            return query;
        },
        __shop:window.g_sys_info,
        loadMe: function(){
            return this.exec("loadById", {
                _id: this.getShopId()
            }).then(lang.hitch(this, function(result){
                var item = result&&result.data&&result.data.item||{};
                item.pendingAmount = -1*item.pendingAmount;
                item.logo = item.logo||"./images/temp/dftLogo.png";
                this.__shop = item;
                return item;
            }));
        },
        //我的小芳点击跳转平台客服参数的获取
        loadShopByPlatform:function(id,shopId){
            return  this.exec('loadById',{
                '_id':id
            });
        },
		// 按照店铺搜索的url
		getListUrlWithMats: function(){
			return this.getBaseUrl()+"/loadShopsWithMats?shopId="+this.getShopId()+"&pageSize=10";
		},
		getListParamWithMats: function(cqRefInfo){
            //按照村查找商品的query 条件
            //默认按照saleAmount倒叙
			var params = {};
			var value = query.getQueryValue(cqRefInfo.search);
            if (value) {
                // 设置的查询编码转回
                params.search = window.decodeURIComponent(value);
            }
            if (cqRefInfo.verifyState && cqRefInfo.verifyState.orderBy) {
                params.orderBy = cqRefInfo.verifyState.orderBy;
            }
			if(cqRefInfo.filter){
                for(var i in cqRefInfo.filter){
                    params[i] = JSON.stringify(cqRefInfo.filter[i]);
                }
            }
			return params;
		},
        getListParamForOpShop: function(cqRefInfo){
            var params = {
                isDelete: false,
				orderBy:"code",
                shopType: 5
            };
            return params;
        },
        getItemProp: function(item){
            item.groupName = item.shopName||"";
            return item;
        }
    });
	
	var shopCBo = new ShopCBo();
	shopCBo.Bo = ShopCBo;
    return shopCBo;
});