﻿define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"../BoBase"
], function(declare,lang,BoBase) {
    var ShopMsgBo = declare("",BoBase.B,{
        modalName : "shop/shopMsg",
        fields:{
			"fromShopId.logo" :{
                type:"text",
                label:"商家图标",
                className:"large-high"
            },
			"fromShopId.shopName" : {
                type:"text",
                label:"商家名称",
                className:"large-high"				
			},
			msgContent: {
                type:"text",
                label:"消息内容",
                className:"large-high"				
			},
            readDetail : {
                type:"text",
                label:"是否已读",
                formatter:function(action,data){
                    var read = "";
                    if(data.isRead){
                        read = '<div class="button-area">'+'店铺名称 : '+data.fromShopId.shopName+'<div class="button">已读</div></div>';
                    }else{
                        read = '<div class="button-area">'+'店铺名称 : '+data.fromShopId.shopName+'<div class="button" cq-action="readDeal">标记已读</div></div>'
                    }
                    return read;
                }
            }			
		},
		getShopMsgListUrl : function(){
			return this.getBaseUrl()+"/load?shopId="+this.getShopId();
		},
		getShopMsgListQuery:function(params){
            var query = {};
            if(params.search){
                query.search = params.search;
            }
            if(params.state&&params.state._id){
                // 上游
                if(1 == params.state._id){
                    query.msgType = 1;
                }else if(2 == params.state._id){
                    //	下游
					query.msgType = 2;
                }else{
                    delete query.msgType;
                }
            }
            return query;
        },
		onShopMsgListClick : function(params,node,list){
            if(node == "readDeal"){
                return this.readDeal(params,list);
            }
            if(params.toView){
				window.moveToView(params.toView,params.toParam);
			}
		},
        readDeal : function(params,list){
            if(params.isRead){
                alert("该信息已读！");
            }
            var domNode = window.event.target;
            return this.exec("save",{_id:params._id,isRead:true}).then(lang.hitch(this,function(data){
                if(data&&data.data&&data.data.item&&data.data.item.isRead == true){
                    alert("标记成功！");
                    domNode.innerHTML = "已读";
                    //list.cqRefresh();
                }
            }));
        }
    });
	var shopMsgBo = new ShopMsgBo();
	shopMsgBo.Bo = ShopMsgBo;
    lang.setObject("bob.shop.shopMsg", shopMsgBo);
    return shopMsgBo;
});
