﻿define([
    "dojo/_base/declare"
], function (declare) {
    return declare("",null,{
        modalName:"shop/store",
        fields:{
            name: {
                type : 'text',
                label : '名称',
                placeHolder : '必填',
                notNull: true
            },
            tel: {
                type: "text",
                label: "联系电话",
                placeHolder: "必填",
                notNull: true
            },
            "lon,lat":{
                type:"location",
                label:"地理位置",
                //用于联动区划，传入省市区ID字段名，不联动则传入空字符串
                distFields:"provinceId,cityId,countId",
                //区域划分地址字段名(显示字段名)
                distFieldsStr:"locationName",
                //详细地址
                detailAddrField:"addr",
                notNull:true
            },
            "provinceId,cityId,countId,locationName" : {
                type : "district",
                label : "省/市/区(县)",
                canEdit : true,
                placeHolder:"请选择"
            },
            addr: {
                type: "textarea",
                label: "详细地址",
                placeHolder: "必填",
                notNull: true
            },
            images: {
                type: 'images',
                label: '图片',
                sizeType: 'cut',
                size: {
                    width: 640,
                    height: 640
                },
                notNull: true
            },
            remark: {
                type: "textarea",
                label: "备注"
            },
            isStore: {
                type: "checkbox",
                label: "同时作为门店接待"
            }
        },
        getListUrl: function(){
            return this.getBaseUrl()+"/load"
        }
    });
});
