﻿// 订单系统商家端
define([
    "dojo/_base/declare",
    '../../BoBase',
    "./_Mixin"
], function (declare,BoBase,_Mixin) {
    var O = declare("", [BoBase.B, _Mixin], {
        fields: {
            save: {
                type: "button",
                action: "save",
                label: "保存"
            },
            deleteById: {
                type: "button",
                action: "deleteById"
            },
            lon: {
                type: "number",
                label: "地理位置",
                notNull: true
            },
            locationName: {
                type: "text",
                label: "省/市/区(县)",
                notNull: true
            }
        },
        save: function(data){
            var msg = this.getDataValidMsg(data,["images","name","tel","addr","lon","locationName"]);
            if(msg){
                alert(msg);
                return;
            }
            if(data.images&&data.images.length){
                data.logo = data.images[0];
            }
            this.exec("save", data).then(function(result){
                if(result&&result.data&&result.data.ok==1){
                    alert("保存成功");
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"保存失败");
                }
            });
        },
        loadStoreById: function(params){
            var params = params&&params.cqViewParam&&params.cqViewParam.params||"";
            if(params){
                return this.exec("loadById",{
                    _id: params
                }).then(function(result){
                    return result&&result.data&&result.data.item||{};
                });
            }else{
                return {
                    isStore: true,
                    isSelfFetch: false
                };
            }
        },
        loadSelfFetchById: function(params){
            var params = params&&params.cqViewParam&&params.cqViewParam.params||"";
            if(params){
                return this.exec("loadById",{
                    _id: params
                }).then(function(result){
                    return result&&result.data&&result.data.item||{};
                });
            }else{
                return {
                    isStore: false,
                    isSelfFetch: true
                };
            }
        },
        onDataReady: function(widget){
            var data = widget.getData();
            widget.hideByFields(["deleteById"]);
            if(!data._id){
                return;
            }
            widget.showByFields(["deleteById"]);
        },
        deleteById: function(data){
            this.exec("deleteById", {
                _id: data._id
            }).then(function(result){
                if(result&&result.data&&result.data.ok==1){
                    alert("删除成功");
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"删除失败");
                }
            });
        },
        getStoreEditLayout: function(){
            return [{
                type: 'form',
                fields: this.getFormItems(["images",'name',"tel","lon,lat","provinceId,cityId,countId,locationName","addr","remark","deleteById","save"], true)
            }];
        },
        getSelfFetchEditLayout: function(){
            return [{
                type: 'form',
                fields: this.getFormItems(["images",'name',"tel","lon,lat","provinceId,cityId,countId,locationName","addr","remark","isStore","deleteById","save"], true)
            }];
        },
        getStoreListParam: function(params){
            var query = {
                shopId: this.getShopId(),
                isStore: true
            };
            if(params.search){
                query.search = params.search;
            }
            return query;
        },
        getSelfFetchListParam: function(params){
            var query = {
                shopId: this.getShopId(),
                isSelfFetch: true
            };
            if(params.search){
                query.search = params.search;
            }
            return query;
        },
        onStoreListClick: function(data){
            window.moveToView("storeEdit", data._id);
        },
        onSelfFetchListClick: function(data){
            window.moveToView("selfFetchEdit", data._id);
        }
    });
    var o = new O();
    o.Bo = O;
    return o;
});