/******************************************************
 *  创建人: 杜飞军
 *  创建时间: 2016/12/13
 *  创建内容
 *  		提供商品收藏功能 处理上架、下架和检查是否已经收藏
 ********************************************************/
define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojo/topic",
	"../../BoBase",
	"bob/user/userBase"
], function (declare, lang, topic, BoBase, userBase) {
	var matStoreBo = new BoBase({
		modalName: 'shop/cm/mat_store',
		// 可处理的字段
		fields: {
			logo: {
				type: 'text',
				label: '图标'
			},
			mName: {
				type: 'text',
				label: '商品名称',
				placeHolder: '必填'
			},
			"mId.mName": {
				type: 'text',
				label: '商品名称'
			},
			"mId.logo": {
				type: 'text',
				label: '商品图标'
			},
			"mId.retailPrice": {
				type: 'text',
				label: '商品价格'
			},
			"mId.totalSale": {
				type: 'text',
				label: '商品销量'
			}
		},
		// summary:
		//			查询当前userId关注了哪些商品
		// view:
		//			collectList
		// description:
		//
		load: function () {
			return this.exec("load", {
				userId: this.getShopId()
			});
		},
		// summary:
		//		关注商品
		// view:
		//		collectList,matDetail
		// description:
		//		也作为matDetail的接口使用
		// params
		// 		mId
		matStore: function (params) {
			return this.exec("mat_store", {
				shopId: this.getShopId(),
				mId: params.mId,
				userId: userBase.getCurrentUserId()
			});
		},
		// summary:
		//		取消关注
		// view:
		//		collectList,matDetail
		// description:
		//		也作为matDetail的接口使用
		// params
		// 		mId
		matStoreCancel: function (params) {
			return this.exec("mat_store_cancel", {
				shopId: this.getShopId(),
				mId: params.mId,
				userId: userBase.getCurrentUserId()
			});
		},
		// summary:
		//			检查商品是否已经被收藏
		// view:
		//			collectList,matDetail
		// description:
		//
		// params
		// 		mId
		checkMatStore: function (params) {
			return this.exec("check_mat_store", {
				shopId: this.getShopId(),
				mId: params.mId,
				userId: userBase.getCurrentUserId()
			});
		},
		// summary:
		//			获取当前用户关注的商家列表
		// view:
		//			collectList
		// description:
		//
		getListUrl: function () {
			return this.getBaseUrl() + "/load";
		},
		// summary:
		//			获得查询条件
		// view:
		//			collectList
		// description:
		//
		getListParam: function () {
			var params = {
				shopId: this.getShopId(),
				userId: userBase.getCurrentUserId(),
				orderBy: 'createAt'
			};
			return params;
		},
		// summary:
		//			列表点击事件处理
		// view:
		//			collectList
		// description:
		//
		onListClick: function (data, action, widget) {
			if (action === 'collect_cancel') {
				this.matStoreCancel({
					mId: data.mId._id
				}).then(function (matStoreData) {
					if (matStoreData && matStoreData.data && matStoreData.data.ok === 1) {
						// 刷新当前数据
						widget.cqRefresh();
					} else {
						alert('取消收藏失败');
					}
				});
			} else {
				window.moveToView('matDetail', data.mId._id);
			}
		}
	});
	return matStoreBo;
});