 //  创建人：周超
 //  创建时间: 2016/12/26
 //  创建内容：
 //  		店铺收藏功能1.店铺详情2.我收藏的店铺
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "../../BoBase",
    "../shop",
    "bob/user/consumer"
], function (declare, lang, topic, BoBase, shop, consumer) {
    var ShopStoreBo = declare("",BoBase.C/*shop.Bo*/,{
        fields:{},
        modalName: 'shop/cm/shop_store',
        //取消收藏方法
        cancelCollectShop: function(targetShopId){
            return this.exec("shopStoreCancel", {
                targetShopId: targetShopId,
                userId: consumer.getCurrentUserId()
            }).then(lang.hitch(this, function(result){
                return result;
            }));
        },
        // 收藏方法
        collectShop: function(targetShopId){
            return this.exec("shopStore", {
                targetShopId: targetShopId,
                userId: consumer.getCurrentUserId()
            }).then(lang.hitch(this, function(result){
                return result;
            }));
        },
        // 列表数据
        getItemPropForShopStore: function(data){
            data.shopName = data.targetShopId.shopName||"";
            data.logo = data.targetShopId.logo||"";
            return data;
        },
        // 加载指定店铺详情
        loadById: function(params){
            return shop.loadById(params);
        },
        // 我关注的店铺url获取
        getShopStoreUrl: function(){
            return this.getBaseUrl()+"/shopStoreLoad";
        },
        // 我关注的店铺筛选条件（列表）
        getShopStoreQuery: function(parm){
            var query = {};
            query.shopId = this.getShopId();
            query.userId = consumer.getCurrentUserId();
            //搜索框
            if(parm.cqViewParam.params){
                query.search = parm.search;
            }
            return query;
        },
        // 我收藏的商家（列表点击触发事件）
        shopStoreAction: function(data,node,list){
            var parms = {};
            parms.userId = consumer.getCurrentUserId();
            parms.shopId = this.getShopId();
            parms.targetShopId = data.targetShopId._id;
            if('cancel' == node){
                this.exec("shopStoreCancel",parms).then(lang.hitch(this,function(result){
                    if(result.data&&result.data.ok==1){
                        alert("取消收藏成功");
                        list.cqRefresh();
                    }else{
                        alert(result.message||"取消失败");
                    }
                }));
            }
        },
        // businessDetails布局中content中的取消收藏方法
        cancel: function(data,wiget){
            var targetShopId = data._id;
            this.cancelCollectShop(targetShopId).then(lang.hitch(this, function(result){
                if(result.data&&result.data.ok==1){
                    alert("取消收藏收藏成功");
                    wiget.cqRefresh();
                }else{
                    alert(result&&result.data&&result.data.message||"收藏失败");
                }
            }));
        },
        // businessDetails布局中content中的收藏店铺方法
        get: function(data,wiget){
            var targetShopId = data._id;
            this.collectShop(targetShopId).then(lang.hitch(this, function(result){
                if(result.data&&result.data.ok==1){
                    alert("收藏成功");
                    wiget.cqRefresh();
                }else{
                    alert(result&&result.data&&result.data.message||"收藏失败");
                }
            }));
        },
        // businessDetail layout布局reload方法
        shopStoreDataReady: function(wiget){
            var data = wiget.getData();
            wiget.hideByFields(["getButton","cancelButton"]);
            var parms = {};
            parms.userId = consumer.getCurrentUserId();
            parms.shopId = this.getShopId();
            parms.targetShopId = data._id;
            this.exec("isStoreShop",parms).then(lang.hitch(this,function(result){
                if(result.data&&result.data.item&&result.data.item.isStore==true){
                    wiget.showByFields(["cancelButton"]);
                }else{
                    wiget.showByFields(["getButton"]);
                }
            }));
        },
        // 刘轩 2016-12-30
        // 我已经收藏的店铺
        cachedShop: null,
        // 加载我已经收藏的数据
        cacheMyShops: function(){
            if(!this.cachedShop){
                this.cachedShop = {};
                return this.exec("shopStoreLoad",{
                    userId: consumer.getCurrentUserId()
                }).then(lang.hitch(this, function(result){
                    //return result;
                    var items = result&&result.data&&result.data.items||[];
                    for(var i=0;i<items.length;i++){
                        this.cachedShop[items[i].targetShopId._id] = 1;
                    }
                }));
            }else{
                return this.defTest({});
            }
        },
        hasCollected: function(targetShopId){
            return !!(this.cachedShop&&this.cachedShop[targetShopId]);
        }
    });
    var shopStoreBo = new ShopStoreBo();
    shopStoreBo.Bo = ShopStoreBo;
    lang.setObject("bob.shop.cm.shopStore", shopStoreBo);
    return shopStoreBo;
});