define([
	"dojo/_base/declare",
	"dojo/_base/lang",
    "bob/user/shopAdmin",
	"./shop"
], function(declare,lang,shopAdmin,shop) {
    var ShopBo = declare("",shop.Bo,{
        modalName : "shop/platformShop",
        // 可处理的字段
        fields:{
            bailAmount: {
                label : '保证金金额',
                type : 'text',
                field : '',
                placeHolder : "请输入保证金金额"
            }, 
            settlePeriod: {
                label : '结算周期',
                type : 'text',
                placeHolder : "请输入结算周期"
            },
            wxPayMchId: {
                label : '微信支付商家ID',
                type : 'text',
                placeHolder : "请输入微信支付商家ID"
            }, 
            wxPayCert: {
                label : '微信支付秘钥文件',
                type : 'text',
                placeHolder : "请输入微信支付秘钥文件"
            }, 
            wxPayPartnerKey: {
                label : '微信支付api密码',
                type : 'text',
                placeHolder : "请输入微信支付api密码"
            },
            aliPayAccount: {
                label : '支付宝商家名',
                type : 'text',
                placeHolder : "请输入支付宝商家名"
            }, 
            aliPayMchId: {
                label : '支付宝商家id',
                type : 'text',
                placeHolder : "请输入支付宝商家id"
            },
            aliPaySeller: {
                label : '支付宝账号',
                type : 'text',
                placeHolder : "请输入支付宝账号"
            }, 
            aliPayPartnerKey: {
                label : '支付宝支付api密码',
                type : 'text',
                placeHolder : "请输入支付宝支付api密码"
            },
            wxPayFeeRate: {
                label : '微信支付率',
                type : 'text',
                placeHolder : "请输入微信支付率"
            }, 
            aliWapFeeRate: {
                label : '支付宝手机支付费率',
                type : 'text',
                placeHolder : "请输入支付宝手机支付费率"
            }, 
            aliWebFeeRate: {
                label : '支付宝网页支付费率',
                    type : 'text',
                    placeHolder : "请输入支付宝网页支付费率"
            }, 
            aliAppFeeRate: {
                label : '支付宝APP支付费率',
                type : 'text',
                placeHolder : "请输入支付宝APP支付费率"
            }, 
            platformFeeRate: {
                label : '平台手续费费率',
                type : 'text',
                placeHolder : "请输入平台手续费费率"
            },
            bailFeedbackRate: {
                label : '担保支付平台补贴',
                type : 'text',
                placeHolder : "请输入担保支付平台补贴"
            }, 
            casheFeebackRate: {
                label : '货到付款补贴',
                type : 'text',
                placeHolder : "请输入货到付款补贴"
            }, 
            pointFeedbackRate: {
                label : '余额支付补贴',
                type : 'text',
                placeHolder : "请输入余额支付补贴"
            },
            automaticReceipt: {
                label : '是否自动签收',
                type : 'checkbox'
            },
            platformResponsible : {
                type:"ref",
                field:"platformResponsible",
                label:"平台责任人",
                searchField:"pName",
                labelFields:"pName",
                dataProvider:"bob/user/shopAdmin",
                targetMethod:"getStaffUrl",
                canEdit:true
            },
            dftOpShop: {
                type:"ref",
                label:"默认运营商",
                field:"dftOpShop",
                searchField:"shopName",
                labelFields:"shopName",
                dataProvider:"bob/shop/shop",
                targetMethod:"getDftOpShopUrl",
                canEdit:true
            },
            platformInfoSaveButton: {
                type: "button",
                label: "保存",
                action: "save"
            },
            isOpVerifySubmit:{
				type:"options",
                label:"运营商认证状态",
                options:{
                    "-1":"已驳回",
                    "0":"未提交",
                    "1" : "待认证",
                    "2" : "已认证"
                },
            },
            opListActions:{
				type:"text",
				label:"操作",
				formatter:function(action,data){
					var v = 
                        (data.isVerified == false?"<div class='button' cq-action='verify'>认证</div>":"")		
				},
				className:"large-width"
            },
            "opTranRegions" : {
                type:"objects",
                label:"运营地区",
                labelField:"remark",
                canEdit:true,
                canDelete:true,
                canAdd:true,
                canDnd:true,
                defaultData:{
                    cityId:null,
                    countyId:null,
                    provinceId:"57a936a0e026905d4c92f647",
                    remark:"重庆市"
                },
                fields:{
                    layout:[{
                        field:"provinceId,cityId,countyId,remark",
                        type:"district",
                        enableAll:true,
                        placeHolder:"请选择地址",
                        label:"区划"
                    }]
                },
                className: "large-width"
            }
		},
        // 平台设置Layout
        getEdtLayoutForSet: function(){
            return [{
                type: "form",
                fields: this.getFormItems([
                "bailAmount","settlePeriod","wxPayMchId",
                "wxPayCert","wxPayPartnerKey","aliPayAccount","aliPayMchId","aliPaySeller",
                "aliPayPartnerKey","wxPayFeeRate","aliWapFeeRate","aliWebFeeRate","aliAppFeeRate",
                "platformFeeRate","bailFeedbackRate","casheFeebackRate",
                "pointFeedbackRate","automaticReceipt","platformResponsible","dftOpShop","platformInfoSaveButton"
                ])
            }];
        },
        getEdtLayoutForOp : function(){
            // summary:
            //      运营商详情页面Layout
            // view:
            //      opMerDetail——运营商详情           
            if(!this.merchantDetailLayout){
                this.merchantDetailLayout = [{
                    type: "form",
                    fields: this.getFormItems([
                        "logo",
                        "contactName","contactPhone",
                        "companyName","legalPerson",
                        "legalPersonCode",
                        "legalImg1","legalImg2",
                        "businessLicense",
                        "orgCode",//组织机构代码
                        "lon,lat",
                        "address",
                        "provinceId,cityId,countId,town",
                        "brief",
                        "opTranRegions",
                        "backVerificationButton",
                        "noVerificationButton",
                        "verificationButton",
                        "deleteMerchantButton",
                        "recommendeMerchantButton",
                        "noRecommendeButton"
                    ])
                }];
            }
            return this.merchantDetailLayout;
        },
        onDataReadyForOp:function(widget){
            // summary:
            //      平台上运营商详情按钮处理
            // view:
            //      opMerDetail——运营商详情            
            var data = widget.getData();
            widget.hideByFields([
                "backVerificationButton",
                "noVerificationButton",
                "verificationButton",
                "deleteMerchantButton",
                "recommendeMerchantButton",
                "noRecommendeButton"
            ]);
            widget.disableByFields([
                "logo",
                "contactName","contactPhone",
                "companyName","legalPerson",
                "legalPersonCode",
                "legalImg1","legalImg2",
                "businessLicense",
                "orgCode",//组织机构代码
                "lon,lat",
                "address",
                "provinceId,cityId,countId,town",
                "brief",
                "opTranRegions"]);
            if(!data.isVerified&&data.isVerifySubmit==1){
                widget.showByFields(["backVerificationButton","verificationButton"]);
            }
            // 已认证 显示取消认证
            if(data.isVerified){
                widget.showByFields(["noVerificationButton"]);
            }                
        },
        doVerification : function(params){
            // summary:
            //      运营商通过认证
            // view:
            //      opMerDetail——运营商详情 
            var data = {
                targetShopId: params._id,
                shopId : this.getShopId()
            };
            this.exec("verifyOPAut", data).then(lang.hitch(this, function(result){
                if(result&&result.data&&result.data.ok==1){
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"操作失败");
                }
            }));
        },
        cancelVerification : function(params){
            // summary:
            //      取消认证运营商
            // view:
            //      opMerDetail——运营商详情
            var data = {
                targetShopId: params._id,
                shopId : this.getShopId()
            };
            this.exec("cancelOPAut", data).then(lang.hitch(this, function(result){
                if(result&&result.data&&result.data.ok==1){
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"操作失败");
                }
            }));            
        },
        backVerification : function(params){
            // summary:
            //      驳回认证运营商
            // view:
            //      opMerDetail——运营商详情
            var data = {
                targetShopId: params._id,
                shopId : this.getShopId()
            };
            // 输入驳回原因
            var backReason = prompt("驳回原因", "");
            if(!backReason){
                alert("请输入驳回原因");
                return;
            }
            data.rejectedReason = backReason;
            this.exec("rejectOPAut", data).then(lang.hitch(this, function(result){
                if(result&&result.data&&result.data.ok==1){
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"操作失败");
                }
            }));            
        }
    });
	var shopBo = new ShopBo();
	shopBo.Bo = ShopBo;
    lang.setObject("bob.shop.pltShop", shopBo);
    return shopBo;
});
