// 店铺公共基类
//		边界定义：
//   		1、提供平台会员自主创建店铺的能力
//			2、提供免注册直接创建店铺的能力
//			3、提供基础版本的店铺管理员维护店铺资料的能力
define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojo/topic",
    "dojo/DeferredList",
	"cq/util/config/config",
    "bob/user/userBase",
    "bob/article/section",
    "bob/article/autoReply",
    "bob/util/copyPlate",
	"../BoBase"
], function(declare,lang,topic,DeferredList,config,user,section,autoReply,copyPlate,BoBase) {
    var ShopBo = declare("",BoBase.B,{
        modalName : "shop/shop",
        // 可处理的字段
        fields:{
            // 支持的支付方式
            "payWeiXin":{
                type:"checkbox",
                label:"微信支付",
                className:"large-high",
                canEdit:"true"
            },
            "payAli":{
                type:"checkbox",
                label:"支付宝支付",
                className:"large-high",
                canEdit:"true"
            },
            "payDeposit":{
                type:"checkbox",
                label:"余额支付",
                className:"large-high",
                canEdit:"true"
            },
            "shopInfoButton":{
                type:"button",
                label:"完成",
                action:"save",
                className:"fullButton"
            },
            "collectButton":{
                type:"button",
                label:"收藏",
                action:"collectAction"
            },
            "cancelCollectButton":{
                type:"button",
                label:"收藏",
                action:"cancelCollectAction"
            },
            "orderCheckerId" : {
                type:"ref",
                field:"orderCheckerId",
                label:"新订单消息通知",
                searchField:"pName",
                labelFields:"pName",
                dataProvider:"bob/user/shopAdmin",
                targetMethod:"getStaffUrl",
                canEdit:true,
				className:"middle-width"
            },
            "svcId" : {
                type:"ref",
                field:"svcId",
                label:"新客服消息通知",
                searchField:"pName",
                //pageSize:5,
                labelFields:"pName",
                dataProvider:"bob/user/shopAdmin",
                targetMethod:"getStaffUrl",
                canEdit:true,
				className:"middle-width"
            },
            "orderTimeout":{
                type:"text",
                label:"自动关闭未付款订单",
                className:"large-high",
                placeHolder:"未填写"
            },
            "tranAddr":{
                type:"text",
                label:"发货地点",
                className:"large-width",
                placeHolder:"未填写"
            },
            "tranRegion" : {
                type : "link",
                label : "销售区域",
                rightText : "",
                canEdit : false,
                href : "section",
                notNull: true
            },
            "tranRegions":{
                type:"objects",
                label:"销售区域",
                labelField:"remark",
                canEdit:true,
                canDelete:true,
                canAdd:true,
                canDnd:true,
                fields:{
                    layout:[{
                        field:"provinceId,cityId,countyId,remark",
                        type:"district",
						enableAll:true,
                        placeHolder:"请选择地址",
                        label:"区划"
                    }]
                },
                notNull: true
            },
            "freightTemplated":{
                type:"checkbox",
                label:"启用运费模板",
                className:"large-high",
                canEdit:"true"
            },
            // 微信相关配置
            "wxLogo":{
                type:"image",
                label:"公众号二维码",
                className:"large-high"
            },
            "wxAppId":{
                type:"text",
                label:"微信APPID",
                className:"middle-width",
                placeHolder:"未填写"
            },
            "wxAppSec":{
                type:"text",
                label:"微信APPSEC",
                className:"middle-width",
                placeHolder:"未填写"
            },
            "wxUrl":{
                type:"text",
                label:"微信配置Url",
                className:"middle-width",
                placeHolder:"未配置"
            },
            "wxCqToken":{
                type:"text",
                label:"微信Token",
                className:"middle-width",
                placeHolder:"未填写"
            },
            "wxHash":{
                type:"text",
                label:"微信wxAesk",
                className:"middle-width",
                placeHolder:"未填写"
            },
            "wxMsgTemplate":{
                type:"text",
                label:"订单状态模板",
                className:"middle-width",
                placeHolder:"未填写"
            },
            "wxVerification":{
                type:"checkbox",
                label:"微信认证",
                className:"middle-width"
            },
            "wxAutoLogin":{
                type:"checkbox",
                label:"快速登录",
                className:"middle-width"
            },
            "isSectionData" : {
                type : "link",
                label : "微信栏目",
                rightText : "未设置",
                canEdit : false,
                href : "#section"
            },
            "isAutoReplyData":{
                type : "link",
                label : "自动回复",
                rightText : "未设置",
                canEdit : false,
                href : "#autoReply"
            },
            "shopWeiXinSave":{
                type:"button",
                label:"完成",
                action:"save",
                className:"fullButton"
            },
            "shopWeiXinUrl":{
                type:"button",
                label:"",
                action:"cutUrlAction",
                className:"fullButton"
            },
            "shopWeiXinToken":{
                type:"button",
                label:"",
                action:"cutTokenAction",
                className:"fullButton"
            },
            "brief": {
                type:"textarea",
                label:"店铺简介",
                className:"large-width",
                placeHolder:"请填写简介",
                notNull: true
            },
            "svcPhone":{
                type:"text",
                label:"客服电话",
                className:"middle-width",
                placeHolder:"请填写客服电话"
            },
            "svcWx":{
                type:"text",
                label:"客服微信",
                className:"middle-width",
                placeHolder:"请填写客服微信"
            },
            "svcQQ":{
                type:"text",
                label:"客服QQ",
                className:"middle-width",
                placeHolder:"请填写客服QQ"
            },
            logo:{
                type:"image",
                label:"公司LOGO",
                className:"large-high",
                sizeType: 'cut',
				size: {
					width: 256,
					height: 256
				},
                notNull: true
            },
            companyName:{
                type:"text",
                label:"经营主体",
                className:"large-width",
                placeHolder:"请输入经营主体名称",
                notNull: true
            },
            shopName:{
                type:"text",
                label:"店铺名称",
                className:"middle-width"
            },
            "lon,lat":{
                type:"location",
                label:"地理位置",
                //用于联动区划，传入省市区ID字段名，不联动则传入空字符串
                distFields:"provinceId,cityId,countId",
                //区域划分地址字段名(显示字段名)
                distFieldsStr:"town",
                //详细地址
                detailAddrField:"address",
                className: "lon-lat-high",
                notNull:true
            },
            legalPerson:{
                type:"text",
                label:"法人姓名",
                className:"middle-width",
                placeHolder:"请输入法人姓名",
                notNull: true
            },
            legalPersonCode: {
                type: "text",
                label: "法人身份证号",
                placeHolder:"请与身份证保持一致",
                className: "middle-width",
                notNull: true
            },
            legalImg1:{
                type:"image",
                label:"法人身份证正面",
                className:"large-high",
                notNull: true
            },
            legalImg2:{
                type:"image",
                label:"法人身份证反面",
                className:"large-high",
                notNull: true
            },
            businessLicense:{
                type:"image",
                label:"营业执照",
                className:"large-high",
                notNull: true
            },
            contactName:{
                type:"text",
                label:"联系人",
                className:"middle-width",
                placeHolder:"请输入联系名称",
                notNull: true
            },
            contactPhone:{
                type:"text",
                label:"联系电话",
                className:"middle-width",
                placeHolder:"请输入电话号码",
                notNull: true
            },
            contactWx:{
                type:"text",
                label:"店主微信",
                className:"middle-width",
                placeHolder:"请输入微信号码"
            },
            contactQQ:{
                type:"text",
                label:"店主QQ",
                className:"middle-width",
                placeHolder:"请输入店主QQ"
            },
            aliPaySeller:{
                type:"text",
                label:"支付宝账号",
                className:"middle-width",
                placeHolder:"请输入支付宝账号"
            },
            bankName:{
                type:"text",
                label:"开户行",
                className:"middle-width",
                placeHolder:"请输入开户银行"
            },
            bankAccountName:{
                type:"text",
                label:"账户名",
                className:"middle-width",
                placeHolder:"请输入账户名"
            },
            bankAccountCode:{
                type:"text",
                label:"账号",
                className:"middle-width",
                placeHolder:"请输入账号"
            },
            payee:{
                type:"text",
                label:"收款人",
                className:"middle-width",
                placeHolder:"请输入收款人"
            },
            fiName:{
                type:"text",
                label:"财务联系人姓名",
                className:"middle-width",
                placeHolder:"请输入财务联系人姓名"
            },
            fiPhone:{
                type:"text",
                label:"财务联系人电话",
                className:"middle-width",
                placeHolder:"请输入财务联系人电话"
            },
            fiQQ:{
                type:"text",
                label:"财务联系人QQ",
                className:"middle-width",
                placeHolder:"请输入财务联系人QQ"
            },
            rejectedReason: {
                type: "text",
                canEdit:false,
                label: "驳回原因",
                className:"large-width"
            },
            orgCode: {
                type: "text",
                label: "组织机构代码",
                placeHolder:"请输入组织机构代码",
                className:"large-width"
            },
            
            //区划编辑,省、市、县、地址文本
            "provinceId,cityId,countId,town" : {
                type : "district",
                label : "省-市-区县",
                canEdit : true,
                className:"large-width province-high",
                placeHolder:"请选择"
            },
            town: {
                type: "text",
                label: "省-市-区县",
				className:"middle-width"
            },
            address: {
                type: "text",
                label: "详细地址",
				className:"middle-width",
                placeHolder:"未填写"
            },
            operateButton:{
                type:"text",
				label:"操作",
				formatter:function(action,data){
					var v = "<div class='button' onclick='window.moveToView(\"merchantDetail\",\""+data._id+"\");'>详情</div>";
					return v;
				}
            },
            //店铺基本信息保存
            baseSaveButton:{
                type:"button",
                label:"保存",
                action:"save",
                className:"fullButton"
            },
            backVerificationButton:{
                type:"button",
                label:"驳回认证",
                action:"backVerification",
                buttonClass:"margin10"
            },
            noVerificationButton:{
                type:"button",
                label:"取消认证",
                action:"cancelVerification",
                buttonClass:"margin10"
            },
            deleteMerchantButton:{
                type:"button",
                label:"删除商家",
                action:"deleteMerchan",
                buttonClass:"margin10"
            },
            recommendeMerchantButton:{
                type:"button",
                label:"推荐商家",
                action:"recommendeMerchant",
                buttonClass:"margin10"
            },
            noRecommendeButton:{
                type:"button",
                label:"撤销推荐",
                action:"cancelRecommende",
                buttonClass:"margin10"
            },
            verificationButton:{
                type:"button",
                label:"标记认证",
                action:"doVerification",
                buttonClass:"margin10"
            },
            shopType: {
                type: "options",
                label: "服务站类型",
                options : {
                    1:"一般商家",
                    2:"服务站",
                    3:"服务中心",
                    4:"服务商",
                    5:"运营商",
                    6:"平台商",
                    7:"政府",
                    9999:"其它"
                } 
            },
            lon: {
                type: "text",
                label: "地理位置"
            },
            lat: {
                type: "text",
                label: "地理位置"
            },
            isVerified:{
                type:"options",
                label:"是否认证",
                options:{
                    "true":"已认证",
                    "false":"待认证"
                },
            }
		},
        //  summary：
        //      保存指定店铺店铺信息
        //  view:
        //      很多，很多
        save: function(data){
            window.busy();
            this.toSave(data).then(lang.hitch(this, function(result){
                window.free();
                if(result.data&&result.data.ok==1){
                    alert("保存成功")
                    history.back();
                }else{
                    alert(result.message||"保存错误");
                }
            }));
        },
        //  summary：
        //      保存数据
        //  description:
        //      暂未找到使用的页面(当前页面有调用)
        toSave: function(data){
            return this.exec("save",data).then(lang.hitch(this,function(result){
                return result;
            }));
        },
		// 一个店铺数据加载完成的回调函数
		// 在这里依据加载到的数据来做显示隐藏等操作
		onDataReady:function(widget){},
        //  summary：
        //      每次进入页面都要加载此函数
        //  view：
        //      merchantDetail
        onDataReadyMerchant:function(widget){
           var data = widget.getData();
           widget.hideByFields([/*
            "backVerificationButton",
            "noVerificationButton",
            "verificationButton",
            "recommendeMerchantButton",
            "noRecommendeButton"*/]);
            widget.disableByFields([
                "logo",
                "shopName","lon,lat",
                "town","address","companyName",
                "legalPerson","legalPersonCode",
                "tranRegion","businessLicense",
                "legalImg1","legalImg2"]);
            //推荐商家，撤销推荐                 
            //驳回认证
            //待审核
            //已认证

        },
        //  summary：
        //      从本商家的商家数据库加载指定的数据
        //  view：
        //      很多，很多
        loadById: function(params){
            return this.exec("loadById", {
                _id: params.cqViewParam?params.cqViewParam.params:params
            }).then(lang.hitch(this, function(result){
                return result.data.item;
            }));
        },
        //  summary：
        //      初始化店铺信息
        //  view：
        //      supplyBus
        loadShopFromPlt: function(params){
            return this.loadByIdFromPlt(params.cqViewParam.params);
        },
        //  summary：
        //      从平台加载数据
        //  description:
        //      暂未找到使用的页面(当前页面有调用)
        loadByIdFromPlt: function(shopId){
            return this.exec("loadById", {
                fromShopId: config.getPlatformShopId(),
                _id: shopId
            }).then(lang.hitch(this, function(result){
                return result.data.item;
            }));
        },
        //  summary：
        //      加载当前商家信息
        //  view:
        //      shopAut
        //      sevAut
        //      opAut
        //      sevStationAut
        //      townShopAut
        //      shopBase
        //      shopWeiXin
        //      shopCustomerMsg
        //      shopPay
        //      setPlatform
        loadMe: function(){
            return this.exec("loadById", {
                _id: this.getShopId()
            }).then(lang.hitch(this, function(result){
                return result.data.item;
            }));
        },
        //  summary：
        //      商家余额Layout
        //  TODO：
        //      暂未找到使用的页面
        getEdtLayoutForWd: function(){},
		// 店铺切换的回调函数
        //  summary：
        //      店铺切换的回调函数
        //  TODO：
        //      暂未找到使用的页面
		onShopChanged:function(){},
        
            /*****shopBase*****/
        // 店铺基础信息
        //  函数名：getEdtLayoutForBase
        //      参数：无
        //      返回值：Object
        //      view：shopBase
        //      功能：店铺基础信息布局
        getEdtLayoutForBase: function(){
            return [{
                type:"form",
                fields:this.getFormItems([
                    "logo","shopName","lon,lat",
                    "address","brief","svcPhone",
                    "svcWx","svcQQ","contactName",
                    "contactPhone","contactWx",
                    "contactQQ","aliPaySeller",
                    "bankName","bankAccountName",
                    "bankAccountCode","payee","fiName",
                    "fiPhone","fiQQ","baseSaveButton"
                ])
            }];
        },


		/*loadVerifiedShopsFromPlatformForMap:function(cqInfo,map,params){
            var hash = {
                "shopType": (params&&params.type) || "",
                "townId": (params&&params.town) || "",
                "shopId": config.getPlatformShopId(),
				"isVerified":true,
            };
            if (params) {
                hash.pageSize = params.pageSize || "";
                hash.pageIndex = params.pageIndex || "";
                hash.orderBy = params.orderBy || "";
            }
            return this.exec("loadShops", hash).then(lang.hitch(this,function(result){
				return result.data.items;
			}));
		},*/
        
            /*****shopWeiXin*****/
        // 店铺微信配置
        // 函数名：getShopWeiXinLayout
        //      参数：无
        //      返回值：Object
        //      view:shopWeiXin
        //      作用：店铺微信布局
        getShopWeiXinLayout : function(){
            return [{
                type: "form",
                fields: this.getFormItems([
                    "wxLogo","wxAppId","wxAppSec",
                    "wxUrl","wxCqToken","wxHash",
                    "wxMsgTemplate","wxVerification",
                    "wxAutoLogin","isSectionData",
                    "isAutoReplyData","shopWeiXinSave",
                    "shopWeiXinUrl","shopWeiXinToken"
                ])
            }];
        },
        //  函数名：onDataReadyByShopWeiXin
        //      参数：widget
        //      返回值：无
        //      view:shopWeiXin
        onDataReadyByShopWeiXin : function(widget){
            widget.disableByFields(["wxUrl"]);
            var data = widget.getData();
            var domNodeName = widget.getEditorByField("isAutoReplyData");
            if(data.autoReplyData&&data.autoReplyData.length>0){
                domNodeName.set("rightText","已设置")
            }else{
                domNodeName.set("rightText","未设置")
            }
            //判断自动回复是否设置
            var nodeSectionName = widget.getEditorByField("isSectionData");
            if(data.sectionData&&data.sectionData.legnth>0){
               nodeSectionName.set("rightText","已设置")
            }else{
               nodeSectionName.set("rightText","未设置")
            }
        },
        // 复制微信url
        // 周超
        //  函数名：cutUrlAction
        //      参数：param
        //      返回值：无
        //      view: shopWeiXin
        cutUrlAction : function(param){
            var wxUrl = param.wxUrl;
            if(!wxUrl){
                alert("微信Url为空");
                return;
            }
            copyPlate.copyToClipboard(wxUrl,function(){
                alert("微信Url复制成功!");
            },function () {
                prompt("",wxUrl);
            });
        },
        // 复制微信Token
        // 周超
        //  函数名：cutTokenAction
        //      参数：param
        //      返回值：无
        //      view: shopWeiXin
        cutTokenAction : function(param){
            var wxToken = param.wxCqToken;
            if(!wxToken){
                alert("微信Token为空");
                return;
            }
            copyPlate.copyToClipboard(wxToken,function(){
                alert("微信Token复制成功!");
            },function () {
                prompt("",wxToken);
            });
        },

            /*****shopCustomerMsg*****/
        // 店铺客服配置
        // 函数名：getShopCustomerMsgLayout
        //      参数：无
        //      返回值：Object
        //      view: shopCustomerMsg
        getShopCustomerMsgLayout:function(){
            return [{
                type: "form",
                fields: this.getFormItems([
                    "orderCheckerId",
                    "svcId",
                    "orderTimeout",
                    "tranAddr",
                    "tranRegions",
                    //"freightTemplated",
                    "shopInfoButton"
                ])
            }];
        },

            /*****shopPay*****/
        // 店铺支付方式配置
        //  函数名：getBussnessShop
        //      参数：无
        //      返回值：Object
        //      view:shopPay
        getShopPayLayout: function(){
            return [{
                type: "form",
                fields: this.getFormItems([
                    "payWeiXin",
                    "payAli",
                    "payDeposit",
                    "shopInfoButton"
                ])
            }];
        },
        //  加载shopWeixin页面数据
        //  周超
        //  函数名：loadShopWeiXinById
        //      参数：无
        //      返回值：Object
        //      TODO：暂未找到使用的页面
        loadShopWeiXinById: function(){
            var data = {};
            data.shopId = this.getShopId();
            return new DeferredList([
               this.exec("loadById",data),
               section.loadData({pageSize:1,pageIndex:0}),
               autoReply.loadData({pageSize:1,pageIndex:0})
            ]).then(function(results){
                var shopData = results[0][1].data;
                var sectionData = results[1][1];
                var autoReplyData = results[2][1];
                var backData = {};
                backData = shopData.item;
                backData.sectionData = sectionData;
                backData.autoReplyData = autoReplyData;
                return backData;
            });
        },
        //  summary：
        //      添加管理员点击事件触发函数
        //  TODO：
        //      暂未找到使用的页面
        findMoreShopAdmin: function(data){
            window.moveToView("addShopAdmin");
        },
        //  summary：
        //      
        //  TODO：
        //      暂未找到使用的页面
        loadByIds:function(shopIds){
            return this.exec("loadByIds",{
                ids:shopIds
            });
        },
        /*opAtPltList,sevManage,sevStationManage*/
        //在当前商家数据库中加载指定条件的商家数据
        //  summary：
        //      商家列表url获取
        //  view：
        //      opAtPltList
        //      b2cShopManage
        //      sevManage
        //      sevStationManage
        //      townShopManage
        getShopListUrl: function(){
            return this.getBaseUrl()+"/loadShops?shopId="+this.getShopId();
        },
        // 商家详情（只获取当前商家的那个url信息）
        // 从商家自己数据库中查找（从平台数据库中查找商家信息）
        // 函数名：getBussnessShop
        //      返回值：url地址
        //      参数：无
        //      TODO：暂未找到使用的页面
        getBussnessShop: function(){
            return this.getBaseUrl()+"/loadShops?";
        },
        //商家列表中显示的商家信息
        //  summary：
        //      商家列表布局
        //  TODO：
        //      暂未找到使用的页面
        getListLayoutForApp : function(data){
            return {
                icon:data.logo||"images/logo.png",
                label:"<div>公司名称："+data.shopName+"</div>"+
                "<div>省市区县："+(data.town||"")+"</div>"+
                "<div>详细地址："+(data.address||"")+"</div>"+
                "<div>联系电话："+(data.contactPhone||"")+"</div>",
                variableHeight:true,
                data:data,
                className: "line2listItem"
            };
        },
        //  summary：
        //      店铺余额数据初始化
        //  view:
        //      shopBalance
        getCurrentShopInfo : function () {
            return this.exec("loadById", {_id : this.getShopId()}).then(lang.hitch(this, function(result){
                if(result.data.ok==1){
                    var item = result&&result.data&&result.data.item||{};
                    item.logo = item.logo||"images/temp/dftLogo.png";
                    return item;   
                }else{
                    return {};
                }
            }));
        },
        //  summary：
        //      添加供应商
        //  TODO：
        //      暂未找到使用的页面
        addSupplyerAction: function(parm){
            var params = {};
            params.shopId = this.getShopId();
            params.supplierShopId = parm;
            return this.exec("addSupplyer", params);
        },
        //  summary：
        //      删除供应商
        //  view: 
        //      supplyBus
        deleteSupplyer: function(parm){
            var params = {};
            params.shopId = this.getShopId();
            params.supplierShopId = parm;
            return this.exec("deleteSupplyer", params);
        },
        //  summary：
        //      加载我的伙伴
        //  view: 
        //      myPartnerList
        loadPartner: function(){
            return this.getBaseUrl()+"/loadPartner";
        },
        //  summary：
        //      加载供应商列表url
        //  view:
        //      supplyList
        loadSupplyUrl: function(){
            return this.getBaseUrl()+"/loadSupplyUrl";
        },
        //  summary：
        //      获取商家列表
        //  view：
        //      searchShopList
        getSearchListUrl: function(){
           return this.getBaseUrl()+"/searchShop?";
        },
    });
    var shopBo = new ShopBo();
    shopBo.Bo = ShopBo;
    topic.subscribe("whz/shop/changed", function() {
        shopBo.onShopChanged();
    });
    return shopBo;
});
