//  创建人：周超
//  创建时间：2017-1-6
//  创建内容：供应商列表
define([
	"dojo/_base/declare",
	"dojo/_base/lang",
    "dojo/Deferred",
    "cq/util/config/config",
	"./shop"
], function(declare,lang,Deferred,config,shop) {
    var ShopCBo = declare("",shop.Bo,{
        //  可处理的字段
        fields:{
            saleAmount: {
                type: "text"
            },
            shopMatNum: {
                type: "text"
            },
            town: {
                type: "text"
            }
        },
        //  我的伙伴
        getShopB2BListQuery: function(params){
            var query = {isDelete:false,isVerified:true};
            query.shopId = this.getShopId();
            if(params.search){
                query.search = params.search;
            }
            if(params.state&&params.state._id){
                //待认证
                if(1 == params.state._id){
                    query.isSupplier=true
                }else if(2 == params.state._id){
                    query.isCustomer=true
                }else if(3 == params.state._id){
                    query.customerState=1
                }else{
                    delete query.isSupplier;
                    delete query.isCustomer;
                    delete query.customerState;
                }
            }
            return query;
        },
        //  合作伙伴点击事件处理
        onShopB2BListClick: function(data){
            window.moveToView("supplyBus",data._id);
        },
        //  根据不同情况显示的不同按钮或内容
        shopStoreDataReady: function(widget){
            var data = widget.getData();
            widget.hideByFields(["getButton","cancelButton"]);
			//注意：data是从平台加载的，而判断是否是供应商，应该从当前商家加载。
			this.loadById(data._id).then(function(shopData){
				if(shopData&&shopData.isSupplier){
					widget.showByFields(["cancelButton"]);
				}else{
					widget.showByFields(["getButton"]);
				}
			});
        },
        //  添加供应商
        addSupplyer: function(data,wiget){
            shop.addSupplyerAction(data._id).then(lang.hitch(this,function(data){
                if(data&&data.data&&data.data.ok == 1){
                    alert("添加成功");
                    wiget.cqRefresh();
                }else{
                    alert("服务器繁忙，请稍后再试！");
                    return;
                }
            }));
        },
        deleteSupplyer: function(data,wiget){
            shop.deleteSupplyer(data._id).then(lang.hitch(this,function(data){
                if(data&&data.data&&data.data.ok == 1){
                    alert("删除成功!");
                    wiget.cqRefresh();
                }else{
                    alert("服务器繁忙，请稍后再试！");
                    return;
                }
            }));
        },
        //获取商家列表（暂未使用）
        getSupplyShopUrl: function(){
            //loadSupplyUrl
            return shop.loadSupplyUrl();
        },
        //  处理点击事件
        onClickSupplyShop: function(data){
            window.moveToView("supplyBus",data._id);
        },
        //listem
        getSupplyShopItemProp: function(data){
            return data/*{
                icon:data.logo||"images/logo.png",
                label:"<div>"+data.shopName+"</div>"+
                "<div class='hflex'><div style='width:60%'>销量："+(data.saleAmount||"0")+"</div><div style='width:40%;'>商品数："+(data.shopMatNum||"0")+"</div></div>"+
                "<div>销售区域："+(data.tranRegion||"全国")+"</div>"+
                "<div>所在地："+(data.town||"")+"</div>",
                variableHeight:true,
                data:data
            }*/;
        },
        //筛选条件
        getSupplyShopParam:function(params){
            //  从平台获取商家列表，因此把shopId设置成平台Id
            var query = {shopId:config.getPlatformShopId(),isVerified:true,shopType:4};
            if(params.district){
                if(params.district.province){
                    query.provinceId = params.district.province._id;
                }
                if(params.district.city){
                    query.cityId = params.district.city._id;
                }
                if(params.district.county){
                    query.countId = params.district.county._id;
                }
            }
            return query;
        }
    });
    
    var shopCBo = new ShopCBo();
    shopCBo.Bo = ShopCBo;
    return shopCBo;
});