//  创建人：周超
//  创建时间：2017-1-4
//  创建内容：（商家收索页面）
define([
	"dojo/_base/declare",
	"dojo/_base/lang",
    "dojo/Deferred",
    "cq/util/config/config",
    "cq/util/sys/geo",
	"./shop"
], function(declare,lang,Deferred,config,geo,shop) {
    var ShopCBo = declare("",shop.Bo,{
        // 可处理的字段
        fields:{
            distance: {
                type: "text",
                label: "距离"
            }
        },
        //处理列表数据(主要是显示距离这个字段)
        getSearchShops: function(data){
            //  定死地址(当前店铺地址)
            var position = geo.getCoordinate();
            if(position){
                var lat1 = position.lon;
                var lng1 = position.lat;
                //  获取目标商家地址坐标
                var lat2,lng2,distance;
                lng2 = data.lon;
                lat2 = data.lat;
                distance = geo.getDistance(lat1,lng1,lat2,lng2);
                data.distance = distance;
            }else{
                data.distance = "无法获取当前店铺地址";
            }
            return data;
        },
        //点击跳转
        onOpListClick: function(data){
            window.moveToView("businessDetails",data._id);
        },
        //搜索条件
        getSearchListQuery:function(params){
            var query = {shopId:config.getPlatformShopId(),isVerified:true,shopType:1};
            // lon,lat 是当前店铺的坐标
            var position = geo.getCoordinate();
            if(position){
                query.orderBy = "distance";
                query.lon = position.lon;
                query.lat = position.lat;
            }else{
                delete query.lon;
                delete query.lat;
            }
            if(params.search){
                query.search = params.search;
            }
            return query;
        }
    });
	
	var shopCBo = new ShopCBo();
	shopCBo.Bo = ShopCBo;
    return shopCBo;
});