//服务站：益农信息社的管理
//	继承自服务商
//	服务站认证：达到6有标准：有场地、有人员、有设备、有宽带、有网页、有持续运营能力
//	服务站的状态：待提交申请0、申请中1、申请通过2、申请驳回3、待验收4、验收中5、验收通过6、验收驳回7
//		申请需提交的资料：
//			LOGO、服务站名称shopName、联系人、联系电话、地址、服务站类型stationType（标准型1、简易型2、专业型3）、
//			经营主体类型shopType（个体1、合作社2、企业3、政府4、其他9999）、经营主体名称、法人姓名、法人身份证号、法人身份证正反面、营业执照、组织机构代码、地理位置、省市区
//			场地照片(先不要)、设备照片（先不要）、服务站简介
//		申请提交的对象：同服务商
//		申请的认证：运营商应将服务商和服务站分开管理，认证内容和认证流程不同。
//		申请通过的服务站，可以使用服务站的功能，但不显示在在村头的前台服务站名单中，只有验收通过的服务站才显示。验收由服务站申请，运营商执行；
//	数据同步：服务站的资料和状态变更，应同步到平台和运营商，以便实现集中管理和统计
//  服务商对外提供的服务项目shop/shop_services：[fromShopId,toShopId,serviceType,isUse]
//      fromShopId和toShopId都是当前shop的数据，是服务商提供的服务
//	服务站集成的服务项目：toShopId是自己的
//		服务项目类别采用四位整数，0-999：内部保留；1000-1999：公益服务；2000-2999：便民服务；3000-3999：电子商务；4000-4999：培训体验
//		服务项目的图标保存到images/icon/serviceIcon/id.png中
//		服务站可以多选计划开展的服务项目；
//		每个服务项目可以选择多家开展此类服务项目的服务商；
//		服务页面显示服务站集成的服务，每个服务项目的下方显示最多3个服务商；农户点击服务商进入服务商对该项服务的服务页面；
//		服务商开展的服务项目需同步到运营商和平台，以便数据共享和统计；
//	服务商接入服务站
//		选择服务商，选择服务项目，点击我要开展服务
//		数据逻辑：添加或者修改自己店铺、服务商店铺、平台店铺的shop_services表

// 变更记录
// 20170101:干劲
//		shopType是一个重要字段，用于区分平台，运营商，服务商，服务站，服务中心，B2C商家更合理。
//		详情查看shop.js中对shopType的定义
//		经营主体的类型不是很重要，暂时没有考虑如何处理
define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"./sevShop"
], function(declare,lang,sevShop) {
    var ShopBo = declare("",sevShop.Bo,{
        modalName : "shop/serviceStation",
        fields:{
            "shopName": {
                type:"text",
                label:"服务站名称",
                className:"middle-width"
            },
            "stationType" : {
                type: "options",
                label: "经营主体类型",
                options : {
                    1:"标准型",
                    2:"简易型",
                    3:"专业型"
                } 
            },
            "brief": {
                type:"textarea",
                label:"服务站简介",
                className:"large-width",
                placeHolder:"请填写简介"
            },
            staAutApplyButton:{
                type:"button",
                label:"提交认证",
                action:"sevStationAutApply",
                className:"fullButton"
            },
            revokeStaAutButton : {
                type:"button",
                label:"撤销认证",
                action:"revokeVerify",
                className:"fullButton"               
            },
            staAutReApplyButton : {
                type:"button",
                label:"重新提交",
                action:"sevStationAutReApply",
                className:"fullButton"
            },
            staCertificationThrough:{
                type:"button",
                label:"认证通过",
                action:"verifyPass",
                className:"large-width",
                canEdit: false
            },
            staAudit : {
                type:"button",
                label:"审核中",
                action:"verify",
                className:"large-width",
                canEdit: false
            }
        },
        getStationShopLayout : function(){
            // summary:
            //      服务站认证Layout
            // view:
            //      sevStationAut——服务站提交认证,
            //      townShopAut——服务中心提交认证
            //description
            //		可供townShop继承
            return [{
                type:"form",
                fields:this.getFormItems([
                    "rejectedReason",
                    "staCertificationThrough",
                    "staAudit",
                    "logo","shopName","contactName",
                    "contactPhone","stationType",
                    "companyName","legalPerson","legalPersonCode",
                    "legalImg1","legalImg2","businessLicense",
                    "orgCode", //组织机构代码
                    "lon,lat","address",
                    "provinceId,cityId,countId,town","brief",
                    "staAutApplyButton",
                    //"revokeStaAutButton",
                    "staAutReApplyButton"
                ],true)
            }]
        },
        staDataReady: function(widget){
            // summary:
            //      数据加载完成,可在此处处理按钮的显示和隐藏
            // view:
            //      sevStationAut——服务站提交认证
            //      townShopAut——服务中心提交认证
            //description
            //		可供townShop继承         
            widget.disableByFields(["rejectedReason"]);
            widget.hideByFields([
                "staAutApplyButton",
                //"revokeStaAutButton",
                "rejectedReason",
                "staAutReApplyButton",
                "staCertificationThrough",
                "staAudit"]);
            var data = widget.getData();
            if(!data.isVerified&&0==data.isVerifySubmit){
                widget.showByFields(["staAutApplyButton"]);
            }
            if(!data.isVerified&&-1==data.isVerifySubmit){
                widget.showByFields(["staAutReApplyButton"]);
                //显示驳回原因
                widget.showByFields(["rejectedReason"]);
            }
            if(!data.isVerified&&1==data.isVerifySubmit){
                widget.showByFields(["revokeStaAutButton"]);
                widget.showByFields(["staAudit"]);
            }
            if(!data.isVerified&&2==data.isVerifySubmit){
                widget.showByFields(["staCertificationThrough"]);
            }
            // 若是审核中或者审核通过 要禁止所有字段的编辑
            if((!data.isVerified&&1==data.isVerifySubmit) || 
                (data.isVerified&&2==data.isVerifySubmit)){
                widget.disableByFields([                   
                    "logo","shopName","contactName",
                    "contactPhone","stationType",
                    "companyName","legalPerson","legalPersonCode",
                    "legalImg1","legalImg2","businessLicense",
                    "orgCode", //组织机构代码
                    "lon,lat","address",
                    "provinceId,cityId,countId,town","brief"
                ]);
            }
			else{
                widget.enableByFields([                   
                    "logo","shopName","contactName",
                    "contactPhone","stationType",
                    "companyName","legalPerson","legalPersonCode",
                    "legalImg1","legalImg2","businessLicense",
                    "orgCode", //组织机构代码
                    "lon,lat","address",
                    "provinceId,cityId,countId,town","brief"
                ]);
			}
        },
        sevStationAutReApply: function(data, widget){
            // summary:
            //      服务站重新认证提交函数 
            // view:
            //      sevStationAut——服务站提交认证
            //      townShopAut——服务中心提交认证
            //description
            //		可供townShop继承 
            this.sevStationAutApply(arguments);
        },
        sevStationAutApply : function(data,widget){
            // summary:
            //      服务站认证提交函数 
            // view:
            //      sevStationAut——服务站提交认证
            //      townShopAut——服务中心提交认证
            //description
            //		可供townShop继承 
            var msg = this.getDataValidMsg(data, ["logo","shopName","contactName",
                    "contactPhone","stationType",
                    "companyName","legalPerson","legalPersonCode",
                    "legalImg1","legalImg2","businessLicense",
                    "orgCode", //组织机构代码
                    "lon","lat","address",
                    "provinceId,cityId,countId,town","brief"]);
            if(msg){
                alert(msg);
                return;
            }
            window.busy();
            var datas = data;
            datas.provinceId = data.provinceId._id|| data.provinceId;
			datas.cityId = data.cityId._id || data.cityId;
			datas.countId = data.countId._id || data.countId;
			delete datas.__v;
            this.exec("verifyStaShopSubmit", datas).then(lang.hitch(this, function(result){
                window.free();
				if(result&&result.data&&result.data.ok==1){
                    history.back();
                }else{
                    alert("提交失败");
                }
			}));
        },
        getStaListQuery:function(params){
            // summary:
            //      服务站列表的查询条件 
            // view:
            //      sevStationManage——服务站管理(服务站列表)
			// description:
			//		shopType=2表示服务站。详情查阅shop.js
            var query = {shopType:2};
            if(params.search){
                query.search = params.search;
            }
            if(params.state&&params.state._id){
                //	待认证
                if(1 == params.state._id){
                    query.isVerifySubmit=1;
                    query.isVerified=false;
                }else if(2 == params.state._id){
                    //	已认证
                    query.isVerifySubmit=2;
                    query.isVerified=true;
                }else if(3 == params.state._id){
                    //	未提交
                    query.isVerifySubmit= 0;
                    query.isVerified=false;
                }else if(4 == params.state._id){
                    //	已驳回
                    query.isVerifySubmit=-1;
                    query.isVerified=false;
                }else{
                    delete query.isVerifySubmit;
                    delete query.isVerified;
                }
            }
            return query;
        },
        onStaListClick : function(data){
            // summary:
            //      服务站列表点击事件 
            // view:
            //      sevStationManage——服务站管理(服务站列表)
            //  	townShopAut——服务中心提交认证
            // description:
            //      点击跳转到服务站详情   
            //      
            //description
            //		可供townShop继承 
            window.moveToView("staMerDetail",data._id);
        }
    });
	var shopBo = new ShopBo();
	shopBo.Bo = ShopBo;
    lang.setObject("bob.shop.stationShop", shopBo);
    return shopBo;
});
