﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/connect",
    "dojo/Deferred",
    "dojo/dom-construct",
    "../user/consumer",
    "cq/util/edit/overlay",
    "cq/util/payType/icon",
    "cq/util/sys/userAgent",
    "cq/util/config/config",
    "cq/util/sys/date"
],function(declare,lang,array,connect,Deferred,domConstruct,consumer,overlay,icon, userAgent,config,date){
    var paymentQrDiv = null;
    //卖家管理订单相关的功能，卖家包括
    //      B2C消费者
    //      B2B采购者
    return declare("",null,{
        fields:{
            // 卖家订单详情界面按钮
            // 支付
            toPay: {
                type: "button",
                action: "payById"
            },
            // 确认收货
            toReceipt: {
                type: "button",
                action: "onReceipt",
            },
            // 评价
            toEva: {
                type: "button",
                action: "onEvaluat"
            },
            //刷新
            refresh:{
				type: 'button',
				action: 'refresh'
            },
            toRefund: {
                type: "button",
                action: "toRefund",
                label: "退款"
            },
            refunding: {
                type: "button",
                action: "refunding",
                label: "退款中"
            },
            finishedRefund: {
                type: "button",
                action: "refunding",
                label: "已退款"
            },
            contactVillger:{
                ype: "button",
                action: "contactVillger",
                label: "联系村官"
            },
            "startPayTime":{
                type:"dateTime"
            },
            "endPayTime":{
                type:"dateTime"
            },
            // 自提点导航
            navigation: {
                type: "button",
                action: "navigation",
                label: "导航"
            }
        },
        navigation: function(data){
            if(!data){
                return;
            }
            if(!data.storeId){
                alert("没有自提点信息");
                return;
            }
            if(!data.storeId.lon||!data.storeId.lat){
                alert("没有地址信息");
                return;
            }
            window.busy();
            require([
                "cq/util/sys/wx",
                "cq/util/sys/userAgent"
            ],function(wx,userAgent){
                window.free();
                if(userAgent.isWeixin()&&wx.isReady){
                    wx.openLocation(data.storeId.lon,data.storeId.lat,data.storeId.name);
                }else if(!userAgent.isIos()&&!userAgent.isAndroid()){
                    window.moveToView('travelMap',encodeURIComponent(JSON.stringify({
                        tp:"point",
                        points:[{
                            lon: data.storeId.lon,
                            lat: data.storeId.lat,
                            title: data.storeId.name
                        }]
                    }))); 
                }else{
                    var aHref = "androidamap://navi?sourceApplication=appname&poiname=fangheng&lat="+data.storeId.lat+"&lon="+data.storeId.lon+"&dev=1&style=1";
                    window.location.href = aHref;
                }
            });
        },
        //订单列表相关功能
        //消费者订单列表获取url
        getListUrl: function(){
            return this.getBaseUrl()+"/loadWithDetails?shopId="+this.getShopId()+"&userId="+consumer.getCurrentUserId();
        },
        //消费者订单列表查询
        getListParam: function(params){
            var query = this._getListQuery(params), state = params.cqViewParam.params;

            if(params.state){
                //待付款
                if(params.state._id == 1){
                    query.isPayed = false;
                    query.isCanceled = false;
                }
                //待发货
                else if(params.state._id == 2){
                    query.isPayed = true;
                    query.isCanceled = false;
                    query.isDelived = false;
                }
                //待收货
                else if(params.state._id == 3){
                    query.isPayed = true;
                    query.isCanceled = false;
                    query.isDelived = true;
                    query.isReceipted = false;
                }
                //待评价
                else if(params.state._id == 4){
                    query.isPayed = true;
                    query.isCanceled = false;
                    query.isReceipted = true;
                    query.isClosed = false;
                }else if(params.state._id == 5){
                    query.isCycle = true;
                    query.refundState = 1;
                    query.isPayed = true;
                    query.isCanceled = false;
                    query.deliveredTimes = 1;
                }
            }
            if(state&&!params.state){
                //待付款
                if(state == 1){
                    query.isPayed = false;
                    query.isCanceled = false;
                }
                //待发货
                else if(state == 2){
                    query.isPayed = true;
                    query.isCanceled = false;
                    query.isDelived = false;
                }
                //待收货
                else if(state == 3){
                    query.isPayed = true;
                    query.isCanceled = false;
                    query.isDelived = true;
                    query.isReceipted = false;
                }
                //待评价
                else if(state == 4){
                    query.isPayed = true;
                    query.isCanceled = false;
                    query.isReceipted = true;
                    query.isClosed = false;
                }else if(state == 5){
                    query.isCycle = true;
                    query.refundState = 1;
                    query.isPayed = true;
                    query.isCanceled = false;
                    query.deliveredTimes = 1;
                }
            }
            return query;
        },
        onActionListClick:function(data,action,list){
            if(action==="detail"){
                window.moveToView(this.detailView,data._id);
            }
        },
        getOrderStateTxt: function(item){
            // 显示订单状态
            var state = "";
            if(item.isPayed){
            //已付款
                if(item.isCanceled){
                    //已付款且已取消，则为已退款
                    state = "已退款";
                }else if(item.refundState==2){
                    state = "退款中";
                }else if(item.isDelived){
					// 如果是正常订单
					if(!item.isCycle){
						//已发货
						if(item.isClosed){
							//若已关闭，则为已完成
							state = "已完成";
						}else{
							if(!item.isReceipted){
								//若未收货，为待收货
								state = "待收货";
							}else{
								//否则，待评价，评价完成之后会变成已完成
								state = "待评价";
							}
						}
					}else{
						var detail = item.details[0];
						if(detail.totalDeliveryTimes-detail.deliveredTimes>0){
							state = "配送中";
						}else{
							state = "已送完";
						}
					}
                    if(item.refundState&&item.refundState>2){
                        state = state + "(部分退款)";
                    }
                }else{
                    //否则为待发货
                    state = "待发货";
                }
            }else{
                //未付款
                if(item.isCanceled){
                    //已取消
                    state = "已取消";
                }else{
                    //待付款
                    state = "待付款";
                }
            }
            return state;
        },
        // 加载指定订单数据
        loadWithDetails:function(params){
            if (!params.cqViewParam.params) {
                return;
            }
            var tsId = params.cqViewParam.params, def = new Deferred();
            //this.loadById(tsId).then(lang.hitch(this,function(orderData){
            //    orderData = orderData.data.item;
            //    //refundState 状态代表着退款状态
            //    if(orderData.isPayed === false && orderData.isCanceled === false){
            //        this.exec("generate_payment_scheme_by_id",{_id:tsId}).then(lang.hitch(this,function(){
            //           this._loadWithDetails(tsId).then(function(data){
            //                def.resolve(data);
            //           });
            //        }));
            //    }else{
            //判断退款状态,整张订单一起退
            this._loadWithDetails(tsId).then(lang.hitch(this,function(data){
                require([
                    "bob/ts/refundAplication/c"
                ], function(refundAplication){
                    refundAplication.loadByTsId(tsId).then(function(refundData){
                        var refundItem = refundData&&refundData.data&&refundData.data.item||{};
                        data.refundId = refundItem._id||"";
                        // 判断当前尾款支付的状态
                        var now = date.nowISOString();
                        if(data.preSaleId&&data.isPreAmountPayed&&!data.isPayed&&!data.isCanceled){
                            if(now<data.details[0].startPayTime){
                                data.finalPaymentTitle = "距离尾款支付还有";
                                data.finalPaymentTime = data.details[0].startPayTime;
                            }else if(now>=data.details[0].startPayTime&&now<=data.details[0].endPayTime){
                                data.finalPaymentTitle = "距离尾款支付结束还有";
                                data.finalPaymentTime = data.details[0].endPayTime;
                            }else{
                                
                            }
                        }
                        data.details[0].pacTeamId = data.pacTeamId;
                        data.earnestState = data.isPreAmountPayed?"已完成":(data.isCanceled?"已取消":"未支付");
                        data.finalPaymentState = data.isPayed?"已完成":(data.isCanceled?"已取消":"未支付");
                        def.resolve(data);
                    });
                });
            }));
            //    }
            //}));
            return def;
        },
        // 订单详情加载完成后的处理
        onDataReady: function(widgets){
            widgets.hideByFields(["toCancel", "toPay", "toReceipt", "toQryLog", "toEva","deliveryCalendar"]);
            widgets.hideByFields([
            "payTime", "delivTime", "recepiptTime","payTypeTxt","payAmount","toRefund", "refunding", "finishedRefund", 
			"cycleDelivery1", "pauseRecord", "cycleModeMsg", "deliveryTimesMsg", "nextDeliveryTime", "cardId.NO",
            "earnestState","preAmount","finalPaymentState","amount","finalPaymentTitle,finalPaymentTime",
            "normalOrder", "preSaleOrder", "showPrePayedDetails", "showFinalPayedDetails", "prePayTypeTxt", "preOnlineAmount",
            "finalPayTypeTxt", "finalPayAmount","storeId.name","storeId.addr"]);
            var item = widgets.getData();
            if(!item._id){
                return;
            }
            // 如果是自提订单 则显示自提信息
            if(item.deliveryType==2){
                widgets.showByFields(["storeId.name","storeId.addr"]);
            }
			// 如果是预售订单 则显示预售信息
			if(item.preSaleId){
				widgets.showByFields(["earnestState","preAmount","finalPaymentState","amount", "preSaleOrder"]);
                if(item.finalPaymentTitle){
                    widgets.showByFields(["finalPaymentTitle,finalPaymentTime"]);
                }
			}else{
                widgets.showByFields(["normalOrder"]);
            }
            if(item.cardId){
                widgets.showByFields(["cardId.NO"]);
            }
            if(item.payTime){
                widgets.showByFields(["payTime"]);
            }
            if(item.delivTime){
                widgets.showByFields(["delivTime"]);
            }
            if(item.recepiptTime){
                widgets.showByFields(["recepiptTime"]);
            }
			if(item.nextDeliveryTime){
				widgets.showByFields(["nextDeliveryTime"]);
			}
			if(item.isCycle){
				widgets.showByFields(["cycleDelivery1", "cycleModeMsg", "deliveryTimesMsg"]);
			}
			if(item.isCycle&&item.isPayed&&item.isDelived){
				widgets.showByFields(["pauseRecord"]);
			}
			
            //周期订单不显示查询物流，显示送达日历
            // 已经支付并且发货
            if (item.isPayed && item.isDelived) {
                if(item.details[0].isCycle){
                    //周期订单
                    if(item.details[0].deliveredTimes){
                        widgets.showByFields(["deliveryCalendar"]);
                    }
                }else{
                    widgets.showByFields(["toQryLog"]);
                }  
            }
            var awardId = item.details[0].awardId||"";
            if(!item.isPayed&&!item.isCanceled){
                //widgets.showByFields(["toCancel", "toPay"]);
                //没到付尾款的时候不显示支付按钮
                widgets.showByFields(["toCancel"]);
                if(item.preSaleId){
                    if(!item.isPreAmountPayed||item.details[0].startPayTime<date.nowISOString()&&date.nowISOString()<=item.details[0].endPayTime){
                        widgets.showByFields(["toPay"]);
                    }
                }else{
                    widgets.showByFields(["toPay"]);
                }
            }
            if(awardId&&item.isPayed){
                widgets.hideByFields(["toCancel"]);
            }
            // 若是预售订单且已经支付了定金 则不允许取消订单
            if(item.preSaleId&&item.isPreAmountPayed){
                widgets.hideByFields(["toCancel"]);
            }
            if(item.isPayed&&item.payType!=="point"){
                if(!item.preSaleId){
                    widgets.showByFields(["payTypeTxt","payAmount"]);
                }
                else{
                    widgets.showByFields(["finalPayTypeTxt", "finalPayAmount"]);
                }
            }
            if(item.isPreAmountPayed&&item.prePayType!=="point"){
                widgets.showByFields(["prePayTypeTxt", "preOnlineAmount"]);
            }
            //refundState: Number  //退货的状态（1，未申请;2，处理中；3，退款成功；4，退款失败关闭）
            //撤销退款后，refundState为4
            // 如果未申请退款且订单未取消且订单未收货 则允许退款,否则 不允许退款
            //如果是周期订单，已支付，未取消，且未送完，才显示退款按钮（不受isReceipted影响）
            //deliveredTimes是剩余的个数
            var restTimes = item.details[0].totalDeliveryTimes-item.details[0].deliveredTimes;
            if(item.isCycle&&(!item.refundState||item.refundState==1||item.refundState==4)&&item.isPayed&&item.isCanceled==false&&restTimes>0){
                widgets.showByFields(["toRefund"]);
            }
            if(!item.isCycle&&(!item.refundState||item.refundState==1||item.refundState==4)&&item.isPayed&&item.isCanceled==false&&item.isReceipted==false){
                widgets.showByFields(["toRefund"]);
            }
            if(item.refundState&&item.refundState==2){
                widgets.showByFields(["refunding"]);
            }
            if(item.refundState&&item.refundState==3){
                widgets.showByFields(["finishedRefund"]);
            }
            // 如果订单处理退款中的状态 则不能再进行收货或评价操作了
            if(item.refundState&&item.refundState==2){
                return;
            }
            // 如果订单是提货卡订单 则不允许退款
            // 2017-08-02 刘轩
            // 从老系统导过来的订单不允许点击退款
            if(item.cardId||item.oldId){
                widgets.hideByFields(["toRefund"]);
            }
            if(item.isPayed&&!item.isCanceled&&item.isDelived&&item.isReceipted==false&&!item.isCycle){
                widgets.showByFields(["toReceipt"]);
            }
            if(item.isPayed&&item.isReceipted&&!item.isCanceled&&!item.isClosed){
                widgets.showByFields(["toEva"]);
            }
        },
        // 点击退款 徐阿雪 2017/3/6
        toRefund:function(data,widget){
            window.moveToView("refundRequest",data._id);
        },
        // 点击退款中或已退款 查看退款进度
        refunding: function(data, widget){
            window.moveToView("refundRequestDetail", data.refundId);
        },
        //依据商品、客户、地址、优惠券获取订单信息
        getTAmount:function(mids,addressId,withCoupons,deliveryTypes,pacTeamId){
            return this.exec3("ts/orderh", "cPrice", {
                mids : mids,
                summary : {
                    addressId : addressId,
                    userId : consumer.getCurrentUserId(),
                    pacTeamId : pacTeamId
                }
            }).then(lang.hitch(this, function(result) {
                var formatHash = {};
                var toMidHash = function(item){
                    formatHash[fromShopId].matInfo[item.mId] = item;
                };
                if (result.ok == 1) {
                    fromShopOrder = result.result;
                    for (var fromShopId in fromShopOrder) {
                        formatHash[fromShopId] = {};
                        formatHash[fromShopId].coupons = fromShopOrder[fromShopId].coupons;
                        formatHash[fromShopId].shopInfo = {
                            shopName : fromShopOrder[fromShopId].fromShopName
                        };
                        formatHash[fromShopId].tAmount = fromShopOrder[fromShopId].tAmount;
                        formatHash[fromShopId].totalPrice = fromShopOrder[fromShopId].mAmount;
                        formatHash[fromShopId].matInfo = {};
                        (fromShopOrder[fromShopId].matDetails||[]).forEach(toMidHash);
                    }
                    return {
                        data : {
                            item : formatHash,
                            ok : 1
                        }
                    };
                } else {
                    alert(result.message || "后台繁忙");
                }
            }));
        },
        //提交订单
        createDistributeOrder:function(orderInfo){
            orderInfo.userId = consumer.getCurrentUserId();
            return this.exec3("ts/orderh", "cCreate", {
                mids : orderInfo.mids,
                summary : {
                    userId : orderInfo.userId,
                    addressId : orderInfo.addressId || undefined,
                    remarks : orderInfo.remarks || undefined,
                    deliveryTypes : orderInfo.deliveryTypes || undefined,
                    coupon:orderInfo.coupon || undefined
                }
            }).then(lang.hitch(this,function(result){
                if (result.ok == 1) {
                    var item = {};
                    for (var fromShopId in result.result) {
                        item[fromShopId] = {
                            order : (result.result)[fromShopId],
                            timeout : (result.result)[fromShopId].timout
                        };
                    }
                    return {
                        data : {
                            item : item,
                            ok : 1
                        }
                    };
                } else {
                    alert(result.message || "后台繁忙");
                }
            }));
        },
        //领取奖励提交订单
        createGiftOrder:function(orderInfo){
            orderInfo.userId = consumer.getCurrentUserId();
            return this.exec("createGiftOrder",orderInfo);
        },
        // 提货卡提交订单
        createDeliveryOrder: function(orderInfo){
            orderInfo.userId = consumer.getCurrentUserId();
            return this.exec("createDeliveryOrder",orderInfo);
        },
        /*
            消费者订单接口相关：
            收货
            评价
            提交评论
            依据商品、客户、地址、优惠券获取订单信息
            提交订单
            订单支付
        */
        // 订单支付完成后 要隐藏overlay 并且刷新显示
        onOrderPayFinished: function(result){
            if(result&&result.data&&result.data.ok==0){
                alert(result.data.message);
            }
            overlay.hide();
        },
        getValidPayType:function(ts){
            var result = null;
            if(ts&&ts.payAmount<=0){
                return [{
                    name: "余额",
                    type:"point",
                    logo:"./images/temp/payicon/pointpay.png"
                }];
            }else if(userAgent.isApp()){
                result =  [{
                    name: "微信",
                    type:config.appWxPay?"wxApp":"wxNative",
                    logo:"./images/temp/payicon/weixinpay.png"
                },{
                    name: "支付宝",
                    type:cordova&&cordova.plugins&&this.canNativeAlipay()&&config.appAliPay?"aliapp":"aliwap",
                    logo:"./images/temp/payicon/alipay.png"
                }];
                if(config.appAlif2f){
                    result.push({
                        name:"当面付",
                        type:"alif2f",
                        logo:"./images/temp/payicon/alipay.png"
                    });
                }
            }else if(userAgent.isWeixin()){
                result = [{
                    name: "微信",
                    type:"weixin",
                    logo:"./images/temp/payicon/weixinpay.png"
                },{
                    name: "支付宝",
                    type:"aliwap",
                    logo:"./images/temp/payicon/alipay.png"
                }];
                if(window.__wxjs_environment === 'miniprogram'){
                    result.pop();
                }
                if(config.appAlif2f){
                    result.push({
                        name:"当面付",
                        type:"alif2f",
                        logo:"./images/temp/payicon/alipay.png"
                    });
                }
            }else{
                result = [{
                    name: "微信",
                    type:"wxNative",
                    logo:"./images/temp/payicon/weixinpay.png"
                },{
                    name: "支付宝",
                    type:"aliwap",
                    logo:"./images/temp/payicon/alipay.png"
                }];
                if(window.__wxjs_environment === 'miniprogram'){
                    result.pop();
                }
                if(config.appAlif2f){
                    result.push({
                        name:"当面付",
                        type:"alif2f",
                        logo:"./images/temp/payicon/alipay.png"
                    });
                }
            }
            
            if(config.payToPlatform == false){
                for(var index = 0;index < result.length;index++){
                    if(result[index].name == "微信"){
                        if(window.g_sys_info.payWeiXin == false){
                            result.splice(index , 1);
                            index--;
                        }
                    }else if(result[index].name == "支付宝"){
                        if(window.g_sys_info.payAli == false){
                            result.splice(index , 1);
                            index--;
                        }
                    }else if(result[index].name == "当面付"){
                        if(window.g_sys_info.payAli == false){
                            result.splice(index , 1);
                            index--;
                        }
                    }
                }
            }
            return result;
        },
        // 订单详情中点击支付按钮
        payById: function(ts, widget){
            var def = new Deferred();
            // 如果是联合订单 则要支付unionId下的所有订单
            if(ts.unionId){
                this.getUnionOrders(ts.unionId).then(function(orders){
                    var payInfo = {
                        tsInfo: {
                            amount:0,
                            couponAmount:0,
                            gold:0,
                            payAmount:0,
                            point:0
                        },
                        ids: []
                    };
                    if(confirm("本订单需要与订单编号为"+array.map(orders, function(order){
                        return order._id!=ts._id?order._id:"";
                    }).join("、")+"的订单一起完成支付，确认支付？")){
                        for(var i=0;i<orders.length;i++){
                            payInfo.ids.push(orders[i]._id);
                            payInfo.tsInfo.amount += orders[i].amount;
                            payInfo.tsInfo.couponAmount += orders[i].couponAmount;
                            payInfo.tsInfo.gold += orders[i].gold;
                            payInfo.tsInfo.payAmount += orders[i].preAmount;
                            payInfo.tsInfo.point += orders[i].point;
                        }
                        def.resolve({
                            payInfo: payInfo,
                            ok: 1
                        });
                    }else{
                        def.resolve({
                            ok: 0
                        });
                    }
                });
            }else{
                //尾款和预付定金金额显示设置
                if(ts.preSaleId){
                    // 未支付定金
                    if(!ts.isPreAmountPayed){
                        // 在线支付定金金额
                        ts.payAmount = ts.preAmount-ts.prePoint-ts.preGold-ts.preCoupon;
                        // 定金金额
                        ts.amount = ts.preAmount;
                        // 定金支付积分
                        ts.point = ts.prePoint;
                        // 定金支付金元宝
                        ts.gold = ts.preGold;
                        // 定金支付优惠券
                        ts.couponAmount = ts.preCoupon;
                    }
                }
                var payInfo = {
                    tsInfo: ts,
                    ids: [ts._id]
                };
                def.resolve({
                    payInfo: payInfo,
                    ok: 1
                });
            }
            var _this = this;
            def.then(function(data){
                if(data.ok==1){
                    var payTypes = _this.getValidPayType(data.payInfo.tsInfo);
                    icon.payOrder(
                        data.payInfo,function(result){
                            if(result&&result.data&&result.data.ok == 0){
                                alert(result.data.msg||"支付失败");
                            }else{
                                widget.cqRefresh();
                            }
                        },{
                            payer: _this,
                            payMethod:"payByIds",
                            // 应该获取商家已配置的支付方式
                            payTypes:payTypes
                        }
                    ).then(function(){
                        overlay.hide();
                    });
                    overlay.showElement(icon.domNode,null);
                    var handler = connect.connect(overlay,"realHided", lang.hitch(this, function(){
                        handler.remove();
                        widget.cqRefresh();
                    }));
                }
            });
            return def;
        },
        // 支付
        payByIds: function (param) {
            var def = new Deferred();
            //若不是微信环境或者商家的是订阅号，通过微信扫码支付
            if ("weixin" == param.payType && (!window.WeixinJSBridge || 1 == g_sys_info.wxType || !g_sys_info.wxVerification)) {
                param.payType = "wxNative";
            }
            // 如果是支付宝支付，判断是否是APP支付，是否安装支付宝插件，如果没有则继续网页支付，否则试用插件支付
            if ("aliwap" == param.payType) {
                if (userAgent.isApp() && this.canNativeAlipay()) {
                    param.payType = "aliapp";
                } else {
                    param.payType = "aliwap";
                }
            }
            // 支付宝面对面支付
            if("alif2f" == param.payType){
                param.payType = "alif2f";
            }
            // 如果是中行支付，判断是否是APP支付，如果没有则继续网页支付
            if ("bocB2CMobile" == param.payType) {
                if (userAgent.isApp()) {
                    param.payType = "bocB2CMobile";
                } else {
                    param.payType = "bocB2C";
                }
            }
            param.returnUrl = location.href;
            if((window.__wxjs_environment === 'miniprogram')&&(param.payType == "wxNative"||param.payType == "weixin")){
                param.returnUrl = param.returnUrl.split("#")[0];
                param.returnUrl += param.ids.length>1?"#orderList":"#orderDetail-"+param.ids[0];
                var options = JSON.stringify(param);
                var path = '../../pages/pay/pay?params='+encodeURIComponent((options));
                window.wx.miniProgram.navigateTo({
                    url: path
                });
                def.resolve({msg:"小程序支付"});
                return;
            }
            this.exec3("ts/orderh","getPayInfoByIds",param).then(lang.hitch(this, function (result) {
                window.free();
                if (result.ok) {
                    result = {
                        data : {
                            item : result.result
                        }
                    };
                    result.data.item.payUrl = result.data.item.url;
                    this.invokePayParam(lang.mixin({}, param, result.data.item), def, result);
                } else {
                    // 统一由前台提示错误信息
                    def.resolve(result);
                }
            }));

            return def;
        },
        canNativeAlipay:function(){
            return !!(cordova.plugins.AliPay||cordova.plugins.alipay);
        },
        // 获取支付参数
        invokePayParam: function (params, def, result) {
            if ("weixin" == params.payType) {
                //微信网页支付
                WeixinJSBridge.invoke("getBrandWCPayRequest", params, function (res) {
                    def.resolve(result);
                });
            } else if ("wxNative" == params.payType) {
                //微信扫码支付
                this._payWithWeiXinQr(params, def, result);
            } else if("alif2f" == params.payType) {
                // 支付宝扫码支付
                this._payWithAliQr(params, def, result);
            } else if ("point" == params.payType) {
                def.resolve(result);
            } else if ("wxApp" == params.payType) {
                // 微信APP支付
                var payParams = {
                    partnerid: params.partnerid,
                    prepayid: params.prepayid,
                    noncestr: params.noncestr,
                    timestamp: params.timestamp,
                    sign: params.paySign,
                };
                Wechat.sendPaymentRequest(payParams, function () {
                    alert("支付成功");
                    def.resolve(result);
                }, function (reason) {
                    alert("支付失败: " + reason);
                    def.resolve(result);
                });
            } else if ("bocNB2B" == params.payType || "bocB2CMobile" == params.payType || "bocB2C" == params.payType) {
                if (userAgent.isMobile() && window.cordova) {
                    var ref = window.open(params.payUrl, "_blank");
                    ref.addEventListener("exit", function () {
                        def.resolve(result);
                        ref.removeEventListener("exit", function () { });
                    });
                } else {
                    var html = "<form method='post' id='sub' action='"+params.action+"'>";
                    for (var key in params.body) {
                        html += "<input type='hidden' name='"+key+"' value='"+params.body[key]+"' />";
                    }
                    html += "</form>";
                    if(confirm("确认支付?")){
                        var w = window.open("dynamic.html","_blank");
                        if(w){
                            w.onload = function(){
                                w.title = "欢迎使用中银支付";
                                setTimeout(function(){
                                    var div = domConstruct.create("div",{
                                        style:"opacity:0.6;background-color:#000;position:absolute;top:0;left:0;width:100%;height:100%;z-index:999;"
                                    },document.body);
                                    var ddiv = domConstruct.create("div",{
                                        style:"top:33%;width:100%;text-align:center;position:relative;"
                                    },div);
                                    var styleStr = "cursor:pointer;display:inline-block;margin:20px;padding:20px;height:auto;line-height:100%;font-size:16px;border-radius:5px;font-weight:bold;";
                                    domConstruct.create("div",{
                                        "class":"footer-tab-highlight",
                                        style:styleStr,
                                        innerHTML:"支付完成",
                                        onclick:function(){
                                            div.parentNode.removeChild(div);
                                            def.resolve(result);
                                        }
                                    },ddiv);
                                    domConstruct.create("div",{
                                        "class":"footer-tab-dark",
                                        style:styleStr,
                                        innerHTML:"取消支付",
                                        onclick:function(){
                                            div.parentNode.removeChild(div);
                                            def.resolve(result);
                                        }
                                    },ddiv);
                                    w.document.body.innerHTML = html;
                                    w.document.getElementById("sub").submit();
                                },600);
                            };
                        }else{
                            alert("支付需要打开新窗口，请允许本网站打开新窗口");
                            def.resolve(result);
                        }
                    }else{
                        def.resolve(result);
                    }
                }
            } else {
                if (params.payType === "aliwap") {
                    this._payWithAliWapParam(params, def, result);
                } else {
                    var payInfo = decodeURIComponent(params.payQueryString);
                    if(cordova.plugins.AliPay){
                        cordova.plugins.AliPay.pay(payInfo, function success(e) {
                            def.resolve(result);
                        }, function error(e) {
                            alert("支付失败: " + e.memo);
                            def.resolve(result);
                        });
                    }else if(cordova.plugins.alipay){
                        cordova.plugins.alipay.payment(payInfo, function success(e) {
                            def.resolve(result);
                        }, function error(e) {
                            alert("支付失败: " + e.memo);
                            def.resolve(result);
                        });
                    }
                }
            }
        },
        // 当面付生成二维码
        _payWithAliQr: function(params, def, result) {
            require([
                "cq/util/image/qrCode"
            ], function(qrCode){
                if(paymentQrDiv && paymentQrDiv.parentNode){
                    paymentQrDiv.parentNode.removeChild(paymentQrDiv);
                }
                var div1 = domConstruct.create("div", {
                    "class": "paymentQrDiv"
                }, document.body);
                paymentQrDiv = div1;
                img1 = domConstruct.create("img", {
                    "class": "paymentQrImg",//action
                    src: qrCode.generatePNG(params.qrcode, {
                        modulesize: 5,
                        margin: 2,
                        ecclevel: "M"
                    })
                }, div1);
                img1 = domConstruct.create("span", {
                    innerHTML: "完成",
                    "class": "paymentQrBtn"
                }, div1);
                img1.onclick = function () {
                    div1.parentElement.removeChild(div1);
                    div1 = null;
                    def.resolve(result);
                };
                img1 = domConstruct.create("span", {
                    innerHTML: "取消",
                    "class": "paymentQrBtn"
                }, div1);
                img1.onclick = function () {
                    div1.parentElement.removeChild(div1);
                    div1 = null;
                    def.resolve(result);
                };
            });
        },
        // 微信支付生成支付二维码
        _payWithWeiXinQr: function (params, def, result) {
            //生成二维码
            require([
                "cq/util/image/qrCode"
            ], function (qrCode) {
                if (paymentQrDiv && paymentQrDiv.parentNode) {
                    paymentQrDiv.parentNode.removeChild(paymentQrDiv);
                }
                var div1 = domConstruct.create("div", {
                    "class": "paymentQrDiv"
                }, document.body), img1 = domConstruct.create("div", {
                    innerHTML: window.WeixinJSBridge ? "请长按二维码支付喔~~" : "微信扫一扫支付",
                    style: "font-size:20px;color:green;margin-top: 3%;"
                }, div1);
                paymentQrDiv = div1;
                img1 = domConstruct.create("img", {
                    "class": "paymentQrImg",//action
                    src: qrCode.generatePNG(params.code_url, {
                        modulesize: 5,
                        margin: 2,
                        ecclevel: "M"
                    })
                }, div1);
                img1 = domConstruct.create("span", {
                    innerHTML: "完成",
                    "class": "paymentQrBtn"
                }, div1);
                img1.onclick = function () {
                    div1.parentElement.removeChild(div1);
                    div1 = null;
                    def.resolve(result);
                };
                img1 = domConstruct.create("span", {
                    innerHTML: "取消",
                    "class": "paymentQrBtn"
                }, div1);
                img1.onclick = function () {
                    div1.parentElement.removeChild(div1);
                    div1 = null;
                    def.resolve(result);
                };
            });
        },
        // 支付宝支付打开浏览器
        _payWithAliWapParam: function (params, def, result) {
            if (params.payUrl) {
                if (window.WeixinJSBridge) {
                    return window._AP ? _AP.pay(params.payUrl) : domConstruct.create("script", {
                        type: "text/javascript",
                        src: "/static/alipay/ap.js",
                        onload: function () {
                            setTimeout(function(){
                                _AP.pay(params.payUrl);
                            },300);
                        }
                    }, document.body);
                } else if (userAgent.isMobile()) {
                    if (window.cordova) {
                        var ref = window.open(params.payUrl, "_blank");
                        ref.addEventListener("exit", function () {
                            def.resolve(result);
                            ref.removeEventListener("exit", function () { });
                        });
                        return;
                    }
                    require(["cq/util/edit/confirmFrame"], function (frame) {
                        frame.show(params.payUrl).then(function () {
                            def.resolve(result);
                        });
                    });
                } else {
                    window.location.href = params.payUrl;
                }
            } else {
                def.resolve(result);
            }
        },
        // 获取订单数量
        getDetailCount:function(data,widget){
            return this.exec("loadDetailCount",{
                shopId:this.getShopId(),
                userId:consumer.getCurrentUserId()
            }).then(lang.hitch(this, function(data){
                return data.data;
            }));
        },
        // 确认收货,在村头确认收货
        onReceipt: function(data, widget){
            if(!confirm("确认收货后,订单交易完成,钱款将立即到达商家帐户,确认?")){
                return;
            }
            window.busy();
            this.exec("receiptById",{
                _id: data._id,
                shopId:this.getShopId(),
                platform:"zct"
            }).then(lang.hitch(this, function(result){
                window.free();
                if(result&&result.data&&result.data.ok==1){
                    widget.cqRefresh();
                }else{
                    alert(result.message||"收货失败");
                }
            }));
        },
        //刷新订单
        refresh:function(data,widget){
            widget.cqRefresh();
        },
        //联系客服操作
        contactVillger: function (data) {
            // summary:
            //        联系客服页面跳转
            // view:
            //         matDetail
            // description:
            //         无
            window.busy();
            require(["bob/im/msgP/c"],function(msgP){
                msgP.toShopSvc(data.fromShopId);
            });
        },
		// 周期订单续订问题
		reNew: function(data, widget){
			// 加载订单中的商品信息
            //加载mat详细信息
            window.busy();
			require(["whz/util/matDispose","bob/mat/matC"], function(matDispose,mat){
                mat.loadByIdOpen(data.mId._id).then(lang.hitch(this,function(result){
                    window.free();
                    matDispose.getAction(result,"buyNow");
                }));
            });
		},
        //周期配送套餐
        deliveryPackage:function(data,widget){
            //若订单已发货且未暂停且未取消且未发完货且未在退款中且订单对应的商品有optId
            //:商品属性ID,tsId,detailId
            window.moveToView("matOption",data.mId._id+"-"+data.tsId+"-"+data._id);
        }
    });
});
