﻿/*
订单退款的基类
徐阿雪 3017/3/38
*/
define([
    "dojo/_base/declare"
], function (declare) {
    return declare("",null,{
        modalName:"summary/settleMonthly",
        fields:{
            monthDate:{
                type:"date",
                label:"月份"
            },
            shopName:{
                type:"text",
                label:"商家名称"
            },
            income:{
                type:"number",
                label:"本月增加",
                fixedTo:3
            },
            balanceAmount:{
                type:"number",
                label:"结余",
                fixedTo:3
            },
            realAmount:{
                type:"number",
                label:"实际结余",
                fixedTo:3
            },
            total:{
                type:"number",
                label:"总交易额",
                fixedTo:3
            },
            tranFee:{
                type:"number",
                label:"交易手续费",
                fixedTo:3
            },
            feedback:{
                type:"number",
                label:"交易补贴",
                fixedTo:3
            },
            shopPayIn:{
                type:"number",
                label:"充值",
                fixedTo:3,
            },
            shopPayOut:{
                type:"number",
                label:"提现",
                fixedTo:3
            },
            startAmount:{
                type:"text",
                label:"期初",
                fixedTo:3
            },
            weixin:{
                type:"number",
                label:"微信",
                fixedTo:3
            },
            weixinFee:{
                type:"number",
                label:"微信手续费",
                fixedTo:3
            },
            weixinRefund:{
                type:"number",
                label:"微信退款金额",
                fixedTo:3
            },
            wxNative:{
                type:"number",
                label:"微信网页",
                fixedTo:3
            },
            wxNativeFee:{
                type:"number",
                label:"微信网页交易费",
                fixedTo:3
            },
            wxNativeRefund:{
                type:"number",
                label:"微信网页退款金额",
                fixedTo:3
            },
            wxApp:{
                type:"number",
                label:"微信APP",
                fixedTo:3
            },
            wxAppFee:{
                type:"text",
                label:"微信APP手续费",
                fixedTo:3
            },
            wxAppRefund:{
                type:"number",
                label:"微信APP退款金额",
                fixedTo:3
            },
            wePay:{
                type:"number",
                label:"微信小程序",
                fixedTo:3
            },
            wePayFee:{
                type:"number",
                label:"微信小程序手续费",
                fixedTo:3
            },
            wePayRefund:{
                type:"number",
                label:"微信小程序退款金额",
                fixedTo:3
            },
            aliapp:{
                type:"number",
                label:"支付宝app",
                fixedTo:3
            },
            aliappFee:{
                type:"number",
                label:"支付宝app手续费",
                fixedTo:3
            },
            aliappRefund:{
                type:"number",
                label:"支付宝app退款金额",
                fixedTo:3
            },
            aliwap:{
                type:"number",
                label:"支付宝手机网页",
                fixedTo:3
            },
            aliwapFee:{
                type:"number",
                label:"支付宝手机网页手续费",
                fixedTo:3
            },
            aliwapRefund:{
                type:"number",
                label:"支付宝手机网页退款金额",
                fixedTo:3
            },
            aliweb:{
                type:"number",
                label:"支付宝网页",
                fixedTo:3,
            },
            aliwebFee:{
                type:"number",
                label:"支付宝网页手续费",
                fixedTo:3
            },
            aliwebRefund:{
                type:"number",
                label:"支付宝网页退款金额",
                fixedTo:3
            },
            chinaPay:{
                type:"number",
                label:"银联电子支付",
                fixedTo:3
            },
            chinaPayFee:{
                type:"number",
                label:"银联电子支付手续费",
                fixedTo:3
            },
            chinaPayRefund:{
                type:"number",
                label:"银联电子支付退款金额",
                fixedTo:3
            },
            unionpayFront:{
                type:"number",
                label:"银联前台支付",
                fixedTo:3
            },
            unionpayFrontFee:{
                type:"number",
                label:"银联前台支付手续费",
                fixedTo:3
            },
            unionpayFrontRefund:{
                type:"number",
                label:"银联前台支付退款金额",
                fixedTo:3
            },
            unionpayApp:{
                type:"number",
                label:"银联app支付",
                fixedTo:3,
            },
            unionpayAppFee:{
                type:"number",
                label:"银联app支付手续费",
                fixedTo:3
            },
            unionpayAppRefund:{
                type:"number",
                label:"银联app支付退款金额",
                fixedTo:3
            },
            unionpayBack:{
                type:"number",
                label:"银联后台支付",
                fixedTo:3
            },
            unionpayBackFee:{
                type:"number",
                label:"银联后台支付手续费",
                fixedTo:3
            },
            unionpayBackRefund:{
                type:"number",
                label:"银联后台支付退款金额",
                fixedTo:3
            },
            lineTransfer:{
                type:"number",
                label:"线下支付",
                fixedTo:3
            },
            lineTransferFee:{
                type:"number",
                label:"线下支付手续费",
                fixedTo:3,
            },
            lineTransferRefund:{
                type:"number",
                label:"线下支付退款金额",
                fixedTo:3,
            },
            bocNB2B:{
                type:"number",
                label:"中国银行B2B",
                fixedTo:3
            },
            bocNB2BFee:{
                type:"number",
                label:"中国银行B2B手续费",
                fixedTo:3
            },
            bocNB2BRefund:{
                type:"number",
                label:"中国银行B2B退款金额",
                fixedTo:3
            },
            bocB2C:{
                type:"number",
                label:"中国银行B2C",
                fixedTo:3
            },
            bocB2CFee:{
                type:"number",
                label:"中国银行B2C手续费",
                fixedTo:3
            },
            bocB2CRefund:{
                type:"number",
                label:"中国银行B2C退款金额",
                fixedTo:3
            },
            bocB2CMobile:{
                type:"number",
                label:"中国银行B2C移动支付",
                fixedTo:3
            },
            bocB2CMobileFee:{
                type:"number",
                label:"中国银行B2C移动支付手续费",
                fixedTo:3
            },
            bocB2CMobileRefund:{
                type:"number",
                label:"中国银行B2C移动支付退款金额",
                fixedTo:3
            },
            gold:{
                type:"number",
                label:"金元宝",
                fixedTo:3
            },
            goldFee:{
                type:"number",
                label:"金元宝手续费",
                fixedTo:3
            },
            goldRefund:{
                type:"number",
                label:"金元宝退款金额",
                fixedTo:3
            },
            "fromShopId.shopName":{
                type:"text",
                label:"商家名称"
            },
            onlineIncome:{
                type:"number",
                label:"在线支付金额",
                fixedTo:3
            },
            point:{
                type:"number",
                label:"积分",
                fixedTo:3
            }
        }
    });
});
