//订单系统消费者端
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    '../BoBase',
    "cq/util/config/config"
], function (declare, lang, BoBase, config) {
    //消费者管理订单的对象
    var O = declare('', [BoBase.B], {
        modalName:"ts/accountCurrent",
        fields:{
            _id:{
                type:"text"
            },
            createAt:{
                type:"dateTime",
                label:"时间",
                qry:{
                    type:"date",
                    label:"日期"
                }
            },
            settleType:{
                type:"options",
                label:"类型",
                options:{
                    "shop.pendingAmount":"待结算",
                    "shop.availableAmount":"可提现"
                }
            },
            invoceId:{
                type:"text",
                label:"单号"
            },
            invoceType:{
                type:"options",
                label:"单据",
                options:{
                    Order:"订单",
                    RechargeOrder:"客户充值",
                    ShopPayLog:"充值/提现",
                    RefundApplication:"退款",
                    DeliveryLog:"周期配送"
                }
            },
            opType:{
                type:"options",
                label:"操作",
                options:{
                    payed:"支付本金",
                    prePayed:"支付定金",
                    signed:"签收",
                    verified:"审核",
                    refunded:"退款",
                    created:"提交"
                }
            },
            startAmount:{
                type:"number",
                fixedTo: 2,
                label:"期初"
            },
            inAmount:{
                type:"number",
                fixedTo: 2,
                label:"收"
            },
            outAmount:{
                type:"number",
                fixedTo: 2,
                label:"支"
            },
            balanceAmount:{
                type:"number",
                fixedTo: 2,
                label:"结余"
            },
            remark:{
                type:"text"
            }
        },
        getQueryLayout:function(){
            return [{
                type: 'form',
                fields: this.getFormItems(['createAt',"settleType"], true,"qry")
            }];
        },
        getListParam:function(params){
            if(!params.query.createAtf){
                alert("请选择开始日期");
            }
            if(!params.query.createAtt){
                alert("请选择结束日期");
            }
            if(!params.query.settleType){
                alert("请选择类型");
            }
            return params.query;
        },
        getListUrl:function(){
            return this.getBaseUrl()+"/load?shopId="+this.getShopId()+"&platformShopId="+config.platformShopId;
        },
        onListClick:function(data){
            switch(data.invoceType){
                case "Order":
                case "RefundApplication":
                case "DeliveryLog":
                    return window.moveToView("orderDetailB",data.invoceId);
                case "ShopPayLog":
                    return window.moveToView("shopBalanceDepDetailB",data.invoceId);
                default:
                    return;
            }
        },
        getExportLayout: function(){
            return this.getFormItems(["createAt","startAmount","inAmount","outAmount","balanceAmount","invoceType","invoceId","opType","remark"]);
        }
    });
    var o = new O();
    o.Bo = O;
    return o;
});