define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "../BoBase",
    "./_CartMixin",
    "../shop/shopB2B"
],function(declare,lang,topic,BoBase,_CartMixin,shop){
    return declare("",[BoBase.B,_CartMixin],{
        shopBo:shop,
        
        //购物车列表需要显示部分字段
        fields:{
            //商品基本信息
            //商品ID
            _id:{
                type:"text",
            },
            //图标
            logo:{
                type:"text",
            },
            //商品名称
            mName:{
                type:"text",
            },
            //购物车数量
            cartQty:{
                type:"text"
            },
            //库存
            qty:{
                type:"text"
            },
            //采购价
            purchasePrice:{
                type:"text"
            },
            retailPrice:{
                type:"text"
            },
            sizeType: {
                type: "text"
            },
            //供应商
            //供货商id
            "fromShopId._id":{
                type:"text"
            },
            //供货商名称
            "fromShopId.shopName":{
                type:"text"
            }
            
        },
        //获取加载购物车商品的url
        getListUrl:function(){
            return this.getBaseUrl()+"/loadMat";
        },
        getTypeProp:function(data){
            data.selected = "sort"===data._id;
            return data;
        },
        initCartMatInfo:function(){
            var ids = this.getIds();
            if(ids&&ids.length){
                return this.exec("loadMat",{
                    ids:this.getIds()
                }).then(lang.hitch(this,function(data){
                    if(data.data){
                        data = data.data;
                    }
                    if(data.items){
                        data = data.items;
                    }
                    this.matHash = {};
                    for(var i=0;i<data.length;i++){
                        this.matHash[data[i]._id] = data[i];
                    }
                }));
            }else{
                this.matHash = {};
                return this.defTest({});
            }
        },
    });
   
});
