define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "./cartB"
],function(declare,lang,topic,cartB){
    var CartB2B = declare("",[cartB],{
        type:"b2b",
        
        getSelectedMids:function(){
            return this.getIds();
        },
        getTypeProp:function(data){
            data.selected = "sort"===data._id;
            return data;
        },
        //获取加载购物车中商品的查询条件
        //      指定分类的采购商品
        //      指定商家供货的商品
        //      购物车中已添加的商品
        getListParam:function(cqRefInfo,list,dataOptions){
            var query = {
                shopId:this.getShopId(),
                isPurchase:true,
                //isUse:true,
                preventSelf:true
            };
            if(cqRefInfo.type){
                if(cqRefInfo.type._id==="cart"){
                    query.ids = this.getIds();
                }else if(cqRefInfo.type._id==="sort"&&cqRefInfo.sort&&cqRefInfo.sort._id){
                    query.sortId = cqRefInfo.sort._id;
                }
            }
            return query;
        },
        onListClick:function(data,action,list){
            if(data){
                this.matHash[data._id] = data;
                var oldNum = data.cartQty||0,newNum = oldNum||0;
                
                if(action==="inc"){
                    //若增加
                    newNum = oldNum>0?oldNum+1:(data.minQty||0)+1;
                }else if(action==="sub"){
                    //若减少
                    newNum = oldNum>0&&(!data.minQty||oldNum>data.minQty)?oldNum-1:0;
                }
                
                if(oldNum!==newNum){
                    //若数量发生了变化，修改数据本身
                    this.setMatQty(data._id,newNum);
                    //通知上级列表，商品发生了变化
                    data.cartQty = newNum;
                    list.onMatChanged(data,oldNum,newNum);
                }
            }
        },
        
        //获取购物车中商品总数量和总金额
        getCartAmtInfo:function(){
            var info = this.getCartInfo(),amtInfo = {
                qty:0,total:0
            },mat;
            for(var mid in info){
                amtInfo.qty += info[mid]-0;
                mat = this.matHash[mid];
                amtInfo.total += (mat&&(mat.purchasePrice||mat.retailPrice)||0)*info[mid];
            }
            return amtInfo;
        },
        //获取按照标准分类的商品数量信息
        getSortedQty:function(){
            var sortQtyInfo = {
                "":0
            };
            var info = this.getCartInfo(),mat,sortId = "";
            for(var mid in info){
                mat = this.matHash[mid];
                if(mat){
                    sortId = mat.sortId&&mat.sortId._id||mat.sortId;
                    sortQtyInfo[sortId] = sortQtyInfo[sortId]||0;
                    sortQtyInfo[sortId] += info[mid];
                    sortQtyInfo[""] += info[mid];
                }
            }
            return sortQtyInfo;
        }
    });
    var cartB2B = new CartB2B();
    topic.subscribe("whz/shop/changed",function(){
        cartB2B.initCartMatInfo();
    });
    return cartB2B;
});