define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "./cartB"
],function(declare,lang,topic,cartB){
    var CartB2C = declare("",[cartB],{
        type:"b2c",
        fields:{
            specName:{
                type:'text'
            }
        },
        //商品详情添加到购物车,
        addMatAndQty:function(mid,qty,params){
            //params里面param.specs和配送此时
            if(!mid){
                return;
            }
            if(params&&params.specs&&params.specs._id){
                this._addLastSpecs(params.specs);
            }
            if(qty>0){
                var info = this.getCartInfo();
                info[mid] = (info[mid]||0)+parseInt(qty);
                if(params){
                    if(info[mid]>params.specs.qty){
                        info[mid] = params.specs.qty;
                        alert("购买数量不能超过"+params.specs.qty);
                    }    
                }
                this.setCartInfo(info);
                return info;
            }
        },
        getSelectedMids:function(){
            return this.getMids();
        },
        getMids:function(){
            var ids = [],info = this.getCartInfo();
            for(var mid in info){
                if(mid){
                    ids.push(mid);
                }
            }
            return ids;
        },
        getParamMethod:function(){
            var fromShopId = this.getShopId();
            return {fromShopId: fromShopId};
        },
        onListClickGroup:function(data,action,list){
            if(action&&data){
                if(action==="del"){
                    this.setMatQty(data.mid?data.mid:data._id,0);
                    item = list.getItemById(data._id);
                    item.destroyRecursive();
                    list.onMatChanged();
                    if(this.matHash[data.matId?data.matId:data._id]){
                        delete this.matHash[data.matId?data.matId:data._id];
                        this.deleteMid(data.matId?data.matId:data._id);
                    }
                    return;
                }
                this.matHash[data._id] = data;
                var oldNum = data.cartQty||0,newNum = oldNum||0;
                var updataItem = lang.hitch(this,function(){
                    if(oldNum!==newNum){
                        if(!data.specs||data.specs.length===0||action!="inc"){
                            this.setMatQty(data._id,newNum);
                        }
                        //通知上级列表，商品发生了变化
                        data.cartQty = newNum;
                        list.onMatChanged(data,oldNum,newNum);
                    }
                });
                if(data.isCycle&&action==="inc"){
                    require(["whz/util/matDispose"], lang.hitch(this,function(matDispose){
                        matDispose.getAction(data,"buyNow","cartB"); 
                        this.setMatQty(data._id,newNum);
                        delete this.matHash[data._id];
                    }));
                    return;
                }
                if(data.specs&&(data.specs.length>0)&&action==="inc"){
                    require(["whz/util/matDispose"], lang.hitch(this,function(matDispose){
                        matDispose.getAction(data,"addTo","cartB");
                        this.addQtyHandle = list.connect(this,"addMatAndQty",lang.hitch(this,function(mid,qty,params){
                            newNum = matDispose.purchNum+oldNum;
                            data.mid = mid;
                            updataItem();
                            clearHandle();
                        }));
                        this.hideHandle = list.connect(matDispose.overlay,"hide",lang.hitch(this,function(){
                            clearHandle();
                        }));
                        var clearHandle = lang.hitch(this,function(){
                            if(this.addQtyHandle){
                                this.addQtyHandle.remove();
                                this.addQtyHandle = null;
                            }
                            if(this.hideHandle){
                                this.hideHandle.remove();
                                this.hideHandle = null;
                            }
                        });
                    }));
                    return;
                }
                if(action==="inc"){
                    //若增加
                    newNum = data.minQty>0&&!oldNum?data.minQty:oldNum+1;
                    if(data.qty&&newNum>data.qty){
                        newNum = data.qty;
                        alert("购买数量不能超过" + data.qty);
                    }
                }else if(action==="sub"){
                    //若减少
                    newNum = oldNum>0&&(!data.minQty||oldNum>data.minQty)?oldNum-1:0;
                }
                updataItem();    
            }
        },
        //获取购物车中商品总数量和总金额
        getCartAmtInfo:function(){
            var info = this.getCartInfo(),amtInfo = {
                qty:0,total:0
            },mat;
            for(var mid in info){
                var ids = mid.split("_");
                if(ids.length===2){
                    mat = this.matHash[ids[0]];
                    if(!mat) continue;
                    if(mat&&mat.specs&&mat.specs.length){
                        for(var j=0;j<mat.specs.length;j++){
                            if(mat.specs[j]._id === ids[1]){
                                amtInfo.total += (mat&&(mat.specs[j].price)||0)*info[mid];    
                                break;
                            }
                        }
                    }
                }else{
                    mat = this.matHash[mid];
                    if((mat&&mat.isCycle)||!mat) continue;
                    amtInfo.total += (mat&&(mat.purchasePrice||mat.retailPrice)||0)*info[mid];
                }
                amtInfo.qty += info[mid]-0;
            }
            return amtInfo;
        },
        // 按在商品分类获取商品数量信息
        getGroupQty:function(){
            var groudQtyInfo = {
                "":0
            };
            var info = this.getCartInfo(),mat,groupId = "";
            var specMatIds = {};
            for(var mid in info){
                if(mid.indexOf('_')!==-1){
                    mid = mid.split("_")[0];
                    if(specMatIds[mid]){
                        continue;
                    }
                    specMatIds[mid] = true;
                }
                mat = this.matHash[mid];
                if(mat&&mat.isCycle) continue;
                if(mat){
                    if(mat.specs&&mat.specs.length){
                        for(var i=0;i<mat.specs.length;i++){
                            var id = mat._id+"_"+mat.specs[i]._id
                            groupId = mat.groupId&&mat.groupId._id||"";
                            groudQtyInfo[groupId] = groudQtyInfo[groupId]||0;
                            groudQtyInfo[groupId] += info[id]||0;
                        }
                    }else{
                        groupId = mat.groupId&&mat.groupId._id||"";
                        groudQtyInfo[groupId] = groudQtyInfo[groupId]||0;
                        groudQtyInfo[groupId] += info[mid]||0;    
                    }
                }
            }
            return groudQtyInfo;
        },
        
        // 重写getMatQtys方法 
        getMatQtys:function(params){
            // params 参数在用于处理周期商品 周期商品时params!==""
            var mids = this.getSelectedMids(),info = this.getCartInfo(),cycle = this.getCartCycle(),matQtys = [];
            for(var i=0;i<mids.length;i++){
                if(info[mids[i]]){
                    if(cycle[mids[i]]){
                        if(params!==""){
                            matQtys = [];
                            matQtys.push({
                                mid:mids[i],
                                qty:info[mids[i]],
                                deliveryCycle:cycle[mids[i]].deliveryCycle,
                                deliveryCycleDetail:cycle[mids[i]].deliveryCycleDetail,
                                deliveryCycleEachNum:cycle[mids[i]].trgNum,
                                totalDeliveryTimes:cycle[mids[i]].totalDeliveryTimes
                            }); 
                            break;
                        }
                        
                    }else{
                        matQtys.push({
                            mid:mids[i],
                            qty:info[mids[i]]
                        });
                    }
                }
            }
            return matQtys;
        },
        getItemParam:function(data){
            var info = this.getCartInfo();
            if(!data.isCycle&&data.specs&&data.specs.length){
                var qty = 0;
                for(var i=0;i<data.specs.length;i++){
                    var mid = data._id+"_"+data.specs[i]._id;
                    qty += info[mid]||0;
                }
                data.cartQty = qty;
            }else{
                data.cartQty = info[data._id]||0;
                if(data.isCycle&&data.specs&&data.specs.length){
                    for(var i=0;i<data.specs.length;i++){
                        var mid = data._id+"_"+data.specs[i]._id;
                        if(info[mid]){
                            delete info[mid]
                        }
                        if(data.cartQty!==0&&info[data._id]){
                            delete info[data._id];
                        }
                        data.cartQty=0;
                    }
                    this.setCartInfo(info);
                }else if(data.isCycle&&data.cartQty){
                    data.cartQty = 0;
                    delete info[data._id];
                    this.setCartInfo(info);
                }
            }
            return data;
        },
        getCartItemParam:function(data){
            if(data.specs&&data.specs.length){
                var info = this.getCartInfo();
                var qty = 0;
                for(var i=0;i<data.specs.length;i++){
                    var mid = data.mid;
                    qty = info[mid];
                }
                data.cartQty = qty;
            }else{
                data.cartQty = this.getCartInfo()[data.mid?data.mid:data._id]||0;
            }
            return data;
        },
        getPacTeamId:function(){
            return "";
        }
    });
    var cartB2C = new CartB2C();
    topic.subscribe("whz/shop/changed",function(){
        cartB2C.initCartMatInfo();
    });
    return cartB2C;
});