﻿/*
周期订单配送记录的基类
徐阿雪 2017/4/27
*/
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/util/edit/confirmFrame2"
], function (declare,lang,confirmIFrame) {
    return declare("",null,{
        modalName:"ts/deliveryLog",
        fields:{
            deliveryTimes:{
                type:"text",
                canEdit:"false"
            },
            deliveryDate:{
                type:"date",
                canEdit:"false"
            },
            qty:{
                type:"text",
                canEdit:"false",
                label:"数量"
            },
            deliveryTypeMsg:{
                type:"text",
                canEdit:"false",
                label:"物流配送公司"
            }
        },
		getListParam: function(params){
            // summary:
            //         周期订单查看物流列表加载query条件
            // view:
            //         cycleOrderLogistics：周期订单查看物流列表
            // description:
            //tsId-shopId
			return {
				shopId: this.getShopId(),//params.cqViewParam.params.split("-")[1]||
				tsId: params.cqViewParam.params//.split("-")[0]
			};
        },
        getListUrl:function(){
            // summary:
            //         周期订单查看物流列表数据重载接口
            // view:
            //         cycleOrderLogistics：周期订单查看物流列表
            // description:
            return this.getBaseUrl()+"/loadByTsId";
        },
        getItemProp:function(data){
            // summary:
            //         周期订单查看物流列表数据重载接口
            // view:
            //         cycleOrderLogistics：周期订单查看物流列表
            // description:  
            //第几次发货
            data.deliveryDate = data.deliveryTime;
            data.deliveryTimes = "第"+data.nthTimes+"次";
            data.deliveryTypeMsg = (data.deliveryType==1?"商家配送，联系卖家了解物流详情":data.logCo+"配送，快递单号："+data.logNo+"，点击查看物流详情");
            return data;
        },
        onListClick:function(data, action, widget){
			if(action=="receipted"){
				window.busy();
				this.exec("cycleReceiptById", {
					_id: data._id
				}).then(lang.hitch(this, function(result){
					window.free();
					if(result&&result.data&&result.data.ok==1){
						widget.cqRefresh();
					}else{
						alert(result&&result.data&&result.data.msg||"收货失败");
					}
				}));
			}else{
                window.busy();
				// 查询订单中的物流数据
				var nthTimes = data.nthTimes;
				// 如果没有物流信息或配送方式为自己配送 则提示暂无物流信息
				if(data.deliveryType==1){
					alert("暂无物流信息");
				}else{
					this.exec("loadById",{_id: data._id}).then(lang.hitch(this, function(data){
						var item = data&&data.data&&data.data.item||{};
						if(!item._id){
                            window.free();
							alert("暂无物流信息");
							return;
						}
                        require([
                            "bob/log/logC"
                        ],function(logC){
                            logC.loadCodeByName(item.logCo).then(function(code){
                                var url = "http://m.kuaidi100.com/result.jsp?com="+code+"&nu="+item.logNo;
                                confirmIFrame.show(url,"物流查询");
                            });
                            window.free();
                        });
					}));
				}
			}
        }
    });
});
