﻿define([
    "dojo/_base/declare",
    '../../BoBase',
    "./_Mixin",
    "bob/ts/orderB",
    "dojo/_base/lang"
], function (declare,BoBase,_Mixin, order, lang) {
    var O = declare("",[BoBase.B,_Mixin],{
        fields: {
            search: {
                type: "button",
                label: "查询",
                action: "search",
                buttonClass: "fullButton"
            },
            isDeliverd: {
                type: "options",
                options: {
                    "true": "已发货",
                    "false": "未发货"
                }
            },
            details: {
                type: 'objects',
                label: '待发明细',
                labelField: 'name',
                rightTextField: 'price',
                userDefinedValue:"userDefinedValue",
                canEdit:true,
                canDelete:true,
                canAdd:false,
                canDnd:false,
                fields: {
                    className:"inlineEditor",
                    layout: [{
                        field: 'dName',
                        type: 'text',
                        label: '收货人'
                    },{
                        field: 'dTel',
                        label: '收货电话',
                        type: 'text'
                    },{
                        field: 'dAddress',
                        label: '收货地址',
                        type: 'textarea'
                    },{
                        field: 'mName',
                        type: 'textarea',
                        label: '商品'
                    }, {
                        field: 'specName',
                        type: 'text',
                        label: '规格'
                    }, {
                        field: 'qty',
                        type: 'number',
                        label: '数量'
                    },{
                        field: "remark",
                        label: "备注",
                        type: "textarea"
                    },{
                        field: "chooseRecord",
                        label: "配置套餐",
                        type: "textarea"
                    }]
                }
            },
            createAt: {
                type: "dateTime",
                label: "单据创建时间"
            },
            lastMod: {
                type: "dateTime",
                label: "单据最后修改时间"
            },
            deliverTime: {
                type: "dateTime",
                label: "发货操作时间"
            },
            save: {
                type: "button",
                action: "save"
            },
            deleteById: {
                type: "button",
                action: "deleteById"
            },
            deliver: {
                type: "button",
                action: "deliver"
            },
            onDExport: {
                type: "button",
                action: "onDExport"
            }
        },
        userDefinedValue: function(widget, data){
            widget.set("label", "<div class='hflex title'><div class='flex1'>"+data.dName+"</div><div>"+data.dTel+"</div></div>"+
            "<div class='title'>"+data.dAddress+"</div>"+
            "<div class='hflex title'><div class='flex1'>"+data.mName+(data.specName?"("+data.specName+")":"")+"</div>"+
            "<div>"+data.qty+"份</div></div>"+
            "<div class='title'>"+(data.remark||"")+"</div>"+
            "<div class='title'>"+(data.chooseRecord||"")+"</div>");
        },
        getDetailsByDate: function(date){
            return order.exec("loadDeliveryWithDetails", {
                startDeliveryDate: date
            }).then(function(result){
                var details = result&&result.data&&result.data.items||[];
                var items = [];
                var currentItem = null;
                for(var i=0;i<details.length;i++){
                    currentItem = details[i];
                    items.push({
                        mName: currentItem.mName,
                        specName: currentItem.specName,
                        qty: currentItem.isCycle?(currentItem.totalDeliveryTimes-currentItem.deliveredTimes>=currentItem.deliveryCycleEachNum?
                        currentItem.deliveryCycleEachNum:currentItem.totalDeliveryTimes-currentItem.deliveredTimes):currentItem.qty,
                        dName: currentItem.dName,
                        dTel: currentItem.dTel,
                        dAddress: currentItem.dAddress,
                        remark: currentItem.remark,
                        chooseRecord: currentItem.chooseRecord,
                        tsId: currentItem.tsId,
                        detailId: currentItem._id
                    });
                }
                return items;
            });
        },
        fieldChangeMethod: function(widget, field, fieldVl){
            var data = widget.getData();
            if(field=="deliveryDate"){
                window.busy();
                data.details = [];
                widget.setData(data);
                this.getDetailsByDate(data.deliveryDate).then(function(items){
                    data.details = items;
                    widget.setData(data);
                    window.free();
                });
            }
        },
        onDataReady: function(widget){
            var data = widget.getData();
            widget.hideByFields(["deleteById","deliver","save","deliverTime"]);
            widget.enableByFields();
            if(!data._id){
                widget.showByFields(["save"]);
                widget.hideByFields(["deliverTime"]);
                widget.disableByFields(["createAt","lastMod"]);
                return;
            }
            widget.showByFields(["deliver"]);
            if(!data.isDeliverd){
                widget.hideByFields(["deliverTime"]);
                widget.showByFields(["deleteById","save"]);
            }else{
                widget.showByFields(["deliverTime"]);
                widget.disableByFields();
            }
            widget.disableByFields(["createAt","lastMod"]);
        },
        save: function(data){
            window.busy();
            var finded = false;
            var msg = "";
            for(var i=0;i<data.details.length;i++){
                if(!Number(data.details[i].qty)||Number(data.details[i].qty)<0){
                    msg = "第"+(i+1)+"行 "+data.details[i].dName+" 发货数量小于0，确定发货数量小于0？点击'确定'保存数据";
                    finded = true;
                    break;
                }
            }
            if(finded){
                if(!confirm(msg)){
                    window.free();
                    return;
                }
            }
            delete data.createAt;
            delete data.lastMod;
            return this.exec("save",data).then(function(result){
                window.free();
                if(result&&result.data&&result.data.ok==1){
                    alert("保存成功");
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"保存失败");
                }
            });
        },
        deliver: function(data, widget){
            window.busy();
            if(!confirm("发货后，满足条件的所有订单都会被发货，且操作不可逆，确认发货？若修改了配送单没有保存，发货将会先执行保存再发货")){
                window.free();
                return;
            }
            var _this = this;
            this.exec("save", data).then(function(result){
                if(result&&result.data&&result.data.ok==1){
                    _this.exec("deliver", {
                        _id: data._id
                    }).then(function(result){
                        window.free();
                        if(result&&result.data&&result.data.ok==1){
                            alert("发货成功");
                            widget.cqRefresh();
                        }else{
                            alert(result&&result.data&&result.data.message||"发货失败");
                        }
                    });
                }else{
                    window.free();
                    alert(result&&result.data&&result.data.message||"发货数据保存失败");
                }
            });
        },
        deleteById: function(data){
            window.busy();
            return this.exec("deleteById", {
                _id: data._id
            }).then(function(result){
                window.free();
                if(result&&result.data&&result.data.ok==1){
                    alert("删除成功");
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"删除成功");
                }
            });
        },
        search: function(data){
            if(!data.deliveryDate){
                alert("请先选择发货日期");
            }
        },
        getItemProp: function(item){
            if(item.isCycle){
                item.qty = item.totalDeliveryTimes-item.deliveredTimes>item.deliveryCycleEachNum?
                item.deliveryCycleEachNum:item.totalDeliveryTimes-item.deliveredTimes;
            }
            return item;
        },
        getEditLayout: function(){
            return [{
                type : "form",
                fields : this.getFormItems(["createAt","lastMod","deliveryDate","deliverTime", "details", "save", "deleteById","deliver","onDExport"], true)
            }];
        },
        loadData: function(e){
            if(!e.cqViewParam.params){
                return this.getDetailsByDate((new Date()).toISOString()).then(function(items){
                    return {
                        deliveryDate: (new Date()).toISOString(),
                        details: items
                    }
                });
            }
            else{
                return this.exec("loadById",{
                    _id: e.cqViewParam.params
                }).then(function(result){
                    return result&&result.data&&result.data.item||{};
                })
            }
        },
        initData: function(data){
            return {
                deliveryDate: (new Date()).toISOString()
            };
        },
        getListUrl: function(){
            return order.getListUrlByDelivery();
        },
        getListUrlB: function(){
            return this.getBaseUrl()+"/load?shopId="+this.getShopId()
        },
        onListClick: function(data, widget){
            window.moveToView("deliveryEdt", data._id);
        },
        loadById: function(params){
            var _id = params.cqViewParam.params;
            return this.exec("loadById", {
                _id: _id
            }).then(function(result){
                return result&&result.data&&result.data.item||{};
            });
        },
        queryInfo: {},
        getListParam: function(params){
            var param = {
                startDeliveryDate: params.query.deliveryDate
            };
            this.queryInfo = param;
            return param;
        },
        getQueryLayout: function(){
            return [{
                type: 'form',
                fields: this.getFormItems(['deliveryDate'], true)
            }];
        },
        onExport: function(widget){
            var query = this.queryInfo;
            var url = this.getListUrl();
            require([
                "cq/util/sys/xlsx",
                "cq/util/sys/date",
                "cq/util/sys/userAgent",
                "cq/util/config/config"
            ],lang.hitch(this,function(xlsx,date,userAgent,config){
                if(userAgent.isBrowser){
                    //依据url和query加载所有要到处的订单数据
                    xlsx.loadAllData(url,query).then(lang.hitch(this,function(items){
                        var datas = this.getExportDatas(items);
                        //导出成xlsx文件
                        xlsx.exportMatrix(datas,Date.now().toString());
                    }));
                }
            }));
        },
        getExportDatas: function(items){
            //设置表头
            var datas = [["订单号","收货人",
            "收货电话","收货地址","商品名称", "规格", "数量","备注","套餐配置信息"]];
            //初始化订单数据
            for(var i=0;i<items.length;i++){
                var data = items[i];
                //if(data.isCycle){
                //    data.qty = data.totalDeliveryTimes-data.deliveredTimes>data.deliveryCycleEachNum?data.deliveryCycleEachNum:data.totalDeliveryTimes-data.deliveredTimes;
                //}
                datas.push([data.tsId,data.dName,data.dTel,data.dAddress,data.mName,data.specName,data.qty,data.remark,data.chooseRecord]);
            }
            return datas;
        },
        getDetailsByIdUrl: function(){
            return this.getBaseUrl()+"/loadDetailsById?shopId="+this.getShopId();
        },
        onDExport: function(data, widget){
            var url = this.getDetailsByIdUrl();
            require([
                "cq/util/sys/xlsx",
                "cq/util/sys/date",
                "cq/util/sys/userAgent",
                "cq/util/config/config"
            ],lang.hitch(this,function(xlsx,date,userAgent,config){
                if(userAgent.isBrowser){
                    //依据url和query加载所有要到处的订单数据
                    xlsx.loadAllData(url,{
                        _id: data._id
                    }).then(lang.hitch(this,function(items){
                        var datas = this.getExportDatas(items);
                        //导出成xlsx文件
                        xlsx.exportMatrix(datas,Date.now().toString());
                    }));
                }
            }));
        },
        deliverByIds: function(widget){
            if(confirm("发货后，满足条件的所有订单都会被发货，且操作不可逆，确认发货？")){
                window.busy();
                return order.deliverByIds({deliveryDate:this.queryInfo.startDeliveryDate}).then(function(result){
                    window.free();
                    if(result&&result.data&&result.data.ok==1){
                        alert("所有订单发货成功");
                    }else{
                        alert(result&&result.data&&result.data.message||"发货失败");
                    }
                });
            }
        }
    });
    var o = new O();
    o.Bo = O;
    return o;
});