// 订单系统商家端
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/query",
    "dojo/touch",
    "dojo/dom-class",
    "cq/util/config/config",
    '../BoBase',
    "./_OrderMixin",
    "cq/util/edit/overlay",
    "cq/widgets/item/order/UpdateOrderPic",
    "cq/util/sys/userAgent",
    "dojo/Deferred",
    "whz/util/orderLogistics",
    "whz/util/cycleOrderLogistics",
    "whz/util/firstdeliver",
    "bob/log/logB",
    'dojo/dom-construct',
    "cq/util/image/qrCode"
], function (declare, lang, array, query, touch, domClass, config, BoBase, _OrderMixin, overlay, UpdateOrderPic, userAgent, Deferred, orderLogistics,
cycleOrderLogistics,firstdelivery,logB,domConstruct,qrCode) {
    //卖家管理订单的对象
    var OrderBBo = declare("", [BoBase.B, _OrderMixin], {
        //字段名
        fields: {
            // 取消
            toCancel: {
                type: "button",
                action: "onCancel"
            },
            // 改价
            toMdfPrc: {
                type: "button",
                action: "onUpdateDiscountAmount"
            },
            // 审核
            toAccpet: {
                type: "button",
                action: "onAccpet"
            },
            // 发货
            toDelivery: {
                type: "button",
                action: "onDelivery"
            },
            state: {
                type: "text",
                label: "状态"
            },
            contactPartner: {
                type: "button",
                action: "contactPartner"
            },
            copyInfo: {
                type: "button",
                action: "copyInfo"
            },
            dName: {
                type: "text",
                label: "收货人",
                placeHolder: "收货人",
                notNull: true
            },
            dTel: {
                type: "text",
                label: "收货电话",
                placeHolder: "收货电话",
                notNull: true
            },
            dAddress: {
                type: "textarea",
                label: "收货地址",
                placeHolder: "收货地址",
                notNull: true
            },
            startDeliveryDate: {
                type: "date",
                label: "开始配送日期"
            },
            nextDeliveryTime: {
                type: "date",
                label: "下次配送日期"
            },
            deliveryCycle: {
                type: "options",
                label: "配送周期",
                options: {
                    1: "日",
                    2: "周",
                    3: "月",
					4: "每两周"
                }
            },
            deliveryCycleEachNum: {
                type: "number",
                label: "每次配送"
            },
            deliveryCycleDetail: {
                type: "button",
                label: "配送模式",
                action: "getDeliveryCycleDetail"
            },
            remark: {
                type: "textarea",
                label: "备注"
            },
            save: {
                type: "button",
                action: "save"
            },
            "userId.nickName": {
                type: "text",
                label: "微信昵称"
            },
            "userId.pName": {
                type: "text",
                label: "姓名"
            },
            "userId.userName": {
                type: "text",
                label: "登录名"
            },
            payed:{
                // 支付
                type:'button',
                action:'toPayed'
            },
            cDeliv:{
                type:'button',
                action:'cancalDeliv'
            },
            cPayed:{
                // 取消支付
                type:'button',
                action:'cancelPayed'
            },
            refundP:{
                type:"button",
                action:"refundOrderP"
            },
            clearTranFee:{
                type:"button",
                action:"clearTranFee",
                label:"免邮"
            }
        },
        toOrderDetailB: function(data, widget){
            window.moveToView("orderDetailB", data._id);
        },
        toOrderDetailP: function(data, widget){
            window.moveToView("orderDetailP", data._id);
        },
        updateUser: function(data, widget){
            if(confirm("确认修改订单下单客户？")){
                window.busy();
                require([
                    "cq/util/edit/jsonRef",
                    "bob/user/customer"
                ],lang.hitch(this, function(jsonRef, customer){
                    window.free();
                    jsonRef.startEdit({_id:data.userId},widget.getView(),{
                        target: customer.getUserListUrl(),
                        getDataLabel: function (data) {
                            return '<div style="min-width:160px;display:inline-block;">' + array.map(["nickName","pName","userName"], function (field) {
                                return data[field] || "";
                            }).join('</div><div style="min-width:160px;display:inline-block;">') + "</div>";
                        },
                        searchField: "search",
                        labelField: "nickName,pName,userName",
                        multiselect: "",
                        query: {isFarmer: false}
                    }).then(lang.hitch(this, function(user){
                        window.busy();
                        if(!(user&&user._id)){
                            alert("请选择客户，修改失败");
                            window.free();
                        }
                        this.exec("updateUser", {
                            tsId: data._id,
                            userId: user._id
                        }).then(function(result){
                            window.free();
                            if(result&&result.data&&result.data.ok==1){
                                alert("修改成功");
                                widget.cqRefresh();
                            }else{
                                alert(result&&result.data&&result.data.message||"修改失败");
                            }
                        });
                    }));
                }));
            }
        },
        mdfOrder: function(data){
            if(!data._id){
                return;
            }
            window.moveToView("updateOrder", data._id);
        },
        fieldChangeMethod: function(widget, field, fieldVl){
            if (field == 'deliveryCycle') {
                this.initDelivery(widget);
            }
        },
        // 初始化周期运送时间
        initDelivery: function (widget) {
            var data = widget.getData();
            if (!data.deliveryCycle) {
                alert('请先选择配送周期');
                return;
            }
            var node = widget.getElementByField('deliveryCycleDetail');
            domConstruct.empty(node);
            switch (data.deliveryCycle.toString()) {
                case '1':
                    domConstruct.place(this.createEveryDay(widget), node, 'last');
                    break;
                case '2':
                    domConstruct.place(this.createWeek(widget), node, 'last');
                    break;
                case '3':
                    domConstruct.place(this.createLuna(widget), node, 'last');
                    break;
				case '4':
					domConstruct.place(this.createWeek(widget), node, "last");
					break;
                default:
                    node.innerHTML = '配送时间';
            }
        },
        // 创建每天的显示内容
        createEveryDay: function (widget) {
            var node;
            node = domConstruct.create('div', {
                "class": 'trg-pack'
            });
            domConstruct.create('div', {
                "class": 'trg-list',
                innerHTML: '每天'
            }, node);
            domConstruct.create('div', {
                "class": 'trg-list',
                innerHTML: '工作日'
            }, node);
            domConstruct.create('div', {
                "class": 'trg-list',
                innerHTML: '周末'
            }, node);
            widget.connect(node, 'click', lang.hitch(this, function (e) {
                var dom = e.target;
                if (domClass.contains(dom, 'trg-list')) {
                    query('.trg-list', node).forEach(function (item) {
                        domClass.remove(item, 'trg-selector');
                    });
                    domClass.add(dom, 'trg-selector');
                }
            }));
            return node;
        },
        // 创建每周的显示内容
        createWeek: function (widget) {
            var node;
            node = domConstruct.create('div', {
                "class": 'trg-pack'
            });
            var week = ['周日', ' 周一', '周二', '周三', '周四', '周五', '周六'];
            array.forEach(week, function (item, key) {
                domConstruct.create('div', {
                    "class": 'trg-list',
                    innerHTML: item
                }, node);
            });
            widget.connect(node, 'click', this.trgSelector);
            return node;
        },
        // 创建每月显示的内容
        createLuna: function (widget) {
            var node;
            node = domConstruct.create('div', {
                "class": 'trg-pack'
            });
            array.forEach(Array.apply(null, {
                length: 31
            }), function (item, key) {
                domConstruct.create('div', {
                    "class": 'trg-list',
                    innerHTML: key + 1 + '号'
                }, node);
            });
            widget.connect(node, 'click', this.trgSelector);
            return node;
        },
        // 选中的处理
        trgSelector: function (e) {
            var node = e.target;
            if (domClass.contains(node, 'trg-list')) {
                if (domClass.contains(node, 'trg-selector')) {
                    domClass.remove(node, 'trg-selector');
                } else {
                    domClass.add(node, 'trg-selector');
                }
            }
        },
        // 获得初始化内容
        getDelivery: function (data, widget) {
            if (!data.deliveryCycle) {
                alert('请先选择配送周期');
                return;
            }
        },
        getUpdateOrderLayout: function(){
            return [{
                type: "form",
                fields: this.getFormItems(["dName", "dTel","dAddress","startDeliveryDate",
                "deliveryCycle", "deliveryCycleDetail","deliveryCycleEachNum","remark","save"])
            }];
        },
        canSaveFields: ["dName", "dTel","dAddress","startDeliveryDate","deliveryCycleEachNum",
                "deliveryCycle", "remark"],
        save: function(data, widget){
            window.busy();
            var msg = this.getDataValidMsg(data, ["dName", "dTel","dAddress"]);
            if(msg){
                alert(msg);
                window.free();
                return;
            }
            var node = widget.getElementByField('deliveryCycleDetail');
            // 初始化配送事件
            var deliveryData = '0000000000000000000000000000000';
            deliveryData = deliveryData.split('');
            query('.trg-list', node).forEach(lang.hitch(this, function (item, key) {
                if (domClass.contains(item, 'trg-selector')) {
                    deliveryData[key] = 1;
                }
            }));
            var selector = array.some(deliveryData, function (item) {
                return item == 1;
            });
            deliveryData = deliveryData.join('');
            if (data.isCycle&&!selector) {
                alert('请选择配送周期');
                window.free();
                return;
            }
            if(data.isCycle&&data.deliveryCycleEachNum<0){
                alert("每次配送输入不合法");
                window.free();
                return;
            }
            var data1 = {
                tsId: data._id,
                deliveryCycleDetail: deliveryData
            };
            for(var i=0;i<this.canSaveFields.length;i++){
                if(data[this.canSaveFields[i]]!=""){
                    data1[this.canSaveFields[i]] = data[this.canSaveFields[i]];
                }
            }
            this.exec("updateOrderH", data1).then(function(result){
                window.free();
                if(result&&result.data&&result.data.ok==1){
                    alert("修改成功");
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"修改失败");
                }
            });
        },
        onUpdateOrderDataReady: function(widget){
            var data = widget.getData();
            widget.hideByFields(["deliveryCycle", "deliveryCycleDetail","deliveryCycleEachNum"]);
            if(!data._id){
                return;
            }
            if(data.isCycle){
                widget.showByFields(["deliveryCycle", "deliveryCycleDetail","deliveryCycleEachNum"]);
                if (data.deliveryCycleDetail) {
                    this.initDelivery(widget);
                    var node = widget.getElementByField('deliveryCycleDetail');
                    var deliveryData = data.deliveryCycleDetail.split('');
                    query('.trg-list', node).forEach(function (item, key) {
                        if (deliveryData[key] == 1) {
                            domClass.add(item, 'trg-selector');
                        }
                    });
                }
            }
        },
        loadUpdateOrderWithDetails: function(e){
            var tsId = e&&e.cqViewParam&&e.cqViewParam.params||"";
            if(!tsId){
                return {};
            }
            return this.exec("loadWithDetails", {_id: tsId}).then(function(result){
                var items = result&&result.data&&result.data.items;
                if(!items.length){
                    return {};
                }
                var item = items[0];
                item.dName = item.details[0].dName;
                item.dTel = item.details[0].dTel;
                item.dAddress = item.details[0].dAddress;
                item.startDeliveryDate = item.details[0].startDeliveryDate||item.startDeliveryDate;
                if(item.isCycle){
                    item.nextDeliveryTime = item.details[0].nextDeliveryTime;
                    item.deliveryCycleDetail = item.details[0].deliveryCycleDetail;
                    item.deliveryCycle = item.details[0].deliveryCycle;
                    item.deliveryCycleEachNum = item.details[0].deliveryCycleEachNum;
                }
                return item;
            });
        },
        copyInfo: function(data, widget){
            require(["cq/util/share/share"], function(share){
                var item = {
                    url: data.details[0].dName+" "+data.details[0].dTel+" "+data.details[0].dAddress
                };
                share.copyUrl(item);
            });
        },
        //状态
        getOrderStatus:function(data){
            /*全部:已支付
            //待发货:已支付且未取消且(未审核或未发货)
            //已发货:已支付且未取消且已发货
            //已完成:已支付且未取消且已关闭
            //退款中:已支付且退款状态不为空且退款状态<4
            //已取消:已支付且已取消*/
            var state = "";
            if(data.isPayed){
                //state = "全部";
                //已付款
                if(!data.isCanceled){
                    if(data.refundState&&data.refundState < 3&&data.refundState > 1){
                        state = "退款中";
                    }else if(data.refundState&&data.refundState==3){
						state = "已退款";
					}else if(data.isClosed){
                        state = "已完成";
                    }else if(data.isReceipted){
                        state = "已收货";
                    }else if(data.isDelived){
                        state = "已发货";
                    }else{
                        state = "待发货";
                    }
                }else{
                    state = "已退款";
                }
            }else {
				//未付款
                if(data.isCanceled){
                    //已取消
                    state = "已取消";
                }else{
                    // 判断是否预售订单
                    if(data.preSaleId){
                        if(data.isPreAmountPayed){
                            state = "已支付";
                        }else{
                            state = "待付款";
                        }
                    }
                    else{
                        //待付款
                        state = "待付款";
                    }
                }
			}
            return state;
        },
        /*
            订单列表页面相关
                商家订单列表获取url
                web端列表点击事件
        */
        // 加载订单列表的url
        getListUrl: function () {
            return this.getBaseUrl() + "/loadWithDetails?shopId=" + this.getShopId() + "&fromShopId=" + this.getShopId();
        },
        getListUrlByDis: function(){
            return this.getBaseUrl() + "/loadWithDetails?shopId=" + this.getShopId() + "&userShopId=" + this.getShopId()+"&neFromShopId="+this.getShopId();
        },
        // 加载可配送列表
        getListUrlByDelivery: function(){
            return this.getBaseUrl()+"/loadDeliveryWithDetails?shopId="+this.getShopId()+"&fromShopId="+this.getShopId();
        },
        getListUrlForP: function(){
            return this.getBaseUrl() + "/loadWithDetails?shopId=" + this.getShopId();
        },
        //orderListP也是用的筛选条件
        getListParamP: function (params) {
            var query = this._getListQuery(params);
            // 要查询到预售订单已支付定金部分的订单
            //query.isPayed = true;
            //query.isPreAmountPayed = true;
            query.payed = true;
            // 如果有did 则修改userId
            if(params&&params.cqViewParam&&params.cqViewParam.params){
                query.userId = params.cqViewParam.params;
            }
            if (params.state) {
                //query.isPayed = true;
                //待发货
                if (params.state._id == 2) {
                    query.isCanceled = false;
                    //已支付且未取消且(未审核或未发货)
                    //query.isAccepted = true;
                    query.isDelived = false;
                    //query.isAccepted = false;
                }
                //已发货
                else if (params.state._id == 3) {
                    query.isCanceled = false;
                    query.isDelived = true;
                    //query.isClosed = false;
                }
                //已完成//已支付且未取消且已关闭
                else if (params.state._id == 4) {
                    query.isCanceled = false;
                    query.isClosed = true;
                }
                //orderListP 已取消,
                else if (params.state._id == 6 ){
                    query.isCanceled = true;
                }
                //orderListP的退款中
                else if(params.state._id == 7){
                    //query.isCanceled = true;
                    query.refundState = 2;
                }
            }
            if(params.filter){
                for(var i in params.filter){
                    query[i] = params.filter[i];//JSON.stringify()
                }
            }
			this.pltQueryInfo = query;
            return query;
        },
        pltQueryInfo: null,
		queryInfo: null,
        // 加载订单列表的条件,
        getListParam: function (params) {
            var query = this._getListQuery(params);
            // 如果有did 则修改userId
            if(params&&params.cqViewParam&&params.cqViewParam.params){
                query.userId = params.cqViewParam.params;
            }
            if (params.state) {
                //待付款
                if (params.state._id == 1) {
                    query.isPayed = false;
                    query.isCanceled = false;
                }
                //待发货
                else if (params.state._id == 2) {
                    query.isPayed = true;
                    query.isCanceled = false;
                    // 已支付 未审批或者未发货的都叫未发货
                    //query.isAccepted = true;
                    query.isDelived = false;
                }
                //已发货
                else if (params.state._id == 3) {
                    query.isPayed = true;
                    query.isCanceled = false;
                    query.isDelived = true;
                    query.isClosed = false;
                }
                //已完成
                else if (params.state._id == 4) {
                    query.isPayed = true;
                    query.isCanceled = false;
                    query.isReceipted = true;
                }
                //退款中
                else if (params.state._id == 5) {
                    query.isPayed = true;
                    query.refundState = 2;
                }
            }
            if(params.filter){
                for(var i in params.filter){
                    query[i] = params.filter[i];//JSON.stringify()
                }
            }
			this.queryInfo = query;
            return query;
        },
        /*
           订单详情页面相关
             订单详情数据加载
             相关操作按钮的显示隐藏
        */
        // 订单详情加载完成后的处理
        onDataReady: function (widgets) {
            widgets.hideByFields(['payed','cDeliv','cPayed',"clearTranFee"]);
            widgets.hideByFields(["refundP","toAccpet", "toDelivery", "toQryLog", "toMdfPrc","cycleDelivery","deliveryCalendar"]);
            widgets.hideByFields(["payTime", "delivTime", "recepiptTime","payTypeTxt","payAmount", "cycleDelivery1", "pauseRecord",
			"cycleModeMsg","deliveryTimesMsg","nextDeliveryTime", "showRefund","cardId.NO", "earnestState","preAmount","finalPaymentState",
            "amount", "finalPaymentTitle,finalPaymentTime",
            "normalOrder", "preSaleOrder", "showPrePayedDetails", "showFinalPayedDetails", "prePayTypeTxt", "preOnlineAmount",
            "finalPayTypeTxt", "finalPayAmount", "mdfOrder","extended","storeId.name","storeId.addr"]);
            var item = widgets.getData();
            if (!item._id) {
                return;
            }
            if(item.orderWay=='20'){
                if(item.isDelived){
                    widgets.showByFields(['cDeliv']);
                }else{
                    widgets.showByFields(['toDelivery']);
                }
                if(item.payWay=='20'&&item.isPayed){
                    if(item.isPayed){
                        widgets.showByFields(['cPayed']);
                    }
                }
                if(!item.isPayed){
                    widgets.showByFields(['payed']);
                }
            }
            if(item.tAmount>0&&true!=item.isPayed){
                widgets.showByFields(["clearTranFee"]);
            }
            if(item.deliveryType==2){
                widgets.showByFields(["storeId.name","storeId.addr"]);
            }
            if(item.isAccepted&&item.isDelived&&(!item.refundState||item.refundState<=1)&&
            (item.isPayed||item.orderWay=="20")&&!item.isCanceled&&item.isCycle&&
            item.details[0].totalDeliveryTimes-item.details[0].deliveredTimes>0){
                widgets.showByFields(["extended"]);
            }
            // 正常订单 未取消 且未发货
            // 周期订单 未取消 未发完货 均允许修改订单
            if((!item.refundState||item.refundState<=1)&&
            item.isPayed&&!item.isCanceled&&
            ((!item.isCycle&&!item.isDelived)||(item.isAccepted&&item.isCycle&&
            item.details[0].totalDeliveryTimes-item.details[0].deliveredTimes>0))){
                widgets.showByFields(["mdfOrder"]);
            }
            if(item.cardId){
                widgets.showByFields(["cardId.NO"]);
            }
            if (!item.isCanceled && !item.isPayed) {
                widgets.showByFields(["toMdfPrc"]);
            }
            // 如果是预售订单 则显示预售信息
			if(item.preSaleId){
				widgets.showByFields(["earnestState","preAmount","finalPaymentState","amount", "preSaleOrder"]);
			}else{
                widgets.showByFields(["normalOrder"]);
            }
            //周期订单不显示查询物流，显示送达日历
            // 已经支付并且发货
            if (item.isPayed && item.isDelived) {
                if(item.isCycle){
                    //周期订单
                    if(item.details[0].deliveredTimes){
                        widgets.showByFields(["deliveryCalendar"]);
                    }
                }else{
                    widgets.showByFields(["toQryLog"]);
                }  
            }
			if(item.nextDeliveryTime){
				widgets.showByFields(["nextDeliveryTime"]);
			}
            if (item.payTime) {
                widgets.showByFields(["payTime"]);
            }
            if (item.delivTime) {
                widgets.showByFields(["delivTime"]);
            }
            if (item.recepiptTime) {
                widgets.showByFields(["recepiptTime"]);
            }
            // 不是周期订单隐藏周期信息
			if(item.isCycle){
				widgets.showByFields(["cycleDelivery1", "cycleModeMsg","deliveryTimesMsg"]);
			}
			if(item.isCycle&&item.isPayed&&item.isDelived){
				widgets.showByFields(["pauseRecord"]);
			}
            if(item.preSaleId&&item.isPreAmountPayed){
                widgets.hideByFields(["toCancel"]);
            }
            if(item.isPayed&&item.payType!=="point"){
                if(!item.preSaleId){
                    widgets.showByFields(["payTypeTxt","payAmount"]);
                }
                else{
                    widgets.showByFields(["finalPayTypeTxt", "finalPayAmount"]);
                }
            }
            if(item.isPreAmountPayed&&item.prePayType!=="point"){
                widgets.showByFields(["prePayTypeTxt", "preOnlineAmount"]);
            }
			if(item.refundState){
				widgets.showByFields(["showRefund"]);
            }else if(!item.isDelived){
                widgets.showByFields(["refundP"]);
            }
            if (item.refundState == 2) {
                return;
            }
            // 只要是未取消的都允许取消
            //订单提交过退款，且订单状态是退款完成，不允许显示取消订单
            var awardId = item.details[0].awardId||"";
            if(item.refundState){
                if (!awardId&&!item.isCanceled && !item.isReceipted&&item.refundState !=3) {
                    widgets.showByFields(["toPay"]);//"toCancel", 
                }
            }else{
                if (!awardId&&!item.isCanceled && !item.isReceipted) {
                    widgets.showByFields(["toPay"]);//"toCancel", 
                }
            }
            if (item.isPayed && !item.isCanceled && item.isAccepted == false) {
                widgets.hideByFields(['toDelivery']);
                widgets.showByFields(["toAccpet"]);
            }
            //退款中和退款完成不允许再次发货
            if(item.isCycle&&(item.isPayed||item.orderWay=='20') && !item.isCanceled&&(!item.refundState||item.refundState<=1)){
                //如果是周期订单，要看分别是第几次发货
                /*item.details[0].deliveredTimes已经配送的次数
                item.details[0].startDeliveryDate第一次审核的时间
                nextDeliveryTime下一次发货时间
                第一次发货时间=现在时间，显示第“item.details[0].deliveredTimes+1”次发货
                没到配送时间不予显示*/
                //deliveredTimes是剩余的个数
                var restTimes = item.details[0].totalDeliveryTimes-item.details[0].deliveredTimes;
                //周期订单第一次发货记录第一次发货时间
                require(["cq/util/sys/date"],lang.hitch(this,function(date){
                    //下一次发货时间等于现在系统时间，而且还有剩余的货，且已经发过货了，显示第几次发货,item.details[0].startDeliveryDate&&
                    if(item.isDelived&&date.formatISODate(item.details[0].nextDeliveryTime)<=date.formatISODate(date.nowISOString())&&restTimes>0){
                        widgets.getEditorByField(["cycleDelivery"]).labelNode.innerHTML = "第"+(parseInt(item.details[0].newdeliveredTimes)+1)+"次发货";
                        widgets.showByFields(["cycleDelivery"]);
                    }
                }));
            }
            if (item.isPayed && !item.isCanceled && item.isAccepted &&item.isDelived == false) {
                widgets.showByFields(["toDelivery"]);
            }
        },
        getOrderStateTxt: function (item) {
            // 显示订单状态
            var state = "";
            if (item.isPayed) {
                //已付款
                if (item.isCanceled) {
                    //已付款且已取消，则为已退款
                    state = "已退款";
                } else if (item.refundState == 2) {
                    state = "退款中";
                } else if (item.isDelived) {
					if(!item.isCycle){
						//已发货
						if (item.isClosed) {
							//若已关闭，则为已完成
							state = "已完成";
						} else if (!item.isReceipted) {
							//若未收货，为待收货
							state = "待收货";
						} else {
							//否则，待评价，评价完成之后会变成已完成
							state = "待评价";
						}
					}else{
						var detail = item.details[0];
						if(detail.totalDeliveryTimes-detail.deliveredTimes>0){
							state = "配送中";
						}else{
							state = "已送完";
						}
					}
                    if(item.refundState&&item.refundState>2){
                        state = state + "(部分退款)";
                    }
                } else if (item.isAccepted) {
                    //否则为待发货
                    state = "待发货";
                } else {
                    state = "待审核";
                }
            } else {
                //未付款
                if (item.isCanceled) {
                    //已取消
                    state = "已取消";
                } else {
                    //待付款
                    state = "待付款";
                }
            }
            return state;
        },
        /*
           商家订单接口相关：
             发货
             审核
             修改价格
        */
        //审核
        onAccpet: function (data, widget) {
            // 判断订单是否拼团成功
            var def = new Deferred();
            require(["bob/mk/pacBuy/team/b"], function(team){
                if(!data.pacTeamId){
                    def.resolve({
                        ok: 1
                    });
                }else{
                    team.loadById(data.pacTeamId).then(function(item){
                        if(item&&item.state!==3){
                            alert("拼团订单未成功，不能审核");
                            def.resolve({
                                ok:0
                            });
                        }else{
                            def.resolve({
                                ok: 1
                            });
                        }
                    });
                }
            });
            def.then(lang.hitch(this,function(msg){
                if(msg.ok==1){
                    // 判断订单是什么订单
                    // 周期订单 则直接审核
                    if(data.isCycle){
                        window.busy();
                        this.exec("acceptById", {
                            _id: data._id,
                            shopId: this.getShopId()
                        }).then(lang.hitch(this, function (result) {
                            window.free();
                            if (result && result.data && result.data.ok == 1) {
                                widget.cqRefresh();
                            } else {
                                alert(result && result.data && result.data.message || "审核失败");
                            }
                        }));
                    }else{
                        // 普通订单
                        // 1,弹出overlay
                        // 2,选择计划发货日期
                        // 3,审核
                        require(["whz/util/orderAccpet"], lang.hitch(this, function(orderAccpet){
                            //周期订单发货
                            orderAccpet.getAction({
                                labelField: "name",
                                data: data,
                                widget: widget
                            });
                        }));
                    }
                }
            }));
            return def;
        },
        onAccpetById: function(params){
            return this.exec("acceptById", params);
        },
        updateOrderH: function(params){
            return this.exec("updateOrderH", params);
        },
        onSelectDelivery: function (params) {
            return this.exec("deliverById", params);
        },
        onSelectCycleDelivery:function(params){
            return this.exec("cycleDeliverById",params);
        },
        //周期订单发货
        cycleDelivery:function(data, widget){
            var cycleDetailId = [],deliveryCycleEachNum;
            array.forEach(data.details, function (item) {
                if(item.isCycle){
                    deliveryCycleEachNum = item.totalDeliveryTimes-item.deliveredTimes>=item.deliveryCycleEachNum?item.deliveryCycleEachNum:item.totalDeliveryTimes-item.deliveredTimes;
                    cycleDetailId.push(item._id);
                }
            });
            //周期订单发货
            cycleOrderLogistics.getAction({
                target: logB.getPlatfromListUrl(),
                labelField: "name",
                data: {
                    tsId: data._id,
                    shopId: this.getShopId(),
                    platformShopId: config.getPlatformShopId(),
                    detailId: cycleDetailId,
					// 若剩余数量<每次配送数量，则传过去的应该是剩余数量
                    qty:deliveryCycleEachNum,
                    deliveryType: data.deliveryType
                },
                widget: widget
            });
        },
        //发货
        onDelivery: function (data, widget) {
            //如果是周期订单，弹出选时间，开始配送
             //周期订单发货另外处理
            var detailId = [],isCycle = false;
            array.forEach(data.details, function (item) {
                detailId.push(item._id);
            });
            if(data.details[0].isCycle){
                isCycle = true;
                firstdelivery.getAction({
                    target: logB.getPlatfromListUrl(),
                    deliveryCycleDetail:data.details[0].deliveryCycleDetail,
                    labelField: "name",
                    data: {
                        _id: data._id,
                        shopId: this.getShopId(),
                        platformShopId: config.getPlatformShopId(),
                        detailId: detailId
                    },
                    widget: widget
                });
            }else{
                orderLogistics.getAction({
                    target: logB.getPlatfromListUrl(),
                    labelField: "name",
                    data: {
                        _id: data._id,
                        shopId: this.getShopId(),
                        platformShopId: config.getPlatformShopId(),
                        detailIds: detailId
                    },
                    widget: widget
                });
            }
            
            // this.exec("deliverById", {
            //     _id: data._id,
            //     shopId: this.getShopId(),
            //     platformShopId: config.getPlatformShopId()
            // }).then(lang.hitch(this, function (result) {
            //     if (result && result.data && result.data.ok == 1) {
            //         widget.cqRefresh();
            //     } else {
            //         alert(result.message || "发货失败");
            //     }
            // }));
        },
        showQRCode: function(data, widget){
            if(!config.appAlif2f){
                alert("当前不支持当面付");
                return;
            }
            if(data.isPayed){
                alert("订单已支付");
                return;
            }
            // 创建overLay
            if(!this.qrCodePane){
                this.qrCodePane = domConstruct.create("div",{
                    
                });
                this.imgNode = domConstruct.create("img", {
                    "class":"paymentQrImg"
                }, this.qrCodePane);
                var btnNode = domConstruct.create("div",{
                    "class": "hflex"
                }, this.qrCodePane);
                var cancelBtn = domConstruct.create("a", {
                    "class": "flex1 button",
                    innerHTML: "取消"
                }, btnNode);
                var okBtn = domConstruct.create("a", {
                    "class": "flex1 button",
                    innerHTML: "确认"
                }, btnNode);
                widget.connect(okBtn, "click", function(){
                    overlay.hide();
                });
                widget.connect(cancelBtn, "click", function(){
                    overlay.hide();
                });
            }
            var _this = this;
            
            this.exec("payByIds",{
                ids:[data._id],
                payType:"alif2f",
                returnUrl:location.href
            }).then(lang.hitch(this, function (result) {
                window.free();
                if (result.data.ok) {
                    
                    _this.imgNode.src = qrCode.generatePNG(result.data.item.qrcode, {
                        moduleSize:5,
                        margin:2,
                        ecclevel:"M"
                    });
                    overlay.hide();
                    overlay.showElement(_this.qrCodePane);
                } else {
                    alert("生成二维码错误");
                }
            }));
        },
        // 修改价格
        onUpdateDiscountAmount: function (data, widget) {
            // 不是供货商不允许改价
            if(data.fromShopId!=this.getShopId()){
                alert("非当前商家不能操作");
                return;
            }
            // 创建overLay
            if (!this.updatePicElement) {
                this.updatePicElement = new UpdateOrderPic();
                this.updatePicElement.startup();
            }
            this.updatePicElement.init(data).then(function (status) {
                overlay.hide();
                if (status) {
                    widget.cqRefresh();
                }
            });
            overlay.showElement(this.updatePicElement.domNode);
        },
        // 改价函数
        updateAmount: function (detail, tsId) {
            return this.exec("updateDiscountAmount", {
                detail: detail,
                tsId: tsId,
                shopId: this.getShopId()
            }).then(lang.hitch(this, function (result) {
                return result;
            }));
        },

        //web端列表点击事件
        onListClick: function (data, action, list) {
            if (data && data._id) {
                //跳转编辑页面
                if (action == "detail") {
                    window.moveToView("orderDetailB", data._id);
                }
            }
        },
        // 物流查询
        onQryLog: function (data, widget){
            // 查询订单中的物流数据
            require([
                "bob/ts/orderLog/b",
                "cq/util/edit/confirmFrame2"
            ], lang.hitch(this, function(orderLog, confirmIFrame){
                window.busy();
                orderLog.loadByTsId(data._id).then(lang.hitch(this, function(data){
                    window.free();
                    var item = data&&data.data&&data.data.item||{};
                    // 如果没有物流信息或配送方式为自己配送 则提示暂无物流信息
                    if(item.type==1||!item._id){
                        alert("暂无物流信息");
                    }else{
                        if(item.log_code==="shunfeng"){
                            var url = "http://www.sf-express.com/mobile/cn/sc/dynamic_function/waybill/waybill_query_by_billno.html?billno="+item.log_no;
                        }else{
                            var url = "http://m.kuaidi100.com/result.jsp?com="+item.log_code+"&nu="+item.log_no;
                        }
                        confirmIFrame.show(url,"物流查询");
                    }
                }));
            }));
        },
        getOrderSummary: function(){
            return this.exec("getOrderSummaryByShop", {}).then(lang.hitch(this, function(result){
                var item = result&&result.data&&result.data.item||{};
                item.amount = window.fixedTo(item.amount, 3);
                return result;
            }));
        },
        contactPartner: function(data, widget){
            require(["bob/im/msgP/b"], lang.hitch(this, function(msg){
                msg.msgTo(data.userId, data.userShopId);
            }));
        },
        // 查看客户
        showCustomer: function(data, widget){
            if(data&&data.userId){
                window.moveToView("customer", data.userId);
            }else{
                alert("没有客户信息");
            }
        },
        //查询物流
        checkDeliveryCalendar:function(data,widget){
            window.moveToView("cycleOrderLogisticsB",data._id);
        },
        // 查看评价
        showComment: function(data, widget){
            // 跳转到评论详情页面
            window.moveToView("commentDetailB", data._id);
        },
        //周期订单发货，保存第一次发货时间，计算下一次发货时间
        updateOrder:function(params){
            return this.exec("updateOrder", params);
        },
		// 暂停周期订单配送
        pause: function(data, widget){
            if(!data._id){
                return;
            }
			window.busy();
            this.exec("pauseDelivery", {
                tsId: data.tsId,
                detailId: data._id
				// 无fromShopId
            }).then(function(result){
                window.free();
                if(result&&result.data&&result.data.ok==1){
                    alert("操作成功");
					//刷新最外层layout
                    widget.getRootDataLayout().cqRefresh();
                }else{
                    alert(result&&result.data&&result.data.message||"操作失败");
                }
            });
        },
		// 恢复周期订单配送
        recovery: function(data, widget){
            if(!data._id){
                return;
            }
			window.busy();
            this.exec("recoveryDelivery", {
                tsId: data.tsId,
                detailId: data._id
            }).then(function(result){
                window.free();
                if(result&&result.data&&result.data.ok==1){
                    alert("操作成功");
					//刷新最外层layout
                    widget.getRootDataLayout().cqRefresh();
                }else{
                    alert(result&&result.data&&result.data.message||"操作失败");
                }
            });
        },
		// 查看暂停记录
		pauseRecord: function(data, widget){
			window.moveToView("pauseOpRecordB", data._id);
		},
		showRefund: function(data, widget){
			// 检查本章订单是否有退款记录
			require(["bob/ts/refundAplication/b"], function(refund){
				refund.loadByTsId(data._id).then(function(refundData){
					var refundItem = refundData&&refundData.data&&refundData.data.item||{};
					if(refundItem._id){
						window.moveToView("refundRequestB", refundItem._id);
					}else{
						alert("本订单无退款记录");
					}
				});
			});
		},
		doExportBill: function(query, url){
			require([
				"cq/util/sys/xlsx",
				"cq/util/sys/date",
				"cq/util/sys/userAgent",
				"cq/util/config/config"
			],lang.hitch(this,function(xlsx,date,userAgent,config){
                if(userAgent.isBrowser){
                    //依据url和query加载所有要到处的订单数据
                    xlsx.loadAllData(url,query).then(lang.hitch(this,function(items){
                        //设置表头
                        // 添加周期订单的总配送及已配送的导出
                        var datas = [["订单号","支付日期","买家店铺","下单店铺",
                        "商品金额","运费","使用村币", "使用优惠券", "使用金元宝","优惠金额","在线支付","退款金额","在线退款",
                        "支付手续费",
                        "状态","支付方式",
                        "创建时间","审核时间","发货时间","收货时间","完成时间","取消时间","备注","套餐配置记录",
                        "客户ID","来源客户ID","来源客户名称","来源客户电话","oldId","收款商家","结算时间"]];
                        //初始化订单数据
                        for(var i=0;i<items.length;i++){
                            var data = items[i];
                            if(data.payType){
                                data.payTypeName = config.getPayTypeStr(data.payType);
                            }
                            if(data.prePayType){
                                data.prePayTypeName = config.getPayTypeStr(data.prePayType);
                            }
                            if(data.payTime){
                                data.payTime = date.formatISODateMinutes(data.payTime);
                            }
                            if(data.prePayTime){
                                data.prePayTime = date.formatISODateMinutes(data.prePayTime);
                            }
                            if(data.createAt){
                                data.createAt = date.formatISODateMinutes(data.createAt);
                            }
                            if(data.acceptTime){
                                data.acceptTime = date.formatISODateMinutes(data.acceptTime);
                            }
                            if(data.delivTime){
                                data.delivTime = date.formatISODateMinutes(data.delivTime);
                            }
                            if(data.cancelTime){
                                data.cancelTime = date.formatISODateMinutes(data.cancelTime);
                            }
                            if(data.recepiptTime){
                                data.recepiptTime = date.formatISODateMinutes(data.recepiptTime);
                            }
                            if(data.closeTime){
                                data.closeTime = date.formatISODateMinutes(data.closeTime);
                            }
                            //平台导出订单时可能会报异常
                            data.userId = data.userId||{};
                            data.userId._id = data.userId._id||"";
                            data.remark = data.remark||"无";
                            data.state = this.getOrderStatus(data);
                            if(data.preSaleId&&data.isPreAmountPayed){
                                // 导出定金的那一行
                                datas.push([data.tsId,data.prePayTime,data.fromShopName,(data.userShopName||""),
                                    data.preAmount,0,
                                    data.prePoint,
                                    data.preCoupon,
                                    data.preGold||0,
                                    0,0,0
                                    (parseFloat(data.preAmount)-parseFloat(data.prePoint)-parseFloat(data.preCoupon)
                                    -parseFloat(data.preGold||0)).toFixed(2),
                                    data.prePayFee,
                                    "已完成",data.prePayTypeName,
                                    data.createAt,data.acceptTime,data.delivTime,data.recepiptTime,data.closeTime,"",data.remark,
                                    data.userId._id,// 客户ID
                                    data.userId.srcUid ? (data.userId.srcUid._id) : "",  // 来源客户ID
                                    data.userId.srcUid ? (data.userId.srcUid.nickName || "") : "",  // 来源客户名称
                                    data.userId.srcUid ? (data.userId.srcUid.phone || "") : "",  // 来源客户电话
                                    data.oldId||"",
                                    data.prePayShopName || "",
                                    data.preSettleDate ? date.formatISODateMinutes(data.preSettleDate): ""
                                ]);
                            }
                            datas.push([data.tsId,data.payTime,data.fromShopName,(data.userShopName||""),
                                //先从订单中获取 订单中没有才从商品中获取
                                data.mAmount,data.tAmount,data.point,
                                data.couponAmount,
                                (data.gold||0),
                                data.discountAmount*-1,
                                (parseFloat(data.amount)
                                -(parseFloat(data.point))
                                -(parseFloat(data.couponAmount))
                                -(parseFloat(data.gold||0))
                                +parseFloat(data.discountAmount)).toFixed(2),
                                data.refundTotalAmount,data.refundAmount,data.payFee,
                                data.state,data.payTypeName,
                                data.createAt,data.acceptTime,data.delivTime,data.recepiptTime,data.closeTime,data.cancelTime,data.remark,
                                data.userId._id,// 客户ID
                                data.userId.srcUid ? (data.userId.srcUid._id) : "",  // 来源客户ID
                                data.userId.srcUid ? (data.userId.srcUid.nickName || "") : "",  // 来源客户名称
                                data.userId.srcUid ? (data.userId.srcUid.phone || "") : "",  // 来源客户电话
                                data.oldId||"",
                                data.payShopName || "",
                                data.settleDate ? date.formatISODateMinutes(data.settleDate): ""
                            ]);
                        }
                        //导出成xlsx文件
                        xlsx.exportMatrix(datas,Date.now().toString());
                    }));
                }
            }));
		},
		//导出订单记录平台属商家的所有订单列表成xlsx文件
		doExport: function(query, url){
			require([
				"cq/util/sys/xlsx",
				"cq/util/sys/date",
				"cq/util/sys/userAgent",
				"cq/util/config/config"
			],lang.hitch(this,function(xlsx,date,userAgent,config){
                if(userAgent.isBrowser){
                    //依据url和query加载所有要到处的订单数据
                    xlsx.loadAllData(url,query).then(lang.hitch(this,function(items){
                        //设置表头
                        // 添加周期订单的总配送及已配送的导出
                        var datas = [["订单号","支付日期","买家店铺","下单店铺","收货人",
                        "收货电话","收货地址","商品名称", "规格","单价",
                        "数量","金额","总配送","已配送",/*"使用村币", "使用优惠券", "使用金元宝","优惠金额","在线支付",
                        "支付手续费","交易手续费",*/
                        //"运费",
                        "状态","支付方式",
                        "创建时间","审核时间","发货时间","收货时间","完成时间","取消时间","备注","套餐配置记录",
                        "客户ID","来源客户ID","来源客户名称","来源客户电话","oldId","收款商家","结算时间"]];
                        //初始化订单数据
                        for(var i=0;i<items.length;i++){
                            var data = items[i];
                            if(data.payType){
                                data.payTypeName = config.getPayTypeStr(data.payType);
                            }
                            if(data.prePayType){
                                data.prePayTypeName = config.getPayTypeStr(data.prePayType);
                            }
                            if(data.payTime){
                                data.payTime = date.formatISODateMinutes(data.payTime);
                            }
                            if(data.prePayTime){
                                data.prePayTime = date.formatISODateMinutes(data.prePayTime);
                            }
                            if(data.createAt){
                                data.createAt = date.formatISODateMinutes(data.createAt);
                            }
                            if(data.acceptTime){
                                data.acceptTime = date.formatISODateMinutes(data.acceptTime);
                            }
                            if(data.delivTime){
                                data.delivTime = date.formatISODateMinutes(data.delivTime);
                            }
                            if(data.cancelTime){
                                data.cancelTime = date.formatISODateMinutes(data.cancelTime);
                            }
                            if(data.recepiptTime){
                                data.recepiptTime = date.formatISODateMinutes(data.recepiptTime);
                            }
                            if(data.closeTime){
                                data.closeTime = date.formatISODateMinutes(data.closeTime);
                            }
                            //平台导出订单时可能会报异常
                            data.userId = data.userId||{};
                            data.userId._id = data.userId._id||"";
                            data.remark = data.remark||"无";
                            var totalPoint = 0, totalGold = 0, totalCoupon = 0;
                            for(var j=0;j<items[i].details.length;j++){
                                data.state = this.getOrderStatus(data);
								// 明细使用村币总数
                                totalPoint += (data.details[j].point||0);
								// 明细使用金元宝总数
                                totalGold += (data.details[j].gold||0);
                                totalCoupon += (data.details[j].couponAmount||0);
                                data.details[j].mId = data.details[j].mId||{};
                                // 如果是预售订单 则要分别导出订单的定金和尾款部分
                                if(data.preSaleId&&data.isPreAmountPayed){
                                    // 导出定金的那一行
                                    datas.push([data.details[0].tsId,data.prePayTime,data.fromShopName,(data.userShopName||""),
                                    data.details[0].dName,
                                    data.details[0].dTel,
                                    data.details[0].dAddress,
                                    //先从订单中获取 订单中没有才从商品中获取
                                    "定金-"+data.details[j].mName||data.details[j].mId.mName,
                                    data.details[j].specName,
                                    data.preAmount/data.details[j].qty,
                                    data.details[j].qty,
                                    data.preAmount,
                                    data.details[j].qty,
                                    data.details[j].isDelived?data.details[j].qty:0,
                                    /*data.prePoint,
                                    data.preCoupon,
                                    data.preGold||0,
                                    0,
                                    (parseFloat(data.preAmount)-parseFloat(data.prePoint)-parseFloat(data.preCoupon)
                                    -parseFloat(data.preGold||0)).toFixed(2),
                                    data.prePayFee,data.preTransactionFee,*/
                                    "已完成",data.prePayTypeName,
                                    data.createAt,data.acceptTime,data.delivTime,data.recepiptTime,data.closeTime,"",data.remark,"",
                                    data.userId._id,// 客户ID
                                    data.userId.srcUid ? (data.userId.srcUid._id) : "",  // 来源客户ID
                                    data.userId.srcUid ? (data.userId.srcUid.nickName || "") : "",  // 来源客户名称
                                    data.userId.srcUid ? (data.userId.srcUid.phone || "") : "",  // 来源客户电话
                                    data.oldId||"",
                                    data.prePayShopName || "",
                                    data.preSettleDate ? date.formatISODateMinutes(data.preSettleDate): ""
                                    ]);
                                }
                                if(!data.preSaleId||(data.preSaleId&&data.isPayed)){
                                    datas.push([data.details[0].tsId,data.payTime,data.fromShopName,(data.userShopName||""),
                                    data.details[0].dName,data.details[0].dTel,data.details[0].dAddress,
                                    //先从订单中获取 订单中没有才从商品中获取
                                    (data.preSaleId?"尾款-":"")+data.details[j].mName||data.details[j].mId.mName,
                                    data.details[j].specName,
                                    data.details[j].price,
                                    data.details[j].qty,
                                    data.details[j].amount,
                                    data.details[j].isCycle?data.details[j].totalDeliveryTimes:data.details[j].qty,
                                    data.details[j].isCycle?data.details[j].deliveredTimes:data.details[j].isDelived?data.details[j].qty:0,
                                    /*data.details[j].point,
                                    data.details[j].couponAmount,
                                    (data.details[j].gold||0),
                                    data.details[j].discountAmount*-1,
                                    (parseFloat(data.details[j].amount)
                                    -(parseFloat(data.details[j].point))
                                    -(parseFloat(data.details[j].couponAmount))
                                    -(parseFloat(data.details[j].gold||0))
                                    +parseFloat(data.details[j].discountAmount)).toFixed(2),
                                    data.details[j].amount/data.amount*data.payFee,data.details[j].amount/data.amount*data.transactionFee,*/
                                    data.state,data.payTypeName,
                                    data.createAt,data.acceptTime,data.delivTime,data.recepiptTime,data.closeTime,data.cancelTime,data.remark, data.details[j].chooseRecord,
                                    data.userId._id,// 客户ID
                                    data.userId.srcUid ? (data.userId.srcUid._id) : "",  // 来源客户ID
                                    data.userId.srcUid ? (data.userId.srcUid.nickName || "") : "",  // 来源客户名称
                                    data.userId.srcUid ? (data.userId.srcUid.phone || "") : "",  // 来源客户电话
                                    data.oldId||"",
                                    data.payShopName || "",
                                    data.settleDate ? date.formatISODateMinutes(data.settleDate): ""
                                    ]);
                                }
                            }
                            // 如果有运费,则将运费单列一行导出
                            if(data.tAmount&&data.isPayed){
                                datas.push([data.details[0].tsId,data.payTime,data.fromShopName,(data.userShopName||""),
                                data.details[0].dName,data.details[0].dTel,data.details[0].dAddress,
                                //从商品中取
                                "运费",
                                "",
                                data.tAmount,
                                1,
                                data.tAmount,
                                1,
                                data.isDelived?1:0,
								// 使用积分
                                /*data.point-totalPoint,
								// 使用优惠券
                                data.couponAmount-totalCoupon,
								// 使用金元宝
								(data.gold||0)-totalGold,
								// 优惠金额
                                0,
								// 在线支付
                                data.tAmount-(data.point-totalPoint)-(data.gold-totalGold)-(data.couponAmount-totalCoupon),
                                data.tAmount/data.amount*data.payFee,data.tAmount/data.amount*data.transactionFee,*/
                                data.state,data.payTypeName,
                                data.createAt,data.acceptTime,data.delivTime,data.recepiptTime,data.closeTime,data.cancelTime,data.remark,"",
                                data.userId._id,// 客户ID
                                data.userId.srcUid ? (data.userId.srcUid._id) : "",  // 来源客户ID
                                data.userId.srcUid ? (data.userId.srcUid.nickName || "") : "",  // 来源客户名称
                                data.userId.srcUid ? (data.userId.srcUid.phone || "") : "",  // 来源客户电话
                                data.oldId||"",
                                data.payShopName || "",
                                data.settleDate ? date.formatISODateMinutes(data.settleDate): ""
                                ]);
                            }
                        }
                        //导出成xlsx文件
                        xlsx.exportMatrix(datas,Date.now().toString());
                    }));
                }
            }));
		},
        orderExport:function(a,b,widget,e){
            //查询条件
            var query = this.getListParamP(widget.getParent().cqRefInfo);
            var url = this.getListUrlForP();
            this.doExport(query, url);
        },
        orderExportBillP: function(a, b, widget){
            var query = this.pltQueryInfo;
			var url = this.getListUrlForP();
			this.doExportBill(query, url);
        },
        orderExportBillB: function(a, b, widget){
            var query = this.queryInfo;
            query.isUserInfoRef = true;
            var url = this.getListUrl();
            this.doExportBill(query, url);
        },
        refundOrderP: function(data,widget){
            window.busy();
            return this.exec("refundOrderP",{
                _id:data._id
            }).then(function(){
                window.free();
                widget.cqRefresh();
            });
        },
		orderExportB: function(a,b,widget){
			var query = this.queryInfo;
            // 导出订单时处理客户、来源客户的问题
            query.isUserInfoRef = true;
			var url = this.getListUrl();
			this.doExport(query, url);
		},
        // 批量发货
        deliverByIds: function(params){
            return this.exec("deliverByIds", params);
        },
        extended: function(data, widget){
            if(confirm("确认顺延一次？")){
                window.busy();
                this.exec("extended",{
                    _id: data._id
                }).then(function(result){
                    window.free();
                    if(result&&result.data&&result.data.ok==1){
                        alert("顺延成功");
                        widget.cqRefresh();
                    }else{
                        alert(result&&result.data&&result.data.message||"顺延失败");
                    }
                });
            }
        },
        getOrderAmountSummaryUrl: function(){
            return this.getBaseUrl()+"/orderAmountSummary?shopId="+this.getShopId();
        },
        exportOrderAmount: function(){
            var url = this.getOrderAmountSummaryUrl();
            require([
				"cq/util/sys/xlsx",
				"cq/util/sys/userAgent"
			],lang.hitch(this,function(xlsx,userAgent){
                window.free();
                if(userAgent.isBrowser()){
                    window.busy();
                    xlsx.exportData(url, {}, this.getFormItems(["userId.nickName","userId.pName","userId.userName","amount"], true),"累计消费统计"+(new Date()).toISOString());
                }
            }));
        },
        toPayed:function(data,widget){
            data.isPayed = true;
            this.exec('updateOfflinePayState',data).then(lang.hitch(this,function(result){
                widget.cqRefresh();
            }));
            //console.log('已支付');
        },
        cancalDeliv:function(data,widget){
            data.isDelived = false;
            this.exec('updateOfflineDelivState',data).then(lang.hitch(this,function(result){
                widget.cqRefresh();
            }));
            //console.log('取消发货');
        },
        cancelPayed:function(data,widget){
            data.isPayed = false;
            this.exec('updateOfflinePayState',data).then(lang.hitch(this,function(result){
                widget.cqRefresh();
            }));
        },
        toTransactionLog:function(data,widget){
            window.moveToView("transactionList","ts_"+data._id);
        },
        //预售订单查询条件,支持按照支付的时间查询
        getListQueryLayout:function(){
            return [{
                type: "form",
                fields: this.getFormItems(["prePayTime"])
            }];
        },
        //预售订单筛选条件根绝支付时间查询订
        getPreSaleListParamP: function (params) {
            var query = {};
            query.orderType = ['4'];
            // 如果有did 则修改userId
            if(params&&params.cqViewParam&&params.cqViewParam.params){
                query.userId = params.cqViewParam.params;
            }
            if(params.filter){
                for(var i in params.filter){
                    if(i){
                        query[i] = params.filter[i];//JSON.stringify()
                    }
                }
            }
            return query;
        },
        //导出预售订单信息
        //导出配置项需要的字段
        exportLayout:function(){
            return this.getFormItems(["_id","prePayTime","userShopName","fromShopName","prePayType","preAmount","prePayAmount","prePoint","preGold"]);
        },
         //预售列表列表点击事件
        onPreSaleListClick: function (data, action, list) {
            if (data && data._id) {
                //跳转编辑页面
                window.moveToView("orderDetailB", data._id);
            }
        },
        clearTranFee:function(data,widget){
            return this.exec("clearTranFee",{
                _id:data._id
            }).then(function(){
                widget.cqRefresh();
            });
        }
    });
    var orderBBo = new OrderBBo();
    orderBBo.Bo = OrderBBo;
    return orderBBo;
});
