﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "bob/user/consumer",
    "cq/app/config",
    "cq/util/sys/userAgent",
    "./_OrderMixin",
    "./_BuyerOrderMixin",
    '../BoBase',
    "dojo/Deferred",
    "cq/util/sys/date"
], function (declare,lang,consumer,appConfig,userAgent,_OrderMixin,_BuyerOrderMixin,BoBase,Deferred,date) {
    //b2b采购端
    //B2B采购，采购方管理订单的对象
    var OrderB2BBo = declare('', [BoBase.B, _OrderMixin,_BuyerOrderMixin], {
        listView:"orderListB2B",
        detailView:"orderDetailB2B",
        // 加载指定订单数据
        loadWithDetails:function(params){
            if (!params.cqViewParam.params) {
                return;
            }
            return this.exec("loadWithB2BDetails",{
                _id:params.cqViewParam.params
            }).then(lang.hitch(this, function(data){
                if(data.data){
                    data = data.data;
                }
                if(data.items){
                    data = data.items[0];
                    // 重算订单状态
                    data.state = this.getOrderStateTxt(data);
                    data.amount = data.amount + data.discountAmount;
                    data.discountAmount = data.discountAmount*-1;
                    data.createAt = date.formatISODateMinutes(data.createAt);
                }
                return data;
            }));
        },
        // 加载订单列表的url
        getListUrl: function(){
            return this.getBaseUrl()+"/loadWithB2BDetails?shopId="+this.getShopId();
        }
    });
    var orderB2B = new OrderB2BBo();
    orderB2B.Bo = OrderB2BBo;
    return orderB2B;
});