﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "bob/user/consumer",
    "cq/app/config",
    "cq/util/sys/userAgent",
    "./_OrderMixin",
    "./_BuyerOrderMixin",
    '../BoBase',
    "cq/util/sys/date"
], function (declare,lang,Deferred,consumer,appConfig,userAgent,_OrderMixin,_BuyerOrderMixin,BoBase,date) {
    //b2b采购端
    //B2B采购，采购方管理订单的对象
    var OrderB2CBo = declare('', [BoBase.B, _OrderMixin,_BuyerOrderMixin], {
        listView: "orderList",
        detailView: "orderDetail",
        // 加载指定订单数据
        fields:{
            amount:{
                type:'text',
                label:'优惠金额',
                placeHolder:'请输入优惠的金额',
                fixedTo:2
            },
            isPay:{
                type:'checkbox',
                label:'已付款'
            },
            isDelived:{
                type:'checkbox',
                label:'已发货'
            },
            
        },
        createOfflineOrder:function(orderInfo){
            return this.exec("createOfflineOrder",orderInfo);
        },
        customerTob2cOrder:function(){
            return {
                amount:'',
                isPay:false,
                isDelived:false
            };    
        },
        b2cOrderReload:function(widget){
            
        },
        getcustomerListLayout:function(){
            return [{
                type:"form",
                fields:this.getFormItems([
                    'amount','isPay','isDelived'
                ])
            }];  
        },
        
        getTAmount:function(mids,addressId,withCoupons){
            var ids = [];
            var idHash = null;
            var specHash = {};
            var data = {
                item:{}
            };
            if(!mids||mids.length===0){
                throw 'orderB2C对象getTAmount的mids参数错误'
            }
            if(mids&&mids.length){
                idHash = {};
                for(var i=0;i<mids.length;i++){
                    if(mids[i].mid.length>24){
                        if(!idHash[mids[i].mid.slice(0,24)]){
                            ids.push(mids[i].mid.slice(0,24));
                        }
                        idHash[mids[i].mid.slice(0,24)] = 1;
                        specHash[mids[i].mid.slice(25)] = mids[i].qty;
                    }else{
                        if(!idHash[mids[i].mid]){
                            ids.push(mids[i].mid);
                        }
                        idHash[mids[i].mid] = 1;
                        specHash[mids[i].mid] = mids[i].qty;
                    }
                }
                idHash = null;
            }
            var def = new Deferred();
            require([
                "bob/mat/matB"
            ],function(matB){
                return matB.loadByMids(ids).then(lang.hitch(this,function(matDatas){
                    if(matDatas&&matDatas.data&&matDatas.data.items){
                        matDatas = matDatas.data.items
                    }else{
                        throw 'getTAmount接口未找到商品信息'
                    }
                    matDatas.forEach(lang.hitch(this,function(matData){
                        var fromShopId = matData.fromShopId;
                        if(!data.item[fromShopId]){
                            data.item[fromShopId] = {
                                coupons:[],
                                matInfo:{},
                                shopInfo:{shopName: matData.fromShopName||""},
                                tAmount:0,
                                totalPrice:0
                           }    
                        }
                        data.item[fromShopId].shopInfo.shopName = matData.fromShopName 
                            || data.item[fromShopId].shopInfo.shopName;
                        if(matData.specs&&matData.specs.length>0){
                            for(var i=0;i<matData.specs.length;i++){
                                if(!specHash[matData.specs[i]._id]){
                                    continue;
                                }
                                data.item[fromShopId].matInfo[matData._id+matData.specs[i]._id] 
                                    = {
                                        freight:0,
                                        fromShopId:matData.fromShopId,
                                        logo:matData.logo,
                                        mName:matData.mName,
                                        price:matData.specs[i].price,
                                        qty: specHash[matData.specs[i]._id]*1,
                                        specId:matData.specs[i]._id,
                                        specName:matData.specs[i].name
                                    }; 
                                data.item[fromShopId].totalPrice += matData.specs[i].price*1*specHash[matData.specs[i]._id];
                            }
                        }else{
                            data.item[fromShopId].matInfo[matData._id] 
                                = {
                                    freight:0,
                                    fromShopId:matData.fromShopId,
                                    logo:matData.logo,
                                    mName:matData.mName,
                                    price:matData.retailPrice,
                                    qty:specHash[matData._id]*1
                                };
                            data.item[fromShopId].totalPrice += matData.retailPrice*1*specHash[matData._id];
                        }
                        
                    }))
                    def.resolve({
                        data:{
                            item:data.item,
                            ok:1
                        }
                    });
                }));
            });    
            return def 
        }
    });
    var orderB2C = new OrderB2CBo();
    orderB2C.Bo = OrderB2CBo;
    return orderB2C;
});
