//订单系统消费者端
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "./_OrderMixin",
    "./_BuyerOrderMixin",
    '../BoBase',
    "bob/user/consumer",
    "cq/util/config/config"
], function (declare, lang, _OrderMixin, _BuyerOrderMixin, BoBase, consumer, config) {
    //消费者管理订单的对象
    var OrderCBo = declare('', [BoBase.C, _OrderMixin, _BuyerOrderMixin], {
        listView: "orderList",
        detailView: "orderDetail",
        toOrderDetail: function(data, widget){
            window.moveToView(this.detailView, data._id);
        },
        // 评价
        onEvaluat: function (data) {
            window.moveToView("orderEval", data._id);
        },
        // 物流查询
        //提交评论
        submitOrderEval: function (data, widget) {
            var params = {},
                msg = "",
                orderEvalDetails = [],
                flag = false;
            params.userId = consumer.getCurrentUserId();
            for (var i = 0; i < data.orderEvalDetails.length; i++) {
                var evalData = data.orderEvalDetails[i];
                if (evalData && evalData.images && evalData.images.length > 5) {
                    msg = "最多只能添加五张图片评论";
                    flag = true;
                    break;
                } else if (evalData && !evalData.content) {
                    msg = "说点什么吧";
                    flag = true;
                    break;
                } else {
                    evalData.deliveryEvaluation = data.deliveryEvaluation;
                    evalData.logisticsEvaluation = data.logisticsEvaluation;
                    evalData.serviceEvaluation = data.serviceEvaluation;
                    evalData.score = ((data.serviceEvaluation || 0) + (data.deliveryEvaluation || 0) + (data.logisticsEvaluation || 0) + (evalData.matEvaluation || 0)) / 4;
                    orderEvalDetails.push(evalData);
                }
            }
            if (flag) {
                alert(msg);
                return false;
            }
            params.orderEvalDetails = orderEvalDetails;
            window.busy();
            this.exec("evalueOrderhAllDetail", params).then(lang.hitch(this, function (data) {
                window.free();
                if (data && data.data && data.data.ok === 1) {
                    history.back();
                } else {
                    alert(data && data.data && data.data.message || "评论提交失败");
                }
            }));
        },
        // 加载订单详情的数据
        loadOrderEvalData: function (params) {
            // 获取订单Id
            if (!params.cqViewParam.params) {
                return;
            }
            var tsId = params.cqViewParam.params;
            return this.loadWithDetails(params).then(lang.hitch(this, function (data) {
                // 获取到订单子表的信息，并处理成自己需要的对象
                var orderEvalDetails = [];
                data.details.forEach(function (item) {
                    orderEvalDetails.push({
                        _id: item._id,
                        mId: item.mId,
                        matEvaluation: 5
                    });
                });
                return {
                    orderEvalDetails: orderEvalDetails,
                    serviceEvaluation: 5,
                    deliveryEvaluation: 5,
                    logisticsEvaluation: 5
                };
            }));
        },
        //加载某一条订单详情的信息 徐阿雪 2017/3/6
        loadByDetailId: function (detailId) {
            return this.exec("loadByDetailId", {
                detailId: detailId
            });
        },
        // 物流查询
        onQryLog: function (data, widget){
            // 查询订单中的物流数据
            window.busy();
            require([
                "bob/ts/orderLog/c",
                "cq/util/edit/confirmFrame2"
            ], lang.hitch(this, function(orderLog, confirmIFrame){
                orderLog.loadByTsId(data._id).then(lang.hitch(this, function(data){
                    window.free();
                    var item = data&&data.data&&data.data.item||{};
                    // 如果没有物流信息或配送方式为自己配送 则提示暂无物流信息
                    if(item.type==1||!item._id){
                        alert("暂无物流信息");
                    }else{
                        // 顺丰官网查询物流要求客户注册，还是适用快递100的接口
                        // if(item.log_code==="shunfeng"){
                        //     var url = "http://www.sf-express.com/mobile/cn/sc/dynamic_function/waybill/waybill_query_by_billno.html?billno="+item.log_no;
                        // }else{
                            var url = "http://m.kuaidi100.com/result.jsp?com="+item.log_code+"&nu="+item.log_no;
                        // }
                        confirmIFrame.show(url,"物流查询");
                    }
                }));
            }));
        },
        pause: function(data, widget){
            if(!data._id){
                return;
            }
            window.busy();
            this.exec("pauseDelivery", {
                tsId: data.tsId,
                detailId: data._id,
                handler: "partner"
            }).then(function(result){
                window.free();
                if(result&&result.data&&result.data.ok==1){
                    alert("暂停配送操作成功");
                    window.free();
					//刷新最外层layout
                    widget.getRootDataLayout().cqRefresh();
                }else{
                    alert(result&&result.data&&result.data.message||"暂停配送操作失败");
                }
            });
        },
        recovery: function(data, widget){
            if(!data._id){
                return;
            }
            window.busy();
            this.exec("recoveryDelivery", {
                tsId: data.tsId,
                detailId: data._id
            }).then(function(result){
                window.free();
                if(result&&result.data&&result.data.ok==1){
                    alert("恢复配送操作成功");
                    window.free();
					//刷新最外层layout
                    widget.getRootDataLayout().cqRefresh();
                }else{
                    alert(result&&result.data&&result.data.message||"恢复配送操作失败");
                }
            });
        },
		// 查看暂停记录
		pauseRecord: function(data, widget){
			window.moveToView("pauseOpRecord", data._id);
		},
        //查询物流
        checkDeliveryCalendar:function(data,widget){
            window.moveToView("cycleOrderLogistics",data._id);//+"-"+data.fromShopId
        },
        //为农户详细farmerMsg页面提供的查询农户的所有商品的购买客户列表
        getListUrlByFarmer:function(){
            return this.getBaseUrl() + '/loadByFarmer';
        },
        getListParamByFarmer:function(cqRefInfo){
            var params = {};
            if(cqRefInfo.cqViewParam&&cqRefInfo.cqViewParam.params){
                params = {
                    shopId: this.getShopId(),
                    farmer: cqRefInfo.cqViewParam.params
                };
            }
            return params;
        },
        getItemPropByFarmer: function(item){
            if(!item.userId){
                item.userId = {};
            }
            if(!item.userId.logo){
                item.userId.logo = config.defultUserLogo;
            }
            if(!item.userId.nickName){
                item.userId.nickName = "佚名";
            }
            return item;
        }
    });
    var orderCBo = new OrderCBo();
    orderCBo.Bo = OrderCBo;
    return orderCBo;
});
