﻿define([
    "dojo/_base/declare",
    '../../BoBase',
    "./_Mixin",
    "dojo/_base/lang",
    "cq/util/sys/query"
], function (declare,BoBase,_Mixin, lang, query) {
    //本对象功能：
    //     周期订单选菜记录
    //      徐阿雪 2017/5/24
    var OrderChooseRBBO = declare("",[BoBase.B,_Mixin],{
        fields: {
            onSaveButton: {
                type: "button",
                label: "保存",
                action: "save"
            }
        },
        getListUrl: function(){
            return this.getBaseUrl()+"/load"
        },
        queryInfo: null,
        getListParam: function(cqRefInfo){
            var search = query.getQueryValue(cqRefInfo.search);
            var params = {
                shopId: this.getShopId(),
                state: 1
            };
            if(search){
                params.search = search;
            }
            var userId = cqRefInfo&&cqRefInfo.cqViewParam&&cqRefInfo.cqViewParam.params||"";
            if(userId){
                params.userId = userId;
            }
            var state = query.getQueryValue(cqRefInfo.state);
            if(state){
                params.state = state;
            }else{
                delete params.state;
            }
            this.queryInfo = params;
            return params;
        },
        onListClick: function(data){
            window.moveToView("chooseRecordEdt", data._id);
        },
        loadById: function(params){
            if(!params.cqViewParam.params){
                return;
            }
            return this.exec("loadById",{
                _id: params.cqViewParam.params
            }).then(function(result){
                return result&&result.data&&result.data.item||{};
            })
        },
        save: function(data){
            window.busy();
            this.exec("updateById", {_id: data._id, remark: data.remark}).then(function(result){
                window.free();
                if(result&&result.data&&result.data.ok==1){
                    alert("修改成功");
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"修改成功");
                }
            });
        },
        onDataReady: function(widget){
            widget.disableByFields(["userId", "createAt"]);
        },
        getEditLayout: function(){
            return [{
                type : "form",
                fields : this.getFormItems(["userId", "createAt", "remark", "onSaveButton"], true)
            }];
        },
        exportExcel: function(a, b, widget){
            var query = this.queryInfo;//this.getListParam(widget.getParent().cqRefInfo);
            var url = this.getListUrl();
            require([
				"cq/util/sys/xlsx",
				"cq/util/sys/date",
				"cq/util/sys/userAgent"
			],lang.hitch(this,function(xlsx,date,userAgent){
                if(userAgent.isBrowser()){
                    //依据url和query加载所有要到处的订单数据
                    xlsx.loadAllData(url,query).then(lang.hitch(this,function(items){
                        //设置表头
                        var datas = [["订单号","配置时间","配置内容","配置人微信","配置人姓名"]];
                        //初始化订单数据
                        for(var i=0;i<items.length;i++){
                            var data = items[i];
                            datas.push([data.tsId,date.formatISODateMinutes(data.createAt),data.remark,data.userId.nickName,data.userId.pName]);
                        }
                        //导出成xlsx文件
                        xlsx.exportMatrix(datas,Date.now().toString());
                    }));
                }
            }));
        }
    });
    var orderChooseRBBO = new OrderChooseRBBO();
    orderChooseRBBO.Bo = OrderChooseRBBO;
    return orderChooseRBBO;
});