﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    '../../BoBase'
], function (declare,lang,BoBase) {
    var O = declare("", [BoBase.B], {
        modalName:"ts/pay/bankStatement",
        fields:{
            day_totalAmount:{
                type:"text"
            },
            day_tsNum:{
                type:"text"
            },
            day_totalTsAmount:{
                label:"今日交易额",
                type:"number",
                fixedTo:2
            },
            day_totalCount:{
                label:"今日订单数",
                type:"number"
            },
            month_totalTsAmount:{
                label:"本月交易额",
                type:"number",
                fixedTo:2
            },
            month_totalCount:{
                label:"本月订单数",
                type:"number"
            },
            year_totalTsAmount:{
                label:"今年交易额",
                type:"number",
                fixedTo:2
            },
            year_totalCount:{
                label:"今年订单数",
                type:"number"
            },
            all_totalTsAmount:{
                label:"累计交易额",
                type:"number",
                fixedTo:2
            },
            all_totalCount:{
                label:"累计订单数",
                type:"number"
            },
            payDate:{
                type:"dateTime",
                label:"支付时间",
                qry:{
                    type:"date",
                    label:"支付日期"
                }
            },
            payType:{
                type:"options",
                label:"支付方式",
                options:{
                    "weixin": "微信",
                    "wxApp": "APP微信",
                    "wxNative": "微信扫码",
                    "aliwap": "支付宝网页",
                    "aliapp": "APP支付宝",
                    "point": "积分",
                    "alif2f":"支付宝当面付",
                    "weApp":"微信小程序"
                }
            },
            amount:{
                type:"number",
                label:"支付金额",
                fixedTo:2
            },
            feeAmount:{
                type:"number",
                label:"支付手续费",
                fixedTo:2
            },
            tsAmount:{
                type:"number",
                label:"订单总额",
                fixedTo:2
            },
            tsType:{
                type:"options",
                label:"订单类型",
                options:{
                    order:"订单",
                    consumerRecharge:"客户充值"
                }
            },
            buyerShopId:{
                type:"ref",
                label:"下单商家",
                searchField:"shopName",
                labelFields:"shopName",
                dataProvider:"bob/user/shopAdmin",
                targetMethod:"getShopListUrl",
            },
            fromShopId:{
                type:"ref",
                label:"供货商家",
                searchField:"shopName",
                labelFields:"shopName",
                dataProvider:"bob/shop/shop",
                targetMethod:"getShopListUrl",
            }
        },
        loadShopTsSummary: function(){
            return this.exec("classfyAmount", {}).then(lang.hitch(this, function(result){
                var item = result&&result.data&&result.data.item||{};
                return item;
            }));
        },
        getOpTownSummaryUrl:function(){
            return this.getBaseUrl()+"/aggregateByTownId?shopId="+this.getShopId();
        },
        //平台运营支付记录
        getListUrl:function(){
            return this.getBaseUrl()+"/load?shopId="+this.getShopId();
        },
        getExportLayout:function(widget){
            return this.getFormItems(["payDate","payType","amount","feeAmount","tsAmount","tsType","buyerShopId.shopName","fromShopId.shopName"]);
        },
        getListParams:function(params){
            var query = params&&params.searchQuery||{};
            for(var i in query){
                if(query[i]===null||query[i]===""||query[i]===undefined){
                    delete query[i];
                }
            }
            query.isGen = false;
            return query;
        },
        getListQueryLayout:function(){
            return [{
                type: "form",
                fields: this.getFormItems(["payDate","payType"], true, "qry")
            }];
        }
    });
    var o = new O();
    o.Bo = O;
    return o;
});
