﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/util/sys/date",
    '../../BoBase'
], function (declare,lang,date,BoBase) {
    var O = declare("", [BoBase.B], {
        modalName:"ts/pm/settleLog",
        fields:{
            fromShopId:{
                label: '商家ID',
                type: 'ref',
                dataProvider: 'bob/shop/pltShop',
                targetMethod: 'getPlatListUrl',
                className: 'middle-width',
                searchField: 'search',
                labelFields: 'shopName',
                query: {},
                notNull: true
            },
            fromShopName:{
                type:"text",
                label:"商家名称"
            },
            wxId:{
                type:"text",
                label:"微信ID"
            },
            wxNick:{
                type:"text",
                label:"微信昵称"
            },
            belongDate:{
                type:"Date",
                label:"归属日期",
                qry:{
                    type:"date",
                    label:"归属日期"
                }
            },
            isSettled:{
                label:"是否结算",
                type:"checkbox"
            },
            settleTime:{
                label:"结算时间",
                type:"dateTime"
            },
            settleRes:{
                label:"结算信息",
                type:"text"
            },
            tsAmount:{
                label:"交易额",
                type:"number",
                fixedTo:2
            },
            agentAmount:{
                label:"代收金额",
                type:"number",
                fixedTo:2
            },
            agentPayFee:{
                label:"支付手续费",
                type:"number"
                // fixedTo:2
            },
            onDelete:{
                type:'button',
                label:'删除商品',
                action:'onDelete'
            }
        },
        getListUrl:function(){
            return this.getBaseUrl()+"/load?shopId="+this.getShopId();
        },
        getListParams:function(params){
            var query = params&&params.searchQuery||{};
            for(var i in query){
                if(query[i]===null||query[i]===""||query[i]===undefined){
                    delete query[i];
                }
                if (query[i] && query[i]._id) {
                    query[i] = query[i]._id;
                }
            }
            // 添加排序方式
            query.orderBy = "-settleTime -belongDate";
            this.queryInfo = query;
            return query;
        },
        getListQueryLayout:function(){
            return [{
                type: "form",
                fields: this.getFormItems(["fromShopId","belongDate"], true, "qry")
            }];
        },
        getItemProp: function(data){
            data.belongDate = date.formatISODate(data.belongDate);
            return data;
        },
        onExport: function(a,b,widget){
			var query = this.queryInfo;
            // 导出订单时处理客户、来源客户的问题
            query.isUserInfoRef = true;
			var url = this.getListUrl();
			this.doExport(query, url);
		},
        doExport: function(query, url){
			require([
				"cq/util/sys/xlsx",
				"cq/util/sys/date",
				"cq/util/sys/userAgent",
				"cq/util/config/config"
			],lang.hitch(this,function(xlsx,date,userAgent,config){
                if(userAgent.isBrowser){
                    //依据url和query加载所有要到处的订单数据
                    xlsx.loadAllData(url,query).then(lang.hitch(this,function(items){
                        //设置表头
                        var datas = [["商家ID","商家名称","微信ID","微信昵称","归属日期","是否结算","结算时间","交易额","代收金额","支付手续费","结算信息"]];
                        //初始化订单数据
                        for(var i=0;i<items.length;i++){
                            var data = items[i];
                            data.belongDate = data.belongDate ? date.formatISODate(data.belongDate) : "";
                            data.settleTime = data.settleTime ? date.formatISODateMinutes(data.settleTime) : "";
                            datas.push([
                                data.fromShopId || "",
                                data.fromShopName || "",
                                data.wxId || "",
                                data.wxNick || "",
                                data.belongDate,
                                data.isSettled ? "是" : "否",
                                data.settleTime,
                                data.tsAmount || 0,
                                data.agentAmount || 0,
                                data.agentPayFee || 0,
                                data.settleRes || ""
                            ]);
                        }
                        //导出成xlsx文件
                        xlsx.exportMatrix(datas,Date.now().toString());
                    }));
                }
            }));
		}
    });
    var o = new O();
    o.Bo = O;
    return o;
});
