﻿/*
订单退款的基类
徐阿雪 2017/2/28
*/
define([
    "dojo/_base/declare"
], function (declare) {
    return declare("",null,{
        modalName:"ts/refund",
        fields:{
            tsId:{
                type:"textarea",
                label:"交易单号",
                canEdit : false
            },
            createAt:{
                type:"dateTime",
                label:"提交时间",
                canEdit : false
            },
            verifyDate: {
                type: "dateTime",
                label: "审核时间",
                canEdit: false
            },
            amount:{
                type:"text",
                label:"退款金额",
                canEdit : false,
                fixedTo:2
            },
            payType:{
                type:"options",
                label:"支付方式",
                canEdit : false,
                options: {
                    "weixin": "微信",
                    "wxApp": "微信APP",
                    "wxNative": "微信",
                    "point": "余额",
                    "aliapp": "支付宝",
                    "aliwap": "支付宝"
                }
            },
            // 审核
            toAccpet: {
                type: "button",
                action: "onAccpet",
                label: "审核"
            },
			"fromShopId.shopName": {
				type: "text",
                label: "退款店铺"
			},
            fromShopId:{
                type:"ref",
                label:"退款店铺",
				dataProvider: 'bob/shop/shop',
                targetMethod: 'getShopListUrl',
                className: 'middle-width',
                searchField: 'shopName',
                labelFields: 'shopName',
                canEdit : false
            },
            payLogId:{
                type:"textarea",
                label:"支付流水号",
                canEdit:false
            },
            isVerified: {
                type: "options",
                label: "状态",
                options: {
                    "true": "已审核",
                    "false": "未处理"
                }
            }
        }
    });
});
