﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/util/config/config",
    '../../BoBase',
    "./_Mixin",
    "bob/user/customer",
	"dojo/Deferred"
], function (declare,lang,config,BoBase,_Mixin,customer, Deferred) {
    //本对象功能：
    //      平台审核，同意退款
    //      徐阿雪
    var RefundBBo = declare("",[BoBase.B,_Mixin],{
		currentQuery: null,
		fields: {
			userId: {
				label: "退款用户",
				type: "ref",
				dataProvider: 'bob/user/customer',
                targetMethod: 'getUserListUrl',
                className: 'middle-width',
                searchField: 'nickName',
                labelFields: 'nickName,pName'
			},
			showOrder: {
				type: "button",
				action: "showOrder"
			},
			copyPayLogId: {
				type: "button",
				buttonClass: "mini-btn",
				action: "copy",
				label: "复制交易流水号"
			}
		},
		showOrder: function(data, widget){
			if(data.tsId){
				window.moveToView("orderDetailP", data.tsId);
			}
		},
        getListParam: function(params){
            // summary:
            //         平台退款申请列表加载query条件
            // view:
            //         refundList：平台查看申请退款列表
            // description:
            var query = {
                isVerified: false,
                shopId: this.getShopId()
            };
            if(params.state&&params.state._id == 2){
                query.isVerified = true;
            }else if(params.state&&params.state._id==1){
               query.isVerified=false;
            }else{
				delete query.isVerified;
			}
			this.currentQuery = query;
            return query;
        },
        getListUrl:function(){
            // summary:
            //         平台退款申请列表数据重载接口
            // view:
            //         refundList：平台查看申请退款列表
            // description:
            return this.getBaseUrl()+"/load";
        },
        // 列表点击事件
        onListClick: function(data){
            // summary:
            //         平台退款申请列表点击事件
            // view:
            //         refundList：平台查看申请退款列表
            // description:
            window.moveToView("refundDetail",data._id);
        },
		copy: function(data, widget){
			require(["cq/util/share/share"], function(share){
				share.copyUrl({url:data.payLogId||""});
			});
		},
        // 详情页面布局
        getDetailLayout: function(){
            // summary:
            //         平台退款申请详情页面布局
            // view:
            //         refundDetail:平台查看申请退款详情页面
            // description:
            return [{
                type: "form",
                fields: this.getFormItems(["tsId","payLogId","fromShopId", "userId","payType","amount","createAt","verifyDate", "copyPayLogId","toAccpet", "showOrder"])
            }];
        },
        // 详情页面获取数据
        initDetailData: function(data){
            // summary:
            //         平台退款申请详情数据加载接口
            // view:
            //         refundDetail:平台查看申请退款详情页面
            // description:
            var id = data.cqViewParam.params, def = new Deferred();
            this.exec("loadById",{_id:id}).then(lang.hitch(this,function(data){
                var item = data&&data.data&&data.data.item||{};
                require([
					"bob/ts/orderB",
					"bob/user/customer"
				], function(order, customer){
					order.loadById(item.tsId).then(function(orderData){
						var orderItem = orderData&&orderData.data&&orderData.data.item||{};
						// 查找用户名称
						customer.loadById(orderItem.userId).then(function(userData){		
							var userItem = userData&&userData.data&&userData.data.item||{};
							item.userId = {};
							item.userId._id = userItem._id;
							item.userId.nickName = userItem.pName||userItem.nickName||userItem.userName;
							def.resolve(item);
						});
					});
				});
            }));
			return def;
        },
        // 详情页面加载完成后的处理
        onDataReady: function(widgets){
            // summary:
            //         平台退款申请详情reload方法
            // view:
            //         refundDetail:平台查看申请退款详情页面
            // description:
            widgets.hideByFields(["toAccpet","verifyDate"]);
            widgets.disableByFields(["tsId","amount","payType","payLogId","fromShopId", "userId","createAt", "verifyDate"]);
            var item = widgets.getData();
            if(!item._id){
                return;
            }
            if(!item.isVerified){
                widgets.showByFields(["toAccpet"]);
            }else{
                widgets.showByFields(["verifyDate"]);
            }
        },
        onAccpet:function(data,widget){
            // summary:
            //         平台退款申请详情，同意退款
            // view:
            //         refundDetail:平台查看申请退款详情页面
            // description:
            window.busy();
            this.exec("agree",{
                _id:data._id
            }).then(lang.hitch(this, function(result){
                window.free();
                if(result&&result.data&&result.data.ok==1){
                    alert("审核成功");
                    history.back();
                }else{
                    alert(result.message||"审核失败");
                }
            }));
        },
        //导出台管理退款记录
        //_id 退款单号，payLogId 交易单号，payLogNum 支付流水号，
        //payType 支付方式(注意列表显示的内容)，amount 退款金额
        orderExport:function(a,b,widget,e){
            //查询条件
            var query = this.currentQuery||this.getListParam(widget.getParent().cqRefInfo);
            var url = this.getListUrl();
            require([
                "cq/util/sys/xlsx"
            ],lang.hitch(this,function(xlsx){
                //依据url和query加载所有要到处的订单数据
                xlsx.exportData(url, query, this.getFormItems(["tsId","payLogId","payType","fromShopId.shopName","amount","createAt","isVerified","verifyDate"]),"退款记录"+Date.now().toString());
            }));
        }
    });
    var refundBBo = new RefundBBo();
    refundBBo.Bo = RefundBBo;
    return refundBBo;
});