﻿/*
订单退款的基类
徐阿雪 2017/2/28
*/
define([
    "dojo/_base/declare"
], function (declare) {
    return declare("",null,{
        modalName:"ts/refundApplication",
        fields:{
            shopName:{
                type:"text",
                label:"退货店铺",
                canEdit : false
            },
            createAt:{
                type:"dateTime",
                label:"申请时间"
            },
            payType:{
                type:"options",
                label:"支付方式",
				options: {
					"weixin": "微信支付",
					"wxApp": "微信支付",
					"wxNative": "微信支付",
					"point": "余额支付",
					"aliapp": "支付宝",
					"aliwap": "支付宝"
				},
                canEdit : false
            },
            "userId.nickName":{
                type:"text",
                label:"退款用户",
                canEdit : false
            },
            //退款的两种形式
            treatmentMethod:{
                type: 'options',
                label:'退款方式',
                selected : 1,
                options:{
                    1:'我要退款，但不退货'//,
                   // 2:'我要退货，并且退款'
                },
                notNull: true
            },
            //退款原因
            reason:{
                type:'options',
                label:'退款原因',
                selected:5,
                options:{
                    //'1':'退运费',
                    '2':'做工问题',
                    '3':'少件/漏发',
                    '4':'商家发错货',
                    '5':'商品与描述不符',
                    '6':'未按约定时间发货'
                },
                notNull: true
            },
            remindAmount:{
                type:"text",
                label:'最大退款额(¥)'
            },
            amount:{
                type:'number',
                label:'退款金额(¥)',
                notNull: true,
                fixedTo:2
            },
            point: {
                type: "number",
                label: "村币退回",
                fixedTo: 2
            },
			gold: {
				type: "number",
				fixed: 2,
				label: "金元宝退回"
			},
            couponAmount: {
                type: "number",
                label: "优惠券",
                fixedTo: 2
            },
            onlineAmount: {
                type: "number",
                label: "在线退回",
                fixedTo: 2
            },
            /*mobile:{
                type:'text',
                label:'手机号码',
                notNull: true
            },*/
            describe:{
                type:'text',
                label:'退款说明',
                placeHolder:'请填写退款说明(可不填)'
                //canEdit:true
            },
            //上传图片
            uploadImage:{
                type : "images",
                label : "上传凭证",
                maxImages:3,
                isSetLabel: false,
                multiple:"multiple"
            },
            isDelived:{
                //是否已经发货
                type:"checkbox"
            },
            totalAmount:{
                type:"text",
                fixedTo: 2
            },
            stateMsg:{
                type:"text"
            },
			"tsId._id": {
				type: "text"
			}
        },
        // 依据订单ID查询退款记录
        loadByTsId:function(tsId){
            // summary:
            //         依据订单ID查询退款记录
            // view:
            //         orderDetial:订单详情页面
            // description:
            return this.exec("loadByTsId",{tsId:tsId});
        }
    });
});
