﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    '../../BoBase',
    "./_Mixin",
	"dojo/Deferred"
], function (declare,lang,BoBase,_Mixin, Deferred) {
    //本对象功能：
    //      商家端审核，同意退款
    //      商家端退款列表
    //      徐阿雪
    // 加载列表的条件
    var RefundAplicBBo = declare("",[BoBase.B,_Mixin],{
        fields: {
            // 审核
            toAccpet: {
                type: "button",
                action: "onAccpet",
                label: "同意退款"
            },
            //拒绝退款
            toReject:{
                type:"button",
                action:"onReject",
                label:"拒绝退款"
            },
            "tsId._id": {
                type: "textarea",
                label: "退款订单"
            },
			userId: {
				label: "退款用户",
				type: "ref",
				dataProvider: 'bob/user/customer',
                targetMethod: 'getUserListUrl',
                className: 'middle-width',
                searchField: 'nickName',
                labelFields: 'nickName,pName'
			},
			describe: {
				type: "textarea",
				label: "退款说明"
			},
            revokeTime: {
                type: "dateTime",
                label: "撤销时间"
            },
            verifyTime: {
                type: "dateTime",
                label: "同意时间"
            },
            platVerifyTime: {
                type: "dateTime",
                label: "平台退款时间"
            },
			rejectTime: {
				type: "dateTime",
				label: "拒绝时间"
			},
			showCustomer: {
				type: "button",
				action: "showCustomer"
			},
			showOrder: {
				type: "button",
				action: "showOrder"
			}
        },
        getListParam: function(params){
            var query = {
                //state:1,
                shopId: this.getShopId()//,
                //fromShopId: this.getShopId()
            };
            var userId = params&&params.cqViewParam&&params.cqViewParam.params||"";
            if(userId){
                query.userId = userId;
            }
            if(params.state&&params.state._id){
                query.state = params.state._id;
            }
            return query;
        },
        // 获取列表url
        getListUrl: function(){
            // summary:
            //         商家端退款申请列表数据重载接口
            // view:
            //         refundRequestListB：商家端查看申请退款列表
            // description:
            return this.getBaseUrl()+"/load"
        },
        // 详情页面获取数据
        initDetailData: function(data){
            // summary:
            //         商家端退款申请详情数据加载接口
            // view:
            //         refundRequestB：商家端查看申请退款详情页面
            // description:
            var id = data.cqViewParam.params, def = new Deferred();
            this.exec("loadById",{_id:id}).then(lang.hitch(this,function(data){
                var item = data.data.item;
                item.uploadImage = item.imgs;
				require(["bob/ts/orderB"], lang.hitch(this,function(order){
					order.originLoadWithDetails(item.tsId._id).then(function(orderData){
						var orderItem = orderData&&orderData.data&&orderData.data.items[0]||{};
						item.payType = orderItem.payType;
						if(orderItem.isCycle){
							var orderdItem = orderItem.details[0];
							var rate = 1-orderdItem.deliveredTimes/orderdItem.totalDeliveryTimes;
							item.point = rate*orderItem.point;
							item.gold = rate*(orderItem.gold||0);
							item.onlineAmount = rate*orderItem.payAmount;
						}else{
							// 如果有金元宝
							if(orderItem.gold&&orderItem.gold>0){
								// 判断 现金、积分、金元宝之间的数量关系
								if(item.amount<=orderItem.gold){
									item.point = 0;
									item.gold = item.amount;
									item.onlineAmount = 0;
								}else if(item.amount<=orderItem.point+orderItem.gold){
									item.point = item.amount-(orderItem.gold||0);
									item.gold = orderItem.gold||0;
									item.onlineAmount = 0;
								}else{
									item.point = orderItem.point;
									item.gold = orderItem.gold||0;
									item.onlineAmount = item.amount - orderItem.point - (orderItem.gold||0);
								}
							}
							// 如果没有金元宝
							else{
								// 判断 现金、积分之间的数量关系
								if(item.amount<=orderItem.point){
									item.point = item.amount;
									item.gold = 0;
									item.onlineAmount = 0;
								}else{
									item.point = orderItem.point;
									item.gold = 0;
									item.onlineAmount = item.amount - orderItem.point;
								}
							}
							
						}
						def.resolve(item);
					});
				}));
            }));
			return def;
        },
        // 详情页面布局
        getDetailLayout: function(){
            // summary:
            //         商家端退款申请详情页面布局
            // view:
            //         refundRequestB:商家端查看申请退款详情页面
            // description:
            return [{
                type: "form",
                fields: this.getFormItems(["tsId._id", "userId","treatmentMethod", "reason", "payType","amount", "point", "gold", "onlineAmount","describe",
				"uploadImage","createAt", "revokeTime","verifyTime","rejectTime","platVerifyTime","toReject","toAccpet", "showCustomer", "showOrder"])
            }];
        },
        // 详情页面加载完成后的处理
        onDataReady: function(widgets){
            // summary:
            //         商家端退款申请详情reload方法
            // view:
            //         refundRequestB：商家端查看申请退款详情页面
            // description:
            widgets.hideByFields(["toAccpet","revokeTime","rejectTime","verifyTime","platVerifyTime","toReject","describe"]);
            widgets.disableByFields(["tsId._id", "treatmentMethod","describe", "reason","amount", "gold", "payType", "point", "onlineAmount","userId",
			"createAt","uploadImage","revokeTime","verifyTime","platVerifyTime", "rejectTime"]);//"userId.pName",
            var item = widgets.getData();
            if(!item._id){
                return;
            }
			if(item.describe){
				widgets.showByFields(["describe"]);
			}
            if(item.state == 1){
                widgets.showByFields(["toAccpet","toReject"]);
            }
            if(item.revokeTime&&item.state==5){
                widgets.showByFields(["revokeTime"]);
            }
			if(item.rejectTime&&item.state==3){
				widgets.showByFields(["rejectTime"]);
			}
            if(item.verifyTime){
                widgets.showByFields(["verifyTime"]);
            }
            if(item.platVerifyTime){
                widgets.showByFields(["platVerifyTime"]);
            }
            var view = widgets.getView();
            if(view){
                view.resize();
            }
        },
        // 详情页面审核
        onAccpet:function(data,widget){
            // summary:
            //         商家端退款申请详情，同意退款
            // view:
            //         refundRequestB：商家端查看申请退款详情页面
            // description:
            if(!confirm("确认同意退款？")){
                return;
            }
            window.busy();
            this.exec3("ts/refund", "agreeRefund", {
                _id:data._id
            }).then(lang.hitch(this, function(result){
                window.free();
                if(result.ok==1){
                    widget.cqRefresh();
                }else{
                    alert(result.message||"审核失败");
                }
                /*if(result&&result.data&&result.data.ok==1){
                    widget.cqRefresh();
                }else{
                    alert(result.message||"审核失败");
                }*/
            }));
        },
        onReject:function(data,widget){
            // summary:
            //         商家端退款申请详情，拒绝退款
            // view:
            //         refundRequestB：商家端查看申请退款详情页面
            // description:
            if(!confirm("确认拒绝退款？")){
                return;
            }
            window.busy();
            this.exec("rejectById",{
                _id:data._id
            }).then(lang.hitch(this, function(result){
                window.free();
                if(result&&result.data&&result.data.ok==1){
                    widget.cqRefresh();
                }else{
                    alert(result.message||"拒绝退款失败");
                }
            }));
        },
        // 列表点击事件
        onListClick: function(data){
            // summary:
            //         商家端退款申请列表点击事件
            // view:
            //         refundRequestListB：商家端查看申请退款列表
            // description:
            window.moveToView("refundRequestB",data._id);
        },
		// 查看退款客户
		showCustomer: function(data, widget){
			if(!data.userId._id){
				alert("无客户");
				return;
			}
			window.moveToView("customer", data.userId._id)
		},
		// 查看退款订单
		showOrder: function(data, widget){
			if(!data.tsId._id){
				alert("无订单");
			}
			window.moveToView("orderDetailB", data.tsId._id);
		}
    });
    var refundAplicBBo = new RefundAplicBBo();
    refundAplicBBo.Bo = RefundAplicBBo;
    return refundAplicBBo;
});
