﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    '../../BoBase',
    "./_Mixin",
    "bob/user/consumer"
], function (declare,lang,Deferred,BoBase,_Mixin,consumer) {
    //本对象功能：
    //      申请退款
    //      查看退款进度，撤销退款申请
    //      徐阿雪 2017/3/1
    var RefundAplicCBo = declare("", [BoBase.C,_Mixin], {
        fields: {
            save:{
                type: "button",
                label: "保存",
                action: "save",
                buttonClass: "fullButton"
            },
            cancelRefund:{
                type:"button",
                label:"撤销退款",
                action:"cancelRefund",
                buttonClass: "fullButton"
            }
        },
        loadById:function(params){
            // summary:
            //         根据id加载退款详情退款
            // view:
            //         refundRequest：消费者查看退款详情
            // description:
            //         无
            if (!params.cqViewParam.params) {
                return;
            }else{
                var def = new Deferred(), tsId = params.cqViewParam.params,item={};
                // 先依据tsId加载 查看订单是否已经提交过退款
                this.loadByTsId(tsId).then(lang.hitch(this, function(refund){
                    // 获取上次提交申请的数据
                    var refundItem = refund&&refund.data&&refund.data.item||{};
                    item.tsId = refundItem.tsId&&refundItem.tsId._id||tsId;
                    if(refundItem._id){
                        item._id = refundItem._id;
                    }
                    item.treatmentMethod = refundItem.treatmentMethod||"1";
                    item.reason = refundItem.reason||"5";
                    item.describe = refundItem.describe||"";
                    item.uploadImage = refundItem.imgs||"";
                    // 查找要退款的金额数据
                    require(["bob/ts/orderC"],lang.hitch(this, function(order){
                        // 查询订单主表所需的数据
                        order.originLoadWithDetails(tsId).then(lang.hitch(this, function(orderhData){
                            var orderhItem = orderhData&&orderhData.data&&orderhData.data.items[0]||{};
                            item.isDelived = orderhItem.isDelived;
                            item.isCycle = orderhItem.isCycle;
                            // 判断是否需要去加载订单明细数据
                            // 周期订单
                            if(orderhItem.isCycle){
                                var orderdItem = orderhItem&&orderhItem.details&&orderhItem.details[0]||{};
                                var rate = 1-orderdItem.deliveredTimes/orderdItem.totalDeliveryTimes;
                                item.point = orderhItem.point*rate;
                                item.gold = (orderhItem.gold||0)*rate;
                                item.onlineAmount = orderhItem.payAmount*rate;
                                item.couponAmount = orderhItem.couponAmount;
                            }else{
                                item.point = orderhItem.point;
                                item.gold = orderhItem.gold||0;
                                item.couponAmount = orderhItem.couponAmount;
                                item.onlineAmount = orderhItem.payAmount;
                            }
                            if(item.isDelived){
                                item.amount = item.point+item.onlineAmount+item.gold;
                            }else{
                                item.amount = item.point+item.onlineAmount+item.gold+item.couponAmount;
                            }
                            item.totalAmount = item.amount;
                            item.realPoint = item.point;
                            item.realOnline = item.onlineAmount;
                            item.realGold = item.gold;
                            def.resolve(item);
                        }));
                    }));
                }));
                return def;
            }
        },
        _getRefundStatus:function(num){
            // 退款状态
            var state = "",data = this.params;
            //1买家申请等待卖家确认 2卖家同意 3卖家不同意 4财务已退款 5已取消
            var state = {
                "1":"申请中",
                "2":"卖家同意退款",
                "3":"不同意退款",
                "4":"已退款",
                "5":"已取消"
            };
            return state[num]||"";
        },
        getItemProp:function(data){
            // summary:
            //         平台退款申请列表数据重载接口
            // view:
            //         refundList：平台查看申请退款列表
            // description:  
            data.stateMsg = this._getRefundStatus(data.state);
            //data.tsId = data.tsId._id;
            return data;
        },
        onListClick:function(data){
             window.moveToView("refundRequestDetail",data._id);
        },
        amountChange:function(widget,field,value){
            if(field == "amount"){
                var amount = widget.getData().amount;
                // 最大可退金额 初始化时已经扣除了优惠券
                var bestAmount = widget.getData().totalAmount;
                var data = widget.getData();
                if(parseFloat(amount)>bestAmount){
                    data.amount = bestAmount;
                    alert("不能超过"+bestAmount);
                }else{
                    // 如果有金元宝
                    if(data.realGold&&data.realGold>0){
                        // 退回优先级 金元宝 积分 现金
                        if(amount<=data.realGold){
                            data.point = 0;
                            data.onlineAmount = 0;
                            data.gold = amount;
                        }else if(amount<=data.realGold+data.realPoint){
                            data.point = amount-data.realGold;
                            data.gold = data.realGold;
                            data.onlineAmount = 0;
                        }else{
                            data.point = data.realPoint;
                            data.gold = data.realGold||0;
                            data.onlineAmount = amount-data.realPoint-data.realGold;
                        }
                    }
                    // 如果没有金元宝
                    else{
                        // 退回优先级 积分 现金
                        if(amount<=data.realPoint){
                            data.point = amount;
                            data.onlineAmount = 0;
                            data.gold = 0;
                        }else{
                            data.point = data.realPoint;
                            data.gold = 0;
                            data.onlineAmount = amount-data.realPoint;
                        }
                    }
                }
                widget.setData(data);
            }
        },
        onDataReady:function(widgets){
            // summary:
            //         新增退款或者查看退款详情的重载数据接口
            // view:
            //         refundRequest：消费者查看退款详情
            // description:
            /* 订单已支付且未发货,则显示退款金额为订单总金额且不允许编辑退款金额,
            若订单已发货,则显示退款金额为订单金额且可以编辑(不能超过订单的总金额)*/
            var item = widgets.getData();
            widgets.disableByFields(["point","couponAmount", "onlineAmount","gold"]);
            widgets.enableByFields(["amount"]);
            if(!item.isDelived||item.isCycle){
                //订单发货
                widgets.disableByFields(["amount"]);
            }
            var view = widgets.getView();
            if(view){
                view.resize();
            }
        },
        getDetailLayout:function(){
            // summary:
            //         新增退款或者查看退款详情的布局界面
            // view:
            //         refundRequest：消费者查看退款详情
            // description:
            //         无
            return [{
                type : "form",
                fields : this.getFormItems(["treatmentMethod","reason","amount","point","gold","couponAmount", "onlineAmount","describe","uploadImage","save"], true)
            }];
        },
        //合法性检查
        _verify:function(data){
            var msg = "";
            if(data.amount<0){
                msg = "退款金额不能为负数";
            }else if(data.amount>data.totalAmount){
                msg = "退款金额不能超过"+data.totalAmount;
            }
            return msg;
        },
        //退款申请保存
        save:function(data,widget){
            // summary:
            //         消费者提交退款申请的保存接口
            // view:
            //         refundRequest：消费者查看退款详情
            // description:
            // 
            var msg = this.getDataValidMsg(data, ["treatmentMethod","reason","amount","describe","uploadImage"]);
            if (msg) {
                alert(msg);
                return;
            }
            msg = this._verify(data); 
            if(msg){
                alert(msg);
                return;
            }
            var tsId = widget.cqRefInfo.cqViewParam.params, _this = this;
            window.busy();
            if(tsId.split("-")[0]!="revise"){
                data.tsId = tsId;
            }
            data.imgs = data.uploadImage;
            _this.exec('save',data).then(function (result) {
                window.free();
                if (result&&result.data && result.data.ok === 1) {
                    alert("申请成功");
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"申请失败");
                }
            });
        },
        getListUrl: function(){
            // summary:
            //         消费者端查看我的申请退款列表url
            // view:
            //         refundRequestList：消费者查看退款详情列表
            // description:
            // 
            return this.getBaseUrl()+"/loadByUserId?shopId="+consumer.getShopId()+"&userId="+consumer.getCurrentUserId();
        },
        loadByRefundId:function(id){
            // summary:
            //         消费者加载退款进度
            // view:
            //         refundRequestDetail:消费者查看退款详情
            // description:进度的cq/widgets/item/order/RefundSchedule.js
            //对外提供的接口，查看进度
            return this.exec("loadById",{_id:id});
        },
        //对外提供的取消接口
        revoke:function(id){
            //shopId:shopId,
            return this.exec("revoke",{_id:id});
        }
    });
    var refundAplicCBo = new RefundAplicCBo();
    refundAplicCBo.Bo = RefundAplicCBo;
    return refundAplicCBo;
});