define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    '../BoBase',
    'cq/util/sys/query',
    "cq/util/config/config",
    "cq/util/sys/date"
], function (declare,lang,BoBase,cqQuery,config, date) {
    var TransactionBo = declare("", [BoBase.B], {
        modalName:"ts/transaction",
        fields:{
            tsId:{
                type:"text",
                label:"交易单号",
                canEdit : false
            },
            tsType:{
                type:"options",
                label:"类型",
                options: {
                    1: "会员购买（在线支付）",
                    2: "支付手续费",
                    3: "交易手续费",
                    4: "交易补贴",
                    5: "店铺提现",
                    6: "店铺充值",
                    7: "团购活动预扣",
                    8: "团购活动补差额",
                    9: "退款",
                    10: "营销费",
                    11: "在线支付定金",
                    12: "定金支付手续费",
                    13: "定金交易手续费",
                    14: "定金补贴",
                    15: "分销收益",
                    101: "会员充值（在线支付）",
                    102: "会员充值支付手续费"
                },
                canEdit : false
            },
            tsAmount:{
                type:"number",
                label:"金额"
            },
            payType:{
                type:"options",
                label:"支付方式",
                options: {
                    "weixin": "微信",
                    "wxApp": "微信APP",
                    "wxNative": "微信",
                    "point": "余额",
                    "aliapp": "支付宝",
                    "aliwap": "支付宝"
                }
            },
            payLogId: {
                type: "text",
                label: "支付流水号"
            },
            createAt:{
                type:"dateTime",
                label:"生成时间",
                canEdit : false,
                qry:{
                    "type":"date",
                    canEdit:true
                }
            },
            tsState: {
                type: "options",
                options: {
                    1: "待确认",
                    2: "已结算",
                    3: "暂停中",
                    4: "已取消"
                },
                label: "状态"
            }
        },
        getListUrl: function(){
            return this.getBaseUrl()+"/load";
        },
        queryInfo: null,
        // 加载列表的条件
        getListParam: function(params){
            //处理起止时间
            var query = {
                // 查询不等于0的数据
                includeZero: false
            };
            if(params.query){
                if(params.query.createAtf){
                    query.createAtf = params.query.createAtf;
                }
                if(params.query.createAtt){
                    query.createAtt = params.query.createAtt;
                }
            }
            var s = params.cqViewParam.params;
            if(s){
                if(s.indexOf("ts_")>-1){
                    query.tsId = s.split("ts_")[1];
                }else{
                    query.shopId = s;
                }
            }
            query.shopId = query.shopId||this.getShopId();
            var queryValue = cqQuery.getQueryValue(params.state);
            if(queryValue&&queryValue!=5){
                query.tsState = queryValue;
            }
            else{
                delete query.tsState;
            }
            this.queryInfo = query;
            return query;
        },
        getQueryLayout:function(){
            return [{
                type: 'form',
                fields: this.getFormItems(['createAt'], true,"qry")
            }];
        },
        // 列表点击事件
        onListClick: function(data){
            if(data.tsType==101||data.tsType==102){
                return;
            }else if(data.tsType==5){
                window.moveToView("shopBalanceDepDetailB", data.tsId);
            }else if(data.tsType==6){
                window.moveToView("shopBalanceTraDetailB", data.tsId);
            }else{
                window.moveToView("orderDetailB",data.tsId);
            }
        },
        getExportLayout: function(){
            return this.getFormItems(["createAt","tsType","tsAmount","payType","payLogId","tsId","tsState"]);
        }
    });
    var transactionBo = new TransactionBo();
    transactionBo.Bo = TransactionBo;
    return transactionBo;
});