//会员系统公共基类
// 1、提供会员系统的基本属性
define([
    "dojo/_base/declare",
    "cq/app/config"
],function(declare,appConfig){
    appConfig.session = {};
    return declare("",null,{
        modalName: "user/user",
        fields: {
            // 用户
            userName: {
                type: "text",
                placeHolder: "请填写手机号",
                label: "手机号",
                className: "cq-item-username",
                notNull: true
            },
            //邀请人
            srcUser: {
                type: "text",
                placeHolder: "请填写手机号",
                label: "邀请人",
                className: "cq-item-username",
                notNull: true
            },
            // 密码
            password: {
                type: "password",
                placeHolder: "必须输入密码",
                label: "密码",
                className: "cq-item-password",
                notNull: true
            },
            repassword: {
                type: "password",
                placeHolder: "请确认密码",
                label: "确认密码",
                className: "cq-item-password",
                notNull: true
            },
            logo: {
                type: "image",
                label: "头像",
                sizeType: "cut",
                size: {
                    width: 640,
                    height: 640
                }
            },
            pName: {
                type: "text",
                placeHolder: "请输入姓名",
                label: "姓名"
            },
            nickName: {
                canEdit:false,
                type: "text",
                placeHolder: "请输入昵称",
                label: "昵称"
            },
            amount: {
                type: "number",
                label: "村币",
                fixedTo: 2
            },
            phone: {
                type: "tel",
                placeHolder: "",
                label: "手机号"
            },
            birthday: {
                type: "date",
                defaultDate:"1990-01-01",
                placeHolder: "",
                label: "生日"
            },
            sex: {
                type: "options",
                label: "性别",
                options: {
                    0: "男",
                    1: "女",
                    2: "保密"
                },
                canEdit: true
            },
            userDesc: {
                type: "textarea",
                className: "large-width large-high3",
                placeHolder: "",
                label: "简介"
            },
            address: {
                className: "large-width",
                type: "text",
                label: "地址"
            },
            contactName:{
                className: "large-width",
                type: "text",
                label: "收货人",
                notNull: true
            },
            tel:{
                className: "large-width",
                type: "text",
                label: "收货电话",
                notNull: true
            },
            detailAddress:{
                className: "large-width",
                type: "text",
                label: "收货地址",
                notNull: true
            },
            "provinceId,cityId,countyId,town": {
                type : "district",
                label : "省/市/区",
                canEdit : true,
                notNull: true
            },
            amont:{
                className: "large-width",
                type: "number",
                fixedTo: 2,
                label: "充值村币",
                placeHolder: "请填写充值村币",
                range: "(0,)",
                notNull: true
            },
            gold: {
                type: "Number",
                label: "金元宝",
                fixedTo: 2
            },
            "userLevel.levelName": {
                type: "text",
                label: "用户等级"
            },
            "userId.userName":{
                type: "text",
                placeHolder: "请填写手机号",
                label: "手机号",
                className: "cq-item-username",
                notNull: true
            },
            isDefault:{
                className: "large-width",
                type: "checkbox",
                label: "默认地址"
            },
            _id:{
                type:"text",
                label:"我的地址Id"
            },
            createAt: {
                type: "dateTime",
                label: "创建时间"
            },
            growth:{
                type:"text",
                label:"成长值",
                fixedTo: 2
            },
            subscribeDate: {
                type: "dateTime",
                label: "关注时间"
            },
            cancelDate: {
                type: "dateTime",
                label: "取消关注时间"
            },
            disTotalIncome: {
                type: "number",
                fixedTo: 2,
                label: "累计收益"
            },
            disPenddingAmt: {
                type: "number",
                fixedTo: 2,
                label: "待确认"
            },
            disRecieptAmt: {
                type: "number",
                fixedTo: 2,
                label: "已提现"
            },
            disRaiseableAmt: {
                type: "number",
                fixedTo: 2,
                label: "可提现"
            },
            //给充值时选填的备注
            remark:{
                type:"text",
                label:"备注",
                placeHolder: "填写备注"
            },
            fansNum1: {
                type: "number",
                label: "一级粉丝"
            },
            fansNum2: {
                type: "number",
                label: "二级粉丝"
            },
            fansNum3: {
                type: "number",
                label: "三级粉丝"
            },
            "srcUid.nickName": {
                type: "text",
                label: "邀请人昵称"
            },
            "srcUid.pName": {
                type: "text",
                label: "邀请人姓名"
            }
        },
        //获取当前用户ID
        getCurrentUserId: function () {
            return appConfig.session.userId;
        }
    });
});