define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "bob/user/_UserMixin",
    "bob/user/actionGrowth/_Mixin",
    "cq/app/config",
    "cq/util/sys/common",
    "cq/util/config/config",
    "bob/shop/shop",
    "bob/BoBase"
], function (declare, lang, topic, _UserMixin, _ActionGrowthMixin, appConfig, common, config, shop, BoBase) {
    var ActionGrowthBo = declare("",[BoBase.B,_UserMixin,_ActionGrowthMixin],{
		fields:{
            // 1:  基础个人资料
            basicInfo:{
                type:"number",
                label:"完善基本资料"
            },
            // 2.  完善会员资料
            otherInfo:{
                type:"number",
                label:"完善会员资料"
            },
            // 3.  签到
            // 4.  每次购物
            tsRate:{
                type:"number",
                label:"购物赠送比例"
            },
            // 5.  邀请新用户
            inviteUser:{
                type:"number",
                label:"邀请新用户"
            },
            // 6.  微信关注
            wechatSubscribe:{
                type:"number",
                label:"微信关注"
            },
            // 8.  APP下载
            firstAppLogin:{
                type:"number",
                label:"APP首次登陆"
            },
            // 10. 微信分享
            weChatShare:{
                type:"number",
                label:"微信分享"
            },
            // 12. 商品收藏
            collectMat:{
                type:"number",
                label:"收藏商品"
            },
            // 13. 店铺收藏
            collectShop:{
                type:"number",
                label:"收藏店铺"
            },
            // 14. 首次购物
            firstTs:{
                type:"number",
                label:"首次购物"
            },
            // 15. 二次购物
            secondTs:{
                type:"number",
                label:"二次购物"
            },
            // 16. 五次购物
            fifthTs:{
                type:"number",
                label:"五次购物"
            },
            // 17. 十次购物
            tenthTs:{
                type:"number",
                label:"十次购物"
            },
            // 18. 每次评价
            commentMat:{
                type:"number",
                label:"评价商品"
            },
            // 19. 村友说首次发布
            firstTimeLine:{
                type:"number",
                label:"首次发布动态"
            },
            // 20. 村友说每天首次发布
            dailyFirstTL:{
                type:"number",
                label:"每天首次发布动态"
            },
            // 21. 会员关注
            followUser:{
                type:"number",
                label:"关注会员"
            },
            // 22. 会员被关注
            followedUser:{
                type:"number",
                label:"会员被关注"
            },
            // 23. 村友圈点赞
            praiseTL:{
                type:"number",
                label:"村友圈点赞"
            },
            // 24. 村友圈被点赞
            praisedTL:{
                type:"number",
                label:"村友圈被点赞"
            },
            // 25. 村有圈评论
            commentTL:{
                type:"number",
                label:"村有圈评论"
            },
            // 26. 村友圈被评论
            commentedTL:{
                type:"number",
                label:"村友圈被评论"
            },
            // 27. 每天网站第一次访问
            visitWeb:{
                type:"number",
                label:"每天首次访问网站"
            },
            // 28. 每天微信第一次访问
            visitWeChat:{
                type:"number",
                label:"每天首次访问微信"
            },
            // 29. 每天APP第一次访问
            visitApp:{
                type:"number",
                label:"每天访问APP"
            },
            saveActionGrowthButton:{
                type:"button",
                label:"完成",
                action:"saveActionGrowthAction",
                className:"fullButton"
            }
        },

        //行为与成长值列表的数据获取
        getListUrlForActionGrowth:function () {
            return this.getBaseUrl() +"/load?shopId="+this.getShopId();
        },
        //行为与成长值列表数据组装
        getItemPropForActionGrowth: function(items){
            return items;
        },
        //行为与成长值列表参数传递
        getListParamForActionGrowth: function(){
            var query = {};
            return query;
        },
        //行为与成长值列表的列表点击事件
        onListClickForActionGrowth: function(data){
            window.moveToView("actionGrowthEdt",data._id);
        },

        //编辑行为与成长值编辑界面的Layout
        getListLayoutForActionGrowth:function(){
            return [{
                type: "form",
                fields: this.getFormItems(["basicInfo","otherInfo","tsRate","inviteUser","wechatSubscribe","firstAppLogin","weChatShare","collectMat","collectShop","firstTs","secondTs","fifthTs","tenthTs","commentMat","firstTimeLine","dailyFirstTL","followUser","followedUser","praiseTL","praisedTL","commentTL","commentedTL","visitWeb","visitWeChat","visitApp","saveActionGrowthButton"])
            }];
        },
        //编辑指定的行为与成长值数据获取
        loadActionGrowthById: function(param){
            return this.exec("load",{shopId:this.getShopId()}).then(function(data){
                return data&&data.data&&data.data.items[0]||data;
            });
        },
        //行为与成长值编辑界面的保存按钮
        saveActionGrowthAction:function(data){
            var msg = this.getDataValidMsg(data);
            if(msg){
                alert(msg);
                return
            }
            this.exec("save",data).then(lang.hitch(this, function (result) {
                if(result&&result.data&&result.data.ok==1){
                    alert("保存成功");
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"保存失败")
                }
            }));
        },
        //输入检验
        getDataValidMsg: function(data){
            var msg = "";
            var re = /^[0-9]+$/;
            var fields = ["basicInfo","otherInfo","tsRate","inviteUser","wechatSubscribe","firstAppLogin","weChatShare","collectMat","collectShop","firstTs","secondTs","fifthTs","tenthTs","commentMat","firstTimeLine","dailyFirstTL","followUser","followedUser","praiseTL","praisedTL","commentTL","commentedTL","visitWeb","visitWeChat","visitApp","saveActionGrowthButton"];
            for(var i =0;i<fields.length;i++){
                if(!data[fields[i]]){
                    continue;
                }
                if(data[fields[i]]<0){
                    return this.fields[fields[i]].label+"不能小于0";
                }
                if(fields[i]=="tsRate"){
                    if(parseFloat(data[fields[i]],10)!=data[fields[i]]){
                        return this.fields[fields[i]].label+"必须为数字";
                    }
                }else if(parseFloat(data[fields[i]],10).toFixed(0)!=data[fields[i]]){
                    return this.fields[fields[i]].label+"必须为正整数";
                }
            }
        }
	});
    var actionGrowthBo = new ActionGrowthBo();
    actionGrowthBo.Bo = ActionGrowthBo;
	return actionGrowthBo;
});