﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang"
],function(declare,lang){
    var consumer = "";
    setTimeout(function(){
        require(["bob/user/consumer"],function(c){
            consumer = c;
        });
    },0);
    return declare("",null,{
        modalName:"user/user",
        //加载默认收货地址
        getDefaultAddr:function(){
            return this.exec("loadDefaultAddress",{
                userId:consumer.getCurrentUserId()
            });
        },
        //加载所有的地址
        getAllAddr:function(){
            return this.exec("loadAddrList",{
                shopId:this.getShopId(),
                userId:consumer.getCurrentUserId()
            });
        },
        //根据id获取收获地址
        getAddrById:function(id){
            return this.exec("loadAddr",{
                _id:id
            });
        },
        
        
        
        //收货地址管理的功能及其接口
        //app我的收货地址列表的数据获取
        getUserAddrListUrl : function(){
            return this.getBaseUrl() + "/loadAddrList?shopId=" + this.getShopId() + "&userId=" + appConfig.session.userId;
        },
        //app我的收货地址列表数据获取的查询参数
        getUserAddrListQuery:function(){
            var query = {};
            return query;
        },
        //app我的收货地址列表的列表项点击事件
        //原来getUserAddrListActions
        onUserAddrListClick: function (item) {
			window.moveToView("userAddrDetail", item._id);
		},
        //app我的收货地址列表的添加地址函数
        //原来addAddress
        moveToUserAddrDetail:function(){
            window.moveToView("userAddrDetail");
        },
        //我的收货地址列表的删除地址响应函数（页面未实现）
        deleteAddress : function(id){
            window.busy();
            return this.exec("deleteAddress",{
                shopId : this.getShopId(),
                _id : id
            }).then(lang.hitch(this, function (dat) {
                window.free();
                if (dat.data.ok == 1) {
                    alert("删除成功");
                } else {
                    alert("删除失败");
                }
            }));
        },
        //我的收货地址详情界面及其接口
        //app我的收货地址详情编辑界面
        getUserAddrDetailLayout:function(){
            if (!this.userAddrDetailLayout) {
                this.userAddrDetailLayout = [{
                    type: "form",
                    fields: this.getFormItems([
                        "contactName","tel","provinceId,cityId,countyId,distAddr","detailAddress","isDefault",/*"UserAddrDetailButton"*/"onSubmitUserAddrDetailButton"
                    ])
                }];
            }
            return this.userAddrDetailLayout;
        },
        //app我的收货地址详情界面的数据获取
        //原来getUserAddrDetail
        getUserAddrDetailData:function(e){
            window.busy();
            return this.exec("loadAddr", {
                    _id:e.cqViewParam.params,
                    shopId:this.getShopId(),
                }).then(lang.hitch(this, function (dat) {
                    window.free();
                    return dat.data.item;
            }));
        },
        //app我的收货地址列表的地址编辑界面的数据保存
        //原来saveAddr
        onUserAddrDetail:function(data) {
            var item = {};
            item.cityId = data.cityId._id;
            item.contactName = data.contactName;
            item.countyId = data.countyId._id;
            item.detailAddress = data.detailAddress;
            item.isDefault = data.isDefault;
            item.provinceId = data.provinceId._id;
            item.provinceName = data.provinceId.distName + "-" + data.cityId.distName + "-" + data.countyId.distName;
            item.shopId = this.getShopId();
            item.tel = data.tel;
            if(data._id){
                item.__v = 0;
                item._id = data._id;
                item.createAt =  data.createAt;
                item.lastMod = data.lastMod;
            }
            window.busy();
            return this.saveUserAddr(item).then(lang.hitch(this, function (result) {
                window.free();
                if (result.data && result.data.ok === 1) {
                    history.back();
                } else {
                    alert("保存失败");
                }
                return data&&data.data&&data.data.item;
            }));
        },
        saveUserAddr:function(item){
            item.userId = consumer.getCurrentUserId();
            return this.exec("saveAddr",item);
        },
        //app我的收货地址编辑界面的设置默认地址接口（界面未启用）
        setDefaultAddr:function(id){
            window.busy();
            return this.exec("setDefault",{
                shopId : this.getShopId(),
                _id : id
            }).then(lang.hitch(this, function (data) {
                window.free();
                if (data.data.ok == 1) {
                    return data.data.item;
                    alert("设置默认地址成功");
                } else {
                    alert ("设置失败");
                }
            }));
        },
        //合法性检查
        validAddr : function (savaData) {
            if (!savaData.contactName) {
                return "请输入收货人姓名";
            }
            if (!(savaData.tel&&(this.isTel(savaData.tel)||this.isCellPhone(savaData.tel)))) {
                return "请输入正确的电话号码";
            }
            if(!savaData.provinceName){
                if (!savaData.provinceId) {
                    return "请选择省";
                }
                if (!savaData.cityId) {
                    return "请选择市";
                }
                if (!savaData.countyId) {
                    return "请选择县";
                }
            }
            if (!savaData.detailAddress) {
                return "请输入详细地址";
            }
        }
    });
});
