define([
    "dojo/_base/declare",
    "cq/util/sys/query",
    "dojo/_base/lang",
    "../BoBase",
    "cq/util/config/config"
], function (declare, query, lang, BoBase, config) {
    //本对象功能：
    //      编辑客户等级
    var ClientLevelBBo = declare("", [BoBase.B], {
        modalName: "user/clientLevel",
        //字段写在userBase里面
        fields: {
            onSave: {
                type: 'button',
                label: '保存',
                action: 'onSave'
            },
            levelName:{
                type: "text",
                label: "等级名称",
                placeHolder: "填写等级名称",
                notNull:true
            }
        },
        getEditLayout:function(){
             return [{
                type: "form",
                fields: this.getFormItems([
                    "levelName", "onSave"
                ], true)
            }];
        },
        //会员等级列表数据获取
        getListUrl:function () {
            return this.getBaseUrl() +"/load?shopId="+this.getShopId();
        },
        onListClick: function(data){
            window.moveToView("clientLevelEdit",data._id);
        },
        loadData : function (params) {
            return this.exec("load");  
        },
        onSave:function(data){
            var msg = this.getDataValidMsg(data, ["levelName"]);
            if(msg){
                alert(msg);
                return;
            }
            return this.exec("save", data).then(lang.hitch(this, function(result){
                if(result.data.ok){
                    history.back();
                }else{
                    alert(result.data.msg);
                }
            }));
        },
        loadById:function(params){
            if (!(params&&params.cqViewParam&&params.cqViewParam.params)) {
                return;
            }
            return this.exec("loadById",{
                _id:params.cqViewParam.params
            }).then(lang.hitch(this,function(result){
                return result.data.item;
            }));
        }
    });
	var clientLevelBBo = new ClientLevelBBo();
	clientLevelBBo.Bo = ClientLevelBBo;
	return clientLevelBBo;
});