//作为消费者，对会员做的所有操作
define([
    "dojo/_base/declare",
    "dojo/Deferred",
    "dojo/topic",
    "dojo/_base/lang",
    "./_UserMixin",
    "../BoBase",
    "./addr/_AddrMixin",
    "cq/app/config",
    "cq/util/config/config",
    "cq/util/sys/userAgent",
    "cq/util/share/share",
    "bob/user/friendRequest",
    "bob/user/follow",
    "cq/util/image/blob"
], function (declare, Deferred, topic, lang, _UserMixin,BoBase,_AddrMixin, appConfig, config, userAgent,share,friendRequest,follow,blob) {
    // 操作的busy和free问题
    //      任何有异步操作的动作都应该busy,所有操作完成之后free
    // 命名规范，大小写、用词和含义
    // 属性、方法按照功能分组
    // 一件事儿应该只有一个接口处理
    //      onXXXClick(列表的点击事件)
    //      onSubmitXXX(遍及界面的确认/完成按钮)
    //      getXXXData(加载一行数据)
    //      getXXXUrl(查数据的地址)

    var lastLoginTime = null;
    config.session = config.session||{};
    //会员功能
    //      注册、登录、找回密码、修改密码、修改个人信息
    //店铺管理员功能
    //      店铺列表、添加店铺
    var ConsumerBo =  declare("",[BoBase.C,_UserMixin,_AddrMixin],{
        fields:{
            //重载基类的用户名，添加了图标属性
            userName: {
                type: "text",
                placeHolder: "请填写手机号",
                label: "手机号",
                className: "cq-item-username",
                notNull: true
            },
            loginName: {
                type: "text",
                label: "登录名"
            },
            // 登录相关按钮
            // 去登陆按钮
            toLoginViewButton: {
                type: "button",
                label: "去登录",
                action: "moveToLogin",
                buttonClass: "fullButton"
            },
            // 登录按钮
            //原来loginButton
            onSubmitLoginButton: {
                type: "button",
                label: "登录",
                action: "onLogin",
                buttonClass: "fullButton"
            },
            // 注册相关按钮
            // 去注册按钮
            toRegisterViewButton: {
                type: "button",
                label: "去注册",
                action: "moveToRegister",
                buttonClass: "fullButton"
            },
            // 注册按钮
            onSubmitRegisterButton: {
                type: "button",
                label: "注册",
                action: "onRegister",
                buttonClass: "fullButton"
            },
            // 找回密码相关按钮
            // 去找回密码按钮
            toFindPwdViewButton: {
                type: "button",
                label: "找回密码",
                action: "moveToFindPwd",
                buttonClass: "txtButton"
            },
            // web端找回密码按钮
            //原来findPwdButton
            onSubmitFindPwdButton: {
                type: "button",
                label: "确定",
                //原来findPwd
                action: "onFindPwd",
                buttonClass: "fullButton"
            },
            // web端修改密码相关按钮 
            onSubmitPwdButton:{
                className : "fullButton",
                type: "button",
                label: "确定",
                action: "onMdfPwd"
            },

            // 注册等消费者功能相关特有字段
            // 验证码
            "userName,vcode": {
                type: "vcode",
                errorMsg: "请输入正确的11位电话号码",
                unExists: "账号已经存在,请直接登录",
                noIcon:true,
                notNull: true
            },
            // 密码——是公共的，写到了基类中
            // 确认密码
            confirmPassword: {
                type: "password",
                placeHolder: "请再次输入密码",
                label: "确认密码",
                className: "cq-item-password",
                notNull: true
            },

            // 修改密码特有字段
            // 原密码
            oldPassword: {
                type: "password",
                placeHolder: "请输入原密码",
                label: "原密码"
            },
            // 新密码
            newPassword: {
                type: "password",
                placeHolder: "请输入新密码",
                label: "新密码"
            },
            // 找回密码特有字段
            // 手机号、验证码，新密码，确认密码，上边已经定义

            //个人信息的功能字段
            //web端个人信息的保存按钮
            //原来mdfUserInfoButton
            onSubmitMdfUserInfoButton: {
                type: "button",
                label: "确认",
                //原来mdfUserInfo
                buttonClass: "fullButton mblListItem",
                action: "onMdfUserInfo"
            },

            //收货地址详情的相关字段
            //我的收货地址详情的保存按钮
            //原来UserAddrDetailButton
            onSubmitUserAddrDetailButton:{
                className : "large-width",
                type: "button",
                label: "保存",
                action: "onUserAddrDetail"
            },
            provinceName: {
                type: "text"
            },
            cityName: {
                type: "text"
            },
            countyName: {
                type: "text"
            },
            editAddr: {
                type: "button",
                action: "editAddr"
            },
            deleteAddr: {
                type: "button",
                action: "deleteAddress"
            },
            isBindPhone : {
                type: "button",
                action: "isBindPhone"
            },
            provinceId: {
                type: "text",
                label: "省/市/区",
                notNull: true
            },
            cityId: {
                type: "text",
                label: "省/市/区",
                notNull: true
            },
            countyId: {
                type: "text",
                label: "省/市/区",
                notNull: true
            },
            "provinceId,cityId,countyId,distAddr":{
                "type":"district",
                "label":"区划",
                "canEdit":true
            },
            dftAddr: {
                type: "text",
                formatter: function(action, data){
                    if(data.isDefault){
                        return "<div class='dftAddr'></div>";
                    }else{
                        return "";
                    }
                }
            },
            toAddFollow: {
                type: "button",
                action: "toAddFollow"
            },
            toCancelFollow: {
                type: "button",
                action: "toCancelFollow"
            },
            toTalk: {
                type:"button",
                action: "toTalk"
            },
            attentionNum: {
                type: "text"
            },
            fansNum: {
                type: "text"
            },

            //分店铺客户余额相关字段
            "fromShopId._id": {
                type:"text"
            },
            "fromShopId.shopName":{
                type:"text"
            },
            "fromShopId.logo":{
                type:"text"
            },
            getBigImgUrl : {
                type : "button"
            },
            //去认证按钮
            toUserAut: {
                type: "button",
                label: "去认证",
                action: "moveToUserAut",
                buttonClass: "txtButton"
            },
            userAut: {
                type: "text"
            },
            growth: {
                type: "Number"
            },
            "wxLoginButton":{
                type:"button",
                label:"微信登录",
                action:"onWxLogin",
                buttonClass:"fullButton"
            },
            toBindPhoneBtn: {
                type: "button",
                label: "绑定",
                action: "bindPhone",
                buttonClass: "fullButton"
            },
            "lon,lat":{
                type: "location",
                distFields:"provinceId,cityId,countyId",
                distFieldsStr:"distAddr",
                className: "locationNone",
                label: "获取当前位置",
            },
            getLocation:{
                type:"button",
                label:"获取当前位置",
                action:"getLocation",
                buttonClass:"mini-btn"
            }
        },
        //自动获取收获地址
        getLocation:function(data,widget){
            this.getCurrentUser().then(lang.hitch(this,function(userData){
                var loc = widget.getEditorByField(["lon,lat"]);
                loc.setValue([userData.lon,userData.lat]);
            }));
        },
        // 从缓存中获取当前用户信息
        getCurrentUserFromSession: function(){
            return config.session.userInfo||{};
        },
        // 绑定手机号页面
        getBindPhoneLayout: function(){
            return [{
                type: "form",
                fields: this.getFormItems([
                    "loginName","userName,vcode", "password", "confirmPassword", "toBindPhoneBtn"
                ])
            }];
        },
        onDataReadyForDetail:function(widget){
            //隐藏location自动获取的字段，
            widget.hideByFields(["lon,lat","getLocation"]);
            //根据编辑和新增形式隐藏获取当前位置按钮
            if(!widget.getData()._id){
                widget.showByFields(["getLocation"]);
            }
        },
        onDataReadyForBindPhone: function(widget){
            var data = widget.getData();
            if(!data._id){
                return;
            }
            widget.disableByFields(["loginName"]);
            widget.hideByFields(["loginName","userName,vcode", "password", "confirmPassword", "toBindPhoneBtn"]);
            // 如果有用户名 且用户名不是手机号 则支持绑定
            var isPhone = this.isTel(data.loginName)||this.isCellPhone(data.loginName);
            // 如果没有userName 或者userName不是手机号码 则支持绑定
            if(!data.userName||!isPhone){
                widget.showByFields(["userName,vcode", "password", "confirmPassword", "toBindPhoneBtn"]);
                // 清空之前系统中的userName
                widget.getEditorByField("userName,vcode").setValue([""]);
            }else{
                widget.showByFields(["loginName"]);
            }
        },
        bindPhone: function(data, widget){
            var msg = this.getDataValidMsg(data, ["userName", "vcode", "password", "confirmPassword"]);
            if(msg){
                alert(msg);
                return;
            }
            if (!this.isCellPhone(data.userName)) {
                alert("手机号格式不合法");
                return;
            }
            if(data.password!==data.confirmPassword){
                alert("密码与确认密码不一致");
                return;
            }
            window.busy();
            this.exec("bindPhone", data).then(lang.hitch(this, function(result){
                window.free();
                if(result&&result.data&&result.data.ok==1){
                    alert("绑定成功");
                    widget.cqRefresh();
                }else{
                    alert(result&&result.data&&result.data.message||"绑定失败");
                }
            }));
        },
        // 点击用户头像 查看大图
        getBigImgUrl : function(data){
            if(data._id){
                require(["cq/widgets/bigImg"],lang.hitch(this,function(bugImg){
                    bugImg.show(data.logo);
                }));
            }
        },
        // 登录页面Layout
        getLoginLayout: function () {
            // summary:
            //         消费者登录Layout
            // view:
            //         login
            // description:
            //         无
            return [{
                type: "form",
                fields: this.getFormItems([
                    "userName", "password", "onSubmitLoginButton", "toRegisterViewButton", "toFindPwdViewButton","wxLoginButton"
                ])
            }];
        },
        // 点击登录按钮的操作
        onLogin: function (data, widget) {
            // summary:
            //         消费者登录按钮的响应
            // view:
            //         login
            // description:
            //         无
            widget.getEditorByField("password").blur();
            widget.getEditorByField("userName").blur();
            var msg = this.getDataValidMsg(data, ["userName", "password"]);
            if (msg) {
                alert(msg);
                return;
            }
            window.busy();
            return this.doLogin(data).then(lang.hitch(this, function (datas) {
                window.free();
                if (datas.data.ok == 1) {
                    var item = datas&&datas.data&&datas.data.item;
                    config.session.loginBackLevel = 1;
                    this.loginBack();
                } else {
                    alert(datas.data.msg || "无效的用户名或密码");
                }
            }));
        },
        // summary:
        //         登陆界面如果有缓存用户名，则将其显示出来
        // view:
        //         login
        // description:
        //         无
        initUserLoginInfo:function(){
            var userName = localStorage.getItem("userName");
            userInfo = {};
            if(userName){
                userInfo.userName = userName;
            }
            return userInfo;
        },
        loginBack:function(){
            // summary:
            //         登陆界面返回按钮的处理
            // view:
            //         login
            // description:
            //         无
            if(config.session.loginBackLevel==2){
                if(history.length<3){
                    window.moveToView("main");
                }else{
                    history.go(-2);
                }
            }else{
                if(history.length==1){
                    window.moveToView("main");
                }else{
                    history.go(-1);
                }
            }
        },
        addFriend: function(userId){
            // summary:
            //         app发送添加好友请求
            // view:
            //         timeLine
            // description:
            //         无

            // 调用 friendRequest 的addFriend
            return friendRequest.addFriend(userId).then(lang.hitch(this,function(dat){
                return dat;
            }));
        },
        // 消费者执行登录
        doLogin: function (data) {
            // summary:
            //         消费者登录操作的执行
            // view:
            //         login
            // description:
            //         无
            window.busy();
            lastLoginTime = null;
            return this.exec("loginByPassword", {
                userName: data.userName,
                password: data.password
            }).then(lang.hitch(this, function (result) {
                //window.free();
                if (result.data.ok == 1) {
                    this._onLoginSuccess(result.data.item);
                } else {
                    delete config.session.userId;
                }
                return result;
            }));
        },
        // 跳转到登录界面
        moveToLogin: function () {
            // summary:
            //         跳转到找回密码
            // view:
            //         findPwd
            // description:
            //         无
            window.moveToView("login");
        },
        moveToFindPwd: function () {
            // summary:
            //         跳转到找回密码
            // view:
            //         login
            // description:
            //         无
            window.moveToView("findPwd");
        },
        moveToRegister: function () {
            // summary:
            //         跳转到注册页面
            // view:
            //         login
            // description:
            //         无
            window.moveToView("register");
        },
        getRegisterLayout: function () {
            // summary:
            //         消费者注册Layout
            // view:
            //         register
            // description:
            //         无
            return [{
                type: "form",
                formClass: "no-border",
                fields: this.getFormItems([
                    "userName,vcode", "password", "confirmPassword", "srcUser", "onSubmitRegisterButton"//, "registerProtocol"
                ])
            }];
        },
        onRegister: function (data, wiget) {
            // summary:
            //         消费者注册按钮响应
            // view:
            //         register
            // description:
            //         无
            var msg = this.getDataValidMsg(data, ["userName", "vcode", "password", "confirmPassword"]);
            if (msg) {
                alert(msg);
                return;
            } else if (data.password != data.confirmPassword) {
                alert("两次密码不一致！");
                return;
            } else if(data.userName == data.srcUser){
                alert("邀请人不能为自己！");
                return;
            }
            if (!this.isCellPhone(data.userName)) {
                alert("手机号格式不合法");
                return;
            }
            window.busy();
            data.platformShopId = config.getPlatformShopId();
            data.vCode = data.vcode;
            delete data.vcode;
            if(!data.srcUser){
                delete data.srcUser;
            }
            this.doRegister(data).then(lang.hitch(this, function (datas) {
                if (datas&&datas.data && datas.data.ok==1) {
                    //  自动执行登录
                    var loginData = {};
                    loginData.userName = data.userName;
                    loginData.password = data.password;
                    this.doLogin(loginData).then(lang.hitch(this,function(result){
                        window.free();
                        if(result&&result.data&&result.data.ok == 1){
                            config.session.loginBackLevel = 2;
                            this.loginBack();
                        }else{
                            window.moveToView("login");
                        }
                    }));
                } else {
                    window.free();
                    alert(datas&&datas.data&&datas.data.message||"注册失败");
                }
            }));
        },
        doRegister: function (data) {
            // summary:
            //         消费者注册的执行接口，店铺管理员注册的实现可能不同
            // view:
            //         register
            // description:
            //         无
            lastLoginTime = null;
            return this.exec("registerByPassword", data).then(lang.hitch(this, function (result) {
                return result;
            }));
        },
        getFindPwdLayout: function () {
            // summary:
            //         web、app端找回密码layout
            // view:
            //         findPwd
            // description:
            //         无
            var layout = [{
                type: "form",
                fields: this.getFormItems([
                    "userName,vcode", "password", "confirmPassword", "onSubmitFindPwdButton"
                ])
            }];
            layout[0].fields[0].canToLogin = false;
            return layout;
        },
        onFindPwd: function (data, widget) {
            // summary:
            //        web找回密码操作
            // view:
            //         findPwd
            // description:
            //         无
            var msg = this.getDataValidMsg(data, ["userName", "vcode", "password", "confirmPassword"]);
            if (msg) {
                alert(msg);
                return;
            } else if (data.password != data.confirmPassword) {
                alert("两次密码不一致");
                return;
            }
            window.busy();
            // 找回密码
            this.exec("resetPassword", {
                "userName": data.userName,
                "password": data.password,
                "vCode": data.vcode
            }).then(lang.hitch(this, function (result) {
                window.free();
                if (result&&result.data&&result.data.ok === 1) {
                    this.loginBack();
                } else {
                    alert(result&&result.data&&result.data.message||"修改失败");
                }
            }));
        },
        getMdfPwdLayout: function () {
            // summary:
            //        app端修改密码Layout
            // view:
            //         mdfPwd
            // description:
            //         无
            return [{
                type: "form",
                fields: this.getFormItems([
                    "oldPassword", "newPassword", "confirmPassword", "onSubmitPwdButton"
                ])
            }];
        },
        onMdfPwd: function (data, widgets) {
            // summary:
            //        app端修改密码操作的执行
            // view:
            //         mdfPwd
            // description:
            //         新密码和老密码不能一样
            if (data.oldPassword === data.newPassword) {
                alert("原密码和新密码不能一样");
                return;
            }
            if (!data.newPassword || data.newPassword !== data.confirmPassword) {
                alert("新密码必须输入，且两次输入的密码需一致");
                return;
            }
            window.busy();
            this.exec("modifyPasswordById", {
                _id: config.session.userId,
                password: data.oldPassword,
                newPassword: data.newPassword
            }).then(lang.hitch(this, function (result) {
                window.free();
                if (result.data.ok === 1) {
                    //清除原先的密码
                    localStorage.removeItem(this.loginShopId + "password");
                    history.back();
                } else {
                    widgets.updateByField("oldPassword");
                    alert("修改失败，请检查原密码是否正确");
                }
            }));
        },

        //收货地址管理的功能及其接口
        getUserAddrListUrl : function(){
            // summary:
            //        app我的收货地址列表的数据获取
            // view:
            //         userAddrList
            // description:
            //         无
            return this.getBaseUrl() + "/loadAddrList?shopId=" + this.getShopId() + "&userId=" + config.session.userId;
        },
        getUserAddrListQuery:function(){
            // summary:
            //        app我的收货地址列表数据获取的查询参数
            // view:
            //         userAddrList
            // description:
            //         无
            var query = {};
            return query;
        },
        getItemPropForAddr: function(data){
            data.provinceName = data.provinceId.distName;
            data.cityName = data.cityId.distName;
            data.countyName = data.countyId.distName;
            return data;
        },
        onUserAddrListClick: function (item,action,widgets) {
            // summary:
            //        app我的收货地址列表的列表项点击事件
            // view:
            //         userAddrList
            // description:
            //         无
            //处理点击编辑按钮事件响应
            if(action=="editAddr"){
                window.moveToView("userAddrDetail", item._id);
            }else if(action=="deleteAddress"){
                window.busy();
                //处理点击删除地址按钮的响应
                this.deleteAddress(item._id).then(lang.hitch(this, function(result){
                    window.free();
                    if(result&&result.data&&result.data.ok==1){
                        alert("删除成功");
                        widgets.cqRefresh();
                    }else{
                        alert(result&&result.data&&result.data.message||"删除失败");
                    }
                }));
            }else{
                window.moveToView("userAddrDetail", item._id);
            }
        },
        moveToUserAddrDetail:function(){
            // summary:
            //        app我的收货地址列表的添加地址按钮的响应函数
            // view:
            //         userAddrList
            // description:
            //         无
            window.moveToView("userAddrDetail");
        },
        deleteAddress : function(id){
            // summary:
            //        我的收货地址列表的删除地址响应函数
            // view:
            //         无
            // description:
            //         无
            return this.exec("deleteAddress",{
                shopId : this.getShopId(),
                _id : id
            }).then(lang.hitch(this, function (dat) {
                return dat;
            }));
        },
        //我的收货地址详情界面及其接口
        getUserAddrDetailLayout:function(){
            // summary:
            //        app我的收货地址详情编辑界面
            // view:
            //         userAddrDetail
            // description:
            //         无
            if (!this.userAddrDetailLayout) {
                this.userAddrDetailLayout = [{
                    type: "form",
                    fields: this.getFormItems([
                        "contactName","tel","provinceId,cityId,countyId,distAddr","detailAddress","isDefault","onSubmitUserAddrDetailButton",
                        "lon,lat","getLocation"
                    ])
                }];
            }
            return this.userAddrDetailLayout;
        },
        getUserAddrDetailData:function(e){
            // summary:
            //        app我的收货地址详情界面的数据获取
            // view:
            //         userAddrDetail
            // description:
            //         无
            window.busy();
            return this.exec("loadAddr", {
                    _id:e.cqViewParam.params,
                    shopId:this.getShopId(),
                }).then(lang.hitch(this, function (dat) {
                    window.free();
                    return dat.data.item;
            }));
        },
        onUserAddrDetail:function(data) {
            // summary:
            //        app我的收货地址详情界面的数据保存
            // view:
            //         userAddrDetail
            // description:
            //         无
            var msg = this.getDataValidMsg(data, ["contactName", "tel", "provinceId",
            "cityId", "countyId", "detailAddress"]);//this.checkFeild(data);
            if(msg){
                alert(msg);
                return;
            }
            var item = {};
            item.cityId = data.cityId._id;
            item.provinceId = data.provinceId._id;
            item.countyId = data.countyId._id;
            item.distAddr = data.distAddr;
            item.contactName = data.contactName;
            item.detailAddress = data.detailAddress;
            item.isDefault = data.isDefault;
            item.shopId = this.getShopId();
            item.tel = data.tel;
            item.userId = config.session.userId;
            if(data._id){
                //item.__v = 0;
                item._id = data._id;
                item.createAt =  data.createAt;
                item.lastMod = data.lastMod;
            }
            window.busy();
            return this.exec("saveAddr", item).then(lang.hitch(this, function (result) {
                window.free();
                if (result&&result.data && result.data.ok === 1) {
                    history.back();
                } else {
                    alert(result&&result.data&&result.data.message);
                }
            }));
        },
        
        
        incLoginGrowth:function(){
        },
        // 其他公共函数
        // 登录成功的后续处理
        //      保存信息到session
        //      保存对应商家客户信息
        //      发布登录完成的事件
        //      用户登陆成功后获取地理位置并保存到数据库（或更新相应的字段）
        //      如果为获取到则不做操作
        _onLoginSuccess: function (info,userChanged) {
            // summary:
            //        登录成功的后续处理
            // view:
            //         无
            // description:
            //         无
            if (!config.session){
                config.session = {};
            }
            if(!config.session.shopUserInfo){
                config.session.shopUserInfo = {};
            }
            if(info&&info.lon&&info.lat){
                config.position = [info.lon,info.lat];
            }
            info = info||config.session.shopUserInfo[this.getShopId()]||{};
            try{
                var _this = this;
                //如果用户是从微信公众号登录，且本次登录为今天的第一次，调用赠送积分接口
                var shopId = this.getShopId();
                require([
                    "cq/util/sys/date",
                    "cq/util/sys/geo",
                    "bob/user/actionGrowth/c"
                ],function(date,geo,actionGrowth){
                    //每天首次登陆
                    var now = lastLoginTime,needUpdate = false;
                    lastLoginTime = new Date(date.nowISOString());
                    if(!now||lastLoginTime.getDate()!==now.getDate()){
                        needUpdate = true;
                        if(userAgent.isApp()){
                            actionGrowth.onAppLogin();
                        }else if(userAgent.isWeixin()){
                           actionGrowth.onWxLogin();
                        }else{
                            actionGrowth.onWebLogin();
                        }
                    }
                });
            }catch(err){
                
            }
            if(false!==userChanged){
                config.session.userId = info._id;
                config.session.userName = info.userName;
                config.session.userInfo = info;
                if (!config.session.shopUserInfo){
                    config.session.shopUserInfo = {};
                }
                config.session.shopUserInfo[this.getShopId()] = info;
                topic.publish("/cq/biz/user/user/hasLogin", true);

                //登录成功后缓存登录账号
                localStorage.setItem('userName',info.userName);
            }
        },
        getUserLocation:function(){
            var def = new Deferred();
            if(config.position&&config.position.length==2){
                def.resolve(config.position);
                return def;
            }
            require([
                "cq/util/sys/geo"
            ],lang.hitch(this,function(geo){
                return geo.getCurrentPosition().then(function(position){
                    if(position&&position.position){
                        config.position = [position.position.lng,position.position.lat];
                    }
                    return config.position;
                }).then(lang.hitch(this,function(position){
                    if(config.session&&config.session.userId){
                        this.saveUserDetail({
                            _id:config.session.userId,
                            lon:position[0],
                            lat:position[1]
                        });
                    }
                    return position;
                })).then(function(position){
                    def.resolve(position);
                });
            }));
            return def;
        },
        // 对外提供的接口
        getCurrentUserId: function () {
            // summary:
            //        获取当前用户ID
            // view:
            //         timeLineForMe
            // description:
            //         无
            return config.session.userId;
        },
        getRegisterBChangeMethod: function (widget, field, value) {
            if (field == "userName") {
                if (value.length == 11) {
                    this.checkUser(value).then(lang.hitch(this, function (userData) {
                        if (userData.data.ok === 1) {
                            localStorage.setItem('userName',userData.data.item.userName);
                            alert("账号已经存在,请登录");
                            window.moveToView("login");
                        }
                    }));
                }
            }
        },
        // 检查账号唯一性
        checkUser: function (userName) {
            return this.exec("checkUser",{
                userName:userName
            });
        },
        _getCurrentUserDef:function(){
            if(!this._currentUserDef){
                this._currentUserDef = this.exec("getCurrentUser", {}).then(lang.hitch(this,function(data){
                    this._currentUserDef = null;
                    return data;
                }));
            }
            return this._currentUserDef;
        },
        /*
        hasLogin: function () {
            // summary:
            //        检查当前用户的登录状态
            // view:
            //         无
            // description:
            //         返回值:true/false
            if (!config.session.userId) {
                return this._getCurrentUserDef().then(lang.hitch(this, function (data) {
                    if (data && data.data && data.data.item &&
                        data.data.item._id) {
                        this._onLoginSuccess(data.data.item);
                    }
                    return !!config.session.userId;
                }));
            } else {
                var def = new Deferred();
                var info = config.session.shopUserInfo&&config.session.shopUserInfo[this.getShopId()];
                this._onLoginSuccess(info,false);
                def.resolve(!!config.session.userId);
                return def;
            }
        },
        */
        hasLogin: function () {
            // summary:
            //        检查当前用户的登录状态
            // view:
            //         无
            // description:
            //         返回值:true/false
            return this._getCurrentUserDef().then(lang.hitch(this, function (data) {
                if (data && data.data && data.data.item && data.data.item._id) {
                    if(!config.session.userId || (config.session.userId!==data.data.item._id)){
                        this._onLoginSuccess(data.data.item);    
                    }else{
                        var info = config.session.shopUserInfo&&config.session.shopUserInfo[this.getShopId()];
                        this._onLoginSuccess(info,false);
                    }
                }else if(config.session.userId){
                    config.session.userId = null;
                    window.moveToView("login");
                }
                return !!config.session.userId;
            }));
        },
        logout: function () {
            // summary:
            //        注销当前用户的登录状态
            // view:
            //         无
            // description:
            //         无
            //return 
            this.exec("logout", {
                shopId: this.getShopId()
            }).then(function(result){
                if(result&&result.data&&result.data.ok==1){
                    localStorage.removeItem(this.loginShopId + "password");
                    localStorage.removeItem(this.loginShopId + "rememberPassword");
                    topic.publish("whz/shop/changed", {
                        _id: this.loginShopId
                    });
                    delete config.session.userId;
                    delete config.session.userInfo;
                    setTimeout(function(){
                        topic.publish("/cq/biz/user/user/hasLogin", false);
                    },100);
                    topic.publish("/cq/biz/user/user/hasLogin", false);
                    window.moveToView("main");
                }else{
                    alert(result&&result.data&&result.data.message||"注销失败");
                }
            });
        },
        getDefaultAddr:function(){
            // summary:
            //        加载默认收货地址
            // view:
            //         无
            // description:
            //         无
            return this.exec("loadDefaultAddress",{
                userId:this.getCurrentUserId()
            });
        },
        getAllAddr:function(){
            // summary:
            //        加载所有的地址
            // view:
            //         无
            // description:
            //         无
            return this.exec("loadAddrList",{
                userId:this.getCurrentUserId()
            });
        },
        getAddrById:function(id){
            // summary:
            //        根据id获取收获地址
            // view:
            //         无
            // description:
            //         无
            return this.exec("loadAddr",{
                _id:id,
                shopId:this.getShopId(),
            });
        },
        getLoginData: function () {
            // summary:
            //        获取用户上次登录信息
            // view:
            //         无
            // description:
            //         无
            var obj = {};
            var shopId = this.getShopId();
            if (localStorage.getItem(shopId + "userName")) {
                obj.userName = localStorage.getItem(shopId + "userName");
            }
            if (localStorage.getItem(shopId + "password")) {
                obj.password = localStorage.getItem(shopId + "password");
                obj.rememberPassword = true;
            }
            if (localStorage.getItem(shopId + "rememberPassword")) {
                this.onLogin(obj);
            }
            return obj;
        },

        // 需要拆分到其他对象中
        // 可能客户管理才需要
        // 没有地方用到 暂时先注释掉
        //loadUser:function(params){
        //    var _id = params && params.cqViewParam && params.cqViewParam.params;
        //    if(_id) return this.loadById(_id);
        //    else return {};
        //},
        loadById: function (id) {
            // summary:
            //        根据id获取用户数据
            // view:
            //         无
            // description:
            //         无
            window.busy();
            return this.exec("loadUserDetail", {
                _id:id
            }).then(lang.hitch(this, function (userData) {
                window.free();
                var item = userData.data.item;
                item.loginName = item.userName;
                item.nickName = item.nickName||item.userName;
                item.logo = item.logo||config.defultUserLogo;
                return item;
            }));
        },
        onDataReadyForVillager: function(widget){
            widget.hideByFields(["toAddFollow", "toCancelFollow", "getAutState","isBindPhone"]);
            var data = widget.getData();
            //if(!data._id){
            //    return;
            //}
            if(data.followed){
                widget.showByFields(["toCancelFollow"]);
            }else{
                widget.showByFields(["toAddFollow"]);
            }
            if(data.isAut){
                widget.showByFields(["getAutState"]);
            }
            // 如果没有userName 或者userName不是手机号码
            var isPhone = this.isTel(data.userName)||this.isCellPhone(data.userName);
            if(!isPhone){
                widget.showByFields(["isBindPhone"]);
            }
            if(data.per){
                var perNode = widget.getElementByField("currentGrowthRate");
                require(["dojo/dom-style"], function(domStyle){
                    domStyle.set(perNode, "width", data.per+"%");
                });
            }
        },
        getMdfUserInfoLayout: function () {
            // summary:
            //        web、app端修改个人信息Layout
            // view:
            //         mdfUserInfo
            // description:
            //         无
            return [{
                type: "form",
                fields: this.getFormItems([
                    "logo",
                    "loginName",
                    "nickName",
                    "pName",
                    "birthday",
                    "sex",
                    "onSubmitMdfUserInfoButton",
                    "toUserAut"
                ], true)
            }];
        },
        registerReload : function (widget) {
            // 判断config中是否配置了用户注册协议和用户隐私协议，配置了则显示，没有则隐藏
            var registerProtocolUrl = config.registerProtocol;
            var privacyProtocolUrl = config.prvacyProtocol;
            widget.hideByFields(["registerProtocol", "privacyProtocol"]);
            // 如果有一个没有配置则隐藏掉对应的按钮
            if(registerProtocolUrl){
                widget.showByFields(["registerProtocol"]);
            }
            if(privacyProtocolUrl){
                widget.showByFields(["privacyProtocol"]);
            }
        },
        privacyProtocol: function(){
            window.open(config.prvacyProtocol);
        },
        registerProtocol: function(){
            window.open(config.registerProtocol);
        },
        disabelField:function(widget){
            widget.disableByFields(["loginName"]);
        },
        getAppUserTitle: function (cqRefInfo, options) {
            // summary:
            //        依据模版字符串获取用户登录提示信息
            // view:
            //         无
            // description:
            //         无
            var format = options && options.format || "[客户名称]您好";
            return this.deferred(format.replace("[客户名称]", config.session.userInfo.pName || ""));
        },
        saveUserDetail:function(params){
            return this.exec("saveUserDetail",params);
        },
        onMdfUserInfo: function (data) {
            // summary:
            //        web、app端修改个人信息的操作
            // view:
            //         mdfUserInfo
            // description:
            //         无
            if (data._id){
                window.busy();
                delete data.password;
                this.saveUserDetail(data).then(function (result) {
                    window.free();
                    if (result&&result.data&&result.data.ok === 1) {
                        alert("保存成功");
                        history.back();
                    } else {
                        alert(result&&result.data&&result.data.message||"保存失败");
                    }
                });
            }
        },
        getCurrentUser: function(){
            // summary:
            //        获取当前登录用户信息
            // view:
            //         无
            // description:
            //         无
            return this._getCurrentUserDef().then(lang.hitch(this, function(result){
                var item = result&&result.data&&result.data.item||{};
                //如果没有设置头像或者没有设置昵称,设置标志供后面完善资料送积分使用
                if(!item.logo||!item.nickName){
                    item.unPerfectInformation = true;
                }
                //把LOGO宽度设置为80
                item.logo = blob.getImageUrl(item.logo||config.defultUserLogo||"", "80");
                item.loginName = item.userName;
                // 如果没有昵称 显示登陆名
                item.nickName = item.nickName||item.userName;
                item.myFans = (item.fansNum1||0) + (item.fansNum2||0) + (item.fansNum3||0);
                item.myIncome = item.disPenddingAmt || "0.00";
                item.growth = parseFloat(item.growth||0,10)||0;
                /*if(item.growth>=10000){
                    item.growth = parseInt(item.growth/10000,10)+"万";
                }*/
                return item||{};
            }));
        },
        getListUrlForFollow: function(){
            return follow.getListUrl();
        },
        getListParamForFollow: function(cqInfo){
            var params = {
                shopId: this.getShopId(),
                userId: this.getCurrentUserId()
            };
            if(cqInfo&&cqInfo.state){
                params.tp = cqInfo.state._id;
            }else{
                params.tp = 1;
            }
            return params;
        },
        onListClickForFollow: function(data, widget){
            window.moveToView("villager", data.userId2._id||data.userId1._id);
        },
        getListPropForFollow: function(item){
            item.nickName = item.nickName||"无名氏";//item.userName
            item.logo = blob.getImageUrl(item.logo||config.defultUserLogo||"", "80");//item.logo||config.defultUserLogo;
            item.attentionNum = item.attentionNum||0;
            item.fansNum = item.fansNum||0;
            item.userAut = item.isAut?"<img style='width: 15px;margin-right: 0;margin-top: 0;bottom: 0;left:30px;' src='./images/temp/tool/aut-tag.png' class='user-aut-tag'/>":"";
            return item;
        },
        loadVillagerDetail: function(params){
            var _id = params && params.cqViewParam && params.cqViewParam.params;
            if(_id) {
                return this.exec("loadUserDetail", {
                    _id: _id
                }).then(lang.hitch(this, function (userData) {
                    window.free();
                    var item = userData.data.item;
                    item.loginName = item.userName;
                    item.nickName = item.nickName||"无名氏";
                    item.logo = item.logo||config.defultUserLogo;
                    return follow.hasFollowed(item._id).then(lang.hitch(this, function(followed){
                        item.followed = followed;
                        return item;
                    }));
                }));
            }else {
                return {};
            }
        },
        toAddFollow: function(data,widget){
            window.busy();
            follow.addFollow(data._id).then(lang.hitch(this, function(result){
                window.free();
                if(result&&result.data&&result.data.ok==1){
                    widget.cqRefresh();
                }else{
                    alert(result&&result.data&&result.data.message||"关注失败");
                }
            }));
        },
        toCancelFollow: function(data, widget){
            window.busy();
            follow.cancelFollow(data._id).then(lang.hitch(this, function(result){
                window.free();
                if(result&&result.data&&result.data.ok==1){
                    widget.cqRefresh();
                }else{
                    alert(result&&result.data&&result.data.message||"取消关注失败");
                }
            }));
        },
        toTalk: function(data, widget){
            if(data._id==this.getCurrentUserId()){
                alert("不能和自己聊天");
                return false;
            }
            require(["bob/im/msgP/c"],lang.hitch(this, function(msgP){
                msgP.msgTo(data._id, this.getShopId());
            }));
        },
        //生成客户分销二维码
        getUserDiscard : function () {
            return this.exec("getUserDiscard", {
                userId : this.getCurrentUserId()
            });
        },
        // 提现
        exchangeDisAmount : function (params) {
            params.userId = this.getCurrentUserId();
            return this.exec("exchangeDisAmount", params);
        },
        //获取当前会员分商家的余额
        //一个商家的余额的数据结构{userId:用户ID,amount:余额,fromShopId:{_id:商家id,shopName:商家名称,logo:商家logo}}
        getMyShopedBalanceUrl:function(){
            return this.getBaseUrl() + '/loadMyShopedBalance';
        },
        //获取shopId
        getBalanceShopID : function(){
            var params={
                shopId:this.getShopId()
            };
            return params;
        },
        onLoginEnter:function(widget,field,value){
            if(field === "password"&&value){
                this.onLogin(widget.getData(),widget);
            }
        },
        //跳转到认证页面
        moveToUserAut:function(){
            window.moveToView('userAut');
        },
        reloadloginMethod:function(widget){
            //微信登录按钮的显示隐藏
            widget.hideByFields(['wxLoginButton']);
            share.isWechatEnable().then(function(data){
                if(data){
                    //如果是ios系统，但是用户没有安装微信,隐藏按钮
                    widget.showByFields(['wxLoginButton']);
                }
            });
        },
        onWxLogin:function(){
            window.busy();
            //如果用户没有安装微信,提示其安装微信
            share.isWechatEnable().then(lang.hitch(this,function(data){
                if(!data){
                    window.free();
                    alert('请安装微信');
                    return ;
                }
                var scope = 'snsapi_userinfo',state = '_'+(new Date());
                //调用插件的方法。获取code
                window.Wechat.auth(scope,state,lang.hitch(this,function(res){
                    if(res&&res.code){
                        window.busy();
                        //获取到了code，将code传入服务器用以用户登录
                        lastLoginTime = null;
                        this.wechatLogin(res.code).then(lang.hitch(this,function(data){
                            window.free();
                            if(data&&data.data&&data.data.ok == 1){
                                this._onLoginSuccess(data&&data.data&&data.data.item);
                                config.session.loginBackLevel = 1;
                                this.loginBack();
                            }else{
                                delete config.session.userId;
                                alert(data.data.msg);
                            }
                        }));
                    }else{
                        window.free();
                    }
                }),function(reason){
                    //获取code失败
                    alert(reason);
                });
            }));
        },
        wechatLogin:function(param){
            lastLoginTime = null;
            return this.exec('loginByWxCode',{'code':param});
        },
        getCurrentUserLevel: function(){
            return this.exec("currentUserLevel",{}).then(lang.hitch(this, function(result){
                var item = result&&result.data&&result.data.item||{};
                //把LOGO宽度设置为80
                item.logo = blob.getImageUrl(item.logo||config.defultUserLogo||"", "80");
                // 如果没有昵称 显示登陆名
                item.nickName = item.nickName||item.userName;
                item.currentGrowth = item.currentGrowth>10000?(parseInt(item.currentGrowth/10000)+"万"):item.currentGrowth.toFixed(0);
                item.per = parseFloat(item.currentGrowth)/parseFloat(item.nextLevelGrowth)*100;
                return item||{};
            }));
		},
        
        //在村头行政相关接口
        getCUserUrl:function(){
            return this.getBaseUrl()+"/loadCUser?shopId="+this.getShopId();
        },
        getGovUserListParam:function(){
            return {
                position:4,
                orderBy:"code"
            };
        },
        onGovUserClick:function(data){
            window.moveToView("villager2",data._id);
        }
    });
    var consumerBo = new ConsumerBo();
    consumerBo.Bo = ConsumerBo;
    consumerBo.hasLogin();
    return consumerBo;
});
