﻿define([
    "dojo/_base/declare",
    "dojo/Deferred",
    "cq/util/sys/query",
    "dojo/_base/lang",
    "./_UserMixin",
    "../BoBase",
    "cq/util/config/config",
    "bob/shop/shop"
], function (declare, Deferred, query, lang, _UserMixin, BoBase, config, shop) {
    //本对象功能：
    //      客户列表
    //      客户编辑
    //      客户充值
    var CustomerBo = declare("", [BoBase.B,_UserMixin], {
        //字段写在userBase里面
        fields: {
            // 客户列表相关属性
            // web端，客户列表操作按钮
            //原来userlistAction
            onUserListClick: {
                type: "text",
                label: "操作",
                formatter: function (action, data) {
                    var v = "<div class='button' cq-action='userlist'>编辑</div>";
                    return v;
                }
            },
            userDeliveryCardB:{
                type:"button",
                action:"userDeliveryCardB"
            },
            
            // 客户充值页面相关属性
            // 客户充值按钮界面的充值按钮
            userCreditButton:{
                className : "large-width",
                type: "button",
                label: "充值",
                action: "saveUserCredit"
            },
            // 给单位客户充值页面
            officeUserCreditButton:{
                className : "large-width",
                type: "button",
                label: "充值",
                action: "onOfficeUserCredit"
            },
            // 客户详情相关属性
            // 保存客户信息
            onSubmitUserDetailButton: {
                type: "button",
                label: "保存",
                className: "large-width",
                action: "onUserdetail"
            },
            onAddAccountButton: {
                type: "button",
                label: "添加",
                className: "large-width",
                action: "addAccount"
            },
            loginName: {
                type:"text",
                label:"登录名"
            },
            toEdit: {
                type: "button",
                action: "toEdit"
            },
            toRecharge: {
                type: "button",
                action: "toRecharge"
            },
            sexTxt: {
                type: "text"
            },
            isAut: {
                type: "checkbox"
            },
            getAutState: {
                type: "button",
                action: "getAutState"
            },
            srcUserName: {
                type: "text"
            },
            fansNum: {
                type: "text",
                fixedTo:0
            },
            attentionNum: {
                type: "text",
                fixedTo:0
            },
            getLogo: {
                type: "button"
            },
            remarkName: {
                type: "text"
            },
			remainAmount: {
				type: "number",
				label: "村币",
				fixedTo:2
			},
            clientLevel:{
                type : "ref",
                label : "等级",
                dataProvider : "bob/user/clientLevel",
                targetMethod : "getListUrl",
                labelFields : "levelName",
                searchField : "levelName",
                canEdit : true
            },
            subscribedTxt: {
                type: "text"
            },
            createAt: {
                type: "date",
                label: "创建日期"
            },
            subscribeDate: {
                type: "dateTime",
                label: "关注日期"
            },
            subscribed: {
                type: "checkbox",
                label: "关注状态"
            },
            search: {
                type: "text",
                label: "关键词",
                placeHolder: "昵称、姓名、电话"
            },
            customerPhone:{
                type:'text',
                label:'电话',
                placeHolder:'请输入客户电话'
            },
            customerName:{
                type:'text',
                label:'客户',
                placeHolder:'请输入客户姓名'
            },
            addressB:{
                type:'text',
                label:"地址",
                placeHolder:'请输入收货地址'
            },
            id:{
                type:'text',
                label:'客户Id'
            },
            // 确认密码
            confirmPassword: {
                type: "password",
                placeHolder: "请再次输入密码",
                label: "确认密码",
                className: "cq-item-password",
                notNull: true
            },
            userName : {
                type:'text',
                label:"账户名",
                notNull: true,
                placeHolder:'英文加数字的组合'
            },
            pName : {
                type:'text',
                label:"姓名",
                notNull: true,
                placeHolder:'请输入姓名'
            }
        },
        getaddrLayout:function(){
            return [{
                type:"form",
                fields:this.getFormItems([
                    'customerPhone','customerName','addressB','id'
                ])
            }];  
        },
        customerTob2cOrder:function(){
            return {
                customerPhone:'',
                customerName:'',
                addressB:'',
                id:''
            };    
        },
        reloadTob2cOrder:function(widget){
            widget.hideByFields(['id']);
            if(!widget.cushandle){
                var cusNode = widget.getEditorByField('customerPhone');
                var addrNode = widget.getEditorByField('addressB');
                var nameNode = widget.getEditorByField('customerName');
                var idNode = widget.getEditorByField('id');
                nameNode.setCanEdit(true);
                widget.cushandle = widget.connect(cusNode,'oninput',lang.hitch(this,function(){
                    var tel = cusNode.getValue();
                    if(widget.addrTimer){
                        clearTimeout(widget.addrTimer);
                        widget.addrTimer= null;
                    }
                    widget.addrTimer = setTimeout(lang.hitch(this,function(){
                        this.exec('loadAddrByPhone',{phone:cusNode.getValue()})
                        .then(function(data){
                            window.busy();
                            if(data.data){
                                data = data.data;
                            }
                            if(data.item){
                                widget.setData({
                                    addressB:((data.item.distAddr||"")+(data.item.detailAddress||""))||'',
                                    customerName:data.item.contactName||"",
                                    id:data.item.userId||'',
                                    customerPhone:data.item.tel||tel
                                });
                            }else{
                                widget.setData({
                                    addressB:'',
                                    customerName:"",
                                    id:'',
                                    customerPhone:tel
                                });
                            }
                            window.free();
                        });
                    }),500);
                }));
            }
            //console.log("aaa");
        },
        userSummaryBySubscribed: function(){
            return this.getBaseUrl()+"/userSummaryBySubscribed?shopId="+this.getShopId()
        },
        getItemPropBySummary: function(item){
            if(item._id=="9999"){
                return item;
            }
            item.subscribedTxt = item.subscribed==true?"已关注 "+item.count:item.subscribed==false?"未关注 "+item.count:"未知 "+item.count;
            return item;
        },
        getLogo: function(data){
            if(data._id){                
                require(["cq/widgets/bigImg"], function(bigImg){
                    bigImg.show(data.logo, 0);
                });
            }
        },
        getAutState: function(data, widget){
            
        },
        onDataReadyForDtl: function(widget){
            var data = widget.getData();
            widget.hideByFields(["getAutState","showUserShopListB"]);
            if(data._id&&data.isAut){
                widget.showByFields(["getAutState"]);
            }
            if(!data._id){
                return;
            }
            if(this.getShopId()==this.getPlatformShopId()){
                widget.showByFields(["showUserShopListB"]);
            }
        },
        // 客户编辑相关接口
        getUserDetailLayout: function () {
            // summary:
            //        web、app客户详情编辑的layout
            // view:
            //         userDetail
            // description:
            //         无
            return [{
                type: "form",
                fields: this.getFormItems([
                    "logo", "nickName", "loginName", "pName", "sex",// "score","isFarmer",
                    "phone","birthday", "address", "amount","clientLevel",
                    "userDesc", "onSubmitUserDetailButton"
                ], true)
            }];
        },
        getAddAccountLayout: function () {
            // summary:
            //        web、app客户详情编辑的layout
            // view:
            //         userDetail
            // description:
            //         无
            return [{
                type: "form",
                fields: this.getFormItems([
                    "userName", "pName", "password", "confirmPassword", "onAddAccountButton"
                ], true)
            }];
        },
        getAccountChangeMethod: function (widget, field, value) {
            if (field == "userName") {
                // 用户名只能输入数字 和 字母
                if (value.length > 1) {
                    var currentData = widget.getData();
                    if (/^[0-9a-zA-Z]+$/.test(value)) {
                        // 合法性通过
                        this.exec("checkUser",{
                            userName:value,
                            platformShopId: this.getShopId()
                        }).then(lang.hitch(this, function(userData){
                            if (userData && userData.data && userData.data.ok == 1) {
                                alert("该账户已存在");
                                delete currentData.userName;
                                widget.setData(currentData);
                            }
                        }));
                    } else {
                        alert("账户名只能是英文 和 数字");
                        // delete currentData.userName;
                        // widget.setData(currentData);
                    }
                }
            }
        },
        addAccount : function(data, widget) {
            var msg = this.getDataValidMsg(data, ["userName", "pName", "password", "confirmPassword"]);
            if (msg) {
                alert(msg);
                return;
            } else if (!(/^[0-9a-zA-Z]+$/.test(data.userName))) {
                alert("账户名只能是英文 和 数字");
                return;
            } else if (data.password != data.confirmPassword) {
                alert("两次密码不一致！");
                return;
            }
            window.busy();
            // data.toShopId = "5884622204337416e8a225e0"; // 在村头旗舰店
            // data.toShopId = "58845f8807430d1efef95896";
            data.toShopId = config.brandStoreId;
            return this.exec("addAccount", data).then(lang.hitch(this, function (result) {
                window.free();
                if (result && result.data && result.data.ok == 1) {
                    alert("添加成功");
                    widget.setData({});
                    widget.cqRefresh();
                } else {
                    alert(result.data.msg || "添加失败");
                }
            }));
        },
        getSexTxt: function(sex){
            sex = sex||"";
            var opt = {
                "1": "女",
                "2": "保密",
                "0": "男",
                "": "未知"
            }
            return opt[sex];
        },
		loadById: function(userId){
			return this.exec("loadUserDetail", {
				_id: userId
			});
		},
        getUserDetailData: function (e) {
            // summary:
            //        web、app客户详情的数据获取
            // view:
            //         userDetail
            // description:
            //         无
            if(!e.cqViewParam.params){
                return {};
            }
            window.busy();
            return this.exec("loadUserDetail", {
                _id: e.cqViewParam.params
            }).then(lang.hitch(this, function (result) {
                window.free();
                var item = result&&result.data&&result.data.item||{};
                item.loginName = item.userName;
                item.sexTxt = this.getSexTxt(item.sex);
                item.remarkName = item.pName || "无";
                item.srcUserName = item.srcUid&&(item.srcUid.nickName||item.srcUid.pName||"佚名")||"";
                item.subscribedDetil = item.subscribed?"是":"否";
                if(item.subscribeDate){
                    item.subscribeDateDetil = ""
                    var dateObj = new Date(item.subscribeDate);
                    item.subscribeDateDetil =dateObj.getFullYear()+"-"+(dateObj.getMonth()+1)+"-"+dateObj.getDate();
                }else{
                    item.subscribeDateDetil = "";
                }
                if(item.cancelDate){
                    item.cancelDateDetil = ""
                    var dateObj = new Date(item.cancelDate);
                    item.cancelDateDetil =dateObj.getFullYear()+"-"+(dateObj.getMonth()+1)+"-"+dateObj.getDate();
                }else{
                    item.cancelDateDetil = "";
                }
                if(item.fromShopId){
                    return shop.loadByIdFromPlt(item.fromShopId).then(function(shopData){
                        item.fromShopName = shopData.shopName;
                        return item;
                    });
                }else{
                    return item;
                }
            }));
        },
        getDisUserById: function(e){
            var userId = e&&e.cqViewParam&&e.cqViewParam.params||"";
            if(!userId){
                alert("no userId");
                return;
            }
            return this.exec("loadUserDetail", {
                _id: userId
            }).then(lang.hitch(this, function(result){
                var item = result&&result.data&&result.data.item||{};
                if(!item._id){
                    alert("no user");
                    return;
                }
                if(item.disCard){                 
                    return this.exec("loadQrCodeById",{
                        userId: userId
                    }).then(function(qrCode){
                        var qrCode = qrCode&&qrCode.data&&qrCode.data.item||{};
                        qrCode = qrCode.imgUrl || "";
                        item.qrCode = qrCode;
                        return item;
                    });   
                }else{
                    return item;
                }
            }));
        },
        onUserdetail: function (data) {
            // summary:
            //        web、app客户详情编辑的保存按钮的响应函数
            // view:
            //         userDetail
            // description:
            //         无
            delete data.password;
            data.isFarmer = false;
            window.busy();
            this.save(data).then(lang.hitch(this, function(result){
                window.free();
                if (result.data && result.data.ok === 1) {
                    alert("保存成功");
                    history.back();
                } else {
                    alert(result&&result.data&&result.data.message||"保存失败");
                }
            }));
        },
        save: function(data){
            return this.exec("saveUserDetail", data).then(lang.hitch(this, function(result){
                return result;
            }));
        },
        // 客户列表相关接口
        getUserListUrl: function () {
            // summary:
            //        web、app客户列表的数据获取
            // view:
            //         userList
            // description:
            //         无
            return this.getBaseUrl() + "/loadUserList?shopId=" + this.getShopId();
        },
        // 加载分销客户url
        getDistributeUrl: function(){
            return this.getBaseUrl()+"/loadDistributeUsers";
        },
        getDistributeParam: function(e){
            var params = {
                shopId: this.getShopId(),
                fromShopId: this.getShopId()
            };
            if(e&&e.search){
                params.search = e.search;
            }
            if(e&&e.orderBy){
                params.orderBy = e.orderBy.orderBy;
            }
            return params;
        },
        getDistributeItem: function(item){
            item.totalFans = item.fansNum1+item.fansNum2+item.fansNum3;
            return item;
        },
        onDistributeClick: function(data){
            window.moveToView("distributeDetail",data._id);
        },
        getUserMsg:function(params){
            // summary:
            //        app商家端查看退款记录里面加载退款的客户信息
            // view:
            //         refundRequestListB
            // description:
            //         无
            return this.exec("/loadUserList",params);
        },
        getQRCode: function(data){
            if(data._id){                
                require(["cq/widgets/bigImg"], function(bigImg){
                    bigImg.show(data.qrCode, 0);
                });
            }
        },
        getDisCard: function(data){
            if(data._id){                
                require(["cq/widgets/bigImg"], function(bigImg){
                    bigImg.show(data.disCard, 0);
                });
            }
        },
        updateDisCard: function(data, widget){
            if(!data._id){
                alert("no userId");
                return;
            }
            window.busy();
            this.exec("refreshQrCodeById", {
                userId: data._id
            }).then(function(result){
                window.free();
                widget.cqRefresh();
            });
        },
        moveToSrcUid: function(data){
            if(data.srcUid){
                window.moveToView("distributeDetail", data.srcUid._id);
            }
        },
        // 导出分销客户
        exportDisClient: function(){
            var url = this.getDistributeUrl();
            var query = this.getDistributeParam();
            require([
				"cq/util/sys/xlsx"
			],lang.hitch(this,function(xlsx){
                xlsx.exportData(url, query, this.getFormItems(["nickName","pName","srcUid.nickName","srcUid.pName",
                "fansNum1","fansNum2","fansNum3","disTotalIncome","disPenddingAmt",
                "disRecieptAmt","disRaiseableAmt"
                ]),"分销客户"+Date.now().toString());
            }));
        },
        getUserListQuery: function (params) {
            // summary:
            //        web、 app端客户列表的数据查询参数
            // view:
            //         userList
            // description:
            //         无
            var query = params&&params.searchQuery||{};
            query.orderBy = "-createAt";
            query.isFarmer = false,
            query.fromShopId = this.getShopId();
            if (params.search) {
                query.search = params.search;
            }
            if(params.subscribed){
                query.subscribed = params.subscribed.subscribed;
            }
            for(var i in query){
                if(query[i]===null||query[i]===""||query[i]===undefined){
                    delete query[i];
                }
            }
            return query;
        },
        getOtherUserListQuery: function (params) {
            // summary:
            //        web、 app端客户列表的数据查询参数
            // view:
            //         userList
            // description:
            //         无
            var query = params&&params.searchQuery||{};
            query.orderBy = "-createAt";
            query.isFarmer = false,
            query.currentShopId = this.getShopId();
            query.preventSelf = true;
            if (params.search) {
                query.search = params.search;
            }
            return query;
        },
        getItemProp: function(data){
            data.nickName = data.nickName||data.pName;
            data.amount = data.amount||0;
            if(data.phone){
                data.phone = "("+data.phone+")";
            }
            return data;
        },
        userListAction: function (data, action, list) {
            // summary:
            //        web客户列表的点击事件的响应函数
            // view:
            //         userList
            // description:
            //         无
            if ("userlist" === action) {
                window.moveToView('userDetail', data._id);
            }
        },
        userlistAction2: function (data, action, list) {
            // summary:
            //        app客户列表的点击事件的响应函数
            // view:
            //         userList
            // description:
            //         无
            if("toUserCredit"===action){
                window.moveToView('userCredit', data._id);
            }else if("toUserDetail"===action){
                window.moveToView('userDetail', data._id);
            }else if("toLevelEdit" === action){
                window.moveToView('clientLevelEdit', data._id);
            }else if("toCustomerView" === action){
                window.moveToView("customerView", data._id);
            }else{
                window.moveToView("customer", data._id);
            }
		},
        getUserListLayout: function () {
            // summary:
            //        web客户列表的界面
            // view:
            //         userList
            // description:
            //         无
            return this.getFormItems(["pName", "nickName", "amount", "phone", /*"userlistAction"*/"onUserListClick"]);
        },
        
        // 公共接口
        addUser:function(){
            // summary:
            //        app上的客户列表的添加客户按钮的响应函数
            // view:
            //         userList
            // description:
            //         无
            window.moveToView("userDetail");
        },
        getUserCreditLayout:function(){
            // summary:
            //        app的充值界面的Layout
            // view:
            //         userCredit
            // description:
            //         无
            return [{
                type: "form",
                fields: this.getFormItems([
                    "pName", "phone","nickName","remainAmount","amont","remark","userCreditButton"
                ])
            }];
        },
        getOfficeUserCreditLayout: function(){
            return [{
                type: "form",
                fields: this.getFormItems([
                    "phone","amont","officeUserCreditButton"
                ])
            }];
        },
        getCreditData:function(e){
            // summary:
            //        app的充值界面的数据获取
            // view:
            //         userCredit
            // description:
            //         无

            //获取用户数据
            window.busy();
            return this.exec("loadUserDetail", {
                _id:e.cqViewParam.params
            }).then(lang.hitch(this, function (userData) {
                window.free();
				var item = userData&&userData.data&&userData.data.item||{};
				item.remainAmount = item.amount||0;
                return item;
            }));
        },
        getOfficeCreditData : function (e) {
            item = {};
            if (this.amount) {
                item.amont = this.amount;
            }
            return Promise.resolve(item);
        },
        initAccountData : function () {
            var item = {};
            return Promise.resolve(item);
        },
        saveUserCredit:function(data){
            // summary:
            //        app的充值按钮的事件处理
            // view:
            //         userCredit
            // description:
            //         无
            var item = {};
            item.pName = data.pName;
            item.phone = data.phone;
            item.amount = data.amont;
            item._id = data._id;
            //如果备注存在的话就保存，不必填
            if(data.remark){
                item.remark = data.remark; 
            }
            window.busy();
            return this.exec("addAmount", item).then(lang.hitch(this, function (result) {
                window.free();
                if (result.data && result.data.ok === 1) {
                    history.back();
                } else {
                    alert(result&&result.data&&result.data.message||"充值失败");
                }
            }));
        },
        onOfficeUserCredit : function (data, widget) {
            window.busy();
            var params = {};
            params.platformShopId = this.getPlatformShopId();
            params.phone = data.phone;
            params.amount = data.amont;
            return this.exec("officeUserAddAmount", params).then(lang.hitch(this, function(result){
                window.free();
                if (result.data && result.data.ok === 1) {
                    alert("充值成功");
                    this.amount = data.amont;
                    widget.cqRefresh();
                } else {
                    alert(result&&result.data&&result.data.message||"充值失败");
                }
            }));
        },
        onDataReadyForCredit: function(widget){
            // summary:
            //        app的充值界面元素的显示
            // view:
            //         userCredit
            // description:
            //         无
            var item = widget.getData();
            if(item){
                widget.disableByFields(["pName", "phone","nickName", "remainAmount"]);
            }
        },
        onDataReadyForUserEdit:function(widget){
            // summary:
            //        app的用户编辑元素的显示
            // view:
            //         userDetail
            // description:
            //         无
            var item = widget.getData();
            if(item){
                widget.disableByFields(["amount", "nickName", "loginName"]);
            }
        },
        toEdit: function(data, widget){
            window.moveToView("userDetail", data._id);
        },
        toRecharge: function(data, widget){
            window.moveToView("userCredit", data._id);
        },
        talkTo: function(data, widget){
            require(["bob/im/msgP/b"], lang.hitch(this, function(msg){
                // 问题：
                // 若是自己微信公众号的客户 是不是fromShopId应该是自己？
                msg.msgTo(data._id, data.fromShopId||this.getShopId());
            }));
        },
        // 历史订单
        lastOrderList: function(data, widget, data2){
            // 依据当前店铺是否平台确定要跳转的目标页面
            if(this.getShopId()==config.getPlatformShopId()){
                window.moveToView("orderListP", data&&data._id||data2.data._id);
            }else{
                window.moveToView("orderListB", data&&data._id||data2.data._id);
            }
        },
        amountlog:function(data, widget, data2){
            window.moveToView("userAmountDB", data&&data._id||data2.data._id);
        },
        loadMsgSender: function(e){
            if(e.cqViewParam&&e.cqViewParam.params){
                var userId = e.cqViewParam.params.split(",")[0];
                return this.exec("loadUserDetail", {_id: userId});
            }else{
                return {};
            }
        },
        showCustomer: function(a,b,widget){
            window.moveToView("customer", widget.data._id);
        },
        disIncome: function(data, widget){
            window.moveToView("disIncomeList", data._id);
        },
        getQueryLayout: function(){
            return [{
                type: "form",
                fields: this.getFormItems(["createAt","subscribeDate","subscribed","search"])
            }];
        },
        getShopedBalanceByUserUrl: function(){
            return this.getBaseUrl()+"/loadMyShopedBalance";
        },
        getShopedBalanceByUserParam: function(cqRefInfo){
            var params = {
                shopId: this.getShopId()
            };
            var userId = cqRefInfo&&cqRefInfo.cqViewParam&&cqRefInfo.cqViewParam.params||"";
            if(userId){
                params.userId = userId;
            }
            return params;
        },
        updateUserFromWx: function(data, widget){
            window.busy();
            this.exec("updateUserFromWx",{
                userId: data._id
            }).then(function(){
                window.free();
                widget.cqRefresh();
            });
        },
        userAmount: function(data){
            window.moveToView("shopedBalanceListB", data._id);
        },
        parsedLog: function(data){
            window.moveToView("parsedLogList", data._id);
        },
        evalList: function(data){
            window.moveToView("userEvalListB", data._id);
        },
        refundList: function(data){
            window.moveToView("refundRequestListB", data._id);
        },
        couponList: function(data){
            window.moveToView("couponListB", data._id);
        },
        chooseRecordList: function(data){
            window.moveToView("chooseRecordList", data._id);
        },
        shopList: function(data){
            window.moveToView("shopListB", data._id);
        },
        parsedLogByShare: function(data){
            window.moveToView("parsedLogByShareList", data._id);
        },
        relatedUser: function(data){
            window.moveToView("relatedUserList", data._id);
        },
        orderCarRecord: function(data){
            window.moveToView("orderCarRecord", data._id);
        },
        shareRecord: function(data){
            window.moveToView("shareRecord", data._id);
        },
        showUserShopListB:function(data,widget){
            window.moveToView("userShopListB", data._id);
        },
        userDeliveryCardB:function(data,widget){
            window.moveToView("userDeliveryCardB","u_"+data._id);
        }
    });
	var customerBo = new CustomerBo();
	customerBo.Bo = CustomerBo;
	return customerBo;
});