﻿define([
    "dojo/_base/declare"
],function(declare){
    return declare("",null,{
        modalName: "user/userFarmer",
        fields: {
            phone: {
                type: "tel",
                placeHolder: "",
                label: "手机号"
            },
            sex: {
                type: "options",
                label: "性别",
                options: {
                    0: "男",
                    1: "女",
                    2: "保密"
                },
                canEdit: true
            },
            address: {
                className: "large-width",
                type: "text",
                label: "地址"
            },
            logo: {
                type: "image",
                label: "头像",
                sizeType: "cut",
                size: {
                    width: 640,
                    height: 640
                }
            },
            pName: {
                type: "text",
                placeHolder: "请输入姓名",
                label: "姓名"
            },
            userDesc: {
                type: "richText",
                placeHolder: "",
                label: "农户介绍"
            },
            score: {
                type: "options",
                placeHolder: "",
                label: "星级",
                options: {
                    1: "1星",
                    2: "2星",
                    3: "3星",
                    4: "4星",
                    5: "5星"
                }
            },
            share: {
                type: 'button',
                label: '分享',
                action: 'share'
			}
        },
        share: function (data, widget) {
            //         点击后分享给其他人
            // view:
            var _this = this;
            require(["cq/util/share/share"], function(share){
                share.getShopLocation(_this.getShopId()).then(function(baseUrl){
                    var url = baseUrl+"#farmerMsg-" + data._id;
                    var options = [//{
                        //timeLine: {
                        //    title: data.pName, // 分享标题
                        //    thumb: data.logo || "", // logo,
                        //    url: "#farmerMsg-" + data._id, // url
                        //}
                    //}, 
                    {
                        "weixin": {
                            title: data.pName,
                            thumb: data.logo || "",
                            url:url
                        }
                    }, {
                        "friendCircle": {
                            title: data.pName,
                            thumb: data.logo || "",
                            url:url
                        }
                    }, {
                        "copy": {
                            url: url
                        }
                    }];
                    share.showShare(options);
                });
            });
        }
    });
});