define([
	'dojo/_base/declare',
	'dojo/_base/lang',
	'./_Mixin',
	'bob/BoBase',
    "bob/user/customer"
], function (declare, lang, _Mixin, BoBase, customer) {
	var O = declare("", [BoBase.B, _Mixin], {
		fields: {
            // 编辑
            edit: {
                type: "button",
                label: "编辑",
                action: "edit"
            },
            // 推荐
            recommend: {
                type: "button",
                action: "recommend"
            },
            // 取消推荐
            cancelRecommend: {
                type: "button",
                action: "cancelRecommend"
            },
            //删除
            deleteButton : {
                type: "button",
                action: "deleteFarmer"
            },
            // 保存
            save: {
                type: "button",
                label: "保存",
                action: "save"
            },
            logo: {
                type: "image",
                label: "头像",
                clickImg:true,
                sizeType: "cut",
                size: {
                    width: 640,
                    height: 640
                },
                noNull: true
            }
        },
        // 农户列表的数据获取
		getListUrl: function () {
			return this.getBaseUrl() + '/load';
		},
        // 商品选择农户
        getListUrlForFarmer: function(){
            return this.getBaseUrl() + '/load?shopId='+this.getShopId();
        },
        getListParam: function(params){
            var query = {
                shopId: this.getShopId()
                //fromShopId: this.getShopId()
            };
            if (params.search) {
                query.search = params.search;
            }
            if (params.state && params.state.isRecommend !== undefined) {
				query.isRecommend = params.state.isRecommend;
			}
            return query;
        },
        onListClick: function(data, action, widget){
            window.moveToView("farmer", data._id);
        },
        getEdtLayout: function(){
            return [{
                type: "form",
                fields: this.getFormItems([
                    "logo", "pName", "sex","phone", "address", "score",
                    "userDesc", "save"
                ], true)
            }];
        },
        getEdtLayoutForDtl: function(){
            return [{
                type: "form",
                fields: this.getFormItems([
                    "logo", "pName", "sex","phone", "address", "score",
                    "userDesc","deleteButton", "cancelRecommend", "recommend", "edit", "share"
                ], true)
            }];
        },
        onDataReady: function(widget){
            widget.disableByFields([
            "logo", "pName", "sex","phone", "address", "score",
            "userDesc"]);
            widget.hideByFields(["recommend", "cancelRecommend","edit", "share"]);
            var data = widget.getData();
            if(!data._id){
                return;
            }
            widget.showByFields(["share"]);
            if(data.isRecommend){
                widget.showByFields(["cancelRecommend"]);
            }else{
                widget.showByFields(["recommend"]);
            }
            if(data.fromShopId==this.getShopId()){
                widget.showByFields(["edit"]);
            }
        },
        loadById: function (e) {
            // summary:
            //        web、app客户详情的数据获取
            // view:
            //         userDetail
            // description:
            //         无
            return this.exec("loadById", {
                _id: e.cqViewParam.params
            }).then(function (result) {
                /*var shopId = this.getShopId();
                require([
                    "dojo/topic",
                    "cq/util/share/share"
                ],function(topic,share){
                    topic.publish("/cq/util/sys/share/infoChanged",{
                        title: item.pName||item.nickName||item.userName||"",
                        thumb: item.logo || "",
                        description: item.userDesc,
                        url:share.getPageLoc(shopId,"#farmerMsg-" + item._id)
                    });
                });*/
                return result.data.item||{};
            });
        },
        edit: function(data, widget){
            window.moveToView("farmerDtlB", data._id);
        },
        // 设置推荐
        recommend: function(data, widget){
            data.isRecommend = true;
            window.busy();
            return this.exec("recommend", data).then(lang.hitch(this, function(result){
                window.free();
                if (result.data && result.data.ok === 1) {
                    alert("推荐成功");
                    widget.cqRefresh();
                } else {
                    alert(result&&result.data&&result.data.message||"推荐失败");
                }
            }));
        },
        cancelRecommend: function(data, widget){
            data.isRecommend = false;
            window.busy();
            return this.exec("recommend", data).then(lang.hitch(this, function(result){
                window.free();
                if (result.data && result.data.ok === 1) {
                    alert("取消推荐成功");
                    widget.cqRefresh();
                } else {
                    alert(result&&result.data&&result.data.message||"取消推荐失败");
                }
            }));
        },
        deleteFarmer:function(data){
            this.exec("deleteById",{
                shopId:this.getShopId(),
                _id:data._id
            }).then(lang.hitch(this,function(result){
                if(result&&result.data&&1 == result.data.ok){
                    history.back();
                }else
                    alert(result&&result.data&&result.data.message||"删除失败");
            }));
        },
        // 保存农户信息
        save: function(data, widget){
            // summary:
            //        保存农户信息
            // view:
            //         farmerDtlB
            // description:
            //         无
            
            // 字段为空检查
            delete data.password;
            data.isFarmer = true;
            window.busy();
            customer.save(data).then(lang.hitch(this, function(result){
                window.free();
                if (result.data && result.data.ok === 1) {
                    alert("保存成功");
                    history.back();
                } else {
                    alert(result&&result.data&&result.data.message||"保存失败");
                }
            }));
        }
	});
	var o = new O();
	o.Bo = O;
	return o;
});