define([
	'dojo/_base/declare',
	'dojo/_base/lang',
	'./_Mixin',
	'bob/BoBase',
    "whz/util/config",
	'cq/util/sys/query'
], function (declare, lang, _Mixin, BoBase, config, query) {
	var O = declare("", [BoBase.C, _Mixin], {
        fields: {
            scoreLabel: {
                type: "text"
            },
            getBigImgUrl : {
                type : "button"
            }
        },
		// 农户列表的数据获取
		getListUrl: function () {
			return this.getBaseUrl() + '/load?shopId=' + this.getShopId();
		},
        getRecommendListUrl: function(){
            return this.getBaseUrl() + "/load?shopId=" + this.getShopId()+ "&isRecommend=true&pageSize=6&orderBy=-recommendTime";
        },
        //点击看大图
        getBigImgUrl : function(data){
            if(data._id){
                require(["cq/widgets/bigImg"],lang.hitch(this,function(bugImg){
                    bugImg.show(data.logo);
                }));
            }
        },
        //跳转到农户页面
        onListClick: function(data, action){
            window.moveToView("farmerMsg", data._id);
        },
        //星级设置
        _getScoreLabel: function(score){
            var opt = {
                1: "一星农户",
                2: "两星农户",
                3: "三星农户",
                4: "四星农户",
                5: "五星农户"
            };
            return opt[score]||"无星级";
        },
        //返回星级
        getItemProp: function(item){
            item.scoreLabel = this._getScoreLabel(item.score||"");
            return item;
        },
        loadById:function(params){
            // summary:
            //      app消费者端,通过id加载农户详情
            // view:
            //      farmerMsg
            // description:
            //      无
            var _id = params && params.cqViewParam && params.cqViewParam.params;
            if(_id){
                return this.exec("loadById", {
                    _id:_id
                }).then(lang.hitch(this, function (result) {
                    var item = result&&result.data&&result.data.item||{};
                    
                    item.logo = item.logo || config.defultFarmerLogo;
                    item.userDesc = item.userDesc || "该农户暂时没有添加简介哟";
                    var shopId = this.getShopId();
                    require([
                        "dojo/topic",
                        "cq/util/share/share"
                    ],function(topic,share){
                        topic.publish("/cq/util/sys/share/infoChanged",{
                            title: item.pName||item.nickName||item.userName||"",
                            thumb: item.logo || "",
                            description: item.userDesc,
                            url:share.getPageLoc(shopId,"#farmerMsg-" + item._id)
                        });
                    });
                    
                    return item;
                }));
            }else{
                return {};
            } 
        },
        //加载村里人列表
        geiListUrlForShop:function(){
            return this.getBaseUrl() + '/load';
        },
        //加载运营中心村里人列表
        getOpListUrlForShop:function(){
            return this.getBaseUrl()+"/loadOp";
        },
        //加载服务中心村里人
        getScListUrlForShop:function(){
            return this.getBaseUrl()+"/loadSc";
        },
        //加载村里人列表的参数
        getListParamForShop:function(params){
            var query = {};
            query.fromShopId =params.cqViewParam.params;
            return query;
        },
        getOpListParamForShop:function(params){
            var query = {};
            //当前商家的id
            query.fromShopId =params.cqViewParam.params;
            query.shopId = config.getPlatformShopId();
            return query;
        },
        ////村里人列表的点击事件
        onListClickForShop: function(data, widget, c){
            //window.moveToView("newDetail", data._id+"_"+c.cqRefInfo.cqViewParam.params);
        },
		// 按照农户搜索的url
		getListUrlWithMats: function(){
			return this.getBaseUrl()+"/loadFarmersWithMats?shopId="+this.getShopId()+"&pageSize=10";
		},
		getListParamWithMats: function(cqRefInfo){
			var params = {};
			var value = query.getQueryValue(cqRefInfo.search);
            if (value) {
                // 设置的查询编码转回
                params.search = window.decodeURIComponent(value);
            }
            params.orderBy = "-growth";
			return params;
		}
	});
	var o = new O();
	o.Bo = O;
	return o;
});