﻿define([
    "dojo/_base/declare",
	"dojo/_base/lang",
    "dojo/topic",
    "bob/BoBase",
    "dojo/Deferred",
    "cq/util/config/config"
], function (declare, lang, topic, BoBase, Deferred, config) {
	var FollowBo = declare("", [BoBase.C], {
        modalName: "user/follow",
        // 可处理字段
        fields: {
            nickName: {
                type: "text",
                label: "姓名"
            },
            logo:{
                type: "text",
                label: "logo"
            }
        },
        getItemProp: function(data){
            data.logo = data.logo||config.defultUserLogo;
            return data;
        },
        //我关注的村的列表接口
        getListUrl: function(){
            return this.getBaseUrl() + "/load";
        },
        //设置我的关注列表缓存默认值
        cachedAttention: {},
        _cacheMyAttention:function(userId){
            return this.exec("loadAttention", {
                shopId: this.getShopId(),
                userId: userId
            }).then(lang.hitch(this,function(data){
                var items = data&&data.data||data;
                items = data&&data.data&&data.data.items||[];
                this.cachedAttention = {};
                if(items&&items.length){
                    for(var i=0;i<items.length;i++){
                        this.cachedAttention[items[i].userId2._id] = 1;
                    }
                }
            }));
        },
        cacheMyAttention:function(){
            if(!this._cacheMyAttentionDef){
                var def = this._cacheMyAttentionDef = new Deferred();
                require(["bob/user/consumer"],lang.hitch(this,function(consumer){
                    this.consumer = consumer;
                    topic.subscribe("/cq/biz/user/user/hasLogin",lang.hitch(this,function(hasLogin){
                        //登录状态发生变化之后需要重置关注信息
                        if(hasLogin){
                            this._cacheMyAttention(this.consumer.getCurrentUserId());
                        }else{
                            this.cachedAttention = {};
                        }
                    }));
                    if(consumer.getCurrentUserId()){
                        //已经登录
                        this._cacheMyAttention(consumer.getCurrentUserId()).then(function(){
                            def.resolve();
                        });
                    }else{
                        //检查是否已登录
                        consumer.hasLogin().then(function(){
                            def.resolve();
                        });
                    }
                }));
            }
            return this._cacheMyAttentionDef;
        },
        //关注列表缓存中是否有userId对应的用户
        hasAttention:function(userId){
            return !!(this.cachedAttention&&this.cachedAttention[userId]);
        },
        //是否已经关注
        hasFollowed: function(targetUserId){
            return this.exec("hasFollowed", {
                targetUserId: targetUserId
            }).then(lang.hitch(this, function(result){
                return result&&result.data&&result.data.item&&result.data.item.followed||false;
            }));
        },
        // 加关注
        addFollow: function(targetUserId){
            return this.exec("addFollow" ,{
                targetUserId: targetUserId
            }).then(lang.hitch(this, function(result){
                //处理缓存的关注信息
                if(result&&result.data&&result.data.ok==1){
                    this.cachedAttention[targetUserId] = 1;
                }
                return result;
            }));
        },
        // 取消关注
        cancelFollow: function(targetUserId){
            return this.exec("cancelFollow", {
                targetUserId: targetUserId
            }).then(lang.hitch(this, function(result){
                //处理缓存的关注信息
                if(this.cachedAttention&&result&&result.data&&result.data.item){
                    this.cachedAttention[targetUserId]&&delete this.cachedAttention[targetUserId];
                }
                return result;
            }));
        }
    });
    var followBo = new FollowBo();
    followBo.Bo = FollowBo;
	return followBo;
});