define([
    "dojo/_base/declare",
	"dojo/_base/lang",
    "cq/util/sys/query",
    "./_UserMixin",
    "../BoBase"
], function (declare, lang, query, _UserMixin, BoBase) {
	var matBo = new BoBase.C({
        fields: {
            agreeBtn: {
                type: "button",
                label: "同意",
                action: "agree",
                className: "colorful-btn"
            },
            disagreeBtn: {
                type: "button",
                label: "拒绝",
                action: "disagree",
                className: "colorful-btn"
            },
            ignoreBtn: {
                type: "button",
                label: "忽略",
                action: "ignore",
                className: "colorful-btn"
            },
            userName: {
                type: "text",
                label: "请求人"
            },
            logo: {
                type: "text",
                label: "logo"
            }
            /*,
            requestUserId: {
                label: '请求人',
				type: 'ref',
				dataProvider: 'bob/user/user',
				targetMethod: 'getGroupUrl',
				className: 'middle-width',
				searchField: 'userName',
				labelFields: 'userName'
            }*/
        },
        modalName: "user/friendRequest",
        addFriend: function (userId) {
            // summary:
            //         app发送添加好友请求
            // view:
            //         timeLine
            // description:
            //         通过consumer对象间接调用
            return this.exec("sendRequest", {
                userId: userId
            }).then(lang.hitch(this, function (result) {
                return result;
            }));
        },
        friendRequestListUrl: function(){
            // summary:
            //        根据需求加载请求列表
            // view:
            //         friendRequestList
            // description:
            //         无
            //return this.getBaseUrl()+ "/friendRequestList?shopId="+ this.getShopId();
            return this.getBaseUrl()+"/friendRequestList";
        },
        getfriendRequestListQuery:function(){
            // summary:
            //        好友请求列表的查询参数
            // view:
            //         friendRequestList
            // description:
            //         无
            var query = {};
            query.shopId = this.getShopId();
            query.state = 1;
            return query;
        },
        getItemPropForfriendRequestList:function(item){
            // summary:
            //        好友请求列表的数据组装
            // view:
            //         friendRequestList
            // description:
            //         无
            var data = {};
            if(item.requestUserId.logo){
                data.logo = item.requestUserId.logo;
            }else{
                 data.logo = "./images/temp/i4.jpg";
            }
            if(item.requestUserId._id){
                data._id = item._id;
            }
            if(item.requestUserId.nickName){
                data.nickName = item.requestUserId.nickName;
            }
            if(item.requestUserId.userName){
                data.userName = item.requestUserId.userName;
            }
            return data;
        },
        friendRequestListAction:function(data,node){
            // summary:
            //        跳转到好友请求
            // view:
            //         friendRequestList
            // description:
            //         无
            
            window.moveToView("friendRequest",data._id);
        },
        loadById: function(params){
            // summary:
            //        根据ID加载请求
            // view:
            //         friendRequest
            // description:
            //         无
            return this.exec("loadById",{
                _id: params.cqViewParam.params
            }).then(lang.hitch(this, function(result){
                var item = result.data.item;
                if(item.requestUserId){
                    item.userName = item.requestUserId.nickName||item.requestUserId.userName||"";
                    if(item.requestUserId.logo){
                        item.logo = item.requestUserId.logo
                    }else{
                        item.logo = "./images/temp/i4.jpg";
                    }
                }
                return item||{};
            }));
        },
        getEdtLayout: function(){
            return [{
                type: "form",
                fields: this.getFormItems([
                    "agreeBtn", "disagreeBtn", "ignoreBtn"
                ], true)
            }];
        },
        onDataReadyForFriendRequest: function(widget){
            // summary:
            //        控制界面元素的显示
            // view:
            //         friendRequest
            // description:
            //         无
            var data = widget.getData();
            widget.hideByFields(["agreeBtn", "disagreeBtn", "ignoreBtn"]);
            if(data.state==1){//1未处理请求2同意3忽略-1拒绝
                widget.showByFields(["agreeBtn", "disagreeBtn", "ignoreBtn"]);
            } 
        },
        // 我的好友请求列表
        // 参数:
        //     params
        load: function () {},
        agree: function (item) {
            // summary:
            //        同意好友请求
            // view:
            //         friendRequest
            // description:
            //         参数:requestId

            // 确认同意后 往friend表中插入数据
            // 给发起好友请求的人发送消息
            this.exec("agree", {
                requestId: item._id
            }).then(lang.hitch(this, function(result){
                if(result&&result.data&&result.data.ok==1){
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"");
                }
            }));
        },
        disagree: function (item) {
            // summary:
            //        拒绝好友请求
            // view:
            //         friendRequest
            // description:
            //         参数:requestId

            // 拒绝后 修改请求状态
            // 给发起好友请求的人发送消息
            this.exec("disagree", {
                requestId: item._id
            }).then(lang.hitch(this, function(result){
                if(result&&result.data&&result.data.ok==1){
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"");
                }
            }));
        },
        ignore: function(item){
            // summary:
            //        忽略好友请求
            // view:
            //         friendRequest
            // description:
            //         参数:requestId

            this.exec("ignore", {
                requestId: item._id
            }).then(lang.hitch(this, function(result){
                if(result&&result.data&&result.data.ok==1){
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"");
                }
            }));
        },
    });
    return matBo;
});