/******************************************************
 *  创建人: 杜飞军
 *  创建时间: 2016/12/13
 *  创建内容
 *  		提供商品收藏功能 处理上架、下架和检查是否已经收藏
 ********************************************************/
define([
	"dojo/_base/declare",
	"dojo/_base/lang",
    'dojo/Deferred',
	"dojo/topic",
	"bob/BoBase",
	"bob/user/consumer",
    "cq/util/share/share",
], function (declare, lang, Deferred,topic, BoBase, consumer, share) {
	var MatStoreBo = declare("",BoBase.C,{
		modalName: 'user/mat_store',
		// 可处理的字段
		fields: {
			logo: {
				type: 'text',
				label: '图标'
			},
			mName: {
				type: 'text',
				label: '商品名称',
				placeHolder: '必填'
			},
			"mId.mName": {
				type: 'text',
				label: '商品名称'
			},
			"mId.logo": {
				type: 'text',
				label: '商品图标'
			},
			"mId.retailPrice": {
				type: 'text',
				label: '商品价格'
			},
			"mId.totalSale": {
				type: 'text',
				label: '商品销量'
			},
			"priceCompare":{
				type:"text",
				formatter:function(value,data){
					if(data.price && data.price>data.mId.retailPrice){
						return  "比关注时降价了"+(data.price-data.mId.retailPrice).toFixed(2)+"元";
					}
					else if(data.price && data.price<data.mId.retailPrice){
						return  "比关注时涨价了"+(data.mId.retailPrice-data.price).toFixed(2)+"元";
					}
					else return "价格没有变化";
				}
			}
		},
		load: function () {
            // summary:
            //		查询当前userId关注了哪些商品
            // view:
            //		collectList --收藏商品列表页面
            // description:
            //      提供内部使用的接口
			return this.exec("load", {
				userId: this.getShopId()
			});
		},
		matStore: function (params) {
            // summary:
            //		关注商品
            // view:
            //		collectList --收藏商品列表页面
            //      matDetail   --商品详情页面
            // description:
            //		也作为matDetail的接口使用
            // params
            // 		mId
            return this.exec("mat_store", {
				shopId: this.getShopId(),
				mId: params.mId,
                price: params.retailPrice,
				userId: consumer.getCurrentUserId()
			});
		},
		matStoreCancel: function (params) {
            // summary:
            //		取消关注
            // view:
            //		collectList --收藏商品列表页面
            //      matDetail   --商品详情页面
            // description:
            //		也作为matDetail的接口使用
            // params
            // 		mId
			return this.exec("mat_store_cancel", {
				mId: params.mId,
				userId: consumer.getCurrentUserId()
			});
		},
		checkMatStore: function (params) {
            // summary:
            //			检查商品是否已经被收藏
            // view:
            //		collectList --收藏商品列表页面
            //      matDetail   --商品详情页面
            // description:
            //
            // params
            // 		mId
			return this.exec("check_mat_store", {
				shopId: this.getShopId(),
				mId: params.mId,
				userId: consumer.getCurrentUserId()
			});
		},
		getListUrl: function () {
            // summary:
            //			获取当前用户关注的商家列表
            // view:
            //		collectList --收藏商品列表页面
            // description:
            //
			return this.getBaseUrl() + "/load";
		},
		getListParam: function () {
            // summary:
            //			获得查询条件
            // view:
            //		collectList --收藏商品列表页面
            // description:
            //
			var params = {
				shopId: this.getShopId(),
				userId: consumer.getCurrentUserId(),
				orderBy: 'createAt'
			};
			return params;
		},
		onListClick: function (data, action, widget) {
            // summary:
            //			列表点击事件处理
            // view:
            //		collectList --收藏商品列表页面
            // description:
            //
			if (action === 'collect_cancel') {
				this.matStoreCancel({
					mId: data.mId._id
				}).then(function (matStoreData) {
					if (matStoreData && matStoreData.data && matStoreData.data.ok === 1) {
						// 刷新当前数据
						widget.cqRefresh();
						alert('取消收藏成功');
					} else {
						alert(matStoreData && matStoreData.data && matStoreData.data.message || '取消收藏失败');
					}
				});
			} else if (action === 'to_shop') {
				window.moveToView('businessDetails', data.mId.fromShopId._id||data.mId.fromShopId);
			} else if (action === 'to_share') {
				var options = [{
						"weixin": {
							title: data.mId.mName,
							thumb: data.mId.logo || "",
							url:share.getPageLoc(this.getShopId(),"#matDetail-" + data.mId._id)
						}
					}, {
						"friendCircle": {
							title: data.mId.mName,
							thumb: data.mId.logo || "",
							url:share.getPageLoc(this.getShopId(),"#matDetail-" + data.mId._id)
						}
					}, {
						"copy": {
							url:share.getPageLoc(this.getShopId(),"#matDetail-" + data.mId._id)
						}
					}
				];
                share.showShare(options);
			} else {
				window.moveToView('matDetail', data.mId._id);
			}
		}
	});
	return new MatStoreBo();
});