﻿define([
    "dojo/_base/declare",
	"dojo/_base/lang",
    "dojo/topic",
    "bob/BoBase",
    "dojo/Deferred",
    "cq/util/config/config"
], function (declare, lang, topic, BoBase, Deferred, config) {
	var ShieldBo = declare("", [BoBase.C], {
        modalName: "user/shield",
        // 可处理字段
        fields: {
            nickName: {
                type: "text",
                label: "姓名"
            },
            logo:{
                type: "text",
                label: "logo"
            }
        },
        getItemProp: function(data){
            data.logo = data.logo||config.defultUserLogo;
            return data;
        },
        // 我已经屏蔽的用户列表
        getListUrl: function(){
            return this.getBaseUrl() + "/loadShield?shopId="+this.getShopId();
        },
        //设置我的屏蔽列表缓存默认值
        cachedAttention: {},
        _cacheMyAttention:function(userId){
            return this.exec("loadAttention", {
                shopId: this.getShopId(),
                userId: userId
            }).then(lang.hitch(this,function(data){
                var items = data&&data.data||data;
                items = data&&data.data&&data.data.items||[];
                this.cachedAttention = {};
                if(items&&items.length){
                    for(var i=0;i<items.length;i++){
                        this.cachedAttention[items[i].userId2._id] = 1;
                    }
                }
            }));
        },
        cacheMyAttention:function(){
            if(!this._cacheMyAttentionDef){
                var def = this._cacheMyAttentionDef = new Deferred();
                this.cachedAttention = {};
                def.resolve();
                return def;
                require(["bob/user/consumer"],lang.hitch(this,function(consumer){
                    this.consumer = consumer;
                    topic.subscribe("/cq/biz/user/user/hasLogin",lang.hitch(this,function(hasLogin){
                        //登录状态发生变化之后需要重置关注信息
                        if(hasLogin){
                            this._cacheMyAttention(this.consumer.getCurrentUserId());
                        }else{
                            this.cachedAttention = {};
                        }
                    }));
                    if(consumer.getCurrentUserId()){
                        //已经登录
                        this._cacheMyAttention(consumer.getCurrentUserId()).then(function(){
                            def.resolve();
                        });
                    }else{
                        //检查是否已登录
                        consumer.hasLogin().then(function(){
                            def.resolve();
                        });
                    }
                }));
            }
            return this._cacheMyAttentionDef;
        },
        //关注列表缓存中是否有userId对应的用户
        hasAttention:function(userId){
            return !!(this.cachedAttention&&this.cachedAttention[userId]);
        },
        //是否已经屏蔽
        hasShielded : function (targetUserId) {
            return this.exec("hasShielded", {
                targetUserId : targetUserId
            }).then(lang.hitch(this, function(result){
                return result&&result.data&&result.data.item&&result.data.item.shielded||false;
            }));
        },
        // 屏蔽
        addShielded: function(targetUserId){
            return this.exec("addShielded" ,{
                targetUserId: targetUserId
            }).then(lang.hitch(this, function(result){
                //处理缓存的关注信息
                if(result&&result.data&&result.data.ok==1){
                    this.cachedAttention[targetUserId] = 1;
                }
                return result;
            }));
        },
        // 取消屏蔽
        deleteShield: function(targetUserId){
            return this.exec("deleteShield", {
                targetUserId: targetUserId
            }).then(lang.hitch(this, function(result){
                //处理缓存的关注信息
                if(this.cachedAttention&&result&&result.data&&result.data.ok==1){
                    delete this.cachedAttention[targetUserId];
                }
                return result;
            }));
        },
        onListClick: function(data, action, widget){
            if(action=="cancelShield"){
                this.deleteShield(data._id).then(function(result){
                    if(result&&result.data&&result.data.ok==1){
                        alert("解除屏蔽成功");
                        widget.cqRefresh();
                    }else{
                        alert(result&&result.data&&result.data.message||"解除屏蔽失败");
                    }
                });
            }else if(action=="showTimeLine"){
                window.moveToView("villager", data._id);
            }
        }
    });
    var shieldBo = new ShieldBo();
    shieldBo.Bo = ShieldBo;
	return shieldBo;
});
