﻿// 店铺管理员公共基类
// 提供店铺管理员注册、切换店铺、商家管理店铺管理员的接口
//因为有BC端之分，故即将作废，2017/01/13

define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "../BoBase",
    "./_UserMixin",
    "cq/app/config",
    "cq/util/sys/common",
    "cq/util/config/config",
    "bob/shop/shop"
], function (declare, lang, topic, BoBase,_UserMixin, appConfig, common, config, shop) {
    var ShopAdminBo = declare("",[BoBase.B,_UserMixin],{
        modalName : "user/user",
        fields: {
            "role":{
                type:"options",
                label:"角色",
                options:{
                    '0': '普通管理员',
                    '1': '高级管理员'
                },
                canEdit:true
            },
            roleTxt: {
                type: "text",
                label: "角色"
            },
            pName: {
                type: "text",
                label: "姓名"
            },
            userName: {
                type: "text",
                label: "登陆名"
            },
            addAdminButton:{
                type:"button",
                label:"完成",
                action:"addAdminAction",
                className:"fullButton"
            },
            // 新增店铺
            shopName: {
                type:"text",
                label:"店铺名称",
                className:"middle-width",
                placeHolder:"取个好听的名字",
                notNull: true
            },
            // 添加店铺确认按钮
            addShopSave : {
                type:"button",
                label:"确认",
                action:"createShopByUser",
                className:"fullButton"                
            },
            shopType: {
                type: "options",
                label: "店铺类型",
                options: {
                    "1": "B2C商家",
                    "4": "服务商",
                    "3": "服务中心",
                    "2": "服务站",
                    "5": "运营商"
                },
                selected: "1",
                notNull: true
            }
        },
        // 获取当前用户信息 B端
        getCurrentUser: function () {
            return appConfig.session;
        },
        // 获取当前店铺 B端
        getCurrentShop: function(){
            return shop.loadMe();
        },
        getStaffUrl: function(){
            return this.getBaseUrl() + "/loadStaff?shopId="+this.getShopId();
        },
        // 用户新增店铺Layout
        getEdtLayoutForUser: function(){
            // 店铺名称
            // 确认按钮 
            return [{
                type : "form",
                fields : this.getFormItems([
                    "shopName",
                    // 第一版本发布时没有这么多商家类型 后面版本叠加时再开放出来
                    //"shopType",
                    "addShopSave"
                ],true)
            }];
        },
        // 用户创建新店铺
        createShopByUser : function(data){
            var msg = this.getDataValidMsg(data, ["shopName"/*, "shopType"*/]);
            if(msg){
                alert(msg);
                return ;
            }
            window.busy();
            // 添加店铺时 默认为一般商家 2017-2-7 刘轩
            data.shopType = 1;
            data.platformShopId = this.getPlatformShopId();
            this.exec("createShop",data).then(lang.hitch(this,function(result){
                if(result&&result.data&&result.data.ok==1){
                    shop.toSave({
                        _id: result.data.item.shop._id,
                        shopType: data.shopType,
                        platformShopId: this.getPlatformShopId()
                    }).then(lang.hitch(this, function(result2){
                        window.free();
                        if(result2&&result2.data&&result2.data.ok==1){
                            // 创建店铺成功
                            this.setCurrentShop(result.data.item.shop);
                            window.moveToView("mainB");
                        }else{
                            alert(result2&&result2.data&&result2.data.result.message||"创建店铺失败");
                        }
                    }));
                }else{
                    window.free();
                    alert(result&&result.data&&result.data.result.message||"创建店铺失败");
                }
            }));
        },
        addAdminAction: function(paramData,widget){
            //编辑、添加。编辑和添加时 数据不一样userId.userName;"userId.userName"
            var data = widget.getData();
            //添加的时候数据结构为paramData["userId.userName"]
            paramData.userId = {};
            if(paramData["userId.userName"]){
                paramData.userId.userName = paramData["userId.userName"];
            }
            paramData.pName = paramData.userId.pName;
            if (!common.isCellPhone(paramData.userId.userName)) {
                alert("请输入11位电话号码");
                return;
            }
            if(paramData.userId.userName){
                paramData.phone = paramData.userId.userName;
            }
            paramData.platformShopId = config.getPlatformShopId();
            paramData.shopId = this.getShopId();
            paramData.userName = paramData.userId.userName;
            paramData.userId = paramData.userId._id;
            delete paramData["userId.userName"];
			//店铺管理员应在平台上注册，所以在平台上执行用户名检查
            this.exec("checkUserOnPlatform", {userName: paramData.userName,platformShopId:this.getPlatformShopId()}).then(lang.hitch(this,function(backdata){
                if (data&&data.data&&data.data.ok == 1) {
					//设置用户ID
					paramData.userId = backdata.data.item._id;
                    window.busy();
                    this.exec("adminSave",paramData).then(lang.hitch(this, function (result) {
                        window.free();
                        if(1 === result.data.ok){
                            history.back();
                        }else{
                            alert("服务器繁忙，请稍后再试！")
                        }
                    }));
                }else{
                    if (!paramData.password || !paramData.repassword) {
                        alert("没有当前用户,请输入密码创建！");
                        widget.showByFields(["pName","password","repassword"]);
                    }else{
                        if (paramData.password !== paramData.repassword) {
                            alert("两次密码不一致");
                        } else {
                            this.exec("adminSave",paramData).then(lang.hitch(this, function (result) {
                                if(1 === result.data.ok){
                                    history.back();
                                }else{
                                    alert("服务器繁忙，请稍后再试！")
                                }
                            }));
                        }
                    }
                }
            }));
        },
        // 注册LayoutaddAdminButton
        getRegisterLayout: function(){
            // 手机号
            // 验证码
            // 密码
            // 确认密码
            if (!this.registerLayout) {
				this.registerLayout = [{
                    type: "form",
                    fields: this.getFormItems([
                        "userName,vcode", "shopName", "password", "confirmPassword", "registerButton"
                    ])
                }];
			}
			return this.registerLayout;
        },
        // 商家注册按钮响应函数
        register: function(data){
            window.busy();
            // 调用createShop方法 直接创建用户和店铺
            var msg = this.getDataValidMsg(data, ["userName", "vcode", "password", "shopName", "confirmPassword"]);
            if(msg){
                alert(msg);
                return;
            }else if (data.password != data.confirmPassword) {
				alert("两次密码不一致");
				return;
			}
			data.platformShopId = config.getPlatformShopId();
			data.vCode = data.vcode;
            window.busy();
            this.doRegister(data).then(lang.hitch(this, function (datas) {
                window.free();
                if (datas.data && datas.data.item && datas.data.item.shop) {
                    window.moveToView("login");
                } else {
                    alert("提交失败!");
                }
            }));
        },
        // 商家注册
        doRegister: function(data){
            return this.exec("registerAndCreateShop",data).then(lang.hitch(this, function (result) {
                return result;
            }));
        },
        onListDataReady:function(items){
			if(1===items.length){
				//若只有一个，自动登录
				this.setCurrentShopLists(items[0]);
                window.moveToView("home");
			}
		},
        // 加载用户已有店铺的条件
        shopListQuery : function(){
            var query = {};
            query.platformShopId = this.getPlatformShopId();
            query.userId = this.getCurrentUserId();
            return query;
        },
        getCurrentUserId: function(){
            return appConfig.session.userId;
        },
        // 用户已有店铺列表
        getShopListItemProp: function(data){
            data.logo = data.shopId.logo||"";
            data.shopName = data.shopId.shopName||"";
            return data;
        },
        // 点击切换到指定店铺
        shopListClick : function(data){
            this.setCurrentShopLists(data);
            window.moveToView("mainB");
        },
        //根据userId加载店铺
        shopListUrl : function(){
            return this.getBaseUrl()+"/loadShopsByUser";
        },
        // 设置当前店铺
        setCurrentShop: function (shop) {
            window.busy();
            this.exec("autoLoginTo", {
                platformShopId: config.getPlatformShopId(),
                targetShopId: shop._id
            }).then(lang.hitch(this,function(data){
                window.free();
                if(data&&data.data&&data.data.item){
                    window.__shop = shop;
                    topic.publish("whz/shop/changed", shop);
                    appConfig.session.shopUserInfo[this.getShopId()] = data.item;
                }
            }));
        },
		getRole:function(){
			return appConfig.session.userInfo.role;
		},
        // 设置当前店铺列表
        setCurrentShopLists:function(shopData){
            appConfig.session.userInfo = shopData.user || appConfig.session.userInfo;
            if (appConfig.session.userInfo) {
                appConfig.session.userInfo.role = shopData.role;
            }
            this.setCurrentShop(shopData.shopId);
        },
        moveToShopList: function(){
            window.moveToView("shopList");
        },
        // 加载当前用户已有店铺数据的url
        getShopListUrl: function(){
            return this.getBaseUrl() + 
                "/loadShopsByUser?"+
                "platformShopId=" + config.getPlatformShopId() + 
                "&userId=" + this.getCurrentUserId();
        },
        // 店铺管理员编辑
        getListLayoutForShopAdmin: function(){
            return [{
                type: "form",
                fields: this.getFormItems([
                    "userId.userName",
                    "pName",
                    "password",
                    "repassword",
                    "role",
                    "addAdminButton"
                ])
            }];
        },
        // 获取店铺管理员的url
        getListUrlForShopAdmin: function(){
            return this.getBaseUrl() + 
                "/shopAdmin?"+
                "platformShopId=" + this.getPlatformShopId() + 
                "&shopId=" + this.getShopId();
        },
        // 商家店铺管理员列表
        getItemPropForShopAdmin: function(data){
            data.pName = data.userId.pName||"";
            data.userName = data.userId.userName||"";
            data.roleTxt = this.setRolr(data.role);
            return data;
        },
        setRolr: function(val) {
            var admin = {
                '0': '普通管理员',
                '1': '高级管理员'//,
                //'2': '采购员',
                //'3': '销售员',
                //'4': '财务'
            };
            return admin[val];
        },
        getListParamForShopAdmin: function(){
            var query = {};
            return query;
        },
        onListClickForShopAdmin: function(data,node,list){
            if('editor' == node){
                window.moveToView("shopAdminDetail",data.userId._id);
            }
            if('delete' == node){
                var isDelete = confirm("确认删除管理员?");
                if(isDelete){
                    window.busy();
                    this.exec("deleteByShopAndUser", {userId:data.userId._id,shopId:this.getShopId(),platformShopId:this.getPlatformShopId()}).then(lang.hitch(this,function(result){
                        window.free();
                        if(1 == result.data.ok){
                            list.removeItemByData(result.data.ok);
                        }else
                            alert("服务器繁忙，请稍后再试")
                    }));
                }
            }
        },
        // 添加店铺管理员
        getEdtLayoutForShopAdmin: function(){
            return [{
                type : "form",
                fields : this.getFormItems([
                    "addShopName",
                    "addShopSave"
                ],true)
            }];
        },
        // 加载指定店铺管理员
        loadShopAdminById: function(param){
            window.busy();
            if(param&&param.cqViewParam&&param.cqViewParam.params){
                return this.exec("loadByShopAndUser", {
                    userId: param.cqViewParam.params,
                    platformShopId: this.getPlatformShopId()
                }).then(lang.hitch(this, function(data) {
                    window.free();
                    return data&&data.data&&data.data.item||data;
                }));
            }
        },
        // 删除店铺管理员
        deleteShopAdmin: function(){},
        // 编辑页面 隐藏userId\userName
        onDataReadyForShopAdmin: function(widget){
            widget.hideByFields(["pName","password","repassword"]);
            widget.disableByFields(["userId.userName"]);
        },
        // 之所以和上一个方法分开写是因为不知道如何区分是否编辑或新增页面
        // 这不同于loadbyId数据初始化的方法（通过参数来判定）
        onDataReadyForAddShopAdmin: function(widget){
            widget.hideByFields(["pName","password","repassword"]);
            widget.enableByFields(["userId.userName"]);
        }/*,
        findMoreShopAdmin: function(){
            window.moveToView("addShopAdmin");
        }*/
	});
    var shopAdminBo = new ShopAdminBo();
    shopAdminBo.Bo = ShopAdminBo;
	return shopAdminBo;
});