//  创建人：周超
//  创建时间2017-1-10
//  创建内容：shopAdmin店铺管理员，B端（不同shopId下数据发生变化）
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "bob/user/_UserMixin",
    "bob/user/shopAdmin/_ShopAdminMixin",
    "cq/app/config",
    "cq/util/sys/common",
    "cq/util/config/config",
    "bob/shop/shop",
    "bob/BoBase"
], function (declare, lang, topic, _UserMixin, _shopAdminMixin, appConfig, common, config, shop, BoBase) {
    var ShopAdminBo = declare("",[BoBase.B,_UserMixin,_shopAdminMixin],{
		fields:{
			"userId.userName":{
				type:"tel",
				label:"登录名",
                placeHolder: "请输入登录名",
                notNull: true
			},
            role: {
                type: "options",
                label: "角色",
                options: {
                    '0': '普通管理员',
                    '1': '高级管理员'//,
                    //'2': '采购员',
                    //'3': '销售员',
                    //'4': '财务'
                },
                notNull: true,
                selected: "0"
            },
            roleTxt: {
                type: "text",
                label: "角色",
                notNull: true
            },
            pName: {
                type: "text",
                label: "姓名",
                placeHolder: '必须输入姓名'
            },
            password: {
                type: "text",
                label: "密码",
                placeHolder: '必须输入密码',
                notNull: true
            },
            repassword: {
                type: "text",
                label: "确认密码",
                placeHolder: '必须输入密码',
                notNull: true
            },
            userName: {
                type: "text",
                label: "手机号",
                placeHolder: '请填写手机号',
            },
            saveAdminButton:{
                type:"button",
                label:"完成",
                action:"saveAdminAction",
                className:"fullButton"
            },
            addAdminButton:{
                type:"button",
                label:"完成",
                action:"addAdminAction",
                className:"fullButton"
            }
		},
        getListUrlForShopAdminP: function(){
            // summary:
            //      平台获取商家店铺管理员的url
            // view:
            //      shopAdminP
            // description:
            //      无
            return this.getBaseUrl() + "/shopAdmin"
        },
        getListParamForShopAdminP: function(params){
            // summary:
            //      平台获取商家店铺管理员列表传递的参数
            // view:
            //      shopAdmin
            // description:
            //      无
            var shopId = params.cqViewParam.params;
            
            var query = {
                shopId:shopId,
                platformShopId:this.getPlatformShopId()
            };
            return query;
        },
        userShopListBUrl:function(){
            // summary:
            //      获取客户管理的店铺url
            // view:
            //      userShopListB
            return this.getBaseUrl() + "/loadShopsByUser"
        },
        //加载客户管理的店铺列表的查询条件
        UserShopListBQuery:function(param){
            var query = {};
            var userId = param.cqViewParam.params;
            query.platformShopId = this.getPlatformShopId();
            query.userId = userId;
            return query;
        },
        getListUrlForShopAdmin: function(){
            // summary:
            //      获取店铺管理员的url
            // view:
            //      shopAdmin
            // description:
            //      无
            return this.getBaseUrl() + 
                "/shopAdmin?"+
                "platformShopId=" + this.getPlatformShopId() + 
                "&shopId=" + this.getShopId();
        },
        getItemPropForShopAdmin: function(data){
            // summary:
            //      商家店铺管理员列表的数据组装
            // view:
            //      shopAdmin
            // description:
            //      无
            data.pName = data.userId.pName||"";
            data.userName = data.userId.userName||"";
            data.roleTxt = this.setRole(data.role);
            return data;
        },
        getListUrlByUserId: function(){
            return this.getBaseUrl() + "/loadShopsByUser?platformShopId="+this.getPlatformShopId();
        },
        getListParamByUserId: function(cqRefInfo){
            var params = {};
            var userId = cqRefInfo&&cqRefInfo.cqViewParam&&cqRefInfo.cqViewParam.params||"";
            if(userId){
                params.userId = userId;
            }
            return params;
        },
        setRole: function(val) {
            // summary:
            //      商家店铺管理员列表的数据选项
            // view:
            //      shopAdmin
            // description:
            //      无
            var admin = {
                '0': '普通管理员',
                '1': '高级管理员'//,
                //'2': '采购员',
                //'3': '销售员',
                //'4': '财务'
            };
            return admin[val];
        },
        getListParamForShopAdmin: function(){
            // summary:
            //      商家店铺管理员列表传递的参数
            // view:
            //      shopAdmin
            // description:
            //      无
            var query = {};
            return query;
        },
        onListClickForShopAdmin: function(data,node,list){
            // summary:
            //      商家店铺管理员列表点击事件的处理
            // view:
            //      shopAdmin
            // description:
            //      无
            //if('editor' == node){
            //    window.moveToView("shopAdminDetail",data.userId._id);
            //}
            if('delete' == node){
                var isDelete = confirm("确认删除管理员?");
                if(isDelete){
                    //  判断当前用户与店铺管理员
                    if(data.userId._id==this.getCurrentUserId()){
                        alert("不能删除自己");
                        return;
                    }//else if(1 == data.role){
                    //    alert("高级管理员不能删除！");
                    //    return ;
                    //}
                    //  接口问题
                    this.exec("deleteByShopAndUser", {
                        userId:data.userId._id,
                        shopId:this.getShopId(),
                        platformShopId:this.getPlatformShopId()
                    }).then(lang.hitch(this,function(result){
                        if(result&&result.data&&1 == result.data.ok){
                            list.cqRefresh();
                        }else
                            alert(result&&result.data&&result.data.message||"删除失败");
                    }));
                }
            }else{
                window.moveToView("shopAdminDetail",data.userId._id);
            }
        },
        getListLayoutForShopAdmin: function(){
            // summary:
            //      店铺管理员详情的Layout
            // view:
            //      shopAdminDetail
            // description:
            //      无
            return [{
                type: "form",
                fields: this.getFormItems([
                    "userId.userName",
                    "role",
                    "saveAdminButton"
                ])
            }];
        },
        // summary:
        //      加载指定店铺管理员
        // view:
        //      shopAdminDetail
        saveAdminAction: function(data){
            data.userName = data.userId.userName;
            //delete data["userId.userName"];
            data.platformShopId = this.getPlatformShopId();
            this.exec("adminSave",data).then(lang.hitch(this, function (result) {
                if(1 === result.data.ok){
                    history.back();
                }else{
                    alert(result.data.msg || "服务器繁忙，请稍后再试！")
                }
            }));
        },
        loadShopAdminById: function(param){
            // summary:
            //      加载指定店铺管理员
            // view:
            //      addShopAdmin
            // description:
            //      无
            if(param&&param.cqViewParam&&param.cqViewParam.params){
                return this.exec("loadByShopAndUser", {
                    userId: param.cqViewParam.params,
                    platformShopId: this.getPlatformShopId()
                }).then(lang.hitch(this, function(data) {
                    return data&&data.data&&data.data.item||data;
                }));
            }
        },
        onDataReadyForAddShopAdmin: function(widget){
            //  summary：
            //      addShopAdmin界面元素的显示
            //  view:
            //      addShopAdmin
            //  description:
            //      之所以和上一个方法分开写是因为不知道如何区分是否编辑或新增页面
            //      这不同于loadbyId数据初始化的方法（通过参数来判定）
            widget.hideByFields(["pName","password","repassword"]);
            widget.enableByFields(["userId.userName"]);
        },
        getAddShopAdminLayout:function(){
            // summary:
            //      增加店铺管理员的Layout
            // view:
            //      addShopAdmin
            // description:
            //      无
            return [{
                type: "form",
                fields: this.getFormItems([
                    "userId.userName",
                    "pName",
                    "password",
                    "repassword",
                    "role",
                    "addAdminButton"
                ])
            }];
        },
        //  添加管理员reLoad
        onDataReadyShopAdminForAdd: function(widget){
            widget.hideByFields(["pName","password","repassword"]);
        },
        //未完善
        addAdminAction: function(data, widget){
            // summary:
            //      新增店铺管理员
            // view:
            //      addShopAdmin
            // description:
            //      无
            //var data = widget.getData();
            var msg = this.getDataValidMsg(data,["userId.userName","role"]);
            if(msg){
                alert(msg);
                return;
            }
            //if (!common.isCellPhone(data["userId.userName"])) {
            //    alert("请输入11位电话号码");
            //    return;
            //}
            //店铺管理员应在平台上注册，所以在平台上执行用户名检查
            this.exec("checkUserOnPlatform", {
                userName: data["userId.userName"],
                platformShopId:this.getPlatformShopId()
            }).then(lang.hitch(this,function(backData){
                data.platformShopId = this.getPlatformShopId();
                if (backData&&backData.data&&backData.data.ok == 1) {
                    //  判断是否是这个店铺的管理员
                    var params = {
                        userId: backData.data.item._id,
                        platformShopId: this.getPlatformShopId()
                    };
                    //如果是平台为商家添加管理员，需要传入改商家的shopId 徐阿雪2018/7/19
                    if(widget.cqRefInfo&&widget.cqRefInfo.cqViewParam&&widget.cqRefInfo.cqViewParam.params){
                        params.fromShopId = widget.cqRefInfo.cqViewParam.params;
                    }
                    this.exec("loadByShopAndUser", params).then(lang.hitch(this, function(resultData) {
                        if(resultData.data.ok == 1){
                            alert("该用户已经是管理员，不能再添加");
                            return ;
                        }else{
                            //  BUG 有该用户的情况下第一次添加会添加失败
                            data.userName = data["userId.userName"];
                            delete data["userId.userName"];
                            data.pName = backData.data.item.pName;
                            data.userId = backData.data.item._id;
                            data.phone = backData.data.item.userName;
                            //如果是平台为商家添加管理员，需要传入改商家的shopId 徐阿雪2018/7/78
                            if(widget.cqRefInfo&&widget.cqRefInfo.cqViewParam&&widget.cqRefInfo.cqViewParam.params){
                                data.fromShopId = widget.cqRefInfo.cqViewParam.params;
                            }
                            this.exec("adminSave",data).then(lang.hitch(this, function (result) {
                                if(1 === result.data.ok){
                                    history.back();
                                }else{
                                    alert("服务器繁忙，请稍后再试！")
                                }
                            }));
                        }
                    }));
                }else{
                    if (!data.password && !data.repassword) {
                        alert("没有当前用户,请输入密码创建！");
                        widget.showByFields(["pName","password","repassword"]);
                        return;
                    }else{
                        var msg = this.getDataValidMsg(data, ["userId.userName", "role", "password", "repassword"]);
                        if(msg){
                            alert(msg);
                            return;
                        }
                        /*if(!data["userId.userName"]){
                            alert("请输入登录名");
                            return;
                        }
                        if(!data.password){
                            alert("请输入密码");
                            return;
                        }
                        if(!data.repassword){
                            alert("请确认密码");
                            return;
                        }
                        if(!data.role){
                            alert("请选择角色");
                            return;
                        }*/
                        if (data.password&&data.repassword&&data.password !== data.repassword) {
                            alert("两次密码不一致");
                            return;
                        } else {
                            //如果是平台为商家添加管理员，需要传入改商家的shopId 徐阿雪2018/7/78
                            if(widget.cqRefInfo&&widget.cqRefInfo.cqViewParam&&widget.cqRefInfo.cqViewParam.params){
                                data.fromShopId = widget.cqRefInfo.cqViewParam.params;
                            }
                            data.userName = data["userId.userName"];
                            delete data["userId.userName"];
                            this.exec("adminSave",data).then(lang.hitch(this, function (result) {
                                if(1 === result.data.ok){
                                    history.back();
                                }else{
                                    alert("服务器繁忙，请稍后再试！")
                                }
                            }));
                        }
                    }
                }
            }))
        },
        onDataReadyForShopAdmin: function(widget){
            //  summary：
            //      店铺管理员编辑数据重载
            //  view:
            //      shopAdminDetail
            // description:
            //      无
            widget.disableByFields(["userId.userName"]);
        }
        
	});
    var shopAdminBo = new ShopAdminBo();
    shopAdminBo.Bo = ShopAdminBo;
	return shopAdminBo;
});