 //  创建人：周超
 //  创建时间: 2016/12/26
 //  创建内容：
 //  		店铺收藏功能1.店铺详情2.我收藏的店铺
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "bob/BoBase",
    "bob/shop/shop",
    "bob/user/consumer",
    "cq/util/share/share",
    "dojo/Deferred"
], function (declare, lang, topic, BoBase, shop, consumer, share, Deferred) {
    var ShopStoreBo = declare("",BoBase.C,{
        fields:{
            shopName:{
                type:"text",
                label:"店铺名称",
                className:"middle-width"
            },
            logo:{
                type:"image",
                label:"公司LOGO",
                className:"large-high",
                sizeType: 'cut',
				size: {
					width: 256,
					height: 256
				},
                notNull: true
            }
		},
        modalName: 'user/shop_store',
        //取消收藏方法
        cancelCollectShop: function(targetShopId){
            return this.exec("shopStoreCancel", {
                targetShopId: targetShopId,
                userId: consumer.getCurrentUserId()
            }).then(lang.hitch(this, function(result){
                // 如果成功了的话 要处理 缓存数据
                if(result&&result.data&&result.data.ok==1){
                    //&&this.cachedShop[result.data.item._id]
                    delete this.cachedShop[result.data.item.targetShopId];
                }
                return result;
            }));
        },
        // 收藏方法
        collectShop: function(targetShopId){
            var def = new Deferred();
            var _this = this;
            /*require([
                "cq/util/sys/userAgent",
                "cq/util/edit/dialog"
            ], function(userAgent, dialog){
                // 微信环境
                if(userAgent.isWeixin()){
                    // 判断当前用户是否已经关注
                    consumer.getCurrentUser().then(function(user){
                        if(!user._id||!user.subscribed){
                            // 弹出二维码
                            dialog.show("<img style='width:160px;height:160px;' src='./images/qr/zaicuntou.jpg'/>", true);
                            def.resolve({
                                data: {
                                    ok: 0,
                                    message: "请长按识别图片，关注公众号"
                                }
                            });
                        }else{
                            _this.exec("shopStore", {
                                targetShopId: targetShopId,
                                userId: consumer.getCurrentUserId()
                            }).then(function(result){
                                // 如果成功了的话 要处理 缓存数据
                                if(result&&result.data&&result.data.ok==1){
                                    _this.cachedShop[result.data.item.targetShopId] = 1;
                                }
                                def.resolve(result);
                            });
                        }
                    });
                }else{*/
                    _this.exec("shopStore", {
                        targetShopId: targetShopId,
                        userId: consumer.getCurrentUserId()
                    }).then(function(result){
                        // 如果成功了的话 要处理 缓存数据
                        if(result&&result.data&&result.data.ok==1){
                            _this.cachedShop[result.data.item.targetShopId] = 1;
                        }
                        def.resolve(result);
                    });
                /*}
            });*/
            return def;
        },
        // 关注的店铺列表数据
        getItemPropForShopStore: function(data){
            data.shopName = data.targetShopId.shopName||"";
            data.logo = data.targetShopId.logo||"";
            return data;
        },
		
        // 加载指定店铺详情
        loadById: function(params){
            return shop.loadById(params);
        },
        // 我关注的店铺url获取
        getShopStoreUrl: function(){
            return this.getBaseUrl()+"/shopStoreLoad";
        },
        // 我关注的店铺查询参数
        getShopStoreQuery: function(parm){
            var query = {};
            query.shopId = this.getShopId();
            query.userId = consumer.getCurrentUserId();
            //搜索框
            if(parm.cqViewParam.params){
                query.search = parm.search;
            }
            return query;
        },
        shopStoreAction: function(data, action, widget){
            if (action === 'collect_cancel') {
                // 直接调用自己的取消关注方法
                this.cancelCollectShop(data.targetShopId._id).then(lang.hitch(this, function(result){
                    if(result.data&&result.data.ok==1){
                       widget.removeItemByData(data);
                       alert("取消关注成功");
                    }else{
                       alert(result&&result.data&&result.data.message||"取消关注失败");
                    }
                }));
            } else if(action === 'to_shop'){
                window.moveToView('businessDetails', data.targetShopId._id);
            }else if(action === 'to_share'){
                var options = [{
                    "weixin": {
                        title: data.mName,
                        thumb: data.logo || "",
                        url: share.getPageLoc(this.getShopId(),"#businessDetails-" + data.targetShopId._id)
                    }
                }, {
                    "friendCircle": {
                        title: data.mName,
                        thumb: data.logo || "",
                        url: share.getPageLoc(this.getShopId(),"#businessDetails-" + data.targetShopId._id)
                    }
                }, {
                    "copy": {
                        url: share.getPageLoc(this.getShopId(),"#businessDetails-" + data.targetShopId._id)
                    }
                }];
                share.showShare(options);
            }else{
                window.moveToView('businessDetails', data.targetShopId._id);
            }
        },
        // 商家详情布局中content中的取消关注店铺
        cancel: function(data,wiget){
            var targetShopId = data._id;
            this.cancelCollectShop(targetShopId).then(lang.hitch(this, function(result){
                if(result.data&&result.data.ok==1){
                    alert("取消关注成功");
                    wiget.cqRefresh();
                }else{
                    alert(result&&result.data&&result.data.message||"取消关注失败");
                }
            }));
        },
        // 商家详情布局中content中的关注店铺
        get: function(data,wiget){
            var targetShopId = data._id;
            this.collectShop(targetShopId).then(lang.hitch(this, function(result){
                if(result.data&&result.data.ok==1){
                    alert("关注成功");
                    wiget.cqRefresh();
                }else{
                    alert(result&&result.data&&result.data.message||"关注失败");
                }
            }));
        },
        // 商家详情中按钮的显示和隐藏
        shopStoreDataReady: function(wiget){
            var data = wiget.getData();
            wiget.hideByFields(["getButton","cancelButton"]);
            var parms = {};
            parms.userId = consumer.getCurrentUserId();
            parms.shopId = this.getShopId();
            parms.targetShopId = data._id;
            this.exec("isStoreShop",parms).then(lang.hitch(this,function(result){
                if(result.data&&result.data.item&&result.data.item.isStore==true){
                    wiget.showByFields(["cancelButton"]);
                }else{
                    wiget.showByFields(["getButton"]);
                }
            }));
        },
        hasCollectedByShopId: function(shopId){
            return this.exec("isStoreShop", {
                targetShopId: shopId,
                userId: consumer.getCurrentUserId()
            }).then(lang.hitch(this, function(result){
                return result&&result.data&&result.data.item&&result.data.item.isStore||false;
            }));
        },
        // 刘轩 2016-12-30
        // 我已经收藏的店铺
        cachedShop: {},
        _cacheMyShops:function(userId){
            return this.exec("shopStoreLoad",{
                shopId: this.getShopId(),
                userId: userId
            }).then(lang.hitch(this, function(result){
                this.cachedShop = {};
                var items = result&&result.data&&result.data.items||[];
                if(items&&items.length){
                    for(var i=0;i<items.length;i++){
                        this.cachedShop[items[i].targetShopId._id] = 1;
                    }
                }
            }));
        },
        // 加载我已经收藏的数据
        cacheMyShops: function(){
            if(!this._cacheMyShopsDef){
                this.cachedShop = {};
                topic.subscribe("/cq/biz/user/user/hasLogin",lang.hitch(this,function(hasLogin){
                    //登录状态发生变化之后需要重置关注信息
                    if(hasLogin){
                        this._cacheMyShops(consumer.getCurrentUserId());
                    }else{
                        this.cachedShop = {};
                    }
                }));
                if(consumer.getCurrentUserId()){
                    this._cacheMyShopsDef = this._cacheMyShops(consumer.getCurrentUserId());
                }else{
                    this._cacheMyShopsDef = consumer.hasLogin();
                }
            }
            return this._cacheMyShopsDef;
        },
        hasCollected: function(targetShopId){
            var a = !!(this.cachedShop&&this.cachedShop[targetShopId]);
            return !!(this.cachedShop&&this.cachedShop[targetShopId]);
        }
    });
    var shopStoreBo = new ShopStoreBo();
    shopStoreBo.Bo = ShopStoreBo;
    lang.setObject("bob.shop.cm.shopStore", shopStoreBo);
    return shopStoreBo;
});