﻿define([
    "dojo/_base/declare",
	"dojo/_base/lang",
    "./_UserMixin",
    "../BoBase",
    "bob/user/consumer",
    "cq/util/sys/date"
], function (declare, lang, _UserMixin, BoBase, consumer, date) {
	var SignInRecordBo = declare('', [BoBase.C], {
        modalName: "user/signInRecord",
        // 可处理字段
        fields: {
            userName: {
                type: "text",
                label: "姓名"
            },
            logo:{
                type: "text",
                label: "logo"
            },
            baseSaveButton:{
                type:"button",
                label:"保存",
                action:"signIn",
                className:"fullButton"
            }
        },
        signIn : function (widget) {
            var signInParams = {};
            signInParams.userId = consumer.getCurrentUserId();
            signInParams.signInDate = new Date();
            this.exec("save", signInParams).then(lang.hitch(this, function(data) {
                if (data && data.data && data.data.ok === 1) {
                    alert("签到成功！");
                    widget.onCqChanged(widget, "");
                } else {
                    alert(data.data.msg || "签到失败!");
                }
            }));
        },
        // 加载我的签到记录
        // 参数:
        //      params
        getLoadUrl: function(){
            return this.getBaseUrl()+ "/load";
        },
        getListParam: function(parms){
            var queryParams = {};
            queryParams.shopId = this.getShopId();
            queryParams.userId = consumer.getCurrentUserId();
            return queryParams;
        },
        getListItemData : function (item) {
            item.pName = item.userId ? (item.userId.pName || "") : "";
            item.signInDay = item.signInDay ? date.formatISODate(item.signInDay) : "";
            return item;
        },
        cachedFriend:null,
        cacheMyFriend:function(){
            if(!this.cachedFriend){
                this.cachedFriend = {};
                return this.exec("loadMyFriend", this.getListParam()).then(lang.hitch(this,function(data){
                    var items = data&&data.data||data;
                    items = data&&data.data&&data.data.items||[];
                    if(items&&items.length){
                        for(var i=0;i<items.length;i++){
                            this.cachedFriend[items[i]._id]=1;
                        }
                    }
                }));
            }else{
                return this.defTest({});
            }
        },
        isFriend:function(userId){
            return !!(this.cachedFriend&&this.cachedFriend[userId]);
        },
        /*
        getCurrentSignIn:function(){},
        reloadCurrentSignIn:function(){
            params.signInDay = new Date();
            this.exec("load",params).then(function(data){
                console.log(data);
            })
            //console.log("ddd");
        }
        */
	});
    var signInRecordBo = new SignInRecordBo();
    signInRecordBo.Bo = SignInRecordBo;
	return signInRecordBo;
});