﻿define([
	"dojo/_base/declare",
    "dojo/topic",//不依赖的模块
    "dojo/Deferred",//不依赖的模块
    "dojo/_base/lang",//不依赖的模块
    "dojo/topic", //不依赖的模块
    "cq/util/sys/date",
    "cq/util/config/config",//不依赖的模块
    "cq/widgets/bigImg",//不依赖的模块
    "../BoBase",
    "./consumer"
],function(declare,topic,Deferred,lang,topic,date,config,bigImg,BoBase,consumer){
	var TimeLineBo = declare("", [BoBase.C], {
		modalName:"user/timeLine",
        fields:{
            title:{
                type:"text",
                //label:"主题",
				placeHolder:"这一刻想记录...",
				className:"large-width fullTextArea"
            },
            createAt:{
                type:"dateTime",
                label:"日期",
				className:"small-width"
            },
            images:{
                type:"images",
                label:"图片",
				size:{width:640,height:640},
				sizeType:"cut"
            },
			//评价内容字段
			content: {
                type: "textarea",
                className: "large-width large-high3",
                placeHolder: "",
                label: "评价内容"
            },
			//提交评价按钮
			onSubmitCommentDetailButton:{
				type:"button",
				action:"onCommentDetail",
				label:"发表评价",
                className: "fullButton"
			},
			//发布村友圈
			saveButton:{
				type:"button",
				action:"onSave",
				label:"发送",
                className: "fullButton"
			},
			//列表点击项
            listActions:{
				type:"text",
				label:"",
				formatter:function(action,data){
					var v = "<div class='button' cq-action='delete'>删除</div><div class='button' onclick='window.moveToView(\"timeLineDetail\",\""+data._id+"\");'>编辑</div>";
					return v;
				}
            },
            toReplay: {
                type: "button",
				action:"toReplay",
				label: "回复",
                className: "fullButton"
            }
        },
        toReplay: function(data){
            alert("ok");
        },
		//点赞的数据处理
		praise:function(data){
			return this.exec("praise", {
				_id:data._id,
				shopId:this.getShopId(),
				}).then(lang.hitch(this, function (dat) {
				return dat;
			}));
		},
		//app端评价界面的Layout
		getCommentDetailLayout:function(){
			if (!this.commentDetailLayout) {
                this.commentDetailLayout = [{
                    type: "form",
                    fields: this.getFormItems([
                        "content","onSubmitCommentDetailButton"
                    ])
                }];
            }
            return this.commentDetailLayout;
		},
		//app端提交评价的数据操作
		onCommentDetail:function(data, param){
			return this.exec("comment", {
				_id:param.cqRefInfo.cqViewParam.params,
				shopId:this.getShopId(),
				content:data.content,
            }).then(lang.hitch(this, function (data) {
                if (data.data && data.data.ok === 1) {
                    history.back();
                    alert("评论成功");
                } else {
                    alert(data&&data.data&&data.data.message||"评论失败");
                }
            }));
		},
		load:function(){
			return this.getBaseUrl() + "/load?shopId=" + this.getShopId();
		},
        getListUrlForCurrentUser: function(){
            return this.getBaseUrl() + "/load?shopId=" + this.getShopId()+"&userId="+consumer.getCurrentUserId();
        },
		loadPlatform:function(){
			return this.getBaseUrl()+"/load?shopId="+config.getPlatformShopId();
		},
        loadById: function(){
            if(!params.cqViewParam.params){
                return;
            }
            return this.exec("loadById", {
				_id: params.cqViewParam.params
			}).then(lang.hitch(this, function(result){
				return result.data.item||{};
			}));
        },
		loadTimeLineInfoById: function(params){
			return this.exec("loadById", {
				_id: params.cqViewParam.params
			}).then(lang.hitch(this, function(result){
				return result.data.item||{};
			}));
			//return this.getBaseUrl()+"/loadById";
		},
		getQueryParam:function(params){
			var query = {
				isUse:true,
				tp:1
			};
			if(params.cqViewParam&& params.cqViewParam.params) {
				var p = params.cqViewParam.params.split("_");
				//if(p[0] == "prj") query.projectId = p[1];
				query._id = p[0];
				query.shopId = this.getShopId();
			}
			if(params.state){
				query.tp = params.state._id;
			}
            return query;
        },
        getEditLayout: function() {
            if(!this.editLayout){
                this.editLayout = [{
                    type: "form",
                    fields: this.getFormItems(["title","images","saveButton"])
                }];
            }
            return this.editLayout;
        },
		onListClick:function(data,action,list){
			if(action == "toReplay"){
				//if(!confirm("确定删除吗？")) return;
				//timeLine.savePlatform({_id:data._id,isUse:false}).then(function(){list.removeItemByData(data);});
                this.toReplay();
			}
		},
		//评论回复
		toHf:function(param,widget){
				var text=prompt("请输入评论内容","")
				if (text!=null && text!=""){
						return this.exec("replay", {commentId:param._id,content:text}).then(lang.hitch(this,function(data){
							if(data.data.ok = 1||data.data){
								history.back();
                    			alert("回复成功");
							}
						}));
					}
		},
		onSave:function(data,dataList){
			data.tp = 1;
			return this.exec("save", data).then(lang.hitch(this, function (result) {
				if (result.data && result.data.ok === 1) {
					//history.back();
					alert("添加成功");
				} else {
					alert("保存失败");
				}
			})); 
		},
		addTimeLine:function(widget){
			window.moveToView("timeLineDtl",widget.cqRefInfo && widget.cqRefInfo.cqViewParam && widget.cqRefInfo.cqViewParam.params);
		},
		nothing:function(){
			
		}
        
    });
	var timeLineBo = new TimeLineBo();
	timeLineBo.Bo = TimeLineBo;
    return timeLineBo;
});
