﻿//订单系统公共基类
// 1、提供订单系统的基本属性
// 2、提供公用的方法
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "whz/util/config",
    "cq/util/sys/date",
    "cq/util/image/blob"
], function (declare, lang, array, config, date, blob) {
    return declare("", null, {
        modalName: "user/timeLine",
        fields: {
            title: {
                type: "textarea",
                placeHolder: "这一刻想记录...",
                className: "large-width fullTextArea",
                label: "动态内容",
                notNull: true
            },
            createAt: {
                type: "dateTime",
                label: "日期"
            },
            images: {
                type: "images",
                label: "图片",
                multiple: "multiple"
            },
            //评价内容字段
            content: {
                type: "textarea",
                placeHolder: "",
                label: "内容",
                notNull: true
            },
            toReplay: {
                type: "button",
                action: "toReplay",
                label: "回复"
            },
            strTime: {
                type: "text"
            }
        },
        loadByIdFunc: function (_id) {
            return this.exec("loadById", {
                _id: _id
            }).then(lang.hitch(this, function (result) {
                var item = result && result.data && result.data.item || {};
                //if(item){
                item.publisher = item.publisher || {};
                item.publisher.logo = item.publisher.logo || config.defultUserLogo;
                if (item.fromShopId) {
                    item.fromShopId.logo = item.fromShopId.logo || config.defultUserLogo;
                }
                if (item.comments && item.comments.length) {
                    array.forEach(item.comments, function (comment) {
                        comment.logo = comment.logo || config.defultUserLogo;
                        comment.nickName = comment.nickName || "无名氏";
                    });
                }
                return result;
            }));
        },
        // 加载指定动态数据
        loadById: function (params) {
            return this.loadByIdFunc(params.cqViewParam.params).then(lang.hitch(this, function (result) {
                var item = result && result.data && result.data.item || {};
                //把LOGO宽度设置为80
                for (var i = 0; i < item.comments.length; i++) {
                    item.comments[i].logo = blob.getImageUrl(item.comments[i].logo||"", "80");
                    if(item.comments[i].userId){
                        item.comments[i].userId.logo = blob.getImageUrl(item.comments[i].userId.logo||"", "80");
                    }
                    if(item.comments[i].replyFor){
                        item.comments[i].replyFor.logo = blob.getImageUrl(item.comments[i].replyFor.logo||"", "80");
                    }
                }
                //设置时间
                if (item.comments && item.comments.length) {
                    item.comments.forEach(function (comment) {
                        comment.strTime = date.getTimeMoment(comment.time);
                    });
                }
                return item;
            }));
        }
    });
});
