﻿define([
	"dojo/_base/declare",
    "dojo/_base/lang",
    'dojo/Deferred',
    "cq/util/config/config",
    "bob/BoBase",
    "bob/user/consumer",
    "./_Mixin",
    "cq/util/sys/date"
],function(declare,lang,Deferred,config ,BoBase,consumer, _Mixin, date){
	var TimeLineBo = declare("", [BoBase.C, _Mixin], {
        fields: {
            "userId.nickName": {
                type: "text"
            },
            "userId.logo": {
                type: "text"
            },
            time: {
                type: "dateTime"
            },
            "replyFor.nickName": {
                type: "text"
            }
        },
        onComment:function(data, param){
            // summary:
            //        app端提交评价的数据操作
            // view:
            //         commentDetail
            // description:
            //         无
            var msg = this.getDataValidMsg(data, ["comment"]);
            if(msg){
                alert(msg);
                return;
            }
            return this.exec("comment", {
                _id:param.cqRefInfo.cqViewParam.params,
                content:data.content,
            }).then(lang.hitch(this, function (data) {
                if (data && data.data && data.data.ok === 1) {
                    history.back();
                    alert("评论成功");
                } else {
                    alert(data&&data.data&&data.data.message||"评论失败");
                }
            }));
		},
        // 发布村有圈时提示
        timeLineEdtReload : function (widget) {
            var hintMsg = config.hintMsg;
            var node = widget.getEditorByField("hintMsg");
            node.innerText = hintMsg || "";
            if (hintMsg) {
                widget.showByFields(["hintMsg"]);
            } else {
                widget.hideByFields(["hintMsg"]);
            }
        },
        onHintMsg : function () {},
		getListUrl:function(){
            // summary:
            //        动态列表的加载
            // view:
            //         timeLine
            // description:
            //         无
			return this.getBaseUrl() + "/load";
		},
        getListParam:function(params){
            // summary:
            //        动态列表的加载的参数传递
            // view:
            //         timeLine、timeLineForMe
            // description:
            //         无
			var query = {
				isUse:true,
                shopId: this.getShopId(),
                tp:3
			};
			if(params.state){
				query.tp = "undefined"===typeof(params.state.tp)?params.state._id:params.state.tp;
			}
            return query;
        },
        getListParamByOpShop: function(params){
            var query = {
				isUse:true,
                shopId: this.getShopId(),
                tp:1,
                opShopId: params.cqViewParam.params,
                orderBy: "-createAt"
			};
            return query;
        },
        getListParamBySevShop: function(params){
            var query = {
				isUse:true,
                shopId: this.getShopId(),
                tp:1,
                sevShopId: params.cqViewParam.params,
                orderBy: "-createAt"
			};
            return query;
        },
        getItemPropByShop: function(item){
            item.logoNode = item.images.length?("<div style='width:100px;height:65px;margin-left:10px;position:relative;'>"+
                "<img style='margin-top:0;margin-right:0;height:100%;width:100%;' src='"+item.images[0]+"'/>"+
                "<div style='position:absolute;bottom:0;right:0;padding: 0 5px;background: rgba(0,0,0,0.5);color: white'>"+item.images.length+"</div>"+
            "</div>"):"";
            item.timeStr = date.getTimeMoment(item.createAt);
            return item;
        },
        getListUrlByUserId: function(){
            return this.getBaseUrl() + "/load?shopId="+this.getShopId()+"&tp=1&isUse=true";
        },
        getListParamByUserId: function(params){
            return {
                userId: params.cqViewParam.params
            };
        },
        getListParamForMe: function(params){
            return {
                isUse:true,
                shopId: this.getShopId(),
                tp:1,
                userId: consumer.getCurrentUserId()
            };
        },
        getItemProp: function(data){
            return data;
        },
        getListUrlForCurrentUser: function(){
            // summary:
            //        我的动态列表的加载
            // view:
            //         timeLineForMe
            // description:
            //         无
            return this.getBaseUrl() + "/load";
        },
        onPublish: function(data,dataList){
            // summary:
            //        app端发布动态的数据操作
            // view:
            //         timeLineDtl
            // description:
            //         无

            // 数据为空检查
            var msg = this.getDataValidMsg(data,["title"]);
            if(msg){
                alert("说点什么再发布吧");
                return ;
            }
			data.tp = 1;
			this.exec("save", data).then(lang.hitch(this, function (result) {
				if (result && result.data && result.data.ok === 1) {
					alert("发布成功");
                    dataList.setData("");
                    history.back();
				} else {
					alert(result&&result.data&&result.data.message||"发布失败");
                    dataList.setData("");
				}
			})); 
		},
        addTimeLine:function(widget){
			window.moveToView("timeLineDtl",widget.cqRefInfo && widget.cqRefInfo.cqViewParam && widget.cqRefInfo.cqViewParam.params);
		},
        deleteTimeLine: function(timeLineId){
            if(!confirm("确认删除?")){
                return;
            }
            return this.exec("save", {
                _id: timeLineId,
                isUse: false
            }).then(lang.hitch(this, function(result){
                return result;
            }));
        },
        toReply: function(data, widget){
            window.moveToView("replyFor", data.timeLineId+","+data._id+","+data.userId._id);
        },
        onReply: function(data){
            return this.exec("reply", {
                _id: data.timeLineId,
                replyFor: data.replyFor,
                content: data.content,
                replyCommentId: data.replyCommentId
            });
        },
        onDataReady: function(widget){
            var data = widget.getData();
            widget.hideByFields(["replyForBtn"]);
            if(!data._id){
                return;
            }
            if(data.replyFor){
                widget.showByFields(["replyForBtn"]);
            }
        },
        moveToReplyFor: function(data){
            window.moveToView("villager", data.replyFor._id);
        },
        toReplyFor: function(data, widget){
            var msg = this.getDataValidMsg(data, ["content"]);
            if(msg){
                alert(msg);
                return;
            }
            var hash = widget.cqRefInfo.cqViewParam.params.split(",");
            if(!hash.length){
                alert("参数无效");
                return;
            }
            this.onReply({
                timeLineId: hash[0],
                content: data.content,
                replyFor: hash[2],
                replyCommentId: hash[1]
            }).then(lang.hitch(this, function(result){
                if(result&&result.data&&result.data.ok==1){
                    alert("回复成功");
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"回复失败");
                }
            }));
        },
        /*
            app端举报的处理
        */
        report : function (data) {
            var def = new Deferred();
            this.exec("report", {
                _id : data._id,
                shopId : this.getShopId()
            }).then(lang.hitch(this, function (data) {
                def.resolve(data);
            }));
            return def;
        },
		praise:function(data){
            // summary:
            //        app端动态页面的点赞的处理
            // view:
            //         timeLine
            // description:
            //         无
            var def = new Deferred();
			this.exec("praise", {
				_id:data._id,
				shopId:this.getShopId(),
			}).then(lang.hitch(this, function (data) {
				def.resolve(data);
                if(data&&data.data&&data.data.ok == 1){
                    //处理点赞,取消点赞相应送积分和扣积分动作
                    var currentUserId = consumer.getCurrentUserId();
                    var praiser = data&&data.data&&data.data.item&&data.data.item.praises;
                    //当前的操作是点赞还是取消点赞的状态变量,默认为false
                    var isPraise = false;
                    for(var i =0,l = praiser.length;i<l;i++){
                        //如果点赞者里面有当前登录人的话，则这个动作为点赞，否则为取消点赞
                        if(currentUserId == praiser[i].userId){
                            isPraise = true;
                        }
                    }
                }
			}));
            return def;
		},
        initCommentDetail:function(){
            // summary:
            //        app提交评论页面清空上次评论的数据
            // view:
            //         commentDetail
            // description:
            //         无
            return "";
        },
        save: function(data){
            data.tp = 2;
			return this.exec("save", data);
        },
        //页面元素的初始化
        initTimeLineDtl:function(){
            return "";
        }
    });
	var timeLineBo = new TimeLineBo();
	timeLineBo.Bo = TimeLineBo;
    return timeLineBo;
});
