﻿define([
    "dojo/_base/declare",
    "dojo/Deferred",
    "cq/util/sys/date",
    "../../BoBase",
    './_Mixin',
    '../consumer'
],function(declare,Deferred,date,BoBase,_Mixin,consumer){
    var UserAutB =  declare('',[BoBase.B,_Mixin],{
        getListUrl:function(){
            return this.getBaseUrl()+"/load?shopId="+this.getShopId();
        },
        getListParam:function(param){
            var query = {};
            param = param||{};
            if(param.state){
                //已提交
                if(param.state._id == 0){
                    query.isVerified=1;
                }
                //已审核
                if(param.state._id ==1){
                    query.isVerified=2;
                }
                //已驳回
                if(param.state._id ==2){
                    query.isVerified = (-1);
                }
            }else{
                query.isVerified = 1;
            }
            return query;
        },
        moveToUserAutB:function(e){
            window.moveToView('userAutB',e._id);
        },
        //userAutB显示字段
        getUserAutBLayout:function(){
            return [{
                type: "form",
                fields: this.getFormItems([
                    'userId.logo','userId.nickName',"name", "phone", "autRemark", "idNo", "idImg",
                    "provinceId,cityId,countryId,cityName","countryId,townId,villageId,townName",'verificationButton','backVerificationButton'
                ])
            }];
        },
        getItemProp:function(data){
            data.logo = data&&data.userId&&data.userId.logo||'';
            data.createAt = date.formatISODateMinutes(data.createAt);
            return data;
        },
        initUserAutBInfo:function(cqRefInfo){
            var def = new Deferred();
            var id = cqRefInfo&&cqRefInfo.cqViewParam&&cqRefInfo.cqViewParam.params||'';
            this.loadUserAutById(id).then(function(data){
                if(data&&data.data&&data.data.ok ==1){
                    var item  = data.data.item
                    item.createAt = date.formatISODateMinutes(item.createAt);
                    def.resolve(item);
                }else{
                    def.resolve();
                }
            });
            return def ;
        },
        loadUserAutById:function(id){
            return this.exec('loadById',{
                _id:id
            });
        },
        reLoadUserAutBMethod:function(widgets){
            var data = widgets.getData();
            if(widgets.getFieldValue(['name'])){
                
                widgets.disableByFields(['userId.logo','userId.nickName',"name", "phone", "autRemark", "idNo", "idImg",'createAt'
                ])
            }
            if(data.isVerified){
                //如果认证状态不为1，隐藏按钮
                if(data.isVerified !== 1){
                    widgets.hideByFields(['verificationButton','backVerificationButton']);
                }
            }
        },
        //按钮审核方法
        onVerifyMethod:function(data){
            if(data&&data._id){
                this.userAutVerify({_id:data._id}).then(function(data){
                    if(data&&data.data&&data.data.ok ==1){
                        alert('审核成功');
                        history.back();
                    } else{
                        alert('审核失败');
                    }
                });
            }
        },
        //按钮驳回方法
        onRejectMethod:function(data){
            var param={};
            param.rejectReason =  prompt('驳回原因');
            if(!param.rejectReason){
                return ;
            }
            param._id = data._id;
            this.userAutReject(param).then(function(data){
                if(data&&data.data&&data.data.ok == 1){
                    alert('驳回成功');
                    history.back();
                    return;
                }else{
                    alert('驳回失败');
                    return ;
                }
            });
            
        },
        //审核认证
        userAutVerify:function(param){
            return this.exec('verify',param);
        },
        //驳回认证
        userAutReject:function(param){
            return this.exec('reject',param);
        }
    });
    var userAutB = new UserAutB();
    userAutB.bo = UserAutB;
    return userAutB;
});