﻿define([
    "dojo/_base/declare",
    "dojo/Deferred",
    "../../BoBase",
    './_Mixin',
    '../consumer'
],function(declare,Deferred,BoBase,_Mixin,consumer){
    var UserAutC =  declare('',[BoBase.C,_Mixin],{
        getUserAutLayout:function(){
            return [{
                type: "form",
                fields: this.getFormItems([
                    "name", "phone", "autRemark", "idNo", "idImg", "provinceId,cityId,countryId,cityName","countryId,townId,villageId,townName",'verificationState','rejectReason',"onSubmitUserAutButton",
                    "reSubmitUserAutButton"
                ])
            }];
        },
        onSubmitUserInfo:function(value,widgets,event){
            if(value.rejectReason){
                value.reSubmit = true;
            }
            var msg = this.getDataValidMsg(value, ["name", "phone", "autRemark", "idNo", "idImg"]);
            if(msg){
                alert(msg);
                return;
            }
            //if(!(this.isCellPhone(value.phone))){
            //    alert('请填写正确的手机号码');
            //    return;
            //}
            if(!(/(^\d{15}$)|(^\d{18}$)|(^\d{17}(\d|X|x)$)/.test(value.idNo))){
                alert('请填写正确的身份证号');
                return;
            }
            if(!value.provinceId||!value.cityId||!value.countryId){
                alert("请选择省市区(县)");
                return;
            }
            if(!value.townId){
                alert("请选择乡镇");
                return;
            }
            value.userId = consumer.getCurrentUserId();
            this.saveUserAutInfo(value).then(function(data){
                if(data&&data.data&&data.data.ok ==1){
                    alert('提交成功');
                    history.back();
                }else{
                    alert(data.data.msg);
                }
                
            })
        },
        testFieldNull:function(params){
            var fields = ["name", "phone", "autRemark", "idNo", "idImg"]
            for(var i=0;i<fields.length;i++){
                if(!params[fields[i]]){
                    return fields[i]+'没有填写';
                }
            }
        },
        //判断当前用户是否已经提交过认证，如果有，则禁止用户操作行为
        initUserAutInfo:function(){
            var def = new Deferred();
            var params = {};
            this.loadUserInfoByUserId().then(function(data){
                if(data&&data.data&&data.data.ok ==1){
                    if(data.data.items.length == 1){
                        params = data.data.items[0];
                        if(params.isVerified == 1){
                            params.verificationState = '审核中';
                        }
                        if(params.isVerified == 2){
                            params.verificationState = '已认证';
                        }
                        if(params.isVerified == -1){
                            params.verificationState = '已驳回';
                        }
                        def.resolve(params);
                    }else{
                        def.resolve({});
                    }
                }
            });
            return def;
        },
        //控制页面的显示问题
        reLoadUserAutMethod:function(widgets){
            //判断初始化页面数据后页面是否有值，如果有，则禁止页面操作动作
            if(widgets.getFieldValue(['name'])){
                var data = widgets.getData();
                //如果认证状为1,2时，显示所有信息字段，隐藏驳回原因和按钮
                if(data.isVerified == 1||data.isVerified ==2){
                    widgets.showByFields(['verificationState']);
                    widgets.disableByFields(["name", "phone", "autRemark", "idNo", "idImg", "provinceId,cityId,countryId,cityName", "countryId,townId,villageId,townName","verificationState"]);
                    widgets.hideByFields(['rejectReason','reSubmitUserAutButton','onSubmitUserAutButton'])
                }else{
                    widgets.showByFields(['rejectReason','reSubmitUserAutButton','verificationState']);
                    widgets.disableByFields(['verificationState','rejectReason']);
                    widgets.hideByFields(['onSubmitUserAutButton']);
                }
            }else{
                widgets.hideByFields(['verificationState','rejectReason','reSubmitUserAutButton']);            
            }
        },
        //用户认证保存操作
        saveUserAutInfo:function(params){
            return this.exec('save',params);
        },
        //验证用户是否提交过认证
        loadUserInfoByUserId:function(){
            return this.exec('load',{
                userId: consumer.getCurrentUserId()
            });
        }
    });
    var userAutC = new UserAutC();
    userAutC.bo = UserAutC;
    return userAutC;
});
