//  创建内容：UserLevel店铺管理员，B端（不同shopId下数据发生变化）
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "bob/user/_UserMixin",
    "bob/user/userLevel/_Mixin",
    "cq/app/config",
    "cq/util/sys/common",
    "cq/util/config/config",
    "bob/shop/shop",
    "bob/BoBase"
], function (declare, lang, topic, _UserMixin, _UserLevelMixin, appConfig, common, config, shop, BoBase) {
    var UserLevelBo = declare("",[BoBase.B,_UserMixin,_UserLevelMixin],{
		fields:{
            levelName :{
                type: "text",
                placeHolder: "",
                label: "等级名称",
                placeHolder: "等级名称",
                notNull: true
            }, 
            growthValue:{
                type: "text",
                placeHolder: "",
                label: "所需成长值",
                placeHolder: "等级所需最小成长值",
                notNull: true
            },
            goldRate:{
                type:"number",
                label:"金元宝比例",
                notNull: true
            },
            mId: {
                label: '赠送商品',
				type: 'ref',
				dataProvider: 'bob/mat/matB',
				targetMethod: 'getListUrlForCurrentShop',
				className: 'middle-width',
				searchField: 'mName',
				labelFields: 'mName'
            },
            group: {
                type: "groupEdit",
                label: "等级奖励",
                rightText: "未设置",
                group: "group3"
            },
            saveUserLevelButton:{
                type:"button",
                label:"完成",
                action:"save",
                className:"fullButton"
            }
        },
        //会员等级列表数据获取
        getListUrlForUserLevel:function () {
            return this.getBaseUrl() +"/load?shopId="+this.getShopId();
        },
        //会员等级列表数据组装
        getItemPropForUserLevel: function(items){
            return items;
        },
        //会员等级列表参数传递
        getListParamForUserLevel: function(){
            var query = {};
            return query;
        },
        //会员等级列表的列表点击事件
        onListClickForUserLevel: function(data){
            window.moveToView("userLevelEd",data._id);
        },
        //会员等级编辑的Layout
        getListLayoutForUserLevel:function(){
            return [{
                type: "form",
                fields: this.getFormItems([
                    "levelName",
                    "growthValue",
                    "group",
                    "goldRate",
                    "saveUserLevelButton"
                ])
            },{
                type : "group",
                groupId:"group3",
                groupClass: "mblEdgeToEdgeList",
                fields : this.getFormItems([
                    "mId"
                ])
            }];
        },
        //编辑指定的会员等级数据获取
        loadUserLevelById: function(param){
            if(param&&param.cqViewParam&&param.cqViewParam.params){
                return this.exec("loadById", {
                    _id: param.cqViewParam.params,
                    shopId: this.getShopId()
                }).then(lang.hitch(this, function(data) {
                    return data&&data.data&&data.data.item||data;
                }));
            }
        },
        //会员等级的保存按钮
        save: function(data){
            var msg = this.getDataValidMsg(data);
            if(msg){
                alert(msg);
                return;
            }
            this.exec("save",data).then(lang.hitch(this, function (result) {
                if(result&&result.data&&result.data.ok==1){
                    alert("保存成功");
                    history.back();
                }else{
                    alert(result&&result.data&&result.data.message||"保存失败")
                }
            }));
        },
        //输入检验
        getDataValidMsg: function(data){
            var msg = "";
            var re = /^[0-9]+$/;
            if (!data.levelName) {
                msg = "等级名称不能为空!";
            }else if(!data.growthValue){
                msg = "所需成长值不能为空!";
            }else if(!re.test(data.growthValue)){
                msg = "所需成长值只能为正整数!";
            }
            return msg;
        }

	});
    var userLevelBo = new UserLevelBo();
    userLevelBo.Bo = UserLevelBo;
	return userLevelBo;
});