define([
    "cq/util/sys/userAgent"
], function (userAgent) {
	return {
        copyToClipboard:function(text, onSuccess, onError){
            if(userAgent.isBrowser()){
                if(document.queryCommandSupported("copy")){
                    var textArea = document.createElement("textarea");
                    textArea.style.fontSize = '12pt';
                    textArea.style.border = '0';
                    textArea.style.padding = '0';
                    textArea.style.margin = '0';
                    textArea.style.position = 'fixed';
                    textArea.style.right = '-9999px';
                    textArea.style.top = (window.pageYOffset || document.documentElement.scrollTop) + 'px';
                    textArea.setAttribute('readonly', '');
                    textArea.value = text;
                    document.body.appendChild(textArea);
                    textArea.select();
                    try{
                        if(document.execCommand('copy')){
                            onSuccess();
                        }else{
                            onError();
                        }
                    }catch(e){
                        onError();
                    }
                    textArea.parentNode.removeChild(textArea);
                }else{
                    onError();
                }
            }else if(cordova&&cordova.plugins&&cordova.plugins.clipboard){
                cordova.plugins.clipboard.copy(text, onSuccess, onError);
            }else{
                onError();
            }
        }
    };
});