﻿//依据layout配置处理界面的生成，同时处理对象之间的关联刷新问题
define([
    "dojo/_base/lang",
    "dojo/_base/array",
    "./_Builder"
],function(lang,array,_Builder){
    //由类型或data-dojo-type建立的html片段
    return new _Builder({
        htmls:{
            //带margin的topBar
            "marginBar":'<div id="{id}" class="margin-bar {outerClass}"><div class="{innerClass}"><div class="top-bar-left {leftClass}">{left}</div><div class="{contentClass}">{content}</div><div class="top-bar-right {rightClass}">{right}</div></div></div>',
            //顶部工具栏，可以水平和垂直，默认是水平的
            "topBar":'<div id="{id}" class="tool-bar {barClass}"><div class="top-bar-left">{left}</div><div class="top-bar-right">{right}</div></div>',
            //不带图标的按钮
            "menuItem":'<a id="{id}" class="menu-item {className}" href="{href}">{label}</a>',
            //带图标的按钮
            "iconMenuItem":'<a id="{id}" class="menu-item" href="{href}"><img src={logo} class="float-left"><span>{label}</span></a>',
            //左右分栏对象，右边宽度可变
            "splitterVR":'<div id="{id}" data-dojo-type="dojox/mobile/FixedSplitter" data-dojo-props="orientation:\'H\', variablePane:{variablePane}"><div data-dojo-type="dojox/mobile/Pane">{left}</div><div data-dojo-type="dojox/mobile/Pane">{right}</div></div>',
            //放置子view的容器
            "viewContainer":'<div id="{id}" class="cq-view-container {className}"></div>',
            
            "img":'<img src="{src}" class="{imgClass}" />',
            //可以在任何地方注入html片段的对象
            "content":"{content}{contents}",
            //固定宽度的工作区
            "cqFW":"<div class='cq-fw'>{content}</div>",
            //编辑区域相关
            "form":'<form id="{id}" class="cq-form {formClass}" onsubmit="return false">{contents}</form>',
            //一项内容，内部包含标签和输入框内容
            "formItem":'<div id="{id}" class="cq-form-item {className}" data-cq-field="{field}">{contents}</div>',
            //输入框的标签
            "formLabel":'<label id="{id}" class="cq-form-label">{label}</label>',
            //输入框
            "formInput":'<input id="{id}" class="cq-form-input cq-field-input" placeholder="{placeholder}" data-dojo-props="canEdit:\'{canEdit}\',placeholder:\'{placeholder}\'" data-cq-field="{field}" type="{inputType}"/>',
            //按钮
            "formButton":'<button id="{id}" class="cq-action cq-form-button {buttonClass}" data-cq-field="{field}" cq-action="{action}">{label}</button>',
            // 超链接
            "formLink":'<a href="{href}" class="cq-form-link">{content}</a>',
            // 复选框
            "formCheckbox":'<span id="{id}" data-cq-field="{field}" class="cq-form-cb cq-field-input"  data-dojo-props="canEdit:\'{canEdit}\'"><input type="checkbox" class="cq-form-checkbox"><label class="cq-form-checkbox-label">{label}</label></span>',
            // 多行文本
            "formTextarea":'<textarea id="{id}" data-cq-field="{field}" data-dojo-props="canEdit:\'{canEdit}\'" class="cq-field-input cq-form-ta cq-form-input"></textarea>',
            // 日期
            "formDate":'<input id="{id}" data-dojo-type="dijit/Calendar">',
            // 列表选项
            "formOption":'<select id="{id}" class="cq-field-input cq-form-select cq-form-input" data-cq-field="{field}" selectOptions=\'{j:options}\'  data-dojo-props="field:\'{field}\',canEdit:\'{canEdit}\'" data-dojo-type="cq/app/widget/web/edit/Select"></select>'
        },
        //由data-dojo-type到对应的js模块
        models:{},
        _getFieldItemClass:function(field){
            return (field.className||"")+" "+(field.notNull?"not-null":"");
        },
        //用来处理字段编辑的兼容性，这里的编辑方式和webBuilder中的一一对应
        decorateField:function(field,fields){
            var fieldType = ","+field.type+",",fieldItem = null;
            var className = this._getFieldItemClass(field);
            //所有支持的编辑方式都要在这里再写一遍，很奇怪
            if(fieldType===",action,"){
                //按钮
                return fields.push({
                    type: "formItem",
                    contents: [{
                        type: "formButton",
                        label: field.label,
                        field: field.field,
                        action: field.action,
                        canEdit:field.canEdit=='false'||field.canEdit==false?false:true
                    }],
                    className:className
                });
            }else if(-1<",text,tel,password,number,email,url,".indexOf(fieldType)){
                //文本
                fieldItem = {
                    type: "formItem",
                    field: field.field,
                    contents: [{
                        type: "formInput",
                        inputType: field.type,
                        field: field.field,
                        canEdit:field.canEdit=='false'||field.canEdit==false?false:true,
                        placeholder:field.placeHolder
                    }],
                    className:className
                };
            }else if(",date,"===fieldType){
                // 张松   2016/09/13  添加日期类型
                fieldItem = {
                    type:"formItem",
                    field:field.field,
                    contents:[{
                        dojoType:"cq/app/widget/web/edit/DatePicker",
                        field:field.field,
                        canEdit:field.canEdit=='false'||field.canEdit==false?false:true
                    }],
                    className:className
                };
            }else if(-1<",image,images,".indexOf(fieldType)){
                //图片
                fieldItem = {
                    type: "formItem",
                    field: field.field,
                    contents: [{
                        dojoType: "cq/app/widget/web/edit/ImagePicker",
                        field: field.field,
                        mode: field.type==="images"?"duplicate":"",
                        canEdit:field.canEdit=='false'||field.canEdit==false?false:true,
                        sizeType:field.sizeType,
                        remark:field.remark,
                        size:field.size||{}
                    }],
                    className:className+" large-width large-high2"
                };
            }else if(",location,"===fieldType){
                //地理位置
                fieldItem = {
                    type: "formItem",
                    field: field.field,
                    contents: [{
                        dojoType: "cq/app/widget/web/edit/Location",
                        field: field.field,
                        distFields:field.distFields,
                        distFieldsStr:field.distFieldsStr,
                        detailAddrField:field.detailAddrField,
                        canEdit:field.canEdit
                    }],
                    className:className
                };
            }else if(",vcode,"===fieldType){
                //手机号、验证码
                fieldItem = {
                    type: "formItem",
                    field: field.field,
                    contents: [{
                        dojoType: "cq/app/widget/web/edit/UserNameAndVerifyCode",
                        //dojoType:"cq/app/widget/mobile/edit/VCode",
                        field: field.field,
                        errorMsg:field.errorMsg,
                        unExists:field.unExists,
                        canEdit:field.canEdit=='false'||field.canEdit==false?false:true,
                        canToLogin:field.canToLogin
                    }],
                    className:className
                };
            }else if(",VerifyCode,"===fieldType){
                fieldItem = {
                    type:"formItem",
                    field:field.field,
                    contents:[{
                        dojoType: "cq/app/widget/web/edit/VerifyCode",
                        field:field.field
                    }],
                    className:className
                };
            }else if(",textarea,"===fieldType){
                fieldItem = {
                    type: "formItem",
                    field: field.field,
                    contents: [{
                        type: "formTextarea",
                        label: field.label,
                        field: field.field,
                        canEdit:field.canEdit=='false'||field.canEdit==false?false:true
                    }],
                    className:className
                };
            }else if(",checkbox,"===fieldType){
                //复选框
                return fields.push({
                    type:"formItem",
                    field:field.field,
                    contents:[{
                        type:"formCheckbox",
                        label:field.label,
                        field:field.field,
                        canEdit:field.canEdit=='false'||field.canEdit==false?false:true
                    }],
                    className:className
                });
            }else if(",options,"===fieldType){
                //枚举值
                fieldItem = {
                    type:"formItem",
                    field:field.field,
                    contents:[{
                        type:"formOption",
                        field:field.field,
                        options:field.options,
                        canEdit:field.canEdit=='false'||field.canEdit==false?false:true
                    }],
                    className:className
                };
            }else if(",ref,"===fieldType){
                //引用
                fieldItem = {
                    type:"formItem",
                    field:field.field,
                    contents:[{
                        dojoType:"cq/app/widget/web/edit/Ref",
                        field:field.field,
                        searchAttr:field.searchField,
                        pageSize:field.pageSize||20,
                        labelAttr:field.labelFields,
                        dataProvider:field.dataProvider,
                        targetMethod:field.targetMethod,
                        canEdit:field.canEdit=='false'||field.canEdit==false?false:true,
                        query:field.query,
                        refQuery:field.refQuery
                    }],
                    className:className
                };
            }else if(",richText,"===fieldType){
                //富文本
                fieldItem = {
                    type:"formItem",
                    field:field.field,
                    contents:[{
                        dojoType:"cq/app/widget/web/edit/RichEditor",
                        field:field.field,
                        height:640,
                        canEdit:field.canEdit=='false'||field.canEdit==false?false:true
                    }],
                    className:className
                };
            }else if(",dateTime,"===fieldType){
                // 张松   2016/09/13  添加日期类型
                fieldItem = {
                    type:"formItem",
                    field:field.field,
                    contents:[{
                        dojoType:"cq/app/widget/web/edit/DateTimePicker",
                        field:field.field,
                        canEdit:field.canEdit=='false'||field.canEdit==false?false:true
                    }],
                    className:className
                };
            }else if(",district,"===fieldType){
                // 张松   2016/09/21  添加区划类型
                fieldItem = {
                    type:"formItem",
                    field:field.field,
                    contents:[{
                        dojoType:"cq/app/widget/web/edit/DistrictEdit",
                        field:field.field,
                        canEdit:field.canEdit=='false'||field.canEdit==false?false:true,
                        fixedUpDis:field.fixedUpDis||{}
                    }],
                    className:className
                };
            }else if(",object,"===fieldType){
                fieldItem = {
                    type:"formItem",
                    field:field.field,
                    className:className+" cq-form-objs-item",
                    contents:[{
                        dojoType:"cq/app/widget/web/edit/ObjEditor",
                        field:field.field,
                        canEdit:field.canEdit=='false'||field.canEdit==false?false:true,
                        fields:field.fields
                    }]
                };
            }else if(",objects,"===fieldType){
                fieldItem = {
                    type : "formItem",
                    field: field.field,
                    className:className+" cq-form-objs-item",
                    contents : [{
                        dojoType:"cq/app/widget/web/edit/ObjsEditor",
                        field:field.field,
                        label:field.label,
                        canEdit:field.canEdit==="false"||field.canEdit===false?false:true,
                        fields:field.fields,
                        canAdd:field.canAdd,
                        canDelete:field.canDelete,
                        defaultData:field.defaultData||{}
                    }]
                };
            }else if(",attachs,"===fieldType){
                fieldItem = {
                    type : "formItem",
                    field: field.field,
                    contents:[{
                        dojoType:"cq/app/widget/web/edit/AttachmentList",
                        field: field.field,
                        label:field.label,
                        canEdit:field.canEdit==="false"||field.canEdit===false?false:true,
                        canAdd:field.canAdd==="false"||field.canAdd===false?false:true
                    }],
                    className:className+" cq-form-objs-item"
                };
            }
            //else if(",steps,"===fieldType){
            //    fieldItem = {
            //        dojoType:"cq/app/widget/web/Steps",
            //        field:field.field,
            //        stepsTags:field.steps.stepsTags,
            //        stepsFields:field.steps.stepsFields,
            //        stepsBtns:field.steps.stepsBtns
            //    };
            //}
            else if(",tagFields,"==fieldType){
                fieldItem = {
                    type:"tagFields",
                    className:className,
                    fields:field.fields
                };
            }else if(",file,"===fieldType){
                fieldItem = {
                    type:"formItem",
                    field:field.field,
                    contents:[{
                        dojoType:"cq/app/widget/web/edit/FileEditor",
                        field:field.field,
                        label:field.label,
                        canEdit:field.canEdit,
                        value:field.value||{}
                    }],
                    className:className
                };
            }else{
                fields.push(field);
            }
            
            if(fieldItem){
                //添加标签项
                if(field.label){
                    fieldItem.contents.splice(0,0,{
                        type: "formLabel",
                        label: field.label
                    });
                }
                // 文本框后添加提示框
                if(field.tips){
                    fieldItem.contents.push({
                        type:field.tips.type=="link"?"formLink":"",
                        content:field.tips.content,
                        href:field.tips.href
                    });
                }
                //添加到编辑列表中
                fields.push(fieldItem);
            }
        },
        //将html拼装为完整的html内容，处理可拖动区域
        joinHtmls:function(htmls,layout,preventScroll){
            return htmls.join("");
        }
    });
});
