//view的公共基类，提供的能力
//  依据配置生成界面内容
//  view嵌套，创建、加载、刷新下级view
//  启动页面内容的刷新
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "../widget/_WidgetBase",
    "../config"
],function(declare,lang,Deferred,_WidgetBase,config){
    // module:
    //      cq/app/view/_ViewBase
    
    return declare("",_WidgetBase,{
        // summary:
        //      提供公共的view加载、切换、销毁相关的接口和基本实现
        
        // viewContainerNode:domNode
        //      用于存放下级view的容器节点，在填充本view之后才被赋值
        // tags:
        //      private
        viewContainerNode:null,
        
        // subViews:object
        //      用户存放下级view的参数，view实例化时由cq/app/config初始化
        //      没有下级view时可以不设置
        subViews:null,
        
        // defaultView:string
        //      默认显示的下级view的viewId
        //      由下级view时必须设置，否则可能会出错
        defaultView:"",
        
        //toTopInfo 返回顶部按钮
            // toTopInfo:{
                // src:"",
                // iconClass:""
            // }
        toTopInfo:null,
        //autoRefresh 是否自动刷新
        autoRefresh:true,
        //refreshBeforeTop 下拉刷新
        refreshBeforeTop:false,
        // lazyOn 是否开启图片延迟加载
        // lazyOn:{cacheHeight:int}// 提前加载可见区域下的一行图片，cacheHeight值必须>=一行高度
        lazyOn:null,
        // flexbar 背景透明并浮动
        topOpacity:false,
        showView:function(road,params){
            // summary:
            //      依据view路径显示view
            //      显示自己，若由下级view，(创建)显示下级view
            //      触发对象变化的事件，刷新内容
            //      异步函数，所有的下级view都ready之后，有跟view执行resize方法，重算所有子节点的大小
            this.show();
            var callback = null,viewParam = this.viewParam = {
                road:road,
                params:params
            };
            var def = new Deferred();
            if(this.subViews){
                if(0===road.length){
                    road.push(this.defaultView);
                }
                
                var newRoad = [],viewId = road[0];
                for(var index=1;index<road.length;index++){
                    newRoad.push(road[index]);
                }
                this.onCqChanged(this,viewParam);
                if(!this.subViews[viewId].view){
                    config.createView(this.subViews[viewId],viewId,this.viewContainerNode).then(lang.hitch(this,function(view){
                        this.subViews[viewId].view = view;
                        this.subViews[viewId].view.showView(newRoad,params).then(lang.hitch(this,function(){
                            def.resolve();
                        }));
                    }));
                }else{
                    this.subViews[viewId].view.showView(newRoad,params).then(lang.hitch(this,function(){
                        def.resolve();
                    }));
                }
            }else{
                //若有配置属性autoRefresh为false则除第一次进入时不自动刷新，若为true或者未配置则自动刷新     郭周全  2017-03-09
                if(false===this.autoRefresh){
                    if(this.oldParams!==params){
                        this.oldParams = params;
                        this.onCqChanged(this,viewParam);
                    }
                }else{
                    this.onCqChanged(this,viewParam);
                }
                this.changeTitle();
                window.free();
                def.resolve();
            }
            return def;
        },
        onContentReady:function(){
            
        },
        changeTitle:function(){
            
        }
    });
});
