﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/Deferred",
    "dojo/query",
    "dijit/_WidgetBase",
    "cq/app/widget/_WidgetBase"
],function(declare,lang,array,domAttr,domClass,domConstruct,Deferred,query,_WidgetBase,cqWidgetBase){
    return declare('',[_WidgetBase,cqWidgetBase],{
        htmlTemp:'<div class="marquee {className}" id="{id}" data-dojo-type="cq/app/widget/mobile/Marquee" data-dojo-props=\'clickMethod:"{clickMethod}",showField:"{showField}",icon:"{icon}",dataProvider:"{dataProvider}",initMethod:"{initMethod}",showNum:"{showNum}",className:"{className}",direction:"{direction}",loop:"{loop}",behavior:"{behavior}",scrollamount:"{scrollamount}",scrolldelay:"{scrolldelay}",align:"{align}",height:"{height}",width:"{width}"\'></div>',
        //showNum:2,
        showField:"",
        urlField:"",
        icon:"",
        dataProvider:"",
        initMethod:"",
        clickMethod:"",
        direction:"left",//表示滚动的方向，值可以是left，right，up，down，默认为left 
        behavior:"scroll",//表示滚动的方式，值可以是scroll（连续滚动）slide（滑动一次）alternate（往返滚动） 
        loop:"",//表示循环的次数，值是正整数，默认为无限循环 
        scrollamount:6, //表示运动速度，值是正整数，默认为6 
        scrolldelay:0,  //表示停顿时间，值是正整数，默认为0，单位似乎是毫秒 
        align:"middle",//表示元素的垂直对齐方式，值可以是top，middle，bottom，默认为middle 
        //bgcolor:"",表示运动区域的背景色，值是16进制的RGB颜色，默认为白色 
        height:"",
        width:"",//表示运动区域的高度和宽度，值是正整数（单位是像素）或百分数，默认width=100% height为标签内元素的高度 
        hspace:"",
        //vspace:表示元素到区域边界的水平距离和垂直距离，值是正整数，单位是像素。
        buildRendering:function(){
            this.inherited(arguments);
            this.initNode();
            //this.cqRefresh();
            this.initEvent();
        },
        initNode:function(){
            this.mqRootNode = domConstruct.create("div",{},this.domNode);
            this.mqLeftNode = domConstruct.create("div",{},this.mqRootNode);
            this.mqRightNode = domConstruct.create("div",{"class":"marqueeRight"},this.mqRootNode);
            if(this.icon){
                this.iconNode = domConstruct.create("img",{},this.mqLeftNode); 
                this.iconNode.src = this.icon;
            }
            this.marqueeNode = domConstruct.create("marquee",{
                direction:this.direction,
                height:this.height,
                loop:this.loop,
                scrollamount:this.scrollamount,
                scrolldelay:this.scrolldelay,
                align:this.align,
                width:this.width,
                behavior:this.behavior
            },this.mqRightNode);
        },
        initData:function(){
            if(this.newsNode) {
                domConstruct.destroy(this.newsNode);    
            }
            this.newsNode =domConstruct.create("div",{},this.marqueeNode);
            if(this.dataProvider&&this.initMethod){
                if(lang.isString(this.dataProvider)){
                    require([this.dataProvider],lang.hitch(this,function(dataProvider){
                        this.dataProvider =dataProvider;
                        this.getData();
                    }));
                }else{
                    this.getData();
                }
            }
        },
        getData:function(){
            var data = this.dataProvider[this.initMethod]();
            if(data&&data.then){
                data.then(lang.hitch(this,function(dt){
                    this.createContent(dt);   
                }));
            }else{
                this.createContent(data);
            }
        },
        createContent:function(data){
            var newNode;
            var aNode;
            for(var i = 0;i<data.length;i++){
                if(this.urlField&&data[i][this.urlField]){
                    aNode = domConstruct.create("a",{href:data[i][this.urlField]||""},this.newsNode);
                    aNode.innerHTML = data[i][this.showField];
                }else{ 
                    newNode = domConstruct.create("div",{
                        "dataId":data[i]._id
                    },this.newsNode);
                    newNode.innerHTML = data[i][this.showField];
                }
                
            }
        },
        initEvent:function(){
            //onMouseOut="this.start()" ：用来设置鼠标移出该区域时继续滚动
            //onMouseOver="this.stop()"：用来设置鼠标移入该区域时停止滚动
            this.connect(this.marqueeNode,"onmouseout",function(){
                this.marqueeNode.start();
            });
            this.connect(this.marqueeNode,"onmouseover",function(){
                this.marqueeNode.stop();    
            });
            this.connect(this.marqueeNode,"onclick",function(e){
                var node = e.target;
                if(node.tagName==="A"){
                    return;
                }
                while(node&&node!==this.marqueeNode&&node.parentNode!==this.newsNode){
                    node = node.parentNode;
                }
                if(node&&node.parentNode===this.newsNode){
                    //响应点击事件
                    if(this.dataProvider&&this.clickMethod){
                        if(lang.isString(this.dataProvider)){
                            require([this.dataProvider],lang.hitch(this,function(dataProvider){
                                dataProvider[this.clickMethod]();
                                this.dataProvider = dataProvider;
                            }));
                        }else{
                            this.dataProvider[this.clickMethod]();
                        }
                    }
                }
            });
        },
        cqRefresh:function(){
            this.initData();
        }
        
        
    });
});