﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojox/mobile/SearchBox",
    "../_WidgetBase"
],function(declare,lang,domConstruct,SearchBox,_CqWidgetBase){
    var _processInput = SearchBox.prototype._processInput;
    SearchBox.prototype._processInput = function(evt){
        if(evt.keyCode===13){
            evt.charOrCode = 229;
        }
        _processInput.apply(this,arguments);
    };
    //搜索框对象，用于触发其他对象的刷新操作
    return declare("",[SearchBox,_CqWidgetBase],{
        //html模版
        htmlTemp:'<input id="{id}" placeholder="{placeholder}" type="search" class="mblTextBox mblSearchBox cq-search {className}" data-dojo-type="cq/app/widget/mobile/SearchBox" />',
        //执行初始化
        onSearch:function(){
            if(this.inputLock){
                return;
            }
            this.onCqChanged(this,this.get("value"));
        },
        buildRendering:function(){
            this.inherited(arguments);
            this.formNode = domConstruct.create("form",{
                "class": "searchboxForm"
            },this.domNode,"before");
            this.formNode.appendChild(this.domNode);
            this.formNode.onsubmit = function(){
                return false;
            };
            this.inputLock = false;
            this.connect(this.domNode,"compositionstart",lang.hitch(this,function(){
                this.inputLock = true;
            }));
            this.connect(this.domNode,"compositionend",lang.hitch(this,function(){
                this.inputLock = false;
                this.onSearch();
            }));
        },
        cqRefresh:function(){
            this.inputLock = false;
            this.inherited(arguments);
            if(this.cqRefInfo&&this.cqRefInfo.cqViewParam&&this.cqRefInfo.cqViewParam.params&&lang.isString(this.cqRefInfo.cqViewParam.params)){
                var str = this.cqRefInfo.cqViewParam.params;
                if(str.substr(0,7)==="search_"){
                    this.cqRefInfo.cqViewParam.params = str.substring(7);
                    this.textbox.value = window.decodeURIComponent(this.cqRefInfo.cqViewParam.params);
                    return this.onSearch();
                }
            }
            this.textbox.value = "";
            this.onSearch();
        }
    });
});