﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/util/sys/common"
],function(declare,lang,common){
    return declare("",null,{
        //拖动加载更多
        loadMoreData:true,
        //数据加载中的标志
        busy:false,
        buildRendering:function(){
            this.loadMoreData = false!==this.loadMoreData&&"false"!==this.loadMoreData;
            this.inherited(arguments);
            if(this.dataProvider){
                this.scrollable = this.getParentScrollable();
                if(this.scrollable){
                    //处理拖动加载更多
                    this.connect(this.scrollable,"scrollTo",this.onParentScroll);
                    this.connect(this.scrollable,"slideTo",this.onParentScroll);
                }
            }
        },
        loadMore:function(){
            var result = this.inherited(arguments);
            return result.then(lang.hitch(this,function(){
                if((!this.start)&&this.scrollable){
                    this.scrollable.slideTo({
                        x:0,
                        y:0
                    });
                }
                this.busy = false;
                if(this.enableBusy){
                    window.free();
                }
            }),lang.hitch(this,function(){
                this.busy = false;
                if(this.enableBusy){
                    window.free();
                }
            }));
        },
        onTotalReady:function(total){
            this._totalCount = total;
        },
        getParentScrollable:function(){
            var scrollable = this.getParent();
            while(scrollable&&(!scrollable.scrollTo)){
                scrollable = scrollable.getParent();
            }
            return scrollable;
        },
        onParentScroll:function(to){
            if(!common.isVisible(this.domNode)){
                return;
            }
            var afterBottom = this.scrollable.containerNode.clientHeight+to.y-this.scrollable.domNode.clientHeight;
            if(this.loadMoreData&&true!==this.busy&&this._totalCount>(this.start+this.pageSize)&&afterBottom<20&&to.y<-20){
                this.start = this.start + this.pageSize;
                this.busy = true;
                this.loadMore();
            }
        }
    });
});