﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojox/mobile/Switch"
],function(declare,lang,domClass,domStyle,Switch){
    // module:
    //      cq/app/widget/mobile/edit/CheckBox
   
    return declare("",[Switch],{    
        // summary:
        //      所有复选框的编辑页面方式
        
        // htmlTemp:String
        //      复选框的html片段
        htmlTemp:'<div class="cq-form-checkbox cq-field-input" data-dojo-type="cq/app/widget/mobile/edit/CheckBox" data-dojo-props="label:\'\',field:\'{field}\',canEdit:\'{canEdit}\',selected:\'{selected}\'"></div>',
        // field:String
        //      复选框的字段名
        field:"",
        // canEdit:boolean
        //      控制复选框是否可以编辑的字段
        canEdit:"",
        
        selected:false,
        
        buildRendering:function(){
            this.inherited(arguments);
            this.leftLabel = "  ";
            this.rightLabel = "  ";
            this.selected = this.selected===true||this.selected==="true";
            domStyle.set(this.domNode,"z-index",1);
        },
        setCanEdit:function(canEdit){
            // summary:
            //      根据canEdit字段的值来设置复选框是否可以编辑
            this.disabled = false===canEdit;
        },
        
        //点击
        onClick:function(){
            // summary:
            //      点击复选框时触发，如果复选框不可编辑则返回，
            if(this.disabled){
                return false; 
            }
            return this.inherited(arguments);
        },
        
        //手机端滑动
        onTouchStart:function(){
            if(this.disabled){
                return false;
            }
            return this.inherited(arguments);
        },
        onTouchMove:function(){
            if(this.disabled){
                return false;
            }
            return this.inherited(arguments);
        },
        onTouchEnd:function(){
            if(this.disabled){
                return false;
            }
            return this.inherited(arguments);
        },
        getValue:function(){
            // summary:
            //      获取所有被选中的复选框的值
            return this.get("value")==="on";
        },
        setValue:function(value){
            // summary:
            //      为复选框设定是否被选中
            if(value===true||value==="true"){
                this.set("value","on");
            }else if(value==="false"||false===value){
                this.set("value","off");
            }else{
                this.setValue(this.selected);
            }
        },
        onStateChanged:function(){
            // summary:
            //      当复选框的状态改变时触发，提供外部使用
            this.onFieldChanged(this,this.field,this.getValue());
        },
        onFieldChanged:function(widget,field,value){
            // summary:
            //      字段变化后触发，本身不做任何操作，提供外部使用
        },
        startup:function(){
            this.inherited(arguments);
            this.setCanEdit(this.canEdit);
        }
    });
});