﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "cq/app/widget/show/DeadLine"
],function(declare,lang,domConstruct,DeadLine){
    return declare("",[DeadLine],{
        // summary:
        //      倒计时编辑器
        
        //编辑器的DOM结构模版
        htmlTemp:'<div id="{id}" class="cq-form-DateLine cq-field-input" data-dojo-type="cq/app/widget/mobile/edit/DateLineEditor" data-dojo-props="field:{field}"></div>',
        
        //字段名，绑定的是两个字段 提示信息 结束时间 对应数据的字段名
        //字段：
        //  label
        //      提示信息
        //  endTimer
        //      结束时间
        field:"",
        
        buildRendering:function(){
            //获取数据所对应的字段名
            this.fields = this.field.split(",");
            this.inherited(arguments);
            this.createProNode();
        },
        //获取数据
        getValue:function(){
            return this.value;
        },
        // 设置数据
        setValue:function(value){
            this.value = value;
            if(this.value.length===2){
                this.title = this.value[0];
                this.date = this.value[1];
            }
            this.setDeadLine(this.date||"");
            this.showPNode.innerHTML = this.title||"";
        },
        
        // 创建提示信息节点
        createProNode:function(){
            this.showPNode = domConstruct.create("span",{},this.domNode,"first");
            this.connect(this,"timeEnd",lang.hitch(this,function(){
                this.parentNode = this.getParentDataLayout(this);
                this.parentNode.cqRefresh();
            }));
        },
        //获取上级DataLayout
        getParentDataLayout:function(node){
            while(!node.isDataLayout){
                node = node.getParent();
            }
            return node;
        }
    });
});