﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/event",
    "dojo/Deferred",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/touch",
    "dojox/mobile/ListItem",
    "cq/util/image/blob",
    "cq/util/sys/userAgent"
],function(declare,lang,event,Deferred,domAttr,domClass,domConstruct,touch,ListItem,blob,userAgent){
    var fileSelectInput,local;
    var createFileInput = function(){
        if(fileSelectInput&&fileSelectInput.parentNode){
            fileSelectInput.parentNode.removeChild(fileSelectInput);
        }
        fileSelectInput = domConstruct.create("input",{
            type:"file",
            style:"display:none"
        },document.body);
        fileSelectInput.onchange = function(){
            local.onImgChange();
        };
    };
    local = {
        onImgChange:function(){
            this.def.resolve(fileSelectInput);
            createFileInput();
        },
        selectFile:function(){
            var def = this.def = new Deferred();
            fileSelectInput.click();
            return def;
        }
    };
    createFileInput();
    return declare("",[ListItem],{
        htmlTemp:'<li id="{id}" data-cq-field="{field}" class="cq-field-input cq-form-fileEditor" data-dojo-type="cq/app/widget/mobile/edit/FileEditor" data-dojo-props=\'labelText:"{label}",canEdit:"{canEdit}",field:"{field}",value:{j:value}\'></li>',
        field:"",
        labelText:"",
        canEdit:true,
        value:null,
        // 初始化组件
        buildRendering:function(){
            this.label = this.labelText;
            this.canEdit = this.canEdit!==false&&this.canEdit!=="false";
            this.inherited(arguments);
            this.downLoadLabel = domConstruct.create("a",{
                style:"display:none;"
            });
            this.setValue(this.value);
            this.setCanEdit(this.canEdit);
            this.bindEvent();
        },
        // 设置可否编辑
        // param:
        //      canEdit:true为可编辑，上传文件。
        //              false为不可编辑，下载文件。
        setCanEdit:function(canEdit){
            this.canEdit = canEdit!==false&&canEdit!=="false";
            this.set("rightText",this.canEdit?"选择文件":"下载");
            //this.bindEvent();
        },
        // get
        getValue:function(){
            return this.value;
        },
        // set
        setValue:function(value){
            this.value = value;
			this.bindDataSource(this.value);
            this.onFiledChanged(this,this.field,this.value);
        },
        onFiledChanged:function(widget,field,value){
            
        },
        //绑定组件数据
        bindDataSource:function(value){
            this.set("label",this.labelText+":"+(value.title||""));
            domAttr.set(this.downLoadLabel,"href",(value.url||"javascript:void(0)"));
            domAttr.set(this.downLoadLabel,"download",(value.title||""));
        },
        
        //绑定事件
        
        bindEvent:function(){
            // this.connect(this.domNode,"onclick",lang.hitch(this,function(){
                // if(this.canEdit){
                    // this.upLoadFile();
                // }else{
                    // this.downLoadFile();
                // }
            // }));
            this.own(touch.release(this.domNode,lang.hitch(this,function(){
                if(this.canEdit){
                    this.upLoadFile();
                }else{
                    this.downLoadFile();
                }
            })));
        },
        
        // 注册文件上传事件
        /* upLoadFile2:function(){
            // 创建一个input 用于触发文件上传事件
            var fileSelectInput = domConstruct.create("input",{
                "class":"none",
                //multiple:"multiple",
                type:"file",
                display:"none"
            },document.body);
            fileSelectInput.click();
            fileSelectInput.onchange = lang.hitch(this,function(){
                blob.upload(fileSelectInput).then(lang.hitch(this,function(data){
                    if(data.items){
                        this.value ={
                            title:data.items[0].originName,
                            url:data.items[0].uri
                        };
                    }
                    this.setValue(this.value);
                    this.onFieldChanged(this,this.field,this.value);
                    if(fileSelectInput.parentNode){
                        fileSelectInput.parentNode.removeChild(fileSelectInput);
                    }
                }));
            });
        }, */
        // 文件上传在微信端onchange事件触发时文件并未传入的问题   郭周全 2017/04/01
        upLoadFile:function(){
            local.selectFile().then(lang.hitch(this,function(){
                blob.upload(fileSelectInput).then(lang.hitch(this,function(data){
                    if(data.items){
                        this.value ={
                            title:data.items[0].originName,
                            url:data.items[0].uri
                        };
                    }
                    this.setValue(this.value);
                    this.onFieldChanged(this,this.field,this.value);
                    if(fileSelectInput.parentNode){
                        fileSelectInput.parentNode.removeChild(fileSelectInput);
                    }
                }));
            }));
        },
        // 注册文件下载事件
		downLoadFile:function(){
            if(userAgent.isMobile()){
                alert("暂不支持下载！");
                return;
            }
            this.downLoadLabel.click();
        }
    });
});