define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojo/dom-class",
    "dojo/dom-attr",
    "dojo/dom-construct",
    "dojo/query",
    "dojo/_base/array",
    "dojox/mobile/ListItem",
    "dojox/mobile/EdgeToEdgeList",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojo/store/JsonRest",
    "cq/util/image/blob",
    "dojox/mobile/ScrollablePane",
    "cq/app/widget/mobile/TplList",
    "cq/util/edit/overlay",
    "dojo/topic"
], function (declare,lang,domStyle,domClass,domAttr,domConstruct,query,array,ListItem,EdgeToEdgeList,EdgeToEdgeStoreList,JsonRest,blob,ScrollablePane,TplList,overlay,topic) {
    return declare("cq.app.widget.mobile.edit.Ref", [ListItem], {
        htmlTemp: '<li id="{id}" data-cq-field="{field}"  class="cq-field-input cq-form-imageRef cq-form-img li-icon" data-dojo-type="cq/app/widget/mobile/edit/ImageRef" data-dojo-props="query:{query},field:\'{field}\',pageSize:\'{pageSize}\',label:\'{label}\',targetMethod:\'{targetMethod}\',dataProvider:\'{dataProvider}\',tagTargetMethod:\'{tagTargetMethod}\',tagDataProvider:\'{tagDataProvider}\',multiselect:\'{multiselect}\',showType:\'{showType}\',showTags:\'{showTags}\',searchParams:\'{searchParams}\',addMaterial:\'{addMaterial}\'"></li>',
        field:"",
        dataProvider:"",
        tagDataProvider:"",
        tagTargetMethod:"",
        targetMethod:"",
        pageSize:20,
        start:0,
        multiselect:"",
        searchParams: {},
        clickable:true,
        query:null,
        showTags:true,
        showType:"",
        addMaterial:false,
        buildRendering:function(){
            this.inherited(arguments);
            var _this = this;
            if(lang.isString(this.tagDataProvider)){
                require([this.tagDataProvider], function(tagDataProvider){
                    _this.tagDataProvider = tagDataProvider;
                });
            }
            if(lang.isString(this.dataProvider)){
                require([this.dataProvider], function(dataProvider){
                    _this.dataProvider = dataProvider;
                });
            }
        },
        onClick:function(viewNode){
            var _this = this;
            this.inherited(arguments);
            this.view = null;
            if(!this.view){
                var view = this.getParent();
                while(view){
                    if(!view.show){
                        view = view.getParent();
                    }else{
                        break;
                    }
                }
                this.view = view;
            }
            // 点击打开图片选择界面
            if(!this.selectView){
                this.selectView = new ScrollablePane({
                    className:"imageref"
                });
                this.view.addChild(this.selectView);
                this.view.startup();
                // 隐藏当前界面
                domClass.add(this.view.getChildren()[0].domNode, "none");
                domStyle.set(this.selectView.domNode, {
                    width:"100%",
                    height:"100%"
                });
                // 添加顶部确定取消按钮
                var top = domConstruct.create("div", {
                    style:"height:45px;width:100%"
                });
                var cancel = domConstruct.create("span", {
                    className:"mblToolBarButton mblToolBarButtonBody mblToolBarButtonLightIcon float-left mblColorDefault",
                    style:"float:left;",
                    innerHTML:'<div><div title="" class="mblDomButtonGrayCross mblDomButton"><div><div></div></div></div></div>'
                }, top);
                this.connect(cancel, "onclick", function(evt){
                    // 隐藏选择界面，并且显示当前界面
                    domClass.remove(this.view.getChildren()[0].domNode, "none");
                    domClass.add(this.selectView.domNode, "none");
                    domStyle.set(_this.selectView.domNode, {
                        height:"0px"
                    });
                    _this.view.resize();
                });
                if(_this.addMaterial){
                    var confirm = domConstruct.create("span", {
                        className:"mblToolBarButton mblColorDefault mblToolBarButtonBody mblToolBarButtonLightText mblToolBarButtonText menu-item addbutton",
                        innerHTML:'+',
                        style:"float:right;"
                    }, top);
                    this.connect(confirm, "onclick", function(evt){
                        window.moveToView("addMaterial1");
                        var handler = topic.subscribe("userImage/material/addMaterial", function(data){
                            domClass.remove(_this.view.getChildren()[0].domNode, "none");
                            domClass.add(_this.selectView.domNode, "none");
                            // _this.setValue(data.bgSrc);
                            handler.remove();
                        });
                    });
                }
                this.selectView.containerNode.appendChild(top);
                // 如果显示标签，添加标签列表
                if(this.showTags&&this.tagDataProvider&&this.tagTargetMethod){
                    if(lang.isString(this.tagTargetMethod)){
                        _this.createTagPane(_this.tagDataProvider, _this.tagTargetMethod, 0);
                    }else{
                        for(var index = 0;index < _this.tagTargetMethod.length;index++){
                            _this.createTagPane(_this.tagDataProvider, _this.tagTargetMethod[index], index);
                        }
                    }
                    // 图片列表
                    this.imageList = new EdgeToEdgeList({
                        className:"mblEdgeToEdgeList cq-list " + (_this.showType=="waterfall"?"waterfall":"")
                    });
                    this.selectView.containerNode.appendChild(this.imageList.domNode);
                    this.imageList.startup();
                    this.busy = true;
                    this.dataProvider[this.targetMethod]({start:0,count:_this.pageSize}).then(function(result){
                        if(result&&result.data&&result.data.ok){
                            _this.start = 0;
                            _this.end = _this.start + result.data.items.length;
                            for(var index = 0;index < result.data.items.length;index++){
                                item = new ListItem({
                                    className:"waterfallItem"
                                });
                                _this.imageList.addChild(item);
                                item.set("value", result.data.items[index]);
                                item.domNode.innerHTML = '<div class="waterfallItem-content"><img class="waterfallItem-img" src="' + result.data.items[index].bgSrc + '"></div>';
                            }
                        }
                        _this.busy = false;
                    });
                    this.connect(this.imageList.domNode, "onclick", function(evt){
                        var target = evt.target;
                        if(domClass.contains(target, "cq-list")){
                            return;
                        }
                        while(!domClass.contains(target, "waterfallItem")){
                            target = target.parentNode;
                        }
                        domClass.remove(_this.view.getChildren()[0].domNode, "none");
                        domClass.add(_this.selectView.domNode, "none");
                        // 获取选中的图片并且设置value
                        // TODO
                        var checkedNode = dijit.registry.byNode(target);
                        if(checkedNode){
                            var pa = _this.getParent();
                            while(!domClass.contains(pa.domNode, "cq-area")){
                                pa = pa.getParent();
                            }
                            var data = pa.getData();
                            var value = checkedNode.get("value");
                            data[_this.field] = value.bgSrc;
                            pa.setData(data);
                            _this.onFieldChanged(pa, _this.field, value.bgSrc);
                        }
                    });
                    this.connect(this.selectView, "scrollTo", this.onScrollTo);
                    this.connect(this.selectView, "slideTo", this.onScrollTo);
                }
            }else{
                domClass.add(this.view.getChildren()[0].domNode, "none");
                domClass.remove(this.selectView.domNode, "none");
                domStyle.set(this.selectView.domNode, {
                    height:"100%"
                });
            }
        },
        createTagPane:function(dataProvider, targetMethod, index){
            var _this = this;
            this.tagListArray = this.tagListArray||[];
            _this["tagPane" + index] = new ScrollablePane({
                className:"mblScrollablePane cq-Rowlist",
                scrollDir:"h"
            });
            _this["tagPane" + index].height = "40";
            _this["tagPane" + index].weight = 0;
            _this["tagPane" + index].scrollBar = false;
            _this["tagPane" + index].resize = function(){
                // this.inherited(arguments);
                this.labelItems = [];
                this.labelItems = query(".list-label-item",this.domNode);
                this.realWidth=0;
                if(this.labelItems.length>0){
                    for(var i=0;i<this.labelItems.length;i++){
                        this.realWidth += (
                            domStyle.get(this.labelItems[i],"width")+
                            domStyle.get(this.labelItems[i],"marginLeft")+
                            domStyle.get(this.labelItems[i],"marginRight")+
                            domStyle.get(this.labelItems[i],"borderLeftWidth")+
                            domStyle.get(this.labelItems[i],"borderRightWidth"));
                    }
                }
                domStyle.set(this.containerNode,"minWidth","100%");
                domStyle.set(this.containerNode,"width",this.realWidth+"px");
                this.width = domStyle.get(this.domNode,"width");
                this.containerWidth = domStyle.get(this.containerNode,"width");
                if(this.width>this.containerWidth){
                    this.cleanup();
                    this.noScroll = true;
                }else{
                    if(this.noScroll){
                        this.init();
                        this.noScroll = false;
                    }
                }
            };
            _this.selectView.containerNode.appendChild(_this["tagPane" + index].domNode);
            _this["tagPane" + index].startup();
            domStyle.set(_this["tagPane" + index].domNode, {
                height:"40px"
            });
            _this["tagList" + index] = new EdgeToEdgeList({
                variableHeight:true,
                className:"mblEdgeToEdgeList cq-list no-margin-top hflex-tab"
            });
            _this.tagListArray.push(_this["tagList" + index]);
            _this["tagPane" + index].containerNode.appendChild(_this["tagList" + index].domNode);
            _this["tagList" + index].startup();
            dataProvider[targetMethod]().then(function(result){
                if(result&&result.data&&result.data.ok){
                    _this["tagPane" + index].items = result.data.items;
                    domConstruct.create("div", {
                        className:"list-label-item h-center row-list-item selected",
                        innerHTML:"全部",
                        style:"display: inline-block; margin: 0px 10px;"
                    }, _this["tagList" + index].domNode);
                    for(var i = 0;i < result.data.items.length;i++){
                        domConstruct.create("div", {
                            className:"list-label-item h-center row-list-item",
                            innerHTML:result.data.items[i].tag,
                            style:"display: inline-block; margin: 0px 10px;",
                            tagId:result.data.items[i]._id
                        }, _this["tagList" + index].domNode);
                    }
                    _this["tagPane" + index].resize();
                }
            });
            this.connect(_this["tagList" + index].domNode, "onclick", function(evt){
                var target = evt.target;
                if(domClass.contains(target, "mblEdgeToEdgeList")){
                    return;
                }
                if(domClass.contains(target, "selected")){
                    return;
                }
                var listNode = target.parentNode;
                domClass.remove(query(".selected", listNode)[0], "selected");
                domClass.add(target, "selected");
                _this.imageList.destroyDescendants();
                _this.busy = true;
                var tag = [];
                for(var ii = 0;ii < _this.tagListArray.length;ii++){
                    var node = query(".selected", _this.tagListArray[ii].domNode)[0];
                    var id = domAttr.get(node, "tagid")||0;
                    if(id){
                        tag.push(id);
                    }
                }
                _this.dataProvider[_this.targetMethod]({start:0,count:_this.pageSize,tag:tag}).then(function(result){
                    if(result&&result.data&&result.data.ok){
                        _this.start = 0;
                        _this.end = _this.start + result.data.items.length;
                        for(var index = 0;index < result.data.items.length;index++){
                            item = new ListItem({
                                className:"waterfallItem"
                            });
                            _this.imageList.addChild(item);
                            item.set("value", result.data.items[index]);
                            item.domNode.innerHTML = '<div class="waterfallItem-content"><img class="waterfallItem-img" src="' + result.data.items[index].bgSrc + '"></div>';
                        }
                    }
                    _this.busy = false;
                });
            });
        },
        onScrollTo:function(to){
            var afterBottom = this.selectView.containerNode.clientHeight+to.y-this.selectView.domNode.clientHeight;
            if(afterBottom < 20&&to.y<-20&&true != this.busy){
                this.loadMore();
            }
        },
        loadMore:function(){
            this.busy = true;
            _this = this;
            this.start = this.end||0;
            this.dataProvider[this.targetMethod]({start:_this.start,count:_this.pageSize}).then(function(result){
                if(result&&result.data&&result.data.ok){
                    _this.end = _this.start + result.data.items.length;
                    for(var index = 0;index < result.data.items.length;index++){
                        item = new ListItem({
                            className:"waterfallItem"
                        });
                        _this.imageList.addChild(item);
                        item.set("value", result.data.items[index]);
                        item.domNode.innerHTML = '<div class="waterfallItem-content"><img class="waterfallItem-img" src="' + result.data.items[index].bgSrc + '"></div>';
                    }
                }
                _this.busy = false;
            });
        },
        getValue:function(){
            return this.get("value");
        },
        setValue:function(value){
            this.set("value", value);
            this.set("rightIcon2",blob.getImageUrl(value,"80")||"");
            if(this.rightIcon2Node){
                domStyle.set(this.rightIcon2Node,{
                    "min-width":"36px",
                    border:"1px solid gray"
                });
            }
        },
        onFieldChanged: function (widget, field, value) {}
    });
});