﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/event",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/touch",
    "dojox/mobile/IconContainer",
    "dojox/mobile/IconItem",
    "dojox/mobile/_EditableIconMixin",
    "cq/util/image/blob",
    "cq/widgets/bigImg"
],function(declare,lang,array,event,domClass,domStyle,touch,IconContainer,IconItem,_EditableIconMixin,blob,bigImg){
    //列表选项，呈现为一个ListItem，内容显示在右侧
    return declare("",[IconContainer],{
        htmlTemp:'<ul class="cq-form-imgs cq-field-input no-shake" data-dojo-type="cq/app/widget/mobile/edit/Images" data-dojo-props=\'multiple:"{multiple}",sizeType:"{sizeType}",canEdit:"{canEdit}",field:"{field}",label:"{label}",size:{j:size},isSetLabel:{isSetLabel},maxImages:"{maxImages}"\'></ul>',
        field:"",
        label:"",
        size:{},
        //默认为压缩
        sizeType:"",
        isSetLabel:true,
        canEdit:true,
        editable:true,
        //图片数量限制
        maxImages:"",
        //一次性上传多张图片,默认为一次传一张
        workMode:false,
        //初始化内容
        buildRendering:function(){
            this.canEdit = this.canEdit!==false&&this.canEdit!=="false";
            this.isSetLabel = this.isSetLabel!==false&&this.isSetLabel!=="false";
            this.inherited(arguments);
            var size = {};
            if(this.size.width||this.size.height){
            }else{
                this.size = {width:640,height:480};
            }
            this.addItem = new IconItem({
                editable : false,
                onClick:function(){
                    return false;
                },
                innerHTML :"<div class='mblIconArea'><div class='mblIconAreaInner add-image' onclick=''>+<form action='/biz/blob/blob/upload'><input class='hidden-file-input' type='file'/></form></div></div>"
            });
        },
        
        //是否可以编辑改为异步的，startEdit是一个异步方法
        _deferDisabled:function(){
            this.isEditing = !this.canEdit;
            if(this.canEdit){
                this.startEdit();
            }else{
                this.endEdit();
            }
        },
        _editableDefer:null,
        setCanEdit:function(canEdit){
            this.canEdit=canEdit!==false&&canEdit!=="false";
            if(this.rightIconNode){
                domStyle.set(this.rightIconNode,"opacity",this.canEdit?1:0);
            }
            if(this._editableDefer){
                this._editableDefer.remove();
            }
            this._editableDefer = this.defer(this._deferDisabled,100);
        },
        postCreate:function(){
            this.inherited(arguments);
            this.connect(this,"startEdit",function(){
                this.addChild(this.addItem);
            });
            //this.addItem.domNode.addEventListener("click",lang.hitch(this,this.onAddImage));
            // 防止滑动时触发上传图片事件  郭周全  2017/04/25
            this.own(touch.press(this.domNode,lang.hitch(this,function(e){
				
                this._touchPos = {
                    x:e.touches&&e.touches[0]?e.touches[0].pageX:e.pageX,
                    y:e.touches&&e.touches[0]?e.touches[0].pageY:e.pageY
                };
            })));
            this.own(touch.release(this.addItem.domNode,lang.hitch(this,function(e){
                 var pos = {
                    x:e.pageX,
                    y:e.pageY
                };
                if(!this.canEdit||(this._touchPos&&(Math.abs(this._touchPos.x-pos.x)>10||Math.abs(this._touchPos.y-pos.y)>10))){
                    return;
                }
                this.onAddImage()
            })));
            if(this.canEdit){
                this.startEdit();
            }
            var endEdit = this.endEdit;
            this.endEdit = function(){
                this._removeAddItem();
                return endEdit.apply(this,arguments);
            };
        },
        onAddImage:function(e){
            if(!this.canEdit){
                return;
            }
            
            blob.selectAndUpload(this.size,0.7,this.sizeType,this.multiple).then(lang.hitch(this,function(data){
                if(data.length){
                    for(var i=0;i<data.length;i++){
                        this.createIcon(data[i][1]);
                    }
                }else if(data.items && data.items.length == 1){
                    this.createIcon(data);                 
                }
            }));
        },
        createIcon:function(data){
            var newIcon = new IconItem({
                icon : blob.getImageUrl(data.items[0].uri,"160"),
                originalIcon:data.items[0].uri,
                label : this.isSetLabel?(this.getChildren().length == 1?"主图":"细节图"):"",
                onClick:lang.hitch(this,this.onClickIcon)
            });
            this.endEdit();
           
            this.addChild(newIcon);
            this.startEdit();
            this.onFieldChanged(this,this.field,this.getValue());
            if(this.maxImages&&(this.getValue().length>=this.maxImages)){
                this.addItem.domNode.style.display="none";
            }else{
                this.addItem.domNode.style.display="";
            } 
        },
        //设置内容
        getValue:function(){
            return array.map(array.filter(this.getChildren(),function(item){
                return item!==this.addItem;
            },this),function(item){
                return item.originalIcon;
            });
        },
        //更新内容
        setValue:function(value){
            this.set("value",value);
            //刷新显示
            this.endEdit();
            var items = this.getChildren();
            while(items.length){
                items.pop().destroyRecursive();
            }
            for(var index=0;index<value.length;index++){
                var icon = new IconItem({
                    icon : blob.getImageUrl(value[index],"160"),
                    originalIcon:value[index],
                    label : this.isSetLabel?(index == 0?"主图":"细节图"):"",
                    onClick:lang.hitch(this,this.onClickIcon)
                });
                /* if(this.isSetLabel){
                    icon.set("label",index == 1?"主图":"细节图");    
                } */
                
                this.addChild(icon);
            }
            if(this.canEdit){
                this.startEdit();
            }
            
        },
        onItemClick:function(){
            return false;
        },
        scaleItem:function(movingItem, scale){
            if(scale>1){
                this._removeAddItem();
            }
        },
        _removeAddItem:function(){
            var node = this.addItem&&this.addItem.domNode;
            if(node&&node.parentNode){
                node.parentNode.removeChild(node);
            }
        },
        onMoveItem:function(){
            this.inherited(arguments);
            this._refreshItem();
        },
        _refreshItem:function(){
            array.forEach(this.getChildren(),function(item,index){
                item.set("label",this.isSetLabel?(index===0?"主图":"细节图"):"");
            });
            this.addChild(this.addItem);
            this.onFieldChanged(this,this.field,this.getValue());
        },
        removeChild:function(){
            this.inherited(arguments);
            this._refreshItem();
            if(this.maxImages&&(this.getValue().length>=this.maxImages)){
                this.addItem.domNode.style.display="none";
            }else{
                this.addItem.domNode.style.display="";
            }
        },
        onFieldChanged:function(widget,field,value){
            
        },
        onClickIcon:function(e){
            if(!this.canEdit){
                var clickIcon = e.target;
                var icons =  this.getChildren();
                var first = 0;
                var iconsSrc = [];
                for(var i=0;i<icons.length;i++){
                    if(icons[i].iconNode ===clickIcon ){
                        first = i;
                    }
                    iconsSrc[i] = {src:icons[i].originalIcon}
                }
                bigImg.show(iconsSrc,first);
                domStyle.set(clickIcon,"opacity","1");
                return false;    
            }
            
        }
    });
});