﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojox/mobile/ListItem",
    "bob/article/userImage/material/c",
    "bob/article/travelTag/c",
    "cq/util/edit/overlay",
    "dojo/dom-construct",
    "dojo/dom-class",
    "dojo/query",
    "dojox/mobile/ScrollablePane"
],function(declare,lang,domStyle,ListItem,MaterialC,TravelC,overlay,domConstruct,domClass,query,ScrollablePane){
    return declare("",[ListItem],{
        htmlTemp:'<li class="cq-form-materialTags cq-field-input" data-dojo-type="cq/app/widget/mobile/edit/MaterialTags" data-dojo-props=\'field:"{field}",label:"{label}",icon:"{icon}",rightText:"{rightText}"\'></li>',
        field:"",
        targetView:"",
        clickable:true,
        buildRendering:function(){
            this.inherited(arguments);
            var did = window.location.hash.split("-")[1];
        },
        setValue:function(value){
            this.value = value;
            domStyle.set(this.rightIconNode,"opacity",1);
            var rightText = "";
            for(var index = 0;index < value.length;index++){
                rightText += value[index].tag + ",";
            }
            rightText = rightText&&rightText.substr(0,rightText.length - 1)||"";
            this.set("rightText",rightText);
        },
        onClick:function(){
            var _this = this;
            if(!this.showView){
                this.showView = domConstruct.create("div", {
                    style:"width:100%;height:100%;"
                });
                var top = domConstruct.create("div", {
                    style:"width:100%;height:45px;"
                }, this.showView);
                var cancel = domConstruct.create("span", {
                    className:"mblToolBarButton mblToolBarButtonBody mblToolBarButtonLightIcon float-left mblColorDefault",
                    style:"float:left;",
                    innerHTML:'<div><div title="" class="mblDomButtonGrayCross mblDomButton"><div><div></div></div></div></div>'
                }, top);
                var confirm = domConstruct.create("span", {
                    className:"mblToolBarButton mblColorDefault mblToolBarButtonBody mblToolBarButtonLightText mblToolBarButtonText float-right cq-btn-dark",
                    innerHTML:'确定',
                    style:"float:right;"
                }, top);
                this.connect(cancel, "onclick", function(){
                    overlay.hide();
                });
                this.connect(confirm, "onclick", function(){
                    overlay.hide();
                    var selectedTags = query(".selected", this.tagList);
                    var value = [];
                    for(var index = 0;index < selectedTags.length;index++){
                        value.push({
                            _id:selectedTags[index].id,
                            tag:selectedTags[index].innerHTML
                        });
                    }
                    var p = this.getParent();
                    while(!domClass.contains(p.domNode, "cq-area")){
                        p = p.getParent();
                    }
                    var data = p.getData();
                    data.tags = value;
                    p.setData(data);
                });
                this.tagList = domConstruct.create("div", {
                    className:"tagList"
                }, this.showView);
                this.connect(this.tagList, "onclick", function(evt){
                    if(domClass.contains(evt.target,"tagItem")){
                        if(domClass.contains(evt.target,"selected")){
                            domClass.remove(evt.target,"selected");
                        }else{
                            domClass.add(evt.target,"selected");
                        }
                    }
                });
                TravelC.load({type:[3]}).then(function(result){
                    if(result&&result.data&&result.data.items){
                        var scrollPane = new ScrollablePane({
                            scrollDir:"h",
                            height:"40px"
                        });
                        scrollPane.placeAt(_this.tagList);
                        domStyle.set(scrollPane.domNode, {
                            height:"40px"
                        });
                        var cont = domConstruct.create("div", {
                            style:"height:40px;"
                        }, scrollPane.containerNode);
                        var sps = [];
                        _this.count1 = cont;
                        for(var index = 0;index < result.data.items.length;index++){
                            var sp = domConstruct.create("div", {
                                className:"tagItem",
                                innerHTML:result.data.items[index].tag,
                                id:result.data.items[index]._id
                            }, cont);
                            sps.push(sp);
                        }
                        _this.sps1 = sps;
                        scrollPane.startup();
                    }
                }).then(function(){
                    TravelC.load({type:[4]}).then(function(result){
                        if(result&&result.data&&result.data.items){
                            var scrollPane = new ScrollablePane({
                                scrollDir:"h",
                                height:"40px"
                            });
                            scrollPane.placeAt(_this.tagList);
                            scrollPane.startup();
                                
                            domStyle.set(scrollPane.domNode, {
                                height:"40px"
                            });
                            var cont = domConstruct.create("div", {
                                style:"height:40px;"
                            }, scrollPane.containerNode);
                            var sps = [];
                            _this.count2 = cont;
                            for(var index = 0;index < result.data.items.length;index++){
                                var sp = domConstruct.create("span", {
                                    className:"tagItem",
                                    innerHTML:result.data.items[index].tag,
                                    id:result.data.items[index]._id
                                }, cont);
                                sps.push(sp);
                            }
                            _this.sps2 = sps;
                        }
                    }).then(function(){
                        TravelC.load({type:[5]}).then(function(result){
                            if(result&&result.data&&result.data.items){
                                var scrollPane = new ScrollablePane({
                                    scrollDir:"h",
                                    height:"40px"
                                });
                                scrollPane.placeAt(_this.tagList);
                                scrollPane.startup();
                                        
                                domStyle.set(scrollPane.domNode, {
                                    height:"40px"
                                }); 
                                var cont = domConstruct.create("div", {
                                    style:"height:40px;"
                                }, scrollPane.containerNode);
                                var sps = [];
                                _this.count3 = cont;
                                for(var index = 0;index < result.data.items.length;index++){
                                    var sp = domConstruct.create("span", {
                                        className:"tagItem",
                                        innerHTML:result.data.items[index].tag,
                                        id:result.data.items[index]._id
                                    }, cont);
                                    sps.push(sp);
                                }
                                _this.sps3 = sps;
                                overlay.showElement(_this.showView);
                                
                                var width = 0;
                                for(var index = 0;index < _this.sps1.length;index++){
                                    width += _this.sps1[index].offsetWidth 
                                        + domStyle.get(_this.sps1[index], "paddingLeft")
                                        + domStyle.get(_this.sps1[index], "paddingRight");
                                }
                                domStyle.set(_this.count1, {
                                    width : width + "px"
                                });
                                width = 0;
                                for(var index = 0;index < _this.sps2.length;index++){
                                    width += _this.sps2[index].offsetWidth
                                        + domStyle.get(_this.sps2[index], "paddingLeft")
                                        + domStyle.get(_this.sps2[index], "paddingRight");
                                }
                                domStyle.set(_this.count2, {
                                    width : width + "px"
                                });
                                width = 0;
                                for(var index = 0;index < _this.sps3.length;index++){
                                    width += _this.sps3[index].offsetWidth
                                        + domStyle.get(_this.sps3[index], "paddingLeft")
                                        + domStyle.get(_this.sps3[index], "paddingRight");
                                }
                                domStyle.set(_this.count3, {
                                    width : width + "px"
                                });
                            }
                        });
                    });
                });
            }else{
                var selectedTags = query(".selected", this.tagList);
                for(var index = 0;index < selectedTags.length;index++){
                    domClass.remove(selectedTags[index], "selected");
                }
                overlay.showElement(this.showView);
            }
        },
        onFieldChanged:function(widget,field,value){
            console.log(arguments);
            window.a = arguments;
        },
        getChangeField:function(data){
            var datas =[];
            if(data.indexOf("{")!==-1){
                var startIndex = data.indexOf("{");
                var endIndex = data.indexOf("}");
                datas.push(data.slice(startIndex+1,endIndex));
            }
            return datas;
        }
    });
});