define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/dom-class",
    "dojo/dom-attr",
    "dojo/_base/event",
    "dojo/touch",
    "dojo/Deferred",
    "dijit/registry",
    "dojox/mobile/ListItem",
    "dojox/mobile/View",
    "cq/app/widget/web/DataLayout",
    "cq/util/edit/overlay",
    "cq/bo/BoBase",
    "cq/app/widget/mobile/edit/District"
],function(declare,lang,domConstruct,domStyle,domClass,domAttr,event,touch,Deferred,registry,ListItem,View,DataLayout,overlay,BoBase,district){
    return declare("",[ListItem],{
        //htmlTemp:'<li class="cq-form-objeditor cq-field-input" data-dojo-type="cq/app/widget/mobile/edit/ObjEditor" data-dojo-props=\'fields:{j:fields},rightTextField:"{rightTextField}",labelField:"{labelField}",dataProvider:"{dataProvider}",canEdit:"{canEdit}",field:"{field}",label:"{label}",multipDataProvider:"{multipDataProvider}",multipReloadMethond:"{multipReloadMethod}",userDefinedValue:"{userDefinedValue}"\'></li>',
        htmlTemp:'<li class="cq-form-objeditor cq-field-input {className}" data-dojo-type="cq/app/widget/mobile/edit/ObjEditor" data-dojo-props=\'fields:{j:fields},rightTextField:"{rightTextField}",labelField:"{labelField}",dataProvider:"{dataProvider}",canEdit:"{canEdit}",field:"{field}",label:"{label}",reloadMethod:"{reloadMethod}",fieldChangeMethod:"{fieldChangeMethod}",userDefinedValue:"{userDefinedValue}"\'></li>',
        field:"",
        fields:{},
        label:"",
        labelField:"",
        rightTextField:"",
        clickable:true,
        canEdit:true,
        dataProvider:"",
        labelMethod:"",
        
        //多字段编辑时
        userDefinedValue:"",
        reloadMethod:"",
        fieldChangeMethod:"",
        
        getObjLabel:function(field, data){
            if(this.dataProvider){
                if(lang.isString(this.dataProvider)){
                    var def = new Deferred();
                    require([this.dataProvider], lang.hitch(this, function(dataProvider){
                        this.dataProvider = dataProvider;
                        var dt = this.dataProvider[this.labelMethod](field, data);
                        if(dt&&dt.then){
                            dt.then(function(result){
                                def.resolve(result);
                            });
                        }else{
                            def.resolve(dt);
                        }
                    }));
                    return def;
                }
            }else{
                return data&&data[field]||"";
            }
        },
        setCanEdit:function(canEdit){
            this.canEdit = canEdit!==false&&canEdit!=="false";
            if(this.rightIconNode){
                domStyle.set(this.rightIconNode,"opacity",this.canEdit?1:0);
            }
            if(this.workMode==="inline"||this.workMode==="edit"){
                //inline编辑模式，设置要编辑的所有字段的可编辑状态
                if(this._loadingEditor){
                    this._refreshCanEdit = true;
                    return;
                }
                if(canEdit){
                    if(this.workMode==="inline")
                        this.inlineView.enableByFields();
                    if(this.workMode==="edit")
                        this.editModeNode.enableByFields();
                }else{
                    
                    if(this.workMode==="inline")
                        this.inlineView.disableByFields();
                    if(this.workMode==="edit")
                        this.editModeNode.disableByFields();
                }
            }
        },
        buildRendering:function(){
            this.inherited(arguments);
            this.canEdit = this.canEdit!==false&&this.canEdit!=="false";
            if(this.fields.workMode ==="edit"){
                this.workMode = "edit";
                //domClass.add(this.domNode,this.fields.className||"");
                if(this.fields.className){
                    this.domNode.className = this.fields.className;
                }
                this.fields = this.fields.layout;
            }else{
                this.fields = this.fields.layout;
                this.workMode = this.fields.length===1?"inline":"multip";
            }
            if("inline"===this.workMode){
                this._loadingEditor = true;
                this._setCanEditing = true;
                setTimeout(lang.hitch(this,this.initInlineEditor),0);
            }else if("edit"===this.workMode){
                this._loadingEditor = true;
                this._setCanEditing = true;
                setTimeout(lang.hitch(this,this.initEditEditor),0);
            }
            
        },
        initEditEditor:function(){
            this.editModeNode = this.createOverlayView();
            this.editModeNode.placeAt(this.labelNode);
            this.connect(this.editModeNode,"onWidgetFieldChanged",this.initEditEditorData);
            this.editModeNode.connect(this.editModeNode,"onLayoutReady",lang.hitch(this,function(){
                // 调整样式并注销右箭头的点击事件
                // 2017-7-25 刘轩 不知道此处这样处理的目的是什么
                /*if(this.fields[0].field){
                    var fieldElment= this.editModeNode.getElementByField(this.fields[0].field);
                    this.editModeNode.fieldElment  = registry.byNode(fieldElment);
                    this.editModeNode.fieldElment.set("rightIcon","");
                    domStyle.set(this.editModeNode.fieldElment.domNode,{
                        "float":"none",
                        "display":"block",
                        "background-color":"rgba(0,0,0,0) !important",
                        "margin":"0"
                    });
                    domStyle.set(this.editModeNode.fieldElment.getParent().domNode,{
                        margin:"0"
                    });
                }*/
                //初始化Edit编辑器的内容
                this._loadingEditor = false;
                if(this._refreshOnload){
                    this._refreshOnload = false;
                    this._loadingEditor = false;
                    this.setValue(this.value);
                }else{
                    this.setValue(this.getValue());    
                }
                
                //初始化Edit编辑器的可编辑状态
                this.setCanEdit(this.canEdit);
                this._setCanEditing = false;
                if(this._refreshCanEdit){
                    this._refreshCanEdit = false;
                    this.setCanEdit(this.canEdit);
                }
                if(this.editModeNode&&this.editModeNode.dataProvider&&this.editModeNode.reloadMethod){
                    this.editModeNode.dataProvider[this.editModeNode.reloadMethod](this.editModeNode);
                }
                this.onFieldChanged(this,this.field,this.editModeNode.getData());
            }));
            
            
        },
        initInlineEditor:function(){
            // summary:
            //      初始化inline编辑器 

            //处理layout和 fields
            var layout ={};
            if(this.fields[0].field){
                var fields =[];
                var item = lang.clone(this.fields[0]);
                fields.push(item.field);
                layout[item.field] = item;
                delete layout[item.field].field;
                
                //设置label为空
                this.label="";
                
                //创建inline编辑器，addChild
                this.inlineView = this.createInlineView(fields,layout);
            }else{
                this.inlineView = new DataLayout({
                    dataProvider:this.dataProvider||"",
                    reloadMethod:this.reloadMethod||"",
                    layout:this.fields
                });
                this.set("variableHeight",true);
            }
            this.inlineView.placeAt(this.labelNode);
            /*this.connect(this.inlineView.domNode,"onclick",function(e){
                if(e&&e.target&&"A"===e.target.tagName){
                    return ;
                }
                event.stop(e);
            });*/
            this.connect(this.inlineView,"onWidgetFieldChanged",this.initInlineData);
            this.inlineView.connect(this.inlineView,"onLayoutReady",lang.hitch(this,function(){
                // 调整样式并注销右箭头的点击事件
                if(this.fields[0].field){
                    var fieldElment= this.inlineView.getElementByField(this.fields[0].field);
                    this.inlineView.fieldElment  = registry.byNode(fieldElment);
                    this.inlineView.fieldElment.set("rightIcon","");
                    domStyle.set(this.inlineView.fieldElment.domNode,{
                        "float":"none",
                        "display":"block",
                        "background-color":"rgba(0,0,0,0) !important",
                        "margin":"0"
                    });
                    domStyle.set(this.inlineView.fieldElment.getParent().domNode,{
                        margin:"0"
                    });
                }
                //初始化inline编辑器的内容
                this._loadingEditor = false;
                if(this._refreshOnload){
                    this._refreshOnload = false;
                    this._loadingEditor = false;
                    this.setValue(this.getValue());
                }else{
                    this.setValue(this.getValue());    
                }
                
                //初始化inline编辑器的可编辑状态
                this.setCanEdit(this.canEdit);
                //自动弹出overlay
                if(this._clickOnReady){
                    this.onClick();
                }
                
                this._setCanEditing = false;
                if(this._refreshCanEdit){
                    this._refreshCanEdit = false;
                    this.setCanEdit(this.canEdit);
                }
            }));
        },
        
        initInlineData:function(){
            // summary:
            //      根据改变后的数据刷新自己的内容，并通知请他字段改变内容。
            
            this.onFieldChanged(this,this.field,this.inlineView.getData());
        },
        initEditEditorData:function(){
            this.onFieldChanged(this,this.field,this.editModeNode.getData());
        },
        getValue:function(){
            // 获取组件的返回值
            
            if(this.workMode==="edit"){
                if(this.editModeNode){
                    return this.editModeNode.getData();
                }else{
                    return "";    
                } 
            }
            
            return this.get("value");
        },
        //val:"",
        setValue:function(value){
            if(this.workMode==="edit"){
                if(this._loadingEditor){
                    this._refreshOnload = true;
                    this.value = value;
                    return;
                }
                //调用inlien编辑器的setData方法，刷新显示
                this.editModeNode.setData(value);
                return;
            }
            this.set("value",value);
            if("inline"===this.workMode){
                if(this._loadingEditor){
                    this._refreshOnload = true;
                    return;
                }
                //调用inlien编辑器的setData方法，刷新显示
                this.inlineView.setData(value);
            }else if(this.dataProvider&&this.userDefinedValue){
                if(lang.isString(this.dataProvider)){
                    require([this.dataProvider],lang.hitch(this,function(dataprovider){
                        dataprovider[this.userDefinedValue](this,value);
                    }));
                    if(this.overlayView){
                        this.overlayView.setData(value);
                    }
                }else{
                    this.dataProvider[this.userDefinedValue](this,value);
                    if(this.overlayView){
                        this.overlayView.setData(value);
                    }
                }
                
            }else{
                if(this.dataProvider&&this.field){
                    if(value){
                        var data=this.getObjLabel(this.field, value);
                        if(data&&data.then){
                            data.then(lang.hitch(this, function(label){
                                this.set("label", label);
                            }));    
                        }
                    }else{
                        this.set("label", this.label||"");
                    }
                    this.set("rightText", "");
                    if(this.overlayView){
                        this.overlayView.setData(value);
                    } 
                }else{
                    //this.set("rightText",value?this.getObjLabel(this.rightTextField,value):"");
                    this.set("rightText",value?value[this.rightTextField]:"");
                    if(this.labelField){
                        //this.set("label", value?this.getObjLabel(this.labelField, value):"");
                        this.set("label", value?value[this.labelField]:"");
                    }
                    if(this.overlayView){
                        this.overlayView.setData(value);
                    }
                }
            }
        },
        onClick:function(callback){
            if(false===this.canEdit){
                return;
            }
            if("edit"===this.workMode){
                return;
            }
            if("inline"===this.workMode){
                if(this.inlineView&&this.inlineView.fieldElment){
                    if(this.inlineView.getEditorByField(this.fields[0].field).onClick){
                        this.inlineView.getEditorByField(this.fields[0].field).onClick();
                    }
                }else{
                    this._clickOnReady = true;
                }
                return;
            }
            
            //if(this.fields.length>1){
            // 点击之后创建DataLayout，底部添加确定和取消按钮，showInOverlay
            if(!this.pane){
                this.pane = new View();
                this.overlayView = this.createOverlayView();
                this.overlayView.placeAt(this.pane.domNode);
                this.btnPane = domConstruct.create("div",{
                    "class": "hflex mblOverlay",
                    style: "position:absolute;width:100%;"
                },this.pane.domNode);
                this.subBtn = domConstruct.create("div",{
                    innerHTML:"确认",
                    className:"cq-btn-submmit flex1 h-center column-2"
                }, this.btnPane);
                this.cancleBtn = domConstruct.create("div",{
                    innerHTML:"取消",
                    className:"cq-btn-cancle flex1 h-center column-2"
                }, this.btnPane);
                // 绑定确定和取消按钮的点击事件
                touch.release(this.btnPane, lang.hitch(this, function(evt){
                    var target = evt.target;
                    if(domClass.contains(target, "cq-btn-submmit")){
                        // 确认按钮
                        var data = this.overlayView.getData();
                        this.setValue(data);
                        this.onFieldChanged(this, this.field, this.getValue());
                    }
                    if(domClass.contains(target, "cq-btn-cancle")){
                        this.overlayView.setData(this.oldData);
                    }
                    var deleteList = this.getValue();
                    this.view.show();
                }));
            }
            if(!this.view){
                var view = this.getParent();
                while(view){
                    if(!view.show){
                        view = view.getParent();
                    }else{
                        break;
                    }
                }
                this.view = view;
            }
            this.pane.placeAt(this.view,"after");
            this.pane.startup();
            this.pane.show();
            this.oldData = this.get("value");
            this.overlayView.setData(this.oldData);
        },
        onFieldChanged:function(widget,field,value){
        },
        
        createInlineView : function(fields,layout){
            var model = new BoBase({
                fields:layout
            });
            return new DataLayout({
                dataProvider:this.dataProvider||"",
                reloadMethod:this.reloadMethod||"",
                fieldChangeMethod:this.fieldChangeMethod||"",
                layout:[{
                    type:"form",
                    fields:model.getFormItems(fields)
                }]
            });
        },
		createOverlayView:function(){
            var layout = {};
            var fields = [];
            lang.clone(this.fields).forEach(function(item){
                fields.push(item.field);
                layout[item.field] = item;
                delete layout[item.field].field;
            });
			var model = new BoBase({
				fields:layout
			});
			return new DataLayout({
                dataProvider:this.dataProvider||"",
                reloadMethod:this.reloadMethod||"",
                fieldChangeMethod:this.fieldChangeMethod||"",
				layout:[{
					type:this.workMode==="edit"?"content":"form",
					fields:model.getFormItems(fields)
				}],
                className: "no-margin-top"
			});
		},
        // 功能：更改对象fields
        // 传递参数有 fields（array）
        alterLayout:function(fields) {
            // 清空原有数据
			this.setValue(null);
			this.onFieldChanged(this, this.field, null);
			
			// 设置编辑属性清单
			this.fields = fields;
            
            //清理工作
            if(this.inlineView){
                //重做buildRendering中初始化工作
                //工作模式
                //若inline，初始化
                this.inlineView.destroyRecursive();
                this.buildRendering();
            }
			// 若已经创建编辑对象
			if(this.overlayView){
				var dataLayout = this.overlayView;
				// 依据新的属性清单创建创建编辑对象
				this.overlayView = this.createOverlayView();
				this.overlayView.placeAt(dataLayout.domNode,"before");
				// 销毁原有编辑对象
				dataLayout.destroyRecursive();
			}
        },
        setShareDP:function(dp){
            this.dataProvider=dp;
        }
    });
});