define([
    "dojo/_base/declare",
    "dojo/_base/event",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/touch",
    "dojox/mobile/EdgeToEdgeList",
    "dojox/mobile/ListItem",
    "dijit/registry",
    "./ObjEditor",
//    "dojox/mobile/common",
    "dojox/mobile/_EditableListMixin"
],function(declare,event,lang,array,domAttr,domClass,domConstruct,domStyle,touch,EdgeToEdgeList,ListItem,registry,ObjEditor/*,common*/,_EditableListMixin){
    lang.mixin(_EditableListMixin.prototype,{
        startEdit:function(){
                this.isEditing = true;
                domClass.add(this.domNode, "mblEditableRoundRectList");
                array.forEach(this.getChildren(), function(child){
                    if(!child.deleteIconNode&&this.deleteIconForEdit){
                        child.set("deleteIcon", this.deleteIconForEdit);
                        if(child.deleteIconNode){
                            child.deleteIconNode.tabIndex = child.tabIndex;
                            domAttr.set(child.deleteIconNode, "role", "button");
                        }
                    }else if(child.deleteIconNode&&!this.deleteIconForEdit){
                        child.set("deleteIcon", this.deleteIconForEdit);
                    }
                    if(child.deleteIconNode){
                        child.deleteIconNode.style.display = "";
                    }
                    if(!this.rightIconNode&&this.rightIconForEdit){
                        child.set("rightIcon", this.rightIconForEdit);
                        if(child.rightIconNode){
                            domAttr.set(child.rightIconNode, "role", "button");
                            domAttr.set(child.rightIconNode, "aria-grabbed", "false");
                        }
                    }else if(this.rightIconNode&&!this.rightIconForEdit){
                        child.set("rightIcon", this.rightIconForEdit);
                    }
                    if(child.rightIconNode){
                        child.rightIconNode.style.display = "";
                        //common._setTouchAction(child.rightIconNode, "none");
                    }
                }, this);
                if(!this._handles){
                    this._handles = [
                        this.connect(this.domNode, touch.press, "_onTouchStart"),
                        this.connect(this.domNode, "onclick", "_onClick"),
                        this.connect(this.domNode, "onkeydown", "_onClick")
                    ];
                }
                
                this.onStartEdit(); // callback
        },
        endEdit:function(){
            domClass.remove(this.domNode, "mblEditableRoundRectList");
            array.forEach(this.getChildren(), function(child){
                if(child.rightIconNode){
                    child.rightIconNode.style.display = "none";
                    //common._setTouchAction(child.rightIconNode, "auto");
                }
                if(child.deleteIconNode){
                    child.deleteIconNode.style.display = "none";
                }
            });
            if(this._handles){
                array.forEach(this._handles, this.disconnect, this);
                this._handles = null;
            }
            this.isEditing = false;
            
            this.onEndEdit();
        },
        onClick:function(e){
            if(e&&e.target){
                var widget = registry.getEnclosingWidget(e.target);
                if(widget&&widget.getParent()===this){
                    return true;
                }
            }
            return false;
        }
    });
    return declare("",[EdgeToEdgeList],{
    //htmlTemp:'<div class="cq-form-objseditor cq-field-input" data-dojo-type="cq/app/widget/mobile/edit/ObjsEditor" data-dojo-props=\'rightTextField:"{rightTextField}",canAdd:{canAdd},canDelete:{canDelete},canDnd:{canDnd},label:"{label}",canEdit:{canEdit},field:"{field}",defaultData:{j:defaultData},labelField:"{labelField}",fields:{j:fields},multipDataProvider:"{multipDataProvider}",multipReloadMethod:"{multipReloadMethod}",userDefinedValue:"{userDefinedValue}"\'></div>',
    htmlTemp:'<div class="cq-form-objseditor cq-field-input {className}" data-dojo-type="cq/app/widget/mobile/edit/ObjsEditor" data-dojo-props=\'rightTextField:"{rightTextField}",canAdd:{canAdd},canDelete:{canDelete},canDnd:{canDnd},label:"{label}",canEdit:{canEdit},arrLength:{arrLength},field:"{field}",defaultData:{j:defaultData},labelField:"{labelField}",fields:{j:fields},dataProvider:"{dataProvider}",reloadMethod:"{reloadMethod}",fieldChangeMethod:"{fieldChangeMethod}",userDefinedValue:"{userDefinedValue}"\'></div>',
    
        field:"",
        fields:{},
        canEdit:true,
        // 是否可以添加
        canAdd:true,
        // 是否可以删除
        canDelete:true,
        // 是否可以调整顺序
        canDnd:true,
        label:"",
        labelField:"",
        rightTextField:"",
        //多字段编辑时
        
        userDefinedValue:"",
        dataProvider:"",
        reloadMethod:"",
        //多字段value的显示自定义方法
        fieldChangeMethod:"",
        //规定添加的长度，默认不限制，如果有值则限制
        arrLength:"",
        defaultData:null,
        
        //对象数组所在容器
        _objectList:null,
        //editable:true,
        getValue:function(){
            return this._objectList.getChildren().map(function(item){
                return item.getValue();
            });
        },
        setValue:function(value){
            this.set("value", value);
            // 销毁子元素
            this._objectList.destroyDescendants();    
            
            // 创建新的子元素
            if(value){
                value.forEach(lang.hitch(this, function(item){
                    var newItem = new ObjEditor({
                        fields:this.fields,
                        canEdit:this.canEdit,
                        className:this.fields.className||"",
                        labelField:this.labelField,
                        rightTextField:this.rightTextField,
                        clickable:this.clickable,
                        //多字段编辑时
                        userDefinedValue:this.userDefinedValue||"",
                        dataProvider:this.dataProvider||"",
                        reloadMethod:this.reloadMethod||"",
                        fieldChangeMethod:this.fieldChangeMethod||"",
                        
                        
                        onFieldChanged:lang.hitch(this, function(widget, field, value){
                            this.fieldChange();
                        })
                    });
                    this._objectList.addChild(newItem);
                    newItem.setValue(item);
                }));
            }
            if(this._objectList.startEdit && this.canEdit&&(this.canDnd||this.canDelete)){
                this._objectList.startEdit();
            }
        },
        onFieldChanged:function(widget,field,value){
        },
        
        
        setCanDelete:function(canDelete){
            this.canDelete = canDelete!==false&&this.canDelete!=="false";
            this._objectList.deleteIconForEdit = this.canDelete?"mblDomButtonRedCircleMinus":"";  
        },
        setCanDnd:function(canDnd){
            this.canDnd = canDnd!==false&&this.canDnd!=="false";
            this._objectList.rightIconForEdit = this.canDnd?"mblDomButtonGrayKnob":"";
        },
        setCanEdit:function(canEdit){
            this.canEdit = canEdit!==false&&canEdit!=="false";
			this._objectList.set("editable",this.canEdit);
			if(this.canEdit && !this._objectList.isEditing && this._objectList.startEdit&&(this.canDelete||this.canDnd)){
                this._objectList.startEdit();
            }else if(!this.canEdit && this._objectList.isEditing && this._objectList.endEdit){
                this._objectList.endEdit();
            }
			var child = this._objectList.getChildren();
			for(var i=0;i<child.length;i++){
                if(child[i]&&child[i].setCanEdit){
                    child[i].setCanEdit(this.canEdit);
                }
            }
            domStyle.set(this.addItem.domNode,"display",this.canAdd&&this.canEdit?"":"none");
        },
        setCanAdd:function(canAdd){
            this.canAdd = canAdd!=="false"&&canAdd!==false;
            domStyle.set(this.addItem.domNode,"display",this.canAdd&&this.canEdit?"":"none");
        },
        fieldChange:function(){
            // 重新获取数据，触发onFieldCHanged
            this.set("value", this.getValue());
            this.onFieldChanged(this, this.field, this.getValue());
        },
        buildRendering:function(){
            this.inherited(arguments);
            // 创建添加ListItem的节点并绑定事件
            this.addItem = new ListItem({
                style:"text-align:center;",name:"objsEditor"
            });
            this.addBtn = domConstruct.create("div", {
                innerHTML:"添加"+(this.label||"")
            }, this.addItem.domNode, "first");
            // 避免滑动屏幕时触发ontouch事件 这里使用onclick事件，而不是用onTouch事件
            this.addBtn.addEventListener("click",lang.hitch(this,function(evt){
                if(!this.canEdit || !this.canAdd) return;
                //假如 arrLength 存在就限制长度，否则不做限制
                if(this.arrLength&&this._objectList.domNode.childNodes.length>=this.arrLength){
                    alert("最多添加"+this.arrLength+"条记录");
                    return;
                }
                var newItem = new ObjEditor({
                    fields:this.fields,
                    canEdit:true,
                    className:this.fields.className||"",
                    labelField:this.labelField,
                    rightTextField:this.rightTextField,
                    clickable:this.clickable,
                    //多字段编辑时
                    userDefinedValue:this.userDefinedValue||"",
                    dataProvider:this.dataProvider||"",
                    reloadMethod:this.reloadMethod||"",
                    fieldChangeMethod:this.fieldChangeMethod||"",
                    
                    onFieldChanged:lang.hitch(this, function(widget, field, value){
                        this.fieldChange();
                    })
                });
                this._objectList.addChild(newItem);
                if(this.defaultData){
                    newItem.setValue(lang.clone(this.defaultData));
                }
                newItem.onClick(); 
                if(this.canEdit&&this._objectList.startEdit){
                    this._objectList.startEdit();
                }
                // 定位添加按钮到可见区域
                this.scrollPane = null;
                this.getScrollPane();
                if(this.scrollPane){
                    var itemHeight = this._objectList.containerNode;
                    itemHeight = itemHeight.firstChild&&itemHeight.firstChild.clientHeight||44;
                    
                    if((this.addItem.domNode.offsetTop+itemHeight)>=this.scrollPane.domNode.offsetHeight)
                        this.scrollPane.scrollTo({y:this.scrollPane.getPos().y-itemHeight,x:0})
                }
            }));
            this.addChild(this.addItem);
            
            //添加数组列表
            this._objectList = new EdgeToEdgeList({
                editable:true,
                clickable:true
            });
            //this.addChild(this._objectList);
            this._objectList.placeAt(this,"first");
            this.setCanDelete(this.canDelete);
            this.setCanDnd(this.canDnd);
            this.setCanEdit(this.canEdit);
            this.setCanAdd(this.canAdd);
            this.mixinOver();
        },
        mixinOver:function(){
            this.connect(this._objectList, "onClick", lang.hitch(this, function(evt){
                var item = registry.getEnclosingWidget(evt.target);
                if(item){
                    if(item.deleteIconNode&&item.deleteIconNode.contains(evt.target)){
                        return;
                    }else if(item instanceof ObjEditor){
                        //只有直接点击到ObjEditor时才触发onClick方法
                        //      编辑列表会阻止下级的onClick函数调用
                        //      ObjEditor通过onClick方法响应点击，这里需要特殊处理
                        item.onClick(evt);
                    }
                }
            }));
            this.connect(this._objectList, "onDeleteItem", lang.hitch(this, function(item){
                item.destroy();
                this.fieldChange();
            }));
            this.connect(this._objectList, "onMoveItem", lang.hitch(this, function(evt){
                if(evt&&evt.rightIcon==="mblDomButtonArrow"){
                    return;
                }else{
                    this.fieldChange();    
                }
            }));
			this.connect(this._objectList.domNode, "onselectstart", event.stop);
        },
        postCreate: function(){
            this.inherited(arguments);
			if(this.syncWithViews){ // see also TabBar#postCreate
				var f = function(view, moveTo, dir, transition, context, method){
					var child = array.filter(this.getChildren(), function(w){
						return w.moveTo === "#" + view.id || w.moveTo === view.id; })[0];
					if(child){ child.set("selected", true); }
				};
				this.subscribe("/dojox/mobile/afterTransitionIn", f);
				this.subscribe("/dojox/mobile/startView", f);
			}
		},
        setShareDP:function(dp){
            this.dataProvider=dp;
        },
        getScrollPane:function(){
            if(!this.scrollPane){
                this.scrollPane = this;    
            }
            if(!domClass.contains(this.scrollPane.domNode,"mblScrollablePane")){
                this.scrollPane = this.scrollPane.getParent();
                this.getScrollPane();
            }
        }
    });
});