﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojo/_base/array",
    "dojox/mobile/ListItem",
    "cq/util/edit/jsonRef",
    "cq/util/edit/JsonRefRead"
], function (declare, lang, domStyle, array, ListItem, jsonRef,jsonRefRead) {
    return declare("cq.app.widget.mobile.edit.Ref", [ListItem], {
    htmlTemp: '<li id="{id}" data-cq-field="{field}"  class="cq-field-input cq-form-ref" data-dojo-type="cq/app/widget/mobile/edit/Ref" data-dojo-props="query:{query},refQuery:{refQuery},field:\'{field}\',keyField:{keyField},pageSize:\'{pageSize}\',label:\'{label}\',targetMethod:\'{targetMethod}\',searchAttr:\'{searchAttr}\',labelAttr:\'{labelAttr}\',dataProvider:\'{dataProvider}\',canEdit:{canEdit},multiselect:\'{multiselect}\',queryMethod:{queryMethod},setRigthTextMethod:\'{setRigthTextMethod}\'"></li>',
        field: "",
        // 查询属性名
        searchAttr: "",
        // 显示的属性名，属性名中间以逗号隔开
        labelAttr: "",
        keyField:"",
        dataProvider: "",
        targetMethod: "",
        queryMethod: "",
        pageSize: "5",
        start: "0",
        multiselect: "",
        canEdit: true,
        clickable: true,
        query:null,
        refQuery:null,
        searchParams: {},
        setRigthTextMethod:"",
        buildRendering: function () {
            this.inherited(arguments);
            this.canEdit = this.canEdit !== false && this.canEdit !== "false";
            //加载dataProvider,获取接口url
            if (this.dataProvider) {
                if (lang.isString(this.dataProvider)) {
                    require([this.dataProvider], lang.hitch(this, function (dataProvider) {
                        // 当数据提供者加载完成之后，调用targetMethod方法，获取url
                        this.dataProvider = dataProvider;
                        this.searchParams = {
                            target: this.dataProvider[this.targetMethod](this.query),
                            searchField: this.searchAttr,
                            labelField: this.labelAttr,
                            multiselect: this.multiselect,
                            query: this.query?lang.clone(this.query):{}
                        };
                        if (this.labelAttr.split(",").length > 1) {
                            this.labelFields = this.labelAttr.split(",");
                            this.searchParams.getDataLabel = lang.hitch(this, this.getDataLabel);
                        }
                    }));
                }
            }
        },
        setCanEdit: function (canEdit) {
            this.canEdit = canEdit;
            if (this.rightIconNode) {
                domStyle.set(this.rightIconNode, "opacity", this.canEdit ? 1 : 0);
            }
        },
        getDataLabel: function (data) {
            return '<div style="min-width:160px;display:inline-block;">' + array.map(this.labelFields, function (field) {
                return data[field] || "";
            }).join('</div><div style="min-width:160px;display:inline-block;">') + "</div>";
        },
        //获取数据
        getValue: function () {
            return this.get("value");
        },
        //设置ListItem的数据
        setValue: function (value) {
            if (!this.canEdit) {
                //this.rightIconNode.innerHTML="";
                domStyle.set(this.rightIconNode, "opacity", 0);
            }
            this.set("value", value);
            if(this.dataProvider&&this.setRigthTextMethod){
                if(lang.isString(this.dataProvider)){
                    require([this.dataProvider],lang.hitch(this,function(dataProvider){
                        this.dataProvider = dataProvider;
                        this.dataProvider[this.setRigthTextMethod](this,value);
                    }));
                }else{
                    this.dataProvider[this.setRigthTextMethod](this,value);
                }
            }else{
                //this.set("rightText", value[this.labelFields ? this.labelFields[0] : this.labelAttr] || "");    
                var label = "";
                if(value){
                    label = (value instanceof Array?value:[value]).map(lang.hitch(this,function(item){
                        return (this.labelFields||[this.labelAttr]).map(function(field){
                            return item[field];
                        }).join("|");
                    })).join(",");
                }
                this.setRight(label || "");
            }
            
        },
        getValueLabel:function(value,field){
        },
        setRight:function(value){
            this.set("rightText",value);        
        },
        //onClick事件
        onClick: function (viewNode) {
            this.inherited(arguments);
            //分组时，多次点击进入 每一次的view都不一样  
            this.view = null;
            if (!this.view) {
                var view = this.getParent();
                while (view) {
                    if (!view.show) {
                        view = view.getParent();
                    } else {
                        break;
                    }
                }
                this.view = view;
            }
            if(false === this.canEdit) {
                if(this.multiselect){
                    this.readView = new jsonRefRead(this.searchParams);
                    this.readView.startEdit(this.getValue() || "", this.view || viewNode);    
                }else{
                    return;    
                }
            }else{
                var query = this.getQueryParams();
                var load = lang.hitch(this,function(searchParams){
                    //调用jsonRef的方法，读取到数据之后，setValue，onFieldChanged
                    jsonRef.startEdit(this.getValue() || "", this.view || viewNode, searchParams).then(lang.hitch(this, function (value) {
                        this.setValue(value);
                        this.onFieldChanged(this, this.field, value);
                    }));
                });
                if(query&&query.then){
                    query.then(load);
                }else{
                    load(query);
                }
            }
        },
        getQueryParams:function(){
            var query = lang.clone(this.searchParams.query||{});
            if(this.dataProvider&&this.queryMethod&&this.dataProvider[this.queryMethod]){
                query = lang.mixin(query,this.dataProvider[this.queryMethod]()||{});
            }
            if(this.refQuery&&this.layoutWidget){
                query = lang.mixin(query,this.layoutWidget.getData(this.refQuery));
            }
            var params = lang.clone(this.searchParams);
            params.query = query||{};
            if(this.keyField){
                params.keyField = this.keyField;
            }
            return params;
        },
        onFieldChanged: function (widget, field, value) {}
    });
});