﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojox/mobile/ListItem"
],function(declare,lang,domStyle,ListItem){
    //列表选项，呈现为一个ListItem，内容显示在右侧
    return declare("",[ListItem],{
        htmlTemp:'<li class="cq-form-richeditor cq-field-input" data-dojo-type="cq/app/widget/mobile/edit/RichText" data-dojo-props=\'canEdit:"{canEdit}",field:"{field}",labelTitle:"{label}",tempType:"{tempType}",isAdvance:"{isAdvance}"\'></li>',
        field:"",
        clickable:true,
        variableHeight:true,
        canEdit:true,
        labelTitle:"",
        tempType:"",
        isAdvance:false,
        buildRendering:function(){
            this.label = this.labelTitle;
            this.canEdit = this.canEdit!==false&&this.canEdit!=="false";
            this.isAdvance = this.isAdvance!==false&&this.canEdit!=="false"&&this.isAdvance!=="";
            this.inherited(arguments);
        },
        setCanEdit:function(canEdit){
            this.canEdit=canEdit;
            if(this.rightIconNode){
                domStyle.set(this.rightIconNode,"opacity",this.canEdit?1:0);
            }
        },
        getValue:function(){
            return this.get("value");
        },
        setValue:function(value){
            if(!this.canEdit){
                //this.rightIconNode.innerHTML="";
                domStyle.set(this.rightIconNode,"opacity",0);
            }
            this.set("value",value);
            this.set("label",this.labelTitle+":"+(value||value===0||value===false?value:""));
        },
        onClick:function(viewNode){
            if(false===this.canEdit){
                return;
            }
            //分组时，多次点击进入 每一次的view都不一样  
            this.view = null;
            if(!this.view){
                var view = this.getParent();
                while(view){
                    if(!view.show){
                        view = view.getParent();
                    }else{
                        break;
                    }
                }
                this.view = view;
            }
            if(this.isAdvance){
                require(["cq/util/edit/toolRichEditor"],lang.hitch(this,function(toolRichEditor){
                    toolRichEditor.startEdit(this.getValue()||"",this.view||viewNode,this.tempType?this.tempType:"").then(lang.hitch(this,function(value){
                        this.setValue(value);
                        this.onFieldChanged(this,this.field,value);
                    }));     
                }));
            }else{
                require(["cq/util/edit/editor"],lang.hitch(this,function(editor){
                    editor.startEdit(this.getValue()||"",this.view||viewNode,this.tempType?this.tempType:"").then(lang.hitch(this,function(value){
                        this.setValue(value);
                        this.onFieldChanged(this,this.field,value);
                    })); 
                }));
            }
        },
        onFieldChanged:function(widget,field,value){
            
        }    
    });
});