﻿define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/lang",
    "dojox/mobile/Rating"
],function(declare,array,lang,Rating){
    // module:
    //      cq/app/widget/mobile/edit/Score
    return declare("",[Rating],{    
        // summary:
        //      所有复选框的编辑页面方式
        
        // htmlTemp:String
        //      复选框的html片段
        htmlTemp:'<div class="cq-form-score cq-field-input" style="z-index:100;" data-dojo-type="cq/app/widget/mobile/edit/Score" data-dojo-props="label:\'\',field:{field},canEdit:{canEdit},image:{image},numStars:{numStars},value:{value}"></div>',
        // field:String
        //      复选框的字段名
        field:"",
        // canEdit:boolean
        //      控制复选框是否可以编辑的字段
        canEdit:"",
        
        value:0,
        // 评级图形
        image:"/static/common/images/star-orange.png",
        // 总分数
        numStars:5,
        buildRendering:function(){
            this.inherited(arguments);
            this.image = this.image||"/static/common/images/star-orange.png";
            this.connect(this.domNode,"onclick",this.onClick);
            this.setCanEdit(this.canEdit);
        },
       
        setCanEdit:function(canEdit){
            // summary:
            this.canEdit = false!==canEdit&&"false"!==canEdit;
        },
        onClick:function(e){
            if(this.canEdit&&e){
                var node = e.target;
                var domNode = this.domNode;
                while (node && node.parentNode !== domNode) {
                    node = node.parentNode;
                }
                var value = array.indexOf(domNode.childNodes, node) + 1;
                this.setValue(value);
                this.onFieldChanged(this,this.field,value);
            }
        },
        //点击
        
        initClick:function(){
            var rating = this.domNode.childNodes;
            array.forEach(rating,lang.hitch(this,function(node){
                
            }));
        },
        /*
        //手机端滑动
        
        onTouchStart:function(){
            // summary:
            //      手机端滑动时触发，如果复选框不可编辑则返回，否则返回所有的复选框参数
            this.setCanEdit(this.canEdit);
            if(this.disabled) return false; 
            return this.inherited(arguments);
        },
        */
        getValue:function(){
            // summary:
            //      获取所有被选中的复选框的值
            return this.get("value");
        },
        setValue:function(value){
            // summary:
            //      为复选框设定是否被选中
            this.set("value",value||0);
            this.set("value",value||0);
        },
        onFieldChanged:function(widget,field,value){
            // summary:
            //      字段变化后触发，本身不做任何操作，提供外部使用
        }
    });
});