﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/Deferred",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/query",
    "dijit/_WidgetBase",
    "dijit/_Container",
    "dijit/registry",
    "cq/app/widget/_WidgetBase"
],function(declare,lang,array,Deferred,domAttr,domClass,domConstruct,query,_WidgetBase,_Container,registry,cqWidgetBase){
    var props = "'dataProvider:\"{dataProvider}\",dataMethod:\"{dataMethod}\","+
    "dataOptions:{j:dataOptions},className:\"{className}\"'";
    return declare('',[_WidgetBase,_Container,cqWidgetBase],{
        htmlTemp:'<div id="{id}" class="cq-DataContainer {className}" data-dojo-type="cq/app/widget/mobile/icon/DataContainer" data-dojo-props='+props+'>{items}</div>',
        //控制整体样式
        className:'',
        //数据提供者
        dataProvider:'',
        //数据加载方法
        dataMethod:'',
        //加载数据的参数
        dataOptions:{},
        //配置按钮属性数组
        items:[],
        
        buildRendering:function(){
            this.inherited(arguments);
            this.containerNode = this.containerNode||this.domNode;
            //this.initView();
        },
        initView:function(){
            var layoutData = this.getLayoutData();
            if(layoutData&&layoutData.then){
                layoutData.then(lang.hitch(this,function(data){
                    this._initViewByData(data);
                }));
            }else{
                this._initViewByData(layoutData);
            }
        },
        getLayoutData:function(){
            if(this.dataProvider&&this.dataMethod){
                if(lang.isString(this.dataProvider)){
                    var def = new Deferred();
                    require([this.dataProvider],lang.hitch(this,function(dataProvider){
                        this.dataProvider = dataProvider;
                        var data = this.dataProvider[this.dataMethod](this.cqRefInfo,this,this.dataOptions);
                        if(data&&data.then){
                            data.then(function(result){
                                def.resolve(result);
                            });
                        }else{
                            def.resolve(data);
                        }
                    }));
                    return def;
                }else{
                    return this.dataProvider[this.dataMethod](this.cqRefInfo,this.dataOptions);
                }
            }else{
                if(this.dataProvider){
                    require([this.dataProvider],lang.hitch(this,function(dataProvider){
                        this.dataProvider = dataProvider;
                    }));
                }
                return this.inherited(arguments);
            }
        },
        _initViewByData:function(data){
            if(data.data&&data.data.item){
                data = data.data.item
            }else if(data.data){
                data= data.data
            }
            var fieldAarry = ['labelField','label2Field','iconField','badgeField','srcField'];
            var fieldNodes = this.containerNode.children;
            array.forEach(fieldNodes,function(fieldNode){
                var datas={};
                //获取到的是dom节点，把他转为dojo对象
                var fieldObj = registry.getEnclosingWidget(fieldNode);
                array.forEach(fieldAarry,function(changeField){
                    if(fieldObj[changeField]){
                        var showField = fieldObj[changeField];
                        var value = data[showField]||'';
                        datas[showField] = value;
                    }
                });
                fieldObj.setData(datas);
            });
        },
        cqRefresh:function(){
            this.initView();
        }
    });
});