﻿/*
    用于点击显示tooltip，
    继承自DataIcon
    配置：
        {
            dojoType:"cq/app/widget/mobile/icon/DropDown",    //模块类型
            label:"tooltip",                                  //按钮显示的信息
            className:"DropDown"                              // 这个className为按钮的className
            tooltipClassName:"tooltipName"                    // 这个className为tooltip容器的className
            dropDownItems:[{                                  //tooltip的内容  这里只是提供一个容器 
                                                                    //容器中的内容自己填充  推荐使用Icon
                id:8    //与外部按钮的关联
                dojoType:"cq/app/widget/mobile/icon/Icon",
                label:"1"
            },{
                dojoType:"cq/app/widget/mobile/icon/Icon",
                label:"2",
                href:""   //跳转
            },{
                dojoType:"cq/app/widget/mobile/icon/Icon",
                label:"3"
            },{
                dojoType:"cq/app/widget/mobile/icon/DataIcon",
                label:"4"
                dataProvider:"",
                dataMethod:"",
                dataOptions:null,
                clickMethod:"",
            }]
        }
*/
define([
    "dojo/_base/declare",
    "dojo/dom-class",
    "dojo/dom-geometry",
    "dojo/dom-style",
    "dojo/query",
    "cq/util/edit/tooltip",
    "./DataIcon"
],function(declare, domClass, domGeometry, domStyle, query, tooltip, DataIcon){
    return declare("",[DataIcon],{
        htmlTemp:'<div id = "{id}" class="cq-dropdown-icon {className}"data-dojo-type="cq/app/widget/mobile/icon/DropDown" data-dojo-props=\'label:{label},icon:{icon}\'><div data-dojo-type="dojox/mobile/Pane" class="tooltipPane {tooltipClassName}" style="display:none">{dropDownItems}</div></div>',
        buildRendering:function(){
            this.inherited(arguments);
            this.resize();
        },
        resize:function(){
            this.inherited(arguments);
            if(!this.tooltipPane){
                this.tooltipPane = query(".tooltipPane",this.domNode)[0];
            }
        },
        onClick:function(e){
            // tooltipPane 的样式不要包含位置信息 必须要有宽度
            /* domStyle.set(this.tooltipPane,{
                "width":"150px",
                "background":"rgba(0,0,0,0.9)",
                "border-radius": "5px",
                "color":"#fff"
            }); */
            this.pos = domGeometry.position(this.domNode);
            tooltip.showElement(this.tooltipPane,this.pos);
        }
    });
});