﻿/*
以下图标、图标容器对象都要继承cq/app/widget/_WidgetBase
分块图片、按钮、标签组件 cq/app/widget/mobile/icon/IconBase
	提供属性：
        图标
        大标题
        小标题
        固定class——图片、文字大小、是否圆角等基本样式控制
        右侧小图标(before/after)——动态设置的样式控制，如上下箭头等
        提示数量
各个页面不见点击之后的链接地址
	修改上述属性的方法
*/
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/dom-class",
    "dojo/dom-attr",
    "dijit/_Widget",
    "../../_WidgetBase"
],function(declare,lang,domConstruct,domStyle,domClass,domAttr,_Widget,_CqWidgetBase){
    return declare("",[_Widget,_CqWidgetBase],{
        htmlTemp:'<div id="{id}" class="{className} cq-icon flex1" data-dojo-type="cq/app/widget/mobile/icon/IconBase" data-dojo-props="className:\'{className}\',label:\'{label}\',label2:\'{label2}\',labelClass:\'{labelClass}\',label2Class:\'{label2Class}\',icon:\'{icon}\',iconClass:\'{iconClass}\',href:\'{href}\',rightIcon:\'{rightIcon}\',badge:\'{badge}\',badgeClass:\'{badgeClass}\'"></div>',
        
        //固定class——图片、文字大小、是否圆角等基本样式控制
        className:"",
        //大标题
        label:"",
        //小标题
        label2:"",
        labelClass:"",
        label2Class:"",
        //图标
        icon:"",
        iconClass:"",
        //链接
        href:"",
        //右侧小图标(before/after)——动态设置的样式控制，如上下箭头等
        rightIcon:"",
        //提示数量
        badge:"",
        badgeClass:"",
        buildRendering:function(){
            this.inherited(arguments);
            this.initNode();
            this.connect(this.domNode,"onclick",function(e){
                this.onClick(e);
            });
        },
        initNode:function(){
            // icom节点
            this.iconArea = domConstruct.create("div",{
                "class":"full-width h-center",
            },this.domNode);
            this.iconNode = domConstruct.create("img",{
                style:this.icon?"display:inline-block":"display:none",
                "class":this.iconClass||"",
                src:this.icon
            },this.iconArea);
            
            // 大标题节点
            this.labelNode = domConstruct.create("div",{
                "class":"full-width h-center "+(this.labelClass||""),
                innerHTML:this.label||""
            },this.domNode);
        
            // 小标题节点
            this.label2Node = domConstruct.create("div",{
                "class":"full-width h-center "+this.label2Class||"",
                innerHTML:this.label2
            },this.domNode);
        
            // 提示消息节点
            this.badgeNode = domConstruct.create("div",{
                // css自己定义位置
                style:"display:inline-block;",//position: absolute; top:0;right:0;
                "class":this.badgeClass||"rightIcon user_toeva_num",
                innerHTML:this.badge||""
                
            },this.domNode);
            domStyle.set(this.domNode,"position","relative");
            if(!this.badge){
                domStyle.set(this.badgeNode,"display","none")
            }
        
        
            // 右侧按钮class（通过伪类控制）
            /*if(this.iconArea){
                domAttr.set(this.iconArea,"class",this.iconClass+" "+this.rightIcon);
                this.rightIconNode = this.iconArea;
            }else if(this.labelNode){
                domAttr.set(this.iconArea,"class",this.labelClass+" "+this.rightIcon);
                this.rightIconNode = this.labelNode;
            }else if(this.label2Node){
                domAttr.set(this.iconArea,"class",this.label2Class+" "+this.rightIcon);
                this.rightIconNode = this.label2Node;
            }*/
        },
        setLabel:function(newLabel){
            
            this.labelNode.innerHTML = newLabel;
        },
        setLabel2:function(newLabel2){
            
            this.label2Node.innerHTML = newLabel2;
        },
        setIcon:function(newIcon){
            this.icon = newIcon || this.icon;
            this.iconNode.src = this.icon;
            if(this.icon){
                this.iconNode.style.display="inline-block";    
            }else{
                this.iconNode.style.display="none";
            }
        },
        setBadge:function(data,isShow){
            if(data){
                domStyle.set(this.badgeNode,"display","");
                this.badgeNode.innerHTML = data;
                this.badge = data;
            }else{
                domStyle.set(this.badgeNode,"display","none");
                this.data=null;
            }
        },
        setRightIcon:function(newRigetIcon){
           domAttr.set(this.rightIconNode,"class",this.label2Class+" "+newRigetIcon);
           this.rightIcon = newRigetIcon;
        },
        setSrc:function(src){
            this.href = src;
        },
        _clickTimer:null,
        onClick:function(){
            clearTimeout(this._clickTimer);
            this._clickTimer = setTimeout(lang.hitch(this,function(){
                if(this.href){
                    if("back"===this.href){
                        var href = location.href;
                        history.back();
                        setTimeout(function(){
                            if(href===location.href){
                                window.moveToView("main");
                            }
                        },10);
                    }else{
                        location.href = this.href;
                    }
                }
            }),300);
        }
    });
});