﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/query",
    "dijit/_WidgetBase",
    "dijit/_Container",
    "dijit/registry",
    "cq/app/widget/_WidgetBase",
],function(declare,lang,array,domAttr,domClass,domConstruct,domStyle,query,_WidgetBase,_Container,registry,cqWidgetBase){
    return declare('',[_WidgetBase,cqWidgetBase,_Container],{
        htmlTemp:'<div id="{id}" class="cq-icon-IconContainer {className}" data-dojo-type="cq/app/widget/mobile/icon/IconContainer" data-dojo-props=\'isFixedTop:{isFixedTop},isFixedBottom:{isFixedBottom},className:"{className}"\'>{items}</div>',
        //控制整体样式
        className:'',
        //各个按钮的具体配置
        // items:[{dojoType:,....}]
        items:[],
        
        //isFixedTop 滑动时容器到达顶部时，固定在页面顶部
        //isFixedTop:false,
        
        //isFixedBottom 滑动时容器到达底部时，固定在页面底部
        //isFixedBottom:false,
        
        buildRendering:function(){
            //isFixedTop isFixedBottom默认为false
            this.isFixedTop = this.isFixedTop?true:false;
            this.isFixedBottom = this.isFixedBottom?true:false;
            this.firstScroll = true;
            this.inherited(arguments);
            //创建和初始化容器节点
            this.containerNode = this.containerNode||this.domNode;
        },
        startup:function(){
            this.inherited(arguments);
            
            if((this.isFixedTop||this.isFixedBottom)&&!this.fixedHandle){
                //获取scrollPane
                var scrollable = this.getParent();
                while(scrollable&&!scrollable.slideTo){
                    
                    scrollable = scrollable.getParent();
                }
                //创建一个节点加入到标签节点旁边，当标签节点从外部移入时用作定位的节点
                if(scrollable){
                    this.scrollable = scrollable;
                    this._nextNode = domConstruct.create("div",{
                        style:"margin:0;padding:0;height:0;"
                    },this.domNode,"after");
                    //this._originPositon = domStyle.get(this.domNode,"position");
                    this._originTop = domStyle.get(this.domNode,"top");
                    //监听slideTo
                    this.fixedHandle = this.connect(this.scrollable,"slideTo",this.handleFix);
                }
            }
        },
        //锁定和解除锁定的具体实现方法
        _handleFix:function(to){
            //若锁定在顶部
            //比较this.nextNode的位置和to.y的关系
            
            if(this.firstScroll){
                this.iconWidgets = this.getChildren();
                if(this.iconWidgets.length>0){
                    for(var i=0;i<this.iconWidgets.length;i++){
                        
                        this.connect(this.iconWidgets[i],"onClick",lang.hitch(this,function(e){
                            var iconNode = e.target;
                            while(!domClass.contains(iconNode,"cq-icon")){
                                iconNode = iconNode.parentNode;
                            }
                            var iconWidget = registry.byNode(iconNode);
                            if(this.domNode.parentNode===this.scrollable.domNode){
                                this.scrollable.slideTo({x:0,y:(!iconWidget.viewToTop?-(this._nextNode.offsetTop-this.domNode.clientHeight):iconWidget.viewToTop)});
                                
                            }
                        }));
                    }
                }
                this.firstScroll = false;
            }
            if(this.iconWidgets.length>0){
                for(var i=0;i<this.iconWidgets.length;i++){
                    if(domClass.contains(this.iconWidgets[i].domNode,"selected")){
                        this.iconWidgets[i].viewToTop = to.y;
                    }
                }
            }
            if(this.isFixedTop){
                if(this.domNode.parentNode!==this.scrollable.domNode){
                    if(to.y+this.domNode.offsetTop<0){
                        //锁定
                        domStyle.set(this.domNode,{
                            top:0
                        });
                        domConstruct.place(this.domNode,this.scrollable.domNode,"last");
                    }
                }else{
                    if(to.y+this.domNode.offsetTop>=0){
                        domStyle.set(this.domNode,"top",this._originTop);
                        domConstruct.place(this.domNode,this._nextNode,"before");
                    }
                }
            }
            //若锁定在底部
            if(this.isFixedBottom){
                if(this.domNode.parentNode!==this.scrollable.domNode){
                    if(to.y+this.domNode.offsetTop+this.domNode.clientHeight>0){
                        //锁定
                        domStyle.set(this.domNode,{
                            bottom:0,
                            position:"fixed"
                        });
                        
                        domConstruct.place(this.domNode,this.scrollable.domNode,"last");
                    }
                }else{
                    if(to.y+this.domNode.offsetTop+this.domNode.clientHeight<=0){
                        //domStyle.set(this.domNode,"top",this._originTop);
                        domStyle.set(this.domNode,{
                            bottom:this._originTop,
                            position:""
                        });
                        
                        domConstruct.place(this.domNode,this._nextNode,"before");
                    }
                }
            }
        },
        handleFix:function(to){
            clearTimeout(this._scrollFixTimer);
            this._scrollFixTimer = setTimeout(lang.hitch(this,function(){
                this._handleFix(to);
            }),100);
        }
    });
});