define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/connect",
    "dojo/_base/json",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/dom-construct",
    "dojo/query",
    "dijit/_WidgetBase",
    "dijit/registry",
    "cq/app/widget/mobile/item/FloorItem",
    "cq/widgets/item/mat/MatListItem",
    "cq/app/widget/show/SlideShow",
    "cq/util/config/config"
], function(declare, lang, array, connect, json, domAttr, domClass, domStyle, domConstruct, query, _WidgetBase, registry, FloorItem, MatListItem, SlideShow,config){
    return declare("", [_WidgetBase], {
        type:"",
        items:[],
        height:0,
        reg:/^H\d{1}$/gi,
        buildRendering:function(){
            this.domNode = domConstruct.create("div", {
                className:"cq-form-floor hflex"
            });
            if(this.items && this.items.provider){
                require([this.items.provider], lang.hitch(this, function(dataProvider){
                    dataProvider[this.items.action](json.fromJson(this.items.params) || {}).then(lang.hitch(this, function(data){
                        if(data&&data.data&&data.data.items){
                            this.items = data.data.items;
                            //for(var i = 0;i < parseInt(this.type.substring(1))&&i < this.items.length;i++){
                            //    var fi = new FloorItem(this.items[i]);
                            //    fi.placeAt(ics[i]);
                            //}
                            this._initFloor();
                        }else if(data&&data instanceof Array){
                            this.items = data;
                            this._initFloor();
                        }
                    }));
                }));
            }else{
                this._initFloor();
            }
        },
        _initFloor:function(){
            if(this.type == "hotsale" || this.type == "businessDynamic"){
                domClass.remove(this.domNode, "hflex");
            }
            this.createItemsContainer();
            this.createItems();
        },
        createItems:function(){
            var ics = query(".cq-form-ic", this.domNode);
            if("H1V2" == this.type || "H2V1" == this.type){// 左一右二或者左二右一
                for(var i = 0;i < 3;i++){
                    var fi = new FloorItem(this.items[i]);
                    domClass.add(fi.domNode,"item-"+i);
                    if("H1V2" == this.type&&i == 2){
                        fi.placeAt(ics[1]);
                    }else if("H2V1" == this.type && i > 0){
                        fi.placeAt(ics[i-1]);
                    }else {
                        fi.placeAt(ics[i]);
                    }
                    if(domClass.contains(fi.domNode.parentNode, "vflex")){
                        domClass.add(fi.domNode, "flex1");
                    }
                }
            }else if(this.type == "slideShow"){
                var fi = new SlideShow({
                    panelsHeight : this.height/2,
                    lazy : false,
                    auto : true,
                    playInterval : 5000,
                    srcField : "icon",
                    panelsWidth: document.body.offsetWidth
                });
                fi.placeAt(ics[0]);
                domStyle.set(ics[0], "width", "100%");
                var items = [];
                fi.items = this.items;
                fi.refresh();
                connect.connect(fi.domNode, "onclick", lang.hitch(this, function(evt){
                    if(evt.target.tagName != "IMG"){
                        return;
                    }
                    if(fi.items[fi._current].url && fi.items[fi._current].url.indexOf("#") == 0){
                        window.moveToView(fi.items[fi._current].url.substr(1));
                    }else if(fi.items[fi._current].url){
                        window.moveToView(fi.items[fi._current]);
                    }
                }));
            }else if(this.type.match(this.reg) || this.type.indexOf("-") >= 0){
                for(var i = 0;i < parseInt(this.type.substring(1))&&i < this.items.length;i++){
                    var fi = new FloorItem(this.items[i]);
                    fi.placeAt(ics[i]);
                }
            }else if(this.type == "hotsale"){
                if(this.items && this.items.length){
                    for(var i = 0;i < this.items.length;i++){
                        var item = this.items[i];
                        item.type = "hotsale";
                        item.url = "matDetail-" + item.hotSaleProduct[0].mId + "_" + item.hotSaleProduct[0].fromShopId._id;
                        item.retailPrice = item.hotSaleProduct[0].retailPrice;
                        item.title = item.hotSaleProduct[0].mName;
                        item.icon = item.hotSaleProduct[0].logo;
                        var fi = new FloorItem(item);
                        fi.placeAt(ics[i]);
                    }
                }
            }else if(this.type == "article"){
                console.log("==========article========")
                console.log(this.items[0]);
                console.log("==================")
                var fi = new FloorItem({
                    type:"article",
                    arts:this.items
                });
                fi.placeAt(ics[0]);
            }else if(this.type == "businessDynamic"){
                if(this.items && this.items.length){
                    for(var i = 0;i < this.items.length;i++){
                        var item = {};
                        item.type = "businessDynamic";
                        item.busData = {
                            name:this.items[i].fromShopId.shopName,
                            logo:this.items[i].fromShopId.logo||"../../images/mobile/user_userIcon.png",
                            town:this.items[i].fromShopId.town,
                            id:this.items[i].fromShopId._id
                        };
                        item.mats = this.items[i].mIds&&this.items[i].mIds.slice(0,3)||[];
                        var fi = new FloorItem(item);
                        fi.placeAt(ics[i]);
                    }
                }
            }else if(this.type == "matDetail"){
                if(this.items.length&&this.items.length>0){
                    domConstruct.create("div", {
                        innerHTML: '<a style="border-bottom:1px solid #e5e5e5;" href="#resultMatList-group_'+this.items[0].groupId._id+'" class="mat-item-cells"><div class="white-background main-header item-cell"><div class="flex1 "><div class="hflex main-header-title"><div class="flex1">'+this.items[0].groupId.gName+'</div></div></div><div><span>更多</span></div></div></a>'
                    }, ics[0]);
                }
                for(var i = 0;i < this.items.length;i++){
                    var fi = new MatListItem({data:this.items[i]});
                    fi.placeAt(ics[0]);
                }
            }
        },
        createItemsContainer:function(){
            if("H1V2" == this.type || "H2V1" == this.type){
                for(var i = 0;i < 2;i++){
                    domConstruct.create("div", {
                        className:"cq-form-ic" + ((("H1V2"==this.type && i == 1)||("H2V1"==this.type && i == 0))?" vflex":"") + (" "+this.type+i)//,
                        //style:"height:400px;"
                    }, this.domNode);
                }
            }else if(this.type.indexOf("-")>=0){
                for(var i = 0;i < 2;i++){
                    domConstruct.create("div", {
                        className:"cq-form-ic" + (((this.type.substr(this.type.indexOf("-")+1)=="3,2"&&i==0)||(this.type.substr(this.type.indexOf("-")+1)=="2,3"&&i==1))?" flex3":" flex2")
                    }, this.domNode)
                }
            }else if(this.type == "slideShow"){
                domConstruct.create("div", {
                    className:"cq-form-ic"
                }, this.domNode);
            }else if(this.type.match(this.reg)){
                for(var i = 0;i < parseInt(this.type.substring(1));i++){
                    domConstruct.create("div", {
                        className:"cq-form-ic flex1"
                    }, this.domNode);
                }
            }else if (this.type == "hotsale"){
                // ic num = this.items.length width = 50%
                if(this.items && this.items.length){
                    for(var i = 0;i < this.items.length;i++){
                        domConstruct.create("div", {
                            className:"cq-form-ic half-width"
                        }, this.domNode);
                    }
                }
            }else if(this.type == "businessDynamic"){
                if(this.items && this.items.length){
                    for(var i = 0;i < this.items.length;i++){
                        domConstruct.create("div", {
                            className:"cq-form-ic",
                        }, this.domNode);
                    }
                }
            }else if(this.type == "article"){
                domConstruct.create("div", {
                    className:"cq-form-ic",
                    style:"height:60px;position:relative;overflow:hidden;width:100%;"
                }, this.domNode);
            }else if(this.type == 'matDetail'){
                domConstruct.create("div", {
                    className:"cq-form-ic",
                    style:"text-align:inherit;width:100%;"
                }, this.domNode);
            }
        }
    });
});
