define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/connect",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/dom-construct",
    "dojo/query",
    "dijit/_WidgetBase",
    "dijit/registry"
], function(declare, lang, array, connect, domAttr, domClass, domStyle, domConstruct, query, _WidgetBase, registry){
    return declare("", [_WidgetBase], {
        type:"",
        icon:"",
        title:"",
        town:"",
        url:"",
        mats:[],
        busData:{},
        retailPrice:"",
        arts:{},
        buildRendering:function(){
            this.domNode = domConstruct.create("div", {
                className:"cq-form-floorItem"
            });
            connect.connect(this.domNode, "onclick", lang.hitch(this, this.onClick));
            this._initItem();
        },
        _initItem:function(){
            if(this.type == "businessDynamic"){
                // 商家信息区域
                var busNode = this.busNode = domConstruct.create("div", {
                    className:"hflex flootItem-bus"
                },this.domNode);
                var busLogo = this.busLogo = domConstruct.create("img", {
                    style:"width:45px;",
                    src:this.busData.logo
                }, domConstruct.create("div", {
                }, busNode));
                var busInfo = this.busInfo = domConstruct.create("div", {
                    className:"flex1",
                    style:"margin-left:3%;"
                }, busNode);
                var busName = this.busName = domConstruct.create("div", {
                    style:"font-size:18px;",
                    innerHTML:this.busData.name
                }, busInfo);
                var busTown = this.busTown = domConstruct.create("div", {
                    innerHTML:this.busData.town,
                    style:"margin-top:10px;font-size:12px;",
                    className:"hflex"
                }, domConstruct.create("div", {
                }, busInfo));
                // 商品展示区域
                var matsNode = this.matsNode = domConstruct.create("div", {
                    className:"hflex floorItem-mats"
                },this.domNode);
                var matNodeLeft = this.matNodeLeft = domConstruct.create("div", {
                    className:"flex2"
                }, matsNode);
                var matNodeRight = this.matNodeRight = domConstruct.create("div", {
                    className:"flex1"
                }, matsNode);
                for(var index = 0;index < this.mats.length;index++){
                    var node = index==0?matNodeLeft:matNodeRight;
                    var imgNode = domConstruct.create("img",{
                        style:"width:100%;",
                        src:this.mats[index].logo,
                        mid:this.mats[index].mId
                    },node);
                }
            }else if(this.type == "article"){
                domClass.add(this.domNode, "floorItem-roll" + Math.ceil(this.arts.length/2));
                for(var index = 0;index < this.arts.length;index++){
                    var a = domConstruct.create("a", {
                        // innerHTML:this.arts[index].title,
                        style:"width:100%;display:block;margin-left:20px;height:30px;line-height:30px;",
                        onclick:"window.moveToView('trendDetail', '" + this.arts[index]._id + "')",
                        href:"javascript:void(0);"
                    }, this.domNode);
                    var groupNode = domConstruct.create("span", {
                        innerHTML:this.arts[index].groupId.groupName,
                        style:"width:70px;border-radius:10px;border:2px solid #FF5722;display: inline-block;height: 20px;line-height: 20px;text-align: center;"
                    }, a);
                    var artlabel = domConstruct.create("span", {
                        innerHTML:this.arts[index].title,
                        style:"height:30px;line-height:30px;margin-left:8px;"
                    }, a);
                }
            }else{
                var imgNode = this.imgNode = domConstruct.create("img", {
                    className:"floorItem-img",
                    src:this.icon
                }, this.domNode);
                var textNode = this.textNode = domConstruct.create("div", {
                    className:"floorItem-text "+(!this.title&&"hide")
                }, this.domNode);
                var titleNode = this.titleNode = domConstruct.create("div", {
                    className:"floorItem-title",
                    innerHTML:this.title
                }, this.textNode);
                if(this.type == "hotsale"){
                    var priceNode = this.priceNode = domConstruct.create("div", {
                        className:"floorItem-price",
                        innerHTML:"￥：" + this.retailPrice
                    }, this.textNode);
                }
            }
        },
        onClick:function(evt){
            var target = evt.target;
            if(this.url){
                if(this.url.indexOf("#") == 0){
                    window.moveToView(this.url.substring(1));
                } else if(this.url.indexOf("javascript:") == 0){
                    var str = this.url.split("javascript:")[1];
                    eval(str);
                }else {
                    window.moveToView(this.url);
                }
            }else if(this.type == "businessDynamic"){
                if(this.busNode.contains(target)){
                    window.moveToView("supplyBus-" + this.busData.id);
                }else if(target.tagName == "IMG"){
                    window.moveToView("matDetail-" + domAttr.get(target, "mid") + "_" + this.busData.id);
                }
            }else if(this.type == "article"){
                
            }
        }
    });
});
