﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dijit/_Widget",
    "../../_WidgetBase"
],function(declare,lang,domConstruct,_Widget,_CqWidgetBase){
    
    return declare("",[_Widget,_CqWidgetBase],{
        htmlTemp:'<div id="{id}" class="flex1 {className}" data-dojo-type="cq/app/widget/mobile/menu/ExternalButton" data-dojo-props="label:\'{label}\',labelClass:\'{labelClass}\',icon:\'{icon}\',iconClass:\'{iconClass}\'"></div>',
        label:"",
        labelClass:"",
        icon:"",
        iconClass:"",
        buildRendering:function(){
            this.inherited(arguments);
            if(this.icon){
                this.iconArea = domConstruct.create("div",{
                    "class":"full-width h-center"
                },this.domNode);
                this.iconNode = domConstruct.create("img",{
                    style:"display:inline-block;",
                    "class":this.iconClass||"",
                    src:this.icon
                },this.iconArea);
            }
            this.labelNode = domConstruct.create("div",{
                "class":"full-width h-center "+(this.labelClass||""),
                innerHTML:this.label||""
            },this.domNode);
            this.bindData();
        },
       
        setTitle:function(title){
            this.labelNode.innerHTML = title;
        },
        
        bindData:function(){
            var data;
            if(this.dataProvider&&this.dataMethod){
                var dataMethod = this.dataMethod;
                var _this = this;
                if(lang.isString(this.dataProvider)){
                    require([this.dataProvider],lang.hitch(this,function(dataProvider){
                        this.dataProvider = dataProvider;
                        data = this.dataProvider[dataMethod](_this);
                        if(data&&data.then){
                        data.then(lang.hitch(this,function(item){
                                this.initPrompt(item);
                            }));
                        }else{
                            this.initPrompt(data);
                        }
                    }));
                    
                }else{
                    
                }
                
            }
        },
        initPrompt:function(item){
            if(item){
                domConstruct.create("div",{
                    "class":"button-promat",
                    style:"border-radius:20px; width: 20px;height: 20px;border: 1px solid red;display: inline-block;line-height: 20px;text-align: center;position: absolute;top:0px;background-color: red;",innerHTML:item
                },this.domNode);
            }
        }
    });
});