﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    "cq/util/sys/date"
],function(declare,lang,domStyle,_WidgetBase,_TemplatedMixin,date){
    props = "deadLine:{deadLine}";
    return declare("",[_WidgetBase,_TemplatedMixin],{
        htmlTemp:"<div id='{id}' data-dojo-type='cq/app/widget/show/DeadLine' data-dojo-props='"+props+"'></div>",
        templateString:"<div data-dojo-attach-point='domNode' class='deadLineContainer'>"+
            '<span class="d" data-dojo-attach-point="dayNode"></span>'+
            '<span data-dojo-attach-point="dayLabelNode">天</span>'+
            '<span class="h" data-dojo-attach-point="hourNode">00</span>'+
            ':<span class="m" data-dojo-attach-point="minuteNode">00</span>'+
            ':<span class="s" data-dojo-attach-point="secondNode">00</span>'+
        "</div>",
        buildRendering:function(){
            this.inherited(arguments);
            this.setDeadLine(this.deadLine);
        },
        setDeadLine:function(deadLine){
            this.deadLine = deadLine;
            if(this.deadLine&&"string"===typeof(this.deadLine)){
                this.deadLine = new Date(this.deadLine);
            }
            this.updateInfo();
        },
        _timer:null,
        updateInfo:function(){
            clearTimeout(this._timer);
            var now = new Date(date.nowISOString());
            if(this.deadLine&&now<this.deadLine){
                var span = this.deadLine-now,remain = 0;
                //秒
                span = Math.floor(span/1000);
                remain = span%60;
                this.secondNode.innerHTML = (remain<10?"0":"")+remain;
                //分钟
                span = (span-remain)/60;
                remain = span%60;
                this.minuteNode.innerHTML = (remain<10?"0":"")+remain;
                //小时
                span = (span-remain)/60;
                remain = span%24;
                this.hourNode.innerHTML = (remain<10?"0":"")+remain;
                //天
                span = span-remain;
                span = span/24;
                this.dayNode.innerHTML = span;
                
                domStyle.set(this.dayNode,"display",span?"":"none");
                domStyle.set(this.dayLabelNode,"display",span?"":"none");
                
                this._timer = setTimeout(lang.hitch(this,this._updateInfo),1000);
            }
        },
        _updateInfo:function(){
            if((new Date(date.nowISOString()))>=this.deadLine){
                this.timeEnd();
            }else{
                this.updateInfo();
            }
        },
        timeEnd:function(){
            
        },
        destroyRecursive:function(){
            this.inherited(arguments);
            if(this._timer){
                clearTimeout(this._timer);
            }
        }
    });
});