define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojo/touch",
    "dijit/_TemplatedMixin",
    "dojox/mobile/View",
    "cq/app/config",
    "cq/util/config/config"
],function(declare,lang,domStyle,touch,_TemplatedMixin,View,config,configUtil){
    var Drawer = declare("",[View,_TemplatedMixin],{
        templateString:'<div data-dojo-attach-point="domNode">'+
            '<div data-dojo-attach-point="leftPaneNode" class="drawer-left">'+
                '<div data-dojo-attach-point="containerNode"></div>'+
            '</div>'+
            '<div data-dojo-attach-point="rightPaneNode">'+
                '<div data-dojo-attach-point="refContainerNode"></div>'+
                '<div data-dojo-attach-point="coverNode"></div>'+
            '</div>'+
        '</div>',
        //自己隐藏时是否要隐藏右侧view
        hideRefOnHide:true,
        //初始化
        buildRendering:function(){
            this.inherited(arguments);
            domStyle.set(this.leftPaneNode,{
                width:"90%",
                height:"100%",
                "verticle-align":"top",
                "display":"inline-block"
            });
            domStyle.set(this.containerNode,{
                width:"100%",
                height:"100%"
            });
            domStyle.set(this.rightPaneNode,{
                width:"10%",
                height:"100%",
                background:"rgb(242, 242, 242)",
                position:"relative",
                display:"inline-block",
                "verticle-align":"top",
                "overflow":"hidden"
            });
            domStyle.set(this.coverNode,{
                width:"100%",
                height:"100%",
                left:0,
                top:0,
                position:"absolute",
                "z-index":999,
                background:"#000",
                opacity:0.1
            });
            // this.connect(this.coverNode,"onclick",function(){
                // this.hideRefOnHide = false;
                // this.hide();
                // this.onAfterTransitionOut();
            // });
            
            this.own(touch.press(this.domNode,lang.hitch(this,function(e){
                //记录开始滑动时的坐标
                this.draging = true;
                this.leftOldWidth = this.leftPaneNode.clientWidth;
                this.touchStart = true;
                //记录屏幕宽度
                this.viewWidth = this.domNode.clientWidth;
                this.startCoordinate = {
                    x:e.touches&&e.touches[0]?e.touches[0].pageX:e.pageX,
                    y:e.touches&&e.touches[0]?e.touches[0].pageY:e.pageY
                };  
            })));
            this.own(touch.move(this.domNode,lang.hitch(this,function(e){
                this.moveCoordinate = {
                    x:e.touches&&e.touches[0]?e.touches[0].pageX:e.pageX,
                    y:e.touches&&e.touches[0]?e.touches[0].pageY:e.pageY
                };
                
                if(!this.parent&&Math.abs(this.moveCoordinate.y-this.startCoordinate.y)-Math.abs(this.moveCoordinate.x-this.startCoordinate.x)>10){
                    //console.log("aaa");
                    return;
                }
                if(this.draging){
                    //滑动后右侧抽屉将要实现的宽度值
                    var leftWidth = this.leftPaneNode.clientWidth-(this.startCoordinate.x-this.moveCoordinate.x);
                    
                    this.touchStart = false;
                    this.startCoordinate = lang.clone(this.moveCoordinate);    
                    if(leftWidth>this.leftOldWidth){
                        //如果将要实现的值大于最初的值
                        return;
                    }else{
                        this.percent = Math.round(leftWidth/this.viewWidth*100);
                        if(this.percent>Math.round(this.leftOldWidth/this.viewWidth*100)){
                            return;
                        }else{
                            if(0<this.percent){
                                this.leftPaneNode.style.width = this.percent+"%";
                                this.rightPaneNode.style.width = (100-this.percent)+"%";   
                            }else{
                                // this.isOpened = false;
                                // this.hideRefOnHide = false;
                                // this.hide();
                                // this.onAfterTransitionOut();
                                // this.leftPaneNode.style.width = "90%";
                                // this.rightPaneNode.style.width = "9%";
                                //alert(this.percent);
                                this.hideDawer();
                            }       
                        } 
                    }
                }
            })));
            this.own(touch.release(this.domNode,lang.hitch(this,function(){
                this.draging = false;
                // if(!this.firstMove){
                    // return;
                // }
                if(this.percent&&0<this.percent&&this.percent<60){
                    //alert(this.percent);
                    //alert("aaa");
                    // this.isOpened = false;
                    // this.hideRefOnHide = false;
                    // this.hide();
                    // this.onAfterTransitionOut();
                    // this.leftPaneNode.style.width = "90%";
                    // this.rightPaneNode.style.width = "9%";
                    this.hideDawer();
                }else{
                    this.leftPaneNode.style.width = "90%";
                    this.rightPaneNode.style.width = "10%";
                }
            })));
            this.connect(this.coverNode,"onclick",lang.hitch(this,function(){
                if(!this.percent||this.percent>=60){
                    this.hideDawer();
                }
            }));
            
        },
        //隐藏view之后的操作
        onAfterTransitionOut:function(){
            //若隐藏自己之后需要隐藏refView，执行隐藏操作
            if(this.hideRefOnHide){
                this.refView.hide();
            }
            this.leftView.hide();
            this.leftView.placeAt(this.domNode,"before");
            //恢复refView的原来位置
            this.refView.placeAt(this.domNode,"after");
        },
        showDawer:function(viewId,refView){
            this.isOpened = true;
            if(refView.domNode.parentNode===this.rightPaneNode){
                return;
            }
            this.hideRefOnHide = true;
            //初始化自己的内容
            this.containerNode.innerHTML = this.refContainerNode.innerHTML = "";
            //将右侧内容方到右侧容器中
            this.refView = refView;
            this.placeAt(refView.domNode,"before");
            domStyle.set(this.refContainerNode,"width",domStyle.get(this.refView.domNode,"width")+"px");
            this.refContainerNode.appendChild(this.refView.domNode);
            domStyle.set(this.domNode,"display","none");
            this.show();
            //加载左侧内容
            config.getLayoutView(viewId,this.containerNode).then(lang.hitch(this,function(view){
                this.leftView = view;
                this.addChild(view);
                //设置左侧内容区域的宽度值使其overflow属性起作用  郭周全  2017-03-03
                this.leftView.domNode.style.width = this.leftPaneNode.clientWidth+"px";
                //执行初始化操作
                view.showView([],"");
                this.resize();
            }));
        },
        hideDawer:function(){
            this.isOpened = false;
            this.hideRefOnHide = false;
            this.hide();
            this.onAfterTransitionOut();
            this.leftPaneNode.style.width = "90%";
            this.rightPaneNode.style.width = "10%";
        },
        isCqOpened:function(){
            return this.isOpened;
        },
        cqHide:function(){
            this.hideDawer();
        }
        
    });
    var drawer = new Drawer();
    // 将本对象记录到一个cover的管理对象中
    configUtil.coverWdigets = configUtil.coverWdigets||[];
    configUtil.coverWdigets.push(drawer);
    return drawer;
});