//购物车对象
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/on",
    "dojo/dom-attr",
	'dojo/dom-construct',
    "dojo/dom-class",
	"dojo/dom-style",
    "dojo/Deferred",
    "dojo/store/JsonRest",
    "dijit/_WidgetBase",
	'dstore/Memory',
	'dstore/Trackable',
	"dstore/Rest",
	"dstore/Cache",
	'dgrid/OnDemandGrid',
	'dgrid/Selector',
	'dgrid/extensions/DijitRegistry',
	'dgrid/extensions/Pagination',
	'dgrid/extensions/ColumnResizer',
    "cq/app/widget/_WidgetBase",
    "cq/app/widget/web/SearchBox",
    "cq/app/widget/web/List",
    "cq/app/widget/web/item/Label",
    "cq/util/sys/xlsx",
    "cq/util/sys/date",
    "../utils/listLayout"
], function (declare, lang, array, on,domAttr,domConstruct, domClass, domStyle, Deferred,JsonRest, _WidgetBase, Memory, Trackable,Rest,Cache, OnDemandGrid,Selector,DijitRegistry,Pagination,ColumnResizer, cqWidgetBase,SearchBox,List,Label,xlsx,date,listLayout) {

    /*var props = "states:{j:states},stateField:{stateField},exportLayoutMethod:'{exportLayoutMethod}',"+
        "label:'{label}',"+
        "addLabel:'{addLabel}',addTarget:'{addTarget}',"+
        "enableImport:'{enableImport}',importMethod:'{importMethod}',"+
        "dataProvider:'{dataProvider}',"+
        "targetMethod:'{targetMethod}',queryParamMethod:'{queryParamMethod}',"+
        "clickMethod:'{clickMethod}',"+
        "gridLayoutMethod:'{gridLayoutMethod}',"+
        "enableSearch:'{enableSearch}',searchField:'{searchField}'";*/
		
		var props = "exportLayoutMethod:{exportLayoutMethod},"+
        "label:{label},"+
        "addLabel:{addLabel},addTarget:{addTarget},"+
        "enableImport:{enableImport},importMethod:{importMethod},"+
        "dataProvider:{dataProvider},"+
        "targetMethod:{targetMethod},queryParamMethod:{queryParamMethod},"+
        "clickMethod:{clickMethod},"+
        "gridLayoutMethod:{gridLayoutMethod},"+
        "enableSearch:{enableSearch},searchField:{searchField},states:{states},stateField:{stateField}";
    
    return declare("",[_WidgetBase, cqWidgetBase], {
        baseClass:"cq-dg",
        //由第三方提供数据
        dataProvider:"",
        //数据提供者提供加载数据的方法
        targetMethod:"",
        //获取listItem属性的方法
        gridLayoutMethod:"",
		//导入自定义layout结构
		exportLayoutMethod:"",
        queryParamMethod:"",
		
		//批量导入的功能
		enableImport:false,
		importMethod:"",
        
        //添加按钮
		addTarget:"",
        addLabel:"",
        
        //搜索框功能
        enableSearch:false,
        searchField:"",
        
        //配置状态栏
        states:null,
        stateField:"",
        
		clickMethod:"",
        
        htmlTemp: '<div id="{id}" class="{gridClass}" data-dojo-type="cq/app/widget/web/DGrid" data-dojo-props="'+props+'"><div></div></div>',
        //当监听到其他对象变化时，刷新本对象
        cqRefresh:function(){
            this.refresh();
        },
		refresh:function(){
            var query = {};
            if(this.dataProvider[this.queryParamMethod]){
                query = this.dataProvider[this.queryParamMethod](this.cqRefInfo);
                this.queryParam = query;
                var url = this.dataProvider[this.targetMethod]();
                
                for(var p in query){
					if(url.indexOf("?")<=0) {
						url+="?";
						if(query[p]!=undefined) url += p+"="+encodeURIComponent(query[p]);
					}else if(query[p]!=undefined) url += "&"+p+"="+encodeURIComponent(query[p]);
                }
                this.store.target = url;
                this.grid.set("collection",this.store);
                this.grid.resize();
            }else{
                this._refreshOnReady = true;
            }
		},
        _onDataProviderReady:function(dataProvider){
            this.dataProvider = dataProvider;
			var url = this.dataProvider[this.targetMethod]();
			if(url.indexOf("?")<=0) url+="?__xx=xx";
			this.store = new declare([ Rest, Trackable, Cache ])({idProperty:"_id",target:url,useRangeHeaders: true,sortParam:"orderBy"});
			// Instantiate grid
			var cols = this.gridCols = listLayout.initLayoutFormatter(this.dataProvider[this.gridLayoutMethod]()).map(function(col){
                col.type = "text";
                return col;
            });
			this.grid = this.gridCols = new (declare([OnDemandGrid,ColumnResizer,Selector]))({
				//collection: store,
				rowsPerPage:30,
				keepScrollPosition:true,
				//allowSelectAll: true,
				columns: cols
			}, this.domNode.firstChild);
			this.grid.on('.dgrid-cell:click', lang.hitch(this,function (event) {
				if(event&&event.target && this.clickMethod){
					var row = this.grid.row(event.target);
					if(!row) return;
					this.dataProvider[this.clickMethod](row.data,this.getActionByNode(row.element,event.target),this);
				}
			}));
			this.grid.startup();
            this.opBarNode = domConstruct.create("div",{
                "class":"op-bar"
            },this.domNode,"first");
			domConstruct.create("div",{
				className:"button grid-export",
				innerHTML:"导出EXCEL",
				onclick:lang.hitch(this,function(){
                    this.onExportXlsx();
                })
			},this.opBarNode,"first");
			this.setEnableImport(this.enableImport);
			this.setAddTarget(this.addTarget);
            this.initSearchBox(this.enableSearch);
            this.initStatesList();
            if(this._refreshOnReady){
                this._refreshOnReady = false;
                this.refresh();
            }
        },
        //导出xlsx文件的事件
        onExportXlsx:function(){
            var layout = this.gridCols;
            //获取导出格式的接口可以直接接管导出动作
            if(this.dataProvider&&this.exportLayoutMethod&&this.dataProvider[this.exportLayoutMethod]){
                layout = this.dataProvider[this.exportLayoutMethod](this.grid.collection.target,{
                },layout,Date.now().toString());
            }
            //若有导出格式方法，但是没有返回具体格式，认为数据对象已执行导出动作
            if(layout&&layout.length){
                xlsx.exportData(this.grid.collection.target,{
                },layout,Date.now().toString());
            }
        },
		setEnableImport:function(enableImport){
			this.enableImport = enableImport!==false&&enableImport!=="false"&&enableImport!=="";
			if(!this._importBtn){
				this._importBtn = domConstruct.create("div",{
					className:"button",
					innerHTML:"批量导入",
					onclick:lang.hitch(this,this.onImport)
				},this.opBarNode,"first");
			}
			domStyle.set(this._importBtn,"display",this.enableImport?"":"none"); 
		},
		setAddTarget:function(target){
			this.addTarget = target;
			if(!this._addBtnNode){
				this._addBtnNode = domConstruct.create("a",{
					className:"button",
					innerHTML:this.addLabel||"新增"
				},this.opBarNode,"first");
			}
			if(this.addTarget){
				domStyle.set(this._addBtnNode,"display","");
				this._addBtnNode.href = this.addTarget;
			}else{
				domStyle.set(this._addBtnNode,"display","none");
			}
		},
        initSearchBox:function(){
            this.enableSearch = this.enableSearch!==false&&this.enableSearch!=="false"&&this.enableSearch!=="";
            if(this.enableSearch){
				var searchBox = new SearchBox();
                searchBox.placeAt(this.opBarNode,"first");
                this.observe(searchBox,this.searchField);
			}
        },
        initStatesList:function(){
            if(this.states){
                if("string"===typeof(this.states)){
                    this.states = JSON.parse(this.states);
                }
                var stateslist = new List({
                    items:this.states,
                    itemType:"Label",
                    workMode:"single",
                    "class":"cq-list",
                });
                stateslist.placeAt(this.opBarNode,"first");
                this.observe(stateslist,this.stateField);
                
                stateslist.cqRefresh();
            }
        },
		onImport:function(){
			if(this.dataProvider&&this.importMethod&&this.dataProvider[this.importMethod]){
				this.dataProvider[this.importMethod](this);
			}else{
				alert("配置错误");
			}
		},
        removeItemByData:function(data){
            if(data){
				var row = this.grid.row(data._id);
				if(!row) return;
				this.grid.removeRow(row);
            }
        },
        refreshItemByData:function(data){
            if(data){
				var row = this.grid.row(data._id);
				if(!row) return;
                lang.mixin(row.data,data);
				this.grid.insertRow(row.data,this.grid.contentNode,row.element,row.rowIndex);
            }
        },
        getActionByNode:function(range,node){
            var action = "";
            while(node&&node.parentNode&&node!==range){
                action = domAttr.get(node,"cq-action");
                if(action){
                    break;
                }
                node = node.parentNode;
            }
			return action;
        },
        postCreate : function () {
			this.inherited(arguments);
            if(this.dataProvider){
                //有数据提供者，初始化数据提供者
                if(lang.isString(this.dataProvider)){
                    require([this.dataProvider],lang.hitch(this,this._onDataProviderReady));
                }else{
                    this._onDataProviderReady(this.dataProvider);
                }
            }
			else{
				this._onDataProviderReady();
			}
        }
    });
});
