﻿define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/lang",
    "dojo/dom-attr",
    "dojo/dom-style",
    "dojo/dom-class",
    "dojo/Deferred",
    "dojo/query",
    "dojo/topic",
    "dijit/_WidgetBase",
    "dijit/focus",
    "../_WidgetBase",
    "../_LayoutMixin"
],function(declare,array,lang,domAttr,domStyle,domClass,Deferred,query,topic,_WidgetBase,focus,_CqWidgetBase,_LayoutMixin){
    var propStr = 'layout:{j:layout},editorEnterMethod:"{editorEnterMethod}",fieldChangeMethod:"{fieldChangeMethod}",reloadMethod:"{reloadMethod}",objsEditor:"{objsEditor}",idInfoMap:{j:idMap},actionStateMethod:"{actionStateMethod}",initMethod:"{initMethod}",dataProvider:"{dataProvider}",layoutMethod:"{layoutMethod}",layoutType:"{layoutType}"';
    return declare("",[_WidgetBase,_LayoutMixin],{
        htmlTemp:"<div id='{id}' class='cq-area {className}' data-dojo-type='cq/app/widget/web/DataLayout' data-dojo-props='"+propStr+"'></div>",
        dataProvider:"",
        objsEditor:null,
        layoutMethod:"",
        reloadMethod:"",
        fieldChangeMethod:"",
        editorEnterMethod:"",
        initMethod:"",
        // 张松       布局方式，如表格布局      2016/11/8
        layoutType:"",
        
        preventScroll:true,
        //防止点击按钮
        preventClick:true,
        
        buildRendering:function(){
            if(this.layout&&"string"===typeof(this.layout)){
                this.layout = JSON.parse(this.layout);
            }
            this.inherited(arguments);
        },
        loadLayout:function(){
            this.actionsHash = {};
            var def = null;
            if(this.dataProvider&&this.layoutMethod){
                if(!lang.isString(this.dataProvider)){
                    return this.dataProvider[this.layoutMethod]();
                }
                def = new Deferred();
                require([this.dataProvider],lang.hitch(this,function(dataProvider){
                    this.dataProvider = dataProvider;
                    var data = this.dataProvider[this.layoutMethod]();
                    if(data&&data.then){
                        data.then(function(result){
                            def.resolve(result);
                        });
                    }else{
                        data = this.dataConversion(data);
                        def.resolve(data);
                    }
                }));
            }else{
                if(!this.dataProvider){
                    return this.inherited(arguments);
                }
                def = new Deferred();
                if(lang.isString(this.dataProvider)){
                    require([this.dataProvider],lang.hitch(this,function(dataProvider){
                        this.dataProvider = dataProvider;
                        def.resolve(this.layout);
                    }));
                }else{
                    def.resolve(this.layout);
                }
            }
            return def;
        },
        bindActionElementEvent:function(node){
            var action = domAttr.get(node,"cq-action");
            if(action){
                this.actionsHash[action] = {};
                this.fieldHandlers.push(this.connect(node,"onclick",function(e){
                    //赵春辉   处理鼠标坏了的情况   2018-12-12
                    //立即执行，600ms内不做响应
                    if(node.datalayoutclicking){
                        return ;
                    }
                    node.datalayoutclicking = true;
                    setTimeout(function(){
                        node.datalayoutclicking = false;
                    },600);
                    this._onActionClick(node,action,e);
                }));
                this.inherited(arguments);
            }
        },
        _onActionClick:function(node,action,e){
            //两个dataLayout嵌套是内层没有dataProvider的问题
            try{
                if(!this.dataProvider){
                    //this.dataProvider = this.getUpDataLayout().dataProvider;
                    this.dataProvider = this.getRootDataLayout().dataProvider;
                }
                if(!this.preventClick){
                    if(!domClass.contains(node,"disabled")){
                        // 强制让最后的填写的节点失去焦点，避免获取到不完整的数据
                        if(focus.curNode){
                            focus.curNode.blur();
                        }
                        this.dataProvider[action](this.getData(),this,e);
                    }
                }
            }catch(e){
            }finally{
                if(window.checkFree){
                    setTimeout(function(){
                        window.checkFree();
                    },600);
                }
            }
        },
        layoutLoaded:false,
        
        onLayoutReady:function(){
            this.layoutLoaded = true;
            
            this.inherited(arguments);
            if(this.autoRefresh){
                this.cqRefresh();
            }
        },
        
        
        cqRefresh:function(){
            this.autoRefresh = false;
            if(!this.layoutLoaded){
                this.autoRefresh = true;
                return;
            }
            if(this.initMethod&&this.dataProvider){
                if(this.dataProvider[this.initMethod]){
                    this.preventClick = true;
                    var data = this.dataProvider[this.initMethod](this.cqRefInfo);
                    if(data&&data.then){
                        data.then(lang.hitch(this,function(initData){
                            this.setData(initData);
                        }));
                    }else{
                        this.setData(data);
                    }
                }else{
                    this.autoRefresh = true;
                }
            }else{
                this.inherited(arguments);
            }
        },
        setData:function(data){
            this._penddingChange = [];
            this.inherited(arguments);
            if(this.dataProvider&&this.dataProvider[this.reloadMethod]){
                this.dataProvider[this.reloadMethod](this);
            }
            this.preventClick = false;
            var _penddingChange = this._penddingChange;
            this._penddingChange = [];
            while(_penddingChange.length){
                this.onWidgetFieldChanged.apply(this,_penddingChange.shift());
            }
        },
        onWidgetFieldChanged:function(widget,field,value){
            if(this.preventClick&&this._penddingChange){
                this._penddingChange.push(arguments);
            }else{
                this.inherited(arguments);
                if(this.dataProvider&&this.dataProvider[this.fieldChangeMethod]){
                    this.dataProvider[this.fieldChangeMethod](this,field&&field.join?field.join(","):field,value);
                }
            }
        },
		//添加回车登陆
        onTextEditorEnter:function(widget,field,value){
            widget.blur();
            if(this.dataProvider&&this.dataProvider[this.editorEnterMethod]){
                this.dataProvider[this.editorEnterMethod](this,field,value);
            }
        },
        //更改人：郭周全  新页面布局定义的数据格式转换,使写法与之前保持一致 2016/11/21
        //steps页面布局数据格式转换方法
        dataConversion :function(rawData){
            var datas=[];
            for(var i=0;i<rawData.length;i++){
                var item = rawData[i];
                if(item.steps!=="steps") continue;
                var newData={
                    dojoType:"cq/app/widget/web/Steps",
                    field:"steps",
                    formClass:"table-clas",
                    steps:{
                        stepsTags:[],
                        stepsFields:[],
                        stepsBtns:[]
                    }   
                };
                for(var j=0;j<item.tags.length;j++){
                    var tagObj = {type:"action",label:item.tags[j]};
                    newData.steps.stepsTags.push(tagObj);
                    newData.steps.stepsFields.push({
                        fields:[],
                        type:"tagFields",
                        tag:tagObj.label
                    });
                }
                for(var k=0;k<item.fields.length;k++){
                    if(item.fields[k].tag){
                        for(var l=0;l<newData.steps.stepsFields.length;l++){
                             if(item.fields[k].tag===newData.steps.stepsFields[l].tag){
                                newData.steps.stepsFields[l].fields.push(item.fields[k]);
                            }
                        }
                        
                    }else{
                      newData.steps.stepsBtns.push(item.fields[k]);
                    }
                }
                array.forEach(newData.steps.stepsFields,function(stepsField){
                    delete stepsField.tag;
                });
                rawData.splice(i,1,newData);
            }
            return rawData;
        },
        getObjs:function(){
            var parent = this.getParent();
            while(parent&&!parent.isObjsEditor){
                parent = parent.getParent();
            }
            return parent||null;
        },
        getUpDataLayout:function(){
            var parent = this.getParent();
            while(parent&&!parent.isDataLayout){
                parent = parent.getParent();
            }
            return parent||null;
        },
        getRootDataLayout:function(){
            var parent = this.getParent();
            while(parent&&!parent.isDataLayout){
                parent = parent.getParent();
            }
            if(parent){
                var rootNode = parent.getParent();
                while(rootNode&&!rootNode.isDataLayout){
                    rootNode = rootNode.getParent();
                }
                parent = rootNode?rootNode:parent;
            }
            return parent||null;
            
        },
        //通过groupId获取节点
        getGroupByGroupId:function(groupId){
            return this.groupIdToElement[groupId];
        }
    });
});