define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/connect",
    "dojo/_base/event",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojo/dom-construct",
    "dojo/dom-class",
    "dojo/query",
    "dijit/_WidgetBase",
    "dojo/dom-attr",
    "dojo/on",
    "dojo/touch",
    "dojo/DeferredList",
    "cq/util/css/transformUtil",
    "../_WidgetBase",
    "../_LayoutMixin",
    "cq/widgets/bigImg",
    "bob/user/consumer",
    "cq/util/config/config"
],function(declare, array, connect, event, lang, domStyle, domConstruct, domClass, query, _WidgetBase, domAttr, on, touch, DeferredList, transformUtil, _CqWidgetBase, _LayoutMixin, bigImg, consumer, config){
    var propStr = 'settingView:"{settingView}",autoRefresh:"{autoRefresh}",dataProvider:"{dataProvider}",hField:"{hField}",vField:"{vField}",dataMethod:"{dataMethod}"';
    return declare("", [_WidgetBase,_LayoutMixin], {
        htmlTemp:"<div id='{id}' class='cq-area {className}' data-dojo-type='cq/app/widget/web/ImageDisplay' data-dojo-props='"+propStr+"'></div>",
        autoRefresh:true,
        dataProvider:"",
        hField:null,
        vField:null,
        dataMethod:"",
        settingView:"",
        currPos:{x:0,y:0},
        getCurrentData:function(){
            return 
        },
        buildRendering:function(){
            var _this = this;
            this.inherited(arguments);
            var parent = this.getParent();
            while(!parent.showView){
                if(parent.allowNestedScrolls){
                    parent.domNode.appendChild(this.domNode);
                }
                parent = parent.getParent();
            }
            // 第一次进入该页面，有可能该页面还没有初始化完成，页面宽度为0，所以使用父节点的宽高
            parent = parent.getParent();
            var offsetHeight = parent.domNode.offsetHeight;
            var offsetWidth = parent.domNode.offsetWidth;
            console.log(offsetHeight+":"+offsetWidth);
            domStyle.set(this.domNode, {
                height:offsetHeight + "px",
                width:offsetWidth + "px"
            });
            // 创建图片展示框
            // 当前图片，上下左右各一张
            this.currImageDiv = domConstruct.create("div", {
                className:"imagedisplay-pane",
                style:"position:absolute;height:100%;width:100%;text-align:center;background-color:white;"
            },this.domNode);
            this.currImage = domConstruct.create("img", {
                className:"imagedisplay-img"
            }, this.currImageDiv);
            this.leftImageDiv = domConstruct.create("div", {
                className:"imagedisplay-pane",
                style:"text-align:center;position:absolute;height:100%;width:100%;background-color:white;left:-" + offsetWidth + "px;"
            }, this.domNode);
            this.leftImage = domConstruct.create("img", {
                className:"imagedisplay-img"
            }, this.leftImageDiv);
            this.rightImageDiv = domConstruct.create("div", {
                className:"imagedisplay-pane",
                style:"text-align:center;position:absolute;height:100%;width:100%;background-color:white;left:" + offsetWidth + "px;"
            }, this.domNode);
            this.rightImage = domConstruct.create("img", {
                className:"imagedisplay-img"
            }, this.rightImageDiv);
            this.topImageDiv = domConstruct.create("div", {
                className:"imagedisplay-pane",
                style:"text-align:center;position:absolute;height:100%;width:100%;background-color:white;top:-" + offsetHeight + "px;"
            }, this.domNode);
            this.topImage = domConstruct.create("img", {
                className:"imagedisplay-img"
            }, this.topImageDiv);
            this.bottomImageDiv = domConstruct.create("div", {
                className:"imagedisplay-pane",
                style:"text-align:center;position:absolute;height:100%;width:100%;background-color:white;top:" + offsetHeight + "px;"
            }, this.domNode);
            this.bottomImage = domConstruct.create("img", {
                className:"imagedisplay-img"
            }, this.bottomImageDiv);
            this.refreshNode = domConstruct.create("div", {
                innerHTML:"下拉刷新所有图片",
                className:"refreshNode",
                style:"position:absolute;left:0px;top:"+(offsetHeight - 40)+"px;width:100%;display:none;text-align:center;height:40px;line-height:40px;color:#666;"
            }, this.topImageDiv);
            this.tagsNode = domConstruct.create("div", {
                className:"tagsNode",
                style:"position:absolute;left:0px;top:"+(offsetHeight - 40)+"px;width:100%;display:none;text-align:center;height:40px;line-height:40px;color:#666;"
            }, this.topImageDiv);
            this.cover = domConstruct.create("div", {
                className:"coverNode",
                style:"width:100%;height:100%;opacity:0.5;background-color:black;display:none;position:absolute;left:0px;top:0px;"
            }, this.currImageDiv);
            if(lang.isString(this.dataProvider)){
                require([this.dataProvider], function(dataProvider){
                    _this.dataProvider = dataProvider;
                });
            }
            /*this.settingBtn = domConstruct.create("div", {
                innerHTML:"设置",
                style:"position:absolute;bottom:20px;right:20px;background-color:#be2f28;color:white;width:40px;text-align:center;height:22px;line-height:22px;border-radius:6px;",
                onclick:function(){
                    window.moveToView(_this.settingView);
                }
            }, this.domNode);
            this.changeLayoutBtn = domConstruct.create("div", {
                innerHTML:"切换模板",
                style:"position:absolute;bottom:20px;right:80px;background-color:#be2f28;color:white;width:80px;text-align:center;height:22px;line-height:22px;border-radius:6px;",
                onclick:function(){
                    _this.changeLayout = true;
                    _this.cqRefresh();
                }
            }, this.domNode);*/
            
            this.settingPane = domConstruct.create("div", {
                style:"position:absolute;bottom:20px;right:20px;width:86px;height:32px;border-radius:16px;border:1px solid #cacaca;line-height:32px;"
            }, this.domNode);
            this.refreshDiv = domConstruct.create("div", {
                style:"position:absolute;height:32px;width:43px;left:0px;",
                onclick:function(){
                    _this.changeLayout = true;
                    _this.cqRefresh();
                }
            }, this.settingPane);
            this.refreshBtn = domConstruct.create("img", {
                style:"width:17px;height:17px;position:absolute;left:14px;top:7px;",
                src:"./images/func/refresh.png",
                className:"refreshBtn"
            }, this.refreshDiv);
            this.settingDiv = domConstruct.create("div", {
                style:"position:absolute;height:32px;width:43px;right:0px;",
                onclick:function(){
                    window.moveToView(_this.settingView);
                }
            }, this.settingPane);
            this.lineDiv = domConstruct.create("div", {
                style:"position:absolute;height:18px;width:1px;background-color:#cacaca;left:43px;top:7px;"
            }, this.settingPane);
            this.settingBtn = domConstruct.create("img", {
                style:"position:absolute;height:17px;width:17px;left:13px;top:7px;",
                src:"./images/func/setting.png",
                className:"settingBtn"
            }, this.settingDiv);
            this.bindEventListener();
        },
        cqRefresh:function(tagId){
            if(tagId){
                this.tagId = tagId;
            }
            console.log("refresh");
            var _this = this;
            this.autoRefresh = false;
            this.cacheData = {};
            if(this.dataProvider){
                this.dataProvider["getLayoutNum"]().then(function(num){
                    _this.layoutNum = num;
                    this.preventClick = true;
                    this.loadingImage = true;
                    // 加载并显示中间图片
                    var x = Math.floor(Math.random()*num);
                    if(_this.changeLayout){
                        while(x == _this.currPos.x){
                            x = Math.floor(Math.random()*num);
                        }
                        _this.currPos = {x:x,y:_this.currPos.y};
                    }else if(_this.changeTag){
                        // do nothing
                    }else{
                        _this.currPos = {x:x,y:0};
                    }
                    window.busy();
                    _this.loadAndShowImage(_this.currPos, "center", tagId, "refresh").then(function(){
                        var arr = [];
                        if(!_this.changeLayout&&!_this.changeTag){
                            arr.push(_this.loadAndShowImage({x:_this.currPos.x, y:_this.currPos.y + 1}, "bottom", tagId));
                            if(_this.currPos.y > 0){
                                arr.push(_this.loadAndShowImage({x:_this.currPos.x, y:_this.currPos.y - 1}, "top", tagId));
                            }
                        }
                        if(arr.length){
                            var dl = new DeferredList(arr);
                            dl.then(function(){
                                _this.loadingImage = false;
                                _this.changeTag = false;
                                _this.changeLayout = false;
                                if(!_this.changeLayout&&!_this.changeTag){
                                    _this.initTagsNode();
                                }
                                window.free();
                            });
                        }else{
                            _this.loadingImage = false;
                            _this.changeTag = false;
                            _this.changeLayout = false;
                            window.free();
                        }
                    });
                });
            }else{
                this.inherited(arguments);
            }
        },
        initTagsNode:function(){
            var _this = this;
            _this.tagsNode.innerHTML = "";
            this.dataProvider["getTags"]().then(function(tags){
                for(var index = 0;index < tags.length;index++){
                    var tagNode = domConstruct.create("div", {
                        innerHTML:tags[index].tag,
                        id:tags[index]._id,
                        className:"tagNode",
                        style:"display:inline-block;border-radius:5px;height:30px;padding:5px;"
                    }, _this.tagsNode);
                }
                // _this.tagsInited = true;
            });
        },
        loadAndShowImage:function(params,pos,tagId,refresh){
            var _this = this;
            return new Promise(function(resolve, reject){
                var imgNode,imgDiv;
                var url = config.dataOrigin + "/bizv2/article/user_image/getImageUrl?x=" + (params.x) + "&y=" + params.y + "&shopId=" + g_sys_info._id + "&userId=" + consumer.getCurrentUserId() + "&preventCache=" + (new Date()).getTime();
                if(tagId){
                    url += "&tagId=" + tagId;
                }
                if(pos == "center"){
                    _this.currImage.src = url;
                    imgNode = _this.currImage;
                    imgDiv = _this.currImageDiv;
                }else if(pos == "left"){
                    _this.leftImage.src = url;
                    imgNode = _this.leftImage;
                    imgDiv = _this.leftImageDiv;
                }else if(pos == "right"){
                    _this.rightImage.src = url;
                    imgNode = _this.rightImage;
                    imgDiv = _this.rightImageDiv;
                }else if(pos == "bottom"){
                    _this.bottomImage.src = url;
                    imgNode = _this.bottomImage;
                    imgDiv = _this.bottomImageDiv;
                }else if(pos == "top"){
                    _this.topImage.src = url;
                    imgNode = _this.topImage;
                    imgDiv = _this.topImageDiv;
                }
                imgNode.onload = function(){
                    if((imgNode.naturalHeight/imgNode.naturalWidth) > (imgDiv.offsetHeight/imgDiv.offsetWidth)){
                        domStyle.set(imgNode, {
                            width:"auto",
                            height:"100%",
                            top:"0px"
                        });
                        domStyle.set(imgNode, {
                            left:(imgDiv.offsetWidth-imgNode.width)/2 + "px"
                        });
                    }else{
                        domStyle.set(imgNode, {
                            width:"100%",
                            height:"auto",
                            position:"absolute"
                        });
                        domStyle.set(imgNode, {
                            top:(imgDiv.offsetHeight-imgNode.height)/2 + "px",
                            left:"0px"
                        });
                    }
                    resolve();
                };
            });
            /*var data = this.dataProvider[this.dataMethod](params,tagId,refresh);
            if(data.then){
                return data.then(function(result){
                    if(pos == "center"){
                        // 除了第一次，其它任何时候不会加载中间图片
                        // 所以不需要设置cacheData的链式结构
                        _this.currImage.src = result.src;
                        _this.cacheData.data = result;
                        imgNode = _this.currImage;
                        imgDiv = _this.currImageDiv;
                    }else if(pos == "left"){
                        _this.leftImage.src = result.src;
                        _this.cacheData.left = {};
                        _this.cacheData.left.data = result;
                        _this.cacheData.left.right = _this.cacheData;
                        imgNode = _this.leftImage;
                        imgDiv = _this.leftImageDiv;
                    }else if(pos == "right"){
                        _this.rightImage.src = result.src;
                        _this.cacheData.right = {};
                        _this.cacheData.right.data = result;
                        _this.cacheData.right.left = _this.cacheData;
                        imgNode = _this.rightImage;
                        imgDiv = _this.rightImageDiv;
                    }else if(pos == "top"){
                        _this.topImage.src = result.src;
                        _this.cacheData.top = {};
                        _this.cacheData.top.data = result;
                        _this.cacheData.top.bottom = _this.cacheData;
                        imgNode = _this.topImage;
                        imgDiv = _this.topImageDiv;
                    }else if(pos == "bottom"){
                        _this.bottomImage.src = result.src;
                        _this.cacheData.bottom = {};
                        _this.cacheData.bottom.data = result;
                        _this.cacheData.bottom.top = _this.cacheData;
                        imgNode = _this.bottomImage;
                        imgDiv = _this.bottomImageDiv;
                    }
                    // 将图片居中显示
                    imgNode.onload = function(){
                        if((imgNode.naturalHeight/imgNode.naturalWidth) > (imgDiv.offsetHeight/imgDiv.offsetWidth)){
                            domStyle.set(imgNode, {
                                width:"auto",
                                height:"100%",
                                top:"0px"
                            });
                            domStyle.set(imgNode, {
                                left:(imgDiv.offsetWidth-imgNode.width)/2 + "px"
                            });
                        }else{
                            domStyle.set(imgNode, {
                                width:"100%",
                                height:"auto",
                                position:"absolute"
                            });
                            domStyle.set(imgNode, {
                                top:(imgDiv.offsetHeight-imgNode.height)/2 + "px",
                                left:"0px"
                            });
                        }
                    };
                    return result;
                });
            }else{
                return Promise.resolve().then(function(){
                    if(pos == "center"){
                        _this.currImage.src = data.src;
                        _this.cacheData = {data:data};
                        imgNode = _this.currImage;
                        imgDiv = _this.currImageDiv;
                    }else if(pos == "left"){
                        _this.leftImage.src = data.src;
                        _this.cacheData.left = {};
                        _this.cacheData.left.data = data;
                        _this.cacheData.left.right = _this.cacheData;
                        imgNode = _this.leftImage;
                        imgDiv = _this.leftImageDiv;
                    }else if(pos == "right"){
                        _this.rightImage.src = data.src;
                        _this.cacheData.right = {};
                        _this.cacheData.right.data = data;
                        _this.cacheData.right.left = _this.cacheData;
                        imgNode = _this.rightImage;
                        imgDiv = _this.rightImageDiv;
                    }else if(pos == "top"){
                        _this.topImage.src = data.src;
                        _this.cacheData.top = {};
                        _this.cacheData.top.data = data;
                        _this.cacheData.top.bottom = _this.cacheData;
                        imgNode = _this.topImage;
                        imgDiv = _this.topImageDiv;
                    }else if(pos == "bottom"){
                        _this.bottomImage.src = data.src;
                        _this.cacheData.bottom = {};
                        _this.cacheData.bottom.data = data;
                        _this.cacheData.bottom.top = _this.cacheData;
                        imgNode = _this.bottomImage;
                        imgDiv = _this.bottomImageDiv;
                    }
                    // 图片居中显示

                    //domStyle.set(imgNode, {
                    //    width:"100%",
                    //    height:"auto",
                    //    position:"absolute"
                    //});
                    imgNode.onload = function(){
                        if((imgNode.naturalHeight/imgNode.naturalWidth) > (imgDiv.offsetHeight/imgDiv.offsetWidth)){
                            domStyle.set(imgNode, {
                                width:"auto",
                                height:"100%",
                                top:"0px"
                            });
                            domStyle.set(imgNode, {
                                left:(imgDiv.offsetWidth-imgNode.width)/2 + "px"
                            });
                        }else{
                            domStyle.set(imgNode, {
                                width:"100%",
                                height:"auto",
                                position:"absolute"
                            });
                            domStyle.set(imgNode, {
                                top:(imgDiv.offsetHeight-imgNode.height)/2 + "px",
                                left:"0px"
                            });
                        }
                    };
                    return data;
                });
            }*/
        },
        getTransform:function(moveX, moveY, moveZ, duration, method){
            var style;
            if(duration != undefined){
                var durationStyle = transformUtil.getDurationStyle(duration||0);
                var animationMethodStyle = transformUtil.getAnimationMethodStyle(method||"linear");
                var transformStyle = transformUtil.getTransformStyle(transformUtil.getTranformStr(Math.floor(moveX||0) + "px", Math.floor(moveY||0) + "px", Math.floor(moveZ||0) + "px"));
                style = lang.mixin(durationStyle, animationMethodStyle);
                style = lang.mixin(style, transformStyle);
            }else{
                style = transformUtil.getTransformStyle(transformUtil.getTranformStr(Math.floor(moveX||0) + "px", Math.floor(moveY||0) + "px", Math.floor(moveZ||0) + "px"));
            }
            return style;
        },
        touchEnd:function(evt){
            if(!this.startClickPos){
                return;
            }
            if(this.showCoverNode){
                return;
            }
            var _this = this;
            // 记录释放时，鼠标位置，并且做图片切换，cacheData切换
            // 清除不显示的对象的链式结构
            var moveX = 0,moveY = 0;
            if(_this.dir == "H"){
                moveX = (evt.touches&&evt.touches[0]?evt.touches[0].pageX:evt.pageX) - _this.startClickPos.x;
                if(Math.abs(moveX) >= _this.domNode.offsetWidth/3){
                    if(moveX > 0){
                        moveX = _this.domNode.offsetWidth;
                    }else{
                        moveX = 0 - _this.domNode.offsetWidth;
                    }
                    var style = _this.getTransform(moveX, 0, 0, 350, "ease-out");
                    domStyle.set(_this.currImageDiv, style);
                    domStyle.set(_this.leftImageDiv, style);
                    domStyle.set(_this.rightImageDiv, style);
                    // 设置绝对定位
                    setTimeout(function(){
                        style = _this.getTransform(0, 0, 0, 0, "linear");
                        domStyle.set(_this.currImageDiv, lang.mixin({
                            left:moveX + "px",
                            top:"0px"
                        }, style));
                        _this.tempImageDiv = _this.currImageDiv;
                        _this.tempImage = _this.currImage;
                        if(moveX > 0){
                            domStyle.set(_this.leftImageDiv, lang.mixin({
                                left:"0px",
                                top:"0px"
                            }, style));
                            domStyle.set(_this.rightImageDiv, lang.mixin({
                                left:"-" + moveX + "px",
                                top:"0px"
                            }, style));
                            // 图片结构
                            _this.currImageDiv = _this.leftImageDiv;
                            _this.currImage = _this.leftImage;
                            _this.leftImageDiv = _this.rightImageDiv;
                            _this.leftImage = _this.rightImage;
                            _this.rightImageDiv = _this.tempImageDiv;
                            _this.rightImage = _this.tempImage;
                            _this.leftImage.src = "";
                            _this.topImage.src = "";
                            _this.bottomImage.src = "";
                            _this.currImageDiv.appendChild(_this.cover);
                            _this.topImageDiv.appendChild(_this.refreshNode);
                            _this.topImageDiv.appendChild(_this.tagsNode);
                            // 加载top，bottom，left
                            _this.currPos = {x:_this.currPos.x - 1, y:_this.currPos.y};
                            _this.loadingImage = true
                            _this.startLoad = new Date().getTime();
                            window.busy();
                            var arr = [
                                _this.loadAndShowImage({x:_this.currPos.x - 1, y:_this.currPos.y}, "left"),
                                _this.loadAndShowImage({x:_this.currPos.x, y:_this.currPos.y + 1}, "bottom")
                            ];
                            if(_this.currPos.y > 0){
                                arr.push(_this.loadAndShowImage({x:_this.currPos.x, y:_this.currPos.y - 1}, "top"));
                            }
                            var dl = new DeferredList(arr);
                            dl.then(function(){
                                _this.loadingImage = false;
                                _this.startLoad = 0;
                                window.free();
                            });
                        }else{
                            domStyle.set(_this.leftImageDiv, lang.mixin({
                                left:0 - moveX + "px",
                                top:"0px"
                            }, style));
                            domStyle.set(_this.rightImageDiv, lang.mixin({
                                left:"0px",
                                top:"0px"
                            }, style));
                            _this.currImageDiv = _this.rightImageDiv;
                            _this.currImage = _this.rightImage;
                            _this.rightImageDiv = _this.leftImageDiv;
                            _this.rightImage = _this.leftImage;
                            _this.leftImageDiv = _this.tempImageDiv;
                            _this.leftImage = _this.tempImage;
                            _this.rightImage.src = "";
                            _this.topImage.src = "";
                            _this.bottomImage.src = "";
                            _this.currImageDiv.appendChild(_this.cover);
                            _this.topImageDiv.appendChild(_this.refreshNode);
                            _this.topImageDiv.appendChild(_this.tagsNode);
                            
                            _this.currPos = {x:_this.currPos.x + 1, y:_this.currPos.y};
                            _this.loadingImage = true;
                            _this.startLoad = new Date().getTime();
                            window.busy();
                            var arr = [
                                _this.loadAndShowImage({x:_this.currPos.x + 1, y:_this.currPos.y}, "right"),
                                _this.loadAndShowImage({x:_this.currPos.x, y:_this.currPos.y + 1}, "bottom")
                            ];
                            if(_this.currPos.y > 0){
                                arr.push(_this.loadAndShowImage({x:_this.currPos.x, y:_this.currPos.y - 1}, "top"));
                            }
                            var dl = new DeferredList(arr);
                            dl.then(function(){
                                _this.loadingImage = false;
                                _this.startLoad = 0;
                                window.free();
                            });
                        }
                    },350);
                }else{
                    var style = _this.getTransform(0, 0, 0, 350, "ease-out");
                    domStyle.set(_this.currImageDiv, style);
                    domStyle.set(_this.leftImageDiv, style);
                    domStyle.set(_this.rightImageDiv, style);
                }
            }else if(_this.dir == "V"){
                moveY = (evt.touches&&evt.touches[0]?evt.touches[0].pageY:evt.pageY) - _this.startClickPos.y;
                if(_this.showRefreshNode){
                    domStyle.set(_this.refreshNode, {
                        display:"none"
                    });
                    domStyle.set(_this.tagsNode, {
                        display:"block"
                    });
                    domStyle.set(_this.cover, {
                        display:"block"
                    });
                    //var style = _this.getTransform(0, 0, 0, 350, "ease-out");
                    //domStyle.set(_this.currImageDiv, style);
                    //domStyle.set(_this.topImageDiv, style);
                    //domStyle.set(_this.bottomImageDiv, style);
                    _this.showRefreshNode = false;
                    _this.showCoverNode = true;
                }else if(Math.abs(moveY) >= _this.domNode.offsetHeight/8){
                    if(moveY > 0){
                        moveY = _this.domNode.offsetHeight;
                    }else{
                        moveY = 0 - _this.domNode.offsetHeight;
                    }
                    var style = _this.getTransform(0, moveY, 0, 350, "ease-out");
                    domStyle.set(_this.currImageDiv, style);
                    domStyle.set(_this.topImageDiv, style);
                    domStyle.set(_this.bottomImageDiv, style);
                    setTimeout(function(){
                        style = _this.getTransform(0, 0, 0, 0, "linear");
                        domStyle.set(_this.currImageDiv, lang.mixin({
                            top:moveY + "px",
                            left:"0px"
                        }, style));
                        _this.tempImageDiv = _this.currImageDiv;
                        _this.tempImage = _this.currImage;
                        if(moveY > 0){
                            domStyle.set(_this.topImageDiv, lang.mixin({
                                top:"0px",
                                left:"0px"
                            }, style));
                            domStyle.set(_this.bottomImageDiv, lang.mixin({
                                top:"-" + moveY + "px",
                                left:"0px"
                            }, style));
                            _this.currImageDiv = _this.topImageDiv;
                            _this.currImage = _this.topImage;
                            _this.topImageDiv = _this.bottomImageDiv;
                            _this.topImage = _this.bottomImage;
                            _this.currImageDiv.appendChild(_this.cover);
                            _this.topImageDiv.appendChild(_this.refreshNode);
                            _this.topImageDiv.appendChild(_this.tagsNode);
                            _this.bottomImageDiv = _this.tempImageDiv;
                            _this.bottomImage = _this.tempImage;
                            _this.topImage.src = "";
                            _this.leftImage.src = "";
                            _this.rightImage.src = "";
                            
                            _this.currPos = {x:_this.currPos.x, y:_this.currPos.y - 1};
                            _this.loadingImage = true;
                            _this.startLoad = new Date().getTime();
                            window.busy();
                            var arr = [
                                // _this.loadAndShowImage({x:_this.currPos.x - 1, y:_this.currPos.y}, "left"),
                                // _this.loadAndShowImage({x:_this.currPos.x + 1, y:_this.currPos.y}, "right")
                            ];
                            if(_this.currPos.y > 0){
                                arr.push(_this.loadAndShowImage({x:Math.floor(Math.random()*_this.layoutNum), y:_this.currPos.y - 1}, "top", this.tagId||""));
                            }
                            if(arr.length){
                                var dl = new DeferredList(arr);
                                dl.then(function(){
                                    _this.loadingImage = false;
                                    _this.startLoad = 0;
                                    window.free();
                                });
                            }else{
                                _this.loadingImage = false;
                                _this.startLoad = 0;
                                window.free();
                            }
                        }else{
                            domStyle.set(_this.topImageDiv, lang.mixin({
                                top:0-moveY + "px",
                                left:"0px"
                            }, style));
                            domStyle.set(_this.bottomImageDiv, lang.mixin({
                                top:"0px",
                                left:"0px"
                            }, style));
                            _this.currImageDiv = _this.bottomImageDiv;
                            _this.currImage = _this.bottomImage;
                            _this.bottomImageDiv = _this.topImageDiv;
                            _this.bottomImage = _this.topImage;
                            _this.topImageDiv = _this.tempImageDiv;
                            _this.topImage = _this.tempImage;
                            _this.currImageDiv.appendChild(_this.cover);
                            _this.topImageDiv.appendChild(_this.refreshNode);
                            _this.topImageDiv.appendChild(_this.tagsNode);
                            _this.bottomImage.src = "";
                            _this.leftImage.src = "";
                            _this.rightImage.src = "";
                            
                            _this.currPos = {x:_this.currPos.x, y:_this.currPos.y + 1};
                            _this.loadingImage = true;
                            _this.startLoad = new Date().getTime();
                            window.busy();
                            var dl = new DeferredList([
                                _this.loadAndShowImage({x:Math.floor(Math.random() * _this.layoutNum), y:_this.currPos.y + 1}, "bottom", this.tagId||""),
                                //_this.loadAndShowImage({x:_this.currPos.x - 1, y:_this.currPos.y}, "left"),
                                //_this.loadAndShowImage({x:_this.currPos.x + 1, y:_this.currPos.y}, "right")
                            ]);
                            dl.then(function(){
                                _this.loadingImage = false;
                                _this.startLoad = 0;
                                window.free();
                            });
                        }
                    }, 350);
                }else{
                    var style = _this.getTransform(0, 0, 0, 350, "ease-out");
                    domStyle.set(_this.currImageDiv, style);
                    domStyle.set(_this.topImageDiv, style);
                    domStyle.set(_this.bottomImageDiv, style);
                }
            }
            _this.dir = null;
            _this.startClickPos = null;
        },
        // 绑定上下左右滑动事件
        bindEventListener:function(){
            var _this = this;
            this.connect(this.domNode, "onclick", lang.hitch(this, function(evt){
                var target = evt.target;
                event.stop(evt);
                if(target.tagName == "IMG" && !domClass.contains(target,"refreshBtn") && !domClass.contains(target, "settingBtn")){
                    bigImg.show([{src:target.src}], 0);
                }else if(domClass.contains(target, "imagedisplay-pane")){
                    var style = _this.getTransform(0, 0, 0, 350, "ease-out");
                    domStyle.set(_this.currImageDiv, style);
                    domStyle.set(_this.topImageDiv, style);
                    domStyle.set(_this.bottomImageDiv, style);
                    domStyle.set(_this.tagsNode, {
                        display:"none"
                    });
                    domStyle.set(_this.cover, {
                        display:"none"
                    });
                }
            }));
            this.connect(this.cover, "onclick", lang.hitch(this, function(evt){
                event.stop(evt);
                _this.showCoverNode = false;
                // _this.cqRefresh();
                var style = _this.getTransform(0, 0, 0, 350, "ease-out");
                domStyle.set(_this.currImageDiv, style);
                domStyle.set(_this.topImageDiv, style);
                domStyle.set(_this.bottomImageDiv, style);
                domStyle.set(_this.tagsNode, {
                    display:"none"
                });
                domStyle.set(_this.cover, {
                    display:"none"
                });
            }));
            this.connect(this.tagsNode, "onclick", lang.hitch(this, function(evt){
                var target = evt.target;
                event.stop(evt);
                _this.showCoverNode = false;
                if(domClass.contains(target, "tagNode")){
                    _this.changeTag = true;
                    _this.cqRefresh(target.id);
                }
                var style = _this.getTransform(0, 0, 0, 350, "ease-out");
                domStyle.set(_this.currImageDiv, style);
                domStyle.set(_this.topImageDiv, style);
                domStyle.set(_this.bottomImageDiv, style);
                domStyle.set(_this.tagsNode, {
                    display:"none"
                });
                domStyle.set(_this.cover, {
                    display:"none"
                });
            }));
            touch.press(this.domNode, lang.hitch(this ,function(evt){
                if(_this.loadingImage){
                    return;
                }
                if(_this.showCoverNode){
                    return;
                }
                // 记录点击时，鼠标位置
                _this.startClickPos = {
                    x:evt.touches&&evt.touches[0]?evt.touches[0].pageX:evt.pageX,
                    y:evt.touches&&evt.touches[0]?evt.touches[0].pageY:evt.pageY
                };
                _this._time = [0];
                _this.startTime = (new Date()).getTime();
                event.stop(evt);
            }));
            touch.move(this.domNode, lang.hitch(this, function(evt){
                if(!_this.startClickPos){
                    return;
                }
                if(_this.loadingImage){
                    return;
                }
                if(_this.showCoverNode){
                    return;
                }
                // 解决鼠标超出屏幕范围不触发touch.release事件
                if((evt.touches&&evt.touches[0]?evt.touches[0].pageX:evt.pageX) <= 0 || (evt.touches&&evt.touches[0]?evt.touches[0].pageX:evt.pageX) >= _this.currImageDiv.offsetWidth){
                    _this.touchEnd(evt);
                    return;
                }else if((evt.touches&&evt.touches[0]?evt.touches[0].pageY:evt.pageY) <= 0|| (evt.touches&&evt.touches[0]?evt.touches[0].pageY:evt.pageY) >= _this.currImageDiv.offsetHeight){
                    _this.touchEnd(evt);
                    return;
                }
                // 图片移动
                _this.touchMovePos = {
                    x:evt.touches&&evt.touches[0]?evt.touches[0].pageX:evt.pageX,
                    y:evt.touches&&evt.touches[0]?evt.touches[0].pageY:evt.pageY
                };
                var moveX = _this.touchMovePos.x - _this.startClickPos.x;
                var moveY = _this.touchMovePos.y - _this.startClickPos.y;
                if(!_this.dir){
                    //if(Math.abs(moveX) > Math.abs(moveY) && Math.abs(moveX) > 4){
                    //    _this.dir = "H";
                    //}else 
                    if(Math.abs(moveY) > 4){
                        _this.dir = "V";
                    }
                }else{
                    if(_this.dir == "H"){
                        if(moveX > 0&&!_this.leftImage.src){
                            return;
                        }else if(moveX < 0 && !_this.rightImage.src){
                            return;
                        }
                        //if(Math.abs(_this.lastMovePos?(_this.touchMovePos.x - _this.lastMovePos.x):moveX) <= 4){
                        //    return;
                        //}
                        var style = _this.getTransform(moveX, 0, 0);
                        domStyle.set(_this.currImageDiv, style);
                        domStyle.set(_this.leftImageDiv, style);
                        domStyle.set(_this.rightImageDiv, style);
                        _this.lastMovePos = _this.touchMovePos;
                    }else{
                        if(moveY > 0 && !_this.topImage.src && _this.currPos.y != 0){
                            return;
                        }else if(moveY < 0 && !_this.bottomImage.src){
                            return;
                        }else{
                            //if(Math.abs(_this.lastMovePos?(_this.touchMovePos.y - _this.lastMovePos.y):moveY) <= 4){
                            //    return;
                            //}
                            if(_this.currPos.y == 0&&moveY > 0){
                                domStyle.set(_this.refreshNode, {
                                    display:"block"
                                });
                                _this.topImage.src = "";
                                _this.showRefreshNode = true;
                                /*if(!_this.showRefreshNode){
                                    _this.showRefreshNode = true;
                                    setTimeout(function(){
                                        _this.topImage.src = "";
                                        _this.cqRefresh();
                                    }, 500);
                                }*/
                                if(moveY < 80){
                                    var style = _this.getTransform(0, moveY, 0);
                                    domStyle.set(_this.currImageDiv, style);
                                    domStyle.set(_this.topImageDiv, style);
                                    domStyle.set(_this.bottomImageDiv, style);
                                    _this.lastMovePos = _this.touchMovePos;
                                }
                            }else{
                                var style = _this.getTransform(0, moveY, 0);
                                domStyle.set(_this.currImageDiv, style);
                                domStyle.set(_this.topImageDiv, style);
                                domStyle.set(_this.bottomImageDiv, style);
                                _this.lastMovePos = _this.touchMovePos;
                            }
                        }
                    }
                }
            }));
            touch.release(this.domNode, lang.hitch(this, this.touchEnd));
        }
    });
});