﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-construct",
    "dojo/Deferred",
    "dijit/_WidgetBase",
    "../_WidgetBase",
    "../_LayoutMixin"
],function(declare,lang,array,domConstruct,Deferred,_WidgetBase,_CqWidgetBase,_LayoutMixin){
    var propStr = 'autoLoad:{autoLoad},enableSearchBtn:{enableSearchBtn},initMethod:{initMethod},enableRange:"{enableRange}",searchLabel:"{searchLabel}",dataProvider:"{dataProvider}",layoutMethod:"{queryLayoutMethod}",layoutType:"table"';
    return declare("",[_WidgetBase,_CqWidgetBase,_LayoutMixin],{
        htmlTemp:"<div id='{id}' class='cq-query-area cq-layout-content cq-view-stepsFields {className}' data-dojo-type='cq/app/widget/web/QueryLayout' data-dojo-props='"+propStr+"'></div>",
        dataProvider:"",
        layoutMethod:"",
        searchLabel:"",
        preventScroll:true,
        enableRange: true,
        enableSearchBtn:true,
        autoLoad:false,
        buildRendering:function(){
            this.enableRange = this.enableRange===false||this.enableRange==="false"?false:true;
            this.inherited(arguments);
        },
        loadLayout:function(){
            this.actionsHash = {};
            var def = null;
            if(this.dataProvider){
                if(lang.isString(this.dataProvider)){
                    def = new Deferred();
                    require([this.dataProvider],lang.hitch(this,function(dataProvider){
                        this.dataProvider = dataProvider;
                        var data = this.dataProvider[this.layoutMethod]();
                        if(data&&data.then){
                            data.then(function(result){
                                def.resolve(result);
                            });
                        }else{
                            def.resolve(data);
                        }
                    }));
                }else{
                    def = this.dataProvider[this.layoutMethod]();
                }
            }else{
                def = this.inherited(arguments);
            }
            if(def&&def.then){
                return def.then(lang.hitch(this,function(layout){
                    return this.decorateQueryLayout(layout);
                }));
            }else{
                return this.decorateQueryLayout(def);
            }
        },
        decorateQueryLayout:function(layout){
            layout = lang.clone(layout);
            var fields = layout[0].fields,len = fields.length,fieldf,fieldt;
            while(len--){
                delete fields[len].className;
                delete fields[len].notNull;
                if(fields[len].type==="checkbox"){
                    fields[len].type = "options";
                    fields[len].options={
                        "":"全部",
                        "true":"是",
                        "false":"否"
                    };
                    fields[len].selected="0";
                }else if(fields[len].type==="options"){
                    fields[len].options[""] = "全部";
                }else if(fields[len].type==="date"||fields[len].type==="dateTime"){
                    if(this.enableRange){
                        fieldf = lang.clone(fields[len]);
                        fieldf.field = fieldf.field+"f";
                        fieldf.label = fieldf.label+"从";
                        fieldt = lang.clone(fields[len]);
                        fieldt.field = fieldt.field+"t";
                        fieldt.label = fieldt.label+"到";
                        fields.splice(len,1,fieldf,fieldt);
                    }
                }
            }
            return layout;
        },
        onLayoutReady:function(){
            this.inherited(arguments);
            this.layoutLoaded = true;
            if(this.enableSearchBtn!==false&&this.enableSearchBtn!=="false"){
                this.searchButton = domConstruct.create("div",{
                    "class":"button searchButton",
                    //style:"float:right",
                    "innerHTML":this.searchLabel||"查询",
                    onclick:lang.hitch(this,function(){
                        var data = this.getData();
                        this.onCqChanged(this,data);
                        this.setData(lang.clone(data));
                    })
                },this.domNode);
            }
            if(this.autoLoad===true||this.autoLoad==="true"){
                this.cqRefresh();
            }
        },
        cqRefresh:function(){
            this.autoRefresh = false;
            if(!this.layoutLoaded){
                this.autoRefresh = true;
                return;
            }
            if(this.initMethod&&this.dataProvider){
                this.preventClick = true;
                if(this.dataProvider[this.initMethod]){
                    var data = this.dataProvider[this.initMethod](this.cqRefInfo);
                    if(data&&data.then){
                        data.then(lang.hitch(this,function(initData){
                            this.setData(initData);
                        }));
                    }else{
                        this.setData(data);
                    }
                }else{
                    this.autoRefresh = true;
                }
            }else{
                this.inherited(arguments);
            }
        },
        _updateDisplay:function(){
            this.inherited(arguments);
            if(this.enableSearchBtn===false||this.enableSearchBtn==="false"){
                var data = this.getData();
                this.onCqChanged(this,data);
            }
        }
    });
});