﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/event",
    "dojo/dom-attr",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dijit/_WidgetBase",
    "cq/biz/blob/blob"
],function(declare,lang,array,event,domAttr,domConstruct,domStyle,_WidgetBase,blob){
    return declare("",[_WidgetBase],{
        // summary: 
        //
        
        htmlTemp:'<div class="cq-form-attachmentList cq-field-input" data-dojo-type="cq/app/widget/web/edit/AttachmentList" data-dojo-props=\'canAdd:"{canAdd}",label:"{label}",canEdit:{canEdit},field:"{field}"\'></div>',
        // field:String
        //      组件名称
        //      实际可能是该组件需要的某些字段、组件的组件名、与之联动的组件的组件名或字段名构成的一段字符串。
        field:"",
        
        
        label:"",
        
        canAdd:true,
        // canEdit:boolean
        //      编辑状态，true为可编辑。
        canEdit:true,
        
        buildRendering:function(){
            // summary:
            //      初始化组件
            // tags:
            //      private
            this.inherited(arguments);
            this.createAddBtn();
            this.setCanEdit(this.canEdit);
        },
        setCanEdit:function(canEdit){
            // summary:
            //      设置组件是否可编辑。
            // params:
            //      canEdit:编辑状态
            // tags:
            //      public
            this.canEdit = canEdit!==false&&canEdit!=="false";
            
            var display = this.canEdit?"":"none";
            if(this.addBtn){
                domStyle.set(this.addBtn,"display",display);
            }
            array.forEach(this.fileList.childNodes,this.refreshNodeStatus,this);
        },
        refreshNodeStatus:function(node){
            domStyle.set(node.deleteNode,"display",this.canEdit?"":"none");
            domStyle.set(node.downloadNode,"display",this.canEdit?"none":"");
        },
        getValue:function(){
            return this.value;
        },
        setValue:function(value){
            // summary:
            //      设置组件的值
            // params:
            //      value:组件的值
            // tags:
            //      private
            domConstruct.empty(this.fileList);
            this.value = [];
            array.forEach(value,this.addFileByValue,this);
        },
        addFileByValue:function(item){
            var node = domConstruct.create("div",{
                "class":"cq-form-item",
                innerHTML:item.title||""
            },this.fileList);
            node.deleteNode = domConstruct.create("button",{
                innerHTML:"删除"
            },node,"first");
            this.connect(node.deleteNode,"onclick",this.onDeleteClick);
            /*
            node.downloadNode = domConstruct.create("a",{
                innerHTML:"<button>下载</button>",
                href:item.url,
                download:item.title
            },node,"first");
            */
            node.downloadNode = domConstruct.create("button",{
                innerHTML:"下载"
                //href:item.url,
                //download:item.title
            },node,"first");
            node.downloadA = domConstruct.create("a",{
                href:item.url,
                download:item.title,
                style:"display:none;"
            },node,"first");
            //this.connect(node.downloadNode,"onclick",node.downloadA.click);
            this.connect(node.downloadNode,"onclick",function(){
                node.downloadA.click();
            },this);
            
            this.refreshNodeStatus(node);
            this.value.push(item);
        },
        onFieldChanged:function(widget,field,value){
            // summary:
            //      本对象发生变化后通知其他对象刷新的接口
            // params:
            //      widget:发生变化对象所在的view
            //      field:发生变化的对象
            //      value:改变后的值
            // tags:
            //      interface
        },
        
        createAddBtn:function(){
            // summary:
            //      创建添加附件节点
            //      为节点提供添加附件的方法
            //this. = domConstruct.create("div",{},this.domNode,"first");
            this.addBtn = domConstruct.create("button",{
                innerHTML:"添加",
                "class":"cq-action"
            },this.domNode,"first");
            this.addBtn.addEventListener("click",lang.hitch(this,function(){
                if(this.canEdit){
                    this.onAddFile();
                }
            }));
            this.fileList = domConstruct.create("div",{},this.addBtn,"before");
            //this.connect(this.fileList,"onclick",this.onDeleteClick);
        },
        
        onAddFile:function(){
            var fileSelectInput = domConstruct.create("input",{
                "class":"none",
                multiple:"multiple",
                style:"display:none;",
                type:"file"
            },document.body);
            fileSelectInput.click();
            fileSelectInput.onchange = lang.hitch(this,function(){
                blob.upload(fileSelectInput).then(lang.hitch(this,function(data){
                    if(data.items && data.items.length > 0){
                        array.forEach(data.items||[],function(item){
                            this.addFileByValue({
								title:item.originName,
								url:item.uri
                            });
                        },this);
						this.onFieldChanged(this,this.field,this.value);
					}
                    if(fileSelectInput.parentNode){
                        fileSelectInput.parentNode.removeChild(fileSelectInput);
                    }
                }));
            });
        },
        onDeleteClick:function(evt){
            if(evt.target&&evt.target.innerHTML === "删除"){
                var node = evt.target.parentNode;
                //for(var i=0;i>this.fileList.childNodes.length;i++){
                for(var i=0;i<this.fileList.childNodes.length;i++){
                    if(this.fileList.childNodes[i]===node){
                        node.parentNode.removeChild(node);
                        this.value.splice(i,1);
                        return;
                    }
                }
            }
        }
    });
});