﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dijit/_WidgetBase",
    "dijit/_Container",
    "dijit/registry",
    "cq/app/widget/web/edit/ObjEditor"
],function(declare,lang,array,domConstruct,domStyle,_WidgetBase,_Container,registry,ObjEditor){
    // module:
    //      cq/app/widget/web/edit/ObjsEditor
    return declare("",[_WidgetBase,_Container],{
        // summary:
        //         编辑组件集合一对多编辑组件
        
        htmlTemp:'<div class="cq-form-objseditor cq-field-input" data-dojo-type="cq/app/widget/web/edit/ObjsEditor" data-dojo-props=\'canAdd:"{canAdd}",label:"{label}",canEdit:{canEdit},field:"{field}",defaultData:{j:defaultData},labelField:"{labelField}",canDelete:"{canDelete}",fields:{j:fields}\'></div>',
        //用于显示的名称字段
        label:"",
        //对象字段
        field:"",
        //要实现的组件的layout
        fields:{},
        // 是否可以添加
        canAdd:true,
        // 是否可以删除
        canDelete:true,
        // 是否可以调整顺序
        canDnd:true,
        // canEdit:boolean
        //      是否可编辑
        canEdit:true,
        // isObjsEditor:boolean
        //      是否是一对多编辑对象,供其他js文件读取判断使用
        isObjsEditor:true,
        // defaultData:obj
        //      设置默认选中项。
        defaultData:null,
        
        
        buildRendering:function(){
            // summary:
            //         初始化组件
            this.canEdit = this.canEdit!==false&&this.canEdit!=="false";
            
            this.canAdd = this.canAdd!==false&&this.canAdd!=="false";
            
            this.canDelete = this.canDelete!==false&&this.canDelete!=="false";
            
            this.inherited(arguments);
            
            //更改人：郭周全  将添加按钮放入一个节点中   2016-11-17
            this.addBtnPanel = domConstruct.create("div",{
                style:"margin: 0 auto;width: 270px; height:20px; height:44px;border: 1px solid rgb(9,124,213);"
            },this.domNode,"last");
            
            //this.addBtn =  domConstruct.place('<button  class="cq-action"  >添加'+this.label||""+'</button>',this.addBtnPanel,"first");
            this.addBtn = domConstruct.create("button",{
                class:"cq-action",
                innerHTML:'添加'+this.label||""
            },this.addBtnPanel,"first");
            
            this.addBtnPanel.addEventListener("click",lang.hitch(this,function(){
                if(!this.canEdit || !this.canAdd) return;
                this.initObjEditor(lang.clone(this.defaultData));
            }));
            this.setCanEdit(this.canEdit);
        },
        setCanEdit:function(canEdit){
            // summary:
            //         设置组件编辑状态
            this.canEdit = canEdit!==false&&canEdit!=="false";
            array.forEach(this.getChildren(),function(item){
                if(item.setCanEdit){
                    item.setCanEdit(this.canEdit);
                }
                this.refreshDelete(item);
            },this);
            if(this.canEdit&&this.canAdd){
                //domStyle.set(this.addBtn,"display","");
                domStyle.set(this.addBtnPanel,"display","");
            }else{
                //domStyle.set(this.addBtn,"display","none");
                if(this.domNode.childNodes.length === 1){
                    domStyle.set(this.domNode,"min-height","44px")    
                }
                domStyle.set(this.addBtnPanel,"display","none");
                
            }
            if(this.deleteNode){
                this.setCanDelete();
            }
        },
        setCanAdd:function(canAdd){
            // summary:
            //      设置是添加对象状态
            domStyle.set(this.addBtnPanel,"display",this.canEdit&&this.canAdd?"":"none");
        },
        getValue:function(){
            // summary:
            //         获取组件的值
            return array.map(this.getChildren(),function(item){
                return item.getValue();
            });
        },
        setValue:function(value){
            // summary:
            //         设置组件的值
            this.getChildren().forEach(function(item){
                item.destroyRecursive();
            });
            array.forEach(value||[],function(item){
                this.initObjEditor(item);
            },this);
        },
        
        initObjEditor:function(value){
            var newObj = new ObjEditor({
                fields : this.fields,
                canEdit: this.canEdit,
                objs:this,
                
               
                onFieldChanged: lang.hitch(this,function(widget,field,value){
                    this.onFieldChanged(this, this.field, this.getValue());
                })
            });
            if(this.canEdit){
                this.refreshDelete(newObj);
            }
            newObj.placeAt(this.addBtnPanel,"before");
            if(value!==undefined){
                newObj.setValue(value);    
            }
        },
        refreshDelete:function(item){
            if(!item._listDeleteNode){
                this.deleteNode=item._listDeleteNode = domConstruct.create("span",{
                    innerHTML:"删除",
                    "class":"cq-objs-obj-del",
                    onclick:lang.hitch(this,function(e){
                        var widget = registry.getEnclosingWidget(e.target);
                        if(widget){
                            widget.destroyRecursive();
                            this.onFieldChanged(this, this.field, this.getValue());
                        }
                    })
                },item.domNode,"first");
            }
            domStyle.set(item._listDeleteNode,"display",this.canEdit?"":"none");
            this.setCanDelete();
        },
        setCanDelete:function(){
            if(!this.canDelete){
                domStyle.set(this.deleteNode,"display",this.canDelete?"":"none");
            }
        },
        onFieldChanged:function(widget,field,value){
            // summary:
            //         value发生变化后通知关联组件
            // frame:
            //         widget:页面（layoutData对象）
            //         field:发生改变的字段
            //         value:改变后的的值
        }
    });
});