﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-attr",
    "dojo/dom-construct",
    "dijit/_WidgetBase"
],function(declare,lang,array,domAttr,domConstruct,_WidgetBase){
    return declare("",[_WidgetBase],{
        // summary: 
        //      定义了web端的下拉列表组件，继承自_WidgetBase.
        
        // field:String
        //      组件名称
        //      实际可能是该组件需要的某些字段、组件的组件名、与之联动的组件的组件名或字段名构成的一段字符串。
        field:"",
        
        //selectOptions:String
        //      下拉选项
        //      格式例如："{"1":"男","2","女"}"
        //      optgroup：{1："男"，2："女"，3："人妖"，"植物"：{4:"树"，5:"abc"}}
        selectOptions:"",
        
        // canEdit:boolean
        //      编辑状态，true为可编辑。
        canEdit:true,
        buildRendering:function(){
            // summary:
            //      初始化组件
            // tags:
            //      private
            this.inherited(arguments);
            this._keys = [];
            if(this.selectOptions&&lang.isString(this.selectOptions)){
                this.selectOptions = JSON.parse(this.selectOptions);
            }
            if(this.selectOptions){
                this.refreshOptions(this.selectOptions);
				this.onFieldChanged(this,this.field,this._keys[0]);
            }
            this.connect(this.domNode,"onchange",function(){
				this.value = this.domNode.value;
                this.onFieldChanged(this,this.field,this.domNode.value);
            });
            this.setCanEdit(this.canEdit!==false&&this.canEdit!=="false");
        },
		refreshOptions:function(options){
			this.selectOptions = options;
			this._keys = [];
			this._values = [];
            this.domNode.innerHTML = "";
			for(var k in this.selectOptions){
				// 如果是分组，则再遍历
				if(typeof this.selectOptions[k] == "object"){
					domConstruct.create("optgroup", {
						label:k
					}, this.domNode);
					for(var kk in this.selectOptions[k]){
						this._keys.push(kk);
						this._values.push(this.selectOptions[k][kk]);
						domConstruct.create("option", {
							value:kk,
							innerHTML:this.selectOptions[k][kk]
						}, this.domNode);
					}
				}
				//如果不是分组，则直接添加到select中
				else{
					this._keys.push(k);
					this._values.push(this.selectOptions[k]);
					domConstruct.create("option", {
						value:k,
						innerHTML:this.selectOptions[k]
					}, this.domNode);
				}
			}
            this.setValue(this.getValue());
		},
        setCanEdit:function(canEdit){
            // summary:
            //      设置组件是否可编辑。
            // params:
            //      canEdit:编辑状态
            // tags:
            //      public
            this.canEdit = false===canEdit?false:true;
            domAttr.set(this.domNode,"disabled",!this.canEdit);
        },
        getValue:function(){
            // summary:
            //      获取组件的值
            // tags:
            //      private
			return this.value;
        },
        setValue:function(value){
			this.value = value;
            // summary:
            //      设置组件的值
            // params:
            //      value:组件的值
            // tags:
            //      private
            if(value||0===value||false===value){
                var len = this._keys.length;
                while(len--){
                    if(this._keys[len]==value){
						this.domNode.selectedIndex = len;
						this.domNode.value = value;
                        return ;
                    }
                }
            }
			this.domNode.value = "";
			this.domNode.selectedIndex = -1;
        },
        onFieldChanged:function(widget,field,value){
            // summary:
            //      本对象发生变化后通知其他对象刷新的接口
            // params:
            //      widget:发生变化对象所在的view
            //      field:发生变化的对象
            //      value:改变后的值
            // tags:
            //      interface
        }
    });
});