define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/xhr",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/Deferred",
    "dojo/touch",
    "dijit/_WidgetBase",
    "cq/biz/user/user",
    "cq/util/config/config",
    "cq/biz/sms/sms"
],function(declare,lang,xhr,domAttr,domClass,domConstruct,Deferred,touch,_WidgetBase,user,config,sms){
    
    return declare("cq.app.widget.web.edit.UserNameAndVerifyCode",[_WidgetBase],{
        // summary: 
        //      定义了web端的注册组件，继承自_WidgetBase.
        
        // htmlTemp:String
        //      组件的DOM结构字符串,并传递组件的属性。
        // tags:
        //      private    
        htmlTemp:'<div id="{id}" data-cq-field="{field}" class="cq-field-input cq-form-UserNameAndVerifyCode" data-dojo-type="cq/app/widget/web/edit/UserNameAndVerifyCode" data-dojo-props="canToLogin:\'{canToLogin}\',field:\'{field}\',errorMsg:\'{errorMsg}\',unExists:\'{unExists}\',canEdit:{canEdit}"></div>',
       
        // field:String
        //      组件名称
        //      实际可能是该组件需要的某些字段、组件的组件名、与之联动的组件的组件名或字段名构成的一段字符串。
        field:"",
        
        // canEdit:boolean
        //      编辑状态，true为可编辑。
        canEdit:true,
        // errorMsg:String
        //      错误提示信息
        errorMsg:"请输入正确的11位电话号码",
        //unExists:String
        //      账号已经存在提示信息
        unExists:"账号已经存在,请直接登陆",
        canToLogin:true,
        buildRendering:function(){
            // summary:
            //      初始化组件
            // tags:
            //      private
            this.inherited(arguments);
            this.canToLogin = "false"!==this.canToLogin&&false!==this.canToLogin;
            this.containerNode = this.containerNode||this.domNode;
            this._initEditor();
        },
        setCanEdit:function(canEdit){
            // summary:
            //      设置组件是否可编辑。
            // params:
            //      canEdit:编辑状态
            // tags:
            //      public
            this.canEdit = canEdit;
            domAttr.set(this.un, "disabled", !canEdit);
            domAttr.set(this.vcode, "disabled", !canEdit);
            domAttr.set(this.btn, "disabled", !canEdit);
        },
        _initEditor:function(){
            // summary：
            //      实现登录使用的组件
            if(!this.editor){
                this.editor = domConstruct.create("div", {
                    
                }, this.containerNode);
                this.uNameItem = domConstruct.create("div",{
                    
                },this.editor);
                this.label = domConstruct.create("label", {
                    innerHTML:"手机号"
                }, this.uNameItem);
                this.un = domConstruct.create("input", {
                }, this.uNameItem);
                this.vCodeItem = domConstruct.create("div", {
                    
                }, this.editor);
                this.label1 = domConstruct.create("label", {
                    innerHTML:"验证码"
                },this.vCodeItem);
                this.vcode = domConstruct.create("input", {
                    
                },this.vCodeItem);
                this.btn = domConstruct.create("a", {
                    innerHTML:"获取验证码",
                    href:"javascript:void(0);",
                    className:"vCode-highlight"
                }, this.vCodeItem);
                // 手机号码输入框内容改变事件
                this.connect(this.un, "onblur", lang.hitch(this, function(e){
                    this.onFieldChanged(this, this.field.split(",")[0], this.un.value);
                    this.value[0] = this.un.value;
                }));
                // 验证码输入框内容改变事件
                this.connect(this.vcode, "onblur", lang.hitch(this, function(e){
                    this.onFieldChanged(this, this.field.split(",")[1], this.vcode.value);
                    this.value[1] = this.vcode.value;
                }));
                // 获取验证码按钮点击事件
                    // 手机号错误
                    // 手机号正确
                        // 发送验证码
                        // 设置定时器，一分钟后可以再次发送验证码
                touch.release(this.btn, lang.hitch(this, function(e){
                    var msg = this.validateUserName();
                }));
                setTimeout(lang.hitch(this,function(){
                    domClass.add(this.uNameItem,"cq-form-item");
                    domClass.add(this.vCodeItem,"cq-form-item");
                    domClass.add(this.label,"cq-form-label");
                    domClass.add(this.label1,"cq-form-label");
                    domClass.add(this.un,"cq-form-input cq-field-input");
                    domClass.add(this.btn,"cq-form-link");
                    domClass.add(this.vcode,"cq-form-input cq-field-input cq-field-input half-length");
                }),10);
            }else{
                this.setValue(this.getValue());
            }
        },
        validateUserName:function(){
                // summary:
                //      验证用户名
            var username = this.un.value;
            if(this.isCellPhone(username)){
                user.checkPlatformUser(username).then(lang.hitch(this, function(data) {
                    // 注册时，如果手机号已经存在，则直接跳转到登录页面
                    if(this.canToLogin){
                        if(data&&data.data&&data.data.ok == 1){
                            this.un.value = "";
                            alert(this.unExists||"账号已经存在,请直接登陆");
                            setTimeout(function() {
                                window.moveToView("login");
                            }, 300);
                        }else{
                            this.getVCode();
                        }
                    }else {// 修改密码时，如果手机号存在，则发送验证码，否则提示手机账号不存在
                        if(data&&data.data&&data.data.ok == 1){
                            this.getVCode();
                        }else{
                            alert("账号不存在");
                        }
                    }
                    //if (data.data.ok === 1) {
                    //    this.un.value = "";
                    //    alert(this.unExists||"账号已经存在,请直接登陆");
                    //    setTimeout(function() {
                    //        window.moveToView("login");
                    //    }, 300);
                    //} else {
                    //    this.getVCode();
                    //}
                }));
            }else {
                alert(this.errorMsg||"请输入正确的11位电话号码");
            }
        },
        getVCode:function(){
            // summary:
            //      发送验证码
            if(this.sendingTime){
                alert("请稍后再发!");
                return;
            }
            window.busy();
            sms.sendVcode(this.un.value).then(lang.hitch(this, function(rt){
                window.free();
                if(rt.data.ok === 1){
                    alert("验证码已发出，请注意查收！");
                    this.sendingTime = Date.now();
                    return this.vCodeInterval = setInterval(lang.hitch(this, this.updateVCode), 1000);
                }
                return alert(rt.data.message||"请稍后重试");
            }));
        },
        updateVCode:function(){
            // summary
            // 立即或者等待60秒发送验证码
            var diff = 60- (Date.now() - this.sendingTime)/1000;
            if(diff > 0){
                diff = diff.toFixed(0);
                this.btn.innerHTML = diff + "秒后重发";
            }else{
                this.sendingTime = null;
                clearInterval(this.vCodeInterval);
                this.vCodeInterval = null;
                this.btn.innerHTML = "获取验证码";
            }
        },
        isCellPhone:function(phone){
            // summary:
            //      验证手机号的合法性
            // params:
            //      phone:手机号
            return /(^1[3|4|5|7|8][0-9]{9}$)/.test(phone) && phone.length==11;
        },
        onFieldChanged:function(widget, field, value){
            // summary:
            //      本对象发生变化后通知其他对象刷新的接口
            // params:
            //      widget:发生变化对象所在的view
            //      field:发生变化的对象
            //      value:改变后的值
            // tags:
            //      interface
        },
        setValue:function(value){
            // summary:
            //      设置组件的值
            // params:
            //      value:组件的值
            // tags:
            //      private
            this.value = value||[];
            if(this.editor){
                this.un.value = this.value[0]||"";
                this.vcode.value = this.value[1]||"";
            }
        },
        getValue:function(){
            // summary:
            //      获取组件的值
            // tags:
            //      private
            return this.value||[];
        }
    });
});