﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/dom-class",
    "dojo/dom-attr",
    "dojo/Deferred",
    "dijit/_WidgetBase",
    "cq/biz/shop/bs/district"
],function(declare,lang,array,domConstruct,domStyle,domClass,domAttr,Deferred,_WidgetBase,district){
    // module:
    //      cq/app/widget/web/edit/VillagEdit
    
    return declare("cq.app.widget.web.edit.DistrictEdit",[_WidgetBase],{
        
        htmlTemp:'<div id="{id}" data-cq-field="{field}" class="cq-field-input cq-form-input cq-form-districtedit" data-dojo-type="cq/app/widget/web/edit/VillageEdit" data-dojo-props=\'field:"{field}",fixedUpDis:{j:fixedUpDis},canEdit:"{canEdit}"\'></div>',
        
        field:'',
        
        canEdit:true,
        
      
        fixedUpDis:null,
        
        districtHash:{},
        
        buildRendering:function(){
            this.value=[];
            this.inherited(arguments);
            this.containerNode = this.containerNode||this.domNode;
            this._initEdit();
        },
        
        setCanEdit:function(canEdit){
            this.canEdit = canEdit;
            if(this.canEdit === false){
                domAttr.set(this.townSelect, "disabled", "disabled");
                domAttr.set(this.villageSelect, "disabled", "disabled");
            }else{
                domAttr.remove(this.townSelect, "disabled");
                domAttr.remove(this.villageSelect, "disabled");
            }
        },
        _initEdit:function(){
            if(!this.editor){
                this.editor = domConstruct.create("div", {
                    className:"cq-districteditor"
                }, this.containerNode);
                this.townSelect = domConstruct.create("select", {
                    className:"cq-districteditor-select"
                }, this.editor);
                this.villageSelect = domConstruct.create("select", {
                    className:"cq-districteditor-select"
                }, this.editor);
                this.initData();
            }else{
                this.editor.setValue(this.getValue());
            }
        },
        initData:function(){
            var parentId="";
            if(this.value&&this.value[0]&&this.value[0]._id){
                parentId = this.value[0]._id;
            }else{
                parentId = this.countryId
            }
            this.loadDistrictData(parentId).then(lang.hitch(this, function(data){
                this.townSelect.innerHTML = "";
                domConstruct.create("option", {
                    innerHTML:"请选择镇"
                }, this.townSelect);
                data.forEach(lang.hitch(this, function(dis){
                    domConstruct.create("option", {
                        innerHTML:dis.distName,
                        _id:dis._id
                    }, this.townSelect);
                }));
                if(this.fixedUpDis.upDis&&this.fixedUpDis.upDis.length){
                    this.setValue(this.fixedUpDis.upDis);
                    domStyle.set(this.townSelect, "display", "none");
                    if(this.fixedUpDis.upDis.length == 2){
                        domStyle.set(this.villageSelect, "display", "none");
                    }
                }
            }));
            domConstruct.create("option", {
                innerHTML:"全部"
            }, this.villageSelect);
            this.connect(this.townSelect, "onchange", lang.hitch(this, function(evt){
                this.villageSelect.innerHTML = "";
                domConstruct.create("option", {
                    innerHTML:"全部"
                }, this.villageSelect);
                this.loadDistrictData(domAttr.get(this.townSelect.selectedOptions[0], "_id")).then(lang.hitch(this, function(data){
                    data.forEach(lang.hitch(this, function(dis){
                        domConstruct.create("option", {
                            innerHTML:dis.distName,
                            _id:dis._id
                        }, this.villageSelect);
                    }));
                }));
                // value值
                this.value[0] = this.districtHash[this.countryId][this.townSelect.selectedIndex];
                this.value[1] = null;
                this.value[2] = this.value[0]?(this.value[0].distName + (this.value[1]?("," + this.value[1].distName + (this.value[2]?("," + this.value[2].distName):"")):"")):"";
                
                this.onFieldChanged(this, this.field.split(",")[1], this.value[0]);
                this.onFieldChanged(this, this.field.split(",")[2], this.value[1]);
                //this.onFieldChanged(this, this.field.split(",")[2], this.value[2]);
               
            }));
            
            this.connect(this.villageSelect, "onchange", lang.hitch(this, function(evt){
                if(this.townSelect.options[0].innerHTML == "全部"){
                    this.value[1] = null;
                }else{
                    this.value[1] = this.districtHash[domAttr.get(this.townSelect.selectedOptions[0], "_id")][this.villageSelect.selectedIndex - 1];
                }
                this.value[2] = this.value[0]?(this.value[0].distName + (this.value[1]?("," + this.value[1].distName + (this.value[2]?("," + this.value[2].distName):"")):"")):"";
                this.onFieldChanged(this, this.field.split(",")[1], this.value[0]);
                this.onFieldChanged(this, this.field.split(",")[2], this.value[1]);
            }));
            
        },
        loadDistrictData:function(parentId){
            if(this.districtHash[parentId]){
                var def = new Deferred();
                def.resolve(this.districtHash[parentId]);
                return def;
            }else{
                return district["loadByUpId"](parentId).then(lang.hitch(this, function(data){
                    data = data&&data.data&&data.data.items||[];
                    this.districtHash[parentId] = data;
                    return data;
                }));
            }    
        },
        onFieldChanged:function(widget, field, value){
        },
        setValue:function(value){
            this.value = value||[];
            if(this.value[0].level===4){
                this.countryId=this.value[0]._id
            }
            if(this.fixedUpDis&&this.fixedUpDis.upDis){
                for(var i=0;i<this.fixedUpDis.upDis.length;i++){
                    if(this.value[i]){
                        break;
                    }else{
                        this.value[i] = this.fixedUpDis.upDis[i];
                    }
                }
            }
            
            if(value&&value[0]&&this.value[0].level===4){
                this.initData();
                var options = this.townSelect.options;
                if(!options || !options.length){
                    return;
                }
                array.forEach(options, lang.hitch(this, function(option, index){
                    if(domAttr.get(option, "_id") == (value[0]._id||value[0])){
                        this.townSelect.selectedIndex = index;
                    }
                }));
                this.villageSelect.innerHTML = "";
                domConstruct.create("option", {
                    innerHTML:"全部"
                }, this.villageSelect);
                
            }else if(value&&value[0]&&this.value[0].level!==4){
                var options = this.townSelect.options;
                if(!options || !options.length){
                    return;
                }
                array.forEach(options, lang.hitch(this, function(option, index){
                    if(domAttr.get(option, "_id") == (value[0]._id||value[0])){
                        this.townSelect.selectedIndex = index;
                    }
                }));
                this.villageSelect.innerHTML = "";
                domConstruct.create("option", {
                    innerHTML:"全部"
                }, this.villageSelect);
                this.loadDistrictData(this.value[0]._id).then(lang.hitch(this, function(data){
                    data.forEach(lang.hitch(this, function(dis){
                        domConstruct.create("option", {
                            innerHTML:dis.distName,
                            _id:dis._id
                        }, this.villageSelect);
                    }));
                    if(value[1]){
                        options = this.villageSelect.options;
                        array.forEach(options, lang.hitch(this, function(option, index){
                            if(domAttr.get(option, "_id") == (value[1]._id||value[1])){
                                this.villageSelect.selectedIndex = index;
                            }
                        }));
                    }
                }));
            }
        },
        getValue:function(){
            return this.value||[];
        }
    });
});