define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/connect",
    "cq/biz/object",
	"cq/util/config/config"
],function(declare, lang, connect, object, config){
    var O = declare("", object.Schema, {
        modalName:"im/question_msg",
        quizSave : function (params) {
            params.fromShopId = this.getShopId();
            return this.exec("quiz_save", params);  
        },
        readSave : function (params) {
            return this.execInCurrentShop("save", params);
        },
        loadQuizById : function (_id) {
            return this.exec("load_quiz_by_id", {
                fromShopId : this.getShopId(),
                _id : _id
            });  
        },
        loadReadById : function (_id) {
            return this.execInCurrentShop("load_by_id", {_id : _id});
        },
        getQuizLoadUrl : function () {
            return this.getBaseUrl() + "/load_quiz?fromShopId=" + this.getShopId();
        },
        getReadLoadUrl : function () {
            return this.getBaseUrl() + "/load_read?shopId=" + this.getShopId();
        },
        loadRead : function (params) {
            return this.execInCurrentShop("load_read", params);
        },
        show : function (_id) {
            return this.execInCurrentShop("show", {_id : _id});
        },
        cancelShow : function (_id) {
            return this.execInCurrentShop("cancel_show", {_id : _id});
        }
    });
    //创建消息对象
    var o = new O();
    lang.setObject("cq.biz.im.questionMsgNew", o);
    o.Schema = O;
    return o;
});