﻿// 创建人:王龙
// 创建时间:2016-7-13
// 创建内容:erp畜只接口
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/Deferred",
    "cq/biz/object"
],function(declare, lang, array, Deferred, object){
    var O = declare("",object.Schema,{
        modalName:"mat/cattle",
        //加载
        loadById:function(id){
            return this.execInCurrentShop("load_by_id", {_id : id});
        },
        // 根据查询条件加载畜只
        findByQuery : function (params) {
            return this.execInCurrentShop("find_by_query", params);  
        },
        //所有数据
        loadAllInfo:function(id){
            return this.execInCurrentShop("load", {shopId : this.getShopId()});
        },
        //保存
        save:function(data){
            return this.execInCurrentShop("save", data);
        },
        saveAll:function(params){
            return this.execInCurrentShop("save_some", params);
        },
        importRabbit : function (params) {
            return this.execInCurrentShop("import_rabbit", params);  
        },
        //为查询界面准备数据源
        getCattleUrl:function(){
            return this.getBaseUrl()+"/load?shopId="+this.getShopId();
        },
        //加载
        load:function(param){
           return this.execInCurrentShop("load",param);
        },
        //加载所有畜只
        findAll:function(id){
            return this.execInCurrentShop("findAll", {shopId : this.getShopId()});
        },
		loadByShop:function(param){
			return this.exec("load_by_shop",param);
		},
        //参数格式：
        //{cattleDatas:[{bamId:"fsdafds",stallId:"fsdaf",capacity:10},...]}
        //返回值：同正常查询的结果
        create : function (param) {
            return this.execInCurrentShop("batch_create", {
                cattleDatas:param
            });
        },
        // 批量创建指定数量的幼畜记录
        // 参数：qty:要创建的数量 ,motherId:母畜,deliverRecordId:产仔记录
        batchCreateCubs : function (condition) {
            return this.execInCurrentShop("batch_create_cubs",condition);
        },
        entryCreateCubs : function (condition) {
            return this.execInCurrentShop("entry_create_cubs",condition);
        },
        //删除
        deleteById : function(id){
            return this.execInCurrentShop("delete_by_id", {_id : id});
        },
        //查询已发清的种母畜
        loadEstrusUrl : function(){
            return this.getBaseUrl()+"/load_estrus?shopId="+this.getShopId();
        },
        //修改畜只公畜检查结论
        updateMaleOkById : function(param){
            return this.execInCurrentShop("update_maleok_by_id",param);
        },
        //返回已配种或已怀孕的母畜
        loadFertilizedUrl : function(param){
            return this.getBaseUrl()+"/load_fertilized?shopId="+this.getShopId();
        },
        //查询公样列表
        getMaleUrl : function(){
            return this.getBaseUrl()+"/load_male?shopId="+this.getShopId();
        },
        //配种记录专用查询公羊列表
        getMaleUrl1 : function(){
            return this.getBaseUrl()+"/load_male1?shopId="+this.getShopId();
        },
        //查询母羊列表
        getFemaleUrl : function(){
            return this.getBaseUrl()+"/load_female?shopId="+this.getShopId();
        },
        //查询待试情的母畜
        loadFemaleTeasingUrl : function(){
            return this.getBaseUrl()+"/load_female_teasing?shopId="+this.getShopId();
        },
        //查询本畜只与指定畜只的亲缘关系
        getRelation : function(param){
            return this.execInCurrentShop("get_relation",param); 
        },
        //查询各种状态下的畜只数量
        getStateCount : function(param){
            return this.execInCurrentShop("get_state_count",param); 
        },
        getCattleCount : function (params) {
            return this.execInCurrentShop("get_cattle_count", params);
        },
        getSexCount : function (params) {
            return this.execInCurrentShop("get_sex_count", params);
        },
        loadGenealogyById : function (id) {
            return this.execInCurrentShop("load_genealogy_by_id", {_id : id});
        },
        // 清空原有的数据
        clearCattle : function () {
            return this.execInCurrentShop("clear_cattle");  
        },
        // 加载指定店铺的各种畜只数量
        getSexCountByShop : function (params) {
            return this.exec("plat_get_sex_count", params);
        },
        // 加载公兔的繁育性能
        maleBreedProperty : function (id) {
            return this.execInCurrentShop("male_breed_property", {_id : id});
        },
        femaleBreedProperty : function (id) {
            return this.execInCurrentShop("female_breed_property", {_id : id});
        },
        rabbitFemaleProductivity : function (id) {
            return this.execInCurrentShop("rabbit_female_productivity", {cattleId : id});
        }
    });
    var o = new O();
        lang.setObject("cq.biz.mat.cattle", o);
        o.Schema = O;
        return o;
})