define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/biz/object"
], function(declare, lang, object) {
    var Discount = declare("", object.Schema, {
        modalName: "mk/discount",
        //查询当前商家的优惠活动
        getLoadUrl: function() {
            return this.getBaseUrl() + "/load?shopId=" + this.getShopId();
        },
        //用户自领优惠券
        //参数: _id，shopId
        getCouponByUserSelf: function(params) {
            return this.exec("get_coupon_by_user_self", params);
        },        
        //获取可用优惠活动
        loadAvailableByUserSelf: function() {
            return this.getBaseUrl() + "/load_available_by_user_self?shopId=" + this.getShopId();
        },
        //获取工抽奖使用的优惠券 徐阿雪
        loadPrizeByUserSelf:function(){
            return this.getBaseUrl() + "/load_prize_by_user_self?shopId=" + this.getShopId();
        },
        //获取可用优惠活动
        loadAvailableByUserSelfThen: function(params) {
            if(!params.shopId){
                params.shopId = this.getShopId();
            }
            return this.exec("load_available_by_user_self", params);
        },
        //网站获取可用优惠活动
        loadB2BAvailableByUserSelf: function(params) {
            return this.exec("load_available_by_user_self", params);
        },
        // 保存创建的活动
        save: function(params) {
            return this.execInCurrentShop("save", params);
        },
        // 加载指定的id内容
        loadById: function(id) {
            return this.execInCurrentShop("load_by_id", {
                _id: id
            });
        },
        // 停用优惠活动
        disableById: function(id) {
            return this.execInCurrentShop("disable_by_id", {
                _id: id
            });
        },
        // 加载来自供应商的优惠活动
        loadAvailableByUserSelfB: function(params) {
            return this.execInCurrentShop("load_available_by_user_self_b", params);
        },
        // 获得来自供应商的优惠券
        getCouponByUserSelfB: function(params) {
            return this.execInCurrentShop("get_coupon_by_user_self_b", params);
        },
        // 更新优惠活动的优惠商品信息 2016/12/15 杜飞军
        upDateMatSelect: function(params) {
            return this.execInCurrentShop("upDate_matSelect", params);
        }
    });
    var discount = new Discount();
    lang.setObject("cq.biz.mk.discount", discount);
    return discount;
});
//保存