﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/json",
    "dojo/Deferred",
    "cq/biz/object"
], function(declare, lang, array, json, Deferred, object) {
    var O = declare("", object.Schema, {
        modalName: "ts/batch",
        //加载
        loadById: function(id) {
            return this.execInCurrentShop("load_by_id", { _id: id });
        },
        //保存
        save: function(data) {
            //data = this.filterSaveData(data);
            return this.execInCurrentShop("save", data);
        },
        //为查询界面准备数据源
        getLoadUrl: function() {
            return this.getBaseUrl() + "/load?shopId=" + this.getShopId();
        },
        // 获取禽蛋类的存栏数量
        getTotalNum : function (params) {
            return this.execInCurrentShop("qdapp_get_total_num", params);
        },
        // 获取禽蛋类近一个月进场的数量
        getEnterNumByMonth : function (params) {
            return this.execInCurrentShop("get_enter_num_by_month", params);
        },
        loadByShop : function (param) {
            return this.exec("load_by_shop", param);
        },
        getAmountByParams : function (params) {
            return this.execInCurrentShop("get_amount_by_params", params);
        },
        loadLocationById : function (_id) {
            return this.execInCurrentShop("load_by_location_by_id", {_id : _id});
        },
        verify : function (params) {
            return this.execInCurrentShop("verify", params);
        },
        unVerify : function (params) {
            return this.execInCurrentShop("unverify", params);
        },
        rabbitVerify : function (params) {
            return this.execInCurrentShop("rabbit_verify", params);
        },
        rabbitUnVerify : function (params) {
            return this.execInCurrentShop("rabbit_unverify", params);
        }
    });
    var o = new O();
    lang.setObject("cq.biz.ts.batch", o);
    o.Schema = O;
    return o;
})
