/*
变更人：徐阿雪
变更时间：2017/2/8
变更内容：选择的购物车的商品重新写了几个方法
*/
define([
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/json",
    "dojo/topic",
    "dojo/Deferred"
], function(lang, array, json, topic,Deferred){
    return lang.mixin(lang.getObject("cq.biz.ts.cart", true),{
        add:function(mid, qty){
            var orderCar = this.get();
            orderCar[mid] = (orderCar[mid]||0) + parseInt(qty)||1;
            this.set(orderCar);
        },
        set:function(car){
            for(var k in car){
                if(!(car[k]>0)){
                    delete car[k];
                }
            }
            localStorage.setItem(window.code + "order", json.toJson(car));
            topic.publish("cq/biz/ts/cart/numChanged",this.getNum());
        },
        get:function(){
            var cart = json.fromJson(localStorage.getItem(window.code + "order") || "{}");
            for(var k in cart){
                if(!(cart[k]>0)){
                    delete cart[k];
                }
            }
            return cart;
        },
        getIds:function(){
            var cart = json.fromJson(localStorage.getItem(window.code + "order") || "{}");
            var data=[];
            for(var id in cart){
                data.push(id);
            }
            return data;
        },
        getAsArray:function(){
            var cart = json.fromJson(localStorage.getItem(window.code + "order") || "{}");
            var data=[];
            for(var id in cart){
                data.push({mid:id,qty:cart[id]});
            }
            return data;
        },
        //监听采购页面的变化
        appCartChange:function(){
            topic.publish("order.pay.finish");
        },
        //不知道哪儿在用没有，是错误的做法2017/4/1
        clear:function(mids){
            var car = this.get();
            if(mids){
                array.forEach(mids, function(mid){
                    delete car[mid];
                });
            }else{
                car = {};
            }
            this.set(car);
        },
        //2017/4/1徐阿雪，删除某一个一个商品
        deleteMid:function(mids){
            var car = this.get();
            if(mids){
                if(car[mids]){
                    delete car[mids];
                }
            }
            this.set(car);
        },
        setSelected:function(selectedIds){
            localStorage.setItem(window.code + "selected", json.toJson({mids:selectedIds}));
        },
        getSelected:function(){
            var cart = json.fromJson(localStorage.getItem(window.code + "selected"));
            mids = cart&&cart.mids||[];
            return mids;
        },
        //购买选中的商品
        getSelectedChart:function(){
            var sMids = this.getSelected();
            var cart = this.get();
            var chart = {};
            array.forEach(sMids, function(mid){
                if(cart[mid]>0){
                    chart[mid] = cart[mid];
                }
            });
            return chart;
        },
        getNum:function(){
            var car = this.get();
            var num=0;
            for(var item in car){
                num+=car[item];
            }
            return num;
        },
        //2017/2/8徐阿雪，将webSelected单独写的选中，防止重盐app使用的可能有冲突
        //购物车选中商品，几个需要重写的接口,
        //直接设置购物车数量,提交订单是需要修改数量
        setCartQty:function(mid,qty){
            var orderCar = this.get();
            orderCar[mid] = parseInt(qty);
            this.set(orderCar);
        },
        //设置商品选中或者取消选中
        updateMatSelected:function(mid,selected){
            if(!mid){
                return;
            }
            var add=true;
            var allMids = this.getSelected();
            if(selected){
                if(allMids.length){
                    array.forEach(allMids,function(allmid){
                        if(allmid==mid){
                            add = false;
                        }
                    });
                    if(add){
                        allMids.push(mid);
                    }
                }else{
                    allMids.push(mid);
                }
                this.setSelected(allMids);
            }else{
                this.clearSelected(mid);
            }
        },
        //获取当前选中的所有商品的qty的总和
        getSelectedQty:function(){
            //获取当前选中的商品的mids:,mid,mid,
            var mids = this.getSelected();
            var cart = this.get();
            var data=0;
            array.forEach(mids,function(mid){
                if(cart[mid]){
                    data += cart[mid];
                }
            });
            return data;
        },
        clearSelected:function(mid){
            var mids = this.getSelected();
            for(var i=0;i<mids.length;i++){
                if(mids[i]==mid){
                    mids.splice(i,1);
                    break;
                }
            }
            this.setSelected(mids);
        },
        //清除所有选中
        clearAllSelected:function(){
            this.setSelected("");
        },
        //获取选中的所有商品的mid和相应的qty
        getMatQtys:function(){
            var mids = this.getSelected(),info = this.get(),matQtys = [];
            for(var i=0;i<mids.length;i++){
                if(info[mids[i]]){
                    matQtys.push({
                        mid:mids[i],
                        qty:info[mids[i]]
                    });
                }
            }
            return matQtys;
        },
        //需要对应商品的shopId的相关接口 
        //保存相应的的shopId
        //保存商品的id对应的数量qty和shopId
        addByShop:function(shopId,mid,qty){
            var orderCar = this.get();
            var orderCarshop =this.getShopIdAndMid();
            orderCar[mid] = (orderCar[mid]||0) + parseInt(qty)||1;
            orderCarshop[mid] = shopId;
            this.set(orderCar);
            this.setShopIdAndMid(orderCarshop);
            this.appCartChange();
        },
        setShopIdAndMid:function(shopMatMap){
            localStorage.setItem(window.code+"orderShop",json.toJson(shopMatMap));
        },
        getShopIdAndMid:function(){
            return json.fromJson(localStorage.getItem(window.code+"orderShop")||"{}");
        },
        clearShop:function(mids){
            var car = this.get();
            var carShop = this.getShopIdAndMid();
            if(mids){
                array.forEach(mids, function(mid){
                    delete car[mid];
                    delete carShop[mid];
                });
            }else{
                car = {};
                carShop = {};
            }
            this.set(car);
            this.setShopIdAndMid(carShop);
            this.appCartChange();
        },
        //修改购物车中指定商品的数量   qty为0 时删除该商品
        setMatQty:function(mid,qty){
            var info = this.get();
            qty = qty-0;
            if(qty>0){
                info[mid] = qty;
            }else{
                delete info[mid];
            }
            this.set(info);
            //-1来区分加入购物车商品的变更
            //this.add(mid,"set");
            //return info;
        },
        //购物车处理数据
        //加载购物车数据
        loadCartData:function(){
            var def = new Deferred();
            require(["cq/biz/mat/mat","cq/biz/shop/shop"],lang.hitch(this,function(mat,shop){
                mat.loadByIds(this.getIds()).then(lang.hitch(this,function(mats){
                    mats = mats&&mats.data&&mats.data.items||[];
                    if(!(mats&&mats.length)){
                        def.resolve([]);//return [];
                    }else{
                        //失效商品和无库存的商品
                        var unUseMats = [],unUse=[];
                        //按照商家分类
                        var items = [],
                            currentMat = null,
                            matInfo = this.get(),
                            mids = this.getSelectedChart(),
                            selectedInfo = {},
                            shopInfo = null,
                            shopHash = {},
                            shopIds = [],
                            i;
                        for(i=0;i<mids.length;i++){
                            selectedInfo[mids[i]] = true;
                        }
                        for(i=0;i<mats.length;i++){
                            currentMat = mats[i];
                            //失效商品和无库存的商品
                            if(currentMat.isPurchase && currentMat.qty && currentMat.fromShopId){
                                shopInfo = shopHash[currentMat.fromShopId];
                                if(!shopInfo){
                                    shopInfo = {
                                        mats:[]
                                    };
                                    shopHash[currentMat.fromShopId] = shopInfo;
                                    items.push(shopInfo);
                                    shopIds.push(currentMat.fromShopId);
                                }
                                //库存，//商品在购物车里面的数量
                                this._updateMatsQty(currentMat,matInfo);
                                currentMat.selected = !!selectedInfo[currentMat._id];
                                //修改在活动中的商品的价格
                                currentMat.specs = {};
                                shopInfo.mats.push(currentMat); 
                            }else{
                                //已经下架和失效的商品整理到一起
                                unUse.push(currentMat);
                            }
                        }
                        //加载商家信息,需要商家的商家名称
                        if(shopIds.length||unUse.length){
                            shop.loadByIds(shopIds).then(lang.hitch(this,function(shops){
                                shops = shops&&shops.data&&shops.data||[];
                                for(i=0;i<shops.length;i++){
                                    shopHash[shops[i]._id].shopInfo = shops[i];
                                }
                                var a = [];
                                //有失效的商品就创建失效的商家列表
                                if(unUse.length){
                                    var unUseShopInfo={shopName:"失效的商品",_id:"111"};
                                    unUseMats.push({mats:unUse,shopInfo:unUseShopInfo});
                                    a = items.concat(unUseMats);
                                }else{
                                    a = items;
                                }
                                def.resolve(a);
                            }));
                        }else{
                            def.resolve([]);
                        }
                    }
                }));
            }));
            return def;
        },
        //修改商品的最小起订量
        _updateMatsQty:function(mat,matInfo){
            //显示的库存
            mat.stockQty = mat.qty;
            mat.minQty = mat.purchaseQty||1;
            mat.retailPrice = mat.purchasePrice;
            //处理商品的数量和选中
            //查看localStorage里面保存的购物车数据和库存的大小
            //商品在购物车里面的数量，取localStorage和商品库存的最小值（其他地方买了会导致商品存款减少）
            mat.qty = matInfo[mat._id];//||mat.minQty;//Math.min(matInfo[mat._id],mat.purchaseQty||1);
        }
    });
});