define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/biz/object",
    "cq/util/config/config"
], function (declare, lang, object, config) {
    var O = declare("", object.Schema, {
        modalName: "ts/refund_application",
        loadById: function (condition) {
            if(!condition.shopId){
				condition.shopId = this.getShopId()
			}
            return this.exec("load_by_id", condition);
        },
		loadByTsId: function (condition) {
			if(!condition.shopId){
				condition.shopId = this.getShopId()
			}
            return this.exec("load_by_tsId", condition);
        },
        load: function () {
            return this.getBaseUrl()+"/load?shopId="+this.getShopId();
        },
        save:function(item){
			if(!item.shopId){
				item.shopId = this.getShopId();
			}
			item.userShopId = this.getShopId();
            return this.exec("save",item);
        },
        applyAgain:function(item){
            if(!item.shopId){
				item.shopId = this.getShopId();
			}
			item.userShopId = this.getShopId();
            return this.exec("apply_again",item);
        },
        aggree:function(params){
            if(!params.shopId){
				params.shopId = this.getShopId()
			}
            return this.exec("aggree",params);
        },
		disaggree:function(params){
            if(!params.shopId){
				params.shopId = this.getShopId()
			}
            return this.exec("disaggree",params);
        }
    });
    var o = new O();
    lang.setObject("cq.biz.ts.refundApplication", o);
    o.Schema = O;
    return o;
});