﻿define([
    "dojo/topic", //不依赖的模块
    "dojo/Deferred", //不依赖的模块
    "dojo/_base/lang", //不依赖的模块
    "cq/biz/user/user", //不依赖的模块
    "./BoBase",
    "dojo/topic", //不依赖的模块
    "cq/util/config/config", //不依赖的模块
    "cq/biz/article/article",
    "cq/biz/article/articleGroup",
    "cq/util/sys/date",
    "cq/bo/section"
], function (topic, Deferred, lang, user, BoBase, topic, config, article, articleGroup, date, boSection) {
    var scCode = ",s_sc,s_zcjq,s_yxpq,s_ydbpq,s_ydnpq,s_jlp,s_spb,s_yb,s_yz,s_bn,s_ddk,s_na,s_jb,s_bb,s_yc,s_jj,s_hc,s_dz,s_qj,s_nc,s_rc,s_tl,s_bs,s_tn,s_wz,s_lp,s_ck,s_fd,s_dj,s_zx,s_kz,s_yy,s_fj,s_ws,s_wx,s_qj,s_wl,s_sztjzzzx,s_xstjzmzzzx,s_yytjzmzzzx,s_psmztjzzzx,";
    var articleBo = new BoBase({
        fields: {
            date: {
                type: "date",
                label: "日期",
                className: "small-width",
            },
            logo: {
                type: "image",
                label: "图片",
                editable: true,
                className: "large-width large-high"
            },
            code: {
                type: "text",
                placeHolder: "编号",
                label: "编号",
                className: "small-width"
            },
            groupName: {
                type: "text",
                placeHolder: "类别名称",
                label: "类别名称",
                className: "large-width"
            },
            title: {
                type: "text",
                placeHolder: "标题",
                label: "标题"
            },
            validDate: {
                type: "date",
                field: "validDate",
                label: "有效期"
            },
            brief: {
                type: "textarea",
                placeHolder: "摘要",
                label: "摘要",
                className: "large-width"
            },
            content: {
                type: "richText",
                label: "资讯详情",
                className: "large-width large-high2"
                    //className: "large-width large-high"
            },
            href: {
                type: "text",
                placeHolder: "链接地址",
                label: "链接地址",
                className: "large-width"
            },
            isTop: {
                type: "checkbox",
                label: "是置顶",
                className: "small-width"
            },
            "section": {
                type: "options",
                field: "section",
                options: {},
                label: "栏目",
                canEdit: true,
                className: "middle-width"
            },
            "section.title": {
                type: "text",
                field: "section.title",
                label: "栏目",
                className: "middle-width"
            },
            groupId: {
                type: "ref",
                field: "groupId",
                label: "用途",
                searchField: "groupName",
                pageSize: 5,
                labelFields: "groupName",
                dataProvider: "cq/biz/article/articleGroup",
                targetMethod: "getLoadUrl",
                canEdit: true,
                className: "middle-width"
            },
            "groupId.groupName": {
                field: "groupId.groupName",
                label: "用途",
                type: "text"
            },
            maker: {
                type: "text",
                field: "maker",
                label: "录入人"
            },
            makeDate: {
                type: "date",
                field: "makeDate",
                label: "录入日期"
            },
            saveButton: {
                type: "button",
                action: "onSaveArticle",
                label: "保存"
            },
            saveGroupButton: {
                type: "button",
                action: "onSaveGroup",
                label: "保存"
            },
            articleActions: {
                type: "text",
                label: "",
                formatter: function (action, data) {
                    var v = "<div class='button' cq-action='deleteArticle'>删除</div><div class='button' onclick='window.moveToView(\"news\",\"" + data._id + "\");'>编辑</div>";
                    return v;
                }
            },
            groupActions: {
                type: "text",
                label: "",
                formatter: function (action, data) {
                    var v = "<div class='button' cq-action='deleteGroup'>删除</div><div class='button' onclick='window.moveToView(\"newsGroup\",\"" + data._id + "\");'>编辑</div>";
                    return v;
                }
            }
        },
        getDetailTemplate: function () {
            return "<h4>{title}</h4><div>{content}</div>";
        },
        loadShopArticle: function () {
            return article.getArticleUrl();
        },
        loadPlatformAnn: function () {
            return article.getLoadByGroupNameUrl("平台公告");
        },
        loadPlatformActivity: function () {
            return article.getLoadByGroupNameUrl("活动公告");
        },
        loadPlatformBuyer: function () {
            return article.getLoadByGroupNameUrl("买家公告");
        },
        loadPlatformSaler: function () {
            return article.getLoadByGroupNameUrl("卖家公告");
        },
        loadPlatformArticle: function (param) {
            var def = new Deferred();
            article.loadPlatformById(param.cqViewParam.params).then(lang.hitch(this, function (data) {
                def.resolve(data.data.item);
            }));
            return def;
        },
        loadShopArticleById: function (param) {
            if (!param || !param.cqViewParam || !param.cqViewParam.params) {
                var userInfo = user.getCurrentShopUserData();
                return {
                    isUse: true,
                    makeDate: date.newDateISOString(),
                    maker: userInfo && (userInfo.pName || userInfo.nickName)
                };
            }
            var def = new Deferred();
            article.loadById(param.cqViewParam.params).then(lang.hitch(this, function (data) {
                if (data && data.data && data.data.item) {
                    if (data.data.item.section) {
                        data.data.item.section = data.data.item.section._id;
                    }
                }
                def.resolve(data.data.item);
            }));
            return def;
        },
        getArticleItemProp: function (data, itemType) {
            return {
                icon: data.logo || "",
                label: data.title || "",
                data: data
            };
        },
        getQueryParam: function (params) {
            var query = {
                isUse: true
            };
            if (params.queryInfo) {
                var k, queryInfo = params.queryInfo,
                    value;
                for (k in queryInfo) {
                    value = queryInfo[k];
                    if (value || 0 === value || false === value) {
                        if ("string" === typeof (value)) {
                            query[k] = value;
                        } else if (value.toString().indexOf("object") > -1) {
                            value = value._id;
                            if (value) {
                                query[k] = value;
                            }
                        } else {
                            query[k] = value;
                        }
                    }
                }
            }
            if (params.search) {
                query.title = params.search;
            }
            return query;
        },
        onShowArticle: function (item) {
            window.moveToView("trendDetail", item._id);
        },


        //列表界面相关功能
        //查询条件区域结构
        getQueryLayout: function () {
            this.fields.section.options = boSection.getSectionOptions();
            return [{
                type: "form",
                fields: this.getFormItems(["code", "title", "section", "groupId"])
            }];
        },
        //资讯信息表格化显示
        getArticleGridLayout: function () {
            if (!this.articleGridLayout) {
                this.articleGridLayout = this.getFormItems(["title", "section.title", "groupId.groupName", "makeDate", "articleActions"], false);
            }
            return this.articleGridLayout;
        },
        // 用于测试
        testQueryLayout: function () {
            return [{
                type: "form",
                fields: this.getFormItems(["date", "code", "title", "isTop", "section"])
            }];
        },
        onListAction: function (data, action, list) {
            if (action == "deleteArticle") {
                if (!confirm("确定删除吗？")) return;
                article.save({
                    _id: data._id,
                    isUse: false
                }).then(function () {
                    list.removeItemByData(data);
                });
            }
        },



        getArticleEditLayout: function () {
            if (!this.merchantLayout) {
                this.merchantLayout = [{
                    type: "form",
                    fields: this.getFormItems(["title", "code", "section", "groupId", "href", "logo", "brief", "content", "maker", "makeDate", "saveButton"])
                }]
            }
            return this.merchantLayout;
        },
        onEditDataReloaod: function (widget) {
            //用途是滚动图片时显示大图，否则隐藏
            var data = widget.getData();
            widget.getEditorByField("section").refreshOptions(boSection.getSectionOptions());
            this._updateLogoDisplay(widget, data);
        },
        _updateLogoDisplay: function (widget, data) {
            //选了分类就需要显示图片，焦点新闻会出现在左侧的滚动图区域
            if (!data || !data.groupId && (!data.section ||
                    scCode.indexOf(boSection.getSectionById(data.section).sCode) === -1)) {
                widget.hideByFields(["logo"]);
            } else {
                widget.showByFields(["logo"]);
            }
        },
        onEditFieldChange: function (widget, field, value) {
            var data = widget.getData();
            if ("groupId" === field) {
                this._updateLogoDisplay(widget, data);
            } else if ("section" === field) {
                this._updateLogoDisplay(widget, data);
            }
        },
        onSaveArticle: function (data, dataList) {
            var msg = this.validAgreeMsg(data);
            if (msg) {
                alert(msg);
                return;
            }
            article.save(data).then(function () {
                history.back();
            });
        },
        validAgreeMsg: function (data) {
            var notNullFields = ["href"];
            for (var i = 0; i < notNullFields.length; i++) {
                if (data[notNullFields[i]]) {
                    var strRegex = "^((https|http|ftp|rtsp|mms)?://)*" + "?(([0-9a-z_!~*'().&=+$%-]+: )?[0-9a-z_!~*'().&=+$%-]+@)?" // ftp的user@  
                        + "(([0-9]{1,3}\.){3}[0-9]{1,3}" // IP形式的URL- 199.194.52.184  
                        + "|" // 允许IP和DOMAIN（域名）  
                        + "([0-9a-z_!~*'()-]+\.)*" // 域名- www.  
                        + "([0-9a-z][0-9a-z-]{0,61})?[0-9a-z]\." // 二级域名  
                        + "[a-z]{2,6})" // first level domain- .com or .museum  
                        + "(:[0-9]{1,4})?" // 端口- :80  
                        + "((/?)|" // a slash isn't required if there is no file name  
                        + "(/[0-9a-z_!~*'().;?:@&=+$,%#-]+)+/?)$";
                    var re = new RegExp(strRegex);
                    if (!re.test(data[notNullFields[i]])) {
                        return "网址格式错误！";
                    }
                }
            }
        },



        //以下内容为资讯类别管理用
        loadGroup: function () {
            return articleGroup.getLoadUrl();
        },
        loadGroupById: function (param) {
            if (!param || !param.cqViewParam || !param.cqViewParam.params) return {
                isUse: true
            };
            var def = new Deferred();
            articleGroup.loadById(param.cqViewParam.params).then(lang.hitch(this, function (data) {
                def.resolve(data.data.item);
            }));
            return def;
        },
        getGroupEditLayout: function () {
            if (!this.groupEditLayout) {
                this.groupEditLayout = [{
                    type: "form",
                    fields: this.getFormItems(["logo", "code", "groupName", "saveGroupButton"])
                }];
            }
            return this.groupEditLayout;
        },
        getGroupQueryParam: function (params) {
            var query = {
                isUse: true
            };
            if (params.search) {
                query.groupName = params.search;
            }
            return query;
        },
        getGroupGridLayout: function () {
            if (!this.groupGridLayout) {
                this.groupGridLayout = this.getFormItems(["code", "groupName", "groupActions"], false);
            }
            return this.groupGridLayout;
        },
        onGroupListAction: function (data, action, list) {
            if (action == "deleteGroup") {
                if (!confirm("确定删除吗？")) return;
                articleGroup.save({
                    _id: data._id,
                    isUse: false
                }).then(function () {
                    list.removeItemByData(data);
                });
            }
        },
        onSaveGroup: function (data, dataList) {
            articleGroup.save(data).then(function () {
                history.back();
            });
        }
    });
    return articleBo;
});