define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "cq/biz/ts/pay/bankStatement",
    "cq/util/config/config",
    "cq/util/sys/date",
    "./BoBase"
],function(declare,lang,bankStatement,config,date,BoBase){
    var Bo =  declare("",BoBase,{
        fields:{
            "buyerShopId.shopName":{
                type:"text",
                label:"买家名称",
                className:"large-width",
                canEdit: false
            },
            "fromShopId.shopName":{
                type:"text",
                label:"卖家名称",
                className:"middle-width",
                canEdit: false
            },
            fromShopId:{
                type:"text",
                label:"卖家名称",
                className:"middle-width",
                canEdit: false
            },
            payType:{
                type:"options",
                label:"支付方式",
                options:config.orderPayType,
                className:"min-width"
            },
			payTypeName:{
				type:"text",
				label:"支付方式",
				formatter:function(action,data){
                    return config.getPayTypeStr(data.payType);
				},
                className:"min-width"
			},
            payTotalAmount : {
                type:"text",
                fixedTo:2,
                label:"支付金额",
                className:"min-width",
                canEdit: false                
            },
            feeTotalAmount : {
                type:"text",
                fixedTo:2,
                label:"手续费",
                className:"min-width",
                canEdit: false               
            },
            amount:{
                type:"text",
                label:"支付金额",
                className:"min-width",
                canEdit: false
            },
            feeAmount:{
                type:"text",
                label:"手续费",
                className:"min-width",
                canEdit: false
            },
            actualAmount:{
                type:"text",
                label:"实收金额",
                className:"min-width",
                canEdit: false
            },
            tranDetailStatus:{
				type:"text",
				label:"交易状态",
				formatter:function(action,data){
                    var v;
                    if("1" == data.tranStatus){
                        v = "<div>成功</div>"
                    }
                    if("2" == data.tranStatus){
                        v = "<div>失败</div>"
                    }
                    if("4" == data.tranStatus){
                        v = "<div>扣款成功</div>"
                    }
					return v;
				},
                className:"min-width"
            },
            /*
            tranStatus:{
                type:"text",
                label:"交易状态",
                className:"large-width",
                canEdit:false
            },
            */
            tranStatus:{
                type:"options",
                label:"交易状态",
                options:{
                    "1":"成功",
                    "2":"失败",
                    "4":"扣款成功"
                },
                className:"min-width",
                canEdit:false
            },
            payDate:{
                type:"date",
                label:"支付日期",
                className:"middle-width"
            },
            payDateList:{
                type:"text",
				label:"支付日期",
                className:"min-width",
                formatter:function(action,data){
                    var v;
                    if(data.payDate){
                        v = date.formatISODateMinutes(data.payDate);
                    }
					return v;
				}
            },
            payDetailDate:{
                type:"text",
                label:"支付日期",
                className:"middle-width",
                canEdit: false
            },
            state:{
                type:"options",
                label:"状态",
                options:{
                    1:"未审核",
                    2:"已审核",
                    3:"已完成"
                },
                className:"min-width"
            },
            merchantNo:{
                type:"text",
                label:"商户号",
                className:"middle-width",
                canEdit: false
            },
            bankName:{
                type:"text",
                label:"付款银行",
                className:"middle-width",
                canEdit: false
            },
            bankAccountName:{
                type:"text",
                label:"付款名称",
                className:"middle-width",
                canEdit: false
            },
            bankAccountCode:{
                type:"text",
                label:"付款账号",
                className:"middle-width",
                canEdit: false
            },
            tsId:{
                type:"text",
                label:"订单",
                className:"middle-width",
                canEdit: false
            },
            transSeq:{
                type:"text",
                label:"交易流水号",
                className:"large-width",
                canEdit: false
            },
            operateShow:{
				type:"text",
				label:"操作",
				formatter:function(action,data){
                    var buttonNode;
                    if(1 == data.state){
                        buttonNode = "<div class='dgrid-button' cq-action='bankStatement'>审核</div>";
                    }else{
                        buttonNode = "<div class=''></div>"
                    }
					var v = "<div class='dgrid-button' onclick='window.moveToView(\"bankStatementDetail\",\""+data._id+"\");'>详情</div>"+
                    buttonNode;
					return v;
				}
            },
            confirmButton:{
                type:"button",
                action:"confirmAction",
                label:"审核",
                className:"large-width"
            }
        },
        getSaleQueryLayout : function(){
            return [{
                type: "form",
                fields: this.getFormItems(["payDate","payType","state"])
            }];
        },
        getBankStatementUrl:function(){
            return bankStatement.load();
        },
        getPaymentStatisticsUrl : function(){
            return bankStatement.aggregatePayStatistics();
        },
        getQueryBankStatement:function(params){
            var query={};
            if(params.querySelect){
                var k,querySelect = params.querySelect,value;
                for(k in querySelect){
					if((k=="payDatef" || k == "payDatet") && querySelect[k]) query[k] = querySelect[k].toISOString();
					else if(querySelect[k]) query[k] = querySelect[k];
					/*
                    value = querySelect[k];
                    if(value||0===value||false===value){
                        if(value){
                            if((typeof value == "object")&& value) {
                                if(value._id){
                                    query[k] = value._id;
                                }else if(JSON.stringify(value) === "{}"){
                                    delete query[k];
                                }else{
                                    query[k] = value;
                                }
                            }
                            if(typeof value == "string" && value) {
                                query[k] = value;
                            }
                        }else{
                            query[k] = value;
                        }
                    }*/
                }
            }
            if(params.search){
                query.search = params.search;
            }
            if(params.state&&params.state._id){
                if("0"==params.state._id){
                    query.state = 1;
                }
                if("1"==params.state._id){
                    query.state = 2;
                }
                if("2"==params.state._id){
                    query.state = 3;
                }
            }
            return query;
        },
        getBankStatementLayout:function(){
            if(!this.bankStatementLayout){
                this.bankStatementLayout = this.getFormItems([
                "fromShopId.shopName",
                "payType",
                "amount",
                "feeAmount",
                "actualAmount",
                "payDateList",
                "transSeq",
                "operateShow"
                ],false);
            }
            return this.bankStatementLayout;
        },
        getQueryPSLayout : function(){
            return [{
                type: "form",
                fields: this.getFormItems(["payDate"])
            }];            
        },
        getQueryPaymentStatistics:function(params){
            var query={};
            if(params.search){
                var k,search = params.search,value;
                for(k in search){
					if((k=="payDatef" || k == "payDatet") && search[k]) query[k] = search[k].toISOString();
					else if(search[k]) query[k] = search[k];
                }
            }
            return query;
        },
        getPaymentStatisticsLayout:function(){
            if(!this.PSLayout){
                this.PSLayout = this.getFormItems([
                    "payType",
                    "payTotalAmount",
                    "feeTotalAmount"
                ],false);
            }
            return this.PSLayout;
        },
        exportPSLayout:function(){
			return this.getFormItems([
                    "payType",
                    "payTotalAmount",
                    "feeTotalAmount"
                ],false);
		},
		getExportLayout:function(){
			return this.getFormItems([
                "buyerShopId.shopName",
                "fromShopId.shopName",
                "payDate",
                "payType",
                "amount",
                "feeAmount",
                "actualAmount",
                "tranStatus",
                "transSeq",
                "merchantNo",
                //付款银行
                "bankName",
                //付款账号
                "bankAccountCode",
                //状态
                "state",
                //订单
                "tsId"
                ],false);
		},
        onListAction:function(data,action,list){
            if("bankStatement" == action){
                bankStatement.verify(data._id).then(lang.hitch(this,function(backData){
                    if(1 == backData.data.ok){
                        alert("审核成功");
                        list.refreshItemByData(backData&&backData.data&&backData.data.item||backData);
                    }else{
                        alert("服务器繁忙，请稍后再试");
                    }
               }));
            }
        },
        getBankStatementDetailLayout:function(){
            return [{
                type:"form",
                fields:this.getFormItems([
                    "fromShopId.shopName",
                    "payTypeName","amount",
                    "feeAmount","actualAmount",
                    "payDetailDate","tranStatus",
                    "transSeq",
                    "merchantNo","bankName",
                    "bankAccountName","bankAccountCode",
                    "state","tsId",
                    "confirmButton"
                ],true)
            }]
        },
        confirmAction:function(data){
           bankStatement.verify(data._id).then(lang.hitch(this,function(backData){
                if(1 == backData.data.ok){
                    alert("审核成功");
                    history.back();
                }else{
                    alert("服务器繁忙，请稍后再试");
                }
           }));
        },
        loadById:function(params){
            return bankStatement.loadById(params.cqViewParam.params).then(lang.hitch(this,function(backData){
                var data = backData.data.item;
                data.payDetailDate = date.formatISODateMinutes(data.payDate);
                if(0 == data.feeAmount){
                    data.feeAmount = "0";
                }
                if(0 == data.amount){
                    data.amount = "0";
                }
                if(0 == data.actualAmount){
                    data.actualAmount = "0";
                }
                return backData.data&&backData.data.item||data;
            }));
        },
        bankStatementDetailReload:function(widget){
            widget.hideByFields(["confirmButton"]);
            var data = widget.getData();
            if(1 == data.state){
                widget.showByFields(["confirmButton"]);
            }
            //设置状态和支付方式不可编辑
            widget.disableByFields(["payType","state"]);
        }
    });
    var priceBo = new Bo();
    priceBo.Bo = Bo;
    return priceBo;
});