//创建人：周超
//创建时间：2016/11/26
//创建内容：商家对象：1商家详情;2添加商家
define([
    "cq/biz/shop/shop",
    "cq/biz/user/user",
    "dojo/_base/lang",
    "cq/util/config/config",
    "cq/util/edit/editor",
    "./BoBase"
],function(shop,user,lang,config,editor,BoBase){
    var priceBo =  new BoBase({
        fields:{
            logo:{
                type:"image",
                label:"店铺图标",
                className:"large-width cq-logo",
                tag:"店铺管理",
                canEdit:false
            },
            "shopType":{
                type:"options",
                label:"经营主体",
                options:config.shopType||{
                    "2001":"服务机构",
                    "2002":"养殖企业",
                    "2003":"合作社",
                    "2004":"养殖户",
                    "2005":"养殖场",
                    "9999":"未分类"
                },
                className:"middle-width",
                canEdit:false
            },
            shopName:{
                type:"text",
                label:"商家名称",
                className:"middle-width",
                canEdit: false
            },
            address:{
                type:"text",
                label:"地理位置",
                className:"middle-width",
                canEdit: false
            },
            "lon,lat":{
                type:"text",
                label:"地理位置",
                className:"large-width",
                canEdit: false
            },
            town:{
                type:"text",
                label:"省市区县",
                className:"middle-width",
                canEdit: false
            },
            availableAmount:{
                type:"text",
                label:"可提现余额",
                className:"middle-width",
                canEdit: false
            },
            pendingAmount:{
                type:"text",
                label:"待结算余额",
                className:"middle-width",
                canEdit:false
            },
            saleAmount:{
                type:"text",
                label:"销售额",
                className:"middle-width",
                canEdit:false
            },
            address:{
                type:"text",
                label:"详细地址",
                className:"middle-width",
                canEdit: false
            },
            "fromShopId.contactName":{
                type:"text",
                label:"联系人",
                className:"large-width",
                canEdit: false
            },
            "fromShopId.contactPhone":{
                type:"text",
                label:"联系电话",
                className:"middle-width",
                canEdit: false
            },
            companyName:{
                type:"text",
                label:"公司名称",
                className:"middle-width",
                canEdit: false
            },
            legalPerson:{
                type:"text",
                label:"法人姓名",
                className:"middle-width",
                canEdit: false
            },
            legalPersonCode:{
                type:"text",
                label:"法人身份证号",
                className:"large-width",
                canEdit: false
            },
            tranRegion:{
                type:"text",
                label:"销售区域",
                className:"large-width",
                canEdit: false
            },
            businessLicense:{
                type:"image",
                label:"营业执照",
                className:"large-width",
                canEdit: false
            },
            legalImg1:{
                type:"image",
                label:"法人身份证正面",
                className:"middle-width",
                canEdit: false
            },
            legalImg2:{
                type:"image",
                label:"法人身份证反面",
                className:"middle-width",
                canEdit: false
            },
            userName:{
                type:"text",
                label:"手机号",
                className:"middle-width",
                placeHolder:"请填写手机号"
            },
            password:{
                type:"password",
                label:"密码",
                className:"middle-width",
                placeHolder:"请输入密码"
            },
            passwordConfirm:{
                type:"password",
                label:"确认密码",
                className:"middle-width",
                placeHolder:"请确认密码"
            },
            shopName2:{
                type:"text",
                label:"商家名称",
                className:"middle-width",
                placeHolder:"请输入商家名称"
            },
            verfyButton:{
                type:"button",
                action:"verfyAction",
                label:"标记认证",
                className:"middle-width"
            },
            recommendButton:{
                type:"button",
                action:"recommendAction",
                label:"推荐商家",
                className:"middle-width"
            },
            deleteButton:{
                type:"button",
                action:"deleteAction",
                label:"删除商家",
                className:"middle-width"
            },
            cancelVerfyButton:{
                type:"button",
                action:"cancelVerfyAction",
                label:"取消认证",
                className:"middle-width"
            },
            cancelComdButton:{
                type:"button",
                action:"cancelComdAction",
                label:"撤销推荐",
                className:"middle-width"
            },
            backVerifyButton:{
                type:"button",
                action:"backVerifyAction",
                label:"驳回认证",
                className:"middle-width"
            },
            confirmButton:{
                type:"button",
                action:"confirmAction",
                label:"完成",
                className:"middle-width"
            }
        },
        //商家详情:初始化数据
        loadById:function(parm){
            var id;
            if(parm.cqViewParam&&parm.cqViewParam.params){
                id = parm.cqViewParam.params;
            }
            return shop.loadById(id).then(lang.hitch(this,function(data){
                return data.data;
            }));
        },
        //商家详情:布局
        getMerchantSaleLayout:function(){
            return [{
                type:"form",
                fields:this.getFormItems([
                    "logo",
                    "shopName","shopType",
                    "town","address",
                    "fromShopId.contactName",
                    "fromShopId.contactPhone","companyName",
                    "legalPerson","legalPersonCode",
                    "tranRegion",
                    "availableAmount","pendingAmount",
                    "saleAmount",
                    "businessLicense",
                    "legalImg1","legalImg2",
                    "verfyButton","backVerifyButton","recommendButton","deleteButton",
                    "cancelVerfyButton","cancelComdButton"
                ],true)
            }]
        },
        //添加商家:布局
        getAddMerchantLayout:function(){
            return [{
                type:"form",
                fields:this.getFormItems([
                    "userName",
                    "shopName2",
                    "password","passwordConfirm",
                    "confirmButton"
                ],true)
            }]
        },
        //添加商家:初始化数据
        loadByNull:function(){
            return {};
        },
        //添加商家:加载页面
        merchantReload:function(widget){},
        //添加商家:字段检查
        checkFeilds:function(data){
            var msg = "";
            if (!data.userName) {
                msg = "手机号码还没有填写";
                return msg;
            }else if(!data.shopName2){
                msg = "店铺名称还没有填写";
                return msg;
            }else if(!data.password){
                msg = "请填写密码";
                return msg;
            }else if(!data.passwordConfirm){
                msg = "确认密码必须填写";
                return msg;
            }
            if(data.passwordConfirm&&data.password&&data.passwordConfirm!==data.password){
                msg = "确认密码必须与原密码相同";
                return msg;
            }
        },
        //检查手机号格式是否正确
        isCellPhone:function(phone){
            return /(^1[3|4|5|7|8][0-9]{9}$)/.test(phone) && phone.length==11;
        },
        //添加商家：保存
        confirmAction:function(data){
            var msg = this.checkFeilds(data);
            if(msg){
                alert(msg);
                return;
            }
            //添加商家：账号检查
            user.checkPlatformUser(data.userName).then(lang.hitch(this, function(phoneData) {
                if (phoneData.data.ok === 1) {
                    alert("账号已注册,请重新输入");
                    return;
                }
                if (!this.isCellPhone(data.userName)) {
                    alert("手机账号格式不对,请重新输入");
                    return;
                }
                data.shopName = data.shopName2;
                delete data.shopName2;
                window.busy();
                shop.createShopNoCode(data).then(lang.hitch(this,function(backData){
                    if(backData.data.item.createUser==true){
                        window.free();
                        alert("注册成功！");
                        history.back();
                    } else {
                        window.free();
                        alert("注册失败！");
                        return;
                    }
                }));
            }));
        },
        //商家详情：页面重载
        verifyReload:function(widget){
            var data = widget.getData();
            var btns = [
            "verfyButton",
            "recommendButton",
            "cancelVerfyButton",
            "cancelComdButton",
            "backVerifyButton"];
            widget.hideByFields(btns);
            widget.disableByFields(["availableAmount","pendingAmount","saleAmount"]);
            //推荐/撤销 推荐
            if(data.isRecommend){
                //显示推荐，隐藏不推荐
                //  替换显示
                widget.showByFields(["cancelComdButton"]);
                widget.hideByFields(["recommendButton"]);
            }else{
                widget.showByFields(["recommendButton"]);
                widget.hideByFields(["cancelComdButton"]);
            }
            //认证/取消认证/驳回认证
            //          取消认证（已审核）
            if(data.isVerifySubmit === 2 && data.isVerified){
                widget.showByFields(["cancelVerfyButton"]);
                widget.hideByFields(["backVerifyButton"]);
                widget.hideByFields(["verfyButton"]);
            }
            //          认证/驳回认证（审核）
            if(data.isVerifySubmit === 1 && !data.isVerified){
                widget.hideByFields(["cancelVerfyButton"]);
                widget.showByFields(["backVerifyButton"]);
                widget.showByFields(["verfyButton"]);
            }
            //          商家未提交认证
            if(data.isVerifySubmit === -1 && !data.isVerified){
                widget.hideByFields(["cancelVerfyButton"]);
                widget.hideByFields(["backVerifyButton"]);
                widget.hideByFields(["verfyButton"]);
            }
        },
        //商家认证
        verfyAction:function(data){
            window.busy();
            shop.verifyShopAut({
                targetShopId : data._id
            }).then(lang.hitch(this, function (data) {
                window.free();
                if (data && data.data && data.data.ok === 1){
                    history.back();
                } else {
                    alert('服务器繁忙！');
                }
            }));
        },
        //商家推荐
        recommendAction:function(data){
            window.busy();
            shop.setRecommend({isRecommend : true,targetShopId : data._id}).then(lang.hitch(this, function (data) {
                window.free();
                if (data && data.data && data.data.ok === 1){
                    history.back();
                } else {
                    alert('服务器繁忙！');
                }
            }));
        },
        //商家删除
        deleteAction:function(data){
            var targetShopId = data._id;
			var r=confirm("删除商家后，该店铺将不能再次使用，是否确认删除！");
			if (r==true) {
				window.busy();
                shop.removeShop(targetShopId).then(function (data) {
                    window.free();
                    if (data && data.data && data.data.ok === 1){
                        history.back();
                    } else {
                        alert('服务器繁忙！');
                    }
                });
            }
        },
        //商家取消认证
        cancelVerfyAction:function(data){
            window.busy();
            shop.cancelShopAut({
                targetShopId : data._id
            }).then(lang.hitch(this, function (data) {
                window.free();
                if (data && data.data && data.data.ok === 1){
                    history.back();
                } else {
                    alert('服务器繁忙！');
                }
            }));
        },
        //商家取消推荐
        cancelComdAction:function(data){
            window.busy();
            shop.setRecommend({
                isRecommend : false,
                targetShopId : data._id
            }).then(lang.hitch(this, function (data) {
                window.free();
                if (data && data.data && data.data.ok === 1){
                    history.back();
                } else {
                    alert('服务器繁忙！');
                }
            }));
        },
        //商家驳回认证
        backVerifyAction:function(data,views){
            if (!views.view) {
                var view = views.getParent();
                while (view) {
                    if (!view.show) {
                        view = view.getParent();
                    } else {
                        break;
                    }
                }
                views.view = view;
            }
            window.busy();
            editor.startEdit("", views.view).then(lang.hitch(this, function (value) {
                shop.rejectShopAut({targetShopId : data._id,rejectedReason : value}).then(lang.hitch(this, function (data) {
                    window.free();
                    if (data && data.data && data.data.ok === 1){
                        history.back();
                    } else {
                        if(data.data.ok === 0&&data.data.msg === "no rejectedReason"){
                            alert("请输入驳回原因！");
                        }else{
                            alert("服务器繁忙,请稍后再试！");
                        }
                    }
                }));
            }));
        },
        getMerchantParam:function(params){
            var query = {isDelete:false};
            return query;
        }
    });
    return priceBo;
});