﻿define([
    "../../BoBase",
    "cq/biz/old/ncc/nccMarket"
],function(BoBase,nccMarket){
    return new BoBase({
        //字段定义
        fields:{
            title:{
                type: "text",
                label: "公司名称",
                editable: true,
                notNull:true,
                placeHolder:"填写公司名称"
            },         
            remark:{
                type: "text",
                label: "备注",
                editable: true,
                notNull:true,
                placeHolder:"填写备注"
            },
            regionId:{
                type:"ref",
                field:"regionId",
                label:"区域",
                searchField:"title",
                pageSize:5,
                labelFields:"title",
                dataProvider:"cq/bo/old/ncc/nccRegion",
                targetMethod:"getListUrl",
                canEdit:true,
                notNull:true,
				className:"middle-width"
            },
            "regionId.title":{
                type: "text",
                label: "区域名称",
                editable: false
            },
			saveButton:{
				type:"button",
				action:"onSave",
				label:"保存"
			},
            listActions:{
				type:"text",
				label:"操作",
				formatter:function(action,data){
					var v = "<div class='button' cq-action='delete'>删除</div><div class='button' onclick='window.moveToView(\"nccMarketEdit\",\""+data._id+"\");'>编辑</div>";
					return v;
				}
            }           
        },
        
        //列表需要的方法
        getListLayout:function(){
            return this.getFormItems(["title", "remark" ,"regionId.title", "listActions"],false);
        },
        getSaleStatisticExportLayout : function(){
            return this.getFormItems(["title", "remark" ,"regionId.title"]);
        },
        getListUrl:function(){
            return nccMarket.getLoadUrl();
        },
        // getListQuery:function(refInfo){
            // if(refInfo&&refInfo.title){
                // return {title:refInfo.title};
            // }else{
                // return {};
            // }
        // },
        getQueryLayout:function(){
            return [{
                type: "form",
                fields: this.getFormItems(["title", "regionId"])
            }];
        },
		getQueryParam:function(params){
			// var query = {isUse:true};
            var query = {};
            if(params.queryInfo){
                var k,queryInfo = params.queryInfo,value;
                for(k in queryInfo){
                    value = queryInfo[k];
                    // if(value||0===value||false===value){
                        // if(value&&"undefined"!==value._id){
                            // if(value._id){
                                // query[k] = value._id;
                            // }else{
                                // query[k] = value;
                            // }
                        // }else{
                            // query[k] = value;
                        // }
                    // }
                    if((typeof value == "object")&& value && value._id) {
                        query[k] = value._id;
                    }
                    if(typeof value == "string" && value) {
                        query[k] = value;
                    }
                }
            }
            if(params.search){
                query.title = params.search;
            }
            return query;
        },
        onGroupListClick:function(data,action,list){           
            if(data&&data._id){
                if(action == "delete"){
                    if(!confirm("确定删除吗？")) return;
                    data.isDelete = true;
                    nccMarket.save(data).then(function(){list.removeItemByData(data);});
                    return;
                }                 
                window.moveToView("nccMarketEdit",data._id);
            }
        },
        getEditLayout:function(){
            return [{
                type: "form",
                fields: this.getFormItems(["title","remark","regionId","saveButton"])
            }];
        },
        loadEditData:function(refInfo){
            if(refInfo&&refInfo.cqViewParam&&refInfo.cqViewParam.params){
                return nccMarket.loadById(refInfo.cqViewParam.params).then(function(data){
                    return data.data.item||{};
                });
            }
            return {};
        },
		onSave:function(data,dataList){
            var canSave = this.canSaveData(data);
            if(canSave) {
                alert(canSave);
                return;
            }
			nccMarket.save(data).then(function(){history.back();});
		},
        canSaveData : function(data){
            var msg = "";
            if(!data.title){
                msg = "请填写名称";
            }else if(!data.remark){
                msg = "请填写备注";
            }else if(!data.regionId._id){
                msg = "请选择区域";
            }
            return msg;
        }
    });
});