﻿define([
    "../../BoBase",
    "cq/biz/old/ncc/nccProduct"
],function(BoBase,nccProduct){
    return new BoBase({
        //字段定义
        fields:{
            title:{
                type: "text",
                label: "品种",
                editable: true,
                notNull:true,
                placeHolder:"填写品种名称"
            },
            measure:{
                type: "text",
                label: "计重方式",
                editable: true,
                notNull:true,
                placeHolder:"填写品种计重方式"
            },            
            remark:{
                type: "text",
                label: "备注",
                editable: true,
                notNull:true,
                placeHolder:"填写品种备注"
            },
            groupId:{
                type:"ref",
                field:"groupId",
                label:"类别",
                searchField:"title",
                pageSize:5,
                labelFields:"title",
                dataProvider:"cq/bo/old/ncc/nccProductGroup",
                targetMethod:"getListUrl",
                canEdit:true,
                notNull:true,
				className:"middle-width"
            },
            "groupId.title":{
                type: "text",
                label: "类别名称",
                editable: false
            },
			saveButton:{
				type:"button",
				action:"onSave",
				label:"保存"
			},
            listActions:{
				type:"text",
				label:"操作",
				formatter:function(action,data){
					var v = "<div class='button' cq-action='delete'>删除</div><div class='button' onclick='window.moveToView(\"nccProductEdit\",\""+data._id+"\");'>编辑</div>";
					return v;
				}
            }
        },
        
        //列表需要的方法
        getListLayout:function(){
            return this.getFormItems(["title","measure", "remark" ,"groupId.title", "listActions"],false);
        },
        getSaleStatisticExportLayout : function(){
            return this.getFormItems(["title","measure", "remark" ,"groupId.title"]);
        },
        getListUrl:function(){
            return nccProduct.getLoadUrl();
        },
        // getListQuery:function(refInfo){
            // if(refInfo&&refInfo.title){
                // return {title:refInfo.title};
            // }else{
                // return {};
            // }
        // },
        getQueryLayout:function(){
            return [{
                type: "form",
                fields: this.getFormItems(["title", "groupId"])
            }];
        },
		getQueryParam:function(params){
			// var query = {isUse:true};
            var query = {};
            if(params.queryInfo){
                var k,queryInfo = params.queryInfo,value;
                for(k in queryInfo){
                    value = queryInfo[k];
                    // if(value||0===value||false===value){
                        // if(value&&"undefined"!==value._id){
                            // if(value._id){
                                // query[k] = value._id;
                            // }else{
                                // query[k] = value;
                            // }
                        // }else{
                            // query[k] = value;
                        // }
                    // }
                    if((typeof value == "object")&& value && value._id) {
                        query[k] = value._id;
                    }
                    if(typeof value == "string" && value) {
                        query[k] = value;
                    }
                }
            }
            if(params.search){
                query.title = params.search;
            }
            return query;
        },
        onGroupListClick:function(data,action,list){
            if(data&&data._id){
                if(action == "delete"){
                    if(!confirm("确定删除吗？")) return;
                    data.isDelete = true;
                    nccProduct.save(data).then(function(){list.removeItemByData(data);});
                    return;
                }  
                window.moveToView("nccProductEdit",data._id);
            }
        },
        getEditLayout:function(){
            return [{
                type: "form",
                fields: this.getFormItems(["title","measure","remark","groupId","saveButton"])
            }];
        },
        loadEditData:function(refInfo){
            if(refInfo&&refInfo.cqViewParam&&refInfo.cqViewParam.params){
                return nccProduct.loadById(refInfo.cqViewParam.params).then(function(data){
                    return data.data.item||{};
                });
            }
            return {};
        },
		onSave:function(data,dataList){
            var canSave = this.canSaveData(data);
            if(canSave) {
                alert(canSave);
                return;
            }
			nccProduct.save(data).then(function(){history.back();});
		},
        canSaveData : function(data){
            var msg = "";
            if(!data.title){
                msg = "请填写名称";
            }else if(!data.remark){
                msg = "请填写备注";
            }else if(!data.measure){
                msg = "请填写计重方式";
            }else if(!data.groupId._id){
                msg = "请选择类别";
            }
            return msg;
        }
    });
});