﻿define([
    "../../BoBase",
    "cq/biz/old/ncc/nccProductGroup"
],function(BoBase,nccProductGroup){
    return new BoBase({
        //字段定义
        fields:{
            title:{
                type: "text",
                label: "名称",
                editable: true,
                notNull:true,
                placeHolder:"填写分类名称"
            },
            upId:{
                type:"ref",
                field:"upId",
                label:"上级",
                searchField:"title",
                pageSize:5,
                labelFields:"title",
                dataProvider:"cq/bo/old/ncc/nccProductGroup",
                targetMethod:"getListUrl",
                canEdit:true,
				className:"middle-width"
            },
            "upId.title":{
                type: "text",
                label: "上级名称",
                editable: false
            },
			saveButton:{
				type:"button",
				action:"onSave",
				label:"保存"
			},
            listActions:{
				type:"text",
				label:"操作",
				formatter:function(action,data){
					var v = "<div class='button' cq-action='delete'>删除</div><div class='button' onclick='window.moveToView(\"nccProductGroupEdit\",\""+data._id+"\");'>编辑</div>";
					return v;
				}
            }
        },
        
        //列表需要的方法
        getListLayout:function(){
            return this.getFormItems(["title", "upId.title", "listActions"],false);
        },
        getListUrl:function(){
            return nccProductGroup.getLoadUrl();
        },
        getListQuery:function(refInfo){
            if(refInfo&&refInfo.title){
                return {title:refInfo.title};
            }else{
                return {};
            }
        },
        onGroupListClick:function(data,action,list){
            if(data&&data._id){
                if(action == "delete"){
                    if(!confirm("确定删除吗？")) return;
                    data.isDelete = true;
                    nccProductGroup.save(data).then(function(){list.removeItemByData(data);});
                    return;
                }                 
                window.moveToView("nccProductGroupEdit",data._id);
            }
        },
        getEditLayout:function(){
            return [{
                type: "form",
                fields: this.getFormItems(["title","upId","saveButton"])
            }];
        },
        getSaleStatisticExportLayout : function(){
            return this.getFormItems(["title", "upId.title"]);
        },
        loadEditData:function(refInfo){
            if(refInfo&&refInfo.cqViewParam&&refInfo.cqViewParam.params){
                return nccProductGroup.loadById(refInfo.cqViewParam.params).then(function(data){
                    return data.data.item||{};
                });
            }
            return {};
        },
		onSave:function(data,dataList){
            //upId为空时，前台传入参数为upId:{},后台报错
            if(!data.upId._id) {
                data.upId = null;
            }
            var canSave = this.canSaveData(data);
            if(canSave) {
                alert(canSave);
                return;
            }
			nccProductGroup.save(data).then(function(){history.back();});
		},
        canSaveData : function(data){
            var msg = "";
            if(!data.title){
                msg = "请填写名称";
            }
            return msg;
        }
    });
});