﻿define([
    "../../BoBase",
    "cq/biz/old/ncc/nccRegion"
],function(BoBase,nccRegion){
    return new BoBase({
        //字段定义
        fields:{
            title:{
                type: "text",
                label: "区域名称",
                editable: true,
                notNull:true,
                placeHolder:"填写区域名称"
            },         
			saveButton:{
				type:"button",
				action:"onSave",
				label:"保存"
			},
            listActions:{
				type:"text",
				label:"操作",
				formatter:function(action,data){
					var v = "<div class='button' cq-action='delete'>删除</div><div class='button' onclick='window.moveToView(\"nccRegionEdit\",\""+data._id+"\");'>编辑</div>";
					return v;
				}
            }
        },
        
        //列表需要的方法
        getListLayout:function(){
            return this.getFormItems(["title", "listActions"],false);
        },
        getListUrl:function(){
            return nccRegion.getLoadUrl();
        },
        getListQuery:function(refInfo){
            if(refInfo&&refInfo.title){
                return {title:refInfo.title};
            }else{
                return {};
            }
        },
        getSaleStatisticExportLayout : function(){
            return this.getFormItems(["title"]);
        },
        onGroupListClick:function(data,action,list){  
            if(data&&data._id){
                if(action == "delete"){
                    if(!confirm("确定删除吗？")) return;
                    data.isDelete = true;
                    nccRegion.save(data).then(function(){list.removeItemByData(data);});
                    return;
                }                
                window.moveToView("nccRegionEdit",data._id);
            }
        },
        getEditLayout:function(){
            return [{
                type: "form",
                fields: this.getFormItems(["title","saveButton"])
            }];
        },
        loadEditData:function(refInfo){
            if(refInfo&&refInfo.cqViewParam&&refInfo.cqViewParam.params){
                return nccRegion.loadById(refInfo.cqViewParam.params).then(function(data){
                    return data.data.item||{};
                });
            }
            return {};
        },
		onSave:function(data,dataList){
            var canSave = this.canSaveData(data);
            if(canSave) {
                alert(canSave);
                return;
            }
			nccRegion.save(data).then(function(){history.back();});
		},
        canSaveData : function(data){
            var msg = "";
            if(!data.title){
                msg = "请填写区域名称";
            }
            return msg;
        }
    });
});