﻿define([
    "dojo/_base/lang",
    "../../BoBase",
    "cq/biz/old/ncc/nccSupplyDemand",
    "cq/biz/old/ncc/nccPersonalInfo"
],function(lang,BoBase,nccSupplyDemand,nccPersonalInfo){
    return new BoBase({
        //字段定义
        fields:{
            title:{
                type: "text",
                label: "名称",
                editable: true,
                notNull:true,
                placeHolder:"填写分类名称"
            },
            makeDate:{
                type: "date",
                notNull:true,
                label: "录入日期"
            },
            userId:{
                type: "ref",
                label: "会员",
                filed:"userId",
                dataProvider:"cq/bo/user",
                targetMethod:"getUserUrl",
                pageSize:5,
                searchField:"pName",
                labelFields:"pName",
                className:"middle-width"
            },
            "userId.pName":{
                type:"text",
                label:"会员"
            },
            companyName:{
                type:"text",
                filed:"companyName",
                label:"企业名称"
            },
            legalPerson:{
                type:"text",
                filed:"legalPerson",
                label:"法人代表"
            },
            cPhone:{
                type:"text",
                filed:"cPhone",
                label:"公司电话"
            },
            businessLicense:{
                type: "image",
                label: "营业执照",
                editable: true,
                className: "large-width large-high",
                filed:"businessLicense",
                label:"营业执照"
            },
            companyAddress:{
                type:"text",
                filed:"companyAddress",
                label:"公司地址"
            },
            industryType:{
                type:"options",
                options:{
                    "批发业":{
                        100511:"农、林、牧产品批发",
                        100512:"食品、饮料及烟草制品批发　",
                        100513:"纺织、服装及家庭用品批发",
                        100514:"文化、体育用品及器材批发",
                        100515:"医药及医疗器材批发",
                        100516:"矿产品、建材及化工产品批发",
                        100517:"机械设备、五金产品及电子产品批发",
                        100518:"贸易经纪与代理",
                        100519:"其他批发业"
                    },
                    "零售业":{
                        100521:"综合零售",
                        100522:"食品、饮料及烟草制品专门零售",
                        100523:"纺织、服装及日用品专门零售",
                        100524:"文化、体育用品及器材专门零售",
                        100525:"医药及医疗器材专门零售",
                        100526:"汽车、摩托车、燃料及零配件专门零售",
                        100527:"家用电器及电子产品专门零售",
                        100528:"五金、家具及室内装饰材料专门零售",
                        100529:"货摊、无店铺及其他零售业"
                    },
                    "装卸搬运和运输代理业":{
                        100581:"装卸搬运",
                        100582:"运输代理业"
                    },
                    "仓储业":{
                        100591:"谷物、棉花等农产品仓储",
                        100599:"其他仓储业"
                    },
                    "住宿业":{
                        100611:"旅游饭店",
                        100612:"一般旅馆",
                        100619:"其他住宿业"
                    },
                    "餐饮业":{
                        100621:"正餐服务",
                        100622:"快餐服务",
                        100623:"饮料及冷饮服务",
                        100629:"其他餐饮业"
                    },
                    "租赁业":{
                        100711:"机械设备租赁",
                        100712:"文化及日用品出租"
                    },
                    "商务服务业":{
                        100721:"企业管理服务",
                        100722:"法律服务",
                        100723:"咨询与调查",
                        100724:"广告业",
                        100725:"知识产权服务",
                        100726:"人力资源服务",
                        100727:"旅行社及相关服务",
                        100728:"安全保护服务",
                        100729:"其他商务服务业"
                    },
                    "居民服务业":{
                        100791:"家庭服务",
                        100792:"托儿所服务",
                        100793:"洗染服务",
                        100794:"理发及美容服务",
                        100795:"洗浴服务",
                        100796:"保健服务",
                        100797:"婚姻服务",
                        100798:"殡葬服务",
                        100799:"其他居民服务业"
                    },
                    "机动车、电子产品和日用产品修理业":{
                        100801:"汽车、摩托车修理与维护",
                        100802:"计算机和办公设备维修",
                        100803:"家用电器修理",
                        100809:"其他日用产品修理业"
                    },
                    "其他服务业":{
                        100811:"清洁服务",
                        100819:"其他未列明服务业"
                    }
                },
                canEdit:false,
                filed:"industryType",
                label:"所属行业"
            },
            brief:{
                type: "richText",
                filed:"brief",
                label: "企业简介",
                className: "large-width large-high2"
            },
            price:{
                type:"number",
                label:"单价",
                notNull:true,
                range:"(0,)"
            },
            regionId:{
                type: "ref",
                label: "产地",
                filed:"regionId",
                dataProvider:"cq/bo/old/ncc/nccRegion",
                targetMethod:"getListUrl",
                canEdit:true,
                pageSize:5,
                searchField:"title",
                labelFields:"title",
                className:"middle-width",
                notNull:true
            },
            "regionId.title":{
                type:"text",
                label:"产地"
            },
            saleType:{
                type: "options",
                label: "销售类型",
                options:{
                    "500001":"零售",
                    "500002":"批发",
                    "500003":"产地",
                    "500004":"收购",
                    "500005":"进场"
                },
                canEdit:true,
                notNull:true
            },
            marketId:{
                type: "ref",
                label: "市场",
                filed:"marketId",
                dataProvider:"cq/bo/old/ncc/nccMarket",
                targetMethod:"getListUrl",
                canEdit:true,
                pageSize:5,
                searchField:"title",
                labelFields:"title",
                className:"middle-width",
                notNull:true
            },
            "marketId.title":{
                type:"text",
                label:"市场"
            },
            sdType:{
                label:"供求类型",
                type: "options",
                options:{
                    "3":"供",
                    "4":"求"
                },
                canEdit:true,
                className:"middle-width",
                notNull:true
            },
            mid:{
                type:"ref",
                label: "品种",
                filed:"mid",
                dataProvider:"cq/bo/old/ncc/nccProduct",
                targetMethod:"getListUrl",
                canEdit:true,
                pageSize:5,
                searchField:"title",
                labelFields:"title",
                className:"middle-width",
                notNull:true
            },
            "mid.title":{
                type:"text",
                label:"品种"
            },
            num:{
                type:"number",
                label:"数量",
                notNull:true,
                range:"(0,)"
            },
            isVerified:{
                type:"checkbox",
                label:"是否审核",
                notNull:true
            },
            remark:{
                type:"text",
                label:"备注",
                notNull:true
            },
            verifyActions:{
                type:"text",
                label:"",
                className:"middle-width",
                formatter:function(action,data){
                    var v = "";
                    var v1 = "<div class='button' cq-action='onCancelVerified'>撤销</div><div class='button' cq-action='edit'>详情</div>";
                    var v2 = "<div class='button' cq-action='delete'>删除</div><div class='button' cq-action='onVerified'>审核</div><div class='button' cq-action='edit'>编辑</div>";
                    v = (!data.isDelete&&data.isVerified?v1:v2);
                    return v;
                }
            },
            saveButton:{
                type:"button",
                action:"onSave",
                label:"保存"
            }
        },
        //列表需要的方法
        getListLayout:function(){
            return this.getFormItems(["title","userId.pName","makeDate","price","regionId.title","saleType","marketId.title","sdType","mid.title","num","isVerified","verifyActions"],false);
        },
        getSaleStatisticExportLayout : function(){
            return this.getFormItems(["title","userId.pName","makeDate","price","regionId.title","saleType","marketId.title","sdType","mid.title","num","isVerified"]);
        },
        getListUrl:function(){
            return nccSupplyDemand.getLoadUrl();
        },
        getListQuery:function(params){
            var query = {};
            if(params.queryInfo){
                var k,queryInfo = params.queryInfo,value;
                for(k in queryInfo){
                    value = queryInfo[k];
                    if(value||0===value||false===value){
                        if(value){
                            if((typeof value == "object")&& value) {
                                if(value._id){
                                    query[k] = value._id;
                                }else if(JSON.stringify(value) === "{}"){
                                    delete query[k];
                                }else{
                                    query[k] = value;
                                }
                            }
                            if(typeof value == "string" && value) {
                                query[k] = value;
                            }
                        }else{
                            query[k] = value;
                        }
                    }
                }
            }
            return query;
        },
        getQueryLayout:function(){
            return [{
                type: "form",
                fields: this.getFormItems(["title","regionId","saleType","marketId","sdType","mid"])
            }];
        },
        onSupplyDemandListClick:function(data,action,list){
            if(data&&data._id){
                if(action == "delete"){
                    var deleteConfirm = confirm("是否删除?")
                    if(!deleteConfirm) return;
                    data.isDelete = true;
                    nccSupplyDemand.save(data).then(function(){list.removeItemByData(data);});
                    return;
                }
                if(action == "onCancelVerified"||action == "onVerified"){
                    data.isVerified = (action == "onCancelVerified"?false:true)
                    nccSupplyDemand.save(data).then(function(){list.refreshItemByData(data);});
                }
                if(action == "edit"){
                    this.isVerified = (data.isVerified?true:false);
                    window.moveToView("nccSupplyDemandEdit",data._id);
                }
            }
        },
        getEditLayout:function(){
            return [{
                type: "form",
                fields: this.getFormItems(["title","makeDate","price","regionId","saleType","marketId","sdType","mid","num","remark","userId","companyName","legalPerson","cPhone","businessLicense","companyAddress","industryType","brief","saveButton"])
            }];
        },
        loadEditData:function(refInfo){
            this.addNew = true;
            if(refInfo&&refInfo.cqViewParam&&refInfo.cqViewParam.params){
                this.addNew = false;
                return nccSupplyDemand.loadById(refInfo.cqViewParam.params).then(function(data){
                    if(data&&data.data&&data.data.item&&data.data.item.userId){
                        return nccPersonalInfo.loadByUserId(data.data.item.userId._id).then(lang.hitch(this,function(result){
                            if(result&&result.data&&result.data.item){
                                data.data.item.companyName = result.data.item.companyName;
                                data.data.item.legalPerson = result.data.item.legalPerson;
                                data.data.item.cPhone = result.data.item.cPhone;
                                data.data.item.businessLicense = result.data.item.businessLicense;
                                data.data.item.companyAddress = result.data.item.companyAddress;
                                data.data.item.industryType = result.data.item.industryType;
                                data.data.item.brief = result.data.item.brief;
                            }
                            return data.data.item||{};
                        }));
                    }else {
                        return data.data.item||{};
                    }
                });
            }
            return {};
        },
        getFields:function(){
            var fields = [];
            for(var k in this.fields){
                fields.push(k);
            }
            return fields;
        },
        onSupplyDemandReload:function(widget){
            var data = widget.getData();
            var fields = this.getFields();
            if(!this.addNew&&this.isVerified){
                widget.disableByFields(fields);
                widget.hideByFields(["saveButton"]);
            }else if(this.addNew||!this.isVerified){
                widget.enableByFields(fields);
                widget.showByFields(["saveButton"]);
                widget.disableByFields(["makeDate","userId","companyName","legalPerson","cPhone","businessLicense","companyAddress","industryType","brief"]);
            }
        },
        onSave:function(data,dataList){
            var fields = this.getFields();
            var msg = this.getDataValidMsg(data,fields);
            if(msg){
                alert(msg);
                return;
            }
            nccSupplyDemand.save(data).then(function(){history.back();});
        }
    })
});