﻿define([
    "../BoBase",
    "cq/bo/article",
    "cq/biz/old/newsUsage"
],function(BoBase,article,newsUsage){
    return new BoBase({
        fields : {
            title:{
                type:"text",
                label:"标题",
                notNull:true,
				className:"middle-width"
            },
            logo: {
                type: "image",
                label: "题图"
            },
            tp:{
                type: "options",
                label: "用途",
                notNull:true,
                options : {
                    1:"图片滚动",
                    2:"焦点新闻",
                    3:"热点关注",
                    4:"专题活动"
                }
            },
            newsId:{
                type:"ref",
                field:"newsId",
                label:"资讯名称",
                searchField:"title",
                pageSize:5,
                labelFields:"title",
                dataProvider:"cq/bo/article",
                targetMethod:"loadShopArticle",
                notNull:true,
                canEdit:true,
				className:"middle-width"
            },
            "newsId.title":{
                type: "text",
                label: "资讯",
                editable: false
            },
            createAt : {
                type : "date",
                label : "操作时间"                
            },
            endDate: {
                type : "date",
                notNull:true,
                label : "结束时间"                
            },
            saveButton:{
                type:"button",
                action:"onSave",
                label:"保存"
            },
            listActions:{
				type:"text",
				label:"",
				formatter:function(action,data){
					var v = "<div class='button' cq-action='delete'>删除</div><div class='button' onclick='window.moveToView(\"nccNewsUsageEdit\",\""+data._id+"\");'>编辑</div>";
					return v;
				}
            },
            endTime : {
                type : "date",
                label : "时间" 
            },
             isVerified : {
                type: "options",
                label: "状态",
                notNull:true,
                options : {
                    false : "待审核",
                    true : "已审核"
                }
            },
            ioType : {
                type: "options",
                label: "类型",
                notNull:true,
                options : {
                    0 : "充值",
                    1 : "提现"
                }
            },
            search : {
                type : "text",
                label : "商家"
            }
        },
        
        //列表需要的方法
        getListLayout:function(){
            if(!this.newsUsageGridLayout){
                this.newsUsageGridLayout = this.getFormItems(["title","tp","createAt","endDate","newsId.title","listActions"],false);
            }
            return this.newsUsageGridLayout;
            //return this.getFormItems(["title","tp","createAt","endDate","newsId.title","listActions"],false);
        },
        getListUrl:function(){
            return newsUsage.getLoadUrl();
        },
        getListQuery:function(refInfo){
            // if(refInfo&&refInfo.title){
                // return {title:refInfo.title};
            // }else{
                // return {};
            // }
            var query = {};
            if(refInfo.queryInfo){
                var k,queryInfo = refInfo.queryInfo,value;
                for(k in queryInfo){
                    value = queryInfo[k];
                    if(value||0===value||false===value){
                        if(value){
                            if((typeof value == "object")&& value) {
                                if(value._id){
                                    query[k] = value._id;
                                }else if(k!="newsId"){
                                    query[k] = value;
                                }
                            }
                            if(typeof value == "string" && value) {
                                query[k] = value;
                            }
                        }else{
                            query[k] = value;
                        }
                    }
                }
            }
            if(refInfo.search){
                query.title = refInfo.search;
            }
            return query;
        },
        // onGroupListClick:function(data,action,list){
            // if(data&&data._id){
                // window.moveToView("nccNewsUsageEdit",data._id);
            // }
        // },
        //查询条件区域结构
        getQueryLayout:function(){
            return [{
                type: "form",
                fields: this.getFormItems(["title","tp","newsId","endDate"])
            }];
        },
        getEditLayout:function(){
            return [{
                type: "form",
                fields: this.getFormItems(["title","tp","newsId","logo","createAt","endDate","saveButton"])
            }];
        },
        loadEditData:function(refInfo){
            if(refInfo&&refInfo.cqViewParam&&refInfo.cqViewParam.params){
                return newsUsage.loadById(refInfo.cqViewParam.params).then(function(data){
                    return data.data.item||{};
                });
            }
            return {};
        },
        onListAction:function(data,action,list){
			if(action == "delete"){
				if(!confirm("确定删除吗？")) return;
                data.isDelete = true;
				newsUsage.save(data).then(function(){list.removeItemByData(data);});
			}
		},
        onChangeData : function(widget,field,value){
            if(field=="newsId"){
                widget.updateByField("title",value&&value.title||"");
                widget.updateByField("logo",value&&value.logo||"");
            }
        },
        canSaveData : function(data){
            var msg = "";
            if(!data.title){
                msg = "请填写标题";
            }else if(!data.tp){
                msg = "请选择类型";
            }else if(!data.logo){
                msg = "请选择题图";
            }else if(!data.newsId){
                msg = "请选择资讯";
            }else if(!data.createAt){
                msg = "请选择交易时间";
            }else if(!data.endDate){
                msg = "请选择结束时间";
            }
            return msg;
        },
        onSave:function(data,dataList){
            var isSave = this.canSaveData(data);
            if(isSave){
                alert(isSave);
                return;
            }
            newsUsage.save(data).then(function(){history.back();});
        }
    })
});