define([
    "dojo/_base/lang",//不依赖的模块
    "./BoBase",
    "cq/biz/ts/cart",
	"cq/biz/ts/order",
    "cq/biz/shop/shop",
    "cq/biz/ts/pay/bankStatement",
    "cq/util/config/config",
    "cq/biz/mat/mat"//不依赖的模块
], function (lang, BoBase, cart, order, shop, bankStatement, config, mat) {
    var boBase = new BoBase({
		//添加字段
		fields:{
            "provinceName":{
                type:"text",
                label:"省"
            },
            "cityName":{
                type:"text",
                label:"市"
            },
            "dftOpShop.shopName":{
                type:"text",
                label:"店铺名称"
            },
            "shopName":{
                type:"text",
                label:"店铺名称"
            },
            "mName":{
                type:"text",
                label:"商品名称"
            },
            "totalAmount":{
                type:"text",
                fixedTo:2,
                label:"销售额"
            },
            "monthAmount":{
                fixedTo:2,
                type:"text",
                label:"月销售"
            },
            "yearAmount":{
                fixedTo:2,
                type:"text",
                label:"年销售"
            },
            "dayAmount":{
                fixedTo:2,
                type:"text",
                label:"日销售"
            },
            "countName":{
                type:"text",
                label:"区县？"
            },
            "details.0.dName": {
                type:"text",
                label:"收件人姓名"
            },
            "details.0.dAddress": {
                type:"text",
                label:"收件人地址"
            },
            "details.0.mId.mName":{
                type:"text",
                label:"商品名称"
            },
            price:{
                type:"text",
                label:"价格"
            },
            "details.0.qty":{
                type:"text",
                label:"商品数量"
            },
            //运费
            tAmount:{
                type:"text",
                label:"运费"
            },
            orderListActions:{
				type:"text",
				label:"",
				formatter:function(action,data){
					var v = "<div class='button' onclick='window.moveToView(\"orderDetailB\",\""+data._id+"\");'>查看</div>";
					return v;
				}
            },
            //金额
            amount:{
                type:"text",
                fixedTo:2,
                label:"总金额(含运费)"
            },
            "details.0.dTel":{
                type:"text",
                label:"收件人电话"
            },
            "details.0.price":{
                type:"text",
                label:"商品单价"
            }
          
			
		},
        _hasLogin: true,
        //通过ID数组加载商家
        loadShops: function () {

        },
        //加载购物车中商品
        loadCartMats: function () {

        },
        //获取
        getShopMatData: function (ids) {
            // [{
            //     shopId: id,
            //     shopName: "",
            //     logo: "",
            //     mats: [{
            //         matId: id,
            //         mName: "",
            //         cartQty: number,
            //         qty: number,
            //         logo: "",
            //         price: ''
            //     }]
            // }]
        },
        //购物车数据
        getOrderCarLayout: function () {
            return this.getShopMatData(cart.getIds());
        },
        //清空购物车
        clearCart: function () {

        },
        //继续购买
        toMatList: function () {

        },
        //结算
        submitOrderCar: function () {

        },
        //购物车合计组件数据
        getCartCountLayout: function () {

        },
		//订单列表显示
		getOrderListGridLayout:function(){
			if(!this.orderListGridLayout){
                this.orderListGridLayout = this.getFormItems(["details.0.dName","details.0.dAddress","details.0.dTel","details.0.mId.mName","details.0.price","details.0.qty","amount","tAmount","orderListActions"],false);
            }
            return this.orderListGridLayout;
		},
		//获取订单列表数据的url
		getOrderListUrl:function(){
			return order.getWithDetailsUrl();
		},
        getOrderListQueryParam:function(params){
            //默认查询全部
            var query = {orderBy:'-createAt'};
            if(params.search){
                query.search = params.search;
            }
            //1为待付款
            if(params.state&&params.state._id==1){
                query={isPayed:false,isCanceled:false,orderBy:'-createAt'};
            }else if(params.state&&params.state._id==2){
                //2为待审核
                query={ isPayed:true,isCanceled:false,isAccepted:false,orderBy:'-createAt'};
            }else if(params.state&&params.state._id==3){
                //3为待发货
                query={isPayed:true,isCanceled:false,isAccepted:true,isDelived:false,orderBy:'-createAt'};
            }else if(params.state&&params.state._id==4){
                //4为已发货
                query={isPayed:true,isCanceled:false,isDelived:true,isReceipted:false,orderBy:'-createAt'};
            }else if(params.state&&params.state._id==5){
                //5为已完成
                query={isPayed:true,isCanceled:false,isDelived:true,isReceipted:true,orderBy:'-createAt'};
            }else if(params.state&&params.state._id==6){
                //6为退款中
                query={isPayed:true,isCanceled:true,isReceipted:false,orderBy:"-createAt"};
            }else if(params.state&&params.state._id==0){
                query={orderBy:"-createAt"};
            }
            return query;
        },
        getOrderDetailLayout:function(){
            if(!this.orderDetailLayout){
                this.orderDetailLayout = [{
                    type:"form",
                    fields:this.getFormItems([
                        
                    ])
                }];
            }
            return this.orderDetailLayout;
        },
        getAggregateQuery: function(params){
            var query={};
            query.pageSize = 5;
            if(config.getPlatformShopId()!==shop.getShopId()){
                query.fromShopId = shop.getShopId();
            }
            if(params.queryInfo&&params.queryInfo.shopInfo&&params.queryInfo.shopInfo._id){
                query.fromShopId = params.queryInfo.shopInfo._id;
            }
            //shopId始终传平台
            query.shopId = config.getPlatformShopId();
            if(params.queryInfo&&params.queryInfo.datef){
                query.payDatef = params.queryInfo.datef;
            }
            if(params.queryInfo&&params.queryInfo.datet){
                query.payDatet = params.queryInfo.datet;
            }
            //  第一次加载默认时间
            if(!params.queryInfo){
                var date = new Date();
                var year = date.getFullYear(),month = date.getMonth()+1,day = date.getDate();
                month =  (month>9)?month:("0"+month);
                day =  (day>9)?day:("0"+day);
                query.payDatef = year+"-"+month+"-01"; 
                query.payDatet = year+"-"+month+"-"+day;
            }
            return query;
        },
        getAggregateByMatSalt: function(){
            var param = {sortId:"5799778b1bab4a341473728b"};
            return order.aggregateByMatB(param);
        },
        getAggregateByMatGrainOil: function(){
            var param = {sortId:"579974b71bab4a34147371a5"};
            return order.aggregateByMatB(param);
        },
        getAggregateByMatSeason: function(){
            var param = {sortId:"579976ad1bab4a3414737254"};
            return order.aggregateByMatB(param);
        },
        getAggregateByMatDrink: function(){
            var param = {sortId:"579976151bab4a3414737216"};
            return order.aggregateByMatB(param);
        },
        getAggregateBySweetFood: function(){
            var param = {sortId:"5844daabc20d03f8c9970510"};
            return order.aggregateByMatB(param);
        },
        getAggregateByCount: function(){
            return bankStatement.getAggregateByCountIdUrl();
        },
        getDistrictSalesQuery: function(params){
            var query = {};
            //普通商家
            if(config.getPlatformShopId()!==shop.getShopId()){
                query.fromShopId=shop.getShopId();
            }
            //平台
            if(params.queryInfo&&params.queryInfo.shopInfo&&params.queryInfo.shopInfo._id){
                query.fromShopId=params.queryInfo.shopInfo._id;
            }
            return query;
        },
        //累计
        getAggregateAmountUrlTotal: function(){
            return bankStatement.getAggregateAmountUrl();
        },
        //年
        getAggregateAmountUrlYear: function(){
            var date = new Date();
            var parms={};
            parms.payDatef = date.getFullYear()+"-01-01";
            return bankStatement.getAggregateAmountUrl(parms);
        },
        //月销售
        getAggregateAmountUrlMonth: function(){
            var date = new Date();
            var parms={};
            parms.payDatef = date.getFullYear()+"-"+(date.getMonth()+1)+"-01";
            return bankStatement.getAggregateAmountUrl(parms);
        },
        //日
        getAggregateAmountUrlDay: function(){
            var date = new Date();
            var parms={};
            date.setHours(0);
            date.setMinutes(0);
            date.setSeconds(0);
            date.setMilliseconds(0);
            parms.payDatef = date;
            return bankStatement.getAggregateAmountUrl(parms);
        },
        getAggregateAmountQuery: function(parms){
            var query={};
            query.pageSize = 5;
            return query;
        }
    });
    return boBase;
});
