define([
		"dojo/_base/lang",
		"./BoBase",
		"cq/biz/ts/cart",
		"cq/biz/ts/order",
        "cq/biz/ts/pm/project",
        "cq/biz/user/user",
        "cq/biz/shop/shop",
        "cq/util/config/config",
        "cq/util/sys/date",
        "dijit/registry",
        "dojo/Deferred"
	], function (lang, BoBase, cart, order,project, user, shop, config, date ,registry,Deferred) {
	var boBase = new BoBase({
			//添加字段
			fields: {
                //申请信息定义
                //申请信息定义
                "matsInfo" : {
                    type : "objects",
                    label: "",
                    labelField : "dName",
                    rightTextField : "dTel",
                    canEdit : false,
                    canDelete : false,
                    canAdd : false,
                    fields : {
                        layout : [{
                            field : "logo",
                            type : "image",
                            label : "商品图片",
                            className:"middle-width"
                        }, {
                            field : "mName",
                            type : "text",
                            label : "名称",
                            className:"middle-width"
                        }, {
                            field : "price",
                            type : "text",
                            label : "价格",
                            className:"middle-width"
                        }, {
                            field : "qty",
                            type : "text",
                            label : "数量",
                            className:"large-width"
                        }]
                    }
                },
                "createAt":{
                    type: "date",
					label: "创建时间",
                    className:"middle-width"
                },
                "details.0.dName": {
					type: "text",
					label: "收件人姓名",
                    className:"middle-width"
				},
                "dName":{
					type: "text",
					label: "收货人",
                    canEdit:false,
                    className:"middle-width"
				},
                "dTel":{
					type: "text",
					label: "电话",
                    canEdit:false,
                    className:"large-width"
				},
                "dAddress":{
					type: "text",
					label: "收货地址",
                    canEdit:false,
                    className:"large-width"
				},
                operateButton:{
                    type:"button",
                    label:"取消订单",
                    action:"orderCancel"
                },
                mName:{
                    type: "text",
                    label: "商品名称",
                    formatter: function (action, data) {
                        //var buttonNode;
                        var v = "";
                        for(var i=0;i<data.details.length;i++){
                            v += "<div>"+data.details[i].mId.mName+"</div>";
                        }
                        return v;
                    }
                },
                price:{
                    type: "text",
                    label: "商品价格",
                    formatter: function (action, data) {
                        var v = "";
                        for(var i=0;i<data.details.length;i++){
                            v += "<div>"+data.details[i].price+"</div>";
                        }
                        return v;
                    }
                },
                qty:{
                    type: "text",
                    label: "商品数量",
                    formatter: function (action, data) {
                        var buttonNode;
                        var v = "";
                        for(var i=0;i<data.details.length;i++){
                            v += "<div>"+data.details[i].qty+"</div>";
                        }
                        return v;
                    }
                },
                detailQty:{
                    type: "text",
					label: "数量",
                    className:"large-width"
                },
                "details.0.dAddress": {
					type: "text",
					label: "收件人地址",
                    className:"large-width"
				},
                "details.0.dTel": {
					type: "text",
					label: "收件人电话",
                    className:"middle-width"
				},
                "details.0.mId.mName": {
					type: "text",
					label: "商品名称"
				},
                "details.0.price": {
					type: "text",
					label: "商品单价"
				},
                "details.0.qty": {
					type: "text",
					label: "商品数量"
				},
                //金额
				amount: {
					type: "text",
					label: "总金额(含运费)",
                    canEdit:false,
                    className:"large-width"
				},
                couponAmount: {
					type: "text",
					label: "优惠券",
                    canEdit:false,
                    className:"large-width"
				},
                tAmount: {
					type: "text",
					label: "运费",
                    canEdit:false,
                    className:"large-width"
				},
                
                "details.mName":{
                    type: "text",
                    label: "商品名称",
                    formatter: function (action, data) {
                        var v = "";
                        for(var i=0;i<data.details.length;i++){
                            v+=" "+data.details[i].mId.mName;
                        }
                        return v;
                    },
                    className:"large-width"
                },
                tListAmount: {
                    type: "text",
                    label: "运费",
                    formatter: function (action, data) {
                        var v = "<div>0</div>";
                        if(data.tAmount){
                            v = "<div>"+data.tAmount.toFixed(2)+"</div>";
                        }
                        return v;
                    },
                    className:"large-width"
				},
                payType:{
                    type:"options",
                    label:"支付方式",
                    options:{
						"point":"积分支付",
						"weixin":"微信支付",
						"wxNative":"微信网页支付",
						"wxApp":"微信App支付",
						"aliwap":"支付宝手机网页支付",
						"aliweb":"支付宝网页支付",
						"chinaPay":"银联电子支付",
						"unionPay":"银联支付",
						"cash":"现金",
						"bocNB2B":"中国银行B2B",
						"bocB2CMobile":"中国银行B2CMobile"
					}				
                },
                picState:{
                    type:"text",
                    label:"已支付",
                    canEdit: false
                },
                integral:{
                    type:"text",
                    label:"积分/优惠券抵扣",
                    canEdit: false,
                    className:"large-width"
                },
                shouldAmount:{
                    type:"text",
                    label:"应付金额",
                    canEdit: false,
                    className:"large-width"
                },
                dates:{
                    type:"text",
                    label:"创建时间",
                    
                    canEdit: false,
                    className:"large-width"
                },
                state:{
                    type:"text",
                    label:"订单状态",
                    canEdit: false,
                    className:"middle-width"
                },
                //描述相符否
                matEvaluation:{
                    type:"text",
                    label:"描述相符",
                    editable: true,
                    className:"large-width"
                },
                //服务态度
                serviceEvaluation:{
                    type:"text",
                    label:"服务态度",
                    editable: true,
                    className:"large-width"
                },
                //发货速度
                deliveryEvaluation:{
                    type:"text",
                    label:"发货速度",
                    editable: true,
                    className:"large-width"
                },
                //物流速度
                logisticsEvaluation:{
                    type:"text",
                    label:"物流速度",
                    editable: true,
                    className:"large-width"
                },
                //评价内容
                content:{
                    type:"text",
                    label:"评价内容",
                    canEdit: true,
                    className:"large-width"
                },
                //上传图片
                images:{
                    type:"image",
                    label:"上传图片",
                    editable: true,
                    className:"large-width"
                    //tag:""
                },
                completeButton:{
                    type:"button",
                    action:"onSaveMatEva",
                    label:"完成"
                },
                //支付宝付
                aliwap:{
                    type:"button",
                    action:"payAliWap",
                    label:"支付宝支付"
                    //className:"small-width"
                },
                point:{
                    type:"button",
                    action:"payPoint",
                    label:"余额支付"
                    //className:"small-width"
                },
                weixin:{
                    type:"button",
                    action:"payWeixin",
                    label:"微信支付"
                    //className:"small-width"
                },
                bocB2CMobile:{
                    type:"button",
                    action:"payBocB2CMobile",
                    label:"银联支付"
                    //className:"small-width"
                },
                operateShow:{
                    type: "text",
                    label: "操作",
                    formatter:function (action, data) {
                        var buttonNode;
                            buttonNode = "<div class=''></div>";
                        var v ="";
                        var stateMsg = "";
                        var state = 1;
                        var clickAction = "";
                        if(data.isPayed){
                            //已付款
                            if(data.isCanceled){
                                //已付款且已取消，则为已退款
                                stateMsg = "已退款";
                            }else if(data.isDelived){
                                //已发货
                                if(data.isClosed){
                                    //若已关闭，则为已完成
                                    stateMsg = "已完成";
                                }else if(!data.isReceipted){
                                    //若未收货，为待收货
                                    stateMsg = "收货";
                                    state = 2;
                                }else{
                                    //否则，待评价，评价完成之后会变成已完成
                                    stateMsg = "评价";
                                    //点击进入评价界面
                                    state = 3;
                                }
                            }else{
                                //否则为待发货
                                stateMsg = "待发货";
                            }
                        }else{
                            //未付款
                            if(data.isCanceled){
                                //已取消
                                stateMsg = "已取消";
                            }else{
                                state = 4;
                                if(data.payType == "point"){
                                    stateMsg = "余额支付";
                                    clickAction = "point";
                                }else if(data.payType == "aliwap"){
                                    stateMsg = "支付宝付";
                                    clickAction = "aliwap";
                                }else if(data.payType == "weixin"){
                                    stateMsg = "微信支付";
                                    clickAction = "weixin";
                                }else if(data.payType == "bocB2CMobile"){
                                    stateMsg = "银联支付";
                                    clickAction = "bocB2CMobile";
                                }else {
                                    stateMsg = "付款";
                                    clickAction = "allPaymethod";
                                    //支付宝，微信，他人代付，银联
                                }
                            }
                        }
                        v = "<div class='dgrid-button' onclick='window.moveToView(\"orderSingleDetail\",\"" + data._id + "\");'>查看</div>"+
                        (stateMsg== ""?"":state==2?"<div class='dgrid-button' cq-action='confirmMat'>"+stateMsg+"</div>":state==3?"<div class='dgrid-button' onclick='window.moveToView(\"matEvaDetail\",\"" + data._id + "\");'>"+stateMsg+"</div>":"<div class='dgrid-button' cq-action="+clickAction+">"+stateMsg+"</div>");
                        return v;
                    }
                },
                saveButton:{
                    type:"button",
                    action:"onSave",
                    label:"保存"
                },
                //App导出
                "details.0._id":{
                    type:"text",
                    label:"订单号",
                    className:"middle-width"
                },
                payTime:{
                    type:"date",
                    label:"支付日期",
                    className:"middle-width"
                },
                "details.0.mId.mName":{
                    type:"text",
                    label:"商品名称",
                    className:"middle-width"
                },
                "payAmount":{
                    type:"text",
                    label:"实付金额",
                    className:"middle-width"
                },
                "acceptTime":{
                    type:"date",
                    label:"审核时间"
                },
                "delivTime":{
                    type:"date",
                    label:"发货时间"
                },
                "cancelTime":{
                    type:"date",
                    label:"取消时间"
                },
                "inviter.pName":{
                    type:"text",
                    label:"邀请人"
                },
                "inviter.userName":{
                    type:"text",
                    label:"邀请人电话"
                }
            },
            getExportAppLayout: function(){
                if (!this.exportAppLayout) {
                    this.exportAppLayout = this.getFormItems([
                        "details.0._id",
                        "payTime",
                        "details.0.dName",
                        "details.0.dTel",
                        "details.0.dAddress",
                        //....
                        "details.mName",
                        //"details.0.price",
                        //"details.0.qty",
                        "amount",
                        //....
                        "couponAmount",
                        "payAmount",
                        "tAmount",
                        "state",
                        //支付方式 
						"payType",
                        "createAt",
                        "acceptTime",
                        "delivTime",
                        "cancelTime",
                        "inviter.pName",
                        "inviter.userName"
                    ]);
                    //state
                    this.exportAppLayout[9].formatter = lang.hitch(this,function(v,data){
                        return this.getOrderStatus(data);
                    });
                    
                }
                return this.exportAppLayout;
            },
            //取消订单
            orderCancel:function(data,widget){
                //widget.getObjs();
                window.busy();
                if (!confirm("确定取消订单吗？")) return;
                order.onCancelAll(data.tsId).then(lang.hitch(this, function(status) {
                    if(status.data.ok){
                        //隐藏取消订单按钮
                        widget.hideByFields(["operateButton"]);
                        //修改订单状态
                    	widget.getEditorByField("state").value="已取消";
                        alert("订单已取消");
                        window.free();
                    }else{
                        alert(status.data.msg);
                    }
                }));
            },
            //列表点击事件
            onListAction:function(data, action, list){
                var role = user.getCurrentUserRole();
                if (action == "confirmMat") {
                    if (!confirm("确定收货吗？")) return;
                    order.setReceipteded(data._id).then(lang.hitch(this, function(data1){
                        if(data1.data.ok){
                            //刷新列表
                            data.isRefounded = false;
                            data.isReceipted = true;
                            list.refreshItemByData(data);
                            alert("你已确认收货");
                        }else{
                            alert(data1.data.msg||"收货失败");
                        }
                    }));
                }else if(action == "point"||action =="aliwap"||action=="weixin"||action=="payByOther"||action=="bocB2CMobile"){
                    //支付宝支付
                    var params = {};
                    params._id = data._id;
                    params.payType = action;
                    order.onPayed(params).then(lang.hitch(this,function(data1){
                        if(data1.data.ok){
                            data.isPayed = true;
                            list.refreshItemByData(data);
                            alert("支付成功");
                            /*if(role == 4){
                                order.loadWithDetails({shopId:order.getShopId(),userShopId:order.getShopId()}).then(lang.hitch(this,function(data2){
                                    list.refreshItemByData(data2.data.items[0]);
                                    alert("你已确认收货"); 
                                }));
                            } else {
                                order.loadWithDetails({shopId:order.getShopId(),userId:user.getCurrentUserId()}).then(lang.hitch(this,function(data2){
                                    list.refreshItemByData(data2.data.items[0]);
                                    alert("你已确认收货"); 
                                }));
                            }*/
                        }else{
                            alert(data1.data.msg||"支付失败");
                        }
                    }));
                }else if(action == "allPaymethod"){
                    //所有的支付都可以
                    window.moveToView("orderSingleDetail",data._id);
                }
            },
            //订单支付
            payAliWap:function(data){
                window.busy();
                var params = {};
                params._id = data._id;
                params.payType = "aliwap";
                order.onPayed(params).then(lang.hitch(this,function(orderData){
                    if(orderData.data.ok){
                        alert("支付成功");
                        window.moveToView("orderSingleList");
                    }else{
                        alert(orderData.data.msg);
                    }
                    window.free();
                }));
            },
            payPoint:function(data){
                window.busy();
                var params = {};
                params._id = data._id;
                params.payType = "point";
                order.onPayed(params).then(lang.hitch(this,function(orderData){
                    if(orderData.data.ok){
                        alert("支付成功");
                        window.moveToView("orderSingleList");
                    }else{
                        alert(orderData.data.msg);
                    }
                    window.free();
                }));
            },
            payWeixin:function(data){
                window.busy();
                var params = {};
                params._id = data._id;
                params.payType = "weixin";
                order.onPayed(params).then(lang.hitch(this,function(orderData){
                    if(orderData.data.ok){
                        alert("支付成功");
                        window.moveToView("orderSingleList");
                    }else{
                        alert(orderData.data.msg);
                    }
                    window.free();
                }));
            },
            /*payByOther:function(data){
                window.free();
                if(data.payByOtherPhone){
                    var param = {};
                    param.receiverId = data.tsId;
                    param.content = (user.getUserData().pName||user.getUserData().pName || "未知")+"请求您帮其付款，付款金额" 
                    +this.actualPayAmount+"元";
                    param.moveTo = "payToAnother";
                    param._id = window.did;
                    param.userName = data.userName;
                    param.taskType = 2;
                    order.findAnotherToPay(param).then(lang.hitch(this,function(payOtherData){
                        if(payOtherData.data.ok){
                            alert("发送成功");
                        }else{
                            alert(payOtherData.data.msg)
                        }
                    }));
                } else {
                    alert("发送失败！");
                }
            },*/
            payBocB2CMobile:function(data){
                window.busy();
                var params = {};
                params._id = data._id;
                params.payType = "bocB2CMobile";
                order.onPayed(params).then(lang.hitch(this,function(orderData){
                    /*if(orderData.data.ok){
                        alert("支付成功");
                        window.moveToView("orderSingleList");
                    }else{
                        alert(orderData.data.msg);
                    }*/
                    window.free();
                }));
            },
            //获取订单的状态
            getOrderStatus:function(data){
                // 将orderStatus的状态按照优先级显示已退款问题修复  2016/7/6  徐阿雪 
                // 已退款是根据主表的已支付和已取消来重新定义
                var state = "";
                if(data.isPayed){
                    //已付款
                    if(data.isCanceled){
                        //已付款且已取消，则为已退款
                        state = "已退款";
                    }else if(data.isDelived){
                        //已发货
                        if(data.isClosed){
                            //若已关闭，则为已完成
                            state = "已完成";
                        }else if(!data.isReceipted){
                            //若未收货，为待收货
                            state = "待收货";
                        }else{
                            //否则，待评价，评价完成之后会变成已完成
                            state = "待评价";
                        }
                    }else{
                        //否则为待发货
                        state = "待发货";
                    }
                }else{
                    //未付款
                    if(data.isCanceled){
                        //已取消
                        state = "已取消";//"<div class='button' >已取消</div>";//
                    }else{
                        //待付款
                        state = "待付款";
                    }
                }
                return state;
            },
			getOrderListUrl: function () {
                var role = user.getCurrentUserRole();
                if(role == 4){
                    return order.getShopWithDetailsUrl();
                } else {
                    return order.getB1BWithDetailsUrl();
                }
			},
			getOrderListQueryParam: function (params) {
				var query = {orderBy:'-createAt'};
				if (params.search) {
					query.search = params.search;
				}
				if(params.state&&params.state._id){
                    if("0" == params.state._id){
                        
                    }else if("1" == params.state._id){
                        query.isPayed = false;
                        query.isCanceled = false;
                    }else if("2" == params.state._id){
                        query.isPayed = true;
                        query.isCanceled = false;
                        query.isDelived = false;
                    }else if("3" == params.state._id){
                        query.isPayed=true;
                        query.isCanceled=false;
                        query.isDelived=true;
                        query.isReceipted=false;
                    }else if("4" == params.state._id){
                        query.isPayed=true;
                        query.isCanceled=false;
                        query.isReceipted=true;
                        query.isClosed=false;
                    }
                }
				return query;
			},
            getOrderListGridLayout: function(){
                if(!this.bankStatementLayout){
                    this.bankStatementLayout = this.getFormItems([
                    "details.0.dName",
                    "details.0.dAddress",
                    "details.0.dTel",
                    "mName",
                    "price",
                    "qty",
                    "amount", "tListAmount", 
                    "operateShow"
                    ],false);
                }
                return this.bankStatementLayout;
            },
            //详情
            getOrderDetailQueryLayout:function(){
                return [{
                    type: "form",
                    fields: this.getFormItems([
                    "details.0.dName","details.0.dTel","details.0.dAddress"//,
                    //"oderState"
                    ])
                }];
            },
            getMatLayout:function(){
                if(!this.bankStatementLayout){
                    this.bankStatementLayout = this.getFormItems([
                        
                    ],false);
                }
                return this.bankStatementLayout;
            },
            getMatParam:function(params){
                var query = {};
                
                return query;
            },
			getOrderDetailLayout:function(){
                return [{
                    type:"form",
                    //dataProvider: "cq/bo/merchant",
                    fields:this.getFormItems([
                        "dName","state",
                        "dTel",
                        "dAddress","matsInfo",
                        "tAmount","amount",
                        "integral","shouldAmount","dates",
                        "operateButton",
                        "point","aliwap",
                        "weixin","bocB2CMobile"
                    ],true)
                }];
            },
            orderDetailReload:function(widget){
                var data = widget.getData();
                var btn = ["point","aliwap","weixin","bocB2CMobile"];
                widget.hideByFields(btn);
                widget.hideByFields(["operateButton"])
                //未支付未取消
                if(!data.isPayed&&!data.isCanceled){
                    widget.showByFields(["operateButton"]);
                    if(data.payType == "point"){
                        widget.showByFields(["point"]);
                    }else if(data.payType == "aliwap"){
                        widget.showByFields(["aliwap"]);
                    }else if(data.payType == "weixin"){
                        widget.showByFields(["weixin"]);
                    }else if(data.payType == "bocB2CMobile"){
                        widget.showByFields(["bocB2CMobile"]);
                    }else {
                        widget.showByFields(btn);
                        //支付宝，微信，他人代付，银联
                    }
                }
                
            },
            /*orderDetailChange:function(widget,field,value){
                if(field == "state"){
                    
                }
            },*/
            getOrderDetailInitData:function(param){
                if(!param || !param.cqViewParam || !param.cqViewParam.params){
                    return project.defTest({isUse:true,state:0});
                }
                return order.loadDetailById(param.cqViewParam.params).then(lang.hitch(this,function(backData){
                    //收货人信息
                    var getData = backData.data.items;
                    //加载订单信息
                    return order.loadById(param.cqViewParam.params).then(lang.hitch(this, function(dataInfo) {
                        //重算订单支付方案?
                        var data;
                        if(dataInfo.data.item){
                            data = dataInfo.data.item;
                            backData = data;
                            backData.dName = getData[0].dName;
                            backData.dAddress = getData[0].dAddress;
                            backData.dTel = getData[0].dTel;
                            var images = [];
                            for(var i=0;i<getData.length;i++){
                                images.push({price:getData[i].price,qty:getData[i].qty,logo:getData[i].mId.logo,mName:getData[i].mId.mName});
                            }
                            backData.matsInfo = images;
                            backData.tAmount = "￥"+data.tAmount.toFixed(2);
                            backData.integral = "￥"+(data.couponAmount + data.point).toFixed(2);
                            backData.shouldAmount = "￥"+(data.amount - ((data.point + data.couponAmount) || 0)).toFixed(2);
                            backData.amount = "￥"+data.amount.toFixed(2);
                            backData.dates = date.formatISODateMinutes(data.createAt);
                            backData.state = this.getOrderStatus(data);
                        }
                        return backData;
                    }));
                }));
            },
            //订单评价
            matEvaDetailInit:function(param){
                //保存订单评价order.evaluedB2BByDetailId
                if(!param || !param.cqViewParam || !param.cqViewParam.params){
                    return project.defTest({isUse:true,state:0});
                }
                return order.loadDetailById(param.cqViewParam.params).then(lang.hitch(this,function(data){
                    return data;
                }));
            },
            matEvaDetailLayOut:function(){
                return [{
                    dojoType : "cq/app/widget/web/Steps",
                    field : "steps",
                    formClass : "table-clas",
                    steps : {
                        stepsTags : [{
                            type : "action",
                            label : "订单评价"
                        }],
                        stepsFields : [{
                            fields : this.getFormItems([
                                "matEvaluation","serviceEvaluation",
                                "deliveryEvaluation","logisticsEvaluation",
                                "content","images"],true),
                            type:"tagFields"
                        }],
                        stepsBtns : this.getFormItems(["completeButton"])
                    }
                }];
            },
            onSaveMatEva:function(data){
                window.busy();
                var param = {};
                param.userId = data.data.items[0].userId;
                param._id = data.data.items[0]._id;
                param.shopId = data.data.items[0].mId.fromShopId;
                order.evaluedB2BByDetailId(param).then(lang.hitch(this,function(dataInfo){//evaluedByDetailId//evaluedB2BByDetailId
                    if(dataInfo.data.ok){
                        window.moveToView("orderSingleList");//history.back();
                    }else{
                        alert("评价失败");
                        window.free();
                    }
                }));
                window.free();
            },
            payOrderDetailLayOut:function(){
                return [{
                    type:"form",
                    fields:this.getFormItems([
                        "dName","state",
                        "dTel",
                        "dAddress","matsInfo",
                        "tAmount","amount",
                        "integral","shouldAmount","dates",
                        "point","aliwap",
                        "weixin","bocB2CMobile"],true)
                }];
            }
		});
	return boBase;
});