//创建人：周超
//创建时间：2016/11/26
//创建内容：平台订单对象：1平台列表;2平台详情
define([
        "dojo/_base/lang",
        "./../BoBase",
        "cq/biz/ts/cart",
        "cq/biz/ts/order",
        "cq/biz/ts/pm/project",
        "cq/biz/user/user",
        "cq/biz/shop/shop",
        "cq/util/config/config",
        "cq/util/sys/date",
        "dijit/registry",
        "dojo/Deferred"
	], function (lang, BoBase, cart, order,project, user, shop, config, date ,registry,Deferred) {
	var boBase = new BoBase({
			//添加字段
			fields: {
                //申请信息定义
                //申请信息定义
                "matsInfo" : {
                    type : "objects",
                    label: "",
                    labelField : "dName",
                    rightTextField : "dTel",
                    canEdit : false,
                    canDelete : false,
                    canAdd : false,
                    fields : {
                        layout : [{
                            field : "logo",
                            type : "image",
                            label : "商品图片",
                            className:"middle-width"
                        }, {
                            field : "mName",
                            type : "text",
                            label : "名称",
                            className:"middle-width"
                        }, {
                            field : "price",
                            type : "text",
                            label : "金额",
                            className:"middle-width"
                        }, {
                            field : "qty",
                            type : "text",
                            label : "数量",
                            className:"large-width"
                        }]
                    }
                },
                "createAt":{
                    type: "date",
                    label: "创建时间",
                    className:"middle-width"
                },
                "_id":{
                    type: "text",
                    label: "订单号",
                    className:"middle-width"
                },
                "details.0.dName": {
                    type: "text",
                    label: "收货人姓名",
                    className:"middle-width"
                },
                "dName":{
                    type: "text",
                    label: "收货人",
                    className:"middle-width"
                },
                "dTel":{
                    type: "text",
                    label: "电话",
                    className:"large-width"
                },
                "dAddress":{
                    type: "text",
                    label: "收货地址",
                    className:"large-width"
                },
                operateButton:{
                    type:"button",
                    action:"operate",
                    label:"取消订单"
                },
                mName:{
                    type: "text",
                    label: "商品名称",
                    formatter: function (action, data) {
                        var v = "";
                        for(var i=0;i<data.details.length;i++){
                            v += "<div>"+data.details[i].mId.mName+"</div>";
                        }
                        return v;
                    }
                },
                qty:{
                    type: "text",
                    label: "商品数量",
                    formatter: function (action, data) {
                        var v = "";
                        for(var i=0;i<data.details.length;i++){
                            v += "<div>"+data.details[i].qty+"</div>";
                        }
                        return v;
                    }
                },
                detailQty:{
                    type: "text",
                    label: "数量",
                    className:"large-width"
                },
                "details.0.dAddress": {
                    type: "text",
                    label: "收货人地址",
                    className:"large-width"
                },
                "details.0.dTel": {
                    type: "text",
                    label: "收货人电话",
                    className:"middle-width"
                },
                "details.0.mId.mName": {
                    type: "text",
                    label: "商品名称"
                },
                "details.0.price": {
                    type: "text",
                    label: "商品单价"
                },
                "details.0.qty": {
                    type: "text",
                    label: "商品数量"
                },
                //金额
                amount: {
                    type: "text",
                    label: "总金额(含运费)",
                    className:"large-width"
                },
				//金额
                actualAmount: {
                    type: "text",
                    label: "总金额(含运费)",
                    className:"large-width",
                    formatter: function (action, data) {
						return (parseFloat(data.amount)+parseFloat(data.discountAmount||0)).toFixed(2);       
                    }
                },
                tAmount: {
                    type: "text",
                    label: "运费",
                    className:"large-width"
                },
                picState:{
                    type:"text",
                    label:"已支付",
                    canEdit: false
                },
                integral:{
                    type:"text",
                    label:"积分/优惠券抵扣",
                    canEdit: false,
                    className:"large-width",
                    formatter:function (action, data) {
                        var v = "<div>"+(parseFloat(data.couponAmount)+parseFloat(data.point)).toFixed(2)+"</div>";
                        return v;
                    }
                },
                shouldAmount:{
                    type:"text",
                    label:"应付金额",
                    canEdit: false,
                    className:"large-width"
                },
                couponAmount:{
                    type: "text",
                    label: "代金券"
                },
                fromShopName:{
                    type:"text",
                    label:"供应商名称",
                    canEdit: false,
                    className:"large-width"
                },
                dates:{
                    type:"text",
                    label:"创建时间",
                    canEdit: false,
                    className:"large-width"
                },
                state:{
                    type:"text",
                    label:"订单状态",
                    //action:"stateClick",
                    canEdit: false,
                    className:"middle-width"
                },
                operateShow:{
                    type: "text",
                    label: "操作",
                    formatter:function (action, data) {
                        v = "<div class='dgrid-button' onclick='window.moveToView(\"plateOrderDetail\",\"" + data._id + "_" + data.fromShopId + "\")'>查看</div>";
                        if(!data.isPayed && !data.isCanceled)
                        v += "<div class='dgrid-button' cq-action='confirmProce'>确认收款</div>";
                        return v;
                    }
                },
                confirButton:{
                    type:"button",
                    action:"confirAction",
                    label:"确认收款"
                }
            },
            getPlateOrderLayout: function(){
                if(!this.plateOrderLayout){
                    this.plateOrderLayout = this.getFormItems([
                    "_id",
                    "details.0.dName",
                    "details.0.dAddress",
                    "details.0.dTel",
                    "mName",
                    "qty",
                    "actualAmount",
                    "integral",
                    "operateShow"
                    ],false);
                }
                return this.plateOrderLayout;
            },
            getPlateOrderUrl: function(){                            
                return order.getPlatformOrderUrl();
                
            },
            getPlateOrderQueryParam: function(params){
                var query = {orderBy:'-createAt'};
                if(!params || !params.cqViewParam || !params.cqViewParam.params){
                    query.shopId=order.getShopId();
                    query.fromShopId = order.getShopId();
                }
                else {
                    query.fromShopId = params.cqViewParam.params;
                    query.shopId = params.cqViewParam.params;
                }					
                if (params.search) {
                    query.search = params.search;
                }
                if(params.state&&params.state._id){
                    if("0" == params.state._id){
                        //query = {};
                    }else if("1" == params.state._id){
                        query.isPayed = true;
                    }else if("2" == params.state._id){
                        query.isPayed = false;
                        query.isCanceled = false;
                    }
                }
                return query;
            },
            getPlateOrderDetailLayout: function(){
                return [{
                    type:"form",
                    fields:this.getFormItems([
                        "fromShopName",
                        "dName","state",
                        "dTel",
                        "dAddress","matsInfo",
                        "tAmount","actualAmount",
                        "integral","shouldAmount","dates",
                        "confirButton"
                    ],true)
                }]
            },
            getPlateOrderDetailReload: function(widget){
                widget.hideByFields(["confirButton"]);
                var data = widget.getData();
                if(!data.isPayed&&!data.isCanceled){
                    widget.showByFields(["confirButton"]);
                }
            },
            initPlateOrderDetailData: function(param){
                if(!param || !param.cqViewParam || !param.cqViewParam.params){
                    return project.defTest({isUse:true,state:0});
                }				 				
                return order.loadDetailShopById({id:param.cqViewParam.params.split("_")[0],shopId:param.cqViewParam.params.split("_")[1]}).then(lang.hitch(this,function(backData){
                    //收货人信息
                    var consData = backData.data.items;
                    var dataImages = [];
                    backData = backData.data.items[0];
                    //商品信息
                    for(var i=0;i<consData.length;i++){
                        dataImages.push({price:consData[i].price,qty:consData[i].qty,logo:consData[i].mId.logo,mName:consData[i].mId.mName});
                    }
                    backData.matsInfo = dataImages;
                    //加载订单信息
                    return order.loadShopById({id:param.cqViewParam.params.split("_")[0],shopId:param.cqViewParam.params.split("_")[1]}).then(lang.hitch(this, function(dataInfo) {
                        //重算订单支付方案?
                        var data;
                        if(dataInfo.data.item){
                            data = dataInfo.data.item;
                            backData.tAmount = data.tAmount.toFixed(2);
                            backData.amount = data.amount;
							backData.actualAmount = (parseFloat(data.amount)+ parseFloat(data.discountAmount||0)).toFixed(2);
                            backData.integral = (data.couponAmount + data.point).toFixed(2);
                            backData.shouldAmount = (parseFloat(data.amount)+ parseFloat(data.discountAmount||0) - ((data.point + data.couponAmount) || 0)).toFixed(2);
                            backData.dates = date.formatISODateMinutes(data.createAt);
                            backData.fromShopName = data.fromShopName;
                            //backData.state = this.getOrderStatus(data);
                        }
                        return backData;
                    }));
                }));
            },
            onListAction:function(data, action, list){
                if("confirmProce" == action){
                    if (!confirm("确定已收款吗？")) return;
                    var params = {};
                    params._id = data._id;
                    params.shopId=data.fromShopId;
                    params.payType = "cash";
                    window.busy();
                    order.setPayedByPlatform(params).then(function(result){
                        window.free();
                        if(1 == result.data.ok){
                            data.isPayed = true;
                            list.refreshItemByData(result.data.item);
                        }else{
                            alert("服务器繁忙");
                        }
                    });
                }
            },
            confirAction: function(data){
                var params = {};
                params._id = data._id;
                params.shopId=data.fromShopId;
                params.payType = "cash";
                window.busy();
                order.setPayedByPlatform(params).then(function(result){
                    window.free();
                    if(1 == result.data.ok){
                        list.refreshItemByData(result.data.item);
                    }else{
                        alert("服务器繁忙");
                    }
                });
            }
        });
    return boBase;
});