﻿define([
    "dojo/topic",//不依赖的模块
    "dojo/Deferred",
    "dojo/_base/lang",
    "dojo/topic", //不依赖的模块
    "cq/biz/user/user",//不依赖的模块
    "cq/util/config/config",//不依赖的模块
    "cq/biz/mk/price",
    "./BoBase"
],function(topic,Deferred,lang,topic,user,config,price,BoBase){
    var priceBo =  new BoBase({
        fields:{
            market:{
                type:"options",
                label:"区域",
				options : {
					1:'全国',
					2:'重庆',
					3:'酉阳',
					4:'福建',
					5:'广东'
				}
            },
            priceType:{
                type:"options",
                label:"销售类型",
				options : {
					1:'进场',
					2:'收购',
					3:'产地',
					4:'批发',
					5:'零售'
				},
                className:"middle-width"
            },
            sortName: {
                type: "text",
                label: "品种",
				className:"middle-width",
                editable: true
            },
            sortId: {
                type: "ref",
                label: "品种",
                dataProvider: "cq/biz/mat/sort",
                targetMethod: "loadNoSub",
                searchField: "sortName",
                labelFields: "sortName",
				className:"middle-width",
                editable: true
            },
            maker:{
                type:"text",
                label:"录入人",
				className:"middle-width"
            },
            makeDate:{
                type:"date",
                label:"日期",
				className:"middle-width"
            },
            price:{
                type:"text",
                label:"价格",
				className:"middle-width"
            },
            districtName:{
                type:"text",
                label:"产地",
				className:"large-width"
            },
            //区划编辑,省、市、区县、地址文本
            "provinceId,cityId,countyId,districtName":{
                type:"district",
                label:"省-市-区县",
				className:"large-width"
            },
            fromShopId:{
                type: "ref",
                label: "市场",
                dataProvider: "cq/biz/shop/shop",
                targetMethod: "getShopByPlatform",
                searchField: "shopName",
                labelFields: "shopName",
				className:"middle-width"
            },
            fromShopName:{
                type:"text",
                label:"市场"
            },
			saveButton:{
				type:"button",
				action:"onSave",
				label:"保存"
			},
            priceActions:{
				type:"text",
				label:"",
				formatter:function(action,data){
					var v = "<div class='button' cq-action='delete'>删除</div><div class='button' onclick='window.moveToView(\"priceTrendDetail\",\""+data._id+"\");'>编辑</div>";
					return v;
				}
            }
        },
		getDetailTemplate:function(){
			return "<h4>{title}</h4><div>{content}</div>";
		},
		load:function(){
			return price.getLoadUrl();
		},
		loadById:function(param){
			if(!param || !param.cqViewParam || !param.cqViewParam.params) return {isUse:true};
			var def=new Deferred();
			price.loadById(param.cqViewParam.params).then(lang.hitch(this,function(data){
				def.resolve(data.data.item);
			}));
			return def;
		},
		getQueryParam:function(params){
			var query = {isUse:true};
            if(params.search){
                query.pName = params.search;
            }
            return query;
        },
        getGridLayout: function() {
            if(!this.priceGridLayout){
                this.priceGridLayout = this.getFormItems(["market","makeDate","price","priceActions"],false);
            }
            return this.priceGridLayout;
        },
        getGridLayout2: function() {
            if(!this.priceGridLayout2){
                this.priceGridLayout2 = this.getFormItems(["sortName","fromShopName","price","priceType","districtName","maker","makeDate","priceActions"],false);
            }
            return this.priceGridLayout2;
        },
        getEditLayout: function() {
            if(!this.editLayout){
                this.editLayout = [{
                    type: "form",
                    fields: this.getFormItems(["market","makeDate","price","saveButton"])
                }];
            }
            return this.editLayout;
        },
        getEditLayout2: function() {
            if(!this.editLayout2){
                this.editLayout2 = [{
                    type: "form",
                    fields: this.getFormItems(["sortId","fromShopId","price","priceType","provinceId,cityId,countyId,districtName","maker","makeDate","saveButton"])
                }];
            }
            return this.editLayout2;
        },
		onListAction:function(data,action,list){
			if(action == "delete"){
				if(!confirm("确定删除吗？")) return;
				price.save({_id:data._id,isUse:false}).then(function(){list.removeItemByData(data);});
			}
		},
		onSave:function(data,dataList){
			//
			window.busy();
            if(data.sortId && data.sortId._id){
                data.sortName = data.sortId.sortName;
                data.sortId = data.sortId._id;
            }
            if(data.fromShopId && data.fromShopId._id){
                data.fromShopName = data.fromShopId.shopName;
                data.fromShopId = data.fromShopId._id;
            }
			price.save(data).then(function(){history.back();window.free();});
		}
        
    });
    return priceBo;
});
