define([
    "./BoBase",
    "cq/biz/ts/pm/projectLog"
],function(BoBase,projectLog){
    return new BoBase({
        //字段定义
        fields:{
            projectTitle:{
                type:"text",
                label:"项目名称",
                className:"middle-width"
            },
            projectId:{
                type:"ref",
                field:"projectId",
                label:"项目",
                searchField:"title",
                pageSize:5,
                labelFields:"title",
                dataProvider:"cq/bo/projectV2",
                targetMethod:"_load",
                canEdit:true,
				className:"middle-width"
            },
            tp:{
                type: "options",
                label: "操作类型",
                options:{
                    "10":"提交申请材料",
                    "20":"拒绝申请材料",
                    "30":"驳回申请材料",
                    "40":"审核申请材料",
                    "50":"复核申请",
                    "60":"提交验收材料",
                    "70":"驳回验收材料",
                    "80":"通过验收材料",
                    "90":"项目结案"
                },
                canEdit:true,
                className:"middle-width"
            },
            createAt:{
                type:"date",
                label:"操作时间"
            },
            remark:{
                type:"text",
                label:"操作备注",
                className:"middle-width"
            }
        },
        getListUrl:function(){
            return projectLog.getLoadUrl();
        },
        getListLayout:function(){
            return this.getFormItems(["projectTitle","tp","createAt","remark"],false);
        },
        prjLogExportLayout : function(){
            return this.getFormItems(["projectTitle","tp","createAt","remark"]);
        },
        getListQuery:function(params){
            var query = {};
            if(params.queryInfo){
                var k,queryInfo = params.queryInfo,value;
                for(k in queryInfo){
                    value = queryInfo[k];
                    if(value||0===value||false===value){
                        if(value){
                            if((typeof value == "object")&& value) {
                                if(value._id){
                                    query[k] = value._id;
                                }else if(k!="projectId"){
                                    query[k] = value;
                                }
                            }
                            if(typeof value == "string" && value) {
                                query[k] = value;
                            }
                        }else{
                            query[k] = value;
                        }
                    }
                }
            }
            return query;
        },
        getQueryLayout:function(){
            return [{
                type: "form",
                fields: this.getFormItems(["projectId","tp","createAt"])
            }];
        }
    })
});