﻿define([
    "dojo/Deferred",
    "dojo/_base/lang",//不依赖的模块
    //依赖以下两个模块有问题
    "dojo/dom-class",
    "dojo/query",
    "dojo/dom-style",
	"dojo/dom-construct",	// create
    "cq/util/config/config",
    "cq/util/sys/date",
    "cq/biz/ts/pm/project",
    "cq/biz/shop/shop",
    "cq/biz/user/user",
    "cq/biz/im/timeLine",
    "cq/widgets/bigImg",//不依赖的模块  写法有问题
    "./BoBase"
],function(Deferred,lang,domClass,query,domStyle,domConstruct,config,date,project,shop,user,timeLine,bigImg,BoBase){
    var projectBo =  new BoBase({
        fields:{
            logo:{
                type:"image",
                label:"店铺图标",
                className:"large-width",
                tag:"店铺管理"
            },
            shopName:{
                type:"text",
                label:"店铺名称",
                className:"middle-width",
                canEdit: true,
                tag:"店铺管理"
            },
            address:{
                type:"text",
                label:"店铺地址",
                className:"middle-width",
                editable: true,
                tag:"店铺管理"
            },
            brief:{
                type:"text",
                label:"店铺简介",
                className:"large-width",
                editable: true,
                tag:"店铺管理"
            },
            svcPhone:{
                type:"text",
                label:"客服电话",
                className:"middle-width",
                editable: true,
                tag:"店铺管理"
            },
            svcQQ:{
                type:"text",
                label:"客服QQ",
                className:"middle-width",
                editable: true,
                tag:"店铺管理"
            },
            svcWx:{
                type:"text",
                label:"客服微信",
                className:"large-width",
                editable: true,
                tag:"店铺管理"
            },
            contactName:{
                type:"text",
                label:"店主姓名",
                className:"middle-width",
                editable: true,
                tag:"店铺管理"
            },
            contactPhone:{
                type:"text",
                label:"店主电话",
                className:"middle-width",
                editable: true,
                tag:"店铺管理"
            },
            contactQQ:{
                type:"text",
                label:"店主QQ",
                className:"middle-width",
                editable: true,
                tag:"店铺管理"
            },
            contactWx:{
                type:"text",
                label:"店主微信",
                className:"middle-width",
                editable: true,
                tag:"店铺管理"
            },
            aliPaySeller:{
                type:"text",
                label:"支付宝账号",
                className:"middle-width",
                editable: true,
                tag:"店铺管理"
            },
            bankName:{
                type:"text",
                label:"开户行",
                className:"middle-width",
                editable: true,
                tag:"店铺管理"
            },
            bankAccountName:{
                type:"text",
                label:"账户名",
                className:"middle-width",
                editable: true,
                tag:"店铺管理"
            },
            bankAccountCode:{
                type:"text",
                label:"账号",
                className:"middle-width",
                editable: true,
                tag:"店铺管理"
            }, 
            payee:{
                type:"text",
                label:"收款人",
                className:"middle-width",
                editable: true,
                tag:"店铺管理"
            }, 
            fiName:{
                type:"text",
                label:"财务联系人姓名",
                className:"middle-width",
                editable: true,
                tag:"店铺管理"
            }, 
            fiPhone:{
                type:"text",
                label:"财务联系人电话",
                className:"middle-width",
                editable: true,
                tag:"店铺管理"
            },  
            fiQQ:{
                type:"text",
                label:"财务联系人QQ",
                className:"middle-width",
                editable: true,
                tag:"店铺管理"
            },    
            completeButton:{
                type:"button",
                action:"onComplete",
                label:"完成"
            },
            orderCheckerId : {
                type:"ref",
                label:"新订单消息通知",
                dataProvider: "cq/biz/user/user",
                targetMethod: "getStaffUrl",
                className:"middle-width",
                searchField: "pName",
                labelFields: "pName",
                editable: true
            },
            svcId : {
                type:"ref",
                label:"新客服消息通知",
                dataProvider: "cq/biz/user/user",
                targetMethod: "getStaffUrl",
                className:"middle-width",
                searchField: "pName",
                labelFields: "pName",
                editable: true
            },
            orderTimeout : {
                type:"text",
                label:"自动关闭未付款",
                className:"large-width",
                tag:"订单客服通知",
                editable: true
            },
            freightTemplated : {
                type:"checkbox",
                label:"是否启用运费模板",
                className:"middle-width",
                tag:"订单客服通知"
            },
            isWhiteList : {
                type:"checkbox",
                label:"是否启用白名单",
                className:"middle-width",
                tag:"订单客服通知"
            },
            manageFreight : {
                type : "action",
                label : "管理运费模板",
                action : "freightDetail",
                className : "large-width",
                tag : "订单客服通知"
            },
            typeId:{
                type:"options",
                label:"项目类型",
				options : {
					1: "创建评比类",
					2: "项目创建类"
				},
                notNull:true,
				className:"small-width",
                tag:"基本信息"
			},
            state:{
                type:"options",
                label:"状态",
				options : {
					0: "申请中",
					1: "已通过",
                    10:"提交申请",
                    20:"拒绝申请",
                    30:"申报驳回",
                    40:"通过申请",
                    50:"申请已复核",
                    60:"提交验收",
                    70:"验收驳回",
                    80:"通过验收",
                    90:"验收已复核"
				},
				className:"middle-width",
                tag:"基本信息"
			},
            fromShopId:{
                type: "ref",
                label: "申报单位",
                dataProvider: "cq/biz/shop/shop",
                targetMethod: "getShopByPlatform",
                searchField: "shopName",
                labelFields: "shopName",
				className:"middle-width",
                tag:"基本信息"
            },
            "fromShopName":{
                type:"text",
                label:"申报单位",
				className:"middle-width",
                tag:"基本信息"
            },
            countyShopName:{
                type:"text",
                label:"区县",
                className:"middle-width",
                tag:"区县"
            },
            "countyName":{
                type:"text",
                label:"区县",
				className:"middle-width",
                tag:"基本信息"
            },
            title:{
                type:"text",
                label:"项目名称",
                notNull:true,
				className:"large-width",
                tag:"基本信息"
            },
            startDate:{
                type:"date",
                label:"申报开始日期",
                notNull:true,
				className:"middle-width",
                tag:"申报信息"
            },
            endDate:{
                type:"date",
                label:"申报截止日期",
                notNull:true,
				className:"middle-width",
                tag:"申报信息"
            },
            createAt:{
                type:"date",
                label:"申报日期",
				className:"middle-width",
                tag:"基本信息"
            },
            submitAt:{
                type:"date",
                label:"提交日期",
				className:"large-width",
                tag:"基本信息"
            },
            applierType:{
                type:"options",
                label:"业主类型",
                notNull:true,
				options : {
					2: "乡镇政府",
                    3: "商贸流通企业"
				},
				className:"middle-width",
                tag:"基本信息"
            },
            property:{
                type:"text",
                label:"建设性质",
				className:"large-width",
                tag:"基本信息"
            },
            scale:{
                type:"textarea",
                label:"内容及规模",
				className:"middle-width",
                tag:"基本信息"
            },
            targetUsage:{
                type:"textarea",
                label:"补助环节",
				className:"large-width large-high",
                tag:"基本信息"
            },
            investments:{
                type:"text",
                label:"项目总金额(万元)",
                notNull:true,
				className:"middle-width",
                tag:"基本信息"
            },
            actInvestments:{
                type:"text",
                label:"实际投资金额(万元)",
                notNull:true,
				className:"middle-width",
                tag:"基本信息"
            },
            justiceName:{
                type:"text",
                label:"联合监管单位",
				className:"middle-width",
                tag:"基本信息"
            },
            investmentByShop:{
                type:"text",
                label:"申报补助金额(万元)",
                notNull:true,
				className:"middle-width",
                tag:"基本信息"
            },
            programBudget:{
                type:"text",
                label:"项目预算(万元)",
                notNull:true,
				className:"middle-width",
                tag:"基本信息"
            },
            verifiedAmount:{
                type:"text",
                label:"实际补助金额(万元)",
                notNull:true,
				className:"middle-width",
                tag:"基本信息"
            },
            checkVerifiedAmount:{
                type:"text",
                label:"验收补助金额(万元)",
                notNull:true,
				className:"middle-width",
                tag:"基本信息"
            },
            newContactPerson:{
                type:"text",
                label:"联系人",
				className:"small-width",
                tag:"基本信息"
            },
            newContactPhone:{
                type:"text",
                label:"联系电话",
				className:"small-width",
                tag:"基本信息"
            },
            content:{
                type:"richText",
                label:"项目申报指南",
				className:"large-width large-high2",
                tag:"基本信息"
            },
            rejectReson:{
                type:"text",
                label:"驳回原因",
				className:"large-width",
                tag:"基本信息"
            },
            startReviewDate:{
                type:"date",
                label:"公示开始日期",
				className:"middle-width",
                tag:"申报信息"
            },
            endReviewDate:{
                type:"date",
                label:"公示截止日期",
				className:"middle-width",
                tag:"申报信息"
            },
            countyVerify:{
                label : "是否允许区县审核",
                type : "checkbox"
            },
            result:{
                type:"textarea",
                label:"建设成效",
				className:"large-width",
                tag:"验收信息"
            },
            // 创建项目定义 ,顶部tab
            "prjApplyTags":{
                type:"tags",
                tags:["基本信息","申报信息","验收信息"]
            },
            "prjApplyContents":{
                type:"table",
                contents:[[{
                    label:"项目名称",
                    type:"text",
                    field:"prjName"
                }],[{
                    label:"项目申报开始日期",
                    type:"date",
                    field:"startDate"
                }, {
                    label:"项目申报截止日期",
                    type:"date",
                    field:"endDate"
                }],[{
                    label:"项目金额",
                    type:"text",
                    field:"prjAmount"
                }],[{
                    label:"联合监管单位",
                    type:"options",
                    options:{
                        0:"重庆市政府",
                        1:"重庆市法院"
                    }
                },{
                    label:"业主类型",
                    type:"options",
                    options:{
                        0:"1",
                        1:"2"
                    }
                }]]
            },
            "prjApplySaveBtn":{
                type:"action",
                label:"确定",
                action:"save"
            },
            "prjApplyCancleBtn":{
                type:"action",
                label:"取消",
                action:"cancle"
            },
            
            
            
			//申请信息定义
			"applyInfosDef" : {
				type : "objects",
				label:"申请信息",
				labelField : "userName",
				rightTextField : "password",
				canEdit : true,
				canDelete : true,
				canAdd : true,
				fields : {
					layout : [{
						field : "title",
						type : "text",
						label : "名称",
                        placeHolder:"填写申请信息名称",
                        className:"large-width"
					}, {
						field : "enums",
						type : "text",
						placeHolder : "枚举值，用逗号分隔",
						label : "枚举值",
                        className:"large-width"
					}, {
						field : "tp",
						type : "options",
						label : "字段类型",
						options : {
							"10": "字符串",
							"20": "数字",
							"30": "枚举值"
						}
					},{
						field : "isStatistics",
						type : "checkbox",
						label : "是否统计"
					}]
				},
                tag:"申报信息"
			},
            "testobjEdti" : {
				type : "objects",
				label:"申请信息",
				labelField : "userName",
				rightTextField : "password",
				canEdit : true,
				canDelete : true,
				canAdd : true,
				fields : {
					dataProvider: "cq/bo/projectV2",
                    layout : [{
						field : "title",
						type : "text",
						label : "名称",
                        placeHolder:"填写申请信息名称",
                        className:"large-width"
					}, {
						field : "enums",
						type : "text",
						placeHolder : "枚举值，用逗号分隔",
						label : "枚举值",
                        className:"large-width"
					}, {
						field : "tp",
						type : "options",
						label : "字段类型",
						options : {
							"10": "字符串",
							"20": "数字",
							"30": "枚举值"
						}
					},{
						field : "isStatistics",
						type : "checkbox",
						label : "是否统计"
					}],
                    fieldChangeMethod:"testChange"
				},
                tag:"申报信息"
            },
			"applyInfos":{
				type:"object",
				label:"申请材料",
				fields : {
					layout : [{
						field : "userName",
						type : "tel",
						placeHolder : "请填写手机号",
						label : "账号"
					}]
				},
                tag:"申报信息"
			},
            "applyFiles":{
                type : "object",
				canEdit : true,
				label:"上传申请附件",
                fields:{
                    layout:[]
                },
                tag:"申报信息"
            },
			"applyFilesDef":{
				type:"objects",
				label:"项目材料模板",
				canEdit : true,
				canDelete : true,
				canAdd : true,
				fields : {
					layout : [{
						field : "title",
						type : "text",
                        className : "large-width",
						label : "申报材料名称"
					}, {
						field : "blankFile",
						type : "file",
						label : "空白文件"
					}, {
						field : "exampleFile",
						type : "file",
						label : "示例文件"
					}]
				},
                tag:"申报信息"
			},
            selfApplyFiles:{
                type:"attachs",
                label:"添加附件",
                tag:"申报信息"
            },
			//验收信息定义
			"checkInfosDef" : {
				type : "objects",
				label:"验收信息",
				labelField : "userName",
				rightTextField : "password",
				canEdit : true,
				canDelete : true,
				canAdd : true,
				fields : {
					layout : [{
						field : "title",
						type : "text",
						label : "名称",
                        placeHolder:"填写验收信息名称",
                        className:"large-width"
					}, {
						field : "enums",
						type : "text",
						placeHolder : "枚举值，用逗号分隔",
						label : "枚举值",
                        className:"large-width"
					}, {
						field : "tp",
						type : "options",
						label : "字段类型",
						options : {
							"10": "字符串",
							"20": "数字",
							"30": "枚举值"
						}
					},  {
						field : "isStatistics",
						type : "checkbox",
						label : "是否统计"
					}]
				},
                tag:"验收信息"
			},
			"checkInfos":{
				type:"object",
				label:"验收材料",
				fields : {
					layout : [{
						field : "userName",
						type : "tel",
						placeHolder : "请填写手机号",
						label : "账号"
					}]
				},
                tag:"验收信息"
			},
            "checkFiles":{
                type : "object",
				canEdit : true,
				label:"上传验收附件",
                fields:{
                    layout:[]
                },
                tag:"验收信息"
            },
            selfCheckFiles:{
                type:"attachs",
                label:"添加附件",
                tag:"验收信息"
            },
			"checkFilesDef":{
				type:"objects",
				label:"项目材料模板",
				canEdit : true,
				canDelete : true,
				canAdd : true,
				fields : {
					layout : [{
						field : "title",
						type : "text",
                        className : "large-width",
						label : "验收材料名称"
					}, {
						field : "blankFile",
						type : "file",
						label : "空白文件"
					}, {
						field : "exampleFile",
						type : "file",
						label : "示例文件"
					}]
				},
                tag:"验收信息"
			},
			
			
			
			
			//项目定义的操作按钮
			saveButton:{
				type:"button",
				action:"onSave",
				label:"保存"
			},
			verifyButton:{
				type:"button",
				action:"onVerify",
				label:"通过"
			},
			
			
			//项目申请的操作按钮
			saveApplyButton:{
				type:"button",
				action:"onSaveApply",
				label:"保存"
			},
			//提交申请或提交验收材料
			submitApplyButton:{
				type:"button",
				action:"onSubmit",
				label:"提交"
			},
			//拒绝
			refuseApplyButton:{
				type:"button",
				action:"onRefuse",
				label:"拒绝"
			},
			//驳回
			rejectApplyButton:{
				type:"button",
				action:"onReject",
				label:"驳回"
			},
			//同意
			agreeApplyButton:{
				type:"button",
				action:"onAgree",
				label:"通过"
			},
            
            
			
			//列表按钮
            listActions:{
				type:"text",
				label:"操作",
				formatter:function(action,data){
                    var nowDate = new Date();
                    if(data.startDate){
                        var starD = new Date(data.startDate);
                    }
					var v = "<div class='button' onclick='window.moveToView(\"prjDefEdt\",\""+data._id+"\");'>详情</div>";
                    if(data.state==4){
                        v += "<div class='button' cq-action='delete'>删除</div>";
                    }else if(starD&&nowDate>starD){
                        if(data.state==1){
                            v += "<div class='button' cq-action='viewApply'>查看申报</div>";
                        }else{
                            v += "<div class='button' cq-action='verify'>审核</div><div class='button' cq-action='reject'>作废</div>";
                        }
                    }else {
                        if(data.state==1){
                            v += "<div class='button' cq-action='unVerify'>撤销审核</div><div class='button' cq-action='reject'>作废</div>";
                        }else {
                            v += "<div class='button' cq-action='verify'>审核</div><div class='button' cq-action='reject'>作废</div>";
                        }
                    }
						
					return v;
				},
				className:"large-width"
            },
            //列表按钮
            homeListActions:{
				type:"text",
				label:"操作",
				formatter:function(action,data){
					var v = "";
                    var nowDate = new Date();
                    if(data.startDate){
                        var starD = new Date(data.startDate);
                    }
                    if(starD&&starD>nowDate){
                        v = "<div class='button' cq-action='verify'>审核</div><div class='button' cq-action='reject'>作废</div>";
                    }else {
                        v = "<div class='button' onclick='window.moveToView(\"prjDefEdt\",\""+data._id+"\");'>编辑</div><div class='button' cq-action='reject'>作废</div>";
                    }
					return v;
				},
				className:"middle-width"
            },
			//审核项目申报的操作集
            checkListActions:{
				type:"text",
				label:"操作",
				formatter:function(action,data){
					var v = 
						//"<div class='button' cq-action='delete'>删除</div>"+
						(data.state==0?"<div class='button' cq-action='verify'>通过</div><div class='button' cq-action='refuse'>拒绝</div><div class='button none' cq-action='reject'>驳回</div>":"")+
						(data.state==11?"<div class='button' cq-action='verify2'>通过验收</div><div class='button' cq-action='refuse2'>拒绝验收</div><div class='button' cq-action='reject2'>驳回验收</div>":"")+
						//(data.state==1?"<div class='button' cq-action='reject'>驳回</div>":"")+
						"<div class='button' onclick='window.moveToView(\"prjCheckDtl\",\""+data._id+"\");'>详情</div>";
					return v;
				},
				className:"small-width"
            },
            applyPrjListAction:{
                type:"text",
                label:"",
                formatter:function(action,data){
					var v = 
						"<div class='button' onclick='window.moveToView(\"prjCheckDtl\",\"prj_"+data._id+"\");'>详情</div>";
					return v;
                },
				className:"large-width"
            }
        },
		
        //项目管理列表界面相关接口
        //列表数据地址
		_load:function(){
            if(user.getCurrentUserRole()!==1){
                return project.getLoadProjectUrlV2()+"&isUse=true&prjMakerId="+user.getCurrentUserId();
            }else{
                return project.getLoadProjectUrlV2()+"&isUse=true";
            }
		},
        load:function(){
            return this._load()+"&typeId=1";
        },
        loadBuild:function(){
            return this._load()+"&typeId=2";
		},
        loadNoState:function(){
            return this._load()+"&state=0";
        },
        //查询条件
		getQueryParam:function(params){
			var query = {isUse:true};
			if(params.cqViewParam&& params.cqViewParam.params) query.srcProjectId = params.cqViewParam.params;
            if(params.search){
                query.pName = params.search;
            }
			if(params.state){
                query.state = params.state._id;
			}
            if(params.search){
                query.title = params.search;
            }
            
            return query;
        },
        getPrjQueryParam:function(params){
			var query = {isUse:true};
			if(params.cqViewParam&& params.cqViewParam.params){
                var projectId =params.cqViewParam.params.replace('prj_','');
                query.srcProjectId = projectId;
            } 
			if(params.state){
                this.prjQueryState = params.state._id;
                if(params.state._id != "all"){
                    query.state = params.state._id;
                }
			}else{
                this.prjQueryState = "";
            }
            if(params.search){
                query.title = params.search;
            }
            return query;
        },
        //列表结构
        getGridLayout: function() {
            if(!this.projectGridLayout){
                this.projectGridLayout = this.getFormItems(["title","investments","applierType","justiceName","startDate","endDate","listActions"],false);
            }
            return this.projectGridLayout;
        },
        getSaleStatisticExportLayout : function(){
            return this.getFormItems(["title","investments","applierType","justiceName","startDate","endDate"]);
        },
        //首页列表
        getHomeGridLayout: function() {
            if(!this.projectHomeGridLayout){
                this.projectHomeGridLayout = this.getFormItems(["title","investments","applierType","justiceName","startDate","endDate","homeListActions"],false);
            }
            return this.projectHomeGridLayout;
        },
        //列表操作
		onListAction:function(data,action,list){
			if(action == "delete"){
				if(!confirm("确定删除吗？")) return;
				project.saveProject({_id:data._id,isUse:false}).then(function(){list.removeItemByData(data);});
			}
			if(action == "verify"){
				data.state=1;
				project.verifyById(data._id).then(function(){
                    list.refreshItemByData(data);
                });
			}
			if(action == "unVerify"){
				data.state=0;
				project.cancelById(data._id).then(function(){list.refreshItemByData(data);});
			}
			if(action == "reject"){
				data.state=4;
				project.stopById(data._id).then(function(){list.refreshItemByData(data);});
			}
			if(action == "viewApply"){
				window.moveToView("prjApplyGrid",'prj_'+data._id);
			}
		},
        
        
        
        //项目管理编辑界面相关接口
        //界面结构
        getEditLayout: function() {
            if(!this.editLayout){
                this.editLayout = [{
                    dojoType:"cq/app/widget/web/Steps",
                    field:"steps",
                    formClass:"table-clas",
                    steps:{
                        stepsTags:[{
                            type:"action",
                            label:"基本信息"
                        },{
                            type:"action", 
                            label:"项目申报材料"
                        },{
                            type:"action", 
                            label:"项目验收材料"
                        }],
                        stepsFields:[{
                            fields:this.getFormItems([
                                "title","typeId","startDate","applierType","endDate","justiceName","countyVerify","investments","content"
                            ]),
                            type:"tagFields"
                        },{
                            fields:this.getFormItems(["applyInfosDef",'applyFilesDef']),
                            className:"objedit",
                            type:"tagFields"
                        },{
                            fields:this.getFormItems(['checkInfosDef','checkFilesDef']),
                            className:"objedit",
                            type:"tagFields"
                        }],
                        stepsBtns:this.getFormItems(['saveButton'])
                    }
                }];
            }
            return this.editLayout;
        },
        // 数据结构测试页面布局
        testLayout:function() {
            if(!this.testELayout){
                this.testELayout = [{
                    type:"form",  
                    fields:this.getFormItems(["testobjEdti",'applyFilesDef']),
                    
                }];
            }
            return this.testELayout;
        },
        
        testChange:function(data,dataLayout,a){
            //alert(data);
            //dataLayout.getElementByField("title").setCanEdit(false);
            console.log(dataLayout.domNode);
        },
        testObjs:function(){
            return layout =[{
                fields:[{
                    field : "title",
                    type : "text",
                    label : "名称",
                    placeHolder:"填写申请信息名称",
                    className:"large-width"
                }, {
                    field : "enums",
                    type : "text",
                    placeHolder : "枚举值，用逗号分隔",
                    label : "枚举值",
                    className:"large-width"
                }, {
                    field : "tp",
                    type : "options",
                    label : "字段类型",
                    options : {
                        "10": "字符串",
                        "20": "数字",
                        "30": "枚举值"
                    }
                },{
                    field : "isStatistics",
                    type : "checkbox",
                    label : "是否统计"
                }],
                type:"form"
            }]
            
        },
        //数据重新加载之后刷新界面显示
        onDataReloaded : function(widget){
			var data = widget.getData();
			if(data.state!=0){
				widget.hideByFields(["saveButton"]);
                widget.disableByFields();
			}
			else{
				widget.showByFields(["saveButton"]);
                widget.enableByFields();
			}
		},
        //加载项目详细信息
		loadById:function(param){
			if(!param || !param.cqViewParam || !param.cqViewParam.params){
                return project.defTest({isUse:true,state:0});
            }
			return project.loadByIdV2(param.cqViewParam.params).then(lang.hitch(this,function(data){
				return data.data.item;
			}));
		},
        
        
        //项目审核方申请列表相关接口
        _loadApply:function(){
            if(user.getCurrentUserRole()!==1){
                return project.getLoadApplyUrlV2()+"&prjMakerId="+user.getCurrentUserId();
            }else{
                return project.getLoadApplyUrlV2()
            }
        },
		getLoadApplyUrl:function(){
            var prjState = null;
            if(user.getCurrentUserRole()!==1){
                if(this.prjQueryState){
                    return project.getLoadApplyUrlV2()+"&prjMakerId="+user.getCurrentUserId();
                }else{
                    prjState = JSON.stringify([10,30,40]);
                    return project.getLoadApplyUrlV2()+"&prjMakerId="+user.getCurrentUserId()+"&state="+prjState;
                }
            }else {
                if(this.prjQueryState){
                    return project.getLoadApplyUrlV2();
                }else{
                    prjState = JSON.stringify([10,40]);
                    return project.getLoadApplyUrlV2()+"&state="+prjState;
                }
            }
		},
        getLoadCheckUrl:function(){
            var prjState = null;
            if(user.getCurrentUserRole()!==1){
                if(this.prjQueryState){
                    return project.getLoadApplyUrlV2()+"&prjMakerId="+user.getCurrentUserId();
                }else{
                    prjState = JSON.stringify([50,60,70,80]);
                    return project.getLoadApplyUrlV2()+"&prjMakerId="+user.getCurrentUserId()+"&state="+prjState;
                }
            }else {
                if(this.prjQueryState){
                    return project.getLoadApplyUrlV2();
                }else{
                    prjState = JSON.stringify([50,60,80]);
                    return project.getLoadApplyUrlV2()+"&state="+prjState;
                }
            }
        },
        //项目审核方项目驳回
        getLoadApplyRejectUrl: function(){
            if(user.getCurrentUserRole()!==1){
                if(this.prjQueryState){
                    return project.getLoadApplyUrlV2()+"&prjMakerId="+user.getCurrentUserId();
                }else{
                    return project.getLoadApplyUrlV2()+"&state=30&prjMakerId="+user.getCurrentUserId();
                }
            }else {
                if(this.prjQueryState){
                    return project.getLoadApplyUrlV2();
                }else{
                    return project.getLoadApplyUrlV2()+"&state=30";
                }
            }
        },
        getLoadCheckRejectUrl: function(){
            if(user.getCurrentUserRole()!==1){
                if(this.prjQueryState){
                    return project.getLoadApplyUrlV2()+"&prjMakerId="+user.getCurrentUserId();
                }else{
                    return project.getLoadApplyUrlV2()+"&state=70&prjMakerId="+user.getCurrentUserId();
                }
            }else{
                if(this.prjQueryState){
                    return project.getLoadApplyUrlV2();
                }else{
                    return project.getLoadApplyUrlV2()+"&state=70";
                }
            }
        },
        getLoadAllPrjUrl:function(){
            if(user.getCurrentUserRole()!==1){
                return project.getLoadApplyUrlV2()+"&prjMakerId="+user.getCurrentUserId();
            }else {
                return project.getLoadApplyUrlV2();
            }
        },
        getPrjLogUrl:function(){
            return projectLog.getLoadUrl();
        },
        //查询条件与项目列表共用
        getApplyCheckGridLayout: function() {
            if(!this.projectApplyGridLayout){
                this.projectApplyGridLayout = this.getFormItems(["title","fromShopName","countyShopName","state","programBudget","investmentByShop","createAt","checkListActions"],false);
            }
            return this.projectApplyGridLayout;
        },
        prjApplyGridExportLayout : function(){
            return this.getFormItems(["title","fromShopName","countyShopName","state","programBudget","investmentByShop","createAt"]);
        },
        //首页待办事项的列表
        getHomeApplyCheckGridLayout: function(){
            if(!this.projectHomeApplyGridLayout){
                this.projectHomeApplyGridLayout = this.getFormItems(["title","fromShopName","countyShopName","state","programBudget","investmentByShop","createAt"],false);
            }
            return this.projectHomeApplyGridLayout;
        },
        //审核方项目进度表
        getProgressGridLayout:function(){
            if(!this.getProgGridLayout){
                this.getProgGridLayout = this.getFormItems(["title","fromShopName","countyShopName","state","programBudget","investmentByShop","submitAt","checkListActions"],false);
            }
            return this.getProgGridLayout;
        },
        //企业，乡镇可申报项目列表
        getPrjListGridLayout:function(){
            if(!this.prjListGridLayout){
                this.prjListGridLayout = this.getFormItems(["title","investments","startDate","endDate"],false);
            }
            return this.prjListGridLayout;
        },
        //企业，乡镇项目进度
        getSecendProgressLayout:function(){
            if(!this.getSecProgressLayout){
                this.getSecProgressLayout = this.getFormItems(["title","state","investmentByShop","verifiedAmount","submitAt"],false);
            }
            return this.getSecProgressLayout;
        },
        //列表中点击之后的响应，这个方法时错的
		onCheckListAction:function(data,action,list){
            if(!action){
                window.moveToView("prjCheckDtl",data._id);
            }
			if(action == "verify"){
				window.moveToView("prjCheckDtl",data._id);
				return;
				if(!confirm("通过该申请吗？")) return;
				data.state=1;
				project.verifyApplyById(data._id).then(function(){list.refreshItemByData(data);});
			}
			if(action == "refuse"){
				if(!confirm("拒绝该申请吗？")) return;
				data.state=4;
				project.refuseApplyById(data._id).then(function(){list.refreshItemByData(data);});
			}
			if(action == "reject"){
				var reason = prompt("请输入驳回理由");
				if(!reason) return;
				data.state=2;
				project.rejectApplyById(data._id,reason).then(function(){list.refreshItemByData(data);});
			}
			if(action == "verify2"){
				if(!confirm("通过该申请吗？")) return;
				data.state=15;
				project.examinePass(data._id).then(function(){list.refreshItemByData(data);});
			}
			if(action == "refuse2"){
				if(!confirm("拒绝该申请吗？")) return;
				data.state=14;
				project.examineNopass(data._id).then(function(){list.refreshItemByData(data);});
			}
			if(action == "reject2"){
				if(!confirm("驳回该申请吗？")) return;
				data.state=13;
				project.examineReject(data._id).then(function(){list.refreshItemByData(data);});
			}
		},
        onHomeListAction:function(data,action,list){
            if(!action){
                window.moveToView("prjCheckDtl","prj_"+data._id);
            }
        },
        onPrjCheckListAction:function(data,action,list){
            if(!action){
                window.moveToView("prjCheckDtl",data._id);
            }
        },
        
        
        
        
        
        
        //列表数据地址，服务商处已审核的项目
        getLoadApplyPrjUrl:function(){
            return project.getLoadProjectUrlV2()+"&state=1&typeId=1";
        },
        getLoadApplyPrjBuildUrl:function(){
            return project.getLoadProjectUrlV2()+"&state=1&typeId=2";
        },
        //项目申请方项目列表相关接口
        getLoadApplierPrjUrl:function(){
            return project.getLoadProjectUrlV2()+"&state=1&typeId=1&applierType="+this.shopData.shopLevel+"&nowDate="+(new Date());
        },
        getLoadApplierPrjBuildUrl:function(){
            return project.getLoadProjectUrlV2()+"&state=1&typeId=2&applierType="+this.shopData.shopLevel+"&nowDate="+(new Date());
        },
        //查询条件与项目列表共用
        //申请方查看的项目列表结构
        getApplyPrjGridLayout: function() {
            if(!this.applyPrjGridLayout){
                this.applyPrjGridLayout = this.getFormItems(["title","investments","applierType","justiceName","startDate","endDate","applyPrjListAction"],false);
            }
            return this.applyPrjGridLayout;
        },
        //列表点击之后最多只有view切换，无需响应函数
        
        
        
        //可申报项目列表
        getLoadCanApplyPrjUrl: function(){
            if(this.shopData){
                return project.getLoadProjectUrlV2()+"&state=1&applierType="+this.shopData.shopLevel+"&nowDate="+(new Date());
            }
            shop.loadInfoFromSevice().then(lang.hitch(this,function(data){
                data = data&&data.data&&data.data.item;
                this.shopData = data;
                if(data){
                    return project.getLoadProjectUrlV2()+"&state=1&applierType="+data.shopLevel;
                }
            }));
        },
        //申请方项目进度
        getLoadMyPrjUrl:function(){
            return project.getLoadApplyUrlV2()+"&fromShopId="+project.getShopId()+"&targetShopId="+config.serviceShopId;
        },
        //项目申请方申请列表相关接口
		getLoadMyApplyUrl:function(){
            if(this.prjQueryState){
                return project.getLoadApplyUrlV2()+"&fromShopId="+project.getShopId()+"&targetShopId="+config.serviceShopId;
            }else{
                var prjState = JSON.stringify([10,40]);
                return project.getLoadApplyUrlV2()+"&fromShopId="+project.getShopId()+"&targetShopId="+config.serviceShopId+"&state="+prjState;
            }
		},
        getLoadMyCheckUrl:function(){
            if(this.prjQueryState){
                return project.getLoadApplyUrlV2()+"&fromShopId="+project.getShopId()+"&targetShopId="+config.serviceShopId;
            }else{
                var prjState = JSON.stringify([50,60,80]);
                return project.getLoadApplyUrlV2()+"&fromShopId="+project.getShopId()+"&targetShopId="+config.serviceShopId+"&state="+prjState;
            }
        },
        //项目申请方项目驳回
        getLoadMyApplyRejectUrl: function(){
            if(this.prjQueryState){
                return project.getLoadApplyUrlV2()+"&fromShopId="+project.getShopId()+"&targetShopId="+config.serviceShopId;
            }else{
                return project.getLoadApplyUrlV2()+"&fromShopId="+project.getShopId()+"&targetShopId="+config.serviceShopId+"&state=30";
            }
        },
        getLoadMyCheckRejectUrl: function(){
            if(this.prjQueryState){
                return project.getLoadApplyUrlV2()+"&fromShopId="+project.getShopId()+"&targetShopId="+config.serviceShopId;
            }else{
                return project.getLoadApplyUrlV2()+"&fromShopId="+project.getShopId()+"&targetShopId="+config.serviceShopId+"&state=70";
            }
        },
        
        getMyApplyGridLayout:function(){
            if(!this.projectMyApplyGridLayout){
                this.projectMyApplyGridLayout = this.getFormItems(["title","fromShopName","countyShopName","state","programBudget","investmentByShop","createAt","applyPrjListAction"],false);
            }
            return this.projectMyApplyGridLayout;
        },
        
        
		loadCheckById:function(param){
			if(!param || !param.cqViewParam || !param.cqViewParam.params){
                return project.defTest({isUse:true,state:0});
            }
			return project.loadApplyById(param.cqViewParam.params).then(lang.hitch(this,function(data){
                return data.data.item;
			}));
		},
		getToApplyQueryParam:function(params){
			var query = {isUse:true,state:1};
            if(params.search){
                query.title = params.search;
            }
            return query;
        },
		getToApplyItemProp:function(data){
			return {
                label:
					"<div>项目名称："+data.title+"</div>"+
					"<div>申报日期从："+date.formatISODate(data.startDate)+"到"+date.formatISODate(data.endDate)+"</div>"
					//"<div>联系方式："+data.newContactPerson+"/"+data.newContactPhone+"</div>"
                ,
                variableHeight:true,
                data:data
            };
		},
		onToApplyDetail:function(data){
			window.moveToView("prjDtl",data._id);
		},
        // 创建项目
        getPrjApplyLayout:function(){
            if(!this.prjApplyLayout){
                this.prjApplyLayout = [{
                    type:"steps",
                    fields:this.getFormItems(["prjApplyTags", "prjApplyContents", "prjApplySaveBtn", "prjApplyCancleBtn"])
                }];
            }
            return this.prjApplyLayout;
        },
		//同意审核时的批复内容
        getVerifyLayout: function() {
            if(!this.verifyLayout){
                this.verifyLayout = [{
                    type: "form",
                    fields: this.getFormItems(["fromShopId","title","createAt","verifiedAmount","scale","targetUsage","verifyButton"])
                }];
            }
            return this.verifyLayout;
        },
		onPrjCheckLoaded:function(widget){
			var data = widget.getData();
			widget.disableByFields(["fromShopId","title","createAt","state","verifiedAmount","scale","targetUsage","actInvestments","result"]);
			widget.hideByFields(["verifyButton"]);
			if(data.state==0){
				widget.enableByFields(["verifiedAmount","scale","targetUsage"]);
				widget.showByFields(["verifyButton"]);
			}
			var n = widget.domNode.firstChild.lastChild;
			if(!n || !domClass.contains(n,"execution")){
				n = domConstruct.create("div", {
					className: "execution"
				}, widget.domNode.firstChild);
			}
			var s = "";
			for(var i=0;data.execution&&i<data.execution.length;i++){
				if(i==0) s+="<label class='cq-form-label'>项目执行记录</label>"
				s+="<div>"+data.execution[i].title+"<div style='float:right'>"+date.formatISODate(data.execution[i].createAt)+"</div></div>";
				s+="<div style='margin-bottom:5px;'>";
				for(var j=0;j<data.execution[i].images.length;j++){
					s+="<img src='"+data.execution[i].images[j]+"' style='margin-right:5px;width:64px;height:64px;cursor:pointer;display:inline-block;' onclick='cq.widgets.bigImg.show(\""+data.execution[i].images[j]+"\")'/>"
				}
				s+="</div>";
			}
			n.innerHTML = s;
		},
        getApplyEditLayout: function() {
            if(!this.editLayout){
                this.editLayout = [{
                    type: "form",
                    fields: this.getFormItems(["fromShopId","title","createAt","state","verifiedAmount","scale","targetUsage","actInvestments","result","verifyButton"])
                }];
            }
            return this.editLayout;
        },
        validSaveMsg:function(data){
            var notNullFields = ["typeId","title","applierType","startDate","endDate","justiceName","investments","content"];
            for(var i=0;i<notNullFields.length;i++){
                if(!data[notNullFields[i]]){
                    return this.fields[notNullFields[i]].label+"必须填写";
                }
            }
        },
		onSave:function(data,dataList){
			//数据合法性检查
            var msg = this.validSaveMsg(data);
            data.prjMakerId = user.getCurrentUserId();
            if(msg){
                alert(msg);
                return;
            }
			window.busy();
			project.saveProjectV2(data).then(function(data){
                window.free();
                if(data.data.ok==1){
                    alert('项目创建成功');
                    history.back();
                }else{
                    alert(data.data.msg);
                    window.free();
                    return;
                }
            });
		},
        prjApplyList : function () {
            window.moveToView("prjApplyList");
        },
		
		
        
        
        
        
        
        
        
        
        
        
        
        
		//项目申请/提交/审核详情界面相关接口
		//获取项目申请界面详情
		getApplyLayout:function(){
            return [{
                dojoType:"cq/app/widget/web/Steps",
                field:"steps",
                formClass:"table-clas",
                steps:{
                    stepsTags:[{
                        type:"action",
                        label:"基本信息"
                    },{
                        type:"action", 
                        label:"申报信息"
                    },{
                        type:"action", 
                        label:"验收信息"
                    }],
                    stepsFields:[{
                        fields:this.getFormItems([
                            //申请相关定义
                            "title","typeId",/*"term",*/"startDate","justiceName","countyVerify","endDate",
                            //验收相关
                            "startReviewDate","endReviewDate",
                            //投入相关定义
                            "investments","investmentByShop","programBudget","verifiedAmount","actInvestments",
                            "checkVerifiedAmount",
                            //项目申报指南
                            "content",
                            //驳回信息
                            "rejectReson"],false),
                        type:"tagFields"
                    },{
                        fields:this.getFormItems(["applyInfos",'applyFilesDef',"applyFiles","selfApplyFiles"]),
                        className:"objedit",
                        type:"tagFields"
                    },{
                        fields:this.getFormItems(["checkInfos",'checkFilesDef',"checkFiles","selfCheckFiles"]),
                        className:"objedit",
                        type:"tagFields"
                    }],
                    stepsBtns:this.getFormItems(["saveApplyButton","submitApplyButton","refuseApplyButton","rejectApplyButton","agreeApplyButton"])
                }
            }];
		},
		//依据界面参数从数据库中加载数据
        _loadApplyData:function(param){
			if(param&&param.cqViewParam&&param.cqViewParam.params){
				var applyId = param.cqViewParam.params;
				if(0===applyId.indexOf("prj_")){
					var def = new Deferred(),projectId = applyId.replace("prj_","");
					project.loadMyApplyByProjectId(projectId).then(function(data){
						if(data&&data.data&&data.data.item){
							def.resolve(data.data.item);
						}else{
							project.loadProjectByIdV2(projectId,config.serviceShopId).then(function(data){
								if(data&&data.data&&data.data.item){
									//依据项目信息生成项目审核信息
									var item = data.data.item;
									def.resolve({
										projectType:2,
										//state:10,
										isUse:true,
										srcProjectId:projectId,
										fromShopId:project.getShopId(),
										targetShopId:item.fromShopId&&item.fromShopId._id||item.fromShopId,
										applyFiles:[],
										checkFiles:[],
										title:item.title,
										startDate:item.startDate,
										endDate:item.endDate,
										content:item.content,
										typeId:item.typeId,
										applierType:item.applierType,
										property:item.property,
										scale:item.scale,
										targetUsage:item.targetUsage,
										term:item.term,
										investments:item.investments,
										newContactPerson:item.newContactPerson,
										newContactPhone:item.newContactPhone,
										countyVerify:item.countyVerify,
										applyInfos:item.applyInfosDef,
										applyFilesDef:item.applyFilesDef,
										justiceName:item.justiceName,
										checkInfos:item.checkInfosDef,
										checkFilesDef:item.checkFilesDef
									});
								}else{
									def.resolve({});
									alert("参数错误");
								}
							});
						}
					});
					return def;
				}else{
					return project.loadApplyByIdV2(applyId).then(function(data){
						if(data&&data.data&&data.data.item){
							var item = data.data.item;
							return data.data.item;
						}else{
							alert("参数错误");
							//history.back();
							return {};
						}
					});
				}
			}else{
				alert("参数错误");
				//history.back();
                return {};
			}
		},
		//依据参数加载数据并加工成界面呈现需要的形式
		loadApplyData:function(param){
            return shop.loadInfoFromSevice().then(lang.hitch(this,function(data){
                data = data&&data.data&&data.data.item;
                if(data){
                    this.shopData = data;
                    return this._loadApplyData(param).then(lang.hitch(this,function(applyData){
                        if(data._id===config.serviceShopId||data.isVerified){
                            if(data._id===config.serviceShopId||data.shopLevel===1||data.shopLevel===applyData.applierType){
                                applyData.applyInfosBak = lang.clone(applyData.applyInfos);
                                applyData.checkInfosBak = lang.clone(applyData.checkInfos);
                                applyData.applyFilesBak = applyData.applyFiles||[];
                                applyData.applyFiles = {};
                                applyData.shopMap = {};
                                var i;
                                if(applyData.verShopIds&&applyData.verShopNames){
                                    for(i=0;i<applyData.verShopIds.length;i++){
                                        applyData.shopMap[applyData.verShopIds[i]] = applyData.verShopNames[i];
                                    }
                                }
                                if(applyData.applyFilesBak.length&&applyData.applyFilesBak[0].files.length){
                                    for(i=0;i<applyData.applyFilesBak.length;i++){
                                        applyData.applyFiles[applyData.applyFilesBak[i].fromShopId] = applyData.applyFilesBak[i].files;
                                    }
                                }
                                
                                applyData.checkFilesBak = applyData.checkFiles||[];
                                applyData.checkFiles = {};
                                if(applyData.checkFilesBak.length&&applyData.checkFilesBak[0].files.length){
                                    for(i=0;i<applyData.checkFilesBak.length;i++){
                                        applyData.checkFiles[applyData.checkFilesBak[i].fromShopId] = applyData.checkFilesBak[i].files;
                                    }
                                }
                                if(data.shopLevel!==0){
                                    applyData.applyFiles[project.getShopId()] = applyData.applyFiles[project.getShopId()]||[];
                                    applyData.checkFiles[project.getShopId()] = applyData.checkFiles[project.getShopId()]||[];
                                }
                                var shopData = shop.getShopMsg();
                                applyData.shopMap[project.getShopId()] = shopData&&shopData.shopName;
                                applyData.selfApplyFiles = applyData.applyFiles[project.getShopId()];
                                delete applyData.applyFiles[project.getShopId()]
                                applyData.selfCheckFiles = applyData.checkFiles[project.getShopId()];
                                delete applyData.checkFiles[project.getShopId()]
                                return applyData;
                            }else {
                                alert("您不符合该项目所需业主类型");
                                history.back();
                            }
                        }else if(data._id!==config.serviceShopId&&!data.isVerified){
                            alert("您的单位还未认证");
                            history.back();
                        }
                    }));
                }else {
                    alert("参数错误");
                    history.back();
                }
            }));
		},
		//申请数据刷新之后的处理，数据刷新之后需要改变界面编辑结构
		onPrjApplyLoaded:function(widget){
			var data = widget.getData();
			if(data&&data.srcProjectId){
				//依据状态做数据的显示隐藏
				widget.getEditorByField("applyInfos").alterLayout(this._getInfoLayout(data.applyInfosBak));
				widget.updateByField("applyInfos",this._getInfoData(data.applyInfosBak));
				widget.getEditorByField("checkInfos").alterLayout(this._getInfoLayout(data.checkInfosBak));
				widget.updateByField("checkInfos",this._getInfoData(data.checkInfosBak));
                var fields = [],shopId;
                for(shopId in data.applyFiles){
                    fields.push({
                        field:shopId,
                        label:data.shopMap[shopId],
                        type:"attachs",
                        canEdit:shopId===project.getShopId()
                    });
                }
                widget.getEditorByField("applyFiles").alterLayout(fields);
                var checkFields = [],checkShopId;
                for(checkShopId in data.checkFiles){
                    checkFields.push({
                        field:checkShopId,
                        label:data.shopMap[checkShopId],
                        type:"attachs",
                        canEdit:checkShopId===project.getShopId()
                    });
                }
                widget.getEditorByField("checkFiles").alterLayout(checkFields);
                
				//禁止所有编辑
				widget.disableByFields();
				//隐藏所有按钮
				//widget.hideByFields(["applyInfos","applyFiles","checkInfos","checkFiles","saveApplyButton","submitApplyButton","refuseApplyButton","rejectApplyButton","agreeApplyButton"]);
                widget.hideByFields(["selfApplyFiles","selfCheckFiles","rejectReson"]);
				var nowDate = date.formatISODate(date.nowISOString());
				if(
					//申请被拒绝
					data.state===20
					//申请已结案
					||data.state===90
					//申请没有通过，且过了申请时限
					||data.state<50&&nowDate>date.formatISODate(data.endDate)
					//处于公示期中
					/* ||data.state==50&&nowDate>=date.formatISODate(data.startReviewDate)&&nowDate<=date.formatISODate(data.endReviewDate )*/
				){
					return this._showReadOnly(widget);
				}
				if(data.currentShopId&&data.verShopIds){
					shopId = project.getShopId();
					if(data.currentShopId===data.fromShopId){
                        //当前商家是申请方
						if(data.currentShopId===shopId){
                            //当前商家处理
							if(data.state===30){
								//状态为驳回申请
                                return this._showRejectApply(widget);
							}else if(data.state===50){
								//需要提交验收材料或验收材料被驳回
                                return this._showReview(widget);
							}else if(data.state===70){
                                return this._showRjectReview(widget);
                            }else{
                                //处于填写申请阶段，可以修改任何申请材料
                                return this._showApply(widget);
                            }
						}
					}else{
						//项目审核方
						var verShopIds = (data.verShopIds||[]).join(",");
						if(
							//当前商家审核申请
							data.currentShopId===shopId
							//或当前商家的下级在审核
							||verShopIds.indexOf(data.currentShopId)<verShopIds.indexOf(shopId)
						){
                            if(data.state===10||data.state===30||data.state===40){
                                //处于申请阶段
                                //审核申请时，审核方需要补充的资料
                                return this._showApplyCheck(widget,data);
                            }else if(data.state===60||data.state===70||data.state===80){
                                //处于验收阶段
                                return this._showReviewCheck(widget,data);
                            }
						}
					}
				}else{
                    //处于填写申请阶段，可以修改任何申请材料
                    return this._showApply(widget);
				}
                this._showReadOnly(widget);
			}
			//其他状态下应该字段是只读的，但是可以看
		},
		_getInfoLayout:function(infoDef){
			infoDef = infoDef||[];
			return infoDef.map(function(item){
				var f = {
					field:item.title,
					type:item.tp==30?"options":"text",
					label:item.title
				};
				if(f.type=="options"){
					f.options = {};
					enums = item.enums.split(",");
					enums.forEach(function(i){
						f.options[i] = i;
					});
				}
				return f;
			});
		},
		_getInfoData:function(infoFields){
			var d = {};
			infoFields.forEach(function(item){
				d[item.title] = item.value;
			});
			return d;
		},
		_refreshInfoByData:function(info,data){
			info.forEach(function(item){
				item.value = data[item.title];
			});
			return info;
		},
        _showReadOnly:function(widget){
            var data = widget.getData();
            if(data.state===10||data.state===30||data.state===40){
                widget.hideByFields(["startReviewDate","endReviewDate","verifiedAmount","checkVerifiedAmount","actInvestments"]);
            }
            widget.disableByFields(["selfApplyFiles","selfCheckFiles"]);
            widget.hideByFields(["countyVerify","refuseApplyButton","rejectApplyButton","agreeApplyButton","saveApplyButton","submitApplyButton"]);
            widget.showByFields(["selfApplyFiles","selfCheckFiles"]);
        },
        //显示为申请方提交申请的状态
        _showApply:function(widget){
            widget.enableByFields(["investmentByShop","programBudget","applyInfos","selfApplyFiles"]);
            widget.hideByFields(["countyVerify","refuseApplyButton","rejectApplyButton","agreeApplyButton","startReviewDate","endReviewDate","actInvestments","verifiedAmount","checkFiles","checkVerifiedAmount","rejectReson"]);
            widget.showByFields(["saveApplyButton","submitApplyButton","selfApplyFiles"]);
        },
        _showRejectApply:function(widget){
            widget.enableByFields(["investmentByShop","programBudget","applyInfos","selfApplyFiles"]);
            widget.hideByFields(["countyVerify","refuseApplyButton","rejectApplyButton","agreeApplyButton","startReviewDate","endReviewDate","actInvestments","verifiedAmount","checkFiles","checkVerifiedAmount"]);
            widget.showByFields(["saveApplyButton","submitApplyButton","selfApplyFiles","rejectReson"]);
        },
        //显示为审核方审核申请的状态
        _showApplyCheck:function(widget,data){
            if(data.countyVerify){
                widget.enableByFields(["selfApplyFiles"]);
                if(this.shopData.shopLevel === 1){
                    //区县
                    if(data.state === 40){
                        //区县通过后
                        widget.hideByFields(["rejectApplyButton","agreeApplyButton"]);
                    }else {
                        //区县未通过
                        widget.showByFields(["rejectApplyButton","agreeApplyButton","selfApplyFiles"]);
                    }
                    widget.hideByFields(["countyVerify","refuseApplyButton","startReviewDate","endReviewDate","investmentByShop","submitApplyButton"]);
                }else{
                    //商委
                    if(data.state !== 40){
                        //区县未通过
                        widget.hideByFields(["saveApplyButton","refuseApplyButton","rejectApplyButton","agreeApplyButton"]);
                    }else {
                        //区县通过后
                        widget.showByFields(["refuseApplyButton","rejectApplyButton","agreeApplyButton"]);
                        widget.enableByFields(["startReviewDate","endReviewDate","verifiedAmount"]);
                    }
                }
                widget.hideByFields(["checkFiles","submitApplyButton","actInvestments","checkVerifiedAmount"]);
            }else {
                if(this.shopData.shopLevel === 1){
                    //区县
                    widget.hideByFields(["countyVerify","refuseApplyButton","startReviewDate","endReviewDate","investmentByShop","submitApplyButton","rejectApplyButton","agreeApplyButton"]);
                }else{
                    widget.enableByFields(["startReviewDate","endReviewDate","verifiedAmount"]);
                    widget.showByFields(["refuseApplyButton","rejectApplyButton","agreeApplyButton"]);
                }
                widget.hideByFields(["checkFiles","submitApplyButton","actInvestments","checkVerifiedAmount"]);
            }
        },
        //显示为申请方提交验收材料的状态
        _showReview:function(widget){
            widget.enableByFields(["actInvestments","checkInfos","selfCheckFiles"]);
            widget.hideByFields(["countyVerify","refuseApplyButton","rejectApplyButton","agreeApplyButton","checkVerifiedAmount","rejectReson"]);
            widget.showByFields(["actInvestments","saveApplyButton","submitApplyButton","checkFiles","selfApplyFiles","selfCheckFiles"]);
        },
        _showRjectReview:function(widget){
            widget.enableByFields(["actInvestments","checkInfos","selfCheckFiles"]);
            widget.hideByFields(["countyVerify","refuseApplyButton","rejectApplyButton","agreeApplyButton","checkVerifiedAmount"]);
            widget.showByFields(["actInvestments","saveApplyButton","submitApplyButton","checkFiles","selfApplyFiles","selfCheckFiles","rejectReson"]);
        },
        //显示为审核方审核验收材料的状态
        _showReviewCheck:function(widget,data){
            if(data.countyVerify){
                if(this.shopData.shopLevel !== 1){
                    //商委
                    if(data.state !== 80){
                        //区县未通过
                        widget.hideByFields(["saveApplyButton","refuseApplyButton","rejectApplyButton","agreeApplyButton"]);
                    }else {
                        widget.enableByFields(["checkVerifiedAmount"]);
                        //区县通过后
                        widget.showByFields(["refuseApplyButton","rejectApplyButton","agreeApplyButton","checkFiles","applyFiles"]);
                    }
                }else {
                    //区县
                    if(data.state === 80){
                        //区县通过后
                        widget.hideByFields(["countyVerify","rejectApplyButton","agreeApplyButton"]);
                    }else {
                        //区县未通过
                        widget.enableByFields(["selfCheckFiles"]);
                        widget.showByFields(["rejectApplyButton","agreeApplyButton","checkFiles","applyFiles","selfCheckFiles"]);
                    }
                    widget.hideByFields(["countyVerify"]);
                }
                widget.showByFields(["checkVerifiedAmount","selfApplyFiles","selfCheckFiles"]);
                widget.hideByFields(["submitApplyButton","refuseApplyButton"]);
            }else {
                if(this.shopData.shopLevel !== 1){
                    //商委
                    widget.showByFields(["rejectApplyButton","agreeApplyButton","checkFiles","applyFiles"]);
                    widget.enableByFields(["startReviewDate","endReviewDate","checkVerifiedAmount"]);
                    widget.showByFields(["refuseApplyButton","checkVerifiedAmount","checkVerifiedAmount"]);
                }else{
                    widget.hideByFields(["countyVerify"]);
                }
                widget.hideByFields(["submitApplyButton","refuseApplyButton"]);
            }
        },
        _getFilesFromHash:function(fileHash,shopMap,verShopIds){
            verShopIds = verShopIds&&verShopIds.length>1?verShopIds:[project.getShopId()];
            var fileArr = [];
            for(var i=0;i<verShopIds.length;i++){
                if(fileHash[verShopIds[i]]){
                    fileArr.push({
                        fromShopId:verShopIds[i],
                        shopName:shopMap[verShopIds[i]],
                        files:fileHash[verShopIds[i]]
                    });
                }
            }
            return fileArr;
        },
		//按钮响应
		_onSaveApply:function(data,dataList){
			var dd = lang.clone(data);
			dd.checkInfos = this._refreshInfoByData(dd.checkInfosBak,dd.checkInfos);
			dd.applyInfos = this._refreshInfoByData(dd.applyInfosBak,dd.applyInfos);
			dd.applyFiles[project.getShopId()] = dd.selfApplyFiles;
            dd.applyFiles = this._getFilesFromHash(dd.applyFiles,dd.shopMap,dd.verShopIds);
            dd.checkFiles[project.getShopId()] = dd.selfCheckFiles;
            dd.checkFiles = this._getFilesFromHash(dd.checkFiles,dd.shopMap,dd.verShopIds);
            return project.saveApplyOnly(dd);
		},
        //保存申请/验收/申请审核补充材料/验收审核补充材料，只保存不影响状态
		onSaveApply:function(data,dataList){
			window.busy();
			this._onSaveApply(data,dataList).then(function(){
				history.back();
			});
		},
		//提交,依据状态提交申请或验收材料,将数据同步到相关商家数据库
		onSubmit:function(data,dataList){
			window.busy();
            //合法性检查
            //申请时
            if(!data.state||data.state===1||data.state===30){
                var msg = this.validApplyMsg(data);
                if(msg){
                    alert(msg);
                    window.free();
                    return;
                }
            }else if(data.state===50||data.state===70){
                //验收时
                var msg = this.validCheckMsg(data);
                if(msg){
                    alert(msg);
                    window.free();
                    return;
                }
            }
			this._onSaveApply(data,dataList).then(function(data){
				//调用后台的提交操作
				project.submitApply(data.data.item._id).then(function(){
					//返回前一个页面
					history.back();
				});
			});
		},
        validApplyMsg:function(data){
            var notNullFields = ["investmentByShop","programBudget","selfApplyFiles","applyInfos"];
            for(var i=0;i<notNullFields.length;i++){
                if(!data[notNullFields[i]]){
                    return this.fields[notNullFields[i]].label+"必须填写";
                }
                if(i===2){
                    var objTemp = this.validObjMsg(data[notNullFields[i]]);
                    if(objTemp){
                        return "申请文件必须上传";
                    }
                }
                if(i===3){
                    for(var applyInfo in data[notNullFields[i]]){
                        if(!data[notNullFields[i]][applyInfo]){
                            return applyInfo+"必须填写";
                        }
                    }
                }
            }
        },
        validObjMsg:function (data) {
            var temp;
            for (temp in data) return !1;
            return !0;
        },
        validCheckMsg:function(data){
            if(this.shopData.shopLevel !== 1){
                var notNullFields = ["actInvestments","selfCheckFiles","checkInfos"];
                for(var i=0;i<notNullFields.length;i++){
                    if(!data[notNullFields[i]]){
                        return this.fields[notNullFields[i]].label+"必须填写";
                    }
                    if(i===1){
                        var objTemp = this.validObjMsg(data[notNullFields[i]]);
                        if(objTemp){
                            return "验收文件必须上传";
                        }
                    }
                    if(i===2){
                        for(var checkInfo in data[notNullFields[i]]){
                            if(!data[notNullFields[i]][checkInfo]){
                                return checkInfo+"必须填写";
                            }
                        }
                    }
                }
            }
        },
		//拒绝,拒绝指定申请,申请流程到此终止
		onRefuse:function(data,dataList){
			window.busy();
			this._onSaveApply(data,dataList).then(function(){
				//调用后台的拒绝操作
				project.refuseApply(data._id).then(function(){
					//返回前一个页面
					history.back();
				});
			});
		},
		//驳回,驳回到指定商家重新处理
		onReject:function(data,dataList){
			window.busy();
            //选择驳回的目标商家和驳回理由
            var remark=prompt("请填写驳回的备注信息","");
            if(remark){
                data.rejectReson = remark;
                this._onSaveApply(data,dataList).then(lang.hitch(this,function(){
                    this.getRejectInfo(data,remark).then(function(rejectInfo){
                        //检查驳回信息的合法性,若不合法,给出提示
                        if(!rejectInfo){
                            return;
                        }
                        //调用后台的驳回操作
                        project.rejectApply(data._id,rejectInfo).then(function(){
                            //返回前一个页面
                            history.back();
                        });
                    });
                }));
            }else{
                alert("请填写驳回原因");
                window.free();
            }
			
		},
		getRejectInfo:function(data,remark){
			var def = new Deferred(),rejectInfo = null;
			for(var i=1;i<data.verShopIds.length;i++){
				if(data.verShopIds[i]===project.getShopId()){
					rejectInfo = {
						targetShopId:data.verShopIds[i-1],
						rejectReson:remark
					};
					break;
				}
			}
			def.resolve(rejectInfo);
			return def;
		},
		//同意,若最后一个处理者,项目结案,否则流转到下一个处理者
		onAgree:function(data,dataList){
			//参数合法性检查,若没有通过,给出提示,最后一个审核者的必填项
            //申请时
            if(data.state===40){
                var msg = this.validAgreeMsg(data);
                if(msg){
                    alert(msg);
                    return;
                }
            }else if(data.state===80){
                //验收时
                var msg = this.validAgreeCheckMsg(data);
                if(msg){
                    alert(msg);
                    return;
                }
            }
            window.busy();
				//若当前商家是最后一个审核商家
				//当前若是申请，申请审批信息必须完整
				//否则审核审批和结案信息必须完整
			this._onSaveApply(data,dataList).then(function(){
				//调用后台同意接口
				project.agreeApply(data._id).then(function(){
					//返回前一个页面
					history.back();
				});
			});
		},
        validAgreeMsg:function(data){
            if(this.shopData.shopLevel !== 1){
                var notNullFields = ["verifiedAmount"];
                for(var i=0;i<notNullFields.length;i++){
                    if(!data[notNullFields[i]]){
                        return this.fields[notNullFields[i]].label+"必须填写";
                    }
                }
            }
        },
        validAgreeCheckMsg:function(data){
            if(this.shopData.shopLevel !== 1){
                var notNullFields = ["checkVerifiedAmount"];
                for(var i=0;i<notNullFields.length;i++){
                    if(!data[notNullFields[i]]){
                        return this.fields[notNullFields[i]].label+"必须填写";
                    }
                }
            }
        },
        saleServiceLayout : function(){
            return [{
                dojoType : "cq/app/widget/web/Steps",
                field : "steps",
                formClass : "table-clas",
                steps : {
                    stepsTags : [{
                        type : "action",
                        label : "店铺管理"
                    },{
                        type : "action",
                        label : "订单客服通知"
                    }],
                    stepsFields : [{
                        fields : this.getFormItems([
                            "logo","shopName","address","brief",
                            "svcPhone","svcQQ","svcWx",
                            "contactName","contactPhone",
                            "contactQQ","contactWx","aliPaySeller","bankName","bankAccountName",
                            "bankAccountCode","payee","fiName","fiPhone",
                            "fiQQ"],true),
                        type:"tagFields"
                    },{
                        fields:this.getFormItems(["orderCheckerId",'svcId',"orderTimeout"/*,"freightTemplated","isWhiteList","manageFreight"*/]),
                        className:"objedit",
                        type:"tagFields"
                    }],
                    stepsBtns : this.getFormItems(["completeButton"])
                }
            }];
        },
        loadsaleServiceData : function(data){
            var id = data.cqViewParam.params;
            return shop.loadById(id).then(lang.hitch(this,function(data){
                return data.data;
            }));
        },
        onComplete:function(data,dataList){
			window.busy();
			shop.save(data).then(function(dat){
                //history.back();
                if(dat.data.ok===1){
                    alert("修改成功");
                }else{
                    alert("修改失败");
                }
                window.free();
            });
		},
        freightDetail : function(){
            window.moveToView("freightDetail");
        },

        //网站上需要的接口
        getPrjUrl:function(){
            
        },
        
        
        
        
        
        //获取自己可以访问的，没有作废的项目列表
        getEffectivePrjUrl:function(){
            return this._load();
        }
    });
    return projectBo;
});
