define([
    "cq/biz/ts/refundRecord",
    "cq/biz/mk/price",
    "cq/util/config/config",
    "./BoBase"
],function(refundRecord,price,config,BoBase){
    var priceBo =  new BoBase({
        fields:{
            "fromShopId.shopName" : {
                type:"text",
                label:"供货商",
                className:"middle-width"              
            },
            createAt:{
                type:"date",
                label:"申请日期",
                className:"middle-width"
            },
            "tsId._id":{
                type:"text",
                label:"订单号",
                className:"middle-width"
            },
            amount:{
                type:"text",
                label:"退款金额",
                className:"middle-width"
            },            
            isVerified:{
                type:"options",
                label:"是否审核",
				options : {
					"true" : "已审核",
                    "false" : "待审核"
				}
            },
            payLogNum:{
                type:"text",
                label:"交易流水号",
                className:"middle-width"
            },
            "tsId.payTime":{
                type:"date",
                label:"支付日期",
                className:"middle-width"
            },
            verifyDate:{
                type:"date",
                label:"退款时间",
				className:"large-width"
            },
            payType:{
                type:"options",
                label:"支付方式",
                options:config.orderPayType,
                className:"middle-width",
                canEdit:false
            },
            merchantNo:{
                type:"text",
                className:"large-width",
                label : "商户号"
            },
            bankName:{
                type:"text",
                label:"付款银行",
				className:"large-width"
            },
            bankAccountCode:{
                type:"text",
                label:"付款账号",
				className:"large-width"
            },
            bankAccountName:{
                type:"text",
                label:"付款账户名",
				className:"large-width"
            }
        },
		load:function(){
			return refundRecord.load();
		},
		loadByPlatform:function(){
			return refundRecord.loadByPlatform();
		},
        getRefundRecordLayout: function() {
            if(!this.refundRecordExport){
                //店铺认证
                this.refundRecordExport = [{
                    type: "form",
                    fields: this.getFormItems([                                       
                    "fromShopId.shopName","createAt",
                    "tsId._id",
                    "amount","payLogNum",
                    "tsId.payTime","payType",
                    "merchantNo","bankName",
                    "bankAccountCode","bankAccountName",
                    "verifyDate"
                    ])
                }];
            }
            return this.refundRecordExport;
        }
    });
    return priceBo;
});