define([
    "cq/biz/ts/refundRecord",
    "dojo/_base/lang",
    "cq/util/config/config",
    "cq/util/sys/date",
    "./BoBase"
],function(refundRecord,lang,config,date,BoBase){
    var priceBo =  new BoBase({
        fields:{
            payLogNum:{
                type:"text",
                label:"交易单号",
                className:"large-width",
                canEdit: false,
                tag:"平台退款"
            },
            payLogNum:{
                type:"text",
                label:"交易流水号",
                className:"middle-width"
            },
            tsId:{
                type:"text",
                label:"订单号",
                className:"middle-width"
            },
            "tsId._id":{
                type:"text",
                label:"订单号",
                className:"middle-width"
            },
            verifyDate : {
                type:"date",
                label:"退款日期",
                className:"middle-width"                
            },
            amount:{
                type:"text",
                label:"退款金额",
                className:"middle-width"
            },
            listAmount:{
                type:"text",
                label: "运费",
                formatter: function (action, data) {
                    var v = "<div>0</div>";
                    if(data.amount){
                        v = "<div>"+data.amount.toFixed(2)+"</div>";
                    }
                    return v;
                },
                className:"middle-width",
                canEdit: false
            },
            fromShopName:{
                type:"text",
                label:"商家名称",
                className:"middle-width",
                canEdit: false,
                tag:"平台退款"
            },
            createAtDetail:{
                type:"text",
                label:"退款日期",
                className:"middle-width"
            },
            "tsId.payTime":{
                type:"date",
                label:"支付日期",
                className:"middle-width"
            },
            payType:{
                type:"options",
                label:"支付方式",
                options:{
                    "point":"积分支付",
                    "weixin":"微信支付",
                    "wxNative":"微信网页支付",
                    "wxApp":"微信App支付",
                    "aliwap":"支付宝手机网页支付",
                    "aliweb":"支付宝网页支付",
                    "chinaPay":"银联电子支付",
                    "unionPay":"银联支付",
                    "cash":"现金",
                    "bocNB2B":"中国银行B2B",
                    "bocB2CMobile":"中国银行B2CMobile"
                },
                className:"middle-width",
                canEdit:false
            },
            "fromShopId.shopName" : {
                type:"text",
                label:"供货商",
                className:"middle-width"              
            },
            createAt:{
                type:"date",
                label:"申请日期",
                className:"middle-width"
            },
            merchantNo:{
                type:"text",
                label:"商户号",
                className:"middle-width",
                canEdit: false,
                tag:"平台退款"
            },
            bankName:{
                type:"text",
                label:"付款银行",
                className:"middle-width"
            },
            bankAccountName:{
                type:"text",
                label:"付款账户名",
                className:"middle-width"
            },
            bankAccountCode:{
                type:"text",
                label:"付款账号",
                className:"middle-width",
                canEdit: false,
                tag:"平台退款"
            },
            fromShopId:{
                type:"text",
                label:"来源商家",
                className:"middle-width",
                canEdit: false
            },
            checkButton:{
                type:"button",
                action:"checkAction",
                label:"审核"
            },
            createAtRefund : {
                type:"text",
                label: "退款日期",
                formatter: function (action, data) {
                    var v;
                    if(data.createAt){
                        v = "<div>"+date.formatISODateMinutes(data.createAt)+"</div>";
                    }
                    return v;
                },
                className:"middle-width",
                canEdit: false
            },
            listAmount:{
                type:"text",
                label: "提现金额",
                formatter: function (action, data) {
                    var v = "<div>0</div>";
                    if(data.amount){
                        v = "<div>"+data.amount.toFixed(2)+"（元）</div>";
                    }
                    return v;
                },
                className:"middle-width",
                canEdit: false
            },
            isVerified:{
                type:"options",
                label:"是否审核",
				options : {
					"true" : "已审核",
                    "false" : "待审核"
				}
            },
            operateShow:{
                type:"text",
                label:"操作按钮",
                formatter:function(action,data){
                    var buttonNode;
                    if(!data.isVerified){
                        buttonNode = "<div class='dgrid-button' cq-action='refundRecord'>审核</div><div class='dgrid-button' cq-action='refundRejectRecord'>拒绝</div>";
                    }else{
                        buttonNode = "<div class='' cq-action='refundRecord'></div>"
                    }
                    var v = "<div class='dgrid-button' onclick='window.moveToView(\"refundRecordDetail\",\""+data._id+"\");'>查看</div>"+
                    buttonNode;
                    return v;
                }
            }
        },
        //列表
        getRefundRecordUrl:function(){
            return refundRecord.loadByPlatform();
        },
        getQueryRefundRecord:function(params){
            var query = {};
            if(params.state&&params.state._id&&"1" == params.state._id){
                query.isVerified = true;
            }
            if(params.state&&params.state._id&&"0" == params.state._id){
                query.isVerified = false;
            }
            return query;
        },
        getRefundRecordLayout:function(){
            if(!this.refundRecordLayout){
                this.refundRecordLayout = this.getFormItems([
                "fromShopId.shopName",
                "createAt",
                "tsId",//"tsId._id",
                "amount",
                "payLogNum",
                "operateShow"
                ],false);
            }
            return this.refundRecordLayout;
        },
        
        loadById:function(parm){
            var id;
            if(parm.cqViewParam&&parm.cqViewParam.params){
                id = parm.cqViewParam.params;
            }
            return refundRecord.loadById(id).then(lang.hitch(this,function(backData){
                if(1 == backData.data.ok){
                    var data = backData.data.item;
                    if(data.amount){
                        data.amount = (data.amount-0).toFixed(2)+"（元）";
                    }
                    if(data.createAt){
                        data.createAtDetail= date.formatISODateMinutes(data.createAt);
                    }
                    if(data.payTime){
                        data.payTime = date.formatISODateMinutes(data.payTime);
                    }
                    return data;
                }else{
                    alert("服务器繁忙，请稍后再试");
                }
            }));
        },
        //sale3后台管理系统平台退款导出
        getRefundExportLayout:function(){
            if (!this.refundExportLayout) {
                this.refundExportLayout = this.getFormItems([
                    "fromShopId.shopName","createAt",
                    "tsId",//"tsId._id",
                    "amount","payLogNum",
                    //"tsId.payTime",
                    "payType",
                    "merchantNo","bankName",
                    "bankAccountCode","bankAccountName",
                    "verifyDate"]);
            }
            return this.refundExportLayout;
        },
        getRefundDetailLayout:function(){
            return [{
                type:"form",
                fields:this.getFormItems([
                    "fromShopId.shopName","createAt",
                    "tsId",//"tsId._id",
                    "amount","payLogNum",
                    "tsId.payTime","payType",
                    "merchantNo","bankName",
                    "bankAccountCode","bankAccountName",
                    "verifyDate"
                ],true)
            }]
        },
        refundRecordReload:function(widget){
            widget.hideByFields(["checkButton"]);
            var data = widget.getData();
            if(false == data.isVerified){
                widget.showByFields(["checkButton"]);
            }
        },
        checkAction:function(data){
            window.busy();
            refundRecord.verify(data._id).then(lang.hitch(this, function (data) {
                window.free();
                if (data.data.ok === 1) {
                    history.back();
                } else {
                    alert("服务器繁忙，请稍后再试");
                }
            }));
        },
        onListAction:function(data,action,list){
            var def = null;
            if("refundRecord" == action){
                if(!data.isVerified){
                    def = this.agreeRefund(data._id);
                }
            }else if("refundRejectRecord"==action){
                def = this.rejectRefund(data._id);
            }
            if(def&&def.then){
                return def.then(function(backData){
                    if (backData.data.ok === 1) {
                        list.refreshItemByData(backData&&backData.data&&backData.data.item||backData);
                    }else{
                        alert("服务器繁忙，请稍后再试");
                    }
                });
            }
        },
        agreeRefund:function(did){
			var isCalcelOrder = confirm("是否同意退款？");
            if (isCalcelOrder) {
                window.busy();
				return refundRecord.agree(did).then(function (data) {
					window.free();
                    return data;
				});
			}
        },
        rejectRefund:function(did){
			var reason=prompt("请输入驳回理由","");
			if (reason){
                window.busy();
				return refundRecord.disagree({
                    _id:did,
                    remark:reason
                }).then(function (data) {
					window.free();
                    return data;
				});
			}
        }
    });
    return priceBo;
});