﻿define([
    "dojo/Deferred",
    "dojo/_base/lang",
    "cq/biz/article/section",
    "./BoBase"
],function(Deferred,lang,section,BoBase){
    var sectionShopId = "",sectionDef = null,codeToId = {
    },idToSubIds = {
    },idToUpperId = {
    },idToSection = {},
    sectionData = [];
    var sectionBo =  new BoBase({
        _initSectionInfo:function(){
            codeToId = {};
            idToSubIds = {};
            idToUpperId = {};
            idToSection = {};
        },
        _buildSectionInfo:function(items){
            var upId = "",id = "",code = "";
            for(var i=0;i<items.length;i++){
                upId = items[i].upSection;
                upId = upId&&upId._id||"";
                code = items[i].sCode||"";
                id = items[i]._id;
                codeToId[code] = id;
                idToSubIds[upId] = idToSubIds[upId]||[];
                idToSubIds[upId].push(id);
                idToUpperId[id] = upId;
                idToSection[id] = items[i];
            }
        },
        getSectionById:function(id){
            return idToSection[id];
        },
        getSectionOptions:function(){
            var options = {},
                item,
                codes = ["c_zczx","c_scfx","c_njbk"],
                subIds = null,
                idIndex = 0;
            for(var i=0;i<codes.length;i++){
                subIds = this.getAllSubIdsByCode(codes[i]);
                if(subIds.length){
                    /* if(subIds.length>1){
                        options[idToSection[subIds[0]].title] = item = {};
                        for(var idIndex=1;idIndex<subIds.length;idIndex++){
							if(idToSubIds[subIds[idIndex]]&&idToSubIds[subIds[idIndex]].length){
							}else{
								item[subIds[idIndex]] = idToSection[subIds[idIndex]].title;
							}
                        }
                    }else{
                        options[subIds[0]] = idToSection[subIds[0]].title;
                    } */
                    options[subIds[0]] = idToSection[subIds[0]].title;
                }
            }
            return options;
        },
        getHasSecondOptions:function(){
            var options = {};
            for(var sectionId in idToUpperId){
                if(idToUpperId[sectionId]){
                    options[idToUpperId[sectionId]] = idToSection[idToUpperId[sectionId]].title;
                }
            }
            return options;
        },
        initSection:function(){
            if(sectionShopId!==section.getShopId()){
                sectionShopId = section.getShopId();
                this._initSectionInfo();
                sectionDef = null;
            }
            return sectionDef||(sectionDef=section.execInCurrentShop("load",{
                isUse:true,
                pageSize:1000
            }).then(lang.hitch(this,function(data){
                //这里可能需要处理死循环
                sectionData = data.data.items||[];
                this._buildSectionInfo(sectionData);
            })));
        },
        //依据顶级编码获取下级信息
        getSubSectionsByCode:function(code){
            if(codeToId[code]){
                return (idToSubIds[codeToId[code]]||[]).map(function(id){
                    return idToSection[id];
                });
            }else{
                return [];
            }
        },
        //依据code获取本身信息,在用勿删
        getSectionByCode:function(code){
            if(codeToId[code]){
                return (idToSection[codeToId[code]]);
            }else{
                return [];
            }
        },
        //依据编码获取顶级编码
        getTopCodeByCode:function(code){
            if(codeToId[code]){
                return this.getTopCodeById(codeToId[code]);
            }else{
                return "";
            }
        },
        //依据编码获取所有下级栏目id
        getAllSubIdsByCode:function(code){
            if(code&&codeToId[code]){
                var id = codeToId[code],ids = [];
                var pushId = function(id){
                    ids.push(id);
                    if(idToSubIds[id]){
                        idToSubIds[id].forEach(pushId);
                    }
                };
                pushId(id);
                return ids;
            }else{
                return [];
            }
        },
        //依据栏目id获取顶级栏目信息
        getTopCodeById:function(id){
            while(idToUpperId[id]){
                id = idToUpperId[id];
            }
            return id?idToSection[id].sCode:"";
        },
        getNMSCSectionOptions:function(){
            var region = {};
            
            region["主城九区"] = {};//"5837a1c99607be0a5653a348"
            region["渝西片区"] = {};//"5837a35c9607be0a5653a3b3"
            region["渝东北片区"] = {};//"5837a37d9607be0a5653a3b9"
            region["渝东南片区"] = {};//"5837a39d9607be0a5653a3c1"

            region["主城九区"]["5837a5c59607be0a5653a429"] = "渝中区";
            region["主城九区"]["5837a5b69607be0a5653a424"] = "渝北区";
            region["主城九区"]["5837a6359607be0a5653a43e"] = "北碚区";
            region["主城九区"]["5837a5db9607be0a5653a432"] = "巴南区";
            region["主城九区"]["5837a6209607be0a5653a439"] = "南岸区";
            region["主城九区"]["5837a62a9607be0a5653a43a"] = "江北区";
            region["主城九区"]["5837a54a9607be0a5653a40d"] = "九龙坡区";
            region["主城九区"]["5837a5779607be0a5653a416"] = "沙坪坝区";
            region["主城九区"]["5837a6089607be0a5653a437"] = "大渡口区";
            region["渝西片区"]["5837b6539607be0a5653a91b"] = "璧山区";
            region["渝西片区"]["5837b5fd9607be0a5653a914"] = "大足区";
            region["渝西片区"]["5837b5f29607be0a5653a913"] = "合川区";
            region["渝西片区"]["5837b5df9607be0a5653a90e"] = "江津区";
            region["渝西片区"]["5837b61e9607be0a5653a916"] = "南川区";
            region["渝西片区"]["5837d6d29607be0a5653afac"] = "綦江区";
            region["渝西片区"]["5837b6319607be0a5653a919"] = "荣昌区";
            region["渝西片区"]["5837b6469607be0a5653a91a"] = "铜梁区";
            region["渝西片区"]["5837b6659607be0a5653a91d"] = "潼南区";
            region["渝西片区"]["5837b5c79607be0a5653a90c"] = "永川区";
            region["渝东北片区"]["5837d57b9607be0a5653af59"] = "忠县";
            region["渝东北片区"]["5837d5119607be0a5653af4d"] = "城口县";
            region["渝东北片区"]["5837d5539607be0a5653af58"] = "垫江县";
            region["渝东北片区"]["5837d5329607be0a5653af54"] = "丰都县";
            region["渝东北片区"]["5837d5e29607be0a5653af66"] = "奉节县";
            region["渝东北片区"]["583fce300c60425a58c1f8a2"] = "涪陵县";
            region["渝东北片区"]["5837d5a09607be0a5653af5a"] = "开州区";
            region["渝东北片区"]["5837b7cf9607be0a5653a9a2"] = "梁平县";
            region["渝东北片区"]["5837d60d9607be0a5653af68"] = "巫山县";
            region["渝东北片区"]["5837d6229607be0a5653af78"] = "巫溪县";
            region["渝东北片区"]["5837b7b89607be0a5653a9a1"] = "万州区";
            region["渝东北片区"]["5837d5c79607be0a5653af5c"] = "云阳县";
            region["渝东南片区"]["5837d6e79607be0a5653afb4"] = "武隆县";
            region["渝东南片区"]["5837d6d29607be0a5653afac"] = "黔江区";
            region["渝东南片区"]["5837d7049607be0a5653afc3"] = "石柱土家族自治县";
            region["渝东南片区"]["5837d7dc9607be0a5653b002"] = "彭水苗族土家族自治县";
            region["渝东南片区"]["5837d7259607be0a5653afd3"] = "秀山土家族苗族自治区";
            region["渝东南片区"]["5837d76d9607be0a5653afe6"] = "酉阳土家族苗族自治区";

            return region;
        },
        fields:{
            title:{
                type:"text",
                label:"标题",
				className:"middle-width"
            },
            sectionType:{
                type:"options",
                label:"栏目类型",
                options : {
					1:'一级栏目',
					2:'资讯栏目',
					4:'打开网页'
				},
				className:"middle-width"
            },
            sCode:{
                type:"text",
                label:"编码",
				className:"middle-width"
            },
            upSection:{
                type: "options",
                field: "section",
                options:{},
                label: "上级栏目",
                canEdit: true,
                className: "middle-width"
            },
            "upSection.title":{
                type:"text",
                label:"上级栏目",
				className:"middle-width-width"
            },
            targetPath:{
                type:"text",
                label:"链接地址",
				className:"large-width"
            },
			saveButton:{
				type:"button",
				action:"onSave",
				label:"保存"
			},
            listActions:{
				type:"text",
				label:"",
				formatter:function(action,data){
                    //系统预定义的不能修改和删除
					var v = data.isSys?"":"<div class='button' cq-action='delete'>删除</div><div class='button' onclick='window.moveToView(\"sectionDetail\",\""+data._id+"\");'>编辑</div>";
					return v;
				}
            }
        },
		load:function(){
			return section.getSectionUrl();
		},
		loadById:function(param){
			if(!param || !param.cqViewParam || !param.cqViewParam.params) return {isUse:true};
			var def=new Deferred();
			section.loadById(param.cqViewParam.params).then(lang.hitch(this,function(data){
                if(data&&data.data&&data.data.item&&data.data.item.upSection&&data.data.item.upSection._id){
                    data.data.item.upSection = data.data.item.upSection._id;
                }
				def.resolve(data.data.item);
			}));
			return def;
		},
		getQueryParam:function(params){
            var query = {};
            if(params.queryInfo){
                var k,queryInfo = params.queryInfo,value;
                for(k in queryInfo){
                    value = queryInfo[k];
                    if(value||0===value||false===value){
                        if(value){
                            if((typeof value == "object")&& value) {
                                if(value._id){
                                    query[k] = value._id;
                                }else if(JSON.stringify(value) === "{}"){
                                    delete query[k];
                                }else{
                                    query[k] = value;
                                }
                            }
                            if(typeof value == "string" && value) {
                                query[k] = value;
                            }
                        }else{
                            query[k] = value;
                        }
                    }
                }
            }
            return query;
        },
        getQueryLayout:function(){
            return [{
                type: "form",
                fields: this.getFormItems(["title","sCode"])
            }];
        },
        getGridLayout: function() {
            if(!this.gridLayout){
                this.gridLayout = this.getFormItems(["title","sCode","upSection.title",/*"sectionType",*/"targetPath","listActions"],false);
            }
            return this.gridLayout;
        },
        getEditLayout: function() {
            if(!this.editLayout){
                this.editLayout = [{
                    type: "form",
                    formClass:"table-clas",
                    fields: this.getFormItems(["sCode","title",/*"upSection","sectionType",*/"targetPath","saveButton"])
                }];
                //this.fields.upSection.options = this.getHasSecondOptions();
            }
            return this.editLayout;
        },
        onEditSectionReloaod:function(widget){
            var data = widget.getData();
            //widget.getEditorByField("upSection").refreshOptions(this.getHasSecondOptions());
        },
		onListAction:function(data,action,list){
			if(action == "delete"){
				if(!confirm("确定删除吗？")) return;
				section.delete(data._id).then(function(){list.removeItemByData(data);});
			}
		},
		onSave:function(data,dataList){
			//
			window.busy();
            //if(!data.upSection || !data.upSection._id) delete data.upSection;
			section.save(data).then(lang.hitch(this,function(data){
                if(data&&data.data&&data.data.item){
                    var item = data.data.item;
                    if(!idToSection[item._id]){
                        sectionData.push(item);
                    }
                    if(item.upSection){
                        item.upSection = idToSection[item.upSection];
                    }
                    this._initSectionInfo();
                    this._buildSectionInfo(sectionData);
                }
                history.back();
                window.free();
            }));
		}
    });
    
    
    return sectionBo;
});
