define([
    "cq/biz/shop/shop",
    "cq/biz/ts/pm/shopPayLog",
    "cq/biz/ts/transaction",
    "cq/biz/shop/freightTemplate",
    "cq/biz/user/user",
    "dojo/_base/lang",
    "cq/util/config/config",
    "cq/util/sys/xlsx",
    "./BoBase"
],function(shop,shopPayLog,transaction,freightTemplate,user,lang,config,xlsx,BoBase){
    var banlanceBo =  new BoBase({
        fields:{
            shopName: {
                type: "text",
                label: config.shopFieldLabel&&config.shopFieldLabel.shopName||"店铺名称",
				className:"middle-width"
            },
            town : {
                type: "text",
                label: "省市区县",
				className:"middle-width"                
            },
            contactPhone : {
                type: "text",
                label: "联系电话",
				className:"middle-width"                 
            },
            saleAmount : {
                type: "text",
                label: "销售金额",
				className:"middle-width"                
            },
			purchaseAmount : {
                type: "text",
                label: "采购金额",
				className:"middle-width"                
            },
            createAt : {
                type : "date",
                label : "注册日期"                
            }, 
            exportButton:{
                type:"button",
                label:"导出明细数据",
                action:"exportData",
                className:"middle-width"
            },
             "inviter.pName" : {
                type:"text",
                label:"邀请人",
                className:"large-width"
            },
            "inviter.userName" : {
                type:"text",
                label:"邀请人手机号",
                className:"large-width",
            },
            "inviter.phone" : {
                type:"text",
                label:"邀请人手机号",
                className:"large-width",
            },
             "fromShop.shopName" : {
                type:"text",
                label:"所属店铺",
                className:"large-width",
            },
            "search" : {
                type:"text",
                label:"",
                className:"large-width",
                placeHolder:"店铺、姓名、邀请人手机号"
            }
        },
        getSaleQueryLayout : function(){
            return [{
                type: "form",
                fields: this.getFormItems(["createAt","search"])
            }];
        },
        getShopsUrl : function(){
            var windowDid = window.location.href.split("-")[1];
            if(windowDid){
                 return shop.shopsByInviterUrl()+"&inviter="+window.location.href.split("-")[1];        
            }else{
                return shop.shopsByInviterUrl();
            }
        },
        getSaleQueryParam:function(params){
            var query = {};
            if(params.queryInfo){
                var k,queryInfo = params.queryInfo,value;
                for(k in queryInfo){
                    value = queryInfo[k];
                    if(value||0===value||false===value){
                        if(value){
                            if((typeof value == "object")&& value) {
                                if(value._id){
                                    query[k] = value._id;
                                }else if(JSON.stringify(value) === "{}"){
                                    delete query[k];
                                }else{
                                    query[k] = value;
                                }
                            }
                            if(typeof value == "string" && value) {
                                query[k] = value;
                            }
                        }else{
                            query[k] = value;
                        }
                    }
                }
                if(params.queryInfo.search){
                    this.query.search = params.queryInfo.search;
                }
            }
            return query;
        },
        getSaleGridLayout: function() {
            if(!this.saleGridLayout){
                this.saleGridLayout = this.getFormItems(["shopName","saleAmount","purchaseAmount","contactPhone","town","createAt"],false);
            }
            return this.saleGridLayout;
        },
        exportButtonLayout:function(){
            return [{
                type:"form",
                fields:this.getFormItems([
                    "exportButton"
                ],true)
            }]
        },
        exportData : function(){
            //var layout = dataLayout.byId("resultList");
            //var list = layout.getCqQueryInfo();
            //var query = list.query;
            var query = {orderBy : "shopName"};
            var url = shop.getShopByPlatform();
            var cols = this.getFormItems([
                    "fromShop.shopName",
                    "inviter.pName",
                    "inviter.phone",
                    "shopName",
                    "contactPhone",
                    "town",
                    "createAt",
                    "saleAmount",
					"purchaseAmount"
                ]);               
            xlsx.exportData(url,query,cols,Date.now().toString());
        }
    });
    return banlanceBo;
});