define([
	"dojo/_base/lang",
    "dojo/dom-class",
    "dojo/dom-construct",
	"../BoBase",
	"cq/biz/ts/cart",
    "cq/biz/user/user",
    "cq/util/sys/date",
	"cq/biz/ts/order",
    "cq/util/config/config",
    "cq/util/sys/xlsx",
    "cq/util/sys/printor"
], function (lang,domClass, domConstruct, BoBase, cart, user, date, order, config, xlsx, printor) {
	var boBase = new BoBase({
		//添加字段
		fields: {
            //商品信息
            "matsInfo" : {
                type : "objects",
                label: "",
                //labelField : "id",
                canEdit : true,
                canDelete : false,
                canAdd : false,
                multipReloadMethod : "matInfoReload",
                multipDataProvider : "cq/bo/ts/order",
                fields : {
                    dataProvider:"cq/bo/ts/order",
                    fieldChangeMethod:"matInfoChange",
                    layout:[{
                        field:"mId",
                        type:"text",
                        label:"商品号",
                        className:"large-width"
                    },/*{
                        field:"tsId",
                        type:"text",
                        label:"订单号"
                    },*/{
                        field : "logo",
                        type : "image",
                        label : "商品图片",
                        className:"middle-width"
                    }, {
                        field : "mName",
                        type : "text",
                        label : "名称",
                        className:"large-width"
                    }, {
                        field : "price",
                        type : "text",
                        label : "价格",
                        className:"large-width"
                    },{
                        field : "discountAmount",
                        type : "text",
                        label : "优惠价格",
                        className:"large-width ",
                        //class :"discountAmount"//text-decoration:line-through 
                    }, {
                        field : "qty",
                        type : "text",
                        label : "数量",
                        className:"large-width"
                    },{
                        field: "newPrice",
                        type:"text",
                        label:"优惠（-表示减少）",
                        canEdit: true,
                        className:"large-width"
                    }]
                }
            },
            
            payDate:{
                type:"date",
                label:"支付日期",
                className:""
            },
			"details.0.createAt": {
				type: "text",
				label: "创建时间",
                formatter:function(action,data){
                    var v = date.formatISODateMinutes(data.createAt);
                    return v;
                }
			},
			"details.0.dName": {
				type: "text",
				label: "收货人姓名"
			},
			"details.0.dAddress": {
				type: "text",
				label: "收货人地址"
			},
			"details.0.dTel": {
				type: "text",
				label: "收货人手机"
			},
            "details.0.mId.mName": {
                type: "text",
				label: "商品名称"
            },
			"details.0.qty": {
				type: "text",
				label: "商品数量"
			},
            //交易金额（仅供详情显示）
			transAmount: {
				type: "text",
                canEdit: false,
				label: "交易金额（含运费）",
                className:"middle-width"
			},
            acceptTime: {
                type: "text",
                canEdit: false,
				label: "审核时间",
                className:"middle-width"
            },
            delivTime: {
                type: "text",
                canEdit: false,
				label: "发货时间",
                className:"middle-width"
            },
            recepiptTime: {
                type: "text",
                canEdit: false,
				label: "签收时间",
                className:"middle-width"
            },
            closeTime: {
                type: "text",
                canEdit: false,
				label: "完成时间",
                className:"middle-width"
            },
            disCount: {
				type: "text",
                canEdit: false,
				label: "积分/优惠券抵扣",
                className:"middle-width"
			},
            _id: {
				type: "text",
                canEdit: false,
				label: "订单号",
                className:"middle-width"
			},
            userShopName: {
				type: "text",
                canEdit: false,
				label: "买家店铺",
                className:"middle-width"
			},
            "inviter.pName": {
				type: "text",
                canEdit: false,
				label: "业务经理",
                className:"middle-width"
			},
            payType: {
				type: "text",
                canEdit: false,
				label: "支付方式",
                className:"middle-width"
			},
            deliveryType: {
				type: "text",
                canEdit: false,
				label: "配送方式",
                className:"middle-width"
			},
			//金额
			amount: {
				type: "text",
                canEdit: false,
				label: "总金额(含运费)",
                className:"large-width"
			},
            //交易金额
            actualAmount:{
                type:'text',
                label:'交易金额',
                className:'middle-width',
				formatter: function (action, data) {
					return (parseFloat(data.amount)+parseFloat(data.discountAmount||0)).toFixed(2);       
				}
            },
			//运费
			tAmount: {
				type: "text",
				label: "运费",
                canEdit: false,
                className:"large-width"
			},
            cancel:{
                type:"button",
                label:"退款",
                action:"moneyBack",
                className:"middle-width"
            },
			orderListActions: {
				type: "text",
				label: "操作",
				formatter: function (action, data) {
                    var status ="";
                    var clickAction = "";
                    if(data.isPayed){
                        if(data.isCanceled){
                            status = "已退款";
                        }else if(data.isDelived){
                            if(data.isClosed){
                                status = "已完成";
                            }else if(!data.isReceipted){
                                status = "待收货";
                            }else{
                                status = "待评价";
                            }
                        }else if(data.isAccepted){
                            status = "发货";
                            clickAction = "deliverMat";
                        }else{
                            status = "审核";
                            clickAction = "checkMat";
                        }
                    }else{
                        if(data.isCanceled){
                            status = "已取消";
                        }else{
                            status = "待付款";
                        }
                    }
					var v = "<div class='dgrid-button' onclick='window.moveToView(\"orderDetailB\",\"" + data._id + "\");'>查看</div>"+
                    (status ==""?"":clickAction!=""?"<div class='dgrid-button' cq-action="+clickAction+">"+status+"</div>":"<div class='dgrid-button' >"+status+"</div>");
					return v;
				}
			},
			"0.createAt": {
				type: "text",
				label: "创建时间"
			},
			"0.dName": {
				type: "text",
				label: "收货人姓名"
			},
			"0.dAddress": {
				type: "text",
				label: "收货人地址"
			},
			"0.dTel": {
				type: "text",
				label: "收货人手机"
			},
			"0.qty": {
				type: "text",
				label: "商品总数"
			},
			"0.amount": {
				type: "text",
				label: "商品总价"
			},
            state:{
                type:"text",
                label:"订单状态",
                canEdit: false
            },
            dName:{
                type: "text",
                label: "收货人",
                canEdit: false,
                className:"middle-width"
            },
            dAddress:{
                type: "text",
                label: "收货地址",
                canEdit: false,
                className:"large-width"
            },
            realPay:{
                type: "text",
                label: "实付金额",
                canEdit: false,
                className:"large-width"
            },
            dates:{
                type:"text",
                label:"创建时间",
                canEdit: false,
                className:"large-width"
            },
            printButton:{
                type:"button",
                label:"打印",
                action:"printAction"
            },
            alertPrice:{
                type:"button",
                label:"修改价格",
                action:"alertOrderPrice"
            },
            
		},
        matInfoChange:function(widget,field,value){
            /*if(field == ""){
                
            }*/
            //widget.hideByFields(["newPrice"]);
            //var data = data;
            //var widget = widget;
            //domClass.add(dataLayOut.getEditorByField("price").domNode,"text-decoration:line-through")
        },
		_hasLogin: true,
		//通过ID数组加载商家
		loadShops: function () { },
		//加载购物车中商品
		loadCartMats: function () { },
		//获取
		getShopMatData: function (ids) {
			// [{
			//     shopId: id,
			//     shopName: "",
			//     logo: "",
			//     mats: [{
			//         matId: id,
			//         mName: "",
			//         cartQty: number,
			//         qty: number,
			//         logo: "",
			//         price: ''
			//     }]
			// }]
		},
        //退款
        moneyBack:function(data,widget){
            if (!confirm("是否确认退款？")) return;
            window.busy();
            order.setCanceled(data._id).then(lang.hitch(this, function (data1) {
                if(data1.data.ok){
                    window.free();
                    widget.hideByFields(["cancel"]);
                    widget.getEditorByField("state").value="已退款";
                    alert("退款成功");
                }else{
                    alert(data1.data.msg);
                }
                
            }));
        },
        //点击事件
        onListAction:function(data, action, list){
            var id = data._id;
            if (action == "deliverMat") {
                if (!confirm("确定发货吗？")) return;
                //发货
                order.setDelivered(id).then(lang.hitch(this,function(data1){
                    if(data1.data.ok){
                        //刷新列表//先大概直接修改让他刷新
                        data.isDelived = true;
                        data.isCanceled = false;
                        data.isReceipted = false;
                        list.refreshItemByData(data);
                        alert("你已确认发货");
                        /*order.loadWithDetails({shopId:order.getShopId(),fromShopId:order.getShopId()}).then(lang.hitch(this,function(data2){
                            list.refreshItemByData(data2.data.items[0]);
                            alert("你已确认发货");
                        }));*/
                    }else{
                        alert(data1.data.msg||"发货失败");
                    }
                }));
            }else if(action == "checkMat"){
                if (!confirm("确定审核吗？")) return;
                //审核
                order.setAccepted(id).then(lang.hitch(this,function(data1){
                    if(data1.data.ok){
                        //刷新列表
                        data.isAccepted = true;
                        list.refreshItemByData(data);
                        alert("审核通过");
                    }else{
                        alert(data1.data.msg||"审核失败");
                    }
                }));
            }
        },
        //获取订单状态
        getOrderDetailStatus : function(items){
            var status=null;
            if(items.isPayed){
                if(items.isCanceled){
                    status = "已退款";
                }else if(items.isDelived){
                    if(items.isClosed){
                        status = "已完成";
                    }else if(!items.isReceipted){
                        status = "待收货";
                    }else{
                        status = "待评价";
                    }
                }else if(items.isAccepted){
                    status = "待发货";
                }else{
                    status = "待审核";
                }
            }else{
                if(items.isCanceled){
                    status = "已取消";
                }else{
                    status = "待付款";
                }
            }
            return status;
        },
		//购物车数据
		getOrderCarLayout: function () {
			return this.getShopMatData(cart.getIds());
		},
        //修改订单价格
        alertOrderPrice:function(data,widget){
            //获取节点
            var matsInfo = widget.fieldToElements.matsInfo[0];
            var mat = matsInfo.getValue();
            var matOrder = [];
            var params = {};
            for(var i=0;i<mat.length;i++){
                if(mat[i].newPrice){
                    //有修改价格就修改
                    if(parseInt(mat[i].newPrice)+parseInt(mat[i].price)<mat[i].price){
                        matOrder.push({_id:mat[i].mId,discountAmount:mat[i].newPrice});
                    }else {
                        alert("优惠价格不能大于商品实际支付价格");
                        return;
                    }
                }
            }
            params.detail = JSON.stringify(matOrder);//JSON.stringify(datas);
            params.tsId = data._id;
            if (!confirm("确定修改价格吗？")) return;
            order.updateDetailDiscountAmount(params).then(lang.hitch(this,function(result){
                if(result.data.ok){
                    //修改价格 原价，优惠价
                    var matInfo = matsInfo.getValue();
                    for(var i=0;i<matsInfo.getValue().length;i++){
                        if(matInfo[i].newPrice){
                            matInfo[i].discountAmount = parseInt(matInfo[i].price) + parseInt(matInfo[i].newPrice);//matInfo[i].newPrice;
                        }
                    }
                    matsInfo.setValue(matInfo);
                    alert("修改成功");
                }else{
                    alert(result.data.msg);
                }
            }));
        },
		//清空购物车
		clearCart: function () { },
		//继续购买
		toMatList: function () { },
		//结算
		submitOrderCar: function () { },
		//购物车合计组件数据
		getCartCountLayout: function () { },
		//订单列表显示
		getOrderListGridLayout: function () {
			if (!this.orderListGridLayout) {
				this.orderListGridLayout = this.getFormItems([
                "details.0.createAt", 
                "details.0.dName", 
                "details.0.dAddress",
                "details.0.dTel", 
                "details.0.mId.mName",
                "details.0.qty", "actualAmount", 
                "tAmount",
                "orderListActions"], false);
			}
			return this.orderListGridLayout;
		},
        getOrderListExportLayout: function(e,dataLayout){
            //导出 卖家店铺名，订单号，支付日期，买家店铺，收货人，收货电话，收货地址，
            //商品名称，单价，数量,交易金额，积分优惠活动/券，实付金额,支付方式，创建时间，业务经理，业务经理电话               
            var url = this.getOrderListUrl();
            var query = this.query;
            xlsx.loadAllData(url,query).then(lang.hitch(this,function(items){
                //设置表头
                var datas = [['订单号','支付日期','买家店铺','收货人','收货电话','收货地址',
                '商品名称','单价','数量','交易金额','积分优惠活动/券','实付金额','状态','支付方式','创建时间',
                '业务经理','业务经理电话']];
                //初始化订单数据
                for(var i=0;i<items.length;i++){
                    if(items[i].userShopId.companyName&&items[i].userShopId.shopName&&(items[i].userShopId.companyName != items[i].userShopId.shopName)){
                        items[i].buyerName = items[i].userShopId.companyName+"("+items[i].userShopId.shopName+")";
                    } else {
                        items[i].buyerName = items[i].userShopId.companyName||items[i].userShopId.shopName;
                    }
                    for(var j=0;j<items[i].details.length;j++){
                            var data = items[i];
                            if(!data.inviter){
                                data.inviter = {};
                                data.inviter.pName = "";
                                data.inviter.userName = "";
                            }
                            if(data.payType){
                                data.payTypeName = config.getPayTypeStr(data.payType);                            
                            }
                            if(data.payTime){
                                data.payTime = date.formatISODateMinutes(data.payTime);
                            }
                            if(data.createAt){
                                data.createAt = date.formatISODateMinutes(data.createAt);
                            }							
                            data.state = this.getOrderStatus(data);                            
                            data.details[j].payAmount = data.details[j].amount + (data.details[j].discountAmount||0) - (data.details[j].couponAmount+data.details[j].point);
                            data.details[j].actualAmount = data.details[j].amount + (data.details[j].discountAmount||0);
                            datas.push([data.details[0].tsId,data.payTime,
                                data.buyerName,data.details[0].dName,data.details[0].dTel,
                                data.details[0].dAddress,data.details[j].mName,data.details[j].price,
                                data.details[j].qty,data.details[j].actualAmount,data.details[j].couponAmount,
                                data.details[j].payAmount,data.state,data.payTypeName,data.createAt,data.inviter.pName,
                                data.inviter.userName
                            ]);
                        }
                    }
                //导出成xlsx文件
                xlsx.exportMatrix(datas,Date.now().toString());
            }));
        },
        getOrderStatus:function(data){
            if(data.isPayed){
                //已付款
                if(data.isCanceled){
                    //已付款且已取消，则为已退款
                    state = "已退款";
                }else if(data.refundState == 2){
                    state = "退款中";
                }else if(data.isDelived){
                    //已发货
                    if(data.isClosed){
                        //若已关闭，则为已完成
                        state = "已完成";
                    }else if(!data.isReceipted){
                        //若未收货，为待收货
                        state = "待收货";
                    }else{
                        //否则，待评价，评价完成之后会变成已完成
                        state = "待评价";
                    }
                }else if(data.isAccepted){
                    //否则为待发货
                    state = "待发货";
                }else{
                    state = "待审核";
                }
            }else{
                //未付款
                if(data.isCanceled){
                    //已取消
                    state = "已取消";
                }else{
                    //待付款
                    state = "待付款";
                }
            }
            return state;
        },        
		//获取订单列表数据的url
		getOrderListUrl: function () {
			return order.getB2BDetailsUrlByFromShop();
		},
		//获取订单列表数据的查询条件
		getOrderListQueryParam: function (params) {
			//默认查询全部
			var query = { orderBy: '-createAt' };
			
			//1为待付款
			if (params.state && params.state._id == 1) {
				query = {
					isPayed: false,
					isCanceled: false,
					orderBy: '-createAt'
				};
			} else if (params.state && params.state._id == 2) {
				//2为待审核
				query = {
					isPayed: true,
					isCanceled: false,
					isAccepted: false,
					orderBy: '-createAt'
				};
			} else if (params.state && params.state._id == 3) {
				//3为待发货
				query = {
					isPayed: true,
					isCanceled: false,
					isAccepted: true,
					isDelived: false,
					orderBy: '-createAt'
				};
			} else if (params.state && params.state._id == 4) {
				//4为已发货
				query = {
					isPayed: true,
					isCanceled: false,
					isDelived: true,
					isReceipted: false,
					orderBy: '-createAt'
				};
			} else if (params.state && params.state._id == 5) {
				//5为已完成
				query = {
					isPayed: true,
					isCanceled: false,
					isDelived: true,
					isReceipted: true,
					orderBy: '-createAt'
				};
			} else if (params.state && params.state._id == 6) {
				//6为退款中
				query = {
					isPayed: true,
					isCanceled: true,
					isReceipted: false,
					orderBy: "-createAt"
				};
			} else if (params.state && params.state._id == 0) {
				query = {
					orderBy: "-createAt"
				};
			}
            if (params.search) {
				query.search = params.search;
			}
            if(params.searchInfo){
                if(params.searchInfo&&params.searchInfo.payDatef){
                    query.payDatef = params.searchInfo.payDatef;
                }
                if(params.searchInfo&&params.searchInfo.payDatet){
                    query.payDatet = params.searchInfo.payDatet;
                }                
            }
            if(params.searchInfo&&params.searchInfo.search){
                query.search = params.searchInfo.search;                
            }
            this.query = query;
			return query;
		},
        /*shopOrderDetailChange:function(widget,field,value){
            
        },*/
        //商品里面字段变化reload来显示隐藏优惠价格
        matInfoReload:function(widget){
            //widget.hideByFields(["newPrice"]);
        },
        //reload 事件
        shopDetailReload:function(dataLayOut){
            //隐藏优惠价格输入框，暂时隐藏不了，得不到matsInfo的domNode
            var data = dataLayOut.getData();
            /*var dom = dataLayOut.getEditorByField("dName");
            var v = '<li class="ordercarTd mnumer" style="width:80px;line-height: 60px;">'
                +        '<a class="des" href="javascript:void(0);">-</a>'
                +        '<input type="tel" style="width:51px; text-align: center;" class="QTY" value="1"/>'
                +        '<a class="add" href="javascript:void(0);">+</a>'
                +    '</li>';
            var s = domConstruct.toDom(v);*/
            //dom.appendChild(domConstruct.toDom(v));
            //domConstruct.place(dom,domConstruct.toDom(v),"before");
            //dataLayOut.getobjs();
            //隐藏修改价格按钮
            dataLayOut.hideByFields(["alertPrice","cancel"]);
            //未取消和未支付的订单显示修改价格
            if(!data.isPayed&&!data.isCanceled){
                dataLayOut.showByFields(["alertPrice"]);
            }
            //显示退款
            if(data.payType === "point"){
                if(data.isPayed && false===data.isCanceled){
                    dataLayOut.showByFields(["cancel"]);
                }
            }else{
                if(data.isPayed && false===data.isCanceled && false===data.isReceipted){
                    dataLayOut.showByFields(["cancel"]);
                }
            }
            //  所有字段不可编辑
            dataLayOut.disableByFields([
                "dName", "state",
                "dAddress",
                "matsInfo",
                "tAmount",
                "realPay", "amount","dates",
                "_id",
                "userShopName","inviter.pName",
                //isPayed?
                "payType","deliveryType",
                //交易金额,积分优惠券/折扣
                "transAmount","disCount",
                //  无字段报错
                //"payTime",
                
                "acceptTime",
                "delivTime","recepiptTime",
                "closeTime"
            ]);
        },
		//订单详情中页头订单信息的Layout
		getOrderDetailLayout: function () {
            return [{
                type:"form",
                fields:this.getFormItems([
                    "dName", "state",
                    "dAddress",
                    "matsInfo",
                    "tAmount",
                    "realPay", "amount","dates",
                    "_id",
                    "userShopName","inviter.pName",
                    //isPayed?
                    "payType","deliveryType",
                    //交易金额,积分优惠券/折扣
                    "transAmount","disCount",
                    "payTime","acceptTime",
                    "delivTime","recepiptTime",
                    "closeTime",
                    "cancel",
                    "alertPrice","printButton"
                ],true)
            }];
		},
		//订单详情中的数据
		getShopOrderDetailInitData: function (param) {
            return order.loadDetailById(param.cqViewParam.params).then(lang.hitch(this,function(data){
                //收货人信息
                var items = data.data.items;
                var item = data.data.items[0];
                //订单价格等等信息
                //加载订单信息
                return order.loadById(param.cqViewParam.params).then(lang.hitch(this, function(dataInfo) {
                    //重算订单支付方案?
                    var orderDate;
                    if(dataInfo.data.item){
                        orderDate = dataInfo.data.item;
                        data = orderDate;
                        var matInfos = [];
                        for(var i=0;i<items.length;i++){
                           var newprice = items[i].price+items[i].discountAmount;
                            matInfos.push({price:items[i].price.toFixed(2),qty:items[i].qty,logo:items[i].mId.logo,mName:items[i].mId.mName,discountAmount:newprice.toFixed(2),mId:items[i]._id});
                            //,mId:items[i].mId._id,tsId:items[i].tsId
                        }
                        data.dName = item.dName;
                        data.dAddress = item.dAddress;
                        //商品信息
                        data.matsInfo = matInfos;
                        data.tAmount = "￥"+orderDate.tAmount.toFixed(2);
                        data.amount = "￥"+orderDate.amount.toFixed(2);
                        //data.integral = "￥"+(orderDate.couponAmount + orderDate.point).toFixed(2);
                        data.realPay = "￥"+orderDate.payAmount.toFixed(2);//(orderDate.amount - ((orderDate.point + orderDate.couponAmount) || 0)).toFixed(2);
                        data.dates = date.formatISODateMinutes(orderDate.createAt);
                        data.state = this.getOrderDetailStatus(orderDate);
                        if(orderDate.deliveryTyp == 1){
                            data.deliveryType = "配送";
                        }else{
                            data.deliveryType = "自提";
                        }
                        if(orderDate.payTime){
                            data.payTime = date.formatISODateMinutes(orderDate.payTime);
                        }
                        if(orderDate.acceptTime){
                            data.acceptTime = date.formatISODateMinutes(orderDate.acceptTime);
                        }
                        if(orderDate.delivTime){
                            data.delivTime = date.formatISODateMinutes(orderDate.delivTime);
                        }
                        if(orderDate.recepiptTime){
                            data.recepiptTime = date.formatISODateMinutes(orderDate.recepiptTime);
                        }
                        if(orderDate.closeTime){
                            data.closeTime = date.formatISODateMinutes(orderDate.closeTime);
                        }
                        if(orderDate.isPayed){
                           data.payType = config.getPayTypeStr(orderDate.payType) 
                        }
                        data.transAmount = window.fixedTo(parseFloat(orderDate.amount)+parseFloat(orderDate.discountAmount||0),3);
                        data.disCount = window.fixedTo(parseFloat(orderDate.couponAmount)+parseFloat(orderDate.point),3);
                    }
                    return data;
                }));
                //var 
            }));
		},
        //打印
        printAction:function(param){
            var printNode;
            order.loadDetailById(param._id).then(lang.hitch(this,function(backData){
                var singleData = backData.data.items[0];
                if(!singleData.remark){
                    singleData.remark = "";
                }
                if(!singleData.inviter){
                    singleData.inviter = "";
                }
                printNode = "<div><div style='float:left;width:40%'>单据号："+singleData._id+"</div>"+"<div style='float:left;width:33%'>单据日期："+date.formatISODateMinutes(singleData.createAt)+"</div>"+"<div>仓库：</div></div>";
                printNode +="<div><div style='float:left;width:40%;'>客户："+singleData.dName+"</div>"+"<div>业务员："+singleData.inviter+"</div></div>";
                printNode +="<div><div style='float:left;width:40%'>订单号："+singleData._id+"</div>"+"<div style='float:left;width:40%;'>备注："+singleData.remark+"</div></div>";
                printNode +="<div><table style='border-collapse:collapse;border:1px solid black'><tbody>"
                            +"<tr style='border:1px solid black'><th style='border:1px solid black'>行号</th><th style='border:1px solid black'>物料名称</th><th style='border:1px solid black'>型号(规格)</th><th style='border:1px solid black'>主单位</th><th style='border:1px solid black'>单价</th><th style='border:1px solid black'>应发数量</th><th style='border:1px solid black'>应发主数量</th><th style='border:1px solid black'>实发数量</th><th style='border:1px solid black'>实发主数量</th><th style='border:1px solid black'>应发金额</th><th style='border:1px solid black'>赠品</th></tr>";
                for(var i=0;i<backData.data.items.length;i++){
                    var param = backData.data.items[i];
                    printNode +="<tr style='border:1px solid black'><th style='border:1px solid black'>"+(i+1)+"</th><th style='border:1px solid black'>"+param.mId.mName+"</th><th style='border:1px solid black'>"+param.mId.sizeType+"</th><th style='border:1px solid black'></th>"
                    +"<th style='border:1px solid black'>"+param.price+"</th><th style='border:1px solid black'>"+param.qty+"</th><th style='border:1px solid black'>"+param.qty+"</th><th style='border:1px solid black'>"+param.qty+"</th><th>"+param.qty+"</th>"
                    +"<th style='border:1px solid black'>"+(param.amount+param.discountAmount)+"</th><th style='border:1px solid black'></th></tr>";
                }
                printNode +="</tbody></table></div>";
                user.getUserInfo().then(lang.hitch(this,function(userData){
                    printNode +="<div><div style='float:left;width:24%'>制单："+userData.data.item.pName+"</div><div style='float:left;width:24%'>审核：</div><div style='float:left;width:24%'>库管: </div><div style='float:left;width:24%'>收货：</div></div>"
                    +"<div><div style='float:left;width:20%;margin-left:10%'>红联：</div>"+"<div style='float:left;width:20%'>蓝联：</div>"+"<div style='float:left;width:20%'>白联：</div>"+"<div style='float:left;width:20%'>绿联：</div></div>";
                    printor.nativePrint("",printNode);
                }));
            }));
        }
	});
	return boBase;
});