define([
		"dojo/_base/lang",
        "dojo/_base/xhr",
		"dojo/dom-style",
        "dojo/Deferred",
		"dojo/topic",
		"dojo/query",
		"dijit/registry",
        "cq/util/config/config",
		"cq/util/edit/editor",
        "cq/biz/ts/refundRecord",
        "cq/biz/ts/pay/bankStatement",
		"./BoBase",
        "cq/biz/ts/order"
	], function (lang, xhr, domStyle, Deferred, topic, query, registry, config, editor, refundRecord,bankStatement,BoBase,order) {
	var widgetTextModel = new BoBase({
			fields : {
				//文本框
				userName : {
					type : "tel",
					placeHolder : "请填写手机号",
					label : "账号",
                    
				},
				//密码框
				password : {
					type : "password",
					placeHolder : "必须输入密码",
					label : "密码",
                    icon:"images/username.png"
				},
				//checkbox/开关编辑——bool值
				rememberPwd : {
					type : "checkbox",
					label : "记住密码",
					//canEdit : false
				},
				//checkbox/开关编辑——bool值
				isStaff : {
					type : "checkbox1",
					label : "保持登录",
					canEdit : true
				},
                number : {
					type : "number",
					
					label : "数字测试"
				},
				//多行文本编辑
				address : {
					type : "textarea",
					label : "用户简介",
					canEdit : true
				},
				//年月日编辑
				date : {
					type : "date",
					label : "日期",
					canEdit : true
				},
                score:{
                    type:"score",
                    label:"得分",
                    canEdit:true,
                    image:"/static/common/images/star-orange.png",
                    numStars:5,
                    value:4
                },
                scored:{
                    type:"scored",
                    label:"得分",
                    canEdit:true,
                    image:"/static/common/images/star-orange.png",
                    numStars:5,
                    value:4
                },
				//地理位置编辑
				"lon,lat" : {
					type : "location",
					label : "位置",
					//用于联动区划，传入省市区ID字段名，不联动则传入空字符串
					distFields : "provinceId,cityId,countyId",
					//区域划分地址字段名
					distFieldsStr : "brief2",
					//详细乡镇村地址字段名
					detailAddrField : "brief",
					//是否可编辑
					canEdit : true
				},
				//地理位置编辑,不可联动区划
				"lon2,lat2" : {
					type : "location",
					label : "位置(不可编辑)",
					//detailAddrField:"brief",
					canEdit : false
				},
				//列表选项编辑
				"sex" : {
					type : "options",
					label : "性别",
					options : {
						0 : "男",
						1 : "女",
                        2:""
					},
                    selected:"1",
					canEdit : true
				},
                "sex1":{
                    type : "options",
					label : "性别",
					options:{
                        1:"男",
                        2:"女",
                        3:"人妖",
                        "植物":{
                            4:"树",
                            5:"abc"
                        }
                    },
                    selected:"0",
					canEdit : true
                },
				//单图编辑
				"icon" : {
					type : "image",
					//控制图片大小的方式，
					//cut:剪切
					//compress:压缩
                    //upload:直接上传
					sizeType : "upload",
					canEdit : true,
                    //查看大图属性clickimg，默认值为false不可查看。
                    clickImg:true,
                    /*
					size : {
						width : 128,
						height : 128
					},*/
					label : "店铺图标",
                    cqWidth:"480"
				},

				"icon1" : {
					type : "image",

					//控制图片大小的方式，
					//cut:剪切
					//compress:压缩
					sizeType : "cut",

					//是否可编辑
					canEdit : true,
					//imgable：设置图片时候能够点击查看大图。默认为false
					clickImg : true,

					//设置图片大小，默认大小为128*128.
					size : {
						width : 800,
						height : 600
					},
					label : "图片(不可编辑状态可看大图)"
				},

				//图片列表编辑
				"icons" : {
					type : "images",
					//控制图片大小的方式，
					//cut:剪切
					//compress:压缩
					sizeType : "compress",
					size : {
						width : 800,
						height : 600
					},
					canEdit : true,
                    maxImages:3, 
                    
				},
                "iconsmultiple" : {
					type : "images",
					//控制图片大小的方式，
					//cut:剪切
					//compress:压缩
					sizeType : "compress",
					size : {
						width : 800,
						height : 600
					},
					canEdit : true,
                    multiple:"multiple"
				},
				//手机号/验证码编辑
				"username,vCode" : {
					type : "vcode",
					errorMsg : "请输入正确的11位电话号码",
					unExists : "账号已经存在,请直接登陆"
				},
                "verifyCode" : {
                    type:"VerifyCode",
                },
				//引用编辑
				"newsId" : {
					type : "ref",
					field : "newsId",
					label : "资讯()",
					searchField : "title",
					pageSize : 5,
					labelFields : "title,code",
					dataProvider : "cq/biz/article/article",
                    multiselect:"multiselect",
					targetMethod : "getArticleUrl",
					canEdit : true
				},
                "newsId2" : {
					type : "ref",
					field : "newsId2",
					label : "资讯",
					searchField : "title",
					pageSize : 5,
					labelFields : "title,code",
					dataProvider : "cq/biz/article/article",
                    //setRigthTextMethod:"aaaa",
					targetMethod : "getArticleUrl",
					canEdit : true
				},
				//格式文本编辑
				richText : {
					type : "richText",
					label : "格式文本",
					canEdit : true
				},
				//年月日编辑
				birthDay : {
					type : "date",
					label : "生日",
					canEdit : true
				},
				//多行文本编辑
				brief : {
					type : "textarea",
					label : "简介",
					canEdit : true
				},
				brief2 : {
					type : "textarea",
					label : "简介"
				},
				//区划编辑,省、市、县、地址文本
				"provinceId,cityId,countyId" : {
					type : "district",
					label : "无名区划"
				},
                // 只选区县
                "province,city,county":{
                    type:"district",
                    label:"区县",
                    fixedUpDis:{
                        upDis:[
                            "57a936a0e026905d4c92f647",
                            "57a936a0e026905d4c92f648"
                        ]
                    }
                },
				//区划编辑,省、市、县、地址文本
				"provinceId,cityId,countyId,distAddr" : {
					type : "district",
					label : "区划",
					canEdit : true
				},
				//区划和乡村的选择应该分开
				//区划编辑,省、市、县、地址文本
				//"provinceId,cityId,countyId,townId,villageId":{
				//    type:"district",
				//    label:"无名选村",
				//	townFields:""
				//},
				//"provinceId,cityId,countyId,townId,villageId,distAddr":{
				//    type:"district",
				//    label:"选村",
				//	townFields:""
				//},
				"countyId,townId,villageId" : {
					type : "village",
					//type:"district",
					label : "村",
					canEdit : true
				},
                "townId,villageId,townVillage" : {
					type : "village",
					//type:"district",
					label : "村",
					canEdit : true
				},
                newObjTest:{
                    type:"newobjs",
                    items:{
                        "测试1":"a",
                        "测试2":"b",
                        "测试3":"c"
                    }
                },
                
				// 对象编辑
				"obj" : {
					type : "object",
					label : "单字段对象测试",
					// labelField:"userName",
					rightTextField : "userName",
					canEdit : true,
					fields : {
						layout : [{
							    field : "userName",
								type : "tel",
								placeHolder : "请填写手机号",
								label : "账号"
							} /*,{
								field : "password",
								type : "password",
								placeHolder : "必须输入密码",
								label : "密码"
							}, {
								field : "rememberPwd",
								type : "checkbox",
								label : "记住密码"
							}, {
								field : "isStaff",
								type : "checkbox",
								label : "保持登录",
								canEdit : true
							}*/
						]
					}
				},
				"obj1" : {
					type : "object",
					label : "对象测试",
					// labelField:"userName",
					//rightTextField : "userName",
					canEdit : true,
					fields : {
						layout : [{
								field : "userName1",
								type : "tel",
								placeHolder : "请填写手机号",
								label : "账号"
							}, {
								field : "password1",
								type : "password",
								placeHolder : "必须输入密码",
								label : "密码"
							}, {
								field : "rememberPwd1",
								type : "checkbox",
								label : "记住密码"
							}, {
								field : "isStaff1",
								type : "checkbox",
								label : "保持登录",
								canEdit : false
							}
						]
					}
				},
				// 对象列表
				"objs" : {
					type : "objects",
                    label:"对象测试",
					labelField : "userName",
					rightTextField : "password",
                    dataProvider:"cq/bo/widgetTest",
					reloadMethod:"testmultipReload",
                    fieldChangeMethod:"testfieldchanged",
                    userDefinedValue:"testuserDefindValue",
                    canEdit : true,
					canDelete : true,
					canAdd : true,
					canDnd : true,
					fields : {
						layout : [{
								field : "userName",
								type : "tel",
								placeHolder : "请填写手机号",
								label : "账号"
							}, {
								field : "password",
								type : "password",
								placeHolder : "必须输入密码",
								label : "密码"
							}, {
								field : "rememberPwd",
								type : "checkbox",
								label : "记住密码"
							}, {
								field : "isStaff",
								type : "checkbox",
								label : "保持登录",
								canEdit : false
							}
						]
					}
				},
                "objs1" : {
                    type:"objects",
                    label:"销售区域",
                    labelField:"remark",
                    canEdit:true,
                    canDelete:true,
                    dataProvider:"cq/bo/widgetTest",
                    reloadMethod:"testObjsDatalayout",
                    canAdd:true,
                    canDnd:true,
                    defaultData:{
                        cityId:null,
                        countId:null,
                        provinceId:"57a936a0e026905d4c92f647",
                        remark:"重庆市"
                    },
                    fields:{
                        layout:[{
                            field:"provinceId,cityId,countId,remark",
                            type:"district",
                            enableAll:true,
                            placeHolder:"请选择地址",
                            label:"区划"
                        }]
                    }
                },
                
                "objs2" : {
                    type:"objects",
                    label:"文本框",
                    labelField:"remark",
                    canEdit:true,
                    canDelete:true,
                    canAdd:true,
                    canDnd:false,
                    fields:{
                        workMode:"edit",
                        className:"editEditor",
                        layout:[{
                            field:"userName",
                            type:"text",
                            enableAll:true,
                            placeHolder:"12345",
                            label:"姓名"
                        },{
                            field:"userNa",
                            type:"text",
                            enableAll:true,
                            placeHolder:"12345",
                            label:"姓名"
                        },{
                            field:"userN",
                            type:"text",
                            enableAll:true,
                            placeHolder:"12345",
                            label:"姓名"
                        }]
                    }
                },
                "objsCurrent" : {
                    type:"objects",
                    label:"文本框",
                    displayPage:"current",
                    labelField:"remark",
                    canEdit:true,
                    canDelete:true,
                    canAdd:true,
                    canDnd:true,
                    dataProvider:"cq/bo/widgetTest",
                    fieldChangeMethod:"testfieldchanged",
                    fields:{
                        layout:[{
                           
                            field:"userName1",
                            type:"text",
                            enableAll:true,
                            placeHolder:"12345",
                            label:"姓名"
                        },{
                            displayPage:"current",
                            field:"userName2",
                            type:"text",
                            enableAll:true,
                            placeHolder:"12345",
                            label:"姓名"
                        },{
                            displayPage:"current",
                            field:"userName3",
                            type:"text",
                            enableAll:true,
                            placeHolder:"12345",
                            label:"姓名"
                        }]
                    }
                },
                "objs4" : {
                    type:"objects",
                    label:"资讯",
                    labelField:"remark",
                    canEdit:true,
                    canDelete:true,
                    canAdd:true,
                    canDnd:true,
                    fields:{
                        layout:[{
                            type : "ref",
                            field : "newsId",
                            label : "资讯",
                            searchField : "title",
                            pageSize : 5,
                            labelFields : "title,code",
                            dataProvider : "cq/biz/article/article",
                            targetMethod : "getArticleUrl",
                            canEdit : true
                        }]
                    }
                },
                "objs3" : {
                    type:"objects",
                    label:"生日",
                    labelField:"remark",
                    canEdit:true,
                    canDelete:true,
                    canAdd:true,
                    canDnd:true,
                    fields:{
                        layout:[{
                            
                            field : "brithDay",
                            type : "date",
                            label : "生日",
                            canEdit : true
                        }]
                    }
                },
                "objs6" : {
                    type:"object",
                    label:"列表对象测试",
                    //labelField:"remark",
                    canEdit:false,
                    //canDelete:true,
                    //canAdd:true,
                    //canDnd:true,
                    fields:{
                        layout:[{
                            
                            field : "attachment",
                            type:"attachs",
                            label:"添加附件1",
                            cnaEdit: true
                        }]
                    }
                },
                /*
                birthDay : {
					type : "date",
					label : "生日",
					canEdit : true
				},*/
				saveButton1 : {
					type : "button",
					label : "提交1",
					action : "save1"
				},
				saveButton2 : {
					type : "button",
					label : "提交2",
					action : "save2"
				},
				saveButton3 : {
					type : "button",
					label : "提交3",
					action : "save3",
					buttonClass : ""
				},
                

				//按钮
				saveButton : {
					type : "button",
					label : "提交",
					action : "save"
				},
				readonlyLink : {
					type : "link",
					label : "只读点击",
					href : "",
					canEdit : true,
					icon : ""
				},
				"link" : {
					type : "link",
					label : "link连接",
					rightText : "点一下看看",
					canEdit : false,
					href : "login",
					icon : "https://ss0.baidu.com/73F1bjeh1BF3odCf/it/u=686530479,3007790249&fm=85&s=5E1445851CCA3AC4618D5D960300C0AA"
				},
				"dropDown" : {
					type : "tabBox",
					tabItems : {
						items : [{
								label : "价格",
								items : [{
										_id : "123454646460",
										label : "12340"
									}, {
										_id : "123454646461",
										label : "12341"
									}, {
										_id : "123454646462",
										label : "12342"
									}, {
										_id : "123454646463",
										label : "12343"
									}
								]
							}, {
								label : "时间",
								items : [{
										_id : "123454646460",
										label : "12340"
									}, {
										_id : "123454646461",
										label : "12341"
									}, {
										_id : "123454646462",
										label : "12342"
									}, {
										_id : "123454646463",
										label : "12343"
									}
								]
							}, {
								label : "地点",
								items : [{
										_id : "123454646460",
										label : "12340"
									}, {
										_id : "123454646461",
										label : "12341"
									}, {
										_id : "123454646462",
										label : "12342"
									}, {
										_id : "123454646463",
										label : "12343"
									}
								]
							}
						]
					}
				},
                "dateTime":{
                    type : "dateTime",
					label : "日期包含小时",
					canEdit : true
                },
                "saveFile":{
                    type:"attachs",
                    label:"添加附件",
                    cnaEdit: true
                },
                "shopName,_id,logo":{
                type:"link",
                label:"{shopName}",
                rightText:"",
                href:"/w/home/{_id}",
                icon:"{logo}"
                },
                "fileEditor":{
                    type:"file",
                    label:"文件",
                    canEdit:true                    
                },
                "fileEditor1":{
                    type:"file",
                    label:"文件不可编辑",
                    canEdit:false,
                    value:{
                        title:"店铺余额问题清单.xlsx",
                        url:"http://192.168.0.2/static/upload/cqthink/0d0/34f5d9413a37048ad9026db899c0293d444fbd8224d27ebd934df7d5390ae"
                    }
                },    
                'chart':{
                    type:"chart",
                    dataProvider: "cq/bo/widgetTest",
                    dataOptions: {},
                    dataMethod:'getChartData',
                    xField:'',
                    xLabelMethod:'xLabelMethod',
                    series:[{
                        serieField:'amount',
                        //序列的样式设置
                        serieTheme:'',
                        //序列的呈现类型——柱状图、折线图等
                        serieType:''
                        }],
                    indicatorLabelMethod:'indicatorLabelMethod',
                },
                "content":{
                    type:"content",
                    content:"<div><li data-dojo-type='dojox/mobile/ListItem' ><div id='cq-auto-y' class='cq-action cq-form-button ' data-cq-field='saveButton' cq-action='save'>提交</div></div>"
                },
                "grouped":{
                    type:"groupEdit",
                    label:"标签三",
                    rightText:"未设置",
                    intervalTop:true,
                    //intervalBottom:true,
                    group:"group3"
                }
			}
		});
	var widgetBo = {
		widgetTest : [{}
		],
		widgetAction : {},
		widgetTestLayout : [{
				type : "form",
				fields : widgetTextModel.getFormItems([
                    "userName", "password", "brief", "rememberPwd",
                    "saveButton", "isStaff", "address", "lon,lat", "lon2,lat2", 
                    "sex", "sex1", "date", "dateTime","saveFile",  "icon", "icons", 
                    "username,vCode", "verifyCode", "newsId2", "richText",
                    "provinceId,cityId,countyId,distAddr", 
                    "provinceId,cityId,countyId", 
                    'countyId,townId,villageId',
                    //"townId,villageId,townVillage",
                    "saveButton","obj1","objs1","objs","province,city,county",
                    "fileEditor","fileEditor1","objs6",'chart'
					])
			}
		],
		getWidgetTestLayout : function () {
			return this.widgetTestLayout;
		},
		getMobileTestLayout : function () {
			if (!this.mobileTestLayout) {
				this.mobileTestLayout = [{
                    type:"form",
                    contents:[{
                        type : "group",
                        groupId:"group1",
                        fields : widgetTextModel.getFormItems([
                            "grouped",
                            "newObjTest",
                            "number",
                            "userName", "password", "rememberPwd", "isStaff",
                            "saveButton1","saveButton2","saveButton3", "saveButton3",
                            "sex", {
                                field : "sex" //,
                                //canEdit:false
                            }
                            //"provinceId,cityId,countyId,townId,villageId",
                            //"provinceId,cityId,countyId,townId,villageId,distAddr",
                            
                            
                        ])
                    },{
                        type : "group",
                        groupId:"group3",
                        fields : widgetTextModel.getFormItems([
                             "birthDay","dateTime","brief", "brief2", "richText", 
                            "username,vCode", "icon", "icons","iconsmultiple","newsId2",//"newsId2",//,
                            "provinceId,cityId,countyId",
                            "provinceId,cityId,countyId,distAddr",
                            "countyId,townId,villageId",
                        ])
                    },{
                        type:"group",
                        groupId:"group2",
                        fields: widgetTextModel.getFormItems([
                            
                            "lon,lat", "lon2,lat2",/* "obj",*/ 
                            "obj1", "objs", "objs1", "objs2", "objs3", 
                            "readonlyLink", "link" ,"date","dateTime",
                            "shopName,_id,logo","fileEditor","fileEditor1",
                            "score","scored","content"
                        ])
                    },{
                        dojoType:"cq/app/widget/mobile/edit/GroupEditor",
                        label:"标签一",
                        rightText:"未设置",
                        intervalTop:true,
                        //intervalBottom:"30px",
                        group:"group1",
                        field:"group1"
                    },{
                        dojoType:"cq/app/widget/mobile/edit/GroupEditor",                        
                        label:"标签二",
                        explain:"这里是标签二吗？",
                        rightText:"未设置",
                        intervalTop:true,
                        //intervalBottom:"30px",
                        group:"group2",                    
                        field:"group2"
                    }]
                }];
			}
			return this.mobileTestLayout;
		},
        getZctTestLayout:function(){
            if (!this.zctTestLayout) {
				this.zctTestLayout = [{
						type : "form",
						fields : widgetTextModel.getFormItems([
								"icon","icons","score","address"
							])
					}
				];
			}
			return this.zctTestLayout;    
        },
		//save方法用于定义button组件的onclick事件。
		//save方法在datalayout的bindActionElementEvent方法中调用
		//data:页面数据；
		//views:触发事件组件的weiget,即组件列表容器。
		save : function (data, views) {
			if (!views.view) {
				var view = views.getParent();
				while (view) {
					if (!view.show) {
						view = view.getParent();
					} else {
						break;
					}
				}
				views.view = view;
			}
			editor.startEdit("", views.view).then(lang.hitch(this, function (value) {
					console.log(value);
				}));
		},

		save1 : function (data) {
			alert("save1");
		},
		save2 : function (data) {
			alert("save2");
		},
		save3 : function (data) {
			alert("save3");
		},
        getUserTitle:function(cqRefInfo,options){
            var def = new Deferred();
            def.resolve("你好");
            return def;
        },
        getLocationTitle:function(cqRefInfo,options){
            var def = new Deferred();
            var currentView = cqRefInfo.cqViewParam.road[0]||"home",currentViewName="";
            if(currentView =="home"){
                currentViewName = "首页";
            }
            if(currentView =="businessVerification"){
                currentViewName = "企业认证";
            }
            if(currentView =="businessList"){
                currentViewName = "企业信息";
            }
            def.resolve( "<div style='color:red;height30px;'>"+currentViewName+"</div>" );
            return def;
        },
        getHeatMapData:function(){
            var def = new Deferred();
            bankStatement.loadData().then(function(data){
                if(data.data.ok===1){
                    var items = data.data.items||{};
                    var datas=[];
                    for(var i =0;i<items.length;i++){
                        datas.push(items[i].buyerShopId);
                    }
                    def.resolve(datas);
                }
            });
            return def;    
        },
        getMarkMapData:function(data,widget,status){
            if(status.oldScaleLevel&&(status.oldScaleLevel>=11)===(status.scaleLevel>=11)){
                return null;
            }
            if(status.oldScaleLevel&&(status.oldScaleLevel<11)===(status.scaleLevel<11)){
                return null;
            }
            var def = new Deferred();
            if(status.scaleLevel<11){
                def.resolve([]);
            }else{
                
            }
            return def;    
        },
        markClick:function(){
            console.log("点击事件触发！");
        },
        markmonuseover:function(data,widget){
            return data.shopName+"</br>"+data.svcPhone+"</br>"+data.town||"";
        },
        getChartData:function(cqRefInfo,chart,options){
            
            return refundRecord.load();
        },
        promptMethod:function(){
            return 3;
        },
        getProductsPieChartData:function(cqRefresh,widget,params){
            var def = new Deferred();
            var items=[{
                id:"999991313",
                sortId:{
                    sortName:"四条腿"
                },
                totalAmount:"46784",
                totalDiscountAmount:0,
                items:[{
                    sortId:{
                        sortName:"兔子"
                    },
                    totalAmount:"46784",
                    totalDiscountAmount:0
                },{
                    sortId:{
                        sortName:"山羊"
                    },
                    totalAmount:"46784",
                    totalDiscountAmount:0
                },{
                    sortId:{
                        sortName:"王八"
                    },
                    totalAmount:"46784",
                    totalDiscountAmount:0
                },{
                    sortId:{
                        sortName:"老牛"
                    },
                    totalAmount:"46784",
                    totalDiscountAmount:0
                }]
            },{
                id:"999991313",
                sortId:{
                    sortName:"两条腿"
                },
                totalAmount:"46784",
                totalDiscountAmount:0,
                items:[{
                    sortId:{
                        sortName:"老母鸡"
                    },
                    totalAmount:"46784",
                    totalDiscountAmount:0
                },{
                    sortId:{
                        sortName:"鸭"
                    },
                    totalAmount:"46784",
                    totalDiscountAmount:0
                },{
                    sortId:{
                        sortName:"鸽子"
                    },
                    totalAmount:"46784",
                    totalDiscountAmount:0
                }]
            },{
                id:"999991313",
                sortId:{
                    sortName:"一条腿"
                    
                },
                totalAmount:"46784",
                totalDiscountAmount:0,
                items:[{
                    sortId:{
                        sortName:"香菇"
                    },
                    totalAmount:"46784",
                    totalDiscountAmount:0
                },{
                    sortId:{
                        sortName:"金针菇"
                    },
                    totalAmount:"46784",
                    totalDiscountAmount:0
                },{
                    sortId:{
                        sortName:"灵芝"
                    },
                    totalAmount:"46784",
                    totalDiscountAmount:0
                }]
            }];
            
                     
            var dataItems = [];
            for(var i = 0;i<items.length;i++){
                var changeData ={};
                changeData["id"] = items[i].id||null;
                changeData["amount"] = (parseFloat(items[i].totalAmount)+parseFloat(items[i].totalDiscountAmount)).toFixed(2);
                changeData["sortName"] = items[i].sortId.sortName||'';
                changeData["items"] = items[i].items||null;
                dataItems.push(changeData);
            }
            def.resolve(dataItems);
        
            return def;
        },
        getProductsPieChartData1:function(cqRefresh,widget,params){
            var def = new Deferred();
            var items;
            var data=[{
                sortId:{
                    sortName:"四条腿"
                },
                totalAmount:"46784",
                totalDiscountAmount:0,
                items:[{
                    sortId:{
                        sortName:"兔子"
                    },
                    totalAmount:"46784",
                    totalDiscountAmount:0
                },{
                    sortId:{
                        sortName:"山羊"
                    },
                    totalAmount:"46784",
                    totalDiscountAmount:0
                },{
                    sortId:{
                        sortName:"王八"
                    },
                    totalAmount:"46784",
                    totalDiscountAmount:0
                },{
                    sortId:{
                        sortName:"老牛"
                    },
                    totalAmount:"46784",
                    totalDiscountAmount:0
                }]
            },{
                sortId:{
                    sortName:"两条腿"
                },
                totalAmount:"46784",
                totalDiscountAmount:0,
                items:[{
                    sortId:{
                        sortName:"老母鸡"
                    },
                    totalAmount:"46784",
                    totalDiscountAmount:0
                },{
                    sortId:{
                        sortName:"鸭"
                    },
                    totalAmount:"46784",
                    totalDiscountAmount:0
                },{
                    sortId:{
                        sortName:"鸽子"
                    },
                    totalAmount:"46784",
                    totalDiscountAmount:0
                }]
            },{
                sortId:{
                    sortName:"一条腿"
                },
                totalAmount:"46784",
                totalDiscountAmount:0,
                items:[{
                    sortId:{
                        sortName:"香菇"
                    },
                    totalAmount:"46784",
                    totalDiscountAmount:0
                },{
                    sortId:{
                        sortName:"金针菇"
                    },
                    totalAmount:"46784",
                    totalDiscountAmount:0
                },{
                    sortId:{
                        sortName:"灵芝"
                    },
                    totalAmount:"46784",
                    totalDiscountAmount:0
                }]
            }];
            
                     
            var dataItems = [];
            if(cqRefresh.pie1&&cqRefresh.pie1.legend){
                for(var i=0;i<data.length;i++){
                   if(data[i].sortId.sortName === cqRefresh.pie1.legend){
                       items = data[i].items;
                   }
                }
            }else{
                items = data[0].items
            }
            for(var i = 0;i<data.length;i++){
                var changeData ={};
                changeData["amount"] = (parseFloat(items[i].totalAmount)+parseFloat(items[i].totalDiscountAmount)).toFixed(2);
                changeData["sortName"] = items[i].sortId.sortName||'';
                changeData["items"] = items[i].items||null;
                dataItems.push(changeData);
            }
            def.resolve(dataItems);
            return def;
        },
        getNews:function(){
            return items=[{
                title:"marquee测试1"
            },{
                title:"marquee测试2"
            },{
                title:"marquee测试3"
            }]
        },
        testmultipReload:function(widget){
            console.log("这是overlay里面的DataLayout");
            //widget.getEditorByField
            //widget.connect(widget.getEditorByField("password"), "oninput", lang.hitch(this,function(){}));
        },
        testuserDefindValue:function(widget,value){
            widget.set("label","多字段自定义value显示测试");       
        },
        testfieldchanged:function(widget,field,value){
            console.log("这里是fieldChangeMethod");
        },
        marqueeClick:function(){
            alert("测试marqueeClick");
        },
        testObjsDatalayout:function(){
            console.log("进入objs的Datalayout的reload方法");
        },
        testRowlist:function(){
            return "http://192.168.0.2/bizv2/article/article/loadGroup?shopId=5867bb69514eed34ca303f5e";
        },
        reloadTest:function(widget){
            widget.getEditorByField("fileEditor1").setValue({
                        title:"店铺余额问题清单.xlsx",
                        url:"http://192.168.0.2/static/upload/cqthink/0d0/34f5d9413a37048ad9026db899c0293d444fbd8224d27ebd934df7d5390ae"
                    });
        }
	};
	return widgetBo;
});