define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojox/mobile/View",
	"dojo/dom-construct",
	"cq/ui/view/_ViewMixin",
	"cq/biz/article/article",
	"cq/util/config/config"
],function(declare,lang,View,domConstruct,_ViewMixin,article,config){
	return declare("cq.ui.b.a.About",[View,_ViewMixin],{
		onFirstShow:function(){
			var option = null;
			//添加头部
			option = {
				left : {
					iconButton: ' ',
                    arrow: "left",
                    label: "",
					onClick: function(){
						history.back();
					}
				},
				title: "关于我们"
			};
			this.addHeader(option);
			//图片
			domConstruct.create("div",{
				style:"",
				width:"100%",
				innerHTML:"<img src='images/gywm.jpg' style='height:200px;width:100%;'/>"
			},this.centerPanel.containerNode)
			//列表
			option = {
				isEdge:true,
				class: "bottom-margin16",
				lists:[{
                    label:"重盐云商官网",
                    rightText:"http://go.cqsalt.com",
                    noArrow:false,
                    onClick:function(){
                        //localStorage.setItem("from","about");
                        //window.moveToView("iframe","http://go.cqsalt.com/");
                    }
                },{
                    label : "关于重盐云商",
                    noArrow:false,
                    onClick : this.moveToAbout,
                    moveTo : "#"
                },{
                    label : "入驻流程",
                    noArrow:false,
                    onClick : function(){
						article.loadPlatformByTitle("入驻流程").then(lang.hitch(this, function(data){
							if(data&&data.data&&data.data.ok==1){
								window.moveToView("trendDetail", data.data.item._id);						
							} else {
								alert("暂无入驻流程");
							}							
						}));
					},
                    moveTo : "#"
                },{
                    label : "服务项目",
                    noArrow:false,
                    onClick : function(){						
						article.loadPlatformByTitle("服务项目").then(lang.hitch(this, function(data){
							if(data&&data.data&&data.data.ok==1){
								window.moveToView("trendDetail", data.data.item._id);							
							} else {
								alert("暂无服务项目");
							}
							
						}));
					},
                    moveTo : "#"
                },{
                    label : "版本号",
                    noArrow:false,
                    rightText:config.version
                },{
                    label : "ICP备案号",
                    noArrow:false,
                    rightText:"渝ICP备09008929号-1"
                },{
                    label : "经营性ICP",
                    noArrow:false,
                    rightText:"渝B2-20160071"
                },{
                    label:"许可证",
                    noArrow:false,
                    onClick:function(){
                        require([
                            "cq/widgets/bigImg"
                        ],function(bigImg){
                            bigImg.show([{
                                src:"./images/business_license.jpg"
                            }]);
                        });
                    }
                }]
			};
			this.addLists(option)
			//版权相关
			domConstruct.create("div",{
				style:"text-align:center",
				width:"100%",
				innerHTML:"<div style='font-size:8px'>重盐云商版权所有</div><div style='font-size:8px'>Copyright © 2016 go.cqsalt.cn All Rights Reserved </div>"
			},this._bottomPane.domNode)
			this.resize();
		},
		moveToAbout:function(){
			article.loadPlatformByTitle("关于重盐云商").then(lang.hitch(this,function(data){
				if(data.data.ok===1){
					moveToView("helpVerification","关于重盐云商");
				}else{
					alert("暂无介绍");
				}
			}))
		}
	})
})