/**
 * Writer 杜飞军
 * Create Time 2016/05/20
 **/
//isEditing的处理
//编辑界面的日期或事件不需要自己转换
//格式(缩进。空格)
//命名。大小写
//语句后的空格

define([
    'dojo/_base/declare',
    'dojo/_base/lang',
    'dojo/_base/array',
    'dojo/dom-attr',
    'dojo/dom-class',
    'dijit/registry',
    'dojox/mobile/View',
    'cq/ui/view/_ViewMixin',
    'cq/biz/mat/mat',
    'cq/biz/mk/discount',
    'cq/util/sys/date',
    'cq/util/edit/jsonRef'
], function(declare, lang, array, domAttr, domClass, registry, View, _ViewMixin, mat, disCount, date, jsonRef) {
    // module:
    //        cq/ui/b/s/AddCoupon
    return declare('cq.ui.b.addCoupon', [
        View, _ViewMixin
    ], {
        // 编辑状态
        isEditing: false,
        // 保留历史数据
        historyData: {},
        onAfterShow: function() {
            // 选择事件后会导致重新请求 判断状态
            if (!this.isEditing) {
                // 清空上一次留下的历史数据
                this.historyData = {};
                if (this.matItem) {
                    this.matItem.destroyRendering();
                }
                this.isEditing = true;
                // 页面加载重新获取路由
                this.searchParams.target = mat.getOnSaleUrl();
                if (window.did) {
                    disCount.loadById(window.did).then(lang.hitch(this, function(data) {
                        if (data && data.data.item) {
                            // 活动有效期时间转换
                            //data.data.item.validDate  = date.formatISODate(data.data.item.validDate);
                            this.setData(data.data.item);
                            this.isShow = data.data.item.wholeUse;
                            if (this.isShow) {
                                domClass.add(this.footerButton, 'none');
                            } else {
                                domClass.remove(this.footerButton, 'none');
                            }
                            this.historyData = lang.clone(data.data.item);
                            this.createItem(data.data.item.mIds, true);
                            this.resize();
                            this.refreshData();
                        }
                    }));
                } else {
                    // 如果页面先通过did进来 再从添加活动入口进来 会有数据 先清空
                    this.setData({using: true, wholeUse: true});
                    this.isShow = true;
                    domClass.add(this.footerButton, 'none');
                    this.refreshData();
                }
            }
        },
        // 设置查询商品的参数
        searchParams: {
            target: mat.getOnSaleUrl(),
            searchField: 'search',
            labelField: 'mName',
            multiselect: 'multiselect',
            query: {
                isUse: true
            }
        },
        // 提供重写的列表
        itemList: function() {
            return {
                class: 'bottom-margin16',
                isEdge: true,
                lists: [
                    {
                        label: '活动名称',
                        rightText: '',
                        edit: {
                            type: 'text',
                            field: 'title'
                        }
                    }, {
                        label: '活动开始时间',
                        rightText: '',
                        moveTo: '#',
                        edit: {
                            type: 'dateMin',
                            field: 'startDate'
                        }
                    }, {
                        label: '活动结束时间',
                        rightText: '',
                        moveTo: '#',
                        edit: {
                            type: 'dateMin',
                            field: 'stopDate'
                        }
                    }, {
                        label: '发放数量',
                        rightText: '',
                        edit: {
                            type: 'text',
                            field: 'totalNum'
                        }
                    }, {
                        label: '满抵金额',
                        rightText: '',
                        edit: {
                            type: 'text',
                            field: 'reachAmount'
                        }
                    }, {
                        label: '抵用金额',
                        rightText: '',
                        edit: {
                            type: 'text',
                            field: 'amount'
                        }
                    }, {
                        label: '会员领取限额',
                        rightText: '',
                        edit: {
                            type: 'text',
                            field: 'userQuota'
                        }
                    }, {
                        label: '是否使用',
                        rightText: '',
                        moveTo: '#',
                        edit: {
                            type: 'checkbox',
                            field: 'using'
                        }
                    },
                    {
                        label: '活动类型',
                        rightText: '',
                        moveTo: '#',
                        edit: {
                            type: 'options',
                            field: 'typeId',
                            options: {
                                1: '抽奖活动',
                                //2: '新客奖品',
                                3: '注册优惠',
                                4: '其他'
                            }
                        }
                    }, {
                        label: '活动说明',
                        rightText: '',
                        moveTo: '#',
                        edit: {
                            type: 'textarea',
                            field: 'remark'
                        }
                    }, {
                        label: '是否全店通用',
                        rightText: '',
                        moveTo: '#',
                        edit: {
                            type: 'checkbox',
                            field: 'wholeUse'
                        },
                        onClick: lang.hitch(this, function(e) {
                            var domNode = registry.getEnclosingWidget(e.target);
                            if (e.target && domNode.declaredClass === 'dojox.mobile.Switch') {
                                if (this.isShow) {
                                    if (this.matItem && this.matItem.domNode) {
                                        domClass.remove(this.matItem.domNode, 'none');
                                    }
                                    domClass.remove(this.footerButton, 'none');
                                } else {
                                    if (this.matItem && this.matItem.domNode) {
                                        domClass.add(this.matItem.domNode, 'none');
                                    }
                                    domClass.add(this.footerButton, 'none');
                                }
                                this.isShow = !this.isShow;
                                this.resize();
                            }
                        })
                    }
                ]
            };
        },
        // 开始页面初始化
        onFirstShow: function() {
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: 'left',
                    label: '优惠活动',
                    onClick: lang.hitch(this, function() {
                        this.isEditing = false;
                        history.back();
                    })
                },
                title: '',
                right: {
                    iconButton: ' ',
                    onClick: lang.hitch(this, this.onComplete),
                    label: '完成'
                }
            };
            this.addHeader(option);
            this.addLists(this.itemList());
            // 添加底部按钮
            option = {
                columns: [
                    {
                        label: '添加商品',
                        className: 'flex2 footer-tab-highlight noverify',
                        onClick: function() {
                            var val = this.getData();
                            if (val.wholeUse) {
                                alert('全店通用下不能选择商品');
                                return;
                            }
                            if (this.matItem) {
                                this.matItem.destroyRendering();
                            }
                            //调用jsonRef的方法，读取到数据之后，setValue，onFieldChanged
                            jsonRef.startEdit(val.mIds || '', this, this.searchParams).then(lang.hitch(this, function(value) {
                                if (value.length) {
                                    var data = array.map(value, function(item) {
                                        return {'_id': item._id, mId: item._id, mName: item.mName};
                                    });
                                    val.mIds = data;
                                    this.setData(val);
                                    this.createItem(data, true);
                                }
                            }));
                        }
                    }
                ],
                forceWidth: false,
                isFooter: true
            };
            this.footerButton = this.addColumns(option);
            this.onAfterShow();
        },
        // 依据数据创建内容
        createItem: function(data, deleteState) {
            if (!lang.isArray(data)) {
                return;
            }
            var option = {
                isEdge: true,
                lists: []
            };
            array.forEach(data, lang.hitch(this, function(item) {
                option.lists.push({
                    label: item.mName,
                    rightText: (deleteState && '<san class="cg_delete" id=' + item.mId + '>删除</span>') || '',
                    moveTo: '',
                    onClick: lang.hitch(this, function(e) {
                        var dom = e.target;
                        if (deleteState && domClass.contains(dom, 'cg_delete')) {
                            var domNode = registry.getEnclosingWidget(dom);
                            if (domNode.declaredClass === 'dojox.mobile.ListItem') {
                                var id = domAttr.get(dom, 'id');
                                var info = this.getData();
                                array.forEach(info.mIds, lang.hitch(this, function(item, key) {
                                    if (item && item.mId === id) {
                                        info.mIds.splice(key, 1);
                                        this.setData(info);
                                        domNode.destroy();
                                    }
                                }));
                            }
                        }
                    })
                });
            }));
            this.matItem = this.addLists(option);
        },
        // 验证数据
        onVerify: function() {
            var data = this.getData(),
                msg = '',
                time = new Date();

            // 增加活动开始后到活动结束前可以修改优惠券可使用商品内容
            //      其他活动信息都不能进行修改

            // 查看原始数据中是否存在_id以确认活动已经被创建
            if (this.historyData._id) {
                // 判断是否在活动中 并且没有失效
                if ((Date.parse(data.startDate) - Date.parse(time)) < 0 && (Date.parse(data.stopDate) - Date.parse(time)) > 0 && this.historyData.using) {
                    // 清除历史数据的mIds
                    delete this.historyData.mIds;
                    // 移除历史数据中的wholeUse
                    delete this.historyData.wholeUse;
                    // 对比数据查看是否被修改
                    for (var i in this.historyData) {
                        if (this.historyData[i] !== data[i]) {
                            msg = '只能修改可使用优惠券商品';
                            alert(msg);
                            return false;
                        }
                    }
                }
            } else {
                // 新增加活动
                if (!data.title) {
                    msg = '活动名称不能为空';
                } else if (!data.startDate) {
                    msg = '开始时间必须填写';
                } else if (!data.stopDate) {
                    msg = '结束时间必须填写';
                } else if (Date.parse(data.stopDate) < Date.parse(data.startDate || 0)) {
                    msg = '活动结束时间不能小于开始时间';
                } else if ((Date.parse(data.startDate) - Date.parse(time)) < 0) {
                    //msg = '活动开始时间不能小于当前时间';
                    msg = "";
                } else if ((Date.parse(data.stopDate) - Date.parse(time)) < 0) {
                    msg = '活动结束时间不能小于当前时间';
                } else if (parseInt(data.totalNum || 0) < 0 || !(parseInt(data.totalNum) == data.totalNum)) {
                    msg = '发放数量不能小于0,并且只能为整数';
                } else if (parseInt(data.reachAmount || 0) < 0 || !(parseFloat(data.reachAmount) == data.reachAmount)) {
                    msg = '满抵金额金额不能小于0,并且只能为数字';
                } else if (parseInt(data.amount || 0) <= 0 || !(parseFloat(data.amount) == data.amount)) {
                    msg = '抵用金额金额不能小于等于0,并且只能为数字';
                } else if (parseFloat(data.amount || 0) >= parseFloat(data.reachAmount || 0)) {
                    msg = '抵用金额必须小于满抵金额';
                } else if (parseInt(data.userQuota) >= parseInt(data.totalNum)) {
                    msg = '会员领取限额必须小于发放数量';
                }
            }
            if (data.typeId == 1) {
                /*if (parseInt(data.totalNum) || parseInt(data.userQuota)) {
                    msg = '设置为活动奖品时，发行总量、会员限领不可设置';
                }*/
                //徐阿雪修改。。。2017/4/7抽奖优惠券需要总量
                if (parseInt(data.userQuota)) {
                    msg = '设置为活动奖品时，发行总量、会员限领不可设置';
                }
            }

            if (msg) {
                alert(msg);
                return false;
            } else {
                if (data.distributeType === 1) {
                    data.num = 0;
                } else if (data.distributeType === 0) {
                    if (data.num <= 0) {
                        alert('指定客户,发放优惠券必须大于0');
                        return false;
                    }
                }
                return true;
            }
        },
        hasStarted:function(){
            var time = new Date();
            return this.historyData._id && (Date.parse(this.historyData.startDate) - Date.parse(time)) < 0 && (Date.parse(this.historyData.stopDate) - Date.parse(time)) > 0 && this.historyData.using
        },
        // 完成提数据
        onComplete: function() {
            //若处于编辑状态
            //    设置为非编辑状态
            //    若数据不合法：
            //        给出提示
            //        设置为编辑状态
            //        返回
            //    否则
            //        调用接口保存
            //            若保存成功：
            //                切换到列表
            //            否则：设置为编辑状态，给出提示
            if (this.isEditing) {
                var data = this.getData();
                if(this.hasStarted()){
                    if(data.wholeUse){
                        data = {
                            _id:data._id,
                            wholeUse:true,
                            mIds:null
                        };
                    }else{
                        data = {
                            _id:data._id,
                            wholeUse:false,
                            mIds:data.mIds
                        };
                        if(!(data.mIds&&data.mIds.length)){
                            return alert("请选择商品");
                        }
                    }
                    window.busy();
                    disCount.upDateMatSelect(data).then(lang.hitch(this,function(dataMsg){
                        window.free();
                        if (dataMsg && dataMsg.data && dataMsg.data.ok === 1) {
                            this.isEditing = false;
                            history.back();
                        } else {
                            alert(dataMsg.data.message);
                        }
                    }));
                    return;
                }
                
                var canSave = this.onVerify();
                if (canSave) {
                    if (!data.wholeUse) {
                        if (!data.mIds.length) {
                            alert('必须选择商品');
                            return;
                        }
                    } else {
                        data.mIds = [];
                    }
                    window.busy();
                    // 新增调用保存方法
                    disCount.save(data).then(lang.hitch(this, function(dataMsg) {
                        window.free();
                        if (dataMsg && dataMsg.data && dataMsg.data.ok === 1) {
                            this.isEditing = false;
                            history.back();
                        } else {
                            alert(dataMsg.data.message);
                        }
                    }));
                }
            }
        }
    });
});
