// 创建人：周超
// 创建时间：2016-11-17
// 功能：平台交易记录
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-class",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "dojo/query",
    "dijit/registry",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojo/on",
	"cq/util/sys/date",
    "dojo/store/JsonRest",
    "cq/biz/ts/pay/bankStatement",
    "cq/util/config/config",
    "cq/util/sys/xlsx"
],function(declare,lang,array,domClass,View,_ViewMixin,query,registry,EdgeToEdgeStoreList,on,date,JsonRest,bankStatement,config,xlsx){
    // module:
    //        cq/ui/b/s/bankStatement
    return declare("cq.ui.b.s.BankStatement",[View,_ViewMixin],{
        // 数据加载开始下标
        start:0,
        end:-1,
        // 每次加载数据的条数
        pageSize : 10,
        // 查询的数据类型，默认为充值
        //state:1,
        onAfterShow:function(){
            if(this.storeList.store){
                if(this.autoRefresh == true){
                    this.setQuery(this.storeList.get("query"));
                    this.refreshData();
                    this.autoRefresh = false;
                }
            }else{
                this.autoRefresh = false;
                var queryResult = this.storeList.setStore(this.store,this.queryWhere,{
                    start: 0,
                    count: this.pageSize
                });
                this.onLoadListData(queryResult,this.start,this.pageSize);
                this.refreshData();
            }
        },
        onFirstShow:function(){
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "",
                    onClick : function() {
                        history.back();
                    }
                },
                title:"平台交易记录"
            };
            this.addHeader(option);
            option = {
                placeHolder:"输入搜索内容，按回车查询",
                "class":"cqSearchBox",
                type:"search",
                isHeader : true,
                onInput:lang.hitch(this,function(evt){
                    if(evt.keyCode==13){
                        this.search = evt.target.value;
                        var condition = this.storeList.get("query");
                        condition.search = evt.target.value;
                        this.setQuery(condition);
                        evt.target.value = "";
                    }
                })
            };
            this.addTextBox(option);
            option = {
                isHeader : true,
                columns:[{
                    label:'未审核',
                    onClick:lang.hitch(this,this.onStateUnconfir)
                },{
                    label:'已审核',
                    onClick:lang.hitch(this,this.onStateConfir)
                },{
                    label:'已完成',
                    onClick:lang.hitch(this,this.onStateComplet)
                }],
                labelClass:'font-size1 tab-selector'
            };
            this.addColumns(option);
            option = {
                isFooter : true,
                columns : [{
                    label : "导出",
					className: 'flex2 footer-tab-highlight',
                    onClick : this.exportShopBalance
                }],
                labelClass: 'font-size1',
                className: "fix-footer"
            };
            this.addColumns(option);
            this.storeList=new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query:{},
                "class":"icon-list-item",
                variableHeight:true,
                //获取数据完成后调用的的处理方法
                onComplete:lang.hitch(this,function(data){
                    for(var i=0;i<data.length;i++){
                        var itemData;
                        if(data[i].state){
                            if(1==data[i].state){
                                itemData = "未审核"
                            }
                            if(2==data[i].state){
                                itemData = "已审核"
                            }
                            if(3==data[i].state){
                                itemData = "已完成"
                            }
                        }else{
                            itemData = "";
                        }
                        data[i]._label="<div class='mat-list-mname mat-list-margin'>卖家名称："+(data[i].fromShopId.shopName||"")+
                            "</div><div class='mat-list-mname mat-list-margin'>支付日期："+(date.formatISODateMinutes(data[i].payDate)||"")+
                            "</div><div class='mat-list-qty mat-list-margin'><span>支付方式："+ config.getPayTypeStr(data[i].payType)+
                            "</div><div><span class='mat-list-margin'>支付金额："+(data[i].amount||"")+"</span><span class='mat-list-totalSale'>状态："+itemData+"</span></div>";
                        data[i].moveTo="#";
                    }
                    this.storeList.generateList(data);
                    this.end=this.start+data.length-1;
                    this.busy = false;
                }),
                queryOptions: {
                    count: this.pageSize,
                    start: this.start
                },
                itemMap:{
                    _label:"label",
                    moveTo:"moveTo"
                }
            });
            // 创建数据源
            this.queryWhere={
                state:1
            };
            this.store = new JsonRest({target:bankStatement.load()});
            // 将数据源赋值给storeList
            this.storeList.placeAt(this.centerPanel.containerNode,"last");
            this.storeList.on("click",lang.hitch(this,this.onClickList));
            this.own(on(this.centerPanel,"afterscroll",lang.hitch(this,this.onLoadMore)));
            //首次进入默认未审核按钮选中
            domClass.add(query('.tab-selector', this.domNode)[0], "selected");
            this.onAfterShow();
        },		
        //数据导出功能
        exportShopBalance : function(){
            var query = this.storeList.query;
            var url = bankStatement.load();
            var cols = [];
            cols[0] = {
                className:"large-width",
                field:"buyerShopId.shopName",
                label:"买家名称",
            };
            cols[1] = {
                className:"large-width",
                field:"fromShopId.shopName",
                label:"卖家名称",
            };
            cols[2] = {
                type:"dateMin",
                className:"large-width",
                field:"payDate",
                label:"支付日期",
            };
            cols[3] = {
                type:"options",
                className:"large-width",
                field:"payType",
                label:"支付方式",
                options : config.orderPayType
            };
            cols[4] = {
                className:"large-width",
                field:"amount",
                label:"支付金额"
            };
            cols[5] = {
                className:"large-width",
                field:"feeAmount",
                label:"手续费"
            };
            cols[6] = {
                className:"large-width",
                field:"actualAmount",
                label:"实收金额"
            };
            cols[7] = {
                type : "options",
                className : "large-width",
                field : "tranStatus",
                label : "交易状态",
                options : {
                    1 : "成功",
                    2 : "失败",
                    4 : "扣款成功"
                }
            };
            //1成功；2失败；4扣款成功
            cols[8] = {
                className : "large-width",
                field : "transSeq",
                label : "交易流水号"
            };
            cols[9] = {
                className : "large-width",
                field : "merchantNo",
                label : "商户号"
            };
            cols[10] = {
                className : "large-width",
                field : "bankName",
                label : "付款银行"
            };
            cols[11] = {
                className : "large-width",
                field : "bankAccountCode",
                label : "付款账号"
            };
            cols[12] = {
                className : "large-width",
                field : "bankAccountName",
                label : "付款账号名称"
            };
            cols[13] = {
                type : "options",
                className : "large-width",
                field : "state",
                label : "状态",
                options : {
                    1 : "待确认",
                    2 : "已确认",
                    3 : "已完成"
                }
            };
            cols[14] = {
                className : "large-width",
                field : "tsId",
                label : "订单Id"
            };
            xlsx.exportData(url,query,cols,Date.now().toString());
        },
        // 改变标签的样式
        claerLabelClass:function(evnt){
            array.forEach(query(".tab-selector",this.domNode),function(item){
                domClass.remove(item,"selected");
            });
            domClass.add(evnt.target,"selected");
        },
        // 待确认
        onStateUnconfir:function(evt){
            this.claerLabelClass(evt);
            var parms=this.storeList.get("query");
            //1：待确认2：已确认3：已完成
            parms.state=1;
            this.setQuery(parms);
        },
        // 已确认
        onStateComplet: function(evt){
            this.claerLabelClass(evt);
            var parms=this.storeList.get("query");
            //1：待确认2：已确认3：已完成
            parms.state=3;
            this.setQuery(parms);
        },
        // 已完成
        onStateConfir: function(evt){
            this.claerLabelClass(evt);
            var parms=this.storeList.get("query");
            //1：待确认2：已确认3：已完成
            parms.state=2;
            this.setQuery(parms);
        },
        // 列表项的点击事件
        onClickList:function(evt){
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            if(li.declaredClass!="dojox.mobile.ListItem") return;
            var _id = li.params._id;
            window.moveToView("bankStatementDetail",_id);
        },
        onLoadMore : function (evt) {
            if (!this.busy && evt.afterBottom) {
                this.start = this.start + this.pageSize;
                if (this.canLoadMore(this.start)){
                    this.busy = true;
                    setTimeout(lang.hitch(this, function () {
                        var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        });
                        this.onLoadListData(queryResult,this.start,this.pageSize);
                }), 1000);
                }
            }
        },
        setQuery:function(query){
            this.start = 0;
            this.end = -1;
            this.storeList.destroyDescendants();
            // 依据查询条件加载数据
            var queryResult = this.storeList.setQuery(query, {
                start : this.start,
                count : this.pageSize
            });
            //依据加载数据得结果处理界面显示
            this.onLoadListData(queryResult,this.start,this.pageSize);
        }
    });
});