// 创建人：周超
// 创建时间：2016-11-17
// 功能：平台交易记录详情
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "dojo/query",
    "cq/util/config/config",
    "cq/biz/ts/pay/bankStatement",
	"cq/util/sys/date",
    "dojo/dom-style",
],function (declare, lang, View, _ViewMixin, query, config, bankStatement, date,domStyle) {
    // module:
    //        cq/ui/b/s/BankStatementDetail
    return declare("cq.ui.b.s.BankStatementDetail", [View, _ViewMixin], {
        onAfterShow : function () {
            bankStatement.loadById(window.did).then(lang.hitch(this,function(data){
                // 已审核的数据
                var item = data.data.item;
                if(1 == item.state){
                    //未审核 显示审核按钮verified
                    domStyle.set(query(".verify", this.footerColumns)[0],"display", "");
                }else{
                    domStyle.set(query(".verify", this.footerColumns)[0],"display", "none");
                }
                this.setData(this.getPageData(item));
                this.refreshData();
            }));
        },		
        getPageData : function (item) {
            var data ={};
            data.buyerShopId = item.buyerShopId.shopName;
            data.fromShopId = item.fromShopId.shopName;
            data.payDate = date.formatISODateMinutes(item.payDate);
            data.payType = config.getPayTypeStr(item.payType);
            data.amount = item.amount;
            data.feeAmount = item.feeAmount;
            data.actualAmount = item.actualAmount;			
            //1成功；2失败；4扣款成功
            if(item.tranStatus){
                if(1==item.tranStatus){
                    data.tranStatus = "成功";
                }
                if(2==item.tranStatus){
                    data.tranStatus = "失败";
                }
                if(4==item.tranStatus){
                    data.tranStatus = "扣款成功";
                }
            }
            data.transSeq = item.transSeq;
            data.merchantNo = item.merchantNo;
            data.bankName = item.bankName;
            data.bankAccountCode = item.bankAccountCode;
            data.bankAccountName = item.bankAccountName;
            if(data.state){
                if(1==item.state){
                    data.state = "未审核";
                }
                if(2==item.state){
                    data.state = "已审核";
                }
                if(3==item.state){
                    data.state = "已完成";
                }
            }else{
                data.state = "";
            }
            data.tsId = item.tsId;
            return data;
        },
        onFirstShow : function () {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "",
                    onClick : function () {
                        history.back();
                    }
                },
                title : "平台交易记录"
            };
            this.addHeader(option);
            option = {
                isEdge : true,
                'class' :'bottom-margin16',
                lists : [{
                    label :　'买家',
                    rightText : "{{buyerShopId}}"
                }, {
                    label : '卖家',
                    rightText : '{{fromShopId}}'
                }]
            };
            this.addLists(option);
            option = {
                isEdge : true,
                'class' :'bottom-margin16',
                lists : [{
                    label : '支付日期',
                    rightText : '{{payDate}}'
                }, {
                    label : '支付方式',
                    rightText : '{{payType}}'
                }, {
                    label : '支付金额',
                    rightText : '{{amount}}'
                }, {
                    label : '手续费',
                    rightText : '{{feeAmount}}'
                }, {
                    label : '实收金额',
                    rightText : '{{actualAmount}}'
                }, {
                    label : '交易状态',
                    rightText : '{{tranStatus}}'
                }, {
                    label : '交易流水号',
                    rightText : '{{transSeq}}'
                }]
            };
            this.addLists(option);
            option = {
                isEdge : true,
                'class' :'bottom-margin16',
                lists : [{
                    label : '商户号',
                    rightText : '{{merchantNo}}'
                }, {
                    label : '付款银行',
                    rightText : '{{bankName}}'
                }, {
                    label : '付款账号',
                    rightText : '{{bankAccountCode}}'
                }, {
                    label : '付款名称',
                    rightText : '{{bankAccountName}}'
                }, {
                    label : '状态',
                    rightText : '{{state}}'
                }, {
                    label : '订单',
                    rightText : '{{tsId}}'
                }]
            };
            this.addLists(option);
            // 添加底部按钮
            option = {
                isEdge : true,
                columns :[{
                    label : '审核',
                    className : 'flex2 footer-tab-highlight verify',
                    onClick : lang.hitch(this,this.onVerify)
                }],
                forceWidth : false,
                isFooter : true
            };
            this.footerColumns=this.addColumns(option);
            this.onAfterShow();
        },
        onVerify : function(){
            bankStatement.verify(window.did).then(lang.hitch(this,function(backData){
				if(1 == backData.data.ok){
					alert("审核成功");
					this.onAfterShow();
				}else{
					alert("服务器繁忙，请稍后再试");
				}
		   }));
        }
    });
});