define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/biz/mk/policy/basicRate",
	"cq/biz/shop/shop"
    ],
    function (declare, lang, View, _ViewMixin, basicRate, shop) {        
        return declare("cq.ui.b.s.BasicRate", [View, _ViewMixin], {            
            //    平台设置：依据商家设置基础服务费            
            isEditing:false,            
            onAfterShow:function(){
                if (!this.isEditing) {
                    //页面状态设置为修改中
                    this.isEditing=true;
					if (!window.did) {
						this.setData({});
						this.refreshData();
					} else {
						// 如果是修改，加载信息
						basicRate.loadById(window.did).then(lang.hitch(this, function(data) {
							// 显示信息                        
							this.setData(data.data.item);
							this.refreshData();
						}));
					}                    
                }
            },
            onFirstShow : function () {
                var option = {
                    left : {
                        iconButton : ' ',
                        arrow : "left",
                        label : "",
                        onClick : function () {
                            this.isEditing = false;                            
                            history.back();
                        }
                    },
                    right : {
                        iconButton : ' ',
                        onClick : this.onSaveStore,
                        label : "完成"
                    },
                    title : "基础服务费"
                };
                this.addHeader(option);
                option = {
                    isEdge : true,
                    class : "bottom-margin16",
                    lists : [{
						label: '供货商',
						moveTo: "#",
						__view_id: this.id,
						edit: {
							type: 'ref',
							field: 'fromShopId',							
							params: {
								target: shop.load_verifyshops_by_platform(),
								query: {},
								searchField: "search",
								labelField: "shopName",
								getDataLabel: function(items) {
									return "<div style='float:left; width:100%;'>" + items.shopName + "</div><div style='clear:both;'></div>";
								}
							}
						}
					},{
						label : '基础费率',
						noArrow : true,
						edit : {
							type : 'text',
							field : 'basicRate'
						}
					}, {
                        label: '开始时间',
                        rightText: '',
                        moveTo: '#',
                        edit: {
                            type: 'dateMin',
                            field: 'startDate'
                        }
                    }, {
                        label: '结束时间',
                        rightText: '',
                        moveTo: '#',
                        edit: {
                            type: 'dateMin',
                            field: 'endDate'
                        }
                    }]
                };
                this.addLists(option);                                
                //加载页面数据
                this.onAfterShow();
            },            
            onSaveStore : function () {
                var basicData = this.getData();                
                //设置费率
                if(basicData.basicRate){
                    var payRate=parseFloat(basicData.basicRate);
                    if(payRate>1||payRate<0||isNaN(payRate)){
                        alert('费率浮动范围应为0~1');
                        return;
                    }
                }
				if(!basicData.fromShopId){
					alert('供货商必须选择');
					return;
                }
                if(!basicData.startDate){
					alert('开始时间必须设置');
					return;
                }
                window.busy();
                var parm = {};
                parm.fromShopId = basicData.fromShopId._id;//window.did;
                parm.shopId = shop.getShopId();
                //  接口应为加载指定供货商费率的数组（暂未修改）
                basicRate.load(parm).then(lang.hitch(this,function(result){
                    var tesData = result.data.items;
                    for(var i = 0;i<tesData.length;i++){
                        //  时间相冲突的两种情况
                        //  1：开始时间在其两者之间
                        //  2：结束时间在其两者之间
                        var timeTesStr = basicData.startDate>tesData[i].startDate&&basicData.startDate<tesData[i].endDate;
                        var timeTesEnd = basicData.endDate > tesData[i].startDate&&basicData.endDate<tesData[i].endDate;
                        if(timeTesStr||timeTesEnd){
                            alert("请检查开始时间或者结束时间是否和之前记录冲突");
                            return
                        }
                    }
                    basicRate.save(basicData).then(lang.hitch(this,function (data) {
                        window.free();
                        if(data.data.ok === 1){
                            this.isEditing = false;                        
                            history.back();
                            alert("保存成功");
                        }else{
                            alert("保存失败");
                        }
                    }));
                }));
            }
    });
});