define([
    "dojo/_base/declare",
    "dojo/_base/lang",
	"dojo/dom-class",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "dijit/registry",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojo/on",
    "dojo/when",
    "dojo/store/JsonRest",
    "cq/biz/mk/policy/basicRate",    
	"cq/util/sys/date"
],function(declare, lang, domClass, View, _ViewMixin, registry, EdgeToEdgeStoreList,on,when, JsonRest, basicRate, date){    
    return declare("cq.ui.b.s.BasicRateList",[View,_ViewMixin],{
        // 初始化开始值
        start:0,
        end:-1,
        pageSize : 20,
        // 设置查询条件
        setQuery:function(query){
            this.start = 0;
            this.end = -1;
            this.basicRateList.destroyDescendants();
            var queryResult = this.basicRateList.setQuery(query, {
                start : this.start,
                count : this.pageSize
            });
            this.onLoadListData(queryResult,this.start,this.pageSize);
            this.centerPanel.resize();
        },
        // 初始化相关接口
        onAfterShow:function(){
            if(this.basicRateList.store){
                this.setQuery(this.params);
            }else{
                this.store = new JsonRest({target:basicRate.getLoadUrl()});
                var queryResult = this.basicRateList.setStore(this.store,this.params,{
                    start:this.start,
                    count:this.pageSize
                });
                this.onLoadListData(queryResult,this.start,this.pageSize);
                this.centerPanel.resize();
            }
           // this.refreshData();
        },        
        // 初始化加载显示内容
        onFirstShow:function(){
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "",
                    onClick : function() {                        
                        history.back();
                    }
                },
                onClick:function(){},
                title:"基础服务费"
            };
            this.addHeader(option);
            option = {
                placeHolder:"请输入要查询的条件，按回车查询",
                class:"cqSearchBox",
                type:"search",
                isHeader:true,
                onInput:lang.hitch(this,function(evt){
                    if(evt.keyCode==13){
                        this.search = evt.target.value;
                        var condition = this.basicRateList.get("query");
                        condition.search = evt.target.value;
                        this.setQuery(condition);
                        condition.search = "";
                        evt.target.value = "";
                    }
                })
            };
            this.addTextBox(option);
            
            option = this.getBottomButtonOptions();
            this.addColumns(option);
            // 创建数据源
            this.basicRateList = new EdgeToEdgeStoreList({
                append: true,
                constraint: false,
                query:{},
                class:"icon-list-item",
                variableHeight:true,
                onComplete:lang.hitch(this,function(datas){
                    var data = datas;
                    for(var i=0;i<data.length;i++){
						data[i]._label = "<div>"
                            +"<div class='user-list-margin'>供货商："+((data[i].fromShopId&&data[i].fromShopId.shopName)? (data[i].fromShopId.shopName): '')+"</div>"
                            +"</div>"
                            +"<div class='webkit-list'>"
							+"<div class='user-list-margin'>基础费率："+((data[i].basicRate)? (data[i].basicRate): 0)+"</div>"
                            +"</div>"
                            +"<div class='webkit-list'>"
                            +"<div class='user-list-margin'>时间段："+(data[i].startDate?date.formatISODateMinutes(data[i].startDate):'')+(data[i].endDate?("~"+date.formatISODateMinutes(data[i].endDate)):'')+"</div>"
                            +"</div>"
                            +"<div class='forth-btn'>"
                            +"<span class='delete float-right'>删除</span>"
                            +"<span class='edit float-right'>编辑</span>"
                            +"</div>";           
                    }
                    this.basicRateList.generateList(data);
                    this.end=this.start+data.length-1;
                    this.busy = false;
                }),
                // 查询条件
                queryOptions: {
                    count: 20,
                    start: this.start
                },
                itemMap:{
                    _label:"label",                    
                    moveTo:"moveTo"
                }
            });
            // 创建数据源
            this.params = {};            
            this.basicRateList.placeAt(this.centerPanel.containerNode,"last");
            this.basicRateList.on("click",lang.hitch(this,this.onClickList));
            this.centerPanel.on("afterscroll",lang.hitch(this,this.onLoadMore));
            this.onAfterShow();
        },
        getBottomButtonOptions:function(){
            return {
                columns:[{
                    label:'添加服务费',
                    className: "footer-tab-highlight",
                    onClick:function(){
                        window.moveToView("basicRate");
                    }
                }],                
                labelClass:'font-size1',
                className:'fix-footer',
                isFooter:true
            };
        },
        // 重写List的点击事件
        onClickList:function(evt){
            // 得到点击的ListItem
            var li = registry.getEnclosingWidget(evt.target);
            if(li.declaredClass!="dojox.mobile.ListItem"){
                return;
            }
            var dom = evt.target;
            var _id = li.params._id;
			//编辑
            if (dom && domClass.contains(dom, "edit")) {
                window.moveToView("basicRate",_id);
            }
            //删除
            if (dom && domClass.contains(dom, "delete")) {
                var isDelete = confirm("确认删除?");
                if (isDelete) {
                    basicRate.deleteById(_id).then(lang.hitch(this, function(data) {
                        if (data.data.ok === 1) {
                            alert("删除成功");
                            this.onAfterShow();
                        } else {
                            alert("删除失败");
                        }
                    }));
                }
            }
        },
        // 重写拖拽加载更多事件
        onLoadMore:function(evt){
			//判断下拉方向和能否加载
            if(!this.busy&&evt.afterBottom){
				//设置本次加载内容的起始位置
                this.start = this.start + this.pageSize;
				//判断能否加载更多内容
				if(this.canLoadMore(this.start)){
					console.log("加载更多");
                    this.busy = true;
                    setTimeout(lang.hitch(this, function () {
						//执行加载内容操作
                        var queryResult = this.basicRateList.setQuery(this.basicRateList.get("query"), {
                            start : this.start,
                            count : this.pageSize
                        });
						//执行加载更多函数
                        this.onLoadListData(queryResult,this.start,this.pageSize);
                    }), 1000);
				}
            }
        }
    });
});