/**
 * 创建人: 周超
 * 创建时间: 2017-1-18
 * 创建内容: 营销费率详情
 */
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/on",
    "dojo/dom-style",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/query",
    "dijit/registry",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/biz/user/user",
    "cq/biz/mat/mat",
    "cq/util/sys/date",
    "cq/biz/shop/shopUser",
    "cq/biz/mk/policy/marketingRate",
    "cq/util/edit/jsonRef"
], function(declare, lang, array, on, domStyle, domAttr, domClass, query, registry, View, _ViewMixin, user, mat, date, shopUser,marketingRate,jsonRef) {
    return declare("cq.ui.b.s.MarketingRate", [View, _ViewMixin], {
        isEditing: false,
        rates : [],
        onAfterShow: function() {
            // 选择事件后会导致重新请求 判断状态
            if (!this.isEditing) {
                // 清空上一次留下的历史数据
                this.historyData = {};
                if (this.matItem) {
                    this.destroyAction();
                }
                this.isEditing = true;
                // 页面加载重新获取路由
                this.searchParams.target = mat.getOnSaleUrl();
                if (window.did) {
                    marketingRate.loadById(window.did).then(lang.hitch(this, function(data) {
                        if (data && data.data.item) {
                            // 活动有效期时间转换
                            //data.data.item.validDate  = date.formatISODate(data.data.item.validDate);
                            this.setData(data.data.item);
                            this.isShow = data.data.item.isAllUse;
                            if (this.isShow) {
                                domClass.add(this.footerButton, 'none');
                            } else {
                                domClass.remove(this.footerButton, 'none');
                            }
                            this.historyData = lang.clone(data.data.item);
                            this.createItem(data.data.item.mIds, true);
                            this.resize();
                            this.refreshData();
                        }
                    }));
                } else {
                    this.setData({isAllUse:true});
                    this.isShow = true;
                    domClass.add(this.footerButton, 'none');
                    this.refreshData();
                }
            }
        },
        onFirstShow: function() {
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "",
                    onClick: function() {
                        history.back();
                        this.isEditing = false;
                        this.isWritePass = true;
                    }
                },
                title: "营销费率",
                right: {
                    iconButton: ' ',
                    onClick: this.saveMarketRate,
                    label: "完成"
                }
            };
            this.addHeader(option);

            option = {
                isEdge: true,
                lists: [{
                    label : '标题',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'title',
                        placeHolder : "未填写"
                    }
                },{
                    label : '单品费率',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'rate',
                        placeHolder : "未填写"
                    }
                },{
                    label : '开始时间',
                    noArrow : true,
                    edit : {
                        type : 'dateMin',
                        field : 'startDate',
                        placeHolder : "未填写"
                    }
                },{
                    label : '结束时间',
                    noArrow : true,
                    edit : {
                        type : 'dateMin',
                        field : 'endDate',
                        placeHolder : "未填写"
                    }
                },{
                    label: '是否全店通用',
                    rightText: '',
                    moveTo: '#',
                    edit: {
                        type: 'checkbox',
                        field: 'isAllUse'
                    },
                    onClick: lang.hitch(this, function(e) {
                        var domNode = registry.getEnclosingWidget(e.target);
                        if (e.target && domNode.declaredClass === 'dojox.mobile.Switch') {
                            if (this.isShow) {
                                if (this.matItem && this.matItem.domNode) {
                                    domClass.remove(this.matItem.domNode, 'none');
                                }
                                domClass.remove(this.footerButton, 'none');
                            } else {
                                if (this.matItem && this.matItem.domNode) {
                                    domClass.add(this.matItem.domNode, 'none');
                                }
                                domClass.add(this.footerButton, 'none');
                            }
                            this.isShow = !this.isShow;
                            this.resize();
                        }
                    })
                }],
                class: "top-bottom-margin16"
            };
            this.addLists(option);
			option = {
                columns : [{
                        label : '添加单品',
                        className : 'cancelrecommend footer-tab-dark flex1 merchantbutton',
                        onClick : function () {
                            var val = this.getData();
                            if (val.wholeUse) {
                                alert('全店通用下不能选择商品');
                                return;
                            }
                            //this.singleFee = prompt("请输入单品费率");
                            //var dataMids;
                            //调用jsonRef的方法，读取到数据之后，setValue，onFieldChanged
                            jsonRef.startEdit(val.mIds || '', this, this.searchParams).then(lang.hitch(this, function(value) {
                                if (value.length) {
                                    var data = array.map(value, function(item) {
                                        return {'_id': item._id, mId: item._id, mName: item.mName};
                                    });
                                    val.mIds = data;
                                    this.setData(val);
                                    this.createItem(data, true);
                                    //dataMids = data;
                                }
                                //var data = {rate:this.singleFee,mids:dataMids};
                                //this.rates.push(data);
                            }));
                        }
                    }
                ],
                forceWidth : false,
                isFooter : true
            }
            this.footerButton = this.addColumns(option);
            this.onAfterShow();
        },
        // 设置查询商品的参数
        searchParams: {
            target: mat.getOnSaleUrl(),
            searchField: 'search',
            labelField: 'mName',
            multiselect: 'multiselect',
            query: {
                isUse: true
            }
        },
        //  销毁商品部分列表
        //  注：将弃用
        destroyAction: function(){
            var listFeeNode = dojo.query(".mblEdgeToEdgeList",this.domNode);
            for(var i=1;i<listFeeNode.length;i++){
                var domNode = registry.getEnclosingWidget(listFeeNode[i]);
                domNode.destroy();
            }
        },
        //  遍历新增加的list
        arrayMap: function(){
            return array.map(this.expectionsList.getChildren(), function(listItem) {
                return listItem.params.data;
            });
        },
        createLabel: function(data,deleteState){
            var labelField = "";
            //for(var i=0;i<data.length;i++){
            //    if(i == 0){
            //        labelField = data[i].mName;
            //    }else{labelField += "，"+data[i].mName};
            //}
            var option = {
                isEdge: true,
                lists: []
            };
            array.forEach(data, lang.hitch(this, function(item) {
                option.lists.push({
                    label: item.mName,
                    rightText: (deleteState && '<san class="cg_delete" id=' + item.mId + '>删除</span>') || '',
                    moveTo: '',
                    onClick: lang.hitch(this, function(e) {
                        var dom = e.target;
                        if (deleteState && domClass.contains(dom, 'cg_delete')) {
                            var domNode = registry.getEnclosingWidget(dom);
                            if (domNode.declaredClass === 'dojox.mobile.ListItem') {
                                var id = domAttr.get(dom, 'id');
                                var info = this.getData();
                                array.forEach(info.mIds, lang.hitch(this, function(item, key) {
                                    if (item && item.mId === id) {
                                        info.mIds.splice(key, 1);
                                        this.setData(info);
                                        domNode.destroy();
                                    }
                                }));
                            }
                        }
                    })
                });
            }));
            this.matItem = this.addLists(option);
        },
        // 依据数据创建内容
        createItem: function(data, deleteState) {
            //  判断是否为加载出来的数据
            //if(data.mids.length>0){
                //this.createLabel(data.mids[i],deleteState
            //    for(var i=0;i<data.mids.length;i++){
                    //  单品费率
            //        this.createLabel(data.mids[i].mids,deleteState);
            //    }
            //}else{
                this.createLabel(data, deleteState);
            //}
        },
        //  保存检查
        seveMsg: function(data){
            var msg = "";
            if(!data.title){
                msg = "请输入标题";
            }
            if(!data.rate){
                msg = "请输入单品费率";
            }
            data.rate=parseFloat(data.rate);
            if(data.rate>1||data.rate<0||isNaN(data.rate)){
                msg = "费率浮动范围应为0~1";
            }
            if(!data.startDate){
                msg = "请选择开始时间";
            }
            if(!data.endDate){
                msg = "请选择结束时间";
            }
            var nowDate = date.nowISOString();//new Date();
            if(data.startDate){
                if(data.startDate<nowDate){
                    msg = "开始时间必须大于当前时间";
                }
            }
            if(data.startDate&&data.endDate){
                if(data.startDate>=data.endDate){
                    msg = "结束时间必须大于开始时间";
                }
            }
            if(!data.isAllUse&&data.mIds.length<1){
                msg = "商品还未选择";
            }
            return msg;
        },
        //  保存---OK
        saveMarketRate: function(){
            var data = this.getData();
            var msg = this.seveMsg(data);
            if(msg){
                alert(msg);
                return;
            }
            if(data.isAllUse){
                data.mIds = [];
            }
            marketingRate.save(data).then(lang.hitch(this,function(backData){
                if(backData&&backData.data&&backData.data.ok == 1){
                    alert("操作成功");
                    history.back();
                }else{
                    alert("操作失败");
                    return;
                }
                this.isEditing = false;
            }));
        }
    });
});
