﻿/*创建人：周科吉
  创建时间：2016-08-25
  创建内容：商品送编辑页面：包含title，wei，startTime，endTime,stopTime,amount,prizeId,isUse,mid
  */
  define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    'dojo/_base/array',
    'dojo/dom-attr',
    "dojo/query",
    'dojo/dom-class',
    'dijit/registry',
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/biz/mk/policy/sale",
    "cq/util/sys/date",
    "cq/biz/mk/prize/prize",
    "cq/biz/mat/mat",
    'cq/util/edit/jsonRef'
  ],function(declare,lang,array,domAttr,query,domClass,registry,View,_ViewMixin,sale,data,prize,mat,jsonRef){
        return declare("cq.ui.b.s.ShopAwardEdit",[View,_ViewMixin],{
            isEditing:false,
            //初始化界面元素
            onFirstShow:function(){
                var option = {
                    left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "商品送",
                    onClick: lang.hitch(this, function() {
                        this.isEditing = false;
                        history.back();
                        })
                    },
                    title: "",
                    right: {
                        iconButton: ' ',
                        onClick: lang.hitch(this, this.onComplete),
                        label: "完成"
                    }
                };
                this.addHeader(option);
                
                //添加编辑页面
                option = {
                    isEdge:true,
                    lists:[{
                        label:"标题",
                        rightText:"",
                        edit:{
                            type: "text",
                            field: "title"
                        }
                    },{
                        label: '赠送类型',
                        rightText: '',
                        moveTo: '#',
                        edit: {
                            type: 'options',
                            field: 'typeId',
                            options: {
                                1: '送积分',
                                2: '送抽奖'
                            }
                        }
                    },{
                        label:"开始时间",
                        rightText:"",
                        moveTo: "#",
                        edit:{
                            type: "dateMin",
                            field: "startTime"
                        } 
                    },{
                        label:"结束时间",
                        rightText:"",
                        moveTo: "#",
                        edit:{
                            type: "dateMin",
                            field: "endTime"
                        } 
                    },
                    {
                        label:"返点比率",
                        rightText:"",
                        edit:{
                            type: "text",
                            field: "amount",
                            placeHolder:"赠送积分的比率"
                        },
                        class:"amount"
                    },{
                        label:"抽奖活动",
                        noArrow:true,
                        rightText:"",
                        edit:{
                            type: "ref",
                            field: "prizeId",
                            params:{
                                target:prize.getLoadUrl(),
                                query:{},
                                searchField:"prizeName",
                                labelField:"prizeName"
                            }
                        },
                        class:"prizeId"
                    },{
                        label:"抽奖次数",
                        rightText:"",
                        edit:{
                            type: "text",
                            field: "prizeQty"
                        },
                        class:"prizeQty"
                    },
                    // {
                        // label:"活动商品",
                        // noArrow:true,
                        // rightText:"",
                        // edit:{
                            // type: "ref",
                            // field: "mId",
                            // params:{
                                // target:mat.getCurrentShopOnSaleUrl(),
                                // query:{},
                                // searchField:"mName",
                                // labelField:"mName"
                            // }
                        // }
                    // },
                    {
                        label: '是否生效',
                        rightText: "",
                        moveTo: "#",
                        edit: {
                            type: "checkbox",
                            field: "isUse"
                        }
                    },{
                        label: '全店通用',
                        rightText: "",
                        moveTo: "#",
                        edit: {
                            type: "checkbox",
                            field: "isAllUse"
                        },
                        onClick: lang.hitch(this, function(e) {
                            var domNode = registry.getEnclosingWidget(e.target);
                            if (e.target && domNode.declaredClass === 'dojox.mobile.Switch') {
                                if (this.isAllUseShow) {
                                    if (this.matItem && this.matItem.domNode) {
                                        domClass.remove(this.matItem.domNode, 'none');
                                    }
                                    domClass.remove(this.footerButton, 'none');
                                } else {
                                    if (this.matItem && this.matItem.domNode) {
                                        domClass.add(this.matItem.domNode, 'none');
                                    }
                                    domClass.add(this.footerButton, 'none');
                                }
                                this.isAllUseShow = !this.isAllUseShow;
                                this.resize();
                            }
                        })
                    }]
                };
                this.addLists(option);
                
                //添加底部按钮
                option = {
                    columns:[{
                        label : '添加活动商品',
                        className: 'flex2 footer-tab-highlight noverify',
                        onClick:function(){
                            var val = this.getData();
                            if (this.matItem) {
                                this.matItem.destroyRendering();
                            }
                            jsonRef.startEdit(val.mids || '', this, this.searchParams).then(lang.hitch(this, function(value) {
                                if (value.length) {
                                    var data = array.map(value, function(item) {
                                        return {'_id': item._id, mid: item._id, mName: item.mName};
                                    });
                                    val.mids = data;
                                    this.setData(val);
                                    this.createItem(data, true);
                                }
                            }));
                        }
                    }],
                    forceWidth: false,
                    isFooter:true
                }
                this.footerButton = this.addColumns(option);
                this.onAfterShow();
            },
            onAfterShow:function(){
                // 选择事件后会导致重新请求 判断状态
                if (!this.isEditing) {
                    // 清空上一次留下的历史数据
                    //this.historyData = {};
                    // 页面加载重新获取路由
                    if (this.matItem) {
                        this.matItem.destroyRendering();
                    }
                    this.isEditing = true;
                    this.searchParams.target = mat.getCurrentShopOnSaleUrl();
                    if (window.did) {
                        sale.loadById(window.did).then(lang.hitch(this, function(data) {
                            if (data && data.data && data.data.item) {
                                this.typeId = data.data.item.typeId;
                                if(this.typeId == 1){
                                    domClass.add(query(".prizeId",this.domNode)[0], 'none');
                                    domClass.add(query(".prizeQty",this.domNode)[0], 'none');
                                    domClass.remove(query(".amount",this.domNode)[0], 'none');
                                }else if(this.typeId == 2){
                                    domClass.add(query(".amount",this.domNode)[0], 'none');
                                    domClass.remove(query(".prizeId",this.domNode)[0], 'none');
                                    domClass.remove(query(".prizeQty",this.domNode)[0], 'none');
                                }else{
                                    domClass.add(query(".amount",this.domNode)[0], 'none');
                                    domClass.add(query(".prizeId",this.domNode)[0], 'none');
                                    domClass.add(query(".prizeQty",this.domNode)[0], 'none');
                                }
                                this.setData(data.data.item);
                                this.isAllUseShow = data.data.item.isAllUse;
                                if(this.isAllUseShow){
                                    domClass.add(this.footerButton, 'none');
                                }else{
                                    domClass.remove(this.footerButton, 'none');
                                }
                                //this.historyData = lang.clone(data.data.item);
                                this.createItem(data.data.item.mids, true);
                                this.resize();
                                this.refreshData();
                            }
                        }));
                    } else {
                        // 如果页面先通过did进来 再从添加活动入口进来 会有数据 先清空
                        domClass.add(query(".amount",this.domNode)[0], 'none');
                        domClass.add(query(".prizeId",this.domNode)[0], 'none');
                        domClass.add(query(".prizeQty",this.domNode)[0], 'none');
                        this.setData({ isUse: true, isAllUse:true});
                        this.isAllUseShow = true;
                        domClass.add(this.footerButton, 'none');
                        this.refreshData();
                    }
                }
            },
            // 验证数据
            onVerify: function() {
                this.isEditing = true;
                var data = this.getData(),
                    msg = "",
                    time = new Date();
                if (!data.title) {
                    msg = "活动名称不能为空";
                }else if(!data.startTime){
                    msg ="请设置活动开始时间";
                }else if ((Date.parse(data.startTime) - Date.parse(time)) < 0) {
                    msg = "活动开始时间不能小于当前时间";
                }else if(!data.endTime){
                    msg = "请设置活动结束时间";
                }else if(!data.typeId){
                    msg = "请选择赠送类型";
                } else if (Date.parse(data.endTime) < Date.parse(data.startTime || 0)) {
                    msg = "活动结束时间不能小于开始时间";
                } else if ((Date.parse(data.endTime) - Date.parse(time)) < 0) {
                    msg = "活动结束时间不能小于当前时间";
                }
                if(data.typeId == 1){
                    if(!data.amount){
                        msg = "请设置返点比率";
                    }
                    if(data.amount>1||data.amount<0){
                        msg = "返点比率必须在0~1之间";
                    }
                }
                if(data.typeId == 2){
                    if(!data.prizeId){
                        msg = "请选择抽奖活动";
                    }else if(!data.prizeQty){
                        msg = "请设置抽奖次数";
                    }else if (parseFloat(data.prizeQty || 0) < 0) {
                        msg = "抽奖次数不能小于0";
                    }
                }
                if (msg) {
                    alert(msg);
                    return false;
                } else {                   
                    return true;
                }
            },
            // 设置查询商品的参数
            searchParams: {
                target: mat.getCurrentShopOnSaleUrl(),
                searchField: 'search',
                labelField: 'mName',
                multiselect: 'multiselect',
                query: {
                    isUse: true
                }
            },
            // 完成提数据
            onComplete: function() {
                if (this.isEditing) {
                    var savePost = this.onVerify();
                    if (savePost) {
                        var data = this.getData();
                        //如果没有输入停止时间，默认跟结束时间相同
                        if(!data.stopTime){
                            data.stopTime=data.endTime;
                        }
                        if (!data.isAllUse) {
                            if (!data.mids) {
                                alert('必须选择商品');
                                return;
                            }
                        } else {
                            data.mids = [];
                        }
                        sale.save(data).then(lang.hitch(this, function(dataMsg) {
                            if (dataMsg.data.ok === 1) {
                                this.isEditing = false;
                                history.back();
                            } else {
                                alert(dataMsg.data.message);
                            }
                        }));
                    }
                }
            },
            onDataChanged : function(field, oldValue, newValue){
                var currentData= this.getData();
                if(field === "typeId"){
                    if(newValue){
                        if(currentData.typeId == 1){
                            domClass.add(query(".prizeId",this.domNode)[0], 'none');
                            domClass.add(query(".prizeQty",this.domNode)[0], 'none');
                            domClass.remove(query(".amount",this.domNode)[0], 'none');
                        }else if(currentData.typeId == 2){
                            domClass.remove(query(".prizeId",this.domNode)[0], 'none');
                            domClass.remove(query(".prizeQty",this.domNode)[0], 'none');
                            domClass.add(query(".amount",this.domNode)[0], 'none');
                        }
                    }
                }
                this.setData(currentData);
                this.refreshData();
            },
            createItem: function(data, deleteState) {
                if (!lang.isArray(data)) {
                    return;
                }
                var option = {
                    isEdge: true,
                    lists: []
                };
                array.forEach(data, lang.hitch(this, function(item) {
                    option.lists.push({
                        label: item.mName,
                        rightText: (deleteState && '<san class="cg_delete" id=' + item.mid + '>删除</span>') || '',
                        moveTo: '',
                        onClick: lang.hitch(this, function(e) {
                            var dom = e.target;
                            if (deleteState && domClass.contains(dom, 'cg_delete')) {
                                var domNode = registry.getEnclosingWidget(dom);
                                if (domNode.declaredClass === 'dojox.mobile.ListItem') {
                                    var id = domAttr.get(dom, 'id');
                                    var info = this.getData();
                                    array.forEach(info.mids, lang.hitch(this, function(item, key) {
                                        if (item && item.mid === id) {
                                            info.mids.splice(key, 1);
                                            this.setData(info);
                                            domNode.destroy();
                                        }
                                    }));
                                }
                            }
                        })
                    });
                }));
                this.matItem = this.addLists(option);
            }
        });
  });