// 变更人：徐阿雪
// 变更时间：2016/08/02
// 变更内容：只能查询本上架的订单，需要传商家Id，继承orderList

// 变更人：徐阿雪
// 变更时间：2017/1/6
// 变更内容：退货导致的根据订单查询状态的修改
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-class",
    "dojo/query",
    "cq/ui/common/ts/OrderList",
    "cq/biz/ts/order",
	"cq/biz/user/user",
    "cq/util/sys/date",
    "cq/util/sys/xlsx",
    "cq/util/config/config",
    "cq/bo/orderListSale3",
    "cq/widgets/item/OrderListItemB"
], function (declare,lang,array,domClass,query,OrderList,order,user,date,xlsx,config,orderListSale,OrderListItemB) {
    return declare("cq.ui.b.t.OrderListB", [OrderList], {
        OrderListItem:OrderListItemB,
        onAfterShow:function(){
            //处理选中问题
            this.changeTab();
            this.type=window.did;
			// 业务经理只能查看自己客户的订单
			user.getUserInfo().then(lang.hitch(this,function(data){
				this.queryWhere = {};
				if(data && data.data && data.data.item && data.data.item.role && data.data.item.role == 3){
					this.queryWhere.inviter = data.data.item._id;
				}					
				this.loadFirstPage(this.queryWhere);
				window.free();				
			}));
            //this.loadFirstPage();            
        },
        //订单详情界面id
        getOrderDetailView:function(){
            return "orderDetailB";
        },
        //加载订单列表的url
        getListTarget:function(){
            return order.getDetailsUrlByFromShop();
        },
        //头部状态的重写
        getStateColumn:function(){
            return {
                isHeader: true,
                columns:[{
                    label:'全部',
                    onClick:lang.hitch(this,function(e){
                        // 徐阿雪 修改movetoview，重写一个函数，获取不同type的数据，加载显示出来
                        this.type= "";
                        this.loadFirstPage(this.queryWhere);
                        this.changeTab(e);
                    })
                },{
                    label:'待审核',//
                    onClick:lang.hitch(this,function(e){
                        this.type = 0;
                        this.loadFirstPage(this.queryWhere);
                        this.changeTab(e);
                    })
                },{
                    label:'待发货',
                    className:'sale',
                    onClick:lang.hitch(this,function(e){
                        this.type = 1;
                        this.loadFirstPage(this.queryWhere);
                        this.changeTab(e);
                    })
                },{
                    label:'待收货',
                    onClick:lang.hitch(this,function(e){
                        this.type = 2;
                        this.loadFirstPage(this.queryWhere);
                        this.changeTab(e);
                    })
                },{
                    label:'待付款',
                    onClick:lang.hitch(this,function(e){
                        this.type = 3;
                        this.loadFirstPage(this.queryWhere);
                        this.changeTab(e);
                    })
                }],
                labelClass:'font-size1 tab-selector'
            };
        },
        changeTab: function(e){
            if(e){
                var dom = e.target;
                var items = query(".tab-selector",this.domNode);
                array.forEach(items,function(item){
                    domClass.remove(item,"selected");
                },this);
                domClass.add(dom,"selected");
            }else{
                var items = query(".tab-selector",this.domNode);
                array.forEach(items,function(item){
                    domClass.remove(item,"selected");
                },this);
                if(window.did||parseInt(window.did)==0){
                    //this.type=parseInt(window.did);
                    domClass.add(items[parseInt(window.did)+1],"selected");
                }else{
                    domClass.add(items[0],"selected");
                }
                
            }
        },
        showDelivereInfo:function(){
            var orderDnames = query(".order-dname",this.domNode);
            var orderDaddresses = query(".order-dAddress",this.domNode);
            for(var i = 0 ;i < orderDnames.length; i ++){
                domClass.remove(orderDnames[i],"none");
                domClass.remove(orderDaddresses[i],"none");
            }
        },
        // 订单查询时的属性
        getParse: function(type){
            type = type+"";
            if(type === "0"){
                //待审核：已支付，未取消，未审核
                //新增加refundState = 2
                return {
                    isPayed:true,
                    isCanceled:false,
                    isAccepted:false,
                    orderBy:'-createAt',
                    refundState:1
                };
            } else if(type === "1"){
                //待发货：已支付、未取消、未发货.已审核
                return {
                    isPayed:true,
                    isCanceled:false,
                    isAccepted:true,
                    isDelived:false,
                    orderBy:'-createAt',
                    refundState:1
                };
            }else if(type === "2"){
                //待收货：已支付、未取消、已发货、未收货
                return {
                    isPayed:true,
                    isCanceled:false,
                    isDelived:true,
                    isReceipted:false,
                    orderBy:'-createAt',
                    refundState:1
                };
            } else if(type === "3"){
                //代付款：未支付，未取消
                return {
                    isPayed:false,
                    isCanceled:false,
                    orderBy:'-createAt',
                    refundState:1
                };
            }else{
                return {
                    orderBy:'-createAt'
                };
            }
        },
        exportOrderList : function(){
            var query = this.storeList.query;
            var url = this.getListTarget();
            //var cols = orderListSale.getExportAppLayout();
            //xlsx.exportData(url,query,cols,Date.now().toString());
			//依据url和query加载所有要到处的订单数据
			xlsx.loadAllData(url,query).then(lang.hitch(this,function(items){
                //设置表头
				var datas = [["订单号","支付日期","收货人",
                "收货电话","收货地址","商品名称","单价",
                "数量","交易金额","积分/优惠券抵扣","实付金额",
                //"运费",
                "状态（待付款、已取消）","支付方式",
                "创建时间","审核时间","发货时间","取消时间"]];
				//初始化订单数据
				for(var i=0;i<items.length;i++){
					for(var j=0;j<items[i].details.length;j++){
                        var data = items[i];                        
                        if(data.payType){
                            data.payTypeName = config.getPayTypeStr(data.payType);                            
                        }
                        if(data.payTime){
                            data.payTime = date.formatISODateMinutes(data.payTime);
                        }
                        if(data.createAt){
                            data.createAt = date.formatISODateMinutes(data.createAt);
                        }
                        //data.acceptTime = date.formatISODate(data.acceptTime);
                        if(data.acceptTime){
                            data.acceptTime = date.formatISODateMinutes(data.acceptTime);
                        }
                        if(data.delivTime){
                            data.delivTime = date.formatISODateMinutes(data.delivTime);
                        }
                        if(data.cancelTime){
                            data.cancelTime = date.formatISODateMinutes(data.cancelTime);
                        }
                        data.details[j].integral = (data.details[j].couponAmount + data.details[j].point).toFixed(2);
                        data.state = this.getOrderStatus(data);                        
						data.details[j].payAmount = data.details[j].amount + (data.details[j].discountAmount||0) - (data.details[j].integral||0);
						data.details[j].actualAmount = data.details[j].amount + (data.details[j].discountAmount||0);
                        datas.push([data.details[0].tsId,data.payTime,
                        data.details[0].dName,data.details[0].dTel,data.details[0].dAddress,
                        //从商品中取
                        data.details[j].mId.mName,data.details[j].price,data.details[j].qty,data.details[j].actualAmount,data.details[j].integral,
                        data.details[j].payAmount,
                        //data.tAmount,
                        data.state,data.payTypeName,
                        data.createAt,data.acceptTime,data.delivTime,data.cancelTime]);
					}
				}
				//导出成xlsx文件
				xlsx.exportMatrix(datas,Date.now().toString());
			}));
        },
        onFirstShow: function(){
            this.inherited(arguments);
            option = {
                isFooter : true,
                columns : [{
                    label : "导出",
					className: 'flex2 footer-tab-highlight',
                    onClick : this.exportOrderList
                }],
                labelClass: 'font-size1',
                className: "fix-footer"
            };
            this.addColumns(option);  
        },
        //重写头部返回view事件
        onBackButtonClick:function(){
            //window.moveToView("home");
            history.back();
        }
    });
});