﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/dom-construct",
    "dojo/query",
    "dojo/Deferred",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "dojox/mobile/ListItem",
    "cq/biz/ts/order",
    "cq/biz/user/user",
    "cq/util/config/config",
    "cq/util/sys/date",
    "cq/biz/ts/refundApplication",
    "cq/biz/mat/mat"
],function(declare, lang, array, domAttr, domClass, domStyle, domConstruct, query, Deferred, View, _ViewMixin, ListItem, order, user, config, date, refundApplication,mat){
    return declare("cq.ui.b.t.OrderDetailB",[View,_ViewMixin],{
        // 初始化页面元素,绑定事件
        onFirstShow:function(){
            // 创建头部信息
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "",
                    onClick : function() {
                        history.back();
                    }
                },
                title:"退款详情"
            };
            this.addHeader(option);
            //收货相关信息
            // 添加class 使
            option={isEdge:true,lists:[],'class':"bottom-margin16"};
            this.orderList=this.addLists(option);
            this.orderStateItem = new ListItem({
                variableHeight:true
            });
            this.orderList.addChild(this.orderStateItem);
            //商品信息
            option={isEdge:true,lists:[],'class':"bottom-margin16"};
            this.matList=this.addLists(option);
            //退款申请状态信息
            option={isEdge:true,lists:[],'class':"bottom-margin16"};
            this.refundList=this.addLists(option);
            //绑定点击事件
            this.refundList.on("click", lang.hitch(this, this.onClickList));
            this.refundItem = new ListItem({
                variableHeight:true
            });
            this.refundList.addChild(this.refundItem);
            //
            this.addBottomMenus();
            //this.addColumns(option);
            this.connectEvent();
            this.onClickCertificate();
            this.onAfterShow();
        },
        //点击退款详情查看大图
        onClickList:function(evt){
            if(evt.target.localName == "img"){
                var imgSrcUri = evt.target.src;
                this.showImg(imgSrcUri); 
            }
        },
        
        // 绑定订单审核/退款/发货点击事件
        connectEvent:function(){
            
        },
        onClickCertificate:function(){
            
        },
        getOrderDetailStatus : function(items){
            var status=null;
            if(items.isPayed){
                if(items.isCanceled){
                    status = "已退款";
                }else if(items.isDelived){
                    if(items.isClosed){
                        status = "已完成";
                    }else if(!items.isReceipted){
                        status = "待收货";
                    }else{
                        status = "待评价";
                    }
                }else if(items.isAccepted){
                    status = "待发货";
                }else{
                    status = "待审核";
                }
            }else{
                if(items.isCanceled){
                    status = "已取消";
                }else{
                    status = "待付款";
                }
            }
            return status;
        },
        _id:"",
        userShopId:"",
        tsId:"",
        // 加载数据,并显示到页面上
        onAfterShow:function () {
            this.inherited(arguments);
            this.orderStateItem.set({label:"",rightText:""});
            this.matList.destroyDescendants();
            this.refundItem.set({label:"",rightText:""});
            // 收货人信息列表赋值
            var id = window.did.split("-");
            this._id = id[0];
            this.tsId = id[1];
            this.userShopId = id[id.length-1];
            //订单退款状态
            refundApplication.loadById({_id:id[0]}).then(lang.hitch(this,function(ordeData){//loadById(id[0])
                if(ordeData&&ordeData.data&&ordeData.data.item){
                    //ordeData.data.item.mids是保存的退款的某一个或几个商品
                    var orderitem = ordeData.data.item;
                    var treatmentMethod = "";
                        if(orderitem.treatmentMethod==1){
                            treatmentMethod = "只退款不退货";
                        }else{
                            treatmentMethod = "退货且退款";
                        }
                    this.refundItem.set({
                        label:"<div class='edit-car-amount'><span class='refundDleft'>创建时间:</span>"+date.formatISODateMinutes(orderitem.createAt) +"</div>"
						+"<div class='edit-car-amount'><span class='refundDleft'>订单号:</span>"+orderitem.tsId._id+"</div>"
                        +"<div class='edit-car-amount'><span class='refundDleft'>退款方式:</span>"+treatmentMethod+"</div>"
                        +"<div class='edit-car-amount'><span class='refundDleft'>退款原因:</span>"+this.reason[orderitem.reason]+"</div>"
                        +"<div class='edit-car-amount'><span class='refundDleft'>退款金额:</span>￥"+orderitem.amount+"</div>"
                        +"<div class='edit-car-amount'><span class='refundDleft'>联系电话:</span>"+orderitem.mobile+"</div>"
                        +"<div class='edit-car-amount'><span class='refundDleft'>退款状态:</span>"+this.getOrderStatus(orderitem)+"</div>"
						+"<div class='edit-car-amount'><span class='refundDleft'>财务说明:</span>"+(orderitem.remark||"")+"</div>"
                        +"<div style='width:auto; display:inline-block !important; display:inline;word-wrap: break-word;word-break: break-all;'><span class='refundDleft'>退款说明:</span>"+(orderitem.describe||"")+"</div><br/>"
                        +"<div class='mat-List' style='width:auto; display:inline-block !important; display:inline;'>"+this.getRefundImages(orderitem.images)+"</div>",
                       /* rightText:"<div class='edit-car-amount'>"+date.formatISODateMinutes(orderitem.createAt) +"</div>"
                        +"<div class='edit-car-amount'>"+orderitem.tsId._id+"</div>"
                        +"<div class='edit-car-amount'>"+treatmentMethod+"</div>"
                        +"<div class='edit-car-amount'>"+this.reason[orderitem.reason]+"</div>"
                        +"<div class='edit-car-amount'>￥"+orderitem.amount+"</div>"
                        +"<div class='edit-car-amount'>"+orderitem.mobile+"</div>"
                        +"<div class='edit-car-amount refundState'>"+this.getOrderStatus(orderitem)+"</div>"
                        //+"<div class='edit-car-amount' style='word-wrap: break-word;word-break: break-all;width: 300px;'>"+orderitem.describe+"</div>"
                        +"<div class=''>"+(orderitem.remark||"")+"</div>"*/
                    });
                    this.changeBottomStatus(orderitem);
                    /**/
                    order.loadDetailById(id[1]).then(lang.hitch(this,function (data) {
                        var items=data&&data.data&&data.data.items||[];
                        //this.orderItems = items;
                        if(items.length){
                            //更新收货人信息
                            //var status=this.getOrderDetailStatus(items[0]);
                            this.orderStateItem.set({
                                label:"<div class='webkit-list'><div class='edit-car-dName'>收货人:"+(items[0].dName?items[0].dName:"未知")+"</div><div class='edit-car-dTel'>"+(items[0].dTel?items[0].dTel:"未知")+"</div></div>"
                                    +"<div class='immune-list'><div class='edit-car-dAddress'>收货地址:"+(items[0].dAddress?items[0].dAddress:"未知")+"</div></div>"
                                //rightText:status
                                //订单状态修改
                            });
                            //添加商品列表项
                            //值添加退款的商品mids
                            for (var i = items.length - 1; i >= 0; i--) {
                                array.forEach(ordeData.data.item.mids,function(mid){
                                    if(items[i].mId._id==mid._id){
                                        var listitem=new ListItem({
                                            label:this.getDetailLabel(items[i]),
                                            rightText:"<span class='edit-car-qty'>x"+items[i].qty+"</span>",
                                            variableHeight:true
                                            });
                                        this.matList.addChild(listitem);
                                    }
                                },this)
                            }
                            var discountItems = [];
                            items.reverse();
                            for (var i = items.length - 1; i >= 0; i--) {
                                if(items[i].discountAmount!=0){
                                    domClass.remove(query(".edit-car-discountAmount",this.matList.containerNode)[i],"none");
                                    domClass.add(query(".edit-car-priceAll",this.matList.containerNode)[i],"line-through");
                                }
                            }
                        }
                    }));
                }
            }));
        },
        /*
        +"<div class='edit-car-matimg'>退款图片</div>"+
        "<div class='edit-car-amount'>"+this.getRefundImages(orderitem.images)+"</div>"
        */
        reason:{
            '1':'退运费',
            '2':'做工问题',
            '3':'少件/漏发',
            '4':'商家发错货',
            '5':'退运费',
            '6':'做工问题',
            '7':'商品与秒描述不符',
            '8':'未按约定时间发货'
        },        
        getOrderStatus:function(data){
            //1买家申请等待卖家确认 2卖家同意 3卖家不同意 4财务已退款 5已完成 6已取消
            var state = "";
            if(data.state == 1){
                state = "待审核";
            }else if(data.state == 2){
                state = "同意退款，等待财务结算";
            }else if(data.state == 3){
                state = "拒绝退款";
            }else if(data.state == 4){
                state = "已退款";
            }else if(data.state == 5){
                state = "已取消";
            }
            return state;
        },	
        // 订单详细信息赋值
        getDetailLabel:function(item){
            var label = "<img class='edit-car-matimg' src='"+item.mId.logo+"' /><span class='edit-car-matname'>"+item.mId.mName+"</span><span class='edit-car-matprice'>￥"+window.fixedTo(item.price,3)+"</span>"
                +"<span class='edit-car-priceAll'>小计:￥"
                +window.fixedTo(item.price*item.qty,3)
                +"</span><span class='edit-car-discountAmount none'>修改价:￥"
                +window.fixedTo(item.amount,3)+"</span>"
                +"<div class='forth-btn ' detailId='" + item._id +"'>";
            label += "</div>";
            return label;
        },
        //显示退款上传的图片
        getRefundImages:function(images){
            var label = "";
            /*if(images.length){
                label = "<div>图片信息</div>";
                array.forEach(images[0].split(","),function(image){
                    label +="<img style='width: 100px;height:100px;float:left;' class='matLists' src='"+image+"'/>";//<div style='float:left;'></div>
                });
            }*/
            if(images){
                label = "<div>图片信息</div>";
                array.forEach(images.split(","),function(image){
                    label +="<img style='width: 100px;height:100px;float:left;' class='matLists' src='"+image+"'/>";//<div style='float:left;'></div>
                });
            }
            return label;
        },
        //底部按钮显示
        changeBottomStatus: function(item){
            domClass.add(query(".agree",this.bottomMenus)[0],"none");
            domClass.add(query(".refuse",this.bottomMenus)[0],"none");
            //状态显示
            if(item.state == 1){
                domClass.remove(query(".agree",this.bottomMenus)[0],"none");
                domClass.remove(query(".refuse",this.bottomMenus)[0],"none");
            }
            //有可能底部全部被隐藏,所以需要重算高度
            this.resize();
        },
        addBottomMenus:function(){
            var option = {
                columns:[{
                    label:'同意退款',
                    className:'flex2 footer-tab-highlight none agree',
                    onClick : lang.hitch(this,this.agreeRefund)
                },
                {
                    label:'拒绝申请',
                    className:'flex2 footer-tab-dark none refuse',
                    onClick:lang.hitch(this,this.refuseRefund)
                }],
                forceWidth:false,
                isFooter:true
            };
            this.bottomMenus = this.addColumns(option);
        },
        agreeRefund:function(){
            var role = user.getCurrentUserRole();
            if(role!=1&&role!=4){
                return alert("只有高级管理员和财务才能处理退货");
            }
            if(!confirm("确认要同意退款申请？"))return;
            window.busy();
            refundApplication.aggree({userShopId:this.userShopId,_id:this._id,state:2,tsId:this.tsId}).then(lang.hitch(this,function(data){
                window.free();
                if(data&&data.data&&data.data.ok){
                    alert("退款成功");
                    this.changeBottomStatus(data.data.item);
                    //修改状态
                    query(".refundState",this.domNode)[0].innerHTML = this.getOrderStatus(data.data.item);
                }
            }));
        },
        refuseRefund:function(){
            var role = user.getCurrentUserRole();
            if(role!=1&&role!=4){
                return alert("只有高级管理员和财务才能处理退货");
            }
            //if(!confirm("确认要拒绝申请？"))return;
			var reason=prompt("请输入拒绝理由","");
			if (reason!=null && reason!=""){
                window.busy();
				refundApplication.disaggree({userShopId:this.userShopId,_id:this._id,state:3,tsId:this.tsId,refuseReason:reason}).then(lang.hitch(this,function(data){
                    window.free();
					if(data&&data.data&&data.data.ok){
						alert("不同意申请，操作成功");
						this.changeBottomStatus(data.data.item);
						//修改状态
						query(".refundState",this.domNode)[0].innerHTML = this.getOrderStatus(data.data.item);
					}
				}));
			}
        }
    });
});
