﻿// 修改人： 徐阿雪
// 修改时间：2016/12/19
// 修内容容: 退款列表
define([
	"dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dojo/_base/array",
    "dojo/query",
    "dojo/dom-construct",
    "dojo/store/JsonRest",
    "dijit/registry",
    "dijit/_WidgetBase",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeStoreList",
    "cq/ui/view/_ViewMixin",
    "cq/biz/ts/order",
    "cq/biz/user/user",
    "cq/util/sys/date",
    "cq/biz/ts/refundApplication"
    //"cq/widgets/item/OrderListItem"
],function(declare,lang,domClass,array,query,domConstruct,JsonRest,registry,_WidgetBase,View,EdgeToEdgeStoreList,_ViewMixin,order,user,date,refundApplication){
    
    return declare('cq.ui.b.t.RefundList',[View,_ViewMixin],{
        start:0,
        pageSize:10,
        condition:{},
        reason:{
            '1':'退运费',
            '2':'做工问题',
            '3':'少件/漏发',
            '4':'商家发错货',
            '5':'退运费',
            '6':'做工问题',
            '7':'商品与秒描述不符',
            '8':'未按约定时间发货'
        },
        onFirstShow : function() {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "",
                    onClick : function () {
                        //history.back();
                        window.moveToView("sale");
                    }
                },
                title:"退货列表"
            };
            this.addHeader(option);
            option = {
                isHeader: true,
                placeHolder: "按回车搜索所有退货信息",
                class: "cqSearchBox",
                type: "search",
                onInput: lang.hitch(this, function(evt) {
                    if (evt.keyCode == 13) {
                        this.condition.search = evt.target.value;
                        this.loadList(this.condition);
                        this.condition.search = "";
                        evt.target.value = "";
                    }
                })
            };
            this.addTextBox(option);
            option = {
                isHeader:true,
                //1买家申请等待卖家确认 2卖家同意 3卖家不同意 4财务已退款 5已完成 6已取消
                columns:[{
                    label:'全部',
                    onClick:lang.hitch(this,function(e){
                        // 徐阿雪 修改movetoview，重写一个函数，获取不同type的数据，加载显示出来
                        this.condition.state = "";
                        this.changeList(e);
                    })
                },
                {
                    label:'待审核',
                    onClick:lang.hitch(this,function(e){
                        this.condition.state = 1;
                        this.changeList(e);
                    })
                },
                {
                    label:'已退款',
                    className:'sale',
                    onClick:lang.hitch(this,function(e){
                        this.condition.state = 4;
                        this.changeList(e);
                    })
                }],
                labelClass:'font-size1 tab-selector'
            };
            this.addColumns(option);
            this.storeList=new EdgeToEdgeStoreList({
                append: true,
                query:{
                },
                className:"icon-list-item",
                variableHeight:true,
                //获取数据完成后调用的的处理方法
                onComplete:lang.hitch(this,function(data){
                    data = data||[];
                    for(var i=0;i<data.length;i++){
                        var treatmentMethod = "";
                        if(data[i].treatmentMethod==1){
                            treatmentMethod = "只退款不退货";
                        }else{
                            treatmentMethod = "退货且退款";
                        }
                        data[i].label="<div class='order-list-status'>"+
                            "<span>创建时间："+date.formatISODateMinutes(data[i].createAt)+"</span>"+
                            "<span class='status'>"+this.getOrderStatus(data[i])+"</span>"+
                            "<div class='tsId'><span>订单号："+(data[i].tsId&&data[i].tsId._id)+"</span></div>"+
                            "<div class='order-company '><span>退款方式："+treatmentMethod+"</span></div>"+
                            "<div class='order-inviter '><span>退款原因："+this.reason[data[i].reason]+"</span></div>"+
							"<div class='order-dname '><span>退款商家："+(data[i].userShopId&&data[i].userShopId.shopName)+"</span></div>"+
                            "<div class='order-dname '><span>手机号码："+data[i].mobile+"</span></div>"+
                            "</div>"
                    }
                    this.storeList.generateList(data);
                    this.busy = false;
                }),
                itemMap:{
                    _label:"label"
                }
            });

            this.storeList.placeAt(this.centerPanel.containerNode,"last");
            this.storeList.on("click",lang.hitch(this,this.onClickList));
            this.centerPanel.on("afterscroll",lang.hitch(this,this.onLoadMore));
            this.onAfterShow();
        },
        getOrderStatus:function(data){
            //1买家申请等待卖家确认 2卖家同意 3卖家不同意 4财务已退款 5已取消
            var state = "";
            if(data.state == 1){
                state = "待审核";
            }else if(data.state == 2){
                state = "卖家同意退款";
            }else if(data.state == 3){
                state = "卖家不同意退款";
            }else if(data.state == 4){
                state = "已退款";
            }else if(data.state == 5){
                state = "已取消";
            }
            return state;
        },
        onAfterShow:function(){
            //加载全部专状态的list 
            this.changeList({
                target:query(".tab-selector",this.domNode)[0]
            });
            
        },
        //选中查看商品列表
        changeList:function(e){
            //清空样式
            //this.clearSelected();
            var doms = query('.tab-selector', this.domNode);
            this.tabSelected(doms,"selected",e.target);
            this.loadList();
        },
        tabSelected : function (doms, className, dom) {
            array.forEach(doms, function (d) {
                domClass.remove(d, className);
            });
            if (dom) {
                domClass.add(dom, className);
            }
        },
        loadList:function(){
            this.start = 0;
            this.storeList.destroyDescendants();
            if(!this.storeList.store){
                var url = refundApplication.load();
                var store = new JsonRest({target:url});
                this.condition.orderBy = "-createAt";
                var queryResult=this.storeList.setStore(store,this.condition,{
                    start:this.start,
                    count:this.pageSize
                });
                this.onLoadListData(queryResult,this.start,this.pageSize);
            }else{
                var queryResult=this.storeList.setQuery(this.condition,{
                    start:this.start,
                    count:this.pageSize
                });
                this.onLoadListData(queryResult,this.start,this.pageSize);
            
            }
        },
        onClickList:function(evt){
            var li = registry.getEnclosingWidget(evt.target);
            if(li.declaredClass!="dojox.mobile.ListItem")return;
            var dom =evt.target;
            var orderList = li.params;
            var id = orderList._id+"-"+orderList.tsId._id+"-"+orderList.userShopId._id;
            window.moveToView("refundDetail",id);
            
        },
        onLoadMore:function(e){
            if(!this.busy&&e.afterBottom){
                this.start = this.start+this.pageSize;
                    if(this.canLoadMore(this.start)){
                        console.log("加载更多商品");
                        this.busy = true;
                        setTimeout(lang.hitch(this, function () {
                            var queryResult = this.storeList.setQuery(this.storeList.get("query"), {
                                start : this.start,
                                count : this.pageSize
                            });
                            this.onLoadListData(queryResult,this.start,this.pageSize);
                        }), 1000);
                    }
            }
        }
    });
});