// 创建人：潘云
// 创建时间：2016-06-24
// 功能：退款记录详情
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "dojo/dom-style",
    "cq/util/config/config",
    "cq/util/sys/date",
    "cq/biz/ts/refundRecord",
    "cq/bo/refundRecord",
    "cq/biz/ts/order"
], function (declare, lang, View, _ViewMixin, domStyle, config, date, refundRecord, refundRecordBo, order) {
    // module:
    //        cq/ui/b/t/RefundRecordDetail
    return declare("cq.ui.b.t.RefundRecordDetail", [View, _ViewMixin], {
        onAfterShow : function () {
            refundRecord.loadById(window.did).then(lang.hitch(this, function (refundData) {
                if (refundData && refundData.data && refundData.data.item && refundData.data.item.tsId) {
                    var orderId = refundData.data.item.tsId || "";
                    var item = refundData.data.item;
                    var shopId = item.fromShopId;
                    if(shopId._id){
                        shopId = shopId._id;
                    }
                    order.loadShopById({id:orderId,shopId:shopId}).then(lang.hitch(this, function (orderData) {
                        if (orderData && orderData.data && orderData.data.item) {
                            var data = {
                                tsId : refundData.data.item.tsId || "",
                                amount : window.fixedTo((refundData.data.item.amount || 0), 3),
                                payTime : orderData.data.item.payTime ? date.formatISODateMinutes(orderData.data.item.payTime) : "",
                                //userId : orderData.data.item.userId || "",
                                payType : config.getPayTypeStr(orderData.data.item.payType),
                                payLogNum : refundData.data.item.payLogNum || "",
                                fromShopName : orderData.data.item.fromShopName || "",
								merchantNo: refundData.data.item.merchantNo,
								bankName: refundData.data.item.bankName,  //付款银行
								bankAccountCode: refundData.data.item.bankAccountCode,  //付款账号
								bankAccountName: refundData.data.item.bankAccountName,
								stateName: (refundData.data.item.state == 1?"已退款":refundData.data.item.state == 0?"退款失败":"未处理")
                            };
                            this.setData(data);
                            // 判断是否显示底部按钮
                            if (refundData.data.item.isVerified) {
                                domStyle.set(this.footerColumns, "display", "none");
                            } else {
                                domStyle.set(this.footerColumns, "display", "");
                            }
                            this.refreshData();
                        }
                    }));
                }
            }));
        },        
        onFirstShow : function () {
            var option = {
                left : {
                    iconButton : ' ',
                    arrow : "left",
                    label : "",
                    onClick : function () {
                        history.back();
                    }
                },
                title : "退款订单详情"
            };
            this.addHeader(option);
            // 订单信息
            option = {
                isEdge : true,
                lists : [{
                    label : '供货商',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'fromShopName',
                        disabled:"true"
                    }
                },{
                    //label: "交易单号",
                    //rightText: "{{payLogId}}",
                    label : '交易单号',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'payLogNum',
                        disabled:"true"
                    }
                },{
                    //label : "退款订单",
                    //rightText : '{{tsId}}'
                    label : '退款订单',
                    noArrow : true,
                    edit : {
                        type : 'text',
                        field : 'tsId',
                        disabled:"true"
                    }
                }, {
                    label : "退款金额",
                    rightText : '{{amount}}'
                }, 
                // {
                    // label : '退款客户',
                    // rightText : '{{userId}}'
                // }, 
                {
                    label : '订单支付时间',
                    rightText : '{{payTime}}'
                }, {
                    label : '订单支付方式',
                    rightText : '{{payType}}'
                }, {
                    label : '商户号',
                    rightText : '{{merchantNo}}'
                }, {
                    label : '付款银行',
                    rightText : '{{bankName}}'
                }, {
                    label : '付款账号',
                    rightText : '{{bankAccountCode}}'
                }, {
                    label : '付款账户名称',
                    rightText : '{{bankAccountName}}'
                }, {
                    label : '退款状态',
                    rightText : '{{stateName}}'
                }]
            };
            this.addLists(option);
            // 添加底部按钮
            option = {
                isEdge : true,
                columns : [/*{
                    label : '审核',
                    className : 'flex2 footer-tab-highlight verified',
                    onClick : this.onVerify
                }*/{
                    label : '同意',
                    className : 'flex2 footer-tab-highlight agree',
                    onClick : this.onAgree
                },{
                    label : '不同意',
                    className : 'flex2 footer-tab-dark disagree',
                    onClick : this.onDisAgree
                }],
                forceWidth : false,
                isFooter : true
            };
            this.footerColumns = this.addColumns(option);
            this.onAfterShow();
        },
        onVerify : function () {
            window.busy();
            refundRecord.verify(window.did).then(lang.hitch(this, function (data) {
                window.free();
                if (data.data.ok === 1) {
                    history.back();
                } else {
                    alert("审核未通过");
                }
            }));
        },
		onAgree : function () {
            var def = refundRecordBo.agreeRefund(window.did);
            if(def&&def.then){
                return def.then(function(data){
					if (data.data.ok === 1) {
						history.back();
					} else {
						alert("操作失败");
					}
                });
            }
        },
		onDisAgree : function () {
            var def = refundRecordBo.rejectRefund(window.did);
            if(def&&def.then){
                return def.then(function(data){
					if (data.data.ok === 1) {
						history.back();
					} else {
						alert("操作失败");
					}
                })；
            }
        }
    });
});
