/**
 * Writer 杜飞军
 * Create Time 2016/05/25
 * Deploy 
 *      判断销售数量 标示已售罄 按钮不可用
 **/
// 变更人：潘云
// 变更时间：2016-06-01
// 变更内容：添加商品评论模块
// 变更人：周超
// 变更时间：2016-06-14
// 变更内容：添加认证显示
// 变更人：冉伟
// 变更时间：2016-06-21
// 变更内容：1.设置显示的小数位数 2.实现商品名称独占一行,名称有多少字数显示多少,库存与规格显示在一行 3.解决宝贝评价与平均评价在手机上没有显示在一行的问题
// 变更人：冉伟
// 变更时间：2016-06-22
// 变更内容：解决下架商品还能加入购物车问题
//变更人:王龙
//变更时间:2016-06-28
//变更内容:将标题商品管理改为商品详情
// 变更人:徐阿雪
// 变更时间:2016/7/11
// 变更原因:添加包邮金额运费限制销售区域
// 变更人:徐阿雪
// 变更时间:2016/7/12
// 变更原因:添加农户入口，商品关联农户，可查看农户信息，要判断农户是否存在
// 变更人:张金鹏
// 变更时间:2016/7/18
// 变更原因:添加联系商家的入口
// 变更人:母浚驰
// 变更时间:2016/7/20
// 变更原因:供货商入口，显示商品参数
// 变更人:张松
// 变更时间:2016/7/24
// 变更原因:页面布局
// 变更人:张松
// 变更时间:2016/8/1
// 变更原因:隐藏供货农户，只在爱在农香中显示
// 变更人:徐阿雪
// 变更时间:2016/8/16
// 变更原因:运费显示更改  将运费包邮重写
// 变更人员：母浚驰
// 变更时间：2016/8/17
// 变更内容：优惠券信息
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/query",
    "dojo/dom-construct",
    "dojo/store/JsonRest",
    "dojo/on",
    "dojo/when",
    "dojo/Deferred",
    "dijit/registry",
    "dojox/mobile/Rating",
    "dojox/mobile/View",
    "dojox/mobile/EdgeToEdgeStoreList",
    "dojox/mobile/ListItem",
    "cq/biz/mat/mat",
    "cq/biz/mat/sort",
    "cq/biz/ts/cart",
    "cq/util/sys/date",
    "cq/biz/shop/shop",
    "cq/biz/user/userFarmer",
    "cq/biz/user/user",
    "cq/biz/im/msg_p",
    "cq/biz/mk/discount",
    "cq/biz/article/ss/comment",
    "cq/ui/view/_ViewMixin",
    "cq/biz/shop/partner",
    "cq/ui/common/t/CouponList",
    "cq/app/widget/mobile/edit/Score"
], function(declare, lang, array, domClass, domStyle, query, domConstruct, JsonRest, on, when, Deferred, registry, Rating, View, EdgeToEdgeStoreList, ListItem, mat, sort, cart, date, shop, userFarmer, user, msg_p, disCount, comment, _ViewMixin, partner, CouponList, Score) {
    return declare("cq.ui.common.m.MatDetail", [View, _ViewMixin], {
        // 是否售罄或下架
        isSoldOut: false,
        farmerId: "",
        start: 0,
        freight: "",
        matId: "",
        onAfterShow: function() {
            // 设置matId值 window.did 可能会传递两个值
            this.matId = window.did.split("_")[0];
            // 先隐藏售罄提示
            domStyle.set(this.soldOut, "display", "none");
            //domClass.remove(this.matDetailDiv.containerNode, "none");
            //domClass.add(this.shopsParamsDiv.containerNode, "none");
            // 异步执行时this.matShopId是空的 优先设置
            this.matShopId = window.did.split("_")[1];
            // 商品从商家或者平台加载，如果从平台加载，重写loadMatData
            this.loadMatData().then(lang.hitch(this, function(data) {
                if (data && data.data && data.data.item && data.data.item.scoreAvg) {
                    data.data.item.scoreAvg = window.fixedTo(data.data.item.scoreAvg, 2);
                }
                //data.data.item.props = this.changeProps(data.data.item.props);
                //取fromShopId    张金鹏，2016/07/18
                this.matShopId = this.matShopId || data.data.item.fromShopId;
                //20160621：设置显示的小数位数
                data.data.item.retailPrice = window.fixedTo(data.data.item.retailPrice|| 0, 3);
                data.data.item.marketPrice = window.fixedTo(data.data.item.marketPrice || 0, 3);
                data.data.item.totalSale = window.fixedTo(data.data.item.totalSale, 1);
                data.data.item.qty = window.fixedTo(data.data.item.qty, 1);
                data.data.item.commentNum = window.fixedTo(data.data.item.commentNum, 1);
                data.data.item.totalSale = data.data.item.totalSale || "0";
                //运费 重盐需要的freight
                this.freight = window.fixedTo(data.data.item.freight, 3);
                if (data.data.item.minQty) {
                    data.data.item.minnQtyText = "起订量：" + data.data.item.minQty;
                } else {
                    data.data.item.minnQtyText = "";
                }
                //获取商铺数据
                shop.loadById(this.matShopId).then(lang.hitch(this, function(data1) {
                    data.data.item.tranFee = this.getTranFee(data1);
                    data.data.item.shopName = data1.data.shopName;
                    data.data.item.tranAddr = data1.data.tranAddr;
                    //var farmerMsgList = query(".mblListItem.farmerMsgList", this.getVerified.domNode)[0];
                    //判断是否存在农户，存在就给item对象赋值，去获取农户的相关信息，并且显示农户，否则就不显示 徐阿雪
                    if (data.data.item.farmer) {
                        //获取农户ID  徐阿雪  2016/7/13
                        this.farmerId = data.data.item.farmer;
                        //将userFarmer的农户信息存到item里面做展示准备
                        data.data.item.pName = data.data.item.farmer.pName;
                        //this.setData(data.data.item);
                        //是农户，显示农户简要信息  徐阿雪
                        //domClass.remove(farmerMsgList,"none");
                    } else {
                        //this.setData(data.data.item);
                        //农户不存在，隐藏  徐阿雪  2016/7/12
                        // domClass.add(farmerMsgList,"none");
                    }
                    this.isSoldOut = false;
                    var hide = query(".footer-tab-highlight", this.bottomMenus)[1];
                    if (hide) {
                        //domStyle.set(opa, "opacity", "1");
                    }
                    // 判断库存是否等于0
                    if (data.data.item.qty === 0) {
                        this.notSale("已售罄");
                    }
                    // 判断商品是否下架
                    if (data.data.item.isUse === false) {
                        this.notSale("已下架");
                    }
                    var images = [];
                    if (data.data.item.logo) {
                        images.push({
                            icon: data.data.item.logo
                        });
                    }
                    for (var i = data.data.item.images.length - 1; i >= 0; i--) {
                        images.push({
                            icon: data.data.item.images[i]
                        });
                    }
                    this.slideShow.items = images;
                    this.slideShow.refresh();
                    // 加载当前商家在供应商的数据
                    this.fromShopData = data.data.item;
                    this.loadParent();
                    /*if (data1.data.isVerified || data1.data.isTrustedPay) {
                        if (this.getVerified) {
                            domClass.remove(this.getVerified.domNode, "none");
                        }
                    }
                    if (this.getVerified) {
                        var dbzf = query(".dbzf", this.getVerified.domNode)[0],
                            qyrz = query(".qyrz", this.getVerified.domNode)[0];
                        //显示隐藏认证点
                        if (data1.data.isVerified === true) {
                            domClass.remove(qyrz, "none");
                        } else {
                            domClass.add(qyrz, "none");
                        }
                        if (data1.data.isTrustedPay === true) {
                            if (data1.data.isVerified === true) {
                                domClass.remove(dbzf, "none");
                                //若企业认证显示则右移
                                domStyle.set(dbzf, "margin-left", "20%");
                            } else {
                                domClass.remove(dbzf, "none");
                            }
                        } else {
                            domClass.add(dbzf, "none");
                        }
                    }*/
                   
                    // 获得用户最新的评价 2017/02/16 杜飞军
                    comment.load({
                        commentType: "mat",
                        commentId: this.matId,
                        shopId: this.matShopId || ""
                    }).then(lang.hitch(this, function(commentData){
                        if(commentData && commentData.data && commentData.data.ok === 1){
                            var comData = commentData.data.items[0];
                            if(comData) {
                                // 把查询到的评论第一条传递给显示数据
								var commentName = comData.userId.pName ? comData.userId.pName : comData.userId.nickName?comData.userId.nickName:"";							
                                data.data.item.commentName = commentName[0]+"***"+commentName[commentName.length-1];
                                data.data.item.commentLogo = comData.userId.logo || "images/userIcon.png";
                                data.data.item.commentContent = comData.content;
                                
                            }
                             // 如果有分级定价，取客户对应的价格
                            if (data.data.item.prices) {
                                partner.loadByIdAndShopId(this.matShopId, shop.getShopId()).then(lang.hitch(this, function(partnerData) {
                                    if (partnerData.data.shopLevel) {
                                        for (var i = 0; i < data.data.item.prices.length; i++) {
                                            if (data.data.item.prices[i].level == partnerData.data.shopLevel) {
                                                data.data.item.retailPrice = data.data.item.prices[i].price;
                                            }
                                        }
                                    }
                                    this.setDefaultAttr(data.data.item);
                                }));
                            } else {
                                this.setDefaultAttr(data.data.item);
                            }
                            this.setDefaultAttr(data.data.item);
                            this.refreshData();
                            if (!this.scoreWidget) {
                                // 添加星级评论
                                this.createRating();
                            }
                            this.addRatingNode();
                            if (data && data.data && data.data.item && data.data.item.scoreAvg) {
                                this.scoreWidget.set("value", Math.round(data.data.item.scoreAvg));
                            } else {
                                this.scoreWidget.set("value", 0);
                            }
                            // 判断市场价是否设置 没有设置隐藏市场价格 2017/02/16 杜飞军
                            if(Number(data.data.item.marketPrice)){
                                domClass.remove(query(".mat_dec",this.domNode)[0], "none");
                            }
                        }
                    }));
                    
                }));
            }));
        },
        loadParent: function(){},
        setDefaultAttr: function(data) {
            this.setData(data);
        },
        //重写运费方法 2016/8/16 徐阿雪
        getTranFee: function(data) {
            //添加包邮金额运费限制销售区域  徐阿雪  2016/7/11
            var tranFee = "";
            if (data.data.tranRegion) {
                tranFee += "限" + data.data.tranRegion + "，";
            } else {
                tranFee += "";
            }
            tranFee += "运费 ￥" + window.fixedTo(data.data.tranFee || 0);
            return tranFee;
        },
        // 供重写的加载数据的方法，如果要从平台获取数据，需要重写此方法
        loadMatData: function() {
            var def = new Deferred();
            mat.loadById(this.matId, this.matShopId).then(lang.hitch(this, function(data) {
                def.resolve(data);
            }));
            return def;
        },
        onFirstShow: function() {
            //this.setData({});
            /*var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "",
                    onClick: function() {
                        history.back();
                    }
                },
                title: "商品详情"
            };
            this.addHeader(option);*/
            this.header = this.addHeaders();
            this.createSelection();
            var data = {
                boxes: [],
                options: {
                    width: domStyle.get(this.domNode, "width"),
                    height: Math.min(domStyle.get(this.domNode, "width"), 360)
                }
            };
            this.slideShow = this.addSlideShow(data);
            //实现商品名称独占一行,名称有多少字数显示多少,库存与规格显示在一行
            var postTxt = "";
            this.addDetail();

            // 商品详情和参数
            this.addShopAssistList();

            option = {
                columns: [{
                    label: "已售罄"
                }],
                isFooter: true,
                labelClass: "messageDiv",
                "className": "bg-gray text-white"
            };
            this.soldOut = this.addColumns(option);

            // 创建props显示
            this.propsDiv = domConstruct.create("div", {
                style: "height:400px;text-align: left;"
            });

            // 添加收藏按钮
            this.bottomMenus = this.addAtttion();
            // 商品评论绑定事件
            this.matEvalList.on("click", lang.hitch(this, this.onEvalList));
            this.connect(query(".getCouponList", this.domNode)[0], "onclick", this.createCouponsList);
            this.onAfterShow();
        },
        // 创建props显示
        createProps: function(data) {
            var option = {
                    isEdge: true,
                    lists: []
                },
                item;
            array.forEach(data, function(data) {
                item = {
                    label: '',
                    rightText: ''
                };
                item.label = data.name;
                item.rightText = data.value;
                option.lists.push(item);
            });
            if (!data.length) {
                item = {
                    label: '',
                    rightText: ''
                };
                item.label = '暂无商品参数';
                option.lists.push(item);
            }
            return this.addLists(option);
        },
        addAtttion: function() {
            var option = {
                columns: [
                    //添加联系商家按钮    张金鹏，2016/07/18
                    {
                        label: '客服',
                        className: 'flex2 footer-tab-dark',
                        onClick: lang.hitch(this, this.toTalk)
                    }, {
                        label: '首页',
                        className: 'flex2 footer-tab-highlight',
                        onClick: function() {
                            window.moveToView("main");
                        }
                    }, {
                        label: '查看购物车',
                        className: 'flex2 footer-tab-dark',
                        onClick: lang.hitch(this, this.toBalance)
                    }, {
                        label: '加入购物车',
                        className: 'flex2 footer-tab-highlight',
                        onClick: lang.hitch(this, this.addOrderCar)
                    }
                ],
                forceWidth: false,
                isFooter: true
            };
            return this.addColumns(option);
        },
        addHeaders: function() {
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "",
                    onClick: function() {
                        history.back();
                    }
                },
                title: "商品详情"
            };

            return this.addHeader(option);
        },
        addDetail: function() {
            /* this.addLists({
                class: "top-bottom-margin16",
                isEdge: true,
                lists: [{
                        label: "{{mName}}",
                        variableHeight: true
                    }, {
                        label: "<span class='matRetail'>￥{{retailPrice}}</span>",
                        rightText: "<span style = 'text-decoration: line-through;'>市场价 ￥{{marketPrice}}</span>",

                    },
                    //{
                    //    label: "{{sizeType}}",
                    //    rightText: "￥{{retailPrice}}",
                    //    class:"matRetail"
                    //},
                    {
                        label: "规格:{{sizeType}}",
                        rightText: "库存:{{qty}}"
                    }, {
                        label: "<div style='width:50%;text-align:left;display:inline-block;font-size:12px;'> {{tranFee}}</div><div style='width:50%;text-align:right;display:inline-block;font-size:12px;'>销量:{{totalSale}}</div>",
                    }
                ]
            });
            */
            // 上面显示 商品名称
            var matInfoNode =   "<div class='mat_mName'>{{mName}}</div>"+
                                "<div>"+
                                    "<div class='mat_price'>"+
                                        "<span class='matRetail'>￥{{retailPrice}}</span> <span class='mat_dec mat_package none'>市场价:￥{{marketPrice}}</span></div>"+
                                    "</div>"+
                                    "<div class='mat_info mat_package'>"+
                                        "<span class='mat_flex'>规格:{{sizeType}}</span><span class='mat_flex'>运费:{{freight}}</span><span>销量:{{totalSale}}</span>"
                                    "</div>"
                                "</div>"
            this.addLists({
                class: "top-bottom-margin16",
                isEdge: true,
                lists: [{
                    label: matInfoNode,
                    variableHeight: true
                }]
            });

            // 添加领取优惠券
            var option = {
                class: "top-bottom-margin16",
                isEdge: true,
                lists: [{
                    moveTo: "#",
                    label: "<div style='float:left'>产品参数</div>",
                    rightText: "<span class='mat_rightLabel'>...</span>",
                    onClick: lang.hitch(this, function() {
                        // 销毁所有的内容
                        if (this.propsPlug) {
                            this.propsPlug.destroyRendering();
                        }
                        // 创建显示的内容
                        var data = this.getData();
                        this.propsPlug = this.createProps(data.props);
                        //this.propsDiv.appendChild(this.propsPlug.domNode);
                        this.propsPlug.placeAt(this.propsDiv);
                        this.showInOverlay(this.propsDiv);
                    })
                }, {
                    class: "getCouponList",
                    moveTo: "#",
                    label: "<div style='float:left'>优惠券</div>",
                    rightText: "<span class='mat_rightLabel'>领取</span>"
                }, {
                    class: "sellerMsgList",
                    moveTo: "#",
                    label: "<div style='float:left' class='sellerIntro'>{{shopName}}</div>",
                    rightText: "<span class='mat_rightLabel'>进入店铺</span>",
                    onClick: lang.hitch(this, function() {
                        window.moveToView("supplyBus", this.matShopId);
                    })
                }]
            };
            this.getCoupons = this.addLists(option);

            //创建担保支付信息
           /* option = {
                class: "getVerified top-bottom-margin16",
                isEdge: true,
                lists: [{
                        label: "<div style='float:left' class='none qyrz'><img style='width: 17px;' src='../../images/mobile/hook.png'/>担保支付</div><div class='none dbzf'><img style='width: 17px;' src='../../images/mobile/hook.png'/>企业认证</div>"
                    },
                    //添加农户简要信息，设置默认为隐藏，若有农户则显示出来 徐阿雪  2016/7/12
                    {
                        class: "farmerMsgList none",
                        moveTo: "#",
                        label: "<div style='float:left' class='farmerIntro'>供货农户</div>",
                        rightText: "{{pName}}",
                        //添加点击事件跳转到农户详细信息页面 徐阿雪  2016/7/12
                        onClick: lang.hitch(this, function() {
                            window.moveToView("farmerMsg", this.farmerId._id);
                        })
                    }
                ]
            };
            this.getVerified = this.addLists(option);
            domClass.add(this.getVerified.domNode, "none");*/
            // 添加商品的评论模块
            var assessNode =    "<div>" +
                                    "<span>商品评价({{commentNum}})</span>" +
                                    "<span class='mat_right'>平均得分:<div class='ratingDiv'></div></sapn>" +
                                "</div>"+
                                "<div style='margin-left:5px;'  >"+
                                    '<div class="hflex item">'+
                                        '<div class="item-mini-img" style="">'+
                                            '<img src="{{commentLogo}}" /> '+
                                        '</div>'+
                                        '<div class="flex1" >'+
                                            '<div><span >{{commentName}}</span></div>'+
                                            '<div class="row2"><span>{{commentContent}}</sapn></div>'+
                                        '</div>'+
                                    '</div>'+
                                    '<div class="mat_comment"><span>查看全部评价</span></div>'+
                                "</div>";
            option = {
                isEdge: true,
                lists: [{
                    //解决宝贝评价与平均评价在手机上没有显示在一行的问题
                    label: assessNode,
                    variableHeight: true
                }]
            };
            this.matEvalList = this.addLists(option);
        },
        //添加查看大图事件 2016/6/30
        onImageNodeclick: function(e) {
            if ("IMG" === e.target.tagName) {
                this.showImg(e.target.src);
            }
        },
        // 创建星级评论对象
        createRating: function() {
            this.scoreWidget = new Rating({
                image: "../../common/images/star-orange.png",
                numStars: 5,
                value: 5
            });
        },
        // 添加星级评论对象
        addRatingNode: function() {
            var li = query("li", this.matEvalList.domNode)[0];
            var rightDiv = query(".mblListItemLabel", li)[0];
            var ratingDiv = query(".ratingDiv", rightDiv)[0];
            ratingDiv.appendChild(this.scoreWidget.domNode);
        },
        onEvalList: function(evt) {
            var li = registry.getEnclosingWidget(evt.target);
            if (li.declaredClass != "dojox.mobile.ListItem") return;
            var _id = this.matId;
            window.moveToView("matEvalList", _id);
        },
        orderCarViewId: "orderCar",
        addOrderCar: function() {
            if (!this.isSoldOut) {
                cart.add(this.matId, this.getData().minQty || 1);
                alert("购物车添加成功!");
                window.moveToView(this.orderCarViewId);
            }
        },
        //先检查是否登陆，若已登录则跳转到联系商家页面，若未登录则跳转到登录页面    张金鹏，2016/07/18
        toTalk: function() {
            //调用user的hasLogin()方法，返回一个异步返回值s。    张金鹏，2016/07/18
            user.hasLogin().then(lang.hitch(this, function(s) {
                if (s) {
                    //调用msg_p对象的getSvcInfo()方法，获取和指定商家客服对话的信息的结果取名叫msgInfo    张金鹏，2016/07/18
                    msg_p.getSvcInfo(this.matShopId).then(lang.hitch(this, function(msgInfo) {
                        if (msgInfo && msgInfo.data && msgInfo.data.item) {
                            var item = msgInfo.data.item;
                            var senderId = item.senderId,
                                receiverId = item.receiverId;
                            senderId = senderId._id || senderId;
                            receiverId = receiverId._id || receiverId;
                            var svcId = senderId === user.getCurrentUserId() ? receiverId : senderId;
                            window.moveToView("svcDetail", this.matShopId + "," + svcId);
                        } else if (msgInfo && msgInfo.data && msgInfo.data.msg && msgInfo.data.msg == "没有客服人员") {
                            alert("没有客服人员");
                        }
                    }));
                } else {
                    window.moveToView("login");
                    history.back();
                    //user.nextPage="pendingMsg";
                }
            }));
        },
        // 直接到购物车
        toBalance: function() {
            window.moveToView("orderCar");
        },
        // 已经售罄或下架
        notSale: function(msg) {
            this.isSoldOut = true;
            query(".messageDiv", this.soldOut)[0].innerHTML = msg;
            // 显示售罄
            domStyle.set(this.soldOut, "display", "");
            var hide = query(".footer-tab-highlight", this.bottomMenus)[1];
            if (hide) {
                domStyle.set(hide, "opacity", "0.7");
            }
            this.resize();
        },
        addShopAssistList: function() {
            // var option = {
            // columns: [{
            // label: '商品详情',
            // onClick: lang.hitch(this.changeMatDetail)
            // }, {
            // label: '商品参数',
            // onClick: lang.hitch(this.changeShopsParams)
            // }],
            // labelClass: 'font-size1 tab-selector'
            // };
            // this.addColumns(option);

            //商品详情
            // option = {
            // isEdge: true,
            // lists: [{
            // label: "<div class='richText shopDetail'>{{content}}</div>",
            // variableHeight: true,
            // onClick: lang.hitch(this, this.onImageNodeclick) //添加查看大图事件 2016/6/30
            // }]
            // };
            // this.matDetailDiv = this.addLists(option);

            // 商品参数
            // option = {
            // isEdge: true,
            // lists: [{
            // label: "<div class='richText shopParams'>{{props}}</div>",
            // variableHeight: true
            // }]
            // };
            // this.shopsParamsDiv = this.addLists(option);
            //this.tabSelected();
            // 商品详情
            var option = {
                isEdge: true,
                lists: [{
                    label: '商品详情',
                }, {
                    label: "<div class='richText shopDetail'>{{content}}</div>",
                    variableHeight: true,
                    onClick: lang.hitch(this, this.onImageNodeclick) //添加查看大图事件 2016/6/30
                }],
                labelClass: 'font-size1'
            };
            this.addLists(option);
        },
        // 商品参数格式转换
        changeProps: function(props) {
            var str = "";
            if (props && props.length > 0) {
                for (var i = 0; i < props.length; i++) {
                    str += "<div style='margin-top:10px;'><span>" + props[i].name + "：</span><span>" + props[i].value + "</span></div>";
                }
            } else {
                str = "暂无商品参数";
            }
            return str;
        },
        //切换到商品详情
        changeMatDetail: function(e) {
            this.tabSelected(e.target);
            domClass.remove(this.matDetailDiv.containerNode, "none");
            domClass.add(this.shopsParamsDiv.containerNode, "none");
        },
        //切换到商品参数
        changeShopsParams: function(e) {
            this.tabSelected(e.target);
            domClass.remove(this.shopsParamsDiv.containerNode, "none");
            domClass.add(this.matDetailDiv.containerNode, "none");
        },
        //切换tabbar
        tabSelected: function(dom) {
            var items = query('.tab-selector', this.domNode);
            for (var i = 0; i < items.length; i++) {
                domClass.remove(items[i], "selected");
            }
            if (dom) {
                domClass.add(dom, "selected");
            } else {
                domClass.add(items[0], "selected");
            }
        },
        // 获得优惠券的接口 提供重写 --2016/11/21 杜飞军
        laodAvailable: function() {
            return disCount.loadAvailableByUserSelfThen({
                shopId: this.matShopId
            });
        },
        // 领取优惠券 提供重写 --2016/11/21 杜飞军
        getCoupon: function(data) {
            return disCount.getCouponByUserSelf({
                _id: data.id,
                shopId: this.matShopId
            });
        },
        //创建优惠券列表
        createCouponsList: function(e) {
            var dom = e.target;
            this.getData();
            //获取商家优惠券
            this.laodAvailable().then(lang.hitch(this, function(data) {
                if (data && data.data && data.data.items && data.data.items.length > 0) {
                    this.showCoupons(data).then(lang.hitch(this, function(s) {
                        // if (s && s.id !== null) {
                        //     // this.getCoupon(s).then(lang.hitch(this, function (data) {
                        //     //     if (data && data.data.ok == 1) {
                        //     //         alert("您领取了" + s.name + "的优惠券");
                        //     //         this.onAfterShow();
                        //     //     } else {
                        //     //         var msg = data.data.message || "优惠券完了";
                        //     //         alert(msg);
                        //     //     }
                        //     // }));
                        // }
                    }));
                } else {
                    var msg = data.data.message || "暂无优惠券";
                    alert(msg);
                }
            }));
        },
        createSelection: function() {},
        //showCoupons：
        //    --参数：data，类型：array
        //    --返回值：obj.setCoupInfo(data)，类型：Deferred
        //    --点击选择优惠券，弹出优惠券弹列表框
        showCoupons: function(data) {
            //创建对象
            this.coupons = new CouponList();
            var obj = this.coupons;
            var div = domConstruct.create("div", {
                className: "shareAll"
            });
            div.appendChild(obj.domNode);
            // 设置数据的商家id 2016/12/15 杜飞军
            data.data.shopId = this.matShopId;
            this.coupons.shopId = this.shopId;
            var def = obj.setCoupInfo(data);
            //显示弹出框
            this.showInOverlay(div);
            return def;
        }
    });
});