define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/query",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/Deferred",
    "dojox/mobile/ListItem",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/biz/mk/discount",
    "cq/util/sys/date"
], function (declare, lang, array, query, domClass, domStyle, Deferred, ListItem, View, _ViewMixin, disCount, date) {
    //路径：
    //    widgets.mobile.OrderInfo
    //创建优惠券对象
    //创建优惠券对象
    return declare("", [View, _ViewMixin], {
        //简介：
        //    优惠券对象：用于创建优惠券对象

        //coupName：String
        //    --用于获取coupName
        coupName: null,
        //coupId：String
        //    用于订单提交
        coupId: null,
        //getLists:
        //    --参数：data，类型：array
        //    --返回值:无
        //    --获取优惠券列表
        getLists: function (data) {
            //销毁原优惠券列表
            this.couponsLists.destroyDescendants();
            //创建新优惠券列表
            var items = data.data.items;
            for (var i = 0; i < items.length; i++) {
                var startDate = items[i].startDate ? date.formatISODate(items[i].startDate) : "";
                var stopDate = items[i].stopDate ? date.formatISODate(items[i].stopDate) : "";
                var listitem = new ListItem({
                    label: "<div class='coupsSelected'>" + "<div class='coupName couponShowList' style='display:none;'>" + items[i].title + "</div>" + "<div class='couponShowList'><font class='price'>" + items[i].amount + "</font>元</div>" + "<div class='couponShowList'>订单满" + items[i].reachAmount + "元使用</div>" + '<div class="getCouponId" style="display: none;">' + items[i]._id + '</div>' + "<div class='couponDtl-date couponShowList'>使用期限 " + startDate + "~" + stopDate + "</div>" + "<button class='couponsBtn'>领用</button></div>",
                    variableHeight: true
                });
                this.couponsLists.addChild(listitem);
            }
        },
        //creatCoupons：
        //    --参数:无
        //    --返回值:无
        //    --初始化页面页面元素
        creatCoupons: function () {
            var option = {
                class: 'couponsLists',
                variableHeight: true,
                //宽度拉伸
                isEdge: true,
                lists: []
            };
            //参数option：元素属性
            this.couponsLists = this.addLists(option);
        },
        //setCoupInfo：
        //    --参数：data，类型:Object
        //    --返回值:this.currentDef,等待释放,类型：Deferred
        //    --为优惠券列表附上数据
        setCoupInfo: function (data) {
            this.currentDef = new Deferred();
            this.shopId = data.data.shopId;
            if (!this.couponsLists) {
                //this.startup();
                //初始化界面元素
                this.creatCoupons();
                this.domNode.appendChild(this.couponsLists.domNode);
                this.connectEve();
            }
            //创建优惠券列表
            this.getLists(data);
            this.resize();
            return this.currentDef;
        },
        //connectEve:
        //    --参数：无
        //    --返回值:无
        //    --为优惠券列表添加点击事件
        connectEve: function () {
            this.connect(this.couponsLists.containerNode, "onclick", this.couponsListClick);
        },
        //getSuccess：
        //    --参数：无
        //    --返回值:无
        //    --点击确定，使用优惠券
        getSuccess: function () {
            var id = this.coupId;
            var name = this.coupName;
            var partInfo = {
                id: id,
                name: name
            };
            disCount.getCouponByUserSelf({
                _id: id,
                shopId: this.shopId
            }).then(lang.hitch(this, function (data) {
                if (data && data.data.ok == 1) {
                    alert("您领取了" + name + "的优惠券");
                    this.couponFinished();
                } else {
                    var msg = data.data.message || "优惠券完了";
                    alert(msg);
                }
            }));
            //释放defer
            this.currentDef.resolve(partInfo);
        },
        couponFinished: function () {},
        //couponsListClick：
        //    --参数：e，类型
        //    --返回值
        //    --点击列表：改变样式，获取id
        couponsListClick: function (e) {
            if (e.target.className.indexOf("couponsBtn") >= 0) {
                //设置选中
                domClass.add(e.target.parentNode, "selected");
                array.forEach(query(".couponsBtn", this.domNode), function (node) {
                    domStyle.set(node, 'backgroundColor', 'rgba(255, 255, 255, 0.2)');
                }, this);
                //变更样式
                domStyle.set(e.target, 'backgroundColor', '#FF2100');
                //获取选中Id，Name
                this.getCoupInfo(e);
                this.getSuccess();
            }
        },
        //获取数据
        //    参数：e，鼠标点击事件，类型：MouseEvent
        //    返回值：无
        //    获取当前选中的节点的部分信息
        getCoupInfo: function (e) {
            //获取名称/类型
            this.coupName = query(".coupName", e.target.parentNode)[0].innerText;
            //获取ID
            this.coupId = query(".getCouponId", e.target.parentNode)[0].innerText;
        },
        //clearState：
        //    参数:无
        //    返回值：无
        //    清除选中状态
        clearState: function () {
            var items = query('.couponsBtn', this.domNode);
            array.forEach(items, function (node) {
                domStyle.set(node, 'backgroundColor', 'rgba(255, 255, 255, 0.2)');
            }, this);
        }
    });
});