/*
变更人：徐阿雪
变更时间：2016/12/15
变更原因：填写退款单页面的基类
*/
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
	"dojo/dom-attr",
    "dojo/dom-style",
	"dojo/dom-class",
    "dojox/mobile/IconItem",
	"dojo/query",
    "cq/ui/view/_ViewMixin",
    "dojox/mobile/View",
	"cq/biz/ts/refundApplication",
	"cq/biz/ts/order",
	"cq/biz/user/user",
    "cq/util/edit/optionsList",
    "cq/util/edit/textArea"
],function(declare, lang, array, domAttr, domStyle, domClass, IconItem, query,_ViewMixin,View, refundApplication, order, user,optionsList,textArea){
    return declare("widgets.mobile.OrderRefund",[View, _ViewMixin],{
        onFirstShow:function(){
            // 创建头部信息
            var option = {
                left: {
                    iconButton: ' ',
                    arrow: "left",
                    label: "",
                    onClick: function() {
                        this.isEditing = false;
                        history.back();
                    }
                },
                title: "退款申请",
                right: {
                    iconButton: ' ',
                    className:"saveNode",
                    onClick: this.onSaveOrderRefund,
                    label: "完成"
                }
            };
            this.addHeader(option);
            option = {
                isEdge: true,
                'class': "top-bottom-margin16",
                lists: this.loadList()
            };
            this.addLists(option);
            this.getUpdateImage();
            /*option ={
                isEdge : false,
                lists:[{
                    label:"退款图片<div>{{showImages}}</div>",
                    variableHeight:true
                }]
            }
            this.showImages = this.addLists(option);*/
            option = {
                isEdge: true,
                'class': "top-bottom-margin16",
                lists: [{                        
                        label: '退款状态',
                        rightText: '{{refundStateName}}'
                    },{                        
                        label: '卖家处理说明',
                        rightText: '{{refuseReason}}',
						variableHeight : true
                    },{                        
                        label: '平台处理说明',
                        rightText: '{{remark}}',
						variableHeight : true
                    }
                ]
            };
            this.stateButton = this.addLists(option);
            option = {
                columns: [{
                        className: 'flex2 footer-tab-highlight none',
                        label: '重新提交',
                        onClick:lang.hitch(this,this.onApplyagain)
                    }
                ],
                labelClass: 'font-size1',
                className: 'fix-footer',
                isFooter: true
            };
            this.footerButton = this.addColumns(option);
			domAttr.set(query(".remindAmount", this.domNode)[0].lastChild, "readonly", true);
            this.onAfterShow();
        },
        orderId:null,
        mids:[],
		details:[],
		fromShopId:null,
        canSave:true,
        refundState:{
            "1":"等待审核",
            "2":"卖家同意,等待退款",
            "3":"卖家拒绝退款",
            "4":"财务已退款",
            "5":"已取消"
        },
        //当前订单的发货状态
        deliveryState:false,
        // 依据Id获得信息
        getLoadById: function() {
            return order.loadById(this.orderId);
        },
        //创建上传图片
        getUpdateImage:function(){
            var option = {
                canAdd: true,
                icons: [],
                editable: true,
                class: "no-shake",
                maxImages:3,
                field:"images",
                size: {
                    width: 640,
                    height: 640
                }
            };
            this.iconContainer = this.addImagePicker(option);
        },
        onAfterShow:function(){
            if(!this.isEditing){
                this.isEditing = true;
				// window传入参数格式：订单id+"-add-"+商品ids+"-"+卖家id+"-"+最大退款额+"-"+订单明细
                var orderMsg = window.did.split("-");
				var alldom = [".remindAmount",".treatmentMethod",".reason",".amount",".mobile",".describe"];
                domClass.remove(query(".saveNode", this.domNode)[0], "none");
                domClass.add(this.footerButton,"none");
                if(orderMsg[1] == "add"){
                    //清除上次上传过的图片
                    this.iconContainer.destroyDescendants();
                    this.getUpdateImage();
					for(var i=0;i<alldom.length;i++){
						domAttr.set(query(alldom[i], this.domNode)[0].lastChild, "readonly", false);
					}
                    this.orderId = orderMsg[0];                    
                    var price = orderMsg[4];
					var midarray = orderMsg[2].split("_");
					var dlsarray = orderMsg[5].split("_");
                    this.mids = [];
                    for(var i=0;i<midarray.length;i++){
						if(midarray[i]){
							this.mids.push(midarray[i]);
						}                        
                    }
					this.details = [];
                    for(var i=0;i<dlsarray.length;i++){
						if(dlsarray[i]){
							this.details.push(dlsarray[i]);
						}                        
                    }
                    if(price){
                        this.setData({
                            remindAmount: price,
                            mobile:user.getUserData().phone
                        });
                        this.refreshData();
                    }
                    domStyle.set(this.stateButton.domNode,"display","none");
                    this.canSave = true;
                } else {
                    //orderMsg最后以为是退款最大金额
                    this.orderId = orderMsg[0];
                    //查看退款详情
                    refundApplication.loadById({shopId:orderMsg[2],_id:orderMsg[1]}).then(lang.hitch(this,function(orderData){
                        if(orderData&&orderData.data&&orderData.data.item){
                            orderData.data.item.refundStateName = this.refundState[orderData.data.item.state];
                            orderData.data.item.remindAmount = orderMsg[orderMsg.length-1];
                            orderData.data.item.images = orderData.data.item.images&&orderData.data.item.images.split(",")||[];
                            var icons = orderData.data.item.images;
                            this.setData(orderData.data.item);
                            //先销毁在创建新的图片加好销毁不了
                            this.iconContainer.destroyDescendants();
                            //添加
                            for(var i=0;i<icons.length;i++){
                                this.iconContainer.addChild(new IconItem({
                                    icon:icons[i],
                                }));
                            }
                            this.refreshData();
                            //底部显示退款状态
                            //1买家申请等待卖家确认 2卖家同意 3卖家不同意 4财务已退款 5已完成 6已取消
                            domStyle.set(this.stateButton.domNode,"display","");
                            //query(".bottonSatte",this.domNode)[0].innerHTML = this.refundState[orderData.data.item.state];
                            if(orderData.data.item.state == 3){
                                this.canSave = true;
                                //domClass.remove(this.footerButton,"none");
                                domClass.add(query(".saveNode", this.domNode)[0], "none");
                                this.resize();
                            } else {
                                this.canSave = false;
                                //设置页面不可编辑                            
                                for(var i=0;i<alldom.length;i++){
                                    domAttr.set(query(alldom[i], this.domNode)[0].lastChild, "readonly", true);
                                }
                                //var editList = this.editList;
                                //隐藏完成按钮
                                domClass.add(query(".saveNode", this.domNode)[0], "none");
                            }                            
                        }
                    }));                    
                }	
                //获取订单的发货状态
                order.loadById(this.orderId).then(lang.hitch(this,function(orderDatas){
                    if(orderDatas&&orderDatas.data&&orderDatas.data.item){
                        this.deliveryState = orderDatas.data.item.isDelived;
                    }
                }));
            }
        },
        
        //提交申请
        onSaveOrderRefund:function(data){
            if(!this.canSave){
                alert("您已经提交过申请！");
                return;
            }
            if(this.isEditing&&this.canSave){
                //合法性检查
                this.isEditing = false;
                var iconItems = this.iconContainer.getChildren();
                var images =[];
                if (iconItems.length) {
                    for(var i=0;i<iconItems.length-1;i++){
                        images.push(iconItems[i].icon);
                    }
                }
                var m = this.getData()
                m.images = images;
                var msg = this.validityChecked(m); 
                if(msg){
                    alert(msg);
                    this.isEditing = true;
                    return;
                }
                //保存                                
                m.tsId = this.orderId;
                m.mids = this.mids;
				m.details = this.details;
				order.loadB2BById(this.orderId).then(lang.hitch(this,function(orderData){
					if(orderData&&orderData.data&&orderData.data.item){
						m.shopId = orderData.data.item.fromShopId;//order.getShopId();                        
						refundApplication.save(m).then(lang.hitch(this,function(data){
							if(data&&data.data&&data.data.ok == 1){
								//window.moveToView("orderDetail",this.orderId);
								history.back();
							} else {
								alert("保存失败");
                                this.isEditing = false;
								return;
							}
						}));
					}
				}));
			}
        },
        //listOptions点击如果查看的话不允许点击，只能查看
        _initOptionEdit:function(edit,li,value){
            var ops = edit.options,field = edit.field.split(".")[0];
            this.connect(li.domNode,"onclick",function(){
                if(window.did.split("-")[1]!="add"){
                    li.set("rightText",ops[this.__data[field]]||"");
                    return;
                }else{
                    optionsList.startEdit(this.__data[field]||"",this,ops).then(lang.hitch(this,function(value){
                        var oldValue = this.__data[field];
                        if((oldValue == undefined) || (oldValue == null)){
                            oldValue = "";
                        }
                        // 张松  如果编辑界面点击返回按钮，则保持原来的值不变  2016/06/14
                        if(value === ""){
                            value = oldValue;
                        }
                        if(false === this.onDataChange(field, oldValue, value)){
                            return;
                        }
                        li.set("rightText",ops[value]||"");
                        this.__data[field] = value;
                        this.onDataChanged(field, oldValue, value);
                    }));
                }
            });
            li.set("rightText",ops[value]||"");
            this.connect(this,"refreshData",function(){
                li.set("rightText",ops[this.__data[field]]||"");
            });
        },
        _initTextAreaEdit:function(edit,li,value){
            var field = edit.field.split(".")[0];
            this.connect(li.domNode, 'onclick', function(){
                if(window.did.split("-")[1]!="add"){
                    li.set("rightText", this.__data[field]||"");
                    return;
                }else{
                    textArea.startEdit(this.__data[field]||"", this).then(lang.hitch(this, function(value){
                        var oldValue = this.__data[field]||"";
                        if(false === this.onDataChange(field, oldValue, value)){
                            return;
                        }
                        this.__data[field] = value;
                        li.set("rightText", value);
                        this.onDataChanged(field, oldValue, value);
                    }));
                }
            });
            li.set("rightText", this.__data[field]||"");
            this.connect(this, "refreshData", function(){
                li.set("rightText", this.__data[field]||"");
            });
        },
        onApplyagain:function(){
            if(!this.canSave){
                alert("您已经提交过申请！");
                return;
            }
            if(this.isEditing&&this.canSave){
                //合法性检查
                this.isEditing = false;
                var iconItems = this.iconContainer.getChildren();
                if (iconItems.length) {
                    var images =[];
                    for(var i=0;i<iconItems.length-1;i++){
                        images.push(iconItems[i].icon);
                    }
                }
                var m = this.getData();
                m.images = images;
                var msg = this.validityChecked(m); 
                if(msg){
                    alert(msg);
                    this.isEditing = true;
                    return;
                }
                refundApplication.applyAgain(m).then(lang.hitch(this,function(data){
                    if(data.data.ok == 1){
                        history.back();
                    } else {
                        alert("保存失败");
                        this.isEditing = false;
                        return;
                    }
                })); 
			}
        },
        //合法性检查
        validityChecked:function(data){
            var msg = "";
            if(!data.treatmentMethod){
                msg = "请选择处理方式";
            }else if(!data.reason){
                msg = "请选择退款原因";
			}else if(!data.amount){
                msg = "请填写退款金额";
            }else if(!(/^\d+(?=\.{0,1}\d+$|$)/.test(data.amount))){
                msg = "退款金额只能为大于0的正数";
            }else if(parseFloat(data.amount)>parseFloat(data.remindAmount)){
                msg = "退款金额不能超过"+data.remindAmount+"元";
            }else if(!data.mobile){
                msg = "手机号码不能为空";
            }
            return msg;
        },
        onDataChanged: function(field, oldValue, newValue) {
            if(field=="treatmentMethod"){
                if(window.did.split("-")[1]!="add"){
                    this.isEditing = false;
                    return;
                }else{
                    //deliveryState 默认为fasle 未发货，true为发货
                    if(!this.deliveryState){
                        if(newValue==2){
                            alert("未发货，只能选择退款");
                            this.isEditing = false;
                        }else{
                            this.isEditing = true;
                        }
                    }
                }
            }else if(field=="reason"&&window.did.split("-")[1]!="add"){
                this.isEditing = false;
                return;
            }else if(field=="describe"&&window.did.split("-")[1]!="add"){
                this.isEditing = false;
                return;
            }
        },
        //再次查看点击不能响应
        onListClicked:function(){
            if(window.did.split("-")[1]!="add"){
                this.isEditing = false;
                return;
            }
        },
        loadList: function() {
            return [{
                label: '退款方式',
                rightText: '',
                moveTo: '#',
                className: "mblListItem treatmentMethod",
                onClick: lang.hitch(this, function() {
                    this.onListClicked();
                    return false;
                }),
                edit: {
                    type: 'options',
                    field: 'treatmentMethod',
                    options:{
                        1:'我要退款，但不退货',
                        2:'我要退货，并且退款'
                    }
                }
            },{
                label:'退款原因',
                rightText: "",
                moveTo: "#",
                className: "mblListItem reason",
                edit:{
                    type:'options',
                    field:'reason',
                    options:{
                        '1':'退运费',
                        '2':'做工问题',
                        '3':'少件/漏发',
                        '4':'商家发错货',
                        '5':'商品与描述不符',
                        '6':'未按约定时间发货',
                    }
                }
                
            },{
                label:'最大退款额(¥)',
				className: "mblListItem remindAmount",
                edit:{
                    type:'text',
                    field:'remindAmount'
                }
            },{
                label:'退款金额(¥)',
                className: "mblListItem amount",
                noArrow: true,
                edit:{
                    type:'text',
                    field:'amount',
                }
            },{
                label:'手机号码',
                className: "mblListItem mobile",
                noArrow: true,
                edit:{
                    type:'text',
                    field:'mobile',
                    placeHolder: '必填'
                }
            },{
                label:'退款说明（可不填）',
                className: "mblListItem describe",
                moveTo: "#",
                rightText: '请填写退款说明',
                edit:{
                    type:'textarea',
                    field:'describe'
                }
            }];
        },
    });
});