define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojo/dom-construct",
    "dojo/dom-attr",
    "dojo/Deferred",
    "dijit/_WidgetBase",
    "bob/shop/store/c"
],function(declare,lang,domStyle,domConstruct,domAttr,Deferred,_WidgetBase,shopStore){
    return new declare("",_WidgetBase,{
        hasLoaded: false,
        selfFetchData: null,
        getAction: function (data) {
            if(this._def){
                this._def.cancel();
            }
            this._def = new Deferred();
            domConstruct.empty(this.domNode);
            //创建商家配送，自提点自提两个按钮
            this.labelNode = domConstruct.create("div",{
                "class": "item-cells",
                style: "height:200px;"
            },this.domNode);
            //创建顶部
            domConstruct.create("div",{
                "class": "cells-title",
                innerHTML:"配送方式"
            },this.labelNode);
            
            //创建与商家配送相关节点
            this.distrNode = domConstruct.create("li",{
                "class":"item-cell",
                style:"text-align:left;"
            },this.labelNode);
            domConstruct.create("div",{
                "class":"item-cell-bd",
                innerHTML:"快递 ¥ "+window.fixedTo(data.tAmount,3)
            },this.distrNode);
            this.distrBt = domConstruct.create("input",{
                "class":"item-cell-ft",
                type:"checkbox"
            },this.distrNode);
            
            //创建自提点自提相关节点
            this.selfFetchNode = domConstruct.create("li",{
                "class":"item-cell",
                style:"text-align:left;"
            },this.labelNode);
            domConstruct.create("div",{
                "class":"item-cell-bd",
                innerHTML:"到店自提"
            },this.selfFetchNode);
            
            this.selfFetchBt = domConstruct.create("input",{
                "class":"item-cell-ft",
                type:"checkbox"
            },this.selfFetchNode);
            //关闭按钮的创建
            var cancelBtn = domConstruct.create("div", {
                innerHTML: "关闭",
                "class": "edit-car-affirm"
            }, this.domNode);
            
            this.loadShopfetch({
                shopId: data.shopId
            }).then(lang.hitch(this, function(selfFetchData){
                // 如果有自提点 则显示自提选项
                if(selfFetchData.length&&selfFetchData.length>0){
                    domStyle.set(this.selfFetchNode,"display","");
                }else{
                    domStyle.set(this.selfFetchNode,"display","none");
                }
                //如果原始的deliveyyType有值，则选择相应的按钮节点
                if(data.deliveryType == 1){
                    domAttr.set(this.distrBt,"checked",true);
                    domAttr.set(this.selfFetchBt,"checked",false);
                }else{
                    domAttr.set(this.selfFetchBt,"checked",true);
                    domAttr.set(this.distrBt,"checked",false);
                }
                // 监控异步对象
                //两个按钮的点击事件
                this.connect(this.distrNode,"onclick",function(){
                    //设置商家配送为选中，设置自提点自提为不选中
                    domAttr.set(this.distrBt,"checked",true);
                    domAttr.set(this.selfFetchBt,"checked",false);
                    //确定选中s商家配送，而且返回值
                    this._def.resolve({
                        deliveryType:1,
                        fetchPos:""
                    });
                });
                this.connect(this.selfFetchNode,"onclick",function(){
                    domAttr.set(this.selfFetchBt,"checked",true);
                    domAttr.set(this.distrBt,"checked",false);
                    //确定选中自提点自提
                    this._def.resolve({
                        deliveryType:2,
                        address:selfFetchData[0]
                    });
                });
                //确定取消的店家事件绑定，没有选择就按照进来的方式显示出去
                this.connect(cancelBtn, "onclick", function(){
                    var params = {
                        deliveryType:data.deliveryType,
                        address:data.storeId
                    };
                    this._def.resolve(params);
                });
            }));
            return this._def;
        },
        loadShopfetch:function(params){
            var def = new Deferred();
            if(!this.hasLoaded){
                shopStore.load({
                    fromShopId:params.shopId,
                    isSelfFetch:true,
                    isUse:true
                }).then(function(data){
                    this.selfFetchData = data&&data.data&&data.data.items||[];
                    def.resolve(data&&data.data&&data.data.items||[]);
                });
            }else{
                //将传进来的address放在数组里面
                def.resolve(this.selfFetchData);
            }
            return def;
        }
    })();
});