define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojox/mobile/Heading",
    "dojox/mobile/ToolBarButton",
    "cq/ui/view/EditorBase",
    "cq/app/widget/mobile/List",
    "bob/shop/store/c"
],function(declare,lang,Deferred,
    Heading,ToolBarButton,EditorBase,List,shopStore){
    return new declare("",EditorBase,{
        //初始化界面元素并绑定事件
        onAfterAddedPane:function(){
            //顶部工具条
            this.header = new Heading({
                label:"自提点选择"
            });
            this.header.placeAt(this.headerPane.domNode);
            //左侧按钮
            this.header.addChild(new ToolBarButton({
                arrow : "left",
                label:"",
                onClick:lang.hitch(this,this.cancel)
            }));
            //列表选择区域
            this.selectList = new List({
                itemType:"IconLabel",
                items:[],
                dataProvider:this,
                clickMethod:"onSelectListClick"
            });
            this.selectList.placeAt(this.contentPane.containerNode);
        },
        startEdit:function(params,refView){
            this.orginValue = params || "";
            this._refView = refView;
            this.setOrigin(this.orginValue);
            this.initList(params);
            this.placeAt(this._refView.domNode,"after");
            this.show();
            this.resize();
            this._editDef = new Deferred();
            return this._editDef;
        },
        initList:function(shopId){
            //加载商家默认的所有自提点
            shopStore.load({fromShopId:shopId,isSelfFetch:true,isUse:true}).then(lang.hitch(this,function(fetchDate){
                if(fetchDate&&fetchDate.data&&fetchDate.data.items.length){
                    fetchDate = fetchDate.data.items;
                    //存在自提点，初始化列表
                    //先清除列表内容
                    this.selectList.getChildren().forEach(function(item){
                        item.destroyRecursive();
                    });
                    //填充列表数据
                    this.selectList.onDataReady(fetchDate.map(lang.hitch(this,function(item){
                        return {
                            label:'<li class="addr-list-item">'+item.name+'<span style="float:right;">'+item.tel+
                            '</span>'+'<li>'+
                            '<li class="addr-list-item"><h5 class="title">'+item.addr+'</h5></li>',
                            variableHeight:true,
                            fetchDate:item
                        };
                    })));
                    this.contentPane.resize();
                }
            }));
        },
        onSelectListClick:function(data){
            this.setValue(data.fetchDate);
            this.finish();
        },
        setValue:function(value){
            this.value = value;
        },
        getValue:function(){
            return this.value;
        },
        cancel:function(){
            return this.defRtn("");
        }
    })();
});