﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojox/mobile/View",
    "dojox/mobile/FixedSplitter",
    "dojox/mobile/Pane",
    "dojox/mobile/Heading",
    "dojox/mobile/ToolBarButton",
    "cq/util/config/config"
],function(declare,lang,Deferred,View,FixedSplitter,Pane,Heading,ToolBarButton,config){
    return declare("cq.ui.view.EditorBase",View,{
        buildRendering : function() {
            config.coverWdigets = config.coverWdigets||[];
            config.coverWdigets.push(this);
          this.inherited(arguments);
          this.domNode.style.height = "100%";
          this.addChild(this.splitter = new FixedSplitter({
              variablePane:1,
              orientation:"V"
          }));
          this.splitter.addChild(this.headerPane = new Pane());
          // 中间区域不能使用ScrollablePane ，否则contenteditable属性失效
          this.splitter.addChild(this.contentPane = new Pane());
          //底部区域添加按钮？？？可以添加
          this.splitter.addChild(this.bottomPane = new Pane({"class": "hflex"}));
          this.onAfterAddedPane();
          this.createContent();
        },
        onAfterAddedPane:function(){
          var header = this.header = new Heading();
          header.placeAt(this.headerPane.domNode, "first");
          var backButton = new ToolBarButton({
            //label : "返回",
            "class" : "float-left",
            //arrow : "left",
            icon:"mblDomButtonGrayCross",
            onClick : lang.hitch(this, this.cancel)
          });
          backButton.placeAt(header, "first");
          var completeButton;
          this.completeButton = completeButton=new ToolBarButton({
            label : "完成",
            "class" : "float-right cq-btn-dark",
            onClick : lang.hitch(this, this.finish)
          });
          completeButton.placeAt(header, "last");
        },
        createContent:function(){
        },
        defRtn:function(value){
          this._editDef.resolve(value);
          this._refView.show();
		  setTimeout(lang.hitch(this,function(){
			  this._refView.resize();
		  }),100);
        },
        cancel : function() {
            return this.defRtn(this.orginValue);
        },
        finish : function() {
            return this.defRtn(this.getValue());
        },
        getValue:function(){
        },
        setOrigin:function(text){
        },
        startEdit : function(text, refView) {
          this.orginValue = text || "";
          this._refView = this.getParentView(refView);
          this.setOrigin(this.orginValue);
          this.placeAt(this._refView.domNode,"after");
          this.show();
          this.resize();
          this._editDef = new Deferred();
          return this._editDef;
        },
        isCqOpened:function(){
            return this.domNode&&this.domNode.parentNode;
        },
        cqHide:function(){
            this.cancel();
        },
        getParentView:function(widget){
            // coverRefView:true || false
            // 如果 startEdit传入的refView不是一个view，而又期望弹出的窗口覆盖掉当前view，则将
            // refView.coverRefView设置为true
            if(!widget.coverRefView){
                return widget;
            }
            var getView = function(widget){
                if(!widget.show){
                    widget = widget.getParent();
                    return getView(widget);
                }else{
                    return widget;
                }
            };
            widget = getView(widget);
            return widget;
        }
    });
});