define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/query",
    "dijit/registry",
    "dojo/touch",
    "dojox/mobile/ListItem",
    "dojo/dom-geometry"
], function (declare, lang, domAttr, domClass, domConstruct, domStyle, query, registry, touch, ListItem, domGeometry) {
    return declare("cq.ui.view.ListItem", [ListItem], {
        headHtml:"<div class='mblListItemHeadLeft'><img src='' class='mblListItemHeadIcon' style='display:none;'><label class='mblListItemHeadLabel' style='display:none;'></label></div><div class='mblListItemHeadRight'></div>",
        rightHtml:"",
        useHeadPane:true,
        useRightPane:true,
        rightClick:"",
        useSlide:true,
        baseClass:"mblListItem mblListItem1",
        itemHandlers:{},
        buildRendering:function(){
            this.inherited(arguments);
            // 添加头部区域
            if(this.useHeadPane){
                this.headPane = domConstruct.create("div", {
                    className:"mblListItemHeadPane",
                    innerHTML:this.headHtml
                }, this.domNode, "first");
                // 调整位置
                this.connect(this, "_setIconAttr", lang.hitch(this, function(e){
                    this.domNode.insertBefore(this.headPane, this.domNode.firstChild);
                }));
                // 设置li宽度
                domStyle.set(this.domNode, "width", domGeometry.getMarginBox(window.viewParam[window.curView].view.domNode).w - 32 + "px");
            }
        },
        startup:function(){
            this.inherited(arguments);
            // 添加右部功能区
            if(this.useRightPane){
                this.rightPane = domConstruct.create("div", {
                    className:"mblListItemRightPane none",
                    innerHTML:this.rightHtml
                }, this.domNode, "after");
            }
            // 右部功能区点击事件
            if(this.rightClick){
                this.itemHandlers["rightClickHandler"] = this.connect(this.rightPane, "onclick", lang.hitch(this, function(e){
                    this.rightClick(e);
                    domClass.remove(this.domNode, "moveToLeft");
                    this.rightPane.parentNode.removeChild(this.rightPane);
                    this.disconnect(this.itemHandlers["slideHandler"]);
                    this.itemHandlers["slideHandler"] = null;
                    delete this.itemHandlers["slideHandler"];
                    this.disconnect(this.itemHandlers["rightClickHandler"]);
                    this.itemHandlers["rightClickHandler"] = null;
                    delete this.itemHandlers["rightClickHandler"];
                }));
            }
            // 左滑
            //if(this.useSlide){
            //    this.itemHandlers["slideHandler"] = this.connect(this, touch.move, lang.hitch(this, function(e){
            //        var x = e.touches ? e.touches[0].pageX : e.clientX;
            //        var y = e.touches ? e.touches[0].pageY : e.clientY;
            //        if((this.touchStartX - x) >= 4 && Math.abs(this.touchStartY - y) <= 4){
                        // 显示右侧功能区
            //            domClass.remove(this.rightPane, "none");
                        // 左侧区域左移
            //            domClass.add(this.domNode, "moveToLeft");
            //        }
            //    }));
            //}
        },
        slideLeft:function(dir){
            if(this.isRead){
                return;
            }
            if(dir > 0){
                // 往左
                // 显示右侧功能区
                domClass.remove(this.rightPane, "none");
                // 左侧区域左移
                domClass.add(this.domNode, "moveToLeft");
            }else{
                // 往右
                domClass.remove(this.domNode, "moveToLeft");
                domClass.add(this.rightPane, "none");
            }
        },
        _setUseHeadPaneAttr:function(use){
            this.useHeadPane = use;
        },
        _setUseRightPaneAttr:function(use){
            this.useRightPane = use;
        },
        _setRightClickAttr:function(rightClick){
            this.rightClick = rightClick;
        },
        _setUseSlideAttr:function(use){
            this.useSlide = use;
        },
        _setHeadLogoAttr:function(logo){
            query(".mblListItemHeadIcon", this.headPane)[0].src = logo;
            domStyle.set(query(".mblListItemHeadIcon", this.headPane)[0], "display", "inline");
        },
        _setHeadLabelAttr:function(label){
            query(".mblListItemHeadLabel", this.headPane)[0].innerHTML = label;
            domStyle.set(query(".mblListItemHeadLabel", this.headPane)[0], "display", "inline");
        },
        _setHeadRightAttr:function(right){
            query(".mblListItemHeadRight", this.headPane)[0].innerHTML = right;
        }
    });
});