define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-style",
    "dojo/Deferred",
    "cq/biz/pr/dPProgram",
],function(declare, lang, array, domStyle, Deferred, dPProgram) {
    return declare("cq.ui.view._DPProgramViewMixin", null, {
        isBatchCreate : false,
        // 记录批量生成时的页面数据
        batchCreateData : null,
        setWindowDid : function () {
            this.didParams = {};
            if (window.did) {
                var dids = window.did.split("-");
                array.forEach(dids, function (did) {
                    var params = did.split("_");
                    if (params.length === 1) {
                        this.didParams._id = params[0];
                    } else {
                        this.didParams[params[0]] = params[1];
                    }
                }, this);
            }
        },
        // 处理显示隐藏的问题
        showCattleList : function (node) {
            // 先隐藏所有的
            domStyle.set(this.editList.domNode, "display", "none");
            domStyle.set(this.batchList.domNode, "display", "none");
            // 显示传入的
            domStyle.set(node, "display", "");
        },
        getWindowDid : function () {
            if (this.didParams.pageType && this.didParams.pageType == "add") {
                this.isBatchCreate = true;
            } else {
                this.isBatchCreate = false;
            }
            this.cattleId = this.didParams.cattle || undefined;
            this.dPProgramId = this.didParams.dPProgramId || undefined;
            this._id = this.didParams._id || undefined;
        },
        selectCattles:function(){
            // 保存当前页面的数据
            this.batchCreateData = this.getData();
            if (this.didParams.taskId) {
                window.moveToView("taskCattleList", "pageType_select-taskId_" + this.didParams.taskId);
            } else {
                window.moveToView("cattleList", "select");
            }
        },
        // 获取疾病防控项目
        getDpprogramData : function () {
            var def = new Deferred();
            var dPProgramData = undefined;
            if (this.dPProgramId) {
                dPProgram.loadById(this.dPProgramId).then(lang.hitch(this, function(data) {
                    if (data && data.data && data.data.ok === 1) {
                        dPProgramData = data.data.item;
                    }
                    def.resolve(dPProgramData);
                }));
            } else {
                def.resolve(dPProgramData);
            }
            return def;
        },
        //批量生成function
        batchCreatePage:function(){
            this.showCattleList(this.batchList.domNode);
            var item = {};
            if (this.batchCreateData) {
                item = this.batchCreateData;
            }
            item.cattleId = this.getCattleCord();
            if (this.dPProgramId) {
                this.getDpprogramData().then(lang.hitch(this, function(data) {
                    item.programId = data;
                    this.setData(this.initPageData(item));
                    this.refreshData();
                }));
            } else {
                this.setData(this.initPageData(item));
                this.refreshData();
            }
        },
        
        // 获取localStorage中的畜只耳号
        getCattleCord : function () {
            var cattleCords = [];
            if (localStorage.cattles) {
                var cattles = JSON.parse(localStorage.cattles);
                if (cattles) {
                    array.forEach(cattles, function (cattle) {
                        cattleCords.push(cattle.earCode); 
                    });
                }
            }
            return cattleCords.toString();
        },
        // 获取localStorage中的畜只对象
        getBatchCattles : function () {
            var pageCattle = [];
            if (localStorage.cattles) {
                var cattles = JSON.parse(localStorage.cattles);
                if (cattles) {
                    array.forEach (cattles, function (cattle) {
                        pageCattle.push(cattle._id);
                    });
                }
            }
            return pageCattle;
        },
    });
});
