define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojox/mobile/View",
    "dojo/Deferred",
    "cq/ui/view/_ViewMixin",
],function(declare, lang, array, View, Deferred, _ViewMixin) {
    return declare("cq.ui.view._QueryFilterMixin", [View, _ViewMixin], {
        // 页面显示的内容
        indexElement : function(){
            this.addHeadList();
            this.addQueryList();
            this.addFooterBtn();
        },
        addHeadList : function () {
            var option = {
                title: "筛选条件",
            };
            this.addHeader(option);
        },
        // 添加要查询的列表项
        addQueryList : function () {},
        addFooterBtn : function () {
            var option = {
                columns: [{
                    label: "确认",
                    onClick: lang.hitch(this, function() {
                        window.busy();
                        data = this.getData();
                        this.currentDef.resolve(data);
                        this.hideOverlay();
                    }),
                    className: "flex2 footer-tab-highlight"
                }, {
                    label: "取消",
                    onClick: lang.hitch(this, function() {
                        this.currentDef.resolve();
                        this.hideOverlay();
                    }),
                    className: "flex2 footer-tab-dark"
                }],
                forceWidth: false,
                isFooter: true
            };
            this.addColumns(option);
        },
        setListItemClass : function () {},
        showAuditOption : function (params) {
            // 初始化一个异步操作
            this.currentDef = new Deferred();
            var pageData = lang.clone(params || {});
            this.startup();
            this.setListItemClass();
            this.setData(this.initPageData(pageData));
            this.refreshData();
            return this.currentDef;
        },
        // 初始化化页面数据，可重写
        initPageData : function (data) {
            return data;
        },
        setWindowDid : function () {
            this.didParams = {};
            if (window.did) {
                var dids = window.did.split("-");
                array.forEach(dids, function (did) {
                    var params = did.split("_");
                    if (params.length === 1) {
                        this.didParams._id = params[0];
                    } else {
                        this.didParams[params[0]] = params[1];
                    }
                }, this);
            }
        }
    });
});
