﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dijit/_Widget",
    "cq/util/config/config"
],function(declare,lang,domConstruct,domStyle,_Widget,config){
    var Dialog = declare("",[_Widget],{
        //初始化节点
        buildRendering:function(){
            //domNode
            this.inherited(arguments);
            //半透明背景
            domStyle.set(this.domNode,{
                display:"none",
                position:"absolute",
                top:0,
                left:0,
                background:"none",
                width:"100%",
                height:"100%",
                "z-index":1
            });
            this.bgNode = domConstruct.create("div",{
                style:"position:absolute;top:0;left:0;background:#000;opacity:0.7;width:100%;height:100%;"
            },this.domNode);
            //内容显示节点
            this.containerNode = domConstruct.create("div",{
                style:"position:absolute;"
            },this.domNode);
            //右上角关闭按钮
            var div = this.closeButton = domConstruct.create("div",{
                style:"position:absolute;width:29px;height:29px;"
            },this.domNode);
            this.connect(this.closeButton,"onclick",function(){
                this.hide()
            });
            div = domConstruct.create("div",{
                style:"position:relative;top:3px;left:3px;width:23px;height:23px;background-color:white;border-radius:12px;box-shadow:0px 1px 2px rgba(0,0,0,0.5);"
            },div);
            div = domConstruct.create("div",{
                style:"position:relative;top:2px;left:2px;width:19px;height:19px;background-color:black;border-radius:10px;"
            },div);
            div = domConstruct.create("div",{
                style:"position:absolute;top:8px;left:3px;width:13px;height:3px;margin:0px;font-size:1px;border-style:none;background-color:white;transform:rotate(45deg);border-radius:1px;"
            },div);
            div = domConstruct.create("div",{
                style:"position:absolute;top:-5px;left:5px;width:3px;height:13px;margin:0px;font-size:1px;background-color:white;border-radius:1px;"
            },div);
            //用来计算内容高度的节点
            this.sizeNode = domConstruct.create("div",{
                style:"position:absolute;left:-1000px;top:-1000px;"
            },this.domNode);
        },
        //显示内容
        //  node        要显示的节点dom对象或者html片段
        //  closeable   是否有关闭按钮，为false时隐藏关闭按钮(右上角的X)
        show:function(node,closeable){
            this.placeAt(document.body);
            this.reposition(node);
            domStyle.set(this.closeButton,"display",closeable===false?"none":"");
            this.containerNode.innerHTML = "";
            while(this.sizeNode.childNodes.length){
                this.containerNode.appendChild(this.sizeNode.childNodes[0]);
            }
        },
        //依据内容大小，重算当前对象的位置
        reposition:function(node){
            domStyle.set(this.sizeNode,{
                display:"inline",
                width:"",
                height:""
            });
            document.body.appendChild(this.sizeNode);
            this.sizeNode.innerHTML = "";
            if("string"===typeof(node)){
                this.sizeNode.innerHTML = node;
            }else{
                this.sizeNode.appendChild(node);
            }
            domStyle.set(this.domNode,"display","");
            var width = domStyle.get(this.domNode,"width");
            if(domStyle.get(this.sizeNode,"width")>0.9*width){
                domStyle.set(this.sizeNode,{
                    "width":width*0.9+"px",
                    display:"inline-block"
                });
            }
            var nodeWidth = domStyle.get(this.sizeNode,"width");
            var height = domStyle.get(this.domNode,"height"),nodeHeight = domStyle.get(this.sizeNode,"height");
            domStyle.set(this.closeButton,{
                top:(height-nodeHeight)/3-15+"px",
                left:(width-nodeWidth)/2-15+nodeWidth+"px"
            });
            domStyle.set(this.containerNode,{
                top:(height-nodeHeight)/3+"px",
                left:(width-nodeWidth)/2+"px"
            });
            this.domNode.appendChild(this.sizeNode);
        },
        //隐藏
        hide:function(){
            domStyle.set(this.domNode,"display","none");
        },
        //当前对话框是否处于显示状态
        isCqOpened:function(){
            return "none"!==domStyle.get(this.domNode,"display");
        },
        cqHide:function(){
            return this.hide();
        }
    });
    var dialog = new Dialog();
    dialog.hide();
    
    config.coverWdigets = config.coverWdigets||[];
    config.coverWdigets.push(dialog);
    return dialog;
});
