﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojox/mobile/Container",
    "dojox/mobile/Pane",
    "dojox/mobile/ScrollablePane",
    "dojox/mobile/View",
    "cq/ui/view/_ViewMixin",
    "cq/ui/view/EditorBase",
    "cq/ui/view/ViewUtil"
],function(declare,lang,domStyle,Container,Pane,ScrollablePane,View,_ViewMixin,EditorBase,ViewUtil){
   var Layout = declare("",EditorBase,{
        baseClass:"mblView cqRichEditor",
        startEdit:function(param,refView){
            var lists = [];
            if(param&&param.fields){
                this.fields = param.fields;
                for(var field in this.fields){
                    var item = this.fields[field];
                    if(item.type === 'img'){
                        lists.push({
                            label: item.label,
                            field:item.field,
                            noArrow: false,
                            variableHeight : true,
                            moveTo: '#',
                            imgSize: this.imgCutSize,
                            sizeType:"upload",
                            "class": "li-icon",
                            edit: {
                                type: "image",
                                field: item.field
                            }
                        });
                    }else if(item.type === "text"){
                        lists.push({
                            label: item.label,
                            field:item.field,
                            noArrow: true,
                            edit: {
                                type: "text",
                                field: item.field
                            }
                        });
                    }else if(item.type === 'textArea'){
                            lists.push({
                                label:item.label,
                                noArrow:false,
                                edit:{
                                    type:"textarea",
                                    field:item.field
                                }
                            });   
                    }
                }
                //values = param.values;
            }
            if (this.boxEdit) {
                this.boxEdit.destroyRecursive();
            }
            this.boxEdit = new BoxEdit({
                "lists":lists
            });
            this.boxEdit.placeAt(this.contentPane.containerNode);
            return this.inherited(arguments);
        },
        
        getValue:function(){
            return this.boxEdit.getData();
        },
        finish : function() {
            var value = this.getValue();
            var isFinish = true;
            for(var i=0;i<this.fields.length;i++){
                if(!value[this.fields[i].field]){
                    isFinish = false;
                    alert(this.fields[i].label+"未编辑");
                    break;
                }
            }
            if(isFinish){
                this.defRtn(value);   
            }else{
                return;
            }
            
        },
        cancel:function() {
            return this.defRtn("");
        }
    });
    var BoxEdit = declare("", [Pane, Container, _ViewMixin], {
        lists:[],
        coverRefView:true,
        indexElement: function() {
            //创建数据编辑的list
            this.createList();
            this.centerPanel.set("style", "height:100%;text-align: left;");
        },
        createList: function() {
            //编辑的界面
            var option = {
                isEdge: true,
                lists: this.lists
                //data: values
            };
            this.boxEditItems = this.addLists(option);
        }
    });
    var layout = new ViewUtil({
        EditorClass:Layout
    }); 
    return layout;
});