﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojox/mobile/Overlay",
    "cq/util/config/config"
],function(declare,lang,domConstruct,domStyle,Overlay,config){
    var maskNode = domConstruct.create("div",{
        style:"opacity:0.6;background-color:#000;display:none;",
        "class":"cover"
    }, document.body, "last");
    var CqOverlay = declare("",Overlay,{
        show:function(){
            this.isOpened = true;
            clearTimeout(this.hideTimer);
            domStyle.set(maskNode,"display","");
            this.inherited(arguments);
        },
        hide:function(){
            this.isOpened = false;
            var arr = arguments;
            clearTimeout(this.hideTimer);
            this.hideTimer = setTimeout(lang.hitch(this,function(){
                domStyle.set(maskNode,"display","none");
                domStyle.set(overlay.domNode,"position","fixed");
                Overlay.prototype.hide.apply(this,arr);
                this.realHided();
            }),300);
        },
        realHided:function(){}
    });
    var overlay = new CqOverlay();
    overlay.placeAt(document.body);
    overlay.startup();
    overlay.connect(maskNode, "onclick", function(){
        this.hide();
    });
    overlay.showInOverlay = function(node){
        overlay.domNode.innerHTML = "";
        overlay.domNode.appendChild(node);
        overlay.show();
    };
    overlay.isCqOpened = function(){
        return this.isOpened;
    };
    overlay.cqHide = function(){
        return this.hide();
    };
    config.coverWdigets = config.coverWdigets||[];
    config.coverWdigets.push(overlay);
    overlay.showElement = overlay.showInOverlay;
    lang.setObject("cq.util.edit.overlay",overlay);
    return overlay;
});