﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/connect",
    "dojo/dom-construct",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/on",
    "dojo/sniff",
    "dijit/Editor",
    "dijit/form/Button",
    "dijit/registry",
    "dijit/_editor/_Plugin",
    "dijit/_editor/plugins/LinkDialog",
    "dijit/_editor/plugins/ViewSource",
    "dijit/_editor/plugins/FontChoice",
    "cq/biz/blob/blob",
    "cq/ui/view/EditorBase",
    "cq/ui/view/ViewUtil"
],function(declare,lang,connect,domConstruct,domClass,domStyle,on,has,Editor,Button,registry,_Plugin,LinkDialog,ViewSource,FontChoice,blob,EditorBase,ViewUtil){
    var loadStyle = function(url){
        var linkNode = domConstruct.create("link",{
            type:'text/css',
            rel:'stylesheet',
            href:url
        });
        var links = document.getElementsByTagName('link');
        for(var i = 0;i<links.length;i++){
            if(linkNode.href === links[i].href){
                return;
            }
        }
        var head = document.getElementsByTagName('head')[0];
        head.appendChild(linkNode);
    };
    loadStyle("../../../lib/dojo2/dijit/themes/claro/claro.css");
    loadStyle("../../../lib/dojo2/dijit/themes/claro/Calendar.css");
    //编辑增加图片上传按钮
    lang.extend(LinkDialog.ImgLinkDialog,{
        _initButton:function(){
            //先执行原来的方法
            LinkDialog.prototype._initButton.apply(this,arguments);
            //图片对话框第一次显示时
            var handler = connect.connect(this.button,"openDropDown",lang.hitch(this,function(){
                //保证只执行一次
                handler.remove();
                domConstruct.place((new Button({
                    label:"上传",style:"float:right;",onClick:lang.hitch(this,this._onUpLoadClick)
                })).domNode,registry.byId(this._uniqueId+"_cancelButton").domNode,"after");
            }));
            if(has("touch")){
                this.editor.onLoadDeferred.then(lang.hitch(this, function(){
                    this.editor.own(on(this.editor.editNode, "click", lang.hitch(this, "_onDblClick")));
                }));
            }
        },
        //上传按钮点击之后，隐藏对话框，显示图片选择框
        _onUpLoadClick:function(){
            var value = this.dropDown.get("value");
            this.dropDown.onCancel();
            blob.selectAndUpload({width:0,height:0},0.7).then(lang.hitch(this,function(data){
                if (data.items && data.items.length == 1) {
                    this.button.openDropDown();
                    value = value||{};
                    value.urlInput = data.items[0].uri;
                    this.dropDown.set("value",value);
                }
            }));
        }
    });
    
    var ToolRichEdit = declare("",EditorBase,{
        createContent:function(){
            domClass.add(this.domNode,"claro");
            // 增加图片上传、看源码按钮
            extraPlugins = ['insertImage','viewsource',{name:'dijit/_editor/plugins/FontChoice', command:'fontSize', generic:true}];
            this.contentNode = new Editor({
                extraPlugins:extraPlugins,
                //height:"500px"
                //height:"100%"
            });
            this.contentNode.startup();
            this.contentNode.placeAt(this.contentPane);
            
        },
        getValue:function(){
            return this.contentNode.getValue();
        },
        setOrigin:function(text){
            this.contentNode.setValue(text||"");
        },
        resize:function(){
            this.inherited(arguments);
            var height = ((this.domNode.clientHeight-this.header.domNode.clientHeight-this.contentNode.toolbar.domNode.clientHeight-8)||0)+"px";
            domStyle.set(this.contentNode.iframe,"height",height);
        }
    });
    var toolRichEdit = new ViewUtil({
        EditorClass:ToolRichEdit
    });
    lang.setObject("cq.util.edit.toolRichEditor",toolRichEdit);
    return toolRichEdit;
});