﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/dom-class",
    "dojo/dom-style",
    "dijit/_WidgetBase",
    "cq/util/config/config"
],function(declare,lang,domConstruct,domClass,domStyle,_WidgetBase,config){
    var maskNode = domConstruct.create("div",{
        style:"opacity:0;background-color:rgb(0,0,0);display:none;",
        "class":"cover"
    }, document.body, "last");
    var CqOverlay = declare("",_WidgetBase,{
        style:"display:none;position:absolute;left:0;top:0;z-index:1000;",
        buildRendering:function(){
            this.inherited(arguments);
            this.tipNode = domConstruct.create("div",{
                style:"display:block;verticle-align:top;width:0px;height:0px;border:8px solid transparent;"
            },this.domNode);
            this.containerNode = domConstruct.create("div",{
                style:"width:150px;display:inline-block;verticle-align:top;"
            },this.domNode);
            this.connect(this.domNode,"onclick",this.onClick);
        },
        showInOverlay:function(/*tooltip 容器节点*/node,/*点击按钮位置信息*/clickPos){
            this.containerNode.innerHTML = "";
            this.containerNode.appendChild(node);
            if(this.tooltipHandle){
                this.tooltipHandle.remove();  
            }
            //tooltip点击后执行hide方法
     
            domStyle.set(node,"display","");
            this.show(clickPos);
        },
        onClick:function(){
            this.hide();
        },
        show:function(clickPos){
            if(this.maskHandler){
                this.maskHandler.remove();
                this.maskHandler = null;
            }
            this.maskHandler = this.connect(maskNode, "onclick", this.onClick);
            this.isOpened = true;
            domStyle.set(maskNode,"display","");
            domStyle.set(this.domNode,"display","");
            this.reposition(clickPos);
        },
        hide:function(){
            if(this.maskHandler){
                this.maskHandler.remove();
                this.maskHandler = null;
            }
            this.isOpened = false;
            if(this._hideTimer){
                clearTimeout(this._hideTimer);
            }
            this._hideTimer = setTimeout(lang.hitch(this,this.realHide),300);
        },
        //
        reposition:function(pos){
            //放在下边，右边对其或者左边对其
            if(pos.w<150){
                if(pos.x+pos.w>150){
                    domStyle.set(this.domNode,"left",parseFloat(pos.x+pos.w-150,10).toFixed(2)+"px");
                    domStyle.set(this.tipNode,"margin-left",parseFloat(150-(pos.w+8)/2-8,10).toFixed(2)+"px");
                }else{
                    domStyle.set(this.domNode,"left",parseFloat(pos.x,10).toFixed(2)+"px");
                    domStyle.set(this.tipNode,"margin-left",parseFloat((pos.w-8)/2-8,10).toFixed(2)+"px");
                }
            }else{
                domStyle.set(this.domNode,"left",parseFloat(pos.x+(pos.w-150)/2,10).toFixed(2)+"px");
                domStyle.set(this.tipNode,"margin-left",parseFloat((150-8)/2,10).toFixed(2)+"px");
            }
            var height = domStyle.get(this.domNode,"height"),
                totalHeight = domStyle.get(maskNode,"height");
            //下边空间不足，且上边空间充足，放到上边，否则放到下边
            if(pos.y>height+8&&totalHeight<pos.y+pos.h+8+height){
                domStyle.set(this.domNode,{
                    "top":parseFloat(pos.y-150-8,10).toFixed(2)+"px"
                });
                domStyle.set(this.tipNode,{
                    "border-top":"10px solid rgba(65, 67, 69, 0.9)",
                    "border-bottom":"0px"
                });
                this.domNode.appendChild(this.tipNode);
            }else{
                domStyle.set(this.domNode,{
                    "top":(pos.y+pos.h)+"px"
                });
                domStyle.set(this.tipNode,{
                    "border-bottom":"10px solid rgba(65, 67, 69, 0.9)",
                    "border-top":"0px"
                });
                this.domNode.appendChild(this.containerNode);
            }
        },
        realHide:function(){
            if(!this.isOpened){
                domStyle.set(this.domNode,"display","none");
                domStyle.set(maskNode,"display","none");
            }
        },
        isCqOpened:function(){
            return this.isOpened;
        },
        cqHide:function(){
            return this.hide();
        }
    });
    var tooltip = new CqOverlay();
    tooltip.placeAt(document.body);
    tooltip.startup();
    config.coverWdigets = config.coverWdigets||[];
    config.coverWdigets.push(tooltip);
    
    tooltip.showElement = tooltip.showInOverlay;
    lang.setObject("cq.util.edit.tooltip",tooltip);
    return tooltip;
});