﻿//郭周全 原cq/biz/blob/blob.js迁移过来的
// selectAndUpload选择图片并且上传，可以传入压缩后图片的尺寸，以及压缩质量
// size如果不传，默认压缩后图片宽度640
// size如果宽度为0，则宽高不压缩
// 否则，压缩后图片宽高为传入的size值
define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/lang",
    "dojo/dom-attr",
    "dojo/DeferredList",
    "dojo/dom-construct",
    "dojo/request/xhr",
    "dojo/Deferred",
    "cq/util/config/config",
    "cq/util/sys/userAgent"
],function(declare,array,lang,domAttr,DeferredList,domConstruct,xhr,Deferred,config,userAgent){
    var blob,fileInput,createFileInput = function(){
        if(fileInput&&fileInput.parentNode){
            fileInput.parentNode.removeChild(fileInput);
        }
        fileInput = domConstruct.create("input",{
            "class":"none",
            style:"display:none;",
            type:"file"
        },document.body);
        fileInput.onchange = function(){
            blob.onFileChanged();
        };
    };
    var papersMaxSize = config.papersMaxSize;
    createFileInput();
    var capture = {
        _init:function(callback,errorback,size){
            this._callback = callback;
            this._errorback = errorback;
            if(!this._initDef){
                this._initDef = new Deferred();
                require([
                    "dojo/dom-style",
                    "dojox/mobile/EdgeToEdgeList",
                    "dojox/mobile/ListItem",
                    "dojox/mobile/SimpleDialog",
                ],lang.hitch(this,function(domStyle,EdgeToEdgeList,ListItem,SimpleDialog){
                    this.dialog = new SimpleDialog({style:"width:240px;",title:"选择来源"});
                    this.dialog.containerNode.appendChild((this.list = new EdgeToEdgeList()).domNode);
                    this.list.addChild(new ListItem({
                        label:"拍照",
                        noArrow:true,
                        clickable:true,
                        onClick:lang.hitch(this, function(){
                            this._captureImg("CAMERA");
                        })
                    }));
                    this.list.addChild(new ListItem({
                        label:"相册",
                        noArrow:true,
                        clickable:true,
                        onClick:lang.hitch(this, function(){
                            this._captureImg("PHOTOLIBRARY");
                        })
                    }));
                    this.list.addChild(this.photoItem = new ListItem({
                        label:"图片",
                        clickable:true,
                        noArrow:true,
                        onClick:lang.hitch(this,function(){
                            this._captureImg("SAVEDPHOTOALBUM");
                        })
                    }));
                    this.list.addChild(this.cancelItem = new ListItem({
                        label:"取消",
                        clickable:true,
                        noArrow:true,
                        onClick:lang.hitch(this,function(){
                            this.dialog.hide();
                        })
                    }));
                    document.body.appendChild(this.dialog.domNode);
                    if(userAgent.isAndroid()){
                        domStyle.set(this.photoItem.domNode, "display", "none");
                    }
                    this.dialog.startup();
                    this._initDef.resolve();
                }));
            }
            return this._initDef;
        },
        show:function(callback,errorback,source){
            this._init(callback,errorback).then(lang.hitch(this,function(){
                if(source){
                    if(source==="camera"){
                        source = "CAMERA";
                    }else if(source==="photo"){
                        source = "PHOTOLIBRARY";
                    }else{
                        source = "SAVEDPHOTOALBUM";
                    }
                    return this._captureImg(source);
                }else{
                    this.dialog.containerNode.appendChild(this.list.domNode);
                    this.dialog.show();
                    this.dialog.resize();
                }
            }));
        },
        _captureImg:function(type){
            if(this.dialog){
                this.dialog.hide();
            }
            this.captureImgDate(type, this._callback, this._errorback);
        },
        captureImgDate:function(type, callback, errorback){
            if(!navigator.camera){
                alert("需要移动设备的支持");
            }
            navigator.camera.getPicture(function(data){
                if(callback){
                    callback("data:image/jpeg;base64,"+data);
                }
            },function(message){
                if(errorback){
                    errorback();
                }
            },{
                quality:50,
                allowEdit:false,
                destinationType:Camera.DestinationType.DATA_URL,
                sourceType:Camera.PictureSourceType[type],
                encodingType:Camera.EncodingType.JPEG
            });
        }
    };
    
    blob =  {
        onFileChanged:function(){
            this.def.resolve(fileInput);
            createFileInput();
        },
        selectFile:function(){
            this.def = new Deferred();
            fileInput.click();
            return this.def;
        },
        // 参数可选：size为图片压缩规格，quality为图片压缩质量0-1
        //sizeType:cut选择剪切,upload直接上传,both两个都大于才压缩,其他任何一个大于就压缩
        selectAndUpload:function(size, quality,sizeType,multiple,source){
            var def = new Deferred();
            if(multiple==="multiple"){
                domAttr.set(fileInput,"multiple",true);
            }
            if(size||quality||sizeType!=="upload"){
                domAttr.set(fileInput,"accept","image/jpeg,image/jpg,image/png");
            }
            // 设备类型不同，处理方式不同，如果是APP，弹出使用相机或者相册选取的选项，如果是浏览器则相册选取
            if(userAgent.isApp()){
                capture.show(lang.hitch(this, function(data){
                    var file = this.dataUrltoBlob(data);
                    var files = [file];
                    if(multiple !== "multiple"){
                        file = files[0];
                        this.uploadReady(file,size, quality,sizeType).then(lang.hitch(this,function(data){
                            def.resolve(data);
                        }));
                    }else{
                        new DeferredList(array.map(files,function(fileData){
                            return this.uploadReady(fileData,size, quality,sizeType);
                        },this)).then(function(result){
                            def.resolve(result);
                        });
                    }
                }), function(message){
                    if(message){
                        alert(message);
                    }
                },source);
            }else{
                this.selectFile().then(lang.hitch(this,function(fileInput){
                    if(multiple!=="multiple"){
                        var file = fileInput.files&&fileInput.files[0]||fileInput.file||fileInput.value;
                        this.uploadReady(file,size, quality,sizeType).then(lang.hitch(this,function(data){
                            def.resolve(data);
                        }));
                    }else{
                        new DeferredList(array.map(fileInput.files,function(fileData){
                            return this.uploadReady(fileData,size, quality,sizeType);
                        },this)).then(function(result){
                            def.resolve(result);
                        });
                    }
                }));
            }
            return def;
        },
        uploadReady:function(file,size, quality,sizeType){
            window.busy();
            var def = new Deferred();   
            if(file){
                //若不是图片文件，或者没有设置大小且文件大于xxx
                if(file.type&&-1===file.type.indexOf("image")||(!size)&&file.size<1024*20){
                    //直接上传
                    this._upload(file).then(function(data){
                        def.resolve(data);
                    });
                }else if(size&&"cut"===sizeType&&size.width&&size.height){
                    //剪切到指定规格
                    var blobcut = URL.createObjectURL(file);
                    var img = new Image(),upload = lang.hitch(this,this.upload),_upload = lang.hitch(this,this._upload);
                    img.onload = function(){
                        if(Math.abs(img.width-size.width)<10&&Math.abs(img.height-size.height)<10){
                            _upload(file).then(function(data){
                                def.resolve(data);
                            });
                        }else if((img.width<size.width||img.height<size.height)&&config.imageUpload&&config.imageUpload.forceSize){
                            alert("图片过小，请重新上传");
                            def.cancel();
                        }else{
                            //做剪切操作
                            require(["cq/util/image/selector"],function(selector){
                                window.free();
                                selector.selectImg(null,size,blobcut,"contain").then(function(url){
                                    window.busy();
                                    upload(url).then(function(data){
                                        def.resolve(data);
                                    });
                                });
                            });
                        }
                    };
                    img.src=blobcut;
                }else if(sizeType==="upload"){
                    //处理旋转信息后直接上传
                    var url = URL.createObjectURL(file);
                    var reader = new FileReader();
                    reader.readAsDataURL(file);
                    reader.onload = lang.hitch(this,function () {
                        if(reader.result.indexOf("image/png")>0){
                            this.upload(reader.result).then(function(data){
                                def.resolve(data);
                            });
                        }
                        else{
                            var imgs = new Image();
                            imgs.onload = lang.hitch(this,function(){
                                this._compress(url,file, quality||0.4,{
                                    width:imgs.width,
                                    height:imgs.height
                                }).then(lang.hitch(this,function(base64){
                                    this.upload(base64).then(function(data){
                                        def.resolve(data);
                                    });
                                }));
                            });
                            imgs.src = url;
                        }
                    });
                }else{
                    //做压缩操作
                    var blob = URL.createObjectURL(file);
                    this._compress(blob, file, quality||0.4, size,sizeType).then(lang.hitch(this, function(base64){
                        this.upload(base64).then(function(data){
                            def.resolve(data);
                        });
                    }));
                }
            }else{
                window.free();
                def.cancel();
            } 
            return def.then(function(data){
                window.free();
                return data;
            });
        },
        // 张松  压缩图片的方法，blob为图片文件url，file为文件对象，quality为图片压缩比例，默认0.4  2016/06/24
        // 压缩规格的处理方式
        _compress:function(blob, file, quality, size, sizeType){
            if(!size){
                size ={};
                size.width = 640;
                size.height=0;
            }
            var def = new Deferred();
            require(["cq/util/image/resizer"],function(resizer){
                resizer(blob,size,quality,sizeType).then(function(base64){
                    def.resolve(base64);
                });
            });
            return def;
        },
        upload:function(fileInput){
            var def = null;
            if(!fileInput){
                window.free();
                def = new Deferred();
                def.reject();
                return def;
            }
            if(papersMaxSize&&papersMaxSize<("string"===typeof(fileInput)&&fileInput.length||fileInput.size)){
                console.log("文件过大,不能上传！");
                window.free();
                def = new Deferred();
                def.reject();
                return def;
            }
            var data = new FormData();
            if(fileInput&&(fileInput.files&&fileInput.files.length||fileInput.file||fileInput.value)){
                if(fileInput.files.length===1){
                    return this._upload(fileInput.files[0]);
                }
                return new DeferredList(array.map(fileInput.files,function(fileData){
                    //return this._upload(fileInput.files[0]);
                    return this._upload(fileData);
                },this)).then(function(items){
                    var data = {items:[]};
                    for(var i=0;i<items.length;i++){
                        if(items[i][1]&&items[i][1].items){
                            data.items = data.items.concat(items[i][1].items);
                        }
                    }
                    return data;
                });
            }else{
                var binary = atob((fileInput.substr(fileInput.indexOf(",")+1)).replace(/\s/g, ''));
                var len = binary.length;
                var buffer = new ArrayBuffer(len);
                var view = new Uint8Array(buffer);
                for(var i = 0; i < len;i++){
                    view[i] = binary.charCodeAt(i);
                }
                var file = new Blob([view],{type:"image/jpg"}); 
                return this._upload(file);
            }
        },
        _upload:function(file){
            var data = new FormData();
            data.append("cq_file",file);
            return xhr.post(this.getBaseUrl()+"/upload",{
                data:data,
                handleAs:"json"
            });
        },
        getBaseUrl:function(){
            return config.getDataOrigin()+"/biz/blob/blob";
        },
        getImageUrl:function(url,width){
            var widthEnum = {
                80:1,
                160:2,
                320:3,
                480:4,
                800:5
            };
            if(width&&widthEnum[width]&&url&&lang.isString(url)&&url.search(/http|https/i)===0&&url.search(/\/static\/upload\//)!==-1){
                var hostStr = url.substring(0,url.search(/\/static\/upload\//));
                var  imgDirectory = encodeURIComponent(url.substr(url.search(/\/static\/upload\//)));
                
                var newUrl = hostStr+"/biz/blob/blob/img"+"?width="+width+"&url="+imgDirectory;
                return newUrl;
            }else{
                return url;
            }
        },
        dataUrltoBlob:function(dataurl){
            var arr = dataurl.split(",");
            var mime = arr[0].match(/:(.*?);/)[1];
            var bstr = atob(arr[1]);
            var n = bstr.length;
            var u8arr = new Uint8Array(n);
            while(n--){
                u8arr[n] = bstr.charCodeAt(n);
            }
            return new Blob([u8arr], {
                type: mime
            });
        },
        
        //空白图片
        blankImg:"data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAIAAAACCAYAAABytg0kAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAADsQAAA7EAZUrDhsAAAAGYktHRAD/AP8A/6C9p5MAAAAHdElNRQfdBwoCFRp2ulIlAAAAGUlEQVQYV2Pct2/ffwYgYPr58yfDz58/GQBO9gkTNKGFEwAAAABJRU5ErkJggg==",
    };
    return blob;
});
