﻿define([
    "dojo/_base/lang",
	"dojo/Deferred",
    //清除图片旋转的程序
    "cq/util/image/realImage"
],function(lang,Deferred,realImage){
    return function(src,size,quality,sizeType){
        var width = size.width, height = size.height, def = new Deferred();
        realImage.getRealUurl(src).then(lang.hitch(this,function(url){
            var img = new Image();
            img.onload = function(){
                var scale=1;
                if(sizeType==="both"){
                    if(width<img.width&&height<img.height){
                        if(width){
                            scale = img.width/width;
                        }
                        if(height){
                            scale = Math.min(scale,img.height/height);
                        }
                    }
                }else{
                    if(width){
                        scale = Math.max(img.width/width,scale);
                    }
                    if(height){
                        scale = Math.max(img.height/height,scale);
                    }
                }
                if(scale>=1){
                    width = img.width/scale;
                    height = img.height/scale;
                    var c = document.createElement("canvas"),ctx = c.getContext("2d");
                    c.width = width;
                    c.height = height;
                    ctx.drawImage(img,0,0,width,height);
                    //强行转化为jpeg格式好了，这种格式的图片比较小，实际上应该保持来源图片格式	
                    //要保持图片的原始格式，有些图标是透明背景，转为jpg格式后背景变成黑色		
                    if(-1<img.src.split(".").pop().toLowerCase()==="png"||-1<img.src.toLowerCase().indexOf("data:image/png;base64,")){
                        //png文件不存在压缩质量的问题
                        def.resolve(c.toDataURL());
                    }else{
                        //处理图片压缩比	
                        //支持配置图片压缩比	
                        //var q = ((window.cqthink&&cqthink.app&&cqthink.app.configer&&cqthink.app.configer.imageQuality)-0)||1;
                        def.resolve(c.toDataURL("image/jpeg",quality));
                    }
                }else{
                    def.resolve(url);
                }
            };
            img.src = url;
        }));
        return def;
    };
	
});