﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-attr",
    "dojo/dom-construct",
    "dojo/Deferred",
    "dijit/_WidgetBase",
    "dojo/dom-class",
    "dojo/query"
],function(declare,lang,domAttr,domConstruct,Deferred,_WidgetBase, domClass, query){
    var Icon = declare("",[_WidgetBase],{
        baseClass:"pay-type-icon",
        buildRendering:function(){
            this.inherited(arguments);
            //this.connect(this.domNode,"onclick",this.onClick);
        },
        showPayInfo: true,
        onClick:function(e){
            var target = e.target;
            while(target&&domClass.conta&&target!==this.domNode){
                target = target.parentNode;
            }
            if(target&&target!==this.domNode){
                window.busy();
                var payType = domAttr.get(target,"name");
                this.payInfo.payType = payType;
                this.payTypeOptions.payer[this.payTypeOptions.payMethod](this.payInfo).then(lang.hitch(this,function(){
                    window.free();
                    if(this.callback){
                        this.callback();
                    }
                }));
            }
        },
        //有两个动作
        //      隐藏选择组件
        //      完成支付动作
        payOrder:function(payInfo,callback,payTypeOptions){
            if(this._def){
                this._def.cancel();
            }
            this._def = new Deferred();
            domConstruct.empty(this.domNode);
            this.payInfo = payInfo;
            this.callback = callback;
            this.payTypeOptions = payTypeOptions;
            if(this.payInfo.tsInfo&&this.showPayInfo){
                this.tsInfo = this.payInfo.tsInfo;
                domConstruct.create("div", {
                    "class":"order-dtl-amnt",
                    innerHTML: "<h3><div>实付金额：</div><div>￥<span>"+this.tsInfo.amount+"</span></div></h3>"
							// 金元宝信息 2017-5-16 刘轩
							+"<h3><div>金元宝抵扣：</div><div>-￥<span>"+Number(this.tsInfo.gold)+"</span></div></h3>"
                            +"<h3><div>村币抵扣</div><div>-￥<span>"+Number(this.tsInfo.point)+"</span></div></h3>"
                            +"<h3><div>优惠券抵扣：</div><div>-￥<span>"+Number(this.tsInfo.couponAmount)+"</span></div></h3>"
                            +"<h3><div>现金支付：</div><div>￥<span>"+Number(this.tsInfo.payAmount)+"</span></div></h3>"                              
                }, this.domNode);
            }
            domConstruct.create("div", {
                "class": "mat-item-cells",
                innerHTML: "选择支付方式"
            }, this.domNode);
            var node = domConstruct.create("div", {
                "class": "mat-item-cells payTypeNode"
            }, this.domNode);
            node.innerHTML = payTypeOptions.payTypes.map(function(type){
                return '<div class="payType item-cell noArrow" name="'+type.type+'">'+
                        '<img style="width:26px;height:26px;" src="'+type.logo+'" />'+
                        '<span class="label">'+type.name+'</span>'+
                        '<label class="check-box"></label>'+
                    '</div>';
            }).join("");
            var btnNode = domConstruct.create("div", {
                "class": "hflex"
            }, this.domNode);
            var cancelBtn = domConstruct.create("a", {
                "innerHTML": "取消",
                "class": "flex1 button"
            }, btnNode);
            var comfirmBtn = domConstruct.create("a", {
                innerHTML: "确认支付",
                "class": "flex1 button"
            }, btnNode);
            
            this.connect(node, "onclick", this.payTypeNodeClick);
			// 选中第一种支付方式
			this.payTypeNodeClick({
				target: query(".payType", node)[0]
			});
            this.connect(cancelBtn, "onclick", function(){
                this._def.resolve();
                if(this.callback){
                    this.callback();
                }
            });
            this.connect(comfirmBtn, "onclick", function(){
                this._def.resolve();
                var payTypeNode = query(".selected", node)[0], payType;
                if(!payTypeNode){
                    alert("请先选择支付方式");
                    return;
                }
                payType = domAttr.get(payTypeNode, "name");
                window.busy();
                this.payInfo.payType = payType;
                if(this.payInfo.tsInfo){
                    delete this.payInfo.tsInfo;
                }
                this.payTypeOptions.payer[this.payTypeOptions.payMethod](this.payInfo).then(lang.hitch(this,function(result){
                    window.free();
                    if(this.callback){
                        this.callback(result);
                    }
                }));
            });
            return this._def;
        },
		payTypeNodeClick: function(e){
			var dom = e.target, node = query(".payTypeNode", this.domNode)[0];
			while(dom&&!domClass.contains(dom, "payType")&&dom!==node){
				dom = dom.parentNode;
			}
			if(!domClass.contains(dom, "payType")){
				return;
			}
			// 清除之前的选中
			query(".selected", node)[0]&&domClass.remove(query(".selected", node)[0], "selected");
			// 设置当前节点的选中
			domClass.add(dom, "selected");
		}
    });
    var icon = new Icon();
    icon.ICON = Icon;
    return icon;
});