define([
    "dojo/_base/connect",
    "dojo/_base/json",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojo/ready",
    "dojo/topic",
    "cq/util/config/config"
], function(connect, json, lang, Deferred, ready, topic, config) {
    var baiduPush = {
        regist: function(){
            var def = new Deferred();
            if(!this.deviceNo){
                // 将app key替换为百度提供的appkey值
                window.baidu_push.startWork(this._config.pushAppKey||"qUSEX2hEvBDzI8qpAdhM2T5o",lang.hitch(this, function(rtnJson){
                    if(rtnJson.type === "onbind"){
                        this.deviceNo = rtnJson.data.channelId;
                        // alert("deviceNo: " + this.deviceNo);
                        def.resolve();
                    }else if(rtnJson.type === "onnotificationarrived" || rtnJson.type === "onnotificationclicked"){
                        if(rtnJson.data && rtnJson.data.moveTo && this.userBo.getCurrentUserId() && rtnJson.data.receiverShopId == this.userBo.getShopId()){
                            if(confirm(rtnJson.data.description+"\n现在查看吗？"))
                            window.moveToView(rtnJson.data.moveTo,rtnJson.data.param);
                        }
                        // if(rtnJson.data.description){
                            // alert(rtnJson.data.description);
                        // }
                        this.onNewPushMessage();
                    }
                }));
            }else{
                def.resolve();
            }
            return def;
        },
        bandPushMessage: function(){
        },
        getAppDeviceInfo: function(){
            return this.deviceNo ? {
                "appId": this._config.androidAppId,
                "deviceNo":this.deviceNo,
                "os":device.manufacturer,
                "osVersion":device.version,
                "serial":device.serial,
                "deviceVersion":device.model
            } : null;
        }
    };
    var iosPush = {
        //ios系统中推送通知的处理
        //注册设备信息
        regist: function() {
            var def = new Deferred();
            if(!this.deviceNo){
                this.push = PushNotification.init({
                    ios: {
                        alert: "true",
                        badge: "true",
                        sound: "true",
                        clearBadge:"true"
                    }
                });
                this.push.on('registration', lang.hitch(this,function(data) {
                    this.deviceNo = data.registrationId;
                    def.resolve();
                }));

                this.push.on('notification', lang.hitch(this,function(data) {
                    if(data.additionalData && data.additionalData.moveTo && this.userBo.getCurrentUserId() && data.additionalData.receiverShopId == this.userBo.getShopId()){
                        if(confirm(data.message+"\n现在查看吗？"))
                        window.moveToView(data.additionalData.moveTo,data.additionalData.param);
                    }
                    else{
                        alert(data.message);
                    }
                }));

                this.push.on('error', lang.hitch(this,function(e) {
                    // e.message
                }));
            }else{
                def.resolve();
            }
            return def;
        },
        //绑定设备收到推送通知的响应函数
        bandPushMessage: function() {
            window.onNotificationAPN = lang.hitch(this, function(e) {
                var str = "";
                for (var i in e) {
                    str += "," + i + ":" + e[i].toString();
                }
                window.plugins.pushNotification.setApplicationIconBadgeNumber(function(e) {
                }, function() {
                }, 0);
                if(e && e.alert){
                    alert(e.alert);
                }
                this.onNewPushMessage();
            });
        },
        //获取应用设备信息
        getAppDeviceInfo: function() {
            return this.deviceNo ? {
                "appId": this._config.iosAppId,
                "deviceNo":this.deviceNo,
                "os":device.manufacturer,
                "osVersion":device.version,
                "serial":device.serial,
                "deviceVersion":device.model
            } : null;
        }
    };
    var jPush = {
        regist: function(){
            var def = new Deferred();
            if(!this.deviceNo){
                window.plugins.jPushPlugin.getUserNotificationSettings(lang.hitch(this, function(result) {
                    var _this = this;
                    if(result == 0) {
                        // 系统设置中已关闭应用推送。
                        var content = _this._config.confirmContent;
                        confirm(content || "系统设置中已关闭该应用推送权限,请前往打开该app通知权限");
                    } else if(result > 0) {
                        var onGetRegistrationID = function(data) {
                            try {
                                if (data.length == 0) {
                                    var t1 = window.setTimeout(getRegistrationID, 1000);
                                }
                                _this.deviceNo = data;
                                def.resolve();
                            } catch (exception) {
                                console.log(exception);
                            }
                        };
                        var getRegistrationID = function() {
                            window.plugins.jPushPlugin.getRegistrationID(lang.hitch(this,onGetRegistrationID));
                        };
                        //初始化推送服务
                        window.plugins.jPushPlugin.init();
                        getRegistrationID();
                    }
                }));
            }else{
                def.resolve();
            }
            return def;
        },
        //暂时没用到，收到信息时的事件操作
        bandPushMessage: function(){
            var onReceiveNotification = function(event) {
                try {
                    var alertContent;
                    if (device.platform == "Android") {
                        alertContent = event.alert;
                    } else {
                        alertContent = event.aps.alert;
                    }
                    alert(alertContent);
                } catch (exception) {
                    console.log(exception)
                }
            };
            document.addEventListener("jpush.receiveNotification", onReceiveNotification, false);
        },        
        bandOpenNotification: function(){
            var onOpenNotification = function(event) {
                try {
                    var alertContent, moveTo, param;
                    console.log(event);
                    if (device.platform == "Android") {
                        alertContent = event.alert;
                        moveTo = event.extras.moveTo;
                        param = event.extras.param;
                    //兼容ios
                    } else {
                        alertContent = event.aps.alert;
                        moveTo = event.moveTo;
                        param = event.param;
                    }
                    if(moveTo){
                        if(confirm(alertContent+"\n现在查看吗？")) {
                            window.moveToView(moveTo,param);
                        }
                    }
                } catch (exception) {
                    console.log("JPushPlugin:onOpenNotification" + exception);
                }
            };
            document.addEventListener("jpush.openNotification", onOpenNotification, false);
        },
        getAppDeviceInfo: function(){
            return this.deviceNo ? {
                "appId": this._config.jPushAppId,
                "deviceNo":this.deviceNo,
                "os":device.manufacturer,
                "osVersion":device.version,
                "serial":device.serial,
                "deviceVersion":device.model
            } : null;
        }
    };
    var xmPush = {
        regist : function(){
            var def = new Deferred();
            var _this = this;
            if(!this.deviceNo){
                var onRegIdChanged = function(event){
                    var regId = event.regId;
                    _this.deviceNo = regId;
                    console.error("deviceNo == " + regId);
                    def.resolve();
                };
                document.addEventListener("xmPushPlugin.onregIdChanged", onRegIdChanged, false);
                window.plugins.xmPushPlugin.startWork(this._config.xmAppId + "," + this._config.xmPushAppKey, lang.hitch(this, function(){
                    
                }));
            }else{
                def.resolve();
            }
            return def;
        },
        bandPushMessage: function(){
            var onReceiveNotification = function(event) {
                try{
                    // 接受到消息之后调用设置badge方法
                    window.plugins.xmPushPlugin.setBadge(1, function(){}, function(){});
                    var alertContent, moveTo, param;
                    console.log(event);
                    alertContent = event.extras.message;
                    moveTo = event.extras.moveTo;
                    param = event.extras.param;
                    // 如果有moveTo表示页面跳转，没有则直接显示
                    if(moveTo){
                        if(confirm(alertContent+"\n现在查看吗？")) {
                            window.moveToView(moveTo,param);
                        }
                    }else {
                        alert(alertContent);
                    }
                    // 当用户查看完消息之后设置badge为0
                    window.plugins.xmPushPlugin.setBadge(0, function(){}, function(){});
                }catch(exception){
                    console.log("xmPushPlugin:receiveNotification " + exception);
                }
            };
            document.addEventListener("xmPushPlugin.receiveNotification", onReceiveNotification, false);
        },
        getAppDeviceInfo:function(){
            return this.deviceNo?{
                "appId":this._config.xmPushAppId,
                "deviceNo":this.deviceNo,
                "os":device.manufacturer,
                "osVersion":device.version,
                "serial":device.serial,
                "deviceVersion":device.model
            }:null;
        }
    };
    
    var hwPush = {
        regist : function(){
            var def = new Deferred();
            if(!this.deviceNo){
                window.plugins.hwPushPlugin.startWork(null, lang.hitch(this, function(){}));
                var _this = this;
                var onReceiveToken = function(event){
                    _this.deviceNo = event.regId;
                    def.resolve();
                };
                document.addEventListener("hwPushPlugin.onRegistOk", onReceiveToken, false);
            }else{
                def.resolve();
            }
            return def;
        },
        bandPushMessage: function(){
            var onReceiveNotification = function(event) {
                window.plugins.hwPushPlugin.setBadge(1, function(){}, function(){});
                try{
                    var alertContent, moveTo, param;
                    console.log(event);
                    alertContent = event.extras.message;
                    moveTo = event.extras.moveTo;
                    param = event.extras.param;
                    // 如果有moveTo表示页面跳转，没有则直接显示
                    if(moveTo){
                        if(confirm(alertContent+"\n现在查看吗？")) {
                            window.moveToView(moveTo,param);
                        }
                    }else {
                        alert(alertContent);
                    }
                    window.plugins.hwPushPlugin.setBadge(0, function(){}, function(){});
                }catch(exception){
                    console.log("xmPushPlugin:receiveNotification " + exception);
                }
            };
            document.addEventListener("hwPushPlugin.receiveNotification", onReceiveNotification, false);
        },
        getAppDeviceInfo: function(){
            return this.deviceNo?{
                "appId":this._config.hwPushAppId,
                "deviceNo":this.deviceNo,
                "os":device.manufacturer,
                "osVersion":device.version,
                "serial":device.serial,
                "deviceVersion":device.model
            }:null;
        }
    };
    
    return {
        start:function(boParam,params){
            if(this._started){
                return;
            }
            this._started = true;
            this._config = params;
            this.userBo = boParam.user;
            this.deviceBo = boParam.deviceBo;
            var started = false;
            if(boParam.userAgent.isIos()){
                started = this._startIos();
            }else if(boParam.userAgent.isAndroid()){
                if(device.manufacturer.toLowerCase().indexOf("xiaomi")>=0 && window.plugins && window.plugins.xmPushPlugin){
                    started = this._startXMPush();
                }
                /*else if(window.plugins && window.plugins.hwPushPlugin){
                    started = this._startHWPush();
                }*/
                else if(device.manufacturer.toLowerCase().indexOf("huawei")>=0 && window.plugins && window.plugins.hwPushPlugin){
                    started = this._startHWPush();
                }else if(window.plugins && window.plugins.jPushPlugin){
                    started = this._startJpush();
                }else{
                    started = this._startAndroid();
                }
            }else {
                started = this._startAndroid();
            }
            if(started){
                // APP启动，首页ready之后直接调用
                this.updateAppDeviceInfo();
                topic.subscribe("/cq/biz/user/user/hasLogin", lang.hitch(this, function(){
                    this.updateAppDeviceInfo();
                }));
                //绑定点击推送通知的事件,极光推送才有该事件
                if(device.manufacturer.toLowerCase().indexOf("xiaomi")>=0 && window.plugins && window.plugins.xmPushPlugin){
                    this.bandPushMessage();
                }else if(window.plugins && window.plugins.jPushPlugin) {
                    this.bandOpenNotification();
                }else{
                    this.bandPushMessage();
                }
            }
        },
        _startJpush:function(){
            if(window.plugins && window.plugins.jPushPlugin){
                lang.mixin(this,jPush);
            }
            return true;
        },
        _startXMPush:function(){
            if(window.plugins && window.plugins.xmPushPlugin){
                lang.mixin(this, xmPush);
            }
            return true;
        },
        _startHWPush:function(){
            if(window.plugins && window.plugins.hwPushPlugin){
                lang.mixin(this, hwPush);
            }
            return true;
        },
        _startAndroid:function(){
            if(window.baidu_push){
                lang.mixin(this,baiduPush);
            }
            return true;
        },
        _startIos:function(){
            if(window.PushNotification){
                lang.mixin(this,iosPush);
            }
            return true;
        },
        updateAppDeviceInfo: function(){
            var o = this.getAppDeviceInfo();
            if (!o) {
                //若没有设备序列号信息，执行注册操作
                this.regist().then(lang.hitch(this, function() {
                    if (this.getAppDeviceInfo()) {
                        //若能够获取到设备信息，说明注册成功，就需要更新设备信息
                        this._updateAppDeviceInfo();
                    }else {
                        this.updateAppDeviceInfo();
                    }
                }));
            }else{
                this._updateAppDeviceInfo();
            }
        },
        _updateAppDeviceInfo: function() {
            var o = this.getAppDeviceInfo(),
                n = lang.clone(o);
            // 登录成功之后才有userId
            if(this.userBo.getCurrentUserId()){
                n.userId = this.userBo.getCurrentUserId();
            }
            this.deviceBo.save(n);
        },
        onNewPushMessage: function() {
        }
    };
});