define([],function(){
    return {
        getViewId:function(){
            return location.hash.substr(1).split("-")[0]||"main";
        },
        getViewParam:function(){
            var hash = location.hash.split("-");
            hash.shift();
            return hash.join("-");
        },
        getQueryStringParam:function(key){
            var params = {};
            var queryString = location.href.split("#")[0].split("?")[1]||"";
            queryString.split("&").forEach(function(str){
                str = str.split("=");
                if(str.length>1){
                    var k = str.shift();
                    params[k] = str.join("=");
                }
            });
            return key?params[key]||"":params;
        },
        //数据合法性判断接口
        isCellPhone:function(str){
            return /(^1[3|4|5|7|8][0-9]{9}$)/.test(str);
        },
        //创建人：周超
        //  差创建时间：2017 1 12
        //  创建内容：去掉字符串前后空格
        deleteBail:function(str){
            return str.replace(/(^\s*)|(\s*$)/g, "");
        },
        //创建人：周超
        //  创建时间：2017 1 13
        //  创建内容：身份证合法性检查
        //  注：身份证末位可以为字符X
        legIdCard:function(num){
            //  把字符串转换为大写
            num = num.toUpperCase();
            //身份证号码为15位或者18位，15位时全为数字，18位前17位为数字，最后一位是校验位，可能为数字或字符X。
            if (!(/(^\d{15}$)|(^\d{17}([0-9]|X)$)/.test(num))){
                return false;
            }
            //校验位按照ISO 7064:1983.MOD 11-2的规定生成，X可以认为是数字10。
            //下面分别分析出生日期和校验位
            var len, re;
            len = num.length;
            if (len == 15){
                re = new RegExp(/^(\d{6})(\d{2})(\d{2})(\d{2})(\d{3})$/);
                var arrSplit = num.match(re);
         
                //检查生日日期是否正确
                var dtmBirth = new Date('19' + arrSplit[2] + '/' + arrSplit[3] + '/' + arrSplit[4]);
                var bGoodDay;
                bGoodDay = (dtmBirth.getYear() == Number(arrSplit[2])) && ((dtmBirth.getMonth() + 1) == Number(arrSplit[3])) && (dtmBirth.getDate() == Number(arrSplit[4]));
                if (!bGoodDay){
                    return false;
                }else{
                        //将15位身份证转成18位
                        //校验位按照ISO 7064:1983.MOD 11-2的规定生成，X可以认为是数字10。
                        var arrInt = new Array(7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2);
                        var arrCh = new Array('1', '0', 'X', '9', '8', '7', '6', '5', '4', '3', '2');
                        var nTemp = 0, i;
                        num = num.substr(0, 6) + '19' + num.substr(6, num.length - 6);
                        for(i = 0; i < 17; i ++)
                        {
                            nTemp += num.substr(i, 1) * arrInt[i];
                        }
                        num += arrCh[nTemp % 11];
                        return true;
                }
            }
            if (len == 18){
                re = new RegExp(/^(\d{6})(\d{4})(\d{2})(\d{2})(\d{3})([0-9]|X)$/);
                var arrSplit = num.match(re);
         
                //检查生日日期是否正确
                var dtmBirth = new Date(arrSplit[2] + "/" + arrSplit[3] + "/" + arrSplit[4]);
                var bGoodDay;
                bGoodDay = (dtmBirth.getFullYear() == Number(arrSplit[2])) && ((dtmBirth.getMonth() + 1) == Number(arrSplit[3])) && (dtmBirth.getDate() == Number(arrSplit[4]));
                if (!bGoodDay){
                    return false;
                }else{
                    //检验18位身份证的校验码是否正确。
                    //校验位按照ISO 7064:1983.MOD 11-2的规定生成，X可以认为是数字10。
                    var valnum;
                    var arrInt = new Array(7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2);
                    var arrCh = new Array('1', '0', 'X', '9', '8', '7', '6', '5', '4', '3', '2');
                    var nTemp = 0, i;
                    for(i = 0; i < 17; i ++){
                        nTemp += num.substr(i, 1) * arrInt[i];
                    }
                    valnum = arrCh[nTemp % 11];
                    if (valnum != num.substr(17, 1)){
                        return false;
                    }
                    return true;
                }
            }
            return false;
        },
        //这些都有实现，在cq/bo/BoBase中
        isTel:function(value){
            
        },
        //
        isNull:function(value){
            
        },
        isNumber:function(value){
            
        },
        parseRange:function(range){
            
        },
        isEmail:function(value){
            
        },
        isUrl:function(value){
            
        },
        
        
        //判断节点状态的方法
        isVisible:function(elem){
            return !!( elem.offsetWidth || elem.offsetHeight || elem.getClientRects().length );
        }
        
    }
});