﻿//处理公共的bug
define([
    "dojo/_base/lang",
    "dojo/_base/connect",
    "dojo/_base/window",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/touch",
    "dojox/mobile/sniff",
    "dojox/mobile/iconUtils",
    "cq/util/config/config"
],function(lang,connect,win,domClass,domConstruct,domStyle,touch,has,iconUtils,config){
    iconUtils.createDomButton = function(/*DomNode*/refNode, /*Object?*/style, /*DomNode?*/toNode){
        // summary:
        //        Creates a DOM button.
        // description:
        //        DOM button is a simple graphical object that consists of one or
        //        more nested DIV elements with some CSS styling. It can be used
        //        in place of an icon image on ListItem, IconItem, and so on.
        //        The kind of DOM button to create is given as a class name of
        //        refNode. The number of DIVs to create is searched from the style
        //        sheets in the page. However, if the class name has a suffix that
        //        starts with an underscore, like mblDomButtonGoldStar_5, then the
        //        suffixed number is used instead. A class name for DOM button
        //        must starts with 'mblDomButton'.
        // refNode:
        //        A node that has a DOM button class name.
        // style:
        //        A hash object to set styles to the node.
        // toNode:
        //        A root node to create a DOM button. If omitted, refNode is used.

        if(!this._domButtons){
            if(has("webkit")){
                var findDomButtons = function(sheet, dic){
                    // summary:
                    //        Searches the style sheets for DOM buttons.
                    // description:
                    //        Returns a key-value pair object whose keys are DOM
                    //        button class names and values are the number of DOM
                    //        elements they need.
                    var i, j;
                    if(!sheet){
                        var _dic = {};
                        var ss = win.doc.styleSheets;
                        for (i = 0; i < ss.length; i++){
                            ss[i] && findDomButtons(ss[i], _dic);
                        }
                        return _dic;
                    }
                    var rules = [];
                    /****
                    *更改原因：浏览器增加了安全控制，js不能读取不同源的CSS定义的CSSRule
                    *修改人:郭周全 2018/02/26
                    */
                    try{
                        rules = sheet.cssRules||[];
                    }catch(e){
                        rules = [];
                    }
                    // sheet.cssRules || [];
                    for (i = 0; i < rules.length; i++){
                        var rule = rules[i];
                        if(rule.href && rule.styleSheet){
                            findDomButtons(rule.styleSheet, dic);
                        }else if(rule.selectorText){
                            var sels = rule.selectorText.split(/,/);
                            for (j = 0; j < sels.length; j++){
                                var sel = sels[j];
                                var n = sel.split(/>/).length - 1;
                                if(sel.match(/(mblDomButton\w+)/)){
                                    var cls = RegExp.$1;
                                    if(!dic[cls] || n > dic[cls]){
                                        dic[cls] = n;
                                    }
                                }
                            }
                        }
                    }
                    return dic;
                };
                this._domButtons = findDomButtons();
            }else{
                this._domButtons = {};
            }
        }

        var s = refNode.className;
        var node = toNode || refNode;
        if(s.match(/(mblDomButton\w+)/) && s.indexOf("/") === -1){
            var btnClass = RegExp.$1;
            var nDiv = 4;
            if(s.match(/(mblDomButton\w+_(\d+))/)){
                nDiv = RegExp.$2 - 0;
            }else if(this._domButtons[btnClass] !== undefined){
                nDiv = this._domButtons[btnClass];
            }
            var props = null;
            if(has("bb") && config.mblBBBoxShadowWorkaround !== false){
                // Removes box-shadow because BlackBerry incorrectly renders it.
                props = {style:"-webkit-box-shadow:none"};
            }
            for(var i = 0, p = node; i < nDiv; i++){
                p = p.firstChild || domConstruct.create("div", props, p);
            }
            if(toNode){
                setTimeout(function(){
                    domClass.remove(refNode, btnClass);
                }, 0);
                domClass.add(toNode, btnClass);
            }
        }else if(s.indexOf(".") !== -1){ // file name
            domConstruct.create("img", {src:s}, node);
        }else{
            return null;
        }
        domClass.add(node, "mblDomButton");
        !!style && domStyle.set(node, style);
        return node;
    };
    var obj = {
        //重新定义A标签的跳转事件
        rewriteAhref:function(){
            require([
                "dojo/_base/event",
            ],function(evt){
                connect.connect(document.body,"onclick",function(e){
                    var node = e.target;
                    while(node){
                        if("A"===node.tagName&&node.href){
                            if(0<=node.href.toLowerCase().indexOf("blob:")||0<=node.href.toLowerCase().indexOf("data:")){
                                return;
                            }
                            evt.stop(e);
                            if(-1<node.href.indexOf("#")){
                                location.href = "#"+node.href.split("#").pop();
                            }else{
                                window.open(node.href,"_blank", 'location=none');
                            }
                            break;
                        }
                        node = node.parentNode;
                    }
                });
            });
        },
        //长按图片出菜单
        longPressPicture:function(){
            require([
                "dojox/mobile/scrollable",
                "dojox/mobile/_ScrollableMixin",
                "dojox/mobile/ScrollablePane",
                "dojox/mobile/ScrollableView",
                "cq/util/sys/userAgent"
            ],function(scrollable,ScrollableMixin,ScrollablePane,ScrollableView,userAgent){
                //赵春辉    处理图片长按识别二维码问题    2015-10-11
                scrollable.prototype.isFormElement = function (node) {
                    if (node && node.nodeType !== 1) { node = node.parentNode; }
                    if (!node || node.nodeType !== 1) { return false; }
                    var t = node.tagName;
                    return (t === "SELECT" || t === "INPUT" || t === "TEXTAREA" || t === "BUTTON" || "IMG" === t);
                };
                scrollable.prototype.addCover = function(){
                    if(!has("touch") && (has("pointer-events") || has("MSPointer")) ){
                        if(!this._cover2){
                            this._cover2 = domConstruct.create("div",null, win.doc.body);
                            this._cover2.className = "mblScrollableCover";
                            domStyle.set(this._cover2, {
                                backgroundColor: "#ffff00",
                                opacity: 0,
                                position: "absolute",
                                top: "0px",
                                left: "0px",
                                width: "100%",
                                height: "100%",
                                zIndex: 2147483647 // max of signed 32-bit integer
                            });
                            this._ch.push(connect.connect(this._cover2, touch.press, this, "onTouchEnd"));
                        }else{
                            this._cover2.style.display = "";
                        }
                        this.setSelectable(this._cover2, false);
                        this.setSelectable(this.domNode, false);
                    }
                };
                scrollable.prototype.removeCover = function(){
                    // summary:
                    //        Removes the transparent DIV cover.

                    if(!has("touch") && this._cover2){
                        this._cover2.style.display = "none";
                        this.setSelectable(this._cover2, true);
                        this.setSelectable(this.domNode, true);
                    }
                };
                if(userAgent.isDesktop()){
                    var init = scrollable.prototype.init,
                    decorateScroll = {
                        disableTouchScroll: true,
                        init: function() {
                            init.apply(this, arguments);
                            if (this._onScroll) {
                                if (win.global.removeEventListener) { // all supported browsers but IE8
                                    win.global.removeEventListener("scroll", this._onScroll, true);
                                    this._onScroll = null;
                                }
                            }

                            if (this._onFocusScroll) {
                                if (this.domNode.removeEventListener) {
                                    this.domNode.removeEventListener("focus", this._onFocusScroll, true);
                                    this._onFocusScroll = null;
                                }
                            }
                            this.connect(this.domNode, "scroll", function() {
                                this.slideTo({
                                    x: -1 * this.domNode.scrollLeft,
                                    y: -1 * this.domNode.scrollTop
                                });
                            });
                            if(this.scrollDir==="h"){
                                domClass.add(this.domNode,"mblScrollablePaneH");
                            }else if(this.scrollDir==="v"){
                                domClass.add(this.domNode,"mblScrollablePaneV");
                            }else{
                                domClass.add(this.domNode,"mblScrollablePaneVH");
                            }
                        },
                        slideTo: function(to) {
                            var scrollEvent, beforeTopHeight, afterBottomHeight;
                            var doScroll = true;
                            if (!this._dim) {
                                this._dim = this.getDim();
                            }
                            if (!(to.y)) {
                                beforeTopHeight = 0;
                            } else {
                                beforeTopHeight = to.y;
                            }
                            if (this._dim.o.h + to.y < 0) {
                                afterBottomHeight = -1 * (this._dim.o.h + to.y);
                            } else {
                                afterBottomHeight = 0;
                            }
                            scrollEvent = {
                                bubbles: false,
                                cancelable: false,
                                x: to.x,
                                y: to.y,
                                beforeTop: beforeTopHeight > 0,
                                beforeTopHeight: beforeTopHeight,
                                afterBottom: afterBottomHeight > 0,
                                afterBottomHeight: afterBottomHeight
                            };
                            doScroll = this.onBeforeScroll(scrollEvent);

                            if (doScroll) {
                                if (this.domNode.scrollTop !== -1 * to.y || this.domNode.scrollLeft !== -1 * to.x) {
                                    this.domNode.scrollTop = -1 * to.y;
                                    this.domNode.scrollLeft = -1 * to.x;
                                }
                                if (scrollEvent) {
                                    // After scroll event
                                    this.onAfterScroll(scrollEvent);
                                }
                            }
                            if(this.DesktopScrollTimer){
                                clearTimeout(this.DesktopScrollTimer);
                                this.DesktopScrollTimer = null;
                            }
                            this.DesktopScrollTimer = 
                                setTimeout(lang.hitch(this,function(){
                                    this.onFlickAnimationEnd();
                                    if(this.DesktopScrollTimer){
                                        clearTimeout(this.DesktopScrollTimer);
                                        this.DesktopScrollTimer = null;
                                    }
                                }),100);
                            
                        },
                        scrollTo: function(to) {
                            if (this.domNode.scrollTop !== -1 * to.y || this.domNode.scrollLeft !== -1 * to.x) {
                                this.domNode.scrollTop = -1 * to.y;
                                this.domNode.scrollLeft = -1 * to.x;
                            }
                        },
                        onFlickAnimationEnd:function(){
                            return;
                        },
                        addCover: function() {},
                        removeCover: function() {}
                    };
                    //赵春辉   会导致日期/时间选择器和区划选择器不工作    2018-01-04
                    //lang.mixin(scrollable.prototype, decorateScroll);
                    lang.mixin(ScrollableMixin.prototype, decorateScroll);
                    lang.mixin(ScrollablePane.prototype, decorateScroll);
                    lang.mixin(ScrollableView.prototype, decorateScroll);
                    domConstruct.create("style", {
                        innerHTML: ".mblScrollablePaneV{position:relative;overflow-x:hidden;overflow-y:auto !important;}"+
                            ".mblScrollablePaneH{position:relative;overflow-y:hidden;overflow-x:auto !important;}"+
                            ".mblScrollablePaneVH{position:relative;overflow-x:auto !important;overflow-y:auto !important;}"
                    }, document.body);
                };
            });
        },
        closeCover:function(){
            var covers = config.coverWdigets||[];
            var len = covers.length;
            while(len--){
                if(covers[len]._destroyed){
                    covers.splice(len,1);
                    continue;
                }
                if(covers[len].isCqOpened&&covers[len].isCqOpened()){
                    covers[len].cqHide();
                    return true;
                }
            }
        },
        // 处理android手机上返回键
        backButtonClick:function(){
            require([
                "dojo/ready",
                "cq/util/sys/userAgent"
            ],function(ready,userAgent){
                ready(function(){
                    if(window.cordova&&cordova.InAppBrowser&&cordova.InAppBrowser.open){
                        window.open = function(href,target){
                            target = target||"_blank";
                            cordova.InAppBrowser.open(href,target);
                        };
                    }
                // 判断 如果为安卓设备且为app 则处理返回键 否则不处理
                if(userAgent.isAndroid()&&userAgent.isApp()){
                    // 如果noBackViews 没有配置 默认为["","main"]
                    if(!(config.noBackViews&&config.noBackViews.length)){
                        config.noBackViews = ["","main"];
                    }
                    //  backMenuTimer记录两次点击的间隔时间  
                    //  backMenuClicked用于记录点击状态  在两秒内点击 或者两秒外点击
                    var backMenuTimer = null, backMenuClicked = false,
                    _exitApp = function(){
                        document.removeEventListener("backbutton",backClick,false);
                        if (navigator.app && navigator.app.exitApp) {
                            navigator.app.exitApp();
                        } else {
                            history.back();
                        }
                    },
                    //返回键点击后的处理函数
                    backClick = function(){
                        if(obj.closeCover()){
                            return;
                        }
                        
                        var viewId = window.curView;
                        // 老系统兼容 以前aftershow的写法时 是否退出的配置在单独的文件中 并保存在viewParam属性中
                        var viewParam = window.viewParam?window.viewParam[viewId]:null;
                        // 新系统兼容 确定当前页面是否配置退出  noBackView记录是否退出
                        var noBackView = viewParam&&viewParam.noBack;
                        if(!noBackView){
                            for(var i=0;i<config.noBackViews.length;i++){
                                if(config.noBackViews[i]===viewId){
                                    //如果当前页面允许退出 将noBackView改为true
                                    noBackView = true;
                                    break;
                                }
                            }
                        }
                        if (noBackView) {
                            // 哪些页面点击返回按钮退出，应该支持配置，欢迎页和首页应该都能两次点击退出 
                            if (backMenuClicked) {
                                // navigator 由cordova提供
                                _exitApp();
                            }
                            alert("再次点击退出");
                            if (backMenuTimer) {
                                clearTimeout(backMenuTimer);
                            }
                            backMenuClicked = true;
                            // 设置两次按钮点击的时间间隔  在这个时间内连续两次点击退出app
                            backMenuTimer = setTimeout(function() {
                                backMenuClicked = false;
                            }, 5000);
                        } else {
                            history.back();
                        }
                    };
                    //监听backButton按钮 由cordova提供
                    document.addEventListener("backbutton", backClick, false);
                    if (window.navigator && navigator.splashscreen) {
                        navigator.splashscreen.hide();
                    }
                }
                });
            });
        },
        fixShare:function(){
            require([
                "cq/util/sys/userAgent"
            ],function(userAgent){
                if(userAgent.isWeixin()){
                    require(["cq/util/sys/wx"]);
                }
            });
        },
        longPressLoadImg:function(){
            require([
                "dojo/_base/event",
                "dojo/ready",
                "cq/util/sys/userAgent"
            ],function(event,ready,userAgent){
                ready(function(){
                    if(!userAgent.isApp()){
                        return;
                    }
                    var loadHandle = null,
                        tooltipHandle = null,
                        tooltipNode = null,
                        pressTime = null,
                        threshold = 4,
                        touchStartPosX = null,
                        touchStartPosY = null,
                        _conn = null;
                    var _touchStart = function(e){
                        if(e.target.tagName!=="IMG"){
                            return;
                        }
                        touchStartPosX = e.touches ? e.touches[0].pageX : e.pageX;
                        touchStartPosY = e.touches ? e.touches[0].pageY : e.pageY; 
                        var url = e.target.src;
                        pressTime = new Date();
                        if(!_conn){
                            _conn = [
                                touch.move(document.body,_touchMove),
                                touch.release(document.body,_touchEnd)
                            ];
                        }
                        loadHandle = setTimeout(function(){
                            require([
                                "cq/util/image/appImageLib",
                                "cq/util/edit/overlay"
                            ],function(appImageLib,overlay){
                                if(!tooltipNode){
                                    tooltipNode = domConstruct.create("div",{
                                        style:"width:150px;height:60px;line-height:60px",
                                        innerHTML:"保存图片到手机"
                                    });
                                }
                                if(!tooltipHandle){
                                    tooltipHandle = connect.connect(tooltipNode,"onclick",function(){
                                        appImageLib.save(url).then(function(result){
                                            if(result){
                                                alert("图片下载完成！");
                                            }else{
                                                alert("图片下载失败！");
                                            }
                                        });
                                        if(tooltipHandle){
                                            tooltipHandle.remove();
                                            tooltipHandle = null;
                                            domConstruct.destroy(tooltipNode);
                                            tooltipNode = null;
                                        }
                                        overlay.hide();
                                    });
                                }
                                overlay.showElement(tooltipNode);
                            });
                        },1000);
                    };
                    var _touchMove = function(e){
                        var x = e.touches ? e.touches[0].pageX : e.pageX;
                        var y = e.touches ? e.touches[0].pageY : e.pageY;
                        var dx = Math.abs(touchStartPosX - x);
                        var dy = Math.abs(touchStartPosY - y);
                        if(dx>threshold||dy>threshold) {
                            clearLOadHandle();
                        }
                    };
                    var _touchEnd = function(e){
                        event.stop(e);
                        clearLOadHandle();
                    };
                    var clearLOadHandle = function(){
                        if(loadHandle){
                            clearTimeout(loadHandle);
                            loadHandle = null;
                        }
                        if(_conn){
                            for(var i=0;i<_conn.length;i++){
                                _conn[i].remove();
                            }                
                        }
                        _conn = null;
                    };
                    touch.press(document.body,_touchStart);
                });
            });
        },
        changeTitle:function(){
            require([
                "dojo/topic",
                "cq/util/sys/userAgent"
            ],function(topic,userAgent){
                if(!userAgent.isWeixin()){
                    return;
                }
                topic.subscribe("cq/app/view/view/titleChanged",function(view){
                    if(!document.originTitle){
                        document.originTitle = document.title;
                    }
                    document.title = view.title||document.originTitle;
                });
            });
        }
    };
    obj.rewriteAhref();
    obj.longPressPicture();
    obj.backButtonClick();
    obj.fixShare();
    obj.longPressLoadImg();
    obj.changeTitle();
    return {};
});