define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/xhr",
    "dojo/cookie",
    "dojo/Deferred",
    "cq/util/config/config",
    "./userAgent"
], function(declare, lang, array, xhr, cookie, Deferred, config, userAgent){
    var Bo = null;
    return lang.mixin(lang.getObject("cq.util.sys.log", true), {
        firstPageLoadTime:0,
        curPageLoadTime:0,
        oldView:"",
        onViewChange:function(params){
            var info = lang.mixin(this.getInfo(),params||{});
            
            if(config&&config.session&&config.session.userInfo&&config.session.userInfo._id){
                info.pid = config.session.userInfo._id;
            }
            var params = location.hash.split("-");
            params.shift();
            info.param = params.join("-");
            xhr("POST", {
                async : false,
                url : config.getDataOrigin() + "/log/add",
                content : {data : JSON.stringify(info)}
            });
        },
        // 获取公共信息
        getInfo:function(){
            var params = {};
            if(!this.firstPageLoadTime){
                this.firstPageLoadTime = this.getDateTime();
                params.logType = "startTime";
            }else{
                params.logType = "viewChange";
            }
            if(this.curPageLoadTime){
                params.duration = this.dateDiff("s", this.curPageLoadTime, this.getDateTime());
            }
            this.curPageLoadTime = this.getDateTime();
            if(this.oldView){
                params.oldView = this.oldView;
            }
            this.oldView = (window.location.hash || "#").split("?")[0].split("&")[0].substr(1).split("-").shift() || "main";
            params.newView = this.oldView;
            params.logTime = this.getDateTime();
            // 客户端类型
            params.clientType = userAgent.getClientType();
            // 网络
            params.netType = userAgent.getNetType();
            // 操作系统
            params.os = userAgent.getOS();
            // 浏览器种类
            params.browserType = userAgent.getBrowserType();
            // 打开的地址
            params.currUrl = window.location.href;
            // 服务器域名
            // APP的打开地址是file://xxxx
            params.host = config&&config.getDataOrigin&&config.getDataOrigin()||window.location.host;
            params.svc = params.currUrl.split("/").pop();
            if(!params.svc || (params.svc.charAt(0) == "#")){
                params.svc = params.currUrl.split("/")[params.currUrl.split("/").length - 2];
            }else{
                if(params.svc.indexOf("#") > 0){
                    params.svc = params.svc.substr(0, params.svc.indexOf("#"));
                }
            }
            // 身份信息
            params.token = this.getToken();
            params.param = window.did;
            if(!Bo){
                try{
                    this._loadBo();
                }catch(e){
                    
                }
            }
            if(Bo){
                params.shopId = Bo.prototype.getShopId();
            }
            return params;
        },
        _loadBo:function(){
            Bo = Bo||require("bob/BoBase").C||require("cq/biz/object").Schema;
        },
        
        // 获取身份信息，如果是APP则获取设备ID，否则生成GUID
        getToken:function(){
            var token = "";
            if(userAgent.isApp()){
                token = device.uuid;
            }else if(!localStorage.getItem("log_token")){
                token = this.newGuid();
                localStorage.setItem("log_token", token);
            }else {
                token = localStorage.getItem("log_token");
            }
            return token;
        },
        // 生成GUID
        newGuid:function(){
            var guid = "", n;
            for (var i = 1; i <= 32; i++) {
                n = Math.floor(Math.random() * 16.0).toString(16);
                guid += n;
                if ((i == 8) || (i == 12) || (i == 16) || (i == 20)){
                    guid += "-";
                }
            }
            return guid;
        },
        
        
        getDateTime : function() {
            var d = new Date();
            d.setTime(d.getTime());
            return this.toDateTimeString(d);
        },
        toDateTimeString : function(date) {
            if("string"===typeof(date)){
                return date;
            }else{
                return this.toDateString(date)+" "+this.toTimeString(date);
            }
        },
        //日期转时间字符串
        toTimeString : function(date) {
            var timeString = "";
            if("string"===typeof(date)){
                timeString = date;
            }else{
                timeString = date.getSeconds();
                if(date.getSeconds() < 10){
                    timeString = "0"+timeString;
                }
                timeString + date.getMinutes()+":"+timeString;
                if(date.getMinutes() < 10){
                    timeString = "0"+timeString;
                }
                timeString = date.getHours()+":"+timeString;
                if(date.getHours<10){
                    timeString = "0"+timeString;
                }
            }
            return timeString;
        },
        //日期转日期字符串
        toDateString : function(date) {
            var dateString = "";
            if(typeof(date)==="string"){
                dateString = date;
            }else{
                dateString = date.getDate();
                if(date.getDate()<10){
                    dateString = "0"+dateString;
                }
                dateString = (date.getMonth() + 1)+"-"+dateString;
                if(date.getMonth() < 9){
                    dateString = "0"+dateString;
                }
                dateString = date.getFullYear()+"-"+dateString;
            }
            return dateString;
        },
        dateDiff : function(strInterval, dateStart, dateEnd) {
            var dtStart = dateStart;
            var dtEnd = dateEnd;
            //如果是字符串转换为日期型
            if (typeof dateStart == 'string'){
                dtStart = this.stringToDate(dateStart);
            }
            if (typeof dateEnd == 'string'){
                dtEnd = this.stringToDate(dateEnd);
            }
            switch (strInterval) {
                case 's':
                    return parseInt((dtEnd - dtStart) / 1000);
                case 'n':
                    return parseInt((dtEnd - dtStart) / 60000);
                case 'h':
                    return parseInt((dtEnd - dtStart) / 3600000);
                case 'd':
                    return parseInt((dtEnd - dtStart) / 86400000);
                case 'w':
                    return parseInt((dtEnd - dtStart) / (86400000 * 7));
                case 'm':
                    return dtEnd.getMonth()-dtStart.getMonth()+(dtEnd.getFullYear()-dtStart.getFullYear())*12;
                case 'y':
                    return dtEnd.getFullYear() - dtStart.getFullYear();
                default:
            }
            return 1;
        },
        stringToDate : function(DateStr) {
            if (typeof(DateStr) === "string") {
                var dateArray = array.map(DateStr.split(/[ \-:]/g),function(i) {
                    return i - 0;
                });
                if (dateArray.length !== 6) {
                    if (dateArray[0] > 1000) {
                        dateArray.push(0, 0, 0);
                    } else {
                        dateArray.splice(0, 0, 1970, 1, 1);
                    }
                }
                return new Date(dateArray[0], dateArray[1] - 1, dateArray[2], dateArray[3], dateArray[4], dateArray[5]);
            } else if ("number" === typeof(DateStr)) {
                return new Date(DateStr);
            } else {
                return DateStr;
            }
        }
    });
});