﻿define([
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-construct",
    "dojo/io/script",
    "dojo/Deferred",
    "dojo/DeferredList",
    "dojo/store/JsonRest",
    "./date",
    "./userAgent",
    "../../app/widget/utils/listLayout"
],function(lang, array, domConstruct, script, Deferred, DeferredList, JsonRest, date, userAgent,listLayout){
    return lang.mixin(lang.getObject("cq.util.sys.xlsx",true),{
        //参考cqthink/dbx/getExel对象
        //将数据导出为xlsx文件
        //sheetData：object
        //    columns：[{field:"列属性名",fieldName:"列名"}]
        //    datas：[{field:value}]
        //生成xlsx文件并已指定的文件名下载
        "export":function(sheetData,fileName){
            console.log(arguments);
            this.init().then(lang.hitch(this, function(flag){
                if(!flag){
                    alert("加载xlsx失败!");
                }else{
                    // 导出为xlsx文件
                    // 生成xlsx对应格式的对象
                    // console.log(this);
                    this.initXlsxFile(sheetData, fileName);
                    this._downloadBlod(true);
                }
            }));
        },
        exportMatrix:function(matrix,fileName){
            this.init().then(lang.hitch(this, function(flag){
                if(!flag){
                    alert("加载xlsx失败!");
                }else{
                    // 导出为xlsx文件
                    // 生成xlsx对应格式的对象
                    // console.log(this);
                    this.initXlsxFileByMatrix(matrix, fileName);
                    this._downloadBlod(true);
                }
            }));
        },
        // 加载xlsx相关组件
        init:function(){
            var def = new Deferred(),succeed = true;
            if("undefined"!=typeof(xlsx)){
                def.resolve(succeed);
            }else{
                try{
                    var JSZip = window.JSZip =  function(data, options) {
                       this.files = {};
                       this.root = "";
                       if (data) {
                          this.load(data, options);
                       }
                    };
                    JSZip.signature = {
                       LOCAL_FILE_HEADER : "\x50\x4b\x03\x04",
                       CENTRAL_FILE_HEADER : "\x50\x4b\x01\x02",
                       CENTRAL_DIRECTORY_END : "\x50\x4b\x05\x06",
                       ZIP64_CENTRAL_DIRECTORY_LOCATOR : "\x50\x4b\x06\x07",
                       ZIP64_CENTRAL_DIRECTORY_END : "\x50\x4b\x06\x06",
                       DATA_DESCRIPTOR : "\x50\x4b\x07\x08"
                    };
                    JSZip.defaults = {
                       base64: false,
                       binary: false,
                       dir: false,
                       date: null,
                       compression: null
                    };
                    JSZip.prototype = (function () {
                        var getRawData = function (file) {
                            if (file._data instanceof JSZip.CompressedObject) {
                                file._data = file._data.getContent();
                                file.options.binary = true;
                                file.options.base64 = false;
                                if (JSZip.utils.getTypeOf(file._data) === "uint8array") {
                                    var copy = file._data;
                                    file._data = new Uint8Array(copy.length);
                                    if (copy.length !== 0) {
                                        file._data.set(copy, 0);
                                    }
                                }
                            }
                            return file._data;
                        };
                        var getBinaryData = function (file) {
                            var result = getRawData(file), type = JSZip.utils.getTypeOf(result);
                            if (type === "string") {
                                if (!file.options.binary) {
                                    if (JSZip.support.uint8array && typeof TextEncoder === "function") {
                                        return TextEncoder("utf-8").encode(result);
                                    }
                                    if (JSZip.support.nodebuffer) {
                                        return new Buffer(result, "utf-8");
                                    }
                                }
                                return file.asBinary();
                            }
                            return result;
                        };
                       var dataToString = function (asUTF8) {
                          var result = getRawData(this);
                          if (result === null || typeof result === "undefined") {
                             return "";
                          }
                          if (this.options.base64) {
                             result = JSZip.base64.decode(result);
                          }
                          if (asUTF8 && this.options.binary) {
                             result = JSZip.prototype.utf8decode(result);
                          } else {
                             result = JSZip.utils.transformTo("string", result);
                          }

                          if (!asUTF8 && !this.options.binary) {
                             result = JSZip.prototype.utf8encode(result);
                          }
                          return result;
                       };
                       var ZipObject = function (name, data, options) {
                          this.name = name;
                          this._data = data;
                          this.options = options;
                       };

                       ZipObject.prototype = {
                          asText : function () {
                             return dataToString.call(this, true);
                          },
                          asBinary : function () {
                             return dataToString.call(this, false);
                          },
                          asNodeBuffer : function () {
                             var result = getBinaryData(this);
                             return JSZip.utils.transformTo("nodebuffer", result);
                          },
                          asUint8Array : function () {
                             var result = getBinaryData(this);
                             return JSZip.utils.transformTo("uint8array", result);
                          },
                          asArrayBuffer : function () {
                             return this.asUint8Array().buffer;
                          }
                       };
                        var decToHex = function(dec, bytes) {
                          var hex = "", i;
                          for(i = 0; i < bytes; i++) {
                             hex += String.fromCharCode(dec&0xff);
                             dec=dec>>>8;
                          }
                          return hex;
                       };
                       var extend = function () {
                          var result = {}, i, attr;
                          for (i = 0; i < arguments.length; i++) { // arguments is not enumerable in some browsers
                             for (attr in arguments[i]) {
                                if (arguments[i].hasOwnProperty(attr) && typeof result[attr] === "undefined") {
                                   result[attr] = arguments[i][attr];
                                }
                             }
                          }
                          return result;
                       };
                       var prepareFileAttrs = function (o) {
                          o = o || {};
                          if (o.base64 === true && o.binary == null) {
                             o.binary = true;
                          }
                          o = extend(o, JSZip.defaults);
                          o.date = o.date || new Date();
                          if (o.compression !== null) o.compression = o.compression.toUpperCase();

                          return o;
                       };
                       var fileAdd = function (name, data, o) {
                          var parent = parentFolder(name), dataType = JSZip.utils.getTypeOf(data);
                          if (parent) {
                             folderAdd.call(this, parent);
                          }

                          o = prepareFileAttrs(o);

                          if (o.dir || data === null || typeof data === "undefined") {
                             o.base64 = false;
                             o.binary = false;
                             data = null;
                          } else if (dataType === "string") {
                             if (o.binary && !o.base64) {
                                if (o.optimizedBinaryString !== true) {
                                   data = JSZip.utils.string2binary(data);
                                }
                             }
                          } else {
                             o.base64 = false;
                             o.binary = true;
                             if (!dataType && !(data instanceof JSZip.CompressedObject)) {
                                throw new Error("The data of '" + name + "' is in an unsupported format !");
                             }
                             if (dataType === "arraybuffer") {
                                data = JSZip.utils.transformTo("uint8array", data);
                             }
                          }
                          this.files[name] = new ZipObject(name, data, o);
                          return this.files[name];
                       };
                       var parentFolder = function (path) {
                          if (path.slice(-1) == '/') {
                             path = path.substring(0, path.length - 1);
                          }
                          var lastSlash = path.lastIndexOf('/');
                          return (lastSlash > 0) ? path.substring(0, lastSlash) : "";
                       };
                       var folderAdd = function (name) {
                          if (name.slice(-1) != "/") {
                             name += "/"; 
                          }
                          if (!this.files[name]) {
                             fileAdd.call(this, name, null, {dir:true});
                          }
                          return this.files[name];
                       };
                       var generateCompressedObjectFrom = function (file, compression) {
                          var result = new JSZip.CompressedObject(), content;
                          if (file._data instanceof JSZip.CompressedObject) {
                             result.uncompressedSize = file._data.uncompressedSize;
                             result.crc32 = file._data.crc32;
                             if (result.uncompressedSize === 0 || file.options.dir) {
                                compression = JSZip.compressions['STORE'];
                                result.compressedContent = "";
                                result.crc32 = 0;
                             } else if (file._data.compressionMethod === compression.magic) {
                                result.compressedContent = file._data.getCompressedContent();
                             } else {
                                content = file._data.getContent();
                                result.compressedContent = compression.compress(JSZip.utils.transformTo(compression.compressInputType, content));
                             }
                          } else {
                             content = getBinaryData(file);
                             if (!content || content.length === 0 || file.options.dir) {
                                compression = JSZip.compressions['STORE'];
                                content = "";
                             }
                             result.uncompressedSize = content.length;
                             result.crc32 = this.crc32(content);
                             result.compressedContent = compression.compress(JSZip.utils.transformTo(compression.compressInputType, content));
                          }
                          result.compressedSize = result.compressedContent.length;
                          result.compressionMethod = compression.magic;
                          return result;
                       };
                       var generateZipParts = function(name, file, compressedObject, offset) {
                          var data = compressedObject.compressedContent,
                              utfEncodedFileName = this.utf8encode(file.name),
                              useUTF8 = utfEncodedFileName !== file.name,
                              o       = file.options,
                              dosTime,
                              dosDate;
                          dosTime = o.date.getHours();
                          dosTime = dosTime << 6;
                          dosTime = dosTime | o.date.getMinutes();
                          dosTime = dosTime << 5;
                          dosTime = dosTime | o.date.getSeconds() / 2;

                          dosDate = o.date.getFullYear() - 1980;
                          dosDate = dosDate << 4;
                          dosDate = dosDate | (o.date.getMonth() + 1);
                          dosDate = dosDate << 5;
                          dosDate = dosDate | o.date.getDate();
                          var header = "";
                          header += "\x0A\x00";
                          header += useUTF8 ? "\x00\x08" : "\x00\x00";
                          header += compressedObject.compressionMethod;
                          header += decToHex(dosTime, 2);
                          header += decToHex(dosDate, 2);
                          header += decToHex(compressedObject.crc32, 4);
                          header += decToHex(compressedObject.compressedSize, 4);
                          header += decToHex(compressedObject.uncompressedSize, 4);
                          header += decToHex(utfEncodedFileName.length, 2);
                          header += "\x00\x00";
                          var fileRecord = JSZip.signature.LOCAL_FILE_HEADER + header + utfEncodedFileName;
                            var dirRecord = JSZip.signature.CENTRAL_FILE_HEADER +
                          "\x14\x00" +
                          header +
                          "\x00\x00" +
                          "\x00\x00" +
                          "\x00\x00" +
                          (file.options.dir===true?"\x10\x00\x00\x00":"\x00\x00\x00\x00")+
                          decToHex(offset, 4) +
                          utfEncodedFileName;
                          return {
                             fileRecord : fileRecord,
                             dirRecord : dirRecord,
                             compressedObject : compressedObject
                          };
                       };
                       var StringWriter = function () {
                          this.data = [];
                       };
                       StringWriter.prototype = {
                          append : function (input) {
                             input = JSZip.utils.transformTo("string", input);
                             this.data.push(input);
                          },
                          finalize : function () {
                             return this.data.join("");
                          }
                       };
                       var Uint8ArrayWriter = function (length) {
                          this.data = new Uint8Array(length);
                          this.index = 0;
                       };
                       Uint8ArrayWriter.prototype = {
                          append : function (input) {
                             if (input.length !== 0) {
                                input = JSZip.utils.transformTo("uint8array", input);
                                this.data.set(input, this.index);
                                this.index += input.length;
                             }
                          },
                          finalize : function () {
                             return this.data;
                          }
                       };
                       return {
                          load : function (stream, options) {
                             throw new Error("Load method is not defined. Is the file jszip-load.js included ?");
                          },
                          filter : function (search) {
                             var result = [], filename, relativePath, file, fileClone;
                             for (filename in this.files) {
                                if ( !this.files.hasOwnProperty(filename) ) { continue; }
                                file = this.files[filename];
                                fileClone = new ZipObject(file.name, file._data, extend(file.options));
                                relativePath = filename.slice(this.root.length, filename.length);
                                if (filename.slice(0, this.root.length) === this.root && 
                                    search(relativePath, fileClone)) { 
                                   result.push(fileClone);
                                }
                             }
                             return result;
                          },
                          file : function(name, data, o) {
                             if (arguments.length === 1) {
                                if (name instanceof RegExp) {
                                   var regexp = name;
                                   return this.filter(function(relativePath, file) {
                                      return !file.options.dir && regexp.test(relativePath);
                                   });
                                } else { // text
                                   return this.filter(function (relativePath, file) {
                                      return !file.options.dir && relativePath === name;
                                   })[0]||null;
                                }
                             } else { // more than one argument : we have data !
                                name = this.root+name;
                                fileAdd.call(this, name, data, o);
                             }
                             return this;
                          },
                          folder : function(arg) {
                             if (!arg) {
                                return this;
                             }
                             if (arg instanceof RegExp) {
                                return this.filter(function(relativePath, file) {
                                   return file.options.dir && arg.test(relativePath);
                                });
                             }
                             var name = this.root + arg;
                             var newFolder = folderAdd.call(this, name);
                             var ret = this.clone();
                             ret.root = newFolder.name;
                             return ret;
                          },
                          remove : function(name) {
                             name = this.root + name;
                             var file = this.files[name];
                             if (!file) {
                                if (name.slice(-1) != "/") {
                                   name += "/";
                                }
                                file = this.files[name];
                             }
                             if (file) {
                                if (!file.options.dir) {
                                   delete this.files[name];
                                } else {
                                   var kids = this.filter(function (relativePath, file) {
                                      return file.name.slice(0, name.length) === name;
                                   });
                                   for (var i = 0; i < kids.length; i++) {
                                      delete this.files[kids[i].name];
                                   }
                                }
                             }
                             return this;
                          },
                          generate : function(options) {
                             options = extend(options || {}, {
                                base64 : true,
                                compression : "STORE",
                                type : "base64"
                             });
                             JSZip.utils.checkSupport(options.type);
                             var zipData = [], localDirLength = 0, centralDirLength = 0, writer, i;
                             for (var name in this.files) {
                                if ( !this.files.hasOwnProperty(name) ) { continue; }
                                var file = this.files[name];
                                var compressionName = file.compression || options.compression.toUpperCase();
                                var compression = JSZip.compressions[compressionName];
                                if (!compression) {
                                   throw new Error(compressionName + " is not a valid compression method !");
                                }
                                var compressedObject = generateCompressedObjectFrom.call(this, file, compression);
                                var zipPart = generateZipParts.call(this, name, file, compressedObject, localDirLength);
                                localDirLength += zipPart.fileRecord.length + compressedObject.compressedSize;
                                centralDirLength += zipPart.dirRecord.length;
                                zipData.push(zipPart);
                             }
                             var dirEnd = "";
                             dirEnd = JSZip.signature.CENTRAL_DIRECTORY_END +
                             "\x00\x00" +
                             "\x00\x00" +
                             decToHex(zipData.length, 2) +
                             decToHex(zipData.length, 2) +
                             decToHex(centralDirLength, 4) +
                             decToHex(localDirLength, 4) +
                             "\x00\x00";
                             switch(options.type.toLowerCase()) {
                                case "uint8array" :
                                case "arraybuffer" :
                                case "blob" :
                                case "nodebuffer" :
                                   writer = new Uint8ArrayWriter(localDirLength + centralDirLength + dirEnd.length);
                                   break;
                                case "base64" :
                                default : // case "string" :
                                   writer = new StringWriter(localDirLength + centralDirLength + dirEnd.length);
                                   break;
                             }
                             for (i = 0; i < zipData.length; i++) {
                                writer.append(zipData[i].fileRecord);
                                writer.append(zipData[i].compressedObject.compressedContent);
                             }
                             for (i = 0; i < zipData.length; i++) {
                                writer.append(zipData[i].dirRecord);
                             }
                             writer.append(dirEnd);
                             var zip = writer.finalize();
                             switch(options.type.toLowerCase()) {
                                case "uint8array" :
                                case "arraybuffer" :
                                case "nodebuffer" :
                                   return JSZip.utils.transformTo(options.type.toLowerCase(), zip);
                                case "blob" :
                                   return JSZip.utils.arrayBuffer2Blob(JSZip.utils.transformTo("arraybuffer", zip));
                                case "base64" :
                                   return (options.base64) ? JSZip.base64.encode(zip) : zip;
                                default : // case "string" :
                                   return zip;
                             }
                          },
                          crc32 : function crc32(input, crc) {
                             if (typeof input === "undefined" || !input.length) {
                                return 0;
                             }
                             var isArray = JSZip.utils.getTypeOf(input) !== "string";
                             var table = [
                                0x00000000, 0x77073096, 0xEE0E612C, 0x990951BA,
                                0x076DC419, 0x706AF48F, 0xE963A535, 0x9E6495A3,
                                0x0EDB8832, 0x79DCB8A4, 0xE0D5E91E, 0x97D2D988,
                                0x09B64C2B, 0x7EB17CBD, 0xE7B82D07, 0x90BF1D91,
                                0x1DB71064, 0x6AB020F2, 0xF3B97148, 0x84BE41DE,
                                0x1ADAD47D, 0x6DDDE4EB, 0xF4D4B551, 0x83D385C7,
                                0x136C9856, 0x646BA8C0, 0xFD62F97A, 0x8A65C9EC,
                                0x14015C4F, 0x63066CD9, 0xFA0F3D63, 0x8D080DF5,
                                0x3B6E20C8, 0x4C69105E, 0xD56041E4, 0xA2677172,
                                0x3C03E4D1, 0x4B04D447, 0xD20D85FD, 0xA50AB56B,
                                0x35B5A8FA, 0x42B2986C, 0xDBBBC9D6, 0xACBCF940,
                                0x32D86CE3, 0x45DF5C75, 0xDCD60DCF, 0xABD13D59,
                                0x26D930AC, 0x51DE003A, 0xC8D75180, 0xBFD06116,
                                0x21B4F4B5, 0x56B3C423, 0xCFBA9599, 0xB8BDA50F,
                                0x2802B89E, 0x5F058808, 0xC60CD9B2, 0xB10BE924,
                                0x2F6F7C87, 0x58684C11, 0xC1611DAB, 0xB6662D3D,
                                0x76DC4190, 0x01DB7106, 0x98D220BC, 0xEFD5102A,
                                0x71B18589, 0x06B6B51F, 0x9FBFE4A5, 0xE8B8D433,
                                0x7807C9A2, 0x0F00F934, 0x9609A88E, 0xE10E9818,
                                0x7F6A0DBB, 0x086D3D2D, 0x91646C97, 0xE6635C01,
                                0x6B6B51F4, 0x1C6C6162, 0x856530D8, 0xF262004E,
                                0x6C0695ED, 0x1B01A57B, 0x8208F4C1, 0xF50FC457,
                                0x65B0D9C6, 0x12B7E950, 0x8BBEB8EA, 0xFCB9887C,
                                0x62DD1DDF, 0x15DA2D49, 0x8CD37CF3, 0xFBD44C65,
                                0x4DB26158, 0x3AB551CE, 0xA3BC0074, 0xD4BB30E2,
                                0x4ADFA541, 0x3DD895D7, 0xA4D1C46D, 0xD3D6F4FB,
                                0x4369E96A, 0x346ED9FC, 0xAD678846, 0xDA60B8D0,
                                0x44042D73, 0x33031DE5, 0xAA0A4C5F, 0xDD0D7CC9,
                                0x5005713C, 0x270241AA, 0xBE0B1010, 0xC90C2086,
                                0x5768B525, 0x206F85B3, 0xB966D409, 0xCE61E49F,
                                0x5EDEF90E, 0x29D9C998, 0xB0D09822, 0xC7D7A8B4,
                                0x59B33D17, 0x2EB40D81, 0xB7BD5C3B, 0xC0BA6CAD,
                                0xEDB88320, 0x9ABFB3B6, 0x03B6E20C, 0x74B1D29A,
                                0xEAD54739, 0x9DD277AF, 0x04DB2615, 0x73DC1683,
                                0xE3630B12, 0x94643B84, 0x0D6D6A3E, 0x7A6A5AA8,
                                0xE40ECF0B, 0x9309FF9D, 0x0A00AE27, 0x7D079EB1,
                                0xF00F9344, 0x8708A3D2, 0x1E01F268, 0x6906C2FE,
                                0xF762575D, 0x806567CB, 0x196C3671, 0x6E6B06E7,
                                0xFED41B76, 0x89D32BE0, 0x10DA7A5A, 0x67DD4ACC,
                                0xF9B9DF6F, 0x8EBEEFF9, 0x17B7BE43, 0x60B08ED5,
                                0xD6D6A3E8, 0xA1D1937E, 0x38D8C2C4, 0x4FDFF252,
                                0xD1BB67F1, 0xA6BC5767, 0x3FB506DD, 0x48B2364B,
                                0xD80D2BDA, 0xAF0A1B4C, 0x36034AF6, 0x41047A60,
                                0xDF60EFC3, 0xA867DF55, 0x316E8EEF, 0x4669BE79,
                                0xCB61B38C, 0xBC66831A, 0x256FD2A0, 0x5268E236,
                                0xCC0C7795, 0xBB0B4703, 0x220216B9, 0x5505262F,
                                0xC5BA3BBE, 0xB2BD0B28, 0x2BB45A92, 0x5CB36A04,
                                0xC2D7FFA7, 0xB5D0CF31, 0x2CD99E8B, 0x5BDEAE1D,
                                0x9B64C2B0, 0xEC63F226, 0x756AA39C, 0x026D930A,
                                0x9C0906A9, 0xEB0E363F, 0x72076785, 0x05005713,
                                0x95BF4A82, 0xE2B87A14, 0x7BB12BAE, 0x0CB61B38,
                                0x92D28E9B, 0xE5D5BE0D, 0x7CDCEFB7, 0x0BDBDF21,
                                0x86D3D2D4, 0xF1D4E242, 0x68DDB3F8, 0x1FDA836E,
                                0x81BE16CD, 0xF6B9265B, 0x6FB077E1, 0x18B74777,
                                0x88085AE6, 0xFF0F6A70, 0x66063BCA, 0x11010B5C,
                                0x8F659EFF, 0xF862AE69, 0x616BFFD3, 0x166CCF45,
                                0xA00AE278, 0xD70DD2EE, 0x4E048354, 0x3903B3C2,
                                0xA7672661, 0xD06016F7, 0x4969474D, 0x3E6E77DB,
                                0xAED16A4A, 0xD9D65ADC, 0x40DF0B66, 0x37D83BF0,
                                0xA9BCAE53, 0xDEBB9EC5, 0x47B2CF7F, 0x30B5FFE9,
                                0xBDBDF21C, 0xCABAC28A, 0x53B39330, 0x24B4A3A6,
                                0xBAD03605, 0xCDD70693, 0x54DE5729, 0x23D967BF,
                                0xB3667A2E, 0xC4614AB8, 0x5D681B02, 0x2A6F2B94,
                                0xB40BBE37, 0xC30C8EA1, 0x5A05DF1B, 0x2D02EF8D
                             ];
                             if (typeof(crc) == "undefined") { crc = 0; }
                             var x = 0;
                             var y = 0;
                             var byte = 0;
                             crc = crc ^ (-1);
                             for( var i = 0, iTop = input.length; i < iTop; i++ ) {
                                byte = isArray ? input[i] : input.charCodeAt(i);
                                y = ( crc ^ byte ) & 0xFF;
                                x = table[y];
                                crc = ( crc >>> 8 ) ^ x;
                             }
                             return crc ^ (-1);
                          },
                          clone : function() {
                             var newObj = new JSZip();
                             for (var i in this) {
                                if (typeof this[i] !== "function") {
                                   newObj[i] = this[i];
                                }
                             }
                             return newObj;
                          },
                          utf8encode : function (string) {
                             if (JSZip.support.uint8array && typeof TextEncoder === "function") {
                                var u8 = TextEncoder("utf-8").encode(string);
                                return JSZip.utils.transformTo("string", u8);
                             }
                             if (JSZip.support.nodebuffer) {
                                return JSZip.utils.transformTo("string", new Buffer(string, "utf-8"));
                             }
                             var result = [], resIndex = 0;
                             for (var n = 0; n < string.length; n++) {
                                var c = string.charCodeAt(n);
                                if (c < 128) {
                                   result[resIndex++] = String.fromCharCode(c);
                                } else if ((c > 127) && (c < 2048)) {
                                   result[resIndex++] = String.fromCharCode((c >> 6) | 192);
                                   result[resIndex++] = String.fromCharCode((c & 63) | 128);
                                } else {
                                   result[resIndex++] = String.fromCharCode((c >> 12) | 224);
                                   result[resIndex++] = String.fromCharCode(((c >> 6) & 63) | 128);
                                   result[resIndex++] = String.fromCharCode((c & 63) | 128);
                                }
                             }
                             return result.join("");
                          },
                          utf8decode : function (input) {
                             var result = [], resIndex = 0;
                             var type = JSZip.utils.getTypeOf(input);
                             var isArray = type !== "string";
                             var i = 0;
                             var c = 0, c1 = 0, c2 = 0, c3 = 0;
                             if (JSZip.support.uint8array && typeof TextDecoder === "function") {
                                return TextDecoder("utf-8").decode(
                                   JSZip.utils.transformTo("uint8array", input)
                                );
                             }
                             if (JSZip.support.nodebuffer) {
                                return JSZip.utils.transformTo("nodebuffer", input).toString("utf-8");
                             }
                             while ( i < input.length ) {
                                c = isArray ? input[i] : input.charCodeAt(i);
                                if (c < 128) {
                                   result[resIndex++] = String.fromCharCode(c);
                                   i++;
                                } else if ((c > 191) && (c < 224)) {
                                   c2 = isArray ? input[i+1] : input.charCodeAt(i+1);
                                   result[resIndex++] = String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                                   i += 2;
                                } else {
                                   c2 = isArray ? input[i+1] : input.charCodeAt(i+1);
                                   c3 = isArray ? input[i+2] : input.charCodeAt(i+2);
                                   result[resIndex++] = String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                                   i += 3;
                                }
                             }
                             return result.join("");
                          }
                       };
                    }());
                    JSZip.compressions = {
                       "STORE" : {
                          magic : "\x00\x00",
                          compress : function (content) {
                             return content; // no compression
                          },
                          uncompress : function (content) {
                             return content; // no compression
                          },
                          compressInputType : null,
                          uncompressInputType : null
                       }
                    };
                    JSZip.support = {
                       arraybuffer : (function(){
                          return typeof ArrayBuffer !== "undefined" && typeof Uint8Array !== "undefined";
                       })(),
                       nodebuffer : (function(){
                          return typeof Buffer !== "undefined";
                       })(),
                       uint8array : (function(){
                          return typeof Uint8Array !== "undefined";
                       })(),
                       blob : (function(){
                          if (typeof ArrayBuffer === "undefined") {
                             return false;
                          }
                          var buffer = new ArrayBuffer(0);
                          try {
                             return new Blob([buffer], { type: "application/zip" }).size === 0;
                          }
                          catch(e) {}
                          try {
                              var Builder = window.BlobBuilder || window.WebKitBlobBuilder ||
                                                window.MozBlobBuilder || window.MSBlobBuilder;
                             var builder = new Builder();
                             builder.append(buffer);
                             return builder.getBlob('application/zip').size === 0;
                          }
                          catch(e) {}
                          return false;
                       })()
                    };
                    (function () {
                       JSZip.utils = {
                          string2binary : function (str) {
                             var result = "";
                             for (var i = 0; i < str.length; i++) {
                                result += String.fromCharCode(str.charCodeAt(i) & 0xff);
                             }
                             return result;
                          },
                          string2Uint8Array : function (str) {
                             return JSZip.utils.transformTo("uint8array", str);
                          },
                          uint8Array2String : function (array) {
                             return JSZip.utils.transformTo("string", array);
                          },
                          arrayBuffer2Blob : function (buffer) {
                             JSZip.utils.checkSupport("blob");
                             try {
                                return new Blob([buffer], { type: "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet" });
                             }
                             catch(e) {}
                             try {
                                 var Builder = window.BlobBuilder || window.WebKitBlobBuilder ||
                                                   window.MozBlobBuilder || window.MSBlobBuilder;
                                var builder = new Builder();
                                builder.append(buffer);
                                return builder.getBlob('application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
                             }
                             catch(e) {}
                             throw new Error("Bug : can't construct the Blob.");
                          },
                          string2Blob : function (str) {
                             var buffer = JSZip.utils.transformTo("arraybuffer", str);
                             return JSZip.utils.arrayBuffer2Blob(buffer);
                          }
                       };
                       function identity(input) {
                          return input;
                       }
                       function stringToArrayLike(str, array) {
                          for (var i = 0; i < str.length; ++i) {
                             array[i] = str.charCodeAt(i) & 0xFF;
                          }
                          return array;
                       }
                       function arrayLikeToString(array) {
                          var chunk = 65536;
                          var result = [], len = array.length, type = JSZip.utils.getTypeOf(array), k = 0;
                          while (k < len && chunk > 1) {
                             try {
                                if (type === "array" || type === "nodebuffer") {
                                   result.push(String.fromCharCode.apply(null, array.slice(k, Math.max(k + chunk, len))));
                                } else {
                                   result.push(String.fromCharCode.apply(null, array.subarray(k, k + chunk)));
                                }
                                k += chunk;
                             } catch (e) {
                                chunk = Math.floor(chunk / 2);
                             }
                          }
                          return result.join("");
                       }
                       function arrayLikeToArrayLike(arrayFrom, arrayTo) {
                          for(var i = 0; i < arrayFrom.length; i++) {
                             arrayTo[i] = arrayFrom[i];
                          }
                          return arrayTo;
                       }
                       var transform = {};
                       transform["string"] = {
                          "string" : identity,
                          "array" : function (input) {
                             return stringToArrayLike(input, new Array(input.length));
                          },
                          "arraybuffer" : function (input) {
                             return transform["string"]["uint8array"](input).buffer;
                          },
                          "uint8array" : function (input) {
                             return stringToArrayLike(input, new Uint8Array(input.length));
                          },
                          "nodebuffer" : function (input) {
                             return stringToArrayLike(input, new Buffer(input.length));
                          }
                       };
                       transform["array"] = {
                          "string" : arrayLikeToString,
                          "array" : identity,
                          "arraybuffer" : function (input) {
                             return (new Uint8Array(input)).buffer;
                          },
                          "uint8array" : function (input) {
                             return new Uint8Array(input);
                          },
                          "nodebuffer" : function (input) {
                             return new Buffer(input);
                          }
                       };
                       transform["arraybuffer"] = {
                          "string" : function (input) {
                             return arrayLikeToString(new Uint8Array(input));
                          },
                          "array" : function (input) {
                             return arrayLikeToArrayLike(new Uint8Array(input), new Array(input.byteLength));
                          },
                          "arraybuffer" : identity,
                          "uint8array" : function (input) {
                             return new Uint8Array(input);
                          },
                          "nodebuffer" : function (input) {
                             return new Buffer(new Uint8Array(input));
                          }
                       };
                       transform["uint8array"] = {
                          "string" : arrayLikeToString,
                          "array" : function (input) {
                             return arrayLikeToArrayLike(input, new Array(input.length));
                          },
                          "arraybuffer" : function (input) {
                             return input.buffer;
                          },
                          "uint8array" : identity,
                          "nodebuffer" : function(input) {
                             return new Buffer(input);
                          }
                       };
                       transform["nodebuffer"] = {
                          "string" : arrayLikeToString,
                          "array" : function (input) {
                             return arrayLikeToArrayLike(input, new Array(input.length));
                          },
                          "arraybuffer" : function (input) {
                             return transform["nodebuffer"]["uint8array"](input).buffer;
                          },
                          "uint8array" : function (input) {
                             return arrayLikeToArrayLike(input, new Uint8Array(input.length));
                          },
                          "nodebuffer" : identity
                       };
                       JSZip.utils.transformTo = function (outputType, input) {
                          if (!input) {
                             input = "";
                          }
                          if (!outputType) {
                             return input;
                          }
                          JSZip.utils.checkSupport(outputType);
                          var inputType = JSZip.utils.getTypeOf(input);
                          var result = transform[inputType][outputType](input);
                          return result;
                       };
                       JSZip.utils.getTypeOf = function (input) {
                          if (typeof input === "string") {
                             return "string";
                          }
                          if (input instanceof Array) {
                             return "array";
                          }
                          if (JSZip.support.nodebuffer && Buffer.isBuffer(input)) {
                             return "nodebuffer";
                          }
                          if (JSZip.support.uint8array && input instanceof Uint8Array) {
                             return "uint8array";
                          }
                          if (JSZip.support.arraybuffer && input instanceof ArrayBuffer) {
                             return "arraybuffer";
                          }
                       };
                       JSZip.utils.checkSupport = function (type) {
                          var supported = true;
                          switch (type.toLowerCase()) {
                             case "uint8array":
                                supported = JSZip.support.uint8array;
                             break;
                             case "arraybuffer":
                                supported = JSZip.support.arraybuffer;
                             break;
                             case "nodebuffer":
                                supported = JSZip.support.nodebuffer;
                             break;
                             case "blob":
                                supported = JSZip.support.blob;
                             break;
                          }
                          if (!supported) {
                             throw new Error(type + " is not supported by this browser");
                          }
                       };
                    })();
                    (function (){
                       JSZip.CompressedObject = function () {
                             this.compressedSize = 0;
                             this.uncompressedSize = 0;
                             this.crc32 = 0;
                             this.compressionMethod = null;
                             this.compressedContent = null;
                       };
                       JSZip.CompressedObject.prototype = {
                          getContent : function () {
                             return null; // see implementation
                          },
                          getCompressedContent : function () {
                             return null; // see implementation
                          }
                       };
                    })();
                    JSZip.base64 = (function() {
                       var _keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
                        return {
                          encode : function(input, utf8) {
                             var output = "";
                             var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
                             var i = 0;
                                while (i < input.length) {

                                chr1 = input.charCodeAt(i++);
                                chr2 = input.charCodeAt(i++);
                                chr3 = input.charCodeAt(i++);

                                enc1 = chr1 >> 2;
                                enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
                                enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
                                enc4 = chr3 & 63;

                                if (isNaN(chr2)) {
                                   enc3 = enc4 = 64;
                                } else if (isNaN(chr3)) {
                                   enc4 = 64;
                                }

                                output = output +
                                   _keyStr.charAt(enc1) + _keyStr.charAt(enc2) +
                                   _keyStr.charAt(enc3) + _keyStr.charAt(enc4);

                             }

                             return output;
                          },
                          decode : function(input, utf8) {
                             var output = "";
                             var chr1, chr2, chr3;
                             var enc1, enc2, enc3, enc4;
                             var i = 0;

                             input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

                             while (i < input.length) {

                                enc1 = _keyStr.indexOf(input.charAt(i++));
                                enc2 = _keyStr.indexOf(input.charAt(i++));
                                enc3 = _keyStr.indexOf(input.charAt(i++));
                                enc4 = _keyStr.indexOf(input.charAt(i++));

                                chr1 = (enc1 << 2) | (enc2 >> 4);
                                chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
                                chr3 = ((enc3 & 3) << 6) | enc4;

                                output = output + String.fromCharCode(chr1);

                                if (enc3 != 64) {
                                   output = output + String.fromCharCode(chr2);
                                }
                                if (enc4 != 64) {
                                   output = output + String.fromCharCode(chr3);
                                }

                             }

                             return output;

                          }
                       };
                    }());
                    (function () {
                       if(!JSZip) {
                          throw "JSZip not defined";
                       }
                       var context = {};
                       (function () {
                    /** @license zlib.js 2012 - imaya [ https://github.com/imaya/zlib.js ] The MIT License */(function() {'use strict';var n=void 0,u=!0,aa=this;function ba(e,d){var c=e.split("."),f=aa;!(c[0]in f)&&f.execScript&&f.execScript("var "+c[0]);for(var a;c.length&&(a=c.shift());)!c.length&&d!==n?f[a]=d:f=f[a]?f[a]:f[a]={};}var C="undefined"!==typeof Uint8Array&&"undefined"!==typeof Uint16Array&&"undefined"!==typeof Uint32Array;function K(e,d){this.index="number"===typeof d?d:0;this.d=0;this.buffer=e instanceof(C?Uint8Array:Array)?e:new (C?Uint8Array:Array)(32768);if(2*this.buffer.length<=this.index)throw Error("invalid index");this.buffer.length<=this.index&&ca(this);}function ca(e){var d=e.buffer,c,f=d.length,a=new (C?Uint8Array:Array)(f<<1);if(C)a.set(d);else for(c=0;c<f;++c)a[c]=d[c];return e.buffer=a;}
                    K.prototype.a=function(e,d,c){var f=this.buffer,a=this.index,b=this.d,k=f[a],m;c&&1<d&&(e=8<d?(L[e&255]<<24|L[e>>>8&255]<<16|L[e>>>16&255]<<8|L[e>>>24&255])>>32-d:L[e]>>8-d);if(8>d+b)k=k<<d|e,b+=d;else for(m=0;m<d;++m)k=k<<1|e>>d-m-1&1,8===++b&&(b=0,f[a++]=L[k],k=0,a===f.length&&(f=ca(this)));f[a]=k;this.buffer=f;this.d=b;this.index=a;};K.prototype.finish=function(){var e=this.buffer,d=this.index,c;0<this.d&&(e[d]<<=8-this.d,e[d]=L[e[d]],d++);C?c=e.subarray(0,d):(e.length=d,c=e);return c;};
                    var ga=new (C?Uint8Array:Array)(256),M;for(M=0;256>M;++M){for(var R=M,S=R,ha=7,R=R>>>1;R;R>>>=1)S<<=1,S|=R&1,--ha;ga[M]=(S<<ha&255)>>>0;}var L=ga;function ja(e){this.buffer=new (C?Uint16Array:Array)(2*e);this.length=0;}ja.prototype.getParent=function(e){return 2*((e-2)/4|0);};ja.prototype.push=function(e,d){var c,f,a=this.buffer,b;c=this.length;a[this.length++]=d;for(a[this.length++]=e;0<c;)if(f=this.getParent(c),a[c]>a[f])b=a[c],a[c]=a[f],a[f]=b,b=a[c+1],a[c+1]=a[f+1],a[f+1]=b,c=f;else break;return this.leng;th;};
                    ja.prototype.pop=function(){var e,d,c=this.buffer,f,a,b;d=c[0];e=c[1];this.length-=2;c[0]=c[this.length];c[1]=c[this.length+1];for(b=0;;){a=2*b+2;if(a>=this.length)break;a+2<this.length&&c[a+2]>c[a]&&(a+=2);if(c[a]>c[b])f=c[b],c[b]=c[a],c[a]=f,f=c[b+1],c[b+1]=c[a+1],c[a+1]=f;else break;b=a;}return{index:e,value:d,length:this.length};};function ka(e,d){this.e=ma;this.f=0;this.input=C&&e instanceof Array?new Uint8Array(e):e;this.c=0;d&&(d.lazy&&(this.f=d.lazy),"number"===typeof d.compressionType&&(this.e=d.compressionType),d.outputBuffer&&(this.b=C&&d.outputBuffer instanceof Array?new Uint8Array(d.outputBuffer):d.outputBuffer),"number"===typeof d.outputIndex&&(this.c=d.outputIndex));this.b||(this.b=new (C?Uint8Array:Array)(32768));}var ma=2,T=[],U;
                    for(U=0;288>U;U++)switch(u){case 143>=U:T.push([U+48,8]);break;case 255>=U:T.push([U-144+400,9]);break;case 279>=U:T.push([U-256+0,7]);break;case 287>=U:T.push([U-280+192,8]);break;default:throw"invalid literal: "+U;}
                    ka.prototype.h=function(){var e,d,c,f,a=this.input;switch(this.e){case 0:c=0;for(f=a.length;c<f;){d=C?a.subarray(c,c+65535):a.slice(c,c+65535);c+=d.length;var b=d,k=c===f,m=n,g=n,p=n,v=n,x=n,l=this.b,h=this.c;if(C){for(l=new Uint8Array(this.b.buffer);l.length<=h+b.length+5;)l=new Uint8Array(l.length<<1);l.set(this.b);}m=k?1:0;l[h++]=m|0;g=b.length;p=~g+65536&65535;l[h++]=g&255;l[h++]=g>>>8&255;l[h++]=p&255;l[h++]=p>>>8&255;if(C)l.set(b,h),h+=b.length,l=l.subarray(0,h);else{v=0;for(x=b.length;v<x;++v)l[h++]=
                    b[v];l.length=h;}this.c=h;this.b=l;}break;case 1:var q=new K(C?new Uint8Array(this.b.buffer):this.b,this.c);q.a(1,1,u);q.a(1,2,u);var t=na(this,a),w,da,z;w=0;for(da=t.length;w<da;w++)if(z=t[w],K.prototype.a.apply(q,T[z]),256<z)q.a(t[++w],t[++w],u),q.a(t[++w],5),q.a(t[++w],t[++w],u);else if(256===z)break;this.b=q.finish();this.c=this.b.length;break;case ma:var B=new K(C?new Uint8Array(this.b.buffer):this.b,this.c),ra,J,N,O,P,Ia=[16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15],W,sa,X,ta,ea,ia=Array(19),
                    ua,Q,fa,y,va;ra=ma;B.a(1,1,u);B.a(ra,2,u);J=na(this,a);W=oa(this.j,15);sa=pa(W);X=oa(this.i,7);ta=pa(X);for(N=286;257<N&&0===W[N-1];N--);for(O=30;1<O&&0===X[O-1];O--);var wa=N,xa=O,F=new (C?Uint32Array:Array)(wa+xa),r,G,s,Y,E=new (C?Uint32Array:Array)(316),D,A,H=new (C?Uint8Array:Array)(19);for(r=G=0;r<wa;r++)F[G++]=W[r];for(r=0;r<xa;r++)F[G++]=X[r];if(!C){r=0;for(Y=H.length;r<Y;++r)H[r]=0}r=D=0;for(Y=F.length;r<Y;r+=G){for(G=1;r+G<Y&&F[r+G]===F[r];++G);s=G;if(0===F[r])if(3>s)for(;0<s--;)E[D++]=0,
                    H[0]++;else for(;0<s;)A=138>s?s:138,A>s-3&&A<s&&(A=s-3),10>=A?(E[D++]=17,E[D++]=A-3,H[17]++):(E[D++]=18,E[D++]=A-11,H[18]++),s-=A;else if(E[D++]=F[r],H[F[r]]++,s--,3>s)for(;0<s--;)E[D++]=F[r],H[F[r]]++;else for(;0<s;)A=6>s?s:6,A>s-3&&A<s&&(A=s-3),E[D++]=16,E[D++]=A-3,H[16]++,s-=A}e=C?E.subarray(0,D):E.slice(0,D);ea=oa(H,7);for(y=0;19>y;y++)ia[y]=ea[Ia[y]];for(P=19;4<P&&0===ia[P-1];P--);ua=pa(ea);B.a(N-257,5,u);B.a(O-1,5,u);B.a(P-4,4,u);for(y=0;y<P;y++)B.a(ia[y],3,u);y=0;for(va=e.length;y<va;y++)if(Q=
                    e[y],B.a(ua[Q],ea[Q],u),16<=Q){y++;switch(Q){case 16:fa=2;break;case 17:fa=3;break;case 18:fa=7;break;default:throw"invalid code: "+Q;}B.a(e[y],fa,u)}var ya=[sa,W],za=[ta,X],I,Aa,Z,la,Ba,Ca,Da,Ea;Ba=ya[0];Ca=ya[1];Da=za[0];Ea=za[1];I=0;for(Aa=J.length;I<Aa;++I)if(Z=J[I],B.a(Ba[Z],Ca[Z],u),256<Z)B.a(J[++I],J[++I],u),la=J[++I],B.a(Da[la],Ea[la],u),B.a(J[++I],J[++I],u);else if(256===Z)break;this.b=B.finish();this.c=this.b.length;break;default:throw"invalid compression type";}return this.b};
                    function qa(e,d){this.length=e;this.g=d}
                    var Fa=function(){function e(a){switch(u){case 3===a:return[257,a-3,0];case 4===a:return[258,a-4,0];case 5===a:return[259,a-5,0];case 6===a:return[260,a-6,0];case 7===a:return[261,a-7,0];case 8===a:return[262,a-8,0];case 9===a:return[263,a-9,0];case 10===a:return[264,a-10,0];case 12>=a:return[265,a-11,1];case 14>=a:return[266,a-13,1];case 16>=a:return[267,a-15,1];case 18>=a:return[268,a-17,1];case 22>=a:return[269,a-19,2];case 26>=a:return[270,a-23,2];case 30>=a:return[271,a-27,2];case 34>=a:return[272,
                    a-31,2];case 42>=a:return[273,a-35,3];case 50>=a:return[274,a-43,3];case 58>=a:return[275,a-51,3];case 66>=a:return[276,a-59,3];case 82>=a:return[277,a-67,4];case 98>=a:return[278,a-83,4];case 114>=a:return[279,a-99,4];case 130>=a:return[280,a-115,4];case 162>=a:return[281,a-131,5];case 194>=a:return[282,a-163,5];case 226>=a:return[283,a-195,5];case 257>=a:return[284,a-227,5];case 258===a:return[285,a-258,0];default:throw"invalid length: "+a;}}var d=[],c,f;for(c=3;258>=c;c++)f=e(c),d[c]=f[2]<<24|
                    f[1]<<16|f[0];return d}(),Ga=C?new Uint32Array(Fa):Fa;
                    function na(e,d){function c(a,c){var b=a.g,d=[],f=0,e;e=Ga[a.length];d[f++]=e&65535;d[f++]=e>>16&255;d[f++]=e>>24;var g;switch(u){case 1===b:g=[0,b-1,0];break;case 2===b:g=[1,b-2,0];break;case 3===b:g=[2,b-3,0];break;case 4===b:g=[3,b-4,0];break;case 6>=b:g=[4,b-5,1];break;case 8>=b:g=[5,b-7,1];break;case 12>=b:g=[6,b-9,2];break;case 16>=b:g=[7,b-13,2];break;case 24>=b:g=[8,b-17,3];break;case 32>=b:g=[9,b-25,3];break;case 48>=b:g=[10,b-33,4];break;case 64>=b:g=[11,b-49,4];break;case 96>=b:g=[12,b-
                    65,5];break;case 128>=b:g=[13,b-97,5];break;case 192>=b:g=[14,b-129,6];break;case 256>=b:g=[15,b-193,6];break;case 384>=b:g=[16,b-257,7];break;case 512>=b:g=[17,b-385,7];break;case 768>=b:g=[18,b-513,8];break;case 1024>=b:g=[19,b-769,8];break;case 1536>=b:g=[20,b-1025,9];break;case 2048>=b:g=[21,b-1537,9];break;case 3072>=b:g=[22,b-2049,10];break;case 4096>=b:g=[23,b-3073,10];break;case 6144>=b:g=[24,b-4097,11];break;case 8192>=b:g=[25,b-6145,11];break;case 12288>=b:g=[26,b-8193,12];break;case 16384>=
                    b:g=[27,b-12289,12];break;case 24576>=b:g=[28,b-16385,13];break;case 32768>=b:g=[29,b-24577,13];break;default:throw"invalid distance";}e=g;d[f++]=e[0];d[f++]=e[1];d[f++]=e[2];var k,m;k=0;for(m=d.length;k<m;++k)l[h++]=d[k];t[d[0]]++;w[d[3]]++;q=a.length+c-1;x=null}var f,a,b,k,m,g={},p,v,x,l=C?new Uint16Array(2*d.length):[],h=0,q=0,t=new (C?Uint32Array:Array)(286),w=new (C?Uint32Array:Array)(30),da=e.f,z;if(!C){for(b=0;285>=b;)t[b++]=0;for(b=0;29>=b;)w[b++]=0}t[256]=1;f=0;for(a=d.length;f<a;++f){b=
                    m=0;for(k=3;b<k&&f+b!==a;++b)m=m<<8|d[f+b];g[m]===n&&(g[m]=[]);p=g[m];if(!(0<q--)){for(;0<p.length&&32768<f-p[0];)p.shift();if(f+3>=a){x&&c(x,-1);b=0;for(k=a-f;b<k;++b)z=d[f+b],l[h++]=z,++t[z];break}0<p.length?(v=Ha(d,f,p),x?x.length<v.length?(z=d[f-1],l[h++]=z,++t[z],c(v,0)):c(x,-1):v.length<da?x=v:c(v,0)):x?c(x,-1):(z=d[f],l[h++]=z,++t[z])}p.push(f)}l[h++]=256;t[256]++;e.j=t;e.i=w;return C?l.subarray(0,h):l}
                    function Ha(e,d,c){var f,a,b=0,k,m,g,p,v=e.length;m=0;p=c.length;a:for(;m<p;m++){f=c[p-m-1];k=3;if(3<b){for(g=b;3<g;g--)if(e[f+g-1]!==e[d+g-1])continue a;k=b}for(;258>k&&d+k<v&&e[f+k]===e[d+k];)++k;k>b&&(a=f,b=k);if(258===k)break}return new qa(b,d-a)}
                    function oa(e,d){var c=e.length,f=new ja(572),a=new (C?Uint8Array:Array)(c),b,k,m,g,p;if(!C)for(g=0;g<c;g++)a[g]=0;for(g=0;g<c;++g)0<e[g]&&f.push(g,e[g]);b=Array(f.length/2);k=new (C?Uint32Array:Array)(f.length/2);if(1===b.length)return a[f.pop().index]=1,a;g=0;for(p=f.length/2;g<p;++g)b[g]=f.pop(),k[g]=b[g].value;m=Ja(k,k.length,d);g=0;for(p=b.length;g<p;++g)a[b[g].index]=m[g];return a}
                    function Ja(e,d,c){function f(a){var b=g[a][p[a]];b===d?(f(a+1),f(a+1)):--k[b];++p[a]}var a=new (C?Uint16Array:Array)(c),b=new (C?Uint8Array:Array)(c),k=new (C?Uint8Array:Array)(d),m=Array(c),g=Array(c),p=Array(c),v=(1<<c)-d,x=1<<c-1,l,h,q,t,w;a[c-1]=d;for(h=0;h<c;++h)v<x?b[h]=0:(b[h]=1,v-=x),v<<=1,a[c-2-h]=(a[c-1-h]/2|0)+d;a[0]=b[0];m[0]=Array(a[0]);g[0]=Array(a[0]);for(h=1;h<c;++h)a[h]>2*a[h-1]+b[h]&&(a[h]=2*a[h-1]+b[h]),m[h]=Array(a[h]),g[h]=Array(a[h]);for(l=0;l<d;++l)k[l]=c;for(q=0;q<a[c-1];++q)m[c-
                    1][q]=e[q],g[c-1][q]=q;for(l=0;l<c;++l)p[l]=0;1===b[c-1]&&(--k[0],++p[c-1]);for(h=c-2;0<=h;--h){t=l=0;w=p[h+1];for(q=0;q<a[h];q++)t=m[h+1][w]+m[h+1][w+1],t>e[l]?(m[h][q]=t,g[h][q]=d,w+=2):(m[h][q]=e[l],g[h][q]=l,++l);p[h]=0;1===b[h]&&f(h)}return k}
                    function pa(e){var d=new (C?Uint16Array:Array)(e.length),c=[],f=[],a=0,b,k,m,g;b=0;for(k=e.length;b<k;b++)c[e[b]]=(c[e[b]]|0)+1;b=1;for(k=16;b<=k;b++)f[b]=a,a+=c[b]|0,a<<=1;b=0;for(k=e.length;b<k;b++){a=f[e[b]];f[e[b]]+=1;m=d[b]=0;for(g=e[b];m<g;m++)d[b]=d[b]<<1|a&1,a>>>=1}return d};ba("Zlib.RawDeflate",ka);ba("Zlib.RawDeflate.prototype.compress",ka.prototype.h);var Ka={NONE:0,FIXED:1,DYNAMIC:ma},V,La,$,Ma;if(Object.keys)V=Object.keys(Ka);else for(La in V=[],$=0,Ka)V[$++]=La;$=0;for(Ma=V.length;$<Ma;++$)La=V[$],ba("Zlib.RawDeflate.CompressionType."+La,Ka[La]);}).call(this); //@ sourceMappingURL=rawdeflate.min.js.map


                       }).call(context);

                       var compress = function (input) {
                          var deflate = new context.Zlib.RawDeflate(input);
                          return deflate.compress();
                       };

                       var USE_TYPEDARRAY =
                          (typeof Uint8Array !== 'undefined') &&
                          (typeof Uint16Array !== 'undefined') &&
                          (typeof Uint32Array !== 'undefined');
                       if(!JSZip.compressions["DEFLATE"]) {
                          JSZip.compressions["DEFLATE"] = {
                             magic : "\x08\x00",
                             compress : compress,
                             compressInputType : USE_TYPEDARRAY ? "uint8array" : "array"
                          }
                       } else {
                          JSZip.compressions["DEFLATE"].compress = compress;
                          JSZip.compressions["DEFLATE"].compressInputType = USE_TYPEDARRAY ? "uint8array" : "array";
                       }
                    })();
                    (function () {
                       if(!JSZip) {
                          throw "JSZip not defined";
                       }
                       var context = {};
                       (function () {

                    /** @license zlib.js 2012 - imaya [ https://github.com/imaya/zlib.js ] The MIT License */(function() {'use strict';var l=void 0,p=this;function q(c,d){var a=c.split("."),b=p;!(a[0]in b)&&b.execScript&&b.execScript("var "+a[0]);for(var e;a.length&&(e=a.shift());)!a.length&&d!==l?b[e]=d:b=b[e]?b[e]:b[e]={}};var r="undefined"!==typeof Uint8Array&&"undefined"!==typeof Uint16Array&&"undefined"!==typeof Uint32Array;function u(c){var d=c.length,a=0,b=Number.POSITIVE_INFINITY,e,f,g,h,k,m,s,n,t;for(n=0;n<d;++n)c[n]>a&&(a=c[n]),c[n]<b&&(b=c[n]);e=1<<a;f=new (r?Uint32Array:Array)(e);g=1;h=0;for(k=2;g<=a;){for(n=0;n<d;++n)if(c[n]===g){m=0;s=h;for(t=0;t<g;++t)m=m<<1|s&1,s>>=1;for(t=m;t<e;t+=k)f[t]=g<<16|n;++h}++g;h<<=1;k<<=1}return[f,a,b]};function v(c,d){this.g=[];this.h=32768;this.c=this.f=this.d=this.k=0;this.input=r?new Uint8Array(c):c;this.l=!1;this.i=w;this.p=!1;if(d||!(d={}))d.index&&(this.d=d.index),d.bufferSize&&(this.h=d.bufferSize),d.bufferType&&(this.i=d.bufferType),d.resize&&(this.p=d.resize);switch(this.i){case x:this.a=32768;this.b=new (r?Uint8Array:Array)(32768+this.h+258);break;case w:this.a=0;this.b=new (r?Uint8Array:Array)(this.h);this.e=this.u;this.m=this.r;this.j=this.s;break;default:throw Error("invalid inflate mode");
                    }}var x=0,w=1;
                    v.prototype.t=function(){for(;!this.l;){var c=y(this,3);c&1&&(this.l=!0);c>>>=1;switch(c){case 0:var d=this.input,a=this.d,b=this.b,e=this.a,f=l,g=l,h=l,k=b.length,m=l;this.c=this.f=0;f=d[a++];if(f===l)throw Error("invalid uncompressed block header: LEN (first byte)");g=f;f=d[a++];if(f===l)throw Error("invalid uncompressed block header: LEN (second byte)");g|=f<<8;f=d[a++];if(f===l)throw Error("invalid uncompressed block header: NLEN (first byte)");h=f;f=d[a++];if(f===l)throw Error("invalid uncompressed block header: NLEN (second byte)");h|=
                    f<<8;if(g===~h)throw Error("invalid uncompressed block header: length verify");if(a+g>d.length)throw Error("input buffer is broken");switch(this.i){case x:for(;e+g>b.length;){m=k-e;g-=m;if(r)b.set(d.subarray(a,a+m),e),e+=m,a+=m;else for(;m--;)b[e++]=d[a++];this.a=e;b=this.e();e=this.a}break;case w:for(;e+g>b.length;)b=this.e({o:2});break;default:throw Error("invalid inflate mode");}if(r)b.set(d.subarray(a,a+g),e),e+=g,a+=g;else for(;g--;)b[e++]=d[a++];this.d=a;this.a=e;this.b=b;break;case 1:this.j(z,
                    A);break;case 2:B(this);break;default:throw Error("unknown BTYPE: "+c);}}return this.m()};
                    var C=[16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15],D=r?new Uint16Array(C):C,E=[3,4,5,6,7,8,9,10,11,13,15,17,19,23,27,31,35,43,51,59,67,83,99,115,131,163,195,227,258,258,258],F=r?new Uint16Array(E):E,G=[0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,0,0,0],H=r?new Uint8Array(G):G,I=[1,2,3,4,5,7,9,13,17,25,33,49,65,97,129,193,257,385,513,769,1025,1537,2049,3073,4097,6145,8193,12289,16385,24577],J=r?new Uint16Array(I):I,K=[0,0,0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,
                    13],L=r?new Uint8Array(K):K,M=new (r?Uint8Array:Array)(288),N,O;N=0;for(O=M.length;N<O;++N)M[N]=143>=N?8:255>=N?9:279>=N?7:8;var z=u(M),P=new (r?Uint8Array:Array)(30),Q,R;Q=0;for(R=P.length;Q<R;++Q)P[Q]=5;var A=u(P);function y(c,d){for(var a=c.f,b=c.c,e=c.input,f=c.d,g;b<d;){g=e[f++];if(g===l)throw Error("input buffer is broken");a|=g<<b;b+=8}g=a&(1<<d)-1;c.f=a>>>d;c.c=b-d;c.d=f;return g}
                    function S(c,d){for(var a=c.f,b=c.c,e=c.input,f=c.d,g=d[0],h=d[1],k,m,s;b<h;){k=e[f++];if(k===l)break;a|=k<<b;b+=8}m=g[a&(1<<h)-1];s=m>>>16;c.f=a>>s;c.c=b-s;c.d=f;return m&65535}
                    function B(c){function d(a,c,b){var d,f,e,g;for(g=0;g<a;)switch(d=S(this,c),d){case 16:for(e=3+y(this,2);e--;)b[g++]=f;break;case 17:for(e=3+y(this,3);e--;)b[g++]=0;f=0;break;case 18:for(e=11+y(this,7);e--;)b[g++]=0;f=0;break;default:f=b[g++]=d}return b}var a=y(c,5)+257,b=y(c,5)+1,e=y(c,4)+4,f=new (r?Uint8Array:Array)(D.length),g,h,k,m;for(m=0;m<e;++m)f[D[m]]=y(c,3);g=u(f);h=new (r?Uint8Array:Array)(a);k=new (r?Uint8Array:Array)(b);c.j(u(d.call(c,a,g,h)),u(d.call(c,b,g,k)))}
                    v.prototype.j=function(c,d){var a=this.b,b=this.a;this.n=c;for(var e=a.length-258,f,g,h,k;256!==(f=S(this,c));)if(256>f)b>=e&&(this.a=b,a=this.e(),b=this.a),a[b++]=f;else{g=f-257;k=F[g];0<H[g]&&(k+=y(this,H[g]));f=S(this,d);h=J[f];0<L[f]&&(h+=y(this,L[f]));b>=e&&(this.a=b,a=this.e(),b=this.a);for(;k--;)a[b]=a[b++-h]}for(;8<=this.c;)this.c-=8,this.d--;this.a=b};
                    v.prototype.s=function(c,d){var a=this.b,b=this.a;this.n=c;for(var e=a.length,f,g,h,k;256!==(f=S(this,c));)if(256>f)b>=e&&(a=this.e(),e=a.length),a[b++]=f;else{g=f-257;k=F[g];0<H[g]&&(k+=y(this,H[g]));f=S(this,d);h=J[f];0<L[f]&&(h+=y(this,L[f]));b+k>e&&(a=this.e(),e=a.length);for(;k--;)a[b]=a[b++-h]}for(;8<=this.c;)this.c-=8,this.d--;this.a=b};
                    v.prototype.e=function(){var c=new (r?Uint8Array:Array)(this.a-32768),d=this.a-32768,a,b,e=this.b;if(r)c.set(e.subarray(32768,c.length));else{a=0;for(b=c.length;a<b;++a)c[a]=e[a+32768]}this.g.push(c);this.k+=c.length;if(r)e.set(e.subarray(d,d+32768));else for(a=0;32768>a;++a)e[a]=e[d+a];this.a=32768;return e};
                    v.prototype.u=function(c){var d,a=this.input.length/this.d+1|0,b,e,f,g=this.input,h=this.b;c&&("number"===typeof c.o&&(a=c.o),"number"===typeof c.q&&(a+=c.q));2>a?(b=(g.length-this.d)/this.n[2],f=258*(b/2)|0,e=f<h.length?h.length+f:h.length<<1):e=h.length*a;r?(d=new Uint8Array(e),d.set(h)):d=h;return this.b=d};
                    v.prototype.m=function(){var c=0,d=this.b,a=this.g,b,e=new (r?Uint8Array:Array)(this.k+(this.a-32768)),f,g,h,k;if(0===a.length)return r?this.b.subarray(32768,this.a):this.b.slice(32768,this.a);f=0;for(g=a.length;f<g;++f){b=a[f];h=0;for(k=b.length;h<k;++h)e[c++]=b[h]}f=32768;for(g=this.a;f<g;++f)e[c++]=d[f];this.g=[];return this.buffer=e};
                    v.prototype.r=function(){var c,d=this.a;r?this.p?(c=new Uint8Array(d),c.set(this.b.subarray(0,d))):c=this.b.subarray(0,d):(this.b.length>d&&(this.b.length=d),c=this.b);return this.buffer=c};q("Zlib.RawInflate",v);q("Zlib.RawInflate.prototype.decompress",v.prototype.t);var T={ADAPTIVE:w,BLOCK:x},U,V,W,X;if(Object.keys)U=Object.keys(T);else for(V in U=[],W=0,T)U[W++]=V;W=0;for(X=U.length;W<X;++W)V=U[W],q("Zlib.RawInflate.BufferType."+V,T[V]);}).call(this); //@ sourceMappingURL=rawinflate.min.js.map


                       }).call(context);

                       var uncompress = function (input) {
                          var inflate = new context.Zlib.RawInflate(input);
                          return inflate.decompress();
                       };

                       var USE_TYPEDARRAY =
                          (typeof Uint8Array !== 'undefined') &&
                          (typeof Uint16Array !== 'undefined') &&
                          (typeof Uint32Array !== 'undefined');


                       // we add the compression method for JSZip
                       if(!JSZip.compressions["DEFLATE"]) {
                          JSZip.compressions["DEFLATE"] = {
                             magic : "\x08\x00",
                             uncompress : uncompress,
                             uncompressInputType : USE_TYPEDARRAY ? "uint8array" : "array"
                          }
                       } else {
                          JSZip.compressions["DEFLATE"].uncompress = uncompress;
                          JSZip.compressions["DEFLATE"].uncompressInputType = USE_TYPEDARRAY ? "uint8array" : "array";
                       }
                    })();
                    (function (root) {

                       var JSZip = root.JSZip;

                       var MAX_VALUE_16BITS = 65535;
                       var MAX_VALUE_32BITS = -1; // well, "\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF" is parsed as -1

                       /**
                        * Prettify a string read as binary.
                        * @param {string} str the string to prettify.
                        * @return {string} a pretty string.
                        */
                       var pretty = function (str) {
                          var res = '', code, i;
                          for (i = 0; i < (str||"").length; i++) {
                             code = str.charCodeAt(i);
                             res += '\\x' + (code < 16 ? "0" : "") + code.toString(16).toUpperCase();
                          }
                          return res;
                       };

                       /**
                        * Find a compression registered in JSZip.
                        * @param {string} compressionMethod the method magic to find.
                        * @return {Object|null} the JSZip compression object, null if none found.
                        */
                       var findCompression = function (compressionMethod) {
                          for (var method in JSZip.compressions) {
                             if( !JSZip.compressions.hasOwnProperty(method) ) { continue; }
                             if (JSZip.compressions[method].magic === compressionMethod) {
                                return JSZip.compressions[method];
                             }
                          }
                          return null;
                       };

                       // class DataReader {{{
                       /**
                        * Read bytes from a source.
                        * Developer tip : when debugging, a watch on pretty(this.reader.data.slice(this.reader.index))
                        * is very useful :)
                        * @constructor
                        * @param {String|ArrayBuffer|Uint8Array|Buffer} data the data to read.
                        */
                       function DataReader(data) {
                          this.data = null; // type : see implementation
                          this.length = 0;
                          this.index = 0;
                       }
                       DataReader.prototype = {
                          /**
                           * Check that the offset will not go too far.
                           * @param {string} offset the additional offset to check.
                           * @throws {Error} an Error if the offset is out of bounds.
                           */
                          checkOffset : function (offset) {
                             this.checkIndex(this.index + offset);
                          },
                          /**
                           * Check that the specifed index will not be too far.
                           * @param {string} newIndex the index to check.
                           * @throws {Error} an Error if the index is out of bounds.
                           */
                          checkIndex : function (newIndex) {
                             if (this.length < newIndex || newIndex < 0) {
                                throw new Error("End of data reached (data length = " +
                                                this.length + ", asked index = " +
                                                (newIndex) + "). Corrupted zip ?");
                             }
                          },
                          /**
                           * Change the index.
                           * @param {number} newIndex The new index.
                           * @throws {Error} if the new index is out of the data.
                           */
                          setIndex : function (newIndex) {
                             this.checkIndex(newIndex);
                             this.index = newIndex;
                          },
                          /**
                           * Skip the next n bytes.
                           * @param {number} n the number of bytes to skip.
                           * @throws {Error} if the new index is out of the data.
                           */
                          skip : function (n) {
                             this.setIndex(this.index + n);
                          },
                          /**
                           * Get the byte at the specified index.
                           * @param {number} i the index to use.
                           * @return {number} a byte.
                           */
                          byteAt : function(i) {
                             // see implementations
                          },
                          /**
                           * Get the next number with a given byte size.
                           * @param {number} size the number of bytes to read.
                           * @return {number} the corresponding number.
                           */
                          readInt : function (size) {
                             var result = 0, i;
                             this.checkOffset(size);
                             for(i = this.index + size - 1; i >= this.index; i--) {
                                result = (result << 8) + this.byteAt(i);
                             }
                             this.index += size;
                             return result;
                          },
                          /**
                           * Get the next string with a given byte size.
                           * @param {number} size the number of bytes to read.
                           * @return {string} the corresponding string.
                           */
                          readString : function (size) {
                             return JSZip.utils.transformTo("string", this.readData(size));
                          },
                          /**
                           * Get raw data without conversion, <size> bytes.
                           * @param {number} size the number of bytes to read.
                           * @return {Object} the raw data, implementation specific.
                           */
                          readData : function (size) {
                             // see implementations
                          },
                          /**
                           * Find the last occurence of a zip signature (4 bytes).
                           * @param {string} sig the signature to find.
                           * @return {number} the index of the last occurence, -1 if not found.
                           */
                          lastIndexOfSignature : function (sig) {
                             // see implementations
                          },
                          /**
                           * Get the next date.
                           * @return {Date} the date.
                           */
                          readDate : function () {
                             var dostime = this.readInt(4);
                             return new Date(
                                ((dostime >> 25) & 0x7f) + 1980, // year
                                ((dostime >> 21) & 0x0f) - 1, // month
                                (dostime >> 16) & 0x1f, // day
                                (dostime >> 11) & 0x1f, // hour
                                (dostime >> 5) & 0x3f, // minute
                                (dostime & 0x1f) << 1); // second
                          }
                       };


                       /**
                        * Read bytes from a string.
                        * @constructor
                        * @param {String} data the data to read.
                        */
                       function StringReader(data, optimizedBinaryString) {
                          this.data = data;
                          if (!optimizedBinaryString) {
                             this.data = JSZip.utils.string2binary(this.data);
                          }
                          this.length = this.data.length;
                          this.index = 0;
                       }
                       StringReader.prototype = new DataReader();
                       /**
                        * @see DataReader.byteAt
                        */
                       StringReader.prototype.byteAt = function(i) {
                          return this.data.charCodeAt(i);
                       };
                       /**
                        * @see DataReader.lastIndexOfSignature
                        */
                       StringReader.prototype.lastIndexOfSignature = function (sig) {
                          return this.data.lastIndexOf(sig);
                       };
                       /**
                        * @see DataReader.readData
                        */
                       StringReader.prototype.readData = function (size) {
                          this.checkOffset(size);
                          // this will work because the constructor applied the "& 0xff" mask.
                          var result = this.data.slice(this.index, this.index + size);
                          this.index += size;
                          return result;
                       };


                       /**
                        * Read bytes from an Uin8Array.
                        * @constructor
                        * @param {Uint8Array} data the data to read.
                        */
                       function Uint8ArrayReader(data) {
                          if (data) {
                             this.data = data;
                             this.length = this.data.length;
                             this.index = 0;
                          }
                       }
                       Uint8ArrayReader.prototype = new DataReader();
                       /**
                        * @see DataReader.byteAt
                        */
                       Uint8ArrayReader.prototype.byteAt = function(i) {
                          return this.data[i];
                       };
                       /**
                        * @see DataReader.lastIndexOfSignature
                        */
                       Uint8ArrayReader.prototype.lastIndexOfSignature = function (sig) {
                          var sig0 = sig.charCodeAt(0),
                          sig1 = sig.charCodeAt(1),
                          sig2 = sig.charCodeAt(2),
                          sig3 = sig.charCodeAt(3);
                          for(var i = this.length - 4;i >= 0;--i) {
                             if (this.data[i] === sig0 && this.data[i+1] === sig1 && this.data[i+2] === sig2 && this.data[i+3] === sig3) {
                                return i;
                             }
                          }

                          return -1;
                       };
                       /**
                        * @see DataReader.readData
                        */
                       Uint8ArrayReader.prototype.readData = function (size) {
                          this.checkOffset(size);
                          var result = this.data.subarray(this.index, this.index + size);
                          this.index += size;
                          return result;
                       };

                       /**
                        * Read bytes from a Buffer.
                        * @constructor
                        * @param {Buffer} data the data to read.
                        */
                       function NodeBufferReader(data) {
                          this.data = data;
                          this.length = this.data.length;
                          this.index = 0;
                       }
                       NodeBufferReader.prototype = new Uint8ArrayReader();

                       /**
                        * @see DataReader.readData
                        */
                       NodeBufferReader.prototype.readData = function (size) {
                          this.checkOffset(size);
                          var result = this.data.slice(this.index, this.index + size);
                          this.index += size;
                          return result;
                       };
                       // }}} end of DataReader

                       // class ZipEntry {{{
                       /**
                        * An entry in the zip file.
                        * @constructor
                        * @param {Object} options Options of the current file.
                        * @param {Object} loadOptions Options for loading the data.
                        */
                       function ZipEntry(options, loadOptions) {
                          this.options = options;
                          this.loadOptions = loadOptions;
                       }
                       ZipEntry.prototype = {
                          /**
                           * say if the file is encrypted.
                           * @return {boolean} true if the file is encrypted, false otherwise.
                           */
                          isEncrypted : function () {
                             // bit 1 is set
                             return (this.bitFlag & 0x0001) === 0x0001;
                          },
                          /**
                           * say if the file has utf-8 filename/comment.
                           * @return {boolean} true if the filename/comment is in utf-8, false otherwise.
                           */
                          useUTF8 : function () {
                             // bit 11 is set
                             return (this.bitFlag & 0x0800) === 0x0800;
                          },
                          /**
                           * Prepare the function used to generate the compressed content from this ZipFile.
                           * @param {DataReader} reader the reader to use.
                           * @param {number} from the offset from where we should read the data.
                           * @param {number} length the length of the data to read.
                           * @return {Function} the callback to get the compressed content (the type depends of the DataReader class).
                           */
                          prepareCompressedContent : function (reader, from, length) {
                             return function () {
                                var previousIndex = reader.index;
                                reader.setIndex(from);
                                var compressedFileData = reader.readData(length);
                                reader.setIndex(previousIndex);

                                return compressedFileData;
                             }
                          },
                          /**
                           * Prepare the function used to generate the uncompressed content from this ZipFile.
                           * @param {DataReader} reader the reader to use.
                           * @param {number} from the offset from where we should read the data.
                           * @param {number} length the length of the data to read.
                           * @param {JSZip.compression} compression the compression used on this file.
                           * @param {number} uncompressedSize the uncompressed size to expect.
                           * @return {Function} the callback to get the uncompressed content (the type depends of the DataReader class).
                           */
                          prepareContent : function (reader, from, length, compression, uncompressedSize) {
                             return function () {

                                var compressedFileData = JSZip.utils.transformTo(compression.uncompressInputType, this.getCompressedContent());
                                var uncompressedFileData = compression.uncompress(compressedFileData);

                                if (uncompressedFileData.length !== uncompressedSize) {
                                   throw new Error("Bug : uncompressed data size mismatch");
                                }

                                return uncompressedFileData;
                             }
                          },
                          /**
                           * Read the local part of a zip file and add the info in this object.
                           * @param {DataReader} reader the reader to use.
                           */
                          readLocalPart : function(reader) {
                             var compression, localExtraFieldsLength;

                             // we already know everything from the central dir !
                             // If the central dir data are false, we are doomed.
                             // On the bright side, the local part is scary  : zip64, data descriptors, both, etc.
                             // The less data we get here, the more reliable this should be.
                             // Let's skip the whole header and dash to the data !
                             reader.skip(22);
                             // in some zip created on windows, the filename stored in the central dir contains \ instead of /.
                             // Strangely, the filename here is OK.
                             // I would love to treat these zip files as corrupted (see http://www.info-zip.org/FAQ.html#backslashes
                             // or APPNOTE#4.4.17.1, "All slashes MUST be forward slashes '/'") but there are a lot of bad zip generators...
                             // Search "unzip mismatching "local" filename continuing with "central" filename version" on
                             // the internet.
                             //
                             // I think I see the logic here : the central directory is used to display
                             // content and the local directory is used to extract the files. Mixing / and \
                             // may be used to display \ to windows users and use / when extracting the files.
                             // Unfortunately, this lead also to some issues : http://seclists.org/fulldisclosure/2009/Sep/394
                             this.fileNameLength = reader.readInt(2);
                             localExtraFieldsLength = reader.readInt(2); // can't be sure this will be the same as the central dir
                             this.fileName = reader.readString(this.fileNameLength);
                             reader.skip(localExtraFieldsLength);

                             if (this.compressedSize == -1 || this.uncompressedSize == -1) {
                                throw new Error("Bug or corrupted zip : didn't get enough informations from the central directory " +
                                                "(compressedSize == -1 || uncompressedSize == -1)");
                             }

                             compression = findCompression(this.compressionMethod);
                             if (compression === null) { // no compression found
                                throw new Error("Corrupted zip : compression " + pretty(this.compressionMethod) +
                                                " unknown (inner file : " + this.fileName + ")");
                             }
                             this.decompressed = new JSZip.CompressedObject();
                             this.decompressed.compressedSize = this.compressedSize;
                             this.decompressed.uncompressedSize = this.uncompressedSize;
                             this.decompressed.crc32 = this.crc32;
                             this.decompressed.compressionMethod = this.compressionMethod;
                             this.decompressed.getCompressedContent = this.prepareCompressedContent(reader, reader.index, this.compressedSize, compression);
                             this.decompressed.getContent = this.prepareContent(reader, reader.index, this.compressedSize, compression, this.uncompressedSize);

                             // we need to compute the crc32...
                             if (this.loadOptions.checkCRC32) {
                                this.decompressed = JSZip.utils.transformTo("string", this.decompressed.getContent());
                                if (JSZip.prototype.crc32(this.decompressed) !== this.crc32) {
                                   throw new Error("Corrupted zip : CRC32 mismatch");
                                }
                             }
                          },

                          /**
                           * Read the central part of a zip file and add the info in this object.
                           * @param {DataReader} reader the reader to use.
                           */
                          readCentralPart : function(reader) {
                             this.versionMadeBy          = reader.readString(2);
                             this.versionNeeded          = reader.readInt(2);
                             this.bitFlag                = reader.readInt(2);
                             this.compressionMethod      = reader.readString(2);
                             this.date                   = reader.readDate();
                             this.crc32                  = reader.readInt(4);
                             this.compressedSize         = reader.readInt(4);
                             this.uncompressedSize       = reader.readInt(4);
                             this.fileNameLength         = reader.readInt(2);
                             this.extraFieldsLength      = reader.readInt(2);
                             this.fileCommentLength      = reader.readInt(2);
                             this.diskNumberStart        = reader.readInt(2);
                             this.internalFileAttributes = reader.readInt(2);
                             this.externalFileAttributes = reader.readInt(4);
                             this.localHeaderOffset      = reader.readInt(4);

                             if (this.isEncrypted()) {
                                throw new Error("Encrypted zip are not supported");
                             }

                             this.fileName = reader.readString(this.fileNameLength);
                             this.readExtraFields(reader);
                             this.parseZIP64ExtraField(reader);
                             this.fileComment = reader.readString(this.fileCommentLength);

                             // warning, this is true only for zip with madeBy == DOS (plateform dependent feature)
                             this.dir = this.externalFileAttributes & 0x00000010 ? true : false;
                          },
                          /**
                           * Parse the ZIP64 extra field and merge the info in the current ZipEntry.
                           * @param {DataReader} reader the reader to use.
                           */
                          parseZIP64ExtraField : function(reader) {

                             if(!this.extraFields[0x0001]) {
                                return;
                             }

                             // should be something, preparing the extra reader
                             var extraReader = new StringReader(this.extraFields[0x0001].value);

                             // I really hope that these 64bits integer can fit in 32 bits integer, because js
                             // won't let us have more.
                             if(this.uncompressedSize === MAX_VALUE_32BITS) {
                                this.uncompressedSize = extraReader.readInt(8);
                             }
                             if(this.compressedSize === MAX_VALUE_32BITS) {
                                this.compressedSize = extraReader.readInt(8);
                             }
                             if(this.localHeaderOffset === MAX_VALUE_32BITS) {
                                this.localHeaderOffset = extraReader.readInt(8);
                             }
                             if(this.diskNumberStart === MAX_VALUE_32BITS) {
                                this.diskNumberStart = extraReader.readInt(4);
                             }
                          },
                          /**
                           * Read the central part of a zip file and add the info in this object.
                           * @param {DataReader} reader the reader to use.
                           */
                          readExtraFields : function(reader) {
                             var start = reader.index,
                                 extraFieldId,
                                 extraFieldLength,
                                 extraFieldValue;

                             this.extraFields = this.extraFields || {};

                             while (reader.index < start + this.extraFieldsLength) {
                                extraFieldId     = reader.readInt(2);
                                extraFieldLength = reader.readInt(2);
                                extraFieldValue  = reader.readString(extraFieldLength);

                                this.extraFields[extraFieldId] = {
                                   id:     extraFieldId,
                                   length: extraFieldLength,
                                   value:  extraFieldValue
                                };
                             }
                          },
                          /**
                           * Apply an UTF8 transformation if needed.
                           */
                          handleUTF8 : function() {
                             if (this.useUTF8()) {
                                this.fileName    = JSZip.prototype.utf8decode(this.fileName);
                                this.fileComment = JSZip.prototype.utf8decode(this.fileComment);
                             }
                          }
                       };
                       // }}} end of ZipEntry

                       //  class ZipEntries {{{
                       /**
                        * All the entries in the zip file.
                        * @constructor
                        * @param {String|ArrayBuffer|Uint8Array|Buffer} data the binary data to load.
                        * @param {Object} loadOptions Options for loading the data.
                        */
                       function ZipEntries(data, loadOptions) {
                          this.files = [];
                          this.loadOptions = loadOptions;
                          if (data) {
                             this.load(data);
                          }
                       }
                       ZipEntries.prototype = {
                          /**
                           * Check that the reader is on the speficied signature.
                           * @param {string} expectedSignature the expected signature.
                           * @throws {Error} if it is an other signature.
                           */
                          checkSignature : function(expectedSignature) {
                             var signature = this.reader.readString(4);
                             if (signature !== expectedSignature) {
                                throw new Error("Corrupted zip or bug : unexpected signature " +
                                                "(" + pretty(signature) + ", expected " + pretty(expectedSignature) + ")");
                             }
                          },
                          /**
                           * Read the end of the central directory.
                           */
                          readBlockEndOfCentral : function () {
                             this.diskNumber                  = this.reader.readInt(2);
                             this.diskWithCentralDirStart     = this.reader.readInt(2);
                             this.centralDirRecordsOnThisDisk = this.reader.readInt(2);
                             this.centralDirRecords           = this.reader.readInt(2);
                             this.centralDirSize              = this.reader.readInt(4);
                             this.centralDirOffset            = this.reader.readInt(4);

                             this.zipCommentLength            = this.reader.readInt(2);
                             this.zipComment                  = this.reader.readString(this.zipCommentLength);
                          },
                          /**
                           * Read the end of the Zip 64 central directory.
                           * Not merged with the method readEndOfCentral :
                           * The end of central can coexist with its Zip64 brother,
                           * I don't want to read the wrong number of bytes !
                           */
                          readBlockZip64EndOfCentral : function () {
                             this.zip64EndOfCentralSize       = this.reader.readInt(8);
                             this.versionMadeBy               = this.reader.readString(2);
                             this.versionNeeded               = this.reader.readInt(2);
                             this.diskNumber                  = this.reader.readInt(4);
                             this.diskWithCentralDirStart     = this.reader.readInt(4);
                             this.centralDirRecordsOnThisDisk = this.reader.readInt(8);
                             this.centralDirRecords           = this.reader.readInt(8);
                             this.centralDirSize              = this.reader.readInt(8);
                             this.centralDirOffset            = this.reader.readInt(8);

                             this.zip64ExtensibleData = {};
                             var extraDataSize = this.zip64EndOfCentralSize - 44,
                             index = 0,
                             extraFieldId,
                             extraFieldLength,
                             extraFieldValue;
                             while(index < extraDataSize) {
                                extraFieldId     = this.reader.readInt(2);
                                extraFieldLength = this.reader.readInt(4);
                                extraFieldValue  = this.reader.readString(extraFieldLength);
                                this.zip64ExtensibleData[extraFieldId] = {
                                   id:     extraFieldId,
                                   length: extraFieldLength,
                                   value:  extraFieldValue
                                };
                             }
                          },
                          /**
                           * Read the end of the Zip 64 central directory locator.
                           */
                          readBlockZip64EndOfCentralLocator : function () {
                             this.diskWithZip64CentralDirStart       = this.reader.readInt(4);
                             this.relativeOffsetEndOfZip64CentralDir = this.reader.readInt(8);
                             this.disksCount                         = this.reader.readInt(4);
                             if (this.disksCount > 1) {
                                throw new Error("Multi-volumes zip are not supported");
                             }
                          },
                          /**
                           * Read the local files, based on the offset read in the central part.
                           */
                          readLocalFiles : function() {
                             var i, file;
                             for(i = 0; i < this.files.length; i++) {
                                file = this.files[i];
                                this.reader.setIndex(file.localHeaderOffset);
                                this.checkSignature(JSZip.signature.LOCAL_FILE_HEADER);
                                file.readLocalPart(this.reader);
                                file.handleUTF8();
                             }
                          },
                          /**
                           * Read the central directory.
                           */
                          readCentralDir : function() {
                             var file;

                             this.reader.setIndex(this.centralDirOffset);
                             while(this.reader.readString(4) === JSZip.signature.CENTRAL_FILE_HEADER) {
                                file = new ZipEntry({
                                   zip64: this.zip64
                                }, this.loadOptions);
                                file.readCentralPart(this.reader);
                                this.files.push(file);
                             }
                          },
                          /**
                           * Read the end of central directory.
                           */
                          readEndOfCentral : function() {
                             var offset = this.reader.lastIndexOfSignature(JSZip.signature.CENTRAL_DIRECTORY_END);
                             if (offset === -1) {
                                throw new Error("Corrupted zip : can't find end of central directory");
                             }
                             this.reader.setIndex(offset);
                             this.checkSignature(JSZip.signature.CENTRAL_DIRECTORY_END);
                             this.readBlockEndOfCentral();


                             /* extract from the zip spec :
                                4)  If one of the fields in the end of central directory
                                    record is too small to hold required data, the field
                                    should be set to -1 (0xFFFF or 0xFFFFFFFF) and the
                                    ZIP64 format record should be created.
                                5)  The end of central directory record and the
                                    Zip64 end of central directory locator record must
                                    reside on the same disk when splitting or spanning
                                    an archive.
                             */
                             if (  this.diskNumber                  === MAX_VALUE_16BITS
                                || this.diskWithCentralDirStart     === MAX_VALUE_16BITS
                                || this.centralDirRecordsOnThisDisk === MAX_VALUE_16BITS
                                || this.centralDirRecords           === MAX_VALUE_16BITS
                                || this.centralDirSize              === MAX_VALUE_32BITS
                                || this.centralDirOffset            === MAX_VALUE_32BITS
                             ) {
                                this.zip64 = true;

                                /*
                                Warning : the zip64 extension is supported, but ONLY if the 64bits integer read from
                                the zip file can fit into a 32bits integer. This cannot be solved : Javascript represents
                                all numbers as 64-bit double precision IEEE 754 floating point numbers.
                                So, we have 53bits for integers and bitwise operations treat everything as 32bits.
                                see https://developer.mozilla.org/en-US/docs/JavaScript/Reference/Operators/Bitwise_Operators
                                and http://www.ecma-international.org/publications/files/ECMA-ST/ECMA-262.pdf section 8.5
                                */

                                // should look for a zip64 EOCD locator
                                offset = this.reader.lastIndexOfSignature(JSZip.signature.ZIP64_CENTRAL_DIRECTORY_LOCATOR);
                                if (offset === -1) {
                                   throw new Error("Corrupted zip : can't find the ZIP64 end of central directory locator");
                                }
                                this.reader.setIndex(offset);
                                this.checkSignature(JSZip.signature.ZIP64_CENTRAL_DIRECTORY_LOCATOR);
                                this.readBlockZip64EndOfCentralLocator();

                                // now the zip64 EOCD record
                                this.reader.setIndex(this.relativeOffsetEndOfZip64CentralDir);
                                this.checkSignature(JSZip.signature.ZIP64_CENTRAL_DIRECTORY_END);
                                this.readBlockZip64EndOfCentral();
                             }
                          },
                          prepareReader : function (data) {
                             var type = JSZip.utils.getTypeOf(data);
                             if (type === "string" && !JSZip.support.uint8array) {
                                this.reader = new StringReader(data, this.loadOptions.optimizedBinaryString);
                             } else if (type === "nodebuffer") {
                                this.reader = new NodeBufferReader(data);
                             } else {
                                this.reader = new Uint8ArrayReader(JSZip.utils.transformTo("uint8array", data));
                             }
                          },
                          /**
                           * Read a zip file and create ZipEntries.
                           * @param {String|ArrayBuffer|Uint8Array|Buffer} data the binary string representing a zip file.
                           */
                          load : function(data) {
                             this.prepareReader(data);
                             this.readEndOfCentral();
                             this.readCentralDir();
                             this.readLocalFiles();
                          }
                       };
                       // }}} end of ZipEntries

                       /**
                        * Implementation of the load method of JSZip.
                        * It uses the above classes to decode a zip file, and load every files.
                        * @param {String|ArrayBuffer|Uint8Array|Buffer} data the data to load.
                        * @param {Object} options Options for loading the data.
                        *  options.base64 : is the data in base64 ? default : false
                        */
                       JSZip.prototype.load = function(data, options) {
                          var files, zipEntries, i, input;
                          options = options || {};
                          if(options.base64) {
                             data = JSZip.base64.decode(data);
                          }

                          zipEntries = new ZipEntries(data, options);
                          files = zipEntries.files;
                          for (i = 0; i < files.length; i++) {
                             input = files[i];
                             this.file(input.fileName, input.decompressed, {
                                binary:true,
                                optimizedBinaryString:true,
                                date:input.date,
                                dir:input.dir
                             });
                          }

                          return this;
                       };

                    }(window));
                    window.TextEncoder = null;
                    function xlsx(file) { 
                        'use strict'; // v2.3.0

                        var defaultFontName = 'Calibri';
                        var defaultFontSize = 11;

                        var result, zip = new JSZip(), zipTime, processTime, s, f, i, j, k, l, t, w, sharedStrings, styles, index, data, val, style, borders, border, borderIndex, fonts, font, fontIndex,
                            docProps, xl, xlWorksheets, worksheet, contentTypes = [[], []], props = [], xlRels = [], worksheets = [], id, columns, cols, colWidth, cell, row, merges, merged,
                            numFmts = ['General', '0', '0.00', '#,##0', '#,##0.00',,,,, '0%', '0.00%', '0.00E+00', '# ?/?', '# ??/??', 'mm-dd-yy', 'd-mmm-yy', 'd-mmm', 'mmm-yy', 'h:mm AM/PM', 'h:mm:ss AM/PM',
                                'h:mm', 'h:mm:ss', 'm/d/yy h:mm',,,,,,,,,,,,,,, '#,##0 ;(#,##0)', '#,##0 ;[Red](#,##0)', '#,##0.00;(#,##0.00)', '#,##0.00;[Red](#,##0.00)',,,,, 'mm:ss', '[h]:mm:ss', 'mmss.0', '##0.0E+0', '@'],
                            alphabet = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';

                        function numAlpha(i) { 
                            var t = Math.floor(i / 26) - 1; return (t > -1 ? numAlpha(t) : '') + alphabet.charAt(i % 26); 
                        }

                        function alphaNum(s) { 
                            var t = 0; if (s.length === 2) { t = alphaNum(s.charAt(0)) + 1; } return t * 26 + alphabet.indexOf(s.substr(-1)); 
                        }

                        function convertDate(input) { 
                            return typeof input === 'object' ? ((input - new Date(1900, 0, 0)) / 86400000) + 1 : new Date(+new Date(1900, 0, 0) + (input - 1) * 86400000); 
                        }

                        function typeOf(obj) {
                            return ({}).toString.call(obj).match(/\s([a-zA-Z]+)/)[1].toLowerCase();
                        }
                        
                        function getAttr(s, n) { 
                            s = s.substr(s.indexOf(n + '="') + n.length + 2); return s.substring(0, s.indexOf('"')); 
                        }
                        
                        function escapeXML(s) { 
                            return (s || '').replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/"/g, '&quot;').replace(/'/g, '&#x27;'); 
                        } // see http://www.w3.org/TR/xml/#syntax
                        
                        function unescapeXML(s) { 
                            return (s || '').replace(/&amp;/g, '&').replace(/&lt;/g, '<').replace(/&gt;/g, '>').replace(/&quot;/g, '"').replace(/&#x27;/g, '\''); 
                        }
                        
                        function filterXML(s){
                            var rs = "";
                            for(var i=0;i<s.length;i++){
                                if((0<=s.charCodeAt(i)&&8>=s.charCodeAt(i))||(11<=s.charCodeAt(i)&&12>=s.charCodeAt(i))||(14<=s.charCodeAt(i)&&31>=s.charCodeAt(i))||(127==s.charCodeAt(i))) rs += "";
                                else rs+=s.charAt(i);
                            }
                            return rs;
                        }

                       if (typeof file === 'string') { 
                        // Load
                            zipTime = Date.now();
                            zip = zip.load(file, { base64: true });
                            result = { worksheets: [], zipTime: Date.now() - zipTime };
                            processTime = Date.now();

                            // Process sharedStrings
                            sharedStrings = []; s = zip.file('xl/sharedStrings.xml');
                            if (s) {
                                s = s.asText().split(/<t.*?>/g); i = s.length;
                                while(--i) { sharedStrings[i - 1] = unescapeXML(s[i].substring(0, s[i].indexOf('</t>'))); } // Do not process i === 0, because s[0] is the text before first t element
                            }

                            // Get file info from "docProps/core.xml"
                            s = zip.file('docProps/core.xml').asText();
                            s = s.substr(s.indexOf('<dc:creator>') + 12);
                            result.creator = s.substring(0, s.indexOf('</dc:creator>'));
                            s = s.substr(s.indexOf('<cp:lastModifiedBy>') + 19);
                            result.lastModifiedBy = s.substring(0, s.indexOf('</cp:lastModifiedBy>'));
                            s = s.substr(s.indexOf('<dcterms:created xsi:type="dcterms:W3CDTF">') + 43);
                            result.created = new Date(s.substring(0, s.indexOf('</dcterms:created>')));
                            s = s.substr(s.indexOf('<dcterms:modified xsi:type="dcterms:W3CDTF">') + 44);
                            result.modified = new Date(s.substring(0, s.indexOf('</dcterms:modified>')));

                            // Get workbook info from "xl/workbook.xml" - Worksheet names exist in other places, but "activeTab" attribute must be gathered from this file anyway
                            s = zip.file('xl/workbook.xml').asText(); index = s.indexOf('activeTab="');
                            if (index > 0) {
                                s = s.substr(index + 11); 
                                // Must eliminate first 11 characters before finding the index of " on the next line. Otherwise, it finds the " before the value.
                                result.activeWorksheet = +s.substring(0, s.indexOf('"'));
                            } else { 
                                result.activeWorksheet = 0; 
                            }
                            s = s.split('<sheet '); i = s.length;
                            while (--i) { // Do not process i === 0, because s[0] is the text before the first sheet element
                                id = s[i].substr(s[i].indexOf('name="') + 6);
                                result.worksheets.unshift({ name: id.substring(0, id.indexOf('"')), data: [] });
                            }

                            // Get style info from "xl/styles.xml"
                            styles = [];
                            s = zip.file('xl/styles.xml').asText().split('<numFmt '); i = s.length;
                            while (--i) { 
                                t = s[i]; numFmts[+getAttr(t, 'numFmtId')] = getAttr(t, 'formatCode'); 
                            }
                            s = s[s.length - 1]; s = s.substr(s.indexOf('cellXfs')).split('<xf '); i = s.length;
                            while (--i) {
                                id = getAttr(s[i], 'numFmtId'); f = numFmts[id];
                                if (f.indexOf('m') > -1) {
                                    t = 'date'; 
                                } else if (f.indexOf('0') > -1) { 
                                    t = 'number'; 
                                } else if (f === '@') { 
                                    t = 'string'; 
                                } else { 
                                    t = 'unknown'; 
                                }
                                styles.unshift({ formatCode: f, type: t });
                            }

                            // Get worksheet info from "xl/worksheets/sheetX.xml"
                            i = result.worksheets.length;
                            while (i--) {
                                s = zip.file('xl/worksheets/sheet' + (i + 1) + '.xml' ).asText().split('<row ');
                                w = result.worksheets[i];
                                w.table = s[0].indexOf('<tableParts ') > 0;
                                t = getAttr(s[0].substr(s[0].indexOf('<dimension')), 'ref');
                                t = t.substr(t.indexOf(':') + 1);
                                w.maxCol = alphaNum(t.match(/[a-zA-Z]*/g)[0]) + 1;
                                w.maxRow = +t.match(/\d*/g).join('');
                                w = w.data;
                                j = s.length;
                                while (--j) { // Don't process j === 0, because s[0] is the text before the first row element
                                    row = w[+getAttr(s[j], 'r') - 1] = [];
                                    columns = s[j].split('<c ');
                                    k = columns.length;
                                    while (--k) { // Don't process l === 0, because k[0] is the text before the first c (cell) element
                                        cell = columns[k];
                                        f = styles[+getAttr(cell, 's')] || { type: 'General', formatCode: 'General' };
                                        t = getAttr(cell, 't') || f.type;
                                        val = cell.substring(cell.indexOf('<v>') + 3, cell.indexOf('</v>'));
                                        val = val ? +val : ''; // turn non-zero into number
                                        switch (t) {
                                            case 's': val = sharedStrings[val]; break;
                                            case 'b': val = val === 1; break;
                                            case 'date': val = convertDate(val); break;
                                        }
                                        row[alphaNum(getAttr(cell, 'r').match(/[a-zA-Z]*/g)[0])] = { value: val, formatCode: f.formatCode };
                                    }
                                }
                            }

                            result.processTime = Date.now() - processTime;

                        } else {
                            // Save
                            processTime = Date.now();
                            sharedStrings = [[], 0];
                            // Fully static
                            zip.folder('_rels').file('.rels', '<?xml version="1.0" encoding="UTF-8" standalone="yes"?><Relationships xmlns="http://schemas.openxmlformats.org/package/2006/relationships"><Relationship Id="rId3" Type="http://schemas.openxmlformats.org/officeDocument/2006/relationships/extended-properties" Target="docProps/app.xml"/><Relationship Id="rId2" Type="http://schemas.openxmlformats.org/package/2006/relationships/metadata/core-properties" Target="docProps/core.xml"/><Relationship Id="rId1" Type="http://schemas.openxmlformats.org/officeDocument/2006/relationships/officeDocument" Target="xl/workbook.xml"/></Relationships>');
                            docProps = zip.folder('docProps');

                            xl = zip.folder('xl');
                            xl.folder('theme').file('theme1.xml', '<?xml version="1.0" encoding="UTF-8" standalone="yes"?><a:theme xmlns:a="http://schemas.openxmlformats.org/drawingml/2006/main" name="Office Theme"><a:themeElements><a:clrScheme name="Office"><a:dk1><a:sysClr val="windowText" lastClr="000000"/></a:dk1><a:lt1><a:sysClr val="window" lastClr="FFFFFF"/></a:lt1><a:dk2><a:srgbClr val="1F497D"/></a:dk2><a:lt2><a:srgbClr val="EEECE1"/></a:lt2><a:accent1><a:srgbClr val="4F81BD"/></a:accent1><a:accent2><a:srgbClr val="C0504D"/></a:accent2><a:accent3><a:srgbClr val="9BBB59"/></a:accent3><a:accent4><a:srgbClr val="8064A2"/></a:accent4><a:accent5><a:srgbClr val="4BACC6"/></a:accent5><a:accent6><a:srgbClr val="F79646"/></a:accent6><a:hlink><a:srgbClr val="0000FF"/></a:hlink><a:folHlink><a:srgbClr val="800080"/></a:folHlink></a:clrScheme><a:fontScheme name="Office"><a:majorFont><a:latin typeface="Cambria"/><a:ea typeface=""/><a:cs typeface=""/><a:font script="Jpan" typeface="MS P????"/><a:font script="Hang" typeface="?? ??"/><a:font script="Hans" typeface="??"/><a:font script="Hant" typeface="????"/><a:font script="Arab" typeface="Times New Roman"/><a:font script="Hebr" typeface="Times New Roman"/><a:font script="Thai" typeface="Tahoma"/><a:font script="Ethi" typeface="Nyala"/><a:font script="Beng" typeface="Vrinda"/><a:font script="Gujr" typeface="Shruti"/><a:font script="Khmr" typeface="MoolBoran"/><a:font script="Knda" typeface="Tunga"/><a:font script="Guru" typeface="Raavi"/><a:font script="Cans" typeface="Euphemia"/><a:font script="Cher" typeface="Plantagenet Cherokee"/><a:font script="Yiii" typeface="Microsoft Yi Baiti"/><a:font script="Tibt" typeface="Microsoft Himalaya"/><a:font script="Thaa" typeface="MV Boli"/><a:font script="Deva" typeface="Mangal"/><a:font script="Telu" typeface="Gautami"/><a:font script="Taml" typeface="Latha"/><a:font script="Syrc" typeface="Estrangelo Edessa"/><a:font script="Orya" typeface="Kalinga"/><a:font script="Mlym" typeface="Kartika"/><a:font script="Laoo" typeface="DokChampa"/><a:font script="Sinh" typeface="Iskoola Pota"/><a:font script="Mong" typeface="Mongolian Baiti"/><a:font script="Viet" typeface="Times New Roman"/><a:font script="Uigh" typeface="Microsoft Uighur"/><a:font script="Geor" typeface="Sylfaen"/></a:majorFont><a:minorFont><a:latin typeface="Calibri"/><a:ea typeface=""/><a:cs typeface=""/><a:font script="Jpan" typeface="MS P????"/><a:font script="Hang" typeface="?? ??"/><a:font script="Hans" typeface="??"/><a:font script="Hant" typeface="????"/><a:font script="Arab" typeface="Arial"/><a:font script="Hebr" typeface="Arial"/><a:font script="Thai" typeface="Tahoma"/><a:font script="Ethi" typeface="Nyala"/><a:font script="Beng" typeface="Vrinda"/><a:font script="Gujr" typeface="Shruti"/><a:font script="Khmr" typeface="DaunPenh"/><a:font script="Knda" typeface="Tunga"/><a:font script="Guru" typeface="Raavi"/><a:font script="Cans" typeface="Euphemia"/><a:font script="Cher" typeface="Plantagenet Cherokee"/><a:font script="Yiii" typeface="Microsoft Yi Baiti"/><a:font script="Tibt" typeface="Microsoft Himalaya"/><a:font script="Thaa" typeface="MV Boli"/><a:font script="Deva" typeface="Mangal"/><a:font script="Telu" typeface="Gautami"/><a:font script="Taml" typeface="Latha"/><a:font script="Syrc" typeface="Estrangelo Edessa"/><a:font script="Orya" typeface="Kalinga"/><a:font script="Mlym" typeface="Kartika"/><a:font script="Laoo" typeface="DokChampa"/><a:font script="Sinh" typeface="Iskoola Pota"/><a:font script="Mong" typeface="Mongolian Baiti"/><a:font script="Viet" typeface="Arial"/><a:font script="Uigh" typeface="Microsoft Uighur"/><a:font script="Geor" typeface="Sylfaen"/></a:minorFont></a:fontScheme><a:fmtScheme name="Office"><a:fillStyleLst><a:solidFill><a:schemeClr val="phClr"/></a:solidFill><a:gradFill rotWithShape="1"><a:gsLst><a:gs pos="0"><a:schemeClr val="phClr"><a:tint val="50000"/><a:satMod val="300000"/></a:schemeClr></a:gs><a:gs pos="35000"><a:schemeClr val="phClr"><a:tint val="37000"/><a:satMod val="300000"/></a:schemeClr></a:gs><a:gs pos="100000"><a:schemeClr val="phClr"><a:tint val="15000"/><a:satMod val="350000"/></a:schemeClr></a:gs></a:gsLst><a:lin ang="16200000" scaled="1"/></a:gradFill><a:gradFill rotWithShape="1"><a:gsLst><a:gs pos="0"><a:schemeClr val="phClr"><a:shade val="51000"/><a:satMod val="130000"/></a:schemeClr></a:gs><a:gs pos="80000"><a:schemeClr val="phClr"><a:shade val="93000"/><a:satMod val="130000"/></a:schemeClr></a:gs><a:gs pos="100000"><a:schemeClr val="phClr"><a:shade val="94000"/><a:satMod val="135000"/></a:schemeClr></a:gs></a:gsLst><a:lin ang="16200000" scaled="0"/></a:gradFill></a:fillStyleLst><a:lnStyleLst><a:ln w="9525" cap="flat" cmpd="sng" algn="ctr"><a:solidFill><a:schemeClr val="phClr"><a:shade val="95000"/><a:satMod val="105000"/></a:schemeClr></a:solidFill><a:prstDash val="solid"/></a:ln><a:ln w="25400" cap="flat" cmpd="sng" algn="ctr"><a:solidFill><a:schemeClr val="phClr"/></a:solidFill><a:prstDash val="solid"/></a:ln><a:ln w="38100" cap="flat" cmpd="sng" algn="ctr"><a:solidFill><a:schemeClr val="phClr"/></a:solidFill><a:prstDash val="solid"/></a:ln></a:lnStyleLst><a:effectStyleLst><a:effectStyle><a:effectLst><a:outerShdw blurRad="40000" dist="20000" dir="5400000" rotWithShape="0"><a:srgbClr val="000000"><a:alpha val="38000"/></a:srgbClr></a:outerShdw></a:effectLst></a:effectStyle><a:effectStyle><a:effectLst><a:outerShdw blurRad="40000" dist="23000" dir="5400000" rotWithShape="0"><a:srgbClr val="000000"><a:alpha val="35000"/></a:srgbClr></a:outerShdw></a:effectLst></a:effectStyle><a:effectStyle><a:effectLst><a:outerShdw blurRad="40000" dist="23000" dir="5400000" rotWithShape="0"><a:srgbClr val="000000"><a:alpha val="35000"/></a:srgbClr></a:outerShdw></a:effectLst><a:scene3d><a:camera prst="orthographicFront"><a:rot lat="0" lon="0" rev="0"/></a:camera><a:lightRig rig="threePt" dir="t"><a:rot lat="0" lon="0" rev="1200000"/></a:lightRig></a:scene3d><a:sp3d><a:bevelT w="63500" h="25400"/></a:sp3d></a:effectStyle></a:effectStyleLst><a:bgFillStyleLst><a:solidFill><a:schemeClr val="phClr"/></a:solidFill><a:gradFill rotWithShape="1"><a:gsLst><a:gs pos="0"><a:schemeClr val="phClr"><a:tint val="40000"/><a:satMod val="350000"/></a:schemeClr></a:gs><a:gs pos="40000"><a:schemeClr val="phClr"><a:tint val="45000"/><a:shade val="99000"/><a:satMod val="350000"/></a:schemeClr></a:gs><a:gs pos="100000"><a:schemeClr val="phClr"><a:shade val="20000"/><a:satMod val="255000"/></a:schemeClr></a:gs></a:gsLst><a:path path="circle"><a:fillToRect l="50000" t="-80000" r="50000" b="180000"/></a:path></a:gradFill><a:gradFill rotWithShape="1"><a:gsLst><a:gs pos="0"><a:schemeClr val="phClr"><a:tint val="80000"/><a:satMod val="300000"/></a:schemeClr></a:gs><a:gs pos="100000"><a:schemeClr val="phClr"><a:shade val="30000"/><a:satMod val="200000"/></a:schemeClr></a:gs></a:gsLst><a:path path="circle"><a:fillToRect l="50000" t="50000" r="50000" b="50000"/></a:path></a:gradFill></a:bgFillStyleLst></a:fmtScheme></a:themeElements><a:objectDefaults/><a:extraClrSchemeLst/></a:theme>');
                            xlWorksheets = xl.folder('worksheets');

                            // Not content dependent
                            docProps.file('core.xml', '<?xml version="1.0" encoding="UTF-8" standalone="yes"?><cp:coreProperties xmlns:cp="http://schemas.openxmlformats.org/package/2006/metadata/core-properties" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:dcterms="http://purl.org/dc/terms/" xmlns:dcmitype="http://purl.org/dc/dcmitype/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><dc:creator>'
                                + (file.creator || 'XLSX.js') + '</dc:creator><cp:lastModifiedBy>' + (file.lastModifiedBy || 'XLSX.js') + '</cp:lastModifiedBy><dcterms:created xsi:type="dcterms:W3CDTF">'
                                + (file.created || new Date()).toISOString() + '</dcterms:created><dcterms:modified xsi:type="dcterms:W3CDTF">' + (file.modified || new Date()).toISOString() + '</dcterms:modified></cp:coreProperties>');

                            // Content dependent
                        styles = new Array(1);
                        borders = new Array(1);
                        fonts = new Array(1);
                            w = file.worksheets.length;
                            while (w--) { 
                                // Generate worksheet (gather sharedStrings), and possibly table files, then generate entries for constant files below
                                id = w + 1;
                                // Generate sheetX.xml in var s
                                worksheet = file.worksheets[w]; data = worksheet.data;
                                s = '';
                                columns = [];
                            merges = [];
                                i = -1; l = data.length;
                                while (++i < l) {
                                    j = -1; k = data[i].length;
                                    s += '<row r="' + (i + 1) + '" x14ac:dyDescent="0.25">';
                                    while (++j < k) {
                                        cell = data[i][j]; val = cell.hasOwnProperty('value') ? cell.value : cell; t = ''; 
                                        // supported styles: borders, hAlign, formatCode and font style
                                        style = {
                                            borders: cell.borders, 
                                            hAlign: cell.hAlign,
                                            vAlign: cell.vAlign,
                                            bold: cell.bold,
                                            italic: cell.italic,
                                            fontName: cell.fontName,
                                            fontSize: cell.fontSize,
                                            formatCode: cell.formatCode || 'General'
                                        };
                                        colWidth = 0;
                                        if (val && typeof val === 'string' && (cell.__t=="s"||true!==isFinite(val))) { 
                                            // If value is string, and not string of just a number, place a sharedString reference instead of the value
                                val = escapeXML(val);
                                            sharedStrings[1]++; // Increment total count, unique count derived from sharedStrings[0].length
                                            index = sharedStrings[0].indexOf(val);
                                            colWidth = val.length;
                                            if (index < 0) {
                                                index = sharedStrings[0].push(val) - 1; 
                                            }
                                            val = index;
                                            t = 's';
                                        } else if (typeof val === 'boolean') { 
                                            val = (val ? 1 : 0); t = 'b'; 
                                            colWidth = 1;
                                        } else if (typeOf(val) === 'date') { 
                                            val = convertDate(val); 
                                            style.formatCode = cell.formatCode || 'mm-dd-yy'; 
                                            colWidth = val.length;
                                        } else if (typeof val === 'object') {
                                            // unsupported value
                                            val = null
                                        } else {
                                            // number, or string which is a number 
                                            colWidth = (''+val).length;
                                        }
                                        
                                        // use stringified version as unic and reproductible style signature
                                        style = JSON.stringify(style);
                                        index = styles.indexOf(style);
                                        if (index < 0) { 
                                            style = styles.push(style) - 1; 
                                        } else { 
                                            style = index; 
                                        }
                                        // keeps largest cell in column, and autoWidth flag that may be set on any cell
                                        if (columns[j] == null) {
                                            columns[j] = {autoWidth: false, max:0};
                                        }
                                        if (cell.autoWidth) {
                                            columns[j].autoWidth = true
                                        }
                                        if (colWidth > columns[j].max) {
                                            columns[j].max = colWidth;
                                        }
                                        // store merges if needed and add missing cells. Cannot have rowSpan AND colSpan
                                        if (cell.colSpan > 1) {
                                            // horizontal merge. ex: B12:E12. Add missing cells (with same attribute but value) to current row
                                            merges.push([numAlpha(j) + (i + 1), numAlpha(j+cell.colSpan-1) + (i + 1)]);
                                            merged = [j, 0]
                                            for (var m = 0; m < cell.colSpan-1; m++) {
                                                merged.push(cell);
                                            }
                                            data[i].splice.apply(data[i], merged);
                                            k += cell.colSpan-1;
                                        } else if (cell.rowSpan > 1) {
                                            // vertical merge. ex: B12:B15. Add missing cells (with same attribute but value) to next columns
                                            for (var m = 1; m < cell.rowSpan; m++) {
                                                if (data[i+m]) {
                                                    data[i+m].splice(j, 0, cell)
                                                } else {
                                                    // readh the end of data
                                                    cell.rowSpan = m;
                                                    break;
                                                }
                                            }
                                            merges.push([numAlpha(j) + (i + 1), numAlpha(j) + (i + cell.rowSpan)]);
                                        }
                                        if (cell.rowSpan > 1 ||cell.colSpan > 1) {
                                            // deletes value, rowSpan and colSpan from cell to avoid refering it from copied cells
                                            delete cell.value;
                                            delete cell.rowSpan;
                                            delete cell.colSpan;
                                        }
                                        s += '<c r="' + numAlpha(j) + (i + 1) + '"' + (style ? ' s="' + style + '"' : '') + (t ? ' t="' + t + '"' : '');
                                        if (val != null) {
                                            s += '>' + (cell.formula ? '<f>' + cell.formula + '</f>' : '') + '<v>' + val + '</v></c>';
                                        } else {
                                            s += '/>';
                                        }
                                    }
                                    s += '</row>';
                                }

                                cols = []
                                for (i = 0; i < columns.length; i++) {
                                    if (columns[i].autoWidth) {
                                        cols.push('<col min="', i+1, '" max="', i+1, '" width="', columns[i].max, '" bestFit="1"/>');
                                    }
                                }
                                // only add cols definition if not empty
                                if (cols.length > 0) {
                                    cols = ['<cols>'].concat(cols, ['</cols>']).join('');
                                }

                                s = '<?xml version="1.0" encoding="UTF-8" standalone="yes"?><worksheet xmlns="http://schemas.openxmlformats.org/spreadsheetml/2006/main" xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships" xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006" mc:Ignorable="x14ac" xmlns:x14ac="http://schemas.microsoft.com/office/spreadsheetml/2009/9/ac">'
                                    + '<dimension ref="A1:' + numAlpha(data[0].length - 1) + data.length + '"/><sheetViews><sheetView ' + (w === file.activeWorksheet ? 'tabSelected="1" ' : '')
                                    + ' workbookViewId="0"/></sheetViews><sheetFormatPr defaultRowHeight="15" x14ac:dyDescent="0.25"/>'
                                    + cols
                                    + '<sheetData>'
                                    + s 
                                    + '</sheetData>';
                                if (merges.length > 0) {
                                    s += '<mergeCells count="' + merges.length + '">';
                                    for (i = 0; i < merges.length; i++) {
                                        s += '<mergeCell ref="' + merges[i].join(':') + '"/>';
                                    }
                                    s += '</mergeCells>';
                                }
                                s += '<pageMargins left="0.7" right="0.7" top="0.75" bottom="0.75" header="0.3" footer="0.3"/>';
                                if (worksheet.table) { 
                                    s += '<tableParts count="1"><tablePart r:id="rId1"/></tableParts>'; 
                                }
                                xlWorksheets.file('sheet' + id + '.xml', s + '</worksheet>');

                                if (worksheet.table) {
                                    i = -1; l = data[0].length; t = numAlpha(data[0].length - 1) + data.length;
                                    s = '<?xml version="1.0" encoding="UTF-8" standalone="yes"?><table xmlns="http://schemas.openxmlformats.org/spreadsheetml/2006/main" id="' + id
                                        + '" name="Table' + id + '" displayName="Table' + id + '" ref="A1:' + t + '" totalsRowShown="0"><autoFilter ref="A1:' + t + '"/><tableColumns count="' + data[0].length + '">';
                                    while (++i < l) { 
                                        s += '<tableColumn id="' + (i + 1) + '" name="' + (data[0][i].hasOwnProperty('value') ? data[0][i].value : data[0][i]) + '"/>'; 
                                    }
                                    s += '</tableColumns><tableStyleInfo name="TableStyleMedium2" showFirstColumn="0" showLastColumn="0" showRowStripes="1" showColumnStripes="0"/></table>';

                                    xl.folder('tables').file('table' + id + '.xml', s);
                                    xlWorksheets.folder('_rels').file('sheet' + id + '.xml.rels', '<?xml version="1.0" encoding="UTF-8" standalone="yes"?><Relationships xmlns="http://schemas.openxmlformats.org/package/2006/relationships"><Relationship Id="rId1" Type="http://schemas.openxmlformats.org/officeDocument/2006/relationships/table" Target="../tables/table' + id + '.xml"/></Relationships>');
                                    contentTypes[1].unshift('<Override PartName="/xl/tables/table' + id + '.xml" ContentType="application/vnd.openxmlformats-officedocument.spreadsheetml.table+xml"/>');
                                }

                                contentTypes[0].unshift('<Override PartName="/xl/worksheets/sheet' + id + '.xml" ContentType="application/vnd.openxmlformats-officedocument.spreadsheetml.worksheet+xml"/>');
                                props.unshift(escapeXML(worksheet.name) || 'Sheet' + id);
                                xlRels.unshift('<Relationship Id="rId' + id + '" Type="http://schemas.openxmlformats.org/officeDocument/2006/relationships/worksheet" Target="worksheets/sheet' + id + '.xml"/>');
                                worksheets.unshift('<sheet name="' + (escapeXML(worksheet.name) || 'Sheet' + id) + '" sheetId="' + id + '" r:id="rId' + id + '"/>');
                            }

                            // xl/styles.xml
                            i = styles.length; t = [];
                            while (--i) { 
                                // Don't process index 0, already added
                                style = JSON.parse(styles[i]);

                                // cell formating, refer to it if necessary
                                if (style.formatCode !== 'General') {
                                    index = numFmts.indexOf(style.formatCode);
                                    if (index < 0) { 
                                        index = 164 + t.length; 
                                        t.push('<numFmt formatCode="' + style.formatCode + '" numFmtId="' + index + '"/>'); 
                                    }
                                    style.formatCode = index
                                } else {
                                    style.formatCode = 0
                                }

                                // border declaration: add a new declaration and refer to it in style
                                borderIndex = 0
                                if (style.borders) {
                                    border = ['<border>']
                                    // order is significative
                                    for (var edge in {left:0, right:0, top:0, bottom:0, diagonal:0}) {
                                        if (style.borders[edge]) {
                                            var color = style.borders[edge];
                                            // add transparency if missing
                                            if (color.length === 6) {
                                                color = 'FF'+color;
                                            }
                                            border.push('<', edge, ' style="thin">', '<color rgb="', style.borders[edge], '"/></', edge, '>');
                                        } else {
                                            border.push('<', edge, '/>');
                                        }
                                    }
                                    border.push('</border>');
                                    border = border.join('');
                                    // try to reuse existing border
                                    borderIndex = borders.indexOf(border);
                                    if (borderIndex < 0) {
                                        borderIndex = borders.push(border) - 1;
                                    }
                                }

                                // font declaration: add a new declaration and refer to it in style
                                fontIndex = 0
                                if (style.bold || style.italic || style.fontSize || style.fontName) {
                                    font = ['<font>']
                                    if (style.bold) {
                                        font.push('<b/>');
                                    }
                                    if (style.italic) {
                                        font.push('<i/>');
                                    }
                                    font.push('<sz val="', style.fontSize || defaultFontSize, '"/>');
                                    font.push('<color theme="1"/>');
                                    font.push('<name val="', style.fontName || defaultFontName, '"/>');
                                    font.push('<family val="2"/>', '</font>');
                                    font = font.join('');
                                    // try to reuse existing font
                                    fontIndex = fonts.indexOf(font);
                                    if (fontIndex < 0) {
                                        fontIndex = fonts.push(font) - 1;
                                    }
                                }

                                // declares style, and refer to optionnal formatCode, font and borders
                                styles[i] = ['<xf xfId="0" fillId="0" borderId="', 
                                    borderIndex, 
                                    '" fontId="',
                                    fontIndex,
                                    '" numFmtId="',
                                    style.formatCode,
                                    '" ',
                                    (style.hAlign || style.vAlign? 'applyAlignment="1" ' : ' '),
                                    (style.formatCode > 0 ? 'applyNumberFormat="1" ' : ' '),
                                    (borderIndex > 0 ? 'applyBorder="1" ' : ' '),
                                    (fontIndex > 0 ? 'applyFont="1" ' : ' '),
                                    '>'
                                ];
                                if (style.hAlign || style.vAlign) {
                                    styles[i].push('<alignment');
                                    if (style.hAlign) {
                                        styles[i].push(' horizontal="', style.hAlign, '"');
                                    }
                                    if (style.vAlign) {
                                        styles[i].push(' vertical="', style.vAlign, '"');
                                    }
                                    styles[i].push('/>');
                                }
                                styles[i].push('</xf>');
                                styles[i] = styles[i].join('');
                            }
                            t = t.length ? '<numFmts count="' + t.length + '">' + t.join('') + '</numFmts>' : '';

                            xl.file('styles.xml', '<?xml version="1.0" encoding="UTF-8" standalone="yes"?><styleSheet xmlns="http://schemas.openxmlformats.org/spreadsheetml/2006/main" xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006" mc:Ignorable="x14ac" xmlns:x14ac="http://schemas.microsoft.com/office/spreadsheetml/2009/9/ac">'
                                + t + '<fonts count="'+ fonts.length + '" x14ac:knownFonts="1"><font><sz val="' + defaultFontSize + '"/><color theme="1"/><name val="' + defaultFontName + '"/><family val="2"/>'
                                + '<scheme val="minor"/></font>' + fonts.join('') + '</fonts><fills count="2"><fill><patternFill patternType="none"/></fill><fill><patternFill patternType="gray125"/></fill></fills>'
                                + '<borders count="' + borders.length + '"><border><left/><right/><top/><bottom/><diagonal/></border>'
                                + borders.join('') + '</borders><cellStyleXfs count="1">'
                                + '<xf numFmtId="0" fontId="0" fillId="0" borderId="0"/></cellStyleXfs><cellXfs count="' + styles.length + '"><xf numFmtId="0" fontId="0" fillId="0" borderId="0" xfId="0"/>'
                                + styles.join('') + '</cellXfs><cellStyles count="1"><cellStyle name="Normal" xfId="0" builtinId="0"/></cellStyles><dxfs count="0"/>'
                                + '<tableStyles count="0" defaultTableStyle="TableStyleMedium2" defaultPivotStyle="PivotStyleLight16"/>'
                                + '<extLst><ext uri="{EB79DEF2-80B8-43e5-95BD-54CBDDF9020C}" xmlns:x14="http://schemas.microsoft.com/office/spreadsheetml/2009/9/main">'
                                + '<x14:slicerStyles defaultSlicerStyle="SlicerStyleLight1"/></ext></extLst></styleSheet>');

                            // [Content_Types].xml
                            zip.file('[Content_Types].xml', '<?xml version="1.0" encoding="UTF-8" standalone="yes"?><Types xmlns="http://schemas.openxmlformats.org/package/2006/content-types"><Default Extension="rels" ContentType="application/vnd.openxmlformats-package.relationships+xml"/><Default Extension="xml" ContentType="application/xml"/><Override PartName="/xl/workbook.xml" ContentType="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet.main+xml"/>'
                                + contentTypes[0].join('') + '<Override PartName="/xl/theme/theme1.xml" ContentType="application/vnd.openxmlformats-officedocument.theme+xml"/><Override PartName="/xl/styles.xml" ContentType="application/vnd.openxmlformats-officedocument.spreadsheetml.styles+xml"/><Override PartName="/xl/sharedStrings.xml" ContentType="application/vnd.openxmlformats-officedocument.spreadsheetml.sharedStrings+xml"/>'
                                + contentTypes[1].join('') + '<Override PartName="/docProps/core.xml" ContentType="application/vnd.openxmlformats-package.core-properties+xml"/><Override PartName="/docProps/app.xml" ContentType="application/vnd.openxmlformats-officedocument.extended-properties+xml"/></Types>');

                            // docProps/app.xml
                            docProps.file('app.xml', '<?xml version="1.0" encoding="UTF-8" standalone="yes"?><Properties xmlns="http://schemas.openxmlformats.org/officeDocument/2006/extended-properties" xmlns:vt="http://schemas.openxmlformats.org/officeDocument/2006/docPropsVTypes"><Application>XLSX.js</Application><DocSecurity>0</DocSecurity><ScaleCrop>false</ScaleCrop><HeadingPairs><vt:vector size="2" baseType="variant"><vt:variant><vt:lpstr>Worksheets</vt:lpstr></vt:variant><vt:variant><vt:i4>'
                                + file.worksheets.length + '</vt:i4></vt:variant></vt:vector></HeadingPairs><TitlesOfParts><vt:vector size="' + props.length + '" baseType="lpstr"><vt:lpstr>' + props.join('</vt:lpstr><vt:lpstr>')
                                + '</vt:lpstr></vt:vector></TitlesOfParts><Manager></Manager><Company>Microsoft Corporation</Company><LinksUpToDate>false</LinksUpToDate><SharedDoc>false</SharedDoc><HyperlinksChanged>false</HyperlinksChanged><AppVersion>1.0</AppVersion></Properties>');

                            // xl/_rels/workbook.xml.rels
                            xl.folder('_rels').file('workbook.xml.rels', '<?xml version="1.0" encoding="UTF-8" standalone="yes"?><Relationships xmlns="http://schemas.openxmlformats.org/package/2006/relationships">'
                                + xlRels.join('') + '<Relationship Id="rId' + (xlRels.length + 1) + '" Type="http://schemas.openxmlformats.org/officeDocument/2006/relationships/sharedStrings" Target="sharedStrings.xml"/>'
                                + '<Relationship Id="rId' + (xlRels.length + 2) + '" Type="http://schemas.openxmlformats.org/officeDocument/2006/relationships/styles" Target="styles.xml"/>'
                                + '<Relationship Id="rId' + (xlRels.length + 3) + '" Type="http://schemas.openxmlformats.org/officeDocument/2006/relationships/theme" Target="theme/theme1.xml"/></Relationships>');

                            // xl/sharedStrings.xml
                            xl.file('sharedStrings.xml', filterXML('<?xml version="1.0" encoding="UTF-8" standalone="yes"?><sst xmlns="http://schemas.openxmlformats.org/spreadsheetml/2006/main" count="'
                                + sharedStrings[1] + '" uniqueCount="' + sharedStrings[0].length + '"><si><t>' + sharedStrings[0].join('</t></si><si><t>') + '</t></si></sst>'));

                            // xl/workbook.xml
                            xl.file('workbook.xml', '<?xml version="1.0" encoding="UTF-8" standalone="yes"?><workbook xmlns="http://schemas.openxmlformats.org/spreadsheetml/2006/main" xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships">'
                                + '<fileVersion appName="xl" lastEdited="5" lowestEdited="5" rupBuild="9303"/><workbookPr defaultThemeVersion="124226"/><bookViews><workbookView '
                                + (file.activeWorksheet ? 'activeTab="' + file.activeWorksheet + '" ' : '') + 'xWindow="480" yWindow="60" windowWidth="18195" windowHeight="8505"/></bookViews><sheets>'
                                + worksheets.join('') + '</sheets><calcPr calcId="145621"/></workbook>');

                            processTime = Date.now() - processTime;
                            zipTime = Date.now();
                            result = {
                                base64: zip.generate({ compression: 'DEFLATE' }), 
                                blob: zip.generate({ compression: 'STORE' ,type:"blob"}), zipTime: Date.now() - zipTime, processTime: processTime,
                                href: function() { return 'data:application/vnd.openxmlformats-officedocument.spreadsheetml.sheet;base64,' + this.base64; }
                            };
                        }
                        return result;
                    }
                    def.resolve(true);
                }catch(e){
                    def.resolve(false);
                }
            }
            return def;
        },
        initXlsxFileByMatrix:function(matrix,fileName){
            this._file = {
                worksheets: [{}],
                creator: 'cqthink',
                created: new Date(),
                lastModifiedBy: 'cqthink',
                modified: new Date(),
                activeWorksheet: 0
            };
            var data = this._file.worksheets[0];
            data.name = fileName;
            data.data = matrix;
            this._file.worksheets[0] = data;
        },
        initXlsxFile:function(sheetData, fileName){
            this._file = {
                worksheets: [{}],
                creator: 'cqthink',
                created: new Date(),
                lastModifiedBy: 'cqthink',
                modified: new Date(),
                activeWorksheet: 0
            };
            var data = this._file.worksheets[0];
            data.name = fileName;
            data.data = [];
            data.data[0] = array.map(sheetData.columns, function(item, index){
                return item.fieldName||item.label;
            });
            data.data = data.data.concat(array.map(sheetData.datas , function(item, index){
                return array.map(sheetData.columns, function(i){
                    return item[i.field];
                });
            }));
            this._file.worksheets[0] = data;
        },
        // 下载文件，isCsv  是否下载未csv文件格式，因为下载为xlsx文件需要大量计算，影响效率，因此直接下载为csv文件
        _downloadBlod:function(isCsv){
            var div = domConstruct.create("div",{
                onclick:function(){
                    if(div.parentNode){
                        div.parentNode.removeChild(div);
                    }
                }
            },document.body);
            var node = domConstruct.create("a",{
                download:(this._file.worksheets[0].name||"导出数据")+(isCsv?".csv":".xlsx"),
                style:"display:block;padding: 10px 0;font-size: 18px;text-align: center;background: white;",
                innerHTML:"确认"
            }, div);
            if(isCsv){
                var getData = function(s){
                    var value  = s&&s.value||s;
                    if(value||0===value||""===value||false===value){
                        value = ""+value;
                        //引号有特殊含义，需要做转义
                        value = value.replace(/"/g,'""').replace(/\n/g," ");
                        if(value.match(/[",\s]/)){
                            //有引号、逗号、空白字符时，需要用引号括起，标识是同一个字段
                            value = '"'+value+'"';
                        }else if(value.length>8&&value[value[0]==="-"?1:0].match(/\d/)){
                            //长数字和日期、时间等转义为字符串
                            value = '"'+value+'"';
                        }
                    }else{
                        value = "";
                    }
                    return value;
                };
                node.href = window.URL.createObjectURL(new Blob(["\ufeff"+array.map(this._file.worksheets[0].data,function(d){
                    return array.map(d,function(dd){
                        return getData(dd);
                    }).join(",");
                }).join("\n")],{type:"data:text/csv"}));
            }else{
                node.href = window.URL.createObjectURL(xlsx(this._file).blob);
            }
            node.click();
            if(window.free){
                window.free();
            }
            setTimeout(function(){
                if(div.parentNode){
                    confirm("开始下载");
                    node.click();
                    if(div.parentNode){
                        div.parentNode.removeChild(div);
                    }
                }
            },10);
        },
        //xlsx.exportData("/biz/shop/bs/district/load_by_level?level=2",{
        //},[{
        //  field:"_id",
        //  fieldName:"id"
        //},{
        //  field:"distName",
        //  fieldName:"省份"
        //}],"你好吗")
        exportData:function(url,query,fields,fileName){
            fields =  listLayout.initLayoutFormatter(fields);
            var file = {
                columns:fields,
                datas:[]
            };
            this.loadAllData(url,query).then(lang.hitch(this,function(items){
                array.forEach(items,function(data){
                    file.datas.push(data);
                    array.forEach(fields,function(field){
                        data[field.field] = field.formatter(data[field.field],data);
                    });
                });
                this['export'](file,fileName);
            }));
        },
        loadAllData:function(url,query){
            var def = new Deferred(),store = new JsonRest({
                target:url
            }),items = [],start = 0,pageSize = 1000,
            //dfields = [],
            onTotalLoaded = function(total){
                // 判断服务器端接口是否支持分页，不支持时，返回的total为null
                store._cqTotal = total;
            },
            startQuery = lang.hitch(this,function(){
                if(window.busy){
                    window.busy();
                }
                //加载数据，加载完成之后处理数据
                var queryResult = store.query(query,{
                    start:start,count:pageSize
                });
                queryResult.total.then(onTotalLoaded);
                queryResult.then(dataLoaded);
            }),dataLoaded = lang.hitch(this,function(datas){
                //处理数据
                datas = datas.items||datas||[];
                start += pageSize;
                items = items.concat(datas);
                if(datas.length===pageSize&&store._cqTotal){
                    // 本页取满了且服务器端支持分页时才加载下一页
                    startQuery();
                }else{
                    def.resolve(items);
                }
            });
            if(userAgent.isMobile()){
                def.resolve([]);
                return def;
            }
            store._cqTotal = 0;
            startQuery();
            return def;
        }
    });
});
