﻿define([
    "dojo/_base/array",
	"dojo/_base/declare",
	"dojo/_base/event",
	"dojo/_base/lang",
	"dojo/dom-attr",
	"dojo/dom-construct",
	"dojo/dom-geometry",
	"dojo/Deferred",
	"dojo/DeferredList",
	"dojo/touch",
	"dijit/_WidgetBase",
    "cq/util/sys/geo"
],function(array,declare,event,lang,domAttr,domConstruct,domGeom,Deferred,DeferredList,touch,_WidgetBase,geoUtil){
	if(!window.AMap){
        domConstruct.create("script",{
            //高德地图url
            src:"http://webapi.amap.com/maps?v=1.3&amp;key=0b9138e58ee2c5776ed90d144bfbfd97&plugin=AMap.CircleEditor"
        },document.head,"last");
    }
    return declare("",_WidgetBase,{
        //当前已添加的标记的需要
		_markIndex:0,
		//已添加的标记对象
		addedMarks:[],
        // 已添加的标记圆对象
        addedCircles : [],
        addedCircleEditors : [],
		//工具条
		enableToolBar:true,
		enableOverView:true,
		//缩放
		enableMapScale:true,
		//编辑位置
		enableEdit:true,
		//中心点经度
		lon:0,
		//中心点维度
		lat:0,
		//默认缩放级别
		mapZoom:13,
		//地图创建的节点
		asRootNode:false,
        
        lonField:null,
        latField:null,
        
		//默认特性
		features:["bg","point","road","building"],
		buildRendering:function(){
            this.inherited(arguments);
            domAttr.set(this.domNode,"dojoClick",false);
        },
        
		postCreate:function(){
			this.inherited(arguments);
			//本对象拖动应该只影响容器内的内容，对外部不产生任何影响
			//赵春辉	若不禁用拖动事件，编辑界面拖动会导致功能关闭	2015-11-15
			//this.connect(this.domNode,touch.press,this.onTouchStart);
		},
		//初始化地图
		startup:function(){
			this.inherited(arguments);
			if(!this.map){
				this.addedMarks = [];
                this.addedCircles = [];
                this.addedCircleEditors = [];
			}
		},
		onTouchStart:function(e){
			event.stop(e);
		},
        
        /******************以下部分是初始化地图的程序******************/
        //初始化地图和地图插件
		initMapElement:function(){
			if(!this.map){
				//初始化地图和地图插件
				var defs = [],def1 = null,def2 = null,def3 = null;
				var mapId = this.get("id")
				if(!this.asRootNode){
					mapId = mapId+"me";
					domConstruct.create("div",{
						"id":mapId,
						style:"width:100%;height:100%;"
					},this.domNode);
				}
				var map = this.map = new AMap.Map(mapId,{
					center:new AMap.LngLat(this.lon||106.54,this.lat||29.59),
					zoom:this.mapZoom||13, //地图显示的缩放级别,
					resizeAble:((this.lon||this.lat)&&true)||false,
					features:this.features
				});
				if(this.lon||this.lat){
					this.setCenter(this.lon,this.lat);
				}
				if(this.enableToolBar){
					defs.push(def1 = new Deferred());
					this.map.plugin(["AMap.ToolBar"],function(){
						map.addControl(new AMap.ToolBar({
							direction:true,//方向导航
							ruler:true//,//视野级别控制尺  
							//autoPosition:true//自动定位
						}));
						def1.resolve();
					});
				}
				if(this.enableOverView){
					defs.push(def2 = new Deferred());
					this.map.plugin(["AMap.OverView"],function(){
						map.addControl(new AMap.OverView());
						def2.resolve();
					});
				}
				if(this.enableMapScale){
					defs.push(def3 = new Deferred());
					this.map.plugin(["AMap.Scale"],function(){
						map.addControl(new AMap.Scale());
						def3.resolve();
					});
				}
				var clickCallback = lang.hitch(this,this.onMapClick);
				//this.connect(this.domNode,"onclick",function(e){
                AMap.event.addListener(this.map,'click',lang.hitch(this,function(e){
					//赵春辉	处理地理位置的方法有问题	2015-05-06
					//var position = domGeom.position(this.domNode),lonLat = this.map.containTolnglat(new AMap.Pixel(e.clientX-position.x,e.clientY-position.y));
					var position = domGeom.position(this.domNode),
                    lonLat = e.lnglat;
                    //添加地理位置名称
					//var geocoder; 
					//var lnglatXY = position; 
					//加载地理编码插件 
					this.map.plugin(["AMap.Geocoder"],function(){  
						var geocoder = new AMap.Geocoder({ 
							radius:1000, //以已知坐标为中心点，radius为半径，返回范围内兴趣点和道路信息 
							extensions: "all"//返回地址描述以及附近兴趣点和道路信息，默认"base" 
						}); 
						//逆地理编码 
						geocoder.getAddress(lonLat,function(status, result){
							//取回逆地理编码结果
							if(status === 'complete' && result.info === 'OK'){
								clickCallback(lonLat.getLng(),lonLat.getLat(),result.regeocode.formattedAddress);
							}
						});
					});
				//});
                }));
				this._mapDef = new DeferredList(defs);
			}
			var def = new Deferred();
			this._mapDef.then(lang.hitch(this,function(){
				//清除界面上的标记
				this.clearAllMarks();
				def.resolve();
			}));
			return def;
		},
		//返回经纬度和地理位置名称,地图点击事件的回调函数
		//@arguments  lon ： 经度
		//@arguments  lat ： 纬度
		//@arguments  addressName ： 地理位置名称
		onMapClick:function(lon, lat, addressName){
		},
        /*******************以上部分程序是初始化地图的程序********************/
        
        /*******************以下部分是编辑圆的处理程序********************/
        // 添加一个圆的
        addCircle : function (circleInfo) {
            var circle = this._addCircle(circleInfo);
            this.setCircleEditor(circle, this.enableEdit);
            return circle;
        },
        setCircleEditor : function (circle, enableEdit) {
            var enableEdit = enableEdit;
            // 创建新的圆编辑器，需要清空
            this.map.plugin(["AMap.CircleEditor"], lang.hitch(this,function() {
                var circleEditor = new AMap.CircleEditor(this.map, circle);
                this.addedCircleEditors.push(circleEditor);
                if (enableEdit) {
                    // 可编辑
                    circleEditor.open();
                } else {
                    circleEditor.close();
                }
            }));
        },
        // 添加一个圆 私有方法
        _addCircle : function (circleInfo) {
            if (circleInfo) {
                circleInfo.lon -= 0;
                circleInfo.lat -= 0;
                circleInfo.radius -= 0;
                var circle = this._createCircle(circleInfo);
                this.addedCircles.push(circle);
                circle.setMap(this.map);
                return circle;
            }
            return;
        },
        // 依据参数创建一个圆
        _createCircle : function (circleInfo) {
            var circle = null;
			if(circleInfo){
                var circleParam = {
                    center: [circleInfo.lon, circleInfo.lat],// 圆心位置
                    radius: circleInfo.radius, //半径
                    strokeColor: "#F33", //线颜色
                    strokeOpacity: 1, //线透明度
                    strokeWeight: 3, //线粗细度
                    fillColor: "#ee2200", //填充颜色
                    fillOpacity: 0.35//填充透明度
                };
                circle = new AMap.Circle(circleParam);
			}
			return circle;
        },
        // 清楚指定的圆
        clearCircle : function (circle) {
            if(circle&&this.addedCircles.length>0){
                for(var i=0;i<this.addedCircles.length;i++){
                    if(this.addedCircles[i]==circle){
                        circle.setMap(null);
                        this.addedCircles.splice(i,1);
                        break;
                    }
                }
            }
        },
        //清除所有圆标记
		clearAllCircles:function(){
			while(this.addedCircles.length){
				this.clearCircle(this.addedCircles[0]);
			}
		},
        /*******************以上部分时编辑圆的处理程序********************/
        
        /*******************以下部分是标记点的处理程序************************/
		//单点显示
		addMark:function(markInfo){
			if(this.enableEdit){
				return this._addMark(markInfo);
			}
            return;
		},
        //多点显示
		initMarks:function(marks,enableRoute){
			for(var i=0;i<marks.length;i++){
				this._addMark(marks[i]);
			}
		},
        // 添加一个标记 私有方法
		_addMark:function(markInfo){
			if(markInfo){
				markInfo.lon -= 0;
				markInfo.lat -= 0;
				if((markInfo.lon||0===markInfo.lon)&&(markInfo.lat||0===markInfo.lat)&&markInfo.lon<=180&&markInfo.lon>=-180&&markInfo.lat>=-90&&markInfo.lat<=90){
					//创建一个标记
					var mark = this._createMark(markInfo);
					//记录创建的标记
					this.addedMarks.push(mark);
					//将标记放到地图上
					mark.setMap(this.map);
                    return mark;
				}
                return;
			}
            return;
		},
		//依据参数创建一个标记
		_createMark:function(markInfo){
			var mark = null;
			if(markInfo){
				var param = {
					position:new AMap.LngLat(markInfo.lon,markInfo.lat)
				};
				if(markInfo.iconInfo){
					param.icon = new AMap.Icon({            
						size: new AMap.Size(markInfo.iconInfo.width||40,markInfo.iconInfo.height||50),  //图标大小
						image: markInfo.iconInfo.src,
						imageOffset: new AMap.Pixel(markInfo.iconInfo.left||0, markInfo.iconInfo.top||0)
					});
				}
				mark=new AMap.Marker(param);
				if(markInfo.title){
					mark.setTitle(markInfo.title);
					mark.setLabel({
						//label默认蓝框白底左上角显示，样式className为：amap-marker-label
						offset: new AMap.Pixel(0, -20),
						//修改label相对于maker的位置
						content:markInfo.title
					});
				}
				mark._cqMarkEventHandlers = [AMap.event.addListener(mark, 'click', lang.hitch(this,function(){
					this.onMarkClick(markInfo);
				}))];
			}
			return mark;
		},
		//清除指定标记
		clearMark:function(mark){
            if(mark&&this.addedMarks.length>0){
                for(var i=0;i<this.addedMarks.length;i++){
                    if(this.addedMarks[i]==mark){
                        while(mark._cqMarkEventHandlers&&mark._cqMarkEventHandlers.length){
                            AMap.event.removeListener(mark._cqMarkEventHandlers.pop());
                        }
                        mark.setMap(null);
                        this.addedMarks.splice(i,1);
                        break;
                    }
                }
            }
			
		},
		//清除所有标记
		clearAllMarks:function(){
			while(this.addedMarks.length){
				this.clearMark(this.addedMarks[0]);
			}
		},
        /*************以上部分是标记点的处理程序**************/
        
        /*************中心点相关*****************************/
		//调整到合理视野  
		setFitView:function(){
			return this.map&&this.map.setFitView();
		},
		setCenter:function(lon,lat){
			if((lon||0===lon)&&(lat||0===lat)&&lon<=180&&lon>=-180&&lat>=-90&&lat<=90){
				this.map.setCenter(new AMap.LngLat(lon,lat));
			}
		},
        getCenter:function(){
            if(this.map){
                return this.map.getCenter();
            }
        },
		/*************中心点相关*****************************/
        
        /*************多边形区域*****************/
		clearAllAreas:function(){
			var area = null;
			while((this._areas||[]).length){
				area = this._areas.pop();
				while(area._cqMarkEventHandlers.length){
					AMap.event.removeListener(area._cqMarkEventHandlers.pop());
				}
				area.setMap(null);
			}
		},
		addAreas:function(options){
			this._areas = this.areas||[];
			while(options.length){
				this._areas.push(this._createArea(options[0]));
				options.shift();
			}
		},
		_createArea:function(areaOption){
			//创建多边形区域
			var area = new AMap.Polyline(lang.mixin(areaOption,areaOption.style));
			area.setMap(this.map);
			area._cqMarkEventHandlers = [];
			//若有hover样式
			if(areaOption.hoverStyle){
				//	侦听mousedown、mouseover、touchstart事件，显示hover样式
				//	侦听mouseout、mouseup、touchend事件，显示原始样式
				var onHover = function(){
					area.setOption(lang.mixin(area.getOptions(),areaOption.hoverStyle));
				},onHoverOut = function(){
					area.setOption(lang.mixin(area.getOptions(),areaOption.style));
				};
				area._cqMarkEventHandlers.push(AMap.event.addListener(area, 'mousedown', onHover));
				area._cqMarkEventHandlers.push(AMap.event.addListener(area, 'mouseover', onHover));
				area._cqMarkEventHandlers.push(AMap.event.addListener(area, 'touchstart', onHover));
				area._cqMarkEventHandlers.push(AMap.event.addListener(area, 'mouseout', onHoverOut));
				area._cqMarkEventHandlers.push(AMap.event.addListener(area, 'mouseup', onHoverOut));
				area._cqMarkEventHandlers.push(AMap.event.addListener(area, 'touchend', onHoverOut));
			}
			
			//侦听click事件，触发this.onAreaClick
			area._cqMarkEventHandlers.push(AMap.event.addListener(area, 'click', lang.hitch(this,function(){
				this.onAreaClick(areaOption);
			})));
			
			return area;
		},
		onAreaClick:function(areaOption){
		},
		/*************多边形区域*****************/
        
        /*************地图显示区域***************************/
        //限制地图显示区域
		setLimitBounds:function(leftLon,bottomLat,rightLon,topLat){
			this.map&&this.map.setLimitBounds(new AMap.Bounds(new AMap.LngLat(leftLon,bottomLat),new AMap.LngLat(rightLon,topLat)));
		},
        // 清除地图显示区域限制
		clearLimitBounds:function(){
			this.map&&this.map.clearLimitBounds();
		},
        /*************地图显示区域***************************/
        
		//查询当前城市
		//参数：无
		//异步返回值：当前城市名称
		citySearch:function(){
			return geoUtil.getLocalCitry.apply(geoUtil,arguments);
		},
		//在制定城市中查询包含指定关键字的地理信息
		search:function(areaCode, placeName, onSuccess, onError){
			return geoUtil.search.apply(geoUtil,arguments);
		},
        
        /****************两点导航(导航)**************************/
		//获取起止点的驾车路线，
		route:function(startPoint, endPoint, onSuccess, onError,waypoints){
			return geoUtil.getDrivingRoute.apply(geoUtil,arguments);
		},
        // 两点导航(导航)
		drivingDrawLine:function(startPoint,endPoint,waypoints,opts){
            opts = opts||{};
			var def = new Deferred();
			this.route(startPoint,endPoint,lang.hitch(this,function(result){
				//显示新的路线之前要清空原有路线
				this._initMap();
				var start_xy = new AMap.LngLat(startPoint.lon, startPoint.lat);
				var end_xy = new AMap.LngLat(endPoint.lon, endPoint.lat);
				var steps = result.routes[0].steps;
                if(false!==opts.shopwStart){
                    var startmarker = this._startmarker = new AMap.Marker({
                        icon : new AMap.Icon({
                            image: "http://cache.amap.com/lbs/static/jsdemo002.png",
                            size:new AMap.Size(44,44),
                            imageOffset: new AMap.Pixel(-334, -180)
                        }), //复杂图标
                        visible : true, 
                        position : start_xy,
                        map:this.map,
                        offset : {
                            x : -16,
                            y : -40
                        }
                    });
                }
                if(false!==opts.showWayPoints){
                    (waypoints||[]).forEach(lang.hitch(this,function(point){
                        if(point.lon&&point.lat){
                            this._addMark({
                                lon:point.lon,
                                lat:point.lat
                            });
                        }
                    }));
                }
                if(false!==opts.showEnd){
                    var endmarker = this._endmarker = new AMap.Marker({
                        icon : new AMap.Icon({
                            image: "http://cache.amap.com/lbs/static/jsdemo002.png",
                            size:new AMap.Size(44,44),
                            imageOffset: new AMap.Pixel(-334, -134)
                        }), //复杂图标
                        visible : true, 
                        position : end_xy,
                        map:this.map,
                        offset : {
                            x : -16,
                            y : -40
                        }
                    });
                }
				//起点到路线的起点 路线的终点到终点 绘制无道路部分
				var extra_path1 = [];
				extra_path1.push(start_xy);
				extra_path1.push(steps[0].path[0]);
				var extra_line1 = this._extra_line1 = new AMap.Polyline({
					map: this.map,
					path: extra_path1,
					strokeColor: "#9400D3",
					strokeOpacity: 0.7,
					strokeWeight: 4,
					strokeStyle: "dashed",
					strokeDasharray: [10, 5]
				});
			
				var extra_path2 = [];
				var path_xy = steps[(steps.length-1)].path;
				extra_path2.push(end_xy);
				extra_path2.push(path_xy[(path_xy.length-1)]);
				var extra_line2 = this._extra_line2 = new AMap.Polyline({
					map: this.map,
					path: extra_path2,
					strokeColor: "#9400D3",
					strokeOpacity: 0.7,
					strokeWeight: 4,
					strokeStyle: "dashed",
					strokeDasharray: [10, 5]
				});
				
				var drawpath = []; 
				for(var s=0; s<steps.length; s++) {
					var plength = steps[s].path.length;
					for (var p=0; p<plength; p++) {
						drawpath.push(steps[s].path[p]);
					}
				}
				var polyline = this._polyline = new AMap.Polyline({
					map: this.map,
					path: drawpath,
					strokeColor: "#9400D3",
					strokeOpacity: 0.7,
					strokeWeight: 4,
					strokeDasharray: [10, 5]
				});
				this.map.setFitView();
				def.resolve(result);
			}),function(){},waypoints);
			return def;
		},
        
        moreMarkNav:function(points){
            if(points&&points.length){
                var start = points[0],end=points[points.length-1];
                var waypoints = [];
                var len = points.length-1;
                while(1<len--){
                    waypoints[len-1] = points[len];
                }
                return this.drivingDrawLine(start,end,waypoints);
            }
            return;
        },
		//初始化地图上的标记
		_initMap:function(){
			if(this._startmarker){
				this._startmarker.setMap(null);
			}
			if(this._endmarker){
				this._endmarker.setMap(null);
			}
			if(this._extra_line1){
				this._extra_line1.setMap(null);
			}
			if(this._extra_line2){
				this._extra_line2.setMap(null);
			}
			if(this._polyline){
				this._polyline.setMap(null);
			}
		},
        /****************两点导航(导航)**************************/
        
		//设置地图缩放等级
		setZoom:function(lv){
			this.mapZoom=lv;
			//var pos=this.map.getCenter();
			//var lat=pos.lat,lng=pos.lng
			//this.map.setZoomAndCenter(Lv, [lng,lat]);
			this.map.setZoom(lv);
		},
		//获取当前地图缩放等级
		getZoom:function(){
			return this.map.getZoom();
		},
		//显示信息窗体
		showInfoWindow:function(title,content,lng,lat,left,top){
			var infoWindow = this._infoWindow;
			if(!infoWindow){
				infoWindow = this._infoWindow = new AMap.InfoWindow({
					content: this.createInfoWindow(title,content),
					offset: new AMap.Pixel(left||0,top||0)
				});
			}
			infoWindow.setContent(this.createInfoWindow(title,content));
            infoWindow.open(this.map,[lng,lat]);
			return infoWindow;
		},
		//创建信息窗体的内容
		createInfoWindow:function(title,content){
			var info="";
			//标题
			info+="<div style='color: #333333;font-size: 14px;font-weight: bold;line-height: 31px;'>"+title+"</div>";
			//内容
			info+="<div>"+content+"</div>";
			return info;
		},
		//关闭信息窗体
		closeInfoWindow:function(){
			 this._infoWindow&&this._infoWindow.close();
		},
		//标记点击事件
		onMarkClick:function(markInfo){
            
        },
        clear:function(){
            this.clearAllMarks();
            this._initMap();
            this.closeInfoWindow();
        },
        // 高亮一个区域
        markCity: function(city, map1) {
            AMap.service('AMap.DistrictSearch', function() {
                var opts = {
                    subdistrict: 1, //返回下一级行政区
                    extensions: 'all', //返回行政区边界坐标组等具体信息
                    level: this.highLightLevel //查询行政级别为 市
                };
                //实例化DistrictSearch
                district = new AMap.DistrictSearch(opts);
                district.setLevel(this.highLightLevel);
                //行政区划高亮（最小到区县）
                district.search(city, function(status, result) {
                    var bounds = result.districtList[0].boundaries;
                    var polygons = [];
                    if (bounds) {
                        for (var i = 0, l = bounds.length; i < l; i++) {
                            //生成行政区划polygon
                            var polygon = new AMap.Polygon({
                                map: map1,
                                strokeWeight: 1,
                                path: bounds[i],
                                fillOpacity: 0.1,
                                fillColor: '#275dab',
                                strokeColor: '#6ca8d5'
                            });
                            polygons.push(polygon);
                        }
                        //地图自适应
                        //map1.setFitView();
                    }
                });
            });
        },
        // 初始化热力区域
        initMapPaneMarks: function() {
            // 热力图 
            var map = this.map;
            map.plugin(["AMap.Heatmap"], lang.hitch(this,function() {
                if(!this.heatMap){
                    //初始化heatMap对象
                    this.heatMap = new AMap.Heatmap(map, {
                        radius: 25, //给定半径
                        opacity: [0, 0.8]
                    });
                }
                this.setheatMapData();
            }));
        },
        //根据数据绘出热力区域
        setheatMapData: function() {
            if(this.lonField===null&&this.latField==null){
                return;
            }
            var items = [];
            if(this.heatMap){
                this.heatDatas = this.heatDatas || [];
                var max = 0;
                array.forEach(this.heatDatas,lang.hitch(this,function(i){
                    if(!i[this.lonField]&&!i[this.latField]){
                        return;
                    }
                    if(i[this.amountField]>max) max = i[this.amountField];
                    items.push({
                        lng:i[this.lonField],
                        lat:i[this.latField],
                        count:i[this.amountField]||0.1
                    });
                }));
                if(max==0){
                    max=1;
                }
                items.sort(function(a,b){
                    return b.count-a.count;
                });
                var len = items.length;
                this.heatMap.setDataSet({
                    data:array.map(items,function(item,i){
                        //item.count = i/len*100;
                        item.count = item.count/max*100;
                        item.count = item.count<20?20:item.count;
                        return item;
                    }),
                    max:100
                });
            }
        },
        getCity:function(param){
            this.map.getCity(param);
        }
	});
});
