﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    'dojo/dom-construct',
    "dojo/Deferred",
    "dojo/number",
    "dojox/charting/Chart",
    "dojox/charting/widget/Legend",
    "cq/app/widget/_WidgetBase",
    "dijit/_WidgetBase",
    "dojox/charting/Theme",
    "dojox/charting/axis2d/Default",
    "dojox/charting/plot2d/Columns",
    "dojox/charting/plot2d/ClusteredColumns",
    "dojox/charting/plot2d/Areas",
    "dojox/charting/plot2d/Grid",
    "dojox/charting/plot2d/Default",
    "dojo/has!touch?dojox/charting/action2d/TouchIndicator:dojox/charting/action2d/MouseIndicator",
],function(declare, lang, array, domConstruct, Deferred, number,Chart, Legend,cqWidgetBase,_WidgetBase,Theme,Default,Columns,ClusteredColumns,Areas,Grid,Default2,Indicator){
/*
    //  type: 'Areas'曲线图 'Columns'柱形图 'Default'为折线图 
    //报表数据提供者
    dataProvider:
	//加载报表数据时携带的参数，object
	dataOptions:
	//读取报表数据的方法名
	dataMethod:
		参数:
			cqRefInfo:本对象侦听的其他对象的当前状态
			chart:当前对象
			dataOptions:读取报表数据时的参数
		返回值:
			支持同步或异步返回数据
			返回的数据是按照显示的顺序已经排序的数据
    //theme:图表的主题名称
    
	//x坐标轴数据对应的属性名
	xField:
	//依据x坐标轴数据得到x坐标轴显示标签的方法名
	xLabelMethod:
	//报表曲线数据，可能有多条
	series:[{
		//序列数据对应的字段名
        serieField:,
        //序列的呈现类型——柱状图、折线图等
        serieType:,
        //使用第二y轴，只能设置为”y”和”y2”，如果不设置，默认使用y轴
        vAxis:
    },….],
    //指示器显示的标签内容的方法名
    indicatorLabelMethod:
    事件
        继承cq/app/widgets/_WidgetBase
        重写cqRefresh方法，刷新报表显示
        若之前已存在报表，销毁原有报表
        加载数据
        从数据中提取各个序列数据
        依据series中序列的个数创建报表横坐标轴和纵坐标轴，所有的序列共用一个x坐标轴
        向报表中添加序列

*/
//加载数据
            //处理数据
            //根据配置生成图形的坐标轴，设置坐标显示名称
            //插入相关数据，生成图形
            //处理图形区域的显示
//处理是否显示图标来指明具体序列序列
    var props = "'dataProvider:\"{dataProvider}\","+
        "dataMethod:\"{dataMethod}\",enableLegend:\"{enableLegend}\",dataOptions:{j:dataOptions},"+
        "xField:\"{xField}\","+
        "xLabelMethod:\"{xLabelMethod}\","+
        "theme:{j:theme},series:{j:series},indicatorLabelMethod:\"{indicatorLabelMethod}\"'";
    
    return declare('',[_WidgetBase,cqWidgetBase],{
        themes:{
            // 3D的样式
            Julie:"Julie", 
            ThreeD:"ThreeD",
            Chris:"Chris",
            Tom:"Tom",
            Claro:"Claro",
            PrimaryColors:"PrimaryColors",
            Electric:"Electric",
            Charged:"Charged",
            Renkoo:"Renkoo",
            // 经典的样式
            Adobebricks:"Adobebricks",
            Algae:"Algae",
            Bahamation:"Bahamation",
            BlueDusk:"BlueDusk",
            CubanShirts:"CubanShirts",
            Desert:"Desert",
            Distinctive:"Distinctive",
            Dollar:"Dollar",
            Grasshopper:"Grasshopper",
            Grasslands:"Grasslands",
            GreySkies:"GreySkies",
            Harmony:"Harmony",
            IndigoNation:"IndigoNation",
            Ireland:"Ireland",
            MiamiNice:"MiamiNice",
            Midwest:"Midwest",
            Minty:"Minty",
            PurpleRain:"PurpleRain",
            RoyalPurples:"RoyalPurples",
            SageToLime:"SageToLime",
            Shrooms:"Shrooms",
            Tufte:"Tufte",
            WatersEdge:"WatersEdge",
            Wetland:"Wetland",
            
            // 带背景色的样式
            blue:"PlotKit/blue",
            cyan:"PlotKit/cyan",
            green:"PlotKit/green",
            orange:"PlotKit/orange",
            purple:"PlotKit/purple",
            red:"PlotKit/red"
            
        }, 
        
        dataProvider:'',
        
        
        dataOptions:{},
        
        
        dataMethod:'',
        
        
        xField:'',
        
        
        xLabelMethod:'',
        
        
        series:[],
        
        indicatorLabelMethod:'',
        
        //是否显示序列标志,默认为false
        enableLegend:false,
        
        //当前是否是在创建节点视图，默认为false
        isCreateView:false,
        
        
        htmlTemp:'<div id="{id}"  class="cq-field-input cq-from-Chart {className}" data-dojo-type="cq/widgets/chart/Chart" data-dojo-props='+props+'><div style=""></div></div>',
        
        buildRendering:function(){
            this.enableLegend = this.enableLegend!==''&&this.enableLegend!==false&&this.enableLegend!=='false';
            this.inherited(arguments);
            this._initChartAndGetData();
        },
        _initChartAndGetData:function(){
            if(!this.isCreateView){
                this.isCreateView = true;
                var layoutData = this.getLayoutData();
                //数据加载完成后依据数据生成视图
                if(layoutData){
                    if(layoutData.then){
                        layoutData.then(lang.hitch(this,this._initChartView));
                    }else{
                        this._initChartView(layoutData);
                    }
                }else{
                    this.isCreateView = false;
                }
            }
        },
        getLayoutData:function(){
            var dataOptions = lang.hitch(this.dataOptions);
            if(this.dataProvider&&this.dataMethod){
                if(lang.isString(this.dataProvider)){
                    var def = new Deferred();
                    require([this.dataProvider],lang.hitch(this,function(dataProvider){
                        this.dataProvider = dataProvider;
                        var data = this.dataProvider[this.dataMethod](this.cqRefInfo,this,dataOptions);
                        if(data&&data.then){
                            data.then(function(result){
                                def.resolve(result);
                            });
                        }else{
                            def.resolve(data);
                        }
                    }));
                    return def;
                }else{
                    return this.dataProvider[this.dataMethod](this.cqRefInfo,this,dataOptions);
                }
            }else{
                if(this.dataProvider){
                    require([this.dataProvider],lang.hitch(this,function(dataProvider){
                        this.dataProvider = dataProvider;
                    }));
                }
                return this.inherited(arguments);
            }
        },
        _initChartView:function(item){
            if(item.items){
                item = item.items;
            }
            this.datas = item;
            //根据series来建立报表曲线数据数组，可能有多条
            var seriesArrays = lang.clone(this.series);
            array.forEach(seriesArrays,lang.hitch(this,function(seriesArray){
                var field = seriesArray.serieField;
                seriesArray.data=[];
                array.forEach(item,lang.hitch(this,function(data){
                    seriesArray.data.push(data[field]);
                }));
            }));
            //创建报表所放位置的dom节点
            if(!this.charNode){
                this.chartNode = domConstruct.create('div',{
                    className:"Chart",
                },this.domNode,"last");
            }
            //创建报表曲线
            
            var chart = this._chart = new Chart(this.chartNode);
            var createY2 = false;
            var maxYNumber=0,maxY2Number=0;
            this.isSetPlotY = false;
            this.isSetPlotY2 = false;
            //依据配置项创建相应的报表样式,样式默认项为柱形图,
            array.forEach(seriesArrays,function(seriesArray,index){
                if(seriesArray.vAxis =="y2"){
                    if(!this.isSetPlotY2){
                        chart.addPlot("default2", {
                            type: seriesArray.serieType,
                            gap: 10,
                            hAxis: "x",
                            vAxis: "y2"
                        }); 
                        this.isSetPlotY2 = true;
                    }
                    
                }else{
                    if(!this.isSetPlotY){
                        chart.addPlot("default", {
                            type: seriesArray.serieType,
                            gap: 10,
                            hAxis: "x",
                            vAxis: "y"
                        }); 
                        this.isSetPlotY = true;
                    }
                }
                
                //如果不为默认值，依据配置样式生成样式并生成图形
                if(seriesArray.vAxis =="y2"){
                    createY2 = true;
                    maxY2Number = maxY2Number>Math.max.apply(this, seriesArray.data)?maxY2Number: Math.max.apply(this, seriesArray.data);
                    
                }else{
                    maxYNumber = maxYNumber>Math.max.apply(this, seriesArray.data)?maxYNumber: Math.max.apply(this, seriesArray.data);
                    
                }
                
                chart.addSeries(seriesArray.serieLabel,seriesArray.data,{
                    plot:seriesArray.vAxis=="y2"?"default2":'default'
                });
            },this);
            //生成报表图形的刻度线
            chart.addAxis("x", {
                title:this.xField,
                enableCache: true,
                htmlLabels: true,
                dirty:true,
                titleOrientation: "orientation",
                font: "normal normal normal 11pt Helvetica",
                fixUpper: "major",
                includeZero: "true",
                fixLower: "major",
                majorTickStep: 10,
                minorTickStep: 1,
                labelFunc: lang.hitch(this, function(v){
                   return this.dataProvider[this.xLabelMethod](item,v); 
                })
            });
            chart.addAxis("y", {
                title:"", 
                titleGap: 50,
                dirty:true,
                vertical: true, 
                includeZero: true,
                font: "normal normal normal 11pt Helvetica",
                natural: true,
                fixed:false,
                //max:200000*5,
                majorTickStep:Math.round(maxYNumber/5),
                minorTickStep:Math.round(maxYNumber/5)
            });
            if(createY2){
                chart.addAxis("y2", {
                    leftBottom: false,
                    title:"", 
                    titleGap: 50,
                    dirty:true,
                    vertical: true, 
                    font: "normal normal normal 11pt Helvetica",
                    includeZero: true,
                    natural: true,
                    fixed:false,
                    fixLower: "major",
                    fixUpper: "major",
                    majorTickStep:maxY2Number/5,
                    minorTickStep:maxY2Number/5
                });
            }
            if(typeof(this.theme)!=="string"){
                chart.setTheme(new Theme(this.theme));
                this.initInteractor(chart,seriesArrays);
            }else{
                if(!this.themes[this.theme]){
                    console.log("不支持该样式");
                    return;
                }else{
                    require([
                        "dojox/charting/themes/"+this.themes[this.theme]
                    ],lang.hitch(this,function(curTheme){
                        chart.setTheme(curTheme);
                        this.initInteractor(chart,seriesArrays);
                    })); 
                }
                
            }
        },
        initInteractor:function(chart,seriesArrays){
            
            this.interactor2 = new Indicator(chart, "default", {
                series: seriesArrays[0].serieLabel,
                dualIndicator: true,
                font: "normal normal bold 12pt Helvetica",
                lineOutline: null,
                outline: null,
                markerOutline: null,
                labelFunc: lang.hitch(this,this.indicatorLabelFunc)
            });
            chart.render();
            //创建报表标志
            if(this.enableLegend){
                this.legend = new Legend({
                    chartRef:this._chart
                });
                if(!this.legendNode){
                    this.legendNode = domConstruct.create('div',{
                        'class':'legend',
                        'style':'',
                    },this.domNode,'first');
                }
                this.legend.placeAt(this.legendNode,'last');
            }
            this.isCreateView = false;
            
        },
        indicatorLabelFunc:function(info){
            return this.dataProvider[this.indicatorLabelMethod](this.datas[info.x-1]);
            //this.datas[info.x]?this.dataProvider[this.indicatorLabelMethod](this.datas[info.x-1]):this.dataProvider[this.indicatorLabelMethod](this.datas[info.x-1]);
        },
        cqRefresh:function(){
            if(this._chart){
                this._chart.destroy();
            }
            if(this.legend){
                this.legend.destroy();
            }
            this._initChartAndGetData();
        }
    });
});