define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "./Table",
    "cq/app/widget/_WidgetBase",
    "cq/app/widget/utils/listLayout"
],function(declare,lang,Table,WidgetBase,listLayout){
    var props = "dataOptions:{dataOptions},dataProvider:{dataProvider},dataMethod:{dataMethod},rowFields:{rowFields},columnFields:{columnFields},qtyFields:{qtyFields}";
    return declare("",[Table,WidgetBase],{
        htmlTemp:'<div data-dojo-type="cq/widgets/chart/DataTable" data-dojo-props="'+props+'"></div>',
        //数据源
        dataProvider:"",
        //取数据的方法
        dataMethod:"",
        //行字段
        rowFields:"",
        //列字段
        columnFields:"",
        //值字段
        qtyFields:"",
        dataOptions:null,
        buildRendering:function(){
            this.inherited(arguments);
            if(this.dataProvider&&"string"===typeof(this.dataProvider)){
                require([
                    this.dataProvider
                ],lang.hitch(this,this._dataProviderLoad));
            }
        },
        _getFormatFields:function(fields){
            return fields?listLayout.initFieldFormatter(this.dataProvider.getFormItems(fields.split(","))):[];
        },
        _dataProviderLoad:function(dataProvider){
            this.dataProvider = dataProvider;
            if(this.dataProvider.getFormItems&&(this.rowFields||this.columnFields||this.qtyFields)){
                this.rows = this._getFormatFields(this.rowFields);
                this.columns = this._getFormatFields(this.columnFields);
                this.qtys = this._getFormatFields(this.qtyFields);
            }
            if(this.refreshOnReady){
                this.cqRefresh();
            }
        },
        cqRefresh:function(){
            if(this.dataProvider&&this.dataProvider[this.dataMethod]){
                if(this.dataDef){
                    this.dataDef.remove();
                }
                this.dataDef = this.defer(this._loadData,300);
            }else{
                this.refreshOnReady = true;
            }
        },
        _loadData:function(){
            var res = this.dataProvider[this.dataMethod](this.cqRefInfo,this,this.dataOptions);
            if(false===res){
                return;
            }else if(res.then){
                res.then(lang.hitch(this,function(data){
                    this.setData(data.items||data);
                }));
            }else{
                this.setData(res.items||res);
            }
        }
    });
});