﻿define([
    
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "cq/app/widget/_WidgetBase",
    "cq/widgets/Map"
],function(declare,lang,domStyle,cqWidgetBase,MapBase){
    
    return declare("",[MapBase,cqWidgetBase],{
        
        htmlTemp:'<div id="{id}" data-cq-field="{field}" class="cq-field-input cq-from-heatMap" data-dojo-type="cq/widgets/chart/HeatMap" data-dojo-props="field:\'{field}\',dataProvider:\'{dataProvider}\',amountField:\'{amountField}\',lonField:\'{lonField}\',latField:\'{latField}\',dataMethod:\'{dataMethod}\',mapZoom:\'{mapZoom}\'"></div>',

        //数据源
        dataProvider:"",
        
        //数量字段 
        amountField:"",
        
        // 经度
        lonField:"",
        
        //纬度
        latField:"",
        
        //通过数据源读取数据的接口方法
        dataMethod:"",
		
		mapZoom:8,
        
        //创建热力图
        buildRendering:function(){
            this.inherited(arguments);
            this.mapZoom=8;
            //创建地图
            this.initMapElement();
            this.cqRefresh();
            
        },
        // 通过数据源加载数据
        cqRefresh:function(){
            if(this.dataProvider){
                if(lang.isString(this.dataProvider)){
                    require([this.dataProvider],lang.hitch(this,function(dataProvider){
                        this.dataProvider = dataProvider;
                        this._initData();
                    }));
                }else{
                    this._initData();
                }    
            }
        },
        
        // 初始化高德地图及其工具栏，覆盖层
        initMapElement:function(){
            this.inherited(arguments);
            // 地图主题
            this.map.setMapStyle("dark");
            // 地图显示的内容
            this.map.setFeatures(["bg","road","building","point"]);
            // 区域高亮
            this.markCity("重庆市",this.map);
		},
        // 初始化数据
        _initData:function(){
            var data = this.dataProvider[this.dataMethod](this.cqRefInfo,this);
            if(data && data.then){
                data.then(lang.hitch(this,function(result){
                    this.heatDatas = result;
                    if(this.map&&this.heatMap){
                        this.setheatMapData();
                    }else if(this.map){
                        this.initMapPaneMarks();
                    }
                    
                }));
            }else{
                this.heatDatas = data;
                if(this.map&&this.heatMap){
                    this.setheatMapData();
                }else if(this.map){
                    this.initMapPaneMarks();
                }
            }
        },
        resize:function(){
            domStyle.set(this.domNode,"height","100%");
        },
        onTouchStart:function(e){
			//event.stop(e);
            return;
		},
    });
});