define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/Deferred",
    "dojo/DeferredList",
    "dojo/query",
    "dijit/_WidgetBase",
    "dojox/mobile/Pane",
    "cq/app/widget/_WidgetBase",
    "cq/widgets/Map"
],function(array,declare,lang,domConstruct,domStyle,Deferred,DeferredList,query,_WidgetBase,Pane,cqWidgetBase,MapBase){
    
    return declare("",[MapBase,cqWidgetBase],{
        
        htmlTemp:'<div id="{id}" data-cq-field="{field}" class="cq-field-input cq-from-markMap" data-dojo-type="cq/widgets/chart/MarkMap" data-dojo-props=\'field:"{field}",highLightCity:"{highLightCity}",highLightLevel:"{highLightLevel}",dataProvider:"{dataProvider}",typeField:"{typeField}",lonField:"{lonField}",latField:"{latField}",dataMethod:"{dataMethod}",markOption:{j:markOption},titleField:"{titleField}",markclickMethod:"{markclickMethod}",center:{j:center},reloadOnScale:"{reloadOnScale}",reloadOnMove:"{reloadOnMove}",isShow:"{isShow}",initWebForm:"{initWebForm}",fixedForm:{fixedForm}\'>',

        dataProvider:"",
		
		//需要高亮的城市
		highLightCity:"",
		//城市级别
		highLightLevel:"city",
        
        dataMethod:"",
        
        lonField:"",
        
        latField:"",
        //不同类型的数据显示的mark可能不同
        typeField:"",       
        //不同类型的数据呈现的mark的配置项
        markOption:null,      
        // mark上显示标题时标题对应的属性名
        titleField:"",      
        // 数据点击之后数据提供者提供的处理函数
        markclickMethod:"markClick",     
        //默认中心点
        center:null,          
        //缩放时重现加载数据
        reloadOnScale:"",   
        //移动地图中心点时重新加载数据
        reloadOnMove:"",
        
        // 鼠标移入时是否显示webForm
        isShow:false,
        // 鼠标移入事件处理函数
        initWebForm:"",
        // 地图显示的内容
        features:["bg","road","building","point"],
        
        //固定窗体类型
        fixedForm:[],
        //创建组件
        buildRendering:function(){
            this.inherited(arguments);
            this.reloadOnScale = true===this.reloadOnScale;
            this.reloadOnMove = true===this.reloadOnMove;
            this.initMapElement();
            this.cqRefresh();
        },
        onTouchStart:function(){
            return;
        },
        // 通过数据源加载数据
        cqRefresh:function(){
            //this.clear();
            if(this.dataProvider){
                if(lang.isString(this.dataProvider)){
                    require([this.dataProvider],lang.hitch(this,function(dataProvider){
                        this.dataProvider = dataProvider;
                        this._loadData();
                            
                    }));
                }else{
                    this._loadData();
                }    
            }
        },
         _loadData:function(){
            //但数据获取出错时 if(this.isBusy) return 会让后续的数据加载出错
            //if(this.isBusy) return;
			this.isBusy = true;
            var data = this.dataProvider[this.dataMethod](this.cqRefInfo,this,{
                center:"",
                scaleLevel:this.scaleLevel,//this.getZoom(),
                oldScaleLevel:this.oldScaleLevel,
                Bounds:this.getLimit(),
                district:""
            });
            
            if(data && data.then){
                data.then(lang.hitch(this,function(result){
                    //this.value = result.items;
                    this._markerData(result,this.map);
                    //this.oldScaleLevel = this.scaleLevel;    
                }));
                
            }else{
                //this.value = data.items;
                this._markerData(data,this.map);
                //this.oldScaleLevel = this.scaleLevel;
            }
        },
        initMapElement:function(){
            this.inherited(arguments)
			
                // 地图主题
                this.map.setMapStyle("light");
                // 地图显示的内容
                this.map.setFeatures(this.features);
                // 区域高亮
				if(this.highLightCity){
					this.markCity(this.highLightCity,this.map);
                }
                AMap.event.addListener(this.map,"moveend",lang.hitch(this,function(){
                    this.closeInfoWindow();
                    if(this.reloadOnMove){
                        clearTimeout(this.moveTimer);
                        this.moveTimer = setTimeout(lang.hitch(this,this.cqRefresh),500);
                    }
                }));
                AMap.event.addListener(this.map,"zoomend",lang.hitch(this,function(){
                    //this.closeInfoWindow();
                    clearTimeout(this.moveTimer);
                    this.moveTimer = setTimeout(lang.hitch(this,this.onScale),500);
                }));
			
            this.scaleLevel = this.map.getZoom();
		},
        
        _markerData:function(data,map1){
			this.isBusy = false;
            if(!data){
                return ;
            }
            if(data.items){
                data = data.items;
            }
            this.value = data;
            
            this.clearAllMarks();
            
            var dataLat,dataLon;
            array.forEach(data,lang.hitch(this,function(item){
                dataLat = item[this.latField];
                dataLon = item[this.lonField];
                if(!dataLat||!dataLon){
                    return;
                }
                var icon = this.markOption[item[this.typeField]]||{};
                if(!icon.src){
                    icon.src = "http://webapi.amap.com/theme/v1.3/markers/n/mark_b.png";
                }
                
                var marker = this.addMark({
                    lon:dataLon,
                    lat:dataLat,
                    iconInfo:icon
                });
                var markerInfo = lang.clone(item);
                markerInfo.markerType = item[this.typeField]
                //onmouseover
                marker._cqMarkEventHandlers = [AMap.event.addListener(marker, 'click', lang.hitch(this,function(){
                    if(lang.isString(this.dataProvider)){
                        require([this.dataProvider],lang.hitch(this,function(dataProvider){
                            this.dataProvider = dataProvider;
                            this.dataProvider[this.markclickMethod](markerInfo,this);
                        }));
                    }else{
                        this.dataProvider[this.markclickMethod](markerInfo,this);
                    }
                }))];
                
                // 固定窗体 和点击显示窗体
                if(this.isShow){
                    if(this.fixedForm.length>0){
                        for(var i=0;i<this.fixedForm.length;i++){
                            if(markerInfo.markerType===this.fixedForm[i]){
                                marker.setLabel({//label默认蓝框白底左上角显示，样式className为：amap-marker-label
                                    offset: new AMap.Pixel(-20, -25),//修改label相对于maker的位置
                                    content: this.dataProvider[this.initWebForm](markerInfo,this)
                                });  
                            }else{
                                marker._cqMarkMouseoverHandlers = [AMap.event.addListener(marker, 'click', lang.hitch(this,function(){
                                    console.log("鼠标移入事件触发");
                                    if(!this.webform){
                                        this.infoWindow(markerInfo);
                                    }
                                }))];
                            }
                        }
                    }else{
                        marker._cqMarkMouseoverHandlers = [AMap.event.addListener(marker, 'click', lang.hitch(this,function(){
                            //console.log("鼠标移入事件触发");
                            if(!this.webform){
                                this.webform = this.infoWindow(markerInfo);
                                this.webform.open(map1,marker.getPosition());    
                            }
                        }))];
                         
                    }                    
                }
            }));
        },
        getZoom:function(){
			return this.map.getZoom();
		},
         // 鼠标滑动后的响应事件
        onScale : function(){
            this.scaleLevel= this.getZoom();
            if(this.oldScaleLevel&&this.oldScaleLevel===this.getZoom()){
                this.oldScaleLevel = this.getZoom();
                return;
            }
            if(this.reloadOnScale){
                this.cqRefresh();
            }
            //this.cqRefresh();
            this.oldScaleLevel = this.scaleLevel;
            //console.log("地图缩放触发");
        },
        // 定义一个高德地图信息窗体
        infoWindow : function(markInfo){
            var info = "";//document.createElement("div");
            var close;
            //info.className = "info";
            var webFormHtml;
            if(lang.isString(this.dataProvider)){
                require([this.dataProvider],lang.hitch(this,function(dataProvider){
                    this.dataProvider = dataProvider;
                    webFormHtml = this.dataProvider[this.initWebForm](markInfo,this);
                }));
            }else{
                webFormHtml = this.dataProvider[this.initWebForm](markInfo,this);
            }
            if(webFormHtml&&webFormHtml.then){
                webFormHtml.then(lang.hitch(function(wfHtml){
                    //info.innerHTML = wfHtml;
                    info = wfHtml;
                }));
            }else{
                info = webFormHtml;
               
            }
            
            var infoWindowNode = this.showInfoWindow("","",markInfo.lon,markInfo.lat,0,-20);
            infoWindowNode.setContent(info);
        },
       
        getLimit:function(){
            var limitMapData = this.map.getBounds()
            var limitData = {northeast:{lon:"",lat:""},southwest:{lon:"",lat:""}};
            limitData.northeast= {lon:limitMapData.northeast.lng,lat:limitMapData.northeast.lat};
            limitData.southwest= {lon:limitMapData.southwest.lng,lat:limitMapData.southwest.lat};
            return limitData;
        },
        resize:function(){
            domStyle.set(this.domNode,"height","100%");
        }
    });
});