define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-attr",
    "dijit/_WidgetBase",
    "dojo/dom-construct"
],function(declare,lang,array,domAttr,_WidgetBase,domConstruct){
    /**
        //测试数据:
            t.setData([{
                dept:"东北",
                dept1:"黑龙江",
                so:"超市",
                qty:100
            },{
                dept:"东北",
                dept1:"吉林",
                so:"超市",
                qty:20
            },{
                dept:"东北",
                dept1:"吉林",
                so:"超市",
                qty:30
            },{
                dept:"东北",
                dept1:"吉林",
                so:"母婴",
                qty:20
            },{
                dept:"东北",
                dept1:"辽宁",
                so:"超市",
                qty:20
            },{
                dept:"华北",
                dept1:"北京",
                so:"超市",
                qty:2000
            },{
                dept:"华北",
                dept1:"河北",
                so:"超市",
                qty:20
            },{
                dept:"华北",
                dept1:"北京",
                so:"母婴",
                qty:50
            }]);
        //场景1：多行字段，无列字段，一个或多个值字段
            t.qtys = [{
                field:"qty",
                label:"数量"
            }
            //,{field:"amount",label:"金额"}
            ];
            t.rows = [{
                field:"dept",
                label:"大区"
            },{
                field:"dept1",
                label:"省区"
            },{
                field:"so",
                label:"渠道"
            }];
        //场景2：多行字段，一个或多个列字段，一个或多个值字段
            t.qtys = [{
                field:"qty",
                label:"数量"
            }
            //,{field:"amount",label:"金额"}
            ];
            t.rows = [{
                field:"dept",
                label:"大区"
            },{
                field:"dept1",
                label:"省区"
            }];
            t.columns = [{
                field:"so",
                label:"渠道"
            }]
        //场景3：没有行字段，一个或多个列字段，一个或多个值字段
            t.qtys = [{
                field:"qty",
                label:"数量"
            }
            ,{field:"amount",label:"金额"}
            ];
            t.rows = [];
            t.columns = [{
                field:"dept",
                label:"大区"
            },{
                field:"so",
                label:"渠道"
            }]
    **/
    return declare("",[_WidgetBase],{
        baseClass:"table-rpt",
        //行字段，不能和列字段同时为空
        //示例:[{field:"groupName",label:"分类"},{field:"mName",label:"商品"},{field:"grade",label:"等级",options:{"1":"一级","2":"二级","5":"特级"}}]
        rows:null,
        //列字段，不能和行字段同时为空，支持options枚举值
        //示例:[{field:"deptName",label:"部门"}]
        columns:null,
        //值字段，对象数组，不能为空或零长度数组，支持options枚举值
        //示例:[{field:"qty",label:"销量"},{field:"amount",label:"销售额"},{field:"disAmount",label:"优惠金额"}]
        qtys:null,
        dataHash:null,
        buildRendering:function(){
            this.inherited(arguments);
            this.contentNode = this.contentNode||this.domNode;
            dojo.connect(this.contentNode, 'onclick', lang.hitch(this, this.onClick));
        },
        //初始化属性，确保格式一致
        _initProps:function(){
            if(!this.qtys){
                return false;
            }
            if(!(this.qtys instanceof Array)){
                this.qtys = [this.qtys];
            }
            if(this.rows&&!(this.rows instanceof Array)){
                this.rows = [this.rows];
            }else{
                this.rows = this.rows||[];
            }
            if(this.columns&&!(this.columns instanceof Array)){
                this.columns = [this.columns];
            }else{
                this.columns = this.columns||[];
            }
            if(this.rows&&this.rows.length||this.columns&&this.columns.length){
                return true;
            }
            return false;
        },
        //设置数据，依据数据刷新显示
        setData:function(items){
            if(!this._initProps()){
                return;
            }
            this.dataHash = {};
            if(items&&items.length){
                var data = this.getMatrix(items);
                this.setContent(this.getContentByMatrix(data));
            }else{
                this.setContent('<div class="rpt-info">该时间段没有数据</div>');
            }
        },
        onClick:function(event){
            var target = event.target;
            while(target && (target.tagName != "TD")){
                target = target.parentNode;
            }
            var name = domAttr.get(target, "name");
            if(name){
                this.onCqChanged(this,this.dataHash[name]);
            }else{
                return null;
            }
        },
        setContent:function(html){
            this.contentNode.innerHTML = html;
        },
        //数据转成矩阵形式，行、列、各个指标值
        getMatrix:function(items){
            if(!(items&&items.length)){
                return null;
            }
            var data = {
                rows:[],
                columns:[],
                hash:{}
            };
            this.cdatas = [];
            var rowHash = {},columnHash = {},qtyHash = {};
            //行字段、列字段、值字段
            array.forEach(items,function(item, index){
                var field = "";
                this.cdatas[index] = [];
                var row = this.rows.map(function(row,idx){
                    //return row.options[item[row.field]];
                    var result = {
                        "field":row.field,
                        "label":row.formatter?row.formatter(item[row.field],item):row.options?row.options[item[row.field]]:item[row.field],
                        "value":item[row.field]
                    };
                    this.cdatas[index][idx] = this.cdatas[index]&&this.cdatas[index][idx - 1]?lang.clone(this.cdatas[index][idx - 1]):[];
                    this.cdatas[index][idx].push(result);
                    var hashName = this.cdatas[index][idx].map(function(hh){
                        return hh["label"];
                    }).join("-");
                    this.dataHash[hashName] = this.cdatas[index][idx];
                    return result.label;
                }, this);
                field = row.join("-");
                if(!rowHash[field]){
                    rowHash[field] = row;
                    data.rows.push(row);
                }
                var column = this.columns.map(function(row){
                    var result = {
                        "field":row.field,
                        "label":row.formatter?row.formatter(item[row.field],item):row.options?row.options[item[row.field]]:item[row.field],
                        "value":item[row.field]
                    };
                    this.cdatas[index][this.cdatas[index].length] = 
                        this.cdatas[index]&&this.cdatas[index][this.cdatas[index].length - 1]?
                            lang.clone(this.cdatas[index][this.cdatas[index].length - 1]):[];
                    this.cdatas[index][this.cdatas[index].length - 1].push(result);
                    var hashName = this.cdatas[index][this.cdatas[index].length - 1].map(function(hh){
                        return hh["label"];
                    }).join("-");
                    this.dataHash[hashName] = this.cdatas[index][this.cdatas[index].length - 1];
                    return result.label;
                }, this);
                field = column.join("-");
                if(!columnHash[field]){
                    columnHash[field] = column;
                    data.columns.push(column);
                }
                field = row.join("-")+(field?"-"+field:"");
                this.qtys.forEach(function(qty){
                    var result = {
                        "field":qty.field,
                        "value":qty.formatter?qty.formatter(item[qty.field],item):qty.options?qty.options[item[qty.field]]:item[qty.field],
                        "label":item[qty.field]
                    };
                    if(qty.type==="s"){
                        data.hash[field+"-"+qty.field] = item[qty.field];
                        if(!qtyHash[field + "-" + qty.field]){
                            qtyHash[field + "-" + qty.field] = index + "-" + this.cdatas[index].length;
                            this.cdatas[index][this.cdatas[index].length] = 
                                this.cdatas[index]&&this.cdatas[index][this.rows.length + this.columns.length - 1]?
                                    lang.clone(this.cdatas[index][this.rows.length + this.columns.length - 1]):[];
                            this.cdatas[index][this.cdatas[index].length - 1].push(result);
                            var hashName = this.cdatas[index][this.cdatas[index].length - 1].map(function(hh, idd){
                                return idd==this.cdatas[index][this.cdatas[index].length - 1].length-1?hh["field"]:hh["label"];
                            }, this).join("-");
                            this.dataHash[hashName] = this.cdatas[index][this.cdatas[index].length - 1];
                        }else{
                            var rowNum = qtyHash[field + "-" + qty.field].split("-")[0];
                            var columnNum = qtyHash[field + "-" + qty.field].split("-")[1];
                            this.cdatas[rowNum][columnNum][this.cdatas[rowNum][columnNum].length - 1] = result;
                            var hashName = this.cdatas[rowNum][columnNum].map(function(hh, idd){
                                return idd==this.cdatas[rowNum][columnNum].length-1?hh["field"]:hh["label"];
                            }, this).join("-");
                            this.dataHash[hashName] = this.cdatas[rowNum][columnNum];
                        }
                    }else{
                        data.hash[field+"-"+qty.field] = (data.hash[field+"-"+qty.field]-0)||0;
                        data.hash[field+"-"+qty.field] += (item[qty.field]-0)||0;
                        if(!qtyHash[field + "-" + qty.field]){
                            qtyHash[field + "-" + qty.field] = index + "-" + this.cdatas[index].length;
                            this.cdatas[index][this.cdatas[index].length] = 
                                this.cdatas[index]&&this.cdatas[index][this.rows.length + this.columns.length - 1]?
                                    lang.clone(this.cdatas[index][this.rows.length + this.columns.length - 1]):[];
                            this.cdatas[index][this.cdatas[index].length - 1].push(result);
                            var hashName = this.cdatas[index][this.cdatas[index].length - 1].map(function(hh, idd){
                                return idd==this.cdatas[index][this.cdatas[index].length - 1].length-1?hh["field"]:hh["label"];
                            }, this).join("-");
                            this.dataHash[hashName] = this.cdatas[index][this.cdatas[index].length - 1];
                        }else{
                            var rowNum = qtyHash[field + "-" + qty.field].split("-")[0];
                            var columnNum = qtyHash[field + "-" + qty.field].split("-")[1];
                            this.cdatas[rowNum][columnNum][this.cdatas[rowNum][columnNum].length - 1] = result;
                            this.cdatas[rowNum][columnNum][this.cdatas[rowNum][columnNum].length - 1]["value"] 
                                = this.cdatas[rowNum][columnNum][this.cdatas[rowNum][columnNum].length - 1]["label"] 
                                = data.hash[field + "-" + qty.field];
                            var hashName = this.cdatas[rowNum][columnNum].map(function(hh, idd){
                                return idd==this.cdatas[rowNum][columnNum].length-1?hh["field"]:hh["label"];
                            }, this).join("-");
                            this.dataHash[hashName] = this.cdatas[rowNum][columnNum];
                        }
                    }
                }, this);
            },this);
            return data;
        },
        //行数据转换为树形数据
        arrToTree:function(rows){
            var hash = {
                subs:[],
                subHash:{},
                span:0,
                key:""
            };
            array.forEach(rows,function(row,idx){
                if(!row.length){
                    return;
                }
                var item = hash;
                item.span++;
                for(var i=0;i<row.length;i++){
                    if(!item.subHash[row[i]]){
                        item.subHash[row[i]] = {
                            subs:[],
                            subHash:{},
                            value:row[i],
                            span:0,
                            key:(i===0?"":item.key+"-")+row[i]
                        };
                        item.subs.push(item.subHash[row[i]]);
                    }
                    item = item.subHash[row[i]];
                    item.span++;
                }
            },this);
            return hash;
        },
        //依据矩阵转换之后的数据生成表格
        getContentByMatrix:function(data){
            var content = "";
            if(data){
                data.rows = this.arrToTree(data.rows);
                data.columns = this.arrToTree(data.columns);
                this.genColumnRows(data);
                content += '<table>'+this.genHead(data)+this.genRows(data)+'</table>';
            }
            return content;
        },
        genColumnRows:function(data){
            //列是否按照指标展开
            var qtys = this.rows.length?this.qtys.length:1;
            var rows = this.columns.map(function(){
                return [];
            });
            //处理显示在列
            var toRows = function(item,deep){
                rows[deep].push({
                    value:item.value,
                    span:item.span*qtys,
                    key:item.key
                });
                item.subs.forEach(function(item){
                    toRows(item,deep+1);
                });
            };
            data.columns.subs.forEach(function(item){
                toRows(item,0);
            });
            //处理多指标
            if(qtys!==1||0===this.columns.length){
                qtys = this.qtys.map(function(qty){
                    return {
                        value:qty.label,
                        span:1
                    };
                });
                var row = [];
                if(rows.length){
                    data.columnKeys = [];
                    var i,getKey = function(qty){
                        return rows[rows.length-1][i].key+"-"+qty.field;
                    };
                    for(i=0;i<rows[rows.length-1].length;i++){
                        row = row.concat.apply(row,qtys);
                        if(this.rows.length){
                            data.columnKeys = data.columnKeys.concat.apply(data.columnKeys,this.qtys.map(getKey));
                        }else{
                            data.columnKeys.push(rows[rows.length-1][i]);
                        }
                    }
                }else{
                    row = qtys;
                    data.columnKeys = this.qtys.map(function(column){
                        return column.field;
                    });
                }
                rows.push(row);
            }else if(this.rows.length){
                data.columnKeys = array.map(rows[rows.length-1],function(column){
                    return column.key+"-"+this.qtys[0].field;
                },this);
            }else{
                data.columnKeys = array.map(rows[rows.length-1],function(column){
                    return column.key;
                },this);
            }
            data.columnRows = rows;
        },
        //生成表格的前几行——标题部分的html片段
        genHead:function(data){
            return "<tr>"+(this.rows.length?this.rows.map(function(row){
                return '<th rowspan="'+data.columnRows.length+'">'+row.label+'</th>';
            }).join(""):(this.qtys.length>1?'<th rowspan="'+data.columnRows.length+'"></th>':""))+array.map(data.columnRows,function(row,idx){
                return array.map(row,function(column){
                    var label = column.value;
                    if(idx<this.columns.length&&this.columns[idx].options){
                        label = this.columns[idx].options[column.value]||"";
                    }
                    return '<th colspan="'+column.span+'">'+label+'</th>';
                },this).join("");
            },this).join('</tr><tr>')+'</tr>';
        },
        //生成表格数据所在行的html片段
        genRows:function(data){
            var qtyField = "";
            //指标在列
            var getRow = function(item, index){
                var pre = item.key?'<td rowspan="'+item.span+'" name="' + item.key + '">'+item.value+'</td>':"";
                if(!item.subs.length){
                    var str = pre;
                    array.forEach(data.columnKeys, function(key, idx){
                        str += '<td name="' + item.key + '-' + key + qtyField + '">';
                        str += data.hash[item.key+"-"+key+qtyField]||"0";
                        str += '</td>'
                    });
                    return str;
                    //return pre+'<td>'+data.columnKeys.map(function(key, idx){
                    //    return data.hash[item.key+"-"+key+qtyField]||"0";
                    //}).join('</td><td>')+'</td>';
                }else{
                    return pre+array.map(item.subs,getRow,this).join('</tr><tr>');
                }
            };
            if(this.rows.length){
                return '<tr>'+array.map(data.rows.subs,getRow,this).join('</tr><tr>')+'</tr>';
            }else if(this.qtys.length>1){
                //指标在行
                return this.qtys.map(function(qty, index){
                    qtyField = "-"+qty.field;
                    return '<tr><td>'+qty.label+'</td>'+getRow({
                        subs:[],
                        key:""
                    })+'</tr>';
                }).join("");
            }else{
                qtyField = "-"+this.qtys[0].field;
                return '<tr>'+getRow({
                    subs:[],
                    key:""
                }).join("")+'</tr>';
            }
        }
    });
});