﻿define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dijit/_WidgetBase",
    "dojox/mobile/Rating",
    "cq/util/sys/date",
    "cq/widgets/bigImg",
    "dojo/query",
    "dojo/dom-attr",
    "cq/util/config/config",
    "cq/util/image/blob"
],function(declare,array,domConstruct, domStyle,_WidgetBase,Rating, date, bigImg, query, domAttr, config, blob){
    var onImageLoad = function () {
        var width = domStyle.get(this.parentNode, "width");
        var size = {};
        if (this.naturalHeight > this.naturalWidth) {
            size["margin-top"] = (this.naturalWidth - this.naturalHeight) / 2 * width / this.naturalWidth + "px";
            size.width = width + "px";
        } else {
            size["margin-left"] = (this.naturalHeight - this.naturalWidth) / 2 * width / this.naturalHeight + "px";
            size.height = width + "px";
            size.width = "";
        }
        domStyle.set(this, size);
        domStyle.set(this.parentNode, "height", width + "px");
    };
    return declare("cq.widgets.item.MatEvalItem", [_WidgetBase], {
        baseClass:"timeLine-list-item",
        params:null,
        myMatEva: false,
        _getUserIcon: function(logo){
            return logo|| config.defultUserLogo;
        },
        isC: true,
        buildRendering:function(){
            this.inherited(arguments);
            // 创建商品信息
            var titleNode = domConstruct.create("div", {
                "class": "time-line-title"
            }, this.domNode);
            if(!this.myMatEva){
                domConstruct.create("a", {
                    "class" : "time-line-logo",
                    href: this.isC?("#villager-"+this.params.userId._id):("#customer-"+this.params.userId._id),
                    innerHTML : "<img src='" + this._getUserIcon(this.params.userId.logo) + "'>"
                }, titleNode);
                if(this.params&&this.params.userId&&this.params.userId.isAut){
                    domConstruct.create("img", {
                        src: "./images/temp/tool/aut-tag.png",
                        "class": "user-aut-tag",
                        style: "left: 34px;width: 15px;bottom: 0;"
                    }, titleNode);
                }
            }
            
            domConstruct.create("div", {
                "class": "time-line-publisher",
                //this.params.userId.pName||this.params.userId.userName||
                // 除nickName以外的所有信息都是客户的隐私，因此不能显示给别人看
                innerHTML: (!this.myMatEva?("<p class='name'>"+(this.params.userId.nickName||"无名氏")+"</p>"):"")+
                            "<p class='date'>"+date.getTimeMoment(this.params.createAt)+"</p>"
            }, titleNode);
            // 添加星级评论
            var ratingNode = domConstruct.create("div",{}, titleNode);
            this.createRating(ratingNode, this.params.score);
            
            // 添加用户的评价内容
            domConstruct.create("div", {
                "class" : "time-line-content",
                innerHTML : this.params.content||""
            }, this.domNode);
            
            if(this.params.images.length){
                var imagesNode = domConstruct.create("div", {
                    "class": "time-line-photo",
                    style: "margin-bottom:10px;"
                }, this.domNode);
                array.forEach(this.params.images, function(image) {
                    var node = domConstruct.create("a", {
                        
                    }, imagesNode);
                    domConstruct.create("img", {
                        src: blob.getImageUrl(image,"160"),
                        onload: onImageLoad,
                        style: "width: 100%;max-width: none;",
                        realSrc: image
                    }, node);
                });
                
                // 如果当前数据有图片
                this.connect(imagesNode, "onclick",
                    function (e) {
                    var dom = e.target;
                    if(dom.tagName=="IMG"){
                        var src = query("img", imagesNode);
                        var index = 0;
                        var srcArr = array.map(src,
                                function (item, i) { //路径的数组对象
                                if (item == e.target) {
                                    index = i;
                                }
                                return {
                                    src: domAttr.get(item, "realSrc")
                                };
                            });
                        bigImg.show(srcArr, index);
                    }else{
                        return;
                    }
                });
            }
            this.createReplay();
            this.clickListMethod(this.domNode,this.params);
        },
        createReplay: function(){
            this.params.shopAdminReply?domConstruct.create("div",{
                innerHTML: '<p>[商家回复]  '+this.params.shopAdminReply+'</p>'+
                            '<p style="float:right;">'+date.formatISODateMinutes(this.params.shopAdminReplyDate)+'</p>',
                "class": "shop-replay"
            },this.domNode):null;
            //如果已经追评过，显示追评信息，不显示追评按钮
            this.params.userReply?domConstruct.create("div", {
                innerHTML: "<p>[追加评价] "+ this.params.userReply+"</p>"+
                        "<p style='float:right;'>"+date.formatISODateMinutes(this.params.userReplyDate)+"</p>",
                "class": "item"
            }, this.domNode):null;
        },
        // 添加图片
        createImages:function(domNode, images) {
            
        },
        // 创建星级评论
        createRating: function(domNode, score) {
            var scoreWidget = new Rating({
                image: "./images/temp/tool/star-orange.png",
                numStars: 5,
                value: score
            });
            domNode.appendChild(scoreWidget.domNode);
        },
        //创建点击列表事件
        clickListMethod:function(){
            
        }
    });
});