﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-construct",
    "dojo/on",
    "dijit/_WidgetBase",
    "cq/util/sys/date"
],function(declare,lang,array,domConstruct,on,_WidgetBase,date){
    return declare("cq.widgets.item.OrderListItem", [_WidgetBase], {
        baseClass:"order-list-item",
        params:null,
        detailsShowRefundState: true,
        //detailView: null,
        buildRendering:function(){
            this.inherited(arguments);
            var countQty = 0;
			this.userShopName = "";
            //var view = window.location.href.split("#")[1].split("-")[0];
            //this.detailView = (view=="orderList"?"orderDetail":view=="orderListB"?"orderDetailB":view=="orderListB2B"?"orderDetailB2B":view=="orderListB2BB"?"orderDetailB2BB":view=="orderListP"?"orderDetailP":"");
			if(this.params.userShopId&&(this.params.userShopId.companyName||this.params.userShopId.shopName)){
				if(this.params.userShopId.companyName&&this.params.userShopId.shopName&&(this.params.userShopId.companyName != this.params.userShopId.shopName)){
					this.userShopName = this.params.userShopId.companyName+"("+this.params.userShopId.shopName+")";
				} else {
					this.userShopName = this.params.userShopId.companyName||this.params.userShopId.shopName;
				}
			}
            this.createHeader();
            this.detailList = domConstruct.create("div",{
                "class":"order-detail-list"
            },this.domNode);
            array.forEach(this.params.details,function (detail){
                countQty+=detail.qty;
                if(this.params.refundState&&detail.refundState!=this.params.refundState){
                    detail.refundState=this.params.refundState;
                }
                //detail.isClosed = this.params.isClosed;
                this.detailList.appendChild(this.createDetails(detail));
            },this);
            this.countNode = domConstruct.create("div",{
                "class":"order-list-count",
                // innerHTML:"<span class='qty'>共"+countQty+"件商品</span>"+
                //     "<span class='count'>合计:￥<i>"+window.fixedTo(parseFloat(this.params.amount)+parseFloat(this.params.discountAmount||0),3)+"<i></span>"+
                //     "<span class='tAmount'>（含运费：￥"+window.fixedTo(this.params.tAmount,3)+"）</span>"
            },this.domNode);
            this.countNode.appendChild(this.createCountNode(countQty));
            this.createBtns();
            on(this.domNode, 'click', lang.hitch(this,function (e) {
                return this.getParent().onItemClick(this,e);
            }));
            //this.onListClick(this.detailList,this.params);
        },//添加运费信息，style.css新建tAmount样式   2016/7/8 徐阿雪
        //onListClick:function(dom,data){
        //    on(dom, 'click', lang.hitch(this,function () {
        //        window.moveToView(this.detailView, data._id);
        //    }));
        //},
        createBtns: function(){},
        createCountNode:function(countQty){
            //refundState in (2,3)时，需要标注是“退款中”或“已退款”，
            var htmlStr = "";
            htmlStr += "<span class='qty'>共"+countQty+"件商品</span>";
            htmlStr += "<span class='count'>合计:￥<i>"+window.fixedTo(parseFloat(this.params.amount)+parseFloat(this.params.discountAmount||0),3)+"<i></span>";
            htmlStr += "<span class='tAmount'>（含运费：￥"+window.fixedTo(this.params.tAmount,3)+"）</span>"
            return domConstruct.toDom(htmlStr);
        },
        createHeader: function(){
            //创建订单状态栏
            domConstruct.create("div",{
                "class":"order-list-status",
                innerHTML:                    
                    "<div class='order-supplyshop'><span>"+(this.params.fromShopName||"")+"</span></div>"
					+"<div class=''><span>创建时间："+
                    date.formatISODateMinutes(this.params.createAt)+
                    "</span>"+
                    "<span class='status'>"+this.getOrderStatus()+"</span></div>"
                    +"<div class='tsId'><span>订单号："+this.params._id+"</span></div>"
                    +"<div class='order-company none'><span>买家店铺："+this.userShopName+"</span></div>"
					+"<div class='order-inviter none'><span>业务经理："+(this.params.inviter?this.params.inviter.pName:"")+"</span><span style='float:right;padding-right:12px'>"+ (this.params.inviter?this.params.inviter.userName:"") +"</span></div>"                    
					+"<div class='order-dname none'><span>收货人："+this.params.details[0].dName+"</span><span style='float:right;padding-right:12px'>"+ this.params.details[0].dTel +"</span></div>"
					+"<div class='order-dAddress none'><span>收货地址："+this.params.details[0].dAddress+"</span></div>"                    
            },this.domNode);
        },
		
        //创建订单详情的列表
        createDetails:function(data){
            var refundMsg = "";
            if(this.params.refundState != 1){//&&this.params.refundState != 4
                if(data.refundState == 2){//this.params.isClosed
                    refundMsg = "退款中";
                }else if(data.refundState == 3){
                    refundMsg = "已退款";
                }else if(data.refundState == 4){//data.isPayed&&!data.isDelived&&
                    refundMsg = "退款关闭";
                }
            }
            var htmlStr = "";
            htmlStr+='<li class="order-detail-item">';
            htmlStr+=    '<img alt="" src="'+(data.mId?data.mId.logo:"")+'" class="icon" style="margin-top: 1px;">';
            htmlStr+=    '<div class="right item-info hflex_top hflex">';
            htmlStr+="<div class='flex1'>";
            htmlStr+='<div class="title"><span>'+(data.mName||(data.mId&&data.mId.mName||""))+'</span>'+(this.detailsShowRefundState?('<br><span class="price">'+refundMsg+'</span>'):'')+'</div>';
            htmlStr+= data.specName?"<p class='sku'>规格: "+data.specName+"</p>":"";
			htmlStr+= data.isCycle?'<p style="margin-top: 5px;display: inline-block;font-size: 12px;border: 1px solid #be2f28;color: #be2f28;padding: 0 2px;border-radius: 3px;margin-right:5px;">周期订单</p>':'';
            htmlStr+= data.preSaleId?'<p style="margin-top: 5px;display: inline-block;font-size: 12px;border: 1px solid #be2f28;color: #be2f28;padding: 0 2px;border-radius: 3px;">预售订单</p>':'';
            htmlStr+= this.params.pacTeamId?'<p style="margin-top: 5px;display: inline-block;font-size: 12px;border: 1px solid #be2f28;color: #be2f28;padding: 0 2px;border-radius: 3px;">拼团订单</p>':'';
            htmlStr+= data.isGift?'<p style="margin-top: 5px;display: inline-block;font-size: 12px;border: 1px solid #be2f28;color: #be2f28;padding: 0 2px;border-radius: 3px;">赠品</p>':'';
            htmlStr+="</div>";
            htmlStr+=        '<div class="priceArea"><span class="price">￥'+window.fixedTo(data.price,3)+'</span><span class="qty">x'+data.qty+'</span></div>';//<br>
            htmlStr+=    '</div>';
            htmlStr+='</li><div class="gap2"></div>';
            return domConstruct.toDom(htmlStr);
        },
        //获取订单的状态
        getOrderStatus:function(){
            // 将orderStatus的状态按照优先级显示已退款问题修复  2016/7/6  徐阿雪 
            // 已退款是根据主表的已支付和已取消来重新定义
            //退款后重新调整退款中的状态  2017/1/6
            var state = "",data = this.params;
            if(data.isPayed){
                //已付款
                if(data.isCanceled){
                    //已付款且已取消，则为已退款
                    state = "已退款";
                }else if(!data.isClosed&&data.refundState == 2){
                    state = "退款中";
                }/*else if(!data.isClosed&&data.refundState == 4){
                    state = "退款关闭";
                }*/else if(data.isDelived){
                    //已发货
                    if(data.isClosed){
                        //若已关闭，则为已完成
                        state = "已完成";
                    }else if(!data.isReceipted){
                        //若未收货，为待收货
                        state = "待收货";
                    }else{
                        //否则，待评价，评价完成之后会变成已完成
                        state = "待评价";
                    }
                }else{
                    //否则为待发货
                    state = "待发货";
                }
            }else{
                //未付款
                if(data.isCanceled){
                    //已取消
                    state = "已取消";
                }else{
                    //待付款
                    state = "待付款";
                }
            }
            return state;
        }
    });
});