﻿define([
    "dojo/_base/declare",
    "dojo/dom-construct",
    "cq/widgets/item/OrderListItem",
    "dojo/dom-class",
    "cq/util/image/blob"
],function(declare,domConstruct,listItem, domClass, blob){
    return declare("cq.widgets.item.OrderListItemC", [listItem], {
        createHeader: function(){
            //创建订单状态栏
            domConstruct.create("div",{
                "class":"o-t-title-shop",
                innerHTML: '<div class="icon">'+
                        '<img src="./images/temp/shopIcon.png">'+
                    '</div>'+
                    '<div class="title">'+
                        '<a >'+(this.params.fromShopName||"")+'</a>'+//href="#businessDetails-'+this.params.fromShopId+'"
                    '</div>'+
                    '<div class="status">'+this.getOrderStatus()+'</div>'
            },this.domNode);
        },
        //创建订单详情的列表
        createDetails:function(data){
            var htmlStr = "";
            htmlStr+='<li class="order-detail-item">';
            htmlStr+=    '<img alt="" src="'+(data.mId?blob.getImageUrl(data.mId.logo,"80"):"")+'" class="icon" style="margin-top: 1px;">';
            htmlStr+=    '<div class="right item-info hflex_top hflex">';
            htmlStr+= "<div class='flex1'>";
            htmlStr+= '<div class="title">'+(data.mName?data.mName:(data.mId&&data.mId.mName||""))+'</div>';
            htmlStr+= data.specName?'<p class="sku">规格: '+data.specName+'</p>':"";
			htmlStr+= data.isCycle?'<p style="margin-top: 5px;display: inline-block;font-size: 12px;border: 1px solid #be2f28;color: #be2f28;padding: 0 2px;border-radius: 3px;margin-right:5px;">周期订单</p>':'';
            htmlStr+= data.preSaleId?'<p style="margin-top: 5px;display: inline-block;font-size: 12px;border: 1px solid #be2f28;color: #be2f28;padding: 0 2px;border-radius: 3px;">预售订单</p>':'';
            htmlStr+= this.params.pacTeamId?'<p style="margin-top: 5px;display: inline-block;font-size: 12px;border: 1px solid #be2f28;color: #be2f28;padding: 0 2px;border-radius: 3px;">拼团订单</p>':'';
            htmlStr+= data.isGift?'<p style="margin-top: 5px;display: inline-block;font-size: 12px;border: 1px solid #be2f28;color: #be2f28;padding: 0 2px;border-radius: 3px;">赠品</p>':'';
            htmlStr+="</div>";
            htmlStr+=        '<div class="priceArea"><span class="price">￥'+window.fixedTo(data.price,3)+'</span><span class="qty">x'+data.qty+'</span></div>';//<br>
            htmlStr+=    '</div>';
            htmlStr+='</li><div class="gap2"></div>';
            return domConstruct.toDom(htmlStr);
        },
        //获取订单的状态
        getOrderStatus:function(){
            // 将orderStatus的状态按照优先级显示已退款问题修复  2016/7/6  徐阿雪 
            // 已退款是根据主表的已支付和已取消来重新定义
            // 退款后重新调整退款中的状态  2017/1/6
            // 添加预售订单的状态 2017/7/7
            var state = "",data = this.params;
            if(data.isPayed){
                //已付款
                if(data.isCanceled){
                    //已付款且已取消，则为已退款
                    state = "已退款";
                }else if(data.refundState==2){
                    state = "退款中";
                }else if(data.isDelived){
                    //已发货
                    if(data.isClosed){
                        //若已关闭，则为已完成
                        state = "已完成";
                    }else if(!data.isReceipted){
                        //若未收货，为待收货
                        state = "待收货";
                    }else{
                        //否则，待评价，评价完成之后会变成已完成
                        state = "待评价";
                    }
                    if(data.refundState&&data.refundState>2){
                        state = state + "(部分退款)";
                    }
                }else{
                    //if(!data.isClosed&&data.refundState&&data.refundState == 2){
                    //    state = "退款中";
                    //}else{
                        //否则为待发货
                        state = "待发货";
                    //}
                }
            }else{
                //未付款
                if(data.isCanceled){
                    //已取消
                    state = "已取消";
                }else{
                    // 判断是否预售订单
                    if(data.preSaleId){
                        if(data.isPreAmountPayed){
                            state = "待支付尾款";
                        }else{
                            state = "待支付定金";
                        }
                    }
                    else{
                        //待付款
                        state = "待付款";
                    }
                }
            }
            return state;
        }
        /*,
        createBtns: function(){
            var btn = domConstruct.create("div", {
                "class": "item-pay-btn2 none"
            }, this.domNode);
            domConstruct.create("div", {
                style: "flex:1;"
            }, btn);
            var payBtn = domConstruct.create("a", {
                innerHTML: "付款",
                class: "none"
            }, btn),receptBtn = domConstruct.create("a", {
                innerHTML: "确认收货",
                class: "none"
            }, btn),qryLog = domConstruct.create("a", {
                innerHTML: "查询物流",
                class: "none"
            }, btn), evaBtn = domConstruct.create("a", {
                innerHTML: "评价",
                class: "none"
            }, btn);
            // 依据当前订单的状态来显示和隐藏按钮
            var data = this.params, qty = 0;
            if(data.isPayed==false&&data.isCanceled==false){
                domClass.remove(payBtn, "none");
                qty++;
            }
            if(data.isPayed&&
                data.isReceipted==false&&
                data.isCanceled==false){
                domClass.remove(receptBtn, "none");
                qty++;
            }
            if(data.isPayed&&
                data.isReceipted==true&&
                data.isCanceled==false&&
                data.isClosed==false){
                domClass.remove(evaBtn, "none");
                qty++;
            }
            if(data.isPayed&&
                data.isDelived){
                domClass.remove(qryLog, "none");
                qty++;
            }
            if(qty>0){
                domClass.remove(btn, "none");
            }
            // 处理按钮事件
            // 支付
            this.connect(payBtn,"onclick", function(){
                
            });
            // 确认收货
            this.connect(receptBtn, "onclick", function(){
                //order.
            });
            // 物流查询
            this.connect(qryLog, "onclick", function(){
                
            });
            // 评价
            this.connect(evaBtn, "onclick", function(){
                window.moveToView("orderEval", this.params._id);
            })
        }*/
    });
});