﻿define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/dom-construct",
    "dijit/_WidgetBase",
    "dojo/dom-attr",
    "dojo/query",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/_base/lang",
    "bob/user/timeLine/c",
    "bob/user/consumer",
    "bob/user/follow",
    "bob/user/actionGrowth/c",
    "whz/util/config",
    "bob/user/shopStore",
    "cq/app/widget/_WidgetBase",
    "cq/util/sys/date",
    "cq/util/image/blob",
    "bob/user/shield"
], function (declare, array, domConstruct, _WidgetBase, domAttr,
    query, domClass, domStyle, lang, timeLine, consumer, follow, actionGrowthC,
    config, shopStore, widgetBase, date, blob, shield) {
        var onImageLoad = function () {
            var width = domStyle.get(this.parentNode, "width");
            var size = {};
            if (this.naturalHeight > this.naturalWidth) {
                size["margin-top"] = (this.naturalWidth - this.naturalHeight) / 2 * width / this.naturalWidth + "px";
                size.width = width + "px";
            } else {
                size["margin-left"] = (this.naturalHeight - this.naturalWidth) / 2 * width / this.naturalHeight + "px";
                size.height = width + "px";
                size.width = "";
            }
            domStyle.set(this, size);
            domStyle.set(this.parentNode, "height", width + "px");
        };
        return declare("whz.widget.TimeLineDtlItem", [_WidgetBase, widgetBase], {
            htmlTemp: '<div id="{id}" data-dojo-type="whz/widget/TimeLineDtlItem"></div>',
            baseClass: "",
            params: null,
            //用户LOGO
            _getUserIcon: function (logo) {
                //头像加载时加载 width=80
                return blob.getImageUrl(logo || config.defultUserLogo || "", "80");
            },
            //商家LOGO
            _getShopIcon: function (logo) {
                //头像加载时加载 width=80
                return blob.getImageUrl(logo || config.defultUserLogo || "", "80");
            },
            createChilds: function () {
                var timelineContainer = domConstruct.create("div", {
                    "class": "timeLine-list-item"
                }, this.domNode);
                //根节点
                var ht = domConstruct.create("div", {
                    "class": "hflex_top",//time-line-title
                    style: "position:relative;"
                }, timelineContainer);
                //判断的具体跳转到页面
                this.logoContainer = domConstruct.create("a", {
                    "class": "time-line-logo"
                }, ht);
                this.userAut = domConstruct.create("img", {
                    src: "./images/temp/tool/aut-tag.png",
                    "class": "user-aut-tag",
                    style: "display:none;left: 34px;width: 15px;bottom: 0;"
                }, ht);
                // logo
                this.logo = domConstruct.create("img", {}, this.logoContainer);
                //发布者和发布时间
                this.publisherContainer = domConstruct.create("div", {
                    "class": "time-line-publisher"
                }, ht);
                this.publisher = domConstruct.create("p", {
                    "class": "name"
                }, this.publisherContainer);
                this.publishTime = domConstruct.create("p", {
                    "class": "date"
                }, this.publisherContainer);
                var actionContainer = domConstruct.create("div", {}, ht);
                this.moreBtn = domConstruct.create("div", {
                    innerHTML: "<img src='./images/temp/tool/more-action.png'/>",
                    style: "width:20px;"
                }, actionContainer);
                // 收藏店铺按钮
                /*this.collectShop = domConstruct.create("a", {
                    innerHTML: "收藏",
                    "class": "hide time-time-add-btn"
                }, actionContainer);
                //关注按钮
                this.attention = domConstruct.create("a", {
                    innerHTML: "关注",
                    "class": "hide time-time-add-btn"
                }, actionContainer);*/
                //发布村友圈的具体内容
                this.content = domConstruct.create("div", {
                    "class": "time-line-content"
                }, timelineContainer);
                //发布村友圈的图片
                this.photoContainer = domConstruct.create("div", {
                    "class": "time-line-photo"
                }, timelineContainer);
                //底部节点
                var hb = domConstruct.create("div", {
                    "class": "time-line-btn"
                }, timelineContainer);
                //去看商品按钮
                this.toMatContainer = domConstruct.create("div", {
                    "class": "time-line-btn-left ",
                    innerHTML: "<a class='hflex'>" +
                    "<img src='./images/temp/eye.png'>" +
                    "<span class='flex1'>查看详情</span>" +
                    "</a>"
                }, hb);
                domConstruct.create("div", {
                    style: "flex:1"
                }, hb);
                //底部节点的右边区域
                this.handleContainer = domConstruct.create("div", {
                    "class": "time-line-btn-right"
                }, hb);
                this.toCommentBtn = domConstruct.create("a", {
                    "class": "time-line-btn-mini",
                    innerHTML: "<img src='./images/temp/pl.jpg'/><i>0</i>"
                }, this.handleContainer);
                this.toPraiseBtn = domConstruct.create("a", {
                    "class": "time-line-btn-mini",
                    innerHTML: "<img src='./images/temp/dz.jpg'/><i>0</i>"
                }, this.handleContainer);

                // 创建标签
                this.labelContainer = domConstruct.create("div", {
                    "class": "hflex-tab hflex timeline-label-item"
                }, this.domNode);
                this.commentLabel = domConstruct.create("div", {
                    innerHTML: "评论 <font class='commentQty'></font> ",
                    "class": "list-label-item selected",
                    name: "comment"
                }, this.labelContainer);
                this.praiseLabel = domConstruct.create("div", {
                    innerHTML: "点赞 <font class='praiseQty'></font> ",
                    "class": "list-label-item",
                    name: "praise"
                }, this.labelContainer);
                // 创建评论
                this.commentContainer = domConstruct.create("div", {
                    "class": "mat-item-cells hide",
                    style: "margin-top: 0;padding-top: 10px;"
                }, this.domNode);
                // 创建点赞
                this.praiseContainer = domConstruct.create("div", {
                    "class": "mat-item-cells hide",
                    style: "margin-top: 0;padding-top: 10px;"
                }, this.domNode);

            },
            hasDz: function (praise) {
                var userId = consumer.getCurrentUserId() || "",
                    isFind = false;
                for (var i = 0; i < praise.length; i++) {
                    if (userId == praise[i].userId) {
                        isFind = true;
                        break;
                    }
                }
                return isFind;
            },
            cqRefresh: function () {
                var timeLineId = this.cqRefInfo.cqViewParam.params;
                // 加载指定数据
                timeLine.loadByIdFunc(timeLineId).then(lang.hitch(this, function (result) {
                    var data = result && result.data && result.data.item || {};
                    this.data = data;
                    // 初始化发布人信息
                    domAttr.set(this.logoContainer, "href", data.tp==1?("#villager-" + data.publisher._id):("#businessDetails-"+data.fromShopId._id));
                    var isAut = data.tp==1?(data.publisher && data.publisher.isAut || false):false;
                    domStyle.set(this.userAut, "display", isAut ? "" : "none");
                    domAttr.set(this.logo, "src", data.tp==1?(this._getUserIcon(data.publisher.logo)):(this._getShopIcon(data.fromShopId.logo)));
                    domAttr.set(this.publishTime, "innerHTML", date.getTimeMoment(data.createAt));
                    domAttr.set(this.publisher, "innerHTML", data.tp==1?(data.publisher.nickName || "无名氏"):(data.fromShopId.shopName || ""));
                    domAttr.set(this.content, "innerHTML", data.title || "");

                    // 初始化按钮的显示隐藏(收藏/关注)
                    //var showCollect = data.tp == 2 && !shopStore.hasCollected(data.fromShopId);
                    //domClass[showCollect ? "remove" : "add"](this.collectShop, "hide");
                    //domAttr.set(this.collectShop, "shopId", data.fromShopId);
                    //var showAttention = data.tp == 1 && !follow.hasAttention(data.publisher._id) && data.publisher._id != consumer.getCurrentUserId();
                    //domClass[showAttention ? "remove" : "add"](this.attention, "hide");
                    //domAttr.set(this.attention, "userId", data.publisher._id);

                    // 初始化查看商品按钮
                    var showMat = data.tp == 2 && !!data.url;
                    domClass[showMat ? "remove" : "add"](this.toMatContainer, "hide");
                    query("a", this.toMatContainer)[0].href = data.url;
                    
                    // 初始化图片区域
                    domConstruct.empty(this.photoContainer);
                    array.forEach(data.images, function (img) {
                        var imgNode = domConstruct.create("a", {}, this.photoContainer);
                        var imgDom = domConstruct.create("img", {
                            src: blob.getImageUrl(img, "160"),
                            onload: onImageLoad,
                            style: "width:100%;max-width:none;"
                        }, imgNode);
                        domAttr.set(imgDom, "realSrc", img);
                    }, this);
                    // 初始化评论/点赞数量
                    domAttr.set(query(".commentQty", this.commentLabel)[0], "innerHTML", data.commentQty || 0);
                    domAttr.set(query(".praiseQty", this.praiseLabel)[0], "innerHTML", data.praiseQty || 0);
                    domAttr.set(query("i", this.toCommentBtn)[0], "innerHTML", data.commentQty || 0);
                    domAttr.set(query("i", this.toPraiseBtn)[0], "innerHTML", data.praiseQty || 0);
                    var hasPraise = this.hasDz(data.praises);
                    domAttr.set(query("img", this.toPraiseBtn)[0], "src", "./images/temp/dz" + (hasPraise ? "3" : "") + ".jpg");
                    domClass[hasPraise ? "add" : "remove"](this.toPraiseBtn, "hasPraise");
                    domAttr.set(this.toCommentBtn, "href", "#commentEdt-" + data._id);
                    domAttr.set(this.toPraiseBtn, "_id", data._id);
                    // 初始化评论信息
                    domConstruct.empty(this.commentContainer);
                    array.forEach(data.comments, function (comment) {
                        var commentHtml = "<div class='hflex_top timeline-comment-item'>" +
                            "<a class='item-mini-img' href='#villager-" + comment.userId._id + "'>" +
                            "<img src='" + this._getUserIcon(comment.userId.logo) + "'/>" +
                            "</a>" +
                            "<div class='flex1 mblListItemLabel'>" +
                            "<div class='hflex'>"+
                                "<div class='flex1'>"+
                                    "<span style='color:rgb(101,141,183);'>" + (comment.userId.nickName || "无名氏") + "</span>" + (comment.replyFor ? ("<span style='margin:0 5px;'>回复</span><a href='#villager-" + comment.replyFor._id + "' style='color:rgb(101,141,183);'>" + (comment.replyFor.nickName || "无名氏") + "</a>") : "") + 
                                "</div>"+
                                "<a href='#replyFor-"+data._id+","+comment._id+","+comment.userId._id+"' style='flex: inherit;-webkit-box-flex: inherit;-webkit-flex: inherit;min-width: inherit;'>"+
                                    "<img style='width:24px;height:24px;' src='./images/temp/pl.jpg'>"+
                                "</a>"+
                            "</div>" +
                            "<div class='brief'>" + date.getTimeMoment(comment.time) + "</div>" +
                            "<div style='white-space: pre-line;line-height: 20px;'>" + comment.content + "</div>" +
                            "</div>" +
                            "</div>";
                        var commentNode = domConstruct.toDom(commentHtml);
                        this.commentContainer.appendChild(commentNode);
                    }, this);

                    // 初始化点赞信息
                    domConstruct.empty(this.praiseContainer);
                    array.forEach(data.praises, function (praise) {
                        var praiseHtml = "<div class='hflex_top timeline-comment-item'>" +
                            "<a class='item-mini-img' href='#villager-" + praise.userId + "'>" +
                            "<img src='" + this._getUserIcon(praise.logo) + "'/>" +
                            "</a>" +
                            "<div class='flex1 mblListItemLabel'>" +
                            "<div class='praise-name'>" + (praise.nickName || "无名氏") + "</div>" +
                            "</div>" +
                            "</div>";
                        var praiseNode = domConstruct.toDom(praiseHtml);
                        this.praiseContainer.appendChild(praiseNode);
                    }, this);
                    // 初始化选中为评论
                    this.setSelected({ target: this.commentLabel });
                }));
            },
            //设置生成DOM对象的模板
            buildRendering: function () {
                this.inherited(arguments);
                this.createChilds();
                //村友圈关注按钮的响应函数
                //this.connect(this.attention, "onclick", this.toAttention);
                //this.connect(this.collectShop, "onclick", this.toCollect);
                this.connect(this.moreBtn, "onclick", this.moreBtnClick);
                // 如果当前数据有图片
                this.connect(this.photoContainer, "onclick", this.showBigImg);
                this.connect(this.commentLabel, "onclick", this.setSelected);
                this.connect(this.praiseLabel, "onclick", this.setSelected);
                this.connect(this.toPraiseBtn, "onclick", this.praise);
            },
            moreBtnClick: function(){
                require([
                "cq/util/edit/overlay"
            ], lang.hitch(this, function(overlay){
                // 设置背景颜色
                domStyle.set(overlay.domNode, "background", "#f2f2f2");
                // 依据当前的数据状态 创建不同的按钮
                var showAttention = this.data.tp==1&&!follow.hasAttention(this.data.publisher._id)&&this.data.publisher._id != consumer.getCurrentUserId();
                var showCancelAttention = this.data.tp==1&&follow.hasAttention(this.data.publisher._id);
                var showCollect = this.data.tp==2&&!shopStore.hasCollected(this.data.fromShopId._id);
                var showCancelCollect = this.data.tp==2&&shopStore.hasCollected(this.data.fromShopId._id);
                var showShield = !shield.hasAttention(this.data.publisher._id)&&this.data.publisher._id!=consumer.getCurrentUserId();
                var html = '<div class="item_actionsheet item_actionsheet_toggle">'+
                        '<div class="item_actionsheet_menu">'+
                            (showAttention?('<div class="item_actionsheet_cell" type="attention">关注</div>'):"")+
                            (showCancelAttention?('<div class="item_actionsheet_cell" type="cancelAttention">取消关注</div>'):"")+
                            (showCollect?('<div class="item_actionsheet_cell" type="collect">收藏</div>'):"")+
                            (showCancelCollect?('<div class="item_actionsheet_cell" type="cancelCollect">取消收藏</div>'):"")+
                            '<div class="item_actionsheet_cell" type="report">举报</div>'+
                            (showShield?('<div class="item_actionsheet_cell" type="shield">屏蔽</div>'):"")+
                        '</div><div class="item_actionsheet_action">'+
                            '<div class="item_actionsheet_cell" type="cancel">取消</div>'+
                        '</div>'+
                    '</div>';  
                // 弹出overlay
                var aa = domConstruct.toDom(html);
                // 监听事件
                var cancelBtn = query("div[type='cancel']", aa)[0];
                var attentionBtn = query("div[type='attention']", aa)[0];
                var cancelAttentionBtn = query("div[type='cancelAttention']", aa)[0];
                var collectBtn = query("div[type='collect']", aa)[0];
                var cancelCollectBtn = query("div[type='cancelCollect']", aa)[0];
                var reportBtn = query("div[type='report']", aa)[0];
                var shieldBtn = query("div[type='shield']", aa)[0];
                // 取消按钮
                this.connect(cancelBtn, "onclick", function(){
                    overlay.hide();
                });
                attentionBtn&&this.connect(attentionBtn, "onclick", function(){
                    window.busy();
                    var userId = this.data.publisher._id || "";
                    follow.addFollow(userId).then(lang.hitch(this, function (result) {
                        window.free();
                        overlay.hide();
                        if (result && result.data && result.data.ok == 1) {
                            alert("关注成功");
                        } else {
                            alert(result && result.data && result.data.message || "关注失败");
                        }
                    }));
                });
                cancelAttentionBtn&&this.connect(cancelAttentionBtn, "onclick", function(){
                    window.busy();
                    var userId = this.data.publisher._id || "";
                    follow.cancelFollow(userId).then(lang.hitch(this, function (result) {
                        window.free();
                        overlay.hide();
                        if (result && result.data && result.data.ok == 1) {
                            alert("取消关注成功");
                        } else {
                            alert(result && result.data && result.data.message || "取消关注成功");
                        }
                    }));
                });
                collectBtn&&this.connect(collectBtn, "onclick", function(){
                    window.busy();
                    //调用店铺收藏接口
                    shopStore.collectShop(this.data.fromShopId._id).then(lang.hitch(this, function (result) {
                        window.free();
                        overlay.hide();
                        if (result && result.data && result.data.ok == 1) {
                            alert("收藏成功");
                        } else {
                            alert(result && result.data && result.data.message || "收藏失败");
                        }
                    }));
                });
                cancelCollectBtn&&this.connect(cancelCollectBtn, "onclick", function(){
                    window.busy();
                    //调用店铺收藏接口
                    shopStore.cancelCollectShop(this.data.fromShopId._id).then(lang.hitch(this, function (result) {
                        window.free();
                        overlay.hide();
                        if (result && result.data && result.data.ok == 1) {
                            alert("取消收藏成功");
                        } else {
                            alert(result && result.data && result.data.message || "取消收藏失败");
                        }
                    }));
                });
                reportBtn&&this.connect(reportBtn, "onclick", function(){
                    if(!confirm("确定要举报？")){
                        overlay.hide();
                        return;
                    }
                    window.busy();
                    timeLine.report({
                        _id: this.data._id
                    }).then(lang.hitch(this, function (result) {
                        window.free();
                        overlay.hide();
                        if (result && result.data && result.data.ok === 1) {
                            alert("举报成功");
                        } else {
                            alert(result && result.data && result.data.message || "举报失败");
                        }
                    }));
                });
                shieldBtn&&this.connect(shieldBtn, "onclick", function(){
                    if(confirm("确定要屏蔽"+(this.data.publisher.nickName||this.data.publisher.pName||this.data.publisher.userName)+"？")){
                        window.busy();
                        var userId = this.data.publisher._id || "";
                        shield.addShielded(userId).then(lang.hitch(this, function (result) {
                            window.free();
                            overlay.hide();
                            if (result && result.data && result.data.ok == 1) {
                                alert("屏蔽成功");
                                // 跳转到屏蔽列表中 可以取消屏蔽
                                window.moveToView("shieldList");
                            } else {
                                alert(result && result.data && result.data.message || "屏蔽失败");
                            }
                        }));
                    }
                    else{
                        overlay.hide();
                    }
                });
                overlay.showElement(aa);
            }));
            },
            praise: function (e) {
                var dom = e.target;
                while (dom && dom.tagName !== "A" && dom !== this.handleContainer) {
                    dom = dom.parentNode;
                }
                var _id = domAttr.get(dom, "_id");
                window.busy();
                timeLine.praise({
                    _id: _id
                }).then(lang.hitch(this, function (result) {
                    window.free();
                    if (result && result.data && result.data.ok == 1) {
                        this.cqRefresh();
                    } else {
                        alert(result && result.data && result.data.message || "点赞失败");
                    }
                }));
            },
            toAttention: function (e) {
                var dom = e.target;
                var userId = domAttr.get(dom, "userId") || "";
                window.busy();
                follow.addFollow(userId).then(lang.hitch(this, function (result) {
                    window.free();
                    if (result && result.data && result.data.ok == 1) {
                        domClass.add(dom, "hide");
                        alert("关注成功");
                    } else {
                        alert(result && result.data && result.data.message || "关注失败");
                    }
                }));
            },
            toCollect: function (e) {
                var dom = e.target;
                var targetShopId = domAttr.get(dom, "shopId") || "";
                window.busy();
                var dom = e.target;
                //调用店铺收藏接口
                shopStore.collectShop(targetShopId).then(lang.hitch(this, function (result) {
                    window.free();
                    if (result && result.data && result.data.ok == 1) {
                        //隐藏节点
                        domClass.add(dom, "none");
                        alert("关注成功");
                    } else {
                        alert(result && result.data && result.data.message || "关注失败");
                    }
                }));
            },
            showBigImg: function (e) {
                var dom = e.target;
                if (dom.tagName == "IMG") {
                    var src = query("img", this.photoContainer);
                    var index = 0;
                    var srcArr = array.map(src, function (item, i) { 
                        //路径的数组对象
                        if (item == e.target) {
                            index = i;
                        }
                        return {
                            src: domAttr.get(item, "realSrc")
                        };
                    });
                    require(["cq/widgets/bigImg"], function (bigImg) {
                        bigImg.show(srcArr, index);
                    });
                } else {
                    return;
                }
            },
            setSelected: function (e) {
                var dom = e.target;
                while (dom && !domClass.contains(dom, "list-label-item") && dom !== this.labelContainer) {
                    dom = dom.parentNode;
                }
                if (!domClass.contains(dom, "list-label-item")) return;
                var selected = query(".selected", this.labelContainer)[0];
                if (selected) domClass.remove(selected, "selected");
                domClass.add(dom, "selected");
                var name = domAttr.get(dom, "name");
                this.showContainer(name);
            },
            labels: {
                "comment": "commentContainer",
                "praise": "praiseContainer"
            },
            showContainer: function (label) {
                for (var i in this.labels) {
                    domClass[i == label ? "remove" : "add"](this[this.labels[i]], "hide");
                }
            }
        });
    });