﻿define([
		"dojo/_base/declare",
		"dojo/_base/array",
		"dojo/dom-construct",
		"dijit/_WidgetBase",
		"cq/util/sys/date",
		"cq/widgets/bigImg",
		"dojo/dom-attr",
		"dojo/query",
		"dojo/dom-class",
		"dojo/_base/lang",
		"bob/user/timeLine/c",
        "dojo/dom-geometry",
        "dojo/dom-style",
        "cq/util/image/blob",
        "cq/util/config/config"
	], function (declare, array, domConstruct, _WidgetBase, date, bigImg, domAttr,
    query, domClass, lang, timeLine, domGem, domStyle, blob,config) {
	var onImageLoad = function () {
        var width = domStyle.get(this.parentNode, "width");
        var size = {};
        if (this.naturalHeight > this.naturalWidth) {
            size["margin-top"] = (this.naturalWidth - this.naturalHeight) / 2 * width / this.naturalWidth + "px";
            size.width = width + "px";
        } else {
            size["margin-left"] = (this.naturalHeight - this.naturalWidth) / 2 * width / this.naturalHeight + "px";
            size.height = width + "px";
            size.width = "";
        }
        domStyle.set(this, size);
        domStyle.set(this.parentNode, "height", width + "px");
    };
    return declare("cq.widgets.item.TimeLineItem", [_WidgetBase], {
		baseClass: "timeLine-list-item",
		params: null,
        myTimeLine: false,
        //设置用户LOGO
        _getUserIcon: function(logo){
            return logo||config.defultUserLogo;
        },
        //设置商家LOGO
        _getShopIcon: function(logo){
            return logo||config.defultUserLogo;
        },
        //设置生成DOM对象的模板
		buildRendering: function () {
			this.inherited(arguments);
            var data = this.params,
            imgs = data.images,
            ht = domConstruct.create("div", {
                    "class": "time-line-title"
                }, this.domNode),
            hl = this.myTimeLine?null:(domConstruct.create("a", {
                    "class": "time-line-logo",
                    href: "#customer-"+(data.publisher&&data.publisher._id)
                }, ht)),
            logo = hl&&domConstruct.create("img", {
                    src:  blob.getImageUrl(data.fromShopId?(this._getShopIcon(data&&data.fromShopId&&data.fromShopId.logo||"")):
                    this._getUserIcon(data && data.publisher && data.publisher.logo || ""),"80")
                }, hl)||null,
            hc = domConstruct.create("div", {
                    "class": "time-line-publisher",
                    innerHTML: "<p class='name'>" + (data.publisher.nickName || data.publisher.userName || "无名氏") + "</p>" +
                    "<p class='date'>" + date.formatISODateMinutes(data.createAt) + "</p>"
                }, ht),
            shopBtnArea = domConstruct.create("div", {
                    "class": data&&data.fromShopId?(this.myTimeLine?"none":""):"none"
                }, ht),
            inShop = null,
            hr = null,
            deleteNode = domConstruct.create("div", {
                    "class": "time-time-delete-btn",
                    innerHTML: "<img src='./images/temp/tool/delete.jpg'/>"
                }, ht),
            hcontent = domConstruct.create("div", {
                    "class": "time-line-content",
                    innerHTML: data.title
                }, this.domNode),
            hphoto = domConstruct.create("div", {
                    "class": "time-line-photo"
                }, this.domNode),
            hb = domConstruct.create("div", {
                    "class": "time-line-btn"
                }, this.domNode),
            hbl = domConstruct.create("div", {
                "class": "time-line-btn-left"
            }, hb),
            hbr = domConstruct.create("div", {
                    "class": "time-line-btn-right"
                }, hb),
            pj = domConstruct.create("a", {
                    "class": "time-line-btn-mini topl",
                    innerHTML: "<img src='./images/temp/pl.jpg'/><i>"+(data.commentQty || "0") + "<i>"
                }, hbr),
            dz = domConstruct.create("a", {
                    "class": "time-line-btn-mini todz",
                    innerHTML: "<img src='./images/temp/dz.jpg'/><i>" + (data.praiseQty || "0") + "</i>"
                }, hbr);
            //dz = domConstruct.create("a", {
            //    "class": "time-line-btn-mini todz",
            //    innerHTML: "<img src='./images/temp/jb.jpg'/><i>" + (data.reportQty || "0") + "</i>"
            //}, hbr);
            // 将有的图片放到图片节点中
            if (imgs.length) {
                var imgNode = null;
                array.forEach(imgs,
                    function (img) {
                    imgNode = domConstruct.create("a", {},hphoto);
                    var imgDom = domConstruct.create("img", {
                        src: blob.getImageUrl(img,"160"),
                        onload: onImageLoad,
                        style: "width: 100%;max-width: none;"
                    },imgNode);
                    domAttr.set(imgDom,"realSrc",img);
                });
                
                // 如果当前数据有图片
                this.connect(hphoto, "onclick",function (e) {
                    var dom = e.target;
                    if(dom.tagName=="IMG"){
                        var src = query("img", hphoto);
                        var index = 0;
                        var srcArr = array.map(src,function (item, i) { 
                            //路径的数组对象
                            if (item == e.target) {
                                index = i;
                            }
                            return {
                                src:domAttr.get(item, "realSrc")
                            };
                        });
                        bigImg.show(srcArr, index);
                    }else{
                        return;
                    }
                });
            }
            //监听点击事件
            deleteNode&&this.connect(deleteNode, "onclick", function(e){
                var dom = e.target;
                while(dom&&!domClass.contains(dom,"time-time-delete-btn")){
                    dom = dom.parentNode;
                }
                //删除自己的村友圈
                timeLine.deleteTimeLine(data._id).then(lang.hitch(this, function(result){
                    if(result&&result.data&&result.data.ok==1){
                        alert("删除成功");
                        // 刷新页面的显示
                        dom.parentNode.parentNode.parentNode.removeChild(dom.parentNode.parentNode);
                    }else{
                        alert(result&&result.data&&result.data.message||"删除失败");
                    }
                }));
            });
		}
	});
});