define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-attr",
    'dojo/dom-style',
    "dojo/dom-class",
    "dijit/_WidgetBase",
    "cq/app/widget/_WidgetBase",
    "dijit/_TemplatedMixin",
    "bob/ts/cart"
],function(declare,lang,domAttr,domStyle,domClass,_WidgetBase,_CqWidgetBase,_TemplatedMixin,cart){
    return declare("",[_WidgetBase,_TemplatedMixin,_CqWidgetBase],{
        htmlTemp:"<div id='{id}' data-dojo-type='cq/widgets/item/cart/cart/AppCartBar'></div>",
        templateString:"<div data-dojo-attach-point='domNode' class='cartFoot'>"+
            "<div class='checkNode checkAll' data-dojo-attach-point='selectButton'>"+//data-dojo-attach-point='selectNode'
                "<input class='mat-check' type='checkbox' data-dojo-attach-point='selectNode'/>全选"+
            "</div>"+
            //"<input class='mat-check' type='checkbox' data-dojo-attach-point='selectNode'/>"+
            "<div class='text-right'>"+
                "<div class='amount'>合计"+
                    "<span class='highlight ' data-dojo-attach-point='amtNode'></span>"+
                "</div>"+
                "<div class='transAmount'>不含运费</div>"+
            "</div>"+
            "<div class='highlight-bg ' data-dojo-attach-point='settleNode'>结算</div>"+
        "</div>",
        buildRendering:function(){
            this.inherited(arguments);
            this.connect(this.selectButton,"onclick",this.onSelectClick);
            this.connect(this.settleNode,"onclick",this.onSettle);
            this.subscribe("/cq/widget/item/cart/matChanged",function(info){
                this.info = info||{};
                this.amtNode.innerHTML = "￥"+window.fixedTo(info.selectedAmt,3);
                this.settleNode.innerHTML = "结算("+info.selectedNum+")"
                //未选中商品时，结算不允许点击，不允许添加点击样式
                if(!info.selectedNum){
                    domClass.add(this.settleNode,"unclickSettleNode");//background-color:burlywood/#DEB887
                    var parent = this.getView();
                    if(parent){
                        parent.resize();
                    }
                }
                this.showFooter();
            });
        },
        getView:function(){
            var parent = this.getParent();
            while(parent&&!(parent.resize&&domClass.contains(parent.domNode,"mblView"))){
                parent = parent.getParent();
            }
            return parent;
        },
        observe:function(widget,field){
            if(field==="cart"){
                this.cartItem = widget;
                this.connect(widget,"setSelected",this.setSelected);
            }
            this.inherited(arguments);
        },
        onSelectClick:function(){
            this.inherited(arguments);
            this.setSelected(!this.selected);
            if(this.cartItem){
                this.cartItem.onSelectClicked(this.selected);
                
            }
        },
        onSettle:function(){
            if(this.info&&this.info.selectedNum)
            window.moveToView("orderInfo");
        },
        setSelected:function(selected){
            var a = cart.getIds();
            this.showFooter();
            this.selected = selected;
            domAttr.set(this.selectNode,"checked",selected);
        },
        //显示隐藏底部
        showFooter:function(){
            if(!cart.getIds().length){
                domStyle.set(this.domNode,"display","none");
            }else{
                domStyle.set(this.domNode,"display","");
            }
        }
        
    });
});