﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-class",
    "dijit/_WidgetBase",
    "cq/app/widget/_WidgetBase",
    "dijit/_TemplatedMixin",
    "dijit/_Container",
    "./_Cart",
    "bob/ts/cart"
],function(declare,lang,domClass,_WidgetBase,CqWidgetBase,_TemplatedMixin,_Container,_Cart,cart){
    return declare("",[_WidgetBase,_Container,_TemplatedMixin,CqWidgetBase,_Cart],{
        htmlTemp:"<div id='{id}' class='{className}' data-dojo-type='cq/widgets/item/cart/cart/WebCart' data-dojo-props='ItemRender:\"{ItemRender}\",renderOption:{j:renderOption}'></div>",
        templateString:'<div data-dojo-attach-point="domNode" style="width:1000px;">'+
            //顶部标题栏
            '<div class="cart-table-th hflex">'+
                '<div class="td" style="width:80px;margin-left:18px;">商品信息'+
                '</div>'+
                '<div class="td" style="width:350px;padding-left:50px;"></div>'+
                '<div class="td flex">单价</div>'+
                '<div class="td flex">数量</div>'+
                '<div class="td flex">金额</div>'+
                '<div class="td flex">操作</div>'+
            '</div>'+
            //商品列表区域
            '<div data-dojo-attach-point="containerNode"></div>'+
            //底部的清空、删除、结算按钮
            '<div class="cart-footer hflex">'+
                '<div class="hflex" data-dojo-attach-point="selectDivNode" style="margin-left:18px;width:80px;">'+
                    '<div class="cart-checkbox">'+
                        '<input type="checkbox" data-dojo-attach-point="selectNode">'+
                        '<label style="margin-top: 18px;"></label>'+
                    '</div>'+
                '</div>'+
                '<div style="margin-left:-55px;margin-right:30px;">全选</div>'+
                '<div class="displayflex">'+
                    '<a class="del-mat" data-dojo-attach-point="deleteNode">删除</a>'+
                    '<a class="clear-mat" style="margin-left:25px;" data-dojo-attach-point="deleteAllNode">清空失效商品</a>'+
                '</div>'+
                '<div class="flex" style="text-align: right;margin-right: 25px;">'+
                    '<span>合计:￥</span><span class="ttlPrice" data-dojo-attach-point="totalNode"></span>'+
                '</div>'+
                '<div>'+
                    '<a data-dojo-attach-point="submitNode" class="checkOut disabled">结算</a>'+
                '</div>'+
            '</div>'+
        '</div>',
        initCartHeader:function(){
            //全选
            this.connect(this.selectDivNode,"onclick",function(){
                this.onSelectClick();
            });
            //删除选中
            this.connect(this.deleteNode,"onclick",function(){
                this.deleteSelected();
            });
            //清空无效的商品
            //先找到无效的商品的节点disabled为true的子节点
            this.connect(this.deleteAllNode,"onclick",function(){
                this.getChildren().forEach(function(item){
                    if(item.disabled){
                        item.deleteAll();
                    }
                });
            });
            this.connect(this.submitNode,"onclick",function(){
                if(!domClass.contains(this.submitNode,"disabled")){
                    window.moveToView("orderInfo");
                }
            });
            //处理默认操作
            this.inherited(arguments);
        },
        onMatChanged:function(){
            clearTimeout(this._changeTimer);
            this._changeTimer = setTimeout(lang.hitch(this,function(){
                var info = this.getMatInfo();
                this.totalNode.innerHTML = window.fixedTo(info.selectedAmt||0,3);
                domClass[info.selectedNum?"remove":"add"](this.submitNode,"disabled");
            }),300);
        },
        //加载当前购物车里面的数据
        loadCartData:function(){
            return cart.loadCartData().then(function(items){
                return items||[];
            });
        }
    });
});