define([
    "dojo/_base/declare",
    "dojo/dom-attr",
    "dojo/dom-style",
    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    "dojo/dom-class",
    "./_Mat"
],function(declare,domAttr,domStyle,_WidgetBase,_TemplatedMixin,domClass,_Mat){
    return declare("",[_WidgetBase,_TemplatedMixin,_Mat],{
        templateString:'<div class="cart-mat hflex" data-dojo-attach-point="domNode" style="padding-top:20px;min-height: 102px;">'+
            '<div class="checkboxs" data-dojo-attach-point="selectDivNode">'+
                '<div class="cart-checkbox">'+
                    '<input data-dojo-attach-point="selectNode" type="checkbox">'+
                    '<label></label>'+
                '</div>'+
            '</div>'+
            '<a class="hflex" style="width:430px;" data-dojo-attach-point="linkNode">'+
                '<div class="td-mat">'+
                    '<img data-dojo-attach-point="logoNode">'+
                '</div>'+
                '<div class="flex td-matname">'+
                    '<p data-dojo-attach-point="titleNode"></p>'+
                '</div>'+
            '</a>'+
            '<div class="flex">'+
                '<p class="td-price" data-dojo-attach-point="priceNode"></p>'+
            '</div>'+
            '<div class="flex" data-dojo-attach-point="editNode">'+
                '<div class="hflex cart-amount">'+
                    '<a data-dojo-attach-point="subNode">-</a>'+
                    '<input data-dojo-attach-point="qtyNode"></input>'+
                    '<a data-dojo-attach-point="incNode">+</a>'+
                '</div>'+
            '</div>'+
            '<div class="flex">'+
                '<p class="td-sum" data-dojo-attach-point="totalNode"></p>'+
            '</div>'+
            '<div class="flex">'+
                '<a class="td-delete" data-dojo-attach-point="deleteNode">删除</a>'+
            '</div>'+
        '</div>',
        //初始化节点，也可以直接用dojo模板实现
        buildRendering:function(){
            this.inherited(arguments);
            this.connect(this.selectDivNode,"onclick",this.onSelectClick);
            this.connect(this.deleteNode,"onclick",this.deleteAll);
            this.connect(this.incNode,"onclick",this.qtyIncClick);
            this.connect(this.subNode,"onclick",this.qtySubClick);
            //输入金额事件
            this.connect(this.qtyNode,"onchange",this.qtyInputChange);
        },
        //处理选中显示
        setSelected:function(selected){
            this.inherited(arguments);
            if(this.selectNode){
                domAttr.set(this.selectNode,"checked",selected);
            }
        },
        updateMatInfo:function(){
            //商品详情的链接
            if(this.domNode){
                domAttr.set(this.linkNode,"href","#matDetail-"+this.mid);
                if(this.logoNode){
                    this.logoNode.src = this.logo;
                }
                if(this.maxQtyNode){
                    this.maxQtyNode.innerHTML = this.maxQty;
                }
                if(this.titleNode){
                    this.titleNode.innerHTML = this.mName;
                }
                if(this.showQtyNode){
                    this.showQtyNode.innerHTML = this.qty;
                }
                if(this.qtyNode){
                    this.qtyNode.value = this.qty;
                }
                if(this.priceNode){
                    this.priceNode.innerHTML = "￥"+window.fixedTo(this.price,3);
                }
                if(this.totalNode){
                    this.totalNode.innerHTML = "￥"+window.fixedTo(this.qty*this.price,3);
                }
            }
        },
        //处理失效或库存为0的商品
        onDataReady:function(data){
            this.inherited(arguments);
            if(!data.isUse || !data.qty){
                //设置 disabled = true
                this.disabled = true;
                //如果是已经选中的商品,取消选中
                this.setSelected(false);
                //设置不可点击和勾选
                //domAttr.set(this.selectNode,"disabled","true");
                //直接设置不可看
                domStyle.set(this.selectDivNode,"display","none");
                domStyle.set(this.editNode,"display","none");
                domStyle.set(this.deleteNode,"display","none");
                domStyle.set(this.totalNode,"display","none");
            }
        },
        setSubButtonDisabled:function(){
        },
        setIncButtonDisabled:function(){
        }
    });
});