/*
变更人：徐阿雪
变更时间：2017/2/8
变更内容：  购物车根绝商家领取优惠券
            根绝商家跳转到到商家的主页
*/
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-attr",
    "dojo/_base/array",
    'dojo/dom-style',
    "dojo/dom-construct",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetBase",
    "dijit/_Container",
    "./_Shop",
    "cq/util/edit/overlay",
	"cq/widgets/item/mat/GetDiscoutList"
],function(declare,lang,domAttr,array,domStyle,domConstruct,_TemplatedMixin,_WidgetBase,_Container,_Shop,overlay,GetDiscountList){
    return declare("",[_WidgetBase,_TemplatedMixin,_Container,_Shop],{
        templateString:"<div data-dojo-attach-point='domNode' style='padding: 0 0 10px 0'>"+
            "<div class = 'appShop'>"+
                "<div class='o-t-title-shop' style='flex:1;'>"+
                    "<div class='checkNode' >"+//data-dojo-attach-point='selectNode'
                        "<input class='mat-check' type='checkbox' data-dojo-attach-point='selectNode'/>"+
                    "</div>"+
                    "<div class='icon' data-dojo-attach-point='iconNode'>"+
                        "<img src='./images/temp/shopIcon.png'>"+
                    "</div>"+
                    "<div class='title' >"+
                        "<a class='normal' data-dojo-attach-point='titleNode'></a>"+
                        "<span class='highlight right continueGOBtn' data-dojo-attach-point='linkNode'>领券</span>"+
                    "</div>"+
                "</div>"+
            "</div>"+
            "<div data-dojo-attach-point='containerNode' class = 'shopChild'></div>"+
            "<div data-dojo-attach-point='activityNode'></div>"+
        "</div>",
        initHeader:function() {
            this.connect(this.selectNode,"onclick",this.onSelectClick);
            //点击商家名称进入商家的店铺首页
            this.connect(this.titleNode,"onclick",this.onShopClick);
            //领券绑定点击事件
            this.connect(this.linkNode,"onclick",this.couponClick);
        },
        onShopClick:function() {
            var shopId  = domAttr.get(this.titleNode,"shopId");
            window.moveToView("businessDetails",shopId);
        },
        //领券
        couponClick:function() {
            var shopId  = domAttr.get(this.titleNode,"shopId");
            this.getDiscount(shopId);
        },
        // 领取优惠劵
		getDiscount: function (fromShopId) {
			require(["bob/mk/discount/c"], lang.hitch(this, function (discount) {
				// 获取商家的数据
				discount.loadByShop(fromShopId).then(lang.hitch(this, function (items) {
					if (!items.length || items.length === 0) {
						alert("没有可以领取的优惠劵");
					} else {
						// 创建overLay
						if (!this.getDiscoutListElement) {
							this.getDiscoutListElement = new GetDiscountList();
						}
						var data = {};
						data.items = items;
						data.fromShopId = fromShopId;
						this.getDiscoutListElement.init(data).then(function () {
							overlay.hide();
						});
						overlay.showElement(this.getDiscoutListElement.domNode);
					}
				}));
			}));
		},
        onDataReady:function(shopMatData) {
            if(shopMatData.shopInfo._id == "111") {
                this.disabled = true;
                domStyle.set(this.linkNode,"display","none");
                domStyle.set(this.selectNode,"display","none");
                domStyle.set(this.iconNode,"display","none");
                domStyle.set(this.linkNode,"display","none");
                domAttr.set(this.titleNode,"shopId",shopMatData.shopInfo._id);
                this.titleNode.innerHTML = "<div>"+shopMatData.shopInfo.shopName+"<button>清除无效商品</button></div>";
                this.connect(this.titleNode.lastElementChild,"onclick",this.deleteAll);
            }else{
                domStyle.set(this.linkNode,"display","");
                domStyle.set(this.selectNode,"display","");
                domStyle.set(this.iconNode,"display","");
                this.titleNode.innerHTML = shopMatData.shopInfo.shopName;
                domAttr.set(this.titleNode,"shopId",shopMatData.shopInfo._id);
                //设置优惠活动
                this.shopActivity[shopMatData.shopInfo._id] = shopMatData.shopActivityInfo&&shopMatData.shopActivityInfo||"";
            }
            this.inherited(arguments);
        },
        //存放改商家的满减活动
        shopActivity:{},
        //创建满减活动的信息
        createActivity:function(totalAmt,mids,activitys){
            //如果是添加的多个规格，参加的活动
            var activitNode  = null;
            array.forEach(activitys,function(activity){
                var msg = "",getmore="";
                if(!activity.allMat){
                    var tamount = 0;
                    array.forEach(activity.mids,function(id){
                        id = id.mId;
                        if(mids[id]){
                            tamount += mids[id].amount;
                        }
                    });
                    if(tamount&&tamount<activity.amount){
                        msg = "再买"+window.fixedTo((activity.amount-tamount),3)+"元享包邮";//+mids[id].mName
                        getmore = "去凑单";
                    }else if(tamount&&tamount>=activity.amount){
                        msg = "您已享受满"+window.fixedTo((activity.amount),3)+"包邮优惠";
                        getmore = "再逛逛";
                    }
                }else{
                    if(totalAmt>=activity.amount){
                        msg = "您已享受满"+window.fixedTo((activity.amount),3)+"包邮优惠";
                        getmore = "再逛逛";
                        
                    }else if(totalAmt<activity.amount){
                        msg = "再买"+window.fixedTo((activity.amount-totalAmt),3)+"元享包邮";
                        getmore = "去凑单";
                    }
                }
                if(msg&&getmore){
                    this.createNode(msg,getmore);
                }
            },this);
        },
        //创建节点
        createNode:function(msg,getmore){
            var activityNode = domConstruct.create("ul",{
                "class":"activity",
                innerHTML:"<li class='o-t-title-shop'><span>"+msg+"</span><span class='title highlight' style='text-align: right;'>"+getmore+"</span></li>"
            });
            this.activityNode.appendChild(activityNode);
            this.connect(this.activityNode.lastElementChild,"onclick",this.onShopClick);
        },
        //重写shop的此方法，监听满减的变化
        onMatChanged:function(){
            this.inherited(arguments);
            //根据现在购物车里面的每个商家的商品的总金额数修改活动节点的显示
            var children = this.getChildren();
            if(children.length){
                var matInfo = this.getMatInfo();
                var shopId  = domAttr.get(this.titleNode,"shopId");
                if(this.shopActivity[shopId]){
                    //销毁上次创建
                    this.destroyActivityNode();
                    //查看
                    this.createActivity(matInfo.totalAmt,matInfo.amount,this.shopActivity[shopId]);
                }
            }
        },
        destroyActivityNode:function(){
            var node = this.activityNode.childNodes;
            var nodeLength = node.length;
            for(var i=0;i<nodeLength;i++){
                this.activityNode.removeChild(node[0]);
            }
        },
        startEdit:function() {
            domStyle.set(this.linkNode,"display","none");
            this.inherited(arguments);
        },
        endEdit:function() {
            if(this.getChildren()[0].disabled){
                domStyle.set(this.linkNode,"display","none");
            }else{
                domStyle.set(this.linkNode,"display","");
            }
            this.inherited(arguments);
        }
    });
});