﻿define([
	"dojo/_base/declare",
	"dojo/_base/array",
	"dojo/_base/lang",
	"dojo/on",
	"dojo/dom-construct",
	"dojo/dom-class",
	"dojox/mobile/EdgeToEdgeList",
	"dojox/mobile/ListItem",
	"dijit/registry",
	"dijit/_WidgetBase",
	"dojo/Deferred",
	"cq/util/sys/date",
	"dojox/mobile/ScrollablePane"
], function (declare, array, lang, on, domConstruct, domClass,
	EdgeToEdgeList, ListItem, registry, _WidgetBase, Deferred, date, ScrollablePane) {
	return declare("cq.widgets.item.mat.GetDiscountList", [_WidgetBase], {
		/*
            根据获取的优惠券，生成优惠券列表，列表绑定了点击领取优惠券事件
        */
        data: null,
		init: function (data) {
			this.def = new Deferred();
			this.data = data;
			this.initElement();
			//若没有初始化，执行初始化
			//销毁原来的
			//记录当前正在修改的数据
			//依据正在修改的数据创建界面元素
			return this.def;
			//返回def
		},
		//初始化
		//创建列表
		//创建确定取消按钮，事件
		//设置固定高度
		//完成按钮
		//从列表中取数据
		//提交数据
		//取消：def
		initElement: function () {
			this.addDiscountListNode();
		},
		addDiscountListNode: function () {
			if (!this.discountList) {
				this.scrollPane = new ScrollablePane({
					"height": "300px",
					"class": "nav_dropdowm_item"
				});
				this.scrollPane.placeAt(this.domNode);
				this.discountList = new EdgeToEdgeList({
					"class": "icon-list-item no-margin-top"
				});
				this.discountList.placeAt(this.scrollPane.containerNode);
				this.discountList.on("click", lang.hitch(this, this.onClickList));
			} else {
				this.discountList.destroyDescendants();
			}
			array.forEach(this.data.items, function (item) {
				var labelStr = "";
                labelStr += "<table style='width:100%;' class='couponItem'>"+
                    "<tr>"+
                        "<td>"+
                            "<div class='discount_left'>"+
                                "<div>" + '¥<font class="discount_Number">' + (item.amount || 0) + "</font></div>"+
                                "<div>满" + window.fixedTo(item.reachAmount, 3) + "使用</div>"+
                                "<div>有效期 " + date.formatISODate(item.startDate) + "至" + date.formatISODate(item.stopDate) + "</div>"+
                            "</div>"+
                        "</td>"+
                        "<td style='vertical-align: middle;width:70px;'>"+
                            "<div class='discount_right'>立即领取</div>"+
                        "</td>"+
                    "</tr>"+
                "</table>";
				var list = new ListItem({
					label: labelStr,
					variableHeight: true,
					rightText: "",
					params: item,
                    style: "margin:0;"
				});
				list.startup();
				this.discountList.addChild(list);
			}, this);
			this.scrollPane.resize();
			this.scrollPane.startup();
		},
		onClickList: function (evt) {
			// 得到点击的ListItem
			var li = registry.getEnclosingWidget(evt.target);
			if (li.declaredClass != "dojox.mobile.ListItem" || !domClass.contains(evt.target, "discount_right")) {
				return;
			}
			var data = li.params;
			require([
                "bob/mk/discount/c",
                "bob/shop/shop"
            ], lang.hitch(this, function (discount, shop) {
				discount.receiveCoupon({
					_id: data._id,
					shopId: this.data.fromShopId,
                    fromShopId: shop.getShopId()
				}).then(lang.hitch(this, function (result) {
					if (result && result.data && result.data.ok === 1) {
						alert("领取优惠劵成功");
					} else {
						alert(result&&result.data&&result.data.message || "领取优惠劵失败");
					}
					this.def.resolve();
				}));
			}));
		}/*,
		updatePic: function () {
			orderB.updateAmount(this.params._id).then(lang.hitch(this, function (result) {
				this.def.resolve();
			}));
		},
		cancelUpdate: function () {
			this.def.resolve();
		}*/
	});
});