﻿define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/query",
    "dijit/_WidgetBase",
    "cq/app/widget/show/DeadLine",
    "cq/util/sys/date"
],function(declare,array, lang,domConstruct, domStyle, query,_WidgetBase,DeadLine, date){
    return declare("cq.widgets.item.mat.LimitDiscount", [_WidgetBase], {
        baseClass:"limit-list-item",
        params:null,
        createDeadLine: function(node){
            var deadLine = new DeadLine({});
            var header = query(".deadLine", this.domNode)[0];
            node.appendChild(deadLine.domNode);
            var deadLineTitle = query(".deadLineTitle", this.domNode)[0];
            var now = date.nowISOString(),
                endTime = this.params.ed,
                startTime = this.params.sd;
            if(deadLine){
                if(now>=startTime&&now<=endTime){
                    deadLine.setDeadLine(endTime);
                    deadLineTitle.innerHTML = "距离结束";
                }else if(now<startTime){
                    deadLine.setDeadLine(startTime);
                    deadLineTitle.innerHTML = "距离开始";
                }else{
                    domStyle.set(header,"display","none");
                }
            }else{
                domStyle.set(header,"display","none");
            }
        },
        buildRendering:function(){
            this.inherited(arguments);
            var countDownNode = domConstruct.create("div", {
                "class": "deadLine hflex"
            }, this.domNode);
            domConstruct.create("div", {
                "class": "flex1 line"
            }, countDownNode);
            var timeNode = domConstruct.create("div", {
                "class": "hflex time"
            }, countDownNode);
            domConstruct.create("div", {
                innerHTML: "距离结束",
                "class": "flex1 deadLineTitle"
            }, timeNode);
            
            var countDown = domConstruct.create("div", {
                "class": "flex1"
            }, timeNode);
            
            domConstruct.create("div", {
                "class": "flex1 line"
            }, countDownNode);
            this.createDeadLine(countDown);
            var contentNode = domConstruct.create("div", {
                "class": "hflex"
            }, this.domNode);
            var imgNode = domConstruct.create("a", {
                href: "#matDetail-"+(this.params.mId._id||this.params.mId),
                "class": "img",
                innerHTML: "<img src='"+(this.params.mId.logo||this.params.logo)+"'>"
            }, contentNode);
            var innerNode = domConstruct.create("div", {
                "class": "flex1"
            }, contentNode);
            var mNameNode = domConstruct.create("div", {
                innerHTML: (this.params.mId.mName||this.params.mName),
                "class": "row2"
            }, innerNode);
            var sizeTypeNode = domConstruct.create("div", {
                innerHTML: (this.params.mId.sizeType||this.params.sizeType),
                "class": "sizeType"
            }, innerNode);
            var prcNode = domConstruct.create("div", {
                innerHTML: "<div class='flex1'>抢购价 <font>￥"+this.params.limitPic+"</font></div>"+
                            "<div style='font-size:12px;color:#666;'>每人限购"+this.params.limitQty+"</div>",
                "class": "price hflex"
            }, innerNode);
            var btnArea = domConstruct.create("div", {
                "class": "hflex"
            }, innerNode);
            var qtyNode = null;
            if(this.params.qty&&this.params.qty>0){
                qtyNode = domConstruct.create("a", {
                    "class": "flex1 qty",
                    innerHTML: "仅剩"+this.params.qty+"件"
                }, btnArea);   
            }else{
                qtyNode = domConstruct.create("span", {
                    "class": "flex1"
                    //style: "font-size:12px;",
                    //innerHTML: date.formatISODateMinutes(this.params.lastMod)+"抢完"
                }, btnArea); 
            }
            var now = date.nowISOString(),
                endTime = this.params.ed,
                startTime = this.params.sd;
            var buyNode = null;
            if(now>=startTime&&now<=endTime){
                if(this.params.qty&&this.params.qty>0){
                    buyNode = domConstruct.create("a", {
                        "class": "flex1 btn",
                        innerHTML: "马上抢",
                        href: "#matDetail-"+(this.params.mId._id||this.params.mId)
                    }, btnArea);
                }else{
                    buyNode = domConstruct.create("a", {
                        "class": "flex1 btn grey",
                        innerHTML: "已抢完"
                    }, btnArea);
                }
            }else if(now<startTime){
                buyNode = domConstruct.create("a", {
                    "class": "flex1 btn",
                    innerHTML: "提醒我"
                }, btnArea);
                this.connect(buyNode, "onclick", this.noticeMe);
            }
        },
        noticeMe: function(){
            require(["bob/im/inform/c"], lang.hitch(this, function(inform){
                item = {};
                item.tempData = {
                    "first": "抢购即将开始",
                    "orderSn": this.params.mId._id||this.params.mId,
                    "orderStatus": "抢购即将开始",
                    "remark": "您关注的抢购活动即将开始了，快去看看吧"
                };
                item.billType = 2;
                item.bid = this.params.mId._id||this.params.mId;
                var sd = new Date(this.params.sd);
                sd.setMinutes(sd.getMinutes()-10);
                item.alarmTime = sd;
                item.url = window.location.href.split("#")[0]+"#matDetail-"+(this.params.mId._id||this.params.mId);
                item.msgContent = "您关注的抢购活动即将开始了，快去看看吧";
                inform.save(item);
            }));
        }
    });
});