define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-style",
    "dojo/Deferred",
    "dojo/topic",
    "dijit/_WidgetBase",
    "cq/app/widget/_WidgetBase",
    "dijit/_TemplatedMixin",
    "dijit/_Container",
    "bob/ts/orderC",
    "bob/mat/opt/c",
    "bob/mat/matB",
    "bob/ts/orderChooseRecord/c"
],function(declare,lang,array,domStyle,Deferred,topic,_WidgetBase,CqWidgetBase,_TemplatedMixin,_Container,orderC,matOpt,matB,orderChooseRecord){
    return declare("",[_WidgetBase,_Container,_TemplatedMixin,CqWidgetBase],{
        htmlTemp:"<div id='{id}' class='{className}' data-dojo-type='cq/widgets/item/mat/matOpt/matOptionB' data-dojo-props='ItemRender:\"{ItemRender}\"'></div>",
        templateString:'<div style="margin-top:10px;" data-dojo-attach-point="domNode" class="cartChild">'+
            "<div class='item-cells'><div class='item-cell'><div data-dojo-attach-point='introduceNode' style='display:block;width:100%;'></div></div></div>"+
            "<div data-dojo-attach-point='containerNode'  class='shopChild' ></div>"+
            "<div style='padding:10px;'><textarea data-dojo-attach-point='remarkNode' placeHolder='其他要求请在此填写'></textarea></div>"+
        '</div>',
        ItemRender:null,
        //商品对应的商家
        fromShopId:"",
        //总的合计分数
        total:0,
        //最大的量
        maxQty:0,
        optId: "",
        //加载当前购物车里面的数据
        loadOptionList:function(){
            var def = new Deferred();
            //加载改订单对应的商家的可选配送套餐
            var params = this.cqRefInfo.cqViewParam.params.split("-");
            var tsId = params[1];
            var mId = params[0];
            var detailId = params[2];
            //找到该单的该商品所属商家，加载改商品
            orderC.loadById(tsId).then(lang.hitch(this, function(orderhData){
                var orderhItem = orderhData&&orderhData.data&&orderhData.data.item||{};
                if(!orderhItem._id){
                    def.resolve({
                        message: "没有订单"
                    });
                }else{
                    this.fromShopId = orderhItem.fromShopId;
                    orderC.loadByDetailId(detailId).then(lang.hitch(this, function(orderdData){
                        var orderdItem = orderdData&&orderdData.data&&orderdData.data.item||{};
                        var optId = orderdItem.optId;
                        // 加载商品的属性
                        if(!optId){
                            def.resolve({
                                message: "商品无可配置套餐"
                            });
                        }else{
                            this.optId = optId;
                            matOpt.loadById({
                                _id: optId,
                                fromShopId: this.fromShopId
                            }).then(function(optData){
                                var optItem = optData&&optData.data&&optData.data.item||{};
                                if(!optItem._id){
                                    def.resolve({
                                        message: "配置套餐数据找不到"
                                    });
                                }else{
                                    def.resolve(optItem);
                                }
                            });
                        }
                    }));
                }
            }));
            return def.then(function(data){
                var s = "";
                if(data.img){
                    s = '<img style="margin:auto;width:90%;padding:4px;display:block;" src="'+data.img+'"/>';
                }
                if(data.href){
                    if(s){
                        data.remark = '<a style="display:block;" href="'+data.href+'" target="_blank">'+s+"</a>"+data.remark;
                    }else{
                        data.remark = '<a style="display:block;" href="'+data.href+'" target="_blank">'+data.remark+"</a>";
                    }
                }else{
                    data.remark = s+data.remark;
                }
                return data;
            });
        },
        renderLoaded:false,
        buildRendering:function(){
            this.inherited(arguments);
            require([this.ItemRender],lang.hitch(this,function(){
                this.ItemRender = arguments[0];
                this.renderLoaded = true;
                if(this.refreshOnRenderLoaded){
                    this.cqRefresh();
                }
            }));
            this.connect(this.remarkNode,"input",this.onChanged);
        },
        getRemark: function(){
            return this.remarkNode.value;
        },
        refreshOnRenderLoaded:false,
        cqRefresh:function(){
            if(!this.renderLoaded){
                this.refreshOnRenderLoaded = true;
                return;
            }
            this.loadOptionList().then(lang.hitch(this,function(data){
                if(data.message){
                    alert(data.message);
                }else{
                    this.maxQty = data.maxQty;
                    this.introduceNode.innerHTML = data.remark;
                    this.onDataReady(data.opts);
                }
            }));
        },
        //依据本对象需要的结构，刷新界面元素
        onDataReady:function(list){
            //销毁原有列表项
            this.getChildren().forEach(function(item){
                item.destroyRecursive();
            });
            this.containerNode.innerHTML = "";
            // 清空备注的填写
            this.remarkNode.value = "";
            //创建下级列表项
            var item = null;
            array.forEach(list,function(data){
                item = new this.ItemRender();
                this.addChild(item);
                item.onDataReady(data);
            },this);
        },
        onChanged:function(){
            var _this = this;
            var qty = 0;
            var remark = "";
            var selectedOpt = [];
            this.getChildren().forEach(function(item){
                qty = qty + item.qty;
                if(item.qty){
                    var a = item.mName+" "+item.qty+" 份；";
                    remark += a;
                    selectedOpt.push({
                        _id: item._id,
                        qty: item.qty
                    });
                }
            },this);
            this.total = qty;
            var notclick = false;
            if(this.total>=parseInt(this.maxQty)){
                alert("最多不超过"+this.maxQty);
                //通知不让下级点击了
                notclick = true;
            }else{
                notclick = false;
            }
            this.getChildren().forEach(function(item){
               item.notClick(notclick); 
            });
            if(this._matChangeTimer){
                clearTimeout(this._matChangeTimer);
            }
            var params = this.cqRefInfo.cqViewParam.params.split("-");
            var tsId = params[1];
            var mId = params[0];
            var detailId= params[2];
            remark += this.getRemark();
            params = {
                // 不需要传入fromShopId
                fromShopId:this.fromShopId,
                tsId:tsId,
                detailId:detailId,
                remark:remark,
                // 记录每一样属性值选择的数量 后台用户检查库存是否足够
                selectedOpt: selectedOpt,
                optId: this.optId
            };
            this._matChangeTimer = setTimeout(lang.hitch(this,function(){
                topic.publish("/cq/widget/item/mat/matOpt/matChanged",{
                    qty:qty,
                    params:params
                });
            }),300);
        },
        destroyRecursive:function(){
            var node = this.domNode;
            this.inherited(arguments);
            if(node.parentNode){
                node.parentNode.removeChild(node);
            }
        }
    });
});
