define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojo/dom-class",
    "dojo/dom-attr",
    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    "cq/util/image/blob"
],function(declare,lang,domStyle,domClass,domAttr,_WidgetBase,_TemplatedMixin, blob){
    return declare("",[_WidgetBase,_TemplatedMixin],{
        templateString:"<table class='cart-mat' data-dojo-attach-point='domNode'>"+
            "<tr>"+
                "<td class='imgTd'>"+
                    //链接和图标
                    "<a class='block'>"+
                        "<img class='large-icon' data-dojo-attach-point='logoNode'/>"+
                    "</a>"+
                "</td>"+
                "<td class='infoTd'>"+
                    "<div data-dojo-attach-point='infoNode' class='infoNode'>"+
                        //标题
                        "<div class='normal title' data-dojo-attach-point='titleNode'></div>"+
                        //单价和数量
                        "<div class='btmNode'>"+
                            "<div class='dtlNode'>"+
                                //库存
                                "<div class='center stockQty'>剩余 <span data-dojo-attach-point='maxQtyNode'></span></div>"+
                            "</div>"+
                            "<div data-dojo-attach-point='editNode'>"+
                                //数量加减
                                "<div class='editBtn'>"+
                                    "<span class='num-sub-icon sub' data-dojo-attach-point='subNode'>-</span>"+
                                    "<span class='fixed-width-120 showQty' data-dojo-attach-point='qtyNode'></span>"+
                                    "<span class='num-inc-icon add' data-dojo-attach-point='incNode'>+</span>"+
                                "</div>"+
                            "</div>"+
                        "</div>"+
                    "</div>"+
                "</td>"+
            "</tr>"+
        "</table>",
        //名称
        mName:"",
        logo:"",
        qty:0,
        optQty:"",
        mId:"",
        _id: "",
        //不允许点击
        notclick:false,
        buildRendering:function(){
            this.inherited(arguments);
            this.connect(this.incNode,"onclick",this.qtyIncClick);
            this.connect(this.subNode,"onclick",this.qtySubClick);
            this.connect(this.logoNode,"onclick", this.logoClick);
        },
        logoClick: function(e){
            var dom = e.target;
            require(["cq/widgets/bigImg"], function(bigImg){
                bigImg.show(domAttr.get(dom, "src"),0);
            });
        },
        onDataReady:function(list){
            this.mId = list._id||"";
            this._id = list._id||"";
            this.mName=list.name||"mName";
            this.logo = list.img||"";
            this.optQty = list.qty||0;
            this.updateList();
        },
        //赋值
        updateList:function(){
            if(this.logo){
                domStyle.set(this.logoNode.parentNode.parentNode, "display", "");
                this.logoNode.src = blob.getImageUrl(this.logo,"80");
            }else{
                domStyle.set(this.logoNode.parentNode.parentNode, "display", "none");
            }
            this.titleNode.innerHTML = this.mName;
            if(this.qty){
                this.setSubAndQty("",this.qty);
            }else{
                this.setSubAndQty("none",0);
            }
        },
        //设置减少和qty可见
        setSubAndQty:function(noneCss,qty){
            domStyle.set(this.qtyNode,"display",noneCss);
            domStyle.set(this.subNode,"display",noneCss);
            this.qtyNode.innerHTML = this.qty;
            this.maxQtyNode.innerHTML = this.optQty;
            this.onChanged();
        },
        //加
        qtyIncClick:function(){
            // 如果添加的数量>库存数量 则阻止点击
            if((this.qty+1)>this.optQty){
                alert(this.mName+"数量不足");
                this.notclick = true;
            }
            //减少到0 为删除
            if(this.notclick){
                //alert("不能再选择了");
                return;
            }
            if(parseInt(this.optQty)>this.qty){
                this.qty = this.qty+1;
            }else{
                alert(this.mName+"剩余数量不足");
                this.qty = parseInt(this.optQty);
            }
            this.setSubAndQty("",this.qty);
        },
        //减
        qtySubClick:function(){
            if(this.qty == 0){
                return;
            }
            //有最大的分数限制
            if(this.qty-1==0){
                this.qty = 0;
                this.setSubAndQty("none",this.qty);
            }else{
                this.qty= this.qty-1;
                this.setSubAndQty("",this.qty);
            }
        },
        //影响上级的底部按钮点击和总的合计
        onChanged:function(){
            if(this.getParent()){
                this.getParent().onChanged();
            }
        },
        getView:function(){
            var parent = this.getParent();
            while(parent&&!(parent.resize&&domClass.contains(parent.domNode,"mblView"))){
                parent = parent.getParent();
            }
            return parent;
        },
        //上级通知下级不允许再点击
        notClick:function(click){
            this.notclick = click;
        },
        destroyRecursive:function(){
            var node = this.domNode;
            this.inherited(arguments);
            if(node.parentNode){
                node.parentNode.removeChild(node);
            }
        }
    });
});