define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dijit/_WidgetBase",
    "cq/app/widget/_WidgetBase",
    "dijit/_TemplatedMixin",
    "bob/ts/orderChooseRecord/c"
],function(declare,lang,_WidgetBase,CqWidgetBase,_TemplatedMixin,orderChooseRecord){
    return declare("",[_WidgetBase,_TemplatedMixin,CqWidgetBase],{
        htmlTemp:"<div id='{id}' class='{className}' data-dojo-type='cq/widgets/item/mat/matOpt/matOptionBar'></div>",
        templateString:'<div data-dojo-attach-point="domNode" class="cartFoot">'+
            "<div class='text-right flex1' >"+
                "<div class='amount'>已选 "+
                    "<span class='highlight ' data-dojo-attach-point='totalNode'></span>"+
                "</div>"+
            "</div>"+
            "<div class='highlight-bg ' data-dojo-attach-point='settleNode'>选好了</div>"+
        '</div>',
        params:{},
        buildRendering:function(){
            this.inherited(arguments);
            this.connect(this.settleNode,"onclick",this.setOrderChoose);
            this.subscribe("/cq/widget/item/mat/matOpt/matChanged",function(info){
                this.totalNode.innerHTML = info.qty+" 份";
                this.params = info.params;
            });
        },
        setOrderChoose:function(){
            // 检查是否选择了
            if(!(this.params.selectedOpt&&this.params.selectedOpt.length)){
                alert("请先选择");
                return false;
            }
            window.busy();
            orderChooseRecord.save(this.params).then(lang.hitch(this,function(data){
                window.free();
                if(data&&data.data&&data.data.ok==1){
                    alert("提交成功");
                    history.back();
                }else{
                    alert(data&&data.data&&data.data.message||"提交失败");
                }
            }));
        },
        destroyRecursive:function(){
            var node = this.domNode;
            this.inherited(arguments);
            if(node.parentNode){
                node.parentNode.removeChild(node);
            }
        }
    });
});
