﻿define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/dom-class",
    "dojo/on",
    "dijit/_WidgetBase",
    "dijit/registry",
    "cq/app/widget/_WidgetBase",
    "cq/util/sys/date",
    "bob/ts/refundAplication/c"
],function(declare,array,lang,domConstruct, domStyle, domClass,on,_WidgetBase,registry,_CqWidgetBase,date,refundAplication){
    return declare("cq.widgets.item.order.refundSchedule", [_WidgetBase,_CqWidgetBase], {
        //徐阿雪 2017/3/2
        htmlTemp:"<div id='{id}' data-dojo-props='idMap:{idMap}' data-dojo-type='cq/widgets/item/order/RefundSchedule' class='cq-RefundSchedule'></div>",
        params:null,
        //清空按上次的数据
        destroyDescendants:function(){
            var divName = this.domNode.childNodes;
            var domLength = divName.length;
            for(var i=0;i<domLength;i++){
                this.domNode.removeChild(divName[0]);
            }
        },
        getView: function(){
            var parent = this.getParent();
            while(parent&&!(parent.resize&&domClass.contains(parent.domNode,"mblView"))){
                parent = parent.getParent();
            }
            return parent;
        },
        _getReason: function(type){
            var o = {
                '1':'退运费',
                '2':'做工问题',
                '3':'少件/漏发',
                '4':'商家发错货',
                '5':'商品与描述不符',
                '6':'未按约定时间发货',
                "7": "拼团失败退款"
            };
            return o[type]||"";
        },
        cqRefresh:function(){
            if(this.domNode.childNodes.length){
                this.destroyDescendants();
            }
            var id = this.cqRefInfo.cqViewParam.params;
            refundAplication.loadByRefundId(id).then(lang.hitch(this,function(data){
                this.params = data&&data.data&&data.data.item||"";
                if(this.params){
                    //创建顶部订单号
                    //domConstruct.create("div",{
                    //    style:"margin:8px;background:#fff;border-radius:5px;padding:6px 8px;height:40px",
                    //    innerHTML:'<div><span>订单号:'+this.params.tsId._id+'</span><br>'+
                    //    '<span>退款金额：'+this.params.amount+'<span>'+
                    //    ''+
                    //    '</div>'
                    //},this.domNode);
                    //1买家申请等待卖家确认 2卖家同意 3卖家不同意 4财务已退款 5已取消
                    this.logisticsNode = domConstruct.create("div",{
                        "class": "refund-items"
                    },this.domNode);
                    var items = [];
                    items.push({
                        title: "买家发起了申请",
                        txt: "发起了退款不退货申请，原因："+this._getReason(this.params.reason)+"，金额："+this.params.amount+"元"+(this.params.describe?("，说明："+this.params.describe):""),
                        time: this.params.createAt,
                        pos: "right"
                    });
                    
                    if(this.params.state==5){
                        items.push({
                            title: "买家撤销了申请",
                            txt: "买家主动撤销了退款申请",
                            time: this.params.revokeTime,
                            pos: "right"
                        });
                    }
                    if(this.params.state>=2&&this.params.state<5&&this.params.state!=3){
                        items.push({
                            title: "卖家同意了申请",
                            txt: "卖家已同意退款申请，余额支付部分已到账，现金部分将在两个工作日内退还原支付帐户，请注意查收",
                            time: this.params.verifyTime,
                            pos: "left"
                        });
                    }
                    if(this.params.state==3){//this.params.state>=2&&this.params.state<5
                        items.push({
                            title: "卖家拒绝了申请",
                            txt: "卖家已拒绝退款申请，具体原因，请联系卖家客服",
                            time: this.params.rejectTime,
                            pos: "left"
                        });
                    }
                    if(this.params.state>=4&&this.params.state<5){
                        items.push({
                            title: "平台同意了申请",
                            txt: "平台已将支付金额退还原支付帐户，具体到帐时间以银行到帐时间为准，请注意查收",
                            time: this.params.platVerifyTime,
                            pos: "left"
                        });
                    }
                    
                    items.forEach(function(item){
                        domConstruct.create("div", {
                            "class": "refund-item",
                            innerHTML: "<div class='hflex'><div class='flex1'></div><div class='refund-time'>"+date.getTimeMoment(item.time)+"</div><div class='flex1'></div></div>"+
                            "<div class='refund-content "+item.pos+"'>"+
                                "<div class='refund-title'>"+item.title+"</div>"+
                                "<div class='refund-inner'>"+item.txt+"</div>"+
                            "</div>"
                        }, this.logisticsNode);
                    }, this);
                    
                    
                    /*var stateMsg = [{"state":"您已提交退款申请，请等待商家审核！","time":this.params.createAt},
                                    {"state":"卖家同意退款，两个工作日内到账，请注意查收！","time":this.params.verifyTime},
                                    {"state":"财务已退款，请核对退款金额","time":this.params.platVerifyTime},
                                    {"state":"退款关闭","time":""},
                                    {"state":"您已撤销退款","time":this.params.revokeTime}];
                    //1买家申请等待卖家确认 2卖家同意  4财务已退款 5已取消(revoke)
                    var state = [];
                    if(this.params.state==1){
                        state = stateMsg.slice(0,1);  
                    }else if(this.params.state == 2){
                        state = stateMsg.slice(0,2);
                    }else if(this.params.state == 5){
                        state = [{"state":"您已提交退款申请，请等待商家审核！","time":this.params.createAt},{"state":"您已撤销退款","time":this.params.revokeTime}];
                    }else if(this.params.state == 4){
                        state = stateMsg.slice(0,3);
                    }
                    this.logisticsNode = domConstruct.create("div",{
                        class:"logisticsDiv"
                    },this.domNode);
                    this.createLogistics(state);*/
                    if(this.params.state == 1){
                        domStyle.set(this.cancelRefundNode, "display", "");
                    }else{
                        domStyle.set(this.cancelRefundNode, "display", "none");
                    }
                    var view = this.getView();
                    if(view){
                        view.resize();
                    }
                }
            }));
        },
        buildRendering:function(){
            this.inherited(arguments);
            setTimeout(lang.hitch(this, function(){
                this.cancelRefundNode = registry.byId(this.idMap["1"]).domNode;
                this.connect(this.cancelRefundNode, "onclick", this.cancelRefund);
            },100));
        },
        /*createLogistics:function(logisticsStates){
            var _this = this;
            var time = "";
            var logisticsText = "";
            this.logisticsNode.innerHTML = "";
            for(var i=logisticsStates.length-1;i>=0;i--){
                time = date.formatISODateMinutes(logisticsStates[i].time);
                logisticsText = logisticsStates[i].state;
                if(i+1==logisticsStates.length){
                    domConstruct.create("div",{
                        class:"hflex",
                        innerHTML:"<div class='refundLine'>"+
                                      "<span class='logisticsIconSelect'></span>"+
                                  "</div>"+
                                  "<div class='flex1' style='margin-bottom:10px;padding-bottom:10px;border-bottom:1px solid rgba(204, 204, 204, 0.35)'>"+
                                      "<div>"+logisticsText+"</div>"+
                                      "<span>"+time+"</span>"+
                                  "</div>"
                    },_this.logisticsNode)
                }else{
                    domConstruct.create("div",{
                        class:"hflex",
                        innerHTML:"<div class='refundLine'>"+
                                      "<span class='logisticsIcon'></span>"+
                                  "</div>"+
                                  "<div class='flex1' style='margin-bottom:10px;padding-bottom:10px;border-bottom:1px solid rgba(204, 204, 204, 0.35)'>"+
                                      "<div>"+logisticsText+"</div>"+
                                      "<span>"+time+"</span>"+
                                  "</div>"
                    },_this.logisticsNode)
                }
            }
        },*/
        //取消退款
        cancelRefund:function(){
            window.busy();
            refundAplication.revoke(this.cqRefInfo.cqViewParam.params).then(lang.hitch(this,function(data){//item.userShopId._id,
                window.free();
                if(data&&data.data&&data.data.ok==1){
                    alert("撤销成功");
                    this.cqRefresh();
                }else{
                    alert(data&&data.data&&data.data.msg||"撤销失败");
                }
            }));
        }
    });
});