﻿define([
	"dojo/_base/declare",
	"dojo/_base/array",
	"dojo/_base/lang",
    "dojo/query",
	"dojo/on",
	"dojo/dom-construct",
	"dijit/_WidgetBase",
    "dojo/Deferred",
    "dojox/mobile/ScrollablePane",
    "dojox/mobile/FixedSplitter",
    "dojox/mobile/Pane"
], function (declare, array, lang, query, on, domConstruct, _WidgetBase, Deferred, ScrollablePane, FixedSplitter, Pane) {
	return declare("cq.widgets.item.order.UpdateOrderPic", [_WidgetBase], {
        data: null,
        init:function(data){
            this.picDef = new Deferred();
            this.domNode.innerHTML = "";
            this.data = data;
            this.initElement();
            //若没有初始化，执行初始化
            //销毁原来的
            //记录当前正在修改的数据
            //依据正在修改的数据创建界面元素
            return this.picDef;
            //返回def
        },
        //初始化
            //创建列表
            //创建确定取消按钮，事件
            //设置固定高度
        //完成按钮
            //从列表中取数据
            //提交数据
            //def.resolve
        //取消：def
        initElement: function(){
            this.details = this.data.details;
            
            if(this._cqSp){
                this._cqSp.destroyRecursive();
            }
            
            // 创建scrollablePane
            var fixed = this._cqSp = new FixedSplitter({
                orientation:"V",
                variablePane:0,
                style: "position:relative;height:300px;"
            });
            fixed.placeAt(this.domNode);
            var pane1 = new Pane({
                
            });
            var scrollPane = new ScrollablePane({
                style: "height:264px;",
                height: "100%",
                scrollDir:"v"
            });
            scrollPane.placeAt(pane1.domNode);
            var pane = new Pane({
                style: "height:36px;"
            });
            fixed.addChild(pane1);
            fixed.addChild(pane);
            
            // 查询有几行明细数据
            var itemNode = null;
            array.forEach(this.details, function(item){
                itemNode = domConstruct.create("div", {
                    innerHTML: "<a class='item-img'>"+
                        "<img src='"+item.mId.logo+"'>"+
                    "</a>"+
                    "<div class='flex1 '>"+
                        "<div class='hflex_top' style='font-size:14px;'>"+
                            "<div class='item-info' style='text-align:left;'>"+
                                "<h3 class='h3 title'>"+item.mName+"</h3>"+
                                (item.specName?"<p class='sku'>规格: "+item.specName+"</p>":"")+
                            "</div>"+
                            "<div class='item-pay'>"+
                                "<div class='item-pay-data'>"+
                                    "<p class='price'>￥"+item.price+"×"+item.qty+"</p>"+
                                    "<p class='qty'>小计：¥"+item.amount+"</p>"+
                                "</div>"+
                            "</div>"+
                        "</div>"+
                        "<div class='hflex' style='font-size:14px;'>"+
                            "<div class='flex1' style='text-align:left;'>优惠金额</div>"+
                            "<input style='-webkit-appearance: none;border: 1px solid #e5e5e5;border-radius: 0;text-align: right;height: 26px;font-size: 14px;width: 100px;' class='flex1 discountAmount' placeholder='请填写优惠金额' type='text'/>"+
                        "</div>"+
                    "</div>",
                    "class": "item-list o-t-item"
                }, scrollPane.containerNode);
            }, this);
            
            var items = query(".discountAmount", this.domNode);
            array.forEach(items,function(item,index){
                fixed.connect(item,"onblur",lang.hitch(this,function(){
                    var dis = 0;
                    query(".discountAmount", this.domNode).forEach(function(node){
                        dis += parseFloat(node.value)||0;
                    });
                    query(".totalPrice", this.domNode)[0].innerHTML = this.data.amount-dis;
                }));
            },this);
            domConstruct.create("div", {
                innerHTML: "<h3>"+
                    "<div>实付款</div>"+
                    "<div>￥<font class='totalPrice'>"+this.data.amount+"</font></div>"+
                "</h3>",
                "class": "order-dtl-amnt"
            }, scrollPane.containerNode);
            var btnNode = domConstruct.create("div",{
                "class": "hflex"
            }, pane.domNode);
            cancelBtn = domConstruct.create("a", {
                "class": "flex1 button",
                innerHTML: "取消"
            }, btnNode);
            confirmBtn = domConstruct.create("a", {
                "class": "flex1 button",
                innerHTML: "确认"
            }, btnNode);
            setTimeout(function(){
                fixed.resize();
            }, 100);
            fixed.connect(cancelBtn, "onclick", lang.hitch(this, this.cancelUpdate));
            fixed.connect(confirmBtn, "onclick", lang.hitch(this, this.updatePic));
        },
        updatePic: function(){
            var discountData = [];
            array.forEach(this.details,function(item,index){
                discountData.push({
                    _id:item._id,
                    discountAmount:parseFloat(query(".discountAmount",this.domNode)[index].value)*-1
                });
            },this);
            // 判断优惠价格是否小于商品价格
            var flag = true, preAmount = this.data.preAmount||0;
            array.forEach(this.details,function(item,index){
                // 定金不允许优惠
                var price = (item.amount-preAmount) + discountData[index].discountAmount;
                if(price<0){
                    flag = false;
                }
            });
            if(flag){
                var detail = JSON.stringify(discountData);
                require(["bob/ts/orderB"], lang.hitch(this, function(orderB){
                    window.busy();
                    orderB.updateAmount(detail,this.data._id).then(lang.hitch(this, function(result){
                        window.free();
                        this.picDef.resolve(true);
                    }));
                }));
            }else{
                this.picDef.resolve(false);
                alert("优惠价格不能大于商品实际支付价格");
            }
        },
        cancelUpdate: function(){
            this.picDef.resolve(false);
        }
	});
});