define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "bob/user/consumer",
    "cq/widgets/item/orderInfo/info/AppOrderInfo"
],function(declare,lang,Deferred,consumer,AppOrderInfo){
    var props = 'addr:{addr},card:{card},order:{order},onlySelected:{onlySelected},ItemRender:{ItemRender},renderOption:{j:renderOption},orderType:{orderType}';
    return declare("",[AppOrderInfo],{
        htmlTemp:"<div id='{id}' class='{className}' data-dojo-type='cq/widgets/item/orderInfo/info/AppDeliveryOrderInfo' data-dojo-props='"+props+"'></div>",
        loadInfoData:function(){
            var def = new Deferred(),cardId = this.cqRefInfo.cqViewParam.params;
            consumer.hasLogin().then(lang.hitch(this,function(hasLogin){
                if(hasLogin){
                    this._getCurrentAddr(this.addrId._id).then(lang.hitch(this,function(addr){
                        this.card.loadById(cardId).then(lang.hitch(this,function(data){
                            if(1!==(data&&data.data&&data.data.ok)){
                                alert(data&&data.dat&&data.data.message||"系统繁忙，请稍后重试");
                                return history.back();
                            }
                            var info = {
                                addr:addr,
                                shops:[],
                                cardId:cardId,
                                mids:data.data.item.cardId.mId._id,
                                fromShopId:data.data.item.cardId.mId.fromShopId
                            },shopInfo = {},
                            shops = data.data&&data.data.item.cardId.mId||{};
                            shops.qty = data.data&&data.data.item.cardId.mQty;
                            shops.price = data.data&&data.data.item.cardId.price;
                            shopInfo.coupons = [];
                            shopInfo.matInfo = shops;
                            shopInfo.mats = [];
                            shopInfo.mats.push(shops);
                            shopInfo.tAmount = data.data&&data.data.item.cardId.freight;
                            shopInfo.totalPrice = shops.qty*shops.price;//+shopInfo.tAmount
                            shopInfo.shopInfo = shops.fromShopId;
                            info.shops.push(shopInfo);
                            def.resolve(info);
                        }));
                    }));
                }else{
                    window.moveToView("login");
                }
            }));
            return def;
        },
        getOrderInfo:function(){
            return {
                dName:this.orderInfo.addr.contactName,
                dTel:this.orderInfo.addr.tel,
                dAddress:(this.orderInfo.addr.distAddr||"")+this.orderInfo.addr.detailAddress,
                addressId:this.orderInfo.addr._id,
                shopId:this.orderInfo.fromShopId,
                cardId:this.orderInfo.cardId
            };
        },
        postOrder:function(info){
            return this.order.createDeliveryOrder(info);
        }
    });
});