/*
变更人：徐阿雪
变更时间：2017/2/10
变更内容：提交订单，与订单列表保持一致
*/
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-construct",
    "dojo/Deferred",
    "dojo/dom-class",
    "dojo/dom-attr",
    "dojo/topic",
    "dijit/registry",
    "dijit/_Container",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetBase",
    "dojox/mobile/Pane",
    "dojox/mobile/Heading",
    "dojox/mobile/ToolBarButton",
    "dojox/mobile/ScrollablePane",
    "bob/user/consumer",
    "./_Info",
    "cq/util/edit/overlay",
    "cq/util/payType/icon",
    "cq/ui/util/addr/addrPicker",
    "cq/app/widget/utils/widget"
],function(declare,lang,array,domConstruct,Deferred,domClass,domAttr,topic,registry,_Container,_TemplatedMixin,_WidgetBase,Pane,Heading,ToolBarButton,ScrollablePane,consumer,_Info,overlay,icon,addrPicker,widget){
    var props = 'addr:{addr},prizeResult:{prizeResult},order:{order},onlySelected:{onlySelected},ItemRender:{ItemRender},renderOption:{j:renderOption},orderType:{orderType}';
    return declare("",[_WidgetBase,_Container,_TemplatedMixin,_Info],{
        htmlTemp:"<div id='{id}' class='{className}' data-dojo-type='cq/widgets/item/orderInfo/info/AppGiftOrderInfo' data-dojo-props='"+props+"'></div>",
        templateString:'<div data-dojo-attach-point="domNode">'+
        //收货地址
        '<div class="mat-item-cells" style="margin-bottom:10px;" data-dojo-attach-point="addrNode">'+
            //左侧的位置图标通过css实现
            '<div class="addrNode">'+
                '<div class="hflex">'+
                    '<div class="flex1" ><span data-dojo-attach-point="dNameNode"></span></div>'+
                    '<div data-dojo-attach-point="dTelNode"></div>'+
                '</div>'+
                '<div data-dojo-attach-point="addrDtlNode"></div>'+
            '</div>'+
        '</div>',
        // 订单支付完成后 要隐藏overlay 并且刷新显示
        onOrderPayFinished: function(result){
            if(result&&result.data&&result.data.ok==0){
                alert(result.data.message);
            }
            overlay.hide();
            setTimeout(function(){
                topic.publish("cq/sys/forceRefresh");
            },300);
        },
        //重写提交订单，余额为0的时候不允许余额支付
        onOrderCreated:function(orderInfo){
            //若提交失败
            if(1!==(orderInfo&&orderInfo.data&&orderInfo.data.ok)){
                //给出提示
                alert(orderInfo.data.msg);
                history.back();
                throw "提交订单错误:"+orderInfo.data.msg;
            }
            //如果余额不足的话
            var order = orderInfo.data.item;
            var point = 0;
            //显示的order扣费信息的order
            var totalOrder = {
                tsInfo: {payAmount:0,amount:0,couponAmount:0,point:0, gold:0},
                ids: []
            };
            for(var i in order){
                if(order[i]){
                    point += order[i].order.point;
                    totalOrder.tsInfo.amount += order[i].order.amount;
                    totalOrder.tsInfo.couponAmount += order[i].order.couponAmount;
                    totalOrder.tsInfo.point +=order[i].order.point;
                    totalOrder.tsInfo.gold +=order[i].order.gold||0;
                    totalOrder.tsInfo.payAmount += order[i].order.payAmount;
                    totalOrder.ids.push(order[i].order._id);
                }
            }
            var payInfo = this.getOrderPayInfo(orderInfo);
            //余额不足以支付的情况显示余额么
            icon.payOrder(
                totalOrder,
                lang.hitch(this, this.onOrderPayFinished),
                {
                    payer: this.order,
                    payMethod:"payByIds",
                    // 应该获取商家已配置的支付方式
                    payTypes:this.order.getValidPayType(totalOrder.tsInfo)
                }
            ).then(function(){
                overlay.hide();
            });
            overlay.showElement(icon.domNode,null);
            var handler = this.connect(overlay,"realHided", lang.hitch(this, function(){
                handler.remove();
                this.onOrderFinished(payInfo);
            }));
        },
        onAddrChanged:function(){
            //如果没有地址的话添加地址，跳转页面
            var addr = this.orderInfo&&this.orderInfo.addr;
            if(addr._id){
                //var addr = this.orderInfo.addr.detailAddress;
                this.dNameNode.innerHTML = "收货人:"+addr.contactName||"";
                this.dTelNode.innerHTML = addr.tel||"";
                this.addrDtlNode.innerHTML = (addr.distAddr||"")+(addr.detailAddress||"");
            }else{
                this.dNameNode.innerHTML = "<div class='emptyAddr'>请添加收货地址</div>";
                this.dTelNode.innerHTML = "";
                this.addrDtlNode.innerHTML = "";
            }
        },
        //点击地址获取刷新地址
        getAddr:function(e){
            var view = this.getView();
            addrPicker.addr = this.addr;
            return addrPicker.startEdit(this.orderInfo&&this.orderInfo.addr,view);
        },
        getView:function(){
            return widget.getEnclosingView(this);
        },
        loadInfoData:function(){
            var def = new Deferred(),prizeResultId = this.cqRefInfo.cqViewParam.params;
            //params = {};
            //params.prizeResultId = prizeResultId;
            //检验是否登录，没有登录去登陆
            consumer.hasLogin().then(lang.hitch(this,function(hasLogin){
                if(hasLogin){
                    this._getCurrentAddr(this.addrId._id).then(lang.hitch(this,function(addr){
                        //this.order.createGiftOrder(params)
                        this.prizeResult.loadMatInfoById(prizeResultId).then(lang.hitch(this,function(data){
                            if(1!==(data&&data.data&&data.data.ok)){
                                alert(data.data.message||"系统繁忙，请稍后重试");
                                return history.back();
                            }
                            var info = {
                                addr:addr,
                                shops:[],
                                prizeResultId:prizeResultId,
                                mids:data.data.item.awardMid._id,
                                fromShopId:data.data.item.awardMid.fromShopId
                            },shopInfo = {},
                            shops = data.data&&data.data.item.awardMid||{};
                            shops.qty = 1;
                            shops.price = 0;
                            //shops.fromShopId = {_id:shops.fromShopId,shopName:"aaa"};
                            shopInfo.matInfo = shops;
                            shopInfo.mats = [];
                            shopInfo.mats.push(shops);
                            shopInfo.tAmount = 0;
                            shopInfo.totalPrice = 0;
                            //后台引用不可用，先用在村头，但是id是对的//{_id:shops.fromShopId,shopName:"在村头"};
                            shopInfo.shopInfo = shops.fromShopId;
                            info.shops.push(shopInfo);
                            def.resolve(info);
                        }));
                    }));
                }else{
                    window.moveToView("login");
                }
            }));
            return def;
        },
        getOrderInfo:function(){
            //数据合法性检查
            //收货地址和交付方式
            //商品
            return {
                dName:this.orderInfo.addr.contactName,
                dTel:this.orderInfo.addr.tel,
                // 记录完整的地址信息 2017-2-28 刘轩
                dAddress:(this.orderInfo.addr.distAddr||"")+this.orderInfo.addr.detailAddress,
                //mids:this.orderInfo.mids,
                addressId:this.orderInfo.addr._id,
                shopId:this.orderInfo.fromShopId,
                prizeResultId:this.orderInfo.prizeResultId
            };
        },
        getAmt:function(){
            var info = {totalAmt:0,couponAmt:0,tranAmt:0,qty:1}
            return info;
        },
        postOrder:function(info){
            return this.order.createGiftOrder(info);
        }
    });
});

