/*
变更人：徐阿雪
变更时间：2017/2/10
变更内容：提交订单，与订单列表保持一致
*/
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-construct",
    "dojo/Deferred",
    "dojo/dom-class",
    "dojo/dom-attr",
    "dojo/dom-style",
    "dojo/topic",
    "dijit/registry",
    "dijit/_Container",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetBase",
    "dojox/mobile/Pane",
    "dojox/mobile/Heading",
    "dojox/mobile/ToolBarButton",
    "dojox/mobile/ScrollablePane",
    "./_Info",
    "cq/util/edit/overlay",
    "cq/util/payType/icon",
    "cq/ui/util/addr/addrPicker",
    "cq/app/widget/utils/widget"
],function(declare,lang,array,domConstruct,Deferred,domClass,domAttr,domStyle,topic,registry,_Container,_TemplatedMixin,_WidgetBase,Pane,Heading,ToolBarButton,ScrollablePane,_Info,overlay,icon,addrPicker,widget){
    var props = 'addr:{addr},cart:{cart},order:{order},onlySelected:{onlySelected},ItemRender:{ItemRender},renderOption:{j:renderOption},orderType:{orderType}';
    return declare("",[_WidgetBase,_Container,_TemplatedMixin,_Info],{
        htmlTemp:"<div id='{id}' class='{className}' data-dojo-type='cq/widgets/item/orderInfo/info/AppOrderInfo' data-dojo-props='"+props+"'></div>",
        templateString:'<div data-dojo-attach-point="domNode">'+
        //收货地址
        '<div class="mat-item-cells" style="margin-bottom:10px;margin-top:0;border-top:5px dashed #9fc7af;" data-dojo-attach-point="addrNode">'+
            //左侧的位置图标通过css实现
            '<div class="addrNode">'+
                '<div class="hflex">'+
                    '<div class="flex1" ><span data-dojo-attach-point="dNameNode"></span></div>'+
                    '<div data-dojo-attach-point="dTelNode"></div>'+
                '</div>'+
                '<div style="margin-top:8px;" data-dojo-attach-point="addrDtlNode"></div>'+
            '</div>'+
        '</div>',
        // 订单支付完成后 要隐藏overlay 并且刷新显示
        onOrderPayFinished: function(result){
            if(result&&result.data&&result.data.ok==0){
                alert(result.data.message);
            }
            overlay.hide();
            setTimeout(function(){
                topic.publish("cq/sys/forceRefresh");
            },300);
        },
        //重写提交订单，余额为0的时候不允许余额支付
        onOrderCreated:function(orderInfo){
            this.inherited(arguments);
            if(this.isB2C){
                return;
            }
            //如果余额不足的话
            var order = orderInfo.data.item;
            //显示的order扣费信息的order
            var totalOrder = {
                tsInfo: {payAmount:0,amount:0,couponAmount:0,point:0,gold:0},
                ids: []
            };
            for(var i in order){
                if(order[i]){
                    //预售商品的金额显示
                    var ts = order[i].order;
                    if(ts.preSaleId){
                        // 未支付定金
                        if(!ts.isPreAmountPayed){
                            //支付定金
                            ts.payAmount = ts.preAmount-ts.prePoint-ts.preGold-ts.preCoupon;
                            ts.amount = ts.preAmount;
                            ts.point = ts.prePoint;
                            ts.gold = ts.preGold;
                            ts.couponAmount = ts.preCoupon;
                        }
                    }
                    totalOrder.tsInfo.amount += ts.amount;
                    totalOrder.tsInfo.couponAmount += ts.couponAmount;
                    totalOrder.tsInfo.point +=ts.point;
                    totalOrder.tsInfo.payAmount += ts.payAmount;
					// 金元宝信息 2017-5-16 刘轩
					totalOrder.tsInfo.gold +=ts.gold||0;
                    totalOrder.ids.push(ts._id);
                }
            }
            var payInfo = this.getOrderPayInfo(orderInfo);
            //余额不足以支付的情况显示余额么
            icon.payOrder(
                totalOrder,
                lang.hitch(this, this.onOrderPayFinished),
                {
                    payer: this.order,
                    payMethod:"payByIds",
                    // 应该获取商家已配置的支付方式
                    payTypes:this.order.getValidPayType(totalOrder.tsInfo)
                }
            ).then(function(){
                overlay.hide();
            });
            overlay.showElement(icon.domNode,null);
            var handler = this.connect(overlay,"realHided", lang.hitch(this, function(){
                handler.remove();
                this.onOrderFinished(payInfo);
            }));
        },
        onAddrChanged:function(){
            //如果没有地址的话添加地址，跳转页面
            var addr = this.orderInfo&&this.orderInfo.addr;
            if(addr._id){
                this.dNameNode.innerHTML = "收货人："+addr.contactName||"";
                this.dTelNode.innerHTML = addr.tel||"";
                this.addrDtlNode.innerHTML = "收货地址："+(addr.distAddr||"")+(addr.detailAddress||"");
            }else{
                this.dNameNode.innerHTML = "<div class='emptyAddr'>请添加收货地址</div>";
                this.dTelNode.innerHTML = "";
                this.addrDtlNode.innerHTML = "";
            }
        },
        //点击地址获取刷新地址
        getAddr:function(e){
            var view = this.getView();
            addrPicker.addr = this.addr;
            return addrPicker.startEdit(this.orderInfo&&this.orderInfo.addr,view);
        },
        getView:function(){
            return widget.getEnclosingView(this);
        },
        onDataReady:function(){
            this.inherited(arguments);
            if(this.isB2C&&!this.showAddr){
                domStyle.set(this.addrNode,'display','none');
            }
        }
    });
});

