define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dijit/_WidgetBase",
    "cq/app/widget/_WidgetBase",
    "dijit/_TemplatedMixin"
],function(declare,lang,domStyle,_WidgetBase,_CqWidgetBase,_TemplatedMixin){
    return declare("",[_WidgetBase,_TemplatedMixin,_CqWidgetBase],{
        htmlTemp:"<div id='{id}' data-dojo-type='cq/widgets/item/orderInfo/info/AppOrderInfoBar'></div>",
        templateString:"<div data-dojo-attach-point='domNode' class='cartFoot'>"+
            "<div class='text-right'>"+
                "<div class='amount'>合计金额：<span class='highlight ' style='font-size:18px;'>¥"+
                    "<font data-dojo-attach-point='amtNode'></font></span>"+
                "</div>"+
                "<div data-dojo-attach-point='tAmountNode' class='transAmount'>含运费：￥"+
                "<font data-dojo-attach-point='tranFeeNode'></font></span>"+
                "</div>"+
            "</div>"+
            "<div class='highlight-bg ' data-dojo-attach-point='settleNode'>提交订单</div>"+
        "</div>",
        buildRendering:function(){
            this.inherited(arguments);
            this.connect(this.settleNode,"onclick",this.onSettle);
        },
        observe:function(widget,field){
            if(field==="info"){
                this.infoItem = widget;
                //处理刷新订单金额信息
                this.connect(this.infoItem,"updateAmt",function(info){
                     if(this.infoItem.isB2C&&!this.isHideTranFee){
                        this.isHideTranFee = true;
                        domStyle.set(this.tAmountNode,'display','none');
                        domStyle.set(this.tranFeeNode,'display','none');
                    }
                    this.amtNode.innerHTML = this.totalAmt = window.fixedTo(info.totalAmt-info.couponAmt+info.tranAmt,3);
                    this.tranFeeNode.innerHTML = window.fixedTo(info.tranAmt,3);
                });
            }
            this.inherited(arguments);
        },
        onSettle:function(){
            //调用订单信息对象的提交订单接口
            if(this.infoItem.isB2C){
                var cus = this.cqRefInfo.customer||{};
                var dis = this.cqRefInfo.discount||{};
                var data = lang.mixin(cus,dis);
                if((data.amount&&data.amount*1)>(this.totalAmt*1)){
                    alert('优惠金额不能大于商品总价');
                    return;
                }
                this.infoItem.submitOrderB2C(data);
            }else{
                this.infoItem.submitOrder();    
            }
        }
    });
});