define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-construct",
    "dojo/Deferred",
    "dojo/dom-class",
    "dojo/dom-attr",
    "dijit/registry",
    "dijit/_Container",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetBase",
    "./_Info",
    "cq/util/edit/overlay",
    "cq/util/payType/icon",
    "cq/ui/util/addr/addrPicker",
    "cq/app/widget/utils/widget",
    "cq/app/widget/web/List",
    "bob/BoBase"
],function(declare,lang,array,domConstruct,Deferred,domClass,domAttr,registry,_Container,_TemplatedMixin,_WidgetBase,_Info,overlay,icon,addrPicker,widget,List,BoBase){
    var props = 'addr:{addr},cart:{cart},order:{order},onlySelected:{onlySelected},ItemRender:{ItemRender},renderOption:{j:renderOption},orderType:{orderType}';
    return declare("",[_WidgetBase,_Container,_TemplatedMixin,BoBase.C,_Info],{
        htmlTemp:"<div id='{id}' class='{className}' data-dojo-type='cq/widgets/item/orderInfo/info/WebOrderInfo' data-dojo-props='"+props+"'></div>",
        templateString:'<div data-dojo-attach-point="domNode" class="confirm-order">'+
            '<div>'+
                '<h2>确认收货信息</h2>'+
                '<div data-dojo-attach-point="addrListNode"></div>'+
                '<div><a data-dojo-attach-point="addAddrNode" class="newAddrBtn changAddr">　　使用新地址</a></div>'+
            '</div>'+
            '<h2>确认订单信息</h2>'+
            '<div class="order-item-filter hflex">'+
                '<div class="td" style="width:640px;">商品信息</div>'+
                '<div class="td flex">单价(元)</div>'+
                '<div class="td flex">数量</div>'+
                '<div class="td flex">小计(元)</div>'+
            '</div>'+
            '<div data-dojo-attach-point="containerNode"></div>'+
            '<div style="overflow:hidden">'+
            '<div class="payInfo hflex">'+
                '<div class="flex"></div>'+
                    '<div style="border: 1px solid #f40;min-width: 230px;">'+
                        '<div class="payInfo-box">'+
                            '<p>总额￥ <font class="realPay-price" data-dojo-attach-point="totalNode"></font></p>'+
                            '<p>运费￥ <font class="realPay-discount" data-dojo-attach-point="tranNode"></font></p>'+
                            '<p>优惠￥ <font class="realPay-tAmount" data-dojo-attach-point="couponNode"></font></p>'+
                            '<p>实付￥ <font class="realPay-realPay" data-dojo-attach-point="realNode"></font></p>'+
                         '</div>'+
                    '</div>'+
                '</div>'+
                '<div class="checkOutButton"><a class="pub-btn-big-orange checkOut" data-dojo-attach-point="submitNode">提交订单</a></div>'+
             '</div>'+
        '</div>',
        fields:{
            contactName:{
                "className":"large-width",
                "type":"text",
                "label":"收货人",
                "canEdit":true,
                "field":"contactName"
            },
            tel:{
                "className":"large-width",
                "type":"text",
                "label":"收货电话",
                "canEdit":true,
                "field":"tel"
            },
            "provinceId,cityId,countyId,distAddr":{
                "type":"district",
                "label":"区划",
                "canEdit":true,
                "field":"provinceId,cityId,countyId,distAddr"
            },
            detailAddress:{
                "className":"large-width",
                "type":"text",
                "label":"收货地址",
                "canEdit":true,
                "field":"detailAddress"
            },
            isDefault:{
                "className":"large-width",
                "type":"checkbox",
                "label":"默认地址",
                "canEdit":true,
                "field":"isDefault"
            },
            saveAddr:{
                type:"action",
                label:"保存",
                className:"buttom",
                action:"saveAddr"
            },
            cancelAddr:{
                type:"action",
                label:"取消",
                className:"buttom",
                action:"cancelAddr"
            }
        },
        infoShowType:overlay,
        payTypeType:icon,
        payTypeOptions:{
            payMethod:"payByIds",
            payTypes:[{
                name: "余额",
                type:"point",
                logo:"./images/temp/pointpay.png"
            },{
                name: "微信",
                type:"weixin",
                logo:"./images/temp/weixinpay.png"
            },{
                name: "微信",
                type:"wxapp",
                logo:"./images/temp/weixinpay.png"
            },{
                name: "支付宝",
                type:"aliapp",
                logo:"./images/temp/alipay.png"
            }]
        },
        buildRendering:function(){
            this.inherited(arguments);
            this.connect(this.addAddrNode,"onclick",function(){
                this.addAddr();
            });
            this.connect(this.submitNode,"onclick",function(){
                this.submitOrder();
            });
            //地址列表
            this.addrList = new List({
                itemType:"Label",
                workMode:"action",
                dataProvider:this,
                clickMethod:"onAddrClick",
                items:[],
                getItemParam:function(data){
                    return {
                        label:data.label,
                        baseClass:"addr-item",
                        data:data
                    };
                }
            },this.addrListNode);
        },
        onAddrClick:function(data,action,list){
            if(this._preventAddrClick){
                return;
            }
            clearTimeout(this._addrClickTimer);
            this._preventAddrClick = true;
            this._addrClickTimer = setTimeout(lang.hitch(this,function(){
                this._preventAddrClick = false;
            }),300);
            if(action==="setDefault"){
                this.getCurrendAddr().then(lang.hitch(this,function(addr){
                    this.addr.setDefaultAddr(data._id).then(lang.hitch(this,function(){
                        this.refreshAddrList(addr);
                    }));
                }));
            }else{
                this.refreshAddrList(data).then(lang.hitch(this,function(){
                    this.setAddr(data);
                }));
            }
        },
        refreshAddrList:function(addr){
            return this.addr.getAllAddr().then(lang.hitch(this,function(data){
                data = data||[];
                if(data.data){
                    data = data.data;
                }
                if(data.items){
                    data = data.items;
                }
                var addrId = addr&&addr._id||data[0]&&data[0]._id;
                for(var i=0;i<data.length;i++){
                    data[i].label = this._getWebAddrLabel(data[i],addrId);
                }
                this.addrList.items = data;
                this.addrList.cqRefresh();
                if(!data.length){
                    this.addAddr();
                }
            }));
        },
        cqRefresh:function(){
            this.getCurrendAddr().then(lang.hitch(this,function(addr){
                this.refreshAddrList(addr).then(lang.hitch(this,function(){
                    this.setAddr(addr);
                }));
            }));
        },
        _getWebAddrLabel:function(addr,selectedAddr){
            addr.distAddr = addr.distAddr||((
                addr.provinceId&&addr.provinceId.distName||""
            )+(
                addr.cityId&&addr.cityId.distName||""
            )+(
                addr.countyId&&addr.countyId.distName||""
            ));
            if(addr._id===selectedAddr){
                return '<div class="addressBox">'+
                    '<div>'+
                        '<i class="marker"></i>'+
                        '<span class="marker-tip">寄送至</span>'+
                    '</div>'+
                    '<label class="addressInfo">'+
                        '<input type="checkbox" name="address" checked="checked">'+
                        '<span class="user-address">'+
                            '<span>'+addr.distAddr+'</span>'+
                            '<span>'+addr.detailAddress+'</span>'+
                            '<span>（</span>'+
                            '<span>'+addr.contactName+'</span>'+
                            '<span> 收）</span>'+
                            '<em>'+addr.tel+'</em>'+
                        '</span>'+
                        '<span class="tips">'+(
                            addr.isDefault?"":'<a class="set-default" cq-action="setDefault">设置为默认收货地址</a>'
                        )+'</span>'+
                    '</label>'+
                '</div>';
            }else{
                return '<div class="addressBox">'+
                    '<label class="addressInfo">'+
                        '<input type="checkbox" name="address">'+
                        '<span class="user-address">'+
                            '<span>'+addr.distAddr+'</span>'+
                            '<span>'+addr.detailAddress+'</span>'+
                            '<span>（</span>'+
                            '<span>'+addr.contactName+'</span>'+
                            '<span> 收）</span>'+
                            '<em>'+addr.tel+'</em>'+
                        '</span>'+
                        '<span class="tips">'+(
                            addr.isDefault?"":'<a class="set-default" cq-action="setDefault">设置为默认收货地址</a>'
                        )+'</span>'+
                    '</label>'+
                '</div>';
            }
        },
        //使用新地址的响应
        addAddr:function(addr){
            var def = new Deferred();
            if(!this.addAddrDialog){
                return require([
                    "dojox/mobile/SimpleDialog",
                    "cq/app/widget/web/DataLayout"
                ],lang.hitch(this,function(Dialog,DataLayout){
                    this.addAddrDialog = new Dialog({
                        title:"地址信息管理",
                        className:"addrManage"
                    });
                    this._addrLayout = new DataLayout({
                        dataProvider:this,
                        layout:[{
                            "type":"form",
                            "fields":[{
                                "className":"large-width",
                                "type":"text",
                                "label":"收货人",
                                "canEdit":true,
                                "field":"contactName"
                            },{
                                "className":"large-width",
                                "type":"text",
                                "label":"收货电话",
                                "canEdit":true,
                                "field":"tel"
                            },{
                                "type":"district",
                                "label":"区划",
                                "canEdit":true,
                                "field":"provinceId,cityId,countyId,distAddr"
                            },{
                                "className":"large-width",
                                "type":"text",
                                "label":"收货地址",
                                "canEdit":true,
                                "field":"detailAddress"
                            },{
                                "className":"large-width",
                                "type":"checkbox",
                                "label":"默认地址",
                                "canEdit":true,
                                "field":"isDefault"
                            },{
                                type:"action",
                                label:"保存",
                                className:"buttom",
                                action:"saveAddr"
                            },{
                                type:"action",
                                label:"取消",
                                className:"buttom",
                                action:"cancelAddr"
                            }]
                        }]
                    });
                    this._addrLayout.placeAt(this.addAddrDialog.containerNode);
                    this.addAddrDialog.startup();
                    this.addAddr(addr);
                }));
            }else{
                this.__addrDef = def;
                this.addAddrDialog.show();
                this._addrLayout.setData(addr||{
                    isDefault:true
                });
            }
            return def;
        },
        saveAddr:function(data,widget){
            window.busy();
            this.addAddrDialog.hide();
            this.addr.saveUserAddr(data).then(lang.hitch(this,function(data){
                window.free();
                if(data.data){
                    data = data.data;
                }
                if(data.item){
                    data = data.item;
                }
                this.onAddrClick(data,"",null);
            }));
        },
        cancelAddr:function(){
            this.addAddrDialog.hide();
        },
        updateAmt:function(info){
            this.totalNode.innerHTML = info.totalAmt||0;
            this.couponNode.innerHTML = info.couponAmt||0;
            this.tranNode.innerHTML = info.tranAmt||0;
            this.realNode.innerHTML = (info.totalAmt||0)+(info.tranAmt||0)-(info.couponAmt||0);
        },
        //重写提交订单，余额为0的时候不允许余额支付
        onOrderCreated:function(orderInfo){
            this.inherited(arguments);
            //如果余额不足的话
            var order = orderInfo.data.item;
            var point = 0;
            for(var i in order){
                point += order[i]&&order[i].order.point;
            }
            if(point == 0){
                this.payTypeOptions = {
                    payMethod:"payByIds",
                    payTypes:[{
                        name: "微信",
                        type:"wxNative",
                        logo:"./images/temp/weixinpay.png"
                    },{
                        name: "支付宝",
                        type:"aliwap",
                        logo:"./images/temp/alipay.png"
                    }]
                };
            }
            this.payTypeOptions.payer = this.order;
            var payInfo = this.getOrderPayInfo(orderInfo);
            if(this.infoShowType&&this.payTypeType){
                this.payTypeType.payOrder(
                    payInfo,
                    lang.hitch(this.infoShowType,function(){
                        this.hide();
                    }),
                    this.payTypeOptions
                );
                this.infoShowType.showElement(this.payTypeType.domNode,this.showOptions);
                var handler = this.connect(this.infoShowType,"hide",function(){
                    handler.remove();
                    this.onOrderFinished(payInfo);
                });
            }else{
                this.onOrderFinished(payInfo);
            }
        },
        onAddrChanged:function(){
        },
        //点击地址获取刷新地址
        getAddr:function(e){
            var view = this.getView();
            addrPicker.addr = this.addr;
            return addrPicker.startEdit(this.orderInfo&&this.orderInfo.addr,view);
        },
        getView:function(){
            return widget.getEnclosingView(this);
        }
    });
});

