define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/Deferred",
    "cq/app/widget/_WidgetBase",
    "bob/user/consumer"
],function(declare,lang,array,Deferred,_WidgetBase,consumer){
    //提交订单需要处理的问题
    //  订单主表信息
    //  收货地址信息
    //  商家信息
    //  优惠券信息
    //  运费信息
    //  订单金额等信息
    //  提交订单
    //  支付问题
    return declare("",[_WidgetBase],{
        //配置弹出框类型，overlay、dialog、tooltip等，外部对象提供
        //  系统中预定义的一些方法对象，提供标准的show和hide方法
        //extraInfoType:"",
        
        //优惠券选择列表，标准的优惠券。列表对象
        //CouponListTye:"",
        
        //地址对象
        //地址列表项
        //AddrItemType:"",
        //地址编辑器
        //addrEditor:"",
        //地址编辑器的配置项
        //addrEditorOptions:null,
        
        //订单处理对象，提交订单等
        order:null,
        //购物车对象，提供读取购物车商品信息等
        cart:null,
        //地址处理对象
        addr:null,
        // 领奖处理对象
        prizeResult: null,
        // 提货卡处理对象
        card: null,
        //商家对象
        ItemRender:"",
        //商家对象的参数
        renderOption:null,
        
        //提交订单之后选择支付方式的相关配置
        infoShowType:"",
        showOptions:null,
        //支付方式选择器
        payTypeType:"",
        //支付方式对应参数
        payTypeOptions:null,
        
        //界面需要的节点
        //显示地址信息的区域的根节点，点击之后开始选择地址
        addrNode:null,
        
        //初始化界面元素，启动初始化流程
        buildRendering:function(){
            this.inherited(arguments);
            var requires = [];
            //加载依赖的模块
            if(this.ItemRender&&"string"===typeof(this.ItemRender)){
                //分店铺的商品的商家列表中的商家对象
                requires.push(this.ItemRender);
            }
            if(this.renderOption&&this.renderOption.ItemRender&&"string"===typeof(this.renderOption.ItemRender)){
                //店铺商品中的商品列表中的上品对象
                requires.push(this.renderOption.ItemRender);
            }
            if(this.order&&"string"===typeof(this.order)){
                //订单管理对象，B2C订单、B2B订单、B2B2C订单对象等
                requires.push(this.order);
            }
            if(this.cart&&"string"===typeof(this.cart)){
                //购物车对象，C端购物车对象、B端购物车对象(B2B采购订单)
                requires.push(this.cart);
            }
            if(this.addr&&"string"===typeof(this.addr)){
                //地址管理对象，C端客户地址管理、B端B2B采购收货地址管理对象
                requires.push(this.addr);
            }
            if(this.prizeResult&&"string"===typeof(this.prizeResult)){
                requires.push(this.prizeResult);
            }
            if(this.card&&"string"===typeof(this.card)){
                requires.push(this.card);
            }
            require(requires,lang.hitch(this,function(){
                var idx = 0;
                if(this.ItemRender&&"string"===typeof(this.ItemRender)){
                    this.ItemRender = arguments[idx];
                    idx++;
                }
                if(this.renderOption&&this.renderOption.ItemRender&&"string"===typeof(this.renderOption.ItemRender)){
                    this.renderOption.ItemRender = arguments[idx];
                    idx++;
                }
                if(this.order&&"string"===typeof(this.order)){
                    this.order = arguments[idx];
                    idx++;
                }
                if(this.cart&&"string"===typeof(this.cart)){
                    this.cart = arguments[idx];
                    idx++;
                }
                if(this.addr&&"string"===typeof(this.addr)){
                    this.addr = arguments[idx];
                    idx++;
                }
                if(this.prizeResult&&"string"===typeof(this.prizeResult)){
                    this.prizeResult = arguments[idx];
                    idx++;
                }
                if(this.card&&"string"===typeof(this.card)){
                    this.card = arguments[idx];
                    idx++;
                }
                if(this.cart&&typeof(this.cart)!=="string"){
                    this.isB2C = (this.cart.type==='b2c');
                }
                this._onShopRenderReady();
            }));
            if(this.addrNode){
                //点击地址区域之后开始选择地址
                this.connect(this.addrNode,"onclick",function(e){
                    this.getAddr(e).then(lang.hitch(this,function(address){
                        //如果该地址改变，但是地址没有重新选择，此地不会刷新
                        //首先考虑是否id变化，然后是位置
                        if(this.addrId._id !== address._id){
                            this._setAddr(address);
                        }else{
                            //id不变，tel改变不用重新加载订单，省市区改变需要重新加载
                            var variables = ["provinceId","cityId","countyId","contactName","tel","detailAddress"];//
                            for(var i=0;i<variables.length;i++){
                                if(this.addrId[variables[i]]._id&&address[variables[i]]._id){
                                    if(this.addrId[variables[i]]._id!=address[variables[i]]._id){
                                        this._setAddr(address);
                                        break;
                                    }
                                }else if(this.addrId[variables[i]]!=address[variables[i]]){
                                    this.orderInfo.addr = address;
                                    this.onAddrChanged();
                                    break;
                                }
                            }
                        }
                    }));
                });
            }
        },
        setAddr:function(addr){
            this._setAddr(addr);
        },
        //设置当前收货地址
        _setAddr:function(address){
            //记录当前商家当前地址
            this._addrHash = this._addrHash||[];
            this._addrHash[this.addr.getShopId()] = address;
            this.addrId = address;
            //加载订单信息，刷新订单显示
            this.loadInfoData().then(lang.hitch(this,this.onDataReady));
        },
        //依赖的东西是否已完成的标记，影响的初始化过程和刷新时是否立即执行
        _cqRendered:false,
        //店铺列表项对象加载完成之后的处理，依赖模块加载完成
        _onShopRenderReady:function(){
            this._cqRendered = true;
            if(this._refreshOnRendered){
                this.cqRefresh();
            }
        },
        getCurrendAddr:function(){
            return this._getCurrentAddr();
        },
        //获取当前的收货地址，同一个店铺，若选择过，取上一次的，否则取默认地址
        _getCurrentAddr:function(){
            if(this.isB2C){
                this.addrId = {};
                return Promise.resolve({});
            }
            //若当前商家有对应收获地址，返回对应收获地址
            if(this._addrHash&&this._addrHash[this.addr.getShopId()]){
                return this.addr.defTest(this._addrHash[this.addr.getShopId()]);
            }else{
                //否则获取、设置病返回默认收货地址
                return this.addr.getDefaultAddr().then(function(data){
                    this.addrId = data&&data.data&&data.data.item;
                    return this.addrId;
                });
            }
        },
        //进入页面之后重新加载数据，并刷新界面显示
        _refreshOnRendered:false,
        //刷新界面数据和显示
        cqRefresh:function(){
            if(!this._cqRendered){
                return this._refreshOnRendered = true;
            }
            //销毁之前的店铺信息，消除之前填写的店铺信息对本次呈现的影响
            this.getChildren().forEach(function(item){
                item.destroyRecursive();
            });
            //获取当前收获地址，然后设置当前收货地址
            this._getCurrentAddr().then(lang.hitch(this,function(addr){
                if(this.isB2C){
                    this.loadInfoData().then(lang.hitch(this,this.onDataReady));    
                }else{
                    this.setAddr(addr);    
                }
            }));       
        },
        //数据记载完成之后，刷新界面
        onDataReady:function(data){
            this.orderInfo = data;
            //销毁原有内容，创建新的
            this.getChildren().forEach(function(item){
                item.destroyRecursive();
            });
            array.forEach(data.shops,function(shop){
                var item = new this.ItemRender(this.renderOption||{});
                this.addChild(item);
                item.onDataReady(shop);
                item.onShopChanged = lang.hitch(this,this._onAmtChanged);
            },this);
            //刷新地址的显示
            this.onAddrChanged();
            //刷新地址显示
            this._onAmtChanged();
        },
        
        //刷新金额显示的接口
        _onAmtChanged:function(){
            this.updateAmt(this.getAmt());
        },
        //获取当前订单金额
        getAmt:function(){
            var info = {
                totalAmt:0,
                tranAmt:0,
                //有可能需要处理优惠券
                couponAmt:0
            };
            this.getChildren().forEach(function(item){
                var i = item.getMatInfo();
                if(i.coupons.amount||i.coupons.length){
                    info.couponAmt +=i.coupons&&i.coupons.amount;
                }
                info.totalAmt += i.totalAmt||0;
                info.tranAmt += i.tranAmt;
            });
            return info;
        },
        //更新总金额，提供给其他对象监听
        updateAmt:function(info){
            
        },
        //提交订单按钮
        submitOrder:function(){
            // 检查地址信息是否完整 不完整 则不允许提交
            var orderInfo = this.getOrderInfo();
            // 如果是自提，检查是否填写提货人提货电话和选择提货点
            this.getSelfFetch();
            if(!orderInfo.addressId||!orderInfo.dName||!orderInfo.dTel||!orderInfo.dAddress){
                alert("请选择收货地址");
                return;
            }
            window.free();
            //获取订单信息、提交订单信息、得到生成的订单之后执行后续动作
            this.postOrder(orderInfo).then(lang.hitch(this,this.onOrderCreated));
        },
        submitOrderB2C:function(data){
            var orderInfo = this.getOrderInfo();
            
            orderInfo.dTel = data.customerPhone;
            orderInfo.dName = data.customerName||"";
            orderInfo.userId = data.id;
            orderInfo.dAddress = data.addressB;
            orderInfo.discountAmount = data.amount;
            orderInfo.isDelived = data.isDelived;
            orderInfo.isPayed = data.isPay;
        
            window.free();
            //获取订单信息、提交订单信息、得到生成的订单之后执行后续动作
            this.postOrder(orderInfo).then(lang.hitch(this,this.onOrderCreated));
            
        },
        //获取提交订单时需要的订单信息
        getOrderPayInfo:function(orderInfo){
            var ids = [],amt = 0;
            if(orderInfo.data){
                orderInfo = orderInfo.data;
            }
            if(orderInfo.item){
                orderInfo = orderInfo.item;
            }
            for(var tsId in orderInfo){
                ids.push(orderInfo[tsId].order._id);
                amt += orderInfo[tsId].order.payAmount;
            }
            //如果有优惠券提交订单
            if(this.orderInfo.coupons&&this.orderInfo.coupons.length){
                var coupon = {};
                //var coupons = this.orderInfo.coupons;
                array.forEach(this.orderInfo.coupons,function(coupons){
                    coupon[coupons.fromShopId] = coupons._id;
                });
                return {
                    ids:ids,
                    totalAmt:amt,
                    coupon:coupon
                };
            }else{
                return {
                    ids:ids,
                    totalAmt:amt
                };
            }
        },
        //提交订单之后的后续动作
        onOrderCreated:function(orderInfo){
            
            //若提交失败
            if(1!==(orderInfo&&orderInfo.data&&orderInfo.data.ok)){
                //给出提示
                alert(orderInfo.data.msg);
                //throw "提交订单错误:"+orderInfo.data.msg;
                if(this.isB2C){
                    return;
                }
                history.back();
            }
            //清空购物车
            // 有才做清空操作 2017-8-2 刘轩 兼容 提货卡提交订单
            this.cart&&this.cart.clearSelected();
            if(this.isB2C){
                window.moveToView('orderDetailB',orderInfo.data.item.orderh._id);
                //history.back()
            }
        },
        //支付订单完成之后的操作
        onOrderFinished:function(payInfo){
            if(payInfo&&payInfo.ids&&payInfo.ids.length===1){
                window.moveToView(this.order.detailView,payInfo.ids[0]);
            }else{
                window.moveToView(this.order.listView);
            }
        },
        
        destroyRecursive:function(){
            var node = this.domNode;
            this.inherited(arguments);
            if(node.parentNode){
                node.parentNode.removeChild(node);
            }
        },
		_week: {
			0: "日",
			1: "一",
			2: "二",
			3: "三",
			4: "四",
			5: "五",
			6: "六"
		},
        //判断是否是周期订单
        _isCycleOrder:function(cycle,num,total,cycleMode){
            var msg = ""
            if(cycle.split("").length==1){
                msg = "每天配送"+num+"次，共"+total+"次";
            }else if(cycle.split("").length==7){
                //每周
				if(cycleMode==4){
					msg = "每两周";
				}else{
					msg = "每周";	
				}
                var week = this._getCycleOrderTime(cycle.split(""));
                array.forEach(week,function(day){
                    msg += this._week[day]+"、";
                },this);
				msg = msg.substr(0, msg.length-1);
                msg += "各配送"+num+"次，共"+total+"次";
            }else{
                //每月
                msg = "每月";
                var month = this._getCycleOrderTime(cycle.split(""));
                array.forEach(month,function(day){
                    msg += (day+1)+"号、";
                },this);
				msg = msg.substr(0, msg.length-1);
                msg += "各配送"+num+"次，共"+total+"次";
            }
            return msg;
        },
        //找到某几天
        _getCycleOrderTime:function(arr){
            var day = [];
            for(var i=0;i<arr.length;i++){
                if(arr[i]==1){
                    //该天配送
                    day.push(i);
                }
            }
            return day;
        },
        loadInfoData:function(){
            var def = new Deferred();
            var mids = this.cart.getMatQtys(this.cqRefInfo&&this.cqRefInfo.cqViewParam&&this.cqRefInfo.cqViewParam.params);
            var pacTeamId = this.cart.getPacTeamId();
            var oldShopInfo = {};
            this.getChildren().forEach(function(item){
                var info = item.getExtraInfo();
                oldShopInfo[info.shopId] = info;
                delete info.shopId;
            });
            //检验是否登录，没有登录去登陆
            consumer.hasLogin().then(lang.hitch(this,function(hasLogin){
                if(hasLogin){
                    this._getCurrentAddr(this.addrId._id).then(lang.hitch(this,function(addr){
                        //运费在前台处理，金额信息时不传入配送方式信息
                        this.order.getTAmount(mids,addr._id||"",true,this.getShopDist(),pacTeamId).then(lang.hitch(this,function(data){
                            if(1!==(data&&data.data&&data.data.ok)){
                                alert(data.data.message||"系统繁忙，请稍后重试");
                                if(!this.isB2C){
                                    return history.back();    
                                }else{
                                    return;
                                }
                            }
                            //判断是否是周期订单
                            if(mids.length==1&&mids[0].deliveryCycle){
                                var cycleMsg = this._isCycleOrder(mids[0].deliveryCycleDetail,mids[0].deliveryCycleEachNum,mids[0].totalDeliveryTimes,mids[0].deliveryCycle);
                            }
                            var info = {
                                addr:addr,
                                shops:[],
                                coupons:[]
                            },shopInfo = null,mat,mid,
                            shops = data.data&&data.data.item||{};
                            for(var shopId in shops){
                                shopInfo = lang.mixin(shops[shopId],oldShopInfo[shopId]||{});
                                //商家信息里面追加默认收货信息
                                shopInfo.addr = addr;
                                shopInfo.shopInfo._id = shopId;
                                shopInfo.mats = [];
                                shopInfo.isCycle = cycleMsg||"";
                                for(mid in shopInfo.matInfo){
                                    mat = shopInfo.matInfo[mid];
                                    mat._id = mid;
                                    //mat.isCycle = cycleMsg||"";
                                    shopInfo.mats.push(mat);
                                }
                                if(shops[shopId].coupons.length){
                                    var bestCoupon = shops[shopId].coupons[0];
                                    //是有很多的数组优惠券，默认选择一个最大的优惠活动，提交订单，和显示
                                    array.forEach(shops[shopId].coupons,function(coupon){
                                        if(coupon.amount>bestCoupon.amount){
                                            bestCoupon = coupon;
                                        }
                                    },this);
                                    //info.coupons[bestCoupon.fromShopId] = bestCoupon;
                                    info.coupons.push(bestCoupon);
                                    shopInfo.coupons = bestCoupon;
                                }
                                info.shops.push(shopInfo);
                            }
                            def.resolve(info);
                        }));
                    }));
                }else{
                    window.moveToView("login");
                }
            }));
            return def;
        },
        getOrderInfo:function(){
            //数据合法性检查
            //收货地址和交付方式
            //商品
            //如果有优惠券提交订单
            if(this.orderInfo.coupons&&this.orderInfo.coupons.length){
                var coupon = {};
                array.forEach(this.orderInfo.coupons,function(coupons){
                    coupon[coupons.fromShopId] = coupons._id;
                });
            }
            // 获取各个店铺的备注信息
            return {
                dName:this.orderInfo.addr.contactName,
                dTel:this.orderInfo.addr.tel,
                // 记录完整的地址信息 2017-2-28 刘轩
                dAddress:(this.orderInfo.addr.distAddr||"")+this.orderInfo.addr.detailAddress,
                //不使用优惠券
                coupon:coupon,
                remarks:this.getRemarks(),
                mids:JSON.stringify(this.cart.getMatQtys()),
                addressId:this.orderInfo.addr._id,
                deliveryTypes:this.getShopDist()
            };
        },
        getRemarks:function(){
            var remarks = {};
            this.getChildren().forEach(function(item){
                item = item.getRemarkInfo();
                remarks[item.shopId] = item.remark;
            });
            return remarks;
        },
        // 分商家获取该商家的配送方式
        getShopDist:function(){
            var remarks = {};
            this.getChildren().forEach(function(item){
                item = item.shopSelfFetch();
                remarks[item.shopId] = {
                    deliveryType:item.deliveryType,
                    storeName:item.storeName,
                    storeTel:item.storeTel,
                    storeId: item.storeId
                };
            });
            return remarks;
        },
        //获取提货人提货位置等等
        getSelfFetch:function(){
            this.getChildren().forEach(function(item){
                item = item.shopSelfFetch();
                if(item.deliveryType == 2){
                    //必须填写提货人和提货电话，也必须选择提货点
                    if(!item.storeName){
                        alert("请填写提货人!");
                        return;
                    }
                    if(!item.storeTel){
                        alert("请填写提货电话!");
                        return;
                    }
                    //合法性检查电话号码
                    if(!(this.order.isTel(item.storeTel)||this.order.isCellPhone(item.storeTel))){
                        alert("请输入合法的电话号码!")
                        return;
                    }
                    if(!(item.storeId&&item.storeId._id)){
                        alert("请选择自提点!");
                        return;
                    }
                }
            });
        },
        postOrder:function(info){
            if(this.isB2C){
                return this.order.createOfflineOrder(info);
            }else{
                return this.order.createDistributeOrder(info);    
            }
        },
        
        //接口，需要子类重写
        //地址变化之后刷新地址显示
        onAddrChanged:function(){
            
        },
        //改选地址的接口，改选之后刷新订单信息
        getAddr:function(){
        }
    });
});
