define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-construct",
    'dojo/dom-style',
    "dojo/Deferred",
    "dojox/mobile/View",
    "dijit/_Container",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetBase",
    "cq/ui/view/EditorBase",
    "./_Shop",
    "cq/util/edit/overlay",
    "cq/util/sys/date",
    "cq/ui/util/addr/shopSelfFetch",
    "cq/ui/util/addr/shopSelfFetch1",
    "cq/app/widget/utils/widget"
],function(declare,lang,array,domConstruct,domStyle,Deferred,View,_Container,_TemplatedMixin,_WidgetBase,EditorBase,_Shop,overlay,date,shopSelfFetch,shopSelfFetch1,widget){
    //店铺商品列表信息
    return declare("",[_WidgetBase,_Container,_TemplatedMixin,_Shop],{
        templateString:"<div data-dojo-attach-point='domNode' style='margin-bottom:10px;'>"+
            "<div class='o-t-title-shop'>"+
                "<div class='icon'><img src='./images/temp/shopIcon.png'></div>"+
                "<div class='title'>"+
                    "<a><span class='normal shpName' data-dojo-attach-point='titleNode'></span></a>"+
                "</div>"+
                //"<div class='coupon'>"+
                //    "<a><span class='coupon' data-dojo-attach-point='getCouponNode'>领券</span></a>"+
                //"</div>"+
            "</div>"+
            "<div data-dojo-attach-point='containerNode' class = 'shopChild'></div>"+
            "<div class='item-cells' style='margin-top:0;'>"+
                "<div class='normal item-cell noArrow' data-dojo-attach-point='cycleNode'>"+
                "</div>"+
                "<div class='normal item-cell noArrow' data-dojo-attach-point='couponNode'>"+
                    "<div class='item-cell-bd'>店铺优惠</div>"+
                    "<div class='item-cell-ft' data-dojo-attach-point='couponContainerNode'></div>"+
                "</div>"+
                //如果商家存在自提点，添加自提点
                "<div data-dojo-attach-point='deliveyTypeNode' class='normal item-cell access'>"+
                    //默认选中商家配送
                    "<div class='item-cell-bd'>配送方式</div>"+
                    "<div class='item-cell-ft' data-dojo-attach-point='deliveyTypeContainerNode'>商家配送</div>"+
                "</div>"+
                
                //如果是自提点自提，显示提货点，提货人，提货电话
                "<div data-dojo-attach-point='selfFetchNode'>"+
                    //提货点节点
                    "<div class='normal item-cell access'>"+
                        "<div class='item-cell-bd' style='white-space: pre;'>自  提  点</div>"+
                        "<div class='item-cell-ft' data-dojo-attach-point='fetchPosNode'></div>"+
                    "</div>"+
                    //提货人，可自己编辑，你默认为收获地址的人和电话
                    "<div class='normal item-cell noArrow'>"+
                        "<div class='item-cell-hd' style='white-space: pre;'>提  货  人</div>"+
                        "<div class='item-cell-ft flex1'><input data-dojo-attach-point='fetchNameNode' placeholder='必填 填写提货人' style='width:100%;-webkit-appearance: none;border:none;border-radius: 0;height: 16px;font-size: 14px;'/></div>"+
                    "</div>"+
                    "<div class='normal item-cell noArrow'>"+
                        "<div class='item-cell-hd'>提货电话</div>"+
                        "<div class='item-cell-ft flex1'><input data-dojo-attach-point='fetchTelNode' placeholder='必填 填写提货电话' style='width:100%;-webkit-appearance: none;border:none;border-radius: 0;height: 16px;font-size: 14px;'/></div>"+
                    "</div>"+
                "</div>"+

                // 添加买家留言部分
                "<div class='normal item-cell noArrow'>"+
                    "<div class='item-cell-hd'>买家留言</div>"+
                    "<div class='item-cell-ft flex1'><input data-dojo-attach-point='remarkNode' placeholder='选填 特殊要求在这里填写' style='width:100%;-webkit-appearance: none;border:none;border-radius: 0;height: 16px;font-size: 14px;'/></div>"+
                "</div>"+
            "</div>"+
            "<div class='normal t-right order-list-count'>"+
                "<span data-dojo-attach-point='totalQtyNode' class='qty'></span>"+
                "<span class='count'>小计：¥"+
                    "<i data-dojo-attach-point='totalAmtNode'></i>"+
                "</span>"+
            "</div>"+
        "</div>",
        //刷新显示
        refreshShopInfo:function(){
            this.titleNode.innerHTML = this.shopData.shopInfo.shopName;
            var info = this.getMatInfo();
            this.totalQtyNode.innerHTML = "共"+info.qty+"件商品";
            this.totalAmtNode.innerHTML = window.fixedTo(info.totalAmt,3);
            if(info.coupons&&info.coupons._id){
                this.couponContainerNode.innerHTML = "省"+info.coupons.amount+"元";
            }else{
                domStyle.set(this.couponNode, "display", "none");
            }
            if(info.isCycle){
                this.cycleNode.innerHTML = info.isCycle;
            }else{
                domStyle.set(this.cycleNode,"display","none");
            }
            domStyle.set(this.selfFetchNode,"display","none");
            this.remarkNode.value = this.shopData.remark||"";
            //绑定点击配送方式节点事件
            var _this = this;
            if(this.delTpHandler){
                this.delTpHandler.remove();
            }
            this.delTpHandler = this.connect(this.deliveyTypeNode,"onclick",this.onDeliveryTypeClick);
            //如果是选择自提点自提，绑定点击自提点点击事件
            if(this.fetchPosHander){
                this.fetchPosHander.remove();
            }
            this.fetchPosHander = this.connect(this.fetchPosNode,"onclick",function(address){
                this.getShopSelfFetch1().then(lang.hitch(this,function(address){
                    if(address){
                        _this.fetchPosNode.innerHTML = address.name;
                    }
                }));
           });
           this.setDeliveryType(this.shopData.deliveryType==2?{
               deliveryType:this.shopData.deliveryType,
               address:this.shopData.storeId
           }:{
               deliveryType:this.shopData.deliveryType
           });
        },
        onDeliveryTypeClick:function(){
            //弹出overlay选择自提或者是配送
            var param = {
                shopId:this.shopData.shopInfo._id,
                deliveryType:this.shopData.deliveryType||1,
                storeId: this.shopData.storeId||{},
                tAmount: this.shopData.tAmount
            };
            shopSelfFetch.getAction(param).then(lang.hitch(this, function(params){
                 overlay.hide();
                 var deliveryType = this.shopData.deliveryType;
                 this.setDeliveryType(params);
                 this.onShopChanged();
            }));
            overlay.showElement(shopSelfFetch.domNode,null);
        },
        setDeliveryType:function(params){
             if(params.deliveryType==2){
                //自提显示自提点
                this.deliveyTypeContainerNode.innerHTML = "到店自提";
                this.fetchPosNode.innerHTML = params.address.name;
                this.shopData.deliveryType = 2;
                //设置提货人和提货电话，默认为收获地址里面的人和电话
                this.fetchNameNode.value = this.shopData.addr.contactName;
                this.fetchTelNode.value = this.shopData.addr.tel;
                this.shopData.storeId = {
                    _id: params.address._id,
                    name: params.address.name,
                    addr: params.address.addr,
                    lon: params.address.lon,
                    lat: params.address.lat
                };
                domStyle.set(this.selfFetchNode,"display","");
            }else{
                this.shopData.deliveryType = 1;
                delete this.shopData.storeId;
                this.deliveyTypeContainerNode.innerHTML = "快递 ¥ "+window.fixedTo(this.shopData.tAmount,3);//"商家配送";
                domStyle.set(this.selfFetchNode,"display","none");
            }
        },
        //加载改商家是否存在自提点，若存在就显示"自提点自提"和”商家配送“多选项,否则直接显示商家配送
        getShopSelfFetch1:function(){
            var view = this.getView();
            //如果最开始的点击第一次点击，默认选中deliveryType =1,商家配送
            if(!this.shopData.deliveryType){
                this.shopData.deliveryType = 1;
            }
            return shopSelfFetch1.startEdit(this.shopData&&this.shopData.shopInfo._id,view);
        },
        getView:function(){
            return widget.getEnclosingView(this);
        }
    });
    //优惠券弹窗口
    //创建优惠券列表，disCount.loadAvailableByUserSelfB(fromShopId)
    //确认领取商家优惠券getCouponByUserSelf(_id,shopId,fromShopId)
    //点击领券弹出框显示当前商家的所有优惠券
    //点击使用优惠券，获取当前点击的优惠券的id和优惠券couponName
    
});