define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array"
],function(declare,lang,array){
    //商家信息
    //  商家基本信息
    //  商家商品
    //  商家选择、领取优惠券
    //  商家运费
    return declare("",null,{
        tAmt:0,
        //商品选择自提位置的addressId
        addressId:null,
        //商品列表项
        ItemRender:null,
        onDataReady:function(shopData){
            this.shopData = shopData;
            this.getChildren().forEach(function(item){
                item.destroyRecursive();
            });
            array.forEach(this.shopData.mats,function(mat){
                var item = new this.ItemRender();
                this.addChild(item);
                item.onDataReady(mat);
            },this);
            this.refreshShopInfo();
        },
        getMatInfo:function(){
            var qty = 0;
            this.shopData.mats.forEach(function(mat){
                qty += mat.qty;
            });
            return {
                qty:qty,
                totalAmt:this.shopData.totalPrice,
                tranAmt:this.shopData.deliveryType==2?0:this.shopData.tAmount,
                coupons:this.shopData.coupons,
                isCycle:this.shopData.isCycle
            };
        },
        onShopChanged:function(){},
        getExtraInfo:function(){
            return lang.mixin(this.getRemarkInfo(),this.shopSelfFetch());
        },
        getRemarkInfo:function(){
            return {
                shopId:this.shopData.mats&&this.shopData.mats[0]&&this.shopData.mats[0].fromShopId||"",
                remark:this.remarkNode&&this.remarkNode.value||""
            };
        },
        //如果是自提，获取当前的提货信息
        shopSelfFetch:function(){
            return {
                shopId:this.shopData.mats&&this.shopData.mats[0]&&this.shopData.mats[0].fromShopId||"",
                storeName:this.fetchNameNode&&this.fetchNameNode.value||"",
                storeTel:this.fetchTelNode&&this.fetchTelNode.value||"",
                //fetchAddr:this.shopData.chooseAddress,
                deliveryType:this.shopData.deliveryType||1,
                storeId: this.shopData.storeId||{}
            };
        },
        destroyRecursive:function(){
            var node = this.domNode;
            this.inherited(arguments);
            if(node.parentNode){
                node.parentNode.removeChild(node);
            }
        }
    });
});