﻿define([
    "dojo/_base/declare",
    "cq/app/widget/_WidgetBase",
    "./BigWheel",
    "bob/user/consumer",
    "bob/mk/prize/c",
    "bob/mk/prizeResult/c"
],function(declare,cqWidgetBase,BigWheel,consumer,prize,prizeResult){
    return declare("",[BigWheel,cqWidgetBase],{
        //配置必须
        htmlTemp:'<div id={id} class="cq-field-input" data-dojo-type="cq/widgets/item/prize/AppPrize"></div>',
        //属性名初始化,没有无需初始化
        cqRefresh:function(){
            this.inherited(arguments);
            if(this.cqRefInfo.cqViewParam&&this.cqRefInfo.cqViewParam.params){
                this.refreshPrizeById(this.cqRefInfo.cqViewParam.params);
            }
        },
        //和服务器端通讯的所有接口
        //所有通讯相关的接口提出来重写
        //加载抽奖活动接口
        loadPrizeById:function(prizeId){
            return prize.loadById(prizeId);
        },
        buyChance: function(){
            return prize.buyChance({
                _id: this._prizeData._id
            });
        },
        getPirzeUserChance:function(){
            return prize.getUserChance({
                _id:this._prizeData._id,
                userId:this.getCurrentUserId()
            });
        },
        //加载抽奖结果
        loadPrize:function(){
            return prize.prize({
                _id:this._prizeData._id,
                userId:this.getCurrentUserId()
            });
        },
        //没有登录时候显示抽奖信息
        loadPrizeResult:function(){
            return prizeResult.load({
                prizeId:this._prizeData._id,
                pageSize:20
            });
        },
        //登录后显示抽奖信息
        loadPrizeResultByUser:function(){
            return prizeResult.load({
                prizeId:this._prizeData._id,
                userId:this.getCurrentUserId(),
                pageSize:20
            });
        },
        //是否登录
        userHasLogin:function(){
            return consumer.hasLogin();
        },
        //获取当前登录的userId
        getCurrentUserId:function(){
            return consumer.getCurrentUserId();
        }
    });
});