﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dijit/_WidgetBase",
    "cq/app/widget/utils/widget"
],function(declare,lang,domConstruct,domStyle,_WidgetBase,widget){
    return declare("",[_WidgetBase],{
        point:null,
        interest:null,
        isLogin:null,
        baseClass:"interest-item",
        buildRendering:function(){
            this.inherited(arguments);
            //初始化界面元素
            //想去或已想去节点
            this.interestNode = domConstruct.create("div",{
                "class":"interest",
                //style:"border: 1px solid rgb(190, 47, 40);border-radius: 10px;width: 60px;text-align: center;float: left;"
            },this.domNode);
            //去过或已去过节点
            this.visitedNode = domConstruct.create("div",{
                "class":"visited",
                //style:"border: 1px solid rgb(190, 47, 40);border-radius: 10px;width: 140px;text-align: center;float:right;"
            },this.domNode);
            //若已去过，当前人logo
            this.visitedLogoNode = domConstruct.create("img",{
                "class":""
            },this.visitedNode);
            //去过或已去过的显示节点
            this.visitedLabelNode = domConstruct.create("span",{
                "class":""
            },this.visitedNode);
            //评分
            this.visitedStarNode = domConstruct.create("span",{
                "class":"",
                style: "margin-left:5px;"
            },this.visitedNode);
        },
        postCreate:function(){
            this.inherited(arguments);
            this.initInterestEvent();
            this.initInterestDisplay();
        },
        initInterestEvent:function(){
            this.connect(this.interestNode,"onclick",this.onMdfInteres);
            this.connect(this.visitedNode,"onclick",this.onMdfInteres);
        },
        initInterestDisplay:function(){
            this.visitedStarNode.innerHTML = "☆☆☆☆☆";
            domStyle.set(this.interestNode,"display","");
            //去过或想去过
            if(this.interest&&this.interest._id){
                if(2==this.interest.tp){
                    var score = this.interest.score||0,
                        scoreStr = "";
                    for(var i=0;i<5;i++){
                        if(score>=0.5){
                            scoreStr += "★";
                        }else{
                            scoreStr += "☆";
                        }
                        score--;
                    }
                    this.visitedStarNode.innerHTML = scoreStr;
                    this.visitedLabelNode.innerHTML = "已去过";
                    domStyle.set(this.interestNode,"display","none");
                }else{
                    this.interestNode.innerHTML = "已想去";
                    this.visitedLabelNode.innerHTML = "去过";
                }
            }else{
                this.interestNode.innerHTML = "想去";
                this.visitedLabelNode.innerHTML = "去过";
            }
        },
        getView:function(){
            return widget.getEnclosingView(this);
        },
        onMdfInteres:function(e){
            if(!this.isLogin){
                window.moveToView("login");
            }
            window.busy();
            var view = this.getView();
            var tp = e.target===this.interestNode?1:2;
            require([
                "whz/util/interest",
                "bob/article/interest/c"
            ],lang.hitch(this,function(interestUtil,interest){
                interestUtil.startEdit({
                    interest:this.interest,
                    point:this.point,
                    tp:tp
                },view).then(lang.hitch(this,function(data){
                    if(data){
                        if("delete"===data){
                            this.interest = null;
                            this.initInterestDisplay();
                            window.busy();
                            interest.removeInterest({
                                pointId:this.point._id
                            }).then(function(){
                                window.free();
                            });
                        }else{
                            data.pointId = this.point._id;
                            data.tp = tp;
                            window.busy();
                            interest.addInterest(data).then(lang.hitch(this,function(data){
                                if(data&&data.data&&data.data.item){
                                    this.interest = data.data.item;
                                    this.initInterestDisplay();
                                }
                                window.free();
                            }));
                        }
                    }
                }));
                window.free();
            }));
        }
    });
});