define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/dom-class",
    "dojo/query",
    "dijit/_WidgetBase",
    "dijit/registry",
    "cq/app/widget/_WidgetBase",
    "bob/article/tPoint/c",
    "bob/article/interest/c",
    "./InterestItem",
    "cq/util/config/config"
],function(declare,lang,domConstruct, domClass, query, _WidgetBase,registry,_CqWidgetBase,point,interest,InterestItem, config){
    return declare("cq.widgets.item.travel.TPointDetail", [_WidgetBase,_CqWidgetBase], {
        //徐阿雪 2017/3/2
        htmlTemp:"<div id='{id}' data-dojo-props='idMap:{idMap}' data-dojo-type='cq/widgets/item/travel/TPointDetail' class='cq-travel'></div>",
        params:null,
        //清空按上次的数据
        destroyDescendants:function(){
            var divName = this.domNode.childNodes;
            var domLength = divName.length;
            for(var i=0;i<domLength;i++){
                this.domNode.removeChild(divName[0]);
            }
        },
        getView: function(){
            var parent = this.getParent();
            while(parent&&!(parent.resize&&domClass.contains(parent.domNode,"mblView"))){
                parent = parent.getParent();
            }
            return parent;
        },
        //景点图片
        //景点名称
        //景点排名
        //景点评分
        //景点到访人数
        cqRefresh:function(){
            if(this.domNode.childNodes.length){
                this.destroyDescendants();
            }
            var id = this.cqRefInfo.cqViewParam.params;
            point.loadByIdFortravel(id).then(lang.hitch(this,function(data){
                this.params = data&&data.data&&data.data.item||"";
                var shopId = point.getShopId();
                if(this.params){
                    this.point = domConstruct.create("div",{
                        "class":"travelColor"
                    },this.domNode);
                    
                    
                    var tmp = config.pointTempId;
                    for(var field in this.params){
                        tmp = tmp.replace("{{"+field+"}}", this.params[field]||"暂无");
                    }
                    domConstruct.create("div", {
                        innerHTML: tmp,
                        style: "position: relative;padding: 20px 15px 15px;background-color: #fff;"
                    }, this.point);
                }
                this.getView().resize();
                this.rebuildInterest();
                require([
                    "dojo/topic",
                    "cq/util/share/share",
                    "cq/util/image/blob"
                ],function(topic,share,blob){
                    var imgUrl = (data.data.item.logo?blob.getImageUrl(data.data.item.logo,160):"");
                    topic.publish("/cq/util/sys/share/infoChanged",{
                        title: data.data.item.pointName||"",
                        thumb: imgUrl,
                        url:share.getPageLoc(shopId,"#tPoint-" + data.data.item._id)
                    });
                });
            }));
        },
        rebuildInterest:function(){
            var pointId = this.params._id,
                interestData = null,
                pointData = null,
                isLogin = null;
            if(this._interestItems){
                this._interestItems.destroyRecursive();
            }
            var onDataReady = lang.hitch(this,function(){
                this._interestItems = new InterestItem({
                    interest:interestData[0],
                    point:pointData,
                    isLogin:isLogin
                },query(".point-interest",this.domNode)[0]);
            });
            //加载感兴趣信息
            interest.loadInfoByPoints({
                pointIds:pointId
            }).then(lang.hitch(this,function(data){
                interestData = data&&data.data&&data.data.items||[];
                if(data.data.ok){
                    isLogin = true;
                }else{
                    isLogin = false;
                }
                //加载相关景点信息，评价时需要标签和用户添加标签数据
                point.loadByIdFortravel({_id:pointId}).then(function(data){
                    pointData = data&&data.data&&data.data.item;
                    onDataReady();
                });
            }));
        },
        buildRendering:function(){
            this.inherited(arguments);
            setTimeout(lang.hitch(this, function(){
                this.navRoute = registry.byId(this.idMap["1"]).domNode;
                this.connect(this.navRoute, "onclick", this.toNavRoute);
                this.share = registry.byId(this.idMap["2"]).domNode;
                this.connect(this.share, "onclick", this.toShare);
            }, 100));
        },
        toNavRoute: function(){
            var params = {};
            params.cqRefInfo = {};
            params.cqRefInfo.cqViewParam = {};
            params.cqRefInfo.cqViewParam.params = this.cqRefInfo.cqViewParam.params;
            point.navigation("","",params);
        },
        toShare: function(){
            var params = {};
            params.cqRefInfo = {};
            params.cqRefInfo.cqViewParam = {};
            params.cqRefInfo.cqViewParam.params = this.cqRefInfo.cqViewParam.params;
            point.share("","",params);
        }
    });
});