define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-attr",
    "dojo/dom-construct",
    "dojo/dom-class",
    "dojo/query",
    "dijit/registry",
    "dijit/_WidgetBase",
    "cq/app/widget/_WidgetBase",
    "bob/article/tRoute/c",
    "bob/article/tPoint/c",
    "bob/article/interest/c",
    "./InterestItem"
],function(declare,lang,array,domAttr,domConstruct,domClass,query,registry,_WidgetBase,_CqWidgetBase,route,point,interest,InterestItem){
    return declare("cq.widgets.item.travel.TRouteDetail", [_WidgetBase,_CqWidgetBase], {
        //徐阿雪 2017/3/2
        htmlTemp:"<div id='{id}' data-dojo-props='idMap:{idMap}' data-dojo-type='cq/widgets/item/travel/TRouteDetail' class='cq-travel' style='background:white;'></div>",
        params:null,
        //清空按上次的数据
        destroyDescendants:function(){
            var divName = this.domNode.childNodes;
            var domLength = divName.length;
            for(var i=0;i<domLength;i++){
                this.domNode.removeChild(divName[0]);
            }
        },
        getView: function(){
            var parent = this.getParent();
            while(parent&&!(parent.resize&&domClass.contains(parent.domNode,"mblView"))){
                parent = parent.getParent();
            }
            return parent;
        },
        cqRefresh:function(){
            if(this.domNode.childNodes.length){
                this.destroyDescendants();
            }
            var id = this.cqRefInfo.cqViewParam.params;
            route.loadByIdFortravel(id).then(lang.hitch(this,function(data){
                this.params = data&&data.data&&data.data.item||"";
                var shopId = route.getShopId();
                if(this.params){
                    this.route = domConstruct.create("div",{
                        "class":"travelColor",
                        style: "padding: 0 15px;"
                    },this.domNode);
                    this.routeDetail = domConstruct.create("div",{
                        "class":"travelFont"
                    },this.route);
                    domConstruct.create("div",{
                        "class":"travelFont",
                        innerHTML:"<div class='travelLogo'><img src="+(this.params.logo?this.params.logo:"../images/temp/banner/userBg.jpg")+"></div>"
                    },this.routeDetail);
                    var items = [];
                    /*items.push({
                        title:"线路名称",
                        msg:this.params.routeName
                    });
                    items.push({
                        title:"坐标",
                        msg:this.params.countyName+"/"+this.params.townName
                    });*/
                    items.push({
                        title:"线路简介",
                        msg:this.params.routeBrief
                    });
                    if(this.params.days){
                        items.push({
                            title:"推荐行程",
                            msg:this.params.days+"天"
                        });
                    }
                    items.forEach(function(item){
                        domConstruct.create("div",{
                            "class":"travelFont",
                            innerHTML:"<div>"+
                                '<section style=" line-height: 28.4444px; white-space: normal; border-width: 0px; border-style: none; border-color: initial;  box-sizing: border-box; " data-color="rgb(235, 103, 148)" data-custom="rgb(235, 103, 148)"><section style="margin: 5px auto; text-align: center;"><section style="display: inline-block; height: 36px; vertical-align: top; border-right-width: 18px; border-right-style: solid; border-right-color: rgb(235, 103, 148); color: inherit; border-top-width: 18px !important; border-top-style: solid !important; border-top-color: transparent !important; border-bottom-width: 18px !important; border-bottom-style: solid !important; border-bottom-color: transparent !important; box-sizing: border-box;"></section><section style="margin-left: -12px; padding-right: 15px; padding-left: 15px; height: 36px; display: inline-block; color: rgb(255, 255, 255); line-height: 36px; border-radius: 10px; box-sizing: border-box; background-color: rgb(235, 103, 148);"><span class="" data-brushtype="text" style="font-size: 18px;"><p style="padding:0;margin:0;">'+item.title+'</p></span></section><section style="margin-left: -12px; vertical-align: top; display: inline-block; height: 36px; border-left-width: 18px; border-left-style: solid; border-left-color: rgb(235, 103, 148); border-top-width: 18px !important; border-top-style: solid !important; border-top-color: transparent !important; border-bottom-width: 18px !important; border-bottom-style: solid !important; border-bottom-color: transparent !important; box-sizing: border-box;"></section></section></section>'+
                                "<div class='travelSpace'>"+item.msg+"</div>"+
                            "</div>"
                        },this.routeDetail);
                    },this);
                    domConstruct.create("div", {
                        innerHTML: this.params.content||"",
                        style: "position: relative;padding: 20px 15px 15px;background-color: #fff;"
                    }, this.domNode);
                    this.rebuildInterest();
                }
                require([
                    "dojo/topic",
                    "cq/util/share/share",
                    "cq/util/image/blob"
                ],function(topic,share,blob){
                    var imgUrl = (data.data.item.logo?blob.getImageUrl(data.data.item.logo,160):"");
                    topic.publish("/cq/util/sys/share/infoChanged",{
                        title: data.data.item.routeName||"",
                        thumb: imgUrl,
                        url:share.getPageLoc(shopId,"#tRoute-" + data.data.item._id)
                    });
                });
            }));
        },
        //想去，去过对象数组(魂村或销毁)
        _interestItems:null,
        rebuildInterest:function(){
            //销毁之前创建的评价对象
            if(this._interestItems){
                while(this._interestItems.length){
                    this._interestItems.pop().destroyRecursive();
                }
            }
            //找到所有景点节点
            this._interestItems = [];
            var pointIds = [],pointNodeHash = {};
            query(".point-interest",this.domNode).forEach(function(node){
                var pointId = domAttr.get(node,"point-id");
                if(pointId){
                    pointIds.push(pointId);
                    pointNodeHash[pointId] = node;
                }
            },this);
            //如果找到了景点信息
            if(pointIds.length){
                var pointDatas = null,
                    interestDatas = null,
                    isLogin = null;
                //准备好数据之后创建评价对象
                var onDataReady = lang.hitch(this,function(){
                    var pointHash = {},
                        interestHash = {};
                    interestDatas.forEach(function(item){
                        interestHash[item.pointId] = item;
                    });
                    pointDatas.forEach(function(item){
                        pointHash[item._id] = item;
                    });
                    array.forEach(pointIds,function(pointId){
                        this._interestItems.push(new InterestItem({
                            interest:interestHash[pointId],
                            point:pointHash[pointId],
                            isLogin:isLogin
                        },pointNodeHash[pointId]));
                    },this);
                });
                //未登录的两个想看和看过都有显示，点击的时候提示登录
                //加载感兴趣信息
                interest.loadInfoByPoints({
                    pointIds:pointIds
                }).then(lang.hitch(this,function(data){
                    interestDatas = data&&data.data&&data.data.items||[];
                    if(data.data.ok){
                        isLogin = true;
                    }else{
                        isLogin = false;
                    }
                    //加载相关景点信息，评价时需要标签和用户添加标签数据
                    point.loadByIds(pointIds).then(function(data){
                        pointDatas = data&&data.data&&data.data.items||[];
                        onDataReady();
                    });
                }));
            }
        },
        createPoint:function(params){
            var items = [];
            items.push({
                title:"旅游特色",
                msg:params.pointSpecial||"暂无"
            });
            items.push({
                title:"接待能力",
                msg:(params.pointCapacity||0)==0?"暂无":"每天能接待"+(params.pointCapacity||0)+"人"
            });
            items.push({
                title:"人均消费",
                msg:(params.avgPriceFrom||0)+"~"+(params.avgPriceTo||0)
            });
            items.push({
                title:"导航",
                msg:params.navigateKeyword||"暂无"
            });
            items.push({
                title:"导航信息",
                msg:params.navigateInfo||"暂无"
            });
            items.push({
                title:"停车信息",
                msg:params.parkingInfo||"暂无"
            });
            items.push({
                title:"周边信息",
                msg:params.neighbourInfo||"暂无"
            });
            items.push({
                title:"联系人",
                msg:params.contactName||"暂无"
            });
            items.push({
                title:"联系电话",
                msg:params.contactTel||"暂无"
            });
            items.push({
                title:"联系QQ",
                msg:this.params.contactQQ||"暂无"
            });
            items.push({
                title:"联系微信",
                msg:params.contactWeXin||"暂无"
            });
            return items;
        },
        buildRendering:function(){
            this.inherited(arguments);
            setTimeout(lang.hitch(this, function(){
                this.navRoute = registry.byId(this.idMap["1"]).domNode;
                this.connect(this.navRoute, "onclick", this.toNavRoute);
                this.share = registry.byId(this.idMap["2"]).domNode;
                this.connect(this.share, "onclick", this.toShare);
            }, 100));
        },
        toNavRoute: function(){
            var params = {};
            params.cqRefInfo = {};
            params.cqRefInfo.cqViewParam = {};
            params.cqRefInfo.cqViewParam.params = this.cqRefInfo.cqViewParam.params;
            route.navRoute(params);
        },
        toShare: function(){
            var params = {};
            params.cqRefInfo = {};
            params.cqRefInfo.cqViewParam = {};
            params.cqRefInfo.cqViewParam.params = this.cqRefInfo.cqViewParam.params;
            route.share("","",params);
        }
    });
});