﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
	"dijit/_WidgetBase",
    "dojo/dom-style",
    "dojo/Deferred",
    "./echarts"
], function (declare,lang,_WidgetBase,domStyle,Deferred,echarts) {
    return declare("echarts.Test", _WidgetBase, {
        width: "",
        height: "",
        type: "bar",
        dataProvider:"",
        dataMethod:"",
        tooltip:{},
        dataOptions:{},
        labelField:null,
        labelArray:null,
        valueFields:null,
        title:null,
        legend: null,
        direction: "h",// h/v
        buildRendering: function(){
            this.inherited(arguments);
            domStyle.set(this.domNode, {
                width: this.width,
                height: this.height
            });
            this.echart = echarts.init(this.domNode);
            this.echart.showLoading();
            lang.isString(this.legend)?[this.legend]:this.legend;
            lang.isString(this.valueFields)?[this.valueFields]:this.valueFields;
            
            if(this.dataProvider&&this.dataMethod){
                if(lang.isString(this.dataProvider)){
                    require([this.dataProvider], lang.hitch(this, function(dataProvider){
                        this.dataProvider = dataProvider;
                        var data = this.dataProvider[this.dataMethod](this.cqRefInfo, this, this.dataOption);
                        if(data && data.then){
                            data.then(lang.hitch(this, function(result){
                                this.echart.hideLoading();
                                this.initEchart(result);
                            }));
                        }else{
                            this.echart.hideLoading();
                            this.initEchart(data);
                        }
                    }));
                }else{
                    var data = this.dataProvider[this.dataMethod](this.cqRefInfo, this, this.dataOption);
                    if(data && data.then){
                        data.then(lang.hitch(this, function(result){
                            this.echart.hideLoading();
                            this.initEchart(result);
                        }));
                    }else{
                        this.echart.hideLoading();
                        this.initEchart(data);
                    }
                }
            }
        },
        initEchart: function(data){
            switch(this.type){
                case "bar":this.initBarEchart(data);break;
                case "pie":this.initPieEchart(data);break;
                case "line":this.initLineEchart(data);break;
                default:break;
            };
        },
        initBarEchart: function(data){
            var items = null;
            if(lang.isArray(data)){
                items = data;
            }else if(data&&data.data&&data.data.items){
                items = data.data.items;
            }else{
                return;
            }
            var option = {
                title: {
                    text: this.title
                },
                tooltip: this.tooltip,
                legend: {
                    data: this.legend
                }
            };
            var labelArray = [];
            option.series = [];
            for(var index = 0;index < items.length;index++){
                labelArray.push(items[index][this.labelField]);
                for(var j = 0;j < this.valueFields.length;j++){
                    if(!option.series[j]){
                        option.series[j] = {
                            name: this.legend?this.legend[j]:"",
                            type: this.type,
                            data: []
                        }
                    }
                    option.series[j].data.push(items[index][this.valueFields[j]]);
                }
            }
            
            if(this.direction == "h"){
                option.xAxis = {
                    type:"category",
                    data:this.labelArray||labelArray
                };
                option.yAxis = {
                    type:"value"
                };
            }else{
                option.yAxis = {
                    type:"category",
                    data:this.labelArray||labelArray
                };
                option.xAxis = {
                    type:"value"
                };
            }
            this.echart.setOption(option);
        },
        initPieEchart: function(data){
            
        },
        initLineEchart: function(data){
            
        },
        resize: function(){
            this.inherited(arguments);
            this.echart.resize();
        }
    });
});