require([
    "dojox/mobile/ProgressIndicator",
    "cq/util/sys/fixeEnv",
    "dojo/ready"
], function (ProgressIndicator, fixeEnv, ready) {
    require([
        "dojo/_base/lang",
        "cq/app/config",
        "cq/app/builder/mobileBuilder",
        "cq/app/layout/loader/memoryLayoutLoader",
        "cq/app/view/view/FullScreenWeb",
        "cq/ui/view/ListItem",//dojox/mobile/ListItem
        "whz/layout/layout",
        "whz/layout/userLayout",
        "whz/layout/progLayout",
        "whz/layout/memberLayout",
        "whz/layout/tsLayout",
        "whz/layout/saleManLayout",
        "whz/layout/shopExchangeLayout",
        "whz/layout/rankLayout",
        "whz/util/config",
        "cq/util/sys/alert"
    ], function (lang, config, mobileBuilder, memoryLayoutLoader, View, ListItem, layout, userLayout, progLayout, memberLayout,tsLayout, saleManLayout,shopExchangeLayout,rankLayout, config2, cqAlert) {
        cqAlert.rewriteAlert();
        //不允许listItem获取焦点
        //ListItem.prototype.tabIndex = "-1";
        //ListItem.prototype.isFocusable = false;
        lang.mixin(config,{
            //用户和员工模块
            userModel:"whz/bo/consumer",
            hasLoginMethod:"hasLogin",
            staffModel:"whz/bo/consumer",
            isStaffMethod:"isStaff",
            //禁止使用biz模块
            disableBiz:true,
            enableWxLogin:false,
            //微信自动登录
            enableLog:false,
            view:{
                subViews: {
                },
                defaultView: "main"
            },
            layoutBuilder:mobileBuilder,
            ViewRender:View,
            loadLayout:function () {
                return memoryLayoutLoader.loadLayout.apply(memoryLayoutLoader, arguments);
            }
        });
        lang.mixin(memoryLayoutLoader,{
            layouts:layout.layouts,
            layoutMethods:progLayout.layoutMethods,
            programLayouts:progLayout.programLayouts
        });
        lang.mixin(memoryLayoutLoader.layouts, userLayout.layouts, memberLayout.layouts,tsLayout.layouts,saleManLayout.layouts,shopExchangeLayout.layouts,rankLayout.layouts);
        lang.mixin(config.view.subViews, progLayout.views, layout.views, userLayout.views,memberLayout.views,tsLayout.views,saleManLayout.views,shopExchangeLayout.views,rankLayout.views);
    });
	require(["whz/widget/protocol"], function(protocol) {
		protocol.check();
	});
});