﻿/***
 * 前台业务逻辑对象，服务器端接口层基类
 **/
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/request/xhr",
    "dojo/Deferred",
    "cq/util/config/config",
    "dojo/store/JsonRest",
    "./JsonRest"
],function(declare,lang,array,xhr,Deferred,config,JsonRest){
    config.session = config.session||{};
    /*
 * A JavaScript implementation of the RSA Data Security, Inc. MD5 Message
 * Digest Algorithm, as defined in RFC 1321.
 * Version 2.1 Copyright (C) Paul Johnston 1999 - 2002.
 * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
 * Distributed under the BSD License
 * See http://pajhome.org.uk/crypt/md5 for more info.
 */
/*
 * Configurable variables. You may need to tweak these to be compatible with
 * the server-side, but the defaults work in most cases.
 */
var hexcase = 0; /* hex output format. 0 - lowercase; 1 - uppercase  */
var b64pad = ""; /* base-64 pad character. "=" for strict RFC compliance */
var chrsz = 8; /* bits per input character. 8 - ASCII; 16 - Unicode  */

function hex_md5(s){ return binl2hex(core_md5(str2binl(s), s.length * chrsz));}
function b64_md5(s){ return binl2b64(core_md5(str2binl(s), s.length * chrsz));}
function str_md5(s){ return binl2str(core_md5(str2binl(s), s.length * chrsz));}
function hex_hmac_md5(key, data) { return binl2hex(core_hmac_md5(key, data)); }
function b64_hmac_md5(key, data) { return binl2b64(core_hmac_md5(key, data)); }
function str_hmac_md5(key, data) { return binl2str(core_hmac_md5(key, data)); }
function md5_vm_test()
{
 return hex_md5("abc") == "900150983cd24fb0d6963f7d28e17f72";
}
function core_md5(x, len)
{
 x[len >> 5] |= 0x80 << ((len) % 32);
 x[(((len + 64) >>> 9) << 4) + 14] = len;
 var a = 1732584193;
 var b = -271733879;
 var c = -1732584194;
 var d = 271733878;
 for(var i = 0; i < x.length; i += 16)
 {
 var olda = a;
 var oldb = b;
 var oldc = c;
 var oldd = d;
 a = md5_ff(a, b, c, d, x[i+ 0], 7 , -680876936);
 d = md5_ff(d, a, b, c, x[i+ 1], 12, -389564586);
 c = md5_ff(c, d, a, b, x[i+ 2], 17, 606105819);
 b = md5_ff(b, c, d, a, x[i+ 3], 22, -1044525330);
 a = md5_ff(a, b, c, d, x[i+ 4], 7 , -176418897);
 d = md5_ff(d, a, b, c, x[i+ 5], 12, 1200080426);
 c = md5_ff(c, d, a, b, x[i+ 6], 17, -1473231341);
 b = md5_ff(b, c, d, a, x[i+ 7], 22, -45705983);
 a = md5_ff(a, b, c, d, x[i+ 8], 7 , 1770035416);
 d = md5_ff(d, a, b, c, x[i+ 9], 12, -1958414417);
 c = md5_ff(c, d, a, b, x[i+10], 17, -42063);
 b = md5_ff(b, c, d, a, x[i+11], 22, -1990404162);
 a = md5_ff(a, b, c, d, x[i+12], 7 , 1804603682);
 d = md5_ff(d, a, b, c, x[i+13], 12, -40341101);
 c = md5_ff(c, d, a, b, x[i+14], 17, -1502002290);
 b = md5_ff(b, c, d, a, x[i+15], 22, 1236535329);
 a = md5_gg(a, b, c, d, x[i+ 1], 5 , -165796510);
 d = md5_gg(d, a, b, c, x[i+ 6], 9 , -1069501632);
 c = md5_gg(c, d, a, b, x[i+11], 14, 643717713);
 b = md5_gg(b, c, d, a, x[i+ 0], 20, -373897302);
 a = md5_gg(a, b, c, d, x[i+ 5], 5 , -701558691);
 d = md5_gg(d, a, b, c, x[i+10], 9 , 38016083);
 c = md5_gg(c, d, a, b, x[i+15], 14, -660478335);
 b = md5_gg(b, c, d, a, x[i+ 4], 20, -405537848);
 a = md5_gg(a, b, c, d, x[i+ 9], 5 , 568446438);
 d = md5_gg(d, a, b, c, x[i+14], 9 , -1019803690);
 c = md5_gg(c, d, a, b, x[i+ 3], 14, -187363961);
 b = md5_gg(b, c, d, a, x[i+ 8], 20, 1163531501);
 a = md5_gg(a, b, c, d, x[i+13], 5 , -1444681467);
 d = md5_gg(d, a, b, c, x[i+ 2], 9 , -51403784);
 c = md5_gg(c, d, a, b, x[i+ 7], 14, 1735328473);
 b = md5_gg(b, c, d, a, x[i+12], 20, -1926607734);
 a = md5_hh(a, b, c, d, x[i+ 5], 4 , -378558);
 d = md5_hh(d, a, b, c, x[i+ 8], 11, -2022574463);
 c = md5_hh(c, d, a, b, x[i+11], 16, 1839030562);
 b = md5_hh(b, c, d, a, x[i+14], 23, -35309556);
 a = md5_hh(a, b, c, d, x[i+ 1], 4 , -1530992060);
 d = md5_hh(d, a, b, c, x[i+ 4], 11, 1272893353);
 c = md5_hh(c, d, a, b, x[i+ 7], 16, -155497632);
 b = md5_hh(b, c, d, a, x[i+10], 23, -1094730640);
 a = md5_hh(a, b, c, d, x[i+13], 4 , 681279174);
 d = md5_hh(d, a, b, c, x[i+ 0], 11, -358537222);
 c = md5_hh(c, d, a, b, x[i+ 3], 16, -722521979);
 b = md5_hh(b, c, d, a, x[i+ 6], 23, 76029189);
 a = md5_hh(a, b, c, d, x[i+ 9], 4 , -640364487);
 d = md5_hh(d, a, b, c, x[i+12], 11, -421815835);
 c = md5_hh(c, d, a, b, x[i+15], 16, 530742520);
 b = md5_hh(b, c, d, a, x[i+ 2], 23, -995338651);
 a = md5_ii(a, b, c, d, x[i+ 0], 6 , -198630844);
 d = md5_ii(d, a, b, c, x[i+ 7], 10, 1126891415);
 c = md5_ii(c, d, a, b, x[i+14], 15, -1416354905);
 b = md5_ii(b, c, d, a, x[i+ 5], 21, -57434055);
 a = md5_ii(a, b, c, d, x[i+12], 6 , 1700485571);
 d = md5_ii(d, a, b, c, x[i+ 3], 10, -1894986606);
 c = md5_ii(c, d, a, b, x[i+10], 15, -1051523);
 b = md5_ii(b, c, d, a, x[i+ 1], 21, -2054922799);
 a = md5_ii(a, b, c, d, x[i+ 8], 6 , 1873313359);
 d = md5_ii(d, a, b, c, x[i+15], 10, -30611744);
 c = md5_ii(c, d, a, b, x[i+ 6], 15, -1560198380);
 b = md5_ii(b, c, d, a, x[i+13], 21, 1309151649);
 a = md5_ii(a, b, c, d, x[i+ 4], 6 , -145523070);
 d = md5_ii(d, a, b, c, x[i+11], 10, -1120210379);
 c = md5_ii(c, d, a, b, x[i+ 2], 15, 718787259);
 b = md5_ii(b, c, d, a, x[i+ 9], 21, -343485551);
 a = safe_add(a, olda);
 b = safe_add(b, oldb);
 c = safe_add(c, oldc);
 d = safe_add(d, oldd);
 }
 return Array(a, b, c, d);
}
function md5_cmn(q, a, b, x, s, t)
{
 return safe_add(bit_rol(safe_add(safe_add(a, q), safe_add(x, t)), s),b);
}
function md5_ff(a, b, c, d, x, s, t)
{
 return md5_cmn((b & c) | ((~b) & d), a, b, x, s, t);
}
function md5_gg(a, b, c, d, x, s, t)
{
 return md5_cmn((b & d) | (c & (~d)), a, b, x, s, t);
}
function md5_hh(a, b, c, d, x, s, t)
{
 return md5_cmn(b ^ c ^ d, a, b, x, s, t);
}
function md5_ii(a, b, c, d, x, s, t)
{
 return md5_cmn(c ^ (b | (~d)), a, b, x, s, t);
}
function core_hmac_md5(key, data)
{
 var bkey = str2binl(key);
 if(bkey.length > 16) bkey = core_md5(bkey, key.length * chrsz);
 var ipad = Array(16), opad = Array(16);
 for(var i = 0; i < 16; i++)
 {
 ipad[i] = bkey[i] ^ 0x36363636;
 opad[i] = bkey[i] ^ 0x5C5C5C5C;
 }
 var hash = core_md5(ipad.concat(str2binl(data)), 512 + data.length * chrsz);
 return core_md5(opad.concat(hash), 512 + 128);
}
function safe_add(x, y)
{
 var lsw = (x & 0xFFFF) + (y & 0xFFFF);
 var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
 return (msw << 16) | (lsw & 0xFFFF);
}
function bit_rol(num, cnt)
{
 return (num << cnt) | (num >>> (32 - cnt));
}
function str2binl(str)
{
 var bin = Array();
 var mask = (1 << chrsz) - 1;
 for(var i = 0; i < str.length * chrsz; i += chrsz)
 bin[i>>5] |= (str.charCodeAt(i / chrsz) & mask) << (i%32);
 return bin;
}
function binl2str(bin)
{
 var str = "";
 var mask = (1 << chrsz) - 1;
 for(var i = 0; i < bin.length * 32; i += chrsz)
 str += String.fromCharCode((bin[i>>5] >>> (i % 32)) & mask);
 return str;
}
function binl2hex(binarray)
{
 var hex_tab = hexcase ? "0123456789ABCDEF" : "0123456789abcdef";
 var str = "";
 for(var i = 0; i < binarray.length * 4; i++)
 {
 str += hex_tab.charAt((binarray[i>>2] >> ((i%4)*8+4)) & 0xF) +
   hex_tab.charAt((binarray[i>>2] >> ((i%4)*8 )) & 0xF);
 }
 return str;
}
function binl2b64(binarray)
{
 var tab = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
 var str = "";
 for(var i = 0; i < binarray.length * 4; i += 3)
 {
 var triplet = (((binarray[i >> 2] >> 8 * ( i %4)) & 0xFF) << 16)
    | (((binarray[i+1 >> 2] >> 8 * ((i+1)%4)) & 0xFF) << 8 )
    | ((binarray[i+2 >> 2] >> 8 * ((i+2)%4)) & 0xFF);
 for(var j = 0; j < 4; j++)
 {
  if(i * 8 + j * 6 > binarray.length * 32) str += b64pad;
  else str += tab.charAt((triplet >> 6*(3-j)) & 0x3F);
 }
 }
 return str;
}
    var toMd5Sign = function(info,saltTyype){
        var str = (config.session&&config.session.phone||"") + "&" + JSON.stringify(info) + "&";
        if("token"===saltTyype){
            str = str + (config.session&&config.session.userInfo&&config.session.userInfo.token||"");
        }
        return hex_md5(str).toUpperCase();
    };
    var query = JsonRest.prototype.query,bo = null;
    JsonRest.prototype.query = function(params,pageInfo){
        if(this.target.indexOf(config.getDataOrigin())==-1){
            return query.apply(this,arguments);
        }
        pageInfo = pageInfo||{
            start:0,
            count:20
        };
        var info = {};
        var saltTyype = params.saltTyype;
        for(var field in params){
            info[field] = params[field];
        }
        if(config.session.userInfo&&config.session.userInfo.empId){
            info["empId"] = config.session.userInfo.empId;
        }
        delete info.saltTyype;
        if(pageInfo.start){
            info.pageNum = parseInt(pageInfo.start/(pageInfo.count||20));
        }else{
            info.pageNum = 0;
        }
        info.pageSize = parseInt(pageInfo.count||20);
        //他们的页码从1开始
        info.pageNum++;
        var def = new Deferred();
        var target = this.target,xhrParams = {
            bizContent:JSON.stringify(info),
            sign:toMd5Sign(info,saltTyype),
            identity:config.session&&config.session.phone||""
        };
        xhr.post(target,{
            data:xhrParams,
            handleAs:"json"
        }).then(function(data){
            def.resolve(data);
            if(data.ok!=1&&data.errcode!=0){
                bo.onRequestError(target,xhrParams,data);
            }
        },function(err){
            bo.onServerError(target,xhrParams,err);
        }).then(function(){},function(err){
            bo.onProgramError(target,xhrParams,err);
        });
        var total = new Deferred();
        var result = def.then(function(data){
            if(data&&data.result){
                total.resolve(data.result.total);
                return {
                    items:data.result.list
                };
            }else{
                total.resolve(0);
                return {
                    ok:0,
                    message:errmsg
                };
            }
        });
        return {
            then:function(){
                return result.then.apply(result,arguments);
            },
            cancel:function(){
                return result.cancel();
            },
            total:{
                then:function(){
                    return total.then.apply(total,arguments);
                }
            }
        };
    };
    var Bo = declare("",null,{
        toMd5Sign1:function(params, saltTyype){
            return toMd5Sign(params, saltTyype);
        },
        //服务器异常处理
        onServerError:function(target,params,err){
            return this._postErrorLog(params,target,err.response.status,"",err.message);
        },
        //结果异常处理
        onRequestError:function(target,params,data){
            return this._postErrorLog(params,target,200,data.errmsg,JSON.stringify(data));
        },
        //前台程序异常处理
        onProgramError:function(target,params,err){
            return this._postErrorLog(params,target,200,err.message,err.stack);
        },
        _postErrorLog:function(params,target,tp,errMsg,result){
            var msg = "",userInfo = "";
            if(config.session&&config.session.userInfo){
                msg = config.session.userInfo.phone;
                if(config.session.userInfo.organization){
                    msg += " "+config.session.userInfo.organization.name;
                }
                userInfo = JSON.stringify(config.session);
            }
            if(errMsg){
                msg += " "+errMsg;
            }
            return this.exec1("add",{
                tp:tp,
                msg:msg,
                target:target,
                params:JSON.stringify(params),
                result:result,
                userAgent:navigator.userAgent,
                userInfo:userInfo
            });
        },
        
        
        
        //数据请求接口
        getBaseUrl:function(){
            return config.getDataOrigin();
        },
        getBaseUrl1:function(){
            return config.dataOrigin1+"/bizv2/" + this.modalName;
        },
        deferred:function(data){
            var def = new Deferred();
            setTimeout(function(){
                def.resolve(data);
            },100);
            return def;
        },
        exec:function(method, params, saltTyype){
            if(window.busy){
                window.busy();
            }
            if(config.session.userInfo&&config.session.userInfo.empId){
                params.empId = config.session.userInfo.empId;
            }
            var def = new Deferred(),target = config.getDataOrigin()+"?method="+encodeURIComponent(method),xhrParams={
                bizContent:JSON.stringify(params),
                sign:toMd5Sign(params,saltTyype),
                identity:config.session&&config.session.phone||""
            };
            xhr.post(target,{
                data:xhrParams,
                handleAs:"json"
            }).then(function(data){
                if(window.free){
                    window.free();
                }
                if(data.result){
                    if(data.result instanceof Array){
                        data.items = data.result;
                    }else{
                        data.item = data.result;
                    }
                }
                data.message = data.message||data.err||data.errmsg;
                def.resolve(data);
                if(data.ok!=1&&data.errcode!=0){
                    bo.onRequestError(target,xhrParams,data);
                }
            },function(err){
                def.reject(err);
                bo.onServerError(target,xhrParams,err);
            }).then(function(){},function(err){
                bo.onProgramError(target,xhrParams,err);
            });
            return def;
        },
        
        getShopId:function(){
            return config.shopId;
        },
        exec1:function(action, param){
            if(window.busy){
                window.busy();
            }
            param.shopId = param.shopId||this.getShopId();
            paramSend = {};
            paramSend.__ds = JSON.stringify(param);
            return xhr.post(config.dataOrigin1+"/bizv2/" + this.modalName + "/" + action,{
                data: paramSend,
                handleAs:"json"
            }).then(function(data){
                if(window.free){
                    window.free();
                }
                return data;
            });
        },
        //数据结构相关处理
        constructor:function(params){
			params = params||{};
			var obj=Object.getPrototypeOf(this),
				fields = [{},this.fields||{},params.fields||{}];
			obj = Object.getPrototypeOf(obj);
			while(obj){
				if(obj.fields){
					fields.splice(1,0,obj.fields);
				}
				obj = Object.getPrototypeOf(obj);
			}
			params.fields = lang.mixin.apply(null,fields);
            lang.mixin(this,params);
        },
        //field的内容
        /**
            检查机制
            所有类型的字段
                notNull
            编辑方式为数字的字段
                type:number，非数字时报错
                range:
                    [0,10]，0到10之间，包含0和10
                    (0,10)，0到10之间，不包含0和10
                    (,0)，小于0
                    (0,)，大于零
            编辑方式为电话的字段
                type:tel，内容不是电话时报错
        **/
        fields:null,
        
        //页面结构相关处理
        _getFieldItem:function(field,canEdit){
            var fieldItem = null;
            if(lang.isString(field)){
                fieldItem = lang.clone(this.fields[field]);
            }else{
                fieldItem = lang.clone(this.fields[field.field]);
            }
            if(fieldItem){
                if("button"===fieldItem.type){
                    fieldItem.type = "action";
                }else if("link"===fieldItem.type){
                }else{
                    fieldItem.canEdit = false===fieldItem.canEdit||false===canEdit||false===field.canEdit?false:true;
                }
                fieldItem.field = field&&field.field||field;
                return fieldItem;
            }else{
                return {
                    type:"text",
                    field:field&&field.field||field,
                    canEdit:false
                };
            }
        },
        getFormItems:function(fields,canEdit){
            var fs = [];
            array.map(fields,function(field){
                var fieldItem = this._getFieldItem(field,canEdit);
                if(fieldItem){
                    fs.push(fieldItem);
                }else{
                    console.error("get field item error");
                    console.error(this,fields,field);
                }
            },this);
            return fs;
        },
        
        //数据逻辑相关接口
        _isNull:function(value){
            return !(value||0===value||false===value);
        },
        _isNumber:function(value){
            return value==parseFloat(value);
        },
        isEmail:function(value){
            return /^([a-zA-Z0-9_-])+@([a-zA-Z0-9_-])+(.[a-zA-Z0-9_-])+/.test(value);
        },
        isUrl:function(value){
            var strRegex = '^((https|http|ftp|rtsp|mms)?://)'
                + '?(([0-9a-z_!~*\'().&=+$%-]+: )?[0-9a-z_!~*\'().&=+$%-]+@)?' //ftp的user@ 
                + '(([0-9]{1,3}.){3}[0-9]{1,3}' // IP形式的URL- 199.194.52.184 
                + '|' // 允许IP和DOMAIN（域名） 
                + '([0-9a-z_!~*\'()-]+.)*' // 域名- www. 
                + '([0-9a-z][0-9a-z-]{0,61})?[0-9a-z].' // 二级域名 
                + '[a-z]{2,6})' // first level domain- .com or .museum 
                + '(:[0-9]{1,4})?' // 端口- :80 
                + '((/?)|' // a slash isn't required if there is no file name 
                + '(/[0-9a-z_!~*\'().;?:@&=+$,%#-]+)+/?)$'; 
            var re=new RegExp(strRegex); 

            return re.test(value);
        },
        isCellPhone:function(phone){
            return !!/^1\d{10}$/.test(phone);
        },
        // getEdtLayout 编辑页面
        // onDataReady 单行数据加载完成
        // getListLayout 列表页面
        // getListUrl 列表页面请求地址
        // onListClick 列表页面点击
        // getListParam 列表页面查询参数
        // loadById 加载指定数据
        // getItemProp 移动端生成HTML片段
        // onListDataReady 列表页数据加载完成
        // onEditFieldChange 字段变更
        // 
        getDataValidMsg:function(data,fields){
            var msg = "";
            array.some(fields,function(field){
                var fieldItem = this.fields[field],value = data[field];
                if(!fieldItem){
                    return;
                }
                if(fieldItem.notNull&&this._isNull(value)){
                    msg = fieldItem.label+"不能为空";
                    return true;
                }
                if(!this._isNull(value)){
                    if(fieldItem.type==="tel"){
                        if(!this.isCellPhone(value)){
                            msg = fieldItem.label+"不合法，请输入正确的电话号码";
                            return true;
                        }
                    }
                    if(fieldItem.type==="number"){
                        if(!this._isNumber(value)){
                            msg = fieldItem.label+"不合法，请填写正确的数字";
                            return true;
                        }
                        if(fieldItem.range){
                            var range = fieldItem.range.split(/[\[\(\),\]]/g);
                            if(range[1]){
                                if("["===fieldItem.range[0]){
                                    if(value-range[1]<0){
                                        msg = fieldItem.label+"不能小于"+range[1];
                                        return true;
                                    }
                                }else{
                                    if(value-range[1]<=0){
                                        msg = fieldItem.label+"必须大于"+range[1];
                                        return true;
                                    }
                                }
                            }
                            if(range[2]){
                                if("]"===fieldItem.range[fieldItem.range.length-1]){
                                    if(value-range[2]>0){
                                        msg = fieldItem.label+"不能大于"+range[2];
                                        return true;
                                    }
                                }else{
                                    if(value-range[2]>=0){
                                        msg = fieldItem.label+"必须小于"+range[2];
                                        return true;
                                    }
                                }
                            }
                        }
                    }
                    if(fieldItem.type==="email"){
                        if(!this.isEmail(value)){
                            msg = fieldItem.label+"格式错误，请填写正确的邮箱地址";
                            return true;
                        }
                    }
                    if(fieldItem.type==="url"){
                        if(!this.isUrl(value)){
                            msg = fieldItem.label+"格式错误，请填写正确的网址";
                            return true;
                        }
                    }
                    if(fieldItem.pattern){
                        if(!fieldItem.pattern.test(value)){
                            msg = fieldItem.label+"格式错误";
                            return true;
                        }
                    }
                    // 添加 objects的检查
                    if(fieldItem.type==="objects"){
                        if(fieldItem.notNull&&!data[field].length){
                            msg = fieldItem.label+"不能为空";
                            return true;
                        }
                    }
                }
            },this);
            return msg;
        }
    });
    bo = new Bo();
    bo.modalName = "log/errorLog";
    return Bo;
});
/**
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "./BoBase"
],function(declare,lang,BoBase){
    var Bo = declare("",BoBase,{
        fields:{
            
        },
    });
    var bo = new Bo();
    bo.Bo = Bo;
    return bo;
});
 **/
