﻿/***
 * 界面上动态显示的按钮上绑定的方法
 **/
define([
    "dojo/Deferred"
],function(Deferred){
    return {
        nowDate:function(){
            var def = new Deferred();
            require([
                "cq/util/sys/date"
            ],function(date){
                def.resolve({
                    label:date.formatISODate(date.nowISOString()),
                    icon:"images/temp/miniIcon/calender.png"
                });
            });
            return def;
        },
        nowConsumerName:function(){
            var def = new Deferred();
            require([
                "whz/bo/consumer"
            ],function(consumer){
                var data = consumer.getCurrentUserFromSession();
                def.resolve({
                    label:data&&data.name||data.empName||"",
                    icon:"images/temp/miniIcon/user.png"
                });
            });
            return def;
        },
        logout:function(){
            require([
                "whz/bo/consumer"
            ],function(consumer){
                consumer.onLogout();
            });
        },
        memberExchange:function(){
            require([
                "cq/util/sys/date"
            ],function(date){
                var nowDate = new Date(date.nowISOString());
                if(nowDate.getMonth()==3 && nowDate.getDate()==1){
                    alert("系统维护,暂停兑换");
                }else{
                    window.moveToView("memberInfoExchange");
                }
            });
        }
    };
});
