﻿/***
 * 作为店铺管理员登录系统的功能
 **/
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "dojo/dom-style",
    "dojo/_base/json",
    "cq/util/config/config",
    "./BoBase"
],function(declare,lang,topic,domStyle,json,config,BoBase){
    var Bo = declare("",BoBase,{
        modalName:"user/user",
        fields:{
            userName:{
                type:"text",
                label:"账号",
                placeHolder:"请输入账号"
            },
            phone:{
                type:"text",
                label:"电话",
                placeHolder:"请输入电话号码"
            },
            password:{
                type:"password",
                label:"密码",
                placeHolder:"请输入密码"
            },
            rememberPassword:{
                
            },
            onSubmitLoginButton:{
                type: "button",
                label: "登录",
                action: "onLogin",
                buttonClass: "fullButton"
            },
            onSubmitOltpLoginButton:{
                type: "button",
                label: "登录",
                action: "onOltpLogin",
                buttonClass: "fullButton"
            },
            // 确认密码
            confirmPassword: {
                type: "password",
                placeHolder: "请再次输入密码",
                label: "确认密码",
                className: "cq-item-password",
                notNull: true
            },

            // 修改密码特有字段
            // 原密码
            oldPassword: {
                type: "password",
                placeHolder: "请输入原密码",
                label: "原密码",
                notNull:true
            },
            // 新密码
            newPassword: {
                type: "password",
                placeHolder: "请输入新密码",
                label: "新密码",
                notNull:true
            },
            // 找回密码特有字段
            // 手机号、验证码，新密码，确认密码，上边已经定义

            //个人信息的功能字段
            //web端个人信息的保存按钮
            //原来mdfUserInfoButton
            updatePassword: {
                type: "button",
                label: "确认",
                //原来mdfUserInfo
                buttonClass: "fullButton",
                action: "updatePassword"
            },
            //验证码
            vcode: {
                dataProvider:"whz/bo/sms",
                smsMethod:"send",
                type: "vcode",
                errorMsg: "请输入正确的11位电话号码",
                unExists: "账号已经存在,请直接登录",
                noIcon:true,
                notNull: true
            },
            telPhone:{
                type:"text",
                label:"手机号",
                placeHolder:"请输入手机号"
            },
            logo: {
                type: "image",
                label: "头像",
                sizeType: "cut",
                size: {
                    width: 640,
                    height: 640
                }
            },
            jobNumber:{
                type:"text",
                label:"工号"
            },
            jobPosition:{
                type:"text",
                label:"职位"
            },
            createUser:{
                type: "button",
                label: "确认添加",
                //原来mdfUserInfo
                buttonClass: "fullButton mblListItem",
                action: "createUser"
            },
            name:{
                type:"text",
                label:"用户名"
            },
            sex:{
                type: "options",
                label: "性别",
                options: {
                    "M": "男",
                    'F': "女",
                    "O": "保密"
                },
                canEdit: true
            },
            organizationName:{
                type:"text",
                label:"门店名"
            },
            storeId:{
                type:"text",
                label:"门店标识"
            }
        },
        onLoginEnter:function(widget,field,value){
            if(field === "password"&&value){
                this.onLogin(widget.getData(),widget);
            }
        },
        getLoginLayout:function(){
            return [{
                type: "form",
                fields: this.getFormItems([
                    "phone", "password", "onSubmitLoginButton"
                ])
            }];
        },
        //修改密码layout
        getMdfPwdLayout: function () {
            // summary:
            //        app端修改密码Layout
            // view:
            //         mdfPwd
            // description:
            //         无
            return [{
                type: "form",
                fields: this.getFormItems([
                    "oldPassword", "newPassword", "confirmPassword","updatePassword"
                ])
            }];
        },
        //查看个人信息的页面，只查看不能更改
        getMdfUserInfoLayout:function(){
            return [{
                type: "form",
                fields: this.getFormItems([
                    "name",
                    "phone",
                    "sex",
                    "jobNumber",
                    "jobPosition"
                ], true)
            }];
        },
        //添加店员的layout 
        getAddShopAdminLayout:function(){
            return [{
                type: "form",
                fields: this.getFormItems([
                    //"vcode",
                    "telPhone",
                    "name",
                    "sex",
                    "jobNumber",
                    "createUser"
                ], true)
            }];
        },
        onLoginReload:function(widget){
            
        },
        onLogin:function(data){
            if(!(data.phone&&data.password)){
                return alert("手机号和密码不能为空");
            }
            window.busy();
            var password = data.password;
            this.exec("nepbaby.app.signin",{
                phone:data.phone,
                password:data.password
            }).then(lang.hitch(this,function(data){
                window.free();
                this._onLoginBack(data);
                if(data&&data.item){
                    //登录成功后缓存登录账号
                    localStorage.setItem('edtInfo',json.toJson({edtPhone:data.item.phone,edtPwd:password}));
                    this.setEdtInfoList({phone:data.item.phone,password:password,name:data.item.name});
                    window.moveToView("main");
                    //history.back();
                }else{
                    alert(data.message||data.errmsg||"登录失败");
                }
            }));
        },
        //设置缓存的业务员信息
        setEdtInfoList:function(info){
            var list = json.fromJson(localStorage.getItem("edtInfoList")||"[]");
            //list里面不存在改信息，就保存
            var isExit = false;
            for(var i=0;i<list.length;i++){
                if(list[i].phone == info.phone){
                    isExit = true;
                    break;
                }
            }
            if(!isExit){
                list.push(info);
            }
            localStorage.setItem('edtInfoList',json.toJson(list));
        },
        _onLoginBack:function(data){
            if(data&&data.item){
                this._onLoginSuccess(data.item);
            }else{
                config.session = {};
            }
        },
        // 设置员工的权限
        setUserRole : function (info) {
            if (info && info.organization) {
                if (info.organization.type && info.organization.type == "40934") {
                    // 连锁总部
                    info.role = "liansuozongbu";
                }
            }
            return info;
        },
        _onLoginSuccess:function(info){
            var info = this.setUserRole(info);
            if (!config.session){
                config.session = {};
            }
            //这里处理用户位置信息
            if(config.session.userId!==info.userId){
                config.session.userId = info.userId;
                config.session.phone = info.phone;
                config.session.userInfo = info;
                topic.publish("/cq/biz/user/user/hasLogin", true);
            }
        },
        hasLogin:function(){
            return this.deferred(config.session&&config.session.userId);
        },
        isStaff:function(){
            return this.hasLogin();
        },
        getCurrentUserFromSession:function(){
            return config.session&&config.session.userInfo||{};
        },
        onLogout:function(){
            config.session = {};
            topic.publish("/cq/biz/user/user/hasLogin",false);
            window.moveToView("login");
        },
        //加载上一次登录的用户信息
        //localStorage.edtInfo
        initUserLoginInfo:function(){
            var items = {};
            if(json.fromJson(localStorage.getItem('edtInfo'))){
                var edtInfo = json.fromJson(localStorage.getItem('edtInfo')||"{}");
                //var edtInfo = localStorage.getItem('edtInfo');
                items.phone = edtInfo.edtPhone;
                items.password = edtInfo.edtPwd||"";
            }
            return items;
        },
        // 查询指定手机号的用户信息
        // 返回用户详细信息
        getUserDetail:function(){
            if(!config.session.phone){
                return alert("用户未登录");
            }
            window.busy();
            return this.exec("nepbaby.user.detail", {
                phone:config.session.phone
            },"token").then(lang.hitch(this,function(result){
                window.free();
                if(result&&result.item){
                    result.item.sex = result.item.sex||"O";
                    result.item.jobNumber = result.item.jobNumber||"无";
                    result.item.jobPosition = result.item.jobPosition||"无";
                    result.item.organizationName = result.item.organization.name;
                    result.item.storeId = result.item.organization.id;
                }                
                return result&&result.item;
            }));
        },
        //我的资料查看
        disabelField:function(widget){
            var button = [/*"logo",*/"name","phone","sex","jobNumber","jobPosition"];
            widget.disableByFields(button);
        },
        // 会员新增
        // 返回新增会员信息
        createUser:function(data){
            if(!data.telPhone){
                alert("店员手机号不能为空");
                return;
            }
            if(!this.isCellPhone(data.telPhone)){
                alert("请输入正确的11位手机号码");
                return;
            }
            if(!data.name){
                alert("姓名不能为空");
                return;
            }
            if(!data.sex){
                alert("性别不能为空");
                return;
            }
            if(!data.jobNumber){
                alert("工号不能为空");
                return;
            }
            window.busy();
            this.exec("nepbaby.user.create", {
                //phone:data.vcode[0],
                phone:data.telPhone,
                name:data.name,
                sex:data.sex,
                jobNumber:data.jobNumber,
                //code:data.vcode[1]
            }).then(lang.hitch(this, function(data){
                window.free();
                if(data&&data.item){
                    alert("创建成功");
                    history.back();
                }else{
                    alert(data.message||data.errmsg||"创建失败");
                }
            }));
        },
        // 修改密码
        updatePassword:function(data){
            if(!config.session.phone){
                return alert("用户未登录");
            }
            if(!data.oldPassword){
                return alert("请输入原始密码");
            }
            if(!data.newPassword){
                return alert("请输入新密码");
            }
            if(!data.confirmPassword){
                return alert("请输入确认密码");
            }
            //检查新密码和确认密码相同
            if(data.newPassword != data.confirmPassword){
                return alert("确认密码不一致");
            }
            window.busy();
            this.exec("nepbaby.user.userpassword.modify", {
                phone:config.session.phone,
                oldPassword:data.oldPassword,
                newPassword:data.newPassword
            }).then(lang.hitch(this, function(data){
                window.free();
                if(data.message&&data.message=="修改成功"){
                    //登录成功后缓存登录账号
                    localStorage.setItem('edtInfo',{edtPhone:data.item.phone});
                    history.back();
                }else{
                    alert(data.message||data.errmsg||"修改密码出错");
                }
            }));
        },
        // 短信验证码下发
        // 返回{code : code}
        sendCheckcode:function(){
            if(!config.session.phone){
                return alert("用户未登录");
            }
            window.busy();
            return this.exec("nepbaby.checkcode.send", {
                phone:config.session.phone
            }).then(lang.hitch(this, function(data){
                window.free();
                return data&&data.item;
            }));
        },
        // 用户列表查询
        // 返回用户列表
        getUserList:function(){
            return this.getBaseUrl()+"?method=nepbaby.user.batchquery";
        },
        getLocalUserList:function(){
            return {info:json.fromJson(localStorage.getItem('edtInfoList')||"[]")};
        },
        switchUser:function(data, widget){
            if(confirm("确认切换账号？")){
                window.busy();
                config.session = {};
                //切换后缓存登录账号
                localStorage.setItem("edtInfo",json.toJson({edtPhone:data.phone,edtPwd:data.password}));
                window.moveToView("login");
                topic.publish("/cq/biz/user/user/hasLogin",false);
            }  
        },
        userListQuery:function(params){
            //按照单号查询
            return {
                phone:params.search||""
            };
        },
        userProp:function(item){
            if(!item.sex){
                item.sex = "O";
            }
            return item;
        },
        userListClick:function(data){
            if(confirm("确认切换账号？")){
                window.busy();
                config.session = {};
                //切换后缓存登录账号
                localStorage.setItem("edtInfo",json.toJson({edtPhone:data.phone,edtPwd:data.password}));
                window.moveToView("login");
                topic.publish("/cq/biz/user/user/hasLogin",false);
            }  
        },
        //业务员登录
        onOltpLogin:function(params){
            if(!(params.userName&&params.password)){
                return alert("用户名和密码不能为空");
            }
            window.busy();
            var password = params.password;
            this.exec1("loginByOLTP",{
                userName:params.userName,
                password:params.password
            }).then(lang.hitch(this,function(data){
                window.free();
                if(data&&data.item){
                    //登录成功后缓存登录账号
                    this._onOLtpLoginSuccess(data.item);
                    localStorage.setItem('edtInfo',json.toJson({edtPhone:data.item.mail,edtPwd:password}));
                    this.setEdtInfoList({phone:data.item.mail,password:password,name:data.item.fullName});
                    if(data.item.jobName == "终端推广员" || data.item.jobName == "专职导购"){
                        window.moveToView("tgzdList");
                    }else{
                        window.moveToView("main");
                        //history.back();
                    }
                }else{
                    this.exec("nepbaby.app.signin",{
                        phone:params.userName,
                        password:params.password
                    }).then(lang.hitch(this,function(data){
                        window.free();
                        this._onLoginBack(data);
                        if(data&&data.item){
                            //登录成功后缓存登录账号
                            localStorage.setItem('edtInfo',json.toJson({edtPhone:data.item.phone,edtPwd:password}));
                            this.setEdtInfoList({phone:data.item.phone,password:password,name:data.item.name});
                            window.moveToView("main");
                            //history.back();
                        }else{
                            alert(data.message||data.errmsg||"登录失败");
                        }
                    }));
                }
            }));
        },
        _onOLtpLoginSuccess:function(info){
            if (!config.session){
                config.session = {};
            }
            //这里处理用户位置信息
            if(config.session.userId!==(info.empId||info.UID)){
                config.session.userId = info.empId||info.UID;
                config.session.phone = info.empId||info.UID;
                config.session.userInfo = info;
                config.session.partnerID = info.partnerID;
                config.session.userType = info.userType;
                //凡是能登录都是业务代表
                if(config.session.userInfo.postName==="业务代表"){
                    config.session.userInfo.role = "yewudaibiao";
                }else{
                    config.session.userInfo.role = "jingli";
                }
                
                topic.publish("/cq/biz/user/user/hasLogin", true);
            }
        },
        //业务员layout
        getOltpLoginLayout:function(){
            return [{
                type: "form",
                fields: this.getFormItems([
                    "userName", "password", "onSubmitOltpLoginButton"
                ])
            }];
        },
        onOLtpLoginEnter:function(widget,field,value){
            if(field === "password"&&value){
                this.onOltpLogin(widget.getData(),widget);
            }
        },
        //加载上一次登录的用户信息
        //localStorage.edtInfo
        initUserOltpLoginInfo:function(){
            var items = {};
            if(json.fromJson(localStorage.getItem('edtInfo'))){
                var edtInfo = json.fromJson(localStorage.getItem('edtInfo')||"{}");
                //var edtInfo = localStorage.getItem('edtInfo');
                items.userName = edtInfo.edtPhone;
                items.password = edtInfo.edtPwd||"";
            }
            return items;
        },
    });
    var bo = new Bo();
    bo.Bo = Bo;
    return bo;
});
