﻿/***
 * 客户管理相关功能
 **/
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojo/Deferred",
    "dojo/request/xhr",
    "cq/util/config/config",
    "cq/util/sys/date",
    "./BoBase",
    "./monthlySum",
    "./consumer",
    "./cust",
    "./terminal",
    "../util/qrDialog",
    "../util/rewardDialog"
], function (declare, lang, domStyle, Deferred, xhr, config, date, BoBase, monthlySum, consumer, cust, terminal, qrDialog, rewardDialog) {
    var Bo = declare("", BoBase, {
        fields: {
            phone: {
                type: "tel",
                label: "手机号"
            },
            name: {
                type: "text",
                label: "会员姓名"
            },
            sex: {
                type: "options",
                label: "会员性别",
                options: {
                    'M': "男",
                    'F': "女",
                    "O": "保密"
                },
                selected: 'F'
            },
            referrerPhone: {
                type: "tel",
                label: "推荐人"
            },
            childrenItems: {
                type: 'objects',
                label: '宝宝（选填）',
                //labelField: 'childrenItems',
                //rightTextField: 'qtyTo',
                fieldChangeMethod: "onFieldChange",
                arrLength: 2,
                canEdit: true,
                canDelete: true,
                canAdd: true,
                canDnd: false,
                fields: {
                    workMode: "edit",
                    className: "editEditor",
                    layout: [{
                        field: "expectDate",
                        type: "date",
                        label: "预产期:"
                    }, {
                        field: "birthday",
                        type: "date",
                        label: "宝宝生日："
                    }, {
                        field: "sex",
                        type: "options",
                        label: "宝宝性别：",
                        options: {
                            'M': '小王子',
                            'F': '小公主'
                        },
                        selected: 'M'

                    }]
                }
            },
            createCustomer: {
                type: "button",
                label: "添加会员",
                buttonClass: "fullButton",
                action: "createCustomer"
            },
            //验证码
            "phone,vcode": {
                dataProvider: "whz/bo/sms",
                smsMethod: "sendVCode",
                type: "vcode",
                label: "手机号,验证码",
                errorMsg: "请输入正确的11位电话号码",
                unExists: "账号已经存在,请直接登录",
                noIcon: true,
                notNull: true
            },
            organizationName: {
                type: "text",
                label: "门店名"
            },
            integral: {
                type: "number",
                label: "积分",
                fixedTo: 0
            },
            storeId: {
                type: "text",
                label: "门店标识"
            },
            goodsName: {
                type: "text",
                label: "商品"
            },
            serialNumber: {
                type: "text",
                label: "单据号"
            },
            goodsBrand: {
                type: "text",
                label: "单位"
            },
            originalCounts: {
                type: "number",
                label: "入库数量"
            },
            outPutCounts: {
                type: "number",
                label: "出库数量"
            },
            createTime: {
                type: "dateTime",
                formatStr: "yyyyMMddhhmmss",
                label: "入库时间"
            },
            memberId: {
                type: "number",
                label: "请输入会员号"
            },
            memberConfirm: {
                type: "button",
                label: "查询",
                buttonClass: "fullButton",
                action: "memberConfirm"
            },
            memberConfirmForExchange: {
                type: "button",
                label: "查询",
                buttonClass: "fullButton",
                action: "memberConfirmForExchange"
            },
            registerTime: {
                type: "dateTime",
                formatStr: "yyyyMMddhhmmss"
            },
            beginTime: {
                type: "dateTime",
                formatStr: "yyyyMMddhhmmss"
            },
            endTime: {
                type: "dateTime",
                formatStr: "yyyyMMddhhmmss"
            },
            begintime: {
                type: "dateTime",
                formatStr: "yyyyMMddhhmmss"
            },
            endtime: {
                type: "dateTime",
                formatStr: "yyyyMMddhhmmss"
            },
            tp: {
                type: "options",
                options: {
                    "10": "新客",
                    "20": "老客",
                    "30": "活跃客户",
                    "40": "流失客户"
                },
                label: "会员类型"
            },
            num: {
                type: "number",
                label: "会员数"
            },
            firstQty: {
                type: "number",
                label: "首次购买",
                fixedTo: 0
            },
            buyQty: {
                type: "number",
                label: "累计购买",
                fixedTo: 0
            },
            exchangeQty: {
                type: "number",
                label: "累计兑换",
                fixedTo: 0
            },
            saleQty: {
                type: "number",
                label: "销售数量"
            },
            giftQty: {
                type: "number",
                label: "累计赠送",
                fixedTo: 0
            },
            queryTime: {
                type: "date",
                label: "日期"
            },
            goodsId: {
                type: "options",
                options: {
                    "1001636,1001638,1001637": "典悦",
                    "1001636": "喜安智典悦1段750g",
                    "1001638": "喜安智典悦3段750g",
                    "1001637": "喜安智典悦2段750g",
                    "1001639,1001642,1001641": "恒悦",
                    "1001639": "喜安智恒悦1段750g",
                    "1001642": "喜安智恒悦3段750g",
                    "1001641": "喜安智恒悦2段750g",
                    "1001647,1001649,1001648": "礼悦",
                    "1001647": "喜安智礼悦1段750g",
                    "1001649": "喜安智礼悦3段750g",
                    "1001648": "喜安智礼悦2段750g",
                    "1000739,1000741,1000743": "喜安欣",
                    "1000739": "喜安欣1段750g",
                    "1000741": "喜安欣2段750g",
                    "1000743": "喜安欣3段750g"
                },
                label: "品种"
            },
            startTime: {
                type: "date",
                label: "根据日期查询此月"
            },
            storeName: {
                type: "text",
                label: "门店名称"
            },
            memberNum: {
                type: "number",
                label: "会员数量",
                fixedTo: 0
            },
            generallyString: {
                type: "options",
                label: "账号状态",
                selected: "2",
                options: {
                    "2": "待审核",
                    "1": "停用",
                    "0": "已审核"
                }
            },
            identity: {
                type: "options",
                label: "门店",
                options: {

                }
            },
            jobNumber: {
                label: "工号",
                type: "text"
            },
            createDY: {
                type: "button",
                label: "添加店员",
                buttonClass: "fullButton",
                action: "createDY"
            },
        },
        createDY: function (params) {
            if (!params.identity) {
                alert("请选择门店");
                return;
            }
            if (!params.phone) {
                alert("手机号必填");
                return;
            }
            if (!params.name) {
                alert("会员姓名必填");
                return;
            }
            if (!params.jobNumber) {
                alert("工号必填");
                return;
            }
            if (window.busy) {
                window.busy();
            }
            var def = null;
            if (params.userId) {
                var info = {
                    userId: params.userId,
                    deptId: params.identity,
                    name: params.name,
                    deptName: this.fields.identity.options[params.identity]
                };
                def = this.exec("nepbaby.salesman.user.update", info);
            } else {
                var identity = params.identity;
                delete params.identity;
                params.createUserId = config.session.userInfo.empId;
                var target = config.getDataOrigin() + "?method=" + encodeURIComponent("nepbaby.salesman.user.create");
                var xhrParams = {
                    bizContent: JSON.stringify(params),
                    sign: this.toMd5Sign1(params),
                    identity: identity
                };
                def = xhr.post(target, {
                    data: xhrParams,
                    handleAs: "json"
                });
            }
            var pre = params.userId ? "修改" : "添加";
            return def.then(function (data) {
                if (window.free) {
                    window.free();
                }
                if (data.errcode == 0) {
                    alert(pre + "成功");
                    window.history.back();
                } else {
                    alert(data.errmsg || (pre + "失败"));
                }
            }, function (err) {
                alert(pre + "失败");
            });
        },
        getAddDYLayout: function () {
            return [{
                type: "form",
                fields: this.getFormItems([
                    "identity", "phone", "name", "sex", "jobNumber", "createDY"
                ])
            }];
        },
        loadDianyuan: function (cqRefInfo) {
            var res = {};
            if (cqRefInfo && cqRefInfo.cqViewParam && cqRefInfo.cqViewParam.params) {
                try {
                    res = JSON.parse(decodeURIComponent(cqRefInfo.cqViewParam.params));
                } catch (e) {
                }
            }
            return res;
        },
        onDianyuanReady: function (widget) {
            var data = widget.getData();
            if (data.userId) {
                widget.disableByFields(["phone", "jobNumber"]);
            } else {
                widget.enableByFields(["phone", "jobNumber"]);
            }
        },
        // 初始化门店列表
        initOptions: function () {
            for (var key in terminal.fields.storeId.options) {
                this.fields.identity.options[key] = terminal.fields.storeId.options[key];
            }
        },
        dyListQuery: function (params) {
            var query = {};
            if (params["1"] && params["1"].generallyString) {
                query.generallyString = params["1"].generallyString;
            }
            query.generallyArray = Object.keys(terminal.fields.subEmpId.options);
            query.generallyArray.push("" + config.session.userInfo.empId);
            return query;
        },
        getDYList: function () {
            return this.getBaseUrl() + "?method=nepbaby.salesman.user.batchquery";
        },
        getYWYStatusLayout: function () {
            return [{
                type: "form",
                fields: this.getFormItems([
                    "generallyString"
                ])
            }];
        },
        initYWYStatus: function (params) {
            var data = {
                generallyString: "2"
            };
            return data;
        },
        onBtnClicked: function (data, action, widget) {
            if (!action) {
                return;
            }
            if (action === "edit") {
                return window.moveToView("addDianyuan", encodeURIComponent(JSON.stringify({
                    userId: data.userId,
                    phone: data.phone,
                    name: data.name,
                    sex: data.sex,
                    identity: data.organization.id,
                    jobNumber: data.jobNumber
                })));
            }
            var bizContent = {};
            bizContent.currencyId = data.userId;
            if (data.status == 1) {
                bizContent.generallyString = 2;
            } else if (data.status == 0) {
                bizContent.generallyString = 1;
            } else if (data.status == 2) {
                bizContent.generallyString = 0;
            }
            this.exec("nepbaby.salesman.user.updatestatus", bizContent)
                .then(function (data1) {
                    widget.cqRefresh();
                });
        },
        getDYItemPro: function (item) {
            item.createUserName = terminal.fields.subEmpId.options[item.createUserId] || "";
            if (item.status == 2 && item.createUserId != config.session.userInfo.empId) {
                item.action = "<span class='line-btn' cq-action='check' style='float:right'>审核</span>";
            } else if (item.status == 0 && item.createUserId == config.session.userInfo.empId) {
                item.action = "<span class='line-btn' cq-action='stop' style='float:right'>停用</span>" +
                    "<span class='line-btn' cq-action='edit' style='float:right'>修改</span>";
            } else if (item.status == 1 && item.createUserId == config.session.userInfo.empId) {
                item.action = "<span class='line-btn' cq-action='start' style='float:right'>启用</span>";
            }
            return item;
        },
        //添加会员layout
        addCustomerLayout: function () {
            // summary:
            //        新增会员layout
            // view:
            //         addCustomer
            // description:
            //         无
            var fields = [
                "storeId",
                "referrerPhone",
                "phone",
                "name",
                "sex",
                "childrenItems",
                "createCustomer"
            ];
            var userInfo = config.session&&config.session.userInfo||{};
            if(userInfo.isVerify) {
                fields.splice(2,1,"phone,vcode");
            }
            return [{
                type: "form",
                fields: this.getFormItems(fields, true)
            }];
        },
        onDataReady: function (widget) {
            var data = widget.getData();
            widget.disableByFields(["storeId", "referrerPhone"]);
            //如果填写了预产期，将生日清空，如果填写了生日，将预产期清空
        },
        onFieldChange: function (widget, field, value) {
            if (field == "expectDate") {
                widget.hideByFields(["birthday"]);
            }
            if (field == "birthday") {
                widget.hideByFields(["expectDate"]);
            }
        },
        onLayoutFieldChange: function (widget, field, value) {
            var pageData = widget.getData();
            if (field == "phone") {
                if (this.isCellPhone(pageData.phone)) {
                    // 长度为11位是处理
                    window.busy();
                    this.getCurrentMemberInfo(pageData.phone).then(lang.hitch(this, function (result) {
                        window.free();
                        if (result.item) {
                            // 找到了对应的数据
                            alert("客户已存在");
                            delete pageData.phone;
                        }
                        widget.setData(pageData);
                    }));
                }
            }
        },
        createCustomer: function (data) {
            if (!data.phone) {
                return alert("手机号码不能为空");
            }
            if (!this.isCellPhone(data.phone)) {
                return alert("手机号不合法，请输入正确的电话号码");
            }
            if (!data.name) {
                return alert("会用姓名不能为空");
            }
            if (!data.sex) {
                return alert("会员性别不能为空");
            }
            if (!data.referrerPhone) {
                return alert("推荐人电话不能为空");
            }
            var childrenItems = [];
            var child = {};
            if (data.childrenItems.length) {
                for (var index = 0; index < data.childrenItems.length; index++) {
                    var item = data.childrenItems[index];
                    if (item.expectDate) {
                        child.type = "EDD";
                        child.birthdate = item.expectDate;
                    } else if (item.birthday) {
                        child.type = "DOB";
                        child.birthdate = item.birthday;
                    }
                    child.sex = item.sex;
                    childrenItems.push(child);
                }
            }
            window.busy();
            var param = {
                phone: data.phone,
                name: data.name,
                sex: data.sex,
                referrerPhone: data.referrerPhone,
                childrenItems: childrenItems
            };
            param.code = data.vcode||"1";
            this.exec("nepbaby.customer.create", param).then(lang.hitch(this, function (data) {
                window.free();
                if (data && data.item) {
                    this.setLastPhone(data.item.phone);
                    alert("注册成功！");
                    qrDialog.show().then(function(){
                        history.back();
                    });
                } else {
                    alert(data.message || "保存出错");
                }
            }));
            //保存成功后保存一个lastPhone:
        },
        setLastPhone: function (phone) {
            require(["whz/bo/customer"], function (customer) {
                customer.lastPhone = phone || "";
            });
        },
        getLastPhone: function () {
            var def = new Deferred();
            require(["whz/bo/customer"], function (customer) {
                def.resolve({ lastPhone: customer.lastPhone });
            });
            return def;
        },
        getReferrerPhone: function () {
            return config.session.phone || config.session.userInfo && config.session.userInfo.empName || "";
        },
        //读取该门店当前会员信息
        getCurrentMemberInfo: function (memberId) {
            window.busy();
            return this.exec("nepbaby.customer.detail", {
                phone: memberId
            }, "token").then(lang.hitch(this, function (data) {
                window.free();
                if (data && data.item) {
                    data.item.storeId = config.session.userInfo && config.session.userInfo.organization && config.session.userInfo.organization.id || "";
                    data.item.referrerPhone = this.getReferrerPhone();
                }
                return data;
            }));
        },
        //读取改门店的信息
        getCurrentStoreInfo: function (cqParams) {
            if (!config.session.phone) {
                return alert("用户未登录");
            }
            var def = new Deferred();
            var item = {
                storeId: config.session.userInfo && config.session.userInfo.organization && config.session.userInfo.organization.id || "",
                referrerPhone: this.getReferrerPhone()
            };
            if (cqParams && cqParams.cqViewParam && cqParams.cqViewParam.params) {
                item.phone = cqParams.cqViewParam.params;
            }
            this.getLastPhone().then(function (data) {
                if (data && data.lastPhone) {
                    item.memberId = data.lastPhone;
                }
                def.resolve(item);
            });
            return def;
        },
        // 会员明细查询
        loadMemberDetail: function (cqParams) {
            var def = null;
            if (cqParams.cqViewParam && cqParams.cqViewParam.params) {
                def = this.exec("nepbaby.customer.detail", {
                    phone: cqParams.cqViewParam.params
                }, "token").then(lang.hitch(this, function (data) {
                    if (data && data.item) {
                        data.item.storeId = config.session.userInfo && config.session.userInfo.organization && config.session.userInfo.organization.id || "";
                        data.item.referrerPhone = this.getReferrerPhone();
                    }
                    return data && data.item;
                }));
            } else {
                def = this.deferred({
                    storeId: config.session.userInfo && config.session.userInfo.organization && config.session.userInfo.organization.id || "",
                    referrerPhone: this.getReferrerPhone()
                });
            }
            return def.then(function (data) {
                return data;
            });
        },
        onListClick: function (data) {
            //会员详情
            window.moveToView("customerDetial", data.phone);
        },
        onStoreListClick: function (data) {
            //会员详情
            window.moveToView("customerList", data.storeId);
        },
        //当日注册新会员查询条件
        newListQuery: function (params) {
            var query = {};
            query.beginDate = date.nowISOString();
            if (params.search) {
                query.phone = search;
            }
            return query;
        },
        onListIntgralClick: function (data) {
            //会员详情
            window.moveToView("customerDetial", data.customerPhone);
        },
        // 修改会员信息
        // 返回会员信息
        modifyCustomer: function (data) {
            if (!data.phone) {
                return alert("手机号码不能为空");
            }
            if (data.phone.length !== 11) {
                return alert("请检查手机号码为11位数字");
            }
            if (!this.isCellPhone(data.phone)) {
                return alert("手机号不合法，请输入正确的电话号码");
            }
            if (!data.name) {
                return alert("会用姓名不能为空");
            }
            if (!data.sex) {
                return alert("会员性别不能为空");
            }
            if (!data.referrerPhone) {
                return alert("推荐人电话不能为空");
            }
            if (data.referrerPhone.length !== 11) {
                return alert("请检查推荐人手机号码为11位数字");
            }
            var childrenItems = [];
            if (data.childrenItems.length) {
                for (var index = 0; index < data.childrenItems.length; index++) {
                    var child = {
                        set: data.childrenItems[index].sex,
                        type: data.childrenItems[index].type,
                        birthdate: data.childrenItems[index].birthdate
                    };
                }
            }
            window.busy();
            this.exec("nepbaby.customer.modify", {
                phone: data.phone,
                name: data.name,
                sex: data.sex,
                referrerPhone: data.referrerPhone,
                childrenItems: childrenItems
            }).then(lang.hitch(this, function (data) {
                window.free();
                if (data && data.item) {
                    alert("修改会员信息成功");
                    history.back();
                } else {
                    alert(data.message || data.errmsg || "操作失败");
                }
            }));
        },
        //店铺积分（余额）查询

        // 会员列表查询
        // pageNum以及pageSize必选
        // 返回会员列表
        getCustomerList: function () {
            return this.getBaseUrl() + "?method=nepbaby.customer.batchquery";
        },
        // 连锁总部下属门店会员列表
        getStoreCustomerList: function () {
            return this.getBaseUrl() + "?method=nepbaby.store.member.batchquery";
        },
        listQuery: function (params) {
            var query = {
                phone: params.search || ""
            };
            if (params.cqViewParam && params.cqViewParam.params) {
                query.currencyId = params.cqViewParam.params;
            }
            return query;
        },
        storeListQuery: function () {
            return {};
        },
        //业务员：点击表格查看会员明细query
        listQueryforTable: function (params) {
            //返回点击的数字里面的所有信息
            return {
                phone: params.search || "",

            };
        },
        //积分售卖列表
        getIntegralList: function () {
            return this.getBaseUrl() + "?method=nepbaby.integral.sell.batchquery";
        },
        //积分兑换列表
        getExchangeList: function () {
            return this.getBaseUrl() + "?method=nepbaby.integral.exchange.batchquery";
        },
        //库存列表,参数:serialNumber
        grtInventoryList: function () {
            return this.getBaseUrl() + "?method=nepbaby.inventory.batchquery";
        },
        inventoryListQuery: function (params) {
            return {
                serialNumber: params.search || ""
            };
        },
        // 会员消费记录列表
        // 返回结果同积分兑换列表
        getMemberShoppingList: function () {
            return this.getBaseUrl() + "?method=nepbaby.customer.consume.batchquery";
        },
        memberQueryList: function (params) {
            return { phone: params.cqViewParam.params };
        },
        getListItemProp: function (item) {
            //确定integral的值是
            //saleType ： POSTING 销售  EXCHANGE 兑换    LARGESS 赠送
            if (item.saleType == "POSTING" || item.saleType == "LARGESS") {
                item.integral = "获得积分：" + item.integral;
            } else if (item.saleType == "EXCHANGE") {
                item.integral = "消耗积分：" + item.integral;
            }
            return item;
        },
        loadStockDetail: function (params) {
            if (!(params && params.cqViewParam && params.cqViewParam.params)) {
                return;
            }
            return this.exec("nepbaby.inventory.batchquery", {
                serialNumber: params.cqViewParam.params
            }).then(lang.hitch(this, function (data) {
                if (data && data.item.list[0]) {
                    data = data.item.list[0];
                    data.outPutCounts = data.originalCounts - data.remainCounts;
                }
                return data;
            }));
        },
        //入库单据列表
        stockDetaillayout: function () {
            return [{
                type: "form",
                fields: this.getFormItems([
                    "goodsName",
                    "serialNumber",
                    "goodsBrand",
                    "originalCounts",
                    "outPutCounts",
                    "createTime"
                ], true)
            }];
        },
        onDataReadyStockDetail: function (widget) {
            //不允许编辑所有
            var data = widget.getData();
            widget.disableByFields(["goodsName", "serialNumber", "goodsBrand", "originalCounts", "outPutCounts", "createTime"]);
        },
        onListClickInvent: function (data) {
            window.moveToView("inventDetail", data.serialNumber);
        },


        getMemberInfolayout: function () {
            return [{
                type: "form",
                fields: this.getFormItems([
                    //"storeId",
                    //"referrerPhone",
                    "memberId",
                    "memberConfirm"
                ], true)
            }];
        },
        getMemberInfolayoutforExchange: function () {
            return [{
                type: "form",
                fields: this.getFormItems([
                    "memberId",
                    "memberConfirmForExchange"
                ], true)
            }];
        },
        memberConfirmForExchange: function (data) {
            //根据输入的会员id读取改会员在改门店的会员信息
            if (!(data && data.memberId)) {
                alert("请输入正确的会员号！");
                return;
            }
            if (data.memberId.length !== 11) {
                return alert("会员号为11位数字");
            }
            if (!this.isCellPhone(data.memberId)) {
                return alert("手机号不合法，请输入正确的电话号码");
            }
            //根据输入的会员id读取改会员在改门店的会员信息
            this.getCurrentMemberInfo(data.memberId).then(lang.hitch(this, function (result) {
                if (result.item) {
                    this.setLastPhone("");
                    window.moveToView("memberExchange", result.item.phone);
                } else {
                    //alert(result.message||result.errorMsg||"没有查到该会员信息,为你创建新的会员！");
                    window.moveToView("addCustomer", data.memberId);
                }
            }));
        },
        //兑换页面，兑换按钮
        memberExchange: function (data) {
            if (!data.phone) {
                alert("请输入正确的会员号!");
                return;
            }
            if (data.phone.length !== 11) {
                return alert("会员号为11位数字");
            }
            if (!this.isCellPhone(data.phone)) {
                return alert("手机号不合法，请输入正确的电话号码");
            }
            if (!data.goodsCodes.length) {
                alert("您还未扫码！");
                return;
            }
            var goodsCodes = [];
            data.goodsCodes.forEach(function (item) {
                if (item) {
                    goodsCodes.push(item.goodsCode);
                }
            });
            window.busy();
            var param = {
                phone: data.phone,
                goodsCodes: goodsCodes,
                referrerPhone: data.referrerPhone
            };
            param.code = data.vcode||"1";
            //会员积分兑换
            this.exec("nepbaby.integral.exchange.submit", param, "token").then(lang.hitch(this, function (result) {
                window.free();
                if (result && result.item) {
                    alert("成功兑换商品，您还剩余积分" + result.item.integral || "");
                    history.back();
                } else {
                    alert(result.message || "购买失败");
                }
            }));
        },
        //强制兑换页面，兑换按钮
        //使用场景： 就是有些货经销商没有出库 货到门店了
        memberExchangeForce: function (data) {
            if (!data.goodsCodes.length) {
                alert("您还未扫码！");
                return;
            }
            var goodsCodes = [];
            data.goodsCodes.forEach(function (item) {
                if (item) {
                    goodsCodes.push(item.goodsCode);
                }
            });
            var def = null;
            if (data.exchangeCode) {
                window.busy();
                def = this.exec("nepbaby.integral.redeemexchange.submit", {
                    phone: data.phone,
                    referrerPhone: data.referrerPhone,
                    code: data.exchangeCode,
                    goodsCodes: goodsCodes
                }, "token");
            } else if (confirm("所有条码已扫完？")) {
                /*if (!data.vcode[1]) {
                    alert("您还未获取验证码！");
                    return;
                }*/
                window.busy();
                //会员积分兑换
                var params = {
                    phone: data.phone,
                    goodsCodes: goodsCodes,
                    referrerPhone: data.referrerPhone
                };
                params.code = data.vcode||"1";
                def = this.exec("nepbaby.integral.exchange.forcesubmit", params, "token");
            }
            if (def) {
                def.then(lang.hitch(this, function (result) {
                    window.free();
                    if (result && result.item) {
                        alert("成功兑换商品!");
                        history.back();
                    } else {
                        alert(result.message || "兑换失败");
                    }
                }));
            }
        },
        memberConfirm: function (data) {
            if (!(data && data.memberId)) {
                alert("请输入正确的会员号！");
                return;
            }
            if (data.memberId.length !== 11) {
                return alert("会员号为11位数字");
            }
            if (!this.isCellPhone(data.memberId)) {
                return alert("手机号不合法，请输入正确的电话号码");
            }
            //根据输入的会员id读取改会员在改门店的会员信息
            this.getCurrentMemberInfo(data.memberId).then(lang.hitch(this, function (result) {
                if (result.item) {
                    this.setLastPhone("");
                    window.moveToView("memberConsumRecord", result.item.phone);
                } else {
                    //alert(result.message||result.errorMsg||"没有查到该会员信息,为你创建新的会员！");
                    window.moveToView("addCustomer", data.memberId);
                }
            }));
        },
        //根据积分码获取详细商品信息
        getIntegral: function (goodsCode) {
            return this.exec("nepbaby.integral.exchange.goodsdetail", { goodsCode: goodsCode });
        },
        getIntegralPro: function (goodsCode) {
            return this.exec("nepbaby.integral.promotion.batchquery", {
                integralCodes: goodsCode,
                phone: config.session.phone
            }, "token");
        },
        onIntegralReady: function (widget) {
            //依据是否有兑换码判断显示兑换码还是验证码
            var a = widget.getElementByField("phone,vcode");
            if(a&&a.children){
                domStyle.set(a.children[0], "display", "none");
            }
            this.exec("nepbaby.select.owner.redeem", widget.getData()).then(function (result) {
                if (result.item && result.item.status == 1) {
                    widget.showByFields(["exchangeCode"]);
                    widget.hideByFields(["vcode", "goodsCodes"]);
                } else {
                    widget.showByFields(["vcode", "goodsCodes"]);
                    widget.hideByFields(["exchangeCode"]);
                }
            });
        },
        onExchangeFieldChange: function (widget, field, value) {
            if (field == "exchangeCode" && value) {
                data = widget.getData();
                this.exec("nepbaby.select.redeem.code", {
                    phone: data.phone,
                    referrerPhone: data.referrerPhone,
                    code: value
                }).then(lang.hitch(this, function (result) {
                    if (result.item && result.item.listHWRedeemDetail && result.item.listHWRedeemDetail.length) {
                        alert("兑换商品：" + result.item.listHWRedeemDetail[0].productName);
                        widget.showByFields(["goodsCodes"]);
                    } else {
                        alert(result.errmsg || "操作失败");
                    }
                }));
            }
        },
        //没有出库也可以强制积分
        //使用场景： 没有出库
        integralForcePost: function (data) {
            //alert(data.integralCodes.ruleId);
            if (!data.integralCodes.list.length) {
                alert("您还未扫码！");
                return;
            }
            /*if(data.integralCodes.ruleId == ""){
                alert("您还没选择参与活动");
                return;
            }*/
            var integralCodes = [], ruleId;
            data.integralCodes.list.forEach(function (integral) {
                if (integral) {
                    integralCodes.push(integral.goodsCode);
                }
            });
            ruleId = data.integralCodes.ruleId;
            /*if(!ruleId){
                alert("您未选择活动")
            }*/
            if (confirm("所有条码已扫完？")) {
                window.busy();
                this.exec("nepbaby.integral.posting.forcesubmit", {
                    referrerPhone: data.referrerPhone,
                    phone: data.phone,
                    integralCodes: integralCodes,
                    ruleId: ruleId || "0"//选择的活动
                }, "token").then(lang.hitch(this, function (result) {
                    window.free();
                    if (!(result && result.item)) {
                        alert(result.message || "购买失败");
                        return;
                    }
                    if (result.item.integral instanceof Array && result.item.integral.length) {
                        // 执行弹出积分码的操作
                        return rewardDialog.show(result.item.integral).then(function() {
                            history.back();
                        });
                    }
                    alert("积分成功");
                    history.back();
                }));
            }
        },
        //正常售卖的积分
        integralPost: function (data) {
            //alert(data.integralCodes.ruleId);
            if (!data.integralCodes.list.length) {
                alert("您还未扫码！");
                return;
            }
            /*if(data.integralCodes.ruleId == ""){
                alert("您还没选择参与活动");
                return;
            }*/
            var integralCodes = [], ruleId;
            data.integralCodes.list.forEach(function (integral) {
                if (integral) {
                    integralCodes.push(integral.goodsCode);
                }
            });
            ruleId = data.integralCodes.ruleId;
            //ruleId是选择的积分码促销活动
            window.busy();
            this.exec("nepbaby.integral.posting.submit", {
                referrerPhone: data.referrerPhone,
                phone: data.phone,
                integralCodes: integralCodes,//,
                ruleId: ruleId || "0"//选择的活动
            }, "token").then(lang.hitch(this, function (result) {
                window.free();
                if (result && result.item) {
                    alert("您已成功积分" + result.item.integral || "");
                    history.back();
                } else {
                    alert(result.message || "购买失败");
                }
            }));
        },
        //活动列表
        getNoticeList: function () {
            return this.getBaseUrl() + "?method=nepbaby.notice.batchquery";
        },
        noticeListQuery: function (params) {
            var query = {};
            if (params.state && params.state._id == 0) {
                //未读
                query.currencyId = 0;
            } else if (params.state && params.state._id == 1) {
                //已读
                query.currencyId = 1;
            }
            return query;
        },
        getNoticeDetail: function (params) {
            window.busy();
            return this.exec("nepbaby.notice.detail.msg", {
                currencyId: params.cqViewParam.params
            }).then(lang.hitch(this, function (result) {
                window.free();
                return result.item;
            }));
        },
        onListClickNotice: function (data) {
            window.moveToView("noticeDetail", data.id);
        },
        //销售分析相关
        setTime: function () {
            var t = new Date();
            var f = new Date();
            f.setMonth(f.getMonth() - 1);
            return {
                queryTimet: t.toISOString(),
                queryTimef: f.toISOString()
            };
        },
        //趋势分析的layout
        getQueryLayout: function () {
            return [{
                type: "form",
                fields: this.getFormItems(["goodsId", "startTime"])
            }];
        },

        //趋势分析取数据
        getTrenData: function (params) {
            var param = {};
            if (params.queryData && params.queryData.goodsId) {
                param.goodsId = params.queryData.goodsId;
                if (params.goodsId && typeof (params.goodsId) == "string" && params.goodsId.indexOf(",") > -1) {
                    params.goodsId = params.goodsId.split(",");
                }
            } else {
                return alert("请选择品种");
            }
            if (params.queryData && params.queryData.startTime) {
                param.makeDate = params.queryData.startTimef;
            }
            if (config.session.userInfo && config.session.userInfo.organization && config.session.userInfo.organization.id) {
                param.storeId = config.session.userInfo.organization.id;
            }
            param.pageSize = 100;
            //param.storeId = "1027616";
            param.merge = 1;
            window.busy();
            return monthlySum.getTrendData(param).then(lang.hitch(this, function (result) {
                window.free();
                return result.items;
            }));
        },
        xLabelMethod: function (data, index) {
            if (data == null) {
                return '';
            }
            if (index == 0) {
                return '';
            }
            var idx = parseInt(index);
            var dtime;
            if (idx < data.length) {
                dtime = date.formatISODate(data[index - 1].makeDate);
            }
            if (dtime) {
                dtime = dtime;
            } else {
                dtime = " ";
            }
            return dtime;
        },
        getThisPoint: function (data) {
            var loginNum = (data.loginNum || 0);
            var payNum = (data.payNum || 0);
            if (data) {
                return "时间:" + data.date + "，登陆商家数：" + loginNum + "，支付商家数：" + payNum;
            }
        },
        loosexLabelMethod: function (data, index) {
            if (data == null) {
                return '';
            }
            if (index == 0) {
                return '';
            }
            var idx = parseInt(index);
            var dtime;
            if (idx < data.length) {
                dtime = data[index - 1].totalQty;
            }
            if (dtime) {
                dtime = dtime;
            } else {
                dtime = " ";
            }
            return dtime;
        },
        //流失客户分析
        getLooseData: function (params) {
            var param = {};
            if (params.queryData && params.queryData.goodsId) {
                param.goodsId = params.queryData.goodsId;
                if (params.goodsId && typeof (params.goodsId) == "string" && params.goodsId.indexOf(",") > -1) {
                    params.goodsId = params.goodsId.split(",");
                }
            } else {
                return alert("请选择品种");
            }
            if (params.queryData && params.queryData.startTime) {
                param.makeDate = params.queryData.startTimef;
            }
            if (config.session.userInfo && config.session.userInfo.organization && config.session.userInfo.organization.id) {
                param.storeId = config.session.userInfo.organization.id;
            }
            param.pageSize = 100;
            window.busy();
            return memberSum.looseTrend(param).then(lang.hitch(this, function (result) {
                window.free();
                return result.items;

            }));
            //var a = [{"_id":0.5,"num":1271,"totalQty":0.5},{"_id":1,"num":988,"totalQty":1},{"_id":1.5,"num":80,"totalQty":1.5},{"_id":2,"num":234,"totalQty":2},{"_id":2.5,"num":47,"totalQty":2.5},{"_id":3,"num":133,"totalQty":3},{"_id":3.5,"num":21,"totalQty":3.5},{"_id":4,"num":107,"totalQty":4},{"_id":4.5,"num":14,"totalQty":4.5},{"_id":5,"num":76,"totalQty":5},{"_id":5.5,"num":16,"totalQty":5.5},{"_id":6,"num":154,"totalQty":6},{"_id":6.5,"num":19,"totalQty":6.5},{"_id":7,"num":100,"totalQty":7},{"_id":7.5,"num":12,"totalQty":7.5},{"_id":8,"num":76,"totalQty":8},{"_id":8.5,"num":11,"totalQty":8.5},{"_id":9,"num":41,"totalQty":9},{"_id":9.5,"num":12,"totalQty":9.5},{"_id":10,"num":33,"totalQty":10},{"_id":10.5,"num":11,"totalQty":10.5},{"_id":11,"num":28,"totalQty":11},{"_id":11.5,"num":2,"totalQty":11.5},{"_id":12,"num":59,"totalQty":12},{"_id":12.5,"num":4,"totalQty":12.5},{"_id":13,"num":28,"totalQty":13},{"_id":13.5,"num":8,"totalQty":13.5},{"_id":14,"num":28,"totalQty":14},{"_id":14.5,"num":3,"totalQty":14.5},{"_id":15,"num":26,"totalQty":15},{"_id":15.5,"num":4,"totalQty":15.5},{"_id":16,"num":15,"totalQty":16},{"_id":16.5,"num":3,"totalQty":16.5},{"_id":17,"num":12,"totalQty":17},{"_id":17.5,"num":2,"totalQty":17.5},{"_id":18,"num":14,"totalQty":18},{"_id":18.5,"num":3,"totalQty":18.5},{"_id":19,"num":10,"totalQty":19},{"_id":19.5,"num":3,"totalQty":19.5},{"_id":20,"num":14,"totalQty":20},{"_id":20.5,"num":4,"totalQty":20.5},{"_id":21,"num":6,"totalQty":21},{"_id":21.5,"num":2,"totalQty":21.5},{"_id":22,"num":6,"totalQty":22},{"_id":23,"num":11,"totalQty":23}];
            //return a;
        },
        getStrRptData: function (refInfo, widget, dataOptions) {
            var params = {
                pageSize: 1000,
                pageIdx: 1
            };
            if (config.session.userInfo && config.session.userInfo.organization && config.session.userInfo.organization.id) {
                params.storeId = config.session.userInfo.organization.id;
            }
            if (refInfo && refInfo.search && refInfo.search.goodsId) {
                params.goodsId = refInfo.search.goodsId;
                if (params.goodsId && typeof (params.goodsId) == "string" && params.goodsId.indexOf(",") > -1) {
                    params.goodsId = params.goodsId.split(",");
                }
            } else {
                return alert("请选择品种");
            }
            if (refInfo && refInfo.search && refInfo.search.startTime) {
                params.month = refInfo.search.startTime;
            }
            window.busy();
            return monthlySum.load(params).then(lang.hitch(this, function (data) {
                window.free();
                data = data.items;
                return data;
            }));
        },

        getunRead: function () {
            window.busy();
            return this.exec("nepbaby.notice.unread", {}, "token").then(function (data) {
                window.free();
                data.item.unread = parseInt(data && data.item && data.item.unread || 0);
                return data.item;
            });
        },
        //公告列表状态的选中按钮
        getStateItemProps: function (data, itemType, list) {
            var refInfo = list && list.cqRefInfo || {};
            var state = refInfo.cqViewParam && refInfo.cqViewParam.params || "";
            data.selected = data._id == state;
            return data;
        },
        //添加回车事件（手机号满11位自动跳转后面处理）
        onScoreEnter: function (widget, field, value) {
            if (field === "memberId" && value) {
                this.memberConfirm(widget.getData(), widget);
            }
        },
        onExchangeEnter: function (widget, field, value) {
            if (field === "memberId" && value) {
                this.memberConfirmForExchange(widget.getData(), widget);
            }
        },
        //销售报表迁移到customer
        getTimeQuery: function () {
            return [{
                type: "form",
                fields: this.getFormItems(["queryTime"])
            }];
        },


        getMatSaleRptData: function (cqRefInfo, widget, dataOptions) {
            var params = {};
            if (cqRefInfo && cqRefInfo.timeQuery && cqRefInfo.timeQuery.queryTimef) {
                params.orderDatef = cqRefInfo.timeQuery.queryTimef;
            }
            if (cqRefInfo && cqRefInfo.timeQuery && cqRefInfo.timeQuery.queryTimet) {
                params.orderDatet = cqRefInfo.timeQuery.queryTimet;
            }
            params.storeId = config.session.userInfo && config.session.userInfo.organization && config.session.userInfo.organization.id || "";
            window.busy();
            return cust.getSaleReport(params).then(lang.hitch(this, function (result) {
                window.free();
                return result && result.items || [];
            }));
        },
        getMatSaleRptDataForSale: function (cqRefInfo, widget, dataOptions) {
            //如果业务员没有选择终端，则查询全部可看终端
            var params = {};
            if (cqRefInfo && cqRefInfo.timeQuery && cqRefInfo.timeQuery.terminal && cqRefInfo.timeQuery.terminal.length) {
                params.storeId = cqRefInfo.timeQuery.terminal;
            } else {
                params.storeId = [];
                consumer.getCurrentUserFromSession().terminal.forEach(function (terminal) {
                    params.storeId.push(terminal.TerminalID);
                });
            }
            if (cqRefInfo && cqRefInfo.timeQuery && cqRefInfo.timeQuery.queryTimef) {
                params.orderDatef = cqRefInfo.timeQuery.queryTimef;
            }
            if (cqRefInfo && cqRefInfo.timeQuery && cqRefInfo.timeQuery.queryTimet) {
                params.orderDatet = cqRefInfo.timeQuery.queryTimet;
            }
            window.busy();
            return cust.getSaleReport(params).then(lang.hitch(this, function (result) {
                window.free();
                return result && result.items || [];
            }));
        },
        exchangeLayoutMethod:function(){
            var fields = [{
                type : "content",
                content:'<div class="storeMsg storeBackground">'+
                    '<div class="labelPadding"><span class="labelName">门店标识：<span/><span class="cq-field-input labelMsg" data-cq-field="storeId"></span></div>'+
                    '<div class="labelPadding"><span class="labelName">推荐人：<span/><span class="cq-field-input labelMsg" data-cq-field="referrerPhone"></span></div>'+
                '</div>'
            },{
                type : "content",
                content: '<div>'+
                    '<div class="storeMsg">'+
                        '<div style="flex:2;padding-left:15px;padding-top:10px"><span class="labelName">会员：<span/><span class="cq-field-input labelMsg" data-cq-field="phone"></span></div>'+
                        '<div class="labelPadding"><span class="cq-field-input labelMsg" data-cq-field="name"></span></div>'+
                        '<div class="labelPadding"><span class="cq-field-input labelMsg" data-cq-field="sex"></span></div>'+
                    '</div>'+
                '</div>'
            },{
                type : "content",
                content: '<div class="storeMsg">'+
                    '<div class="labelPadding">'+
                        '<span class="labelName">当前积分：<span/><span class="cq-field-input labelMsg" data-cq-field="integral"></span>'+
                    '</div>'+
                '</div>'
            },{
                type:"content",
                content:'<div class="cq-form-vcode cq-field-input zct-item" data-cq-field="phone,vcode" data-dojo-type="cq/app/widget/mobile/edit/VCode" data-dojo-props=\'"field":"phone,vcode","dataProvider":"whz/bo/sms","smsMethod":"send","label":"会员号,验证码","noIcon":"true","errorMsg":"请输入正确的11位电话号码"\'></div>'
            },{
                field:"exchangeCode",
                label:"兑换码",
                type:"text"
            },{
                type : "content",
                content: '<div class="cq-field-input scanner" data-cq-field="goodsCodes" data-dojo-type="whz/widget/ScannerList" data-dojo-props=\'"field":"goodsCodes","dataProvider":"whz/bo/customer","infoMethod":"getIntegral","rightText":"name","labelField":"goodsCode","scannerLabel":"积分码"\'></div>'
            },{
                type: "action",
                action: "memberExchangeForce",
                label: "兑换",
                field: "memberExchangeForce",
                className: "none"
            }];
            var userInfo = config.session&&config.session.userInfo||{};
            if(userInfo.isVerify==1) {
                fields.splice(3, 1);
            }
            return [{
                type : "form",
                canDelete:false,
                canAdd:false,
                canDnd:false,
                canEdit:false,
                formClass: "no-border",
                fields:fields
            }];
        }
    });
    var bo = new Bo();
    bo.Bo = Bo;
    return bo;
});
