﻿/***
 * 积分兑换功能
 **/
 define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "./BoBase"
],function(declare, lang, topic, BoBase){
    var Bo = declare("",BoBase,{
        // 积分兑换商品明细
        // {id:xx,name:xxx,integral:xx,goodsCode:xxx}
        getExchangeMatInfo:function(data, widget, evt){
            if(!data.goodsCode){
                return alert("罐底码不能为空");
            }
            return this.exec("nepbaby.integral.exchange.goodsdetail", {
                goodsCode:data.goodsCode
            }).then(lang.hitch(this, function(data){
                return data&&data.item;
            }));
        },
        // 积分兑换登记
        // 返回{integral:integral}
        submitExchange:function(data, widget, evt){
            if(!data.phone){
                return alert("会员电话不能为空");
            }
            if(!data.code){
                return alert("验证码不能为空");
            }
            if(!data.goodsCodes){
                return alert("罐底码列表不能为空");
            }
            return this.exec("nepbaby.integral.exchange.submit", {
                phone:data.phone,
                code:data.code,
                goodsCodes:data.goodsCodes
            }).then(lang.hitch(this, function(data){
                return data&&data.item;
            }));
        },
        // 积分兑换强制登记
        // return {integral:integral}
        forceSubmitExchange:function(data, widget, evt){
            if(!data.phone){
                return alert("会员电话不能为空");
            }
            if(!data.code){
                return alert("验证码不能为空");
            }
            if(!data.goodsCodes){
                return alert("罐底码列表不能为空");
            }
            return this.exec("nepbaby.integral.exchange.forcesubmit", {
                phone:data.phone,
                code:data.code,
                goodsCodes:data.goodsCodes
            }).then(lang.hitch(this, function(data){
                return data&&data.item;
            }));
        },
        // 积分兑换列表
        // 返回门店订单列表
        // [{orderId:xx,customerName:xx,customerPhone:xx,goodsName:xx,
        // integralCode:xx,integral:xx,quantity:xx,referrerName:xx,
        // referrerPhone:xx,createTime:xx,exchangeType:xx,consumeType:xx,
        // orderGoods:[{goodsName:xx,integralCode:xx,integral:xx}]}]
        getExchangeList:function(data, widget, evt){
            if(!data.referrerPhone){
                return alert("推荐人电话不能为空");
            }
            if(!data.pageNum){
                return alert("页码不能为空");
            }
            if(!data.pageSize){
                return alert("pageSize不能为空");
            }
            return this.exec("nepbaby.integral.exchange.batchquery", {
                phone:data.referrerPhone,
                pageNum:data.pageNum,
                pageSize:data.pageSize
            }).then(lang.hitch(this, function(data){
                return data&&data.items;
            }));
        },
        // 积分售卖列表
        // 返回结果同积分兑换列表
        getExchangeSaleList:function(data, widget, evt){
            if(!data.referrerPhone){
                return alert("推荐人电话不能为空");
            }
            if(!data.pageNum){
                return alert("页码不能为空");
            }
            if(!data.pageSize){
                return alert("pageSize不能为空");
            }
            return this.exec("nepbaby.integral.sell.batchquery", {
                phone:data.referrerPhone,
                pageNum:data.pageNum,
                pageSize:data.pageSize
            }).then(lang.hitch(this, function(data){
                return data&&data.items;
            }));
        }
    });
    var bo = new Bo();
    bo.Bo = Bo;
    return bo;
});