/***
 * 所以关于商品的功能
 **/
define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "cq/util/config/config",
    "cq/util/sys/userAgent",
    "./consumer",
    "./BoBase"
],function(declare,lang,Deferred,config,userAgent,consumer, BoBase){
    var Bo = declare("",BoBase,{
        isRefreshData : true,
        fields:{
            bdate:{
                type:"dateTime",
                formatStr:"yyyyMMddhhmmss"
            },
            goodsName:{
                type:"text",
                label:"商品名称"
            },
            saleQty:{
                type:"number",
                label:"销售数量"
            },
            giftQty:{
                type:"number",
                label:"赠送数量"
            },
            exchangeQty:{
                type:"number",
                label:"兑换数量"
            },
            terminal:{
                type:"options",
                options:{
                },
                label:"门店号"
            },
            status : {
                type : "options",
                options : {
                    0 : "失效单据",
                    1 : "待出库",
                    2 : "部分出库",
                    3 : "处理完成",
                    4 : "待审核"
                },
                label : "状态"
            },
            showIntegralDetail : {
                type : "action",
                label : "查看明细",
                action : "onShowIntegralDetail"
            }
        },
        onShowIntegralDetail : function (data) {
            this.pageData = data;
            this.isRefreshData = false;
            window.moveToView("storeIntegralList");
        },
        onDataReady : function (widgets) {
            var userInfo = consumer.getCurrentUserFromSession();
            // if (userInfo.role === "liansuozongbu") {
            if(userInfo.isRedeem == 1){
                widgets.showByFields(["showIntegralDetail"]);
            } else {
                widgets.hideByFields(["showIntegralDetail"]);
            }
        },
        //溯源点击响应
        getMatSoure:function(){
            if(userAgent.isApp()&&window.cordova&&window.cordova.plugins&&window.cordova.plugins.barcodeScanner){
				if (this.ttt && (Date.now() - this.ttt) < 1000) {
					return;
				}
				this.ttt = Date.now();
                cordova.plugins.barcodeScanner.scan(lang.hitch(this,function (result) {
                    if(result&&result.text){
                        window.open("http://app.nepbaby.com/suyuan?code=" + result.text);
                    }else{
                        return;
                    }
                }),function (error) {
                    alert("扫码失败: " + error);
                },{
                    //优先使用前置摄像头
                    // iOS and Android
                    preferFrontCamera : false,
                    //显示切换摄像头按钮
                    //iOS and Android
                    showFlipCameraButton : true,
                    //显示闪光灯开关
                    //iOS and Android
                    showTorchButton : true,
                    //默认开启闪光灯
                    //Android, launch with the torch switched on (if available)
                    torchOn: false,
                    //saveHistory: false, // Android, save scan history (default false)
                    //扫码区域底部提示信息
                    //Android
                    prompt : "请将条码放入扫描区域内",
                    //Android, display scanned text for X ms. 0 suppresses it entirely, default 1500
                    resultDisplayDuration: 0,
                    //编码格式
                    //default: all but PDF_417 and RSS_EXPANDED
                    //formats : "QR_CODE,PDF_417",
                    //扫码时的旋转方向
                    // Android only (portrait|landscape), default unset so it rotates with the device
                    //orientation : "portrait",
                    //disableAnimations : true, // iOS
                    //禁用扫码成功的滴滴声
                    //iOS and Android
                    disableSuccessBeep: false
                });
            }
        },
        getUrlList:function(){
            // summary:
            //        门店兑换列表统计
            // view:
            //         shopExchangeList
            // description:
            //         签名必填
            return this.getBaseUrl()+"?method=nepbaby.billbills.batchquery";
        },
        loadGoosList:function(){
            /*var list = [
                {name:"haha水电费士大夫",id:1,storeExchangeIntegral:200},
                {name:"yessd",id:2,storeExchangeIntegral:300},
                {name:"yoyo",id:3,storeExchangeIntegral:400}
            ];
            var item = {};
            item.mats = list;
            item.name = "haha";
            item.usableIntegral = 2000;
            return item;*/
            if(!config.session.phone){
                return alert("用户未登录");
            }
            var def = new Deferred();
            if (this.isRefreshData) {
                window.busy();
                this.exec("nepbaby.terminal.integral.batchquery",{
                    phone:config.session.phone
                },"token").then(lang.hitch(this,function(data){
                    var item = {
                        brandname : "喜安智"
                    };
                    item.usableIntegral = data.result.usableIntegral;
                    this.exec("nepbaby.goods.goods.batchquery",{
                        phone:config.session.phone,
                        //brandname:"xianxin"
                        brandname:item.brandname || "喜安智"
                    }).then(function(data){
                        window.free();
                        item.mats = data.result.list||[];
                        def.resolve(item);
                    });
                }));
            } else {
                // 不用刷新数据，去当前数据
                this.isRefreshData = true;
                def.resolve(this.pageData);
            }
            return def;
        },
        //门店兑换的字段改变触发事件
        onStoreChanged:function(widget,field,value){
            if(field == "mats"){
                var data = widget.getData();
                //循环data.mats累加qty*storeExchangeIntegral的值
                var totalIntegral = 0;
                for(var i=0;i<data.mats.length;i++){
                    if(data.mats[i].qty){
                        totalIntegral += data.mats[i].qty*data.mats[i].storeExchangeIntegral;
                    }
                    if(totalIntegral>data.usableIntegral){
                        alert("门店积分不够兑换"+data.mats[i].qty+"罐"+data.mats[i].name);
                        totalIntegral = totalIntegral-data.mats[i].qty*data.mats[i].storeExchangeIntegral;
                        data.mats[i].qty = "";
                        break;
                    }
                    data.totalIntegral = totalIntegral;
                }
                widget.setData(data);
            }
            if (field == "brandname") {
                window.busy();
                var pageData = widget.getData();
                this.exec("nepbaby.goods.goods.batchquery",{
                    phone:config.session.phone,
                    brandname:value
                }).then(function(data){
                    window.free();
                    pageData.totalIntegral = 0;
                    pageData.mats = data.result.list||[];
                    widget.setData(pageData);
                });
            }
        },
        ListQuery:function(params){
            return {
                phone:params.search||""
            };
        },
        getItemPro:function(item){
            return item;
        },
        onListClick:function(){
            
        },
        //门店兑换列表
        getStoreExcangeUrl:function(){
            // summary:
            //        门店兑换列表
            // view:
            //         
            // description:
            //         签名必填
            return this.getBaseUrl()+"?method=nepbaby.billbills.batchquery";
        },
        getStoreIntegral:function(){
            // summary:
            //        当前门店积分（余额）
            // view:
            //         
            // description:
            //         门店兑换列表
            //cqParams.cqViewParam.params
            if(!config.session.phone){
                return alert("用户未登录");
            }
            return this.exec("nepbaby.terminal.integral.batchquery",{
                phone:config.session.phone
            },"token").then(function(data){
                return data.result;
            });
        },
        storeExChange:function(data){
            // summary:
            //        门店兑换
            // view:
            //         
            // description:
            //     
            var mats = [];
            for(var i=0;i<data.mats.length;i++){
                if(data.mats[i].qty){
                    //参与兑换，否则不参与
                    mats.push({mid:data.mats[i].id,qty:data.mats[i].qty});
                }
            }
            if(!mats.length){
                alert("没有填写需要兑换的商品");
                return;
            }
            if(data.totalIntegral>data.usableIntegral){
                alert("门店积分不够，请重新选择兑换方案");
                return;
            }
            window.busy();
            this.exec("nepbaby.termianl.exchange.create",{
                mats:mats
            },"token").then(lang.hitch(this,function(data){
                if(data&&data.item){
                    window.free();
                    alert("兑换成功");
                    history.back();
                }else{
                    window.free();
                    alert(data.message||data.errorMsg||"操作失败");
                }
            }));
        }
    });
    var bo = new Bo();
    bo.Bo = Bo;
    return bo;
});