define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojo/Deferred",
    "dojo/request/xhr",
    "cq/util/config/config",
    "cq/util/sys/date",
    "./BoBase"
], function (declare,lang,domStyle,Deferred,xhr,config,date,BoBase) {
    var O =  declare("",BoBase,{
        modalName:"nepbaby/terminal",
        fields:{
        	deptId:{
        		label:"大区id"
        	},
        	deptName:{
                label:"大区"
            },
            provinceId:{
                label:"省区id"
            },            
            provinceName:{
                label:"省区"
            },
            cityId:{
            	label:"城市id"
            },
            cityName:{
            	label:"城市"
            },
            empId:{
            	label:"业务员id"
            },
            empName:{
            	label:"业务员"
            },
            amount:{
            	label:"流向金额"
            },
            rank:{
            	label:"排行"
            },
            modelName:{
                type:"options",
                label:"指标类型",
                selected : "Flow",
                options:{
                    "Flow":"流向",
                    "Sale":"纯销"
                }
            },
            time:{
                type:"options",
                label:"时段范围",
                selected:"month",
                options:{
                    "month":"本月",
                    "year":"本年"
                }
            },
            brandId:{
                type:"options",
                label:"品牌",
                selected : "1000000",
                options:{
                    "1000000":"喜安智",
                    "1000002":"喜安欣",
                    "1000003":"保健品"
                }
            },
            rankField:{
                type:"options",
                label:"榜单类型",
                selected:"Emp",
                options:{
                    "Emp":"业务员",
                    "City":"城市",
                    "Province":"省区",
                    "Dept":"大区"
                }
            }
        },
        initRankListLayout:function(){
            var data = {
                modelName:"Flow",
                time:"month",
                rankField:"Emp",
                brandId:1000000
            };
            return data;
        },
        getRankListLayout:function(){
            return [{
                type:"form",
                fields:this.getFormItems(["modelName","time","rankField","brandId"])
            }];
        },
        loadRunkData:function(refInfo,list,options){
            return this.loadRank(refInfo).then(function(res){
                var items = [];
                if(res&&res.items){
                    for(var i=0;i<res.items.length&&i<20;i++){
                        items.push(lang.clone(res.items[i]));
                    }
                }
                return items;
            });
        },
        loadRunkDataDesc:function(refInfo,list,options){
            return this.loadRank(refInfo).then(function(res){
                var items = [];
                if(res&&res.items){
                    for(var i=res.items.length-1;i>=0&&i>=res.items.length-20;i--){
                        items.push(lang.clone(res.items[i]));
                    }
                }
                return items;
            });
        },
        loadRank:function(refInfo){
            if(!this.listDataDef){
                var params = this.rankListQuery(refInfo);
                if(!params){
                    return;
                }
                var _this = this;
                this.listDataDef = xhr.get(config.dataOrigin1 + "/datacenter/getRankList",{
                    query:params,
                    handleAs:"json"
                }).then(function(res){
                    setTimeout(function(){
                        _this.listDataDef = null;
                    },100);
                    return res;
                });
            }
            return this.listDataDef;
        },
        load:function(){
            return this.getBaseUrl1()+"/loadRank?shopId="+this.getShopId();
        },
        getListUrl:function(){
            var userInfo = config.session&&config.session.userInfo||{};
            return this.getBaseUrl()+"/loadByEmp?shopId="+this.getShopId()&"empId="+userInfo.empId;
        },
        rankListQuery:function(params){
            var query = {};
            if(params["1"]&&!params["1"].modelName){
                alert("指标类型必填");
                return;
            }
            if(params["1"]&&!params["1"].time){
                alert("时段必填");
                return;
            }
            if(params["1"]&&!params["1"].rankField){
                alert("榜单类型必填");
                return;
            }
            if(params["1"]&&!params["1"].brandId){
                alert("品牌必填");
                return;
            }
            if(params["1"]){
                if(params["1"].modelName){
                    query.modelName = params["1"].modelName;
                }
                if(params["1"].time){
                    var date = new Date();
                    if(params["1"].time == "month"){
                        query.createAtf = date.getFullYear() + "-"
                            + (date.getMonth() + 1) + "-01" 
                            + " 00:00:00";
                        query.createAtt = date.getFullYear() + "-"
                            + (date.getMonth() + 2) + "-01"
                            + " 00:00:00";
                    }else{
                        query.createAtf = date.getFullYear() + "-01-01"
                            + " 00:00:00";
                        query.createAtt = (date.getFullYear()+1) + "-01-01"
                            + " 00:00:00";
                    }
                }
                if(params["1"].rankField){
                    query.rankField = params["1"].rankField;
                }
                if(params["1"].brandId){
                    query.brandId = params["1"].brandId;
                }
            }
            return {params:JSON.stringify(query)};
        },
        getRankListItemPro:function(item){
            if(item.deptName){
                item.name = item.name + "(" + item.deptName + ")"
            }
            if(item.saleQty){
                item.saleQty = item.saleQty.toFixed(1) + "罐";
            }
            if(item.amount){
                item.amount = item.amount.toFixed(2);
            }
            return item;
        },
        //业务员门店查询
        ListQuery:function(params){
        	return {tp:"liuxiang"};
        
        }
    });
    var o = new O();
    o.Bo = o;
    return o;
});
