define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/xhr",
    "dojo/_base/connect",
    "dojo/dom-style",
    "dojo/Deferred",
    "dojo/query",
    "dojo/dom-construct",
    "dojo/dom-geometry",
    "dijit/registry",
    "cq/util/config/config",
    "cq/util/sys/date",
    "cq/util/edit/tooltip",
    "./BoBase",
    "./monthlySum",
    "./consumer",
    "./cust"
], function (declare, lang, xhr, connect, domStyle, Deferred, query, domConstruct, domGeometry, registry, config, date, tooltip, BoBase, monthlySum, consumer, cust) {
    var O = declare("", BoBase, {
        modalName: "nepbaby/terminal",
        planePath: 'path://M1705.06,1318.313v-89.254l-319.9-221.799l0.073-208.063c0.521-84.662-26.629-121.796-63.961-121.491c-37.332-0.305-64.482,36.829-63.961,121.491l0.073,208.063l-319.9,221.799v89.254l330.343-157.288l12.238,241.308l-134.449,92.931l0.531,42.034l175.125-42.917l175.125,42.917l0.531-42.034l-134.449-92.931l12.238-241.308L1705.06,1318.313z',
        fields: {
            //查询条件相关字段
            //终端——业务代表负责的终端列表
            storeId: {
                label: "终端",
                type: "options",
                options: {}
            },
            //字段清单——各级经理的下级人员
            subEmpId: {
                label: "下级",
                type: "options",
                options: {}
            },
            //商品——暂时只有喜安欣的商品
            goodsId: {
                type: "ref",
                field: "goodsId",
                keyField: "id",
                label: "产品",
                searchField: "name",
                labelFields: "name",
                dataProvider: "whz/bo/terminal",
                targetMethod: "getLoadGoodsUrl",
                refQuery: {
                    Brandname: "{brandName}"
                },
                multiselect: "multiselect",
                canEdit: true,
                className: "middle-width"
            },
            brandName: {
                type: "options",
                label: "品牌",
                selected: "喜安智",
                options: {
                    "喜安智": "喜安智",
                    "喜安欣": "喜安欣"
                }
            },
            brandId: {
                type: "options",
                label: "品牌",
                selected: "1000000",
                options: {
                    "1000000": "喜安智",
                    "1000002": "喜安欣",
                    "1000003": "保健品"
                }
            },
            empId: {
                type: 'text',
                label: "业务员ID"
            },
            //月份
            makeDate: {
                type: "date",
                label: "月份"
            },
            // 月份
            month: {
                type: 'date',
                label: '月份'
            },
            //日期
            createAt: {
                type: "date",
                label: "日期"
            },
            lastTsDate: {
                type: "date",
                label: "最后进货日期"
            },
            //客户分析报表相关
            tp: {
                type: "options",
                options: {
                    "10": "新客",
                    "20": "老客",
                    "30": "活跃客户",
                    "40": "流失客户"
                },
                label: "会员类型"
            },
            num: {
                type: "number",
                label: "数量"
            },
            buyQty: {
                type: "number",
                label: "累计购买",
                fixedTo: 0
            },
            saleQty: {
                type: "number",
                label: "购买",
                fixedTo: 0
            },
            exchangeQty: {
                type: "number",
                label: "兑换",
                fixedTo: 0
            },
            giftQty: {
                type: "number",
                label: "赠送",
                fixedTo: 0
            },
            empName: {
                label: "人员"
            },


            TerminalName: {
                type: "text",
                label: "名称"
            },
            TerminalID: {
                type: "text",
                label: "编码"
            },
            "ClientName": {
                type: "text",
                label: "经销商"
            },
            usableIntegral: {
                type: "text",
                label: "可用积分"
            },
            isRedeem: {
                type: "options",
                options: {
                    "1": "可兑换",
                    "0": "不可兑换"
                }
            },
            storeName: {
                type: "text",
                label: "店铺"
            },
            goodsName: {
                type: "text",
                label: "产品"
            },
            memberName: {
                type: "text",
                label: "客户"
            },
            mId: {
                type: "ref",
                label: "商品",
                labelFields: "mName",
                dataProvider: "whz/bo/terminal",
                targetMethod: "getMatUrl",
                keyField: "_id"
            },
            terminalName: {
                type: "text",
                canEdit: false,
                label: "终端名称"
            },
            DetailAddress: {
                type: "text",
                canEdit: false,
                label: "终端地址"
            },
            gps: {
                type: "location",
                canEdit: false,
                label: "地理位置"
            },
            createAt: {
                type: "date",
                // canEdit:false,
                label: "建档日期"
            },
            foundingDate: {
                type: "date",
                canEdit: false,
                label: "成立日期"
            },
            lastTsDate: {
                type: "date",
                canEdit: false,
                label: "上次活跃日期"
            },
            hasApp: {
                type: "checkbox",
                canEdit: false,
                label: "是否启用APP"
            },
            canDeliver: {
                type: "checkbox",
                canEdit: false,
                label: "是否可配送"
            },
            lmfRealQty: {
                type: "text",
                canEdit: false,
                label: "本月进货量"
            },
            lmsRealQty: {
                type: "text",
                canEdit: false,
                label: "本月销售量"
            },
            groupField: {
                type: "options",
                label: "分组",
                options: {
                    "brandId": "品牌",
                    "series": "系列",
                    "mId": "产品"
                }
            }
        },
        getTGZDListUrl: function () {
            var userInfo = config.session && config.session.userInfo || {};
            return this.getBaseUrl1() + "/getPromotTerminal?shopId=" + this.getShopId() + "&empId=" + userInfo.empId;
        },
        onListClick: function (data, evt, widget) {
            if (config.session && config.session.userInfo) {
                config.session.userInfo.role = "mendiandianyuan";
                config.session.userInfo.organization = config.session.userInfo.organization || {};
                config.session.userInfo.organization.id = data.TerminalID;
                config.session.userInfo.organization.name = data.TerminalName;
                config.session.phone = data.TerminalCode;
                // 温晨光，推广和导购都要求注册时发送验证码，兑换时不需要
                config.session.userInfo.isVerify = 1; //data.isVerify;
                window.moveToView("main");
            }
        },
        getTGZDListQuery: function (params) {
            return {};
        },
        getBarYAxis: function (params) {
            console.log(params);
            var def = new Deferred();
            var result = [{
                axis: 'y',
                axisIndex: 0,
                data: []
            }];
            if (this.cacheBarData) {
                for (var index = 0; index < this.cacheBarData.length; index++) {
                    result[0].data.push(this.cacheBarData[index].eName);
                }
                this.cacheBarData = null;
                this.cacheBarYearData = null;
            }
            return def.resolve(result);
        },
        getBarData: function (params, widget, cqOptions) {
            console.log(params);
            var def = new Deferred();

            var result = {
                series1: [],
                series2: [],
                series3: [],
                series4: [],
                series5: [],
                series6: [],
                series7: []
            };
            widget.height = 10;
            if (this.cacheBarData) {
                for (var index = 0; index < this.cacheBarData.length; index++) {
                    result.series1.push(0);
                    result.series2.push({
                        value: this.cacheBarData[index].monthProgress,
                        label: {
                            show: true,
                            formatter: (this.cacheBarData[index].monthProgress / this.cacheBarData[index].monthTask * 100).toFixed(2) + "%",
                            color: "#999",
                            fontSize: 12
                        },
                        itemStyle: {
                            normal: {
                                barBorderRadius: 8,
                                color: this.cacheBarData[index].monthProgress >= this.cacheBarData[index].monthTask ? "#ff8201" : "#d95127"
                            }
                        }
                    });
                    result.series3.push({
                        value: 0,
                        label: {
                            show: true,
                            color: "#333",
                            fontSize: 16,
                            offset: [-5, 0],
                            position: "left",
                            formatter: this.cacheBarData[index].eName
                        }
                    });
                    result.series4.push(this.cacheBarData[index].monthTask);
                }
                widget.height = this.cacheBarData.length * 80 + 80;
            }
            if (this.cacheBarYearData) {
                for (var index = 0; index < this.cacheBarYearData.length; index++) {
                    result.series5.push(0);
                    result.series6.push({
                        value: this.cacheBarYearData[index].yearProgress,
                        label: {
                            show: true,
                            formatter: (this.cacheBarYearData[index].yearProgress / this.cacheBarYearData[index].yearTask * 100).toFixed(2) + "%",
                            color: "#999",
                            fontSize: 12
                        },
                        itemStyle: {
                            normal: {
                                barBorderRadius: 8,
                                color: this.cacheBarYearData[index].yearProgress >= this.cacheBarYearData[index].yearTask ? "#ff8201" : "#d95127"
                            }
                        }
                    });
                    result.series7.push(this.cacheBarYearData[index].yearTask);
                }
                widget.height = this.cacheBarData.length * 80 + 80;
            }
            widget.resize();
            return def.resolve(result);
        },
        getBarSeries: function () {
            var def = new Deferred();

            return def.resolve([{
                type: "bar",
                id: "series3",
                itemStyle: {
                    normal: {
                        color: "white"
                    }
                },
                barWidth: 20
            }, {
                type: "bar",
                id: "series1",
                stack: "stack1",
                itemStyle: {
                    normal: {
                        color: "blue",
                        barBorderRadius: 8
                    }
                },
                barWidth: 16,
                label: {
                    show: true,
                    formatter: function () {
                        return "月达成";
                    },
                    position: "left",
                    offset: [-10, 0],
                    color: '#666'
                }
            }, {
                type: "bar",
                id: "series2",
                stack: "stack1",
                barWidth: 16
            }, {
                type: "scatter",
                id: "series4",
                symbol: "rect",
                symbolOffset: [0, 3],
                symbolSize: [5, 20],
                itemStyle: {
                    normal: {
                        color: "#596a76"
                    }
                },
                tooltip: {
                    formatter: function (params) {
                        return "月总目标金额:" + params.value;
                    }
                }
            }, {
                type: "bar",
                id: "series5",
                stack: "stack2",
                itemStyle: {
                    normal: {
                        color: "blue",
                        barBorderRadius: 8
                    }
                },
                xAxisIndex: 1,
                barWidth: 16,
                label: {
                    show: true,
                    formatter: function () {
                        return "年达成";
                    },
                    position: "left",
                    offset: [-10, 0],
                    color: '#666'
                }
            }, {
                type: "bar",
                id: "series6",
                stack: "stack2",
                xAxisIndex: 1,
                barWidth: 16
            }, {
                type: "scatter",
                id: "series7",
                symbol: "rect",
                symbolOffset: [0, 25],
                symbolSize: [5, 20],
                xAxisIndex: 1,
                itemStyle: {
                    normal: {
                        color: "#596a76"
                    }
                },
                tooltip: {
                    formatter: function (params) {
                        return "年总目标金额:" + params.value;
                    }
                }
            }]);
        },
        brandListClicked: function (params, action, widget) {
            console.log(arguments);
            widget.onCqChanged(widget, params.data);
            query(".brandListChecked")[0].innerHTML = params.name;
        },
        getBrandData: function () {
            var def = new Deferred();
            return def.resolve({
                items: [{
                    name: "喜安智",
                    brandId: "1000000",
                    selected: true
                }, {
                    name: "喜安欣",
                    brandId: "1000002"
                }, {
                    name: "保健品",
                    brandId: "1000003"
                }]
            });
        },
        getTaskAndProgressData: function (params) {
            console.log(arguments);
            var def = new Deferred();
            var _this = this;

            /*var data = {item:{yearDictList:[{ramtTotal:9800,empId:145,
            empName:"宋继军",tamtTotal:15000},{ramtTotal:17365,empId:198,empName:"陈业武",tamtTotal:23264
            },{ramtTotal:12345,empId:199,empName:"张三",tamtTotal:54321}],monthDictList:[{ramtTotal:900,empId:145,empName:"宋继军",
            tamtTotal:1000},{ramtTotal:8888,empId:198,empName:"陈业武",tamtTotal:9009},{ramtTotal:1234,empId:199,
            empName:"张三",tamtTotal:4321},{ramtTotal:2345,empId:200,empName:"王五",tamtTotal:5432},{
            ramtTotal:3456,empId:201,empName:"赵六",tamtTotal:6543},{ramtTotal:4567,empId:202,empName:"一二三四",tamtTotal:7654
            },{ramtTotal:2345,empId:200,empName:"哈哈",tamtTotal:5432},{ramtTotal:6543,empId:201,empName:"哈哈哈",tamtTotal:3456
            },{ramtTotal:4567,empId:202,empName:"二哈",tamtTotal:7654}]}};*/
            var date = new Date();
            var result = {
                items: [{
                    yearTask: "0.00",
                    yearProgress: "0.00",
                    currMonth: date.getMonth() + 1,
                    monthTask: "0.00",
                    monthProgress: "0.00",
                    empData: [],
                    empYearData: []
                }]
            };
            var userInfo = config.session && config.session.userInfo || {};

            var obj = {
                year: date.getFullYear(),
                month: date.getMonth() + 1,
                empId: userInfo.empId || userInfo.userId
            };

            if (params["1"] && params["1"].brandId) {
                obj.brandId = params["1"].brandId;
            } else {
                return def.resolve(result);
            }

            xhr("GET", {
                url: config.dataOrigin1 + "/datacenter/getEmpPlanRate?params="
                    + JSON.stringify(obj),
                handleAs: "json",
                load: function (data) {
                    if (data && data.item && data.item.yearDictList && data.item.yearDictList.length) {
                        for (var index = 0; index < data.item.yearDictList.length; index++) {
                            if (data.item.yearDictList[index].empId == (userInfo.empId || userInfo.userId)) {
                                result.items[0].yearTask = data.item.yearDictList[index].tamtTotal.toFixed(2);
                                result.items[0].yearProgress = data.item.yearDictList[index].ramtTotal.toFixed(2);
                            } else {
                                result.items[0].empYearData.push({
                                    eName: data.item.yearDictList[index].empName,
                                    yearTask: data.item.yearDictList[index].tamtTotal,
                                    yearProgress: data.item.yearDictList[index].ramtTotal
                                });
                            }
                        }
                    }
                    if (data && data.item && data.item.monthDictList && data.item.monthDictList.length) {
                        for (var index = 0; index < data.item.monthDictList.length; index++) {
                            if (data.item.monthDictList[index].empId == (userInfo.empId || userInfo.userId)) {
                                result.items[0].monthTask = data.item.monthDictList[index].tamtTotal.toFixed(2);
                                result.items[0].monthProgress = data.item.monthDictList[index].ramtTotal.toFixed(2);
                            } else {
                                result.items[0].empData.push({
                                    eName: data.item.monthDictList[index].empName,
                                    monthTask: data.item.monthDictList[index].tamtTotal,
                                    monthProgress: data.item.monthDictList[index].ramtTotal
                                });
                            }
                        }
                    }
                    _this.cacheBarData = result.items[0].empData;
                    _this.cacheBarYearData = result.items[0].empYearData;
                    def.resolve(result);
                },
                error: function (err) {
                    _this.cacheBarData = result.items[0].empData;
                    _this.cacheBarYearData = result.items[0].empYearData;
                    def.resolve(result);
                }
            });

            return def;
        },
        getSummaryLayout: function () {
            return [{
                type: "form",
                fields: this.getFormItems([
                    "terminalName", "DetailAddress", "gps", "createAt", "foundingDate", "lastTsDate",
                    "hasApp", "canDeliver"
                ])
            }];
        },
        getOutQtyData: function (cqRefInfo, widget, dataOptions) {
            var def = new Deferred();
            var result = {
                series1: [{
                    name: "销量",
                    value: 0,
                    label: {
                        position: "inside"
                    },
                    itemStyle: {
                        color: "#2f4554"
                    },
                    labelType: "num"
                }],
                series2: [{
                    name: "销量",
                    value: 0,
                    label: {
                        position: "inside"
                    },
                    itemStyle: {
                        color: "green"
                    },
                    labelValue: '+0',
                    labelType: 'num'
                }]
            };
            var obj = {};
            var _this = this;
            if (!_this.cacheData) {
                _this.cacheData = {};
            }
            obj.terminalId = parseInt(window.location.hash.split('-')[1]);
            if (cqRefInfo.series && cqRefInfo.series._id && cqRefInfo.series._id != "0") {
                obj.groupId = cqRefInfo.series._id;
            }
            if (!_this.cacheData[obj.terminalId]) {
                _this.cacheData[obj.terminalId] = {};
            }
            if (_this.cacheData[obj.terminalId][obj.groupId || 0]) {
                var dt = _this.cacheData[obj.terminalId][obj.groupId || 0];
                result.series1[0].value = dt.llmsRealQty;
                if (dt.llmsRealQty == 0) {
                    result.series1[0].label.position = "left";
                }
                result.series2[0].value = dt.lmsRealQty;
                if (dt.lmsRealQty == 0) {
                    result.series2[0].label.position = "right";
                }
                result.series2[0].itemStyle.color
                    = dt.lmsRealQty > dt.llmsRealQty ? 'green' : 'red';
                result.series2[0].labelValue
                    = (dt.lmsRealQty >= dt.llmsRealQty ? "+" : "") + (dt.lmsRealQty - dt.llmsRealQty);
                return def.resolve(result);
            } else {
                xhr('GET', {
                    url: config.dataOrigin1 + '/datacenter/TerminalSta?params='
                        + JSON.stringify(obj),
                    handleAs: 'json',
                    load: function (data) {
                        var dt = {};
                        if (data && data.items && data.items[0]) {
                            dt = data && data.items && data.items[0];
                            dt.lmfRealQty = dt.lmfRealQty || 0;
                            dt.lmsRealQty = dt.lmsRealQty || 0;
                            dt.llmfRealQty = dt.llmfRealQty || 0;
                            dt.llmsRealQty = dt.llmsRealQty || 0;
                        }
                        _this.cacheData[obj.terminalId][obj.groupId || 0] = dt;
                        result.series1[0].value = dt.llmsRealQty;
                        if (dt.llmsRealQty == 0) {
                            result.series1[0].label.position = "left";
                        }
                        result.series2[0].value = dt.lmsRealQty;
                        if (dt.lmsRealQty == 0) {
                            result.series2[0].label.position = "right";
                        }
                        result.series2[0].itemStyle.color
                            = dt.lmsRealQty > dt.llmsRealQty ? 'green' : 'red';
                        result.series2[0].labelValue
                            = (dt.lmsRealQty >= dt.llmsRealQty ? "+" : "") + (dt.lmsRealQty - dt.llmsRealQty);
                        setTimeout(widget.resize(), 100);
                        def.resolve(result)
                    },
                    error: function (err) {
                        def.resolve(result);
                    }
                });
            }
            return def;
        },
        getInQtyData: function (cqRefInfo, widget, dataOptions) {
            var def = new Deferred();
            var result = {
                series1: [{
                    name: "进货",
                    value: 0,
                    label: {
                        position: "inside"
                    },
                    itemStyle: {
                        color: "#2f4554"
                    },
                    labelType: "num"
                }],
                series2: [{
                    name: "进货",
                    value: 0,
                    itemStyle: {
                        color: "green"
                    },
                    label: {
                        position: "inside"
                    },
                    labelValue: '+0',
                    labelType: 'num'
                }]
            };
            var obj = {};
            var _this = this;
            if (!_this.cacheData) {
                _this.cacheData = {};
            }
            obj.terminalId = parseInt(window.location.hash.split('-')[1]);
            if (cqRefInfo.series && cqRefInfo.series._id && cqRefInfo.series._id != "0") {
                obj.groupId = cqRefInfo.series._id;
            }
            _this.terminalId = obj.terminalId;
            _this.groupId = obj.groupId || 0;
            if (!_this.cacheData[obj.terminalId]) {
                _this.cacheData[obj.terminalId] = {};
            }
            if (_this.cacheData[obj.terminalId][obj.groupId || 0]) {
                var dt = _this.cacheData[obj.terminalId][obj.groupId || 0];
                result.series1[0].value = dt.llmfRealQty;
                if (dt.llmfRealQty == 0) {
                    result.series1[0].label.position = "left";
                }
                result.series2[0].value = dt.lmfRealQty;
                if (dt.lmfRealQty == 0) {
                    result.series2[0].label.position = "right";
                }
                result.series2[0].itemStyle.color
                    = dt.lmfRealQty > dt.llmfRealQty ? 'green' : 'red';
                result.series2[0].labelValue
                    = (dt.lmfRealQty >= dt.llmfRealQty ? "+" : "") + (dt.lmfRealQty - dt.llmfRealQty);
                return def.resolve(result);
            } else {
                xhr('GET', {
                    url: config.dataOrigin1 + '/datacenter/TerminalSta?params='
                        + JSON.stringify(obj),
                    handleAs: 'json',
                    load: function (data) {
                        var dt = {};
                        if (data && data.items && data.items[0]) {
                            dt = data && data.items && data.items[0];
                            dt.lmfRealQty = dt.lmfRealQty || 0;
                            dt.lmsRealQty = dt.lmsRealQty || 0;
                            dt.llmfRealQty = dt.llmfRealQty || 0;
                            dt.llmsRealQty = dt.llmsRealQty || 0;
                        }
                        _this.cacheData[obj.terminalId][obj.groupId || 0] = dt;
                        result.series1[0].value = dt.llmfRealQty;
                        if (dt.llmfRealQty == 0) {
                            result.series1[0].label.position = "left";
                        }
                        result.series2[0].value = dt.lmfRealQty;
                        if (dt.lmfRealQty == 0) {
                            result.series2[0].label.position = "right";
                        }
                        result.series2[0].itemStyle.color
                            = dt.lmfRealQty > dt.llmfRealQty ? 'green' : 'red';
                        result.series2[0].labelValue
                            = (dt.lmfRealQty >= dt.llmfRealQty ? "+" : "") + (dt.lmfRealQty - dt.llmfRealQty);
                        setTimeout(widget.resize(), 100);
                        def.resolve(result)
                    },
                    error: function (err) {
                        def.resolve(result);
                    }
                });
            }
            return def;
        },
        clickInQty: function (params, echart, widget) {
            var result = {
                series1: [{
                    name: "进货",
                    value: 0,
                    label: {
                        position: "inside"
                    },
                    itemStyle: {
                        color: "#2f4554"
                    }
                }],
                series2: [{
                    name: "进货",
                    value: 0,
                    itemStyle: {
                        color: "green"
                    },
                    label: {
                        position: "inside"
                    },
                    labelValue: '+0',
                    labelType: 'percent'
                }]
            };
            if (params.data.labelType == "num") {
                var dt = this.cacheData[this.terminalId][this.groupId];
                result.series1[0].value = dt.llmfRealQty;
                if (dt.llmfRealQty == 0) {
                    result.series1[0].label.position = "left";
                }
                result.series2[0].value = dt.lmfRealQty;
                if (dt.lmfRealQty == 0) {
                    result.series2[0].label.position = "right";
                }
                result.series2[0].itemStyle.color =
                    dt.lmfRealQty >= dt.llmfRealQty ? "green" : "red";
                result.series2[0].labelValue =
                    (dt.lmfRealQty >= dt.llmfRealQty ? "+" : "")
                    + (dt.llmfRealQty == 0 ? dt.lmfRealQty : (((dt.lmfRealQty - dt.llmfRealQty) / dt.llmfRealQty * 100).toFixed(2) + "%"));
                result.series2[0].labelType = 'percent';
                result.series1[0].labelType = 'percent';
            } else {
                var dt = this.cacheData[this.terminalId][this.groupId];
                result.series2[0].labelType = 'num';
                result.series1[0].labelType = 'num';
                result.series1[0].value = dt.llmfRealQty;
                if (dt.llmfRealQty == 0) {
                    result.series1[0].label.position = "left";
                }
                result.series2[0].value = dt.lmfRealQty;
                if (dt.lmfRealQty == 0) {
                    result.series2[0].label.position = "right";
                }
                result.series2[0].itemStyle.color
                    = dt.lmfRealQty > dt.llmfRealQty ? 'green' : 'red';
                result.series2[0].labelValue
                    = (dt.lmfRealQty >= dt.llmfRealQty ? "+" : "") + (dt.lmfRealQty - dt.llmfRealQty);
            }
            widget.setSeriesData(result);
        },
        clickOutQty: function (params, echart, widget) {
            var result = {
                series1: [{
                    name: "销量",
                    value: 0,
                    label: {
                        position: "inside"
                    },
                    itemStyle: {
                        color: "#2f4554"
                    }
                }],
                series2: [{
                    name: "销量",
                    value: 0,
                    itemStyle: {
                        color: "green"
                    },
                    label: {
                        position: "inside"
                    },
                    labelValue: '+0',
                    labelType: 'percent'
                }]
            };
            if (params.data.labelType == "num") {
                var dt = this.cacheData[this.terminalId][this.groupId];
                result.series1[0].value = dt.llmsRealQty;
                if (dt.llmsRealQty == 0) {
                    result.series1[0].label.position = "left";
                }
                result.series2[0].value = dt.lmsRealQty;
                if (dt.lmsRealQty == 0) {
                    result.series2[0].label.position = "right";
                }
                result.series2[0].itemStyle.color =
                    dt.lmsRealQty >= dt.llmsRealQty ? "green" : "red";
                result.series2[0].labelValue =
                    (dt.lmsRealQty >= dt.llmsRealQty ? "+" : "")
                    + (dt.llmsRealQty == 0 ? dt.lmsRealQty : (((dt.lmsRealQty - dt.llmsRealQty) / dt.llmsRealQty * 100).toFixed(2) + "%"));
                result.series2[0].labelType = 'percent';
                result.series1[0].labelType = 'percent';
            } else {
                var dt = this.cacheData[this.terminalId][this.groupId];
                result.series2[0].labelType = 'num';
                result.series1[0].labelType = 'num';
                result.series1[0].value = dt.llmsRealQty;
                if (dt.llmsRealQty == 0) {
                    result.series1[0].label.position = "left";
                }
                result.series2[0].value = dt.lmsRealQty;
                if (dt.lmsRealQty == 0) {
                    result.series2[0].label.position = "right";
                }
                result.series2[0].itemStyle.color
                    = dt.lmsRealQty > dt.llmsRealQty ? 'green' : 'red';
                result.series2[0].labelValue
                    = (dt.lmsRealQty >= dt.llmsRealQty ? "+" : "") + (dt.lmsRealQty - dt.llmsRealQty);
            }
            widget.setSeriesData(result);
        },
        inQtyAxisData: function () {
            var def = new Deferred();
            return def.resolve([{
                axis: 'x',
                axisIndex: 0,
                data: ['进货']
            }]);
        },
        OutQtyAxisData: function () {
            var def = new Deferred();
            return def.resolve([{
                axis: 'x',
                axisIndex: 0,
                data: ['销售']
            }]);
        },
        getInQtySeries: function () {
            var def = new Deferred();
            return def.resolve([{
                type: "bar",
                id: "series1",
                name: "上月进货",
                stack: "stack1",
                label: {
                    show: true,
                    formatter: '{c}'
                }
            }, {
                type: "bar",
                id: "series2",
                name: "本月进货",
                stack: "stack1",
                label: {
                    show: true,
                    formatter: function (params) {
                        return params.data.labelValue;
                    }
                }
            }]);
        },
        getOutQtySeries: function () {
            var def = new Deferred();
            return def.resolve([{
                type: "bar",
                id: "series1",
                name: "上月销售",
                stack: "stack1",
                label: {
                    show: true,
                    formatter: '{c}'
                }
            }, {
                type: "bar",
                id: "series2",
                name: "本月销售",
                stack: "stack1",
                label: {
                    show: true,
                    formatter: function (params) {
                        return params.data.labelValue;
                    }
                }
            }]);
        },
        getInQtyLineData: function (cqRefInfo, widget, dataOptions) {
            var def = new Deferred();
            var obj = {};
            obj.terminalId = parseInt(window.location.hash.split("-")[1]);
            if (cqRefInfo && cqRefInfo.series && cqRefInfo.series._id && cqRefInfo.series._id != 0) {
                obj.groupId = cqRefInfo.series._id;
            }
            var _this = this;
            if (!_this.lineCacheData) {
                _this.lineCacheData = {

                };
            }
            if (!_this.lineCacheData[obj.terminalId]) {
                _this.lineCacheData[obj.terminalId] = {};
            }
            if (_this.lineCacheData[obj.terminalId][obj.groupId || 0]
                && _this.lineCacheData[obj.terminalId][obj.groupId || 0].inQty) {
                return def.resolve(_this.lineCacheData[obj.terminalId][obj.groupId || 0].inQty);
            } else {
                _this.lineCacheData[obj.terminalId][obj.groupId || 0] = _this.lineCacheData[obj.terminalId][obj.groupId || 0] || {};
                _this.lineCacheData[obj.terminalId][obj.groupId || 0].inQty = {};
                xhr('GET', {
                    url: config.dataOrigin1 + '/datacenter/TerminalInOutTrend?params='
                        + JSON.stringify(obj),
                    handleAs: 'json',
                    load: function (data) {
                        var arr1 = [];
                        for (var index = 12; index > 0; index--) {
                            var date = new Date();
                            date.setMonth(date.getMonth() - index);
                            arr1.push(date.getFullYear() + "年" + (date.getMonth() + 1) + "月");
                        }
                        var arr = [];
                        for (var index = 0; index < data.items.length; index++) {
                            if (data.items[index].type == "Flow") {
                                arr.push(data.items[index]);
                            }
                        }
                        arr.sort(function (a, b) {
                            var m1 = new Date(a.month);
                            var m2 = new Date(b.month);
                            return m1.getFullYear() == m2.getFullYear() ? (m1.getMonth() - m2.getMonth()) : (m1.getFullYear() - m2.getFullYear());
                        });
                        var result = [];
                        for (var index = 0; index < arr1.length; index++) {
                            var val = 0;
                            for (var j = 0; j < arr.length; j++) {
                                var dt = new Date(arr[j].month);
                                if ((dt.getFullYear() + "年"
                                    + (dt.getMonth() + 1) + "月") == arr1[index]) {
                                    val = arr[j].realQty || 0;
                                    break;
                                }
                            }
                            result.push(val);
                        }
                        _this.lineCacheData[obj.terminalId][obj.groupId || 0].inQty.series1 = result;
                        setTimeout(widget.resize(), 100);
                        def.resolve({
                            series1: result
                        });
                    },
                    error: function (err) {
                        def.resolve({});
                    }
                });
            }
            return def;
        },
        getOutQtyLineData: function (cqRefInfo, widget, dataOptions) {
            var def = new Deferred();
            var obj = {};
            obj.terminalId = parseInt(window.location.hash.split("-")[1]);
            if (cqRefInfo && cqRefInfo.series && cqRefInfo.series._id && cqRefInfo.series._id != 0) {
                obj.groupId = cqRefInfo.series._id;
            }
            var _this = this;
            if (!_this.lineCacheData) {
                _this.lineCacheData = {

                };
            }
            if (!_this.lineCacheData[obj.terminalId]) {
                _this.lineCacheData[obj.terminalId] = {};
            }
            if (_this.lineCacheData[obj.terminalId][obj.groupId || 0]
                && _this.lineCacheData[obj.terminalId][obj.groupId || 0].outQty) {
                return def.resolve(_this.lineCacheData[obj.terminalId][obj.groupId || 0].outQty);
            } else {
                _this.lineCacheData[obj.terminalId][obj.groupId || 0] = _this.lineCacheData[obj.terminalId][obj.groupId || 0] || {};
                _this.lineCacheData[obj.terminalId][obj.groupId || 0].outQty = {};
                xhr('GET', {
                    url: config.dataOrigin1 + '/datacenter/TerminalInOutTrend?params='
                        + JSON.stringify(obj),
                    handleAs: 'json',
                    load: function (data) {
                        var arr1 = [];
                        for (var index = 12; index > 0; index--) {
                            var date = new Date();
                            date.setMonth(date.getMonth() - index);
                            arr1.push(date.getFullYear() + "年" + (date.getMonth() + 1) + "月");
                        }
                        var arr = [];
                        for (var index = 0; index < data.items.length; index++) {
                            if (data.items[index].type == "Sale") {
                                arr.push(data.items[index]);
                            }
                        }
                        arr.sort(function (a, b) {
                            var m1 = new Date(a.month);
                            var m2 = new Date(b.month);
                            return m1.getFullYear() == m2.getFullYear() ? (m1.getMonth() - m2.getMonth()) : (m1.getFullYear() - m2.getFullYear());
                        });
                        var result = [];
                        for (var index = 0; index < arr1.length; index++) {
                            var val = 0;
                            for (var j = 0; j < arr.length; j++) {
                                var dt = new Date(arr[j].month);
                                if ((dt.getFullYear() + "年"
                                    + (dt.getMonth() + 1) + "月") == arr1[index]) {
                                    val = arr[j].realQty || 0;
                                    break;
                                }
                            }
                            result.push(val);
                        }
                        _this.lineCacheData[obj.terminalId][obj.groupId || 0].outQty.series1 = result;
                        setTimeout(widget.resize(), 100);
                        def.resolve({
                            series1: result
                        });
                    },
                    error: function (err) {
                        def.resolve({});
                    }
                });
            }
            return def;
        },
        getLineSeries: function () {
            var def = new Deferred();
            return def.resolve([{
                id: "series1",
                type: 'line',
                name: "series1"
            }]);
        },
        inQtyLineFormatter: function (params) {
            return params[0].name + "进货" + params[0].value + "罐";
        },
        OutQtyLineFormatter: function (params) {
            return params[0].name + "销售" + params[0].value + "罐";
        },
        getLineCategory: function () {
            var def = new Deferred();
            var arr = [];
            for (var index = 12; index > 0; index--) {
                var date = new Date();
                date.setMonth(date.getMonth() - index);
                arr.push(date.getFullYear() + "年" + (date.getMonth() + 1) + "月");
            }
            return def.resolve([{
                axis: 'x',
                axisIndex: 0,
                data: arr
            }]);
        },
        getInQtyPieData: function (cqRefInfo, widget, dataOptions) {
            var def = new Deferred();
            var obj = {};
            obj.terminalId = parseInt(window.location.hash.split("-")[1]);
            if (cqRefInfo && cqRefInfo.series && cqRefInfo.series._id && cqRefInfo.series._id != 0) {
                obj.groupId = cqRefInfo.series._id;
            }
            var _this = this;
            if (!_this.pieCacheData) {
                _this.pieCacheData = {};
            }
            if (!_this.pieCacheData[obj.terminalId]) {
                _this.pieCacheData[obj.terminalId] = {};
            }
            if (_this.pieCacheData[obj.terminalId][obj.groupId || 0]
                && _this.pieCacheData[obj.terminalId][obj.groupId || 0].inQty) {
                return def.resolve(_this.pieCacheData[obj.terminalId][obj.groupId || 0].inQty);
            } else {
                _this.pieCacheData[obj.terminalId][obj.groupId || 0]
                    = _this.pieCacheData[obj.terminalId][obj.groupId || 0] || {};
                _this.pieCacheData[obj.terminalId][obj.groupId || 0].inQty = {};
                xhr('GET', {
                    url: config.dataOrigin1 + '/datacenter/TerminalInOutPie?params='
                        + JSON.stringify(obj),
                    handleAs: 'json',
                    load: function (data) {
                        var arr = [];
                        for (var index = 0; index < data.items.length; index++) {
                            if (data.items[index].type == "Flow") {
                                arr.push({
                                    name: data.items[index].name,
                                    value: data.items[index].realQty || 0
                                });
                            }
                        }
                        _this.pieCacheData[obj.terminalId][obj.groupId || 0].inQty.series1 = arr;
                        setTimeout(widget.resize(), 100);
                        def.resolve({
                            series1: arr
                        });
                    },
                    error: function (err) {
                        def.resolve({});
                    }
                });
                return def;
            }
        },
        getOutQtyPieData: function (cqRefInfo, widget, dataOptions) {
            var def = new Deferred();
            var obj = {};
            obj.terminalId = parseInt(window.location.hash.split("-")[1]);
            if (cqRefInfo && cqRefInfo.series && cqRefInfo.series._id && cqRefInfo.series._id != 0) {
                obj.groupId = cqRefInfo.series._id;
            }
            var _this = this;
            if (!_this.pieCacheData) {
                _this.pieCacheData = {};
            }
            if (!_this.pieCacheData[obj.terminalId]) {
                _this.pieCacheData[obj.terminalId] = {};
            }
            if (_this.pieCacheData[obj.terminalId][obj.groupId || 0]
                && _this.pieCacheData[obj.terminalId][obj.groupId || 0].outQty) {
                return def.resolve(_this.pieCacheData[obj.terminalId][obj.groupId || 0].outQty);
            } else {
                _this.pieCacheData[obj.terminalId][obj.groupId || 0]
                    = _this.pieCacheData[obj.terminalId][obj.groupId || 0] || {};
                _this.pieCacheData[obj.terminalId][obj.groupId || 0].outQty = {};
                xhr('GET', {
                    url: config.dataOrigin1 + '/datacenter/TerminalInOutPie?params='
                        + JSON.stringify(obj),
                    handleAs: 'json',
                    load: function (data) {
                        var arr = [];
                        for (var index = 0; index < data.items.length; index++) {
                            if (data.items[index].type == "Sale") {
                                arr.push({
                                    name: data.items[index].name,
                                    value: data.items[index].realQty || 0
                                });
                            }
                        }
                        _this.pieCacheData[obj.terminalId][obj.groupId || 0].outQty.series1 = arr;
                        setTimeout(widget.resize(), 100);
                        def.resolve({
                            series1: arr
                        });
                    },
                    error: function (err) {
                        def.resolve({});
                    }
                });
                return def;
            }
        },
        getPieSeries: function () {
            var def = new Deferred();
            return def.resolve([{
                type: 'pie',
                id: 'series1',
                label: {
                    position: "inside"
                },
                radius: '66%'
            }]);
        },
        inQtyPieFormatter: function (params) {
            return params.name + "进货" + params.value + "罐";
        },
        outQtyPieFormatter: function (params) {
            return params.name + "销售" + params.value + "罐";
        },
        getPieLegend: function (cqRefInfo, widget, dataOptions) {
            var def = new Deferred();
            var obj = {};
            obj.terminalId = parseInt(window.location.hash.split("-")[1]);
            if (cqRefInfo && cqRefInfo.series && cqRefInfo.series._id && cqRefInfo.series._id != 0) {
                obj.groupId = cqRefInfo.series._id;
            }
            var _this = this;
            if (!_this.pieLegendCacheData) {
                _this.pieLegendCacheData = {};
            }
            if (!_this.pieLegendCacheData[obj.terminalId]) {
                _this.pieLegendCacheData[obj.terminalId] = {};
            }
            if (_this.pieLegendCacheData[obj.terminalId][obj.groupId || 0]) {
                return def.resolve(_this.pieLegendCacheData[obj.terminalId][obj.groupId || 0]);
            } else {
                xhr('GET', {
                    url: config.dataOrigin1 + '/datacenter/TerminalInOutPie?params='
                        + JSON.stringify(obj),
                    handleAs: 'json',
                    load: function (data) {
                        var arr = [];
                        for (var index = 0; index < data.items.length; index++) {
                            if (arr.indexOf(data.items[index].name) < 0) {
                                arr.push(data.items[index].name);
                            }
                        }
                        _this.pieLegendCacheData[obj.terminalId][obj.groupId || 0] = arr;
                        def.resolve(arr);
                    },
                    error: function (err) {
                        def.resolve([]);
                    }
                });
                return def;
            }
        },
        getSummaryInfo: function (params) {
            var def = new Deferred();
            xhr('GET', {
                url: config.dataOrigin1 + "/datacenter/showData?params={\"modelName\":\"Terminal\","
                    + "\"queryParams\":{\"$and\":[{\"hasProperty\":{\"_id\":\""
                    + params.cqViewParam.params + "\"}}]}}",
                handleAs: "json",
                load: function (data) {
                    def.resolve(data && data.items && data.items[0] || {});
                },
                error: function (err) {
                    def.resolve({});
                }
            });
            return def;
        },
        getSeriesData: function (params) {
            var def = new Deferred();
            xhr('GET', {
                url: config.dataOrigin1 + "/datacenter/TerimalMatGroup?params={\"terminalId\":"
                    + params.cqViewParam.params + "}",
                handleAs: "json",
                load: function (data) {
                    def.resolve(data || {});
                },
                error: function (err) {
                    def.resolve({});
                }
            });
            return def;
        },
        getItemProp: function (item) {
            return item;
        },
        getInQtyLayout: function () {
            return [{
                type: "form",
                fields: this.getFormItems([
                    "lmfRealQty"
                ])
            }];
        },
        getQtyInfo: function (params) {
            var def = new Deferred();
            var obj = {};
            var _this = this;
            if (!_this.cacheData) {
                _this.cacheData = {};
            }
            obj.terminalId = parseInt(window.location.hash.split('-')[1]);
            if (params.series && params.series._id && params.series._id != "0") {
                obj.groupId = params.series._id;
            }
            if (!_this.cacheData[obj.terminalId]) {
                _this.cacheData[obj.terminalId] = {};
            }
            if (_this.cacheData[obj.terminalId][obj.groupId || 0]) {
                return def.resolve(_this.cacheData[obj.terminalId][obj.groupId || 0]);
            } else {
                xhr('GET', {
                    url: config.dataOrigin1 + '/datacenter/TerminalSta?params='
                        + JSON.stringify(obj),
                    handleAs: 'json',
                    load: function (data) {
                        var dt = {};
                        if (data && data.items && data.items[0]) {
                            dt = data && data.items && data.items[0];
                            dt.lmfRealQty = dt.lmfRealQty || 0;
                            dt.lmsRealQty = dt.lmsRealQty || 0;
                            dt.llmfRealQty = dt.llmfRealQty || 0;
                            dt.llmsRealQty = dt.llmsRealQty || 0;
                        }
                        _this.cacheData[obj.terminalId][obj.groupId || 0] = dt;
                        def.resolve(dt)
                    },
                    error: function (err) {
                        def.resolve({});
                    }
                });
            }
            return def;
        },
        getOutQtyLayout: function () {
            return [{
                type: "form",
                fields: this.getFormItems([
                    "lmsRealQty"
                ])
            }];
        },
        getMatUrl: function () {
            return config.dataOrigin1 + "/datacenter/showData?params={%22modelName%22:%22Mat%22}";
        },
        getMapData: function (cqRefInfo, widget, dataOptions) {
            var def = new Deferred();

            var data = {
                series1: [],
                series2: [],
                series3: [],
                series4: [],
                series5: []
            };

            if (cqRefInfo && cqRefInfo["cqViewParam"] && cqRefInfo["cqViewParam"].params) {
                // 终端数据
                var param = cqRefInfo["cqViewParam"].params;
                var clientId = parseInt(param.split("_")[0]);
                var mId = parseInt(param.split("_")[1]);
                var year = parseInt(param.split("_")[4]);
                var month = parseInt(param.split("_")[5]);

                var obj = {
                    mId: mId,
                    clientId: clientId,
                    year: year,
                    month: month
                };

                xhr("GET", {
                    url: config.dataOrigin1 + "/datacenter/clientSaleMat?params=" + JSON.stringify(obj),
                    handleAs: 'json',
                    load: function (zdData) {

                        data.series4.push({
                            value: [param.split("_")[2], param.split("_")[3]],
                            tooltip: {
                                formatter: ""
                            }
                        });

                        for (var index = 0; index < zdData.items.length; index++) {
                            zdData.items[index].gps && data.series5.push({
                                terminalName: zdData.items[index].terminalName,
                                terminalId: zdData.items[index].terminalId,
                                itemStyle: {
                                    color: zdData.items[index].saleQty > 0 ? "#2d9700" : "#4ba7f8"
                                },
                                value: zdData.items[index].gps.split(",").concat(zdData.items[index].saleQty || 0)
                            });
                            if (zdData.items[index].flowQty > 0) {
                                data.series2.push({
                                    coords: [[param.split("_")[2], param.split("_")[3]], zdData.items[index].gps.split(",")]
                                });
                            }
                        }

                        data.series3 = data.series2;
                        widget.bmap.zoom = 7;
                        widget.bmap.maxZoom = 9;
                        widget.bmap.minZoom = 7;
                        widget.bmap.center = [param.split("_")[2], param.split("_")[3]];
                        def.resolve(data);
                        //var bmap = widget.echart.getModel().getComponent('bmap').getBMap();
                        //setTimeout(function(){
                        //    bmap.setZoom(7);
                        //    bmap.setMinZoom(7);
                        //    bmap.setMaxZoom(9);
                        //bmap.setCenter([param.split("_")[2],param.split("_")[3]]);
                        //}, 200);
                    },
                    error: function (err) {
                        def.resolve(data);
                    }
                });
            } else if (cqRefInfo && cqRefInfo["1"] && !cqRefInfo["cqViewParam"].params
                && cqRefInfo["1"].month && cqRefInfo["1"].mId && cqRefInfo["1"].mId._id) {
                // 经销商数据
                var date = new Date(cqRefInfo["1"].month);
                var year = date.getFullYear();
                var month = date.getMonth() + 1;
                var obj = {
                    year: year,
                    month: month,
                    mId: cqRefInfo["1"].mId._id
                };
                xhr("GET", {
                    url: config.dataOrigin1 + "/datacenter/clientRepertory?params=" + JSON.stringify(obj),
                    handleAs: "json",
                    load: function (crData) {

                        for (var index = 0; index < crData.items.length; index++) {
                            var rate = (crData.items[index].endQty && crData.items[index].endQty > 0) ? (crData.items[index].outQty / crData.items[index].endQty) : 0;
                            crData.items[index].gps && data.series1.push({
                                mId: cqRefInfo["1"].mId._id,
                                clientId: crData.items[index].clientId,
                                clientName: crData.items[index].clientName,
                                year: year,
                                month: month,
                                value: [crData.items[index].gps.split(",")[0], crData.items[index].gps.split(",")[1], crData.items[index].inQty || 0, crData.items[index].outQty || 0, crData.items[index].endQty || 0, rate]
                            });
                            if (crData.items[index].inQty > 0) {
                                data.series2.push({
                                    coords: [[113.5107, 23.2196], crData.items[index].gps.split(",")]
                                });
                            }
                        }
                        data.series3 = data.series2;
                        widget.bmap.zoom = 5;
                        widget.bmap.maxZoom = 7;
                        widget.bmap.minZoom = 5;
                        widget.bmap.center = [104.73, 31.48];

                        def.resolve(data);
                    },
                    error: function (err) {
                        def.resolve(data);
                    }
                });

            } else {
                if (cqRefInfo && cqRefInfo["1"] && !cqRefInfo["1"].month) {
                    alert("日期必须选择");
                }
                if (cqRefInfo && cqRefInfo["1"] && !cqRefInfo["1"].mId) {
                    alert("商品必须选择");
                }
                return def.resolve({});
            }
            return def;
        },
        getMapSeries: function () {
            var def = new Deferred();
            return def.resolve([{
                id: "series1",
                type: 'effectScatter',
                coordinateSystem: 'bmap',
                zlevel: 3,
                rippleEffect: {
                    brushType: 'stroke'
                },
                symbolSize: function (val) {
                    return (val[4] / 50) > 25 ? 25 : ((val[4] / 50) < 5 ? 5 : (val[4] / 50));
                },
                label: {
                    normal: {
                        show: false,
                        color: 'black',
                        position: 'right',
                        formatter: function (params) {
                            return params.data.clientName || params.data.terminalName;
                        }
                    }
                }
            }, {
                id: "series2",
                type: "lines",
                zlevel: 1,
                coordinateSystem: "bmap",
                effect: {
                    show: true,
                    period: 5,
                    trailLength: 0.7,
                    color: '#4ba7f8',
                    symbolSize: 5
                },
                lineStyle: {
                    normal: {
                        color: {
                            type: 'linear',
                            x: 0,
                            y: 0,
                            x2: 1,
                            y2: 0,
                            colorStops: [{
                                offset: 0, color: '#007d38' // 0% 处的颜色
                            }, {
                                offset: 1, color: '#0071b6' // 100% 处的颜色
                            }],
                            globalCoord: false // 缺省为 false
                        },
                        width: 0,
                        curveness: 0.2
                    }
                }
            }, {
                type: 'lines',
                id: 'series3',
                zlevel: 2,
                coordinateSystem: 'bmap',
                symbol: ['none', 'arrow'],
                symbolSize: 10,
                effect: {
                    show: true,
                    period: 5,
                    trailLength: 0,
                    symbol: this.planePath,
                    symbolSize: 15
                },
                lineStyle: {
                    normal: {
                        color: {
                            type: 'linear',
                            x: 0,
                            y: 0,
                            x2: 1,
                            y2: 0,
                            colorStops: [{
                                offset: 0, color: '#007d38' // 0% 处的颜色
                            }, {
                                offset: 1, color: '#0071b6' // 100% 处的颜色
                            }],
                            globalCoord: false // 缺省为 false
                        },
                        width: 3,
                        opacity: 0.6,
                        curveness: 0.2
                    }
                }
            }, {
                type: "scatter",
                id: "series4",
                coordinateSystem: "bmap",
                symbol: "pin",
                symbolSize: 25,
                zlevel: 4
            }, {
                id: "series5",
                type: 'effectScatter',
                coordinateSystem: 'bmap',
                zlevel: 3,
                rippleEffect: {
                    brushType: 'stroke'
                },
                symbolSize: function (val) {
                    return (val[2] / 20) > 25 ? 25 : ((val[2] / 20) < 5 ? 5 : (val[2] / 20));
                },
                label: {
                    normal: {
                        show: false,
                        color: 'black',
                        position: 'right',
                        formatter: function (params) {
                            return params.data.terminalName;
                        }
                    }
                }
            }]);
        },
        mapFormatter: function (params, echart) {
            if (params.seriesId == "series1") {
                return params.data.clientName + "<br/>" + "进:" + params.data.value[2] + ",销:"
                    + params.data.value[3] + ",存:" + params.data.value[4]
                    + "<br/>"
                    + "<input type='button' value='终端' onclick='window.moveToView(\"map\", \""
                    + params.data.clientId + "_" + params.data.mId + "_"
                    + params.data.value[0] + "_" + params.data.value[1] + "_"
                    + params.data.year + "_" + params.data.month + "\");'>";
            } else if (params.seriesId == "series5") {
                return params.data.terminalName + "<br/>"
                    + "<input type='button' value='详情' onclick='window.moveToView(\"terminalSummary\",\""
                    + params.data.terminalId + "\")'>";
            } else {
                return "";
            }
        },
        clickMap: function (params, echart, widget) {
            if (params.seriesId == "series4") {
                window.moveToView("map");
            }
        },
        initMapLayout: function () {
            var data = {};
            var date = new Date();
            date.setDate(1);
            date.setMonth(date.getMonth() - 1);
            data.month = date.toISOString();
            return data;
        },
        getMapLayout: function () {
            return [{
                type: "form",
                fields: this.getFormItems([
                    "mId", "month"
                ])
            }];
        },
        loadTerminalFlowDetail: function () {
            return config.dataOrigin1 + "/datacenter/terminalFlowDetail";
        },
        terminalFlowDetailQuery: function (params) {
            var query = {};
            var userInfo = config.session && config.session.userInfo || {};
            query.empId = userInfo.empId || userInfo.userId;
            query.createAtf = this.createAtf;
            query.createAtt = this.createAtt;
            var mid = window.location.hash.split("-")[1];
            query.mId = mid;
            query.orderByParms = [{ "fieldName": "createAt", "sortType": 0 }];
            return { params: JSON.stringify(query) };
        },
        getTerminalFlowDetailItemPro: function (item) {
            return item;
        },
        getTerminalOutputLayout: function () {
            return [{
                type: "form",
                fields: this.getFormItems(["month"])
            }];
        },
        initTerminalOutputLayout: function () {
            var data = {};
            var date = new Date();
            date.setMonth(date.getMonth() - 1);
            date.setDate(1);
            data.month = date.toISOString();
            return data;
        },
        initTerminalFlowLayout: function (params) {
            console.log(params);
            var data = {};
            var datef = new Date();
            datef.setMonth(datef.getMonth() - 1);
            datef.setDate(1);
            var datet = new Date();
            datet.setDate(0);
            data.brandId = data.brandId || "1000000";
            data.createAtf = datef.toISOString();
            data.createAtt = datet.toISOString();
            data.groupField = "brandId";
            return data;
        },
        getTerminalFlowLayout: function (params) {
            console.log(params);
            return [{
                type: "form",
                fields: this.getFormItems(["createAt", "brandId", "groupField"])
            }];
        },
        loadTerminalFlow: function (params) {
            return config.dataOrigin1 + "/datacenter/terminalFlow"
        },
        terminalFlowQuery: function (params) {
            if (!params["1"]) {
                return;
            }
            if (params["1"] && !params["1"].createAtf) {
                alert("日期从必填");
                return;
            }
            if (params["1"] && !params["1"].createAtt) {
                alert("日期到必填");
                return;
            }
            var query = {
            };
            if (params["1"] && params["1"].createAtf) {
                query.createAtf = params["1"].createAtf;
                this.createAtf = params["1"].createAtf;
            }
            if (params["1"] && params["1"].createAtt) {
                var date = new Date(params["1"].createAtt);
                date.setDate(1);
                date.setMonth(date.getMonth() + 1);
                query.createAtt = date.toISOString();
                this.createAtt = date.toISOString();
            }
            if (params["1"] && params["1"].brandId) {
                query.brandId = params["1"].brandId;
            }
            if (params["1"] && params["1"].groupField) {
                query.groupField = params["1"].groupField;
                this.queryType = params["1"].groupField;
            }
            query.orderByParms = [
                { "fieldName": "brandId", "sortType": 0 },
                { "fieldName": "mName", "sortType": 0 }
            ];
            var userInfo = config.session && config.session.userInfo || {};
            query.empId = userInfo.empId || userInfo.userId;
            return { params: JSON.stringify(query) };
        },
        terminalFlowClicked: function (params) {
            if (this.queryType == "mId" && params.mId) {
                window.moveToView("terminalFlowDetail", params.mId);
            }
        },
        getTerminalFlowItemPro: function (item) {
            if (item.brandName) {
                item.mName = item.brandName;
            }
            if (item.seriesName) {
                item.mName = item.seriesName;
            }
            return item;
        },
        //加载商品相关接口
        getLoadGoodsUrl: function () {
            return this.getBaseUrl() + "?method=" + encodeURIComponent("nepbaby.goods.goods.batchquery");
        },

        //初始化字段options
        initOptions: function () {
            this.fields.storeId.options = {};
            this.fields.subEmpId.options = {};
            var info = consumer.getCurrentUserFromSession(), options;
            if (info.role === "mendiandianyuan" ||
                info.role === "mendianguanliyuan" ||
                info.role === "liansuozongbu") {
                return;
            } else if (info.role === "yewudaibiao") {
                options = this.fields.storeId.options;
                return this.exec1("loadByEmp", {}).then(function (result) {
                    if (result && result.items) {
                        result.items.forEach(function (doc) {
                            options[doc.TerminalID] = doc.TerminalName;
                        });
                    }
                });
            } else {
                options = this.fields.subEmpId.options;
                return this.exec1("loadSubEmp", {}).then(function (result) {
                    if (result && result.items) {
                        result.items.forEach(function (doc) {
                            options[doc.EmpID] = doc.EmpName;
                        });
                    }
                });
            }
        },
        // 初始化门店列表
        initOptions1: function () {
            var options = this.fields.storeId.options;
            return this.exec1("loadByEmp", {}).then(function (result) {
                if (result && result.items) {
                    result.items.forEach(function (doc) {
                        options[doc.TerminalID] = doc.TerminalName;
                    });
                }
            });
        },

        loadByEmp: function (params) {
            return this.exec1('loadByEmp', params);
        },
        load: function () {
            return this.getBaseUrl1() + "/loadByEmp?shopId=" + this.getShopId();
        },
        getListUrl: function () {
            var userInfo = config.session && config.session.userInfo || {};
            return this.getBaseUrl1() + "/loadByEmp?shopId=" + this.getShopId() + "&empId=" + userInfo.empId;
        },

        //业务员门店查询
        ListQuery: function (params) {
            //var userInfo = consumer.getCurrentUserFromSession();
            var userInfo = config.session && config.session.userInfo || {};
            var query = {
                withIntegral: true,
                empId: userInfo.empId
            };
            if (params && params.search) {
                query.search = params.search;
            }
            return query;
        },
        getItemPro: function (item) {
            //可能会修改可兑换
            item.exchange = "可兑换";
            return item;
        },

        //
        setTimeAndMat: function () {
            var dateTime = new Date();
            return {
                startTime: dateTime.toISOString(),
                goodsId: ""
            };
        },
        terminalOutput: function (params) {
            var def = new Deferred();
            if (!params["1"]) {
                return def.resolve({ terminalOutput: [] });
            }
            if (params["1"] && !params["1"].month) {
                alert("必须选择月份");
                return def.resolve({ terminalOutput: [] });
            }
            //if(params["1"]&&!params["1"].brandId){
            //    alert("必须选择品牌");
            //    return def.resolve({terminalOutput:[]});
            //}
            var _this = this;
            var date = new Date();
            date.setMonth(date.getMonth() - 1);
            var month = params["1"] && params["1"].month || (date.toISOString());
            date = new Date(month);
            var year = date.getFullYear();
            this.terminalYear = year;
            this.terminalMonth = date.getMonth() + 1;
            this.terminalBrandId = params["1"] && params["1"].brandId || "";
            var userInfo = config.session && config.session.userInfo || {};
            var obj = {
                empId: userInfo.empId || userInfo.userId,
                year: this.terminalYear,
                month: this.terminalMonth,
                brandId: this.terminalBrandId
            }
            xhr('GET', {
                url: config.dataOrigin1 + '/datacenter/terminalOutput?params='
                    + JSON.stringify(obj),
                handleAs: 'json',
                load: function (data) {
                    var result = [];
                    _this.terminalOutputLegend = [];
                    for (var index = 0; index < data.items.length; index++) {
                        result.push({
                            name: data.items[index].brandName,
                            brandId: data.items[index].brandId,
                            value: parseFloat(data.items[index].avg.toFixed(2)),
                            sum: data.items[index].sum
                        });
                        _this.terminalOutputLegend.push(data.items[index].brandName);
                    }
                    def.resolve({ terminalOutput: result });
                },
                error: function (err) {
                    def.resolve({ terminalOutput: [] });
                }
            });
            return def;
        },
        loadTerminalOut: function (params) {
            return config.dataOrigin1 + "/datacenter/terminalOutput";
        },
        terminalOutQuery: function (params) {
            var userInfo = config.session && config.session.userInfo || {};
            var query = {
                empId: userInfo.empId || userInfo.userId
            };
            if (params["1"].month) {
                var date = new Date(params["1"].month);
                query.year = date.getFullYear();
                query.month = date.getMonth() + 1;
                this.terminalYear = date.getFullYear();
                this.terminalMonth = date.getMonth() + 1;
            } else {
                alert("必须选择月份");
                return;
            }
            return { params: JSON.stringify(query) };
        },
        getTerminalOutItemPro: function (item) {
            item.avg = item.avg.toFixed(2);
            return item;
        },
        terminalOutputClicked: function (params) {
            window.moveToView("terminalOutputList", "y_" + this.terminalYear
                + "_m_" + this.terminalMonth + "_b_" + params.data.brandId);
        },
        getTerminalOutputSeries: function () {
            var def = new Deferred();
            return def.resolve([{
                id: 'terminalOutput',
                name: 'terminalOutput',
                type: 'pie',
                center: ['50%', '40%'],
                radius: '60%',
                label: {
                    position: 'inside',
                    formatter: function (params) {
                        return params.name + ":" + params.value;
                    }
                }
            }]);
        },
        terminalOutputFormatter: function (params) {
            return params.name + "<br/>总产出:" + params.data.sum + "<br/>门店总数:" + params.data.count + "<br/>平均产出:" + params.value;
        },
        terminalOutputPieClicked: function (params, echart, widget) {
            window.moveToView('terminalOutputList', "y_" + this.terminalYear
                + "_m_" + this.terminalMonth + "_b_" + params.data.brandId);
        },
        getTerminalOutputLegend: function () {
            var def = new Deferred();
            return def.resolve(this.terminalOutputLegend);
        },
        // 终端状态分析查询条件
        getTerminalActiveStutasLayout: function () {
            var fields = ['brandId', 'month'];

            return [{
                type: "form",
                fields: this.getFormItems(fields)
            }];
        },
        initTerminalActiveStatusLayout: function (cqRefInfo) {
            var data = {};
            var date = new Date();
            date.setMonth(date.getMonth() - 1);
            date.setDate(1);
            data.brandId = data.brandId || "1000000";
            data.month = date.toISOString();
            return data;
        },
        terminalPieClicked: function (params, echart, widget) {
            //console.log(params);
            //console.log(echart);
            //console.log(widget);
            window.moveToView('empStoreList', 'm_' + this.terminalMonth
                + '_b_' + this.terminalBrandId + '_s_' + params.data.statusCode
                + "_y_" + this.terminalYear);
        },
        getTerminalActiveStutas: function (params) {
            var def = new Deferred();
            if (!params["1"]) {
                return def.resolve({ TerminalActiveStatus: [] });
            }
            if (params["1"] && !params["1"].month) {
                alert("必须选择月份");
                return def.resolve({ TerminalActiveStatus: [] });
            }
            if (params["1"] && !params["1"].brandId) {
                alert("必须选择品牌");
                return def.resolve({ TerminalActiveStatus: [] });
            }
            var _this = this;
            var date = new Date();
            date.setMonth(date.getMonth() - 1);
            var month = params["1"] && params["1"].month || (date.toISOString());
            date = new Date(month);
            var year = date.getFullYear();
            this.terminalYear = year;
            this.terminalMonth = date.getMonth() + 1;
            this.terminalBrandId = params["1"] && params["1"].brandId || "";
            var userInfo = config.session && config.session.userInfo || {};
            var obj = {
                empId: userInfo.empId || userInfo.userId,
                year: this.terminalYear,
                month: this.terminalMonth
            }
            if (this.terminalBrandId) {
                obj.brandId = parseInt(this.terminalBrandId);
            }
            xhr('GET', {
                url: config.dataOrigin1 + '/datacenter/getTerminalActiveStatus?params='
                    + JSON.stringify(obj),
                handleAs: 'json',
                load: function (data) {
                    var result = [];
                    var terminalLegend = [];
                    var all = 0;
                    for (var index = 0; index < data.items.length; index++) {
                        var key = data.items[index].status;
                        result.push({
                            name: (key == 10 ? "活跃" : (key == 20 ? "休眠" : "沉睡")),
                            statusCode: key,
                            value: data.items[index].count
                        });
                        all += data.items[index].count;
                    }
                    for (var index = 0; index < data.items.length; index++) {
                        var key = data.items[index].status;
                        var legend = (key == 10 ? "活跃" : (key == 20 ? "休眠" : "沉睡"))
                            + "-" + (data.items[index].count / all * 100).toFixed(2) + "%";
                        terminalLegend.push(legend);
                        result[index].name = legend;
                    }
                    _this.terminalLegend = terminalLegend;
                    def.resolve({ TerminalActiveStatus: result });
                },
                error: function (err) {
                    def.resolve({ TerminalActiveStatus: [] });
                }
            });
            return def;
        },
        getTerminalLegend: function () {
            var def = new Deferred();
            return def.resolve(this.terminalLegend);
        },
        formatter: function (params) {
            return params.name.split('-')[0] + "<br/>" + params.value;
        },
        getTerminalActiveStatusSeries: function () {
            var def = new Deferred();
            return def.resolve([{
                id: 'TerminalActiveStatus',
                name: 'TerminalActiveStatus',
                type: 'pie',
                center: ['50%', '40%'],
                radius: '60%',
                label: {
                    position: 'inside',
                    formatter: function (params) {
                        return params.name.split("-")[0] + ":" + params.value;
                    }
                }
            }]);
        },
        loadTerminalOutput: function () {
            var params = window.location.hash;
            params = params.split("-")[1];
            params = params.split("_");
            var userInfo = config.session && config.session.userInfo || {};
            var obj = {
                empId: userInfo.empId || userInfo.userId,
                year: params[1],
                month: params[3],
                brandId: parseInt(params[5]),
                orderByParms: [{ "fieldName": "qty", "sortType": this.sortMethod || 0 }]
            };
            return config.dataOrigin1 + '/datacenter/terminalOutputDetail?'
                + 'params=' + JSON.stringify(obj);
        },
        loadTerminal: function () {
            var params = window.location.hash;
            params = params.split("-")[1];
            params = params.split("_");
            // console.log(params);
            var userInfo = config.session && config.session.userInfo || {};
            var obj = {
                empId: userInfo.empId || userInfo.userId,
                year: params[7],
                month: params[1],
                brandId: parseInt(params[3]),
                status: params[5],
                orderByParms: [{ "fieldName": "lastTsDate", "sortType": 0 }]
            };
            return config.dataOrigin1 + '/datacenter/getTerminal?'
                + 'params=' + JSON.stringify(obj);
        },
        terminalOutputQuery: function (params) {
            var userInfo = config.session && config.session.userInfo || {};
            var query = {
                empId: userInfo.empId || userInfo.userId
            };
            return query;
        },
        terminalQuery: function (params) {
            //console.log("terminalQuery=====");
            //console.log(params);
            //var userInfo = consumer.getCurrentUserFromSession();
            var userInfo = config.session && config.session.userInfo || {};
            var query = {
                empId: userInfo.empId || userInfo.userId
            };
            return query;
        },
        getTerminalOutputItemPro: function (item) {
            // item.time = this.terminalYear + "年" + this.terminalMonth + "月";
            item.qty = item.qty.toFixed(2);
            return item;
        },
        getTerminalItemPro: function (item) {
            //console.log("getTerminalItemPro===");
            //console.log(item);
            return item;
        },
        //销售分析报表的查询条件
        getQueryLayoutForSale: function () {
            var fields = ["brandName", "goodsId", "createAt"];
            var info = consumer.getCurrentUserFromSession();
            if (info.role === "yewudaibiao") {
                fields.push("storeId");
            } else if (info.role === "jingli") {
                fields.push("subEmpId");
            }
            return [{
                type: "form",
                fields: this.getFormItems(fields)
            }];
        },
        //销售分析查询条件初始化
        initSaleQueryLayout: function (cqRefInfo) {
            var data = {
                createAtt: date.newDateISOString()
            };
            data.brandName = data.brandName || "喜安欣";
            if (!data.createAtf) {
                var d = new Date(data.createAtt);
                d.setMonth(d.getMonth() - 1);
                d.setDate(d.getDate() + 1);
                data.createAtf = d.toISOString();
            }
            return data;
        },
        //销售分析查询条件的接口
        getSaleRptData: function (cqRef, widget, dataOptions) {
            var params = this.getQueryParams(cqRef);
            if (!params) {
                return ;
            }
            if (!params.brandName) {
                alert("品牌不能为空");
                return;
            }
            params.pageSize = 1000;
            params.pageIndex = 0;
            params.brandname = params.brandName;
            delete params.brandName;
            if (params.goodsId && params.goodsId.length) {
                params.goodsIds = params.goodsId.map(function (value) {
                    return value.id;
                });
                delete params.goodsId;
            }
            if (params.makeDatet) {
                params.endDate = params.makeDatet;
                delete params.makeDatet;
            }
            if (params.makeDatef) {
                params.beginDate = params.makeDatef;
                delete params.makeDatef;
            }
            if (!params) {
                return params;
            }
            return this.exec("nepbaby.product.report.batchquery", params);
            //return this.exec1("loadSaleRpt",params);
        },
        //点击客户数量之后客户数量列表接口
        getSaleLogForSaleRpt: function (cqRef, widget, dataOptions) {
            var params = this.getRptedQueryParams(cqRef, widget, dataOptions);
            if (!params) {
                return false;
            }
            if (!params.qtyType) {
                return false;
            }
            if (!params.goodsId) {
                return false;
            }
            return this.exec1("loadSaleByType", params);
        },

        //客户分析查询条件结构
        getQueryLayoutForCustomerRpt: function () {
            var fields = ["brandName", "goodsId", "makeDate"];
            var info = consumer.getCurrentUserFromSession();
            if (info.role === "yewudaibiao") {
                fields.push("storeId");
            } else if (info.role === "jingli") {
                fields.push("subEmpId");
            }
            return [{
                type: "form",
                fields: this.getFormItems(fields)
            }];
        },
        //客户分析查询条件初始化
        initConsumerQueryLayout: function (cqRefInfo) {
            var data = {
                makeDatet: date.newDateISOString(),
                brandName: "喜安智"
            };
            if (!data.makeDatef) {
                var d = new Date(data.makeDatet);
                d.setMonth(d.getMonth() - 1);
                d.setDate(d.getDate() + 1);
                data.makeDatef = d.toISOString();
            }
            return data;
        },
        getQueryParams: function (cqRef) {
            if (!cqRef.search) {
                alert("请选择查询条件");
                return false;
            }
            var params = {};
            if (cqRef.search.makeDatef && cqRef.search.makeDatet) {
                params.makeDatef = cqRef.search.makeDatef;
                params.makeDatet = cqRef.search.makeDatet;
            } else if (cqRef.search.createAtf && cqRef.search.createAtt) {
                params.makeDatef = cqRef.search.createAtf;
                params.makeDatet = cqRef.search.createAtt;
            } else {
                alert("请选择月份或日期");
                return false;
            }
            if (cqRef.search.goodsId) {
                params.goodsId = cqRef.search.goodsId;
                if (params.goodsId && typeof (params.goodsId) == "string" && params.goodsId.indexOf(",") > -1) {
                    params.goodsId = params.goodsId.split(",");
                }
            }
            if (cqRef.search.storeId) {
                params.storeId = cqRef.search.storeId;
            }
            var info = consumer.getCurrentUserFromSession();
            if (info.role !== "yewudaibiao" && info.role !== "jingli") {
                //门店要携带门店信息
                params.storeId = info.organization.id;
            }
            if (info.postName) {
                params.postName = info.postName;
                params.empId = info.empId;
            }
            if (cqRef.search.brandName) {
                params.brandName = cqRef.search.brandName;
            }
            if (cqRef.search.subEmpId) {
                params.currencyId = cqRef.search.subEmpId;
            }
            return params;
        },
        getRptedQueryParams: function (cqRef, widget, dataOptions) {
            var params = this.getQueryParams(cqRef);
            if (!params) {
                return params;
            }
            if (!cqRef.rpt) {
                return false;
            }
            for (var k in cqRef.rpt) {
                if (cqRef.rpt[k].field === "tp") {
                    params.tp = cqRef.rpt[k].value;
                } else if (cqRef.rpt[k].field === "goodsId") {
                    params.goodsId = cqRef.rpt[k].value;
                    if (params.goodsId && typeof (params.goodsId) == "string" && params.goodsId.indexOf(",") > -1) {
                        params.goodsId = params.goodsId.split(",");
                    }
                } else {
                    params.qtyType = cqRef.rpt[k].field;
                }
            }
            if (!(params.tp || params.goodsId)) {
                return false;
            }
            if (!params.qtyType) {
                return false;
            }
            return params;
        },
        //读取月度会员报表数据
        getConsumerRptData: function (cqRef, widget, dataOptions) {
            var params = this.getQueryParams(cqRef);
            if (!params) {
                return;
            }
            if (!params.brandName) {
                alert("品牌不能为空");
                return;
            }
            params.pageSize = 1000;
            params.pageIndex = 0;
            params.brandname = params.brandName;
            delete params.brandName;
            if (params.goodsId && params.goodsId.length) {
                params.goodsIds = params.goodsId.map(function (value) {
                    return value.id;
                });
                delete params.goodsId;
            }
            if (params.makeDatet) {
                params.endDate = params.makeDatet;
                delete params.makeDatet;
            }
            if (params.makeDatef) {
                params.beginDate = params.makeDatef;
                delete params.makeDatef;
            }
            //20187/17徐阿雪 如果是内部人员，查询添加职务和员工id字段
            var userInfo = {};
            if (config.session && config.session.userInfo)
                userInfo = config.session.userInfo;
            if (userInfo.postName && userInfo.empId) {
                params.postName = userInfo.postName;
                params.empId = userInfo.empId;
            }
            if (!params) {
                return params;
            }
            //return this.exec1("loadCustomerRpt",params);
            return this.exec("nepbaby.member.report.batchquery", params);
        },
        //点击客户数量之后客户数量列表接口
        getCustNumForCustRpt: function (cqRef, widget, dataOptions) {
            var params = this.getRptedQueryParams(cqRef, widget, dataOptions);
            if (!params) {
                return false;
            }
            if (!params.qtyType) {
                return false;
            }
            return this.exec1("loadMemberByType", params);
        },







        //加载顾客分析表格的客户明细
        getCustRptForSale: function (refInfo, widget) {
            return false;
            var params = {
            };
            if (!refInfo) {
                return [];
            }
            if (refInfo.search) {
                //如果业务员没有选择终端，则查询全部可看终端
                if (refInfo.search.terminal && refInfo.search.terminal.length) {
                    params.storeId = refInfo.search.terminal;
                } else {
                    params.storeId = [];
                    var userInfo = config.session && config.session.userInfo || {};
                    if (userInfo.terminal.length) {
                        userInfo.terminal.forEach(function (terminal) {
                            params.storeId.push(terminal.TerminalID);
                        });
                    }
                }
                //如果选择商品
                if (refInfo.search.goodsId) {
                    params.goodsId = refInfo.search.goodsId;
                    if (params.goodsId && typeof (params.goodsId) == "string" && params.goodsId.indexOf(",") > -1) {
                        params.goodsId = params.goodsId.split(",");
                    }
                } else {
                    return alert("请选择品种");
                }
                //月份
                if (refInfo.search.startTime) {
                    params.month = refInfo.search.startTime;
                }
            }
            if (refInfo.rpt) {
                //点击表格的参数
                var len = refInfo.rpt.length;
                while (len--) {
                    params[refInfo.rpt[len].field] = refInfo.rpt[len].value;
                }
            }
            if (params.month && params.num) {
                //加载客户明细
                window.busy();
                return cust.loadMemberByMonth(params).then(function (data) {
                    window.free();
                    return data && data.items || [];
                });
            }
            return [];
        },
        getStrRptDataForSale: function (refInfo) {
            var params = {
                pageSize: 1000,
                pageIdx: 1
            };
            //如果业务员没有选择终端，则查询全部可看终端
            if (refInfo && refInfo.search && refInfo.search.terminal && refInfo.search.terminal.length) {
                params.storeId = refInfo.search.terminal;
            } else {
                params.storeId = [];
                var userInfo = config.session && config.session.userInfo || {};
                if (userInfo.terminal.length) {
                    userInfo.terminal.forEach(function (terminal) {
                        params.storeId.push(terminal.TerminalID);
                    });
                }
            }
            if (refInfo && refInfo.search && refInfo.search.goodsId) {
                params.goodsId = refInfo.search.goodsId;
                if (params.goodsId && typeof (params.goodsId) == "string" && params.goodsId.indexOf(",") > -1) {
                    params.goodsId = params.goodsId.split(",");
                }
            } else {
                return alert("请选择品种");
            }
            if (refInfo && refInfo.search && refInfo.search.startTime) {
                params.month = refInfo.search.startTime;
            }
            window.busy();
            return monthlySum.load(params).then(lang.hitch(this, function (data) {
                window.free();
                data = data.items;
                return data;
            }));
        },
        //销售分析相关
        setTime: function () {
            var t = new Date();
            var f = new Date();
            f.setMonth(f.getMonth() - 1);
            return {
                queryTimet: t.toISOString(),
                queryTimef: f.toISOString()
            };
        },
        getTimeQueryForSale: function () {
            return [{
                type: "form",
                fields: this.getFormItems(["queryTime", "terminal"])
            }];
        },
        getMatSaleRptDataForSale: function (cqRefInfo, widget, dataOptions) {
            //如果业务员没有选择终端，则查询全部可看终端
            var params = {};
            if (cqRefInfo && cqRefInfo.timeQuery && cqRefInfo.timeQuery.terminal && cqRefInfo.timeQuery.terminal.length) {
                params.storeId = cqRefInfo.timeQuery.terminal;
            } else {
                params.storeId = [];
                var userInfo = config.session && config.session.userInfo || {};
                userInfo.terminal.forEach(function (terminal) {
                    params.storeId.push(terminal.TerminalID);
                });
            }
            if (cqRefInfo && cqRefInfo.timeQuery && cqRefInfo.timeQuery.queryTimef) {
                params.orderDatef = cqRefInfo.timeQuery.queryTimef;
            }
            if (cqRefInfo && cqRefInfo.timeQuery && cqRefInfo.timeQuery.queryTimet) {
                params.orderDatet = cqRefInfo.timeQuery.queryTimet;
            }
            window.busy();
            return cust.getSaleReport(params).then(lang.hitch(this, function (result) {
                window.free();
                return result && result.items || [];
            }));
        },
        changeSort: function () {
            var sortDom = query(".changeSort")[0];
            sortDom = sortDom.childNodes[1];
            if (this.sortMethod == 1) {
                this.sortMethod = 0;
                sortDom.innerHTML = "升序";
            } else {
                this.sortMethod = 1;
                sortDom.innerHTML = "降序";
            }
            var list = query(".terminalOutList")[0];
            var listObj = registry.byId(list.id);
            listObj.refresh();
        },
        loadCurrMonthTerminal: function (params) {
            var def = new Deferred();
            var date = new Date(params["1"].month);
            var userInfo = config.session && config.session.userInfo || {};
            var obj = {
                brandId: params["1"].brandId,
                year: date.getFullYear(),
                month: date.getMonth() + 1,
                empId: userInfo.empId || userInfo.userId
            };
            xhr("GET", {
                url: config.dataOrigin1 + "/datacenter/terminalOutput?params="
                    + JSON.stringify(obj),
                handleAs: "json",
                load: function (data) {
                    var brandName = "";
                    var avg1 = 0;
                    if (data && data.items && data.items.length) {
                        avg1 = data.items[0].avg;
                        brandName = data.items[0].brandName;
                    }
                    obj.month = date.getMonth();
                    xhr("GET", {
                        url: config.dataOrigin1 + "/datacenter/terminalOutput?params="
                            + JSON.stringify(obj),
                        handleAs: "json",
                        load: function (data1) {
                            var avg2 = 0;
                            if (data1 && data1.items && data1.items.length) {
                                avg2 = data1.items[0].avg;
                                brandName = data1.items[0].brandName;
                            }
                            if (avg2 == 0) {
                                avgFlag = "0%";
                            } else {
                                avgFlag = ((avg1 - avg2) / avg2 * 100).toFixed(2) + "%";
                            }
                            def.resolve({
                                brandName: brandName,
                                avg1: "本月" + avg1,
                                avg2: "上月" + avg2,
                                avgFlag: avgFlag
                            });
                        },
                        error: function (err) {
                            def.resolve({});
                        }
                    });
                },
                error: function (err) {
                    def.resolve({});
                }
            });

            return def;
        },
        terminalOutClick: function (params, widget, event) {
            window.moveToView("terminalOutputList", "y_" + this.terminalYear
                + "_m_" + this.terminalMonth + "_b_" + this.terminalBrandId);
        },
        getLinesData: function (params) {
            var def = new Deferred();

            if (!params["1"]) {
                return def.resolve({
                    series1: [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                    series2: [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                    series3: [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                    series4: [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
                });
            }
            if (params["1"] && !params["1"].month) {
                alert("必须选择月份");
                return def.resolve({
                    series1: [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                    series2: [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                    series3: [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                    series4: [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
                });
            }
            if (params["1"] && !params["1"].brandId) {
                alert("必须选择品牌");
                return def.resolve({
                    series1: [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                    series2: [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                    series3: [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                    series4: [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
                });
            }
            var _this = this;
            var date = new Date();
            date.setMonth(date.getMonth() - 1);
            var month = params["1"] && params["1"].month || (date.toISOString());
            date = new Date(month);
            var year = date.getFullYear();
            this.terminalYear = year;
            this.terminalMonth = date.getMonth() + 1;
            this.terminalBrandId = params["1"] && params["1"].brandId || "";
            var userInfo = config.session && config.session.userInfo || {};
            var obj = {
                empId: userInfo.empId || userInfo.userId,
                year: this.terminalYear,
                month: this.terminalMonth
            }
            if (this.terminalBrandId) {
                obj.brandId = parseInt(this.terminalBrandId);
            }
            var currData = new Date(params["1"].month);
            xhr("GET", {
                url: config.dataOrigin1 + "/datacenter/terminalOutputByYear?params="
                    + JSON.stringify(obj),
                handleAs: "json",
                load: function (data) {
                    var result = {
                        series1: [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                        series2: [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                        series3: [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                        series4: [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
                    };
                    if (data && data.item && data.item.outputItems && data.item.outputItems.length) {
                        for (var index = 0; index < data.item.outputItems.length; index++) {
                            var item = data.item.outputItems[index];
                            var d = new Date(item.year + "-" + item.month);
                            var i = 11 - ((currData.getFullYear() - d.getFullYear()) * 12
                                + (currData.getMonth() - d.getMonth()));
                            result.series4[i] = item.avg.toFixed(2);
                        }
                    }
                    if (data && data.item && data.item.statusItems && data.item.statusItems.length) {
                        for (var index = 0; index < data.item.statusItems.length; index++) {
                            var item = data.item.statusItems[index];
                            var d = new Date(item.year + "-" + item.month);
                            var i = 11 - ((currData.getFullYear() - d.getFullYear()) * 12
                                + (currData.getMonth() - d.getMonth()));
                            if (item.status == 10) {
                                result.series1[i] = item.count;
                            } else if (item.status == 20) {
                                result.series2[i] = item.count;
                            } else if (item.status == 30) {
                                result.series3[i] = item.count;
                            }
                        }
                    }
                    def.resolve(result);
                },
                error: function (err) {
                    def.resolve({
                        series1: [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                        series2: [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                        series3: [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                        series4: [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
                    });
                }
            });

            return def;
        },
        getLinesSeries: function () {
            var def = new Deferred();

            return def.resolve([{
                type: "line",
                id: "series1",
                name: "活跃"
            }, {
                type: "line",
                id: "series2",
                name: "休眠"
            }, {
                type: "line",
                id: "series3",
                name: "沉睡"
            }, {
                type: "line",
                id: "series4",
                name: "店均产出",
                yAxisIndex: 1
            }]);
        },
        linesFormatter: function (params) {
            return params[0].name + "<br/>活跃状态<br/>活跃:" + params[0].value
                + "<br/>休眠:" + params[1].value + "<br/>沉睡:" + params[2].value
                + "<br/>店均产出:" + params[3].value;
        },
        getLinesXData: function (params, widget, options) {
            var def = new Deferred();

            var result = [];
            var date = new Date(params["1"] && params["1"].month || null);
            date.setMonth(date.getMonth() - 12);
            for (var index = 0; index < 12; index++) {
                date.setMonth(date.getMonth() + 1);
                result.push(date.getFullYear() + "年" + (date.getMonth() + 1) + "月");
            }

            return def.resolve([{
                axis: 'x',
                axisIndex: 0,
                data: result
            }]);
        },
        getLinesLegend: function () {
            var def = new Deferred();
            return def.resolve(["活跃", "休眠", "沉睡", "店均产出"]);
        }
    });
    var o = new O();
    o.Bo = o;
    return o;
});
