﻿define([
    "dojo/Deferred",
    "dojo/_base/lang",
    "cq/util/config/config",
    "cq/util/sys/date",
    "./common",
    "../bo/consumer"
], function (Deferred, lang, config, date, common, consumer) {
    return {
        layoutMethods: {
            //首页相关功能
            _getMainTopCommon:function(){
                //顶部标题栏
                return [{
                    type:"content",
                    contents:["<div style='background:rgb(36,168,252);height:48px;'>",//background:-webkit-gradient(linear, 0 0, 0 bottom,from(rgb(36,168,252)),to(rgb(52,138,195)))
                        "<img style='display:block;margin:auto;height:100%;' src='./images/temp/logo/homeTop.png'>",
                    "</div>"]
                },{//用户信息栏
                    dojoType: "cq/app/widget/mobile/icon/IconContainer",
                    className: "top-info-bar main-top",
                    items: [{
                        dojoType:"cq/app/widget/mobile/icon/DataIcon",
                        "className":"h-icon-label nini-icon flex2",
                        dataProvider:"whz/bo/buttonLabel",
                        labelField:"label",
                        iconField:"icon",
                        dataMethod:"nowDate",
                        waitFor:{
                            "0":"cqViewParams"
                        }
                    },{
                        dojoType:"cq/app/widget/mobile/icon/DataIcon",
                        "className":"h-icon-label nini-icon flex2-5",
                        dataProvider:"whz/bo/buttonLabel",
                        labelField:"label",
                        iconField:"icon",
                        dataMethod:"nowConsumerName",
                        waitFor:{
                            "0":"cqViewParams"
                        }
                    },{
                        dojoType:"cq/app/widget/mobile/icon/DataIcon",
                        "className":"noFlex h-icon-label nini-icon",
                        icon:"images/temp/miniIcon/logout.png",
                        label:"退出",
                        dataProvider:"whz/bo/buttonLabel",
                        clickMethod:"logout"
                    }]
                }];
            },
            getHeader:function(title){
                return {
                    //顶部标题栏
                    fixed:"top",
                    type:"topBar",
                    label:title,
                    left:[{
                        type:"iconMenuItem",
                        label:"",
                        icon:"",
                        arrow:"left",
                        href:"back"
                    }]
                };
            },
            getYewuReportList:function(){
                var list = [{
                    href:"#newCustomerCrowth",
                    label: "门店新客统计",
                    rightText: "点击查看",
                    icon: "images/func/f6.png"
                },{
                    href:"#saleCrowth",
                    label: "门店销售统计",
                    rightText: "点击查看",
                    icon: "images/func/saleDetail.png"
                }];
                return list;
            },
            getReportList:function(role){
                //先只返回显示三个列表信息
                var list = [{
                    href:"#newCustomerList",
                    label: "当日门店注册会员清单",
                    rightText: "点击查看",
                    icon: "images/func/f6.png"
                },{
                    href:"#saleDetails",
                    label: "当日销售明细",
                    rightText: "点击查看",
                    icon: "images/func/saleDetail.png"
                },{
                    href:"#historySales",
                    label:'历史销售汇总',
                    rightText:"点击查看",
                    icon: "images/func/saleTotal.png"
                },{
                    href:"#customerList",
                    label:'会员名单',
                    rightText:"点击查看",
                    icon: "images/func/customerList.png"
                }];
                return list;
                //当日门店注册会员清单,当日销售明细,历史销售汇总,新客回头分析,近三个月活跃会员数,会员名单,交叉会员查询
                /*var list = [{
                    href:"#newCustomerList",
                    label: "当日门店注册会员清单",
                    rightText: "点击查看",
                    icon: "images/func/f6.png"
                },{
                    href:"#saleDetails",
                    label: "当日销售明细",
                    rightText: "点击查看",
                    icon: "images/func/saleDetail.png"
                },{
                    href:"#historySales",
                    label:'历史销售汇总',
                    rightText:"点击查看",
                    icon: "images/func/saleTotal.png"
                },{
                    href:"#",
                    label:'新客回头分析',
                    rightText:"点击查看",
                    icon: "images/func/htke.png"
                },{
                    href:"#",
                    label:'近三个月活跃会员数',
                    rightText:"点击查看",
                    icon: "images/func/huoyuedu.png"
                },{
                    href:"#customerList",
                    label:'会员名单',
                    rightText:"点击查看",
                    icon: "images/func/f4.png"
                },{
                    href:"#",
                    label:'交叉会员查询',
                    rightText:"点击查看",
                    icon: "images/func/userInfo.png"
                }];
                if(role == 2){
                    //业务员
                    list.splice(4,3);
                    return 
                }else if(role == 3){
                    //总部人员
                    list.splice(5,1);
                }
                return list;*/
            },
            //首页布局
            getMainLayout:function(){
                var layout = this._getMainTopCommon();
                var userInfo = consumer.getCurrentUserFromSession();
                var user_Type = config.session.userType;
                if(user_Type == '2'){
                    layout = layout.concat([{
                      type: "flexBar",
                      className: "item-tab no-padding-bottom no-margin-top",
                      buttons: [{
                          dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                          href:"#shopExchangeList",
                          icon: "images/func/exchange.png",
                          label: "门店兑换"
                      },{
                          dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                          iconClass:"",
                          href:"#",
                          icon: "",
                          label: ""
                      },{
                          dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                          iconClass:"",
                          href:"#",
                          icon: "",
                          label: ""
                      }]
                    }]);
                }else{
                //门店界面
                if(userInfo.role==="mendiandianyuan"||
                    userInfo.role==="mendianguanliyuan"){
                    layout = layout.concat([{
                        type: "flexBar",
                        className: "item-tab no-padding-bottom no-margin-top",
                        buttons: [{
                            dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                            href:"#addCustomer",
                            icon: "images/func/customer.png",
                            label: "会员注册"
                        },{
                            dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                            iconClass:"",
                            href:"#getMemberInfo",
                            icon: "images/func/point.png",
                            label: "会员积分"
                        },{
                            dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                            iconClass:"",
                            //href:"#memberInfoExchange",
                            dataProvider:"whz/bo/buttonLabel",
                            action:"memberExchange",
                            icon: "images/func/exchange.png",
                            label: "会员兑换"
                        }]
                    },{
                        type: "flexBar",
                        className: "item-tab no-padding-bottom no-margin-top",
                        buttons: [{
                            dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                            href:"#customerList",
                            icon: "images/func/userInfo.png",
                            label: "会员查询"
                        },{
                            dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                            iconClass:"",
                            dataProvider:"whz/bo/goods",
                            action:"getMatSoure",
                            icon: "images/func/f1.png",
                            label: "产品溯源"
                        },{
                            dojoType:"cq/app/widget/mobile/icon/DataContainer",
                            id:"DataContainer",
                            className:'DataContainer flex1',
                            items:[{
                                dojoType:'cq/app/widget/mobile/icon/Icon',
                                label:'活动公告',
                                badgeField:'unread',
                                icon:'images/func/notice.png',
                                href: "#noticeList"
                            }],
                            dataProvider:'whz/bo/customer',
                            dataMethod:'getunRead',
                            dataOptions:{},
                            waitFor:{
                                "0":"DataContainer"
                            }
                        }]
                    },{
                        type: "flexBar",
                        className: "item-tab no-padding-bottom no-margin-top",
                        buttons: [{
                            dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                            href:"#storeBusiness",
                            icon: "images/func/f7.png",
                            label: "门店业务"
                        },{
                            dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                            iconClass:"",
                            href:"#reportCenter",
                            icon: "images/func/management.jpg",
                            label: "报表中心"
                        },{
                            dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                            iconClass:"",
                            href:"#",
                            icon: "images/func/f8.png",
                            label: "最新资讯"
                        }]
                    }]);
                }else if(userInfo.role==="liansuozongbu"){
                    layout = layout.concat([{
                        type: "flexBar",
                        className: "item-tab no-padding-bottom no-margin-top",
                        buttons: [{
                            dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                            href:"#addCustomer",
                            icon: "images/func/customer.png",
                            label: "会员注册"
                        },{
                            dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                            iconClass:"",
                            href:"#getMemberInfo",
                            icon: "images/func/point.png",
                            label: "会员积分"
                        },{
                            dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                            iconClass:"",
                            //href:"#memberInfoExchange",
                            dataProvider:"whz/bo/buttonLabel",
                            action:"memberExchange",
                            icon: "images/func/exchange.png",
                            label: "会员兑换"
                        }]
                    },{
                        type: "flexBar",
                        className: "item-tab no-padding-bottom no-margin-top",
                        buttons: [{
                            dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                            href:"#storeCustomerList",
                            icon: "images/func/userInfo.png",
                            label: "会员查询"
                        },{
                            dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                            iconClass:"",
                            dataProvider:"whz/bo/goods",
                            action:"getMatSoure",
                            icon: "images/func/f1.png",
                            label: "产品溯源"
                        },{
                            dojoType:"cq/app/widget/mobile/icon/DataContainer",
                            id:"DataContainer",
                            className:'DataContainer flex1',
                            items:[{
                                dojoType:'cq/app/widget/mobile/icon/Icon',
                                label:'活动公告',
                                badgeField:'unread',
                                icon:'images/func/notice.png',
                                href: "#noticeList"
                            }],
                            dataProvider:'whz/bo/customer',
                            dataMethod:'getunRead',
                            dataOptions:{},
                            waitFor:{
                                "0":"DataContainer"
                            }
                        }]
                    },{
                        type: "flexBar",
                        className: "item-tab no-padding-bottom no-margin-top",
                        buttons: [{
                            dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                            href:"#storeBusiness",
                            icon: "images/func/f7.png",
                            label: "门店业务"
                        },{
                            dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                            iconClass:"",
                            href:"#reportCenter",
                            icon: "images/func/management.jpg",
                            label: "报表中心"
                        },{
                            dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                            iconClass:"",
                            href:"#",
                            icon: "images/func/f8.png",
                            label: "最新资讯"
                        }]
                    }]);
                    //连锁总部界面
                    /*layout = layout.concat([{
                        type: "flexBar",
                        className: "item-tab no-padding-bottom no-margin-top",
                        buttons: [{
                            dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                            iconClass:"",
                            href:"#storeCustomerList",
                            icon: "images/func/customer.png",
                            label: "门店会员"
                        },{
                            dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                            href:"#storeBusiness",
                            icon: "images/func/f7.png",
                            label: "门店业务"
                        },{
                            dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                            iconClass:"",
                            href:"#reportCenter",
                            icon: "images/func/management.jpg",
                            label: "报表中心"
                        }]
                    },{
                        type: "flexBar",
                        className: "item-tab no-padding-bottom no-margin-top",
                        buttons: [{
                            dojoType:"cq/app/widget/mobile/icon/DataContainer",
                            id:"DataContainer",
                            className:'DataContainer flex1',
                            items:[{
                                dojoType:'cq/app/widget/mobile/icon/Icon',
                                label:'活动公告',
                                badgeField:'unread',
                                icon:'images/func/notice.png',
                                href: "#noticeList"
                            }],
                            dataProvider:'whz/bo/customer',
                            dataMethod:'getunRead',
                            dataOptions:{},
                            waitFor:{
                                "0":"DataContainer"
                            }
                        },{
                            dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                            href:"#",
                            icon: "images/func/f8.png",
                            label: "最新资讯"
                        },{
                            dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                            iconClass:"",
                            href:"#",
                            icon: "",
                            label: ""
                        }]
                    }]);*/
                }else{
                    //业务员
                    this.setCustomerOP();
                    //修改客户信息分析里面查询终端的options
                    layout = layout.concat([{
                        type: "flexBar",
                        className: "item-tab no-padding-bottom no-margin-top",
                        buttons: [{
                            dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                            iconClass:"",
                            href:"#saleManageStore",
                            icon: "images/func/f7.png",
                            label: "门店查询"
                        },{
                            dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                            iconClass:"",
                            dataProvider:"whz/bo/goods",
                            action:"getMatSoure",
                            icon: "images/func/f1.png",
                            label: "产品溯源"
                        },{
                            dojoType:"cq/app/widget/mobile/icon/DataContainer",
                            id:"DataContainer",
                            className:'DataContainer flex1',
                            items:[{
                                dojoType:'cq/app/widget/mobile/icon/Icon',
                                label:'活动公告',
                                //badgeField:'unread',
                                icon:'images/func/notice.png',
                                href: "#"//"#noticeList"
                            }]//,
                            //dataProvider:'whz/bo/customer',
                            //dataMethod:'getunRead',
                            //dataOptions:{},
                            //waitFor:{
                            //    "0":"DataContainer"
                            //}
                        }]
                    },{
                        type: "flexBar",
                        className: "item-tab no-padding-bottom no-margin-top",
                        buttons: [{
                            dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                            href:"#customerRpt",
                            label:'顾客分析',
                            rightText:"点击查看",
                            icon: "images/func/khfx.png"
                        },{
                            dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                            href:"#matSaleRpt",
                            label:'销售分析',
                            rightText:"点击查看",
                            icon: "images/func/xsfx.png"
                        },{
                            dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                            iconClass:"",
                            href:"#",
                            icon: "images/func/customer.png",
                            label: "最新资讯"
                        }]
                    },{
                        type: "flexBar",
                        className: "item-tab no-padding-bottom no-margin-top",
                        buttons: [{
                            dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                            iconClass:"",
                            href:"#rankList",
                            icon: "images/func/paihangbang.png",
                            label: "排行榜"
                        },{
                            dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                            iconClass:"",
                            href:"#storeStatusPie",
                            icon:"images/func/zhongduanhuoyue.png",
                            label:"终端活跃"
                        },{
                            dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                            iconClass:"",
                            href:"#terminalFlow",
                            icon: "images/func/liuxiangtongji.png",
                            label: "流向统计"
                        }]
                    },{
                        type: "flexBar",
                        className: "item-tab no-padding-bottom no-margin-top",
                        buttons: [{
                            dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                            iconClass:"",
                            href:"#taskAndProgress",
                            icon: "images/func/jindu.png",
                            label: "任务进度"
                        },{
                            dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                            iconClass:"",
                            href:"#dianyuanguanli",
                            icon: "images/func/customer.png",
                            label:"店员管理"
                        }]
                    }]);
                }
                }
                layout.push({
                    type: "content",
                    fixed: "bottom",
                    content: '<div style="font-size:16px;color:#8F8F8F;text-align:left;">'+
						'<div style="display:flex;">' +
							'<div style="flex:1;"></div>' +
							'<div>当前版本：2.2.5</div>' +
							'<div style="flex:1;"></div>' +
						'</div>'+
						'<div style="display:flex">'+
							'<div style="flex:1;"></div>' +
							'<div>服务热线：400-830-3896</div>' +
							'<div style="flex:1;"></div>' +
						'</div>'+
                    '</div>'
                });
                layout.push(common.getnepBabyFooter(1));
                return layout;
            },
            getStoreBusLayout:function(){
                var layout = [];
                var userInfo = consumer.getCurrentUserFromSession();
                
                if(userInfo.role==="mendiandianyuan"||userInfo.role==="mendianguanliyuan"||userInfo.role==="liansuozongbu"){
                    layout.push(this.getHeader("门店业务"));
                    if(userInfo.isRedeem == 1){
                        layout.push({
                            dojoType:"cq/app/widget/mobile/List",
                            items:[{
                                href:"#shopExchange",
                                label: "门店兑换",
                                rightText: "点击查看",
                                icon: "images/func/exchange.png"
                            },{
                                href:"#shopExchangeList",
                                label: "兑换列表",
                                rightText: "点击查看",
                                icon: "images/func/f4.png"
                            }],
                            listClass: "inherit-icon",
                            itemType: "IconLabel"
                        });
                    }
                    layout.push({
                        dojoType:"cq/app/widget/mobile/List",
                        items:[{
                            href:"#storeList",
                            label:'会员消费',
                            rightText:"点击查看",
                            icon: "images/func/f3.png"
                        },/*{
                            href:"#goodsReturn",
                            label:'退货',
                            rightText:"点击查看",
                            icon: "images/func/return.png"
                        },*/{
                            href:"#storeStock",
                            label:'门店库存',
                            rightText:"点击查看",
                            icon: "images/func/storeStock.png"
                        }/*,{
                            href:"#",
                            label: "门店盘点",
                            rightText: "点击修改",
                            icon: "images/func/pandian.png"
                        },{
                            href:"#",
                            label:'门店间调拨',
                            rightText:"点击查看",
                            icon: "images/func/f22.png"
                        }*//*{
                            href:"#",
                            label:'门店盘点',
                            rightText:"点击查看",
                            icon: "images/func/consumer.png"
                        },{
                            href:"#",
                            label:'门店间调拨',
                            //rightText:"点击编辑",
                            icon: "images/func/f2.png"
                        },{
                            href:"#",
                            label:'门店库存',
                            //rightText:"点击编辑",
                            icon: "images/func/userInfo.png"
                        },{
                            href:"#",
                            label:'门店退货',
                            //rightText:"点击编辑",
                            icon: "images/func/userInfo.png"
                        },{
                            href:"#",
                            label:'顾客退货',
                            //rightText:"点击编辑",
                            icon: "images/func/userInfo.png"
                        }*/],
                        listClass: "inherit-icon",
                        itemType: "IconLabel"
                    });
                }
                return layout;
            },
            getReportlayout:function(){
                /*四种角色*/
                var layout = [],list = [];
                var userInfo = consumer.getCurrentUserFromSession();
                layout.push(this.getHeader("报表中心"));
                if(userInfo.role==="mendiandianyuan"||userInfo.role==="mendianguanliyuan"||userInfo==="liansuozongbu"){
                    list = this.getReportList(0);
                }else if(userInfo.role==="zongburenyuan"){
                    list = this.getReportList(3);
                }
                layout.push({
                    dojoType:"cq/app/widget/mobile/List",
                    items:[{
                        href:"#customerRpt",
                        label: "本月客户分析",
                        rightText:"点击查看",
                        icon: "images/func/khfx.png"
                    },{
                        href:"#matSaleRpt",
                        label: "销售分析",
                        rightText:"点击查看",
                        icon: "images/func/xsfx.png"
                    },{
                        href:"#newCustomerList",
                        label: "当日门店注册会员清单",
                        rightText: "点击查看",
                        icon: "images/func/f6.png"
                    },{
                        href:"#customerList",
                        label:'会员名单',
                        rightText:"点击查看",
                        icon: "images/func/customerList.png"
                    }],
                    listClass: "inherit-icon",
                    itemType: "IconLabel"
                }/*,{
                    dojoType:"cq/app/widget/mobile/List",
                    items:list,
                    listClass: "inherit-icon",
                    itemType: "IconLabel"
                }*/);
                return layout;
            },
            //业务员登录修改view
            setCustomerOP:function(){
                require([
                    "whz/bo/terminal",
                    "whz/bo/customer"
                ],function(terminal,customer){
                    terminal.initOptions();
                    terminal.initOptions1().then(function(){
                        customer.initOptions();
                    });
                });
            },
            //设置分门店和业务员功能菜单显示
            getSettingLayout:function(){
                var userInfo = consumer.getCurrentUserFromSession();
                var layout = [this.getHeader("系统设置")];
                if(userInfo.role==="mendiandianyuan"||
                    userInfo.role==="mendianguanliyuan"||
                    userInfo.role==="liansuozongbu"){
                    //门店功能
                    layout = layout.concat(common.accountMenu);
                }else{
                    //业务员功能
                    layout = layout.concat(common.oltpAccountMenu);
                }
                return layout;
            },
            
            //报表相关view
            //客户分析
            getCustomerRptLayout:function(){
                var layout = [{
                    fixed:"top",
                    type:"topBar",
                    label:"客户分析",
                    left:[{
                        type:"iconMenuItem",
                        label:"",
                        icon:"",
                        arrow:"left",
                        href:"back"
                    }]
                },{
                    dojoType: "cq/app/widget/web/QueryLayout",
                    //enableRange:false,
                    dataProvider: "whz/bo/terminal",
                    initMethod: "initConsumerQueryLayout",
                    queryLayoutMethod: "getQueryLayoutForCustomerRpt",
                    id: "1",
                    searchLabel: "查询",
                    waitFor:{
                        "0":"cqViewParam"
                    }
                },{
                    "id":"rpt",
                    dojoType:"cq/widgets/chart/DataTable",
                    dataProvider:"whz/bo/terminal",
                    dataMethod:"getConsumerRptData",
                    rowFields:"tp",
                    columnFields:"",
                    qtyFields : "num",
                    //qtyFields:"num,buyQty,exchangeQty,giftQty",
                    waitFor:{
                        "1":"search"
                    }
                }];
                var userInfo = consumer.getCurrentUserFromSession();
                if(userInfo.role==="yewudaibiao"){
                    //业务代表
                    layout = layout.concat([{
                        type:"div",
                        content:"门店状况"
                    },{
                        type:"div",
                        content:[{
                            dojoType:"cq/widgets/chart/DataTable",
                            dataProvider:"whz/bo/terminal",
                            dataMethod:"getCustNumForCustRpt",
                            rowFields:"storeName,num",
                            columnFields:"",
                            qtyFields:"",
                            waitFor:{
                                "rpt":"rpt",
                                "1":"search"
                            }
                        }]
                    }]);
                }else if(userInfo.role==="jingli"){
                    //各级经理
                    layout = layout.concat([{
                        type:"content",
                        content:"人员状况"
                    },{
                        type:"div",
                        content:[{
                            dojoType:"cq/widgets/chart/DataTable",
                            dataProvider:"whz/bo/terminal",
                            dataMethod:"getCustNumForCustRpt",
                            rowFields:"empName,num",
                            columnFields:"",
                            qtyFields:"",
                            waitFor:{
                                "rpt":"rpt",
                                "1":"search"
                            }
                        }]
                    }]);
                }
                return layout;
            },
            getMatSaleRptLayout:function(){
                var layout = [{
                    fixed:"top",
                    type:"topBar",
                    label:"销售分析",
                    left:[{
                        type:"iconMenuItem",
                        label:"",
                        icon:"",
                        arrow:"left",
                        href:"back"
                    }]
                },{
                    dojoType: "cq/app/widget/web/QueryLayout",
                    dataProvider: "whz/bo/terminal",
                    initMethod: "initSaleQueryLayout",
                    queryLayoutMethod: "getQueryLayoutForSale",
                    id: "1",
                    searchLabel: "查询",
                    waitFor:{
                        "0":"cqViewParam"
                    }
                },{
                    "id":"rpt",
                    dojoType:"cq/widgets/chart/DataTable",
                    dataProvider:"whz/bo/terminal",
                    dataMethod:"getSaleRptData",
                    rowFields:"goodsName",
                    columnFields:"",
                    qtyFields:"saleQty,giftQty,exchangeQty",
                    waitFor:{
                        "1":"search"
                    }
                }];
                var userInfo = consumer.getCurrentUserFromSession();
                if(userInfo.role==="yewudaibiao"){
                    //业务代表
                    layout = layout.concat([{
                        type:"div",
                        content:"门店状况"
                    },{
                        type:"div",
                        content:[{
                            dojoType:"cq/widgets/chart/DataTable",
                            dataProvider:"whz/bo/terminal",
                            dataMethod:"getSaleLogForSaleRpt",
                            rowFields:"storeName",
                            columnFields:"",
                            qtyFields:"num",
                            waitFor:{
                                "rpt":"rpt",
                                "1":"search"
                            }
                        }]
                    }]);
                }else if(userInfo.role==="jingli"){
                    //各级经理
                    layout = layout.concat([{
                        type:"div",
                        content:"人员状况"
                    },{
                        type:"div",
                        content:[{
                            dojoType:"cq/widgets/chart/DataTable",
                            dataProvider:"whz/bo/terminal",
                            dataMethod:"getSaleLogForSaleRpt",
                            rowFields:"empName",
                            columnFields:"",
                            qtyFields:"num",
                            waitFor:{
                                "rpt":"rpt",
                                "1":"search"
                            }
                        }]
                    }]);
                }
                return layout;
            }
        },
        programLayouts: {
            main: {
                noBack: true,
                method: "getMainLayout"
            },
            storeBusiness:{
                method: "getStoreBusLayout"
            },
            reportCenter:{
                method: "getReportlayout"
            },
            setting:{
                method:"getSettingLayout"
            },
            
            //报表相关view
            customerRpt:{
                method:"getCustomerRptLayout"
            },
            matSaleRpt:{
                method:"getMatSaleRptLayout"
            }
        },
        views:{
            main:{
                mustLogin:true,
                preventScroll:true
            },
            //门店业务//业务员相关业务
            storeBusiness:{
                mustLogin:true
            },
            //报表业务
            reportCenter:{
                mustLogin:true
            },
            setting:{
                mustLogin:true
            },
            
            //两个报表view
            //客户分析
            customerRpt:{
                mustLogin:true
            },
            //销售分析//报表
            matSaleRpt:{
                mustLogin:true
            }
        }
    };
});
