﻿define([
    "./common"
],function(common){
    return {
        views:{
            //门店兑换
            shopExchange:{
                mustLogin:true
            },
            //产品列表统计
            shopExchangeList:{
                mustLogin:true
            },
            //当日销售明细
            saleDetails:{
                mustLogin:true
            },
            //历史销售汇总
            historySales:{
                mustLogin:true
            }
        },
        layouts:{
            //由门店余额和门店商品列表组成
            shopExchange:[{
                //顶部标题栏
                fixed:"top",
                type:"topBar",
                label:"门店兑换",
                left:[{
                    type:"iconMenuItem",
                    label:"",
                    icon:"",
                    arrow:"left",
                    href:"back"
                }]
            },{//门店信息
                dojoType: "cq/app/widget/web/DataLayout",
                dataProvider: "whz/bo/customer",
                initMethod: "getCurrentStoreInfo",
                className: "inherit-background no-margin-top",
                layout:[{
                    type : "content",
                    content:'<div class="storeMsg storeBackground">'+
                            '<div class="labelPadding"><span class="labelName">门店标识：<span/><span class="cq-field-input labelMsg" data-cq-field="storeId"></span></div>'+
                            '<div class="labelPadding"><span class="labelName">推荐人：<span/><span class="cq-field-input labelMsg" data-cq-field="referrerPhone"></span></div>'+
                        '</div>'
                }],
                waitFor: {
                    "0": "cqViewParam"
                }
            },/*{//门店剩余积分
                dojoType: "cq/app/widget/web/DataLayout",
                dataProvider: "whz/bo/goods",
                initMethod: "getStoreIntegral",
                className: "inherit-background no-margin-top",
                layout:[{
                    type : "content",
                    content:'<div class="storeMsg">'+
                        '<div class="labelPadding"><span class="labelName">门店积分：<span/><span class="cq-field-input labelMsg" data-cq-field="usableIntegral"></span></div>'+
                    '</div>'
                }],
                waitFor: {
                    "0": "cqViewParam"
                }
            },{
                type: "content",
                content: "<div style='padding-left:15px;font-size:large;margin:8px 0px;'>商品列表:</div>"
            },*/{//门店所有商品
                dojoType: "cq/app/widget/web/DataLayout",
                dataProvider: "whz/bo/goods",
                initMethod: "loadGoosList",
                reloadMethod : "onDataReady",
                className: "inherit-background no-margin-top",
                
                //layoutMethod: "getMatsLayout",
                fieldChangeMethod:"onStoreChanged",
                layout:[{
                    type : "content",
                    content:'<div class="storeMsg">'+
                        '<div class="labelPadding">'+
                            '<span class="labelName">门店积分：<span/>'+
                            '<span class="cq-field-input labelMsg" data-cq-field="usableIntegral"></span>'+
                            '<span style="float:right;" class="cq-action list_item_button" data-cq-field="showIntegralDetail" cq-action="onShowIntegralDetail">查看明细</span>'+
                        '</div>'+
                    '</div>'
                },{
                    type : "form",
                    canDelete:false,
                    canAdd:false,
                    canDnd:false,
                    canEdit:false,
                    formClass: "no-border",
                    fields:[{
                        type : "options",
                        label : "兑换品牌",
                        field : "brandname",
                        options : {
                            "喜安智" : "喜安智",
                            "喜安欣" : "喜安欣"
                        }
                    }, {
                        type: "content",
                        content: "<div style='padding-left:15px;font-size:large;margin:8px 0px;'>商品列表:</div>"
                    }, {
                        type: "objects",
                        field:"mats",
                        canDelete:false,
                        canAdd:false,
                        canDnd:false,
                        canEdit:true,
                        fields:{
                            className:"mblListItem",
                            layout:[{
                                type: "content",
                                canDelete:false,
                                canAdd:false,
                                canDnd:false,
                                canEdit:false,
                                content:'<div class="item-list o-t-item" style="display:block;">'+
                                    '<div class="hflex_top">'+
                                        '<div style="flex:2">'+
                                            '<p style="padding-left:15px;font-size: 15px;"><span class="cq-field-input" data-cq-field="name"></span></p>'+
                                            '<p style="padding-left:15px;color:#999;">(每罐需要<span class="cq-field-input" data-cq-field="storeExchangeIntegral"></span>积分)</p>'+
                                        '</div>'+
                                        '<div style="flex:1">'+
                                            '<input class="cq-field-input" data-cq-field="qty" placeholder="填写兑换罐数"/>'+
                                        '</div>'+
                                    '</div>'+
                                '</div>'
                            }]
                        }
                    },{
                        type:"content",
                        content:"<div style='height:44px;line-height:44px;padding:5px 18px;'>合计：<span class='cq-field-input' data-cq-field='totalIntegral'></span></div>"
                    },{
                        type: "action",
                        field: "storeExChange",
                        action: "storeExChange",
                        label: "兑换",
                        className: "none"
                    }]
                }],
                waitFor: {
                    "0": "cqViewParam",
                    "1": "storeExChange"
                }
            },{
                fixed:"bottom",
                type:"footerBar",
                className: "colorful-btn-area",
                buttons:[{
                    id: "1",
                    dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                    className: " footer-tab-col-normal colorful-btn",
                    label:"确认兑换"
                }]
            }],
            shopExchangeList:[{
                //顶部标题栏
                fixed:"top",
                type:"topBar",
                label:"门店兑换列表",
                left:[{
                    type:"iconMenuItem",
                    label:"",
                    icon:"",
                    arrow:"left",
                    href:"back"
                }]
            },/*{
                //顶部搜索框
                fixed:"top",
                id:"1",
                dojoType:"cq/app/widget/mobile/SearchBox",
                placeholder: "请输入会员号"
            },*/{
                dojoType: "cq/app/widget/mobile/TplList",
                dataProvider: "whz/bo/goods",
                targetMethod: "getUrlList",
                queryParamMethod: "ListQuery",
                itemPropMethod:"getItemPro",
                itemType: "dojox/mobile/ListItem",
                clickMethod: "onListClick",
                waitFor: {
                    "0": "cqViewParam"
                    //"1": "search"
                },
                itemOptions: {
                    variableHeight: true,
                    label: '<div class="brief">兑换门店：{exchangeName}</div>'+
                        '<div class="brief">时间：{bdate}</div>'+
                        '<div class="brief">兑换产品：{name}</div>'+
                        '<div class="brief">兑换状态：{status}</div>'+
                        '<div class="brief">数量（罐）：{quantity}</div>',
                    noArrow:true
                }
            }],
            saleDetails:[{
                //顶部标题栏
                fixed:"top",
                type:"topBar",
                label:"当日销售明细",
                left:[{
                    type:"iconMenuItem",
                    label:"",
                    icon:"",
                    arrow:"left",
                    href:"back"
                }]
            },/*{
                dojoType: "cq/app/widget/mobile/TplList",
                dataProvider: "whz/bo/goods",
                targetMethod: "getUrlList",
                queryParamMethod: "ListQuery",
                itemPropMethod:"getItemPro",
                itemType: "dojox/mobile/ListItem",
                clickMethod: "onListClick",
                waitFor: {
                    "0": "cqViewParam"
                    //"1": "search"
                },
                itemOptions: {
                    variableHeight: true,
                    label: '<div class="brief">兑换门店：{exchangeName}</div>'+
                        '<div class="brief">时间：{bdate}</div>'+
                        '<div class="brief">兑换产品：{name}</div>'+
                        '<div class="brief">兑换状态：{status}</div>'+
                        '<div class="brief">数量（罐）：{quantity}</div>',
                    noArrow:true
                }
            }*/],
            historySales:[{
                //顶部标题栏
                fixed:"top",
                type:"topBar",
                label:"历史销售汇总",
                left:[{
                    type:"iconMenuItem",
                    label:"",
                    icon:"",
                    arrow:"left",
                    href:"back"
                }]
            }]
        }
    };
});
