﻿define([
    "./common"
],function(common){
    return {
        views:{
            //登录
            login:{
                noBack: true,
                preventScroll:true
            },
            //注册
            register:{
            },
            //找回密码
            findPwd:{
                mustLogin:true,
            },
            //修改密码
            mdfPwd: {
                mustLogin:true
            },
            // 个人信息
            mdfUserInfo: {
                mustLogin:true
            },
            //账户设置
            accountList:{
                mustLogin:true,
            },
            //店员管理
            shopAdmin: {
                mustLogin:true
            },
            //添加店员
            addShopAdmin: {
                mustLogin: true
            },
            about:{
                mustLogin:true
            }
        },
        layouts:{
            // 登录
            "login":[{
                dojoType: "cq/app/widget/web/DataLayout",
                className: "inherit-background no-margin-top loginBack",
                layout:[{
                    type : "form",
                    fields:[{
                        type: "content",
                        content: ["<img src='./images/temp/logo/maxLogo.png' style='width:60%;margin:auto;margin-top:40px;padding-bottom:40px;display:block;' />"],
                        className: "inherit-background",
                        listClass: "inherit-background",
                    }]
                }],
                waitFor: {
                    "0": "cqViewParam"
                }
            },{
                className: "cq-login-content cq-layout-content no-margin-top",
                layoutType: "table",
                dojoType: "cq/app/widget/web/DataLayout",
                dataProvider: "whz/bo/consumer",
                layoutMethod: "getOltpLoginLayout",
                initMethod: "initUserOltpLoginInfo",
                //添加回车登录方法
                editorEnterMethod:"onOLtpLoginEnter",
                waitFor: {
                    "0": "cqViewParam"
                }
            }, {
                type: "content",
                fixed: "bottom",
                content: '<div style="font-size:16px;color:#8F8F8F;text-align:left;">'+
                    '<div style="display:flex;">' +
                        '<div style="flex:1;"></div>' +
                        '<div>当前版本：2.2.5</div>' +
                        '<div style="flex:1;"></div>' +
                    '</div>'+
                    '<div style="display:flex">'+
                        '<div style="flex:1;"></div>' +
                        '<div>服务热线：400-830-3896</div>' +
                        '<div style="flex:1;"></div>' +
                    '</div>'+
                '</div>'
            }],
            // 注册
            "register": [{
                //顶部标题栏
                fixed:"top",
                type:"topBar",
                label:"注册",
                left:[{
                    type:"iconMenuItem",
                    label:"",
                    icon:"",
                    arrow:"left",
                    href:"back"
                }]
            },{
                className: "cq-login-content cq-layout-content",
                dojoType: "cq/app/widget/web/DataLayout",
                dataProvider: "whz/bo/consumer",
                layoutMethod: "getRegisterLayout",
                initMethod: "nothing",
                fieldChangeMethod:"getRegisterBChangeMethod",
                reloadMethod : "registerReload",
                waitFor: {
                    "0": "cqViewParam"
                }
            },{
                dojoType: "cq/app/widget/web/DataLayout",
                dataProvider: "whz/bo/consumer",
                layout: [{
                    type: "form",
                    formClass: "no-margin-top",
                    canDelete: false,
                    fields: [{
                        type: "content",
                        content: "<div style='padding:8px 16px;font-size:13px;' class='cq-form-item'>点击上面的“注册”按钮，即表示你同意 "+
                        "<span class='cq-action register_span protocol_span' cq-action='registerProtocol' data-cq-field='registerProtocol'>《用户注册协议》</span>"+
                        " 和 "+
                        "<span class='cq-action privacy_span protocol_span' cq-action='privacyProtocol' data-cq-field='privacyProtocol'>《用户隐私协议》</span></div>"
                    }]
                }]
            }],
            //找回密码
            findPwd: [{
                //顶部标题栏
                fixed:"top",
                type:"topBar",
                label:"找回密码",
                left:[{
                    type:"iconMenuItem",
                    label:"",
                    icon:"",
                    arrow:"left",
                    href:"back"
                }]
            },{
                className: "cq-login-content cq-layout-content",
                dojoType: "cq/app/widget/web/DataLayout",
                dataProvider: "whz/bo/consumer",
                layoutMethod: "getFindPwdLayout",
                waitFor: {
                    "0": "cqViewParam"
                }
            }],
            // 修改密码
            "mdfPwd": [{
                //顶部标题栏
                fixed:"top",
                type:"topBar",
                label:"修改密码",
                left:[{
                    type:"iconMenuItem",
                    label:"",
                    icon:"",
                    arrow:"left",
                    href:"back"
                }]
            },{
                className: "cq-login-content cq-layout-content",
                dojoType: "cq/app/widget/web/DataLayout",
                dataProvider: "whz/bo/consumer",
                layoutMethod: "getMdfPwdLayout",
                waitFor: {
                    "0": "cqViewParam",
                    "1": "updatePassword"
                }
            },{
                fixed: "bottom",
                type: "footerBar",
                buttons: [{
                    id: "1",
                    dojoType: "cq/app/widget/mobile/menu/ColumnButton",
                    label: "确认",
                    className: " footer-tab-col-normal colorful-btn"
                }],
                className: "colorful-btn-area"
            }],
            // 个人信息
            mdfUserInfo: [{
                fixed: "top",
                type: "topBar",
                label: "个人信息",
                left: [{
                    type: "iconMenuItem",
                    label: "",
                    icon: "",
                    arrow: "left",
                    href: "back"
                }]
            },{
                dojoType: "cq/app/widget/web/DataLayout",
                dataProvider: "whz/bo/consumer",
                className: "inherit-background no-margin-top",//cq-view-stepsFields",
                //layoutType: "table",
                //layoutMethod: "getMdfUserInfoLayout",
                reloadMethod:"disabelField",
                //initMethod: "getMdfUserInfoData",
                initMethod: "getUserDetail",
                layout:[{
                    type : "form",
                    canDelete:false,
                    canAdd:false,
                    canDnd:false,
                    canEdit:false,
                    fields:[{
                        type: "content",
                        content: '<div class="user-content">'+
                            '<div>'+
                                '<a href="#mdfUserInfo" class="userInfoLogo">'+
                                    '<img src="images/temp/logo/maxLogo.png" class="user-logo"/>'+
                                '</a>'+
                            '</div>'+
                            '<div class="user-name"><span class="cq-field-input" data-cq-field="organizationName"></span></div>'+
                        '</div>',
                        className: "inherit-background",
                        listClass: "inherit-background",
                    }]
                },{
                    type: "content",
                    content: "<div style='background:white'>"+
                        "<div class='list-customer'><div class='list-customer-logo'><img src='./images/temp/tool/name.png'></div><div class='textLong'>用户名：<span class='cq-field-input' data-cq-field='name'></span></div></div>"+
                        "<div class='list-customer'><div class='list-customer-logo'><img src='./images/temp/tool/phone.png'></div><div>手机号：<span class='cq-field-input' data-cq-field='phone'></span></div></div>"+
                        "<div class='list-customer'><div class='list-customer-logo'><img src='./images/temp/tool/sex.png'></div><div>性别：<span class='cq-field-input' data-cq-field='sex'></span></div></div>"+
                        "<div class='list-customer'><div class='list-customer-logo'><img src='./images/temp/tool/number.png'></div><div>工号：<span class='cq-field-input' data-cq-field='jobNumber'></span></div></div>"+
                        "<div class='list-customer'><div class='list-customer-logo'><img src='./images/temp/tool/work.png'></div><div>职位：<span class='cq-field-input' data-cq-field='jobPosition'></span></div></div>"+
                    "</div>"
                }],
                waitFor: {
                    "0": "cqViewParam"
                }
            }],
            accountList:[{
                fixed: 'top',
                type: 'topBar',
                label: '账号管理',
                left: [{
                    type: 'iconMenuItem',
                    label: '',
                    icon: '',
                    arrow: 'left',
                    href: 'back'
                }]
            },{
                dojoType: "cq/app/widget/web/DataLayout",
                dataProvider: "whz/bo/consumer",
                initMethod: "getLocalUserList",
                className: "inherit-background no-margin-top cq-list",
                fieldChangeMethod:"onStoreChanged",
                layout:[{
                    type : "form",
                    canDelete:false,
                    canAdd:false,
                    canDnd:false,
                    canEdit:false,
                    formClass: "no-border",
                    fields:[{
                        type: "objects",
                        field:"info",
                        canDelete:false,
                        canAdd:false,
                        canDnd:false,
                        canEdit:true,
                        fields:{
                            className:"mblListItem",
                            layout:[{
                                type: "content",
                                canDelete:false,
                                canAdd:false,
                                canDnd:false,
                                canEdit:false,
                                content:'<a class="cq-action" cq-action="switchUser"><div style="display:flex;padding:10px;border-bottom: 1px solid #e5e5e5;">'+
                                    '<div style="padding: 0px 15px 0px 0px;"><div class="acountListLogo"><img style="padding:12px 0px 0px 10px;" src="images/temp/logo/maxLogo.png"></div></div>'+
                                    '<div style="flex:5;" class="title">'+
                                        '<div style="height: 30px;line-height: 30px;" class="cq-field-input textLong" data-cq-field="name"></div>'+
                                        '<div style="height: 30px;line-height: 30px;" class="cq-field-input" data-cq-field="phone"></div>'+
                                    '</div>'+
                                    '</div></a>'
                            }]
                        }
                    }]
                }],
                waitFor: {
                    "0": "cqViewParam"
                }
            },{
                fixed:"bottom",
                type:"footerBar",
                buttons:[{
                    dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                    className:"colorful-btn",
                    label:"退出当前账户",
                    dataProvider:"whz/bo/consumer",
                    action:"onLogout"
                }],
                className: "colorful-btn-area"
            }],
            
            //店员管理
            shopAdmin: [{
                //顶部标题栏
                fixed:"top",
                type:"topBar",
                label:"店员列表",
                left:[{
                    type:"iconMenuItem",
                    label:"",
                    icon:"",
                    arrow:"left",
                    href:"back"
                }]
            },{
                //顶部搜索框
                fixed:"top",
                id:"1",
                dojoType:"cq/app/widget/mobile/SearchBox",
                placeholder: "请输入手机号"
            },{
                dojoType: "cq/app/widget/mobile/TplList",
                dataProvider: "whz/bo/consumer",
                targetMethod: "getUserList",
                queryParamMethod: "userListQuery",
                itemPropMethod:"userProp",
                itemType: "dojox/mobile/ListItem",
                waitFor: {
                    "0": "cqViewParam",
                    "1": "search"
                },
                itemOptions: {
                    variableHeight: true,
                    label: '<div class="title textLong">店员名称：{name}</div>'+
                        '<div class="brief">性别：{sex}</div>'+
                        '<div class="brief">手机号码：{phone}</div>'+
                        '<div class="brief">工号：{jobNumber}</div>',
                    noArrow:true
                }
            }/*,{
                fixed:"bottom",
                type:"footerBar",
                buttons:[{
                    dojoType:"cq/app/widget/mobile/menu/ColumnButton",
                    className:"colorful-btn",
                    label:"添加店员",
                    href: "#addShopAdmin"
                    //dataProvider:"bob/user/shopAdmin",
                    //action:"findMoreShopAdmin"
                }],
                className: "colorful-btn-area"
            }*/],
            //新增店员
            addShopAdmin: [{
                fixed: "top",
                type: "topBar",
                label: "店铺管理员",
                left: [{
                    type: "iconMenuItem",
                    label: "",
                    icon: "",
                    arrow: "left",
                    href: "back"
                }]
            }, {
                dojoType: "cq/app/widget/web/DataLayout",
                dataProvider: "whz/bo/consumer",
                layoutMethod: "getAddShopAdminLayout",
                //reloadMethod: "onDataReadyShopAdminForAdd",
                waitFor: {
                    "0": "cqViewParam",
                    "1": "createUser"
                }
            },{
                fixed: "bottom",
                type: "footerBar",
                buttons: [{
                    id: "1",
                    dojoType: "cq/app/widget/mobile/menu/ColumnButton",
                    label: "确认添加",
                    className: " footer-tab-col-normal colorful-btn"
                }],
                className: "colorful-btn-area"
            }],
            about:[{
                //顶部标题栏
                fixed:"top",
                type:"topBar",
                label:"关于",
                left:[{
                    type:"iconMenuItem",
                    label:"",
                    icon:"",
                    arrow:"left",
                    href:"back"
                }]
            },{
                type: "content",
                content: "<div class='item-cells'>"+
                    "<div class='item-cell'>"+
                        "<h1>1、商品销售管理类软件</h1>"+
                    "</div>"+
                    "<div class='item-cell'>"+
                        "<h1>2、不同角色不同权限不同功能</h1>"+
                    "</div>"+
                    "<div class='item-cell'>"+
                        "<h1>3、完成配置化菜单功能</h1>"+
                    "</div>"+
                    "<div class='item-cell'>"+
                        "<h1>4、从入库到出库，最终通过门店销售给用户</h1>"+
                    "</div>"+
                    "<div class='item-cell'>"+
                    "<h1>查看<a href='http://www.nepbaby.com/agreement/app_agreement.html' style='color:#2a8fbd;'>《用户协议》</a>及<a href='http://www.nepbaby.com/agreement/privacy_agreement.html' style='color:#2a8fbd;'>《隐私协议》</a></h1>"+
                "</div>"+
                "</div>"
            }]
        }    
    };
});
