﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/keys",
    "dojo/dom-style",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojox/mobile/ListItem",
    "cq/util/sys/userAgent"
],function(declare,lang,keys,domStyle,domClass,domConstruct,ListItem,userAgent){
    // module:
    //      whz/widget/Scanner
    
    return declare("",[ListItem],{
        // summary:
        //      编辑组件，扫码获取条码或二维码内容，非APP环境使用键盘输入
        
        // htmlTemp:String
        //      时间的html片段，内容显示在右侧
		
        htmlTemp:'<li id="{id}" tabIndex="-1" class="scannerList cq-form-saner cq-field-input" data-dojo-type="dojox/mobile/ListItem" data-dojo-props="canEdit:{canEdit},label:{label},field:{field},baseClass:{className}" data-cq-field="{field}"></li>',
        
        // field:String
        //      时间列表的字段名
        field:"",
        
        // clickable:boolean
        //      控制时间列表是否可以点击的字段，默认为true
        clickable:false,//true
        
        // canEdit:boolean
        //      控制时间列表是否可以编辑,默认为true
        canEdit:true,
        //rightIcon:"image/temp/miniIcon/scanner.png",
        
        buildRendering:function(){
            // summary:
            //      创建列表时，初始化列表元素
            this.canEdit = this.canEdit!==false&&this.canEdit!=="false";
            this.inherited(arguments);
            this.textBox = domConstruct.create("input",{
                "class": "cq-form-input",
		"style": "width:60%;",
		type: "text"
	    },this.domNode);
            if(userAgent.isApp()&&window.cordova&&window.cordova.plugins&&window.cordova.plugins.barcodeScanner){
                scannerBtNode = domConstruct.create("div",{
                    "class":"scannerNode",
                    innerHTML:"<div class='scannerBt'></div>"
                },this.domNode);
                this.connect(scannerBtNode,"onclick",this.btClick);
            }
            this.connect(this.textBox,"onblur",function(){
                this.onInputFinish(this.textBox.value);
            });
            this.connect(this.textBox,"onkeypress",function(e){
                if(e.keyCode==keys.ENTER && this.textBox.value){
                    this.onInputFinish(this.textBox.value);
                }
            });
        },
        btClick:function(e){
            var dom = e.target;
            if(dom.className=="scannerBt"){
                this.onRightBtClick();
            }
        },
        isScanning:false,
        onRightBtClick:function(){
            if(this.isScanning){
                return;
            }
            this.isScanning = true;
            cordova.plugins.barcodeScanner.scan(lang.hitch(this,function (result) {
                this.isScanning = false;
                if(!result.cancelled){
                    var text = result.text.split("=")[1];
                    this.onInputFinish(text);
                }
            }),function (error) {
                this.isScanning = false;
                alert("扫码失败: " + error);
            },{
                //优先使用前置摄像头
                // iOS and Android
                preferFrontCamera : false,
                //显示切换摄像头按钮
                //iOS and Android
                showFlipCameraButton : true,
                //显示闪光灯开关
                //iOS and Android
                showTorchButton : true,
                //默认开启闪光灯
                //Android, launch with the torch switched on (if available)
                torchOn: false,
                //saveHistory: false, // Android, save scan history (default false)
                //扫码区域底部提示信息
                //Android
                prompt : "请将条码放入扫描区域内",
                //Android, display scanned text for X ms. 0 suppresses it entirely, default 1500
                resultDisplayDuration: 0,
                //编码格式
                //default: all but PDF_417 and RSS_EXPANDED
                //formats : "QR_CODE,PDF_417",
                //扫码时的旋转方向
                // Android only (portrait|landscape), default unset so it rotates with the device
                //orientation : "portrait",
                //disableAnimations : true, // iOS
                //禁用扫码成功的滴滴声
                //iOS and Android
                disableSuccessBeep: false
            });
        },
        onInputFinish:function(value){
            this.setValue(value);
            this.onFieldChanged(this,this.field,value);
        },
        
        getValue:function(){
            // summary:
            //      获取时间列表上的值
            return this.get("value");
        },
        
        setValue:function(value){
            this.set("value",value||"");
            this.textBox.value = this.get("value");
        },
        
        setCanEdit:function(canEdit){
            // summary:
            //      根据参数来设置是否可以编辑
            this.canEdit=canEdit;
            if(this.rightIconNode){
                domStyle.set(this.rightIconNode,"opacity",this.canEdit?1:0);
            }
        },
        onFieldChanged:function(widget,field,value){
            // summary:
            //      数据改变后触发，提供外部实现功能
        }
    });
});
