﻿define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojo/dom-attr",
    "dojo/dom-construct",
    "dojo/dom-class",
    "dojox/mobile/EdgeToEdgeList",
    "dojox/mobile/ListItem",
    //"dojox/mobile/RadioButton",
    "dijit/form/RadioButton",
    "dijit/registry",
    "./Scanner"
],function(declare,lang,domStyle,domAttr,domConstruct,domClass,EdgeToEdgeList,ListItem,RadioButton,registry,Scanner){
    return declare("",[EdgeToEdgeList],{
        htmlTemp:'<ul class="{className}" id="{id}" dojoType="whz/widget/ScannerList" data-dojo-props="field:{field},dataProvider:{dataProvider},infoMethod:{infoMethod},integralPromethod:{integralPromethod},labelField:{labelField},scannerLabel:{scannerLabel}"></ul>',
        //绑定的字段
        field:"",
        //检查条码的数据提供者
        dataProvider:"",
        //依据条码获取信息的方法
        infoMethod:"",
        //有可能需要加载活动列表
        integralPromethod:"",
        //获取到的信息，显示内容属性名
        labelField:"",
        //条码扫描器的显示标签
        //左边的信息
        rightText:"",
        scannerLabel:"",
        //不允许选中
        select:"",
        //选中的活动Id
        ruleId:"",
        //创建扫码组件
        buildRendering:function(){
            this.inherited(arguments);
            this.scanner = new Scanner({
                label:this.scannerLabel,
                "className":"mblListItem scannerList"
            });
            this.connect(this.scanner,"onFieldChanged",function(widget,field,value){//onkeydown//keypress//onClick
                if(value){
                    //查看条码是否已经扫描过
                    if(!this.isScan(value)){
                        this.validCode(value);
                    }
                }
            });
            //添加扫码
            this.addChild(this.scanner);
            
            this.codeList = new EdgeToEdgeList({
                class:"goodCodes"
            });
            //添加扫码获得的商品
            this.addChild(this.codeList);
            
            if(this.dataProvider&&this.integralPromethod){
                //添加扫码获得的相应活动图标
                var item= new ListItem({
                    label:"请选择活动：",
                    class:"activityTitle"
                });
                this.addChild(item);
                //添加促销活动列表对象
                this.integralProList = new EdgeToEdgeList({
                    style:"padding: 0 8px;",
                    onCheckStateChanged:lang.hitch(this,this.onRuleChanged),
                    select:"single"
                });
                //添加扫码获得的相应活动
                this.addChild(this.integralProList);
            }
            
            this.setCanEdit(this.canEdit!==false&&this.canEdit!=="false");
        },
        onRuleChanged:function(item){
            //设置选中的促销活动id
            this.ruleId = item.data.id;
            this.onFieldChanged(this,this.field,this.getValue());
        },
        setCanEdit:function(canEdit){
            this.canEdit = !!canEdit;
            domStyle.set(this.scanner.domNode,"display",this.canEdit?"":"none");
        },
        //设置内容
        setValue:function(value){
            this.set("value",[]);
            //将扫的条码删除
            this.codeList.destroyDescendants();
            if(this.integralProList){
                this.ruleId = "0";
                this.integralProList.destroyDescendants();
            }
        },
        //读取内容
        getValue:function(){
            var infos = this.codeList.getChildren();
            //infos.shift();
            if(this.dataProvider&&this.integralPromethod){
                return {
                    list:infos.map(function(item){
                        return item.params.data;
                    }),
                    ruleId:this.ruleId
                };
            }else{
                return infos.map(function(item){
                    return item.params.data;
                });
            } 
        },
        //检查条码是否已经被扫码
        isScan:function(code){
            var infos = this.codeList.getChildren();
            var isScan = false;
            for(var i=0;i<infos.length;i++){
                var goodsCode = infos[i].params.data.goodsCode;
                if(goodsCode == code){
                    alert("您已经扫过该商品");
                    this.scanner.setValue("");
                    isScan = true;
                    break;
                }
            }
            return isScan;
        },
        //条码是否有效
        validCode:function(code){
            this.scanner.setValue("");
            if(this.dataProvider&&this.infoMethod){
                window.busy();
                require([this.dataProvider],lang.hitch(this,function(dp){
                    dp[this.infoMethod](code).then(lang.hitch(this,function(data){
                        window.free();
                        if(data&&data.result){
                            var item = new ListItem({
                                label:this.labelField?data.result[this.labelField]||"":"",
                                rightText:this.rightText?data.result[this.rightText]||"":code,
                                onClick:lang.hitch(this,this.onCodeListClick),
                                clickable:true,
                                noArrow:true,
                                deleteIcon:"mblDomButtonRedCircleMinus",
                                data:data.result
                            });
                            this.codeList.addChild(item);
                            this.onCodeChanged();
                        }else{
                            alert(data.message||"error");
                        }
                    }));
                }));
            }else{
                var item = new ListItem({
                    label:"积分码",
                    rightText:code
                });
                item.params.data = code;
                this.codeList.addChild(item);
                this.onCodeChanged();
            }
        },
        //点击活动列表选中活动的id
        onCodeListClick:function(e){
            var dom = e.target,item = registry.getEnclosingWidget(e.target);
            if(item&&item.deleteIconNode){
                while(dom&&dom!=item.deleteIconNode){
                    dom = dom.parentNode;
                }
                if(dom===item.deleteIconNode){
                    item.destroyRecursive();
                    this.onCodeChanged();
                }
            }
        },
        onCodeChanged:function(){
            //触发 integralProList活动列表刷新事件
            if(this.dataProvider&&this.integralPromethod){
                this.integralProList.destroyDescendants();
                var goodsCode = [];
                this.codeList.getChildren().forEach(function(item){
                    if(item){
                        goodsCode.push(item.data.goodsCode);
                    }
                });
                if(goodsCode.length){
                    window.busy();
                    require([this.dataProvider],lang.hitch(this,function(dp){
                        dp[this.integralPromethod](goodsCode).then(lang.hitch(this,function(data){
                            window.free();
                            if(data&&data.result&&data.result.list.length){
                                var item = null;
                                for(var i=0;i<data.result.list.length;i++){
                                    item = new ListItem({
                                        label:data.result.list[i][this.rightText],
                                        checkClass:"mblDomButtonSilverCircleGreenButton",
                                        uncheckClass:"mblDomButtonSilverCircleGrayButton",
                                        data:data.result.list[i]
                                    });
                                    this.integralProList.addChild(item);
                                }
                                if(item){
                                    item.set("checked",true);
                                }
                            }else{
                                alert(data.errmsg||"活动加载错误");
                            }
                        }));
                    }));
                }else{
                    this.onFieldChanged(this,this.field,this.getValue());
                }
            }else{
                this.onFieldChanged(this,this.field,this.getValue());
            }
        },
        onFieldChanged:function(widget,field,value){
        }
    });
});